%%% Load files

:- reconsult('listOperations.pl').
:- reconsult('ontologyInformation.pl').
:- reconsult('mappingInformation.pl').
:- reconsult('readAxioms.pl').
:- reconsult('mapping2AdimenSUMO.pl').
:- reconsult('createMultipleMappingGoals.pl').
:- reconsult('writeGoals.pl').
:- reconsult('Mappings/nounSense.pl').
:- reconsult('Mappings/verbSense.pl').
:- reconsult('Mappings/adjSense.pl').
:- reconsult('Mappings/advSense.pl').

main:-

		print_to_screen('Deleting previous information ... '),
		print_to_screen('\n'),
		deletePreviousOntologyInformation,										% Deleting previous ontology information
		deletePreviousMappingInformation,										% Deleting previous mapping information
		print_to_screen('Done!'),
		print_to_screen('\n'),

		print_to_screen('Reading input axiom files ... '),
		print_to_screen('\n'),
		readAxioms,																% Reading input files
		print_to_screen('Done!'),
		print_to_screen('\n'),

		print_to_screen('\n'),
		print_to_screen('Initializing ontology information ...'),
		initializeOntologyInformation,											% Initializing ontology information
		print_to_screen('\n'),
		print_to_screen('Done!'),
		print_to_screen('\n'),

		print_to_screen('\n'),
		print_to_screen('Obtaining mapping to AdimenSUMO...'),
		mapping2AdimenSUMO,														% Obtaining mapping to AdimenSUMO
		print_to_screen('\n'),
		print_to_screen('Done!'),
		print_to_screen('\n'),

		print_to_screen('\n'),
		print_to_screen('Creating multiple mapping goals...'),
		createMultipleMappingGoals,												% Creating multiple mapping goals
		print_to_screen('\n'),
		print_to_screen('Done!'),
		print_to_screen('\n'),

		print_to_screen('\n'),
		print_to_screen('Obtaining AdimenSUMO hierarchy...'),
		obtainAdimenSUMOHierarchy,												% Obtaining AdimenSUMO hierarchy
		print_to_screen('\n'),
		print_to_screen('Done!'),
		print_to_screen('\n'),

		print_to_screen('\n'),
		print_to_screen('Saving AdimenSUMO hierarchy...'),
		saveAdimenSUMOHierarchy,												% Saving AdimenSUMO hierarchy
		print_to_screen('\n'),
		print_to_screen('Done!'),
		print_to_screen('\n'),

		print_to_screen('\n'),
		print_to_screen('Writing multiple mapping goals...'),
		writeGoals,																% Writing multiple mapping goals
		print_to_screen('\n'),
		print_to_screen('Done!'),
		print_to_screen('\n').
