% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% %																				% %
% %		Part III:		Mapping information										% %
% %																				% %
% %				All the predicates to get|set information in the mapping		% %
% %																				% %
% %																				% %
% %		mapping2SUMO('00001740-n','Entity',equivalence).						% %
% %																				% %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %


% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% %																				% %
% %		Load mapping information:												% %
% %																				% %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %

:- reconsult('Mappings/nounMapping2SUMO.pl').
:- reconsult('Mappings/verbMapping2SUMO.pl').
:- reconsult('Mappings/adjMapping2SUMO.pl').
:- reconsult('Mappings/advMapping2SUMO.pl').

:- reconsult('Mappings/nounGloss.pl').
:- reconsult('Mappings/verbGloss.pl').
:- reconsult('Mappings/adjGloss.pl').
:- reconsult('Mappings/advGloss.pl').


% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% %																				% %
% %		Delete previous information:											% %
% %																				% %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %

deletePreviousMappingInformation:-
		retractall(('nounMapping2AdimenSUMO'(_,_))),
		retractall(('verbMapping2AdimenSUMO'(_,_))),
		retractall(('adjMapping2AdimenSUMO'(_,_))),
		retractall(('advMapping2AdimenSUMO'(_,_))),
%		retractall(('&missingConcept'(_))).
		retractall(('&missingMapping'(_,_))),
		retractall(('&nonDirectMapping'(_,_))),
		retractall(('&missingMappingRelation'(_))).

deletePreviousFormattingInformation:-
%		retractall(('&missingSynset'(_))),
		retractall(('ant'(_,_))),
		retractall(('sim'(_,_))),
		retractall(('hyp'(_,_))),
		retractall(('der'(_,_))),
		retractall(('part'(_,_))),
		retractall(('pert'(_,_))),
		retractall(('also'(_,_))).


% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% %																				% %
% %		Initialize auxiliary information:										% %
% %																				% %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %


% % Dynamic Predicates:
% %			- '&mapping2AdimenSUMO'/2

:- dynamic	'nounMapping2AdimenSUMO'/2, 'verbMapping2AdimenSUMO'/2,
			 'adjMapping2AdimenSUMO'/2, 'advMapping2AdimenSUMO'/2,
%			 '&missingConcept'/1, '&missingSynset'/1,
			 '&missingMapping'/2, '&nonDirectMapping'/2, '&missingMappingRelation'/1,
			 'ant/2', 'sim/2', 'hyp/2', 'der/2', 'part/2', 'pert/2', 'also/2'.


% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% %																				% %
% %		Consulting auxiliary information										% %
% %																				% %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %

% %		- getAdimenSUMOMapping/2

%%% getSUMOMapping(in WS, out M)
%%%		WS: WordNet synset
%%%		M: mapping to WS

getSUMOMapping(WS,M):-
		nounMapping2SUMO(WS,M),
		!.
getSUMOMapping(WS,M):-
		verbMapping2SUMO(WS,M),
		!.
getSUMOMapping(WS,M):-
		adjMapping2SUMO(WS,M),
		!.
getSUMOMapping(WS,M):-
		advMapping2SUMO(WS,M).

% %		- getAdimenSUMOMapping/2

%%% getAdimenSUMOMapping(in WS, out M)
%%%		WS: WordNet synset
%%%		M: mapping to WS

getAdimenSUMOMapping(WS,M):-
		nounMapping2AdimenSUMO(WS,M),
		!.
getAdimenSUMOMapping(WS,M):-
		verbMapping2AdimenSUMO(WS,M),
		!.
getAdimenSUMOMapping(WS,M):-
		adjMapping2AdimenSUMO(WS,M),
		!.
getAdimenSUMOMapping(WS,M):-
		advMapping2AdimenSUMO(WS,M).


%%% isNounSynset(in WS)
%%%		WS: WordNet synset
%%%		Action:
%%%				success	if WS IS a noun WordNet synset mapped into AdimenSUMO
%%%				failure if WS is NOT a noun Wordnet synset mapped into AdimenSUMO

isNounSynset(WS):-
		nounMapping2AdimenSUMO(WS,_).

%%% isVerbSynset(in WS)
%%%		WS: WordNet synset
%%%		Action:
%%%				success	if WS IS a verb WordNet synset mapped into AdimenSUMO
%%%				failure if WS is NOT a verb Wordnet synset mapped into AdimenSUMO

isVerbSynset(WS):-
		verbMapping2AdimenSUMO(WS,_).

%%% isAdjectiveSynset(in WS)
%%%		WS: WordNet synset
%%%		Action:
%%%				success	if WS IS a adjective WordNet synset mapped into AdimenSUMO
%%%				failure if WS is NOT a adjective Wordnet synset mapped into AdimenSUMO

isAdjectiveSynset(WS):-
		adjMapping2AdimenSUMO(WS,_).

%%% isAdverbSynset(in WS)
%%%		WS: WordNet synset
%%%		Action:
%%%				success	if WS IS a adverb WordNet synset mapped into AdimenSUMO
%%%				failure if WS is NOT a adverb Wordnet synset mapped into AdimenSUMO

isAdverbSynset(WS):-
		advMapping2AdimenSUMO(WS,_).

%%% isNounWNSynset(in WS)
%%%		WS: WordNet synset
%%%		Action:
%%%				success	if WS IS a noun WordNet synset mapped into SUMO
%%%				failure if WS is NOT a noun Wordnet synset mapped into SUMO

isNounWNSynset(WS):-
		nounMapping2SUMO(WS,_).

%%% isVerbWNSynset(in WS)
%%%		WS: WordNet synset
%%%		Action:
%%%				success	if WS IS a verb WordNet synset mapped into SUMO
%%%				failure if WS is NOT a verb Wordnet synset mapped into SUMO

isVerbWNSynset(WS):-
		verbMapping2SUMO(WS,_).

%%% isAdjectiveWNSynset(in WS)
%%%		WS: WordNet synset
%%%		Action:
%%%				success	if WS IS a adjective WordNet synset mapped into SUMO
%%%				failure if WS is NOT a adjective Wordnet synset mapped into SUMO

isAdjectiveWNSynset(WS):-
		adjMapping2SUMO(WS,_).

%%% isAdverbWNSynset(in WS)
%%%		WS: WordNet synset
%%%		Action:
%%%				success	if WS IS a adverb WordNet synset mapped into SUMO
%%%				failure if WS is NOT a adverb Wordnet synset mapped into SUMO

isAdverbWNSynset(WS):-
		advMapping2SUMO(WS,_).
