%%%
%%%	This file has been obtained from Mappings/WordNetMappings30-adj.txt
%%%
%%%	For each synset, we include a fact using "adjMapping2SUMO/2" where
%%%
%%%		-	The first argument is the synset itself
%%%		-	The second argument is the SUMO concept
%%%		-	The third argument is the type of relation between the synset and
%%%				the SUMO concept
%%%
%%%			The type of relations are
%%%
%%%			* equivalence (originally denoted by '=') (503 occurrences)
%%%			* subsumption (originally denoted by '+') (14849 occurrences)
%%%			* instance (originally denoted by '@') (730 occurrences)
%%%
%%%			and its complements:
%%%
%%%			* not(equivalence) (originally denoted by ':') (8 occurrences)
%%%			* not(subsumption) (originally denoted by '[') (506 occurrences)
%%%			* not(instance) (originally denoted by ']') (0 occurrences)
%%%
%%%	1560 synsets are not correctly mapped to SUMO
%%%
%%%		-	1560 synset(s) do not have mapping class and relation
%%%		-	0 synset(s) do not have mapping class
%%%		-	0 synset(s) do not have relation class

adjMapping2SUMO('00001740-a',[ (capability,equivalence)]).
adjMapping2SUMO('00002098-a',[ (capability,subsumption)]).
adjMapping2SUMO('00002312-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00002527-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00002730-a',[ ('',undefined)]).
adjMapping2SUMO('00002843-a',[ ('',undefined)]).
adjMapping2SUMO('00002956-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00003131-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00003356-a',[ ('BeginFn',subsumption)]).
adjMapping2SUMO('00003553-s',[ ('BeginFn',subsumption)]).
adjMapping2SUMO('00003700-s',[ ('',undefined)]).
adjMapping2SUMO('00003829-s',[ ('Birth',equivalence)]).
adjMapping2SUMO('00003939-a',[ ('',undefined)]).
adjMapping2SUMO('00004171-s',[ ('Death',subsumption)]).
adjMapping2SUMO('00004296-s',[ ('Death',subsumption)]).
adjMapping2SUMO('00004413-a',[ ('Summary',equivalence)]).
adjMapping2SUMO('00004615-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00004723-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00004817-s',[ ('Summary',equivalence)]).
adjMapping2SUMO('00004980-a',[ ('Text',subsumption)]).
adjMapping2SUMO('00005107-s',[ ('Text',subsumption)]).
adjMapping2SUMO('00005205-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00005473-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00005599-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00005718-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00005839-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00006032-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00006245-s',[ ('Relation',equivalence)]).
adjMapping2SUMO('00006336-a',[ (capability,subsumption)]).
adjMapping2SUMO('00006777-s',[ (capability,subsumption)]).
adjMapping2SUMO('00006885-s',[ (capability,subsumption)]).
adjMapping2SUMO('00007096-s',[ (capability,subsumption)]).
adjMapping2SUMO('00007208-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00007331-s',[ ('',undefined)]).
adjMapping2SUMO('00007516-s',[ (capability,subsumption)]).
adjMapping2SUMO('00007697-s',[ (capability,subsumption)]).
adjMapping2SUMO('00007813-a',[ (capability,subsumption)]).
adjMapping2SUMO('00007990-s',[ (capability,subsumption)]).
adjMapping2SUMO('00008206-a',[ (capability,subsumption)]).
adjMapping2SUMO('00008443-s',[ (capability,subsumption)]).
adjMapping2SUMO('00008595-a',[ (capability,subsumption)]).
adjMapping2SUMO('00008734-a',[ (capability,subsumption)]).
adjMapping2SUMO('00008877-a',[ (capability,subsumption)]).
adjMapping2SUMO('00009046-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00009346-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00009618-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00009978-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00010385-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00010537-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00010726-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00011160-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00011327-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00011665-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00011757-a',[ ('Abstract',equivalence)]).
adjMapping2SUMO('00012071-s',[ ('Proposition',subsumption)]).
adjMapping2SUMO('00012362-s',[ ('Proposition',subsumption)]).
adjMapping2SUMO('00012689-s',[ ('Abstract',subsumption)]).
adjMapping2SUMO('00012932-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00013160-a',[ ('Physical',subsumption)]).
adjMapping2SUMO('00013442-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00013662-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00013887-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00014358-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00014490-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00014858-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00015097-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00015247-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00015480-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00015589-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00015720-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00015854-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00016005-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00016135-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00016247-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00016350-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00016532-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00016647-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00016756-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00017024-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00017186-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00017352-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00017509-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00017688-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00017782-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00018069-s',[ (capability,subsumption)]).
adjMapping2SUMO('00018222-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00018435-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00018584-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00018850-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00019131-a',[ (capability,subsumption)]).
adjMapping2SUMO('00019349-s',[ (capability,subsumption)]).
adjMapping2SUMO('00019505-s',[ (capability,subsumption)]).
adjMapping2SUMO('00019731-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00019874-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00020103-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00020241-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('00020410-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00020647-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00020787-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00021110-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00021403-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00021592-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00021766-a',[ ('True',subsumption)]).
adjMapping2SUMO('00022219-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00022437-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00022680-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00022852-s',[ ('',undefined)]).
adjMapping2SUMO('00022962-s',[ ('True',subsumption)]).
adjMapping2SUMO('00023120-s',[ ('Impelling',subsumption)]).
adjMapping2SUMO('00023278-s',[ ('True',subsumption)]).
adjMapping2SUMO('00023383-a',[ ('False',subsumption)]).
adjMapping2SUMO('00023655-s',[ ('Impelling',subsumption)]).
adjMapping2SUMO('00023854-s',[ ('False',subsumption)]).
adjMapping2SUMO('00024139-s',[ ('False',subsumption)]).
adjMapping2SUMO('00024241-s',[ ('False',subsumption)]).
adjMapping2SUMO('00024417-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00024619-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00024834-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00024996-s',[ ('BeginFn',subsumption)]).
adjMapping2SUMO('00025138-s',[ (uses,subsumption)]).
adjMapping2SUMO('00025238-a',[ ('AcidicPH',equivalence)]).
adjMapping2SUMO('00025470-s',[ ('Substance',subsumption)]).
adjMapping2SUMO('00025633-s',[ (capability,subsumption)]).
adjMapping2SUMO('00025728-a',[ ('Substance',subsumption)]).
adjMapping2SUMO('00026051-s',[ (capability,subsumption)]).
adjMapping2SUMO('00026168-s',[ ('BasicPH',equivalence)]).
adjMapping2SUMO('00026294-s',[ (capability,subsumption)]).
adjMapping2SUMO('00026388-s',[ ('',undefined)]).
adjMapping2SUMO('00026515-a',[ ('Substance',subsumption)]).
adjMapping2SUMO('00026706-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00026895-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00027074-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00027247-a',[ ('Disseminating',subsumption)]).
adjMapping2SUMO('00027599-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00027833-s',[ ('Stating',subsumption)]).
adjMapping2SUMO('00028008-s',[ ('True',subsumption)]).
adjMapping2SUMO('00028181-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00028280-s',[ ('Stating',subsumption)]).
adjMapping2SUMO('00028471-s',[ ('True',subsumption)]).
adjMapping2SUMO('00028672-a',[ ('False',subsumption)]).
adjMapping2SUMO('00028867-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00028984-s',[ ('Stating',subsumption)]).
adjMapping2SUMO('00029108-s',[ ('Stating',subsumption)]).
adjMapping2SUMO('00029216-s',[ ('Classifying',subsumption)]).
adjMapping2SUMO('00029343-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00029769-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00029933-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00030508-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00030701-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00030798-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00031138-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00031384-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00031533-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00031674-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00031824-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00031974-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00032358-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00032497-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00032733-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00033077-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00033206-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00033359-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00033475-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00033574-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00033886-s',[ ('',undefined)]).
adjMapping2SUMO('00034032-s',[ (capability,subsumption)]).
adjMapping2SUMO('00034232-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00034322-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00034572-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00034710-a',[ ('Position',subsumption)]).
adjMapping2SUMO('00034924-s',[ ('Position',subsumption)]).
adjMapping2SUMO('00035074-a',[ ('Position',subsumption)]).
adjMapping2SUMO('00035254-s',[ (capability,subsumption)]).
adjMapping2SUMO('00035368-s',[ ('Retired',equivalence)]).
adjMapping2SUMO('00035465-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00035779-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00035868-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00035978-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00036163-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00036254-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00036346-s',[ ('Pliable',subsumption)]).
adjMapping2SUMO('00036481-a',[ ('Process',subsumption)]).
adjMapping2SUMO('00036763-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00036879-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00036998-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00037188-s',[ ('Process',subsumption)]).
adjMapping2SUMO('00037341-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00037457-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00037653-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('00037757-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00037985-s',[ ('',undefined)]).
adjMapping2SUMO('00038119-s',[ ('Horizontal',subsumption)]).
adjMapping2SUMO('00038260-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00038462-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00038623-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00038750-a',[ (capability,subsumption)]).
adjMapping2SUMO('00039122-s',[ ('PoliticalProcess',subsumption)]).
adjMapping2SUMO('00039259-s',[ ('',undefined)]).
adjMapping2SUMO('00039394-s',[ ('',undefined)]).
adjMapping2SUMO('00039592-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00039929-s',[ ('',undefined)]).
adjMapping2SUMO('00040058-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00040325-a',[ ('Process',subsumption)]).
adjMapping2SUMO('00040534-s',[ (capability,subsumption)]).
adjMapping2SUMO('00040685-a',[ ('Process',subsumption)]).
adjMapping2SUMO('00040909-s',[ ('Process',subsumption)]).
adjMapping2SUMO('00041051-a',[ (capability,subsumption)]).
adjMapping2SUMO('00041202-s',[ (capability,subsumption)]).
adjMapping2SUMO('00041361-a',[ ('Process',subsumption)]).
adjMapping2SUMO('00041488-s',[ ('Living',equivalence)]).
adjMapping2SUMO('00041618-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('00041841-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('00042037-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('00042228-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('00042457-a',[ (causes,subsumption)]).
adjMapping2SUMO('00042692-s',[ (causes,subsumption)]).
adjMapping2SUMO('00042837-s',[ (agent,subsumption)]).
adjMapping2SUMO('00042982-s',[ (capability,subsumption)]).
adjMapping2SUMO('00043125-a',[ ('Process',subsumption)]).
adjMapping2SUMO('00043231-s',[ ('Process',subsumption)]).
adjMapping2SUMO('00043411-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('00043615-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('00043765-a',[ (exists,subsumption)]).
adjMapping2SUMO('00044132-s',[ (exists,subsumption)]).
adjMapping2SUMO('00044353-a',[ ('Possibility',equivalence)]).
adjMapping2SUMO('00044608-s',[ ('Possibility',subsumption)]).
adjMapping2SUMO('00044760-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00044987-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00045123-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00045356-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00045561-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00045735-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00045888-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00046014-a',[ (capability,subsumption)]).
adjMapping2SUMO('00046109-a',[ (capability,subsumption)]).
adjMapping2SUMO('00046339-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00046471-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00046558-s',[ (capability,subsumption)]).
adjMapping2SUMO('00046673-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00046792-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00046955-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00047029-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00047243-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00047406-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00047566-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00047653-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00047786-a',[ (capability,subsumption)]).
adjMapping2SUMO('00047954-a',[ (capability,subsumption)]).
adjMapping2SUMO('00048129-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('00048460-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('00048706-s',[ (capability,subsumption)]).
adjMapping2SUMO('00048858-s',[ (not,subsumption)]).
adjMapping2SUMO('00049016-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00049266-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('00049469-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00049683-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00049879-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00050083-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('00050260-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('00050446-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('00050641-a',[ (destination,subsumption)]).
adjMapping2SUMO('00050799-s',[ (destination,subsumption)]).
adjMapping2SUMO('00050947-a',[ (destination,subsumption)]).
adjMapping2SUMO('00051045-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00051373-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00051571-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00051696-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00052012-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00052246-s',[ (capability,subsumption)]).
adjMapping2SUMO('00052431-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00052672-a',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00053032-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00053154-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00053248-s',[ (capability,subsumption)]).
adjMapping2SUMO('00053384-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00053564-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00053691-s',[ ('Liquid',subsumption)]).
adjMapping2SUMO('00054109-s',[ ('Liquid',subsumption)]).
adjMapping2SUMO('00054201-s',[ ('',undefined)]).
adjMapping2SUMO('00054278-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00054364-s',[ ('Liquid',subsumption)]).
adjMapping2SUMO('00054541-s',[ (capability,subsumption)]).
adjMapping2SUMO('00054667-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00054804-s',[ ('Liquid',subsumption)]).
adjMapping2SUMO('00054908-a',[ (capability,subsumption)]).
adjMapping2SUMO('00055041-s',[ (not,subsumption)]).
adjMapping2SUMO('00055142-s',[ ('',undefined)]).
adjMapping2SUMO('00055256-s',[ (not,subsumption)]).
adjMapping2SUMO('00055340-a',[ ('Law',subsumption)]).
adjMapping2SUMO('00055539-a',[ ('Law',subsumption)]).
adjMapping2SUMO('00055765-a',[ (capability,subsumption)]).
adjMapping2SUMO('00055906-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00056002-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('00056660-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('00056849-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00056943-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00057149-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00057390-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00057490-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00057566-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00057737-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00057881-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00057992-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00058280-s',[ (part,subsumption)]).
adjMapping2SUMO('00058379-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00058554-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00058696-s',[ (part,subsumption)]).
adjMapping2SUMO('00058822-s',[ (part,subsumption)]).
adjMapping2SUMO('00058929-s',[ (part,subsumption)]).
adjMapping2SUMO('00059028-s',[ (part,subsumption)]).
adjMapping2SUMO('00059131-s',[ (part,subsumption)]).
adjMapping2SUMO('00059201-s',[ (part,subsumption)]).
adjMapping2SUMO('00059326-s',[ (part,subsumption)]).
adjMapping2SUMO('00059491-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00059669-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00059782-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00059965-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00060053-s',[ (part,subsumption)]).
adjMapping2SUMO('00060151-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00060294-s',[ (part,subsumption)]).
adjMapping2SUMO('00060397-a',[ (not,subsumption)]).
adjMapping2SUMO('00060605-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00060875-s',[ (not,subsumption)]).
adjMapping2SUMO('00060969-a',[ (capability,subsumption)]).
adjMapping2SUMO('00061088-a',[ (capability,subsumption)]).
adjMapping2SUMO('00061262-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00061664-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00061885-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00062152-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00062367-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00062626-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00062740-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00063087-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00063277-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00063563-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00063953-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00064176-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00064365-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00064479-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00064787-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00065064-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00065184-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('00065488-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00065667-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00065791-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00066146-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00066565-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00066703-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00066800-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00066933-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00067038-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00067379-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00067638-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00067767-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00067966-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00068180-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00068278-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00068566-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00068738-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00068883-s',[ (resource,subsumption)]).
adjMapping2SUMO('00069060-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00069217-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00069427-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00069531-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00069948-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00070111-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00070288-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('00070427-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00070583-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00070839-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00070939-a',[ (causes,subsumption)]).
adjMapping2SUMO('00071142-s',[ (causes,subsumption)]).
adjMapping2SUMO('00071242-s',[ (causes,subsumption)]).
adjMapping2SUMO('00071427-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00071559-s',[ ('Managing',subsumption)]).
adjMapping2SUMO('00071739-s',[ (patient,subsumption)]).
adjMapping2SUMO('00071897-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00071992-a',[ (patient,subsumption)]).
adjMapping2SUMO('00072281-s',[ (patient,subsumption)]).
adjMapping2SUMO('00072436-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00072673-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00072790-s',[ (patient,subsumption)]).
adjMapping2SUMO('00073048-a',[ ('Pretending',subsumption)]).
adjMapping2SUMO('00073358-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('00073465-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('00073761-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('00073935-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('00074094-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('00074216-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00074346-a',[ ('Pretending',subsumption)]).
adjMapping2SUMO('00074594-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00074741-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('00074867-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('00075019-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('00075135-a',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00075389-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00075515-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00075737-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00075952-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00076127-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00076341-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00076580-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00076739-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00076921-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00077059-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00077196-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00077354-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00077449-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00077645-a',[ ('Anxiety',equivalence)]).
adjMapping2SUMO('00078329-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('00078463-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00078576-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00078705-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('00078851-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00078942-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('00079069-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00079262-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00079356-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('00079485-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00079629-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00079786-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00079896-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00080098-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('00080213-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('00080357-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00080698-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00080861-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00080981-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00081087-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('00081234-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00081417-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00081513-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('00081671-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00081930-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00082034-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00082160-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00082241-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00082766-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00083003-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00083296-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00083478-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00083749-s',[ ('',undefined)]).
adjMapping2SUMO('00083876-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00084022-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00084353-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00084661-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00084795-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00084956-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00085139-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00085264-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00085630-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00085870-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00086005-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00086210-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00086341-s',[ ('Unhappiness',subsumption)]).
adjMapping2SUMO('00086606-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00086801-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00087022-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00087152-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00087354-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('00087597-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00087837-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00088055-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00088157-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00088328-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00088545-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00088658-a',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('00088792-s',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('00088899-s',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('00089051-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00089355-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00089550-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00090219-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00090408-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00090628-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00090718-a',[ ('Weapon',subsumption)]).
adjMapping2SUMO('00090917-a',[ ('Weapon',subsumption)]).
adjMapping2SUMO('00091121-a',[ ('Weapon',subsumption)]).
adjMapping2SUMO('00091311-a',[ ('Awake',subsumption)]).
adjMapping2SUMO('00091764-s',[ ('Awake',subsumption)]).
adjMapping2SUMO('00092136-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00092275-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00092391-s',[ ('ConsciousnessAttribute',subsumption)]).
adjMapping2SUMO('00092551-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00092691-a',[ ('Procedure',subsumption)]).
adjMapping2SUMO('00092848-s',[ ('Proposition',subsumption)]).
adjMapping2SUMO('00092933-a',[ ('Procedure',subsumption)]).
adjMapping2SUMO('00093108-s',[ ('Investigating',subsumption)]).
adjMapping2SUMO('00093275-a',[ (capability,subsumption)]).
adjMapping2SUMO('00093433-s',[ (capability,subsumption)]).
adjMapping2SUMO('00093556-s',[ (capability,subsumption)]).
adjMapping2SUMO('00093810-a',[ (capability,subsumption)]).
adjMapping2SUMO('00094069-s',[ (capability,subsumption)]).
adjMapping2SUMO('00094239-s',[ ('',undefined)]).
adjMapping2SUMO('00094324-s',[ (capability,subsumption)]).
adjMapping2SUMO('00094448-a',[ ('Living',equivalence)]).
adjMapping2SUMO('00094799-s',[ ('',undefined)]).
adjMapping2SUMO('00094941-s',[ (capability,subsumption)]).
adjMapping2SUMO('00095094-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00095280-a',[ ('Dead',equivalence)]).
adjMapping2SUMO('00095873-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00096072-s',[ ('Dead',subsumption)]).
adjMapping2SUMO('00096239-s',[ ('Dead',subsumption)]).
adjMapping2SUMO('00096414-s',[ ('Dead',subsumption)]).
adjMapping2SUMO('00096595-s',[ ('AnimacyAttribute',subsumption)]).
adjMapping2SUMO('00096815-s',[ ('AnimacyAttribute',subsumption)]).
adjMapping2SUMO('00096913-s',[ ('',undefined)]).
adjMapping2SUMO('00097022-s',[ ('AnimacyAttribute',subsumption)]).
adjMapping2SUMO('00097147-s',[ (exists,subsumption)]).
adjMapping2SUMO('00097305-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00097452-s',[ ('Killing',subsumption)]).
adjMapping2SUMO('00097577-s',[ ('Killing',subsumption)]).
adjMapping2SUMO('00097674-s',[ ('Dead',subsumption)]).
adjMapping2SUMO('00097768-s',[ ('Dead',equivalence)]).
adjMapping2SUMO('00097906-s',[ ('Killing',subsumption)]).
adjMapping2SUMO('00098043-s',[ (capability,subsumption)]).
adjMapping2SUMO('00098147-s',[ ('Killing',subsumption)]).
adjMapping2SUMO('00098307-s',[ ('Dead',subsumption)]).
adjMapping2SUMO('00098450-s',[ ('Dead',subsumption)]).
adjMapping2SUMO('00098529-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00098736-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00098933-a',[ (capability,subsumption)]).
adjMapping2SUMO('00099097-a',[ (capability,subsumption)]).
adjMapping2SUMO('00099290-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00099590-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00099704-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00099874-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00100213-s',[ ('Combustion',not(subsumption))]).
adjMapping2SUMO('00100373-s',[ (capability,subsumption)]).
adjMapping2SUMO('00100506-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00100634-a',[ ('Classifying',subsumption)]).
adjMapping2SUMO('00100881-s',[ ('List',subsumption)]).
adjMapping2SUMO('00100989-s',[ ('Classifying',subsumption)]).
adjMapping2SUMO('00101152-a',[ ('Classifying',subsumption)]).
adjMapping2SUMO('00101331-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00101452-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00101609-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00101800-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00102079-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00102201-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('00102578-s',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('00102786-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('00102930-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00103196-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00103302-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00103447-s',[ ('Word',subsumption)]).
adjMapping2SUMO('00103567-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00103696-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('00103953-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('00104051-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00104318-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00104533-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00104699-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00104825-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00104942-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00105023-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00105197-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00105388-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00105566-a',[ ('',undefined)]).
adjMapping2SUMO('00105746-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00106020-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00106182-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00106277-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00106456-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00106821-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00107017-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00107128-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00107250-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00107384-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00107648-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00107868-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00107984-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00108145-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00108263-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00108434-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00108595-a',[ ('',undefined)]).
adjMapping2SUMO('00108698-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00109016-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00109133-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00109261-a',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('00109382-a',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('00109504-a',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('00109633-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('00109782-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('00109966-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00110252-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00110497-a',[ ('Device',subsumption)]).
adjMapping2SUMO('00110701-a',[ ('Device',subsumption)]).
adjMapping2SUMO('00110853-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('00111129-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('00111415-a',[ ('Language',subsumption)]).
adjMapping2SUMO('00111604-s',[ ('Language',subsumption)]).
adjMapping2SUMO('00111856-a',[ ('Language',subsumption)]).
adjMapping2SUMO('00112018-s',[ ('Language',subsumption)]).
adjMapping2SUMO('00112231-a',[ ('IntentionalPsychologicalProcess',subsumption)]).
adjMapping2SUMO('00112628-a',[ ('IntentionalPsychologicalProcess',subsumption)]).
adjMapping2SUMO('00113015-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('00113245-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('00113476-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00113663-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00113818-a',[ ('Anger',equivalence)]).
adjMapping2SUMO('00114266-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00114454-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00114797-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00114921-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00115094-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00115193-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00115494-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00115777-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00115906-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00116058-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00116245-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00116463-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00116529-a',[ ('Unhappiness',subsumption)]).
adjMapping2SUMO('00116744-s',[ ('Anger',equivalence)]).
adjMapping2SUMO('00116940-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00117106-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00117235-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00117385-a',[ ('SentientAgent',subsumption)]).
adjMapping2SUMO('00117654-s',[ ('SentientAgent',equivalence)]).
adjMapping2SUMO('00117754-a',[ ('SentientAgent',not(equivalence))]).
adjMapping2SUMO('00117961-s',[ ('SentientAgent',not(subsumption))]).
adjMapping2SUMO('00118066-a',[ ('Animal',equivalence)]).
adjMapping2SUMO('00118238-a',[ ('Dead',subsumption)]).
adjMapping2SUMO('00118451-s',[ ('Unconscious',equivalence)]).
adjMapping2SUMO('00118567-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00118844-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00119006-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00119279-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00119409-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00119533-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00119750-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00119875-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00119993-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00120132-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00120252-a',[ ('Noun',subsumption)]).
adjMapping2SUMO('00120411-a',[ ('Noun',subsumption)]).
adjMapping2SUMO('00120574-a',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('00120784-s',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('00121034-a',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('00121183-s',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('00121376-s',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('00121552-a',[ (earlier,subsumption)]).
adjMapping2SUMO('00121649-a',[ (earlier,subsumption)]).
adjMapping2SUMO('00121865-a',[ (earlier,subsumption)]).
adjMapping2SUMO('00122128-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00122245-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00122386-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00122626-a',[ (earlier,subsumption)]).
adjMapping2SUMO('00122844-s',[ (causes,subsumption)]).
adjMapping2SUMO('00123485-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00123653-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00123804-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00123961-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00124077-a',[ (located,subsumption)]).
adjMapping2SUMO('00124353-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00124493-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00124685-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00124918-a',[ (located,subsumption)]).
adjMapping2SUMO('00125068-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('00125170-s',[ ('Transportation',subsumption)]).
adjMapping2SUMO('00125319-a',[ ('Government',subsumption)]).
adjMapping2SUMO('00125553-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00125711-a',[ (earlier,subsumption)]).
adjMapping2SUMO('00125993-s',[ ('Above',equivalence)]).
adjMapping2SUMO('00126116-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00126235-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00126339-s',[ ('Text',subsumption)]).
adjMapping2SUMO('00126497-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00126702-s',[ ('FieldOfStudy',subsumption)]).
adjMapping2SUMO('00126830-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00127137-s',[ (meetsTemporally,equivalence)]).
adjMapping2SUMO('00127296-a',[ (earlier,subsumption)]).
adjMapping2SUMO('00127543-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00127661-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00127815-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00127948-s',[ ('ListOrderFn',equivalence)]).
adjMapping2SUMO('00128137-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00128262-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00128467-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00128572-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00128733-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00128882-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00129029-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00129103-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('00129276-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('00129467-a',[ ('Birth',subsumption)]).
adjMapping2SUMO('00129612-a',[ (earlier,subsumption)]).
adjMapping2SUMO('00129729-a',[ (earlier,subsumption)]).
adjMapping2SUMO('00129878-a',[ (earlier,subsumption)]).
adjMapping2SUMO('00130017-a',[ (earlier,subsumption)]).
adjMapping2SUMO('00130151-a',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('00130281-a',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('00130412-a',[ (earlier,subsumption)]).
adjMapping2SUMO('00130518-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00130596-a',[ (earlier,subsumption)]).
adjMapping2SUMO('00130701-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00130778-a',[ ('FrontFn',subsumption)]).
adjMapping2SUMO('00131018-s',[ ('FrontFn',subsumption)]).
adjMapping2SUMO('00131176-s',[ ('FrontFn',subsumption)]).
adjMapping2SUMO('00131297-s',[ ('FrontFn',subsumption)]).
adjMapping2SUMO('00131426-a',[ ('BackFn',subsumption)]).
adjMapping2SUMO('00131692-s',[ ('BackFn',subsumption)]).
adjMapping2SUMO('00131863-s',[ ('BackFn',subsumption)]).
adjMapping2SUMO('00132040-s',[ ('BackFn',subsumption)]).
adjMapping2SUMO('00132127-a',[ ('BackFn',subsumption)]).
adjMapping2SUMO('00132385-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00132754-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00132849-a',[ (capability,subsumption)]).
adjMapping2SUMO('00133065-a',[ (capability,subsumption)]).
adjMapping2SUMO('00133259-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00133335-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('00133417-a',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('00133669-s',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('00133851-a',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('00134060-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00134251-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00134401-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00134562-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00134701-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00135092-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00135193-s',[ ('',undefined)]).
adjMapping2SUMO('00135342-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00135455-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00135718-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00136081-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00136185-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00136354-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00136589-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00136727-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00136884-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00137120-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00137277-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00137373-s',[ ('',undefined)]).
adjMapping2SUMO('00137501-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00137641-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00137725-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00137943-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00138169-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00138314-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00138622-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00138782-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00138912-a',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('00139126-a',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('00139344-a',[ ('Building',subsumption)]).
adjMapping2SUMO('00139492-s',[ ('Building',subsumption)]).
adjMapping2SUMO('00139702-s',[ ('Building',subsumption)]).
adjMapping2SUMO('00139870-a',[ ('Building',subsumption)]).
adjMapping2SUMO('00139990-s',[ ('Building',subsumption)]).
adjMapping2SUMO('00140075-s',[ ('Building',subsumption)]).
adjMapping2SUMO('00140233-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00140437-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00140542-a',[ ('Building',subsumption)]).
adjMapping2SUMO('00140880-s',[ ('Building',subsumption)]).
adjMapping2SUMO('00140989-s',[ ('Building',subsumption)]).
adjMapping2SUMO('00141111-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00141316-s',[ ('Building',subsumption)]).
adjMapping2SUMO('00141429-s',[ ('Building',subsumption)]).
adjMapping2SUMO('00141522-a',[ ('Building',subsumption)]).
adjMapping2SUMO('00141647-s',[ ('Building',subsumption)]).
adjMapping2SUMO('00141746-s',[ ('Building',subsumption)]).
adjMapping2SUMO('00141818-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00141947-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00142040-a',[ (part,subsumption)]).
adjMapping2SUMO('00142270-a',[ (part,subsumption)]).
adjMapping2SUMO('00142407-a',[ ('Weapon',subsumption)]).
adjMapping2SUMO('00142622-s',[ ('Weapon',subsumption)]).
adjMapping2SUMO('00142704-s',[ ('Weapon',subsumption)]).
adjMapping2SUMO('00142825-s',[ ('Weapon',subsumption)]).
adjMapping2SUMO('00142917-a',[ ('Weapon',not(subsumption))]).
adjMapping2SUMO('00143201-s',[ ('Weapon',not(subsumption))]).
adjMapping2SUMO('00143294-s',[ ('Weapon',not(subsumption))]).
adjMapping2SUMO('00143376-s',[ ('Weapon',not(subsumption))]).
adjMapping2SUMO('00143516-s',[ ('Weapon',not(subsumption))]).
adjMapping2SUMO('00143589-a',[ (part,subsumption)]).
adjMapping2SUMO('00143854-s',[ (part,subsumption)]).
adjMapping2SUMO('00144020-s',[ ('',undefined)]).
adjMapping2SUMO('00144102-s',[ (capability,subsumption)]).
adjMapping2SUMO('00144244-s',[ (part,subsumption)]).
adjMapping2SUMO('00144408-s',[ ('',undefined)]).
adjMapping2SUMO('00144510-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00144598-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00144728-a',[ (part,subsumption)]).
adjMapping2SUMO('00144877-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00145083-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00145628-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00145706-s',[ ('',undefined)]).
adjMapping2SUMO('00145805-s',[ ('',undefined)]).
adjMapping2SUMO('00145883-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00145995-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00146128-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00146210-a',[ ('Human',subsumption)]).
adjMapping2SUMO('00146430-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00146501-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00146609-s',[ ('',undefined)]).
adjMapping2SUMO('00146693-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00146786-a',[ ('Human',subsumption)]).
adjMapping2SUMO('00146883-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('00147052-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00147160-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00147397-s',[ ('',undefined)]).
adjMapping2SUMO('00147528-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('00147659-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00147734-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00148078-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00148642-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00148852-s',[ ('Planning',subsumption)]).
adjMapping2SUMO('00149120-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00149262-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00149461-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00149686-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00149861-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00150055-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00150202-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00150505-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00150835-s',[ (capability,subsumption)]).
adjMapping2SUMO('00150936-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00151105-a',[ (capability,subsumption)]).
adjMapping2SUMO('00151530-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('00151661-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00151855-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00152004-s',[ (capability,subsumption)]).
adjMapping2SUMO('00152104-s',[ (capability,subsumption)]).
adjMapping2SUMO('00152285-s',[ ('RadiatingSound',not(subsumption))]).
adjMapping2SUMO('00152629-s',[ (capability,subsumption)]).
adjMapping2SUMO('00152784-s',[ ('Communication',subsumption)]).
adjMapping2SUMO('00152896-a',[ ('Communication',subsumption)]).
adjMapping2SUMO('00153083-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00153239-a',[ (capability,subsumption)]).
adjMapping2SUMO('00153410-a',[ ('CorpuscularObject',subsumption)]).
adjMapping2SUMO('00153545-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00153652-a',[ ('Object',subsumption)]).
adjMapping2SUMO('00153789-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00153898-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00154163-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00154270-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00154583-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00154837-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00154965-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00155144-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00155720-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00155886-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00156101-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00156440-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00156575-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00156839-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00157080-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00157268-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00157389-a',[ ('PsychologicalProcess',subsumption)]).
adjMapping2SUMO('00157659-s',[ (capability,subsumption)]).
adjMapping2SUMO('00157849-a',[ ('PsychologicalProcess',subsumption)]).
adjMapping2SUMO('00157925-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00158110-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00158238-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00158332-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00158407-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00158546-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00158701-a',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00158864-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00158961-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00159106-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00159267-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00159381-a',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('00159498-a',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00159735-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('00159975-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00160144-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('00160288-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00160425-a',[ ('Building',subsumption)]).
adjMapping2SUMO('00160573-a',[ ('Building',subsumption)]).
adjMapping2SUMO('00160768-s',[ ('Building',subsumption)]).
adjMapping2SUMO('00160957-s',[ ('Building',subsumption)]).
adjMapping2SUMO('00161065-a',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00161170-s',[ ('',undefined)]).
adjMapping2SUMO('00161276-a',[ ('Detaching',subsumption)]).
adjMapping2SUMO('00161431-a',[ (capability,subsumption)]).
adjMapping2SUMO('00161684-s',[ (capability,subsumption)]).
adjMapping2SUMO('00161878-s',[ (capability,subsumption)]).
adjMapping2SUMO('00161993-s',[ (capability,subsumption)]).
adjMapping2SUMO('00162083-a',[ (capability,subsumption)]).
adjMapping2SUMO('00162248-s',[ ('',undefined)]).
adjMapping2SUMO('00162386-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00162661-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00162863-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00162990-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00163315-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00163480-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00163592-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00163948-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00164308-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00164462-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00164598-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00164681-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00164863-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00165171-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00165458-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00165585-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00165766-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00165943-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00166146-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00166753-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00167077-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00167278-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00167520-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00167671-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00167829-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00168039-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00168188-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00168551-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00168694-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00168820-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00168910-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00169056-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00169164-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00169432-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00169692-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00169826-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00169955-a',[ (capability,subsumption)]).
adjMapping2SUMO('00170156-a',[ (capability,subsumption)]).
adjMapping2SUMO('00170358-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00170717-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00170847-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00171044-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00171292-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00171447-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00171590-a',[ (capability,subsumption)]).
adjMapping2SUMO('00171872-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00172172-s',[ ('Stating',subsumption)]).
adjMapping2SUMO('00172308-s',[ (capability,subsumption)]).
adjMapping2SUMO('00172452-a',[ (capability,subsumption)]).
adjMapping2SUMO('00172562-a',[ ('Adjective',subsumption)]).
adjMapping2SUMO('00172774-s',[ ('Adjective',subsumption)]).
adjMapping2SUMO('00172993-a',[ ('Adjective',subsumption)]).
adjMapping2SUMO('00173220-a',[ ('Pregnant',subsumption)]).
adjMapping2SUMO('00173391-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00173694-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00173764-a',[ (capability,subsumption)]).
adjMapping2SUMO('00174056-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00174150-s',[ ('RadiatingSound',equivalence)]).
adjMapping2SUMO('00174243-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('00174379-a',[ (capability,subsumption)]).
adjMapping2SUMO('00174719-s',[ ('Communication',subsumption)]).
adjMapping2SUMO('00174879-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('00174983-s',[ ('MotionPicture',subsumption)]).
adjMapping2SUMO('00175123-s',[ ('RadiatingSound',not(subsumption))]).
adjMapping2SUMO('00175300-s',[ ('RadiatingSoundUltrasonic',subsumption)]).
adjMapping2SUMO('00175435-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('00175528-a',[ ('SpeedFn',subsumption)]).
adjMapping2SUMO('00175719-a',[ ('SpeedFn',subsumption)]).
adjMapping2SUMO('00175887-a',[ ('SpeedFn',subsumption)]).
adjMapping2SUMO('00176150-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00176387-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00176676-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00176838-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00176991-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00177186-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00177547-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00177834-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00177963-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00178126-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00178464-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00178575-a',[ (holdsRight,subsumption)]).
adjMapping2SUMO('00178811-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('00179035-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('00179190-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('00179315-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('00179486-a',[ (holdsRight,subsumption)]).
adjMapping2SUMO('00179676-s',[ ('Declaring',subsumption)]).
adjMapping2SUMO('00179815-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('00179925-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00180211-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00180359-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('00180496-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('00180655-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('00180835-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('00181030-a',[ (origin,subsumption)]).
adjMapping2SUMO('00181162-s',[ (origin,subsumption)]).
adjMapping2SUMO('00181264-s',[ ('',undefined)]).
adjMapping2SUMO('00181373-a',[ (origin,subsumption)]).
adjMapping2SUMO('00181476-a',[ ('Device',subsumption)]).
adjMapping2SUMO('00181904-s',[ ('Weapon',subsumption)]).
adjMapping2SUMO('00182086-s',[ ('Device',subsumption)]).
adjMapping2SUMO('00182225-s',[ ('Device',subsumption)]).
adjMapping2SUMO('00182418-s',[ ('Device',subsumption)]).
adjMapping2SUMO('00182510-s',[ ('Device',subsumption)]).
adjMapping2SUMO('00182639-s',[ ('',undefined)]).
adjMapping2SUMO('00182718-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00182843-a',[ ('Device',subsumption)]).
adjMapping2SUMO('00182961-s',[ ('Device',subsumption)]).
adjMapping2SUMO('00183053-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00183675-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00183832-s',[ (capability,subsumption)]).
adjMapping2SUMO('00183932-s',[ (capability,subsumption)]).
adjMapping2SUMO('00184075-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00184229-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00184363-s',[ (capability,subsumption)]).
adjMapping2SUMO('00184543-s',[ ('Keeping',subsumption)]).
adjMapping2SUMO('00184676-s',[ ('',undefined)]).
adjMapping2SUMO('00184792-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00185020-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00185160-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00185363-s',[ ('Keeping',subsumption)]).
adjMapping2SUMO('00185509-s',[ ('Position',subsumption)]).
adjMapping2SUMO('00185607-s',[ (capability,subsumption)]).
adjMapping2SUMO('00185759-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00185921-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00186193-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00186490-s',[ ('Keeping',subsumption)]).
adjMapping2SUMO('00186616-a',[ ('Awake',equivalence)]).
adjMapping2SUMO('00186925-s',[ ('Awake',subsumption)]).
adjMapping2SUMO('00187049-s',[ ('Awake',subsumption)]).
adjMapping2SUMO('00187176-s',[ ('Awake',subsumption)]).
adjMapping2SUMO('00187443-s',[ ('Awake',subsumption)]).
adjMapping2SUMO('00187590-s',[ ('Asleep',subsumption)]).
adjMapping2SUMO('00187736-a',[ ('Asleep',equivalence)]).
adjMapping2SUMO('00188058-s',[ ('Asleep',subsumption)]).
adjMapping2SUMO('00188155-s',[ ('Asleep',subsumption)]).
adjMapping2SUMO('00188436-s',[ ('ConsciousnessAttribute',subsumption)]).
adjMapping2SUMO('00188738-s',[ ('Asleep',subsumption)]).
adjMapping2SUMO('00188917-s',[ ('',undefined)]).
adjMapping2SUMO('00189017-s',[ ('ConsciousnessAttribute',subsumption)]).
adjMapping2SUMO('00189253-s',[ ('ConsciousnessAttribute',subsumption)]).
adjMapping2SUMO('00189511-s',[ ('Asleep',subsumption)]).
adjMapping2SUMO('00189580-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00189833-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00190023-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00190115-a',[ (inScopeOfInterest,equivalence)]).
adjMapping2SUMO('00190653-s',[ ('IntentionalRelation',subsumption)]).
adjMapping2SUMO('00190960-s',[ ('IntentionalRelation',subsumption)]).
adjMapping2SUMO('00191265-s',[ ('IntentionalRelation',subsumption)]).
adjMapping2SUMO('00191603-a',[ ('IntentionalRelation',subsumption)]).
adjMapping2SUMO('00192026-s',[ ('IntentionalRelation',subsumption)]).
adjMapping2SUMO('00192332-s',[ ('IntentionalRelation',subsumption)]).
adjMapping2SUMO('00192523-s',[ ('IntentionalRelation',subsumption)]).
adjMapping2SUMO('00192756-a',[ ('IntentionalRelation',subsumption)]).
adjMapping2SUMO('00192880-a',[ ('IntentionalRelation',subsumption)]).
adjMapping2SUMO('00193015-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00193367-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00193480-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00193799-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00194357-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00194817-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00194924-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00195191-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00195383-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00195684-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00196122-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00196233-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00196312-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00196449-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00196560-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00196664-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00196799-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00196934-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00197151-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00197247-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00197319-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00197447-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00197576-a',[ ('BackFn',equivalence)]).
adjMapping2SUMO('00197773-s',[ ('BackFn',subsumption)]).
adjMapping2SUMO('00197891-s',[ ('BackFn',subsumption)]).
adjMapping2SUMO('00198147-a',[ ('FrontFn',equivalence)]).
adjMapping2SUMO('00198383-s',[ ('FrontFn',subsumption)]).
adjMapping2SUMO('00198610-s',[ ('FrontFn',subsumption)]).
adjMapping2SUMO('00198757-s',[ ('FrontFn',subsumption)]).
adjMapping2SUMO('00198904-a',[ ('FrontFn',subsumption)]).
adjMapping2SUMO('00199114-s',[ ('Guiding',equivalence)]).
adjMapping2SUMO('00199463-s',[ ('Guiding',equivalence)]).
adjMapping2SUMO('00199569-a',[ ('Guiding',subsumption)]).
adjMapping2SUMO('00199811-s',[ ('Pursuing',subsumption)]).
adjMapping2SUMO('00200026-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00200258-s',[ ('Book',subsumption)]).
adjMapping2SUMO('00200431-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00200529-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00200603-s',[ (part,subsumption)]).
adjMapping2SUMO('00200760-s',[ ('',undefined)]).
adjMapping2SUMO('00200854-s',[ (part,subsumption)]).
adjMapping2SUMO('00200979-s',[ (part,subsumption)]).
adjMapping2SUMO('00201130-a',[ (part,subsumption)]).
adjMapping2SUMO('00201259-s',[ (part,subsumption)]).
adjMapping2SUMO('00201354-a',[ ('BackFn',subsumption)]).
adjMapping2SUMO('00201722-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00201802-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('00201961-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00202095-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00202250-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00202411-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00202508-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('00202677-s',[ ('Icon',subsumption)]).
adjMapping2SUMO('00202772-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00202875-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00203030-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00203123-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00203237-a',[ ('FrontFn',subsumption)]).
adjMapping2SUMO('00203495-s',[ ('Icon',subsumption)]).
adjMapping2SUMO('00203614-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00203774-a',[ ('EngineeringComponent',subsumption)]).
adjMapping2SUMO('00203917-a',[ ('EngineeringComponent',subsumption)]).
adjMapping2SUMO('00204077-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00204249-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00204491-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00204779-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00205033-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00205150-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00205295-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00205696-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00206003-a',[ ('Building',subsumption)]).
adjMapping2SUMO('00206127-a',[ ('Building',subsumption)]).
adjMapping2SUMO('00206205-a',[ ('Object',subsumption)]).
adjMapping2SUMO('00206317-a',[ ('Object',subsumption)]).
adjMapping2SUMO('00206403-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00206627-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00206750-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00206900-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00207034-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00207133-s',[ ('',undefined)]).
adjMapping2SUMO('00207226-s',[ ('',undefined)]).
adjMapping2SUMO('00207305-s',[ ('',undefined)]).
adjMapping2SUMO('00207389-s',[ ('',undefined)]).
adjMapping2SUMO('00207467-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('00207547-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00207706-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00207809-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00207887-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00207961-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00208052-a',[ ('Position',subsumption)]).
adjMapping2SUMO('00208150-a',[ ('Position',subsumption)]).
adjMapping2SUMO('00208229-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('00208447-s',[ ('Mineral',subsumption)]).
adjMapping2SUMO('00208613-s',[ ('',undefined)]).
adjMapping2SUMO('00208749-s',[ (part,subsumption)]).
adjMapping2SUMO('00208872-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00208946-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('00209079-a',[ ('Fern',subsumption)]).
adjMapping2SUMO('00209253-s',[ ('Fern',subsumption)]).
adjMapping2SUMO('00209390-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00209550-a',[ ('Fern',subsumption)]).
adjMapping2SUMO('00209620-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00209781-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00209916-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00209988-s',[ ('',undefined)]).
adjMapping2SUMO('00210079-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00210212-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00210281-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00210371-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00210446-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('00210848-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00211026-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00211092-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00211221-s',[ (capability,subsumption)]).
adjMapping2SUMO('00211370-s',[ ('Mammal',subsumption)]).
adjMapping2SUMO('00211444-s',[ ('',undefined)]).
adjMapping2SUMO('00211564-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00211735-s',[ ('',undefined)]).
adjMapping2SUMO('00211827-s',[ ('',undefined)]).
adjMapping2SUMO('00211916-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00212057-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00212173-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('00212949-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00213071-s',[ ('',undefined)]).
adjMapping2SUMO('00213172-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('00213387-s',[ ('',undefined)]).
adjMapping2SUMO('00213516-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00213610-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00213814-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('00213933-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00214001-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00214165-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00214323-s',[ ('',undefined)]).
adjMapping2SUMO('00214461-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00214640-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00214812-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00214907-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00215087-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00215257-s',[ ('',undefined)]).
adjMapping2SUMO('00215344-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00215468-s',[ ('',undefined)]).
adjMapping2SUMO('00215564-s',[ ('',undefined)]).
adjMapping2SUMO('00215654-s',[ ('',undefined)]).
adjMapping2SUMO('00215745-s',[ ('',undefined)]).
adjMapping2SUMO('00215834-s',[ ('',undefined)]).
adjMapping2SUMO('00215929-s',[ ('',undefined)]).
adjMapping2SUMO('00216003-s',[ ('',undefined)]).
adjMapping2SUMO('00216079-s',[ ('',undefined)]).
adjMapping2SUMO('00216155-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00216308-s',[ ('',undefined)]).
adjMapping2SUMO('00216420-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00216560-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00216668-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00216858-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00217075-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00217183-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00217297-a',[ ('EngineeringComponent',subsumption)]).
adjMapping2SUMO('00217428-s',[ ('EngineeringComponent',subsumption)]).
adjMapping2SUMO('00217563-a',[ ('EngineeringComponent',subsumption)]).
adjMapping2SUMO('00217728-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00218305-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00218440-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00218673-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00218837-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00218950-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00219389-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00219705-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00219809-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00219924-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00220082-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00220241-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00220341-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00220502-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00220600-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00220739-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00220956-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00221318-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00221469-s',[ ('',undefined)]).
adjMapping2SUMO('00221553-s',[ ('',undefined)]).
adjMapping2SUMO('00221627-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00221934-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00222147-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00222272-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00222449-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00222543-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00222662-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00222775-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00222873-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00222969-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00223119-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00223220-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00223375-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00223504-s',[ ('',undefined)]).
adjMapping2SUMO('00223582-s',[ ('',undefined)]).
adjMapping2SUMO('00223683-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00223802-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00224031-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00224166-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00224366-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00224515-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00224731-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00225099-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00225408-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00225564-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00225821-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00225912-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00226105-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00226339-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00226434-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00226535-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00226618-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00226891-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00227003-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00227301-s',[ ('',undefined)]).
adjMapping2SUMO('00227507-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00228025-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00228173-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00228294-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00228485-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00228645-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00228876-s',[ ('',undefined)]).
adjMapping2SUMO('00228967-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('00229130-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('00229227-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00229371-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00229487-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00229630-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00229978-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('00230076-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('00230208-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00230335-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00230843-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00230940-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00231103-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00231252-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00231591-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00231761-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00231963-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00232068-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00232234-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00232385-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00232620-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00232754-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00232986-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00233151-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00233263-a',[ ('Government',subsumption)]).
adjMapping2SUMO('00233353-a',[ ('Government',subsumption)]).
adjMapping2SUMO('00233442-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00233635-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00233756-s',[ ('Device',subsumption)]).
adjMapping2SUMO('00233925-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00234106-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00234378-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00234522-s',[ ('Device',subsumption)]).
adjMapping2SUMO('00234733-s',[ ('SelfConnectedObject',subsumption)]).
adjMapping2SUMO('00234872-a',[ ('SelfConnectedObject',subsumption)]).
adjMapping2SUMO('00235239-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00235326-s',[ ('',undefined)]).
adjMapping2SUMO('00235429-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00235571-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00235731-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00235823-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00235913-s',[ ('',undefined)]).
adjMapping2SUMO('00235988-s',[ ('',undefined)]).
adjMapping2SUMO('00236086-s',[ ('',undefined)]).
adjMapping2SUMO('00236200-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00236338-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00236483-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00236652-s',[ (knows,subsumption)]).
adjMapping2SUMO('00236839-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00236922-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00236989-a',[ (part,subsumption)]).
adjMapping2SUMO('00237156-s',[ ('Government',subsumption)]).
adjMapping2SUMO('00237240-a',[ (part,subsumption)]).
adjMapping2SUMO('00237788-s',[ (part,subsumption)]).
adjMapping2SUMO('00237881-s',[ ('',undefined)]).
adjMapping2SUMO('00237965-s',[ ('',undefined)]).
adjMapping2SUMO('00238037-s',[ (part,subsumption)]).
adjMapping2SUMO('00238189-s',[ ('Government',subsumption)]).
adjMapping2SUMO('00238310-s',[ ('Government',subsumption)]).
adjMapping2SUMO('00238400-s',[ (part,subsumption)]).
adjMapping2SUMO('00238490-s',[ ('',undefined)]).
adjMapping2SUMO('00238564-s',[ ('',undefined)]).
adjMapping2SUMO('00238636-s',[ ('',undefined)]).
adjMapping2SUMO('00238712-s',[ ('',undefined)]).
adjMapping2SUMO('00238788-s',[ ('',undefined)]).
adjMapping2SUMO('00238862-s',[ ('',undefined)]).
adjMapping2SUMO('00238934-s',[ ('',undefined)]).
adjMapping2SUMO('00239012-s',[ ('',undefined)]).
adjMapping2SUMO('00239090-s',[ ('Government',subsumption)]).
adjMapping2SUMO('00239185-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00239325-s',[ ('Collection',subsumption)]).
adjMapping2SUMO('00239444-s',[ ('',undefined)]).
adjMapping2SUMO('00239520-s',[ ('',undefined)]).
adjMapping2SUMO('00239594-s',[ ('',undefined)]).
adjMapping2SUMO('00239668-s',[ ('',undefined)]).
adjMapping2SUMO('00239742-s',[ ('',undefined)]).
adjMapping2SUMO('00239847-s',[ (part,subsumption)]).
adjMapping2SUMO('00240008-s',[ ('Collection',subsumption)]).
adjMapping2SUMO('00240197-a',[ ('Collection',subsumption)]).
adjMapping2SUMO('00240323-a',[ ('Collection',subsumption)]).
adjMapping2SUMO('00240417-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00240584-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00240655-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00240842-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00241004-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00241079-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00241260-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('00241397-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('00241530-a',[ ('',undefined)]).
adjMapping2SUMO('00241672-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('00241816-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('00241952-a',[ ('Human',subsumption)]).
adjMapping2SUMO('00242293-s',[ ('EthnicGroup',subsumption)]).
adjMapping2SUMO('00242575-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00242832-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00243039-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00243180-a',[ ('WhiteEthnicity',equivalence)]).
adjMapping2SUMO('00243395-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00243515-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00243606-a',[ ('Human',subsumption)]).
adjMapping2SUMO('00243945-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00244054-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00244199-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00244324-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00244410-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00244503-a',[ ('Human',subsumption)]).
adjMapping2SUMO('00244820-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00244958-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00245112-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00245200-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00245319-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00245458-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00245763-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00245860-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00245952-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00246175-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00246348-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00246497-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00246623-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00246727-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('00246878-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00247013-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00247247-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00247439-a',[ ('Blood',subsumption)]).
adjMapping2SUMO('00247868-s',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('00247993-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('00248118-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('00248251-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00248560-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00248837-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00249104-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00249303-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00249433-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('00249576-s',[ ('ViolentContest',not(subsumption))]).
adjMapping2SUMO('00249721-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00250119-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00250483-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00250659-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00250739-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00251134-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00251373-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00251529-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00251681-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00251809-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00252130-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00252310-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00252498-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00252733-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00252826-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00252954-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00253196-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00253361-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00253469-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00253654-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00253757-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00253869-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00254046-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00254152-a',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('00254296-s',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('00254419-s',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('00254516-a',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00254615-a',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('00254746-a',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00254880-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00254983-a',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('00255057-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00255308-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00255453-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00255582-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00255720-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00255918-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00256042-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00256237-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00256453-a',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('00256538-s',[ ('Detaching',subsumption)]).
adjMapping2SUMO('00256636-a',[ ('Book',subsumption)]).
adjMapping2SUMO('00256883-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00257032-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00257102-s',[ ('Book',subsumption)]).
adjMapping2SUMO('00257232-s',[ ('Book',subsumption)]).
adjMapping2SUMO('00257356-s',[ ('Book',subsumption)]).
adjMapping2SUMO('00257462-a',[ ('Book',subsumption)]).
adjMapping2SUMO('00257579-s',[ ('Text',subsumption)]).
adjMapping2SUMO('00257742-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00258090-s',[ ('Text',subsumption)]).
adjMapping2SUMO('00258255-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00258411-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00258587-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00258797-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00258899-s',[ ('',undefined)]).
adjMapping2SUMO('00259011-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00259098-s',[ ('',undefined)]).
adjMapping2SUMO('00259177-s',[ ('',undefined)]).
adjMapping2SUMO('00259256-a',[ (meetsSpatially,subsumption)]).
adjMapping2SUMO('00259329-a',[ ('',undefined)]).
adjMapping2SUMO('00259433-a',[ ('',undefined)]).
adjMapping2SUMO('00259568-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00259820-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00259957-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00260100-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00260323-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00260430-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00260695-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00260780-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00260973-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00261109-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00261245-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00261486-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00261602-s',[ (possesses,subsumption)]).
adjMapping2SUMO('00261735-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00261885-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('00262008-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00262124-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00262328-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00262444-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00262529-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00262705-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00262792-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00263463-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00263840-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00263994-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00264178-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00264262-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00264459-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00264570-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00264776-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00265214-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00265314-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00265496-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00265765-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00265989-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00266228-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00266309-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00266420-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00266634-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00266985-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00267145-a',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('00267268-s',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('00267356-a',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('00267452-a',[ ('Breathing',equivalence)]).
adjMapping2SUMO('00267774-s',[ ('',undefined)]).
adjMapping2SUMO('00267871-a',[ ('Breathing',subsumption)]).
adjMapping2SUMO('00268273-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('00268383-s',[ (causes,subsumption)]).
adjMapping2SUMO('00268748-s',[ ('Breathing',subsumption)]).
adjMapping2SUMO('00268869-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('00269063-s',[ ('Mineral',subsumption)]).
adjMapping2SUMO('00269241-s',[ ('Mineral',subsumption)]).
adjMapping2SUMO('00269364-s',[ ('Mineral',subsumption)]).
adjMapping2SUMO('00269486-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('00269580-s',[ ('Mineral',subsumption)]).
adjMapping2SUMO('00269758-a',[ (possesses,subsumption)]).
adjMapping2SUMO('00269894-a',[ (possesses,subsumption)]).
adjMapping2SUMO('00269989-a',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00270496-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00270732-s',[ ('',undefined)]).
adjMapping2SUMO('00270856-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00271022-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00271208-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00271288-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00271419-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00271580-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00271813-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00271966-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00272069-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00272172-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00272410-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00272555-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00272771-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00272950-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00273082-a',[ ('RadiatingLight',not(subsumption))]).
adjMapping2SUMO('00273652-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00273901-s',[ ('RadiatingLight',not(subsumption))]).
adjMapping2SUMO('00274068-s',[ ('RadiatingLight',not(subsumption))]).
adjMapping2SUMO('00274291-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00274373-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00274551-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00274698-s',[ ('RadiatingLight',not(subsumption))]).
adjMapping2SUMO('00274833-s',[ ('RadiatingLight',not(subsumption))]).
adjMapping2SUMO('00274971-s',[ ('RadiatingLight',not(subsumption))]).
adjMapping2SUMO('00275106-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00275290-s',[ ('RadiatingLight',not(subsumption))]).
adjMapping2SUMO('00275486-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00275764-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00275985-s',[ ('RadiatingLight',not(subsumption))]).
adjMapping2SUMO('00276226-s',[ ('',undefined)]).
adjMapping2SUMO('00276355-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00276472-a',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('00276689-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00276862-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('00277183-a',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('00277339-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('00277550-a',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('00277749-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('00277867-a',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('00278006-a',[ ('Illuminated',subsumption)]).
adjMapping2SUMO('00278131-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('00278266-a',[ (capability,subsumption)]).
adjMapping2SUMO('00278418-a',[ (capability,subsumption)]).
adjMapping2SUMO('00278551-a',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00279092-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00279332-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00279618-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00280245-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00280463-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00280844-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00281075-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00281173-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00281342-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00281527-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00281657-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00282020-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00282389-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00282557-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00282675-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('00283060-s',[ ('',undefined)]).
adjMapping2SUMO('00283167-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00283327-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00283580-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00283703-a',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00283972-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00284194-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00284400-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00284575-a',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00284816-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00284930-a',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00285148-a',[ (believes,subsumption)]).
adjMapping2SUMO('00285413-s',[ ('',undefined)]).
adjMapping2SUMO('00285506-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00285725-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00285905-s',[ (believes,subsumption)]).
adjMapping2SUMO('00286063-s',[ (believes,subsumption)]).
adjMapping2SUMO('00286214-a',[ (believes,subsumption)]).
adjMapping2SUMO('00286470-s',[ (believes,subsumption)]).
adjMapping2SUMO('00286578-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00286837-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00287128-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00287275-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00287498-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00287640-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00287962-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00288070-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00288237-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00288362-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00288498-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00288685-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00288809-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00289082-a',[ ('Detaching',equivalence)]).
adjMapping2SUMO('00289365-a',[ ('Separating',not(subsumption))]).
adjMapping2SUMO('00289594-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00289799-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00289983-a',[ ('Separating',subsumption)]).
adjMapping2SUMO('00290337-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00290483-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00290593-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00290784-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00290923-a',[ ('Separating',not(subsumption))]).
adjMapping2SUMO('00291181-s',[ ('Freezing',subsumption)]).
adjMapping2SUMO('00291338-s',[ ('Separating',not(subsumption))]).
adjMapping2SUMO('00291471-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00291665-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00291848-a',[ ('',undefined)]).
adjMapping2SUMO('00292024-a',[ ('',undefined)]).
adjMapping2SUMO('00292298-a',[ (sibling,subsumption)]).
adjMapping2SUMO('00292448-a',[ (sibling,subsumption)]).
adjMapping2SUMO('00292611-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('00292750-s',[ ('Below',subsumption)]).
adjMapping2SUMO('00292872-a',[ ('Putting',not(subsumption))]).
adjMapping2SUMO('00292937-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00293248-s',[ (located,subsumption)]).
adjMapping2SUMO('00293376-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00293611-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00293819-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00293882-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00294056-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00294175-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00294463-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00294579-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00295011-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00295235-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00295507-s',[ ('Position',subsumption)]).
adjMapping2SUMO('00295657-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('00295924-s',[ ('',undefined)]).
adjMapping2SUMO('00296061-s',[ ('Bone',subsumption)]).
adjMapping2SUMO('00296186-s',[ ('Bone',subsumption)]).
adjMapping2SUMO('00296276-s',[ ('Bone',subsumption)]).
adjMapping2SUMO('00296354-a',[ ('Bone',not(subsumption))]).
adjMapping2SUMO('00296482-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('00296625-a',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00296783-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00296935-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00297097-a',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('00297250-s',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('00297403-a',[ (believes,subsumption)]).
adjMapping2SUMO('00297598-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00297755-s',[ (believes,subsumption)]).
adjMapping2SUMO('00297897-s',[ (believes,subsumption)]).
adjMapping2SUMO('00298041-a',[ (believes,subsumption)]).
adjMapping2SUMO('00298293-s',[ (believes,subsumption)]).
adjMapping2SUMO('00298507-s',[ (believes,subsumption)]).
adjMapping2SUMO('00298767-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00299144-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00299313-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00299476-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00299690-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00300007-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00300196-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00300359-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00300469-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00300738-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00300943-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00301032-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00301187-a',[ (capability,subsumption)]).
adjMapping2SUMO('00301432-s',[ (capability,subsumption)]).
adjMapping2SUMO('00301589-s',[ (capability,subsumption)]).
adjMapping2SUMO('00301777-a',[ (capability,subsumption)]).
adjMapping2SUMO('00301951-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00302436-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00302658-s',[ (capability,subsumption)]).
adjMapping2SUMO('00302761-a',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('00302951-s',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('00303480-s',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('00303579-s',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('00303727-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('00304144-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00304455-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00304670-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00304949-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00305225-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00305464-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00305590-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00305700-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00305882-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00306034-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00306131-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('00306232-a',[ ('Putting',not(subsumption))]).
adjMapping2SUMO('00306314-a',[ (capability,equivalence)]).
adjMapping2SUMO('00306663-s',[ (capability,subsumption)]).
adjMapping2SUMO('00306909-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00307182-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00307474-a',[ (capability,subsumption)]).
adjMapping2SUMO('00307794-s',[ (capability,subsumption)]).
adjMapping2SUMO('00308015-a',[ (capability,subsumption)]).
adjMapping2SUMO('00308188-a',[ (capability,subsumption)]).
adjMapping2SUMO('00308355-a',[ ('IntentionalProcess',subsumption)]).
adjMapping2SUMO('00308488-s',[ ('IntentionalProcess',subsumption)]).
adjMapping2SUMO('00308593-a',[ ('IntentionalProcess',not(subsumption))]).
adjMapping2SUMO('00308720-s',[ ('IntentionalProcess',not(subsumption))]).
adjMapping2SUMO('00308870-s',[ ('IntentionalProcess',not(subsumption))]).
adjMapping2SUMO('00309021-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00309620-s',[ ('',undefined)]).
adjMapping2SUMO('00309740-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00309945-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00310138-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00310433-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00310716-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00310943-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00311044-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00311187-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00311354-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00311505-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00311663-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00312234-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00312519-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00312757-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00313041-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00313217-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00313387-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00313701-s',[ ('Carnivore',equivalence)]).
adjMapping2SUMO('00313836-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00313911-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00314023-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('00314265-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00314390-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00314466-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00314559-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00314639-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00314794-s',[ ('Eating',subsumption)]).
adjMapping2SUMO('00314927-s',[ ('Eating',subsumption)]).
adjMapping2SUMO('00315109-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('00315254-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00315383-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00315631-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00315702-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00315805-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('00315931-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00316046-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00316167-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00316274-a',[ ('Covering',subsumption)]).
adjMapping2SUMO('00316477-a',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('00316572-a',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('00316733-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00316827-a',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('00317008-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00317310-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00317481-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00317629-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00317727-s',[ ('Cutting',subsumption)]).
adjMapping2SUMO('00317821-a',[ ('Cutting',not(subsumption))]).
adjMapping2SUMO('00317886-a',[ ('Text',subsumption)]).
adjMapping2SUMO('00318082-a',[ ('Text',subsumption)]).
adjMapping2SUMO('00318291-a',[ ('Text',subsumption)]).
adjMapping2SUMO('00318498-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00318667-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00318942-a',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('00319090-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('00319262-a',[ ('RegulatoryProcess',not(subsumption))]).
adjMapping2SUMO('00319389-s',[ ('Removing',not(subsumption))]).
adjMapping2SUMO('00319534-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('00319851-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00319965-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00320064-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00320177-s',[ ('',undefined)]).
adjMapping2SUMO('00320255-s',[ ('Bird',subsumption)]).
adjMapping2SUMO('00320378-s',[ ('',undefined)]).
adjMapping2SUMO('00320456-s',[ ('',undefined)]).
adjMapping2SUMO('00320536-s',[ ('',undefined)]).
adjMapping2SUMO('00320614-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00320756-s',[ ('',undefined)]).
adjMapping2SUMO('00320847-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('00320985-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00321094-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00321444-s',[ ('',undefined)]).
adjMapping2SUMO('00321535-s',[ ('',undefined)]).
adjMapping2SUMO('00321614-s',[ ('',undefined)]).
adjMapping2SUMO('00321691-s',[ ('',undefined)]).
adjMapping2SUMO('00321770-s',[ ('',undefined)]).
adjMapping2SUMO('00321849-s',[ ('',undefined)]).
adjMapping2SUMO('00321928-s',[ ('',undefined)]).
adjMapping2SUMO('00322007-s',[ ('',undefined)]).
adjMapping2SUMO('00322084-s',[ ('',undefined)]).
adjMapping2SUMO('00322161-s',[ ('',undefined)]).
adjMapping2SUMO('00322242-s',[ ('',undefined)]).
adjMapping2SUMO('00322321-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00322457-a',[ (causes,equivalence)]).
adjMapping2SUMO('00322844-s',[ (causes,subsumption)]).
adjMapping2SUMO('00322938-s',[ (causes,subsumption)]).
adjMapping2SUMO('00323047-s',[ (causes,subsumption)]).
adjMapping2SUMO('00323199-s',[ (causes,equivalence)]).
adjMapping2SUMO('00323426-s',[ (causes,subsumption)]).
adjMapping2SUMO('00323796-s',[ (causes,subsumption)]).
adjMapping2SUMO('00323873-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00324013-s',[ (causes,subsumption)]).
adjMapping2SUMO('00324195-s',[ (causes,subsumption)]).
adjMapping2SUMO('00324481-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00324680-s',[ (causes,subsumption)]).
adjMapping2SUMO('00324878-s',[ (causes,subsumption)]).
adjMapping2SUMO('00325069-s',[ (causes,subsumption)]).
adjMapping2SUMO('00325197-a',[ (causes,subsumption)]).
adjMapping2SUMO('00325281-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00325619-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00325840-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00325995-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00326202-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00326296-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00326436-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00326608-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00327031-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00327541-s',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('00327690-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00327857-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00327930-s',[ ('',undefined)]).
adjMapping2SUMO('00328017-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00328128-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00328270-s',[ ('Cell',not(subsumption))]).
adjMapping2SUMO('00328401-s',[ ('',undefined)]).
adjMapping2SUMO('00328528-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00328653-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00328798-a',[ ('Separating',subsumption)]).
adjMapping2SUMO('00329034-s',[ ('Separating',subsumption)]).
adjMapping2SUMO('00329268-a',[ ('Separating',not(subsumption))]).
adjMapping2SUMO('00329396-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00329585-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00329695-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00329831-a',[ (holdsRight,subsumption)]).
adjMapping2SUMO('00330219-s',[ (located,subsumption)]).
adjMapping2SUMO('00330322-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00330396-s',[ ('Device',subsumption)]).
adjMapping2SUMO('00330506-s',[ (located,subsumption)]).
adjMapping2SUMO('00330644-s',[ (located,subsumption)]).
adjMapping2SUMO('00330728-s',[ (located,subsumption)]).
adjMapping2SUMO('00330904-s',[ (located,subsumption)]).
adjMapping2SUMO('00331030-s',[ (located,subsumption)]).
adjMapping2SUMO('00331167-s',[ (located,subsumption)]).
adjMapping2SUMO('00331259-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00331446-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00331716-s',[ (located,subsumption)]).
adjMapping2SUMO('00331889-s',[ (located,subsumption)]).
adjMapping2SUMO('00332091-s',[ (located,subsumption)]).
adjMapping2SUMO('00332269-s',[ (located,subsumption)]).
adjMapping2SUMO('00332375-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('00332524-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('00332723-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00332869-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('00333015-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('00333197-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00333351-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00333611-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00333824-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00333987-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00334245-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00334379-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00334555-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00334702-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('00334852-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00334940-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00335090-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('00335225-s',[ ('PoliticalProcess',subsumption)]).
adjMapping2SUMO('00335421-a',[ (knows,subsumption)]).
adjMapping2SUMO('00335768-s',[ (knows,subsumption)]).
adjMapping2SUMO('00335895-s',[ (knows,subsumption)]).
adjMapping2SUMO('00336041-s',[ (knows,subsumption)]).
adjMapping2SUMO('00336168-a',[ (believes,subsumption)]).
adjMapping2SUMO('00336564-s',[ (believes,subsumption)]).
adjMapping2SUMO('00336724-s',[ (believes,subsumption)]).
adjMapping2SUMO('00336831-a',[ (knows,subsumption)]).
adjMapping2SUMO('00337172-s',[ (knows,subsumption)]).
adjMapping2SUMO('00337404-a',[ (believes,subsumption)]).
adjMapping2SUMO('00337841-s',[ (believes,subsumption)]).
adjMapping2SUMO('00338013-s',[ (believes,subsumption)]).
adjMapping2SUMO('00338275-s',[ ('IntentionalProcess',subsumption)]).
adjMapping2SUMO('00338421-a',[ (believes,subsumption)]).
adjMapping2SUMO('00338551-a',[ (believes,subsumption)]).
adjMapping2SUMO('00338669-s',[ (believes,subsumption)]).
adjMapping2SUMO('00338817-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00339157-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00339288-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00339599-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00339742-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00339941-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00340239-a',[ ('Likely',subsumption)]).
adjMapping2SUMO('00340626-s',[ ('Likely',subsumption)]).
adjMapping2SUMO('00340827-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00341017-s',[ ('Likely',subsumption)]).
adjMapping2SUMO('00341292-s',[ ('Likely',subsumption)]).
adjMapping2SUMO('00341405-a',[ ('Unlikely',subsumption)]).
adjMapping2SUMO('00341655-s',[ ('Unlikely',subsumption)]).
adjMapping2SUMO('00341933-s',[ ('Unlikely',subsumption)]).
adjMapping2SUMO('00342139-s',[ ('',undefined)]).
adjMapping2SUMO('00342250-a',[ ('Declaring',subsumption)]).
adjMapping2SUMO('00342488-s',[ (capability,subsumption)]).
adjMapping2SUMO('00342626-s',[ ('Certificate',subsumption)]).
adjMapping2SUMO('00342755-s',[ ('',undefined)]).
adjMapping2SUMO('00342902-a',[ ('Certificate',not(subsumption))]).
adjMapping2SUMO('00343015-a',[ ('Necessity',subsumption)]).
adjMapping2SUMO('00343226-s',[ ('Necessity',subsumption)]).
adjMapping2SUMO('00343360-s',[ ('Necessity',subsumption)]).
adjMapping2SUMO('00343552-s',[ ('Necessity',equivalence)]).
adjMapping2SUMO('00343700-a',[ ('Possibility',subsumption)]).
adjMapping2SUMO('00343883-a',[ (capability,subsumption)]).
adjMapping2SUMO('00344024-a',[ (capability,subsumption)]).
adjMapping2SUMO('00344125-a',[ (capability,subsumption)]).
adjMapping2SUMO('00344686-s',[ (capability,subsumption)]).
adjMapping2SUMO('00344816-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00344890-s',[ ('',undefined)]).
adjMapping2SUMO('00345005-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00345189-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00345494-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00345694-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00345860-s',[ ('',undefined)]).
adjMapping2SUMO('00345949-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00346103-s',[ (capability,subsumption)]).
adjMapping2SUMO('00346246-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00346368-s',[ (capability,subsumption)]).
adjMapping2SUMO('00346527-s',[ ('',undefined)]).
adjMapping2SUMO('00346626-s',[ (capability,subsumption)]).
adjMapping2SUMO('00346847-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00346991-a',[ (capability,subsumption)]).
adjMapping2SUMO('00347400-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00347571-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00347707-s',[ (capability,subsumption)]).
adjMapping2SUMO('00347880-s',[ ('',undefined)]).
adjMapping2SUMO('00348018-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00348198-a',[ (capability,subsumption)]).
adjMapping2SUMO('00348380-s',[ (capability,subsumption)]).
adjMapping2SUMO('00348537-s',[ (capability,subsumption)]).
adjMapping2SUMO('00348808-a',[ (capability,subsumption)]).
adjMapping2SUMO('00348938-s',[ (capability,subsumption)]).
adjMapping2SUMO('00349148-s',[ (capability,subsumption)]).
adjMapping2SUMO('00349295-a',[ (capability,subsumption)]).
adjMapping2SUMO('00349523-a',[ (capability,subsumption)]).
adjMapping2SUMO('00349759-s',[ (capability,subsumption)]).
adjMapping2SUMO('00349894-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00350069-a',[ (capability,subsumption)]).
adjMapping2SUMO('00350384-a',[ (capability,subsumption)]).
adjMapping2SUMO('00350621-a',[ ('Aerating',subsumption)]).
adjMapping2SUMO('00350876-s',[ ('Device',subsumption)]).
adjMapping2SUMO('00351012-s',[ ('AdditionFn',subsumption)]).
adjMapping2SUMO('00351226-a',[ ('Process',subsumption)]).
adjMapping2SUMO('00351420-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00351523-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00351679-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00351818-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00351991-s',[ ('Process',subsumption)]).
adjMapping2SUMO('00352127-a',[ ('Process',subsumption)]).
adjMapping2SUMO('00352536-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00352716-s',[ ('Process',subsumption)]).
adjMapping2SUMO('00352877-s',[ ('ContentDevelopment',subsumption)]).
adjMapping2SUMO('00353001-s',[ ('',undefined)]).
adjMapping2SUMO('00353101-s',[ ('ContentDevelopment',subsumption)]).
adjMapping2SUMO('00353206-a',[ ('Process',not(subsumption))]).
adjMapping2SUMO('00353431-s',[ (patient,subsumption)]).
adjMapping2SUMO('00353604-s',[ (located,subsumption)]).
adjMapping2SUMO('00353812-s',[ ('ContentDevelopment',not(subsumption))]).
adjMapping2SUMO('00353889-s',[ ('Decreasing',not(subsumption))]).
adjMapping2SUMO('00353969-s',[ ('ContentDevelopment',not(subsumption))]).
adjMapping2SUMO('00354090-a',[ ('Law',subsumption)]).
adjMapping2SUMO('00354176-s',[ ('ContentDevelopment',subsumption)]).
adjMapping2SUMO('00354330-a',[ ('Law',subsumption)]).
adjMapping2SUMO('00354433-a',[ ('Process',subsumption)]).
adjMapping2SUMO('00354692-s',[ ('Process',subsumption)]).
adjMapping2SUMO('00354833-s',[ ('Transaction',subsumption)]).
adjMapping2SUMO('00354934-s',[ ('Process',subsumption)]).
adjMapping2SUMO('00355083-s',[ (equal,subsumption)]).
adjMapping2SUMO('00355258-a',[ ('Process',subsumption)]).
adjMapping2SUMO('00355453-s',[ ('',undefined)]).
adjMapping2SUMO('00355611-s',[ (equal,subsumption)]).
adjMapping2SUMO('00355782-a',[ ('',undefined)]).
adjMapping2SUMO('00355950-a',[ ('',undefined)]).
adjMapping2SUMO('00356110-a',[ ('ChemicalDecomposition',subsumption)]).
adjMapping2SUMO('00356211-a',[ ('ChemicalDecomposition',not(subsumption))]).
adjMapping2SUMO('00356339-a',[ (capability,subsumption)]).
adjMapping2SUMO('00356648-a',[ (capability,subsumption)]).
adjMapping2SUMO('00356926-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00357254-s',[ ('DiagnosticProcess',subsumption)]).
adjMapping2SUMO('00357556-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00357790-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00357983-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00358132-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('00358392-s',[ ('Radiating',subsumption)]).
adjMapping2SUMO('00358534-s',[ ('Radiating',subsumption)]).
adjMapping2SUMO('00358678-s',[ ('Radiating',subsumption)]).
adjMapping2SUMO('00358820-s',[ ('Radiating',subsumption)]).
adjMapping2SUMO('00358951-a',[ ('Radiating',not(subsumption))]).
adjMapping2SUMO('00359160-s',[ ('Radiating',not(subsumption))]).
adjMapping2SUMO('00359260-s',[ ('Radiating',not(subsumption))]).
adjMapping2SUMO('00359459-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00359645-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00359862-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00360041-a',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('00360235-a',[ ('FinancialTransaction',not(subsumption))]).
adjMapping2SUMO('00360306-a',[ (possesses,subsumption)]).
adjMapping2SUMO('00360442-s',[ (possesses,subsumption)]).
adjMapping2SUMO('00360569-a',[ (possesses,subsumption)]).
adjMapping2SUMO('00360650-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00360950-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00361125-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00361509-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00361720-s',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('00361837-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00362173-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00362269-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00362467-a',[ ('Happiness',subsumption)]).
adjMapping2SUMO('00362892-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00363031-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00363291-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00363621-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00363938-s',[ ('Happiness',subsumption)]).
adjMapping2SUMO('00364145-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00364479-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00364881-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00365261-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00365513-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00365681-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00365799-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00365936-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00366025-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('00366185-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('00366355-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('00366526-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('00366691-a',[ ('ColorAttribute',equivalence)]).
adjMapping2SUMO('00369504-s',[ ('Yellow',subsumption)]).
adjMapping2SUMO('00369648-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00369732-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00369831-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00369941-s',[ ('Brown',subsumption)]).
adjMapping2SUMO('00370160-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00370267-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00370501-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00370601-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00370688-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00370771-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00370869-s',[ ('Blue',subsumption)]).
adjMapping2SUMO('00371163-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00371311-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00371411-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00371511-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00371611-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00371741-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00371841-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00371945-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00372029-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00372111-s',[ ('Brown',subsumption)]).
adjMapping2SUMO('00372266-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00372367-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00372476-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00372571-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00372653-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00372799-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00372960-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00373067-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00373209-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00373381-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00373493-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00373621-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00373731-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00373811-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00373915-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00374001-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00374214-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00374303-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00374390-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00374477-s',[ ('Blue',subsumption)]).
adjMapping2SUMO('00374556-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00374635-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00374735-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00374818-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00374944-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00375090-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00375217-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00375303-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00375387-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00375471-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00375593-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00375720-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00375847-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00375969-s',[ ('Green',equivalence)]).
adjMapping2SUMO('00376255-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00376342-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00376453-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00376537-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00376645-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00376821-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00376917-s',[ ('Purple',subsumption)]).
adjMapping2SUMO('00377036-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00377131-s',[ ('Blue',subsumption)]).
adjMapping2SUMO('00377224-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00377323-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00377438-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00377524-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00377616-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00377702-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00377802-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00377890-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00378002-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00378084-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00378166-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00378280-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00378498-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00378591-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00378687-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00378782-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00378892-s',[ ('OrangeColor',subsumption)]).
adjMapping2SUMO('00379084-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00379181-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00379267-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('00379413-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00379495-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00379595-s',[ ('Pink',subsumption)]).
adjMapping2SUMO('00379697-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00379804-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00379914-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00379992-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00380077-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00380178-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00380312-s',[ ('Purple',subsumption)]).
adjMapping2SUMO('00380483-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00380583-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00380686-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00380789-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00380895-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00380992-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00381097-s',[ ('Red',equivalence)]).
adjMapping2SUMO('00381525-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00381636-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00381766-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00381861-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00381975-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00382074-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00382173-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00382321-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00382411-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00382512-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00382594-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00382693-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00382792-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00382874-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00382990-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00383088-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00383189-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00383291-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00383429-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00383521-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00383607-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00383700-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00383827-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00383957-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00384099-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00384195-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00384292-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00384410-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00384533-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00384615-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00384694-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00384782-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00384936-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00385059-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00385188-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00385338-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00385432-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00385547-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00385651-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00385756-s',[ ('Yellow',equivalence)]).
adjMapping2SUMO('00385990-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00386095-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00386196-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00386303-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00386392-a',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00387392-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00387593-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00387699-s',[ ('Black',subsumption)]).
adjMapping2SUMO('00387808-s',[ ('',undefined)]).
adjMapping2SUMO('00387922-s',[ ('',undefined)]).
adjMapping2SUMO('00388032-s',[ ('',undefined)]).
adjMapping2SUMO('00388152-s',[ ('Blue',subsumption)]).
adjMapping2SUMO('00388249-s',[ ('',undefined)]).
adjMapping2SUMO('00388350-s',[ ('',undefined)]).
adjMapping2SUMO('00388477-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00388571-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00388725-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00388849-s',[ ('Black',subsumption)]).
adjMapping2SUMO('00389035-s',[ ('',undefined)]).
adjMapping2SUMO('00389150-s',[ ('',undefined)]).
adjMapping2SUMO('00389231-s',[ ('Black',subsumption)]).
adjMapping2SUMO('00389310-s',[ ('Gray',subsumption)]).
adjMapping2SUMO('00389607-s',[ ('',undefined)]).
adjMapping2SUMO('00389734-s',[ ('',undefined)]).
adjMapping2SUMO('00389861-s',[ ('',undefined)]).
adjMapping2SUMO('00389962-s',[ ('',undefined)]).
adjMapping2SUMO('00390071-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00390195-s',[ ('Black',subsumption)]).
adjMapping2SUMO('00390332-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00390461-s',[ ('White',subsumption)]).
adjMapping2SUMO('00390539-s',[ ('White',subsumption)]).
adjMapping2SUMO('00390630-s',[ ('',undefined)]).
adjMapping2SUMO('00390725-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00390844-s',[ ('',undefined)]).
adjMapping2SUMO('00390943-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00391077-s',[ ('',undefined)]).
adjMapping2SUMO('00391162-s',[ ('',undefined)]).
adjMapping2SUMO('00391265-s',[ ('',undefined)]).
adjMapping2SUMO('00391368-s',[ ('',undefined)]).
adjMapping2SUMO('00391487-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00391572-s',[ ('',undefined)]).
adjMapping2SUMO('00391699-s',[ ('',undefined)]).
adjMapping2SUMO('00391806-s',[ ('',undefined)]).
adjMapping2SUMO('00391897-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00392093-s',[ ('White',subsumption)]).
adjMapping2SUMO('00392184-s',[ ('',undefined)]).
adjMapping2SUMO('00392281-s',[ ('',undefined)]).
adjMapping2SUMO('00392367-s',[ ('',undefined)]).
adjMapping2SUMO('00392460-s',[ ('White',subsumption)]).
adjMapping2SUMO('00392574-s',[ ('',undefined)]).
adjMapping2SUMO('00392706-s',[ ('',undefined)]).
adjMapping2SUMO('00392812-a',[ ('Black',equivalence)]).
adjMapping2SUMO('00393105-a',[ ('White',equivalence)]).
adjMapping2SUMO('00393422-s',[ ('',undefined)]).
adjMapping2SUMO('00393508-a',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00393683-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00393852-a',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00393992-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00394135-a',[ ('Device',subsumption)]).
adjMapping2SUMO('00394331-a',[ ('Device',subsumption)]).
adjMapping2SUMO('00394562-a',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00395626-s',[ ('Red',equivalence)]).
adjMapping2SUMO('00395977-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00396115-s',[ ('Polychromatic',subsumption)]).
adjMapping2SUMO('00396296-s',[ ('Black',subsumption)]).
adjMapping2SUMO('00396444-s',[ ('',undefined)]).
adjMapping2SUMO('00396523-s',[ ('',undefined)]).
adjMapping2SUMO('00396627-s',[ ('',undefined)]).
adjMapping2SUMO('00396721-s',[ ('',undefined)]).
adjMapping2SUMO('00396839-s',[ ('',undefined)]).
adjMapping2SUMO('00396958-s',[ ('',undefined)]).
adjMapping2SUMO('00397108-s',[ ('',undefined)]).
adjMapping2SUMO('00397191-s',[ ('',undefined)]).
adjMapping2SUMO('00397314-s',[ ('',undefined)]).
adjMapping2SUMO('00397441-s',[ ('',undefined)]).
adjMapping2SUMO('00397532-s',[ ('',undefined)]).
adjMapping2SUMO('00397633-s',[ ('',undefined)]).
adjMapping2SUMO('00397757-s',[ ('',undefined)]).
adjMapping2SUMO('00397870-s',[ ('',undefined)]).
adjMapping2SUMO('00397975-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00398172-s',[ ('',undefined)]).
adjMapping2SUMO('00398271-s',[ ('',undefined)]).
adjMapping2SUMO('00398373-s',[ ('',undefined)]).
adjMapping2SUMO('00398482-s',[ ('',undefined)]).
adjMapping2SUMO('00398581-s',[ ('',undefined)]).
adjMapping2SUMO('00398677-s',[ ('',undefined)]).
adjMapping2SUMO('00398816-s',[ ('Monochromatic',equivalence)]).
adjMapping2SUMO('00398978-s',[ ('Polychromatic',subsumption)]).
adjMapping2SUMO('00399479-s',[ ('',undefined)]).
adjMapping2SUMO('00399606-s',[ ('',undefined)]).
adjMapping2SUMO('00399715-s',[ ('',undefined)]).
adjMapping2SUMO('00399840-s',[ ('',undefined)]).
adjMapping2SUMO('00399923-s',[ ('',undefined)]).
adjMapping2SUMO('00400013-s',[ ('',undefined)]).
adjMapping2SUMO('00400101-s',[ ('',undefined)]).
adjMapping2SUMO('00400193-s',[ ('Polychromatic',equivalence)]).
adjMapping2SUMO('00400312-s',[ ('',undefined)]).
adjMapping2SUMO('00400395-s',[ ('',undefined)]).
adjMapping2SUMO('00400472-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00400644-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00400737-s',[ ('',undefined)]).
adjMapping2SUMO('00400826-s',[ ('',undefined)]).
adjMapping2SUMO('00400922-s',[ ('',undefined)]).
adjMapping2SUMO('00401028-s',[ ('',undefined)]).
adjMapping2SUMO('00401125-s',[ ('Polychromatic',subsumption)]).
adjMapping2SUMO('00401444-s',[ ('',undefined)]).
adjMapping2SUMO('00401562-s',[ ('',undefined)]).
adjMapping2SUMO('00401650-a',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00401831-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00401922-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00402004-a',[ ('Coloring',subsumption)]).
adjMapping2SUMO('00402159-a',[ ('SurfaceChange',not(subsumption))]).
adjMapping2SUMO('00402285-s',[ ('SurfaceChange',not(subsumption))]).
adjMapping2SUMO('00402419-a',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00402731-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00402855-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00403072-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00403385-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00403505-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00403654-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00403819-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00403982-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00404110-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00404202-a',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00404568-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00404961-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00405179-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00405406-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00405554-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('00405750-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00405879-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00406140-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00406348-s',[ ('',undefined)]).
adjMapping2SUMO('00406495-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00406743-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00406867-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00407151-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00407420-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00407654-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00407766-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00407887-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00408031-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00408284-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00408445-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00408660-a',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00408992-s',[ ('White',equivalence)]).
adjMapping2SUMO('00409141-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00409207-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00409319-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00409440-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00409668-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('00409750-a',[ ('Music',subsumption)]).
adjMapping2SUMO('00409889-a',[ ('Music',subsumption)]).
adjMapping2SUMO('00410078-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('00410268-s',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('00410449-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('00410668-s',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('00411009-a',[ (believes,subsumption)]).
adjMapping2SUMO('00411215-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00411353-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00411481-a',[ (believes,subsumption)]).
adjMapping2SUMO('00411599-s',[ (believes,subsumption)]).
adjMapping2SUMO('00411694-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00411886-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00412171-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00412355-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00412460-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00412567-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00412788-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00413224-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00413312-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('00413432-s',[ ('Word',subsumption)]).
adjMapping2SUMO('00413622-a',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('00413861-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('00414080-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('00414227-a',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('00414354-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('00414518-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00414709-a',[ ('Classifying',subsumption)]).
adjMapping2SUMO('00414823-s',[ ('Classifying',subsumption)]).
adjMapping2SUMO('00414919-s',[ ('Classifying',subsumption)]).
adjMapping2SUMO('00415002-a',[ ('Classifying',not(subsumption))]).
adjMapping2SUMO('00415116-s',[ ('Classifying',not(subsumption))]).
adjMapping2SUMO('00415228-a',[ ('Classifying',subsumption)]).
adjMapping2SUMO('00415543-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00415696-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00415931-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00416045-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00416164-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00416301-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00416415-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00416550-s',[ ('Classifying',subsumption)]).
adjMapping2SUMO('00416651-s',[ ('Classifying',not(subsumption))]).
adjMapping2SUMO('00416765-a',[ ('IntentionalPsychologicalProcess',subsumption)]).
adjMapping2SUMO('00417032-a',[ ('IntentionalPsychologicalProcess',not(subsumption))]).
adjMapping2SUMO('00417204-s',[ ('IntentionalPsychologicalProcess',not(subsumption))]).
adjMapping2SUMO('00417413-a',[ ('Clean',equivalence)]).
adjMapping2SUMO('00417898-s',[ (capability,subsumption)]).
adjMapping2SUMO('00417978-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00418110-s',[ ('Clean',subsumption)]).
adjMapping2SUMO('00418198-s',[ (uses,subsumption)]).
adjMapping2SUMO('00418364-s',[ ('Clean',subsumption)]).
adjMapping2SUMO('00418679-s',[ ('Clean',subsumption)]).
adjMapping2SUMO('00418809-s',[ ('Clean',subsumption)]).
adjMapping2SUMO('00418950-s',[ ('Clean',subsumption)]).
adjMapping2SUMO('00419058-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00419175-s',[ ('Clean',subsumption)]).
adjMapping2SUMO('00419289-a',[ ('Dirty',equivalence)]).
adjMapping2SUMO('00420182-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00420287-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00420480-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00420650-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00421002-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00421202-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00421308-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('00421383-s',[ ('Dirty',equivalence)]).
adjMapping2SUMO('00421513-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00421590-s',[ ('Dirty',subsumption)]).
adjMapping2SUMO('00421875-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00422168-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00422374-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00422546-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00422620-s',[ ('Dirty',subsumption)]).
adjMapping2SUMO('00422772-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('00422870-s',[ ('Dirty',subsumption)]).
adjMapping2SUMO('00423001-s',[ ('Dirty',subsumption)]).
adjMapping2SUMO('00423269-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00423431-s',[ ('Black',subsumption)]).
adjMapping2SUMO('00423569-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00423689-s',[ ('',undefined)]).
adjMapping2SUMO('00423781-s',[ ('Removing',not(subsumption))]).
adjMapping2SUMO('00423874-s',[ ('Removing',not(subsumption))]).
adjMapping2SUMO('00424008-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00424240-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00424370-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00424787-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00425002-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00425234-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00425313-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00425588-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00425740-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00426068-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00426186-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00426347-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00426608-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00426907-a',[ ('RadiatingNuclear',subsumption)]).
adjMapping2SUMO('00427105-s',[ ('Radiating',subsumption)]).
adjMapping2SUMO('00427255-a',[ ('Radiating',not(subsumption))]).
adjMapping2SUMO('00427331-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00427496-s',[ ('',undefined)]).
adjMapping2SUMO('00427644-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00427786-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00428121-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00428243-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00428404-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00428878-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00429016-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00429355-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00429793-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00429909-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00430041-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00430191-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00430545-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00430756-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00431004-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00431447-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00431774-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00432251-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00432453-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00432626-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00432861-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00432998-s',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('00433115-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00433529-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00433811-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00433972-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('00434097-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('00434265-s',[ ('',undefined)]).
adjMapping2SUMO('00434384-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00434524-s',[ ('',undefined)]).
adjMapping2SUMO('00434597-s',[ (capability,subsumption)]).
adjMapping2SUMO('00434692-a',[ (capability,subsumption)]).
adjMapping2SUMO('00434838-a',[ (capability,subsumption)]).
adjMapping2SUMO('00435013-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00435190-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00435374-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00435492-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00435872-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00436115-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00436385-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00436544-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00436645-s',[ ('ConsciousnessAttribute',subsumption)]).
adjMapping2SUMO('00436920-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00437149-s',[ ('ConsciousnessAttribute',subsumption)]).
adjMapping2SUMO('00437223-s',[ ('ConsciousnessAttribute',subsumption)]).
adjMapping2SUMO('00437419-s',[ ('',undefined)]).
adjMapping2SUMO('00437539-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00437744-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00437852-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00438063-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00438166-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00438332-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00438567-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00438707-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00438909-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00439252-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00439431-s',[ ('',undefined)]).
adjMapping2SUMO('00439588-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00439905-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00440292-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00440489-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00440579-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00441154-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00441272-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00441365-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00441523-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00441630-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00441781-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00441927-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00442057-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00442255-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00442361-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00442827-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00442917-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00443075-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00443274-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00443490-s',[ (greaterThan,subsumption)]).
adjMapping2SUMO('00443618-s',[ (greaterThan,subsumption)]).
adjMapping2SUMO('00443988-s',[ (greaterThan,subsumption)]).
adjMapping2SUMO('00444220-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00444399-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00444519-a',[ ('Near',equivalence)]).
adjMapping2SUMO('00444984-s',[ ('Adjacent',equivalence)]).
adjMapping2SUMO('00445169-s',[ ('Near',subsumption)]).
adjMapping2SUMO('00445308-s',[ ('Near',subsumption)]).
adjMapping2SUMO('00445440-s',[ ('Near',subsumption)]).
adjMapping2SUMO('00445548-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00445937-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00446107-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00446236-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00446333-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00446525-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00446605-s',[ (located,subsumption)]).
adjMapping2SUMO('00446758-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00446921-a',[ ('Near',subsumption)]).
adjMapping2SUMO('00447472-s',[ (meetsSpatially,subsumption)]).
adjMapping2SUMO('00447753-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00447909-s',[ (meetsSpatially,subsumption)]).
adjMapping2SUMO('00448130-s',[ ('Adjacent',subsumption)]).
adjMapping2SUMO('00448314-s',[ ('ImmediateFutureFn',equivalence)]).
adjMapping2SUMO('00448644-s',[ ('Near',subsumption)]).
adjMapping2SUMO('00448777-s',[ ('Cutting',subsumption)]).
adjMapping2SUMO('00448924-s',[ ('Near',subsumption)]).
adjMapping2SUMO('00449079-s',[ ('Adjacent',subsumption)]).
adjMapping2SUMO('00449332-s',[ ('Near',equivalence)]).
adjMapping2SUMO('00449525-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00449662-s',[ ('Near',subsumption)]).
adjMapping2SUMO('00449769-s',[ ('Adjacent',subsumption)]).
adjMapping2SUMO('00449889-s',[ ('Adjacent',subsumption)]).
adjMapping2SUMO('00450147-s',[ ('Adjacent',subsumption)]).
adjMapping2SUMO('00450269-s',[ ('',undefined)]).
adjMapping2SUMO('00450402-s',[ ('Near',subsumption)]).
adjMapping2SUMO('00450606-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00450915-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00451032-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00451155-s',[ (familyRelation,subsumption)]).
adjMapping2SUMO('00451291-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00451510-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00451872-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00452020-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('00452114-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('00452407-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('00452605-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('00452773-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('00452883-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('00453053-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('00453308-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00453529-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00453647-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00453726-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00454440-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00454849-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00454984-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00455084-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00455190-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00455310-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00455405-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00455485-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00455605-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00455717-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00455824-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00456026-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00456121-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00456229-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00456355-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00456436-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00456576-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00456739-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00456855-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00456929-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00457036-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00457160-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00457258-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00457355-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00457482-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00457598-a',[ ('Clothing',not(subsumption))]).
adjMapping2SUMO('00457998-s',[ ('Clothing',not(subsumption))]).
adjMapping2SUMO('00458266-s',[ ('Clothing',not(subsumption))]).
adjMapping2SUMO('00458488-s',[ ('Clothing',not(subsumption))]).
adjMapping2SUMO('00458664-s',[ ('Clothing',not(subsumption))]).
adjMapping2SUMO('00458810-s',[ ('Clothing',not(subsumption))]).
adjMapping2SUMO('00458940-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00459102-s',[ ('Clothing',not(subsumption))]).
adjMapping2SUMO('00459210-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00459330-s',[ ('Clothing',not(subsumption))]).
adjMapping2SUMO('00459443-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00459553-s',[ ('Clothing',not(subsumption))]).
adjMapping2SUMO('00459746-s',[ ('',undefined)]).
adjMapping2SUMO('00459881-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00459953-s',[ ('Clothing',not(subsumption))]).
adjMapping2SUMO('00460076-s',[ ('Clothing',not(subsumption))]).
adjMapping2SUMO('00460157-s',[ ('Clothing',not(subsumption))]).
adjMapping2SUMO('00460296-s',[ ('Clothing',not(subsumption))]).
adjMapping2SUMO('00460386-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('00460536-a',[ ('Putting',not(subsumption))]).
adjMapping2SUMO('00460624-s',[ ('Putting',not(subsumption))]).
adjMapping2SUMO('00460735-a',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00460946-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00461091-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00461195-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00461311-a',[ ('RadiatingLight',not(subsumption))]).
adjMapping2SUMO('00461609-s',[ ('RadiatingLight',not(subsumption))]).
adjMapping2SUMO('00461859-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00461971-s',[ ('RadiatingLight',not(subsumption))]).
adjMapping2SUMO('00462129-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00462249-s',[ ('RadiatingLight',not(subsumption))]).
adjMapping2SUMO('00462409-s',[ ('RadiatingLight',not(subsumption))]).
adjMapping2SUMO('00462546-s',[ ('Gas',subsumption)]).
adjMapping2SUMO('00462741-s',[ ('Gas',subsumption)]).
adjMapping2SUMO('00462909-a',[ (located,subsumption)]).
adjMapping2SUMO('00463162-s',[ (located,subsumption)]).
adjMapping2SUMO('00463308-s',[ (located,subsumption)]).
adjMapping2SUMO('00463399-s',[ (located,subsumption)]).
adjMapping2SUMO('00463580-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00463784-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00463917-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00464068-s',[ (located,subsumption)]).
adjMapping2SUMO('00464195-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00464399-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00464513-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00464845-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00464962-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00465221-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00465585-s',[ ('',undefined)]).
adjMapping2SUMO('00465737-a',[ (capability,subsumption)]).
adjMapping2SUMO('00465943-s',[ (capability,subsumption)]).
adjMapping2SUMO('00466077-s',[ (capability,subsumption)]).
adjMapping2SUMO('00466229-s',[ (capability,subsumption)]).
adjMapping2SUMO('00466365-a',[ (capability,subsumption)]).
adjMapping2SUMO('00466486-s',[ (capability,subsumption)]).
adjMapping2SUMO('00466577-a',[ ('Hole',subsumption)]).
adjMapping2SUMO('00466725-a',[ ('Hole',not(subsumption))]).
adjMapping2SUMO('00466808-a',[ ('Collection',equivalence)]).
adjMapping2SUMO('00467019-s',[ ('Collection',subsumption)]).
adjMapping2SUMO('00467240-s',[ ('Collection',subsumption)]).
adjMapping2SUMO('00467564-s',[ (possesses,subsumption)]).
adjMapping2SUMO('00467737-s',[ ('',undefined)]).
adjMapping2SUMO('00467913-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('00468176-s',[ (capability,subsumption)]).
adjMapping2SUMO('00468362-s',[ ('Disseminating',subsumption)]).
adjMapping2SUMO('00468574-s',[ ('',undefined)]).
adjMapping2SUMO('00468795-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00469170-s',[ ('Word',subsumption)]).
adjMapping2SUMO('00469468-s',[ ('Radiating',subsumption)]).
adjMapping2SUMO('00469603-a',[ ('Disseminating',subsumption)]).
adjMapping2SUMO('00469767-s',[ ('Disseminating',subsumption)]).
adjMapping2SUMO('00469879-s',[ ('Disseminating',subsumption)]).
adjMapping2SUMO('00469999-s',[ ('Disseminating',subsumption)]).
adjMapping2SUMO('00470111-a',[ ('Disseminating',not(subsumption))]).
adjMapping2SUMO('00470284-s',[ ('Disseminating',not(subsumption))]).
adjMapping2SUMO('00470372-s',[ ('Disseminating',not(subsumption))]).
adjMapping2SUMO('00470528-s',[ ('Disseminating',not(subsumption))]).
adjMapping2SUMO('00470719-s',[ ('Disseminating',not(subsumption))]).
adjMapping2SUMO('00470930-a',[ ('Publication',equivalence)]).
adjMapping2SUMO('00471072-a',[ ('Publication',equivalence)]).
adjMapping2SUMO('00471178-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00471260-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00471348-a',[ ('Disseminating',subsumption)]).
adjMapping2SUMO('00471572-s',[ (agent,subsumption)]).
adjMapping2SUMO('00471698-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00471842-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00471966-a',[ ('Disseminating',not(subsumption))]).
adjMapping2SUMO('00472057-a',[ ('Law',subsumption)]).
adjMapping2SUMO('00472177-a',[ ('Law',subsumption)]).
adjMapping2SUMO('00472336-a',[ ('Combining',equivalence)]).
adjMapping2SUMO('00472534-s',[ ('Function',subsumption)]).
adjMapping2SUMO('00472694-s',[ ('Combining',not(equivalence))]).
adjMapping2SUMO('00472810-a',[ ('Combining',not(equivalence))]).
adjMapping2SUMO('00472914-s',[ ('Combining',not(equivalence))]).
adjMapping2SUMO('00472992-a',[ (capability,subsumption)]).
adjMapping2SUMO('00473243-s',[ (capability,subsumption)]).
adjMapping2SUMO('00473502-s',[ (capability,subsumption)]).
adjMapping2SUMO('00473658-s',[ (capability,subsumption)]).
adjMapping2SUMO('00473778-s',[ (capability,subsumption)]).
adjMapping2SUMO('00473869-s',[ (capability,subsumption)]).
adjMapping2SUMO('00474043-a',[ (capability,subsumption)]).
adjMapping2SUMO('00474227-s',[ (capability,subsumption)]).
adjMapping2SUMO('00474311-s',[ (capability,subsumption)]).
adjMapping2SUMO('00474440-s',[ (capability,subsumption)]).
adjMapping2SUMO('00474541-s',[ (capability,subsumption)]).
adjMapping2SUMO('00474620-a',[ (capability,subsumption)]).
adjMapping2SUMO('00474883-s',[ ('Impelling',subsumption)]).
adjMapping2SUMO('00475008-a',[ (capability,subsumption)]).
adjMapping2SUMO('00475125-a',[ ('Combustion',subsumption)]).
adjMapping2SUMO('00475308-s',[ ('Combustion',subsumption)]).
adjMapping2SUMO('00475625-s',[ ('Combustion',subsumption)]).
adjMapping2SUMO('00475749-a',[ ('Combustion',not(subsumption))]).
adjMapping2SUMO('00475927-s',[ ('Combustion',not(subsumption))]).
adjMapping2SUMO('00475996-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00476249-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00476494-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00476663-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00476819-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00477284-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00477553-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00477661-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00477896-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00478015-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00478311-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00478590-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00478685-s',[ ('PathologicProcess',subsumption)]).
adjMapping2SUMO('00478872-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00479073-s',[ ('Anxiety',equivalence)]).
adjMapping2SUMO('00479192-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00479330-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00479783-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00479933-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00480439-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00480753-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00480880-s',[ ('',undefined)]).
adjMapping2SUMO('00480965-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00481222-a',[ (equal,subsumption)]).
adjMapping2SUMO('00481463-s',[ (cooccur,equivalence)]).
adjMapping2SUMO('00481592-s',[ (capability,subsumption)]).
adjMapping2SUMO('00481737-s',[ (equal,subsumption)]).
adjMapping2SUMO('00481855-a',[ (equal,subsumption)]).
adjMapping2SUMO('00482059-s',[ (equal,subsumption)]).
adjMapping2SUMO('00482139-s',[ (capability,subsumption)]).
adjMapping2SUMO('00482227-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00482452-s',[ ('PerCapitaFn',equivalence)]).
adjMapping2SUMO('00482580-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00482673-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00482948-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00483048-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00483146-a',[ ('Corporation',subsumption)]).
adjMapping2SUMO('00483481-s',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('00483650-s',[ ('Transaction',subsumption)]).
adjMapping2SUMO('00483816-s',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('00484070-s',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('00484333-a',[ ('Corporation',not(subsumption))]).
adjMapping2SUMO('00484538-s',[ ('',undefined)]).
adjMapping2SUMO('00484680-s',[ ('Corporation',not(subsumption))]).
adjMapping2SUMO('00484782-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00484932-s',[ ('FinancialTransaction',not(subsumption))]).
adjMapping2SUMO('00485044-a',[ ('Residence',equivalence)]).
adjMapping2SUMO('00485252-a',[ ('Building',subsumption)]).
adjMapping2SUMO('00485431-a',[ ('Position',subsumption)]).
adjMapping2SUMO('00485593-a',[ ('Position',subsumption)]).
adjMapping2SUMO('00485711-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00486290-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00486539-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00486819-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00486990-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00487198-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00487327-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00487525-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00487653-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00488187-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00488561-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00488697-s',[ ('',undefined)]).
adjMapping2SUMO('00488857-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00488998-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00489108-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00489491-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00489768-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00489863-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00490035-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00490413-s',[ (equal,not(subsumption))]).
adjMapping2SUMO('00490650-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00490845-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00490979-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00491089-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00491320-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00491511-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00491749-a',[ (capability,subsumption)]).
adjMapping2SUMO('00491971-a',[ (capability,subsumption)]).
adjMapping2SUMO('00492157-s',[ (capability,subsumption)]).
adjMapping2SUMO('00492332-a',[ (capability,subsumption)]).
adjMapping2SUMO('00492477-s',[ (capability,subsumption)]).
adjMapping2SUMO('00492595-a',[ (capability,subsumption)]).
adjMapping2SUMO('00492677-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00493012-s',[ ('CommunalAttribute',subsumption)]).
adjMapping2SUMO('00493297-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00493460-a',[ (instance,equivalence)]).
adjMapping2SUMO('00493820-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00494027-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00494198-s',[ ('Maneuver',subsumption)]).
adjMapping2SUMO('00494409-s',[ (instance,equivalence)]).
adjMapping2SUMO('00494622-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00494907-a',[ (capability,subsumption)]).
adjMapping2SUMO('00495916-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00496170-s',[ ('',undefined)]).
adjMapping2SUMO('00496259-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00496422-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00496569-s',[ (capability,subsumption)]).
adjMapping2SUMO('00496670-s',[ ('Communication',subsumption)]).
adjMapping2SUMO('00496845-s',[ (capability,subsumption)]).
adjMapping2SUMO('00496938-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00497148-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00497330-s',[ ('',undefined)]).
adjMapping2SUMO('00497442-s',[ ('',undefined)]).
adjMapping2SUMO('00497535-s',[ (capability,subsumption)]).
adjMapping2SUMO('00497626-s',[ ('',undefined)]).
adjMapping2SUMO('00497717-s',[ (capability,subsumption)]).
adjMapping2SUMO('00497808-s',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('00497964-s',[ ('Gesture',subsumption)]).
adjMapping2SUMO('00498161-s',[ ('Communication',subsumption)]).
adjMapping2SUMO('00498286-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00498439-s',[ (capability,subsumption)]).
adjMapping2SUMO('00498536-s',[ (capability,subsumption)]).
adjMapping2SUMO('00498629-s',[ ('',undefined)]).
adjMapping2SUMO('00498724-s',[ ('',undefined)]).
adjMapping2SUMO('00498817-s',[ ('',undefined)]).
adjMapping2SUMO('00498912-s',[ ('Proposition',subsumption)]).
adjMapping2SUMO('00499062-s',[ ('Language',not(subsumption))]).
adjMapping2SUMO('00499183-s',[ (capability,subsumption)]).
adjMapping2SUMO('00499315-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00499441-s',[ ('',undefined)]).
adjMapping2SUMO('00499530-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00499730-s',[ (capability,subsumption)]).
adjMapping2SUMO('00499823-s',[ ('',undefined)]).
adjMapping2SUMO('00499920-s',[ ('',undefined)]).
adjMapping2SUMO('00500024-s',[ ('',undefined)]).
adjMapping2SUMO('00500126-s',[ (capability,subsumption)]).
adjMapping2SUMO('00500219-s',[ ('',undefined)]).
adjMapping2SUMO('00500310-s',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('00500434-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00500569-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00500889-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00501004-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00501313-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00501552-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00501723-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00501820-s',[ ('Communication',not(subsumption))]).
adjMapping2SUMO('00501998-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00502180-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00502487-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00502646-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00502730-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00502809-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00502922-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00503020-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00503157-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00503321-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00503527-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00503664-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00503780-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00503876-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00503982-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00504172-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00504431-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00504592-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00505086-s',[ ('PastFn',subsumption)]).
adjMapping2SUMO('00505285-s',[ (equal,subsumption)]).
adjMapping2SUMO('00505410-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00505853-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00506299-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00506601-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00506743-s',[ ('',undefined)]).
adjMapping2SUMO('00506852-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00507053-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00507292-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00507464-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00507789-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('00507912-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00508036-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00508192-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00508480-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00508592-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00508750-s',[ ('Proposition',subsumption)]).
adjMapping2SUMO('00508924-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('00509039-a',[ (capability,subsumption)]).
adjMapping2SUMO('00509206-a',[ (capability,subsumption)]).
adjMapping2SUMO('00509377-a',[ (capability,subsumption)]).
adjMapping2SUMO('00509576-s',[ (capability,subsumption)]).
adjMapping2SUMO('00509735-a',[ (capability,subsumption)]).
adjMapping2SUMO('00509896-s',[ (capability,subsumption)]).
adjMapping2SUMO('00510050-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00510348-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00510644-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00511037-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00511214-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00511526-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00511739-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00511966-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00512130-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00512261-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00512487-a',[ ('Contest',subsumption)]).
adjMapping2SUMO('00512769-s',[ ('Contest',subsumption)]).
adjMapping2SUMO('00512941-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00513048-s',[ (equal,subsumption)]).
adjMapping2SUMO('00513165-a',[ ('Contest',not(subsumption))]).
adjMapping2SUMO('00513388-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00513559-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00513716-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00513799-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00513981-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00514175-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00514278-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00514396-a',[ (capability,subsumption)]).
adjMapping2SUMO('00514613-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00514717-a',[ (capability,subsumption)]).
adjMapping2SUMO('00514884-a',[ (forall,subsumption)]).
adjMapping2SUMO('00515380-s',[ (forall,subsumption)]).
adjMapping2SUMO('00515622-s',[ ('Icon',subsumption)]).
adjMapping2SUMO('00515753-s',[ ('Text',subsumption)]).
adjMapping2SUMO('00515870-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00516231-s',[ (duration,subsumption)]).
adjMapping2SUMO('00516360-s',[ ('Separating',not(subsumption))]).
adjMapping2SUMO('00516539-a',[ (part,subsumption)]).
adjMapping2SUMO('00516887-s',[ (part,subsumption)]).
adjMapping2SUMO('00517010-s',[ (part,subsumption)]).
adjMapping2SUMO('00517314-s',[ (part,subsumption)]).
adjMapping2SUMO('00517554-s',[ (half,equivalence)]).
adjMapping2SUMO('00517710-s',[ (part,subsumption)]).
adjMapping2SUMO('00517816-s',[ ('',undefined)]).
adjMapping2SUMO('00517916-a',[ (sibling,equivalence)]).
adjMapping2SUMO('00518035-a',[ (familyRelation,subsumption)]).
adjMapping2SUMO('00518164-a',[ ('Promise',equivalence)]).
adjMapping2SUMO('00518405-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00518549-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00518716-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00518848-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00518981-s',[ ('Selecting',not(subsumption))]).
adjMapping2SUMO('00519103-s',[ ('Selecting',not(subsumption))]).
adjMapping2SUMO('00519211-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00519477-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00519668-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00519823-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00520081-a',[ ('Declaring',subsumption)]).
adjMapping2SUMO('00520214-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00520892-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00521329-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00521584-s',[ (forall,subsumption)]).
adjMapping2SUMO('00521692-s',[ ('',undefined)]).
adjMapping2SUMO('00521811-s',[ (forall,subsumption)]).
adjMapping2SUMO('00521976-s',[ (forall,subsumption)]).
adjMapping2SUMO('00522101-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00522240-s',[ ('Maneuver',subsumption)]).
adjMapping2SUMO('00522349-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00522463-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00522680-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00522885-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00523068-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00523229-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00523364-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00523479-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00523587-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00523786-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00523867-s',[ ('Device',subsumption)]).
adjMapping2SUMO('00523978-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00524388-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00524496-s',[ (part,subsumption)]).
adjMapping2SUMO('00524607-s',[ ('',undefined)]).
adjMapping2SUMO('00524693-s',[ (part,subsumption)]).
adjMapping2SUMO('00524965-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00525105-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00525315-s',[ ('Maneuver',subsumption)]).
adjMapping2SUMO('00525453-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00526062-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00526541-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00526696-s',[ (located,subsumption)]).
adjMapping2SUMO('00526832-s',[ (located,subsumption)]).
adjMapping2SUMO('00526984-s',[ (located,subsumption)]).
adjMapping2SUMO('00527188-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00527551-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00527744-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00527870-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00528041-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00528167-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00528333-s',[ ('Physical',equivalence)]).
adjMapping2SUMO('00528495-s',[ ('',undefined)]).
adjMapping2SUMO('00528629-s',[ (located,subsumption)]).
adjMapping2SUMO('00528761-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00528875-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00529075-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00529191-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00529266-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00529657-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00530047-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00530354-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00530772-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00531087-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00531342-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00531628-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00531887-s',[ ('SurfaceChange',subsumption)]).
adjMapping2SUMO('00532147-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00532288-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00532560-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00532753-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00532892-a',[ (capability,subsumption)]).
adjMapping2SUMO('00533221-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00533452-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00533738-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00533851-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00534250-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00534524-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00534827-s',[ ('',undefined)]).
adjMapping2SUMO('00534918-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00535042-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00535170-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00535293-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00535452-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00535844-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00536008-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00536103-s',[ ('',undefined)]).
adjMapping2SUMO('00536195-s',[ ('',undefined)]).
adjMapping2SUMO('00536304-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00536416-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00536572-s',[ ('',undefined)]).
adjMapping2SUMO('00536655-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00536792-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00536898-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00536998-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00537073-s',[ ('',undefined)]).
adjMapping2SUMO('00537169-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00537248-s',[ ('',undefined)]).
adjMapping2SUMO('00537339-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00537644-s',[ ('',undefined)]).
adjMapping2SUMO('00537745-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00537884-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00538017-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00538174-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00538276-s',[ ('',undefined)]).
adjMapping2SUMO('00538371-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00538469-s',[ ('',undefined)]).
adjMapping2SUMO('00538565-a',[ ('DensityFn',subsumption)]).
adjMapping2SUMO('00538891-s',[ ('DensityFn',subsumption)]).
adjMapping2SUMO('00539009-s',[ ('DensityFn',subsumption)]).
adjMapping2SUMO('00539207-s',[ ('Collection',subsumption)]).
adjMapping2SUMO('00539389-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00539687-s',[ ('DensityFn',subsumption)]).
adjMapping2SUMO('00539793-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('00540236-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00540366-s',[ ('SelfConnectedObject',not(subsumption))]).
adjMapping2SUMO('00540487-s',[ ('DensityFn',subsumption)]).
adjMapping2SUMO('00540632-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00540826-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00540977-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00541189-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00541349-s',[ ('Disseminating',subsumption)]).
adjMapping2SUMO('00541460-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00541614-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00541823-s',[ ('DensityFn',subsumption)]).
adjMapping2SUMO('00541935-s',[ ('Giving',subsumption)]).
adjMapping2SUMO('00542099-s',[ ('DensityFn',subsumption)]).
adjMapping2SUMO('00542282-s',[ ('Separating',subsumption)]).
adjMapping2SUMO('00542359-s',[ ('DensityFn',subsumption)]).
adjMapping2SUMO('00542501-s',[ ('Liquid',subsumption)]).
adjMapping2SUMO('00542660-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00542775-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00542953-a',[ (equal,subsumption)]).
adjMapping2SUMO('00543117-s',[ (equal,subsumption)]).
adjMapping2SUMO('00543200-a',[ (equal,subsumption)]).
adjMapping2SUMO('00543407-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00543494-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00543603-a',[ (inScopeOfInterest,equivalence)]).
adjMapping2SUMO('00543993-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00544231-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00544478-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00544860-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00545015-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00545484-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00545600-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00545746-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00546155-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00546452-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00546646-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00546951-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00547166-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00547317-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00547641-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00547930-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00548029-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00548316-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00548579-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00548781-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00549133-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00549236-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00549675-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('00549826-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('00550282-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00550574-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00550777-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00551120-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00551267-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00551416-s',[ ('',undefined)]).
adjMapping2SUMO('00551695-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00551806-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00551950-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('00552089-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00552168-a',[ ('SocialInteraction',not(subsumption))]).
adjMapping2SUMO('00552315-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('00552618-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('00552841-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00553140-s',[ (realization,subsumption)]).
adjMapping2SUMO('00553279-s',[ (believes,subsumption)]).
adjMapping2SUMO('00553478-s',[ (believes,subsumption)]).
adjMapping2SUMO('00553594-s',[ ('Promise',subsumption)]).
adjMapping2SUMO('00553732-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('00553899-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00554098-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00554302-s',[ (believes,subsumption)]).
adjMapping2SUMO('00554478-a',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00554624-s',[ (capability,subsumption)]).
adjMapping2SUMO('00554780-a',[ ('Increasing',subsumption)]).
adjMapping2SUMO('00554879-a',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00555117-a',[ ('Increasing',subsumption)]).
adjMapping2SUMO('00555325-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00555709-s',[ ('False',subsumption)]).
adjMapping2SUMO('00555859-s',[ ('',undefined)]).
adjMapping2SUMO('00556174-s',[ ('',undefined)]).
adjMapping2SUMO('00556318-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00556611-s',[ ('',undefined)]).
adjMapping2SUMO('00556709-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00556881-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00557108-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00557221-a',[ (capability,subsumption)]).
adjMapping2SUMO('00557304-a',[ (capability,subsumption)]).
adjMapping2SUMO('00557478-a',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('00557637-a',[ ('RegulatoryProcess',not(subsumption))]).
adjMapping2SUMO('00557813-a',[ (capability,subsumption)]).
adjMapping2SUMO('00558019-s',[ (capability,subsumption)]).
adjMapping2SUMO('00558232-a',[ (capability,subsumption)]).
adjMapping2SUMO('00558373-a',[ ('Keeping',subsumption)]).
adjMapping2SUMO('00558612-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00558738-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00558827-s',[ ('Keeping',subsumption)]).
adjMapping2SUMO('00558951-s',[ ('Keeping',subsumption)]).
adjMapping2SUMO('00559031-s',[ ('Keeping',subsumption)]).
adjMapping2SUMO('00559120-s',[ ('Keeping',subsumption)]).
adjMapping2SUMO('00559271-s',[ ('Keeping',subsumption)]).
adjMapping2SUMO('00559425-a',[ ('Keeping',not(subsumption))]).
adjMapping2SUMO('00559530-s',[ ('Keeping',not(subsumption))]).
adjMapping2SUMO('00559690-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00559930-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00560100-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00560284-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00560453-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00560586-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00560900-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00561036-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00561359-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00561600-a',[ (equal,subsumption)]).
adjMapping2SUMO('00561757-s',[ (equal,subsumption)]).
adjMapping2SUMO('00561896-s',[ (equal,subsumption)]).
adjMapping2SUMO('00562026-a',[ (equal,subsumption)]).
adjMapping2SUMO('00562116-a',[ (equal,subsumption)]).
adjMapping2SUMO('00562308-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00562469-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00562803-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00562909-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00563116-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00563288-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00563648-a',[ (capability,subsumption)]).
adjMapping2SUMO('00563789-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('00563980-s',[ (capability,subsumption)]).
adjMapping2SUMO('00564262-a',[ ('Separating',subsumption)]).
adjMapping2SUMO('00564504-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00564667-s',[ (or,subsumption)]).
adjMapping2SUMO('00564858-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('00565115-s',[ ('Separating',subsumption)]).
adjMapping2SUMO('00565289-s',[ ('Separating',subsumption)]).
adjMapping2SUMO('00565565-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('00565799-a',[ ('Music',subsumption)]).
adjMapping2SUMO('00565962-a',[ ('Music',subsumption)]).
adjMapping2SUMO('00566099-a',[ (connected,equivalence)]).
adjMapping2SUMO('00566342-s',[ (connected,subsumption)]).
adjMapping2SUMO('00566733-s',[ (connected,subsumption)]).
adjMapping2SUMO('00566835-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00566961-s',[ (connected,subsumption)]).
adjMapping2SUMO('00567161-s',[ (connected,subsumption)]).
adjMapping2SUMO('00567287-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00567414-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00567593-a',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('00567860-s',[ (connected,subsumption)]).
adjMapping2SUMO('00568171-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00568304-s',[ ('Detaching',equivalence)]).
adjMapping2SUMO('00568541-s',[ ('Separating',subsumption)]).
adjMapping2SUMO('00568658-s',[ ('',undefined)]).
adjMapping2SUMO('00568881-s',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('00568959-s',[ ('Detaching',subsumption)]).
adjMapping2SUMO('00569090-a',[ (capability,subsumption)]).
adjMapping2SUMO('00569304-s',[ (capability,subsumption)]).
adjMapping2SUMO('00569468-s',[ (capability,subsumption)]).
adjMapping2SUMO('00569568-a',[ (capability,subsumption)]).
adjMapping2SUMO('00569918-s',[ (capability,subsumption)]).
adjMapping2SUMO('00570099-s',[ (capability,subsumption)]).
adjMapping2SUMO('00570225-s',[ (capability,subsumption)]).
adjMapping2SUMO('00570322-s',[ (capability,subsumption)]).
adjMapping2SUMO('00570512-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('00570590-a',[ ('Awake',subsumption)]).
adjMapping2SUMO('00570991-s',[ ('Awake',subsumption)]).
adjMapping2SUMO('00571291-s',[ ('Awake',subsumption)]).
adjMapping2SUMO('00571424-s',[ ('Awake',subsumption)]).
adjMapping2SUMO('00571643-a',[ ('Unconscious',equivalence)]).
adjMapping2SUMO('00572060-s',[ ('Unconscious',subsumption)]).
adjMapping2SUMO('00572202-s',[ ('Unconscious',subsumption)]).
adjMapping2SUMO('00572392-s',[ ('Unconscious',subsumption)]).
adjMapping2SUMO('00572534-s',[ ('Unconscious',subsumption)]).
adjMapping2SUMO('00572714-s',[ ('Unconscious',subsumption)]).
adjMapping2SUMO('00572845-s',[ ('PsychologicalProcess',subsumption)]).
adjMapping2SUMO('00573008-s',[ ('ConsciousnessAttribute',subsumption)]).
adjMapping2SUMO('00573093-s',[ ('PsychologicalProcess',subsumption)]).
adjMapping2SUMO('00573225-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00573542-s',[ ('Declaring',subsumption)]).
adjMapping2SUMO('00573666-s',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('00573770-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00573926-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00574010-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00574114-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00574308-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00574422-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00574644-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00574744-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00574884-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00575012-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00575126-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00575230-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00575520-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00575685-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00576011-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00576189-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00576423-s',[ ('PoliticalProcess',subsumption)]).
adjMapping2SUMO('00576573-s',[ ('PoliticalProcess',subsumption)]).
adjMapping2SUMO('00576680-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00577122-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00577405-s',[ (realization,equivalence)]).
adjMapping2SUMO('00577612-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00577698-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00577782-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00577920-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00578234-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00578523-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00578662-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00578831-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00578960-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00579084-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00579498-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00579622-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00579881-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00580039-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00580346-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00580497-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00580684-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00580805-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00581401-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00581637-s',[ (capability,subsumption)]).
adjMapping2SUMO('00581812-a',[ (capability,subsumption)]).
adjMapping2SUMO('00582164-a',[ (capability,subsumption)]).
adjMapping2SUMO('00582314-a',[ (capability,subsumption)]).
adjMapping2SUMO('00582636-s',[ (capability,subsumption)]).
adjMapping2SUMO('00582762-s',[ (capability,subsumption)]).
adjMapping2SUMO('00582876-a',[ (capability,subsumption)]).
adjMapping2SUMO('00583239-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00583581-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00583842-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00583990-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00584403-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00584626-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00584820-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00585202-s',[ ('Creation',subsumption)]).
adjMapping2SUMO('00585398-s',[ ('ShapeChange',subsumption)]).
adjMapping2SUMO('00585597-s',[ ('BiologicalProcess',subsumption)]).
adjMapping2SUMO('00585751-s',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('00585856-s',[ ('TherapeuticProcess',subsumption)]).
adjMapping2SUMO('00586060-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00586183-a',[ ('Damaging',subsumption)]).
adjMapping2SUMO('00586617-s',[ ('Destruction',subsumption)]).
adjMapping2SUMO('00586883-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('00587193-s',[ ('Destruction',subsumption)]).
adjMapping2SUMO('00587376-s',[ (capability,subsumption)]).
adjMapping2SUMO('00587697-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00587890-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00588062-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('00588207-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00588425-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('00588535-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00588655-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('00588797-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00589067-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00589344-s',[ ('Happiness',equivalence)]).
adjMapping2SUMO('00589448-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00589624-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00589960-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00590163-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00590271-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00590390-a',[ (capability,subsumption)]).
adjMapping2SUMO('00590564-s',[ (capability,subsumption)]).
adjMapping2SUMO('00590669-s',[ (capability,subsumption)]).
adjMapping2SUMO('00590782-s',[ (capability,subsumption)]).
adjMapping2SUMO('00590923-a',[ ('True',subsumption)]).
adjMapping2SUMO('00591147-s',[ ('True',subsumption)]).
adjMapping2SUMO('00591298-s',[ ('True',subsumption)]).
adjMapping2SUMO('00591406-s',[ ('True',subsumption)]).
adjMapping2SUMO('00591513-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00591710-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00591817-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00591953-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00592113-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00592222-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00592539-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00592754-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00592880-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00593071-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00593276-s',[ ('',undefined)]).
adjMapping2SUMO('00593374-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00593664-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00593836-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00594004-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00594146-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00594267-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00594413-a',[ (forall,subsumption)]).
adjMapping2SUMO('00595147-s',[ (forall,subsumption)]).
adjMapping2SUMO('00595299-s',[ (forall,subsumption)]).
adjMapping2SUMO('00595863-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00596043-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00596211-s',[ (forall,subsumption)]).
adjMapping2SUMO('00596358-s',[ ('Heating',subsumption)]).
adjMapping2SUMO('00596511-s',[ (meetsTemporally,equivalence)]).
adjMapping2SUMO('00596639-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00596769-a',[ (forall,subsumption)]).
adjMapping2SUMO('00597148-s',[ (forall,subsumption)]).
adjMapping2SUMO('00597267-s',[ (located,subsumption)]).
adjMapping2SUMO('00597424-a',[ ('Function',subsumption)]).
adjMapping2SUMO('00597599-a',[ ('Function',subsumption)]).
adjMapping2SUMO('00597758-a',[ (meetsTemporally,equivalence)]).
adjMapping2SUMO('00597988-s',[ (forall,subsumption)]).
adjMapping2SUMO('00598203-a',[ (agent,subsumption)]).
adjMapping2SUMO('00598413-s',[ (agent,subsumption)]).
adjMapping2SUMO('00598536-s',[ ('',undefined)]).
adjMapping2SUMO('00598679-a',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('00599005-s',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('00599111-s',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('00599186-s',[ (agent,subsumption)]).
adjMapping2SUMO('00599292-s',[ (agent,subsumption)]).
adjMapping2SUMO('00599468-s',[ (agent,subsumption)]).
adjMapping2SUMO('00599628-s',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('00599745-s',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('00599821-a',[ ('RegulatoryProcess',not(subsumption))]).
adjMapping2SUMO('00600192-s',[ ('RegulatoryProcess',not(subsumption))]).
adjMapping2SUMO('00600395-s',[ ('',undefined)]).
adjMapping2SUMO('00600540-s',[ (capability,subsumption)]).
adjMapping2SUMO('00600725-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00600879-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00601032-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00601150-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00601250-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00601499-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00601650-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00601783-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00602117-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00602293-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00602474-s',[ ('',undefined)]).
adjMapping2SUMO('00602563-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00602721-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00602888-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00603039-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00603194-s',[ ('Promise',subsumption)]).
adjMapping2SUMO('00603367-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00603660-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00603804-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00604221-s',[ ('',undefined)]).
adjMapping2SUMO('00604399-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00604520-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00604617-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00604897-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00604978-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00605128-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00605406-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00605516-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00605893-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00606079-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00606240-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00606347-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00606602-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00606859-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00607009-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00607202-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00607421-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00607656-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00607857-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00607977-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00608245-s',[ ('',undefined)]).
adjMapping2SUMO('00608421-a',[ ('UnconventionalAttribute',equivalence)]).
adjMapping2SUMO('00608668-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00608791-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00609341-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00609564-s',[ ('UnconventionalAttribute',equivalence)]).
adjMapping2SUMO('00609750-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00609938-s',[ ('',undefined)]).
adjMapping2SUMO('00610057-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00610249-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00610532-a',[ ('RadiatingNuclear',equivalence)]).
adjMapping2SUMO('00610734-s',[ ('Weapon',subsumption)]).
adjMapping2SUMO('00610861-a',[ ('Device',subsumption)]).
adjMapping2SUMO('00611047-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00611281-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00611527-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00611754-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00611938-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00612114-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('00612383-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00612504-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00612652-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('00612891-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00612980-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00613068-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00613382-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00613728-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('00613866-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('00613975-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('00614120-s',[ ('',undefined)]).
adjMapping2SUMO('00614200-s',[ ('',undefined)]).
adjMapping2SUMO('00614305-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00614436-s',[ ('',undefined)]).
adjMapping2SUMO('00614518-s',[ ('',undefined)]).
adjMapping2SUMO('00614600-s',[ ('',undefined)]).
adjMapping2SUMO('00614680-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00614791-s',[ ('',undefined)]).
adjMapping2SUMO('00614868-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('00614990-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00615191-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00615343-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00615457-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00615655-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00615757-a',[ ('Cooking',equivalence)]).
adjMapping2SUMO('00616408-s',[ ('',undefined)]).
adjMapping2SUMO('00616532-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00616654-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00616748-s',[ ('',undefined)]).
adjMapping2SUMO('00616822-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00616913-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00617033-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00617137-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00617271-s',[ ('',undefined)]).
adjMapping2SUMO('00617344-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00617422-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00617510-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00617583-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00617678-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00617752-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00617864-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00617951-s',[ ('',undefined)]).
adjMapping2SUMO('00618040-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00618169-s',[ ('',undefined)]).
adjMapping2SUMO('00618274-s',[ ('',undefined)]).
adjMapping2SUMO('00618377-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00618493-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00618584-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00618752-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00618865-s',[ ('',undefined)]).
adjMapping2SUMO('00618944-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00619030-s',[ ('',undefined)]).
adjMapping2SUMO('00619119-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00619238-s',[ ('',undefined)]).
adjMapping2SUMO('00619324-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00619433-a',[ ('Cooking',not(subsumption))]).
adjMapping2SUMO('00619601-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00619691-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00619808-s',[ ('Cooking',not(equivalence))]).
adjMapping2SUMO('00619873-s',[ ('Cooking',not(subsumption))]).
adjMapping2SUMO('00619972-a',[ ('Cooperation',equivalence)]).
adjMapping2SUMO('00620208-s',[ ('',undefined)]).
adjMapping2SUMO('00620341-s',[ ('Cooperation',subsumption)]).
adjMapping2SUMO('00620585-a',[ ('Cooperation',not(subsumption))]).
adjMapping2SUMO('00620731-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00621100-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00621207-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00621524-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00621857-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00622014-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00622354-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00622468-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00622581-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00622828-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00622935-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00623105-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00623261-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00623356-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00623565-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00623814-s',[ (capability,subsumption)]).
adjMapping2SUMO('00623939-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00624026-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00624416-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00624576-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00624913-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00625055-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00625170-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00625393-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00625774-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00626136-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00626483-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00626701-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00626800-a',[ ('Object',equivalence)]).
adjMapping2SUMO('00627004-s',[ ('Object',equivalence)]).
adjMapping2SUMO('00627204-s',[ ('Object',equivalence)]).
adjMapping2SUMO('00627410-a',[ ('Abstract',subsumption)]).
adjMapping2SUMO('00627643-s',[ ('Abstract',subsumption)]).
adjMapping2SUMO('00627849-a',[ ('SelfConnectedObject',subsumption)]).
adjMapping2SUMO('00628201-s',[ ('Agent',subsumption)]).
adjMapping2SUMO('00628354-s',[ ('',undefined)]).
adjMapping2SUMO('00628432-s',[ ('',undefined)]).
adjMapping2SUMO('00628519-s',[ ('',undefined)]).
adjMapping2SUMO('00628610-s',[ ('',undefined)]).
adjMapping2SUMO('00628687-s',[ ('',undefined)]).
adjMapping2SUMO('00628776-s',[ ('',undefined)]).
adjMapping2SUMO('00628881-s',[ ('',undefined)]).
adjMapping2SUMO('00628988-s',[ ('',undefined)]).
adjMapping2SUMO('00629068-s',[ ('',undefined)]).
adjMapping2SUMO('00629146-a',[ ('Agent',subsumption)]).
adjMapping2SUMO('00629269-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00629382-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00629532-a',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('00629808-a',[ ('RegulatoryProcess',not(subsumption))]).
adjMapping2SUMO('00629997-a',[ ('Object',equivalence)]).
adjMapping2SUMO('00630329-s',[ ('Object',subsumption)]).
adjMapping2SUMO('00630466-s',[ ('CorpuscularObject',subsumption)]).
adjMapping2SUMO('00630727-s',[ ('CorpuscularObject',subsumption)]).
adjMapping2SUMO('00630802-a',[ ('Abstract',subsumption)]).
adjMapping2SUMO('00631040-s',[ ('Abstract',subsumption)]).
adjMapping2SUMO('00631193-s',[ ('Abstract',subsumption)]).
adjMapping2SUMO('00631391-a',[ ('True',subsumption)]).
adjMapping2SUMO('00631798-s',[ ('True',subsumption)]).
adjMapping2SUMO('00632071-s',[ ('True',subsumption)]).
adjMapping2SUMO('00632306-s',[ ('True',subsumption)]).
adjMapping2SUMO('00632438-a',[ ('False',subsumption)]).
adjMapping2SUMO('00632949-s',[ ('False',subsumption)]).
adjMapping2SUMO('00633084-s',[ ('False',subsumption)]).
adjMapping2SUMO('00633235-s',[ ('False',subsumption)]).
adjMapping2SUMO('00633410-a',[ ('True',subsumption)]).
adjMapping2SUMO('00633581-s',[ ('True',subsumption)]).
adjMapping2SUMO('00633778-a',[ ('False',subsumption)]).
adjMapping2SUMO('00633937-s',[ ('False',subsumption)]).
adjMapping2SUMO('00634062-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00634259-s',[ ('Device',subsumption)]).
adjMapping2SUMO('00634404-s',[ ('Device',subsumption)]).
adjMapping2SUMO('00634559-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00634636-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00634759-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00634862-a',[ (capability,subsumption)]).
adjMapping2SUMO('00635078-s',[ (capability,subsumption)]).
adjMapping2SUMO('00635244-s',[ (capability,subsumption)]).
adjMapping2SUMO('00635327-s',[ (capability,subsumption)]).
adjMapping2SUMO('00635456-a',[ (capability,subsumption)]).
adjMapping2SUMO('00635607-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00635752-s',[ (capability,subsumption)]).
adjMapping2SUMO('00635955-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00636391-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00636547-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00636891-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00637172-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00637267-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00637455-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00637645-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00637751-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00637857-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00637979-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00638067-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00638253-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00638396-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00638501-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00638622-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00638841-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('00638981-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00639230-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00639356-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00639594-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00639842-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00640106-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00640283-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00640520-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00640660-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00640931-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00641036-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00641158-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00641343-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00641460-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00641640-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00641813-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00641944-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00642152-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00642263-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00642379-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00642725-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00642934-a',[ ('TimeDuration',subsumption)]).
adjMapping2SUMO('00643116-a',[ ('TimeDuration',subsumption)]).
adjMapping2SUMO('00643250-a',[ (capability,subsumption)]).
adjMapping2SUMO('00643598-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00643760-s',[ (capability,subsumption)]).
adjMapping2SUMO('00643863-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00644299-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00644372-a',[ (capability,subsumption)]).
adjMapping2SUMO('00644560-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00644839-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00645169-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00645281-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00645493-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00645856-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00645982-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00646117-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00646276-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00646413-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00646691-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00646890-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00646981-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00647070-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00647247-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00647542-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00647867-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00648089-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00648238-s',[ ('',undefined)]).
adjMapping2SUMO('00648345-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00648543-s',[ ('',undefined)]).
adjMapping2SUMO('00648614-s',[ ('Boiling',equivalence)]).
adjMapping2SUMO('00648816-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00648977-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00649228-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00649405-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00649586-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00649892-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00650135-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00650351-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00650577-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00650900-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00651039-s',[ ('Dangerous',equivalence)]).
adjMapping2SUMO('00651451-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00651697-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00651841-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00651935-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('00652351-s',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('00652533-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('00652692-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00652893-s',[ ('',undefined)]).
adjMapping2SUMO('00653044-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00653190-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00653295-a',[ ('Certificate',subsumption)]).
adjMapping2SUMO('00653434-a',[ ('Certificate',subsumption)]).
adjMapping2SUMO('00653514-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00653617-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00653740-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00653822-a',[ ('On',subsumption)]).
adjMapping2SUMO('00654125-s',[ ('On',subsumption)]).
adjMapping2SUMO('00654315-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00654394-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00654596-s',[ ('',undefined)]).
adjMapping2SUMO('00654685-s',[ ('CognitiveAgent',subsumption)]).
adjMapping2SUMO('00654829-a',[ ('CognitiveAgent',subsumption)]).
adjMapping2SUMO('00654983-s',[ ('CognitiveAgent',subsumption)]).
adjMapping2SUMO('00655136-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00655292-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00655445-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00655668-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00655779-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00656132-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00656384-s',[ ('',undefined)]).
adjMapping2SUMO('00656507-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00656771-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00656862-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00657064-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00657198-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00657473-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00657600-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00657726-s',[ ('',undefined)]).
adjMapping2SUMO('00657804-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00658022-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00658166-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00658259-a',[ ('OneDimensionalFigure',subsumption)]).
adjMapping2SUMO('00658513-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00658591-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00658680-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00658752-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00658942-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00659181-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00659259-s',[ ('TwoDimensionalFigure',subsumption)]).
adjMapping2SUMO('00659421-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00659530-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00659617-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00659715-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00660019-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00660313-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00660551-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00660809-s',[ ('ThreeDimensionalFigure',subsumption)]).
adjMapping2SUMO('00661146-s',[ ('TimePosition',subsumption)]).
adjMapping2SUMO('00661278-a',[ ('Cutting',subsumption)]).
adjMapping2SUMO('00661640-s',[ ('Cutting',subsumption)]).
adjMapping2SUMO('00661819-s',[ ('Cutting',subsumption)]).
adjMapping2SUMO('00661887-s',[ ('Cutting',subsumption)]).
adjMapping2SUMO('00661973-s',[ ('Hole',subsumption)]).
adjMapping2SUMO('00662139-s',[ ('Cutting',subsumption)]).
adjMapping2SUMO('00662318-s',[ ('Detaching',subsumption)]).
adjMapping2SUMO('00662529-s',[ ('Separating',subsumption)]).
adjMapping2SUMO('00662687-a',[ ('Cutting',not(subsumption))]).
adjMapping2SUMO('00662782-s',[ ('Hole',not(subsumption))]).
adjMapping2SUMO('00662873-s',[ ('Cutting',not(subsumption))]).
adjMapping2SUMO('00662958-a',[ ('Cutting',subsumption)]).
adjMapping2SUMO('00663104-a',[ ('Cutting',not(subsumption))]).
adjMapping2SUMO('00663267-a',[ ('Cutting',subsumption)]).
adjMapping2SUMO('00663468-s',[ ('Cutting',subsumption)]).
adjMapping2SUMO('00663576-s',[ ('Cutting',subsumption)]).
adjMapping2SUMO('00663807-s',[ ('Cutting',subsumption)]).
adjMapping2SUMO('00663981-s',[ ('Hole',subsumption)]).
adjMapping2SUMO('00664167-a',[ ('Cutting',not(subsumption))]).
adjMapping2SUMO('00664317-s',[ ('Cutting',not(subsumption))]).
adjMapping2SUMO('00664449-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00664879-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00665156-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00665502-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00665587-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00665829-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00665962-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00666058-a',[ ('TimePosition',subsumption)]).
adjMapping2SUMO('00666610-s',[ ('TimePosition',subsumption)]).
adjMapping2SUMO('00666784-s',[ ('Process',subsumption)]).
adjMapping2SUMO('00666960-s',[ ('Transfer',subsumption)]).
adjMapping2SUMO('00667079-s',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('00667208-s',[ ('Position',subsumption)]).
adjMapping2SUMO('00667353-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00667463-s',[ ('Text',subsumption)]).
adjMapping2SUMO('00667641-s',[ ('',undefined)]).
adjMapping2SUMO('00667822-s',[ ('TimePosition',subsumption)]).
adjMapping2SUMO('00667936-s',[ ('Process',subsumption)]).
adjMapping2SUMO('00668053-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00668208-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00668366-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00668571-a',[ ('TimePosition',subsumption)]).
adjMapping2SUMO('00668816-s',[ ('TimePosition',subsumption)]).
adjMapping2SUMO('00668919-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00669021-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00669138-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00669367-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00669478-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00669853-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00669942-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00670418-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00670530-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00670635-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00670741-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00670938-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00671091-a',[ ('Giving',subsumption)]).
adjMapping2SUMO('00671357-s',[ ('Giving',subsumption)]).
adjMapping2SUMO('00671441-a',[ ('Giving',not(subsumption))]).
adjMapping2SUMO('00671593-s',[ ('Giving',not(subsumption))]).
adjMapping2SUMO('00671683-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00671831-a',[ ('Covering',subsumption)]).
adjMapping2SUMO('00671976-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('00672079-a',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('00672226-a',[ ('Making',subsumption)]).
adjMapping2SUMO('00672382-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00672513-s',[ ('Making',subsumption)]).
adjMapping2SUMO('00672621-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00672785-s',[ ('Product',subsumption)]).
adjMapping2SUMO('00672932-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00673172-s',[ ('Product',subsumption)]).
adjMapping2SUMO('00673330-s',[ ('',undefined)]).
adjMapping2SUMO('00673456-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00673662-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00673807-s',[ ('Making',subsumption)]).
adjMapping2SUMO('00673919-s',[ ('Making',subsumption)]).
adjMapping2SUMO('00674021-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('00674196-a',[ ('Making',subsumption)]).
adjMapping2SUMO('00674270-a',[ ('Making',subsumption)]).
adjMapping2SUMO('00674476-s',[ ('Making',subsumption)]).
adjMapping2SUMO('00674633-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00674732-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00674824-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('00674913-s',[ ('Making',subsumption)]).
adjMapping2SUMO('00675064-a',[ ('Manufacture',subsumption)]).
adjMapping2SUMO('00675228-s',[ ('Buying',subsumption)]).
adjMapping2SUMO('00675368-s',[ ('Manufacture',subsumption)]).
adjMapping2SUMO('00675473-s',[ ('Manufacture',subsumption)]).
adjMapping2SUMO('00675587-s',[ ('Manufacture',subsumption)]).
adjMapping2SUMO('00675701-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00675928-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00676093-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('00676271-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00676457-a',[ ('Process',subsumption)]).
adjMapping2SUMO('00676555-a',[ ('Molecule',subsumption)]).
adjMapping2SUMO('00676754-s',[ ('Molecule',subsumption)]).
adjMapping2SUMO('00676855-s',[ ('Molecule',subsumption)]).
adjMapping2SUMO('00676999-s',[ ('Molecule',subsumption)]).
adjMapping2SUMO('00677170-s',[ ('Molecule',subsumption)]).
adjMapping2SUMO('00677313-a',[ ('Molecule',subsumption)]).
adjMapping2SUMO('00677448-s',[ ('Molecule',subsumption)]).
adjMapping2SUMO('00677545-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00677721-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('00677877-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00678024-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00678221-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00678473-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00678666-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00678923-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00679147-a',[ ('Damaging',equivalence)]).
adjMapping2SUMO('00679562-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('00679717-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00680005-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('00680156-s',[ ('DeviceDamaged',equivalence)]).
adjMapping2SUMO('00680395-s',[ ('Injuring',subsumption)]).
adjMapping2SUMO('00680532-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00680634-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('00680791-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00681019-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('00681094-a',[ ('Damaging',not(subsumption))]).
adjMapping2SUMO('00681268-s',[ ('Damaging',not(subsumption))]).
adjMapping2SUMO('00681409-a',[ (capability,subsumption)]).
adjMapping2SUMO('00681548-a',[ (capability,subsumption)]).
adjMapping2SUMO('00681673-s',[ (date,subsumption)]).
adjMapping2SUMO('00681777-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00681930-a',[ ('Deaf',equivalence)]).
adjMapping2SUMO('00682168-s',[ (capability,subsumption)]).
adjMapping2SUMO('00682329-s',[ (causes,subsumption)]).
adjMapping2SUMO('00682419-s',[ (capability,subsumption)]).
adjMapping2SUMO('00682521-s',[ ('Deaf',equivalence)]).
adjMapping2SUMO('00682662-s',[ (capability,not(subsumption))]).
adjMapping2SUMO('00682744-a',[ (capability,subsumption)]).
adjMapping2SUMO('00682841-s',[ (capability,subsumption)]).
adjMapping2SUMO('00682932-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00683185-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00683531-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00683910-s',[ ('',undefined)]).
adjMapping2SUMO('00684054-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00684163-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00684334-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00684480-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00684782-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00685113-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00685365-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00685483-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00685638-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00685924-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00686081-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00686356-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00686573-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00686789-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00686890-a',[ ('Stating',subsumption)]).
adjMapping2SUMO('00687163-a',[ ('Questioning',subsumption)]).
adjMapping2SUMO('00687356-a',[ ('Stating',subsumption)]).
adjMapping2SUMO('00687614-s',[ ('Stating',subsumption)]).
adjMapping2SUMO('00687750-s',[ ('Disseminating',subsumption)]).
adjMapping2SUMO('00687952-s',[ ('Stating',subsumption)]).
adjMapping2SUMO('00688074-s',[ ('Stating',subsumption)]).
adjMapping2SUMO('00688296-s',[ ('Stating',subsumption)]).
adjMapping2SUMO('00688413-s',[ ('',undefined)]).
adjMapping2SUMO('00688581-a',[ ('Stating',not(subsumption))]).
adjMapping2SUMO('00688740-s',[ ('Stating',not(subsumption))]).
adjMapping2SUMO('00688855-s',[ ('Stating',not(subsumption))]).
adjMapping2SUMO('00688947-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00689215-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00689336-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00689471-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00689673-a',[ ('Permission',subsumption)]).
adjMapping2SUMO('00689878-s',[ ('Permission',subsumption)]).
adjMapping2SUMO('00689970-a',[ ('Permission',subsumption)]).
adjMapping2SUMO('00690058-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00690683-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00690892-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00691022-s',[ ('WaterArea',subsumption)]).
adjMapping2SUMO('00691141-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00691497-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00691696-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00692154-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00692255-s',[ (capability,subsumption)]).
adjMapping2SUMO('00692415-s',[ ('WaterArea',subsumption)]).
adjMapping2SUMO('00692548-s',[ ('WaterArea',subsumption)]).
adjMapping2SUMO('00692762-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00693020-s',[ ('Asleep',subsumption)]).
adjMapping2SUMO('00693237-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00693356-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00693570-s',[ ('Asleep',subsumption)]).
adjMapping2SUMO('00693743-a',[ ('True',subsumption)]).
adjMapping2SUMO('00693961-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00694086-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00694284-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00694483-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00694608-a',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('00694773-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00694924-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00695024-a',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('00695209-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('00695335-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('00695432-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00695523-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00695938-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00696207-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00696335-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00696518-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00696828-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00696996-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00697089-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00697188-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00697389-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00697691-s',[ (capability,subsumption)]).
adjMapping2SUMO('00697923-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00698088-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00698262-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00698506-s',[ (capability,subsumption)]).
adjMapping2SUMO('00698586-s',[ ('Word',subsumption)]).
adjMapping2SUMO('00698848-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00699085-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00699207-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00699521-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00699651-a',[ ('Word',subsumption)]).
adjMapping2SUMO('00699876-a',[ ('Word',subsumption)]).
adjMapping2SUMO('00700016-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00700214-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00700312-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00700451-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00700884-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00701178-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00701299-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00701479-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00701894-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00702118-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00702245-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00702444-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00702642-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00702773-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00702962-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00703109-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00703366-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00703454-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00703615-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00704270-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00704360-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00704609-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00704898-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00705336-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00705498-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00705616-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00705776-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00705891-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00706311-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00706455-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00706688-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00706800-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00706974-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00707087-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00707206-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('00707366-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00707667-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00707795-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00708017-a',[ ('Fragile',equivalence)]).
adjMapping2SUMO('00708498-s',[ ('Fragile',subsumption)]).
adjMapping2SUMO('00708738-s',[ ('Fragile',subsumption)]).
adjMapping2SUMO('00709021-s',[ ('Food',subsumption)]).
adjMapping2SUMO('00709215-s',[ ('Fragile',subsumption)]).
adjMapping2SUMO('00709446-s',[ ('Fragile',subsumption)]).
adjMapping2SUMO('00709625-s',[ ('Fragile',subsumption)]).
adjMapping2SUMO('00709744-a',[ ('Unbreakable',equivalence)]).
adjMapping2SUMO('00709959-s',[ ('Unbreakable',subsumption)]).
adjMapping2SUMO('00710097-s',[ ('Unbreakable',subsumption)]).
adjMapping2SUMO('00710260-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00710585-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00710741-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00710909-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00711059-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00711308-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00711528-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00711831-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00712004-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00712186-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00712314-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00712419-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00712765-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00712877-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00713205-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00713351-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00713558-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00713853-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00713995-a',[ ('Requesting',subsumption)]).
adjMapping2SUMO('00714190-s',[ ('Requesting',subsumption)]).
adjMapping2SUMO('00714320-s',[ ('Requesting',subsumption)]).
adjMapping2SUMO('00714437-s',[ ('Requesting',subsumption)]).
adjMapping2SUMO('00714585-s',[ ('Requesting',subsumption)]).
adjMapping2SUMO('00714763-s',[ ('Requesting',subsumption)]).
adjMapping2SUMO('00714889-s',[ ('Requesting',subsumption)]).
adjMapping2SUMO('00715140-a',[ ('Democracy',equivalence)]).
adjMapping2SUMO('00715586-s',[ ('Government',subsumption)]).
adjMapping2SUMO('00715677-s',[ ('Government',subsumption)]).
adjMapping2SUMO('00715830-s',[ ('Government',subsumption)]).
adjMapping2SUMO('00716056-s',[ ('Government',subsumption)]).
adjMapping2SUMO('00716211-s',[ ('Government',subsumption)]).
adjMapping2SUMO('00716370-s',[ ('Government',subsumption)]).
adjMapping2SUMO('00716562-s',[ ('Government',subsumption)]).
adjMapping2SUMO('00716892-s',[ ('Government',subsumption)]).
adjMapping2SUMO('00717417-a',[ ('Government',subsumption)]).
adjMapping2SUMO('00717684-s',[ ('Government',subsumption)]).
adjMapping2SUMO('00718137-s',[ ('Government',subsumption)]).
adjMapping2SUMO('00718339-s',[ ('Government',subsumption)]).
adjMapping2SUMO('00718635-s',[ ('Government',subsumption)]).
adjMapping2SUMO('00718924-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00719328-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00719442-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00719819-s',[ (capability,subsumption)]).
adjMapping2SUMO('00720082-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00720212-s',[ ('Obligation',subsumption)]).
adjMapping2SUMO('00720296-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00720524-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00720777-s',[ ('',undefined)]).
adjMapping2SUMO('00720913-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00721050-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00721157-a',[ (capability,subsumption)]).
adjMapping2SUMO('00721287-s',[ (capability,subsumption)]).
adjMapping2SUMO('00721371-s',[ (capability,subsumption)]).
adjMapping2SUMO('00721505-a',[ (capability,subsumption)]).
adjMapping2SUMO('00721636-s',[ (capability,subsumption)]).
adjMapping2SUMO('00721838-s',[ (capability,subsumption)]).
adjMapping2SUMO('00722110-a',[ ('ContentBearingProcess',subsumption)]).
adjMapping2SUMO('00722386-s',[ ('ContentBearingProcess',subsumption)]).
adjMapping2SUMO('00722611-s',[ ('ContentBearingProcess',subsumption)]).
adjMapping2SUMO('00722707-s',[ ('ContentBearingProcess',subsumption)]).
adjMapping2SUMO('00722886-s',[ ('',undefined)]).
adjMapping2SUMO('00723015-s',[ (refers,equivalence)]).
adjMapping2SUMO('00723163-a',[ (represents,subsumption)]).
adjMapping2SUMO('00723395-s',[ (represents,subsumption)]).
adjMapping2SUMO('00723542-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00723786-s',[ (entails,subsumption)]).
adjMapping2SUMO('00723910-s',[ (represents,subsumption)]).
adjMapping2SUMO('00724081-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00724397-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00724596-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00724720-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00724861-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00725227-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00725522-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00725704-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00725772-a',[ (capability,subsumption)]).
adjMapping2SUMO('00726189-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00726317-s',[ (capability,subsumption)]).
adjMapping2SUMO('00726445-s',[ (capability,subsumption)]).
adjMapping2SUMO('00726612-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('00726723-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00727113-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00727268-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00727481-s',[ ('AgeGroup',subsumption)]).
adjMapping2SUMO('00727564-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00728103-s',[ ('Nation',subsumption)]).
adjMapping2SUMO('00728225-s',[ ('CognitiveAgent',subsumption)]).
adjMapping2SUMO('00728431-s',[ ('Agent',subsumption)]).
adjMapping2SUMO('00728619-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00728826-s',[ ('CommutativeFunction',equivalence)]).
adjMapping2SUMO('00728993-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('00729133-s',[ ('',undefined)]).
adjMapping2SUMO('00729246-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00729439-s',[ (capability,subsumption)]).
adjMapping2SUMO('00729647-s',[ (capability,subsumption)]).
adjMapping2SUMO('00729776-s',[ ('IntentionalProcess',subsumption)]).
adjMapping2SUMO('00729894-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00730009-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('00730082-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00730215-a',[ ('Phrase',subsumption)]).
adjMapping2SUMO('00730470-a',[ ('Phrase',subsumption)]).
adjMapping2SUMO('00730731-a',[ (member,subsumption)]).
adjMapping2SUMO('00730896-s',[ (believes,subsumption)]).
adjMapping2SUMO('00730985-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00731292-a',[ (member,subsumption)]).
adjMapping2SUMO('00731471-s',[ (believes,subsumption)]).
adjMapping2SUMO('00731606-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00731725-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00731804-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('00731955-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('00732037-a',[ (member,subsumption)]).
adjMapping2SUMO('00732160-s',[ (believes,subsumption)]).
adjMapping2SUMO('00732318-a',[ ('FieldOfStudy',subsumption)]).
adjMapping2SUMO('00732456-a',[ ('FieldOfStudy',subsumption)]).
adjMapping2SUMO('00732682-a',[ (represents,subsumption)]).
adjMapping2SUMO('00732872-a',[ (represents,subsumption)]).
adjMapping2SUMO('00732960-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00733297-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00733406-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00733541-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00733632-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00733743-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00733905-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00734187-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00734318-a',[ ('Damaging',subsumption)]).
adjMapping2SUMO('00734798-s',[ ('Destruction',subsumption)]).
adjMapping2SUMO('00734906-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00735088-s',[ ('Destruction',subsumption)]).
adjMapping2SUMO('00735195-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00735336-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('00735608-s',[ ('Destruction',subsumption)]).
adjMapping2SUMO('00735709-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00735882-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('00736020-s',[ ('IntentionalProcess',subsumption)]).
adjMapping2SUMO('00736196-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('00736299-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('00736511-s',[ ('Destruction',subsumption)]).
adjMapping2SUMO('00736671-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('00736879-s',[ ('Destruction',subsumption)]).
adjMapping2SUMO('00737033-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('00737116-s',[ ('Destruction',subsumption)]).
adjMapping2SUMO('00737246-a',[ ('Maintaining',subsumption)]).
adjMapping2SUMO('00737432-s',[ ('Maintaining',subsumption)]).
adjMapping2SUMO('00737515-s',[ ('Maintaining',subsumption)]).
adjMapping2SUMO('00737619-s',[ (capability,subsumption)]).
adjMapping2SUMO('00737703-s',[ ('Maintaining',subsumption)]).
adjMapping2SUMO('00737801-s',[ ('Keeping',subsumption)]).
adjMapping2SUMO('00737973-a',[ (capability,subsumption)]).
adjMapping2SUMO('00738182-s',[ (capability,subsumption)]).
adjMapping2SUMO('00738284-s',[ (capability,subsumption)]).
adjMapping2SUMO('00738368-a',[ (capability,subsumption)]).
adjMapping2SUMO('00738503-s',[ (capability,subsumption)]).
adjMapping2SUMO('00738593-a',[ (capability,subsumption)]).
adjMapping2SUMO('00738829-s',[ (capability,subsumption)]).
adjMapping2SUMO('00739022-s',[ (capability,subsumption)]).
adjMapping2SUMO('00739163-s',[ (capability,subsumption)]).
adjMapping2SUMO('00739273-a',[ (capability,subsumption)]).
adjMapping2SUMO('00739495-s',[ (capability,subsumption)]).
adjMapping2SUMO('00739663-s',[ (capability,subsumption)]).
adjMapping2SUMO('00739789-s',[ (capability,subsumption)]).
adjMapping2SUMO('00739932-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00740217-s',[ ('Number',subsumption)]).
adjMapping2SUMO('00740336-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00740767-s',[ ('Calculating',subsumption)]).
adjMapping2SUMO('00740958-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00741076-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00741240-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00741459-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('00741633-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00741867-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00742164-s',[ ('Planning',subsumption)]).
adjMapping2SUMO('00742316-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00742425-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00742620-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00742714-s',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('00742879-a',[ ('Right',subsumption)]).
adjMapping2SUMO('00743183-s',[ ('Left',subsumption)]).
adjMapping2SUMO('00743293-s',[ ('Right',subsumption)]).
adjMapping2SUMO('00743435-a',[ ('Left',subsumption)]).
adjMapping2SUMO('00743742-s',[ ('Left',subsumption)]).
adjMapping2SUMO('00743869-s',[ ('Left',subsumption)]).
adjMapping2SUMO('00744017-a',[ ('Heating',subsumption)]).
adjMapping2SUMO('00744141-a',[ ('Heating',not(subsumption))]).
adjMapping2SUMO('00744277-a',[ (equal,subsumption)]).
adjMapping2SUMO('00744506-a',[ (equal,subsumption)]).
adjMapping2SUMO('00744669-s',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('00744916-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00745642-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00745858-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00746047-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00746451-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00746819-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00746994-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00747226-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00747471-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00747576-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00747727-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00747910-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00748058-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00748359-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00748563-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00748674-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00748795-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00748947-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00749040-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00749230-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00749749-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00749947-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00750054-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00750296-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00750602-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00750712-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00750843-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00750926-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00751099-s',[ ('',undefined)]).
adjMapping2SUMO('00751170-a',[ ('Mammal',subsumption)]).
adjMapping2SUMO('00751353-a',[ ('Mammal',subsumption)]).
adjMapping2SUMO('00751525-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00751838-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00752110-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00752392-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00752555-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00752714-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00752847-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00753093-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00753378-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00753504-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00753659-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00753786-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00753922-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00754107-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00754393-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00754682-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00754873-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00755220-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00755482-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00755742-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00755876-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00756091-a',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00756327-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00756459-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00756638-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00756728-a',[ ('Decreasing',not(subsumption))]).
adjMapping2SUMO('00756897-s',[ ('Decreasing',not(subsumption))]).
adjMapping2SUMO('00757001-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('00757120-s',[ ('Putting',not(subsumption))]).
adjMapping2SUMO('00757236-a',[ ('Molecule',subsumption)]).
adjMapping2SUMO('00757408-a',[ ('Molecule',subsumption)]).
adjMapping2SUMO('00757634-s',[ ('',undefined)]).
adjMapping2SUMO('00757783-s',[ ('Molecule',subsumption)]).
adjMapping2SUMO('00757923-a',[ ('SaturationAttribute',subsumption)]).
adjMapping2SUMO('00758150-s',[ ('SaturationAttribute',subsumption)]).
adjMapping2SUMO('00758290-a',[ ('SaturationAttribute',subsumption)]).
adjMapping2SUMO('00758459-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00758800-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00759169-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00759458-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00759551-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00759826-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00760149-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00760289-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00760473-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00760577-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00760783-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00760916-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00761260-s',[ ('Transportation',subsumption)]).
adjMapping2SUMO('00761449-s',[ ('Transportation',subsumption)]).
adjMapping2SUMO('00761592-s',[ ('Near',subsumption)]).
adjMapping2SUMO('00761734-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00761844-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00762168-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00762355-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('00762721-s',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('00763013-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00763272-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('00763407-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00763633-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('00763767-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('00763901-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00764301-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00764484-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00765173-s',[ ('Device',subsumption)]).
adjMapping2SUMO('00765289-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00765410-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00765537-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00765666-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00765862-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00766102-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00766348-s',[ ('',undefined)]).
adjMapping2SUMO('00766457-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00766957-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('00767133-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00767349-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00767626-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00768098-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00768397-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00768808-s',[ ('Communication',subsumption)]).
adjMapping2SUMO('00768927-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00769121-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00769239-a',[ ('QuantityChange',subsumption)]).
adjMapping2SUMO('00769489-a',[ ('Relation',subsumption)]).
adjMapping2SUMO('00769761-s',[ ('',undefined)]).
adjMapping2SUMO('00769926-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('00770114-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('00770316-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00770480-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00770756-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00770993-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00771203-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00771373-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00771616-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00771803-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00772137-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00772360-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00772492-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00772776-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00772910-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00773109-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00773299-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00773455-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00773579-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00773759-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00774006-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00774182-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00774323-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00774676-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00774911-s',[ (capability,subsumption)]).
adjMapping2SUMO('00775135-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00775301-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00775486-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00775611-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00775693-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00775900-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00776090-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00776192-s',[ ('',undefined)]).
adjMapping2SUMO('00776290-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00776406-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00776570-a',[ (capability,subsumption)]).
adjMapping2SUMO('00776706-s',[ ('Device',subsumption)]).
adjMapping2SUMO('00776822-a',[ ('Device',subsumption)]).
adjMapping2SUMO('00776922-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00777106-s',[ (holdsObligation,subsumption)]).
adjMapping2SUMO('00777238-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00777418-a',[ (holdsRight,subsumption)]).
adjMapping2SUMO('00777650-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00777891-s',[ ('CurrencyMeasure',subsumption)]).
adjMapping2SUMO('00778017-s',[ ('CurrencyMeasure',subsumption)]).
adjMapping2SUMO('00778161-a',[ (holdsRight,subsumption)]).
adjMapping2SUMO('00778270-s',[ ('CurrencyMeasure',subsumption)]).
adjMapping2SUMO('00778363-a',[ ('Near',subsumption)]).
adjMapping2SUMO('00778509-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00778680-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00778828-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00778958-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00779133-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00779240-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00779374-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00779819-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00780011-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00780352-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00780575-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00780712-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00780944-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00781061-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00781168-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00781539-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('00781644-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('00781974-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00782216-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00782568-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00782738-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00782856-a',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('00782957-a',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('00783129-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00783469-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00783675-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00783840-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00784037-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00784215-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00784411-s',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('00784533-a',[ (capability,subsumption)]).
adjMapping2SUMO('00784922-s',[ (capability,subsumption)]).
adjMapping2SUMO('00785002-s',[ (capability,subsumption)]).
adjMapping2SUMO('00785298-s',[ (capability,subsumption)]).
adjMapping2SUMO('00785406-s',[ ('DivisionFn',subsumption)]).
adjMapping2SUMO('00785555-s',[ (capability,subsumption)]).
adjMapping2SUMO('00785684-a',[ (capability,subsumption)]).
adjMapping2SUMO('00785889-s',[ (capability,subsumption)]).
adjMapping2SUMO('00786031-s',[ ('DivisionFn',subsumption)]).
adjMapping2SUMO('00786173-s',[ (capability,subsumption)]).
adjMapping2SUMO('00786291-a',[ ('Text',subsumption)]).
adjMapping2SUMO('00786485-s',[ (refers,subsumption)]).
adjMapping2SUMO('00786624-s',[ ('Certificate',subsumption)]).
adjMapping2SUMO('00786790-a',[ ('Certificate',subsumption)]).
adjMapping2SUMO('00787002-s',[ ('Certificate',subsumption)]).
adjMapping2SUMO('00787136-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00787357-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00787595-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00788032-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00788145-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00788268-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00788474-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00788821-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00789281-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00789392-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00789494-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00789871-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00789988-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00790086-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00790394-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00790540-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00790691-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00791044-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00791131-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00791227-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00791631-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00791944-s',[ (capability,subsumption)]).
adjMapping2SUMO('00792075-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('00792202-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('00792476-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00792641-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00792769-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00792991-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00793250-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00793426-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00793592-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00793682-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('00793793-a',[ ('AnatomicalStructure',subsumption)]).
adjMapping2SUMO('00793988-a',[ ('AnatomicalStructure',subsumption)]).
adjMapping2SUMO('00794146-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00794277-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00794426-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00794650-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00794825-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00795078-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00795246-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00795395-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('00795495-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00795671-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00795785-a',[ (capability,subsumption)]).
adjMapping2SUMO('00795959-a',[ (capability,subsumption)]).
adjMapping2SUMO('00796047-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00796337-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('00796591-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00796715-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00796928-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00797113-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00797218-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00797299-a',[ ('ConsciousnessAttribute',subsumption)]).
adjMapping2SUMO('00797706-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00798017-s',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('00798103-s',[ ('ConsciousnessAttribute',subsumption)]).
adjMapping2SUMO('00798384-s',[ ('ConsciousnessAttribute',subsumption)]).
adjMapping2SUMO('00798491-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00798879-s',[ ('Drugged',subsumption)]).
adjMapping2SUMO('00799129-s',[ ('ConsciousnessAttribute',subsumption)]).
adjMapping2SUMO('00799224-s',[ ('ConsciousnessAttribute',subsumption)]).
adjMapping2SUMO('00799401-s',[ ('ConsciousnessAttribute',subsumption)]).
adjMapping2SUMO('00799517-a',[ ('Awake',subsumption)]).
adjMapping2SUMO('00799716-s',[ ('Awake',subsumption)]).
adjMapping2SUMO('00799800-s',[ ('',undefined)]).
adjMapping2SUMO('00799953-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00800159-s',[ ('Awake',subsumption)]).
adjMapping2SUMO('00800248-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00800464-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00800597-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00800678-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00800755-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00800826-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00801328-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00801462-s',[ ('',undefined)]).
adjMapping2SUMO('00801539-s',[ ('',undefined)]).
adjMapping2SUMO('00801616-s',[ ('',undefined)]).
adjMapping2SUMO('00801691-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00801874-s',[ ('',undefined)]).
adjMapping2SUMO('00801947-s',[ ('',undefined)]).
adjMapping2SUMO('00802020-s',[ ('Poking',subsumption)]).
adjMapping2SUMO('00802179-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00802300-s',[ (capability,subsumption)]).
adjMapping2SUMO('00802397-s',[ ('',undefined)]).
adjMapping2SUMO('00802514-s',[ (capability,subsumption)]).
adjMapping2SUMO('00802767-s',[ ('',undefined)]).
adjMapping2SUMO('00802844-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('00802960-s',[ ('',undefined)]).
adjMapping2SUMO('00803038-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00803275-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00803432-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00803751-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00803846-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00803971-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00804106-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00804220-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00804371-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00804502-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00804695-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00805115-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00805309-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00805566-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00805676-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00805810-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00806064-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00806243-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00806387-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00806512-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00806991-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00807277-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00807399-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00807667-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00807817-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00808011-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00808191-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00808614-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00808822-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00808940-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00809164-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00809343-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00809622-s',[ ('Impelling',equivalence)]).
adjMapping2SUMO('00809790-s',[ (capability,subsumption)]).
adjMapping2SUMO('00810164-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00810355-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00810481-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00810636-s',[ ('BackFn',subsumption)]).
adjMapping2SUMO('00810764-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00810916-a',[ (desires,equivalence)]).
adjMapping2SUMO('00811248-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00811421-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00811536-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00811707-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00811820-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00811969-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00812170-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00812417-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00812521-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00812626-s',[ ('',undefined)]).
adjMapping2SUMO('00812710-s',[ ('',undefined)]).
adjMapping2SUMO('00812785-s',[ ('',undefined)]).
adjMapping2SUMO('00812860-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('00812952-a',[ (starts,equivalence)]).
adjMapping2SUMO('00813589-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00813915-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00814073-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00814251-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00814468-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00814611-s',[ (earlier,equivalence)]).
adjMapping2SUMO('00814902-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00815000-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00815227-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00815406-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00815586-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00815849-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00815941-a',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('00816160-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00816324-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00816481-a',[ (earlier,subsumption)]).
adjMapping2SUMO('00816839-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00817004-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00817176-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00817242-s',[ (earlier,subsumption)]).
adjMapping2SUMO('00817424-a',[ (earlier,subsumption)]).
adjMapping2SUMO('00817731-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00818008-s',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('00818175-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00818581-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00818829-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00819051-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('00819235-a',[ (earlier,subsumption)]).
adjMapping2SUMO('00819526-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00819709-s',[ ('',undefined)]).
adjMapping2SUMO('00819852-a',[ ('Language',subsumption)]).
adjMapping2SUMO('00820219-s',[ ('Language',subsumption)]).
adjMapping2SUMO('00820458-a',[ ('Language',subsumption)]).
adjMapping2SUMO('00820721-a',[ ('Language',subsumption)]).
adjMapping2SUMO('00820975-s',[ ('Language',subsumption)]).
adjMapping2SUMO('00821208-s',[ ('Language',subsumption)]).
adjMapping2SUMO('00821367-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00821603-s',[ ('Getting',subsumption)]).
adjMapping2SUMO('00821723-a',[ ('UnilateralGetting',subsumption)]).
adjMapping2SUMO('00821959-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00822115-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00822449-a',[ ('Anxiety',equivalence)]).
adjMapping2SUMO('00822907-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00823192-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00823350-a',[ ('East',equivalence)]).
adjMapping2SUMO('00823556-s',[ ('Cooperation',equivalence)]).
adjMapping2SUMO('00823665-s',[ ('East',subsumption)]).
adjMapping2SUMO('00823832-s',[ ('East',subsumption)]).
adjMapping2SUMO('00823971-s',[ ('East',subsumption)]).
adjMapping2SUMO('00824094-s',[ ('East',subsumption)]).
adjMapping2SUMO('00824183-s',[ ('East',subsumption)]).
adjMapping2SUMO('00824321-a',[ ('West',equivalence)]).
adjMapping2SUMO('00824509-s',[ ('West',subsumption)]).
adjMapping2SUMO('00824631-s',[ ('West',subsumption)]).
adjMapping2SUMO('00824753-s',[ ('West',subsumption)]).
adjMapping2SUMO('00824876-s',[ ('West',subsumption)]).
adjMapping2SUMO('00824965-s',[ ('West',subsumption)]).
adjMapping2SUMO('00825089-a',[ ('West',equivalence)]).
adjMapping2SUMO('00825375-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('00825604-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('00825807-s',[ ('Asia',subsumption)]).
adjMapping2SUMO('00825970-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('00826215-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('00826403-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('00826658-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('00826827-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('00826959-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('00827192-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('00827327-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('00827556-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('00827743-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('00827923-a',[ ('Human',subsumption)]).
adjMapping2SUMO('00828095-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00828175-a',[ ('Human',subsumption)]).
adjMapping2SUMO('00828336-a',[ ('Human',subsumption)]).
adjMapping2SUMO('00828661-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00828779-a',[ ('Food',equivalence)]).
adjMapping2SUMO('00829041-s',[ (capability,subsumption)]).
adjMapping2SUMO('00829146-s',[ ('Food',subsumption)]).
adjMapping2SUMO('00829243-s',[ ('',undefined)]).
adjMapping2SUMO('00829496-a',[ ('Food',not(subsumption))]).
adjMapping2SUMO('00829656-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('00829745-a',[ ('Learning',subsumption)]).
adjMapping2SUMO('00830051-s',[ ('Learning',subsumption)]).
adjMapping2SUMO('00830381-s',[ (capability,subsumption)]).
adjMapping2SUMO('00830508-s',[ ('Learning',subsumption)]).
adjMapping2SUMO('00830630-s',[ (capability,subsumption)]).
adjMapping2SUMO('00830717-a',[ ('Learning',not(subsumption))]).
adjMapping2SUMO('00830981-s',[ (knows,not(subsumption))]).
adjMapping2SUMO('00831225-s',[ ('Learning',not(subsumption))]).
adjMapping2SUMO('00831603-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00831696-s',[ ('Learning',not(subsumption))]).
adjMapping2SUMO('00831903-s',[ ('Learning',not(subsumption))]).
adjMapping2SUMO('00832075-a',[ (capability,subsumption)]).
adjMapping2SUMO('00832200-a',[ ('Learning',not(subsumption))]).
adjMapping2SUMO('00832347-a',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('00832609-s',[ (causes,subsumption)]).
adjMapping2SUMO('00832784-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00833018-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00833334-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00833575-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00833737-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00833878-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00834048-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00834198-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00834959-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00835122-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00835292-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00835504-s',[ ('',undefined)]).
adjMapping2SUMO('00835609-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00835978-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00836111-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00836277-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00836544-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00837084-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00837249-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00837415-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00837574-s',[ ('',undefined)]).
adjMapping2SUMO('00837756-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00837868-s',[ ('',undefined)]).
adjMapping2SUMO('00837977-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00838296-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00838533-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00838659-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00838856-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00839225-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00839411-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00839619-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00839959-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00840103-s',[ ('',undefined)]).
adjMapping2SUMO('00840212-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00840510-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00840634-s',[ ('Substance',subsumption)]).
adjMapping2SUMO('00840737-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00840902-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00841159-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00841403-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00841800-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00841934-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00842041-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00842199-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00842324-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00842550-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00842704-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00842810-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00842914-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00843046-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00843146-a',[ ('Pliable',subsumption)]).
adjMapping2SUMO('00843595-s',[ ('Pliable',subsumption)]).
adjMapping2SUMO('00843988-s',[ ('Food',subsumption)]).
adjMapping2SUMO('00844112-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('00844263-s',[ (capability,subsumption)]).
adjMapping2SUMO('00844461-s',[ ('Pliable',subsumption)]).
adjMapping2SUMO('00844719-s',[ ('Pliable',subsumption)]).
adjMapping2SUMO('00844869-s',[ ('Pliable',subsumption)]).
adjMapping2SUMO('00845025-s',[ ('Pliable',subsumption)]).
adjMapping2SUMO('00845127-s',[ ('Pliable',subsumption)]).
adjMapping2SUMO('00845216-s',[ ('Pliable',subsumption)]).
adjMapping2SUMO('00845406-s',[ ('Pliable',subsumption)]).
adjMapping2SUMO('00845528-a',[ ('Rigid',subsumption)]).
adjMapping2SUMO('00845737-s',[ ('Rigid',subsumption)]).
adjMapping2SUMO('00845856-s',[ ('Rigid',subsumption)]).
adjMapping2SUMO('00845928-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00846052-a',[ ('Selecting',subsumption)]).
adjMapping2SUMO('00846219-s',[ ('PoliticalOrganization',subsumption)]).
adjMapping2SUMO('00846349-s',[ ('Selecting',subsumption)]).
adjMapping2SUMO('00846462-a',[ ('OrganizationalProcess',subsumption)]).
adjMapping2SUMO('00846625-s',[ ('OrganizationalProcess',subsumption)]).
adjMapping2SUMO('00846789-s',[ ('OrganizationalProcess',subsumption)]).
adjMapping2SUMO('00846944-a',[ ('OrganizationalProcess',subsumption)]).
adjMapping2SUMO('00847103-s',[ ('OrganizationalProcess',subsumption)]).
adjMapping2SUMO('00847196-s',[ ('OrganizationalProcess',subsumption)]).
adjMapping2SUMO('00847306-a',[ ('OrganizationalProcess',not(subsumption))]).
adjMapping2SUMO('00847399-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00847577-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00847715-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00847861-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00847972-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00848074-a',[ ('Obligation',equivalence)]).
adjMapping2SUMO('00848375-s',[ ('Obligation',subsumption)]).
adjMapping2SUMO('00848466-s',[ ('Obligation',subsumption)]).
adjMapping2SUMO('00848679-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00848838-s',[ ('Obligation',subsumption)]).
adjMapping2SUMO('00848983-s',[ ('Obligation',subsumption)]).
adjMapping2SUMO('00849108-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00849232-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00849357-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00849912-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('00850053-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00850183-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00850434-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00850552-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00850648-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00850875-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00850983-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00851103-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00851329-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00851588-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00851744-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00852101-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00852197-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00852425-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('00852576-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00852754-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('00852875-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('00852988-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00853225-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00853324-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('00853473-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00853631-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('00853776-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00854255-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00854413-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00854869-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00854989-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00855158-s',[ ('FunkMusic',equivalence)]).
adjMapping2SUMO('00855309-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00855565-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00855670-s',[ ('',undefined)]).
adjMapping2SUMO('00856011-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00856132-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00856325-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('00856511-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00856651-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00856790-s',[ ('MakingMusic',subsumption)]).
adjMapping2SUMO('00856860-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00857206-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00857387-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00857560-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00858053-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00858340-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00858558-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00858780-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00858917-a',[ (increasesLikelihood,subsumption)]).
adjMapping2SUMO('00859350-s',[ (increasesLikelihood,subsumption)]).
adjMapping2SUMO('00859453-s',[ (capability,subsumption)]).
adjMapping2SUMO('00859632-s',[ ('Perception',subsumption)]).
adjMapping2SUMO('00859949-s',[ ('Experimenting',subsumption)]).
adjMapping2SUMO('00860127-s',[ ('Investigating',subsumption)]).
adjMapping2SUMO('00860254-s',[ ('Investigating',subsumption)]).
adjMapping2SUMO('00860365-s',[ ('Investigating',subsumption)]).
adjMapping2SUMO('00860611-a',[ ('FieldOfStudy',subsumption)]).
adjMapping2SUMO('00860932-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00861109-s',[ (increasesLikelihood,subsumption)]).
adjMapping2SUMO('00861216-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00861818-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00862067-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00862190-s',[ (increasesLikelihood,subsumption)]).
adjMapping2SUMO('00862327-a',[ ('FieldOfStudy',subsumption)]).
adjMapping2SUMO('00862526-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00862718-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00862911-s',[ ('FieldOfStudy',subsumption)]).
adjMapping2SUMO('00863049-a',[ ('FieldOfStudy',subsumption)]).
adjMapping2SUMO('00863361-s',[ ('Text',subsumption)]).
adjMapping2SUMO('00863555-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00863717-a',[ ('Position',subsumption)]).
adjMapping2SUMO('00863823-a',[ (employs,subsumption)]).
adjMapping2SUMO('00863946-a',[ (employs,subsumption)]).
adjMapping2SUMO('00864203-s',[ (employs,subsumption)]).
adjMapping2SUMO('00864346-s',[ ('Hiring',equivalence)]).
adjMapping2SUMO('00864461-s',[ (employs,subsumption)]).
adjMapping2SUMO('00864693-a',[ ('Unemployed',equivalence)]).
adjMapping2SUMO('00864884-s',[ ('TerminatingEmployment',equivalence)]).
adjMapping2SUMO('00865007-s',[ ('Unemployed',subsumption)]).
adjMapping2SUMO('00865201-a',[ (capability,subsumption)]).
adjMapping2SUMO('00865331-a',[ (capability,subsumption)]).
adjMapping2SUMO('00865471-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00865620-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00865765-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00865848-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00866047-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00866182-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00866392-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00866471-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00866735-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00866894-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00866987-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00867092-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00867213-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00867520-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00867615-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00867758-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00867841-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00867916-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00868241-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00868448-s',[ (partiallyFills,subsumption)]).
adjMapping2SUMO('00868603-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00868815-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00868988-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00869138-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00869253-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00869461-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00869690-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00869972-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00870127-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00870303-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00870481-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00870614-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('00870827-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('00871051-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('00871255-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00871494-a',[ ('',undefined)]).
adjMapping2SUMO('00871690-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00871816-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00872010-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00872195-a',[ ('ChemicalProcess',subsumption)]).
adjMapping2SUMO('00872347-a',[ ('ChemicalProcess',subsumption)]).
adjMapping2SUMO('00872510-a',[ ('ChemicalProcess',subsumption)]).
adjMapping2SUMO('00872715-s',[ ('',undefined)]).
adjMapping2SUMO('00872906-a',[ ('ChemicalProcess',subsumption)]).
adjMapping2SUMO('00873113-a',[ (origin,subsumption)]).
adjMapping2SUMO('00873251-a',[ (origin,subsumption)]).
adjMapping2SUMO('00873387-a',[ ('Text',subsumption)]).
adjMapping2SUMO('00873502-a',[ ('Text',subsumption)]).
adjMapping2SUMO('00873603-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00874092-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00874226-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00874547-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00874634-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00874781-s',[ ('',undefined)]).
adjMapping2SUMO('00874920-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00875235-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00875422-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00875712-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00875962-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00876204-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00876465-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00876609-a',[ (holdsRight,subsumption)]).
adjMapping2SUMO('00876735-a',[ (holdsRight,subsumption)]).
adjMapping2SUMO('00876989-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00877119-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00877263-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00877345-a',[ ('Investigating',subsumption)]).
adjMapping2SUMO('00877816-s',[ ('',undefined)]).
adjMapping2SUMO('00877938-s',[ ('',undefined)]).
adjMapping2SUMO('00878086-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00878362-s',[ ('Investigating',subsumption)]).
adjMapping2SUMO('00878438-s',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('00878704-a',[ ('Investigating',not(subsumption))]).
adjMapping2SUMO('00878829-a',[ ('Investigating',subsumption)]).
adjMapping2SUMO('00879030-s',[ ('Investigating',subsumption)]).
adjMapping2SUMO('00879259-s',[ ('Investigating',subsumption)]).
adjMapping2SUMO('00879468-s',[ ('Investigating',subsumption)]).
adjMapping2SUMO('00879624-s',[ ('Investigating',subsumption)]).
adjMapping2SUMO('00879918-s',[ ('Investigating',subsumption)]).
adjMapping2SUMO('00880120-a',[ ('Investigating',not(subsumption))]).
adjMapping2SUMO('00880207-a',[ ('Increasing',equivalence)]).
adjMapping2SUMO('00880447-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('00880586-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('00880765-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('00881030-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00881177-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00881337-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('00881432-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('00881551-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('00881735-a',[ ('Decreasing',equivalence)]).
adjMapping2SUMO('00882018-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00882166-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00882312-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00882462-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00882580-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00882742-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00882890-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00883075-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00883188-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00883345-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('00883611-a',[ (capability,subsumption)]).
adjMapping2SUMO('00883830-a',[ (capability,subsumption)]).
adjMapping2SUMO('00884007-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00884157-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00884286-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00884501-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00884778-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00885099-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00885288-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00885415-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00885594-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00885695-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00886117-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00886253-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00886448-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00886681-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00886804-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00886895-s',[ ('',undefined)]).
adjMapping2SUMO('00886980-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00887062-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00887317-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00887472-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00887719-a',[ (wants,equivalence)]).
adjMapping2SUMO('00888051-s',[ (wants,subsumption)]).
adjMapping2SUMO('00888200-s',[ (wants,subsumption)]).
adjMapping2SUMO('00888477-s',[ (wants,subsumption)]).
adjMapping2SUMO('00888765-s',[ (wants,subsumption)]).
adjMapping2SUMO('00889098-s',[ ('Unhappiness',subsumption)]).
adjMapping2SUMO('00889239-s',[ ('Unhappiness',subsumption)]).
adjMapping2SUMO('00889334-a',[ (wants,subsumption)]).
adjMapping2SUMO('00889490-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00889672-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('00889831-a',[ (equal,equivalence)]).
adjMapping2SUMO('00890351-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00890622-s',[ (equal,subsumption)]).
adjMapping2SUMO('00890781-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00890874-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00890985-s',[ (equal,subsumption)]).
adjMapping2SUMO('00891081-s',[ (equal,subsumption)]).
adjMapping2SUMO('00891170-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00891468-s',[ ('',undefined)]).
adjMapping2SUMO('00891569-s',[ ('',undefined)]).
adjMapping2SUMO('00891705-s',[ ('',undefined)]).
adjMapping2SUMO('00891807-s',[ (equal,subsumption)]).
adjMapping2SUMO('00891970-s',[ ('Process',subsumption)]).
adjMapping2SUMO('00892104-s',[ (equal,subsumption)]).
adjMapping2SUMO('00892243-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('00892379-a',[ (equal,subsumption)]).
adjMapping2SUMO('00892635-s',[ (equal,subsumption)]).
adjMapping2SUMO('00892773-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('00892976-s',[ (equal,subsumption)]).
adjMapping2SUMO('00893118-s',[ (increasesLikelihood,subsumption)]).
adjMapping2SUMO('00893239-s',[ (equal,subsumption)]).
adjMapping2SUMO('00893347-s',[ (causes,subsumption)]).
adjMapping2SUMO('00893441-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00893878-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00894029-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00894272-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00894435-s',[ ('',undefined)]).
adjMapping2SUMO('00894551-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00894627-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00894757-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00894879-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00894980-a',[ ('Solution',subsumption)]).
adjMapping2SUMO('00895126-a',[ ('Solution',subsumption)]).
adjMapping2SUMO('00895276-a',[ ('Solution',subsumption)]).
adjMapping2SUMO('00895442-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00896026-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('00896182-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00896378-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00896555-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00897015-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00897223-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00897363-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00897517-a',[ (capability,subsumption)]).
adjMapping2SUMO('00897681-s',[ (capability,subsumption)]).
adjMapping2SUMO('00897759-s',[ (capability,subsumption)]).
adjMapping2SUMO('00898013-s',[ (capability,subsumption)]).
adjMapping2SUMO('00898132-s',[ (capability,subsumption)]).
adjMapping2SUMO('00898289-a',[ (capability,subsumption)]).
adjMapping2SUMO('00898488-s',[ (capability,subsumption)]).
adjMapping2SUMO('00898628-s',[ (capability,subsumption)]).
adjMapping2SUMO('00898814-s',[ (capability,subsumption)]).
adjMapping2SUMO('00898963-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00899226-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00899612-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00899738-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00900071-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00900478-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00900616-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00901060-s',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('00901161-s',[ (needs,subsumption)]).
adjMapping2SUMO('00901345-s',[ (part,subsumption)]).
adjMapping2SUMO('00901547-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00901650-s',[ ('',undefined)]).
adjMapping2SUMO('00901826-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00901969-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00902157-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00902347-s',[ (needs,subsumption)]).
adjMapping2SUMO('00902652-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00902946-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00903117-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('00903264-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00903449-a',[ (needs,subsumption)]).
adjMapping2SUMO('00903668-a',[ (needs,subsumption)]).
adjMapping2SUMO('00903894-s',[ (needs,subsumption)]).
adjMapping2SUMO('00904163-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00904290-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00904548-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00904745-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00905039-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00905181-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00905386-a',[ ('DeonticAttribute',subsumption)]).
adjMapping2SUMO('00905728-a',[ ('DeonticAttribute',subsumption)]).
adjMapping2SUMO('00905905-a',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00906099-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00906312-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00906455-a',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00906655-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00907032-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00907243-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00907400-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00907661-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00907830-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00907972-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00908143-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00908315-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00908483-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00908672-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00908929-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00909118-s',[ (capability,subsumption)]).
adjMapping2SUMO('00909220-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('00909363-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00909545-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00910101-s',[ ('LevelShape',subsumption)]).
adjMapping2SUMO('00910404-s',[ ('',undefined)]).
adjMapping2SUMO('00910542-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00910750-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00910885-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00910983-s',[ ('',undefined)]).
adjMapping2SUMO('00911091-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00911204-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00911327-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00911762-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00911935-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00912094-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00912288-s',[ ('LevelShape',subsumption)]).
adjMapping2SUMO('00912490-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00912637-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('00912814-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00912980-s',[ ('',undefined)]).
adjMapping2SUMO('00913131-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00913306-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00913387-a',[ ('EvenInteger',equivalence)]).
adjMapping2SUMO('00913454-a',[ ('OddInteger',equivalence)]).
adjMapping2SUMO('00913551-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00913720-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00913889-s',[ ('',undefined)]).
adjMapping2SUMO('00914104-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00914269-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('00914421-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00914808-s',[ (equal,subsumption)]).
adjMapping2SUMO('00914983-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00915141-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00915321-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00915420-s',[ ('Icon',subsumption)]).
adjMapping2SUMO('00915556-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00915787-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00915976-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00916199-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00916383-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00916524-s',[ ('RoundFn',equivalence)]).
adjMapping2SUMO('00916706-a',[ (capability,subsumption)]).
adjMapping2SUMO('00916965-s',[ (capability,subsumption)]).
adjMapping2SUMO('00917207-a',[ (capability,subsumption)]).
adjMapping2SUMO('00917482-s',[ (capability,subsumption)]).
adjMapping2SUMO('00917613-a',[ (capability,subsumption)]).
adjMapping2SUMO('00917768-s',[ (capability,subsumption)]).
adjMapping2SUMO('00917956-s',[ (capability,subsumption)]).
adjMapping2SUMO('00918200-s',[ ('',undefined)]).
adjMapping2SUMO('00918354-s',[ ('',undefined)]).
adjMapping2SUMO('00918491-a',[ (capability,subsumption)]).
adjMapping2SUMO('00918616-s',[ (capability,subsumption)]).
adjMapping2SUMO('00918779-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00918939-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00919018-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00919155-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00919321-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00919445-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('00919542-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00919813-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00919919-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00919984-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00920167-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00920260-s',[ ('ConsciousnessAttribute',subsumption)]).
adjMapping2SUMO('00920422-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00920494-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00920603-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00920704-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00920797-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00920881-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00921014-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00921369-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00921538-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00921631-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('00921866-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00922051-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00922228-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00922344-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00922439-s',[ ('Touching',subsumption)]).
adjMapping2SUMO('00922594-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00922840-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00923066-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00923232-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00923321-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00923495-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00923671-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00923790-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00923993-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00924257-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00924635-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00924791-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00924952-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00925177-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00925287-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00925460-a',[ (capability,subsumption)]).
adjMapping2SUMO('00925560-s',[ (capability,subsumption)]).
adjMapping2SUMO('00925642-a',[ (capability,subsumption)]).
adjMapping2SUMO('00925820-s',[ (capability,subsumption)]).
adjMapping2SUMO('00925985-s',[ (capability,subsumption)]).
adjMapping2SUMO('00926141-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('00926348-a',[ ('Removing',not(subsumption))]).
adjMapping2SUMO('00926505-s',[ ('Removing',not(subsumption))]).
adjMapping2SUMO('00926802-s',[ ('Eating',not(subsumption))]).
adjMapping2SUMO('00926871-s',[ ('FinancialTransaction',not(subsumption))]).
adjMapping2SUMO('00927017-a',[ (exists,subsumption)]).
adjMapping2SUMO('00927373-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00927578-a',[ (not,subsumption)]).
adjMapping2SUMO('00927832-s',[ (located,subsumption)]).
adjMapping2SUMO('00927978-s',[ (not,subsumption)]).
adjMapping2SUMO('00928238-s',[ (not,subsumption)]).
adjMapping2SUMO('00928414-s',[ ('Disappearing',subsumption)]).
adjMapping2SUMO('00928525-a',[ (exists,subsumption)]).
adjMapping2SUMO('00928781-s',[ (exists,subsumption)]).
adjMapping2SUMO('00928874-s',[ (exists,subsumption)]).
adjMapping2SUMO('00929164-a',[ (not,subsumption)]).
adjMapping2SUMO('00929443-s',[ (not,subsumption)]).
adjMapping2SUMO('00929567-a',[ ('Likely',subsumption)]).
adjMapping2SUMO('00929815-s',[ ('Likely',subsumption)]).
adjMapping2SUMO('00929916-s',[ ('Likely',subsumption)]).
adjMapping2SUMO('00930022-s',[ ('Likely',subsumption)]).
adjMapping2SUMO('00930170-s',[ ('Likely',subsumption)]).
adjMapping2SUMO('00930290-a',[ ('Unlikely',subsumption)]).
adjMapping2SUMO('00930540-s',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('00930765-s',[ ('Unlikely',subsumption)]).
adjMapping2SUMO('00931070-s',[ ('Unlikely',subsumption)]).
adjMapping2SUMO('00931306-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00931395-s',[ ('Unlikely',subsumption)]).
adjMapping2SUMO('00931555-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00931833-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00931974-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00932184-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00932367-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00932565-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00932695-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00932829-s',[ (capability,subsumption)]).
adjMapping2SUMO('00932918-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00933032-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00933154-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00933415-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00933599-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00933941-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00934082-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00934199-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00934554-s',[ (lessThan,subsumption)]).
adjMapping2SUMO('00934738-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00934874-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00934966-s',[ ('',undefined)]).
adjMapping2SUMO('00935103-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00935259-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00935359-s',[ ('CurrencyMeasure',subsumption)]).
adjMapping2SUMO('00935500-a',[ (hasSkill,subsumption)]).
adjMapping2SUMO('00935792-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00936038-s',[ (knows,subsumption)]).
adjMapping2SUMO('00936297-s',[ (hasSkill,subsumption)]).
adjMapping2SUMO('00936427-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00936523-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00936740-a',[ (hasSkill,subsumption)]).
adjMapping2SUMO('00936998-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00937186-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00937341-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00937616-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00937732-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00937985-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00938210-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00938305-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00938441-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00938659-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00938801-a',[ (capability,subsumption)]).
adjMapping2SUMO('00938979-s',[ (capability,subsumption)]).
adjMapping2SUMO('00939105-a',[ (capability,subsumption)]).
adjMapping2SUMO('00939444-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00939895-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00940108-s',[ (capability,subsumption)]).
adjMapping2SUMO('00940314-s',[ ('Stating',not(subsumption))]).
adjMapping2SUMO('00940437-a',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('00940870-s',[ ('Stating',subsumption)]).
adjMapping2SUMO('00940969-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00941148-s',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('00941242-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00941375-s',[ ('',undefined)]).
adjMapping2SUMO('00941485-a',[ ('LinguisticCommunication',not(subsumption))]).
adjMapping2SUMO('00941940-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00942163-s',[ ('LinguisticCommunication',not(subsumption))]).
adjMapping2SUMO('00942380-s',[ ('LinguisticCommunication',not(subsumption))]).
adjMapping2SUMO('00942693-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00942806-s',[ (uses,equivalence)]).
adjMapping2SUMO('00942871-a',[ (uses,subsumption)]).
adjMapping2SUMO('00943092-s',[ (uses,subsumption)]).
adjMapping2SUMO('00943203-s',[ (uses,subsumption)]).
adjMapping2SUMO('00943363-a',[ (capability,subsumption)]).
adjMapping2SUMO('00943599-s',[ (capability,subsumption)]).
adjMapping2SUMO('00943683-s',[ (capability,subsumption)]).
adjMapping2SUMO('00943831-s',[ (capability,subsumption)]).
adjMapping2SUMO('00943999-a',[ (capability,subsumption)]).
adjMapping2SUMO('00944111-s',[ (capability,subsumption)]).
adjMapping2SUMO('00944449-a',[ (capability,subsumption)]).
adjMapping2SUMO('00944734-s',[ (capability,subsumption)]).
adjMapping2SUMO('00944848-s',[ (capability,subsumption)]).
adjMapping2SUMO('00945019-a',[ (capability,subsumption)]).
adjMapping2SUMO('00945123-a',[ (capability,subsumption)]).
adjMapping2SUMO('00945207-a',[ (capability,subsumption)]).
adjMapping2SUMO('00945399-s',[ (capability,subsumption)]).
adjMapping2SUMO('00945513-a',[ ('StringInstrument',subsumption)]).
adjMapping2SUMO('00945658-s',[ ('',undefined)]).
adjMapping2SUMO('00945772-a',[ ('StringInstrument',subsumption)]).
adjMapping2SUMO('00945927-s',[ ('StringInstrument',subsumption)]).
adjMapping2SUMO('00946050-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00946281-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00946409-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('00946499-a',[ (capability,subsumption)]).
adjMapping2SUMO('00946844-s',[ (capability,subsumption)]).
adjMapping2SUMO('00947012-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00947264-s',[ (capability,subsumption)]).
adjMapping2SUMO('00947520-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('00947680-a',[ (capability,subsumption)]).
adjMapping2SUMO('00947789-a',[ (capability,subsumption)]).
adjMapping2SUMO('00947945-a',[ (capability,subsumption)]).
adjMapping2SUMO('00948103-a',[ (located,subsumption)]).
adjMapping2SUMO('00948384-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00948514-s',[ (located,subsumption)]).
adjMapping2SUMO('00948670-a',[ (contains,equivalence)]).
adjMapping2SUMO('00948985-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00949115-s',[ (located,subsumption)]).
adjMapping2SUMO('00949229-s',[ ('Contest',subsumption)]).
adjMapping2SUMO('00949374-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00949548-a',[ (located,subsumption)]).
adjMapping2SUMO('00949797-s',[ (located,subsumption)]).
adjMapping2SUMO('00949883-s',[ (located,subsumption)]).
adjMapping2SUMO('00950002-s',[ (located,subsumption)]).
adjMapping2SUMO('00950119-s',[ (located,subsumption)]).
adjMapping2SUMO('00950272-a',[ (located,subsumption)]).
adjMapping2SUMO('00950465-s',[ (located,subsumption)]).
adjMapping2SUMO('00950592-s',[ (located,subsumption)]).
adjMapping2SUMO('00950706-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00951003-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00951163-s',[ (located,subsumption)]).
adjMapping2SUMO('00951247-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00951528-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00951709-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00951831-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00952181-s',[ ('Expressing',not(subsumption))]).
adjMapping2SUMO('00952307-s',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('00952395-a',[ (located,subsumption)]).
adjMapping2SUMO('00952653-s',[ (superficialPart,subsumption)]).
adjMapping2SUMO('00952761-s',[ (superficialPart,subsumption)]).
adjMapping2SUMO('00952867-a',[ (located,subsumption)]).
adjMapping2SUMO('00953127-s',[ (located,subsumption)]).
adjMapping2SUMO('00953213-s',[ (located,subsumption)]).
adjMapping2SUMO('00953332-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00953731-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00953814-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00953886-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00954064-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00954153-s',[ ('',undefined)]).
adjMapping2SUMO('00954233-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00954390-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00954503-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00954576-s',[ ('',undefined)]).
adjMapping2SUMO('00954678-s',[ ('',undefined)]).
adjMapping2SUMO('00954760-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00954864-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00954965-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00955115-a',[ (capability,subsumption)]).
adjMapping2SUMO('00955405-a',[ (capability,not(subsumption))]).
adjMapping2SUMO('00955626-a',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('00955802-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('00955915-a',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('00956049-s',[ ('Foul',subsumption)]).
adjMapping2SUMO('00956131-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00956568-s',[ ('Law',subsumption)]).
adjMapping2SUMO('00956733-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00956976-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00957099-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00957176-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00957551-s',[ ('',undefined)]).
adjMapping2SUMO('00957743-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00958020-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00958151-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00958475-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('00958615-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00958712-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00958880-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00959244-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00959530-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00959731-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00959979-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00960094-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00960481-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00960629-a',[ ('',undefined)]).
adjMapping2SUMO('00960856-s',[ ('',undefined)]).
adjMapping2SUMO('00960971-a',[ ('',undefined)]).
adjMapping2SUMO('00961195-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('00961392-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00961667-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00961908-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00962025-s',[ ('',undefined)]).
adjMapping2SUMO('00962135-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00962306-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00962476-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00962634-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00962939-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00963283-s',[ ('PoliticalProcess',subsumption)]).
adjMapping2SUMO('00963502-s',[ ('PoliticalProcess',subsumption)]).
adjMapping2SUMO('00963671-s',[ ('PoliticalProcess',subsumption)]).
adjMapping2SUMO('00963858-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('00964090-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00964303-s',[ ('',undefined)]).
adjMapping2SUMO('00964470-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00964590-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00964768-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00964906-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00965176-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00965359-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00965606-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00965894-s',[ (knows,subsumption)]).
adjMapping2SUMO('00966037-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00966167-s',[ (knows,subsumption)]).
adjMapping2SUMO('00966357-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00966477-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00966753-s',[ (knows,subsumption)]).
adjMapping2SUMO('00966960-s',[ (knows,subsumption)]).
adjMapping2SUMO('00967129-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00967646-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00967897-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00968010-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00968522-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00968730-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00968957-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00969103-s',[ ('Text',subsumption)]).
adjMapping2SUMO('00969264-s',[ ('',undefined)]).
adjMapping2SUMO('00969333-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00969556-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00969763-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00970081-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00970249-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00970610-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00970803-s',[ ('',undefined)]).
adjMapping2SUMO('00970947-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00971075-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00971506-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00971660-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00971933-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00972236-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00972354-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00972501-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00972642-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00972902-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00973192-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00973434-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00973568-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00973677-s',[ ('TrendyAttribute',equivalence)]).
adjMapping2SUMO('00973844-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00974159-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00974404-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00974519-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00974697-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00974908-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00975011-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00975171-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00975487-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00975692-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00975778-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00976016-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00976123-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00976339-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00976508-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00977105-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('00977238-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00977372-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00977606-s',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('00977699-s',[ ('',undefined)]).
adjMapping2SUMO('00977839-s',[ ('',undefined)]).
adjMapping2SUMO('00978059-s',[ ('',undefined)]).
adjMapping2SUMO('00978199-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00978429-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00978581-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00978754-s',[ ('Quick',subsumption)]).
adjMapping2SUMO('00979031-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00979234-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00979366-s',[ ('Quick',equivalence)]).
adjMapping2SUMO('00979697-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00979862-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00980144-s',[ ('Quick',subsumption)]).
adjMapping2SUMO('00980287-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00980385-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00980527-a',[ ('Slow',equivalence)]).
adjMapping2SUMO('00980961-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00981067-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00981195-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('00981304-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00981455-s',[ ('Device',subsumption)]).
adjMapping2SUMO('00981612-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00981703-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('00981818-a',[ ('Quick',equivalence)]).
adjMapping2SUMO('00982065-s',[ ('Music',subsumption)]).
adjMapping2SUMO('00982170-s',[ ('Music',subsumption)]).
adjMapping2SUMO('00982275-s',[ ('Music',subsumption)]).
adjMapping2SUMO('00982357-s',[ ('Music',subsumption)]).
adjMapping2SUMO('00982430-s',[ ('Music',subsumption)]).
adjMapping2SUMO('00982518-s',[ ('Music',subsumption)]).
adjMapping2SUMO('00982602-a',[ ('Music',subsumption)]).
adjMapping2SUMO('00982881-s',[ ('Music',subsumption)]).
adjMapping2SUMO('00982954-s',[ ('Music',subsumption)]).
adjMapping2SUMO('00983052-s',[ ('Music',subsumption)]).
adjMapping2SUMO('00983119-s',[ ('Music',subsumption)]).
adjMapping2SUMO('00983196-s',[ ('Music',subsumption)]).
adjMapping2SUMO('00983304-s',[ ('Music',subsumption)]).
adjMapping2SUMO('00983401-s',[ ('Music',subsumption)]).
adjMapping2SUMO('00983499-s',[ ('Music',subsumption)]).
adjMapping2SUMO('00983573-a',[ ('Device',subsumption)]).
adjMapping2SUMO('00983722-a',[ ('Device',subsumption)]).
adjMapping2SUMO('00983862-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00984251-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00984333-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00984624-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00984879-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00985104-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00985297-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00985387-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00985608-a',[ ('Microorganism',subsumption)]).
adjMapping2SUMO('00985909-a',[ ('Microorganism',subsumption)]).
adjMapping2SUMO('00986027-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00986457-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00986611-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00986766-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00986975-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00987180-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00987349-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00987510-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00987703-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00987769-s',[ ('Human',subsumption)]).
adjMapping2SUMO('00987974-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00988077-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00988232-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00988797-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('00988988-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00989416-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00989544-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00989647-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00989721-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00989830-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00989957-s',[ ('',undefined)]).
adjMapping2SUMO('00990053-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00990192-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00990442-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00990855-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00991189-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00991301-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('00991481-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00991584-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00991678-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00991838-a',[ ('FatTissue',equivalence)]).
adjMapping2SUMO('00992133-s',[ ('FatTissue',subsumption)]).
adjMapping2SUMO('00992291-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00992432-s',[ ('FatTissue',subsumption)]).
adjMapping2SUMO('00992716-s',[ ('FatTissue',subsumption)]).
adjMapping2SUMO('00992826-s',[ ('Mixture',subsumption)]).
adjMapping2SUMO('00992955-a',[ ('Food',subsumption)]).
adjMapping2SUMO('00993117-s',[ ('Food',subsumption)]).
adjMapping2SUMO('00993316-s',[ ('Food',subsumption)]).
adjMapping2SUMO('00993529-a',[ (causes,subsumption)]).
adjMapping2SUMO('00993667-s',[ (causes,subsumption)]).
adjMapping2SUMO('00993885-s',[ (causes,subsumption)]).
adjMapping2SUMO('00994073-s',[ (causes,subsumption)]).
adjMapping2SUMO('00994210-a',[ (causes,subsumption)]).
adjMapping2SUMO('00994326-s',[ (causes,subsumption)]).
adjMapping2SUMO('00994410-a',[ (capability,subsumption)]).
adjMapping2SUMO('00994567-a',[ (capability,subsumption)]).
adjMapping2SUMO('00994744-a',[ (capability,subsumption)]).
adjMapping2SUMO('00994882-a',[ (capability,subsumption)]).
adjMapping2SUMO('00995027-s',[ (capability,subsumption)]).
adjMapping2SUMO('00995119-a',[ (orientation,subsumption)]).
adjMapping2SUMO('00995365-s',[ (orientation,subsumption)]).
adjMapping2SUMO('00995468-a',[ (orientation,subsumption)]).
adjMapping2SUMO('00995647-s',[ (orientation,subsumption)]).
adjMapping2SUMO('00995775-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('00996089-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00996343-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('00996448-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('00996864-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00997036-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('00997298-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('00997394-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('00997604-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00997914-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00998040-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00998207-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00998381-s',[ ('Device',subsumption)]).
adjMapping2SUMO('00998479-s',[ ('Device',subsumption)]).
adjMapping2SUMO('00998598-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00998674-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00998850-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00998985-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('00999136-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('00999242-s',[ ('',undefined)]).
adjMapping2SUMO('00999330-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('00999519-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('00999671-s',[ ('Device',subsumption)]).
adjMapping2SUMO('00999817-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01000093-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('01000442-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01000592-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01000737-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('01000881-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01001180-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01001547-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01001689-a',[ (capability,subsumption)]).
adjMapping2SUMO('01001945-s',[ (capability,subsumption)]).
adjMapping2SUMO('01002055-s',[ (capability,subsumption)]).
adjMapping2SUMO('01002170-s',[ (capability,subsumption)]).
adjMapping2SUMO('01002256-s',[ (capability,subsumption)]).
adjMapping2SUMO('01002377-a',[ (capability,subsumption)]).
adjMapping2SUMO('01002664-s',[ (capability,subsumption)]).
adjMapping2SUMO('01002827-s',[ (causes,subsumption)]).
adjMapping2SUMO('01002911-s',[ ('SexualReproduction',not(subsumption))]).
adjMapping2SUMO('01003050-a',[ (finishes,subsumption)]).
adjMapping2SUMO('01003277-s',[ (finishes,subsumption)]).
adjMapping2SUMO('01003536-s',[ (finishes,subsumption)]).
adjMapping2SUMO('01003822-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01004051-s',[ ('',undefined)]).
adjMapping2SUMO('01004245-s',[ (finishes,subsumption)]).
adjMapping2SUMO('01004318-a',[ (finishes,subsumption)]).
adjMapping2SUMO('01004541-s',[ (finishes,subsumption)]).
adjMapping2SUMO('01004703-s',[ (finishes,subsumption)]).
adjMapping2SUMO('01004818-s',[ (not,subsumption)]).
adjMapping2SUMO('01004932-s',[ (not,subsumption)]).
adjMapping2SUMO('01005063-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('01005306-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('01005410-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('01005506-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01005675-a',[ (finishes,subsumption)]).
adjMapping2SUMO('01005914-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('01006016-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('01006136-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('01006284-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('01006386-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('01006566-a',[ ('FiniteQuantity',equivalence)]).
adjMapping2SUMO('01006788-s',[ (meetsSpatially,subsumption)]).
adjMapping2SUMO('01006967-s',[ (capability,subsumption)]).
adjMapping2SUMO('01007120-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01007258-s',[ ('ConstantQuantity',subsumption)]).
adjMapping2SUMO('01007354-a',[ ('Quantity',subsumption)]).
adjMapping2SUMO('01007657-s',[ ('Quantity',subsumption)]).
adjMapping2SUMO('01007947-s',[ (time,subsumption)]).
adjMapping2SUMO('01008174-s',[ ('Quantity',subsumption)]).
adjMapping2SUMO('01008289-s',[ (capability,subsumption)]).
adjMapping2SUMO('01008439-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('01008656-s',[ ('Word',subsumption)]).
adjMapping2SUMO('01008745-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('01008947-a',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('01009206-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('01009343-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('01009709-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01009865-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01010025-a',[ (finishes,subsumption)]).
adjMapping2SUMO('01010271-s',[ (finishes,subsumption)]).
adjMapping2SUMO('01010569-s',[ (finishes,subsumption)]).
adjMapping2SUMO('01010747-s',[ (finishes,subsumption)]).
adjMapping2SUMO('01010862-a',[ ('FirstFn',equivalence)]).
adjMapping2SUMO('01011392-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01011753-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01011973-s',[ (starts,subsumption)]).
adjMapping2SUMO('01012100-s',[ (greaterThan,subsumption)]).
adjMapping2SUMO('01012247-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('01012503-s',[ ('FirstFn',equivalence)]).
adjMapping2SUMO('01012855-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('01012990-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('01013171-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('01013279-a',[ ('LastFn',equivalence)]).
adjMapping2SUMO('01013681-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('01013843-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01013961-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('01014251-a',[ (between,equivalence)]).
adjMapping2SUMO('01014685-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01014838-s',[ ('ConstantQuantity',subsumption)]).
adjMapping2SUMO('01014953-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('01015185-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('01015392-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('01015599-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('01015798-s',[ ('Near',subsumption)]).
adjMapping2SUMO('01015940-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('01016035-a',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('01016215-a',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('01016436-a',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('01016644-a',[ (capability,subsumption)]).
adjMapping2SUMO('01016806-a',[ (capability,subsumption)]).
adjMapping2SUMO('01016874-a',[ (capability,subsumption)]).
adjMapping2SUMO('01017048-a',[ (capability,subsumption)]).
adjMapping2SUMO('01017161-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01017439-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01017600-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01017738-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01018264-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01018359-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01018530-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01018667-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01018788-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01019000-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01019283-s',[ ('PathologicProcess',subsumption)]).
adjMapping2SUMO('01019450-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01019587-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01019713-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01020007-s',[ ('PathologicProcess',subsumption)]).
adjMapping2SUMO('01020117-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01020282-s',[ ('PathologicProcess',subsumption)]).
adjMapping2SUMO('01020393-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01020709-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01020885-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01021120-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01021301-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01021499-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01021607-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01021794-a',[ ('Icon',subsumption)]).
adjMapping2SUMO('01021923-a',[ ('Icon',subsumption)]).
adjMapping2SUMO('01022064-a',[ (capability,subsumption)]).
adjMapping2SUMO('01022367-s',[ (capability,subsumption)]).
adjMapping2SUMO('01022657-s',[ (capability,subsumption)]).
adjMapping2SUMO('01022785-s',[ (capability,subsumption)]).
adjMapping2SUMO('01022926-s',[ (capability,subsumption)]).
adjMapping2SUMO('01023010-s',[ ('',undefined)]).
adjMapping2SUMO('01023128-s',[ ('Muscle',subsumption)]).
adjMapping2SUMO('01023289-a',[ ('Rigid',subsumption)]).
adjMapping2SUMO('01023533-s',[ ('Muscle',subsumption)]).
adjMapping2SUMO('01023706-s',[ ('Rigid',equivalence)]).
adjMapping2SUMO('01024002-s',[ ('Pliable',subsumption)]).
adjMapping2SUMO('01024073-a',[ (capability,subsumption)]).
adjMapping2SUMO('01024228-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01024400-s',[ (capability,subsumption)]).
adjMapping2SUMO('01024597-a',[ (capability,subsumption)]).
adjMapping2SUMO('01024812-s',[ (capability,subsumption)]).
adjMapping2SUMO('01025212-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01025397-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01025610-s',[ ('',undefined)]).
adjMapping2SUMO('01025732-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01025913-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01026150-s',[ ('',undefined)]).
adjMapping2SUMO('01026262-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01026552-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01026721-a',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('01026911-s',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('01027076-a',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('01027263-a',[ (capability,subsumption)]).
adjMapping2SUMO('01027686-s',[ (capability,subsumption)]).
adjMapping2SUMO('01027832-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01027988-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01028163-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01028467-s',[ ('Text',subsumption)]).
adjMapping2SUMO('01028623-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01028796-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01029044-a',[ (capability,subsumption)]).
adjMapping2SUMO('01029151-s',[ (capability,subsumption)]).
adjMapping2SUMO('01029399-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('01029563-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('01029710-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('01029873-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('01030022-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01030289-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01030372-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01030525-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01030605-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01030691-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01030826-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01031038-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01031115-s',[ ('ShapeChange',not(subsumption))]).
adjMapping2SUMO('01031232-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01031405-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01031503-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01031602-s',[ ('',undefined)]).
adjMapping2SUMO('01031701-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01031797-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('01031908-s',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('01032029-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01032226-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01032339-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01032451-s',[ ('',undefined)]).
adjMapping2SUMO('01032531-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('01032624-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01032710-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01032845-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01032978-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01033081-a',[ ('FrontFn',subsumption)]).
adjMapping2SUMO('01033249-s',[ ('FrontFn',subsumption)]).
adjMapping2SUMO('01033371-a',[ ('BackFn',subsumption)]).
adjMapping2SUMO('01033542-s',[ ('BackFn',subsumption)]).
adjMapping2SUMO('01033616-s',[ ('BackFn',subsumption)]).
adjMapping2SUMO('01033708-a',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('01033840-a',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('01033996-a',[ ('Birth',subsumption)]).
adjMapping2SUMO('01034153-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01034296-a',[ ('Selecting',subsumption)]).
adjMapping2SUMO('01034457-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01034858-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('01035007-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01035277-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('01035422-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('01035559-s',[ ('Birth',subsumption)]).
adjMapping2SUMO('01035725-s',[ ('Transportation',subsumption)]).
adjMapping2SUMO('01035858-s',[ (origin,subsumption)]).
adjMapping2SUMO('01035976-s',[ ('Human',subsumption)]).
adjMapping2SUMO('01036083-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01036383-s',[ (origin,subsumption)]).
adjMapping2SUMO('01036754-s',[ ('Domestic',equivalence)]).
adjMapping2SUMO('01036874-s',[ (located,equivalence)]).
adjMapping2SUMO('01037022-s',[ ('Birth',subsumption)]).
adjMapping2SUMO('01037148-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01037405-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01037540-a',[ (equal,equivalence)]).
adjMapping2SUMO('01037763-s',[ ('Nation',subsumption)]).
adjMapping2SUMO('01037885-s',[ ('International',equivalence)]).
adjMapping2SUMO('01038102-a',[ ('Domestic',equivalence)]).
adjMapping2SUMO('01038332-s',[ ('Nation',subsumption)]).
adjMapping2SUMO('01038580-s',[ ('City',subsumption)]).
adjMapping2SUMO('01038808-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01039203-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01039366-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01039460-s',[ ('',undefined)]).
adjMapping2SUMO('01039556-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01039687-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01039843-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01040087-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01040239-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01040331-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01040410-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01040544-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01040752-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01040825-s',[ ('',undefined)]).
adjMapping2SUMO('01040984-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01041209-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01041408-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01041481-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01041634-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01041916-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01042491-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01042703-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01042921-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01043070-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01043226-s',[ ('FormalAttribute',equivalence)]).
adjMapping2SUMO('01043374-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01043505-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01043619-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01043746-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01043924-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01044118-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01044240-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01044557-s',[ ('CasualAttribute',equivalence)]).
adjMapping2SUMO('01044730-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01044922-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01045067-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01045216-a',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('01045518-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01045711-a',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('01045963-s',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('01046226-s',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('01046553-s',[ ('Text',subsumption)]).
adjMapping2SUMO('01046784-s',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('01046994-s',[ ('Text',subsumption)]).
adjMapping2SUMO('01047144-s',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('01047301-a',[ ('FirstFn',equivalence)]).
adjMapping2SUMO('01047561-a',[ ('LastFn',equivalence)]).
adjMapping2SUMO('01047752-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('01047874-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01048202-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01048406-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01048587-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01048762-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01048976-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01049210-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01049352-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01049462-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01049941-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01050088-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01050603-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01050890-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01051410-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01051718-s',[ ('',undefined)]).
adjMapping2SUMO('01051814-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01052038-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01052248-a',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01052428-s',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01052611-s',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01052888-s',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01053046-s',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01053144-a',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01053539-s',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01053634-s',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01053915-s',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01054047-s',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01054204-s',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01054367-s',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01054504-s',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01054630-s',[ ('',undefined)]).
adjMapping2SUMO('01054741-s',[ ('',undefined)]).
adjMapping2SUMO('01054832-s',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01054922-s',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01055073-a',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01055682-s',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01055767-s',[ ('',undefined)]).
adjMapping2SUMO('01055846-s',[ ('',undefined)]).
adjMapping2SUMO('01055923-s',[ ('',undefined)]).
adjMapping2SUMO('01056001-s',[ ('',undefined)]).
adjMapping2SUMO('01056086-s',[ ('',undefined)]).
adjMapping2SUMO('01056163-s',[ ('',undefined)]).
adjMapping2SUMO('01056242-s',[ ('',undefined)]).
adjMapping2SUMO('01056325-s',[ ('',undefined)]).
adjMapping2SUMO('01056402-s',[ ('',undefined)]).
adjMapping2SUMO('01056481-s',[ ('',undefined)]).
adjMapping2SUMO('01056558-s',[ ('',undefined)]).
adjMapping2SUMO('01056636-s',[ ('',undefined)]).
adjMapping2SUMO('01056711-s',[ ('',undefined)]).
adjMapping2SUMO('01056802-s',[ ('',undefined)]).
adjMapping2SUMO('01056897-s',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01057103-s',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01057270-s',[ ('',undefined)]).
adjMapping2SUMO('01057348-s',[ ('',undefined)]).
adjMapping2SUMO('01057447-s',[ ('',undefined)]).
adjMapping2SUMO('01057541-s',[ ('',undefined)]).
adjMapping2SUMO('01057614-s',[ ('',undefined)]).
adjMapping2SUMO('01057695-s',[ ('',undefined)]).
adjMapping2SUMO('01057775-a',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01057958-s',[ ('',undefined)]).
adjMapping2SUMO('01058029-s',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('01058179-a',[ (capability,subsumption)]).
adjMapping2SUMO('01058281-a',[ (capability,subsumption)]).
adjMapping2SUMO('01058363-a',[ ('Selecting',subsumption)]).
adjMapping2SUMO('01058650-s',[ ('ChemicalDecomposition',subsumption)]).
adjMapping2SUMO('01058756-s',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('01058854-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('01059058-s',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('01059252-s',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('01059400-a',[ ('Attaching',subsumption)]).
adjMapping2SUMO('01059711-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('01059911-s',[ (located,subsumption)]).
adjMapping2SUMO('01060110-s',[ ('',undefined)]).
adjMapping2SUMO('01060304-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('01060445-s',[ (capability,subsumption)]).
adjMapping2SUMO('01060570-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('01060712-s',[ (capability,subsumption)]).
adjMapping2SUMO('01060785-a',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('01060947-s',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('01061100-s',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('01061310-s',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('01061489-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01062114-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01062393-s',[ ('PoliticalOrganization',subsumption)]).
adjMapping2SUMO('01062631-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01062819-s',[ ('Detaching',subsumption)]).
adjMapping2SUMO('01062938-s',[ ('Adjacent',subsumption)]).
adjMapping2SUMO('01063102-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01063286-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01063490-s',[ ('EducationalProcess',not(subsumption))]).
adjMapping2SUMO('01063638-s',[ ('Keeping',not(subsumption))]).
adjMapping2SUMO('01063753-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01063958-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01064167-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01064286-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01064619-s',[ ('Committing',subsumption)]).
adjMapping2SUMO('01064806-s',[ ('Committing',subsumption)]).
adjMapping2SUMO('01064913-s',[ ('Keeping',subsumption)]).
adjMapping2SUMO('01065126-s',[ ('Keeping',subsumption)]).
adjMapping2SUMO('01065321-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01065401-s',[ ('CognitiveAgent',subsumption)]).
adjMapping2SUMO('01065538-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01065614-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01065694-a',[ ('Confining',not(subsumption))]).
adjMapping2SUMO('01065861-s',[ ('Confining',not(subsumption))]).
adjMapping2SUMO('01065941-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01066070-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01066226-s',[ ('Confining',subsumption)]).
adjMapping2SUMO('01066441-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01066542-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01066787-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01067003-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01067193-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01067415-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01067538-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01067694-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01068012-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01068104-s',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('01068217-s',[ ('Cutting',subsumption)]).
adjMapping2SUMO('01068306-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01068438-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01068513-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01068609-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01068726-a',[ ('Food',subsumption)]).
adjMapping2SUMO('01069187-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01069283-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01069454-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01069607-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01069715-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01069823-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01070002-s',[ ('FruitOrVegetable',subsumption)]).
adjMapping2SUMO('01070088-s',[ ('Microorganism',subsumption)]).
adjMapping2SUMO('01070321-s',[ ('ChemicalDecomposition',subsumption)]).
adjMapping2SUMO('01070538-s',[ ('ChemicalDecomposition',subsumption)]).
adjMapping2SUMO('01070716-s',[ ('ChemicalDecomposition',subsumption)]).
adjMapping2SUMO('01070844-s',[ ('ChemicalDecomposition',subsumption)]).
adjMapping2SUMO('01071049-s',[ ('ChemicalDecomposition',subsumption)]).
adjMapping2SUMO('01071198-a',[ ('Food',subsumption)]).
adjMapping2SUMO('01071321-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01071423-a',[ ('Food',subsumption)]).
adjMapping2SUMO('01071794-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01071941-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01072112-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01072196-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01072297-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01072382-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01072586-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01072782-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01072908-s',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('01073094-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01073194-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01073311-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01073435-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01073592-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01073707-a',[ ('Water',subsumption)]).
adjMapping2SUMO('01073822-a',[ ('SodiumChloride',subsumption)]).
adjMapping2SUMO('01074062-s',[ ('SodiumChloride',subsumption)]).
adjMapping2SUMO('01074335-s',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('01074458-s',[ ('SodiumChloride',subsumption)]).
adjMapping2SUMO('01074582-s',[ ('SodiumChloride',subsumption)]).
adjMapping2SUMO('01074650-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01075178-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01075524-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01075742-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01075864-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01076024-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01076145-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01076435-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01076634-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01076793-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01077158-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01077263-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01077362-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01077485-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01077638-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01077829-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01077995-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01078178-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01078302-a',[ ('Freezing',equivalence)]).
adjMapping2SUMO('01078673-s',[ ('Injuring',subsumption)]).
adjMapping2SUMO('01078840-s',[ ('Freezing',subsumption)]).
adjMapping2SUMO('01078932-s',[ ('Freezing',subsumption)]).
adjMapping2SUMO('01079052-s',[ ('Freezing',subsumption)]).
adjMapping2SUMO('01079143-s',[ ('Freezing',subsumption)]).
adjMapping2SUMO('01079240-s',[ ('Freezing',subsumption)]).
adjMapping2SUMO('01079396-s',[ ('Freezing',subsumption)]).
adjMapping2SUMO('01079532-s',[ ('Freezing',subsumption)]).
adjMapping2SUMO('01079683-a',[ ('Freezing',not(subsumption))]).
adjMapping2SUMO('01079857-s',[ ('Freezing',not(subsumption))]).
adjMapping2SUMO('01079978-s',[ ('Melting',equivalence)]).
adjMapping2SUMO('01080060-s',[ ('Melting',subsumption)]).
adjMapping2SUMO('01080197-s',[ ('Melting',subsumption)]).
adjMapping2SUMO('01080297-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01080717-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01080823-s',[ ('',undefined)]).
adjMapping2SUMO('01080900-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01081068-s',[ ('Replication',subsumption)]).
adjMapping2SUMO('01081263-s',[ ('',undefined)]).
adjMapping2SUMO('01081340-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01081592-s',[ (capability,subsumption)]).
adjMapping2SUMO('01081917-s',[ ('',undefined)]).
adjMapping2SUMO('01082038-s',[ ('',undefined)]).
adjMapping2SUMO('01082115-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01082302-s',[ ('',undefined)]).
adjMapping2SUMO('01082377-s',[ ('',undefined)]).
adjMapping2SUMO('01082456-s',[ ('',undefined)]).
adjMapping2SUMO('01082535-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01082714-s',[ (realization,subsumption)]).
adjMapping2SUMO('01082925-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01082998-s',[ (capability,subsumption)]).
adjMapping2SUMO('01083157-a',[ ('ContainerFull',subsumption)]).
adjMapping2SUMO('01083754-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01084023-s',[ ('',undefined)]).
adjMapping2SUMO('01084091-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01084297-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01084486-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01084575-s',[ ('',undefined)]).
adjMapping2SUMO('01084644-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01084900-s',[ (property,subsumption)]).
adjMapping2SUMO('01085097-s',[ ('',undefined)]).
adjMapping2SUMO('01085167-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01085268-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01085442-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01085661-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01085848-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01085937-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01086042-s',[ ('',undefined)]).
adjMapping2SUMO('01086118-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01086213-s',[ ('Eating',subsumption)]).
adjMapping2SUMO('01086339-s',[ (uses,subsumption)]).
adjMapping2SUMO('01086453-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01086545-a',[ ('ContainerEmpty',subsumption)]).
adjMapping2SUMO('01086915-s',[ ('ContainerEmpty',subsumption)]).
adjMapping2SUMO('01087093-s',[ (not,subsumption)]).
adjMapping2SUMO('01087300-s',[ ('Carrying',not(subsumption))]).
adjMapping2SUMO('01087388-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01087557-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01087757-s',[ ('UnilateralGetting',subsumption)]).
adjMapping2SUMO('01087977-s',[ (occupiesPosition,subsumption)]).
adjMapping2SUMO('01088164-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01088262-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01088351-s',[ (not,subsumption)]).
adjMapping2SUMO('01088478-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('01088749-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01088881-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('01089027-a',[ ('Removing',not(subsumption))]).
adjMapping2SUMO('01089136-a',[ ('FullTimePosition',equivalence)]).
adjMapping2SUMO('01089275-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01089369-a',[ ('PartTimePosition',equivalence)]).
adjMapping2SUMO('01089616-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01089775-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01089949-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01090061-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01090308-a',[ (capability,subsumption)]).
adjMapping2SUMO('01090593-s',[ (part,subsumption)]).
adjMapping2SUMO('01090820-s',[ (capability,subsumption)]).
adjMapping2SUMO('01090993-a',[ (capability,subsumption)]).
adjMapping2SUMO('01091160-s',[ (part,subsumption)]).
adjMapping2SUMO('01091234-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('01091556-a',[ (capability,subsumption)]).
adjMapping2SUMO('01091728-s',[ (capability,subsumption)]).
adjMapping2SUMO('01091995-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01092142-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01092371-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01092572-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01092727-s',[ ('',undefined)]).
adjMapping2SUMO('01092889-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01092989-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01093142-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01093323-a',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('01093524-s',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('01093631-s',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('01093850-s',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('01093956-a',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('01094049-a',[ ('Giving',subsumption)]).
adjMapping2SUMO('01094398-s',[ ('Giving',subsumption)]).
adjMapping2SUMO('01094647-s',[ ('Giving',subsumption)]).
adjMapping2SUMO('01094767-s',[ ('Giving',subsumption)]).
adjMapping2SUMO('01094855-s',[ ('Giving',subsumption)]).
adjMapping2SUMO('01095085-s',[ ('Learning',subsumption)]).
adjMapping2SUMO('01095277-s',[ ('EngineeringComponent',subsumption)]).
adjMapping2SUMO('01095406-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01095555-a',[ ('Giving',not(subsumption))]).
adjMapping2SUMO('01095785-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01095914-a',[ ('Bird',subsumption)]).
adjMapping2SUMO('01096123-s',[ ('Bird',subsumption)]).
adjMapping2SUMO('01096308-s',[ ('FullyFormed',subsumption)]).
adjMapping2SUMO('01096471-a',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('01096648-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01096750-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('01096889-a',[ ('Artifact',not(subsumption))]).
adjMapping2SUMO('01096990-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('01097315-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01097484-s',[ ('Giving',subsumption)]).
adjMapping2SUMO('01097690-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01097847-s',[ ('',undefined)]).
adjMapping2SUMO('01097966-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01098154-a',[ ('Putting',not(subsumption))]).
adjMapping2SUMO('01098293-a',[ ('Giving',subsumption)]).
adjMapping2SUMO('01098390-a',[ ('Giving',not(subsumption))]).
adjMapping2SUMO('01098492-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('01098678-s',[ ('',undefined)]).
adjMapping2SUMO('01098826-s',[ ('',undefined)]).
adjMapping2SUMO('01098941-s',[ ('',undefined)]).
adjMapping2SUMO('01099051-s',[ ('',undefined)]).
adjMapping2SUMO('01099134-s',[ ('Combustion',subsumption)]).
adjMapping2SUMO('01099235-a',[ ('Putting',not(subsumption))]).
adjMapping2SUMO('01099348-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01099435-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01099536-a',[ ('Stating',subsumption)]).
adjMapping2SUMO('01099707-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01099810-s',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('01099951-s',[ ('Stating',subsumption)]).
adjMapping2SUMO('01100082-a',[ ('Stating',not(subsumption))]).
adjMapping2SUMO('01100210-a',[ ('EngineeringComponent',subsumption)]).
adjMapping2SUMO('01100394-s',[ ('EngineeringComponent',subsumption)]).
adjMapping2SUMO('01100595-s',[ ('EngineeringComponent',subsumption)]).
adjMapping2SUMO('01100817-s',[ (connected,subsumption)]).
adjMapping2SUMO('01101022-s',[ (connected,subsumption)]).
adjMapping2SUMO('01101118-a',[ (connected,subsumption)]).
adjMapping2SUMO('01101264-s',[ (connected,subsumption)]).
adjMapping2SUMO('01101391-a',[ (forall,subsumption)]).
adjMapping2SUMO('01101891-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01102058-s',[ (capability,subsumption)]).
adjMapping2SUMO('01102164-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01102308-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01102451-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01102568-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01102674-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01102876-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01103021-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01103529-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01103676-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01103844-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01104026-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01104460-s',[ (instance,equivalence)]).
adjMapping2SUMO('01104709-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01104889-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01105042-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01105233-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01105620-a',[ ('NonspecificDisease',equivalence)]).
adjMapping2SUMO('01105840-a',[ ('Nation',equivalence)]).
adjMapping2SUMO('01106129-s',[ ('Nation',equivalence)]).
adjMapping2SUMO('01106405-a',[ ('Local',equivalence)]).
adjMapping2SUMO('01106614-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('01106815-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('01106989-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('01107094-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('01107206-a',[ ('Government',subsumption)]).
adjMapping2SUMO('01107521-a',[ ('Government',subsumption)]).
adjMapping2SUMO('01107751-a',[ ('OrganizationalProcess',subsumption)]).
adjMapping2SUMO('01107973-a',[ ('OrganizationalProcess',subsumption)]).
adjMapping2SUMO('01108276-s',[ ('OrganizationalProcess',subsumption)]).
adjMapping2SUMO('01108427-s',[ ('Transportation',subsumption)]).
adjMapping2SUMO('01108586-s',[ ('City',subsumption)]).
adjMapping2SUMO('01108716-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01109096-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01109359-a',[ (holdsRight,subsumption)]).
adjMapping2SUMO('01109599-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01109782-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('01109914-a',[ (holdsRight,subsumption)]).
adjMapping2SUMO('01110251-s',[ ('Product',subsumption)]).
adjMapping2SUMO('01110470-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('01110686-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('01110819-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('01111016-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01111312-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01111418-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01111965-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01112471-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01112573-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01112969-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01113114-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01113225-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01113505-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01113636-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01113807-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01114116-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01114434-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01114658-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01114973-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01115081-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01115349-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01115635-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01115920-s',[ ('Stating',subsumption)]).
adjMapping2SUMO('01116026-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01116118-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01116380-a',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01116857-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01117226-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01117362-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01117477-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01117677-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01117823-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01117942-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01118118-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01118232-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01118409-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01118568-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('01118673-s',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('01118928-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('01119033-s',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('01119192-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01119305-a',[ ('',undefined)]).
adjMapping2SUMO('01119421-a',[ ('SurfaceChange',subsumption)]).
adjMapping2SUMO('01119661-s',[ ('SurfaceChange',subsumption)]).
adjMapping2SUMO('01119937-s',[ ('',undefined)]).
adjMapping2SUMO('01120010-s',[ ('SurfaceChange',subsumption)]).
adjMapping2SUMO('01120242-s',[ ('SurfaceChange',subsumption)]).
adjMapping2SUMO('01120398-a',[ ('SurfaceChange',not(subsumption))]).
adjMapping2SUMO('01120515-s',[ ('SurfaceChange',not(subsumption))]).
adjMapping2SUMO('01120654-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('01120766-a',[ ('Putting',not(subsumption))]).
adjMapping2SUMO('01120925-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01121238-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01121402-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01121507-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01121757-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01121989-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01122121-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01122269-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01122411-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01122595-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01122776-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01122907-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01123002-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01123148-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01123879-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('01124192-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01124342-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01124441-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01124574-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01124768-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01125006-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01125154-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01125241-s',[ ('Human',subsumption)]).
adjMapping2SUMO('01125429-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01126291-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01126683-s',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('01126841-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01127147-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01127302-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01127440-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01127661-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01127782-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01128010-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01128103-s',[ (capability,subsumption)]).
adjMapping2SUMO('01128253-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01128406-s',[ ('Human',subsumption)]).
adjMapping2SUMO('01128508-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01128719-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01128871-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01129021-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01129185-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01129371-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01129533-s',[ ('',undefined)]).
adjMapping2SUMO('01129644-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01129823-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01129977-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01130261-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01130614-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01130733-s',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('01130932-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01131043-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01131454-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01131803-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01131935-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01132366-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01132515-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01133017-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01133374-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01133784-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01133876-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01134232-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01134486-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01134769-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01135269-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01135420-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01135673-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01135914-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01136127-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01136248-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01136541-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01137000-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01137289-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01137378-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01137882-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01137994-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01138161-s',[ ('ObjectAttitude',subsumption)]).
adjMapping2SUMO('01138316-s',[ ('ObjectAttitude',subsumption)]).
adjMapping2SUMO('01138450-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01138610-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01138770-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01138902-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01139067-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01139245-s',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('01139352-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01139613-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01139832-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01140054-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01140188-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01140290-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01140514-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01140896-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01141242-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01141468-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01141595-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01141743-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01142069-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01142196-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01142349-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01142595-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01142666-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01142804-a',[ ('QuantityChange',subsumption)]).
adjMapping2SUMO('01143006-s',[ ('QuantityChange',subsumption)]).
adjMapping2SUMO('01143138-s',[ ('QuantityChange',subsumption)]).
adjMapping2SUMO('01143279-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01143585-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01143750-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01143855-s',[ ('BeginFn',subsumption)]).
adjMapping2SUMO('01144009-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01144102-s',[ ('',undefined)]).
adjMapping2SUMO('01144230-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01144359-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01144571-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01144730-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01144887-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01145151-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01145422-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01145639-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01145724-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01145862-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01145931-s',[ ('',undefined)]).
adjMapping2SUMO('01146012-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('01146207-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('01146371-s',[ ('False',subsumption)]).
adjMapping2SUMO('01146493-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01146732-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01146920-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01147044-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01147300-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01147433-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('01147622-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('01147836-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('01148086-s',[ ('',undefined)]).
adjMapping2SUMO('01148283-a',[ ('Happiness',equivalence)]).
adjMapping2SUMO('01148764-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01148897-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01149050-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01149195-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01149358-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01149494-a',[ ('Unhappiness',subsumption)]).
adjMapping2SUMO('01150063-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01150205-s',[ ('Unhappiness',subsumption)]).
adjMapping2SUMO('01150475-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01150771-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01150915-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01151246-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01151335-s',[ ('',undefined)]).
adjMapping2SUMO('01151452-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01151592-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01151740-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01151951-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01152091-s',[ ('StateChange',subsumption)]).
adjMapping2SUMO('01152189-s',[ ('StateChange',subsumption)]).
adjMapping2SUMO('01152320-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01152453-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01152521-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01152620-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01152746-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01153141-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('01153346-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01153435-s',[ (capability,subsumption)]).
adjMapping2SUMO('01153595-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01153703-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01153844-s',[ (causes,subsumption)]).
adjMapping2SUMO('01154030-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01154229-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01154351-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01154500-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01154639-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01154775-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01154886-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01154964-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01155206-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01155354-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01155603-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01155815-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01155968-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01156112-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01156302-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01156505-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01156750-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01156925-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01157179-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01157494-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01157762-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01157887-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01158020-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01158180-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01158453-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01158596-a',[ ('Beverage',subsumption)]).
adjMapping2SUMO('01158837-s',[ ('Beverage',subsumption)]).
adjMapping2SUMO('01158974-s',[ ('Beverage',subsumption)]).
adjMapping2SUMO('01159119-s',[ (capability,subsumption)]).
adjMapping2SUMO('01159217-s',[ ('Beverage',subsumption)]).
adjMapping2SUMO('01159405-s',[ ('Beverage',subsumption)]).
adjMapping2SUMO('01159531-a',[ ('Beverage',subsumption)]).
adjMapping2SUMO('01159655-a',[ ('Damaging',not(subsumption))]).
adjMapping2SUMO('01159907-s',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('01160031-a',[ ('Damaging',subsumption)]).
adjMapping2SUMO('01160584-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('01160775-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('01160880-s',[ ('Injuring',subsumption)]).
adjMapping2SUMO('01161059-s',[ ('Injuring',subsumption)]).
adjMapping2SUMO('01161233-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01161635-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01161877-s',[ (inhibits,subsumption)]).
adjMapping2SUMO('01161984-s',[ ('Damaging',equivalence)]).
adjMapping2SUMO('01162267-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01162406-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01162633-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01162817-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01162901-s',[ ('Injuring',subsumption)]).
adjMapping2SUMO('01163083-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01163320-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01163589-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01163759-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01163860-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01163941-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01164072-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01164250-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01164420-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01164561-s',[ ('Music',subsumption)]).
adjMapping2SUMO('01164763-a',[ (causes,subsumption)]).
adjMapping2SUMO('01165266-s',[ (capability,subsumption)]).
adjMapping2SUMO('01165474-s',[ (capability,subsumption)]).
adjMapping2SUMO('01165665-s',[ (capability,subsumption)]).
adjMapping2SUMO('01165830-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01165943-s',[ (capability,subsumption)]).
adjMapping2SUMO('01166314-s',[ ('BiologicallyActiveSubstance',not(subsumption))]).
adjMapping2SUMO('01166413-s',[ (capability,subsumption)]).
adjMapping2SUMO('01166656-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01166875-s',[ ('',undefined)]).
adjMapping2SUMO('01166993-s',[ ('',undefined)]).
adjMapping2SUMO('01167269-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01167540-s',[ (capability,subsumption)]).
adjMapping2SUMO('01167817-a',[ ('Damaging',subsumption)]).
adjMapping2SUMO('01168166-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('01168315-s',[ ('',undefined)]).
adjMapping2SUMO('01168434-s',[ (capability,subsumption)]).
adjMapping2SUMO('01168632-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01168845-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('01168988-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01169194-a',[ ('TherapeuticProcess',subsumption)]).
adjMapping2SUMO('01169533-s',[ ('',undefined)]).
adjMapping2SUMO('01169660-s',[ (earlier,subsumption)]).
adjMapping2SUMO('01169817-a',[ (capability,subsumption)]).
adjMapping2SUMO('01169940-a',[ (capability,subsumption)]).
adjMapping2SUMO('01170069-a',[ (causes,subsumption)]).
adjMapping2SUMO('01170136-a',[ (causes,subsumption)]).
adjMapping2SUMO('01170243-a',[ ('DiseaseOrSyndrome',not(subsumption))]).
adjMapping2SUMO('01170823-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('01170984-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01171076-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01171213-s',[ ('DiseaseOrSyndrome',not(subsumption))]).
adjMapping2SUMO('01171396-s',[ ('DiseaseOrSyndrome',not(subsumption))]).
adjMapping2SUMO('01171606-s',[ ('Ingesting',subsumption)]).
adjMapping2SUMO('01171746-s',[ ('DiseaseOrSyndrome',not(subsumption))]).
adjMapping2SUMO('01171955-s',[ ('',undefined)]).
adjMapping2SUMO('01172035-s',[ ('',undefined)]).
adjMapping2SUMO('01172139-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('01172394-s',[ ('',undefined)]).
adjMapping2SUMO('01172493-s',[ ('',undefined)]).
adjMapping2SUMO('01172594-s',[ ('DiseaseOrSyndrome',not(subsumption))]).
adjMapping2SUMO('01172692-s',[ ('DiseaseOrSyndrome',not(subsumption))]).
adjMapping2SUMO('01172889-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01173697-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01173795-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01174048-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01174222-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01174438-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01174565-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01175007-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01175158-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01175298-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01175427-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01175541-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01175636-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01175741-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01175939-s',[ ('',undefined)]).
adjMapping2SUMO('01176057-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01176246-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01176544-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01176695-s',[ (larger,subsumption)]).
adjMapping2SUMO('01176787-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01176973-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01177105-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01177246-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01177435-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01177556-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01177704-s',[ ('AnatomicalStructure',subsumption)]).
adjMapping2SUMO('01177899-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('01178024-s',[ ('',undefined)]).
adjMapping2SUMO('01178134-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01178231-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01178345-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01178458-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01178577-s',[ ('',undefined)]).
adjMapping2SUMO('01178669-a',[ ('SaturationAttribute',subsumption)]).
adjMapping2SUMO('01178856-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01178974-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01179241-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01179345-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01179547-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01179767-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01180084-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01180363-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01180549-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01180695-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01181116-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01181251-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01181329-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01181446-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01181661-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01181904-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01182024-a',[ (capability,subsumption)]).
adjMapping2SUMO('01182302-s',[ (capability,subsumption)]).
adjMapping2SUMO('01182414-s',[ (capability,subsumption)]).
adjMapping2SUMO('01182554-s',[ ('Digesting',subsumption)]).
adjMapping2SUMO('01182747-a',[ (capability,subsumption)]).
adjMapping2SUMO('01182974-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01183114-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01183274-s',[ (capability,subsumption)]).
adjMapping2SUMO('01183348-s',[ ('Digesting',not(subsumption))]).
adjMapping2SUMO('01183436-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01183601-a',[ (part,subsumption)]).
adjMapping2SUMO('01183892-s',[ ('',undefined)]).
adjMapping2SUMO('01183966-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01184085-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01184183-s',[ ('',undefined)]).
adjMapping2SUMO('01184261-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('01184448-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('01184584-s',[ ('Detaching',subsumption)]).
adjMapping2SUMO('01184706-a',[ (part,subsumption)]).
adjMapping2SUMO('01184825-a',[ (part,subsumption)]).
adjMapping2SUMO('01184932-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01185264-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01185417-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('01185636-s',[ ('',undefined)]).
adjMapping2SUMO('01185775-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01185916-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01186107-s',[ ('',undefined)]).
adjMapping2SUMO('01186207-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01186408-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01186733-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01186913-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01187072-s',[ (capability,subsumption)]).
adjMapping2SUMO('01187322-s',[ ('',undefined)]).
adjMapping2SUMO('01187503-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01187611-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01187777-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01188058-a',[ ('Device',subsumption)]).
adjMapping2SUMO('01188186-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01188328-a',[ ('Device',subsumption)]).
adjMapping2SUMO('01188491-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01188648-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('01188762-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01189109-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01189386-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01189853-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01189998-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01190168-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01190316-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01190484-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01190683-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01190916-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01190993-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01191227-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('01191448-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('01191618-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01191780-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01191876-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01192035-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01192248-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01192393-s',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('01192639-a',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('01192786-s',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('01193046-a',[ (smaller,subsumption)]).
adjMapping2SUMO('01193275-s',[ ('Weapon',subsumption)]).
adjMapping2SUMO('01193373-a',[ (larger,subsumption)]).
adjMapping2SUMO('01193714-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01194099-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01194328-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01194483-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01194806-a',[ (confersRight,subsumption)]).
adjMapping2SUMO('01194974-s',[ (confersRight,subsumption)]).
adjMapping2SUMO('01195128-s',[ (confersObligation,subsumption)]).
adjMapping2SUMO('01195341-a',[ (confersObligation,subsumption)]).
adjMapping2SUMO('01195536-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01195963-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01196098-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01196276-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01196367-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01196484-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01196648-s',[ (causes,subsumption)]).
adjMapping2SUMO('01196775-s',[ (instrument,equivalence)]).
adjMapping2SUMO('01197024-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01197207-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01197386-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01197634-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01197737-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01197899-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01198019-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01198188-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01198356-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01198433-a',[ ('Bird',subsumption)]).
adjMapping2SUMO('01198586-a',[ ('Bird',subsumption)]).
adjMapping2SUMO('01198737-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01199083-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01199476-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01199663-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01199751-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01200095-s',[ ('Substance',subsumption)]).
adjMapping2SUMO('01200339-s',[ ('Substance',subsumption)]).
adjMapping2SUMO('01200491-s',[ ('Substance',subsumption)]).
adjMapping2SUMO('01200617-s',[ (causes,subsumption)]).
adjMapping2SUMO('01200705-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('01200915-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('01201100-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01201298-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01201422-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01201758-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01201937-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01202105-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01202212-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01202367-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01202514-s',[ ('',undefined)]).
adjMapping2SUMO('01202634-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01202813-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01202994-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01203147-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01203288-a',[ ('Classifying',subsumption)]).
adjMapping2SUMO('01203703-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01203873-s',[ (capability,subsumption)]).
adjMapping2SUMO('01203986-s',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('01204142-s',[ ('Vertical',equivalence)]).
adjMapping2SUMO('01204318-a',[ ('Classifying',not(subsumption))]).
adjMapping2SUMO('01204443-s',[ ('Classifying',not(subsumption))]).
adjMapping2SUMO('01204557-a',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('01205131-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01205232-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01205473-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01205746-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01205886-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01206046-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01206164-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01206318-s',[ ('Above',subsumption)]).
adjMapping2SUMO('01206474-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01206916-s',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('01207007-s',[ ('',undefined)]).
adjMapping2SUMO('01207145-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01207282-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01207423-s',[ ('',undefined)]).
adjMapping2SUMO('01207546-s',[ ('Below',subsumption)]).
adjMapping2SUMO('01207697-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01207835-a',[ ('Above',subsumption)]).
adjMapping2SUMO('01208044-s',[ ('Above',subsumption)]).
adjMapping2SUMO('01208146-s',[ ('Above',subsumption)]).
adjMapping2SUMO('01208221-s',[ ('Above',subsumption)]).
adjMapping2SUMO('01208352-a',[ ('Below',subsumption)]).
adjMapping2SUMO('01208492-s',[ ('Below',subsumption)]).
adjMapping2SUMO('01208571-a',[ ('Device',subsumption)]).
adjMapping2SUMO('01208738-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01208919-a',[ ('Device',subsumption)]).
adjMapping2SUMO('01209003-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01209210-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01209351-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01209470-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01209542-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01209679-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('01209770-a',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('01209984-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01210080-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01210174-s',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('01210300-a',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('01210375-a',[ ('Mixture',subsumption)]).
adjMapping2SUMO('01210477-a',[ ('Mixture',subsumption)]).
adjMapping2SUMO('01210581-a',[ ('',undefined)]).
adjMapping2SUMO('01210717-a',[ ('',undefined)]).
adjMapping2SUMO('01210854-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('01211296-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01211531-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01211665-s',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('01211828-s',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('01211962-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01212095-s',[ (greaterThan,subsumption)]).
adjMapping2SUMO('01212346-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01212469-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('01212732-s',[ ('CurrencyMeasure',subsumption)]).
adjMapping2SUMO('01212867-s',[ (lessThan,subsumption)]).
adjMapping2SUMO('01213000-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01213090-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01213197-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01213550-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01213721-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01213786-s',[ ('MusicalInstrument',subsumption)]).
adjMapping2SUMO('01213961-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01214115-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01214255-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01214430-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01214606-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01214842-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01215028-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01215136-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01215263-s',[ ('MusicalInstrument',subsumption)]).
adjMapping2SUMO('01215421-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01215663-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01215797-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01215935-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01216145-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01216317-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01216456-a',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01216710-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01216807-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01216981-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01217134-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01217338-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01217485-a',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01217579-a',[ ('Word',subsumption)]).
adjMapping2SUMO('01217919-a',[ ('Word',subsumption)]).
adjMapping2SUMO('01218007-a',[ ('Device',subsumption)]).
adjMapping2SUMO('01218207-a',[ ('Device',subsumption)]).
adjMapping2SUMO('01218341-a',[ ('Building',subsumption)]).
adjMapping2SUMO('01218548-s',[ ('Building',subsumption)]).
adjMapping2SUMO('01218660-s',[ ('Building',subsumption)]).
adjMapping2SUMO('01218797-a',[ ('Building',subsumption)]).
adjMapping2SUMO('01219007-s',[ ('Building',subsumption)]).
adjMapping2SUMO('01219111-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01219279-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('01219373-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('01219502-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01219603-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01219709-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01219827-a',[ (located,subsumption)]).
adjMapping2SUMO('01219938-a',[ (located,subsumption)]).
adjMapping2SUMO('01220052-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('01220311-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('01220487-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('01220640-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('01220882-s',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('01221057-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('01221290-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('01221502-a',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('01221719-a',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('01221875-s',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('01222100-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01222253-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('01222360-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01222722-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01222884-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01223271-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01223781-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01223941-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01224253-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01224650-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01224755-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01224964-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01225294-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01225398-a',[ ('Stating',subsumption)]).
adjMapping2SUMO('01225643-s',[ ('True',subsumption)]).
adjMapping2SUMO('01225772-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01225898-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01226129-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01226240-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01226660-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01226809-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01226997-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01227137-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01227546-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01228050-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01228159-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01228282-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01228370-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01228530-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01228797-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01229020-a',[ ('Unhappiness',subsumption)]).
adjMapping2SUMO('01229435-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01229561-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01229826-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01230153-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01230387-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01230521-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01230616-s',[ (capability,subsumption)]).
adjMapping2SUMO('01230728-s',[ (capability,subsumption)]).
adjMapping2SUMO('01230850-a',[ ('JoiningAnOrganization',subsumption)]).
adjMapping2SUMO('01231070-a',[ ('JoiningAnOrganization',not(subsumption))]).
adjMapping2SUMO('01231191-a',[ ('OrganizationalProcess',subsumption)]).
adjMapping2SUMO('01231369-s',[ ('OrganizationalProcess',subsumption)]).
adjMapping2SUMO('01231638-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01231837-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01231917-a',[ ('ChemicalSynthesis',subsumption)]).
adjMapping2SUMO('01232105-a',[ ('ChemicalDecomposition',subsumption)]).
adjMapping2SUMO('01232204-a',[ (capability,subsumption)]).
adjMapping2SUMO('01232298-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01232507-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01232635-a',[ ('Horizontal',equivalence)]).
adjMapping2SUMO('01232917-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01233020-s',[ ('Horizontal',subsumption)]).
adjMapping2SUMO('01233104-s',[ ('Horizontal',subsumption)]).
adjMapping2SUMO('01233225-s',[ ('Icon',subsumption)]).
adjMapping2SUMO('01233347-a',[ ('Vertical',equivalence)]).
adjMapping2SUMO('01233851-s',[ ('Vertical',subsumption)]).
adjMapping2SUMO('01233960-s',[ ('Vertical',subsumption)]).
adjMapping2SUMO('01234030-s',[ ('Vertical',subsumption)]).
adjMapping2SUMO('01234167-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01234527-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01234747-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01234952-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01235071-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01235178-s',[ ('',undefined)]).
adjMapping2SUMO('01235334-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01235439-s',[ ('Icon',subsumption)]).
adjMapping2SUMO('01235568-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01235706-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01235859-a',[ ('Vertical',subsumption)]).
adjMapping2SUMO('01236443-s',[ (capability,subsumption)]).
adjMapping2SUMO('01236565-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01236716-s',[ ('',undefined)]).
adjMapping2SUMO('01236842-s',[ ('Icon',subsumption)]).
adjMapping2SUMO('01236964-s',[ ('Icon',subsumption)]).
adjMapping2SUMO('01237162-s',[ ('',undefined)]).
adjMapping2SUMO('01237254-s',[ ('',undefined)]).
adjMapping2SUMO('01237342-s',[ ('',undefined)]).
adjMapping2SUMO('01237433-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('01237534-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01237656-s',[ ('Icon',subsumption)]).
adjMapping2SUMO('01237754-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01237897-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01238201-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01238343-s',[ ('Inclining',subsumption)]).
adjMapping2SUMO('01238486-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01238773-s',[ ('Icon',subsumption)]).
adjMapping2SUMO('01238914-s',[ ('Icon',subsumption)]).
adjMapping2SUMO('01239040-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01239199-s',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('01239410-s',[ ('',undefined)]).
adjMapping2SUMO('01239534-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01239617-s',[ ('',undefined)]).
adjMapping2SUMO('01239781-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01239862-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01240029-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01240235-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01240413-a',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('01240591-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('01240805-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01240931-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01241065-a',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('01241248-s',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('01241455-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01241600-s',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('01241757-a',[ ('Maneuver',subsumption)]).
adjMapping2SUMO('01241927-a',[ ('Maneuver',subsumption)]).
adjMapping2SUMO('01242101-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01242282-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01242489-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01242750-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01243102-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01243373-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01243609-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01243722-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01243825-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01244106-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01244195-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01244410-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01244846-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01245138-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01245441-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01245610-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01245778-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('01245889-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01246004-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01246148-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01246388-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01246579-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01246801-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01247025-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01247240-a',[ ('HotTemperature',equivalence)]).
adjMapping2SUMO('01247975-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01248064-s',[ ('HotTemperature',subsumption)]).
adjMapping2SUMO('01248198-s',[ ('Heating',subsumption)]).
adjMapping2SUMO('01248358-s',[ ('Heating',subsumption)]).
adjMapping2SUMO('01248477-s',[ ('Heating',subsumption)]).
adjMapping2SUMO('01248605-s',[ ('Heating',subsumption)]).
adjMapping2SUMO('01248713-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01248958-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01249137-s',[ (capability,subsumption)]).
adjMapping2SUMO('01249309-s',[ ('Warm',subsumption)]).
adjMapping2SUMO('01249555-s',[ ('',undefined)]).
adjMapping2SUMO('01249621-s',[ ('Heating',subsumption)]).
adjMapping2SUMO('01249768-s',[ ('TemperatureMeasure',subsumption)]).
adjMapping2SUMO('01249843-s',[ ('HotTemperature',subsumption)]).
adjMapping2SUMO('01249962-s',[ ('TemperatureMeasure',subsumption)]).
adjMapping2SUMO('01250121-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01250393-s',[ ('HotTemperature',subsumption)]).
adjMapping2SUMO('01250565-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('01250694-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01250835-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01250991-s',[ ('TemperatureMeasure',subsumption)]).
adjMapping2SUMO('01251128-a',[ ('ColdTemperature',equivalence)]).
adjMapping2SUMO('01251830-s',[ ('Perception',subsumption)]).
adjMapping2SUMO('01251958-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01252151-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01252399-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01252566-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01252714-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01253022-s',[ ('Cooling',subsumption)]).
adjMapping2SUMO('01253112-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01253254-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01253469-s',[ ('Heating',not(subsumption))]).
adjMapping2SUMO('01253592-s',[ ('ColdTemperature',subsumption)]).
adjMapping2SUMO('01253661-s',[ ('Cooling',subsumption)]).
adjMapping2SUMO('01253879-s',[ ('Cooling',subsumption)]).
adjMapping2SUMO('01254026-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01254165-s',[ ('ColdTemperature',subsumption)]).
adjMapping2SUMO('01254296-s',[ ('Heating',not(subsumption))]).
adjMapping2SUMO('01254432-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01254607-s',[ ('',undefined)]).
adjMapping2SUMO('01254784-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01255022-s',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('01255177-s',[ ('',undefined)]).
adjMapping2SUMO('01255296-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01255530-s',[ ('',undefined)]).
adjMapping2SUMO('01255715-s',[ ('',undefined)]).
adjMapping2SUMO('01255807-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01256076-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01256213-s',[ ('',undefined)]).
adjMapping2SUMO('01256332-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01256735-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01256865-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01256973-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01257145-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01257330-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01257501-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01257612-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01257990-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01258264-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01258617-a',[ ('Human',equivalence)]).
adjMapping2SUMO('01259015-s',[ ('Hominid',subsumption)]).
adjMapping2SUMO('01259123-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01259280-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('01259391-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01259644-s',[ ('Human',equivalence)]).
adjMapping2SUMO('01259746-s',[ ('Hominid',equivalence)]).
adjMapping2SUMO('01259941-s',[ ('Human',equivalence)]).
adjMapping2SUMO('01260023-a',[ ('Human',not(subsumption))]).
adjMapping2SUMO('01260282-s',[ ('Ape',subsumption)]).
adjMapping2SUMO('01260451-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01260584-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01260707-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01260873-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01261127-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01261363-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01261528-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01261727-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('01261867-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01262128-s',[ ('',undefined)]).
adjMapping2SUMO('01262284-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01262611-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01263013-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01263445-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01263832-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01263971-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01264179-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01264336-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01264913-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01265108-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01265308-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01265938-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01266092-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01266397-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01266649-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01266841-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01267076-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01267339-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01267480-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01267632-s',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('01267762-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01268002-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01268194-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01268426-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01268636-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01268837-s',[ ('',undefined)]).
adjMapping2SUMO('01268937-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01269073-a',[ ('PerceptualAttribute',subsumption)]).
adjMapping2SUMO('01269319-s',[ ('PerceptualAttribute',subsumption)]).
adjMapping2SUMO('01269506-s',[ ('PerceptualAttribute',subsumption)]).
adjMapping2SUMO('01269819-s',[ ('PerceptualAttribute',subsumption)]).
adjMapping2SUMO('01269907-s',[ ('Eating',not(subsumption))]).
adjMapping2SUMO('01270004-a',[ ('PerceptualAttribute',subsumption)]).
adjMapping2SUMO('01270175-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01270486-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01270704-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01270868-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01271410-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01271604-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01271700-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01271961-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01272176-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01272397-a',[ (capability,subsumption)]).
adjMapping2SUMO('01272609-s',[ (capability,subsumption)]).
adjMapping2SUMO('01272718-s',[ (capability,subsumption)]).
adjMapping2SUMO('01272836-s',[ (capability,subsumption)]).
adjMapping2SUMO('01272920-s',[ (capability,subsumption)]).
adjMapping2SUMO('01273033-s',[ (capability,subsumption)]).
adjMapping2SUMO('01273143-a',[ (capability,subsumption)]).
adjMapping2SUMO('01273316-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01273454-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01273604-s',[ (capability,subsumption)]).
adjMapping2SUMO('01273689-s',[ (capability,subsumption)]).
adjMapping2SUMO('01273773-s',[ (capability,subsumption)]).
adjMapping2SUMO('01273910-a',[ (located,subsumption)]).
adjMapping2SUMO('01274125-a',[ (causes,subsumption)]).
adjMapping2SUMO('01274261-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01274524-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01274626-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01274741-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01274945-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('01275057-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01275195-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('01275395-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01275562-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01276150-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01276482-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01276693-s',[ ('',undefined)]).
adjMapping2SUMO('01276872-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01276992-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01277097-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01277426-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01277753-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01277952-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01278080-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01278251-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01278423-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01278818-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01279028-s',[ ('Historical',equivalence)]).
adjMapping2SUMO('01279183-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01279310-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01279431-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01279611-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01279735-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01279978-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01280349-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01280576-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01280908-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01281559-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01281695-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01281874-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01282014-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01282510-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01282921-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01283155-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01283508-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01283787-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01284212-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01284544-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01284836-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01285136-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01285376-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01285713-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01285850-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01285938-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01286093-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01286239-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01286375-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01286539-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01286659-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01286799-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01287160-s',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('01287282-s',[ (capability,subsumption)]).
adjMapping2SUMO('01287486-s',[ (capability,subsumption)]).
adjMapping2SUMO('01287808-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01287972-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01288091-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01288298-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01288396-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01288690-s',[ ('Detergent',subsumption)]).
adjMapping2SUMO('01288895-s',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('01289083-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01289229-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01289480-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01289607-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('01289701-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('01290028-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('01290174-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01290333-a',[ ('Removing',not(subsumption))]).
adjMapping2SUMO('01290547-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01290766-a',[ ('Meeting',subsumption)]).
adjMapping2SUMO('01290947-a',[ ('Meeting',subsumption)]).
adjMapping2SUMO('01291098-s',[ ('Stating',subsumption)]).
adjMapping2SUMO('01291234-a',[ (located,subsumption)]).
adjMapping2SUMO('01291391-a',[ (located,subsumption)]).
adjMapping2SUMO('01291589-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01291757-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('01291850-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('01291937-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('01292128-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01292411-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01292683-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01292884-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01293049-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01293158-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01293396-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01293542-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01293882-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01294051-a',[ ('FutureFn',subsumption)]).
adjMapping2SUMO('01294185-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('01294300-a',[ ('FutureFn',subsumption)]).
adjMapping2SUMO('01294583-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01294756-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01294857-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01294975-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01295143-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01295255-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01295337-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01295443-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('01295660-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01295837-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01295946-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01296091-s',[ ('PastFn',subsumption)]).
adjMapping2SUMO('01296270-a',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('01296474-a',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('01296718-s',[ (capability,subsumption)]).
adjMapping2SUMO('01296816-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('01296961-s',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('01297152-s',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('01297315-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01297658-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01297946-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01298239-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01298708-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01298884-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01299173-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01299385-s',[ ('',undefined)]).
adjMapping2SUMO('01299484-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01299687-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01299888-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01300187-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01300370-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01300661-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01300961-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01301056-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01301206-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01301316-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01301624-a',[ ('GeopoliticalArea',subsumption)]).
adjMapping2SUMO('01301840-s',[ ('GeopoliticalArea',subsumption)]).
adjMapping2SUMO('01301992-s',[ (causes,subsumption)]).
adjMapping2SUMO('01302137-s',[ ('',undefined)]).
adjMapping2SUMO('01302368-a',[ ('GeopoliticalArea',subsumption)]).
adjMapping2SUMO('01302544-s',[ ('GeopoliticalArea',subsumption)]).
adjMapping2SUMO('01302699-s',[ (causes,subsumption)]).
adjMapping2SUMO('01302811-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01303042-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01303298-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01303449-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01303544-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01303636-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01303776-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01303946-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01304081-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01304250-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01304374-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01304570-a',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('01304802-s',[ ('Guiding',subsumption)]).
adjMapping2SUMO('01305123-s',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('01305244-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01305344-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01305607-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01305704-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01305792-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01305929-a',[ (believes,subsumption)]).
adjMapping2SUMO('01306087-s',[ (believes,subsumption)]).
adjMapping2SUMO('01306273-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01306645-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01306967-s',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('01307067-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01307375-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01307571-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01307690-s',[ (knows,subsumption)]).
adjMapping2SUMO('01307850-s',[ (knows,subsumption)]).
adjMapping2SUMO('01308089-s',[ (knows,subsumption)]).
adjMapping2SUMO('01308259-s',[ ('Reading',subsumption)]).
adjMapping2SUMO('01308425-a',[ (knows,subsumption)]).
adjMapping2SUMO('01308736-s',[ ('',undefined)]).
adjMapping2SUMO('01308894-s',[ (knows,subsumption)]).
adjMapping2SUMO('01309220-s',[ (knows,subsumption)]).
adjMapping2SUMO('01309428-s',[ (knows,subsumption)]).
adjMapping2SUMO('01309526-s',[ (knows,subsumption)]).
adjMapping2SUMO('01309657-s',[ (knows,subsumption)]).
adjMapping2SUMO('01309835-s',[ ('Reading',not(subsumption))]).
adjMapping2SUMO('01309991-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01310273-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01310545-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01310685-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01311067-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01311321-a',[ (inhabits,subsumption)]).
adjMapping2SUMO('01311605-s',[ (inhabits,subsumption)]).
adjMapping2SUMO('01311705-s',[ (inhabits,subsumption)]).
adjMapping2SUMO('01311814-s',[ (inhabits,subsumption)]).
adjMapping2SUMO('01311973-s',[ (inhabits,subsumption)]).
adjMapping2SUMO('01312105-s',[ (inhabits,subsumption)]).
adjMapping2SUMO('01312215-s',[ (inhabits,subsumption)]).
adjMapping2SUMO('01312376-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01312466-s',[ ('',undefined)]).
adjMapping2SUMO('01312567-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01312739-a',[ (inhabits,subsumption)]).
adjMapping2SUMO('01313004-s',[ (inhabits,subsumption)]).
adjMapping2SUMO('01313178-s',[ (inhabits,subsumption)]).
adjMapping2SUMO('01313346-s',[ (inhabits,subsumption)]).
adjMapping2SUMO('01313525-s',[ (inhabits,subsumption)]).
adjMapping2SUMO('01313649-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01313835-s',[ (inhabits,subsumption)]).
adjMapping2SUMO('01313929-a',[ (capability,subsumption)]).
adjMapping2SUMO('01314197-s',[ ('Getting',subsumption)]).
adjMapping2SUMO('01314537-s',[ (familyRelation,subsumption)]).
adjMapping2SUMO('01314863-s',[ ('',undefined)]).
adjMapping2SUMO('01315025-s',[ ('',undefined)]).
adjMapping2SUMO('01315249-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('01315339-s',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('01315507-a',[ (capability,subsumption)]).
adjMapping2SUMO('01315670-s',[ ('Getting',subsumption)]).
adjMapping2SUMO('01315844-s',[ (attribute,subsumption)]).
adjMapping2SUMO('01316019-s',[ (capability,subsumption)]).
adjMapping2SUMO('01316127-s',[ (causes,subsumption)]).
adjMapping2SUMO('01316222-a',[ (inhibits,equivalence)]).
adjMapping2SUMO('01316467-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01316808-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01317012-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01317231-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01317362-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01317462-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01317560-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01317678-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01317831-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01317954-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01318252-s',[ ('Injuring',subsumption)]).
adjMapping2SUMO('01318330-s',[ ('Injuring',subsumption)]).
adjMapping2SUMO('01318510-s',[ ('Detaching',subsumption)]).
adjMapping2SUMO('01318659-s',[ ('',undefined)]).
adjMapping2SUMO('01318741-s',[ ('Injuring',subsumption)]).
adjMapping2SUMO('01318937-s',[ ('Injuring',subsumption)]).
adjMapping2SUMO('01319061-s',[ ('Injuring',subsumption)]).
adjMapping2SUMO('01319182-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01319434-s',[ ('Female',subsumption)]).
adjMapping2SUMO('01319583-s',[ ('Cutting',not(subsumption))]).
adjMapping2SUMO('01319712-s',[ ('Injuring',not(subsumption))]).
adjMapping2SUMO('01319807-s',[ ('Injuring',not(subsumption))]).
adjMapping2SUMO('01319874-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01320184-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01320474-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01320705-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01320988-a',[ ('CriminalAction',equivalence)]).
adjMapping2SUMO('01321429-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01321529-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01321939-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01322044-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01322236-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01322323-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01322488-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01322621-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01322702-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01322846-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01322959-s',[ ('',undefined)]).
adjMapping2SUMO('01323096-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01323207-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01323334-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01323449-a',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('01323815-s',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('01323962-s',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('01324131-s',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('01324271-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01324424-s',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('01324565-s',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('01324683-s',[ ('Text',subsumption)]).
adjMapping2SUMO('01324870-s',[ ('Text',subsumption)]).
adjMapping2SUMO('01325017-s',[ ('Text',subsumption)]).
adjMapping2SUMO('01325193-s',[ ('',undefined)]).
adjMapping2SUMO('01325273-s',[ ('',undefined)]).
adjMapping2SUMO('01325372-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01325451-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01325691-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01325777-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01326013-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01326148-a',[ ('Organization',subsumption)]).
adjMapping2SUMO('01326415-s',[ ('Organization',subsumption)]).
adjMapping2SUMO('01326516-s',[ ('Organization',subsumption)]).
adjMapping2SUMO('01326652-s',[ ('Organization',subsumption)]).
adjMapping2SUMO('01326805-s',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('01326917-a',[ ('Organization',subsumption)]).
adjMapping2SUMO('01327205-s',[ ('Confining',subsumption)]).
adjMapping2SUMO('01327371-s',[ ('OrganizationalProcess',subsumption)]).
adjMapping2SUMO('01327574-s',[ ('Confining',subsumption)]).
adjMapping2SUMO('01327680-s',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('01327925-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01328229-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01328419-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01328604-s',[ ('Combining',subsumption)]).
adjMapping2SUMO('01328753-s',[ ('PsychologicalProcess',subsumption)]).
adjMapping2SUMO('01328877-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01329007-a',[ ('Combining',not(subsumption))]).
adjMapping2SUMO('01329138-a',[ ('Combining',subsumption)]).
adjMapping2SUMO('01329306-s',[ ('Mixture',subsumption)]).
adjMapping2SUMO('01329413-s',[ ('Combining',subsumption)]).
adjMapping2SUMO('01329616-a',[ ('Combining',not(subsumption))]).
adjMapping2SUMO('01329719-s',[ ('Combining',not(subsumption))]).
adjMapping2SUMO('01329830-a',[ ('Combining',equivalence)]).
adjMapping2SUMO('01330008-s',[ ('ChemicalSynthesis',equivalence)]).
adjMapping2SUMO('01330114-s',[ (part,subsumption)]).
adjMapping2SUMO('01330307-s',[ (piece,subsumption)]).
adjMapping2SUMO('01330506-s',[ ('Combining',subsumption)]).
adjMapping2SUMO('01330662-s',[ ('Combining',subsumption)]).
adjMapping2SUMO('01330786-a',[ ('Combining',not(subsumption))]).
adjMapping2SUMO('01330890-s',[ ('ChemicalSynthesis',not(subsumption))]).
adjMapping2SUMO('01330986-a',[ ('Combining',subsumption)]).
adjMapping2SUMO('01331244-s',[ ('Combining',subsumption)]).
adjMapping2SUMO('01331459-s',[ ('Combining',subsumption)]).
adjMapping2SUMO('01331540-s',[ ('Combining',subsumption)]).
adjMapping2SUMO('01331675-s',[ (origin,subsumption)]).
adjMapping2SUMO('01331878-a',[ ('Separating',subsumption)]).
adjMapping2SUMO('01332070-s',[ ('',undefined)]).
adjMapping2SUMO('01332285-s',[ ('ChemicalDecomposition',subsumption)]).
adjMapping2SUMO('01332386-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01332907-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01333118-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01333331-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01333477-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01333609-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01333718-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01333886-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01334075-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01334277-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01334398-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01334833-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01334958-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01335156-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01335458-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01335708-s',[ ('',undefined)]).
adjMapping2SUMO('01335903-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01336084-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01336231-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01336371-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01336587-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01336837-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01336926-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01337121-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01337314-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01337486-a',[ ('IntentionalProcess',subsumption)]).
adjMapping2SUMO('01337767-s',[ ('IntentionalProcess',subsumption)]).
adjMapping2SUMO('01337939-s',[ ('Planning',subsumption)]).
adjMapping2SUMO('01338116-s',[ ('IntentionalProcess',subsumption)]).
adjMapping2SUMO('01338363-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01338730-a',[ (hasPurposeForAgent,subsumption)]).
adjMapping2SUMO('01338909-s',[ ('IntentionalProcess',not(subsumption))]).
adjMapping2SUMO('01339203-s',[ (causes,subsumption)]).
adjMapping2SUMO('01339492-s',[ ('IntentionalProcess',not(subsumption))]).
adjMapping2SUMO('01339730-a',[ ('Designing',equivalence)]).
adjMapping2SUMO('01340016-s',[ ('Designing',subsumption)]).
adjMapping2SUMO('01340147-a',[ ('Designing',not(subsumption))]).
adjMapping2SUMO('01340256-a',[ ('Increasing',subsumption)]).
adjMapping2SUMO('01340422-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01340522-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('01340691-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('01340875-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01340990-a',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('01341153-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01341490-s',[ (capability,subsumption)]).
adjMapping2SUMO('01341731-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01341822-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01341920-a',[ ('BiologicalProcess',subsumption)]).
adjMapping2SUMO('01342058-a',[ ('BiologicalProcess',subsumption)]).
adjMapping2SUMO('01342237-a',[ (inScopeOfInterest,equivalence)]).
adjMapping2SUMO('01342572-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01342759-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01342949-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01343200-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01343411-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01343679-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01343918-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01344171-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01344344-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01344485-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01344684-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01344834-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01344963-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01345307-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01345997-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01346198-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01346343-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01346538-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01346650-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01346755-a',[ ('OrganizationalProcess',subsumption)]).
adjMapping2SUMO('01346978-s',[ ('OrganizationalProcess',subsumption)]).
adjMapping2SUMO('01347138-a',[ ('OrganizationalProcess',subsumption)]).
adjMapping2SUMO('01347348-s',[ ('OrganizationalProcess',subsumption)]).
adjMapping2SUMO('01347492-s',[ ('OrganizationalProcess',subsumption)]).
adjMapping2SUMO('01347613-s',[ ('OrganizationalProcess',subsumption)]).
adjMapping2SUMO('01347749-s',[ ('OrganizationalProcess',not(subsumption))]).
adjMapping2SUMO('01347935-a',[ (holdsRight,subsumption)]).
adjMapping2SUMO('01348083-a',[ (holdsRight,subsumption)]).
adjMapping2SUMO('01348258-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01348528-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01348835-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01349041-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01349435-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01349760-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01349927-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01350225-s',[ (located,subsumption)]).
adjMapping2SUMO('01350494-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01350674-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01350876-a',[ ('IntentionalPsychologicalProcess',subsumption)]).
adjMapping2SUMO('01351021-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01351302-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01351391-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01351637-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01351837-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01351922-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01352067-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01352320-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01352561-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01352895-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01353014-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('01353153-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01353226-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('01353516-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01353618-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01353866-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01353982-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01354308-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01354430-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01354581-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01354750-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01354925-a',[ (capability,subsumption)]).
adjMapping2SUMO('01355089-a',[ ('Water',equivalence)]).
adjMapping2SUMO('01355207-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('01355378-s',[ ('Mineral',subsumption)]).
adjMapping2SUMO('01355556-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('01355746-s',[ ('Mineral',subsumption)]).
adjMapping2SUMO('01355966-a',[ ('PathologicProcess',subsumption)]).
adjMapping2SUMO('01356143-s',[ ('PathologicProcess',subsumption)]).
adjMapping2SUMO('01356283-a',[ ('PathologicProcess',not(subsumption))]).
adjMapping2SUMO('01356365-a',[ ('TherapeuticProcess',subsumption)]).
adjMapping2SUMO('01356515-a',[ ('TherapeuticProcess',subsumption)]).
adjMapping2SUMO('01356683-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01356932-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01357027-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01357206-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01357342-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01357484-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01357742-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01357966-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01358096-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01358231-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01358363-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01358534-s',[ ('Requesting',subsumption)]).
adjMapping2SUMO('01358695-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01358846-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01359035-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01359159-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01359277-a',[ (located,subsumption)]).
adjMapping2SUMO('01359424-a',[ (located,subsumption)]).
adjMapping2SUMO('01359543-a',[ ('Smooth',equivalence)]).
adjMapping2SUMO('01359697-s',[ ('ShapeChange',subsumption)]).
adjMapping2SUMO('01359771-s',[ ('Smooth',equivalence)]).
adjMapping2SUMO('01359861-a',[ ('ShapeChange',not(subsumption))]).
adjMapping2SUMO('01360085-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('01360231-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01360321-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01360413-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01360571-s',[ ('ShapeChange',not(subsumption))]).
adjMapping2SUMO('01360692-a',[ ('ShapeChange',not(subsumption))]).
adjMapping2SUMO('01360804-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('01360962-s',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('01361107-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('01361264-s',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('01361414-a',[ ('Happiness',equivalence)]).
adjMapping2SUMO('01361705-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01361863-a',[ ('Unhappiness',subsumption)]).
adjMapping2SUMO('01362273-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01362387-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01362598-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01362684-s',[ ('Unhappiness',subsumption)]).
adjMapping2SUMO('01362950-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01363153-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01363370-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01363613-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01363824-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01363936-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01364008-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01364585-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01364817-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01364993-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01365103-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01365239-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('01365407-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('01365544-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01365785-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('01366062-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01366157-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('01366277-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('01366525-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01366718-a',[ ('Happiness',subsumption)]).
adjMapping2SUMO('01367008-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01367211-s',[ ('Happiness',subsumption)]).
adjMapping2SUMO('01367431-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01367651-s',[ ('Happiness',subsumption)]).
adjMapping2SUMO('01368192-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01368464-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01368657-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01368726-s',[ ('BodyMotion',not(subsumption))]).
adjMapping2SUMO('01368793-a',[ (part,subsumption)]).
adjMapping2SUMO('01368948-s',[ ('',undefined)]).
adjMapping2SUMO('01369078-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01369274-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01369404-a',[ (part,subsumption)]).
adjMapping2SUMO('01369491-s',[ (part,subsumption)]).
adjMapping2SUMO('01369663-a',[ ('ObjectiveNorm',subsumption)]).
adjMapping2SUMO('01370053-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01370141-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01370305-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01370475-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01370590-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01370864-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01371009-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01371137-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01371258-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01371397-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01371553-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01371646-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01371769-a',[ (part,subsumption)]).
adjMapping2SUMO('01371911-a',[ (part,subsumption)]).
adjMapping2SUMO('01372049-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01372568-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01372773-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01372948-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01373314-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01373545-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01373728-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01374004-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01374183-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01374361-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('01374461-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01374582-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01374789-a',[ ('',undefined)]).
adjMapping2SUMO('01374912-s',[ (knows,subsumption)]).
adjMapping2SUMO('01375174-a',[ (knows,equivalence)]).
adjMapping2SUMO('01375546-s',[ (knows,subsumption)]).
adjMapping2SUMO('01375689-s',[ ('',undefined)]).
adjMapping2SUMO('01375831-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01376208-s',[ ('Classifying',subsumption)]).
adjMapping2SUMO('01376355-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01376522-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01376705-s',[ ('',undefined)]).
adjMapping2SUMO('01376894-a',[ (knows,subsumption)]).
adjMapping2SUMO('01377257-s',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('01377407-s',[ ('',undefined)]).
adjMapping2SUMO('01377488-s',[ (knows,subsumption)]).
adjMapping2SUMO('01377721-s',[ (knows,subsumption)]).
adjMapping2SUMO('01377819-s',[ (knows,subsumption)]).
adjMapping2SUMO('01377933-s',[ (knows,subsumption)]).
adjMapping2SUMO('01378088-s',[ ('Classifying',not(subsumption))]).
adjMapping2SUMO('01378219-a',[ ('Learning',subsumption)]).
adjMapping2SUMO('01378429-s',[ ('Learning',subsumption)]).
adjMapping2SUMO('01378671-s',[ ('Learning',subsumption)]).
adjMapping2SUMO('01378878-a',[ ('Learning',not(subsumption))]).
adjMapping2SUMO('01379116-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01379251-s',[ ('Learning',not(subsumption))]).
adjMapping2SUMO('01379361-s',[ ('Learning',not(subsumption))]).
adjMapping2SUMO('01379562-s',[ ('Learning',not(subsumption))]).
adjMapping2SUMO('01379705-a',[ (part,subsumption)]).
adjMapping2SUMO('01379844-a',[ (part,subsumption)]).
adjMapping2SUMO('01379988-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01380127-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01380267-a',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('01380571-s',[ (capability,equivalence)]).
adjMapping2SUMO('01380721-a',[ ('WaterArea',subsumption)]).
adjMapping2SUMO('01380926-s',[ ('WaterArea',subsumption)]).
adjMapping2SUMO('01381074-s',[ ('Transportation',subsumption)]).
adjMapping2SUMO('01381196-s',[ ('WaterArea',subsumption)]).
adjMapping2SUMO('01381340-s',[ ('WaterArea',subsumption)]).
adjMapping2SUMO('01381473-s',[ (located,subsumption)]).
adjMapping2SUMO('01381615-s',[ ('Below',subsumption)]).
adjMapping2SUMO('01381777-a',[ ('Giving',subsumption)]).
adjMapping2SUMO('01381907-a',[ ('Giving',not(subsumption))]).
adjMapping2SUMO('01382086-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01383394-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01383582-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01383684-s',[ ('',undefined)]).
adjMapping2SUMO('01383756-s',[ (larger,subsumption)]).
adjMapping2SUMO('01383857-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01383935-s',[ (larger,subsumption)]).
adjMapping2SUMO('01384081-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01384212-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01384438-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01384572-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01384730-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01385046-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01385149-s',[ (capability,subsumption)]).
adjMapping2SUMO('01385255-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01385663-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01385773-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01386010-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01386234-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01386538-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01386883-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01387149-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01387319-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01387902-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01388062-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('01388228-s',[ ('AreaMeasure',subsumption)]).
adjMapping2SUMO('01388327-s',[ ('',undefined)]).
adjMapping2SUMO('01388418-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01388542-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01388655-s',[ (equal,subsumption)]).
adjMapping2SUMO('01388809-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('01388928-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01389022-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01389170-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01389451-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01389634-s',[ ('',undefined)]).
adjMapping2SUMO('01389738-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01389846-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01389993-s',[ ('Oversized',equivalence)]).
adjMapping2SUMO('01390130-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01390215-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01390344-s',[ ('AreaMeasure',subsumption)]).
adjMapping2SUMO('01390487-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01390588-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01390683-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01390778-s',[ ('',undefined)]).
adjMapping2SUMO('01390900-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01391074-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01391237-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01391351-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01392071-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01392160-s',[ ('SubatomicParticle',subsumption)]).
adjMapping2SUMO('01392249-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01392633-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01392896-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01393024-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01393141-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01393311-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01393397-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01393483-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01393681-s',[ (smaller,subsumption)]).
adjMapping2SUMO('01393822-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01393976-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01394075-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01394180-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01394316-s',[ ('',undefined)]).
adjMapping2SUMO('01394400-s',[ ('',undefined)]).
adjMapping2SUMO('01394558-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01394744-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01394922-s',[ (smaller,equivalence)]).
adjMapping2SUMO('01395028-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01395095-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01395229-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01395330-a',[ (greaterThan,equivalence)]).
adjMapping2SUMO('01395488-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01395617-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01395821-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01396047-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01396333-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01396503-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01396628-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01396800-a',[ ('Solution',subsumption)]).
adjMapping2SUMO('01396931-s',[ ('Solution',subsumption)]).
adjMapping2SUMO('01397125-a',[ ('Solution',subsumption)]).
adjMapping2SUMO('01397251-s',[ ('Solution',subsumption)]).
adjMapping2SUMO('01397385-a',[ (capability,subsumption)]).
adjMapping2SUMO('01397674-s',[ (capability,subsumption)]).
adjMapping2SUMO('01397786-s',[ (capability,subsumption)]).
adjMapping2SUMO('01397892-s',[ (capability,subsumption)]).
adjMapping2SUMO('01397998-s',[ (capability,subsumption)]).
adjMapping2SUMO('01398199-a',[ (capability,subsumption)]).
adjMapping2SUMO('01398528-s',[ (capability,subsumption)]).
adjMapping2SUMO('01398648-s',[ ('',undefined)]).
adjMapping2SUMO('01398772-s',[ (capability,subsumption)]).
adjMapping2SUMO('01398865-s',[ (capability,subsumption)]).
adjMapping2SUMO('01398941-s',[ (capability,subsumption)]).
adjMapping2SUMO('01399096-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01399235-s',[ (capability,subsumption)]).
adjMapping2SUMO('01399328-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('01399469-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01399564-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01399671-a',[ ('Putting',not(subsumption))]).
adjMapping2SUMO('01399748-a',[ ('Food',subsumption)]).
adjMapping2SUMO('01399949-a',[ ('Food',subsumption)]).
adjMapping2SUMO('01400098-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01400237-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01400336-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01400464-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01400562-a',[ ('Law',equivalence)]).
adjMapping2SUMO('01400876-s',[ ('',undefined)]).
adjMapping2SUMO('01400961-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01401105-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01401224-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01401413-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01401532-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01401734-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01401854-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01402343-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01402498-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01402580-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01402763-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01403012-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01403151-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01403316-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01403469-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01403632-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01403760-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01404042-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('01404195-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01404370-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01404482-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01404582-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01404702-a',[ ('Text',subsumption)]).
adjMapping2SUMO('01404898-s',[ ('Text',subsumption)]).
adjMapping2SUMO('01405047-s',[ ('Text',subsumption)]).
adjMapping2SUMO('01405214-a',[ ('Text',subsumption)]).
adjMapping2SUMO('01405390-s',[ ('Text',subsumption)]).
adjMapping2SUMO('01405523-s',[ ('Text',subsumption)]).
adjMapping2SUMO('01405693-a',[ ('Decoding',subsumption)]).
adjMapping2SUMO('01405797-a',[ ('Decoding',not(subsumption))]).
adjMapping2SUMO('01405904-a',[ (familyRelation,subsumption)]).
adjMapping2SUMO('01406058-s',[ (familyRelation,subsumption)]).
adjMapping2SUMO('01406180-s',[ (familyRelation,subsumption)]).
adjMapping2SUMO('01406263-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01406418-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01406640-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01406853-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01406961-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01407267-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01407465-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01407738-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01407816-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01407909-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01408135-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01408240-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01408421-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01408593-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01408738-a',[ ('',undefined)]).
adjMapping2SUMO('01408929-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01409221-a',[ ('Fern',subsumption)]).
adjMapping2SUMO('01409379-a',[ ('Fern',subsumption)]).
adjMapping2SUMO('01409581-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01410036-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01410118-s',[ ('',undefined)]).
adjMapping2SUMO('01410222-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01410363-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01410606-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01410905-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01411065-a',[ (equal,equivalence)]).
adjMapping2SUMO('01411291-a',[ (equal,subsumption)]).
adjMapping2SUMO('01411451-a',[ ('Likely',equivalence)]).
adjMapping2SUMO('01411919-s',[ ('Likely',subsumption)]).
adjMapping2SUMO('01412134-s',[ ('Likely',subsumption)]).
adjMapping2SUMO('01412286-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01412415-a',[ ('Unlikely',equivalence)]).
adjMapping2SUMO('01412721-s',[ ('Unlikely',subsumption)]).
adjMapping2SUMO('01412912-s',[ ('Unlikely',subsumption)]).
adjMapping2SUMO('01413084-s',[ ('Unlikely',subsumption)]).
adjMapping2SUMO('01413247-a',[ ('Likely',subsumption)]).
adjMapping2SUMO('01413501-s',[ (equal,subsumption)]).
adjMapping2SUMO('01413576-s',[ ('Likely',subsumption)]).
adjMapping2SUMO('01413763-s',[ ('Likely',subsumption)]).
adjMapping2SUMO('01413871-a',[ ('Unlikely',subsumption)]).
adjMapping2SUMO('01414137-s',[ ('False',subsumption)]).
adjMapping2SUMO('01414250-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01414488-s',[ ('',undefined)]).
adjMapping2SUMO('01414566-s',[ ('',undefined)]).
adjMapping2SUMO('01414663-s',[ ('',undefined)]).
adjMapping2SUMO('01414740-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01414817-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('01414938-s',[ ('',undefined)]).
adjMapping2SUMO('01415021-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01415219-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01415480-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01415605-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01415917-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01416081-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01416255-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01416508-a',[ (familyRelation,subsumption)]).
adjMapping2SUMO('01416809-s',[ (familyRelation,subsumption)]).
adjMapping2SUMO('01416959-s',[ (familyRelation,subsumption)]).
adjMapping2SUMO('01417105-s',[ (familyRelation,subsumption)]).
adjMapping2SUMO('01417228-a',[ (familyRelation,subsumption)]).
adjMapping2SUMO('01417451-a',[ ('Relation',subsumption)]).
adjMapping2SUMO('01417678-s',[ ('Relation',subsumption)]).
adjMapping2SUMO('01417790-a',[ ('Relation',subsumption)]).
adjMapping2SUMO('01417941-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01418104-s',[ ('',undefined)]).
adjMapping2SUMO('01418181-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01418288-a',[ (inList,equivalence)]).
adjMapping2SUMO('01418350-a',[ (inList,subsumption)]).
adjMapping2SUMO('01418486-s',[ (part,subsumption)]).
adjMapping2SUMO('01418647-s',[ ('Certificate',subsumption)]).
adjMapping2SUMO('01418789-a',[ ('ContentDevelopment',subsumption)]).
adjMapping2SUMO('01418989-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('01419149-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('01419462-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01419638-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('01419784-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01419999-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('01420337-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01420488-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('01420899-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('01421077-a',[ (capability,subsumption)]).
adjMapping2SUMO('01421249-s',[ ('Text',subsumption)]).
adjMapping2SUMO('01421368-s',[ (knows,subsumption)]).
adjMapping2SUMO('01421491-a',[ (capability,subsumption)]).
adjMapping2SUMO('01421602-a',[ (capability,subsumption)]).
adjMapping2SUMO('01421679-a',[ (capability,subsumption)]).
adjMapping2SUMO('01421887-s',[ (capability,subsumption)]).
adjMapping2SUMO('01422098-s',[ (capability,subsumption)]).
adjMapping2SUMO('01422243-s',[ (capability,subsumption)]).
adjMapping2SUMO('01422354-s',[ (capability,subsumption)]).
adjMapping2SUMO('01422468-s',[ (capability,subsumption)]).
adjMapping2SUMO('01422556-a',[ (cooccur,subsumption)]).
adjMapping2SUMO('01422863-s',[ ('ContentDevelopment',not(subsumption))]).
adjMapping2SUMO('01422956-a',[ ('ContentDevelopment',subsumption)]).
adjMapping2SUMO('01423187-s',[ ('ContentDevelopment',subsumption)]).
adjMapping2SUMO('01423344-s',[ ('ContentDevelopment',subsumption)]).
adjMapping2SUMO('01423491-s',[ ('ContentDevelopment',subsumption)]).
adjMapping2SUMO('01423592-s',[ ('ContentDevelopment',subsumption)]).
adjMapping2SUMO('01423676-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01423851-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01423998-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01424156-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01424238-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01424353-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01424455-a',[ ('Weapon',subsumption)]).
adjMapping2SUMO('01424596-s',[ ('Weapon',subsumption)]).
adjMapping2SUMO('01424706-s',[ ('Weapon',subsumption)]).
adjMapping2SUMO('01424868-a',[ ('Weapon',subsumption)]).
adjMapping2SUMO('01425056-s',[ ('Weapon',subsumption)]).
adjMapping2SUMO('01425154-s',[ ('Weapon',subsumption)]).
adjMapping2SUMO('01425300-a',[ (part,subsumption)]).
adjMapping2SUMO('01425435-a',[ (part,subsumption)]).
adjMapping2SUMO('01425529-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01425708-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01425895-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01426077-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01426273-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01426375-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01426749-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01427010-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01427188-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01427333-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01427602-a',[ ('',undefined)]).
adjMapping2SUMO('01427757-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01428122-s',[ ('',undefined)]).
adjMapping2SUMO('01428282-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01428389-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01428509-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01428581-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01428767-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01428838-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01428972-a',[ ('Guiding',subsumption)]).
adjMapping2SUMO('01429138-s',[ ('Guiding',subsumption)]).
adjMapping2SUMO('01429260-s',[ ('Guiding',subsumption)]).
adjMapping2SUMO('01429359-a',[ ('Guiding',not(subsumption))]).
adjMapping2SUMO('01429485-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01429676-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01429788-s',[ ('',undefined)]).
adjMapping2SUMO('01429870-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01430009-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('01430111-a',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('01430452-s',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('01430628-s',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('01430716-s',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('01430847-a',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('01431112-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01431369-s',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('01431471-s',[ ('PsychologicalProcess',subsumption)]).
adjMapping2SUMO('01431638-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01431938-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01432070-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01432202-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01432318-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01432452-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01432605-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01432712-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01432894-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01433081-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01433267-a',[ ('',undefined)]).
adjMapping2SUMO('01433386-a',[ ('',undefined)]).
adjMapping2SUMO('01433493-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01434007-s',[ (larger,subsumption)]).
adjMapping2SUMO('01434218-s',[ (larger,subsumption)]).
adjMapping2SUMO('01434530-s',[ (capability,subsumption)]).
adjMapping2SUMO('01434717-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01434841-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01434966-s',[ ('',undefined)]).
adjMapping2SUMO('01435060-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01435189-s',[ ('',undefined)]).
adjMapping2SUMO('01435290-s',[ ('',undefined)]).
adjMapping2SUMO('01435399-s',[ ('',undefined)]).
adjMapping2SUMO('01435507-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01435675-s',[ ('Word',subsumption)]).
adjMapping2SUMO('01435891-s',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('01436003-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01436432-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01436567-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01436671-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01436791-s',[ ('Cutting',subsumption)]).
adjMapping2SUMO('01436968-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01437037-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01437165-s',[ ('',undefined)]).
adjMapping2SUMO('01437268-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01437349-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01437472-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01437752-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01437963-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01438743-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01438853-s',[ ('TimeDuration',subsumption)]).
adjMapping2SUMO('01438963-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01439072-s',[ ('TimeDuration',subsumption)]).
adjMapping2SUMO('01439155-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01439496-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01439706-s',[ ('',undefined)]).
adjMapping2SUMO('01439784-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01440058-s',[ ('',undefined)]).
adjMapping2SUMO('01440159-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01440331-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01440422-s',[ ('Certificate',subsumption)]).
adjMapping2SUMO('01440574-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01440641-s',[ ('',undefined)]).
adjMapping2SUMO('01440776-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01440889-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01441000-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01441271-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01441418-s',[ ('',undefined)]).
adjMapping2SUMO('01441530-s',[ ('TimeDuration',subsumption)]).
adjMapping2SUMO('01441729-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01441866-s',[ ('',undefined)]).
adjMapping2SUMO('01441965-s',[ ('',undefined)]).
adjMapping2SUMO('01442079-s',[ ('YearDuration',equivalence)]).
adjMapping2SUMO('01442186-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01442597-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01442826-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01442974-s',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('01443097-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01443402-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01443581-s',[ ('Certificate',subsumption)]).
adjMapping2SUMO('01443733-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01443842-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01444022-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01444230-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01444434-a',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01444620-a',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01444813-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01445063-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01445184-s',[ ('',undefined)]).
adjMapping2SUMO('01445320-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01445438-s',[ ('Measuring',subsumption)]).
adjMapping2SUMO('01445558-s',[ ('Measuring',subsumption)]).
adjMapping2SUMO('01445705-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01445917-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01446240-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('01446457-a',[ ('Covering',subsumption)]).
adjMapping2SUMO('01446632-a',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('01446749-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01446991-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01447178-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01447302-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01447683-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01447781-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01447937-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01448058-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01448178-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01448362-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01448456-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01448697-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('01448861-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01449007-s',[ ('',undefined)]).
adjMapping2SUMO('01449184-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01449354-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01449564-a',[ (capability,subsumption)]).
adjMapping2SUMO('01449884-s',[ (capability,subsumption)]).
adjMapping2SUMO('01450084-s',[ (possesses,subsumption)]).
adjMapping2SUMO('01450178-s',[ (capability,subsumption)]).
adjMapping2SUMO('01450293-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01450443-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01450607-s',[ (capability,subsumption)]).
adjMapping2SUMO('01450713-a',[ ('Learning',subsumption)]).
adjMapping2SUMO('01450888-s',[ ('Learning',subsumption)]).
adjMapping2SUMO('01450969-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01451225-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01451402-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01451498-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01451768-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01451850-s',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01451937-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01452024-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01452138-s',[ (capability,subsumption)]).
adjMapping2SUMO('01452266-a',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('01452385-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('01452488-a',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('01452593-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01453084-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01453187-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01453381-s',[ ('',undefined)]).
adjMapping2SUMO('01453467-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01453625-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01453719-s',[ ('',undefined)]).
adjMapping2SUMO('01453809-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01453896-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01453984-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01454244-s',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('01454402-s',[ ('',undefined)]).
adjMapping2SUMO('01454494-s',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('01454636-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01454985-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01455221-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01455412-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01455540-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('01455732-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01455888-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01456038-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01456221-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01456487-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01456572-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01456710-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01456977-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01457079-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01457234-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01457369-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01457486-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01457692-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01457871-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01458054-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01458200-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01458303-a',[ ('Music',subsumption)]).
adjMapping2SUMO('01458490-s',[ ('Music',subsumption)]).
adjMapping2SUMO('01458619-s',[ ('Music',subsumption)]).
adjMapping2SUMO('01458736-a',[ ('Music',subsumption)]).
adjMapping2SUMO('01458941-s',[ ('Music',subsumption)]).
adjMapping2SUMO('01459058-s',[ ('Music',subsumption)]).
adjMapping2SUMO('01459158-a',[ ('StateChange',subsumption)]).
adjMapping2SUMO('01459295-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01459422-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01459755-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01459949-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01460266-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01460421-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01460679-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01460982-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01461138-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01461292-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01461455-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01461597-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01461680-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01461822-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01462046-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01462124-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01462324-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01462461-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01462625-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01462882-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01463137-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01463326-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01463414-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01463537-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01463642-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('01463735-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01463869-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01463965-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01464433-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01464700-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01465061-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01465214-s',[ ('RomanticAttribute',equivalence)]).
adjMapping2SUMO('01465468-s',[ ('Building',subsumption)]).
adjMapping2SUMO('01465583-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01465668-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01465922-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01466038-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01466136-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01466207-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01466305-s',[ ('',undefined)]).
adjMapping2SUMO('01466476-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01466593-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01466775-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01466956-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01467046-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01467184-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01467298-a',[ ('Character',subsumption)]).
adjMapping2SUMO('01467534-s',[ ('Character',subsumption)]).
adjMapping2SUMO('01467700-a',[ ('Character',subsumption)]).
adjMapping2SUMO('01467919-s',[ ('Character',subsumption)]).
adjMapping2SUMO('01468097-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01468319-s',[ ('',undefined)]).
adjMapping2SUMO('01468420-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01468552-s',[ ('',undefined)]).
adjMapping2SUMO('01468682-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01468850-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01468994-a',[ ('Music',subsumption)]).
adjMapping2SUMO('01469161-a',[ ('Music',subsumption)]).
adjMapping2SUMO('01469390-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('01469516-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('01469677-a',[ (capability,subsumption)]).
adjMapping2SUMO('01469927-s',[ (capability,subsumption)]).
adjMapping2SUMO('01470141-a',[ (capability,subsumption)]).
adjMapping2SUMO('01470298-a',[ ('DirectionalAttribute',subsumption)]).
adjMapping2SUMO('01470496-a',[ ('DirectionalAttribute',subsumption)]).
adjMapping2SUMO('01470649-s',[ ('DirectionalAttribute',subsumption)]).
adjMapping2SUMO('01470813-a',[ (capability,subsumption)]).
adjMapping2SUMO('01470913-a',[ (capability,subsumption)]).
adjMapping2SUMO('01471002-a',[ (greaterThan,subsumption)]).
adjMapping2SUMO('01471260-s',[ (greaterThan,subsumption)]).
adjMapping2SUMO('01471368-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01471538-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01471723-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01471848-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01471954-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01472098-a',[ ('Music',subsumption)]).
adjMapping2SUMO('01472225-a',[ ('Music',subsumption)]).
adjMapping2SUMO('01472351-a',[ ('FieldOfStudy',subsumption)]).
adjMapping2SUMO('01472509-a',[ ('FieldOfStudy',subsumption)]).
adjMapping2SUMO('01472628-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01472790-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01473083-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01473353-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01473558-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01473680-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01473826-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01473996-a',[ ('Character',subsumption)]).
adjMapping2SUMO('01474196-s',[ ('',undefined)]).
adjMapping2SUMO('01474324-a',[ ('Character',subsumption)]).
adjMapping2SUMO('01474513-a',[ (capability,subsumption)]).
adjMapping2SUMO('01474806-s',[ (capability,subsumption)]).
adjMapping2SUMO('01474942-s',[ (capability,subsumption)]).
adjMapping2SUMO('01475041-s',[ (capability,subsumption)]).
adjMapping2SUMO('01475160-s',[ (capability,subsumption)]).
adjMapping2SUMO('01475282-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01475526-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01475733-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01475831-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01476046-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01476154-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01476325-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01476516-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01476685-a',[ ('Male',equivalence)]).
adjMapping2SUMO('01477077-s',[ ('Male',subsumption)]).
adjMapping2SUMO('01477251-s',[ ('Male',subsumption)]).
adjMapping2SUMO('01477391-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01477564-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01477711-s',[ (capability,subsumption)]).
adjMapping2SUMO('01477806-a',[ ('Female',equivalence)]).
adjMapping2SUMO('01478182-s',[ ('Female',subsumption)]).
adjMapping2SUMO('01478353-s',[ ('Female',subsumption)]).
adjMapping2SUMO('01478482-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('01478626-a',[ ('SexAttribute',subsumption)]).
adjMapping2SUMO('01478907-s',[ ('SexAttribute',subsumption)]).
adjMapping2SUMO('01479025-s',[ ('SexAttribute',subsumption)]).
adjMapping2SUMO('01479181-s',[ ('SexAttribute',subsumption)]).
adjMapping2SUMO('01479376-s',[ ('SexAttribute',subsumption)]).
adjMapping2SUMO('01479509-s',[ ('SexAttribute',subsumption)]).
adjMapping2SUMO('01479715-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('01479805-a',[ ('Human',subsumption)]).
adjMapping2SUMO('01479940-a',[ ('Human',not(subsumption))]).
adjMapping2SUMO('01480080-s',[ ('Human',not(subsumption))]).
adjMapping2SUMO('01480186-a',[ ('SurfaceChange',subsumption)]).
adjMapping2SUMO('01480492-s',[ ('SurfaceChange',subsumption)]).
adjMapping2SUMO('01480603-s',[ (inhibits,subsumption)]).
adjMapping2SUMO('01480684-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01480916-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01481014-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01481135-a',[ ('SurfaceChange',not(subsumption))]).
adjMapping2SUMO('01481282-s',[ ('SurfaceChange',not(subsumption))]).
adjMapping2SUMO('01481402-a',[ ('SurfaceChange',subsumption)]).
adjMapping2SUMO('01481513-a',[ ('SurfaceChange',not(subsumption))]).
adjMapping2SUMO('01481612-a',[ (spouse,equivalence)]).
adjMapping2SUMO('01481812-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01481932-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01482020-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('01482140-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01482228-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01482551-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01482658-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01482751-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01482865-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01482956-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01483076-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01483143-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01483251-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01483324-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01483562-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01483677-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01483950-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01484083-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01484342-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01484451-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01484651-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01484814-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01484987-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01485254-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01485401-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01485502-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01485708-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01485828-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01485971-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01486084-a',[ ('Word',subsumption)]).
adjMapping2SUMO('01486197-a',[ ('Word',subsumption)]).
adjMapping2SUMO('01486327-a',[ ('Word',subsumption)]).
adjMapping2SUMO('01486489-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01486704-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01486854-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01486960-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01487048-s',[ ('',undefined)]).
adjMapping2SUMO('01487201-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01487352-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01487496-s',[ ('Relation',subsumption)]).
adjMapping2SUMO('01487627-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01487943-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01488066-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01488245-a',[ ('FullyFormed',equivalence)]).
adjMapping2SUMO('01488616-s',[ ('FullyFormed',subsumption)]).
adjMapping2SUMO('01488856-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01489006-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01489085-s',[ ('FullyFormed',subsumption)]).
adjMapping2SUMO('01489207-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01489325-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01489454-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01489557-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01489722-a',[ ('NonFullyFormed',equivalence)]).
adjMapping2SUMO('01490061-s',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('01490257-s',[ ('Embryonic',equivalence)]).
adjMapping2SUMO('01490505-s',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('01490603-s',[ ('Larval',equivalence)]).
adjMapping2SUMO('01490855-s',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('01491067-s',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('01491240-s',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('01491541-s',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('01491691-s',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('01491775-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01491930-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01492061-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01492257-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01492394-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01492596-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01492907-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01493016-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01493173-a',[ ('FullyFormed',subsumption)]).
adjMapping2SUMO('01493423-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01493636-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01493807-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01493897-a',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('01494146-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01494273-a',[ ('TimeDuration',subsumption)]).
adjMapping2SUMO('01494429-a',[ ('TimeDuration',subsumption)]).
adjMapping2SUMO('01494586-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01494740-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01494959-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('01495066-s',[ ('Substance',subsumption)]).
adjMapping2SUMO('01495181-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('01495298-s',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('01495381-a',[ ('Human',subsumption)]).
adjMapping2SUMO('01495535-a',[ ('Human',subsumption)]).
adjMapping2SUMO('01495725-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01495912-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01496021-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01496311-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01496462-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01496592-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01496816-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01496976-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01497245-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01497387-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01497594-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01497736-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01498084-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01498298-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01498418-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01498594-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01498769-a',[ (capability,subsumption)]).
adjMapping2SUMO('01498957-a',[ (capability,subsumption)]).
adjMapping2SUMO('01499155-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01499269-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01499457-a',[ ('Food',subsumption)]).
adjMapping2SUMO('01499602-a',[ ('Food',subsumption)]).
adjMapping2SUMO('01499686-a',[ ('Device',subsumption)]).
adjMapping2SUMO('01499999-s',[ ('Machine',subsumption)]).
adjMapping2SUMO('01500247-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01500416-s',[ (believes,subsumption)]).
adjMapping2SUMO('01500555-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01500672-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01500766-a',[ ('Device',subsumption)]).
adjMapping2SUMO('01500876-s',[ (believes,subsumption)]).
adjMapping2SUMO('01500952-s',[ ('Device',not(subsumption))]).
adjMapping2SUMO('01501113-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01501505-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01501619-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01501718-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01501821-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01501990-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01502099-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01502195-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01502383-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01502507-a',[ ('',undefined)]).
adjMapping2SUMO('01502796-s',[ ('',undefined)]).
adjMapping2SUMO('01502925-s',[ ('',undefined)]).
adjMapping2SUMO('01503052-s',[ ('',undefined)]).
adjMapping2SUMO('01503179-s',[ ('',undefined)]).
adjMapping2SUMO('01503375-s',[ ('',undefined)]).
adjMapping2SUMO('01503504-s',[ ('',undefined)]).
adjMapping2SUMO('01503633-s',[ ('',undefined)]).
adjMapping2SUMO('01503760-s',[ ('',undefined)]).
adjMapping2SUMO('01503886-a',[ ('',undefined)]).
adjMapping2SUMO('01503978-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('01504147-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('01504282-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01504430-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('01504531-a',[ ('Removing',not(subsumption))]).
adjMapping2SUMO('01504625-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01504926-s',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('01505041-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01505181-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01505318-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01505462-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01505619-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01505786-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01505991-a',[ ('Melting',equivalence)]).
adjMapping2SUMO('01506258-s',[ ('Melting',subsumption)]).
adjMapping2SUMO('01506385-s',[ (capability,subsumption)]).
adjMapping2SUMO('01506526-s',[ ('Melting',subsumption)]).
adjMapping2SUMO('01506661-s',[ ('Melting',subsumption)]).
adjMapping2SUMO('01506770-a',[ ('Melting',not(equivalence))]).
adjMapping2SUMO('01506945-s',[ ('Solid',subsumption)]).
adjMapping2SUMO('01507008-s',[ ('Solid',subsumption)]).
adjMapping2SUMO('01507134-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01507402-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01507808-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01507992-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01508086-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01508320-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01508444-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('01508592-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('01508719-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01509066-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01509262-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01509367-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01509527-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01510320-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01510444-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01510628-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01510798-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01510914-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01511031-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01511152-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01511292-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01511387-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01511520-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01511854-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01512142-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('01512275-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01512527-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01512645-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01512804-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01512909-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01513050-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01513376-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01513512-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01513619-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01513776-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01513951-s',[ ('Decreasing',not(subsumption))]).
adjMapping2SUMO('01514141-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01514374-a',[ ('Procedure',subsumption)]).
adjMapping2SUMO('01514598-a',[ ('Procedure',subsumption)]).
adjMapping2SUMO('01514827-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01515280-s',[ ('CaseRole',subsumption)]).
adjMapping2SUMO('01515525-s',[ ('Relation',subsumption)]).
adjMapping2SUMO('01515692-s',[ ('Relation',subsumption)]).
adjMapping2SUMO('01516014-s',[ ('Relation',subsumption)]).
adjMapping2SUMO('01516207-s',[ ('ViolentContest',subsumption)]).
adjMapping2SUMO('01516346-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01516605-s',[ ('',undefined)]).
adjMapping2SUMO('01516832-a',[ ('Relation',not(subsumption))]).
adjMapping2SUMO('01516961-s',[ ('IntentionalRelation',subsumption)]).
adjMapping2SUMO('01517081-a',[ ('MilitaryOrganization',subsumption)]).
adjMapping2SUMO('01517317-s',[ ('PoliticalOrganization',subsumption)]).
adjMapping2SUMO('01517526-s',[ ('PoliticalOrganization',subsumption)]).
adjMapping2SUMO('01517632-s',[ ('ViolentContest',subsumption)]).
adjMapping2SUMO('01517755-s',[ ('ViolentContest',subsumption)]).
adjMapping2SUMO('01517921-a',[ ('PoliticalOrganization',not(subsumption))]).
adjMapping2SUMO('01518161-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01518295-s',[ ('ViolentContest',subsumption)]).
adjMapping2SUMO('01518386-a',[ ('MilitaryOrganization',equivalence)]).
adjMapping2SUMO('01518577-s',[ (believes,subsumption)]).
adjMapping2SUMO('01518694-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01518860-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01518955-a',[ ('PoliticalOrganization',not(subsumption))]).
adjMapping2SUMO('01519167-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01519284-a',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('01519465-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01519580-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('01519673-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01519803-a',[ ('Decreasing',not(subsumption))]).
adjMapping2SUMO('01520091-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01520655-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01520908-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01521017-s',[ ('Decreasing',not(subsumption))]).
adjMapping2SUMO('01521139-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01521293-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01521427-s',[ ('Decreasing',not(subsumption))]).
adjMapping2SUMO('01521542-a',[ ('BreakabilityAttribute',subsumption)]).
adjMapping2SUMO('01521776-s',[ ('',undefined)]).
adjMapping2SUMO('01521905-s',[ ('Heating',subsumption)]).
adjMapping2SUMO('01522038-a',[ ('BreakabilityAttribute',subsumption)]).
adjMapping2SUMO('01522214-s',[ ('BreakabilityAttribute',subsumption)]).
adjMapping2SUMO('01522376-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('01522895-s',[ ('AirTransportation',subsumption)]).
adjMapping2SUMO('01522985-s',[ (capability,subsumption)]).
adjMapping2SUMO('01523136-s',[ (capability,subsumption)]).
adjMapping2SUMO('01523249-s',[ (capability,subsumption)]).
adjMapping2SUMO('01523450-s',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('01523567-s',[ (capability,subsumption)]).
adjMapping2SUMO('01523724-s',[ (capability,subsumption)]).
adjMapping2SUMO('01523968-s',[ ('Walking',subsumption)]).
adjMapping2SUMO('01524102-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01524215-s',[ (capability,subsumption)]).
adjMapping2SUMO('01524344-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01524445-s',[ (capability,subsumption)]).
adjMapping2SUMO('01524562-s',[ ('Transportation',subsumption)]).
adjMapping2SUMO('01524632-s',[ (capability,subsumption)]).
adjMapping2SUMO('01524722-s',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('01525017-s',[ ('Transportation',subsumption)]).
adjMapping2SUMO('01525116-a',[ (capability,subsumption)]).
adjMapping2SUMO('01525320-s',[ (capability,subsumption)]).
adjMapping2SUMO('01525502-s',[ (capability,subsumption)]).
adjMapping2SUMO('01525659-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01525776-a',[ (capability,subsumption)]).
adjMapping2SUMO('01525984-s',[ ('',undefined)]).
adjMapping2SUMO('01526062-s',[ ('StationaryArtifact',not(subsumption))]).
adjMapping2SUMO('01526262-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01526480-a',[ (capability,subsumption)]).
adjMapping2SUMO('01526582-a',[ (capability,subsumption)]).
adjMapping2SUMO('01526769-s',[ (capability,subsumption)]).
adjMapping2SUMO('01526905-s',[ (capability,subsumption)]).
adjMapping2SUMO('01527075-a',[ (capability,subsumption)]).
adjMapping2SUMO('01527245-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01527420-a',[ ('Metal',equivalence)]).
adjMapping2SUMO('01527930-s',[ ('',undefined)]).
adjMapping2SUMO('01528039-s',[ ('Metal',subsumption)]).
adjMapping2SUMO('01528126-s',[ ('Metal',subsumption)]).
adjMapping2SUMO('01528239-s',[ ('Metal',subsumption)]).
adjMapping2SUMO('01528349-s',[ ('Metal',subsumption)]).
adjMapping2SUMO('01528463-s',[ ('Mixture',subsumption)]).
adjMapping2SUMO('01528644-s',[ ('Metal',subsumption)]).
adjMapping2SUMO('01528730-s',[ ('Metal',subsumption)]).
adjMapping2SUMO('01528946-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01529053-s',[ ('Metal',subsumption)]).
adjMapping2SUMO('01529167-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01529293-a',[ ('Metal',not(subsumption))]).
adjMapping2SUMO('01529479-s',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('01529643-a',[ ('InternalChange',subsumption)]).
adjMapping2SUMO('01529897-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('01530076-s',[ ('Insect',subsumption)]).
adjMapping2SUMO('01530378-s',[ ('Insect',subsumption)]).
adjMapping2SUMO('01530622-s',[ ('Insect',subsumption)]).
adjMapping2SUMO('01530801-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('01531019-s',[ ('Mineral',subsumption)]).
adjMapping2SUMO('01531180-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('01531274-s',[ ('Mineral',subsumption)]).
adjMapping2SUMO('01531375-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01531957-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01532149-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01532261-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01532454-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01532586-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01532653-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01532760-s',[ ('',undefined)]).
adjMapping2SUMO('01532912-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01533120-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01533535-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01533659-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01533806-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01533974-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01534282-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01534648-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01534858-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01535082-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01535270-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01535481-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01535583-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01535709-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01536094-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01536276-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01536445-s',[ ('',undefined)]).
adjMapping2SUMO('01536641-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01536745-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('01536911-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('01537144-s',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('01537269-s',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('01537448-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01537628-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01537759-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01537885-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01538118-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01538311-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01538583-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01538690-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01538858-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01539022-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01539225-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01539444-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01539642-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01539887-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01540102-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01540365-a',[ ('Process',subsumption)]).
adjMapping2SUMO('01540637-s',[ ('Process',subsumption)]).
adjMapping2SUMO('01540871-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('01541013-a',[ ('Process',not(subsumption))]).
adjMapping2SUMO('01541156-s',[ ('Process',not(subsumption))]).
adjMapping2SUMO('01541258-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('01541448-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01541567-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01541632-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01541828-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01542071-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01542252-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01542489-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01542629-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01542744-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01542865-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('01543088-s',[ ('',undefined)]).
adjMapping2SUMO('01543225-s',[ ('',undefined)]).
adjMapping2SUMO('01543361-s',[ ('',undefined)]).
adjMapping2SUMO('01543502-s',[ ('',undefined)]).
adjMapping2SUMO('01543633-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('01543772-a',[ ('Music',subsumption)]).
adjMapping2SUMO('01543937-s',[ ('Music',subsumption)]).
adjMapping2SUMO('01544059-s',[ ('Music',subsumption)]).
adjMapping2SUMO('01544169-a',[ ('Music',subsumption)]).
adjMapping2SUMO('01544347-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01544580-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01544688-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01544856-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01545059-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01545203-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01545317-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01545427-a',[ (capability,subsumption)]).
adjMapping2SUMO('01545571-a',[ ('Multilingual',equivalence)]).
adjMapping2SUMO('01545777-s',[ ('Multilingual',subsumption)]).
adjMapping2SUMO('01545904-s',[ ('Multilingual',subsumption)]).
adjMapping2SUMO('01546110-s',[ ('Multilingual',subsumption)]).
adjMapping2SUMO('01546222-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('01546349-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('01546593-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01546826-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01547007-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01547220-a',[ ('Relation',subsumption)]).
adjMapping2SUMO('01547470-s',[ ('Relation',subsumption)]).
adjMapping2SUMO('01547595-s',[ ('Relation',subsumption)]).
adjMapping2SUMO('01547721-a',[ ('Relation',subsumption)]).
adjMapping2SUMO('01547831-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('01547961-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('01548193-a',[ ('DeonticAttribute',subsumption)]).
adjMapping2SUMO('01548694-s',[ ('SocialInteraction',not(subsumption))]).
adjMapping2SUMO('01548808-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01548925-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01549087-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01549185-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01549291-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01549568-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01549964-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01550304-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01550438-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01550572-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01550779-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01551026-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01551130-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01551377-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01551461-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01551633-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01552162-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01552255-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01552419-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01552634-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01552802-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01552885-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01553340-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01553494-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01553629-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01553925-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01554063-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01554230-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01554412-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01554510-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01554940-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01555133-a',[ (greaterThan,subsumption)]).
adjMapping2SUMO('01555416-a',[ (lessThan,subsumption)]).
adjMapping2SUMO('01555732-a',[ (greaterThan,subsumption)]).
adjMapping2SUMO('01556061-a',[ (lessThan,subsumption)]).
adjMapping2SUMO('01556355-a',[ (greaterThan,subsumption)]).
adjMapping2SUMO('01556616-a',[ (lessThan,subsumption)]).
adjMapping2SUMO('01556913-s',[ (lessThan,subsumption)]).
adjMapping2SUMO('01557120-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01557386-a',[ (lessThan,subsumption)]).
adjMapping2SUMO('01557614-a',[ (capability,subsumption)]).
adjMapping2SUMO('01557790-s',[ (origin,subsumption)]).
adjMapping2SUMO('01557903-a',[ (capability,subsumption)]).
adjMapping2SUMO('01558086-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01558194-s',[ (capability,subsumption)]).
adjMapping2SUMO('01558291-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01558385-a',[ (hasPurposeForAgent,subsumption)]).
adjMapping2SUMO('01558641-s',[ (hasPurposeForAgent,subsumption)]).
adjMapping2SUMO('01558749-s',[ (hasPurposeForAgent,subsumption)]).
adjMapping2SUMO('01558912-a',[ (hasPurposeForAgent,subsumption)]).
adjMapping2SUMO('01559042-s',[ (hasPurposeForAgent,subsumption)]).
adjMapping2SUMO('01559270-s',[ (hasPurposeForAgent,subsumption)]).
adjMapping2SUMO('01559484-a',[ ('Device',subsumption)]).
adjMapping2SUMO('01559655-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01559728-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01559804-a',[ ('Device',not(subsumption))]).
adjMapping2SUMO('01559903-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01560165-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01560320-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01560513-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01560821-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01561079-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01561280-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01561429-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01561564-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01561694-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01561771-a',[ ('Motion',equivalence)]).
adjMapping2SUMO('01562167-s',[ ('Walking',equivalence)]).
adjMapping2SUMO('01562284-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01562416-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01562488-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01562668-s',[ ('Transportation',subsumption)]).
adjMapping2SUMO('01562809-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01562992-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01563147-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01563349-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01563494-s',[ (capability,subsumption)]).
adjMapping2SUMO('01563578-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01563713-s',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('01563923-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01564073-a',[ ('Motion',not(equivalence))]).
adjMapping2SUMO('01564315-s',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('01564512-s',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('01564603-s',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('01564881-s',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('01565038-s',[ (capability,subsumption)]).
adjMapping2SUMO('01565139-s',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('01565252-s',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('01565396-a',[ ('Icon',subsumption)]).
adjMapping2SUMO('01565608-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01565751-a',[ ('Icon',subsumption)]).
adjMapping2SUMO('01566027-a',[ ('Cutting',subsumption)]).
adjMapping2SUMO('01566223-s',[ ('',undefined)]).
adjMapping2SUMO('01566288-a',[ ('Cutting',not(subsumption))]).
adjMapping2SUMO('01566476-a',[ ('Position',subsumption)]).
adjMapping2SUMO('01566634-a',[ ('Position',subsumption)]).
adjMapping2SUMO('01566725-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01566916-a',[ ('Continent',equivalence)]).
adjMapping2SUMO('01567203-s',[ ('Continent',subsumption)]).
adjMapping2SUMO('01567294-s',[ ('Continent',subsumption)]).
adjMapping2SUMO('01567500-a',[ ('Continent',subsumption)]).
adjMapping2SUMO('01567694-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01567862-a',[ ('Nation',subsumption)]).
adjMapping2SUMO('01568092-s',[ (believes,subsumption)]).
adjMapping2SUMO('01568375-a',[ ('International',equivalence)]).
adjMapping2SUMO('01568684-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01569002-s',[ (believes,subsumption)]).
adjMapping2SUMO('01569166-s',[ ('Nation',subsumption)]).
adjMapping2SUMO('01569366-s',[ ('Nation',subsumption)]).
adjMapping2SUMO('01569549-a',[ ('StateOrProvince',subsumption)]).
adjMapping2SUMO('01569807-a',[ ('StateOrProvince',subsumption)]).
adjMapping2SUMO('01569965-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01570286-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01570470-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01570747-s',[ ('ViolentContest',subsumption)]).
adjMapping2SUMO('01570892-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('01571181-s',[ ('Coloring',subsumption)]).
adjMapping2SUMO('01571363-a',[ ('OrganicObject',not(subsumption))]).
adjMapping2SUMO('01571869-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01572009-s',[ ('',undefined)]).
adjMapping2SUMO('01572171-s',[ ('Coloring',subsumption)]).
adjMapping2SUMO('01572325-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01572458-s',[ ('Substance',subsumption)]).
adjMapping2SUMO('01572604-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01572831-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01572974-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01573101-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01573238-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01573568-s',[ ('OrganicObject',not(subsumption))]).
adjMapping2SUMO('01573762-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01573889-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01574036-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01574259-s',[ ('Physical',subsumption)]).
adjMapping2SUMO('01574446-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01574925-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01575299-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01575424-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01575810-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01576071-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01576551-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01576729-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01576845-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01577086-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01577327-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01577498-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01577672-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01577771-a',[ ('Music',subsumption)]).
adjMapping2SUMO('01577973-a',[ ('Music',subsumption)]).
adjMapping2SUMO('01578152-a',[ ('Music',subsumption)]).
adjMapping2SUMO('01578312-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01578683-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01578856-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01579128-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01579304-s',[ ('',undefined)]).
adjMapping2SUMO('01579467-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01579608-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01579853-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01580050-a',[ ('Necessity',equivalence)]).
adjMapping2SUMO('01580306-s',[ (needs,subsumption)]).
adjMapping2SUMO('01580601-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01580775-s',[ (needs,subsumption)]).
adjMapping2SUMO('01580968-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01581115-a',[ ('Necessity',subsumption)]).
adjMapping2SUMO('01581305-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01582049-s',[ (needs,subsumption)]).
adjMapping2SUMO('01582224-s',[ (needs,subsumption)]).
adjMapping2SUMO('01582306-s',[ ('Keeping',subsumption)]).
adjMapping2SUMO('01582461-a',[ ('CurrencyMeasure',subsumption)]).
adjMapping2SUMO('01582598-s',[ ('CurrencyMeasure',subsumption)]).
adjMapping2SUMO('01582698-s',[ ('CurrencyMeasure',subsumption)]).
adjMapping2SUMO('01582821-a',[ ('CurrencyMeasure',subsumption)]).
adjMapping2SUMO('01582946-s',[ ('AdditionFn',equivalence)]).
adjMapping2SUMO('01583040-a',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('01583486-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('01583659-s',[ ('Neurosis',subsumption)]).
adjMapping2SUMO('01583880-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('01584017-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('01584164-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('01584287-s',[ ('Neurosis',subsumption)]).
adjMapping2SUMO('01584569-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('01584724-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('01584857-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('01585022-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('01585312-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('01585491-s',[ ('PsychologicalDysfunction',equivalence)]).
adjMapping2SUMO('01585679-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('01585781-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('01585892-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('01586009-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01586194-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01586342-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01586752-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01586866-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01587077-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01587474-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01587643-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01587787-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01587950-a',[ ('Bird',subsumption)]).
adjMapping2SUMO('01588065-a',[ ('Bird',subsumption)]).
adjMapping2SUMO('01588172-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01588426-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01588619-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01589045-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01589217-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01589650-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01590044-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01590115-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01590484-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01591050-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01591227-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01591394-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01591699-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01591895-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01592108-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01592262-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01592509-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01592642-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01592857-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01593079-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01593480-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01593649-a',[ ('NormativeAttribute',equivalence)]).
adjMapping2SUMO('01594146-s',[ (average,equivalence)]).
adjMapping2SUMO('01594472-s',[ ('Relation',subsumption)]).
adjMapping2SUMO('01594811-s',[ ('Relation',subsumption)]).
adjMapping2SUMO('01595050-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01595312-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01595440-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01595596-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01596122-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01596455-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01596674-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01596809-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01597105-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01597240-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01597387-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01597509-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01597702-s',[ (lessThan,subsumption)]).
adjMapping2SUMO('01597928-s',[ (greaterThan,subsumption)]).
adjMapping2SUMO('01598125-s',[ ('',undefined)]).
adjMapping2SUMO('01598319-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01598592-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01598859-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01599114-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01599228-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01599340-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('01599445-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01599532-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01599782-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01599898-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01600041-s',[ (capability,subsumption)]).
adjMapping2SUMO('01600174-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01600333-a',[ ('North',equivalence)]).
adjMapping2SUMO('01600713-s',[ ('North',subsumption)]).
adjMapping2SUMO('01600888-s',[ ('North',subsumption)]).
adjMapping2SUMO('01601069-s',[ ('North',subsumption)]).
adjMapping2SUMO('01601297-s',[ ('North',subsumption)]).
adjMapping2SUMO('01601462-s',[ ('North',subsumption)]).
adjMapping2SUMO('01601592-s',[ ('North',subsumption)]).
adjMapping2SUMO('01601763-s',[ ('North',subsumption)]).
adjMapping2SUMO('01601901-s',[ ('North',subsumption)]).
adjMapping2SUMO('01601981-s',[ ('North',subsumption)]).
adjMapping2SUMO('01602112-s',[ ('North',subsumption)]).
adjMapping2SUMO('01602250-s',[ ('North',subsumption)]).
adjMapping2SUMO('01602330-a',[ ('South',equivalence)]).
adjMapping2SUMO('01602683-s',[ ('South',subsumption)]).
adjMapping2SUMO('01602797-s',[ ('South',subsumption)]).
adjMapping2SUMO('01602966-s',[ ('South',subsumption)]).
adjMapping2SUMO('01603179-s',[ ('South',subsumption)]).
adjMapping2SUMO('01603354-s',[ ('South',subsumption)]).
adjMapping2SUMO('01603518-s',[ ('South',subsumption)]).
adjMapping2SUMO('01603649-s',[ ('South',subsumption)]).
adjMapping2SUMO('01603789-s',[ ('South',subsumption)]).
adjMapping2SUMO('01603869-s',[ ('South',subsumption)]).
adjMapping2SUMO('01604000-s',[ ('South',subsumption)]).
adjMapping2SUMO('01604146-s',[ ('South',subsumption)]).
adjMapping2SUMO('01604226-a',[ ('North',subsumption)]).
adjMapping2SUMO('01604453-s',[ ('North',subsumption)]).
adjMapping2SUMO('01604566-s',[ ('North',subsumption)]).
adjMapping2SUMO('01604945-s',[ ('North',subsumption)]).
adjMapping2SUMO('01605081-a',[ ('South',subsumption)]).
adjMapping2SUMO('01605327-s',[ ('South',subsumption)]).
adjMapping2SUMO('01605445-s',[ ('South',subsumption)]).
adjMapping2SUMO('01605569-s',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('01605753-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01606058-s',[ ('Blue',equivalence)]).
adjMapping2SUMO('01606214-s',[ ('Government',instance)]).
adjMapping2SUMO('01606470-s',[ ('Human',subsumption)]).
adjMapping2SUMO('01606648-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01606942-s',[ ('Government',instance)]).
adjMapping2SUMO('01607120-s',[ ('Icon',subsumption)]).
adjMapping2SUMO('01607293-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01607492-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01607572-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01607744-s',[ ('',undefined)]).
adjMapping2SUMO('01607831-s',[ ('',undefined)]).
adjMapping2SUMO('01607909-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('01607978-a',[ ('Perception',equivalence)]).
adjMapping2SUMO('01608127-s',[ ('Perception',subsumption)]).
adjMapping2SUMO('01608264-a',[ ('Perception',not(subsumption))]).
adjMapping2SUMO('01608465-s',[ ('Remembering',not(equivalence))]).
adjMapping2SUMO('01608656-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01608848-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01608997-s',[ ('Seeing',not(subsumption))]).
adjMapping2SUMO('01609101-s',[ ('Perception',not(subsumption))]).
adjMapping2SUMO('01609201-a',[ ('Perception',subsumption)]).
adjMapping2SUMO('01609373-s',[ ('Perception',equivalence)]).
adjMapping2SUMO('01609501-s',[ ('Perception',subsumption)]).
adjMapping2SUMO('01609762-s',[ ('Hearing',equivalence)]).
adjMapping2SUMO('01609900-a',[ ('Perception',not(subsumption))]).
adjMapping2SUMO('01610126-s',[ ('Learning',not(subsumption))]).
adjMapping2SUMO('01610261-s',[ ('Perception',subsumption)]).
adjMapping2SUMO('01610339-a',[ ('Learning',subsumption)]).
adjMapping2SUMO('01610484-s',[ ('Seeing',subsumption)]).
adjMapping2SUMO('01610803-a',[ ('Learning',not(subsumption))]).
adjMapping2SUMO('01610952-s',[ ('Stating',not(subsumption))]).
adjMapping2SUMO('01611067-a',[ (capability,subsumption)]).
adjMapping2SUMO('01611329-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01611490-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01611683-s',[ (capability,subsumption)]).
adjMapping2SUMO('01611839-a',[ (capability,subsumption)]).
adjMapping2SUMO('01611973-s',[ (capability,subsumption)]).
adjMapping2SUMO('01612053-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01612627-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01612878-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01613047-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01613309-s',[ ('',undefined)]).
adjMapping2SUMO('01613463-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01613839-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01614127-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01614372-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01614558-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01614778-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01614988-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01615180-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01615460-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01615625-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01615785-s',[ (capability,subsumption)]).
adjMapping2SUMO('01615925-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01616157-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01616244-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01616350-s',[ (capability,subsumption)]).
adjMapping2SUMO('01616474-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01616798-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01616891-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01617004-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01617144-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01617255-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01617410-s',[ ('',undefined)]).
adjMapping2SUMO('01617502-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01617591-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01617675-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('01617859-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('01618053-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01618376-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01618895-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01619105-s',[ (capability,subsumption)]).
adjMapping2SUMO('01619379-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01619475-s',[ ('',undefined)]).
adjMapping2SUMO('01619604-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01619689-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01619880-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01620052-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01620286-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01620401-s',[ (capability,subsumption)]).
adjMapping2SUMO('01620509-a',[ (inhibits,subsumption)]).
adjMapping2SUMO('01620893-s',[ (inhibits,subsumption)]).
adjMapping2SUMO('01621080-s',[ (inhibits,subsumption)]).
adjMapping2SUMO('01621268-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01621424-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('01621680-s',[ (inhibits,subsumption)]).
adjMapping2SUMO('01621807-s',[ (prevents,subsumption)]).
adjMapping2SUMO('01621894-s',[ (prevents,subsumption)]).
adjMapping2SUMO('01622033-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01622188-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01622302-a',[ (inhibits,subsumption)]).
adjMapping2SUMO('01622505-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01622748-s',[ ('',undefined)]).
adjMapping2SUMO('01622908-s',[ (inhibits,subsumption)]).
adjMapping2SUMO('01623088-s',[ (prevents,subsumption)]).
adjMapping2SUMO('01623187-a',[ (uses,subsumption)]).
adjMapping2SUMO('01623360-s',[ (uses,subsumption)]).
adjMapping2SUMO('01623744-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01623836-a',[ (uses,subsumption)]).
adjMapping2SUMO('01624010-s',[ (uses,subsumption)]).
adjMapping2SUMO('01624115-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01624267-a',[ ('PoliticalProcess',subsumption)]).
adjMapping2SUMO('01624403-a',[ ('PoliticalProcess',not(subsumption))]).
adjMapping2SUMO('01624533-s',[ ('Giving',subsumption)]).
adjMapping2SUMO('01624633-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01625063-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01625492-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01625760-s',[ ('',undefined)]).
adjMapping2SUMO('01625893-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01626440-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01626562-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01626874-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01627049-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01627166-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01627315-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01627459-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01627635-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01627836-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01627965-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01628200-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01628302-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01628531-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01628677-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01628839-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01628946-a',[ ('Weapon',subsumption)]).
adjMapping2SUMO('01629212-s',[ ('Weapon',subsumption)]).
adjMapping2SUMO('01629349-s',[ ('ViolentContest',subsumption)]).
adjMapping2SUMO('01629493-s',[ ('ViolentContest',subsumption)]).
adjMapping2SUMO('01629681-s',[ ('ViolentContest',subsumption)]).
adjMapping2SUMO('01629832-s',[ ('ViolentContest',subsumption)]).
adjMapping2SUMO('01630033-s',[ ('ViolentContest',subsumption)]).
adjMapping2SUMO('01630117-a',[ ('Contest',subsumption)]).
adjMapping2SUMO('01630439-s',[ ('Weapon',subsumption)]).
adjMapping2SUMO('01630579-s',[ ('Weapon',subsumption)]).
adjMapping2SUMO('01630673-s',[ ('Weapon',subsumption)]).
adjMapping2SUMO('01630773-s',[ ('Contest',subsumption)]).
adjMapping2SUMO('01630939-s',[ ('Maneuver',subsumption)]).
adjMapping2SUMO('01631025-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01631217-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01631386-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01631703-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01631830-a',[ ('Expressing',subsumption)]).
adjMapping2SUMO('01632066-s',[ ('Stating',subsumption)]).
adjMapping2SUMO('01632314-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01632411-a',[ ('Expressing',not(subsumption))]).
adjMapping2SUMO('01632537-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01632808-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01632988-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01633153-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01633316-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01633490-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01633591-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01633880-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01634027-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01634199-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01634364-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01634495-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01634736-s',[ ('Declaring',subsumption)]).
adjMapping2SUMO('01634851-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01635018-s',[ ('Declaring',not(subsumption))]).
adjMapping2SUMO('01635146-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01635633-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01635962-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01636090-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01636205-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01636363-s',[ ('Declaring',subsumption)]).
adjMapping2SUMO('01636507-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01636636-s',[ ('',undefined)]).
adjMapping2SUMO('01636757-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01636887-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01637032-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01637184-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01637371-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01637454-a',[ (located,subsumption)]).
adjMapping2SUMO('01637583-s',[ (located,subsumption)]).
adjMapping2SUMO('01637766-a',[ (located,subsumption)]).
adjMapping2SUMO('01637904-a',[ (located,subsumption)]).
adjMapping2SUMO('01638053-a',[ (located,subsumption)]).
adjMapping2SUMO('01638178-a',[ (located,subsumption)]).
adjMapping2SUMO('01638311-a',[ (located,subsumption)]).
adjMapping2SUMO('01638438-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01638962-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01639230-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01639446-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01639636-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01639720-s',[ ('Giving',subsumption)]).
adjMapping2SUMO('01639891-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01639973-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01640124-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01640261-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01640356-s',[ ('Repairing',subsumption)]).
adjMapping2SUMO('01640482-s',[ (uses,subsumption)]).
adjMapping2SUMO('01640618-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01640729-s',[ ('Coloring',subsumption)]).
adjMapping2SUMO('01640850-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01641460-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01641648-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01641791-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01641921-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01642081-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01642245-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01642379-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01642477-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01642657-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01642843-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01642951-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01643094-s',[ ('Investigating',not(subsumption))]).
adjMapping2SUMO('01643260-s',[ (uses,subsumption)]).
adjMapping2SUMO('01643373-s',[ (uses,subsumption)]).
adjMapping2SUMO('01643480-s',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('01643620-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01644225-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01644541-s',[ (age,equivalence)]).
adjMapping2SUMO('01644709-s',[ ('Growth',subsumption)]).
adjMapping2SUMO('01644847-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01644967-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01645048-s',[ (age,subsumption)]).
adjMapping2SUMO('01645152-s',[ ('Coloring',subsumption)]).
adjMapping2SUMO('01645296-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01645490-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01645678-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('01646021-s',[ (age,subsumption)]).
adjMapping2SUMO('01646120-s',[ (age,subsumption)]).
adjMapping2SUMO('01646278-s',[ (age,subsumption)]).
adjMapping2SUMO('01646366-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01646435-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01646646-s',[ (age,subsumption)]).
adjMapping2SUMO('01646794-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01646941-a',[ ('HumanYouth',equivalence)]).
adjMapping2SUMO('01647601-s',[ ('',undefined)]).
adjMapping2SUMO('01647675-s',[ ('',undefined)]).
adjMapping2SUMO('01647750-s',[ ('',undefined)]).
adjMapping2SUMO('01647829-s',[ ('',undefined)]).
adjMapping2SUMO('01647906-s',[ ('',undefined)]).
adjMapping2SUMO('01647983-s',[ (age,subsumption)]).
adjMapping2SUMO('01648189-s',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('01648313-s',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('01648491-s',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('01648617-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01648698-s',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('01648891-s',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('01649031-s',[ ('HumanChild',equivalence)]).
adjMapping2SUMO('01649184-s',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('01649271-s',[ ('',undefined)]).
adjMapping2SUMO('01649469-s',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('01649561-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01649651-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01649720-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01649876-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01650037-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01650193-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01650401-a',[ (capability,subsumption)]).
adjMapping2SUMO('01650581-s',[ (capability,subsumption)]).
adjMapping2SUMO('01650752-a',[ (capability,subsumption)]).
adjMapping2SUMO('01650883-a',[ (path,subsumption)]).
adjMapping2SUMO('01651044-a',[ (path,subsumption)]).
adjMapping2SUMO('01651196-a',[ (capability,subsumption)]).
adjMapping2SUMO('01651346-s',[ (connected,subsumption)]).
adjMapping2SUMO('01651469-a',[ (capability,subsumption)]).
adjMapping2SUMO('01651609-s',[ (connected,subsumption)]).
adjMapping2SUMO('01651741-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01651896-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01652033-a',[ (located,subsumption)]).
adjMapping2SUMO('01652158-a',[ (located,subsumption)]).
adjMapping2SUMO('01652380-a',[ ('Detaching',subsumption)]).
adjMapping2SUMO('01652601-s',[ ('Detaching',subsumption)]).
adjMapping2SUMO('01652689-s',[ ('Detaching',subsumption)]).
adjMapping2SUMO('01652782-a',[ ('Attaching',subsumption)]).
adjMapping2SUMO('01652902-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01653135-s',[ (causes,subsumption)]).
adjMapping2SUMO('01653231-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('01653379-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01653538-a',[ (prevents,subsumption)]).
adjMapping2SUMO('01653857-s',[ (prevents,subsumption)]).
adjMapping2SUMO('01653992-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01654162-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01654299-s',[ ('',undefined)]).
adjMapping2SUMO('01654377-a',[ ('OpeningEyes',subsumption)]).
adjMapping2SUMO('01654582-s',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('01654769-s',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('01654900-s',[ ('OpeningEyes',subsumption)]).
adjMapping2SUMO('01655025-s',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('01655162-a',[ ('ClosingEyes',subsumption)]).
adjMapping2SUMO('01655386-s',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('01655538-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01655651-s',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('01655783-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('01655972-s',[ ('Text',subsumption)]).
adjMapping2SUMO('01656129-s',[ ('Text',subsumption)]).
adjMapping2SUMO('01656253-s',[ ('Text',subsumption)]).
adjMapping2SUMO('01656416-a',[ ('Text',subsumption)]).
adjMapping2SUMO('01656520-s',[ ('Text',subsumption)]).
adjMapping2SUMO('01656628-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('01657056-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01657129-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01657233-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01657420-s',[ ('ReproductiveBody',subsumption)]).
adjMapping2SUMO('01657562-s',[ ('',undefined)]).
adjMapping2SUMO('01657760-s',[ (prevents,subsumption)]).
adjMapping2SUMO('01657867-s',[ ('Insect',subsumption)]).
adjMapping2SUMO('01657967-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01658195-s',[ ('',undefined)]).
adjMapping2SUMO('01658269-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01658386-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01658533-s',[ ('Keeping',subsumption)]).
adjMapping2SUMO('01658666-s',[ ('Surrounded',equivalence)]).
adjMapping2SUMO('01658814-a',[ ('Keeping',not(subsumption))]).
adjMapping2SUMO('01659014-s',[ ('',undefined)]).
adjMapping2SUMO('01659117-s',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('01659277-s',[ ('StationaryArtifact',not(subsumption))]).
adjMapping2SUMO('01659355-a',[ ('ChemicalProcess',subsumption)]).
adjMapping2SUMO('01659447-a',[ ('ChemicalProcess',not(subsumption))]).
adjMapping2SUMO('01659577-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('01659762-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('01659874-a',[ ('Putting',not(subsumption))]).
adjMapping2SUMO('01659999-a',[ ('Set',subsumption)]).
adjMapping2SUMO('01660135-a',[ ('Set',subsumption)]).
adjMapping2SUMO('01660267-a',[ ('MilitaryProcess',subsumption)]).
adjMapping2SUMO('01660444-s',[ ('ViolentContest',subsumption)]).
adjMapping2SUMO('01660712-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01660857-a',[ ('MilitaryProcess',not(subsumption))]).
adjMapping2SUMO('01660994-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01661289-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01661529-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01661914-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01662119-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01662384-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01662510-a',[ (capability,subsumption)]).
adjMapping2SUMO('01662685-a',[ (capability,subsumption)]).
adjMapping2SUMO('01662756-a',[ ('Contest',subsumption)]).
adjMapping2SUMO('01662912-s',[ ('Contest',subsumption)]).
adjMapping2SUMO('01663049-a',[ ('Contest',not(subsumption))]).
adjMapping2SUMO('01663201-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01663359-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01663571-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01663916-s',[ (believes,subsumption)]).
adjMapping2SUMO('01664015-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01664156-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01664310-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01664455-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01664581-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01664783-s',[ (believes,subsumption)]).
adjMapping2SUMO('01664880-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01665184-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01665457-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01665581-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01665674-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01665816-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01665972-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01666126-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01666275-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01666489-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01666927-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01667110-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01667271-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01667519-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01667729-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01668011-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('01668250-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01668340-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01668567-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01668723-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01668858-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01669246-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01669507-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01669617-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01669774-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01669899-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01670037-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01670221-a',[ ('Planning',subsumption)]).
adjMapping2SUMO('01670427-s',[ ('Planning',subsumption)]).
adjMapping2SUMO('01670524-s',[ ('Planning',subsumption)]).
adjMapping2SUMO('01670669-s',[ ('Corporation',subsumption)]).
adjMapping2SUMO('01670856-s',[ ('ShapeChange',subsumption)]).
adjMapping2SUMO('01670982-s',[ ('ShapeChange',subsumption)]).
adjMapping2SUMO('01671095-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01671336-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01671509-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01671620-s',[ ('Corporation',not(subsumption))]).
adjMapping2SUMO('01671732-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01671881-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01672239-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01672487-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01672607-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01673061-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01673434-s',[ ('',undefined)]).
adjMapping2SUMO('01673590-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01673815-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01673946-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01674134-s',[ ('',undefined)]).
adjMapping2SUMO('01674242-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01674604-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01674926-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01675190-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01675931-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01676026-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01676350-s',[ ('',undefined)]).
adjMapping2SUMO('01676517-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01676993-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01677200-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01677433-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01677623-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01677733-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01677957-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01678112-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01678417-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01678586-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01678729-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01678946-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01679055-a',[ ('OrganicCompound',equivalence)]).
adjMapping2SUMO('01679244-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('01679459-a',[ ('OrganicObject',equivalence)]).
adjMapping2SUMO('01679744-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01679907-s',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('01680116-a',[ ('OrganicObject',not(subsumption))]).
adjMapping2SUMO('01680283-s',[ ('Organism',not(subsumption))]).
adjMapping2SUMO('01680417-s',[ ('Organism',not(subsumption))]).
adjMapping2SUMO('01680559-s',[ ('Organism',not(subsumption))]).
adjMapping2SUMO('01680689-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01680836-a',[ ('Separating',subsumption)]).
adjMapping2SUMO('01681028-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('01681307-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01681477-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01681607-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01681789-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01681882-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01682073-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01682229-a',[ (orientation,subsumption)]).
adjMapping2SUMO('01682677-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01682822-s',[ (destination,subsumption)]).
adjMapping2SUMO('01683061-s',[ (orientation,subsumption)]).
adjMapping2SUMO('01683221-s',[ (destination,subsumption)]).
adjMapping2SUMO('01683349-s',[ (destination,subsumption)]).
adjMapping2SUMO('01683496-s',[ (hasPurposeForAgent,subsumption)]).
adjMapping2SUMO('01683667-a',[ (hasPurposeForAgent,subsumption)]).
adjMapping2SUMO('01683908-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('01684133-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01684426-a',[ ('Learning',subsumption)]).
adjMapping2SUMO('01684811-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01684922-s',[ ('Measuring',subsumption)]).
adjMapping2SUMO('01685131-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01685231-s',[ ('Measuring',subsumption)]).
adjMapping2SUMO('01685377-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01685706-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01685906-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01686036-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01686269-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01686439-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01686906-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01687030-s',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('01687167-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01687363-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01687586-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01687965-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01688154-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01688271-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01688757-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01689223-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01689442-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01689580-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01689775-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01689880-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01690167-s',[ ('',undefined)]).
adjMapping2SUMO('01690244-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01690448-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01690606-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01690767-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01690987-s',[ ('',undefined)]).
adjMapping2SUMO('01691073-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01691302-s',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('01691474-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01691687-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01691826-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01691975-s',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('01692222-a',[ (located,subsumption)]).
adjMapping2SUMO('01692512-s',[ (located,subsumption)]).
adjMapping2SUMO('01692640-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01692786-a',[ (located,subsumption)]).
adjMapping2SUMO('01692969-a',[ (located,subsumption)]).
adjMapping2SUMO('01693189-s',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('01693311-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01693425-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01693585-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('01693799-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01694081-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('01694223-a',[ ('Covering',equivalence)]).
adjMapping2SUMO('01694892-s',[ ('ReproductiveBody',subsumption)]).
adjMapping2SUMO('01695041-s',[ ('Building',subsumption)]).
adjMapping2SUMO('01695160-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01695269-s',[ ('',undefined)]).
adjMapping2SUMO('01695363-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01695505-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01695749-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01695891-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01696165-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01696346-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01696502-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('01696632-s',[ ('Moss',subsumption)]).
adjMapping2SUMO('01696734-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01696855-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01696999-s',[ ('',undefined)]).
adjMapping2SUMO('01697129-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01697235-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('01697318-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01697425-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01697592-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01697770-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01697878-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('01698000-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01698103-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01698231-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01698400-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01698610-s',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('01698760-s',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('01698903-s',[ ('Putting',not(subsumption))]).
adjMapping2SUMO('01699006-s',[ ('StationaryArtifact',not(subsumption))]).
adjMapping2SUMO('01699095-a',[ ('Covering',subsumption)]).
adjMapping2SUMO('01699410-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01699576-s',[ ('',undefined)]).
adjMapping2SUMO('01699652-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01699838-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01699982-a',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('01700075-a',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('01700293-a',[ ('StationaryArtifact',not(subsumption))]).
adjMapping2SUMO('01700414-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01700944-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01701017-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01701134-s',[ ('',undefined)]).
adjMapping2SUMO('01701227-s',[ ('',undefined)]).
adjMapping2SUMO('01701321-s',[ ('',undefined)]).
adjMapping2SUMO('01701411-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01701512-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01701769-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01702031-s',[ ('',undefined)]).
adjMapping2SUMO('01702140-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01702253-s',[ ('',undefined)]).
adjMapping2SUMO('01702357-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01702543-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01702627-s',[ ('',undefined)]).
adjMapping2SUMO('01702727-s',[ ('',undefined)]).
adjMapping2SUMO('01702814-s',[ ('',undefined)]).
adjMapping2SUMO('01702913-s',[ ('',undefined)]).
adjMapping2SUMO('01703012-s',[ ('',undefined)]).
adjMapping2SUMO('01703106-s',[ ('',undefined)]).
adjMapping2SUMO('01703237-s',[ ('',undefined)]).
adjMapping2SUMO('01703330-s',[ ('',undefined)]).
adjMapping2SUMO('01703417-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('01703494-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('01703619-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('01703710-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('01703797-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01704073-a',[ (part,subsumption)]).
adjMapping2SUMO('01704273-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('01704420-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01704523-s',[ ('',undefined)]).
adjMapping2SUMO('01704599-s',[ ('',undefined)]).
adjMapping2SUMO('01704675-a',[ (part,subsumption)]).
adjMapping2SUMO('01704761-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01705088-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01705195-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01705418-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01705513-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01705655-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01706111-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01706341-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01706465-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01706986-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01707084-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01707230-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01707404-s',[ ('Communication',subsumption)]).
adjMapping2SUMO('01707531-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01707733-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01708049-s',[ ('Disseminating',not(subsumption))]).
adjMapping2SUMO('01708164-s',[ ('Disseminating',not(subsumption))]).
adjMapping2SUMO('01708249-a',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01708563-s',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01708663-s',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01708898-s',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01709081-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01709245-s',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01709354-s',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01709437-s',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01709542-s',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01709681-s',[ (equal,subsumption)]).
adjMapping2SUMO('01709815-a',[ ('FinancialTransaction',not(subsumption))]).
adjMapping2SUMO('01710054-s',[ ('FinancialTransaction',not(subsumption))]).
adjMapping2SUMO('01710260-s',[ ('FinancialTransaction',not(subsumption))]).
adjMapping2SUMO('01710421-s',[ ('',undefined)]).
adjMapping2SUMO('01710543-s',[ (holdsObligation,subsumption)]).
adjMapping2SUMO('01710709-s',[ ('',undefined)]).
adjMapping2SUMO('01710809-s',[ ('FinancialTransaction',not(subsumption))]).
adjMapping2SUMO('01710946-s',[ ('FinancialTransaction',not(subsumption))]).
adjMapping2SUMO('01711071-a',[ ('Pain',equivalence)]).
adjMapping2SUMO('01711465-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01711614-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('01711724-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01711910-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01712076-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01712174-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01712327-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01712529-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01712657-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01712753-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01712940-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01713095-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01713250-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01713373-a',[ ('Covering',subsumption)]).
adjMapping2SUMO('01713550-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01713713-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01713815-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01713925-a',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('01714157-s',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('01714314-s',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('01714406-s',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('01714516-a',[ ('Covering',subsumption)]).
adjMapping2SUMO('01714633-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01714774-a',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('01714896-s',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('01714985-a',[ (represents,subsumption)]).
adjMapping2SUMO('01715157-s',[ (represents,subsumption)]).
adjMapping2SUMO('01715287-s',[ (containsInformation,subsumption)]).
adjMapping2SUMO('01715430-s',[ (represents,subsumption)]).
adjMapping2SUMO('01715574-a',[ (represents,subsumption)]).
adjMapping2SUMO('01715708-s',[ (represents,subsumption)]).
adjMapping2SUMO('01715790-s',[ (represents,subsumption)]).
adjMapping2SUMO('01715872-a',[ (capability,subsumption)]).
adjMapping2SUMO('01716034-a',[ (capability,subsumption)]).
adjMapping2SUMO('01716227-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01716491-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01716845-s',[ ('SodiumChloride',subsumption)]).
adjMapping2SUMO('01716971-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01717117-a',[ (capability,subsumption)]).
adjMapping2SUMO('01717471-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01717669-a',[ (capability,subsumption)]).
adjMapping2SUMO('01717901-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01718158-a',[ (parallel,equivalence)]).
adjMapping2SUMO('01718470-s',[ ('SpatialRelation',subsumption)]).
adjMapping2SUMO('01718609-s',[ ('SpatialRelation',subsumption)]).
adjMapping2SUMO('01718732-s',[ ('SpatialRelation',subsumption)]).
adjMapping2SUMO('01718867-a',[ ('PlaneAngleMeasure',subsumption)]).
adjMapping2SUMO('01719393-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01719507-s',[ ('SpatialRelation',subsumption)]).
adjMapping2SUMO('01719779-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01719870-s',[ ('PlaneAngleMeasure',subsumption)]).
adjMapping2SUMO('01720091-s',[ ('SpatialRelation',subsumption)]).
adjMapping2SUMO('01720198-s',[ ('',undefined)]).
adjMapping2SUMO('01720280-a',[ ('SpatialRelation',subsumption)]).
adjMapping2SUMO('01720549-s',[ ('PlaneAngleMeasure',subsumption)]).
adjMapping2SUMO('01720642-s',[ ('AngleMeasure',subsumption)]).
adjMapping2SUMO('01720930-s',[ ('PlaneAngleMeasure',subsumption)]).
adjMapping2SUMO('01721059-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01721197-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01721319-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01721401-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01721530-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01721691-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01721867-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01721953-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01722039-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01722140-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01722260-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01722367-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01722529-a',[ (parent,subsumption)]).
adjMapping2SUMO('01722699-a',[ (parent,subsumption)]).
adjMapping2SUMO('01722846-s',[ (parent,subsumption)]).
adjMapping2SUMO('01722965-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01723091-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01723308-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01723543-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01723648-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01723856-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01724072-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01724368-a',[ (part,subsumption)]).
adjMapping2SUMO('01724456-a',[ (part,subsumption)]).
adjMapping2SUMO('01724551-a',[ (capability,subsumption)]).
adjMapping2SUMO('01724743-s',[ (capability,subsumption)]).
adjMapping2SUMO('01724916-s',[ (capability,subsumption)]).
adjMapping2SUMO('01725031-s',[ (capability,subsumption)]).
adjMapping2SUMO('01725129-s',[ (capability,subsumption)]).
adjMapping2SUMO('01725273-a',[ (capability,subsumption)]).
adjMapping2SUMO('01725422-s',[ (capability,subsumption)]).
adjMapping2SUMO('01725537-s',[ (capability,subsumption)]).
adjMapping2SUMO('01725624-s',[ (capability,subsumption)]).
adjMapping2SUMO('01725712-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01726021-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01726235-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01726613-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01726775-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01726859-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01727133-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01727303-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01727439-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01727644-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01727741-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01727926-a',[ ('PastFn',equivalence)]).
adjMapping2SUMO('01728476-s',[ ('PastFn',subsumption)]).
adjMapping2SUMO('01728614-s',[ ('PastFn',subsumption)]).
adjMapping2SUMO('01728919-s',[ ('PastFn',subsumption)]).
adjMapping2SUMO('01729157-s',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('01729384-s',[ ('PastFn',subsumption)]).
adjMapping2SUMO('01729566-s',[ ('PastFn',subsumption)]).
adjMapping2SUMO('01729819-s',[ ('PastFn',subsumption)]).
adjMapping2SUMO('01730060-s',[ ('Historical',equivalence)]).
adjMapping2SUMO('01730329-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01730444-s',[ ('PastFn',subsumption)]).
adjMapping2SUMO('01730745-s',[ ('PastFn',subsumption)]).
adjMapping2SUMO('01730820-s',[ ('ImmediatePastFn',equivalence)]).
adjMapping2SUMO('01730909-s',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('01731108-s',[ ('TimePosition',subsumption)]).
adjMapping2SUMO('01731208-s',[ ('Month',subsumption)]).
adjMapping2SUMO('01731351-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01731786-s',[ (exists,subsumption)]).
adjMapping2SUMO('01731882-s',[ ('TimePosition',subsumption)]).
adjMapping2SUMO('01732012-s',[ ('Month',subsumption)]).
adjMapping2SUMO('01732131-s',[ ('TimePosition',subsumption)]).
adjMapping2SUMO('01732270-a',[ ('FutureFn',equivalence)]).
adjMapping2SUMO('01732601-s',[ ('FutureFn',subsumption)]).
adjMapping2SUMO('01732855-s',[ ('FutureFn',subsumption)]).
adjMapping2SUMO('01732958-s',[ ('FutureFn',subsumption)]).
adjMapping2SUMO('01733082-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01733189-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01733330-s',[ ('Month',subsumption)]).
adjMapping2SUMO('01733462-a',[ ('Birth',equivalence)]).
adjMapping2SUMO('01733588-s',[ ('Birth',subsumption)]).
adjMapping2SUMO('01733661-a',[ ('Birth',not(subsumption))]).
adjMapping2SUMO('01733784-s',[ ('Birth',not(subsumption))]).
adjMapping2SUMO('01733867-a',[ (parent,subsumption)]).
adjMapping2SUMO('01733982-a',[ (parent,subsumption)]).
adjMapping2SUMO('01734171-s',[ (parent,subsumption)]).
adjMapping2SUMO('01734267-s',[ (father,subsumption)]).
adjMapping2SUMO('01734347-s',[ (mother,subsumption)]).
adjMapping2SUMO('01734436-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01734607-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01734772-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01734884-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01735130-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01735252-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01735346-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01735475-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01735622-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01735736-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01736122-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01736384-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01736571-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01736883-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01737084-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01737241-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01737503-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01737698-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01737825-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01738100-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01738252-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01738335-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01738495-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01738663-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01738746-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01738895-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01739080-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01739178-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('01739315-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01739456-a',[ ('Putting',not(subsumption))]).
adjMapping2SUMO('01739582-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01739693-a',[ ('Covering',subsumption)]).
adjMapping2SUMO('01739808-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01739898-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01739987-a',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('01740085-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01740207-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01740358-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01740630-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01740772-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01740892-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01741270-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01741408-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01741563-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01741669-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01741953-s',[ (believes,subsumption)]).
adjMapping2SUMO('01742119-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01742296-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01742537-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01742715-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('01742912-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01743138-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01743217-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01743506-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01743704-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('01743909-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01744111-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01744515-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01745027-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01745191-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01745296-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01745517-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01745653-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01745846-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01745946-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01746114-a',[ (capability,subsumption)]).
adjMapping2SUMO('01746292-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01746464-s',[ (capability,subsumption)]).
adjMapping2SUMO('01746605-a',[ (capability,subsumption)]).
adjMapping2SUMO('01746995-s',[ (capability,subsumption)]).
adjMapping2SUMO('01747195-s',[ (capability,subsumption)]).
adjMapping2SUMO('01747364-s',[ (capability,subsumption)]).
adjMapping2SUMO('01747713-s',[ (capability,subsumption)]).
adjMapping2SUMO('01747849-s',[ (capability,subsumption)]).
adjMapping2SUMO('01747996-s',[ (capability,subsumption)]).
adjMapping2SUMO('01748152-s',[ (capability,subsumption)]).
adjMapping2SUMO('01748318-a',[ (capability,subsumption)]).
adjMapping2SUMO('01748716-s',[ (capability,subsumption)]).
adjMapping2SUMO('01748824-s',[ (capability,subsumption)]).
adjMapping2SUMO('01748936-s',[ (capability,subsumption)]).
adjMapping2SUMO('01749125-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01749225-s',[ (capability,subsumption)]).
adjMapping2SUMO('01749320-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01749915-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01750073-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01750256-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01750386-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01750617-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01750746-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01750847-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01751080-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01751201-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01751353-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01751465-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01751609-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01751693-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01751828-s',[ ('Verb',subsumption)]).
adjMapping2SUMO('01751940-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01752167-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01752553-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01752692-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01752792-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01752953-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01753140-s',[ ('',undefined)]).
adjMapping2SUMO('01753249-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01753365-a',[ (capability,subsumption)]).
adjMapping2SUMO('01753652-s',[ (capability,subsumption)]).
adjMapping2SUMO('01753785-s',[ (capability,subsumption)]).
adjMapping2SUMO('01753922-a',[ (capability,subsumption)]).
adjMapping2SUMO('01754049-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01754341-s',[ (capability,subsumption)]).
adjMapping2SUMO('01754421-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01754873-s',[ (duration,subsumption)]).
adjMapping2SUMO('01755024-s',[ (duration,subsumption)]).
adjMapping2SUMO('01755418-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01755508-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01755627-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01756166-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01756292-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01756758-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01756940-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01757082-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01757211-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01757483-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01757608-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01757782-s',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('01757914-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01758038-s',[ (capability,subsumption)]).
adjMapping2SUMO('01758194-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01758339-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01758582-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01758790-s',[ ('',undefined)]).
adjMapping2SUMO('01758934-a',[ (capability,subsumption)]).
adjMapping2SUMO('01759092-s',[ (capability,subsumption)]).
adjMapping2SUMO('01759251-s',[ (capability,subsumption)]).
adjMapping2SUMO('01759362-a',[ (capability,subsumption)]).
adjMapping2SUMO('01759527-s',[ (capability,subsumption)]).
adjMapping2SUMO('01759676-a',[ (capability,subsumption)]).
adjMapping2SUMO('01759876-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('01760009-a',[ (capability,subsumption)]).
adjMapping2SUMO('01760132-a',[ (capability,subsumption)]).
adjMapping2SUMO('01760293-s',[ (capability,subsumption)]).
adjMapping2SUMO('01760488-s',[ (capability,subsumption)]).
adjMapping2SUMO('01760670-a',[ (capability,subsumption)]).
adjMapping2SUMO('01760847-s',[ ('Selecting',subsumption)]).
adjMapping2SUMO('01760944-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01761186-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01761375-s',[ ('Prohibition',subsumption)]).
adjMapping2SUMO('01761609-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01761742-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01761871-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01762065-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01762257-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01762404-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01762582-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01762748-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01762839-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01763159-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01763445-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01763594-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01763683-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01763813-a',[ (inhibits,equivalence)]).
adjMapping2SUMO('01764183-s',[ (prevents,subsumption)]).
adjMapping2SUMO('01764351-s',[ (prevents,subsumption)]).
adjMapping2SUMO('01764543-s',[ (inhibits,subsumption)]).
adjMapping2SUMO('01764745-s',[ (inhibits,subsumption)]).
adjMapping2SUMO('01764895-s',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('01765132-s',[ (causes,subsumption)]).
adjMapping2SUMO('01765237-s',[ (inhibits,subsumption)]).
adjMapping2SUMO('01765498-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01765643-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01765926-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01766133-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01766550-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01766784-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01766958-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01767076-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01767207-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01767329-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01767826-s',[ ('',undefined)]).
adjMapping2SUMO('01767975-s',[ ('Meeting',subsumption)]).
adjMapping2SUMO('01768086-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('01768252-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01768466-s',[ ('Meeting',subsumption)]).
adjMapping2SUMO('01768724-s',[ (possesses,equivalence)]).
adjMapping2SUMO('01768969-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01769179-s',[ ('Meeting',subsumption)]).
adjMapping2SUMO('01769378-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01769565-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01769744-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01769843-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01770177-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01770392-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01770591-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01770726-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01770903-a',[ (inhibits,subsumption)]).
adjMapping2SUMO('01771124-s',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('01771381-s',[ ('Expressing',subsumption)]).
adjMapping2SUMO('01771462-a',[ (capability,subsumption)]).
adjMapping2SUMO('01771632-a',[ (capability,subsumption)]).
adjMapping2SUMO('01771839-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01772032-a',[ (capability,subsumption)]).
adjMapping2SUMO('01772305-s',[ (capability,subsumption)]).
adjMapping2SUMO('01772512-s',[ (capability,subsumption)]).
adjMapping2SUMO('01772609-a',[ (capability,subsumption)]).
adjMapping2SUMO('01772914-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01773094-s',[ (capability,subsumption)]).
adjMapping2SUMO('01773234-a',[ (capability,subsumption)]).
adjMapping2SUMO('01773420-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01773665-a',[ (capability,subsumption)]).
adjMapping2SUMO('01774091-s',[ ('SurfaceChange',subsumption)]).
adjMapping2SUMO('01774191-s',[ ('Microorganism',subsumption)]).
adjMapping2SUMO('01774376-s',[ ('',undefined)]).
adjMapping2SUMO('01774483-s',[ (capability,subsumption)]).
adjMapping2SUMO('01774619-s',[ (capability,subsumption)]).
adjMapping2SUMO('01774720-s',[ (capability,subsumption)]).
adjMapping2SUMO('01774869-s',[ (capability,subsumption)]).
adjMapping2SUMO('01775034-s',[ ('',undefined)]).
adjMapping2SUMO('01775200-s',[ ('',undefined)]).
adjMapping2SUMO('01775280-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('01775420-s',[ (capability,subsumption)]).
adjMapping2SUMO('01775540-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01775768-s',[ ('',undefined)]).
adjMapping2SUMO('01775874-s',[ ('',undefined)]).
adjMapping2SUMO('01775980-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01776161-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01776282-s',[ ('',undefined)]).
adjMapping2SUMO('01776423-s',[ ('',undefined)]).
adjMapping2SUMO('01776532-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('01776629-a',[ (capability,subsumption)]).
adjMapping2SUMO('01776713-a',[ ('Hole',not(subsumption))]).
adjMapping2SUMO('01776845-s',[ (capability,subsumption)]).
adjMapping2SUMO('01776974-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01777212-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01777367-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01777526-s',[ ('',undefined)]).
adjMapping2SUMO('01777662-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01777822-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01778073-a',[ ('BiologicallyActiveSubstance',not(subsumption))]).
adjMapping2SUMO('01778212-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('01778572-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01778935-s',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('01779193-s',[ ('Physical',subsumption)]).
adjMapping2SUMO('01779428-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01779558-s',[ ('PhysiologicProcess',equivalence)]).
adjMapping2SUMO('01779792-s',[ ('',undefined)]).
adjMapping2SUMO('01779986-a',[ ('PsychologicalProcess',subsumption)]).
adjMapping2SUMO('01780343-s',[ ('IntentionalPsychologicalProcess',subsumption)]).
adjMapping2SUMO('01780596-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01780740-s',[ ('PsychologicalProcess',subsumption)]).
adjMapping2SUMO('01780937-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01781076-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01781243-a',[ (believes,subsumption)]).
adjMapping2SUMO('01781356-a',[ (believes,subsumption)]).
adjMapping2SUMO('01781478-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01781781-s',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('01781882-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01782100-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01782426-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01782519-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01782717-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01782854-a',[ ('Position',not(subsumption))]).
adjMapping2SUMO('01782981-a',[ (believes,subsumption)]).
adjMapping2SUMO('01783158-a',[ (believes,subsumption)]).
adjMapping2SUMO('01783434-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01783522-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01783710-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01783863-s',[ ('Meeting',subsumption)]).
adjMapping2SUMO('01784017-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01784217-s',[ (believes,subsumption)]).
adjMapping2SUMO('01784401-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01784602-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01784723-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01784830-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01784946-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01785079-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01785180-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01785341-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01785783-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01785906-a',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('01786026-s',[ ('',undefined)]).
adjMapping2SUMO('01786133-a',[ ('Polychromatic',subsumption)]).
adjMapping2SUMO('01787009-s',[ ('Polychromatic',subsumption)]).
adjMapping2SUMO('01787138-s',[ ('',undefined)]).
adjMapping2SUMO('01787231-s',[ ('',undefined)]).
adjMapping2SUMO('01787331-s',[ ('',undefined)]).
adjMapping2SUMO('01787408-s',[ ('Polychromatic',subsumption)]).
adjMapping2SUMO('01787548-s',[ ('Polychromatic',subsumption)]).
adjMapping2SUMO('01787740-s',[ ('',undefined)]).
adjMapping2SUMO('01787842-s',[ ('',undefined)]).
adjMapping2SUMO('01787941-s',[ ('Tissue',subsumption)]).
adjMapping2SUMO('01788048-s',[ ('Polychromatic',subsumption)]).
adjMapping2SUMO('01788169-s',[ ('',undefined)]).
adjMapping2SUMO('01788273-s',[ ('Polychromatic',subsumption)]).
adjMapping2SUMO('01788369-s',[ ('',undefined)]).
adjMapping2SUMO('01788445-s',[ ('Polychromatic',subsumption)]).
adjMapping2SUMO('01788564-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01788705-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('01788843-s',[ ('',undefined)]).
adjMapping2SUMO('01788994-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('01789117-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('01789279-s',[ ('',undefined)]).
adjMapping2SUMO('01789359-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('01789481-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01789734-s',[ ('',undefined)]).
adjMapping2SUMO('01789873-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('01789954-s',[ ('',undefined)]).
adjMapping2SUMO('01790070-s',[ ('',undefined)]).
adjMapping2SUMO('01790150-s',[ ('',undefined)]).
adjMapping2SUMO('01790259-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('01790348-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('01790507-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('01790613-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('01790807-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('01790938-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('01791036-s',[ ('',undefined)]).
adjMapping2SUMO('01791138-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('01791257-s',[ ('',undefined)]).
adjMapping2SUMO('01791349-s',[ ('',undefined)]).
adjMapping2SUMO('01791434-s',[ ('',undefined)]).
adjMapping2SUMO('01791510-s',[ ('',undefined)]).
adjMapping2SUMO('01791591-s',[ ('',undefined)]).
adjMapping2SUMO('01791670-s',[ ('',undefined)]).
adjMapping2SUMO('01791749-s',[ ('',undefined)]).
adjMapping2SUMO('01791829-s',[ ('',undefined)]).
adjMapping2SUMO('01791911-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01792387-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01792573-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01792821-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01792973-s',[ ('Food',subsumption)]).
adjMapping2SUMO('01793106-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01793254-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01793405-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01793557-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01793674-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01793812-s',[ ('ElementalSubstance',equivalence)]).
adjMapping2SUMO('01793985-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01794125-s',[ ('',undefined)]).
adjMapping2SUMO('01794340-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01794771-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01794995-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('01795203-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01795353-s',[ ('DressyAttribute',equivalence)]).
adjMapping2SUMO('01795460-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('01795610-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('01795799-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('01795933-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01796109-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01796304-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01796452-s',[ ('False',subsumption)]).
adjMapping2SUMO('01796600-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01796736-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01796844-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('01796977-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('01797148-a',[ ('Planning',subsumption)]).
adjMapping2SUMO('01797394-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01797528-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01797633-s',[ ('Planning',subsumption)]).
adjMapping2SUMO('01797770-s',[ ('',undefined)]).
adjMapping2SUMO('01797862-a',[ ('Planning',not(subsumption))]).
adjMapping2SUMO('01798162-s',[ ('Planning',not(subsumption))]).
adjMapping2SUMO('01798371-s',[ ('Planning',not(subsumption))]).
adjMapping2SUMO('01798484-s',[ ('Planning',not(subsumption))]).
adjMapping2SUMO('01798697-s',[ ('Planning',not(subsumption))]).
adjMapping2SUMO('01798828-a',[ ('IntentionalProcess',subsumption)]).
adjMapping2SUMO('01799035-a',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01799297-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01799457-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01799670-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01799781-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01799957-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01800169-s',[ ('Unlikely',equivalence)]).
adjMapping2SUMO('01800349-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01800764-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01800873-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01801029-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01801327-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01801446-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01801600-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01802165-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01802774-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01802932-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01803247-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01803335-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01803583-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01803792-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01804034-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01804175-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01804422-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01804728-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01804906-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01805064-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01805157-a',[ ('Happiness',subsumption)]).
adjMapping2SUMO('01805355-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01805489-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01805618-s',[ ('',undefined)]).
adjMapping2SUMO('01805730-s',[ ('Happiness',subsumption)]).
adjMapping2SUMO('01805801-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01805889-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01806106-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01806483-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01806677-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01806992-s',[ ('Communication',subsumption)]).
adjMapping2SUMO('01807075-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01807219-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01807605-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01807799-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01807964-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01808139-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01808227-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01808329-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01808413-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01808544-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01808671-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01808822-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01809019-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01809245-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01809541-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01809655-a',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('01810011-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01810189-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01810348-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01810453-s',[ ('',undefined)]).
adjMapping2SUMO('01810536-s',[ ('',undefined)]).
adjMapping2SUMO('01810613-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01810720-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01810868-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01810998-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01811172-s',[ ('QuantityChange',subsumption)]).
adjMapping2SUMO('01811277-s',[ ('',undefined)]).
adjMapping2SUMO('01811352-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01811430-s',[ ('',undefined)]).
adjMapping2SUMO('01811504-a',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('01811683-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01811820-a',[ ('PlaneAngleMeasure',subsumption)]).
adjMapping2SUMO('01811905-a',[ ('PlaneAngleMeasure',subsumption)]).
adjMapping2SUMO('01811997-a',[ ('SurfaceChange',subsumption)]).
adjMapping2SUMO('01812237-s',[ ('SurfaceChange',subsumption)]).
adjMapping2SUMO('01812630-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01812846-a',[ ('SurfaceChange',not(subsumption))]).
adjMapping2SUMO('01813081-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01813183-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01813289-s',[ ('SurfaceChange',not(subsumption))]).
adjMapping2SUMO('01813400-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01813733-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01813920-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01814085-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01814252-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01814385-a',[ ('PoliticalOrganization',equivalence)]).
adjMapping2SUMO('01814711-s',[ ('Government',equivalence)]).
adjMapping2SUMO('01814929-s',[ ('PoliticalProcess',subsumption)]).
adjMapping2SUMO('01815030-s',[ ('',undefined)]).
adjMapping2SUMO('01815129-a',[ ('PoliticalProcess',not(subsumption))]).
adjMapping2SUMO('01815219-s',[ ('PoliticalProcess',not(subsumption))]).
adjMapping2SUMO('01815309-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01815540-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01815669-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01815838-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01816195-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01816305-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01816376-s',[ ('Favorite',subsumption)]).
adjMapping2SUMO('01816525-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01816696-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01816956-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01817155-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01817301-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01817405-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01817500-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01817908-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01818077-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01818234-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01818680-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01818820-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01818992-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01819152-s',[ (causes,subsumption)]).
adjMapping2SUMO('01819293-s',[ ('Expressing',not(subsumption))]).
adjMapping2SUMO('01819390-a',[ ('ConstantQuantity',subsumption)]).
adjMapping2SUMO('01819592-s',[ ('NonnegativeRealNumber',equivalence)]).
adjMapping2SUMO('01819692-s',[ ('PositiveRealNumber',equivalence)]).
adjMapping2SUMO('01819821-a',[ ('ConstantQuantity',subsumption)]).
adjMapping2SUMO('01819976-s',[ ('NegativeRealNumber',equivalence)]).
adjMapping2SUMO('01820103-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01820338-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01820481-a',[ (result,subsumption)]).
adjMapping2SUMO('01820684-s',[ ('Bacterium',subsumption)]).
adjMapping2SUMO('01820861-a',[ (result,subsumption)]).
adjMapping2SUMO('01821078-s',[ ('Bacterium',subsumption)]).
adjMapping2SUMO('01821266-a',[ ('Possibility',equivalence)]).
adjMapping2SUMO('01821690-s',[ (capability,subsumption)]).
adjMapping2SUMO('01821920-s',[ (capability,subsumption)]).
adjMapping2SUMO('01822153-s',[ (capability,subsumption)]).
adjMapping2SUMO('01822411-s',[ ('Possibility',subsumption)]).
adjMapping2SUMO('01822563-s',[ (capability,subsumption)]).
adjMapping2SUMO('01822933-s',[ ('Unlikely',subsumption)]).
adjMapping2SUMO('01823092-a',[ ('Possibility',subsumption)]).
adjMapping2SUMO('01823475-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01823574-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01823948-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01824081-s',[ ('Possibility',not(subsumption))]).
adjMapping2SUMO('01824244-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01824563-s',[ (equal,subsumption)]).
adjMapping2SUMO('01824653-s',[ ('',undefined)]).
adjMapping2SUMO('01824751-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01825080-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01825310-s',[ ('',undefined)]).
adjMapping2SUMO('01825419-a',[ ('Male',subsumption)]).
adjMapping2SUMO('01825550-a',[ ('Male',subsumption)]).
adjMapping2SUMO('01825671-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01826186-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01826327-s',[ (causes,subsumption)]).
adjMapping2SUMO('01826477-s',[ (causes,subsumption)]).
adjMapping2SUMO('01826575-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01826828-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01826979-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01827161-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01827261-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01827432-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01827535-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01827766-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01827946-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01828130-s',[ ('',undefined)]).
adjMapping2SUMO('01828242-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01828391-a',[ ('Device',subsumption)]).
adjMapping2SUMO('01828706-s',[ ('',undefined)]).
adjMapping2SUMO('01828836-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01828987-s',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('01829149-s',[ ('',undefined)]).
adjMapping2SUMO('01829254-s',[ ('',undefined)]).
adjMapping2SUMO('01829369-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01829505-a',[ ('Device',subsumption)]).
adjMapping2SUMO('01829652-a',[ ('Device',subsumption)]).
adjMapping2SUMO('01829835-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01829980-a',[ ('Device',subsumption)]).
adjMapping2SUMO('01830134-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01830403-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01830599-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01830703-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01830871-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01830946-a',[ ('AnatomicalStructure',subsumption)]).
adjMapping2SUMO('01831203-s',[ ('AnatomicalStructure',subsumption)]).
adjMapping2SUMO('01831346-a',[ ('AnatomicalStructure',not(subsumption))]).
adjMapping2SUMO('01831473-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('01831679-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01831789-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('01831942-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('01832108-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('01832245-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01832341-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01832491-s',[ ('',undefined)]).
adjMapping2SUMO('01832604-a',[ ('Putting',not(subsumption))]).
adjMapping2SUMO('01832707-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01832807-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01832945-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01833092-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01833226-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01833401-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01833541-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01833643-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01833791-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01833939-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01834121-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('01834230-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('01834304-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01834812-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01835023-s',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('01835276-s',[ ('',undefined)]).
adjMapping2SUMO('01835409-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01835663-s',[ (capability,subsumption)]).
adjMapping2SUMO('01835843-s',[ (capability,subsumption)]).
adjMapping2SUMO('01836025-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01836117-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01836350-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01836766-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01837025-s',[ ('',undefined)]).
adjMapping2SUMO('01837182-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01837487-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01837605-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01837744-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01838151-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01838253-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01838379-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01838529-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01838772-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01838916-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01839099-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01839317-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01839417-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01839663-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01839829-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01840121-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01840366-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01840673-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01840880-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01841054-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01841179-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01841295-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01841390-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01841544-a',[ (capability,subsumption)]).
adjMapping2SUMO('01841699-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01841834-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01842001-a',[ (capability,subsumption)]).
adjMapping2SUMO('01842198-s',[ ('ProbabilityRelation',subsumption)]).
adjMapping2SUMO('01842304-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01842468-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01842643-s',[ (capability,subsumption)]).
adjMapping2SUMO('01842763-a',[ ('Planning',subsumption)]).
adjMapping2SUMO('01842963-s',[ ('Planning',subsumption)]).
adjMapping2SUMO('01843092-a',[ ('Planning',not(subsumption))]).
adjMapping2SUMO('01843205-s',[ ('Planning',not(subsumption))]).
adjMapping2SUMO('01843380-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01843746-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01843906-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01844002-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01844141-s',[ ('',undefined)]).
adjMapping2SUMO('01844241-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01844441-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('01844585-s',[ ('Process',subsumption)]).
adjMapping2SUMO('01844742-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01844858-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01845002-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01845160-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01845451-s',[ ('Planning',not(subsumption))]).
adjMapping2SUMO('01845921-s',[ ('Planning',not(subsumption))]).
adjMapping2SUMO('01846049-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01846204-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('01846413-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('01846815-s',[ (located,subsumption)]).
adjMapping2SUMO('01847022-s',[ (located,subsumption)]).
adjMapping2SUMO('01847101-s',[ (exists,subsumption)]).
adjMapping2SUMO('01847242-s',[ (located,subsumption)]).
adjMapping2SUMO('01847349-s',[ ('',undefined)]).
adjMapping2SUMO('01847515-s',[ (located,subsumption)]).
adjMapping2SUMO('01847672-a',[ (located,subsumption)]).
adjMapping2SUMO('01847864-s',[ (located,subsumption)]).
adjMapping2SUMO('01848056-s',[ ('',undefined)]).
adjMapping2SUMO('01848171-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01848355-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01848611-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01848701-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01848970-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01849170-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01849288-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01849740-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01849844-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01849960-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01850288-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01850446-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01850742-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01850862-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01851118-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01851330-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01851523-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01851795-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01851916-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01852107-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01852174-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01852548-s',[ ('',undefined)]).
adjMapping2SUMO('01852666-s',[ (result,subsumption)]).
adjMapping2SUMO('01852812-s',[ ('Getting',subsumption)]).
adjMapping2SUMO('01852924-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01853039-s',[ ('Text',subsumption)]).
adjMapping2SUMO('01853228-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01853461-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01853934-s',[ ('Selecting',subsumption)]).
adjMapping2SUMO('01854129-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01854420-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01854546-s',[ (result,subsumption)]).
adjMapping2SUMO('01854702-s',[ ('Getting',subsumption)]).
adjMapping2SUMO('01854935-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01855086-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01855204-s',[ ('',undefined)]).
adjMapping2SUMO('01855348-s',[ ('StreamWaterArea',subsumption)]).
adjMapping2SUMO('01855446-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01855621-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01855764-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01856066-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01856238-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01856419-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01856686-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01856802-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01856929-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01857410-s',[ ('',undefined)]).
adjMapping2SUMO('01857527-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01857743-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01857956-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01858094-a',[ ('Private',equivalence)]).
adjMapping2SUMO('01858740-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01859055-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01859368-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01859466-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01859571-s',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('01859801-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01859970-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01860207-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01860328-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01860465-s',[ ('Meeting',subsumption)]).
adjMapping2SUMO('01860580-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01860765-s',[ ('',undefined)]).
adjMapping2SUMO('01860890-s',[ ('Meeting',subsumption)]).
adjMapping2SUMO('01861095-s',[ ('',undefined)]).
adjMapping2SUMO('01861205-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01861648-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01861776-s',[ ('NationalGovernment',subsumption)]).
adjMapping2SUMO('01861910-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01862055-s',[ ('Organization',subsumption)]).
adjMapping2SUMO('01862161-s',[ ('StateGovernment',subsumption)]).
adjMapping2SUMO('01862296-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01862386-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01862697-s',[ (equal,subsumption)]).
adjMapping2SUMO('01862891-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01863066-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01863246-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01863442-s',[ ('',undefined)]).
adjMapping2SUMO('01863680-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01863970-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01864123-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01864279-s',[ ('',undefined)]).
adjMapping2SUMO('01864471-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01864666-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01865043-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01865197-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01865640-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('01865807-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('01865967-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01866129-s',[ ('',undefined)]).
adjMapping2SUMO('01866243-s',[ ('',undefined)]).
adjMapping2SUMO('01866336-s',[ (result,subsumption)]).
adjMapping2SUMO('01866429-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01866535-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01866812-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01867052-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01867189-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01867295-a',[ (capability,subsumption)]).
adjMapping2SUMO('01867502-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01867768-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01867996-a',[ (capability,subsumption)]).
adjMapping2SUMO('01868185-s',[ (capability,subsumption)]).
adjMapping2SUMO('01868302-a',[ (capability,subsumption)]).
adjMapping2SUMO('01868470-s',[ (capability,subsumption)]).
adjMapping2SUMO('01868578-s',[ (capability,subsumption)]).
adjMapping2SUMO('01868724-a',[ ('Profession',equivalence)]).
adjMapping2SUMO('01869126-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01869258-s',[ ('Stating',subsumption)]).
adjMapping2SUMO('01869370-a',[ ('Position',subsumption)]).
adjMapping2SUMO('01869634-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01869975-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01870100-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01870321-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01870636-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01870889-a',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01871204-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01871349-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01871473-s',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01871565-s',[ (profit,equivalence)]).
adjMapping2SUMO('01871774-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01871949-a',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01872265-s',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01872374-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01872486-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01872619-s',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01872745-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01873163-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01873295-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01873406-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01873985-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01874331-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01874561-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01874716-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01874886-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01875227-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01875437-s',[ ('SurfaceChange',subsumption)]).
adjMapping2SUMO('01875560-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01875711-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01875829-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01875929-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('01876006-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01876261-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01876555-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01876670-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01876780-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01876957-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01877182-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01877299-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01877416-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01877521-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01877617-a',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01877792-s',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01877919-a',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('01878075-a',[ (capability,subsumption)]).
adjMapping2SUMO('01878227-s',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('01878358-a',[ (capability,subsumption)]).
adjMapping2SUMO('01878466-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01878870-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01879261-s',[ ('Permission',equivalence)]).
adjMapping2SUMO('01879464-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01879667-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01879912-s',[ ('',undefined)]).
adjMapping2SUMO('01880071-s',[ ('',undefined)]).
adjMapping2SUMO('01880163-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01880531-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01880918-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01881365-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01881478-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01881696-a',[ ('Predicting',subsumption)]).
adjMapping2SUMO('01882162-s',[ ('Predicting',subsumption)]).
adjMapping2SUMO('01882292-s',[ ('Predicting',subsumption)]).
adjMapping2SUMO('01882474-s',[ ('Predicting',subsumption)]).
adjMapping2SUMO('01882621-s',[ ('Predicting',subsumption)]).
adjMapping2SUMO('01882754-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01883106-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01883226-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01883325-s',[ ('Predicting',equivalence)]).
adjMapping2SUMO('01883586-a',[ ('Predicting',subsumption)]).
adjMapping2SUMO('01883719-s',[ ('Predicting',not(subsumption))]).
adjMapping2SUMO('01883813-s',[ ('Predicting',not(subsumption))]).
adjMapping2SUMO('01883898-a',[ ('FutureFn',subsumption)]).
adjMapping2SUMO('01884176-s',[ ('FutureFn',subsumption)]).
adjMapping2SUMO('01884353-s',[ ('FutureFn',subsumption)]).
adjMapping2SUMO('01884539-a',[ ('PastFn',subsumption)]).
adjMapping2SUMO('01884744-s',[ ('PastFn',subsumption)]).
adjMapping2SUMO('01884930-a',[ ('Keeping',subsumption)]).
adjMapping2SUMO('01885275-s',[ ('Keeping',subsumption)]).
adjMapping2SUMO('01885382-s',[ ('Keeping',subsumption)]).
adjMapping2SUMO('01885532-s',[ (capability,subsumption)]).
adjMapping2SUMO('01885614-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01885757-s',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('01885866-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01885991-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01886139-s',[ (capability,subsumption)]).
adjMapping2SUMO('01886241-s',[ (capability,subsumption)]).
adjMapping2SUMO('01886407-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01886620-s',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('01886783-s',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('01886963-s',[ ('Device',not(subsumption))]).
adjMapping2SUMO('01887076-a',[ ('Device',subsumption)]).
adjMapping2SUMO('01887638-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01887819-s',[ (capability,subsumption)]).
adjMapping2SUMO('01888017-s',[ ('Managing',subsumption)]).
adjMapping2SUMO('01888284-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01888450-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01888554-s',[ (capability,subsumption)]).
adjMapping2SUMO('01888765-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01888941-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01889084-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01889173-a',[ (capability,subsumption)]).
adjMapping2SUMO('01889256-a',[ ('Happiness',equivalence)]).
adjMapping2SUMO('01889819-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01890097-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01890187-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01890382-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01890752-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01890988-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01891109-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01891773-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01892327-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('01892433-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01892506-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01892683-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('01892830-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01892953-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01893303-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01893510-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01893724-a',[ ('Investigating',subsumption)]).
adjMapping2SUMO('01893939-s',[ ('Investigating',subsumption)]).
adjMapping2SUMO('01894077-s',[ (increasesLikelihood,subsumption)]).
adjMapping2SUMO('01894196-s',[ ('Investigating',subsumption)]).
adjMapping2SUMO('01894324-s',[ ('Investigating',subsumption)]).
adjMapping2SUMO('01894416-a',[ ('Investigating',subsumption)]).
adjMapping2SUMO('01894576-s',[ ('Investigating',subsumption)]).
adjMapping2SUMO('01894670-s',[ ('Investigating',subsumption)]).
adjMapping2SUMO('01894758-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01895099-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01895296-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01895630-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01895717-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01895837-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01896046-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01896299-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01896396-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01896478-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01896925-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01897106-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01897224-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01897378-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01897607-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01897787-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01897948-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01898051-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01898129-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01898490-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01898722-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01898974-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01899167-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01899360-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01899742-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01899970-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01900188-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01900349-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01900630-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01900771-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01900915-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01901082-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01901186-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01901496-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01901649-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01901777-a',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('01902003-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01902171-a',[ ('RegulatoryProcess',not(subsumption))]).
adjMapping2SUMO('01902313-s',[ ('RegulatoryProcess',not(subsumption))]).
adjMapping2SUMO('01902468-a',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('01902703-s',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('01902866-s',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('01902980-s',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('01903160-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01903412-a',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('01903617-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01903813-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01903965-s',[ ('Certificate',subsumption)]).
adjMapping2SUMO('01904156-a',[ ('Replication',subsumption)]).
adjMapping2SUMO('01904371-s',[ ('Replication',subsumption)]).
adjMapping2SUMO('01904485-s',[ ('Replication',subsumption)]).
adjMapping2SUMO('01904596-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01904698-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01904845-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01905140-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01905235-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01905377-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01905552-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01905653-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01906173-s',[ ('Microorganism',subsumption)]).
adjMapping2SUMO('01906320-s',[ ('Clean',subsumption)]).
adjMapping2SUMO('01906464-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01906817-s',[ ('Metal',subsumption)]).
adjMapping2SUMO('01906975-s',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('01907103-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01907293-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01907416-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01907481-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01907595-s',[ ('Metal',subsumption)]).
adjMapping2SUMO('01907711-s',[ ('Clean',subsumption)]).
adjMapping2SUMO('01907878-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01908039-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01908341-s',[ ('',undefined)]).
adjMapping2SUMO('01908539-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01908641-s',[ ('Metal',subsumption)]).
adjMapping2SUMO('01908755-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('01908889-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01909077-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01909421-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01909491-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01909628-s',[ ('',undefined)]).
adjMapping2SUMO('01909718-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01909890-a',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('01910114-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01910249-s',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('01910359-s',[ ('Device',subsumption)]).
adjMapping2SUMO('01910488-a',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('01910652-s',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('01910819-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01911053-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01911296-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01911415-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01911589-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01911683-a',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('01911951-s',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('01912145-s',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('01912280-s',[ ('Guiding',subsumption)]).
adjMapping2SUMO('01912483-s',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('01912613-a',[ ('EducationalProcess',not(subsumption))]).
adjMapping2SUMO('01912858-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('01913089-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01913200-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01913413-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01913514-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01913642-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01913715-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01913931-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01914108-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01914250-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01914407-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01914521-a',[ ('Attribute',equivalence)]).
adjMapping2SUMO('01914767-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01914930-a',[ ('Quantity',equivalence)]).
adjMapping2SUMO('01915353-s',[ ('Number',subsumption)]).
adjMapping2SUMO('01915482-s',[ ('Number',subsumption)]).
adjMapping2SUMO('01915586-s',[ ('Number',equivalence)]).
adjMapping2SUMO('01915745-s',[ (capability,subsumption)]).
adjMapping2SUMO('01915849-s',[ ('Number',subsumption)]).
adjMapping2SUMO('01915991-s',[ (measure,subsumption)]).
adjMapping2SUMO('01916142-s',[ ('',undefined)]).
adjMapping2SUMO('01916229-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01916555-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01916693-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01916784-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01916979-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01917370-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01917594-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01917916-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01918001-s',[ ('Stating',subsumption)]).
adjMapping2SUMO('01918184-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01918464-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01918541-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01918660-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01918771-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01918873-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01918984-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01919282-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01919428-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01919676-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01919793-s',[ ('Walking',subsumption)]).
adjMapping2SUMO('01919931-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01920367-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01920697-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('01920834-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('01921011-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('01921171-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('01921335-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('01921466-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01921639-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('01921752-s',[ ('Breathing',subsumption)]).
adjMapping2SUMO('01921868-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('01922030-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('01922131-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('01922227-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01922410-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01922562-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01922763-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01923118-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01923286-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01923391-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01923720-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01924148-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01924316-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01924585-s',[ ('',undefined)]).
adjMapping2SUMO('01924803-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01925000-s',[ ('Process',subsumption)]).
adjMapping2SUMO('01925158-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01925242-s',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('01925372-a',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('01925708-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01925979-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('01926089-s',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('01926229-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01926376-a',[ ('Reasoning',not(subsumption))]).
adjMapping2SUMO('01926654-s',[ ('Reasoning',not(subsumption))]).
adjMapping2SUMO('01926803-s',[ (capability,subsumption)]).
adjMapping2SUMO('01926921-s',[ ('Reasoning',not(subsumption))]).
adjMapping2SUMO('01927061-s',[ ('Reasoning',not(subsumption))]).
adjMapping2SUMO('01927279-a',[ ('EmotionalState',equivalence)]).
adjMapping2SUMO('01927455-a',[ ('IntentionalPsychologicalProcess',subsumption)]).
adjMapping2SUMO('01927654-a',[ ('EthnicGroup',subsumption)]).
adjMapping2SUMO('01927904-s',[ ('EthnicGroup',subsumption)]).
adjMapping2SUMO('01928019-s',[ ('EthnicGroup',subsumption)]).
adjMapping2SUMO('01928114-s',[ ('EthnicGroup',subsumption)]).
adjMapping2SUMO('01928283-s',[ (believes,subsumption)]).
adjMapping2SUMO('01928381-a',[ ('EthnicGroup',not(subsumption))]).
adjMapping2SUMO('01928608-a',[ (capability,subsumption)]).
adjMapping2SUMO('01928926-s',[ (causes,subsumption)]).
adjMapping2SUMO('01929062-s',[ (capability,subsumption)]).
adjMapping2SUMO('01929202-s',[ (capability,subsumption)]).
adjMapping2SUMO('01929312-s',[ ('',undefined)]).
adjMapping2SUMO('01929456-s',[ (capability,subsumption)]).
adjMapping2SUMO('01929600-a',[ (capability,subsumption)]).
adjMapping2SUMO('01929802-s',[ (capability,subsumption)]).
adjMapping2SUMO('01930004-s',[ (capability,subsumption)]).
adjMapping2SUMO('01930244-s',[ (capability,subsumption)]).
adjMapping2SUMO('01930417-s',[ (capability,subsumption)]).
adjMapping2SUMO('01930512-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01931034-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01931203-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01931517-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01931676-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01931807-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01931926-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01932234-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01932481-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01932633-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01932902-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01932973-a',[ ('True',equivalence)]).
adjMapping2SUMO('01933520-s',[ ('True',equivalence)]).
adjMapping2SUMO('01933731-s',[ ('True',equivalence)]).
adjMapping2SUMO('01934026-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01934284-s',[ ('Historical',equivalence)]).
adjMapping2SUMO('01934554-a',[ ('False',subsumption)]).
adjMapping2SUMO('01935139-s',[ ('IntentionalRelation',subsumption)]).
adjMapping2SUMO('01935301-s',[ ('IntentionalRelation',subsumption)]).
adjMapping2SUMO('01935581-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01935744-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01935935-s',[ ('IntentionalRelation',subsumption)]).
adjMapping2SUMO('01936184-s',[ ('FictionalText',equivalence)]).
adjMapping2SUMO('01936528-s',[ ('False',subsumption)]).
adjMapping2SUMO('01936778-s',[ ('False',subsumption)]).
adjMapping2SUMO('01936997-s',[ ('False',subsumption)]).
adjMapping2SUMO('01937187-s',[ ('False',subsumption)]).
adjMapping2SUMO('01937390-s',[ ('False',subsumption)]).
adjMapping2SUMO('01937759-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01937994-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01938322-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01938508-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01938659-a',[ ('False',subsumption)]).
adjMapping2SUMO('01938975-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('01939226-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01939402-s',[ ('Perception',subsumption)]).
adjMapping2SUMO('01939596-a',[ (monetaryValue,subsumption)]).
adjMapping2SUMO('01939784-a',[ (monetaryValue,subsumption)]).
adjMapping2SUMO('01939984-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01940472-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01940651-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01941026-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01941274-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01941383-s',[ ('True',subsumption)]).
adjMapping2SUMO('01941604-s',[ ('True',subsumption)]).
adjMapping2SUMO('01941814-s',[ ('True',subsumption)]).
adjMapping2SUMO('01941999-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01942279-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01942507-s',[ ('False',subsumption)]).
adjMapping2SUMO('01942732-s',[ ('False',subsumption)]).
adjMapping2SUMO('01942888-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01943067-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01943406-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01943746-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01944088-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01944492-s',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('01944660-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01944904-s',[ ('',undefined)]).
adjMapping2SUMO('01945010-s',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('01945139-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01945350-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('01945550-a',[ (and,subsumption)]).
adjMapping2SUMO('01946012-s',[ ('',undefined)]).
adjMapping2SUMO('01946167-s',[ (part,subsumption)]).
adjMapping2SUMO('01946267-s',[ ('Substituting',subsumption)]).
adjMapping2SUMO('01946439-s',[ (capability,subsumption)]).
adjMapping2SUMO('01946595-s',[ (and,subsumption)]).
adjMapping2SUMO('01946764-s',[ (and,subsumption)]).
adjMapping2SUMO('01946911-a',[ (and,subsumption)]).
adjMapping2SUMO('01947021-s',[ (and,subsumption)]).
adjMapping2SUMO('01947127-s',[ ('Transaction',not(subsumption))]).
adjMapping2SUMO('01947266-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01947741-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01948014-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01948092-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01948231-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01948389-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01948573-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01948721-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01948848-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('01948958-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01949059-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01949149-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01949611-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01949740-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01949859-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01950198-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01950711-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01950857-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01951008-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01951112-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01951197-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01951372-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01951456-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01951559-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01951684-a',[ ('Process',subsumption)]).
adjMapping2SUMO('01951943-s',[ ('QuantityChange',subsumption)]).
adjMapping2SUMO('01952153-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('01952301-s',[ ('Process',subsumption)]).
adjMapping2SUMO('01952405-a',[ ('Process',not(subsumption))]).
adjMapping2SUMO('01952643-s',[ ('SelfConnectedObject',subsumption)]).
adjMapping2SUMO('01952907-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01953161-s',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('01953297-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('01953467-a',[ ('Removing',not(subsumption))]).
adjMapping2SUMO('01953635-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('01954005-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01954128-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01954263-s',[ ('Combustion',subsumption)]).
adjMapping2SUMO('01954418-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01954517-s',[ ('SurfaceChange',subsumption)]).
adjMapping2SUMO('01954640-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01954781-a',[ ('Putting',not(subsumption))]).
adjMapping2SUMO('01954943-s',[ ('Removing',not(subsumption))]).
adjMapping2SUMO('01955031-a',[ ('Covering',subsumption)]).
adjMapping2SUMO('01955147-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01955272-a',[ ('TherapeuticProcess',subsumption)]).
adjMapping2SUMO('01955494-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('01955670-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('01955796-s',[ ('TherapeuticProcess',subsumption)]).
adjMapping2SUMO('01955898-a',[ ('TherapeuticProcess',not(subsumption))]).
adjMapping2SUMO('01956060-a',[ (capability,subsumption)]).
adjMapping2SUMO('01956229-s',[ (capability,subsumption)]).
adjMapping2SUMO('01956370-s',[ (capability,subsumption)]).
adjMapping2SUMO('01956523-a',[ (capability,subsumption)]).
adjMapping2SUMO('01956675-s',[ (capability,subsumption)]).
adjMapping2SUMO('01956855-s',[ (capability,subsumption)]).
adjMapping2SUMO('01956964-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01957177-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01957312-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01957454-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01957712-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01957855-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01957942-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01958027-a',[ ('Writing',subsumption)]).
adjMapping2SUMO('01958259-s',[ ('Certificate',subsumption)]).
adjMapping2SUMO('01958512-s',[ ('Writing',subsumption)]).
adjMapping2SUMO('01958659-a',[ ('Writing',not(subsumption))]).
adjMapping2SUMO('01958777-s',[ ('Writing',not(subsumption))]).
adjMapping2SUMO('01958898-a',[ ('Certificate',subsumption)]).
adjMapping2SUMO('01959111-a',[ ('Certificate',not(subsumption))]).
adjMapping2SUMO('01959294-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01959711-s',[ ('Position',subsumption)]).
adjMapping2SUMO('01959807-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01959918-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01960076-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01960207-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01960310-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01960432-s',[ ('Verb',subsumption)]).
adjMapping2SUMO('01960557-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01960656-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01961048-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01961205-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01961410-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01961666-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01961786-s',[ ('Verb',subsumption)]).
adjMapping2SUMO('01961937-a',[ ('',undefined)]).
adjMapping2SUMO('01962107-a',[ ('',undefined)]).
adjMapping2SUMO('01962310-a',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('01962492-a',[ ('Guiding',not(subsumption))]).
adjMapping2SUMO('01962631-a',[ (capability,subsumption)]).
adjMapping2SUMO('01962819-a',[ (capability,subsumption)]).
adjMapping2SUMO('01962982-a',[ (capability,subsumption)]).
adjMapping2SUMO('01963117-a',[ (capability,subsumption)]).
adjMapping2SUMO('01963294-a',[ (capability,subsumption)]).
adjMapping2SUMO('01963378-a',[ (capability,subsumption)]).
adjMapping2SUMO('01963509-a',[ (capability,subsumption)]).
adjMapping2SUMO('01963688-s',[ (capability,subsumption)]).
adjMapping2SUMO('01963792-a',[ (capability,subsumption)]).
adjMapping2SUMO('01963958-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01964196-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01964367-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01964632-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01964775-a',[ ('',undefined)]).
adjMapping2SUMO('01964933-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01965096-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01965287-a',[ ('Requesting',equivalence)]).
adjMapping2SUMO('01965388-a',[ ('Requesting',not(subsumption))]).
adjMapping2SUMO('01965512-s',[ ('Requesting',not(subsumption))]).
adjMapping2SUMO('01965636-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01965849-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01966016-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01966212-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01966315-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('01966488-a',[ (equal,subsumption)]).
adjMapping2SUMO('01966740-s',[ (forall,subsumption)]).
adjMapping2SUMO('01966853-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01967041-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('01967240-a',[ ('Process',subsumption)]).
adjMapping2SUMO('01967803-s',[ ('Process',subsumption)]).
adjMapping2SUMO('01967917-s',[ ('Process',subsumption)]).
adjMapping2SUMO('01968033-s',[ ('Process',subsumption)]).
adjMapping2SUMO('01968165-s',[ (forall,subsumption)]).
adjMapping2SUMO('01968352-s',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('01968503-s',[ ('RecurrentTimeIntervalFn',subsumption)]).
adjMapping2SUMO('01968721-s',[ ('RecurrentTimeIntervalFn',subsumption)]).
adjMapping2SUMO('01968811-s',[ ('RecurrentTimeIntervalFn',subsumption)]).
adjMapping2SUMO('01968956-s',[ ('RecurrentTimeIntervalFn',subsumption)]).
adjMapping2SUMO('01969038-s',[ ('RecurrentTimeIntervalFn',subsumption)]).
adjMapping2SUMO('01969150-s',[ ('RecurrentTimeIntervalFn',subsumption)]).
adjMapping2SUMO('01969348-s',[ ('RecurrentTimeIntervalFn',subsumption)]).
adjMapping2SUMO('01969477-s',[ ('RecurrentTimeIntervalFn',subsumption)]).
adjMapping2SUMO('01969606-s',[ ('RecurrentTimeIntervalFn',subsumption)]).
adjMapping2SUMO('01969707-s',[ ('RecurrentTimeIntervalFn',subsumption)]).
adjMapping2SUMO('01969881-s',[ ('RecurrentTimeIntervalFn',subsumption)]).
adjMapping2SUMO('01970014-s',[ ('RecurrentTimeIntervalFn',subsumption)]).
adjMapping2SUMO('01970136-s',[ ('RecurrentTimeIntervalFn',subsumption)]).
adjMapping2SUMO('01970322-s',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('01970464-a',[ ('Process',subsumption)]).
adjMapping2SUMO('01970604-s',[ ('Process',subsumption)]).
adjMapping2SUMO('01970686-s',[ ('Process',subsumption)]).
adjMapping2SUMO('01970777-a',[ ('PoliticalOrganization',subsumption)]).
adjMapping2SUMO('01970963-s',[ ('Organization',subsumption)]).
adjMapping2SUMO('01971046-a',[ ('PoliticalOrganization',subsumption)]).
adjMapping2SUMO('01971237-a',[ (familyRelation,subsumption)]).
adjMapping2SUMO('01971519-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01971671-s',[ (familyRelation,subsumption)]).
adjMapping2SUMO('01971846-s',[ (familyRelation,subsumption)]).
adjMapping2SUMO('01972070-s',[ (familyRelation,subsumption)]).
adjMapping2SUMO('01972204-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('01972349-s',[ (familyRelation,subsumption)]).
adjMapping2SUMO('01972479-s',[ (familyRelation,subsumption)]).
adjMapping2SUMO('01972596-a',[ (familyRelation,subsumption)]).
adjMapping2SUMO('01972712-s',[ (familyRelation,subsumption)]).
adjMapping2SUMO('01972820-a',[ ('Relation',subsumption)]).
adjMapping2SUMO('01973311-s',[ ('Relation',subsumption)]).
adjMapping2SUMO('01973529-s',[ ('',undefined)]).
adjMapping2SUMO('01973655-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01973823-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('01973969-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01974071-s',[ ('',undefined)]).
adjMapping2SUMO('01974298-s',[ ('Relation',subsumption)]).
adjMapping2SUMO('01974451-s',[ ('Relation',subsumption)]).
adjMapping2SUMO('01974584-s',[ ('Relation',subsumption)]).
adjMapping2SUMO('01974740-a',[ ('Relation',not(subsumption))]).
adjMapping2SUMO('01974904-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01974979-s',[ ('',undefined)]).
adjMapping2SUMO('01975059-s',[ ('Relation',subsumption)]).
adjMapping2SUMO('01975138-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01975448-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01975671-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01975833-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01976084-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01976360-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01976532-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01976851-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01977025-s',[ ('',undefined)]).
adjMapping2SUMO('01977155-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01977488-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01977669-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01978003-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01978237-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('01978395-a',[ (capability,subsumption)]).
adjMapping2SUMO('01978532-s',[ (capability,subsumption)]).
adjMapping2SUMO('01978894-a',[ (capability,subsumption)]).
adjMapping2SUMO('01979053-a',[ (represents,subsumption)]).
adjMapping2SUMO('01979326-s',[ (represents,subsumption)]).
adjMapping2SUMO('01979501-s',[ (represents,subsumption)]).
adjMapping2SUMO('01979604-s',[ (represents,subsumption)]).
adjMapping2SUMO('01979803-s',[ (represents,subsumption)]).
adjMapping2SUMO('01979985-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01980250-a',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('01980557-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('01980796-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('01981009-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('01981243-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('01981448-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('01981583-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('01981699-a',[ (represents,equivalence)]).
adjMapping2SUMO('01981916-s',[ (represents,subsumption)]).
adjMapping2SUMO('01982186-s',[ (represents,subsumption)]).
adjMapping2SUMO('01982538-a',[ (represents,subsumption)]).
adjMapping2SUMO('01982646-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01982957-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01983162-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01983432-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01983548-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01983672-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01983797-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01984097-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01984252-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01984411-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01984669-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01984806-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01985247-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01985557-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01985812-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01985976-s',[ (capability,subsumption)]).
adjMapping2SUMO('01986134-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01986260-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01986349-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01986483-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01986654-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01986759-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01986926-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01987093-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01987207-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01987341-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01987646-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01987856-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01988024-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01988166-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('01988324-a',[ (holdsRight,subsumption)]).
adjMapping2SUMO('01988468-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('01988565-s',[ (capability,subsumption)]).
adjMapping2SUMO('01988724-a',[ (holdsRight,subsumption)]).
adjMapping2SUMO('01988829-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01988934-s',[ (holdsRight,subsumption)]).
adjMapping2SUMO('01989012-a',[ (capability,subsumption)]).
adjMapping2SUMO('01989175-a',[ (capability,subsumption)]).
adjMapping2SUMO('01989446-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01989669-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01990172-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01990373-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01990507-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01990653-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01991029-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01991166-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01991267-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01991462-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01991586-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01991783-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01991961-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01992149-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01992418-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01992555-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01992712-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01992867-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01992996-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01993140-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01993408-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01993598-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01993693-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01993843-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01993940-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01994180-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01994404-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01994602-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01995047-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01995288-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01995500-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01995596-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01995863-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01996051-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01996288-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01996377-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('01996875-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('01997221-s',[ ('',undefined)]).
adjMapping2SUMO('01997415-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01997583-s',[ ('Obligation',subsumption)]).
adjMapping2SUMO('01997748-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01997910-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01998260-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('01998535-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01998730-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01998835-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('01998989-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01999085-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('01999180-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('01999306-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01999608-s',[ ('Communication',subsumption)]).
adjMapping2SUMO('01999766-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('01999941-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('02000118-a',[ ('Guiding',subsumption)]).
adjMapping2SUMO('02000298-s',[ ('Keeping',subsumption)]).
adjMapping2SUMO('02000406-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02000559-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02000680-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02000968-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02001240-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02001406-s',[ ('',undefined)]).
adjMapping2SUMO('02001596-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02001776-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02001984-s',[ (inhibits,subsumption)]).
adjMapping2SUMO('02002227-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02002470-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02002580-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02002683-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02002814-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02003023-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02003186-s',[ ('CurrencyMeasure',subsumption)]).
adjMapping2SUMO('02003357-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02003477-s',[ ('',undefined)]).
adjMapping2SUMO('02003604-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02003725-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02004023-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02004176-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02004385-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02004685-s',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('02004838-s',[ ('Obligation',subsumption)]).
adjMapping2SUMO('02005065-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02005245-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02005364-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02005460-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02005756-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02006031-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02006228-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02006538-s',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('02006700-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02006798-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02006933-s',[ (connected,subsumption)]).
adjMapping2SUMO('02007067-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02007225-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02007322-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02007413-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02007508-a',[ (capability,subsumption)]).
adjMapping2SUMO('02007663-s',[ (capability,subsumption)]).
adjMapping2SUMO('02007775-a',[ (capability,subsumption)]).
adjMapping2SUMO('02007882-a',[ (capability,subsumption)]).
adjMapping2SUMO('02008082-s',[ (capability,subsumption)]).
adjMapping2SUMO('02008245-s',[ (capability,subsumption)]).
adjMapping2SUMO('02008380-a',[ (capability,subsumption)]).
adjMapping2SUMO('02008508-s',[ (capability,subsumption)]).
adjMapping2SUMO('02008615-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02008820-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02008917-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02009012-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02009166-s',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02009280-a',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('02009688-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('02009880-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('02009993-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('02010127-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('02010266-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('02010441-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('02010536-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('02010831-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('02011002-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02011142-a',[ (capability,subsumption)]).
adjMapping2SUMO('02011320-s',[ (capability,subsumption)]).
adjMapping2SUMO('02011445-s',[ (capability,subsumption)]).
adjMapping2SUMO('02011622-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('02011810-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02012073-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02012157-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02012333-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02012504-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02012748-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02013083-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02013197-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02013422-s',[ ('',undefined)]).
adjMapping2SUMO('02013630-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02013758-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02013864-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02014048-s',[ ('Awake',subsumption)]).
adjMapping2SUMO('02014140-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02014308-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02014387-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02014514-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02014611-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02014715-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02014972-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02015055-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02015134-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02015238-a',[ (believes,subsumption)]).
adjMapping2SUMO('02015403-a',[ (believes,subsumption)]).
adjMapping2SUMO('02015571-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02015767-s',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('02015891-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02016001-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02016145-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02016295-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02016535-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02016881-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02017141-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02017372-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02017613-s',[ ('Text',subsumption)]).
adjMapping2SUMO('02017721-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02017933-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02018141-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02018296-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02018486-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02018649-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02018899-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02019021-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02019470-s',[ ('',undefined)]).
adjMapping2SUMO('02019635-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02019805-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02019881-s',[ ('Music',subsumption)]).
adjMapping2SUMO('02020011-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02020310-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02020495-s',[ ('',undefined)]).
adjMapping2SUMO('02020609-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02020810-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02020897-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02021050-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02021235-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02021332-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02021415-s',[ ('Measuring',equivalence)]).
adjMapping2SUMO('02021540-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02021664-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02021748-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02021818-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('02021905-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02022167-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02022556-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02022953-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02023287-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02023430-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02023661-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02023914-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02024022-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02024143-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02024411-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02024658-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02024758-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02024928-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02025274-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02025498-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02025718-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02025885-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02026055-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02026197-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02026312-a',[ (capability,subsumption)]).
adjMapping2SUMO('02026442-a',[ (capability,subsumption)]).
adjMapping2SUMO('02026629-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02026785-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02027003-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02027147-a',[ (component,subsumption)]).
adjMapping2SUMO('02027319-s',[ (component,subsumption)]).
adjMapping2SUMO('02027480-s',[ ('Red',subsumption)]).
adjMapping2SUMO('02027609-a',[ (component,subsumption)]).
adjMapping2SUMO('02027704-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02027906-s',[ ('',undefined)]).
adjMapping2SUMO('02028046-s',[ ('Device',subsumption)]).
adjMapping2SUMO('02028263-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('02028367-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02028488-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02028612-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02028865-s',[ ('Human',subsumption)]).
adjMapping2SUMO('02029047-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02029167-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02029438-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02029568-s',[ ('Human',subsumption)]).
adjMapping2SUMO('02029752-a',[ ('Human',subsumption)]).
adjMapping2SUMO('02029954-s',[ ('Human',subsumption)]).
adjMapping2SUMO('02030080-a',[ (believes,subsumption)]).
adjMapping2SUMO('02030312-s',[ (believes,subsumption)]).
adjMapping2SUMO('02030425-s',[ ('',undefined)]).
adjMapping2SUMO('02030562-s',[ (believes,subsumption)]).
adjMapping2SUMO('02030704-s',[ (believes,subsumption)]).
adjMapping2SUMO('02030793-s',[ (believes,subsumption)]).
adjMapping2SUMO('02030935-a',[ (believes,subsumption)]).
adjMapping2SUMO('02031165-s',[ (believes,subsumption)]).
adjMapping2SUMO('02031248-s',[ (believes,subsumption)]).
adjMapping2SUMO('02031335-s',[ (believes,subsumption)]).
adjMapping2SUMO('02031473-s',[ (believes,subsumption)]).
adjMapping2SUMO('02031624-a',[ (believes,subsumption)]).
adjMapping2SUMO('02031810-s',[ (believes,subsumption)]).
adjMapping2SUMO('02031986-a',[ ('Right',subsumption)]).
adjMapping2SUMO('02032386-s',[ ('Right',subsumption)]).
adjMapping2SUMO('02032617-s',[ ('',undefined)]).
adjMapping2SUMO('02032730-s',[ ('Right',subsumption)]).
adjMapping2SUMO('02032850-s',[ ('',undefined)]).
adjMapping2SUMO('02032953-a',[ ('Left',subsumption)]).
adjMapping2SUMO('02033323-s',[ ('Left',subsumption)]).
adjMapping2SUMO('02033450-s',[ ('',undefined)]).
adjMapping2SUMO('02033556-s',[ ('Left',subsumption)]).
adjMapping2SUMO('02033742-s',[ ('',undefined)]).
adjMapping2SUMO('02033868-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02034179-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02034248-s',[ ('',undefined)]).
adjMapping2SUMO('02034324-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02034504-s',[ ('',undefined)]).
adjMapping2SUMO('02034592-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02034739-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('02034828-a',[ ('Obligation',equivalence)]).
adjMapping2SUMO('02035086-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02035337-a',[ ('Obligation',equivalence)]).
adjMapping2SUMO('02035765-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02036077-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02036397-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02036578-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02036934-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02037152-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02037272-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02037531-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02037708-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02038126-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02038421-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02038555-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02038735-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02038891-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02038994-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02039304-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02039491-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('02039632-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02039763-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02039845-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02040049-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02040233-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02040519-s',[ ('',undefined)]).
adjMapping2SUMO('02040652-a',[ ('Circle',equivalence)]).
adjMapping2SUMO('02041134-s',[ ('',undefined)]).
adjMapping2SUMO('02041229-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02041711-s',[ ('',undefined)]).
adjMapping2SUMO('02041807-s',[ ('',undefined)]).
adjMapping2SUMO('02041940-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02042078-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02042183-s',[ ('',undefined)]).
adjMapping2SUMO('02042267-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02042411-s',[ ('',undefined)]).
adjMapping2SUMO('02042503-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02042599-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02042687-s',[ ('',undefined)]).
adjMapping2SUMO('02042775-s',[ ('',undefined)]).
adjMapping2SUMO('02042872-s',[ ('',undefined)]).
adjMapping2SUMO('02042970-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02043051-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02043142-s',[ ('',undefined)]).
adjMapping2SUMO('02043217-a',[ ('Square',subsumption)]).
adjMapping2SUMO('02043499-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02043587-s',[ ('PlaneAngleMeasure',subsumption)]).
adjMapping2SUMO('02043729-s',[ ('ShapeChange',subsumption)]).
adjMapping2SUMO('02043806-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02043898-a',[ ('CircleSector',subsumption)]).
adjMapping2SUMO('02044642-s',[ ('',undefined)]).
adjMapping2SUMO('02044736-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02044860-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02045008-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02045144-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02045255-s',[ ('',undefined)]).
adjMapping2SUMO('02045345-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02045473-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02045620-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02045723-s',[ ('Cylinder',subsumption)]).
adjMapping2SUMO('02045894-s',[ ('',undefined)]).
adjMapping2SUMO('02046017-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02046115-s',[ ('',undefined)]).
adjMapping2SUMO('02046199-s',[ ('Circle',subsumption)]).
adjMapping2SUMO('02046446-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02046625-s',[ ('',undefined)]).
adjMapping2SUMO('02046736-s',[ ('',undefined)]).
adjMapping2SUMO('02046828-s',[ ('',undefined)]).
adjMapping2SUMO('02046916-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02047051-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02047160-s',[ ('',undefined)]).
adjMapping2SUMO('02047252-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02047335-s',[ ('',undefined)]).
adjMapping2SUMO('02047413-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02047496-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02047603-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02047726-s',[ ('',undefined)]).
adjMapping2SUMO('02047807-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02048247-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02048344-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02048449-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02048626-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02048794-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02048875-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02048977-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02049147-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02049243-s',[ ('',undefined)]).
adjMapping2SUMO('02049323-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02049428-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02049648-s',[ ('',undefined)]).
adjMapping2SUMO('02049812-s',[ ('',undefined)]).
adjMapping2SUMO('02049918-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02050116-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02050368-s',[ ('',undefined)]).
adjMapping2SUMO('02050452-a',[ ('Rural',equivalence)]).
adjMapping2SUMO('02050841-s',[ ('Position',subsumption)]).
adjMapping2SUMO('02051013-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02051179-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02051500-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('02051616-s',[ ('Rural',subsumption)]).
adjMapping2SUMO('02051788-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02051881-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02052005-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02052197-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02052333-a',[ ('City',subsumption)]).
adjMapping2SUMO('02052603-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02052757-s',[ ('',undefined)]).
adjMapping2SUMO('02052830-s',[ ('City',subsumption)]).
adjMapping2SUMO('02052983-a',[ ('ChemicalDecomposition',subsumption)]).
adjMapping2SUMO('02053094-s',[ ('Oxidation',subsumption)]).
adjMapping2SUMO('02053253-a',[ ('ChemicalDecomposition',not(subsumption))]).
adjMapping2SUMO('02053392-s',[ ('ChemicalDecomposition',not(subsumption))]).
adjMapping2SUMO('02053460-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('02053553-s',[ ('',undefined)]).
adjMapping2SUMO('02053631-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('02053818-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02054075-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02054216-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02054310-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02054610-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02054779-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02054926-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02055062-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02055460-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02055617-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02055773-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02055900-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02056001-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02056165-s',[ ('',undefined)]).
adjMapping2SUMO('02056265-s',[ ('ReligiousProcess',equivalence)]).
adjMapping2SUMO('02056566-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02056663-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02056761-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02056880-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02057226-s',[ ('Position',not(subsumption))]).
adjMapping2SUMO('02057444-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02057535-a',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02057681-a',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02057829-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02058148-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02058379-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02058529-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02058656-s',[ ('Injuring',not(subsumption))]).
adjMapping2SUMO('02058794-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02059280-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02059381-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02059626-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02059811-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02060106-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02060198-s',[ ('',undefined)]).
adjMapping2SUMO('02060359-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02060496-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02060912-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02061126-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02061307-a',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('02061487-a',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('02061678-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('02061799-a',[ (capability,subsumption)]).
adjMapping2SUMO('02061998-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02062133-s',[ (capability,subsumption)]).
adjMapping2SUMO('02062358-a',[ (capability,subsumption)]).
adjMapping2SUMO('02062481-s',[ (capability,subsumption)]).
adjMapping2SUMO('02062565-s',[ (capability,subsumption)]).
adjMapping2SUMO('02062670-a',[ (equal,subsumption)]).
adjMapping2SUMO('02063279-s',[ (equal,subsumption)]).
adjMapping2SUMO('02063554-s',[ (equal,subsumption)]).
adjMapping2SUMO('02063759-s',[ ('',undefined)]).
adjMapping2SUMO('02063903-s',[ (copy,subsumption)]).
adjMapping2SUMO('02064013-s',[ ('',undefined)]).
adjMapping2SUMO('02064127-s',[ (copy,equivalence)]).
adjMapping2SUMO('02064427-s',[ (instance,subsumption)]).
adjMapping2SUMO('02064537-s',[ (believes,subsumption)]).
adjMapping2SUMO('02064745-a',[ (equal,subsumption)]).
adjMapping2SUMO('02065404-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02065665-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02065958-s',[ (equal,subsumption)]).
adjMapping2SUMO('02066142-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02066312-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02066662-s',[ (equal,subsumption)]).
adjMapping2SUMO('02066836-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02067063-s',[ (equal,subsumption)]).
adjMapping2SUMO('02067491-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02067719-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02067913-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02068174-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02068277-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02068476-a',[ (equal,equivalence)]).
adjMapping2SUMO('02068730-s',[ ('Stating',subsumption)]).
adjMapping2SUMO('02068946-s',[ (equal,subsumption)]).
adjMapping2SUMO('02069355-a',[ (equal,subsumption)]).
adjMapping2SUMO('02070030-s',[ (equal,subsumption)]).
adjMapping2SUMO('02070188-s',[ (equal,subsumption)]).
adjMapping2SUMO('02070342-s',[ (equal,subsumption)]).
adjMapping2SUMO('02070491-s',[ (equal,subsumption)]).
adjMapping2SUMO('02070711-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02070887-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02071139-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02071301-s',[ ('',undefined)]).
adjMapping2SUMO('02071420-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02071782-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02071973-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02072341-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02072537-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02072660-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02072806-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02072923-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02073113-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02073443-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('02073678-s',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('02073834-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02073970-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02074092-a',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02074673-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02074929-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02075321-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02075594-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02075737-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02075847-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02075938-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02076016-s',[ ('Psychosis',subsumption)]).
adjMapping2SUMO('02076234-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02076416-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02076557-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02076713-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02076817-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02076988-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02077157-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02077253-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02077469-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02077625-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02077741-s',[ ('Psychosis',subsumption)]).
adjMapping2SUMO('02077904-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02078011-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02078153-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02078264-s',[ (capability,subsumption)]).
adjMapping2SUMO('02078399-a',[ (capability,subsumption)]).
adjMapping2SUMO('02078673-s',[ (capability,subsumption)]).
adjMapping2SUMO('02078788-s',[ (capability,subsumption)]).
adjMapping2SUMO('02078894-s',[ (capability,subsumption)]).
adjMapping2SUMO('02079029-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02079313-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02079507-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02079732-s',[ (capability,subsumption)]).
adjMapping2SUMO('02079830-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02080110-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02080318-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02080488-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02080577-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02080937-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02081114-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02081492-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02081563-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02081672-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02081933-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02082081-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02082218-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02082611-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02082812-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02082924-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02083053-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02083222-a',[ (capability,subsumption)]).
adjMapping2SUMO('02083391-s',[ (capability,subsumption)]).
adjMapping2SUMO('02083516-a',[ (capability,subsumption)]).
adjMapping2SUMO('02083615-a',[ ('Learning',subsumption)]).
adjMapping2SUMO('02083908-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02084101-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02084358-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02084538-a',[ ('Learning',not(subsumption))]).
adjMapping2SUMO('02084663-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02084735-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02084804-a',[ ('Science',equivalence)]).
adjMapping2SUMO('02084979-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02085132-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02085322-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02085449-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02085740-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02085898-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02086115-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02086356-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02086472-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02086667-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('02086879-s',[ ('Removing',not(subsumption))]).
adjMapping2SUMO('02086991-a',[ ('Putting',not(subsumption))]).
adjMapping2SUMO('02087178-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('02087342-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02087450-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02087594-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('02087723-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('02087956-a',[ (capability,subsumption)]).
adjMapping2SUMO('02088086-a',[ (capability,subsumption)]).
adjMapping2SUMO('02088198-a',[ (capability,subsumption)]).
adjMapping2SUMO('02088314-a',[ (capability,subsumption)]).
adjMapping2SUMO('02088404-a',[ ('Covering',subsumption)]).
adjMapping2SUMO('02088760-s',[ (hasPurposeForAgent,subsumption)]).
adjMapping2SUMO('02088883-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02088974-s',[ (hasPurposeForAgent,subsumption)]).
adjMapping2SUMO('02089377-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02089514-s',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('02089724-s',[ (knows,subsumption)]).
adjMapping2SUMO('02089811-s',[ (hasPurposeForAgent,subsumption)]).
adjMapping2SUMO('02089943-s',[ ('Disseminating',not(subsumption))]).
adjMapping2SUMO('02090069-s',[ ('Disseminating',not(subsumption))]).
adjMapping2SUMO('02090228-s',[ ('Stating',not(subsumption))]).
adjMapping2SUMO('02090341-a',[ (hasPurposeForAgent,subsumption)]).
adjMapping2SUMO('02090567-s',[ (hasPurposeForAgent,subsumption)]).
adjMapping2SUMO('02090823-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02091020-a',[ ('Covering',subsumption)]).
adjMapping2SUMO('02091165-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02091300-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02091574-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02091851-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02091997-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02092129-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02092460-s',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('02092741-s',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('02092987-s',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('02093134-s',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('02093305-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02093493-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02093703-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02093802-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02093888-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02094203-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02094388-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02094514-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02094633-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02094755-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02095037-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02095193-s',[ ('Contract',subsumption)]).
adjMapping2SUMO('02095311-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02095542-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02095670-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02095786-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02095936-a',[ ('Attaching',subsumption)]).
adjMapping2SUMO('02096083-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('02096213-a',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('02096382-s',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('02096604-s',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('02096759-a',[ ('Contract',subsumption)]).
adjMapping2SUMO('02096923-s',[ ('',undefined)]).
adjMapping2SUMO('02097029-a',[ ('Contract',subsumption)]).
adjMapping2SUMO('02097152-s',[ ('',undefined)]).
adjMapping2SUMO('02097268-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02097480-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02097796-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02097884-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02098002-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02098136-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02098243-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02098325-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02098694-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02098918-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02099019-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02099303-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02099442-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02099561-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02099651-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02099774-a',[ (greaterThan,subsumption)]).
adjMapping2SUMO('02100031-s',[ (greaterThan,subsumption)]).
adjMapping2SUMO('02100236-s',[ (greaterThan,subsumption)]).
adjMapping2SUMO('02100376-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02100566-s',[ (greaterThan,subsumption)]).
adjMapping2SUMO('02100709-a',[ (lessThan,subsumption)]).
adjMapping2SUMO('02100968-s',[ (lessThan,subsumption)]).
adjMapping2SUMO('02101240-s',[ (lessThan,subsumption)]).
adjMapping2SUMO('02101382-s',[ (lessThan,subsumption)]).
adjMapping2SUMO('02101580-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02101757-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02101942-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02102178-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02102321-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02102484-a',[ (capability,subsumption)]).
adjMapping2SUMO('02102796-a',[ (capability,subsumption)]).
adjMapping2SUMO('02103052-s',[ (capability,subsumption)]).
adjMapping2SUMO('02103333-s',[ ('Perception',not(subsumption))]).
adjMapping2SUMO('02103481-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02103982-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02104190-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02104277-s',[ (capability,subsumption)]).
adjMapping2SUMO('02104396-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02104600-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02104727-s',[ (capability,subsumption)]).
adjMapping2SUMO('02104890-s',[ (capability,subsumption)]).
adjMapping2SUMO('02105055-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02105176-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02105375-a',[ (capability,subsumption)]).
adjMapping2SUMO('02105603-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02105898-s',[ (capability,subsumption)]).
adjMapping2SUMO('02105990-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02106366-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02106509-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02106651-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02106761-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02107162-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02107386-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02107634-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02107827-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02107991-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02108098-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02108198-a',[ (causes,subsumption)]).
adjMapping2SUMO('02108359-a',[ (causes,subsumption)]).
adjMapping2SUMO('02108547-s',[ (causes,subsumption)]).
adjMapping2SUMO('02108665-a',[ ('Perception',subsumption)]).
adjMapping2SUMO('02108827-a',[ ('Perception',subsumption)]).
adjMapping2SUMO('02109012-s',[ ('Perception',subsumption)]).
adjMapping2SUMO('02109162-s',[ ('Perception',subsumption)]).
adjMapping2SUMO('02109326-s',[ ('Perception',subsumption)]).
adjMapping2SUMO('02109448-a',[ ('Transfer',subsumption)]).
adjMapping2SUMO('02109552-a',[ ('Transfer',not(subsumption))]).
adjMapping2SUMO('02109678-a',[ (equal,equivalence)]).
adjMapping2SUMO('02110161-s',[ ('Separating',subsumption)]).
adjMapping2SUMO('02110317-s',[ ('Separating',subsumption)]).
adjMapping2SUMO('02110447-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02110778-s',[ (equal,subsumption)]).
adjMapping2SUMO('02110993-s',[ (disjoint,equivalence)]).
adjMapping2SUMO('02111095-s',[ ('Separating',subsumption)]).
adjMapping2SUMO('02111339-s',[ (capability,subsumption)]).
adjMapping2SUMO('02111486-s',[ ('SocialInteraction',not(subsumption))]).
adjMapping2SUMO('02111684-a',[ ('Cooperation',subsumption)]).
adjMapping2SUMO('02111981-s',[ ('Cooperation',subsumption)]).
adjMapping2SUMO('02112108-s',[ ('Cooperation',subsumption)]).
adjMapping2SUMO('02112455-s',[ ('Cooperation',subsumption)]).
adjMapping2SUMO('02112701-s',[ ('Cooperation',subsumption)]).
adjMapping2SUMO('02112891-s',[ ('Cooperation',subsumption)]).
adjMapping2SUMO('02112976-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02113191-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02113449-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02113672-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02113827-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02114190-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02114296-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02114483-s',[ (causes,subsumption)]).
adjMapping2SUMO('02114613-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02114746-s',[ ('InfectiousDisease',subsumption)]).
adjMapping2SUMO('02115034-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02115187-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02115324-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('02115759-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('02116054-s',[ (inhibits,subsumption)]).
adjMapping2SUMO('02116304-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('02116397-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02116473-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02116618-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02116783-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('02116934-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02117144-s',[ ('Removing',not(subsumption))]).
adjMapping2SUMO('02117232-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02117464-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02117694-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('02117866-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('02118047-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02118181-s',[ (capability,subsumption)]).
adjMapping2SUMO('02118379-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02118840-s',[ (believes,subsumption)]).
adjMapping2SUMO('02119213-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02119639-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02119716-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02119971-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02120150-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02120276-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02120458-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02120828-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02121123-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02121290-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02121424-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02121572-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02121735-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02121859-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02122132-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02122379-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02122543-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02122715-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02123007-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02123118-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02123314-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02123475-a',[ ('Selecting',equivalence)]).
adjMapping2SUMO('02123579-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02123743-a',[ ('Selecting',not(subsumption))]).
adjMapping2SUMO('02123812-a',[ (capability,subsumption)]).
adjMapping2SUMO('02124096-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02124253-s',[ (capability,subsumption)]).
adjMapping2SUMO('02124654-a',[ (capability,subsumption)]).
adjMapping2SUMO('02124886-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02125057-s',[ (capability,subsumption)]).
adjMapping2SUMO('02125198-s',[ (capability,subsumption)]).
adjMapping2SUMO('02125294-s',[ ('Repairing',not(subsumption))]).
adjMapping2SUMO('02125409-a',[ (inhabits,subsumption)]).
adjMapping2SUMO('02125601-a',[ (inhabits,subsumption)]).
adjMapping2SUMO('02125797-a',[ (inhabits,subsumption)]).
adjMapping2SUMO('02126140-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02126332-s',[ (inhabits,subsumption)]).
adjMapping2SUMO('02126430-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('02126694-s',[ (inhabits,subsumption)]).
adjMapping2SUMO('02126796-s',[ (inhabits,subsumption)]).
adjMapping2SUMO('02126889-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02127159-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02127509-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02127693-s',[ ('Human',subsumption)]).
adjMapping2SUMO('02127815-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02128084-s',[ ('EthnicGroup',subsumption)]).
adjMapping2SUMO('02128388-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02128566-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02128736-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02128922-s',[ (located,subsumption)]).
adjMapping2SUMO('02129007-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02129136-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('02129259-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02129535-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02129718-s',[ ('Ordering',subsumption)]).
adjMapping2SUMO('02129908-s',[ ('Ordering',subsumption)]).
adjMapping2SUMO('02130137-s',[ ('',undefined)]).
adjMapping2SUMO('02130272-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02130391-s',[ ('Planning',subsumption)]).
adjMapping2SUMO('02130514-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02130672-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02130821-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02131072-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02131668-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02131834-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02131958-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02132080-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02132224-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02132607-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02132735-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02132967-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02133207-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02133431-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02133653-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02133779-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02134162-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02134286-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02134397-s',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('02134557-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02134701-s',[ ('',undefined)]).
adjMapping2SUMO('02134802-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02134896-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02134999-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02135138-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02135213-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02135290-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02135389-a',[ ('SexualReproduction',subsumption)]).
adjMapping2SUMO('02135595-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02135692-s',[ ('SexAttribute',subsumption)]).
adjMapping2SUMO('02135773-s',[ ('SexAttribute',subsumption)]).
adjMapping2SUMO('02135913-a',[ ('AsexualReproduction',equivalence)]).
adjMapping2SUMO('02136158-s',[ ('AsexualReproduction',subsumption)]).
adjMapping2SUMO('02136423-s',[ ('Replication',subsumption)]).
adjMapping2SUMO('02136522-s',[ ('SexAttribute',subsumption)]).
adjMapping2SUMO('02136665-s',[ ('AsexualReproduction',subsumption)]).
adjMapping2SUMO('02136802-a',[ ('SexAttribute',subsumption)]).
adjMapping2SUMO('02136970-s',[ ('SexAttribute',subsumption)]).
adjMapping2SUMO('02137070-s',[ ('SexAttribute',subsumption)]).
adjMapping2SUMO('02137205-s',[ ('SexAttribute',subsumption)]).
adjMapping2SUMO('02137305-a',[ ('SexAttribute',subsumption)]).
adjMapping2SUMO('02137394-s',[ ('SexAttribute',subsumption)]).
adjMapping2SUMO('02137538-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02137713-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02137806-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02138034-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('02138138-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('02138257-a',[ ('Mammal',subsumption)]).
adjMapping2SUMO('02138428-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('02138659-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02138989-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02139403-s',[ ('',undefined)]).
adjMapping2SUMO('02139563-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02139652-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02139793-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02139884-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02140144-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02140305-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02140392-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02140492-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02140834-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02141021-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02141209-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02141298-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02141644-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02141735-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02141867-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02142063-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02142139-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02142306-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02142446-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('02142592-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02142787-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02142983-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('02143056-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02144436-s',[ ('Pliable',subsumption)]).
adjMapping2SUMO('02144834-s',[ ('',undefined)]).
adjMapping2SUMO('02144913-s',[ ('',undefined)]).
adjMapping2SUMO('02144988-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02145135-s',[ ('',undefined)]).
adjMapping2SUMO('02145209-s',[ ('',undefined)]).
adjMapping2SUMO('02145308-s',[ ('',undefined)]).
adjMapping2SUMO('02145388-s',[ ('',undefined)]).
adjMapping2SUMO('02145464-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02145598-s',[ ('',undefined)]).
adjMapping2SUMO('02145674-s',[ ('',undefined)]).
adjMapping2SUMO('02145754-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02145832-s',[ ('',undefined)]).
adjMapping2SUMO('02145918-s',[ ('',undefined)]).
adjMapping2SUMO('02146029-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02146159-s',[ ('',undefined)]).
adjMapping2SUMO('02146235-s',[ ('',undefined)]).
adjMapping2SUMO('02146347-s',[ ('',undefined)]).
adjMapping2SUMO('02146481-s',[ ('',undefined)]).
adjMapping2SUMO('02146557-s',[ ('',undefined)]).
adjMapping2SUMO('02146645-s',[ ('ShapeChange',subsumption)]).
adjMapping2SUMO('02146760-s',[ ('',undefined)]).
adjMapping2SUMO('02146864-s',[ ('',undefined)]).
adjMapping2SUMO('02146949-s',[ ('',undefined)]).
adjMapping2SUMO('02147033-s',[ ('',undefined)]).
adjMapping2SUMO('02147117-s',[ ('',undefined)]).
adjMapping2SUMO('02147203-s',[ ('',undefined)]).
adjMapping2SUMO('02147297-s',[ ('',undefined)]).
adjMapping2SUMO('02147387-s',[ ('',undefined)]).
adjMapping2SUMO('02147477-s',[ ('',undefined)]).
adjMapping2SUMO('02147567-s',[ ('',undefined)]).
adjMapping2SUMO('02147653-s',[ ('',undefined)]).
adjMapping2SUMO('02147739-s',[ ('',undefined)]).
adjMapping2SUMO('02147825-s',[ ('',undefined)]).
adjMapping2SUMO('02147922-s',[ ('',undefined)]).
adjMapping2SUMO('02148011-s',[ ('',undefined)]).
adjMapping2SUMO('02148109-s',[ ('',undefined)]).
adjMapping2SUMO('02148187-s',[ ('',undefined)]).
adjMapping2SUMO('02148277-s',[ ('',undefined)]).
adjMapping2SUMO('02148361-s',[ ('',undefined)]).
adjMapping2SUMO('02148450-s',[ ('',undefined)]).
adjMapping2SUMO('02148526-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02148648-s',[ ('',undefined)]).
adjMapping2SUMO('02148728-s',[ ('',undefined)]).
adjMapping2SUMO('02148805-s',[ ('',undefined)]).
adjMapping2SUMO('02148917-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02149070-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02149153-s',[ ('',undefined)]).
adjMapping2SUMO('02149245-s',[ ('ShapeChange',subsumption)]).
adjMapping2SUMO('02149412-s',[ ('',undefined)]).
adjMapping2SUMO('02149502-s',[ ('',undefined)]).
adjMapping2SUMO('02149597-s',[ ('',undefined)]).
adjMapping2SUMO('02149695-s',[ ('',undefined)]).
adjMapping2SUMO('02149787-s',[ ('ShapeChange',subsumption)]).
adjMapping2SUMO('02150029-s',[ ('',undefined)]).
adjMapping2SUMO('02150130-s',[ ('',undefined)]).
adjMapping2SUMO('02150220-s',[ ('',undefined)]).
adjMapping2SUMO('02150308-s',[ ('',undefined)]).
adjMapping2SUMO('02150397-s',[ ('',undefined)]).
adjMapping2SUMO('02150489-s',[ ('',undefined)]).
adjMapping2SUMO('02150569-s',[ ('',undefined)]).
adjMapping2SUMO('02150658-s',[ ('',undefined)]).
adjMapping2SUMO('02150750-s',[ ('',undefined)]).
adjMapping2SUMO('02150842-s',[ ('',undefined)]).
adjMapping2SUMO('02150960-s',[ ('',undefined)]).
adjMapping2SUMO('02151050-s',[ ('',undefined)]).
adjMapping2SUMO('02151145-s',[ ('',undefined)]).
adjMapping2SUMO('02151234-s',[ ('',undefined)]).
adjMapping2SUMO('02151320-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02151438-s',[ ('',undefined)]).
adjMapping2SUMO('02151527-s',[ ('',undefined)]).
adjMapping2SUMO('02151616-s',[ ('',undefined)]).
adjMapping2SUMO('02151705-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02151837-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02152078-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02152216-a',[ (and,subsumption)]).
adjMapping2SUMO('02152473-s',[ (and,subsumption)]).
adjMapping2SUMO('02152716-s',[ (and,subsumption)]).
adjMapping2SUMO('02152848-a',[ (and,subsumption)]).
adjMapping2SUMO('02152985-s',[ (and,subsumption)]).
adjMapping2SUMO('02153174-s',[ (and,subsumption)]).
adjMapping2SUMO('02153359-s',[ (and,subsumption)]).
adjMapping2SUMO('02153472-a',[ ('Cutting',subsumption)]).
adjMapping2SUMO('02153620-s',[ ('Cutting',subsumption)]).
adjMapping2SUMO('02153705-s',[ ('Cutting',subsumption)]).
adjMapping2SUMO('02153817-a',[ ('Cutting',not(subsumption))]).
adjMapping2SUMO('02153965-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02154118-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02154247-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02154334-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02154422-a',[ ('Cutting',subsumption)]).
adjMapping2SUMO('02154635-a',[ ('Cutting',not(subsumption))]).
adjMapping2SUMO('02154756-a',[ ('Covering',subsumption)]).
adjMapping2SUMO('02155054-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('02155233-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('02155361-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02155454-s',[ ('',undefined)]).
adjMapping2SUMO('02155524-a',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('02155675-a',[ (capability,subsumption)]).
adjMapping2SUMO('02155771-a',[ (capability,subsumption)]).
adjMapping2SUMO('02155936-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02156111-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02156177-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('02156293-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('02156421-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02156505-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02156579-a',[ ('Clothing',not(subsumption))]).
adjMapping2SUMO('02156686-s',[ ('Clothing',not(subsumption))]).
adjMapping2SUMO('02156822-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02156934-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02157041-a',[ ('Clothing',not(subsumption))]).
adjMapping2SUMO('02157226-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02157399-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02157594-s',[ (capability,subsumption)]).
adjMapping2SUMO('02157747-s',[ (capability,subsumption)]).
adjMapping2SUMO('02157936-s',[ (capability,subsumption)]).
adjMapping2SUMO('02158089-a',[ (capability,subsumption)]).
adjMapping2SUMO('02158192-a',[ (capability,subsumption)]).
adjMapping2SUMO('02158301-a',[ (capability,subsumption)]).
adjMapping2SUMO('02158438-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02158646-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02158731-s',[ (capability,subsumption)]).
adjMapping2SUMO('02158826-a',[ (capability,subsumption)]).
adjMapping2SUMO('02159293-s',[ (capability,subsumption)]).
adjMapping2SUMO('02159364-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02159453-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02159612-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02159787-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02159969-s',[ (capability,subsumption)]).
adjMapping2SUMO('02160135-s',[ (capability,subsumption)]).
adjMapping2SUMO('02160291-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02160465-s',[ (capability,subsumption)]).
adjMapping2SUMO('02160622-s',[ (capability,subsumption)]).
adjMapping2SUMO('02160696-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02160878-a',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('02161016-s',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('02161136-s',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('02161314-a',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('02161432-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02161982-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02162179-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02162458-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02162733-s',[ (increasesLikelihood,subsumption)]).
adjMapping2SUMO('02162934-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02163307-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02163468-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02163602-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02163774-s',[ ('',undefined)]).
adjMapping2SUMO('02164050-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02164165-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02164402-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02164713-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02164913-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02165171-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02165318-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02165432-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02165655-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02165925-a',[ ('ProbabilityRelation',subsumption)]).
adjMapping2SUMO('02166027-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02166159-s',[ ('PoliticalProcess',subsumption)]).
adjMapping2SUMO('02166277-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02166346-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02167133-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02167285-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02167405-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02167513-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02167628-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02167740-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02167894-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02168014-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02168132-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02168248-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02168400-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02168549-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02168699-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02168796-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02168904-s',[ ('',undefined)]).
adjMapping2SUMO('02168991-s',[ ('',undefined)]).
adjMapping2SUMO('02169081-s',[ ('',undefined)]).
adjMapping2SUMO('02169175-s',[ ('',undefined)]).
adjMapping2SUMO('02169267-s',[ ('',undefined)]).
adjMapping2SUMO('02169359-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02169467-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02169591-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02169728-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02169844-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02169940-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02170052-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02170199-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02170411-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02170546-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02170673-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02170821-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02170957-s',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('02171024-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02171724-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02171836-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02171938-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02172038-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02172152-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02172255-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02172377-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02172488-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02172617-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02172770-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02172851-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02172995-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02173125-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02173264-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02173371-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02173510-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02173632-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02173773-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02173930-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02174089-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02174188-s',[ ('',undefined)]).
adjMapping2SUMO('02174305-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02174417-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02174542-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02174678-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02174781-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02174896-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02175267-s',[ ('Word',subsumption)]).
adjMapping2SUMO('02175487-s',[ ('',undefined)]).
adjMapping2SUMO('02175684-s',[ (capability,subsumption)]).
adjMapping2SUMO('02175980-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02176178-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02176741-s',[ (capability,subsumption)]).
adjMapping2SUMO('02176841-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02177397-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('02177584-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02177755-s',[ ('CorpuscularObject',equivalence)]).
adjMapping2SUMO('02177872-s',[ ('Mixture',equivalence)]).
adjMapping2SUMO('02178116-s',[ ('',undefined)]).
adjMapping2SUMO('02178241-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02178348-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02178500-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02178628-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02178837-s',[ ('',undefined)]).
adjMapping2SUMO('02179044-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02179167-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02179279-a',[ ('Pretending',subsumption)]).
adjMapping2SUMO('02179707-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02179808-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02179968-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02180157-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('02180277-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('02180486-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02180797-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02181231-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02181432-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02181926-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('02182088-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('02182217-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('02182302-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02182562-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('02182728-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02182862-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02182979-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02183135-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02183421-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02183512-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02183611-a',[ ('RealNumber',subsumption)]).
adjMapping2SUMO('02186132-s',[ ('Integer',instance)]).
adjMapping2SUMO('02186265-s',[ ('',undefined)]).
adjMapping2SUMO('02186338-s',[ ('Integer',instance)]).
adjMapping2SUMO('02186470-s',[ ('Integer',instance)]).
adjMapping2SUMO('02186580-s',[ ('Integer',instance)]).
adjMapping2SUMO('02186665-s',[ ('Integer',instance)]).
adjMapping2SUMO('02186750-s',[ ('Integer',instance)]).
adjMapping2SUMO('02186833-s',[ ('Integer',instance)]).
adjMapping2SUMO('02186970-s',[ ('Integer',instance)]).
adjMapping2SUMO('02187073-s',[ ('Integer',instance)]).
adjMapping2SUMO('02187161-s',[ ('Integer',instance)]).
adjMapping2SUMO('02187296-s',[ ('Integer',instance)]).
adjMapping2SUMO('02187379-s',[ ('Integer',instance)]).
adjMapping2SUMO('02187465-s',[ ('Integer',instance)]).
adjMapping2SUMO('02187606-s',[ ('Integer',instance)]).
adjMapping2SUMO('02187699-s',[ ('Integer',instance)]).
adjMapping2SUMO('02187793-s',[ ('Integer',instance)]).
adjMapping2SUMO('02187903-s',[ ('Integer',instance)]).
adjMapping2SUMO('02187995-s',[ ('Integer',instance)]).
adjMapping2SUMO('02188108-s',[ ('Integer',instance)]).
adjMapping2SUMO('02188205-s',[ ('Integer',instance)]).
adjMapping2SUMO('02188317-s',[ ('Integer',instance)]).
adjMapping2SUMO('02188431-s',[ ('Integer',instance)]).
adjMapping2SUMO('02188525-s',[ ('Integer',instance)]).
adjMapping2SUMO('02188620-s',[ ('Integer',instance)]).
adjMapping2SUMO('02188720-s',[ ('Integer',instance)]).
adjMapping2SUMO('02188817-s',[ ('Integer',instance)]).
adjMapping2SUMO('02188913-s',[ ('Integer',instance)]).
adjMapping2SUMO('02189008-s',[ ('Integer',instance)]).
adjMapping2SUMO('02189108-s',[ ('Integer',instance)]).
adjMapping2SUMO('02189209-s',[ ('Integer',instance)]).
adjMapping2SUMO('02189306-s',[ ('Integer',instance)]).
adjMapping2SUMO('02189396-s',[ ('Integer',instance)]).
adjMapping2SUMO('02189491-s',[ ('Integer',instance)]).
adjMapping2SUMO('02189587-s',[ ('Integer',instance)]).
adjMapping2SUMO('02189688-s',[ ('Integer',instance)]).
adjMapping2SUMO('02189786-s',[ ('Integer',instance)]).
adjMapping2SUMO('02189883-s',[ ('Integer',instance)]).
adjMapping2SUMO('02189979-s',[ ('Integer',instance)]).
adjMapping2SUMO('02190080-s',[ ('Integer',instance)]).
adjMapping2SUMO('02190182-s',[ ('Integer',instance)]).
adjMapping2SUMO('02190278-s',[ ('Integer',instance)]).
adjMapping2SUMO('02190377-s',[ ('Integer',instance)]).
adjMapping2SUMO('02190469-s',[ ('Integer',instance)]).
adjMapping2SUMO('02190562-s',[ ('Integer',instance)]).
adjMapping2SUMO('02190660-s',[ ('Integer',instance)]).
adjMapping2SUMO('02190755-s',[ ('Integer',instance)]).
adjMapping2SUMO('02190849-s',[ ('Integer',instance)]).
adjMapping2SUMO('02190942-s',[ ('Integer',instance)]).
adjMapping2SUMO('02191040-s',[ ('Integer',instance)]).
adjMapping2SUMO('02191139-s',[ ('Integer',instance)]).
adjMapping2SUMO('02191232-s',[ ('Integer',instance)]).
adjMapping2SUMO('02191336-s',[ ('Integer',instance)]).
adjMapping2SUMO('02191427-s',[ ('Integer',instance)]).
adjMapping2SUMO('02191519-s',[ ('Integer',instance)]).
adjMapping2SUMO('02191616-s',[ ('Integer',instance)]).
adjMapping2SUMO('02191710-s',[ ('Integer',instance)]).
adjMapping2SUMO('02191803-s',[ ('Integer',instance)]).
adjMapping2SUMO('02191895-s',[ ('Integer',instance)]).
adjMapping2SUMO('02191992-s',[ ('Integer',instance)]).
adjMapping2SUMO('02192090-s',[ ('Integer',instance)]).
adjMapping2SUMO('02192184-s',[ ('Integer',instance)]).
adjMapping2SUMO('02192284-s',[ ('Integer',instance)]).
adjMapping2SUMO('02192376-s',[ ('Integer',instance)]).
adjMapping2SUMO('02192469-s',[ ('Integer',instance)]).
adjMapping2SUMO('02192567-s',[ ('Integer',instance)]).
adjMapping2SUMO('02192662-s',[ ('Integer',instance)]).
adjMapping2SUMO('02192756-s',[ ('Integer',instance)]).
adjMapping2SUMO('02192849-s',[ ('Integer',instance)]).
adjMapping2SUMO('02192947-s',[ ('Integer',instance)]).
adjMapping2SUMO('02193046-s',[ ('Integer',instance)]).
adjMapping2SUMO('02193141-s',[ ('Integer',instance)]).
adjMapping2SUMO('02193249-s',[ ('Integer',instance)]).
adjMapping2SUMO('02193346-s',[ ('Integer',instance)]).
adjMapping2SUMO('02193444-s',[ ('Integer',instance)]).
adjMapping2SUMO('02193547-s',[ ('Integer',instance)]).
adjMapping2SUMO('02193647-s',[ ('Integer',instance)]).
adjMapping2SUMO('02193746-s',[ ('Integer',instance)]).
adjMapping2SUMO('02193844-s',[ ('Integer',instance)]).
adjMapping2SUMO('02193947-s',[ ('Integer',instance)]).
adjMapping2SUMO('02194051-s',[ ('Integer',instance)]).
adjMapping2SUMO('02194151-s',[ ('Integer',instance)]).
adjMapping2SUMO('02194255-s',[ ('Integer',instance)]).
adjMapping2SUMO('02194351-s',[ ('Integer',instance)]).
adjMapping2SUMO('02194448-s',[ ('Integer',instance)]).
adjMapping2SUMO('02194550-s',[ ('Integer',instance)]).
adjMapping2SUMO('02194649-s',[ ('Integer',instance)]).
adjMapping2SUMO('02194747-s',[ ('Integer',instance)]).
adjMapping2SUMO('02194844-s',[ ('Integer',instance)]).
adjMapping2SUMO('02194946-s',[ ('Integer',instance)]).
adjMapping2SUMO('02195049-s',[ ('Integer',instance)]).
adjMapping2SUMO('02195145-s',[ ('Integer',instance)]).
adjMapping2SUMO('02195234-s',[ ('Integer',instance)]).
adjMapping2SUMO('02195328-s',[ ('Integer',instance)]).
adjMapping2SUMO('02195423-s',[ ('Integer',instance)]).
adjMapping2SUMO('02195523-s',[ ('Integer',instance)]).
adjMapping2SUMO('02195620-s',[ ('Integer',instance)]).
adjMapping2SUMO('02195716-s',[ ('Integer',instance)]).
adjMapping2SUMO('02195811-s',[ ('Integer',instance)]).
adjMapping2SUMO('02195911-s',[ ('Integer',instance)]).
adjMapping2SUMO('02196012-s',[ ('Integer',instance)]).
adjMapping2SUMO('02196107-s',[ ('Integer',instance)]).
adjMapping2SUMO('02196211-s',[ ('Integer',instance)]).
adjMapping2SUMO('02196333-s',[ ('Integer',instance)]).
adjMapping2SUMO('02196439-s',[ ('Integer',instance)]).
adjMapping2SUMO('02196543-s',[ ('Integer',instance)]).
adjMapping2SUMO('02196657-s',[ ('Integer',instance)]).
adjMapping2SUMO('02196769-s',[ ('Integer',instance)]).
adjMapping2SUMO('02196891-s',[ ('Integer',instance)]).
adjMapping2SUMO('02197007-s',[ ('Integer',instance)]).
adjMapping2SUMO('02197130-s',[ ('Integer',instance)]).
adjMapping2SUMO('02197244-s',[ ('Integer',instance)]).
adjMapping2SUMO('02197364-s',[ ('Integer',instance)]).
adjMapping2SUMO('02197476-s',[ ('Integer',instance)]).
adjMapping2SUMO('02197595-s',[ ('Integer',instance)]).
adjMapping2SUMO('02197708-s',[ ('Integer',instance)]).
adjMapping2SUMO('02197828-s',[ ('Integer',instance)]).
adjMapping2SUMO('02197944-s',[ ('Integer',instance)]).
adjMapping2SUMO('02198069-s',[ ('Integer',instance)]).
adjMapping2SUMO('02198187-s',[ ('Integer',instance)]).
adjMapping2SUMO('02198302-s',[ ('Integer',instance)]).
adjMapping2SUMO('02198409-s',[ ('Integer',instance)]).
adjMapping2SUMO('02198520-s',[ ('Integer',instance)]).
adjMapping2SUMO('02198631-s',[ ('Integer',instance)]).
adjMapping2SUMO('02198752-s',[ ('Integer',instance)]).
adjMapping2SUMO('02198891-s',[ ('Integer',instance)]).
adjMapping2SUMO('02199005-s',[ ('Integer',instance)]).
adjMapping2SUMO('02199177-s',[ ('Integer',instance)]).
adjMapping2SUMO('02199342-s',[ ('Integer',instance)]).
adjMapping2SUMO('02199523-s',[ ('',undefined)]).
adjMapping2SUMO('02199699-s',[ ('Integer',instance)]).
adjMapping2SUMO('02199813-s',[ ('Integer',instance)]).
adjMapping2SUMO('02199919-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02200035-a',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02201882-s',[ ('Integer',instance)]).
adjMapping2SUMO('02201970-s',[ ('Number',subsumption)]).
adjMapping2SUMO('02202047-s',[ ('FirstFn',equivalence)]).
adjMapping2SUMO('02202146-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02202307-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02202443-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02202712-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02202854-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02202979-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02203123-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02203249-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02203373-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02203500-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02203629-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02203763-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02203868-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02203976-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02204131-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02204237-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02204363-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02204472-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02204580-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02204716-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02204823-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02204932-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02205045-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02205158-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02205271-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02205384-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02205496-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02205610-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02205725-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02205838-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02205947-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02206056-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02206173-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02206291-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02206409-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02206526-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02206642-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02206762-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02206881-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02206998-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02207105-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02207219-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02207334-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02207450-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02207566-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02207681-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02207795-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02207913-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02208030-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02208145-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02208270-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02208385-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02208492-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02208608-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02208723-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02208852-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02208971-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02209080-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02209197-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02209306-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02209423-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02209551-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02209678-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02209806-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02209933-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02210068-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02210202-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02210344-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02210478-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02210620-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02210752-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02210892-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02211024-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02211164-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02211296-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02211436-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02211572-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02211716-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02211850-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02211989-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02212108-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02212231-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02212352-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02212473-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02212591-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02212698-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02212805-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02212914-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02213029-s',[ ('ListOrderFn',subsumption)]).
adjMapping2SUMO('02213144-s',[ (greaterThan,subsumption)]).
adjMapping2SUMO('02213270-a',[ ('Writing',subsumption)]).
adjMapping2SUMO('02213377-a',[ ('Writing',not(subsumption))]).
adjMapping2SUMO('02213557-s',[ ('Planning',not(subsumption))]).
adjMapping2SUMO('02213748-a',[ (capability,subsumption)]).
adjMapping2SUMO('02213824-a',[ (capability,subsumption)]).
adjMapping2SUMO('02213947-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02214366-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02214518-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02214736-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02215087-s',[ (equal,subsumption)]).
adjMapping2SUMO('02215382-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02215567-s',[ (part,subsumption)]).
adjMapping2SUMO('02215769-s',[ ('PoliticalOrganization',subsumption)]).
adjMapping2SUMO('02215977-a',[ ('Collection',subsumption)]).
adjMapping2SUMO('02216694-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('02216890-s',[ ('Collection',subsumption)]).
adjMapping2SUMO('02216985-s',[ ('Collection',subsumption)]).
adjMapping2SUMO('02217241-s',[ ('MultiplicationFn',subsumption)]).
adjMapping2SUMO('02217452-s',[ ('Collection',subsumption)]).
adjMapping2SUMO('02217799-s',[ ('MultiplicationFn',subsumption)]).
adjMapping2SUMO('02218179-s',[ (part,subsumption)]).
adjMapping2SUMO('02218314-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02218547-s',[ ('Collection',subsumption)]).
adjMapping2SUMO('02218834-s',[ ('MultiplicationFn',subsumption)]).
adjMapping2SUMO('02219015-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02219144-s',[ ('MultiplicationFn',subsumption)]).
adjMapping2SUMO('02219287-s',[ ('Collection',subsumption)]).
adjMapping2SUMO('02219492-s',[ ('Collection',subsumption)]).
adjMapping2SUMO('02219660-s',[ ('Collection',subsumption)]).
adjMapping2SUMO('02219770-s',[ ('Collection',subsumption)]).
adjMapping2SUMO('02219876-s',[ ('Collection',subsumption)]).
adjMapping2SUMO('02219988-s',[ ('Collection',subsumption)]).
adjMapping2SUMO('02220099-s',[ ('Collection',subsumption)]).
adjMapping2SUMO('02220207-s',[ ('Collection',subsumption)]).
adjMapping2SUMO('02220308-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02220571-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02220788-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02221017-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02221173-a',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('02221362-a',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('02221550-s',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('02221723-s',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('02221821-s',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('02221951-s',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('02222053-a',[ (measure,subsumption)]).
adjMapping2SUMO('02222578-s',[ ('',undefined)]).
adjMapping2SUMO('02222675-s',[ ('',undefined)]).
adjMapping2SUMO('02222773-s',[ ('',undefined)]).
adjMapping2SUMO('02222871-s',[ ('',undefined)]).
adjMapping2SUMO('02222965-s',[ ('',undefined)]).
adjMapping2SUMO('02223066-s',[ ('LengthMeasure',subsumption)]).
adjMapping2SUMO('02223165-s',[ ('',undefined)]).
adjMapping2SUMO('02223263-s',[ ('LengthMeasure',subsumption)]).
adjMapping2SUMO('02223361-s',[ ('',undefined)]).
adjMapping2SUMO('02223457-s',[ ('',undefined)]).
adjMapping2SUMO('02223559-s',[ ('',undefined)]).
adjMapping2SUMO('02223659-s',[ ('',undefined)]).
adjMapping2SUMO('02223785-s',[ ('',undefined)]).
adjMapping2SUMO('02223881-s',[ ('LengthMeasure',subsumption)]).
adjMapping2SUMO('02223977-s',[ ('',undefined)]).
adjMapping2SUMO('02224076-s',[ ('',undefined)]).
adjMapping2SUMO('02224168-s',[ ('',undefined)]).
adjMapping2SUMO('02224266-s',[ ('',undefined)]).
adjMapping2SUMO('02224362-s',[ (measure,subsumption)]).
adjMapping2SUMO('02224509-s',[ ('List',subsumption)]).
adjMapping2SUMO('02224588-s',[ ('',undefined)]).
adjMapping2SUMO('02224688-s',[ ('',undefined)]).
adjMapping2SUMO('02224790-s',[ ('LengthMeasure',subsumption)]).
adjMapping2SUMO('02224879-s',[ ('',undefined)]).
adjMapping2SUMO('02224977-s',[ ('',undefined)]).
adjMapping2SUMO('02225071-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02225202-s',[ ('List',subsumption)]).
adjMapping2SUMO('02225287-a',[ ('SurfaceChange',subsumption)]).
adjMapping2SUMO('02225387-a',[ ('SurfaceChange',not(subsumption))]).
adjMapping2SUMO('02225510-a',[ (hasSkill,equivalence)]).
adjMapping2SUMO('02226028-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02226162-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02226661-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02226756-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02226979-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02227344-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02227485-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02227663-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02227772-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02227946-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02228163-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02228335-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02228901-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02229000-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02229201-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02229324-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02229584-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02229812-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02229961-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02230080-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02230205-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02230324-s',[ ('Position',subsumption)]).
adjMapping2SUMO('02230471-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02230581-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02230795-a',[ ('Number',subsumption)]).
adjMapping2SUMO('02230990-a',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02231355-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02231502-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02231886-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02231998-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02232112-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02232251-a',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02232739-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02232869-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02233072-s',[ ('',undefined)]).
adjMapping2SUMO('02233154-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02233282-s',[ ('',undefined)]).
adjMapping2SUMO('02233390-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02233680-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02233799-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02233927-a',[ ('Combustion',subsumption)]).
adjMapping2SUMO('02234187-s',[ ('Combustion',subsumption)]).
adjMapping2SUMO('02234281-s',[ ('Combustion',subsumption)]).
adjMapping2SUMO('02234388-s',[ ('Combustion',subsumption)]).
adjMapping2SUMO('02234485-a',[ ('Combustion',subsumption)]).
adjMapping2SUMO('02234673-s',[ ('Combustion',not(subsumption))]).
adjMapping2SUMO('02234781-a',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02235188-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02235330-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02235520-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02235740-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02235826-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('02235994-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02236146-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02236271-a',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02236423-s',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('02236532-s',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('02236645-a',[ ('Covering',subsumption)]).
adjMapping2SUMO('02236757-a',[ ('Covering',not(subsumption))]).
adjMapping2SUMO('02236842-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02237303-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('02237420-s',[ ('',undefined)]).
adjMapping2SUMO('02237502-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02237644-s',[ ('',undefined)]).
adjMapping2SUMO('02237761-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02237978-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02238128-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02238310-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02238462-a',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02239289-s',[ (causes,subsumption)]).
adjMapping2SUMO('02239479-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02239607-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02239746-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02239888-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02240006-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02240129-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02240275-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('02240379-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02240490-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('02240668-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('02240795-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('02241078-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02241247-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02241443-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02241543-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02241714-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02241834-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('02241988-s',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02242223-s',[ ('LandArea',subsumption)]).
adjMapping2SUMO('02242412-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02242481-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02242582-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02242697-s',[ ('',undefined)]).
adjMapping2SUMO('02242798-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02242887-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02243086-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02243255-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02243411-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02243567-a',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02243806-a',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02244065-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02244198-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02244361-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02244472-a',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02244619-a',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02244890-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02245020-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02245108-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02245223-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02245318-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02245403-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02245944-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02246056-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02246182-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02246296-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02246410-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02246539-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02246637-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02246733-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02246826-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02246903-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02247074-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02247166-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02247295-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02247422-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02247489-s',[ ('',undefined)]).
adjMapping2SUMO('02247637-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02247785-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02247938-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02248011-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02248078-a',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02248204-a',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02248349-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02248693-s',[ ('EthnicGroup',equivalence)]).
adjMapping2SUMO('02248984-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02249183-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02249337-s',[ ('',undefined)]).
adjMapping2SUMO('02249441-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02249766-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02249948-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02250231-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02250430-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02250691-s',[ ('SocialInteraction',not(subsumption))]).
adjMapping2SUMO('02250899-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02251057-a',[ ('SocialInteraction',not(subsumption))]).
adjMapping2SUMO('02251212-s',[ ('SocialInteraction',not(subsumption))]).
adjMapping2SUMO('02251576-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02251773-s',[ ('',undefined)]).
adjMapping2SUMO('02251899-s',[ ('SocialInteraction',not(subsumption))]).
adjMapping2SUMO('02252053-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02252182-a',[ ('SocialInteraction',not(subsumption))]).
adjMapping2SUMO('02252352-s',[ ('',undefined)]).
adjMapping2SUMO('02252480-s',[ ('',undefined)]).
adjMapping2SUMO('02252634-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02252877-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('02253065-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02253205-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('02253389-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02253536-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('02253655-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02253817-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('02253964-a',[ ('Attaching',subsumption)]).
adjMapping2SUMO('02254088-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02254172-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('02254264-a',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('02254434-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('02254546-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('02254669-s',[ ('Attaching',not(subsumption))]).
adjMapping2SUMO('02254778-a',[ ('Contest',subsumption)]).
adjMapping2SUMO('02254971-a',[ ('Contest',subsumption)]).
adjMapping2SUMO('02255069-a',[ ('ReproductiveBody',subsumption)]).
adjMapping2SUMO('02255317-s',[ ('',undefined)]).
adjMapping2SUMO('02255394-s',[ ('',undefined)]).
adjMapping2SUMO('02255487-s',[ ('ReproductiveBody',subsumption)]).
adjMapping2SUMO('02255608-s',[ ('ReproductiveBody',subsumption)]).
adjMapping2SUMO('02255736-s',[ ('',undefined)]).
adjMapping2SUMO('02255840-s',[ ('',undefined)]).
adjMapping2SUMO('02255928-s',[ ('',undefined)]).
adjMapping2SUMO('02256005-s',[ ('',undefined)]).
adjMapping2SUMO('02256082-a',[ ('ReproductiveBody',not(subsumption))]).
adjMapping2SUMO('02256209-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('02256306-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('02256437-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02256659-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('02256732-a',[ ('Artifact',not(subsumption))]).
adjMapping2SUMO('02256868-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02257038-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02257141-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02257601-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02257731-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02257856-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02258002-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02258249-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02258360-s',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02258600-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02258972-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02259120-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02259239-a',[ ('Selling',equivalence)]).
adjMapping2SUMO('02259380-s',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('02259540-s',[ ('Selling',subsumption)]).
adjMapping2SUMO('02259667-a',[ ('Selling',not(subsumption))]).
adjMapping2SUMO('02259817-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02259966-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02260035-a',[ ('Solid',equivalence)]).
adjMapping2SUMO('02260382-s',[ ('StateChange',subsumption)]).
adjMapping2SUMO('02260477-s',[ ('StateChange',subsumption)]).
adjMapping2SUMO('02260570-s',[ ('StateChange',subsumption)]).
adjMapping2SUMO('02260730-s',[ ('Substance',subsumption)]).
adjMapping2SUMO('02260847-s',[ ('PhysicalState',subsumption)]).
adjMapping2SUMO('02261013-s',[ ('Device',subsumption)]).
adjMapping2SUMO('02261162-s',[ ('Solid',subsumption)]).
adjMapping2SUMO('02261386-a',[ ('Liquid',equivalence)]).
adjMapping2SUMO('02261746-s',[ ('Liquid',subsumption)]).
adjMapping2SUMO('02261985-s',[ (capability,subsumption)]).
adjMapping2SUMO('02262173-s',[ ('StateChange',subsumption)]).
adjMapping2SUMO('02262293-s',[ ('PhysicalState',subsumption)]).
adjMapping2SUMO('02262365-s',[ ('Liquid',subsumption)]).
adjMapping2SUMO('02262542-a',[ ('Gas',equivalence)]).
adjMapping2SUMO('02262879-s',[ ('Gas',subsumption)]).
adjMapping2SUMO('02262984-s',[ ('PhysicalState',subsumption)]).
adjMapping2SUMO('02263150-s',[ ('StateChange',subsumption)]).
adjMapping2SUMO('02263270-s',[ ('StateChange',subsumption)]).
adjMapping2SUMO('02263407-s',[ ('Gas',subsumption)]).
adjMapping2SUMO('02263491-s',[ ('Gas',subsumption)]).
adjMapping2SUMO('02263680-a',[ ('SelfConnectedObject',subsumption)]).
adjMapping2SUMO('02263875-s',[ ('SelfConnectedObject',subsumption)]).
adjMapping2SUMO('02263982-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02264366-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02264521-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02264657-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02264807-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02265015-a',[ ('Substance',subsumption)]).
adjMapping2SUMO('02265306-s',[ ('',undefined)]).
adjMapping2SUMO('02265386-s',[ (capability,subsumption)]).
adjMapping2SUMO('02265496-s',[ ('',undefined)]).
adjMapping2SUMO('02265594-s',[ (capability,subsumption)]).
adjMapping2SUMO('02265719-s',[ ('',undefined)]).
adjMapping2SUMO('02265815-s',[ ('',undefined)]).
adjMapping2SUMO('02265891-a',[ ('Substance',subsumption)]).
adjMapping2SUMO('02266043-s',[ ('',undefined)]).
adjMapping2SUMO('02266145-a',[ (capability,subsumption)]).
adjMapping2SUMO('02266351-s',[ (capability,subsumption)]).
adjMapping2SUMO('02266451-s',[ (capability,subsumption)]).
adjMapping2SUMO('02266600-a',[ (capability,subsumption)]).
adjMapping2SUMO('02266771-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02267012-a',[ ('Stating',subsumption)]).
adjMapping2SUMO('02267164-a',[ ('Stating',not(subsumption))]).
adjMapping2SUMO('02267308-a',[ (exists,subsumption)]).
adjMapping2SUMO('02267686-s',[ (exists,subsumption)]).
adjMapping2SUMO('02268133-s',[ (forall,subsumption)]).
adjMapping2SUMO('02268268-s',[ (exists,subsumption)]).
adjMapping2SUMO('02268485-a',[ (not,subsumption)]).
adjMapping2SUMO('02268882-s',[ (not,subsumption)]).
adjMapping2SUMO('02269039-s',[ ('',undefined)]).
adjMapping2SUMO('02269142-s',[ ('ConstantQuantity',subsumption)]).
adjMapping2SUMO('02269286-a',[ (forall,subsumption)]).
adjMapping2SUMO('02269635-s',[ (forall,subsumption)]).
adjMapping2SUMO('02269794-s',[ (forall,subsumption)]).
adjMapping2SUMO('02270057-s',[ (forall,subsumption)]).
adjMapping2SUMO('02270186-s',[ (forall,subsumption)]).
adjMapping2SUMO('02270342-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02270782-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02271052-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02271177-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02271437-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02271544-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02272047-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02272305-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02272485-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02272670-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02272954-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02273088-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02273326-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02273643-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02273838-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02273952-s',[ ('Freezing',subsumption)]).
adjMapping2SUMO('02274089-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02274253-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02274537-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02274869-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02274959-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02275209-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02275412-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02275629-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02275803-s',[ ('ChemicalDecomposition',subsumption)]).
adjMapping2SUMO('02275892-s',[ ('ChemicalDecomposition',subsumption)]).
adjMapping2SUMO('02276088-a',[ ('Beverage',subsumption)]).
adjMapping2SUMO('02276305-s',[ ('Beverage',subsumption)]).
adjMapping2SUMO('02276660-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('02276752-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02276852-s',[ ('Beverage',subsumption)]).
adjMapping2SUMO('02276964-a',[ ('Beverage',subsumption)]).
adjMapping2SUMO('02277078-s',[ ('Beverage',subsumption)]).
adjMapping2SUMO('02277182-s',[ ('Beverage',subsumption)]).
adjMapping2SUMO('02277279-a',[ ('Beverage',subsumption)]).
adjMapping2SUMO('02277485-a',[ ('Beverage',subsumption)]).
adjMapping2SUMO('02277607-a',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('02277829-s',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('02278011-s',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('02278195-s',[ ('Position',subsumption)]).
adjMapping2SUMO('02278337-a',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('02278513-s',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('02278738-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02278842-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02278939-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02279360-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02279523-s',[ ('',undefined)]).
adjMapping2SUMO('02279622-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02279723-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02279900-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02280090-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02280333-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02280457-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02280566-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02280680-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02280821-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02280969-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02281182-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02281325-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02281611-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02281813-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02281938-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02282171-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02282277-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02282376-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02282651-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02282843-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02282985-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02283188-a',[ (causes,subsumption)]).
adjMapping2SUMO('02283356-s',[ (causes,subsumption)]).
adjMapping2SUMO('02283525-s',[ ('',undefined)]).
adjMapping2SUMO('02283703-a',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('02284023-s',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('02284169-s',[ ('Speaking',subsumption)]).
adjMapping2SUMO('02284324-s',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('02284423-s',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('02284578-a',[ ('Writing',equivalence)]).
adjMapping2SUMO('02284892-s',[ ('Writing',subsumption)]).
adjMapping2SUMO('02285035-s',[ ('Writing',subsumption)]).
adjMapping2SUMO('02285147-s',[ ('Writing',subsumption)]).
adjMapping2SUMO('02285278-s',[ ('Writing',subsumption)]).
adjMapping2SUMO('02285407-s',[ ('Writing',subsumption)]).
adjMapping2SUMO('02285480-s',[ ('Writing',subsumption)]).
adjMapping2SUMO('02285607-s',[ ('Writing',subsumption)]).
adjMapping2SUMO('02285739-s',[ ('Writing',subsumption)]).
adjMapping2SUMO('02285854-s',[ ('Writing',subsumption)]).
adjMapping2SUMO('02285969-s',[ ('Writing',subsumption)]).
adjMapping2SUMO('02286083-a',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('02286294-a',[ ('RadiatingSound',not(subsumption))]).
adjMapping2SUMO('02286507-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('02286661-a',[ ('Writing',subsumption)]).
adjMapping2SUMO('02286790-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02286927-a',[ ('Writing',not(subsumption))]).
adjMapping2SUMO('02287175-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02287276-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02287510-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02287636-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02287878-a',[ (capability,subsumption)]).
adjMapping2SUMO('02288022-s',[ ('',undefined)]).
adjMapping2SUMO('02288118-a',[ (capability,subsumption)]).
adjMapping2SUMO('02288252-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02288350-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02288490-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02288668-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02288904-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02289018-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02289151-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02289287-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02289405-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02289543-s',[ ('Text',subsumption)]).
adjMapping2SUMO('02289659-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02289738-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02290179-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02290265-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02290454-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02290714-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02290998-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02291336-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02291500-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02291632-s',[ (capability,subsumption)]).
adjMapping2SUMO('02291754-s',[ (causes,subsumption)]).
adjMapping2SUMO('02291843-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02292303-s',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02292421-s',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('02292573-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02292797-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02293141-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02293230-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02293386-s',[ ('ConsciousnessAttribute',subsumption)]).
adjMapping2SUMO('02293497-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02293592-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02293760-s',[ ('',undefined)]).
adjMapping2SUMO('02293856-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02294122-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02294263-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02294440-a',[ (realization,subsumption)]).
adjMapping2SUMO('02294563-a',[ (realization,subsumption)]).
adjMapping2SUMO('02294662-s',[ (realization,subsumption)]).
adjMapping2SUMO('02294777-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02295098-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02295298-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02295511-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02295710-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02295867-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02295998-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02296415-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02296632-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02296824-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02296950-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02297089-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02297166-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02297409-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02297586-s',[ ('NormativeAttribute',not(subsumption))]).
adjMapping2SUMO('02297664-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02297966-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02298152-s',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('02298285-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02298642-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02298766-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02299048-a',[ ('Food',subsumption)]).
adjMapping2SUMO('02299189-s',[ ('Food',subsumption)]).
adjMapping2SUMO('02299366-a',[ ('Food',subsumption)]).
adjMapping2SUMO('02299437-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('02299673-s',[ ('',undefined)]).
adjMapping2SUMO('02299748-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('02299889-s',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('02300002-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('02300101-a',[ ('AstronomicalBody',not(subsumption))]).
adjMapping2SUMO('02300227-a',[ ('Ingesting',subsumption)]).
adjMapping2SUMO('02300413-s',[ ('Eating',subsumption)]).
adjMapping2SUMO('02300501-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02300624-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02300714-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02300786-s',[ ('Eating',subsumption)]).
adjMapping2SUMO('02300914-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02301107-s',[ ('Food',not(subsumption))]).
adjMapping2SUMO('02301180-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02301338-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02301430-s',[ ('Eating',not(subsumption))]).
adjMapping2SUMO('02301489-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02301560-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02301969-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02302187-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02302366-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02302537-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02302705-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02302822-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02302941-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02303077-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02303575-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02303754-s',[ ('PathologicProcess',subsumption)]).
adjMapping2SUMO('02304035-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02304119-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('02304208-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02304322-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02304565-s',[ ('Tremor',subsumption)]).
adjMapping2SUMO('02304987-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('02305176-s',[ ('Rotating',subsumption)]).
adjMapping2SUMO('02305394-s',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('02305484-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02305651-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02305786-s',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('02305906-a',[ (part,subsumption)]).
adjMapping2SUMO('02306080-a',[ (part,subsumption)]).
adjMapping2SUMO('02306192-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('02306288-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02306598-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02306763-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02306874-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02307026-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02307199-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02307367-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02307563-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02307729-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02308001-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02308214-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02308472-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02308840-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02309004-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02309187-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02309341-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02309668-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02309800-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02309971-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02310185-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02310371-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02310533-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02310679-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02310771-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('02310895-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02311190-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02311293-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02311442-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02311544-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02312060-s',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('02312250-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02312354-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02312450-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02312719-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02312918-s',[ (capability,subsumption)]).
adjMapping2SUMO('02313138-s',[ ('',undefined)]).
adjMapping2SUMO('02313235-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02313454-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02313563-s',[ ('',undefined)]).
adjMapping2SUMO('02313676-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02313784-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02314070-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02314236-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02314371-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02314451-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02314584-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02314756-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02314919-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02315002-a',[ ('CircleSector',subsumption)]).
adjMapping2SUMO('02315461-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02315648-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02315808-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02315914-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02316071-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02316253-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02316366-s',[ ('',undefined)]).
adjMapping2SUMO('02316524-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02316626-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02316718-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02316820-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02316992-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02317145-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02317258-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02317327-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02317598-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02317800-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('02317942-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02318057-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('02318207-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02318272-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02318372-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02318464-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02318728-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02318950-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02319034-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02319129-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02319346-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02319538-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02319765-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02319922-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02320117-a',[ ('Stressed',subsumption)]).
adjMapping2SUMO('02320289-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02320442-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02320680-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02320751-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02320886-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02321009-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02321575-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02321702-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02321809-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02322157-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02322248-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02322391-s',[ ('',undefined)]).
adjMapping2SUMO('02322512-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02322704-s',[ ('',undefined)]).
adjMapping2SUMO('02322885-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02323072-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02323204-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02323358-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('02323521-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02323726-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02323823-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02324005-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02324165-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02324397-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02324781-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02324944-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02325097-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02325304-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02325484-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02325642-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02325816-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02325984-s',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('02326342-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02326482-s',[ (capability,subsumption)]).
adjMapping2SUMO('02326621-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('02326695-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02327078-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02327315-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02327428-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02327569-s',[ ('Canine',subsumption)]).
adjMapping2SUMO('02328012-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02328108-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02328297-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02328445-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02328559-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02328659-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02328916-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02329075-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02329220-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02329355-a',[ ('Managing',subsumption)]).
adjMapping2SUMO('02329606-s',[ ('',undefined)]).
adjMapping2SUMO('02329765-s',[ ('Managing',subsumption)]).
adjMapping2SUMO('02329864-s',[ ('Managing',subsumption)]).
adjMapping2SUMO('02330064-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02330336-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02330574-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02330762-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02330935-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02331088-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02331262-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02331721-s',[ ('',undefined)]).
adjMapping2SUMO('02331857-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02332204-s',[ (occupiesPosition,subsumption)]).
adjMapping2SUMO('02332286-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02332421-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('02332604-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02332704-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02332845-s',[ ('',undefined)]).
adjMapping2SUMO('02332956-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('02333147-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('02333314-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('02333453-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02333880-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02333976-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02334321-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02334436-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02334561-s',[ (result,subsumption)]).
adjMapping2SUMO('02334717-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('02334854-s',[ ('',undefined)]).
adjMapping2SUMO('02334973-s',[ (occupiesPosition,subsumption)]).
adjMapping2SUMO('02335119-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('02335241-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02335393-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02335602-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('02335708-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('02335828-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02336109-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02336338-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02336449-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02336759-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02336904-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02337188-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02337329-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02337558-s',[ ('SubtractionFn',subsumption)]).
adjMapping2SUMO('02337667-a',[ ('Food',subsumption)]).
adjMapping2SUMO('02337912-s',[ ('Food',subsumption)]).
adjMapping2SUMO('02338037-s',[ ('Food',subsumption)]).
adjMapping2SUMO('02338125-s',[ ('Food',subsumption)]).
adjMapping2SUMO('02338197-s',[ ('Sweetness',subsumption)]).
adjMapping2SUMO('02338327-a',[ ('Food',subsumption)]).
adjMapping2SUMO('02338468-s',[ ('Food',subsumption)]).
adjMapping2SUMO('02338543-s',[ ('Food',subsumption)]).
adjMapping2SUMO('02338615-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02338917-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02339120-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02339341-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02339577-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02339791-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02340003-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02340096-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02340213-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02340458-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02340710-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02340878-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02341014-s',[ ('Position',subsumption)]).
adjMapping2SUMO('02341132-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02341266-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02341864-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02342196-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02342309-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02342463-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02342608-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02342778-s',[ ('',undefined)]).
adjMapping2SUMO('02342899-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02343110-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02343378-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02343517-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02343636-s',[ ('',undefined)]).
adjMapping2SUMO('02343762-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02343931-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02344070-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02344241-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02344381-s',[ ('',undefined)]).
adjMapping2SUMO('02344512-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02344672-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02344793-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02344998-s',[ ('',undefined)]).
adjMapping2SUMO('02345194-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02345272-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02345713-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02345859-s',[ ('Metal',subsumption)]).
adjMapping2SUMO('02346013-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02346242-s',[ ('',undefined)]).
adjMapping2SUMO('02346351-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02346557-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02346785-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02346878-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02347086-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02347371-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02347489-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02347564-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02347742-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02347915-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02348140-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02348285-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02348376-s',[ ('Food',subsumption)]).
adjMapping2SUMO('02348482-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('02348678-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('02348847-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02349003-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02349149-s',[ ('On',subsumption)]).
adjMapping2SUMO('02349274-s',[ ('On',subsumption)]).
adjMapping2SUMO('02349477-a',[ ('Adjacent',subsumption)]).
adjMapping2SUMO('02349604-s',[ ('Below',equivalence)]).
adjMapping2SUMO('02349685-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02349852-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02350035-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02350205-a',[ ('Managing',subsumption)]).
adjMapping2SUMO('02350353-a',[ ('Managing',not(subsumption))]).
adjMapping2SUMO('02350590-s',[ ('Seeing',not(subsumption))]).
adjMapping2SUMO('02350729-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02351064-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02351149-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02351246-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02351370-s',[ (capability,subsumption)]).
adjMapping2SUMO('02351490-s',[ ('Liquid',subsumption)]).
adjMapping2SUMO('02351692-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02351988-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02352153-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02352301-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02352472-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02352572-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02352650-a',[ ('Giving',subsumption)]).
adjMapping2SUMO('02352868-s',[ ('Giving',subsumption)]).
adjMapping2SUMO('02353026-a',[ (decreasesLikelihood,subsumption)]).
adjMapping2SUMO('02353211-s',[ (decreasesLikelihood,subsumption)]).
adjMapping2SUMO('02353488-s',[ (decreasesLikelihood,subsumption)]).
adjMapping2SUMO('02353599-s',[ (decreasesLikelihood,subsumption)]).
adjMapping2SUMO('02353707-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02353849-s',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('02354001-s',[ ('Device',subsumption)]).
adjMapping2SUMO('02354129-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02354234-s',[ ('Device',not(subsumption))]).
adjMapping2SUMO('02354403-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02354537-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02354897-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02355248-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02355398-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02355521-s',[ (increasesLikelihood,subsumption)]).
adjMapping2SUMO('02356048-s',[ (increasesLikelihood,subsumption)]).
adjMapping2SUMO('02356244-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02356430-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02356579-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02356712-s',[ (decreasesLikelihood,subsumption)]).
adjMapping2SUMO('02356820-a',[ (capability,subsumption)]).
adjMapping2SUMO('02357006-s',[ (capability,subsumption)]).
adjMapping2SUMO('02357115-a',[ ('Possibility',not(subsumption))]).
adjMapping2SUMO('02357322-s',[ (capability,subsumption)]).
adjMapping2SUMO('02357479-a',[ ('Surprise',equivalence)]).
adjMapping2SUMO('02357810-s',[ ('Surprise',subsumption)]).
adjMapping2SUMO('02358277-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02358650-s',[ ('',undefined)]).
adjMapping2SUMO('02358762-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02358898-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02359051-s',[ ('Surprise',subsumption)]).
adjMapping2SUMO('02359308-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02359464-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02359789-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02359958-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02360171-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02360351-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02360448-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02360944-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02361325-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02361540-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02361848-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02362030-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02362178-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02362348-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02362499-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02362708-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02362904-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02363093-s',[ ('TherapeuticProcess',not(subsumption))]).
adjMapping2SUMO('02363166-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02363358-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02363614-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02363811-s',[ ('TherapeuticProcess',subsumption)]).
adjMapping2SUMO('02363939-s',[ ('',undefined)]).
adjMapping2SUMO('02364066-s',[ (capability,subsumption)]).
adjMapping2SUMO('02364245-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02364347-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02364448-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02364721-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02364834-s',[ ('',undefined)]).
adjMapping2SUMO('02364954-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02365142-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02365264-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02365397-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02365776-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02365900-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02366078-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02366200-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02366365-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02366474-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02366618-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02366716-a',[ ('Planning',subsumption)]).
adjMapping2SUMO('02366927-s',[ ('Planning',subsumption)]).
adjMapping2SUMO('02367095-a',[ ('Planning',not(subsumption))]).
adjMapping2SUMO('02367319-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02367477-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02367604-a',[ ('Sweetness',subsumption)]).
adjMapping2SUMO('02367785-a',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('02368068-s',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('02368147-s',[ ('',undefined)]).
adjMapping2SUMO('02368247-s',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('02368336-a',[ ('Sweetness',equivalence)]).
adjMapping2SUMO('02368566-s',[ ('Sweetness',subsumption)]).
adjMapping2SUMO('02368718-s',[ ('Sweetness',subsumption)]).
adjMapping2SUMO('02368787-a',[ ('Sourness',equivalence)]).
adjMapping2SUMO('02369027-s',[ ('Bitterness',subsumption)]).
adjMapping2SUMO('02369179-s',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('02369335-s',[ ('Sourness',subsumption)]).
adjMapping2SUMO('02369460-s',[ ('Sourness',subsumption)]).
adjMapping2SUMO('02369683-s',[ ('Sourness',subsumption)]).
adjMapping2SUMO('02369763-a',[ ('ChemicalProcess',subsumption)]).
adjMapping2SUMO('02369869-s',[ ('ChemicalDecomposition',subsumption)]).
adjMapping2SUMO('02369989-a',[ ('ChemicalDecomposition',not(subsumption))]).
adjMapping2SUMO('02370083-s',[ ('ChemicalDecomposition',not(subsumption))]).
adjMapping2SUMO('02370212-a',[ (believes,subsumption)]).
adjMapping2SUMO('02370329-a',[ (believes,subsumption)]).
adjMapping2SUMO('02370625-s',[ (knows,subsumption)]).
adjMapping2SUMO('02370752-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02370894-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02371077-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02371215-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02371343-a',[ ('Stating',subsumption)]).
adjMapping2SUMO('02371495-s',[ ('Committing',subsumption)]).
adjMapping2SUMO('02371583-a',[ ('Committing',not(subsumption))]).
adjMapping2SUMO('02371718-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02372118-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02372303-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02372434-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02372520-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02372697-s',[ (capability,subsumption)]).
adjMapping2SUMO('02372951-s',[ ('',undefined)]).
adjMapping2SUMO('02373055-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02373309-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02373467-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02373599-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02373868-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02373981-s',[ (capability,subsumption)]).
adjMapping2SUMO('02374259-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02374349-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02374557-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02374697-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02374914-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02375312-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02375491-s',[ ('',undefined)]).
adjMapping2SUMO('02375639-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02375828-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02376118-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02376277-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02376562-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02376809-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02376995-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02377186-a',[ ('FieldOfStudy',subsumption)]).
adjMapping2SUMO('02377418-a',[ ('FieldOfStudy',subsumption)]).
adjMapping2SUMO('02377651-a',[ (cooccur,equivalence)]).
adjMapping2SUMO('02378191-s',[ (cooccur,subsumption)]).
adjMapping2SUMO('02378347-s',[ (cooccur,subsumption)]).
adjMapping2SUMO('02378496-s',[ (cooccur,subsumption)]).
adjMapping2SUMO('02378872-s',[ (cooccur,subsumption)]).
adjMapping2SUMO('02379157-s',[ (cooccur,subsumption)]).
adjMapping2SUMO('02379323-s',[ (cooccur,subsumption)]).
adjMapping2SUMO('02379455-s',[ (cooccur,subsumption)]).
adjMapping2SUMO('02379595-a',[ (cooccur,subsumption)]).
adjMapping2SUMO('02379820-s',[ (cooccur,subsumption)]).
adjMapping2SUMO('02379925-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02380225-s',[ (cooccur,subsumption)]).
adjMapping2SUMO('02380358-s',[ (cooccur,subsumption)]).
adjMapping2SUMO('02380565-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02380819-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02381089-a',[ ('Sentence',subsumption)]).
adjMapping2SUMO('02381189-a',[ ('Sentence',subsumption)]).
adjMapping2SUMO('02381302-a',[ ('Word',subsumption)]).
adjMapping2SUMO('02381495-s',[ ('Word',subsumption)]).
adjMapping2SUMO('02381613-s',[ ('Word',subsumption)]).
adjMapping2SUMO('02381764-a',[ ('Word',subsumption)]).
adjMapping2SUMO('02381963-s',[ ('Word',subsumption)]).
adjMapping2SUMO('02382144-s',[ ('Word',subsumption)]).
adjMapping2SUMO('02382396-s',[ ('Word',subsumption)]).
adjMapping2SUMO('02382572-s',[ ('Word',subsumption)]).
adjMapping2SUMO('02382762-s',[ ('Word',subsumption)]).
adjMapping2SUMO('02382934-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02383151-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02383380-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02383564-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02383709-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02383831-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02384077-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02384383-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02384672-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02384843-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02385102-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02385492-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02385726-s',[ (height,equivalence)]).
adjMapping2SUMO('02385851-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02386002-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02386125-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02386305-s',[ ('',undefined)]).
adjMapping2SUMO('02386418-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02386545-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02386612-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02386962-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02387413-s',[ ('Human',subsumption)]).
adjMapping2SUMO('02387662-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02387790-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02387970-s',[ ('',undefined)]).
adjMapping2SUMO('02388070-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02388145-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02388441-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('02388596-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('02388773-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02388921-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('02389099-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('02389220-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02389520-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02389649-s',[ ('',undefined)]).
adjMapping2SUMO('02389719-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('02389833-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('02389946-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02390194-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02390335-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02390569-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02390724-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02391003-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02391342-s',[ ('',undefined)]).
adjMapping2SUMO('02391455-a',[ (capability,subsumption)]).
adjMapping2SUMO('02391683-s',[ ('TextureAttribute',equivalence)]).
adjMapping2SUMO('02391867-a',[ (capability,subsumption)]).
adjMapping2SUMO('02392134-a',[ ('PropertyFn',subsumption)]).
adjMapping2SUMO('02392406-s',[ ('PropertyFn',subsumption)]).
adjMapping2SUMO('02392537-s',[ (capability,subsumption)]).
adjMapping2SUMO('02392654-a',[ ('PropertyFn',subsumption)]).
adjMapping2SUMO('02392878-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02393086-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02393220-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02393401-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02393670-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02393791-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02394366-s',[ ('',undefined)]).
adjMapping2SUMO('02394487-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02394793-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02394975-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02395115-a',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('02395810-s',[ ('Sourness',subsumption)]).
adjMapping2SUMO('02395910-s',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('02396098-s',[ ('Bitterness',equivalence)]).
adjMapping2SUMO('02396267-s',[ ('Bitterness',subsumption)]).
adjMapping2SUMO('02396354-s',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('02396484-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02396578-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02396720-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02396911-s',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('02397119-s',[ ('PerceptualAttribute',subsumption)]).
adjMapping2SUMO('02397234-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02397496-s',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('02397644-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('02397732-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02397903-s',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('02398051-s',[ ('',undefined)]).
adjMapping2SUMO('02398129-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02398255-s',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('02398378-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02398608-s',[ ('PerceptualAttribute',subsumption)]).
adjMapping2SUMO('02398773-s',[ ('Saltiness',equivalence)]).
adjMapping2SUMO('02398928-s',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('02399014-s',[ ('Sourness',equivalence)]).
adjMapping2SUMO('02399176-s',[ ('',undefined)]).
adjMapping2SUMO('02399259-s',[ ('TasteAttribute',subsumption)]).
adjMapping2SUMO('02399399-a',[ ('TasteAttribute',not(subsumption))]).
adjMapping2SUMO('02399595-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02400002-s',[ ('Cooking',not(subsumption))]).
adjMapping2SUMO('02400125-s',[ ('Cooking',not(subsumption))]).
adjMapping2SUMO('02400218-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02400471-s',[ (capability,subsumption)]).
adjMapping2SUMO('02400628-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02400724-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02400929-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02401196-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02401288-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02401445-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02401590-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02401863-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02402078-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02402268-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02402439-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02402559-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02402846-s',[ ('',undefined)]).
adjMapping2SUMO('02402943-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02403030-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02403206-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02403401-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02403505-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02403671-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02403944-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02404081-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02404306-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02404421-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02404670-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02404793-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02404868-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02405038-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02405160-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02405326-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02405677-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02405805-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02405959-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02406166-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02406370-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02406640-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02406790-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02406908-s',[ ('',undefined)]).
adjMapping2SUMO('02407041-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02407193-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02407346-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02407603-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02407855-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02408011-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02408140-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02408293-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02408470-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02408611-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02408793-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02408977-s',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02409095-s',[ (part,subsumption)]).
adjMapping2SUMO('02409293-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02409500-a',[ ('Process',subsumption)]).
adjMapping2SUMO('02409712-a',[ ('Process',subsumption)]).
adjMapping2SUMO('02409849-a',[ (capability,subsumption)]).
adjMapping2SUMO('02410156-a',[ (capability,subsumption)]).
adjMapping2SUMO('02410393-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02410983-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02411116-s',[ ('',undefined)]).
adjMapping2SUMO('02411224-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02411322-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02411447-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02411559-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02411683-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('02411798-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('02411913-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('02412059-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('02412164-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02412732-s',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02412880-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02413037-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02413221-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02413390-s',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02413851-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02414031-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02414188-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02414323-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02414500-s',[ ('',undefined)]).
adjMapping2SUMO('02414599-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02414749-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02414908-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('02415025-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02415172-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02415294-s',[ ('',undefined)]).
adjMapping2SUMO('02415390-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02415764-s',[ ('StateChange',subsumption)]).
adjMapping2SUMO('02415938-s',[ (capability,subsumption)]).
adjMapping2SUMO('02416036-s',[ ('StateChange',subsumption)]).
adjMapping2SUMO('02416285-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02416390-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02416610-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02416765-s',[ ('Liquid',subsumption)]).
adjMapping2SUMO('02416898-s',[ ('',undefined)]).
adjMapping2SUMO('02417028-s',[ ('Liquid',subsumption)]).
adjMapping2SUMO('02417170-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('02417301-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02417611-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02417725-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02417895-a',[ (capability,subsumption)]).
adjMapping2SUMO('02418093-s',[ (capability,subsumption)]).
adjMapping2SUMO('02418249-s',[ (capability,subsumption)]).
adjMapping2SUMO('02418412-s',[ (capability,subsumption)]).
adjMapping2SUMO('02418538-a',[ ('Possibility',not(subsumption))]).
adjMapping2SUMO('02418692-s',[ ('Unlikely',subsumption)]).
adjMapping2SUMO('02418872-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02419159-s',[ ('IntentionalPsychologicalProcess',subsumption)]).
adjMapping2SUMO('02419434-s',[ ('Bird',subsumption)]).
adjMapping2SUMO('02419933-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02420085-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02420215-s',[ ('Selecting',subsumption)]).
adjMapping2SUMO('02420390-s',[ ('',undefined)]).
adjMapping2SUMO('02420530-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02420757-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02421003-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02421158-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02421364-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02421833-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02421919-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02422068-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02422242-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02422499-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02422592-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02422685-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02423073-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02423284-s',[ ('Clean',subsumption)]).
adjMapping2SUMO('02423432-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02423563-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02423649-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02423865-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02423981-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02424095-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02424254-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02424716-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02424949-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02425220-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02425529-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02425749-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02426042-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02426270-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02426420-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02426550-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02426679-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02426890-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02427087-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02427412-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02427594-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02427718-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('02427882-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('02427981-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02428150-s',[ ('',undefined)]).
adjMapping2SUMO('02428251-s',[ ('',undefined)]).
adjMapping2SUMO('02428377-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02428610-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02428810-s',[ ('',undefined)]).
adjMapping2SUMO('02428884-s',[ ('Putting',not(subsumption))]).
adjMapping2SUMO('02429066-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('02429182-a',[ ('Putting',not(subsumption))]).
adjMapping2SUMO('02429377-s',[ (capability,subsumption)]).
adjMapping2SUMO('02429461-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02429571-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02429721-s',[ ('Building',subsumption)]).
adjMapping2SUMO('02429880-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02430002-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02430096-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02430238-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02430355-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02430563-s',[ ('',undefined)]).
adjMapping2SUMO('02430659-a',[ ('ShapeAttribute',not(subsumption))]).
adjMapping2SUMO('02430756-a',[ (part,subsumption)]).
adjMapping2SUMO('02431024-s',[ ('Device',subsumption)]).
adjMapping2SUMO('02431178-s',[ ('',undefined)]).
adjMapping2SUMO('02431262-s',[ ('',undefined)]).
adjMapping2SUMO('02431351-s',[ ('',undefined)]).
adjMapping2SUMO('02431440-s',[ ('',undefined)]).
adjMapping2SUMO('02431529-s',[ ('',undefined)]).
adjMapping2SUMO('02431619-a',[ ('Device',not(subsumption))]).
adjMapping2SUMO('02431728-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02432154-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02432428-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02432562-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02432682-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02432851-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02433000-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02433365-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02433451-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02433895-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02433975-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02434115-s',[ ('',undefined)]).
adjMapping2SUMO('02434210-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02434307-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02434380-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02434473-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02434605-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02434797-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02434929-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02435026-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02435206-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02435383-s',[ (capability,subsumption)]).
adjMapping2SUMO('02435671-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02435901-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02436025-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02436245-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02436341-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02436551-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02436622-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02436794-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02436995-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02437148-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02437462-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02437534-s',[ ('Music',subsumption)]).
adjMapping2SUMO('02437685-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02437853-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02438043-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02438188-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02438346-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02438655-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02438749-s',[ ('EngineeringComponent',subsumption)]).
adjMapping2SUMO('02438831-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02438968-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02439076-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02439225-s',[ ('',undefined)]).
adjMapping2SUMO('02439303-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02439377-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02439499-s',[ ('',undefined)]).
adjMapping2SUMO('02439582-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('02439740-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02439875-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02439949-a',[ (top,equivalence)]).
adjMapping2SUMO('02440184-s',[ (top,subsumption)]).
adjMapping2SUMO('02440292-s',[ (top,subsumption)]).
adjMapping2SUMO('02440461-s',[ (top,subsumption)]).
adjMapping2SUMO('02440617-s',[ ('Above',equivalence)]).
adjMapping2SUMO('02440691-a',[ (bottom,equivalence)]).
adjMapping2SUMO('02440881-s',[ (bottom,subsumption)]).
adjMapping2SUMO('02440996-s',[ ('',undefined)]).
adjMapping2SUMO('02441132-s',[ (bottom,subsumption)]).
adjMapping2SUMO('02441215-a',[ (side,equivalence)]).
adjMapping2SUMO('02441373-s',[ (side,subsumption)]).
adjMapping2SUMO('02441469-s',[ (side,subsumption)]).
adjMapping2SUMO('02441642-a',[ (top,subsumption)]).
adjMapping2SUMO('02441786-s',[ (top,subsumption)]).
adjMapping2SUMO('02441895-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02441990-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02442082-a',[ (top,subsumption)]).
adjMapping2SUMO('02442184-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02442274-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02442441-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02442604-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02442765-s',[ ('PlaningHullWaterVehicle',subsumption)]).
adjMapping2SUMO('02442883-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02443005-a',[ (bottom,subsumption)]).
adjMapping2SUMO('02443155-a',[ ('ComputerProgram',subsumption)]).
adjMapping2SUMO('02443406-a',[ ('ComputerProgram',subsumption)]).
adjMapping2SUMO('02443623-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02443803-s',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02443907-s',[ ('TropicalClimateZone',subsumption)]).
adjMapping2SUMO('02444147-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02444375-s',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02444475-s',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02444627-s',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02444758-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02444894-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02445093-a',[ ('Touching',equivalence)]).
adjMapping2SUMO('02445207-s',[ ('Touching',subsumption)]).
adjMapping2SUMO('02445394-s',[ ('Touching',subsumption)]).
adjMapping2SUMO('02445554-a',[ ('Touching',not(subsumption))]).
adjMapping2SUMO('02445636-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02445863-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02445978-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02446070-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02446239-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02446380-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02446551-s',[ ('',undefined)]).
adjMapping2SUMO('02446651-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02446846-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02446931-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02447104-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02447215-s',[ ('Cooking',subsumption)]).
adjMapping2SUMO('02447344-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02447569-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02447779-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02448040-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02448166-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02448324-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02448437-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02448623-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02448749-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02448889-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02449177-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02449287-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02449430-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02449775-s',[ ('',undefined)]).
adjMapping2SUMO('02449952-s',[ ('Injuring',subsumption)]).
adjMapping2SUMO('02450175-s',[ ('',undefined)]).
adjMapping2SUMO('02450269-s',[ ('',undefined)]).
adjMapping2SUMO('02450364-s',[ ('',undefined)]).
adjMapping2SUMO('02450512-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02450640-a',[ ('BiologicallyActiveSubstance',not(subsumption))]).
adjMapping2SUMO('02450814-s',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02450919-s',[ ('BiologicallyActiveSubstance',not(subsumption))]).
adjMapping2SUMO('02451014-s',[ ('BiologicallyActiveSubstance',not(subsumption))]).
adjMapping2SUMO('02451113-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02451551-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02451634-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02451828-s',[ (capability,subsumption)]).
adjMapping2SUMO('02451951-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02452379-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02452562-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02452789-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02452919-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02453035-a',[ ('Food',subsumption)]).
adjMapping2SUMO('02453183-a',[ ('Food',subsumption)]).
adjMapping2SUMO('02453323-a',[ (capability,subsumption)]).
adjMapping2SUMO('02453492-a',[ (capability,subsumption)]).
adjMapping2SUMO('02453616-a',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('02453770-s',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('02453921-s',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('02454081-a',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('02454206-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02454339-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02454482-a',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('02454619-s',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('02454750-a',[ ('Cutting',subsumption)]).
adjMapping2SUMO('02454885-s',[ ('Cutting',subsumption)]).
adjMapping2SUMO('02455069-a',[ ('Cutting',not(subsumption))]).
adjMapping2SUMO('02455188-s',[ ('Cutting',not(subsumption))]).
adjMapping2SUMO('02455297-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02455845-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02456157-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02456530-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02456698-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02456875-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02457015-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02457167-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02457558-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02457932-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02458046-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02458262-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02458408-s',[ ('',undefined)]).
adjMapping2SUMO('02458497-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02458691-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02458871-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02458973-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02459109-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02459465-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02459667-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02459862-s',[ ('Asleep',subsumption)]).
adjMapping2SUMO('02459969-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02460099-s',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02460262-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02460404-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02460502-a',[ ('True',equivalence)]).
adjMapping2SUMO('02460964-s',[ ('True',subsumption)]).
adjMapping2SUMO('02461295-s',[ ('True',subsumption)]).
adjMapping2SUMO('02461438-s',[ ('True',subsumption)]).
adjMapping2SUMO('02461586-s',[ ('True',subsumption)]).
adjMapping2SUMO('02461723-a',[ ('False',equivalence)]).
adjMapping2SUMO('02462089-s',[ ('False',subsumption)]).
adjMapping2SUMO('02462210-s',[ ('False',subsumption)]).
adjMapping2SUMO('02462375-s',[ ('False',subsumption)]).
adjMapping2SUMO('02462489-s',[ ('False',subsumption)]).
adjMapping2SUMO('02462619-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02462883-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02463029-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02463154-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02463582-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02463847-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02464105-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02464277-s',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02464491-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02464615-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02464693-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02465115-s',[ ('True',subsumption)]).
adjMapping2SUMO('02465350-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02465519-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02465909-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02465978-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02466111-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02466382-s',[ ('Pretending',subsumption)]).
adjMapping2SUMO('02466566-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02466734-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02466916-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02466999-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02467108-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02467241-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02467386-a',[ ('Rotating',subsumption)]).
adjMapping2SUMO('02467559-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02467766-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02467982-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02468110-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02468208-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02468326-a',[ ('Motion',not(subsumption))]).
adjMapping2SUMO('02468453-s',[ ('Right',subsumption)]).
adjMapping2SUMO('02468538-s',[ ('Right',subsumption)]).
adjMapping2SUMO('02468635-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02469119-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02469407-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02469577-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02469756-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02469928-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02470316-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02470531-a',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('02470734-a',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('02470952-s',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('02471091-a',[ ('On',subsumption)]).
adjMapping2SUMO('02471264-s',[ ('On',subsumption)]).
adjMapping2SUMO('02471466-s',[ ('On',subsumption)]).
adjMapping2SUMO('02471602-s',[ ('Removing',subsumption)]).
adjMapping2SUMO('02471782-a',[ ('Below',subsumption)]).
adjMapping2SUMO('02471984-s',[ ('Below',subsumption)]).
adjMapping2SUMO('02472137-s',[ ('Below',subsumption)]).
adjMapping2SUMO('02472252-s',[ ('Below',subsumption)]).
adjMapping2SUMO('02472384-s',[ ('Below',subsumption)]).
adjMapping2SUMO('02472563-a',[ ('Above',subsumption)]).
adjMapping2SUMO('02472693-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02473033-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02473141-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02473371-s',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02473543-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02473655-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02473757-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02473886-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02473977-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02474076-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02474191-a',[ ('Organization',subsumption)]).
adjMapping2SUMO('02474377-s',[ ('Corporation',subsumption)]).
adjMapping2SUMO('02474476-s',[ (member,subsumption)]).
adjMapping2SUMO('02474674-a',[ (member,subsumption)]).
adjMapping2SUMO('02474876-s',[ ('Corporation',subsumption)]).
adjMapping2SUMO('02475001-s',[ (member,subsumption)]).
adjMapping2SUMO('02475179-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02475292-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02475430-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('02475529-a',[ (part,subsumption)]).
adjMapping2SUMO('02475604-a',[ (part,subsumption)]).
adjMapping2SUMO('02475692-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02475855-a',[ ('Cooperation',subsumption)]).
adjMapping2SUMO('02476338-s',[ ('Cooperation',subsumption)]).
adjMapping2SUMO('02476485-s',[ (member,subsumption)]).
adjMapping2SUMO('02476637-s',[ ('Organization',subsumption)]).
adjMapping2SUMO('02476870-s',[ ('',undefined)]).
adjMapping2SUMO('02477047-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02477211-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('02477335-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02477457-s',[ ('Government',subsumption)]).
adjMapping2SUMO('02477557-s',[ ('Organization',subsumption)]).
adjMapping2SUMO('02477691-s',[ ('Cooperation',subsumption)]).
adjMapping2SUMO('02477885-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02478052-s',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02478215-s',[ ('Attaching',subsumption)]).
adjMapping2SUMO('02478383-s',[ ('Cooperation',subsumption)]).
adjMapping2SUMO('02478504-s',[ ('Separating',not(subsumption))]).
adjMapping2SUMO('02478589-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('02478749-a',[ ('Separating',equivalence)]).
adjMapping2SUMO('02479361-s',[ ('CorpuscularObject',subsumption)]).
adjMapping2SUMO('02479492-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('02479602-s',[ ('CorpuscularObject',subsumption)]).
adjMapping2SUMO('02480023-s',[ ('CorpuscularObject',subsumption)]).
adjMapping2SUMO('02480151-s',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('02480317-s',[ ('',undefined)]).
adjMapping2SUMO('02480631-s',[ ('CorpuscularObject',subsumption)]).
adjMapping2SUMO('02480747-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02480861-s',[ ('Classifying',subsumption)]).
adjMapping2SUMO('02481012-s',[ ('Separating',subsumption)]).
adjMapping2SUMO('02481354-s',[ ('Separating',subsumption)]).
adjMapping2SUMO('02481457-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('02481608-s',[ ('Text',subsumption)]).
adjMapping2SUMO('02481793-s',[ ('',undefined)]).
adjMapping2SUMO('02481870-s',[ ('',undefined)]).
adjMapping2SUMO('02481951-s',[ ('Animal',subsumption)]).
adjMapping2SUMO('02482159-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02482298-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('02482509-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02482644-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02482790-s',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02482932-s',[ ('',undefined)]).
adjMapping2SUMO('02483011-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02483198-s',[ ('',undefined)]).
adjMapping2SUMO('02483311-s',[ ('',undefined)]).
adjMapping2SUMO('02483386-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02483540-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02483692-a',[ ('Mollusk',subsumption)]).
adjMapping2SUMO('02483839-s',[ ('Mollusk',subsumption)]).
adjMapping2SUMO('02483908-a',[ ('Mollusk',subsumption)]).
adjMapping2SUMO('02484078-s',[ ('Mollusk',subsumption)]).
adjMapping2SUMO('02484208-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02484530-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02484638-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02484919-s',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('02485050-s',[ ('Icon',subsumption)]).
adjMapping2SUMO('02485168-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('02485319-s',[ ('',undefined)]).
adjMapping2SUMO('02485488-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02485650-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02485895-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02486046-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02486122-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02486248-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02486425-s',[ ('',undefined)]).
adjMapping2SUMO('02486504-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02486628-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02486797-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02486932-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02487108-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('02487244-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02487414-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('02487540-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02487718-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02487906-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02488118-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02488304-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02488445-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02488553-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02488705-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('02488907-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('02489092-a',[ (capability,subsumption)]).
adjMapping2SUMO('02489312-a',[ (capability,subsumption)]).
adjMapping2SUMO('02489485-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02489667-s',[ ('',undefined)]).
adjMapping2SUMO('02489745-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02489961-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02490098-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02490170-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02490631-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('02490831-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02490949-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('02491171-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02491308-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02491421-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02491578-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02491708-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02491836-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02491961-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02492383-s',[ ('ContestAttribute',subsumption)]).
adjMapping2SUMO('02492565-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02492719-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02492812-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02492981-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02493137-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02493300-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02493395-s',[ ('Impelling',subsumption)]).
adjMapping2SUMO('02493574-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02493700-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02493867-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02493951-a',[ ('Upstairs',subsumption)]).
adjMapping2SUMO('02494092-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02494253-s',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02494401-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02494499-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02494594-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02494716-a',[ ('CityDistrict',equivalence)]).
adjMapping2SUMO('02494923-a',[ (uses,equivalence)]).
adjMapping2SUMO('02495156-s',[ (uses,subsumption)]).
adjMapping2SUMO('02495270-s',[ (uses,equivalence)]).
adjMapping2SUMO('02495346-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02495564-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02495687-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02495922-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02496323-s',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('02496425-s',[ (capability,subsumption)]).
adjMapping2SUMO('02496534-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02496674-s',[ (capability,subsumption)]).
adjMapping2SUMO('02496857-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02497013-s',[ (capability,subsumption)]).
adjMapping2SUMO('02497141-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02497471-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02497743-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02497830-s',[ (capability,subsumption)]).
adjMapping2SUMO('02497938-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02498213-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02498507-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02498708-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02499036-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02499148-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02499301-s',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('02499511-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02499643-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02499750-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02500050-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02500179-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02500379-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02500497-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02500590-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02500736-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02500884-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02501247-s',[ ('',undefined)]).
adjMapping2SUMO('02501367-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02501534-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02501693-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02501820-s',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02502016-s',[ (monetaryValue,equivalence)]).
adjMapping2SUMO('02502163-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02502468-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02502578-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02502901-s',[ ('',undefined)]).
adjMapping2SUMO('02502994-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02503216-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02503305-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02503656-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02503900-s',[ ('',undefined)]).
adjMapping2SUMO('02504046-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02504131-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02504558-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02504830-s',[ ('',undefined)]).
adjMapping2SUMO('02505004-s',[ ('',undefined)]).
adjMapping2SUMO('02505141-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02505308-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02505415-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02505617-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02505716-a',[ (capability,subsumption)]).
adjMapping2SUMO('02506029-s',[ (forall,subsumption)]).
adjMapping2SUMO('02506267-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02506408-s',[ ('Quantity',subsumption)]).
adjMapping2SUMO('02506555-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02506922-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02507209-s',[ (forall,subsumption)]).
adjMapping2SUMO('02507324-s',[ ('Polychromatic',subsumption)]).
adjMapping2SUMO('02507436-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02507515-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02507772-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02507968-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02508104-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02508277-a',[ ('Uncovering',subsumption)]).
adjMapping2SUMO('02508514-s',[ ('Disseminating',subsumption)]).
adjMapping2SUMO('02508669-s',[ ('Uncovering',subsumption)]).
adjMapping2SUMO('02508766-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02508917-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02509059-s',[ ('Device',subsumption)]).
adjMapping2SUMO('02509170-s',[ ('Device',subsumption)]).
adjMapping2SUMO('02509292-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02509484-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02509710-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02509854-s',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02509984-s',[ ('Device',not(subsumption))]).
adjMapping2SUMO('02510062-a',[ ('Vertebrate',equivalence)]).
adjMapping2SUMO('02510273-a',[ ('Invertebrate',equivalence)]).
adjMapping2SUMO('02510446-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02510604-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02510786-s',[ (capability,subsumption)]).
adjMapping2SUMO('02510879-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02511340-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02511528-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02511800-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02512044-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02512205-s',[ ('Impacting',subsumption)]).
adjMapping2SUMO('02512334-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02512470-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02512641-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02512794-s',[ ('',undefined)]).
adjMapping2SUMO('02512922-a',[ (believes,subsumption)]).
adjMapping2SUMO('02513101-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02513269-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02513521-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02513614-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02513740-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02514099-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02514239-s',[ ('Position',subsumption)]).
adjMapping2SUMO('02514380-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02514543-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02514819-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02515001-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02515214-s',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02515341-a',[ (capability,subsumption)]).
adjMapping2SUMO('02515808-s',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('02515993-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02516148-s',[ (capability,subsumption)]).
adjMapping2SUMO('02516316-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('02516435-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('02516570-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02516690-s',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('02516785-s',[ ('Icon',subsumption)]).
adjMapping2SUMO('02517002-s',[ (capability,subsumption)]).
adjMapping2SUMO('02517169-s',[ ('',undefined)]).
adjMapping2SUMO('02517265-a',[ (capability,subsumption)]).
adjMapping2SUMO('02517713-s',[ ('Covering',subsumption)]).
adjMapping2SUMO('02517817-s',[ (capability,subsumption)]).
adjMapping2SUMO('02517999-s',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02518229-s',[ ('RadiatingLight',not(subsumption))]).
adjMapping2SUMO('02518370-s',[ ('Seeing',not(subsumption))]).
adjMapping2SUMO('02518470-s',[ ('',undefined)]).
adjMapping2SUMO('02518601-s',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02518852-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02518926-s',[ ('',undefined)]).
adjMapping2SUMO('02519029-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('02519171-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('02519292-s',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02519399-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('02519555-a',[ ('Substance',subsumption)]).
adjMapping2SUMO('02519813-s',[ (capability,subsumption)]).
adjMapping2SUMO('02520077-a',[ (capability,subsumption)]).
adjMapping2SUMO('02520219-a',[ ('IntentionalProcess',equivalence)]).
adjMapping2SUMO('02520693-s',[ ('IntentionalProcess',equivalence)]).
adjMapping2SUMO('02520824-s',[ ('IntentionalProcess',equivalence)]).
adjMapping2SUMO('02520925-s',[ ('IntentionalProcess',subsumption)]).
adjMapping2SUMO('02521036-s',[ ('IntentionalProcess',subsumption)]).
adjMapping2SUMO('02521183-s',[ ('FinancialTransaction',not(subsumption))]).
adjMapping2SUMO('02521353-a',[ ('IntentionalProcess',not(subsumption))]).
adjMapping2SUMO('02521758-s',[ ('IntentionalProcess',not(subsumption))]).
adjMapping2SUMO('02521890-s',[ ('IntentionalProcess',not(subsumption))]).
adjMapping2SUMO('02521998-s',[ ('IntentionalProcess',not(subsumption))]).
adjMapping2SUMO('02522082-s',[ ('IntentionalProcess',not(subsumption))]).
adjMapping2SUMO('02522164-s',[ ('IntentionalProcess',not(subsumption))]).
adjMapping2SUMO('02522267-a',[ ('IntentionalProcess',subsumption)]).
adjMapping2SUMO('02522417-a',[ ('IntentionalProcess',not(subsumption))]).
adjMapping2SUMO('02522669-s',[ ('IntentionalProcess',not(subsumption))]).
adjMapping2SUMO('02522938-s',[ ('AutonomicProcess',equivalence)]).
adjMapping2SUMO('02523092-s',[ ('IntentionalProcess',not(subsumption))]).
adjMapping2SUMO('02523275-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02523664-s',[ (capability,subsumption)]).
adjMapping2SUMO('02523867-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02524032-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02524192-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('02524345-s',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('02524443-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02524563-s',[ (capability,subsumption)]).
adjMapping2SUMO('02524688-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('02524900-s',[ ('Contest',subsumption)]).
adjMapping2SUMO('02525058-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02525206-a',[ (capability,subsumption)]).
adjMapping2SUMO('02525597-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02525732-s',[ (capability,subsumption)]).
adjMapping2SUMO('02525876-s',[ (capability,subsumption)]).
adjMapping2SUMO('02526061-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02526124-s',[ (capability,subsumption)]).
adjMapping2SUMO('02526441-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02526611-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02526725-s',[ (capability,subsumption)]).
adjMapping2SUMO('02526925-a',[ (wants,equivalence)]).
adjMapping2SUMO('02527220-s',[ (wants,subsumption)]).
adjMapping2SUMO('02527402-s',[ (wants,subsumption)]).
adjMapping2SUMO('02527489-s',[ (wants,subsumption)]).
adjMapping2SUMO('02527588-s',[ ('Pursuing',equivalence)]).
adjMapping2SUMO('02527734-a',[ (wants,subsumption)]).
adjMapping2SUMO('02528048-s',[ (capability,subsumption)]).
adjMapping2SUMO('02528206-s',[ ('Giving',subsumption)]).
adjMapping2SUMO('02528440-s',[ ('SocialInteraction',not(subsumption))]).
adjMapping2SUMO('02528566-s',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('02528809-s',[ ('Directing',not(subsumption))]).
adjMapping2SUMO('02528921-s',[ ('Stating',subsumption)]).
adjMapping2SUMO('02529047-s',[ (wants,subsumption)]).
adjMapping2SUMO('02529148-s',[ (wants,subsumption)]).
adjMapping2SUMO('02529264-a',[ ('WarmTemperature',equivalence)]).
adjMapping2SUMO('02529581-s',[ ('WarmTemperature',equivalence)]).
adjMapping2SUMO('02529761-s',[ ('Heating',subsumption)]).
adjMapping2SUMO('02529859-s',[ ('Heating',subsumption)]).
adjMapping2SUMO('02529945-a',[ ('CoolTemperature',equivalence)]).
adjMapping2SUMO('02530282-s',[ ('Cooling',subsumption)]).
adjMapping2SUMO('02530370-s',[ ('Cooling',subsumption)]).
adjMapping2SUMO('02530474-s',[ ('Cooling',subsumption)]).
adjMapping2SUMO('02530620-s',[ ('Cooling',subsumption)]).
adjMapping2SUMO('02530693-s',[ ('Cooling',subsumption)]).
adjMapping2SUMO('02530861-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02531122-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02531243-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02531422-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02531775-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02531919-a',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('02532114-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('02532200-a',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('02532398-s',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('02532508-a',[ ('WarmBloodedVertebrate',equivalence)]).
adjMapping2SUMO('02532681-s',[ ('WarmBloodedVertebrate',equivalence)]).
adjMapping2SUMO('02532898-a',[ ('ColdBloodedVertebrate',equivalence)]).
adjMapping2SUMO('02533075-s',[ ('ColdBloodedVertebrate',equivalence)]).
adjMapping2SUMO('02533313-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02533540-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02533682-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02533810-a',[ (capability,subsumption)]).
adjMapping2SUMO('02534042-s',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02534245-a',[ (capability,subsumption)]).
adjMapping2SUMO('02534315-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('02534417-a',[ ('Putting',not(subsumption))]).
adjMapping2SUMO('02534501-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('02534690-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('02534877-a',[ ('Increasing',equivalence)]).
adjMapping2SUMO('02535161-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('02535335-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('02535533-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('02535645-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('02535831-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('02536026-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02536123-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('02536365-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02536518-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('02536605-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('02536740-a',[ ('Decreasing',equivalence)]).
adjMapping2SUMO('02536911-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('02537181-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('02537351-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('02537513-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('02537636-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('02537743-a',[ ('Increasing',subsumption)]).
adjMapping2SUMO('02537841-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('02537946-s',[ ('Increasing',subsumption)]).
adjMapping2SUMO('02538050-a',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('02538184-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('02538295-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('02538389-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('02538508-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('02538626-a',[ ('Increasing',subsumption)]).
adjMapping2SUMO('02538803-a',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('02539034-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('02539223-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('02539359-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02539576-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02539717-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02539877-a',[ ('Plant',not(subsumption))]).
adjMapping2SUMO('02539968-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02540236-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02540458-s',[ ('Directing',not(subsumption))]).
adjMapping2SUMO('02540578-a',[ ('DiseaseOrSyndrome',not(subsumption))]).
adjMapping2SUMO('02540899-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02541012-s',[ ('TherapeuticProcess',subsumption)]).
adjMapping2SUMO('02541302-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02542148-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02542256-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02542325-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02542675-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02542878-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02543034-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02543149-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02543324-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02543436-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02543598-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02543823-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02543934-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02544048-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02544427-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02544525-s',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02544892-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02545023-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02545168-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02545257-s',[ ('',undefined)]).
adjMapping2SUMO('02545385-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02545484-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02545592-s',[ ('',undefined)]).
adjMapping2SUMO('02545689-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02545874-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02545989-s',[ ('PathologicProcess',subsumption)]).
adjMapping2SUMO('02546116-s',[ ('PathologicProcess',subsumption)]).
adjMapping2SUMO('02546316-s',[ ('',undefined)]).
adjMapping2SUMO('02546526-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02546624-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02546713-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02546854-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02547131-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02547217-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02547317-a',[ ('Wet',equivalence)]).
adjMapping2SUMO('02547862-s',[ ('Damp',subsumption)]).
adjMapping2SUMO('02547953-s',[ ('Damp',subsumption)]).
adjMapping2SUMO('02548066-s',[ ('Swamp',subsumption)]).
adjMapping2SUMO('02548619-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02548820-s',[ ('Damp',subsumption)]).
adjMapping2SUMO('02549032-s',[ ('Wet',equivalence)]).
adjMapping2SUMO('02549234-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02549393-s',[ ('Damp',subsumption)]).
adjMapping2SUMO('02549569-s',[ ('Damp',subsumption)]).
adjMapping2SUMO('02549691-s',[ ('Damp',subsumption)]).
adjMapping2SUMO('02549857-s',[ ('Damp',subsumption)]).
adjMapping2SUMO('02550023-s',[ ('',undefined)]).
adjMapping2SUMO('02550170-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02550333-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02550517-s',[ ('Motion',subsumption)]).
adjMapping2SUMO('02550704-s',[ ('Damp',subsumption)]).
adjMapping2SUMO('02550891-s',[ ('Damp',subsumption)]).
adjMapping2SUMO('02551069-s',[ ('Damp',subsumption)]).
adjMapping2SUMO('02551141-s',[ ('Damp',subsumption)]).
adjMapping2SUMO('02551259-s',[ ('Damp',subsumption)]).
adjMapping2SUMO('02551380-a',[ ('Dry',equivalence)]).
adjMapping2SUMO('02551946-s',[ ('Dry',subsumption)]).
adjMapping2SUMO('02552222-s',[ ('',undefined)]).
adjMapping2SUMO('02552315-s',[ ('',undefined)]).
adjMapping2SUMO('02552415-s',[ ('Dry',subsumption)]).
adjMapping2SUMO('02552646-s',[ ('Dry',subsumption)]).
adjMapping2SUMO('02552849-s',[ ('Dry',subsumption)]).
adjMapping2SUMO('02553017-s',[ ('Dry',subsumption)]).
adjMapping2SUMO('02553137-s',[ ('Dry',subsumption)]).
adjMapping2SUMO('02553234-s',[ ('Dry',subsumption)]).
adjMapping2SUMO('02553560-s',[ ('Dry',subsumption)]).
adjMapping2SUMO('02553725-s',[ ('',undefined)]).
adjMapping2SUMO('02553797-s',[ ('Dry',subsumption)]).
adjMapping2SUMO('02553902-s',[ ('Dry',subsumption)]).
adjMapping2SUMO('02554019-s',[ ('',undefined)]).
adjMapping2SUMO('02554140-s',[ ('Dry',subsumption)]).
adjMapping2SUMO('02554267-a',[ ('OrganOrTissueProcess',subsumption)]).
adjMapping2SUMO('02554420-s',[ ('OrganOrTissueProcess',subsumption)]).
adjMapping2SUMO('02554546-a',[ ('OrganOrTissueProcess',not(subsumption))]).
adjMapping2SUMO('02554663-s',[ ('OrganOrTissueProcess',not(subsumption))]).
adjMapping2SUMO('02554752-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02554940-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02555126-a',[ ('Wet',equivalence)]).
adjMapping2SUMO('02555267-a',[ ('Dry',equivalence)]).
adjMapping2SUMO('02555387-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('02555550-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('02555683-a',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('02555777-a',[ ('TransportationDevice',not(subsumption))]).
adjMapping2SUMO('02555954-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02556229-s',[ ('Position',subsumption)]).
adjMapping2SUMO('02556402-s',[ ('Position',subsumption)]).
adjMapping2SUMO('02556568-s',[ ('',undefined)]).
adjMapping2SUMO('02556720-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02556901-s',[ ('Position',subsumption)]).
adjMapping2SUMO('02557023-s',[ ('Position',subsumption)]).
adjMapping2SUMO('02557145-s',[ ('Position',subsumption)]).
adjMapping2SUMO('02557357-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02557719-s',[ ('Food',subsumption)]).
adjMapping2SUMO('02558032-s',[ ('',undefined)]).
adjMapping2SUMO('02558184-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02558528-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02558767-s',[ ('',undefined)]).
adjMapping2SUMO('02558996-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02559180-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02559534-s',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02559694-s',[ ('Food',subsumption)]).
adjMapping2SUMO('02559862-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02560035-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02560402-s',[ ('Food',subsumption)]).
adjMapping2SUMO('02560548-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02561014-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02561123-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02561302-s',[ ('',undefined)]).
adjMapping2SUMO('02561391-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02561490-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02561560-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02561752-s',[ ('MotionPicture',subsumption)]).
adjMapping2SUMO('02561888-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02562235-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02562368-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('02562484-s',[ ('',undefined)]).
adjMapping2SUMO('02562566-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02562705-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02562805-s',[ ('',undefined)]).
adjMapping2SUMO('02562909-s',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('02563068-a',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02563194-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02563310-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02563466-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02563616-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02563727-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02564023-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02564330-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02564546-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02564683-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02564810-s',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02564915-a',[ ('Clothing',not(subsumption))]).
adjMapping2SUMO('02564986-a',[ (desires,equivalence)]).
adjMapping2SUMO('02565327-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02565425-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02565583-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02565701-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02565801-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02565939-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02566015-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02566299-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02566453-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02566644-s',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02566799-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02567117-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02567281-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02567473-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02567593-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02567738-s',[ ('',undefined)]).
adjMapping2SUMO('02567815-s',[ ('Bird',subsumption)]).
adjMapping2SUMO('02567918-s',[ ('',undefined)]).
adjMapping2SUMO('02567999-s',[ ('',undefined)]).
adjMapping2SUMO('02568076-s',[ ('Icon',subsumption)]).
adjMapping2SUMO('02568192-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02568285-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('02568389-s',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('02568480-s',[ (capability,subsumption)]).
adjMapping2SUMO('02568556-a',[ ('EngineeringComponent',subsumption)]).
adjMapping2SUMO('02568738-s',[ ('Device',subsumption)]).
adjMapping2SUMO('02568884-s',[ (connected,subsumption)]).
adjMapping2SUMO('02569030-a',[ ('EngineeringComponent',not(subsumption))]).
adjMapping2SUMO('02569130-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02569454-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02569558-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02569945-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02570046-s',[ ('',undefined)]).
adjMapping2SUMO('02570183-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02570282-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02570643-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02571277-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02571536-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02571903-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02572038-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02572267-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02572420-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02572657-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02572823-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02573192-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02573443-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02573708-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('02573859-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02573987-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('02574092-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('02574188-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('02574294-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('02574481-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02574614-s',[ ('',undefined)]).
adjMapping2SUMO('02574706-s',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02574890-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02575008-a',[ ('FloweringPlant',not(subsumption))]).
adjMapping2SUMO('02575138-s',[ ('FloweringPlant',not(subsumption))]).
adjMapping2SUMO('02575238-s',[ ('FloweringPlant',not(subsumption))]).
adjMapping2SUMO('02575330-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02575653-s',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02575733-s',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02575834-s',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02575952-s',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02576058-s',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02576223-s',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02576365-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('02576489-s',[ ('Wood',equivalence)]).
adjMapping2SUMO('02576657-a',[ ('Tissue',not(subsumption))]).
adjMapping2SUMO('02576795-s',[ ('Plant',subsumption)]).
adjMapping2SUMO('02576918-s',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02577061-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02577454-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02577734-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02577907-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02578035-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02578235-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02578546-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02578894-s',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02579136-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02579363-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02579469-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02579760-s',[ ('Putting',subsumption)]).
adjMapping2SUMO('02579864-s',[ ('',undefined)]).
adjMapping2SUMO('02579952-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02580126-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('02580267-s',[ ('Fabric',subsumption)]).
adjMapping2SUMO('02580449-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02581047-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02581172-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02581254-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02581365-s',[ ('',undefined)]).
adjMapping2SUMO('02581530-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02581829-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02582064-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02582163-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02582269-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02582473-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02582602-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02582697-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02582873-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02583043-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02583271-s',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02583467-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02583619-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02583898-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02584031-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02584203-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02584347-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02584459-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02584610-s',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02584699-a',[ ('Damaging',not(subsumption))]).
adjMapping2SUMO('02584817-s',[ ('Damaging',not(subsumption))]).
adjMapping2SUMO('02584981-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02585545-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02585919-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02586089-s',[ ('',undefined)]).
adjMapping2SUMO('02586206-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02586446-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02586608-s',[ ('',undefined)]).
adjMapping2SUMO('02586747-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02586957-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02587083-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02587261-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02587407-s',[ ('',undefined)]).
adjMapping2SUMO('02587556-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02587738-s',[ ('SubjectiveWeakPositiveAttribute',subsumption)]).
adjMapping2SUMO('02587936-s',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02588099-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02588421-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02588527-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02588647-s',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02588762-a',[ ('Dry',subsumption)]).
adjMapping2SUMO('02588915-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('02589086-a',[ ('Damp',subsumption)]).
adjMapping2SUMO('02589258-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('02589402-s',[ ('Organism',subsumption)]).
adjMapping2SUMO('02589551-a',[ ('Damp',subsumption)]).
adjMapping2SUMO('02589730-s',[ ('Damp',subsumption)]).
adjMapping2SUMO('02589913-a',[ ('Region',subsumption)]).
adjMapping2SUMO('02590057-a',[ ('Region',subsumption)]).
adjMapping2SUMO('02590168-s',[ ('Region',subsumption)]).
adjMapping2SUMO('02590268-a',[ ('Moss',subsumption)]).
adjMapping2SUMO('02590382-a',[ ('Moss',subsumption)]).
adjMapping2SUMO('02590519-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02590614-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02590709-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02590891-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02591088-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02591239-s',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02591372-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02591506-a',[ (part,subsumption)]).
adjMapping2SUMO('02591594-a',[ (part,subsumption)]).
adjMapping2SUMO('02591684-a',[ (side,subsumption)]).
adjMapping2SUMO('02591787-a',[ (side,subsumption)]).
adjMapping2SUMO('02591896-a',[ ('PlaneAngleMeasure',subsumption)]).
adjMapping2SUMO('02592015-a',[ ('PlaneAngleMeasure',subsumption)]).
adjMapping2SUMO('02592147-a',[ ('',undefined)]).
adjMapping2SUMO('02592396-a',[ ('',undefined)]).
adjMapping2SUMO('02592611-a',[ ('',undefined)]).
adjMapping2SUMO('02592750-a',[ ('',undefined)]).
adjMapping2SUMO('02592890-a',[ ('',undefined)]).
adjMapping2SUMO('02593124-s',[ ('',undefined)]).
adjMapping2SUMO('02593269-a',[ ('',undefined)]).
adjMapping2SUMO('02593578-s',[ ('',undefined)]).
adjMapping2SUMO('02593735-a',[ ('',undefined)]).
adjMapping2SUMO('02593861-a',[ ('',undefined)]).
adjMapping2SUMO('02594006-a',[ ('',undefined)]).
adjMapping2SUMO('02594159-a',[ ('',undefined)]).
adjMapping2SUMO('02594329-a',[ ('',undefined)]).
adjMapping2SUMO('02594443-a',[ ('',undefined)]).
adjMapping2SUMO('02594565-a',[ ('',undefined)]).
adjMapping2SUMO('02594714-a',[ ('',undefined)]).
adjMapping2SUMO('02594940-s',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02595071-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('02595167-a',[ ('',undefined)]).
adjMapping2SUMO('02595255-a',[ ('',undefined)]).
adjMapping2SUMO('02595357-a',[ ('',undefined)]).
adjMapping2SUMO('02595469-a',[ ('',undefined)]).
adjMapping2SUMO('02595647-a',[ ('',undefined)]).
adjMapping2SUMO('02595829-a',[ ('',undefined)]).
adjMapping2SUMO('02596059-a',[ ('',undefined)]).
adjMapping2SUMO('02596222-a',[ ('',undefined)]).
adjMapping2SUMO('02596342-a',[ ('',undefined)]).
adjMapping2SUMO('02596462-a',[ ('',undefined)]).
adjMapping2SUMO('02596626-s',[ ('',undefined)]).
adjMapping2SUMO('02596728-s',[ ('',undefined)]).
adjMapping2SUMO('02596810-s',[ ('',undefined)]).
adjMapping2SUMO('02596905-s',[ ('',undefined)]).
adjMapping2SUMO('02597007-a',[ ('',undefined)]).
adjMapping2SUMO('02597115-a',[ ('',undefined)]).
adjMapping2SUMO('02597245-s',[ ('',undefined)]).
adjMapping2SUMO('02597329-s',[ ('',undefined)]).
adjMapping2SUMO('02597418-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('02597496-a',[ ('Injuring',subsumption)]).
adjMapping2SUMO('02597617-s',[ ('',undefined)]).
adjMapping2SUMO('02597696-s',[ ('',undefined)]).
adjMapping2SUMO('02597781-a',[ ('',undefined)]).
adjMapping2SUMO('02597850-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02597951-a',[ ('',undefined)]).
adjMapping2SUMO('02598110-s',[ ('',undefined)]).
adjMapping2SUMO('02598211-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('02598494-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02598608-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02598768-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02598981-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02599114-a',[ ('',undefined)]).
adjMapping2SUMO('02599269-a',[ ('',undefined)]).
adjMapping2SUMO('02599409-a',[ ('',undefined)]).
adjMapping2SUMO('02599509-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02599689-a',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02599837-a',[ ('Replication',subsumption)]).
adjMapping2SUMO('02599939-a',[ ('PostSecondarySchool',equivalence)]).
adjMapping2SUMO('02600131-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02600244-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02600447-a',[ ('Fungus',subsumption)]).
adjMapping2SUMO('02600593-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('02600691-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('02600792-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('02600893-a',[ ('',undefined)]).
adjMapping2SUMO('02600999-a',[ ('CognitiveAgent',subsumption)]).
adjMapping2SUMO('02601123-a',[ ('FruitOrVegetable',subsumption)]).
adjMapping2SUMO('02601242-a',[ ('PureSubstance',not(subsumption))]).
adjMapping2SUMO('02601326-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('02601432-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02601564-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('02601674-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02601788-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02601940-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02602190-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02602261-a',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('02602434-a',[ ('NonFloweringPlant',subsumption)]).
adjMapping2SUMO('02602644-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('02602784-a',[ ('Bacterium',subsumption)]).
adjMapping2SUMO('02602951-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02603069-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02603235-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02603319-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02603423-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02603540-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('02603673-a',[ ('Gland',subsumption)]).
adjMapping2SUMO('02603779-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('02603926-a',[ ('Selecting',subsumption)]).
adjMapping2SUMO('02604117-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02604261-a',[ ('',undefined)]).
adjMapping2SUMO('02604343-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('02604473-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02604543-a',[ ('Hormone',subsumption)]).
adjMapping2SUMO('02604683-a',[ (believes,subsumption)]).
adjMapping2SUMO('02604802-a',[ ('',undefined)]).
adjMapping2SUMO('02604913-a',[ ('',undefined)]).
adjMapping2SUMO('02605035-a',[ ('',undefined)]).
adjMapping2SUMO('02605157-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02605281-a',[ ('',undefined)]).
adjMapping2SUMO('02605416-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02605509-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02605621-a',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('02605786-a',[ ('',undefined)]).
adjMapping2SUMO('02605953-a',[ ('',undefined)]).
adjMapping2SUMO('02606070-a',[ ('Hormone',subsumption)]).
adjMapping2SUMO('02606182-a',[ ('Heating',subsumption)]).
adjMapping2SUMO('02606283-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02606393-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02606502-a',[ ('Fungus',subsumption)]).
adjMapping2SUMO('02606601-a',[ ('CognitiveAgent',subsumption)]).
adjMapping2SUMO('02606762-a',[ (capability,subsumption)]).
adjMapping2SUMO('02606856-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02606960-a',[ ('',undefined)]).
adjMapping2SUMO('02607078-a',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('02607187-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02607298-a',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('02607455-a',[ ('TherapeuticProcess',subsumption)]).
adjMapping2SUMO('02607608-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02607752-a',[ ('Morpheme',subsumption)]).
adjMapping2SUMO('02607909-a',[ (agent,equivalence)]).
adjMapping2SUMO('02608090-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02608244-a',[ ('',undefined)]).
adjMapping2SUMO('02608380-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02608507-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02608592-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02608753-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02608902-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02609065-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02609168-a',[ ('',undefined)]).
adjMapping2SUMO('02609369-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02609503-a',[ ('',undefined)]).
adjMapping2SUMO('02609673-a',[ ('',undefined)]).
adjMapping2SUMO('02609813-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('02609984-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02610260-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02610364-a',[ ('Protein',subsumption)]).
adjMapping2SUMO('02610486-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02610603-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02610761-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02610917-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02611013-a',[ ('Protein',subsumption)]).
adjMapping2SUMO('02611112-a',[ ('Alga',equivalence)]).
adjMapping2SUMO('02611187-a',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02611290-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02611442-a',[ ('EthnicGroup',subsumption)]).
adjMapping2SUMO('02611694-a',[ ('Ingesting',subsumption)]).
adjMapping2SUMO('02611803-a',[ ('Substance',subsumption)]).
adjMapping2SUMO('02611943-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02612058-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02612184-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('02612300-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02612400-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02612531-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02612653-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02612787-a',[ (familyRelation,subsumption)]).
adjMapping2SUMO('02612939-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02613090-a',[ ('Replication',subsumption)]).
adjMapping2SUMO('02613206-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02613294-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('02613393-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02613502-a',[ ('Morpheme',subsumption)]).
adjMapping2SUMO('02613584-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02613683-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('02613965-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('02614093-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02614194-a',[ ('Character',subsumption)]).
adjMapping2SUMO('02614435-a',[ ('',undefined)]).
adjMapping2SUMO('02614579-a',[ ('Character',subsumption)]).
adjMapping2SUMO('02614816-a',[ ('Character',subsumption)]).
adjMapping2SUMO('02614945-a',[ (altitude,equivalence)]).
adjMapping2SUMO('02615079-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02615207-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('02615325-a',[ ('Alveolus',subsumption)]).
adjMapping2SUMO('02615424-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02615587-a',[ ('Combining',subsumption)]).
adjMapping2SUMO('02615711-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('02615804-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02615921-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02616071-a',[ ('',undefined)]).
adjMapping2SUMO('02616202-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02616345-a',[ (capability,subsumption)]).
adjMapping2SUMO('02616480-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02616627-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02616906-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02616997-a',[ ('Language',instance)]).
adjMapping2SUMO('02617146-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02617357-a',[ ('Separating',subsumption)]).
adjMapping2SUMO('02617476-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02617641-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02617812-a',[ ('Myriapod',subsumption)]).
adjMapping2SUMO('02617933-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02618108-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02618361-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02618468-a',[ ('Building',subsumption)]).
adjMapping2SUMO('02618668-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02618880-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02619083-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02619174-a',[ ('ChemicalProcess',subsumption)]).
adjMapping2SUMO('02619291-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02619404-a',[ ('ChemicalProcess',subsumption)]).
adjMapping2SUMO('02619527-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02619686-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02619839-a',[ ('Icon',subsumption)]).
adjMapping2SUMO('02620134-a',[ ('ContentDevelopment',subsumption)]).
adjMapping2SUMO('02620252-a',[ ('ContentDevelopment',subsumption)]).
adjMapping2SUMO('02620436-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02620550-a',[ ('Mathematics',equivalence)]).
adjMapping2SUMO('02620724-a',[ (capability,subsumption)]).
adjMapping2SUMO('02620863-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02620992-a',[ ('BiologicalProcess',subsumption)]).
adjMapping2SUMO('02621117-a',[ ('BiologicalProcess',subsumption)]).
adjMapping2SUMO('02621246-a',[ ('PathologicProcess',subsumption)]).
adjMapping2SUMO('02621348-a',[ (believes,subsumption)]).
adjMapping2SUMO('02621496-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02621609-a',[ (capability,subsumption)]).
adjMapping2SUMO('02621799-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02621901-a',[ ('Replication',subsumption)]).
adjMapping2SUMO('02622093-a',[ ('Hormone',subsumption)]).
adjMapping2SUMO('02622210-a',[ ('SexAttribute',subsumption)]).
adjMapping2SUMO('02622386-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('02622493-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('02622678-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02622859-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('02623037-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02623229-a',[ ('FruitOrVegetable',subsumption)]).
adjMapping2SUMO('02623387-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02623529-a',[ ('FloweringPlant',equivalence)]).
adjMapping2SUMO('02623672-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02623776-a',[ ('StateOfMind',subsumption)]).
adjMapping2SUMO('02623880-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('02623991-a',[ ('DiseaseOrSyndrome',not(subsumption))]).
adjMapping2SUMO('02624086-a',[ (believes,subsumption)]).
adjMapping2SUMO('02624209-a',[ (believes,subsumption)]).
adjMapping2SUMO('02624314-a',[ (believes,subsumption)]).
adjMapping2SUMO('02624477-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02624615-a',[ ('SexualReproduction',subsumption)]).
adjMapping2SUMO('02624834-a',[ ('SexualReproduction',subsumption)]).
adjMapping2SUMO('02625007-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02625149-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02625281-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02625430-a',[ ('',undefined)]).
adjMapping2SUMO('02625546-a',[ ('',undefined)]).
adjMapping2SUMO('02625648-a',[ ('',undefined)]).
adjMapping2SUMO('02625838-a',[ ('',undefined)]).
adjMapping2SUMO('02625975-a',[ ('Worm',subsumption)]).
adjMapping2SUMO('02626177-a',[ ('Getting',subsumption)]).
adjMapping2SUMO('02626294-a',[ ('',undefined)]).
adjMapping2SUMO('02626379-a',[ ('',undefined)]).
adjMapping2SUMO('02626487-a',[ ('Stating',subsumption)]).
adjMapping2SUMO('02626634-a',[ ('',undefined)]).
adjMapping2SUMO('02626829-a',[ ('EngineeringComponent',subsumption)]).
adjMapping2SUMO('02626995-a',[ ('EngineeringComponent',subsumption)]).
adjMapping2SUMO('02627136-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02627257-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02627383-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02627510-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02627612-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02627787-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02627927-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02628073-a',[ ('Bird',subsumption)]).
adjMapping2SUMO('02628171-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02628337-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02628550-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02628667-a',[ ('Human',subsumption)]).
adjMapping2SUMO('02628811-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02629017-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('02629182-a',[ ('Eating',subsumption)]).
adjMapping2SUMO('02629301-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02629410-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02629659-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02629846-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02629942-a',[ ('Region',subsumption)]).
adjMapping2SUMO('02630121-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02630221-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('02630402-a',[ (believes,subsumption)]).
adjMapping2SUMO('02630519-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02630695-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02630994-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02631085-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02631238-a',[ ('Amphibian',subsumption)]).
adjMapping2SUMO('02631453-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02631594-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02631686-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('02631812-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02631955-a',[ ('Word',subsumption)]).
adjMapping2SUMO('02632148-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02632263-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02632363-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02632504-a',[ ('Word',subsumption)]).
adjMapping2SUMO('02632595-a',[ ('Insect',subsumption)]).
adjMapping2SUMO('02632696-a',[ ('Maintaining',subsumption)]).
adjMapping2SUMO('02632799-a',[ ('Maintaining',subsumption)]).
adjMapping2SUMO('02632916-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02633011-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02633115-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02633222-a',[ ('',undefined)]).
adjMapping2SUMO('02633329-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02633447-a',[ ('AsexualReproduction',subsumption)]).
adjMapping2SUMO('02633696-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('02633877-a',[ ('AsexualReproduction',subsumption)]).
adjMapping2SUMO('02634073-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02634232-a',[ ('',undefined)]).
adjMapping2SUMO('02634428-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02634569-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02634709-a',[ ('',undefined)]).
adjMapping2SUMO('02634820-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02634940-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02635069-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02635221-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02635395-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02635499-a',[ ('Noun',subsumption)]).
adjMapping2SUMO('02635611-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02635794-a',[ ('Declaring',subsumption)]).
adjMapping2SUMO('02635941-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02636123-a',[ ('Getting',subsumption)]).
adjMapping2SUMO('02636261-a',[ ('Room',subsumption)]).
adjMapping2SUMO('02636358-a',[ (capability,subsumption)]).
adjMapping2SUMO('02636461-a',[ ('Water',equivalence)]).
adjMapping2SUMO('02636582-a',[ ('Water',subsumption)]).
adjMapping2SUMO('02636708-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02636811-a',[ ('Arachnid',equivalence)]).
adjMapping2SUMO('02637063-a',[ ('Language',subsumption)]).
adjMapping2SUMO('02637182-a',[ ('',undefined)]).
adjMapping2SUMO('02637380-a',[ ('Arachnid',subsumption)]).
adjMapping2SUMO('02637537-a',[ ('',undefined)]).
adjMapping2SUMO('02637730-a',[ ('Selecting',subsumption)]).
adjMapping2SUMO('02637973-a',[ ('Selecting',subsumption)]).
adjMapping2SUMO('02638121-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02638392-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02638740-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02638894-a',[ ('CognitiveAgent',subsumption)]).
adjMapping2SUMO('02639064-a',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('02639193-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02639302-a',[ ('Government',subsumption)]).
adjMapping2SUMO('02639430-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02639590-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('02639772-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02639895-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02640086-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('02640223-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02640354-a',[ ('Reptile',subsumption)]).
adjMapping2SUMO('02640503-a',[ ('GeographicArea',equivalence)]).
adjMapping2SUMO('02640629-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('02640746-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('02640908-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02641012-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02641118-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('02641201-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02641378-a',[ ('',undefined)]).
adjMapping2SUMO('02641571-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('02641731-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02641856-a',[ ('Artery',subsumption)]).
adjMapping2SUMO('02642034-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02642258-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02642394-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02642497-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02642634-a',[ ('Arthropod',equivalence)]).
adjMapping2SUMO('02642886-a',[ ('ReproductiveBody',subsumption)]).
adjMapping2SUMO('02643082-a',[ ('Group',subsumption)]).
adjMapping2SUMO('02643220-a',[ ('BodyJunction',subsumption)]).
adjMapping2SUMO('02643446-a',[ (part,subsumption)]).
adjMapping2SUMO('02643673-a',[ ('Mammal',subsumption)]).
adjMapping2SUMO('02643900-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02644050-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02644177-a',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('02644407-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02644602-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02644748-a',[ ('FruitOrVegetable',subsumption)]).
adjMapping2SUMO('02644870-a',[ ('ReproductiveBody',subsumption)]).
adjMapping2SUMO('02645042-a',[ ('IntentionalPsychologicalProcess',subsumption)]).
adjMapping2SUMO('02645187-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02645303-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02645417-a',[ ('',undefined)]).
adjMapping2SUMO('02645494-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02645677-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02645868-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('02645950-a',[ ('',undefined)]).
adjMapping2SUMO('02646072-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('02646215-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('02646381-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02646605-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02646804-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02646952-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02647123-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02647236-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02647358-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02647497-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02647688-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02647917-a',[ ('Perception',subsumption)]).
adjMapping2SUMO('02648021-a',[ ('',undefined)]).
adjMapping2SUMO('02648106-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('02648270-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('02648392-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02648576-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02648698-a',[ ('Hearing',subsumption)]).
adjMapping2SUMO('02648847-a',[ ('Hearing',subsumption)]).
adjMapping2SUMO('02648988-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02649125-a',[ ('Hearing',subsumption)]).
adjMapping2SUMO('02649399-a',[ (capability,subsumption)]).
adjMapping2SUMO('02649570-a',[ ('Hearing',subsumption)]).
adjMapping2SUMO('02649706-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('02649873-a',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('02650083-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('02650214-a',[ ('DiagnosticProcess',subsumption)]).
adjMapping2SUMO('02650303-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('02650425-a',[ ('GeographicArea',instance)]).
adjMapping2SUMO('02650537-a',[ ('Hominid',subsumption)]).
adjMapping2SUMO('02650672-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02650795-a',[ ('Government',subsumption)]).
adjMapping2SUMO('02651014-a',[ (authors,subsumption)]).
adjMapping2SUMO('02651244-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02651468-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02651696-a',[ ('ChemicalProcess',subsumption)]).
adjMapping2SUMO('02651816-a',[ ('Replication',subsumption)]).
adjMapping2SUMO('02651921-a',[ ('Writing',subsumption)]).
adjMapping2SUMO('02652018-a',[ ('Digesting',subsumption)]).
adjMapping2SUMO('02652124-a',[ ('TherapeuticProcess',subsumption)]).
adjMapping2SUMO('02652261-a',[ ('DiagnosticProcess',subsumption)]).
adjMapping2SUMO('02652372-a',[ (believes,subsumption)]).
adjMapping2SUMO('02652490-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02652590-a',[ ('ChemicalSynthesis',subsumption)]).
adjMapping2SUMO('02652877-a',[ ('',undefined)]).
adjMapping2SUMO('02653056-a',[ ('ContentDevelopment',subsumption)]).
adjMapping2SUMO('02653174-a',[ ('Growth',subsumption)]).
adjMapping2SUMO('02653281-a',[ ('Hormone',subsumption)]).
adjMapping2SUMO('02653385-a',[ ('Sentence',subsumption)]).
adjMapping2SUMO('02653651-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02653806-a',[ ('FruitOrVegetable',subsumption)]).
adjMapping2SUMO('02653924-a',[ ('Bird',equivalence)]).
adjMapping2SUMO('02654035-a',[ ('Bird',subsumption)]).
adjMapping2SUMO('02654216-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02654314-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02654442-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('02654548-a',[ (familyRelation,subsumption)]).
adjMapping2SUMO('02654652-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02654752-a',[ ('',undefined)]).
adjMapping2SUMO('02654894-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02655015-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02655180-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02655318-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02655431-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02655560-a',[ ('',undefined)]).
adjMapping2SUMO('02655723-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02655838-a',[ ('PlaneAngleMeasure',subsumption)]).
adjMapping2SUMO('02655943-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02656034-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02656121-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('02656218-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02656464-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02656539-a',[ ('',undefined)]).
adjMapping2SUMO('02656699-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02656801-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02656930-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02657100-a',[ ('',undefined)]).
adjMapping2SUMO('02657221-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02657334-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02657454-a',[ ('Virus',subsumption)]).
adjMapping2SUMO('02657619-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02657741-a',[ ('Bacterium',equivalence)]).
adjMapping2SUMO('02657966-a',[ ('',undefined)]).
adjMapping2SUMO('02658043-a',[ ('Dancing',subsumption)]).
adjMapping2SUMO('02658188-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02658412-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02658629-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('02658737-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('02658835-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('02659044-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02659154-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02659292-a',[ ('ReproductiveBody',subsumption)]).
adjMapping2SUMO('02659404-a',[ ('Fungus',subsumption)]).
adjMapping2SUMO('02659571-a',[ ('ReproductiveBody',subsumption)]).
adjMapping2SUMO('02659733-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02659931-a',[ ('Building',subsumption)]).
adjMapping2SUMO('02660065-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02660164-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02660337-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('02660546-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02660651-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02660940-a',[ ('',undefined)]).
adjMapping2SUMO('02661099-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02661202-a',[ ('Expressing',subsumption)]).
adjMapping2SUMO('02661314-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02661446-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02661574-a',[ (bottom,subsumption)]).
adjMapping2SUMO('02661806-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02661922-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02662020-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02662142-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02662252-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02662394-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02662538-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02662692-a',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('02662792-a',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02662933-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('02663040-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02663145-a',[ ('Collection',subsumption)]).
adjMapping2SUMO('02663351-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02663453-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('02663583-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02663676-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02663798-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('02663950-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02664067-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02664215-a',[ ('',undefined)]).
adjMapping2SUMO('02664354-a',[ ('CurrencyMeasure',subsumption)]).
adjMapping2SUMO('02664592-a',[ ('TimeMeasure',subsumption)]).
adjMapping2SUMO('02664700-a',[ ('Number',subsumption)]).
adjMapping2SUMO('02664825-a',[ ('Enzyme',subsumption)]).
adjMapping2SUMO('02664932-a',[ ('ChemicalProcess',subsumption)]).
adjMapping2SUMO('02665088-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02665212-a',[ ('Replication',subsumption)]).
adjMapping2SUMO('02665367-a',[ ('BiologicalProcess',subsumption)]).
adjMapping2SUMO('02665497-a',[ ('BiologicalProcess',subsumption)]).
adjMapping2SUMO('02665642-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02665803-a',[ ('Biology',equivalence)]).
adjMapping2SUMO('02666029-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02666132-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02666294-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02666434-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02666530-a',[ ('ChemicalSynthesis',subsumption)]).
adjMapping2SUMO('02666637-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02666747-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02666852-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02666952-a',[ ('',undefined)]).
adjMapping2SUMO('02667148-a',[ ('AsexualReproduction',subsumption)]).
adjMapping2SUMO('02667275-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('02667426-a',[ ('',undefined)]).
adjMapping2SUMO('02667550-a',[ ('Icon',subsumption)]).
adjMapping2SUMO('02667637-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('02667741-a',[ ('LogicalOperator',subsumption)]).
adjMapping2SUMO('02667973-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02668058-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02668153-a',[ ('Hominid',subsumption)]).
adjMapping2SUMO('02668258-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02668432-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02668585-a',[ ('',undefined)]).
adjMapping2SUMO('02668695-a',[ ('',undefined)]).
adjMapping2SUMO('02668839-a',[ ('',undefined)]).
adjMapping2SUMO('02668981-a',[ ('Writing',subsumption)]).
adjMapping2SUMO('02669125-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02669223-a',[ ('Invertebrate',subsumption)]).
adjMapping2SUMO('02669373-a',[ ('Mollusk',subsumption)]).
adjMapping2SUMO('02669490-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02669616-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02669731-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02669806-a',[ ('CognitiveAgent',subsumption)]).
adjMapping2SUMO('02670050-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02670202-a',[ ('Crustacean',subsumption)]).
adjMapping2SUMO('02670411-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02670572-a',[ ('',undefined)]).
adjMapping2SUMO('02670678-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02670812-a',[ (part,subsumption)]).
adjMapping2SUMO('02670899-a',[ (capability,subsumption)]).
adjMapping2SUMO('02671038-a',[ (capability,subsumption)]).
adjMapping2SUMO('02671202-a',[ (capability,subsumption)]).
adjMapping2SUMO('02671423-a',[ ('',undefined)]).
adjMapping2SUMO('02671577-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('02671714-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02671795-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02671885-a',[ ('',undefined)]).
adjMapping2SUMO('02672015-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02672116-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02672219-a',[ ('Bird',subsumption)]).
adjMapping2SUMO('02672344-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02672500-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02672591-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02672729-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02672886-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02673022-a',[ ('Certificate',subsumption)]).
adjMapping2SUMO('02673139-a',[ ('AnatomicalStructure',subsumption)]).
adjMapping2SUMO('02673345-a',[ ('Icon',subsumption)]).
adjMapping2SUMO('02673446-a',[ ('Amphibian',subsumption)]).
adjMapping2SUMO('02673594-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('02673712-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02673810-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('02673880-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02673969-a',[ ('Substance',subsumption)]).
adjMapping2SUMO('02674148-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02674303-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02674398-a',[ ('Substance',subsumption)]).
adjMapping2SUMO('02674530-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02674642-a',[ ('AnatomicalStructure',subsumption)]).
adjMapping2SUMO('02674772-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('02675055-a',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('02675196-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02675320-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02675446-a',[ ('Calorie',equivalence)]).
adjMapping2SUMO('02675626-a',[ ('',undefined)]).
adjMapping2SUMO('02675738-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('02675856-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02676046-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02676205-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02676309-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02676383-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02676456-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02676610-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02676825-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02676966-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02677112-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02677231-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02677332-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('02677549-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('02677703-a',[ ('Canine',equivalence)]).
adjMapping2SUMO('02677861-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02678001-a',[ (capability,subsumption)]).
adjMapping2SUMO('02678087-a',[ ('',undefined)]).
adjMapping2SUMO('02678218-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02678371-a',[ ('',undefined)]).
adjMapping2SUMO('02678502-a',[ ('HoofedMammal',subsumption)]).
adjMapping2SUMO('02678677-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02678850-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02679063-a',[ ('Fish',subsumption)]).
adjMapping2SUMO('02679202-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02679352-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02679468-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02679653-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02679858-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02680017-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02680151-a',[ ('DiagnosticProcess',subsumption)]).
adjMapping2SUMO('02680242-a',[ ('OrganismProcess',subsumption)]).
adjMapping2SUMO('02680492-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02680580-a',[ ('Carnivore',equivalence)]).
adjMapping2SUMO('02680723-a',[ ('',undefined)]).
adjMapping2SUMO('02680977-a',[ ('',undefined)]).
adjMapping2SUMO('02681141-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02681282-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02681402-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02681567-a',[ ('ReproductiveBody',subsumption)]).
adjMapping2SUMO('02681681-a',[ ('ReproductiveBody',subsumption)]).
adjMapping2SUMO('02681776-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02681881-a',[ ('ContentDevelopment',subsumption)]).
adjMapping2SUMO('02682039-a',[ ('',undefined)]).
adjMapping2SUMO('02682134-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02682298-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02682406-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02682543-a',[ ('',undefined)]).
adjMapping2SUMO('02682699-a',[ ('ChemicalDecomposition',subsumption)]).
adjMapping2SUMO('02682863-a',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('02683049-a',[ ('Enzyme',subsumption)]).
adjMapping2SUMO('02683160-a',[ ('',undefined)]).
adjMapping2SUMO('02683315-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02683419-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02683650-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02683869-a',[ ('Class',subsumption)]).
adjMapping2SUMO('02684005-a',[ ('Class',subsumption)]).
adjMapping2SUMO('02684198-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02684317-a',[ ('Building',subsumption)]).
adjMapping2SUMO('02684482-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02684557-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02684742-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02684875-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02684971-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02685153-a',[ ('EarthsAtmosphere',subsumption)]).
adjMapping2SUMO('02685299-a',[ ('Cell',equivalence)]).
adjMapping2SUMO('02685539-a',[ (located,subsumption)]).
adjMapping2SUMO('02685703-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02685785-a',[ ('',undefined)]).
adjMapping2SUMO('02685946-a',[ (located,subsumption)]).
adjMapping2SUMO('02686046-a',[ ('',undefined)]).
adjMapping2SUMO('02686159-a',[ (located,subsumption)]).
adjMapping2SUMO('02686322-a',[ ('Substance',subsumption)]).
adjMapping2SUMO('02686439-a',[ ('Substance',subsumption)]).
adjMapping2SUMO('02686630-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02686950-a',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('02687191-a',[ ('BiologicalProcess',subsumption)]).
adjMapping2SUMO('02687333-a',[ ('',undefined)]).
adjMapping2SUMO('02687434-a',[ ('BiologicalProcess',subsumption)]).
adjMapping2SUMO('02687578-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02687727-a',[ ('Quantity',subsumption)]).
adjMapping2SUMO('02687822-a',[ ('',undefined)]).
adjMapping2SUMO('02688016-a',[ (believes,subsumption)]).
adjMapping2SUMO('02688131-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02688263-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02688369-a',[ ('Mollusk',subsumption)]).
adjMapping2SUMO('02688523-a',[ ('Worm',subsumption)]).
adjMapping2SUMO('02688623-a',[ ('Food',subsumption)]).
adjMapping2SUMO('02688833-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02688974-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('02689112-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('02689256-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02689430-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02689542-a',[ ('Metal',subsumption)]).
adjMapping2SUMO('02689658-a',[ ('Metal',subsumption)]).
adjMapping2SUMO('02689782-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02689889-a',[ ('HoofedMammal',subsumption)]).
adjMapping2SUMO('02689973-a',[ ('AquaticMammal',subsumption)]).
adjMapping2SUMO('02690153-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02690270-a',[ ('Worm',subsumption)]).
adjMapping2SUMO('02690429-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02690613-a',[ ('',undefined)]).
adjMapping2SUMO('02690922-a',[ ('Metal',subsumption)]).
adjMapping2SUMO('02691028-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02691142-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02691237-a',[ ('',undefined)]).
adjMapping2SUMO('02691390-a',[ ('UnilateralGiving',subsumption)]).
adjMapping2SUMO('02691531-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02691680-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02691839-a',[ ('',undefined)]).
adjMapping2SUMO('02691944-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02692034-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02692105-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('02692229-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02692378-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02692471-a',[ ('Reptile',subsumption)]).
adjMapping2SUMO('02692624-a',[ ('Chemistry',equivalence)]).
adjMapping2SUMO('02692815-a',[ ('ChemicalProcess',subsumption)]).
adjMapping2SUMO('02692966-a',[ ('ChemicalProcess',subsumption)]).
adjMapping2SUMO('02693186-a',[ ('ChemicalProcess',subsumption)]).
adjMapping2SUMO('02693278-a',[ ('ChemicalProcess',subsumption)]).
adjMapping2SUMO('02693440-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02693533-a',[ ('TherapeuticProcess',subsumption)]).
adjMapping2SUMO('02693701-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02693802-a',[ ('Island',instance)]).
adjMapping2SUMO('02693895-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02694109-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02694247-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02694583-a',[ ('',undefined)]).
adjMapping2SUMO('02694784-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02694948-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02695045-a',[ ('',undefined)]).
adjMapping2SUMO('02695229-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02695389-a',[ ('',undefined)]).
adjMapping2SUMO('02695522-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02695647-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('02695765-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02695966-a',[ ('Vertebrate',equivalence)]).
adjMapping2SUMO('02696090-a',[ ('',undefined)]).
adjMapping2SUMO('02696234-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02696386-a',[ ('Human',instance)]).
adjMapping2SUMO('02696515-a',[ ('Human',instance)]).
adjMapping2SUMO('02696638-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02696795-a',[ ('MotionPicture',equivalence)]).
adjMapping2SUMO('02696920-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02697116-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02697329-a',[ ('City',equivalence)]).
adjMapping2SUMO('02697452-a',[ ('City',equivalence)]).
adjMapping2SUMO('02697677-a',[ ('Bird',subsumption)]).
adjMapping2SUMO('02697781-a',[ ('',undefined)]).
adjMapping2SUMO('02697911-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02698031-a',[ ('ClericalSecretary',subsumption)]).
adjMapping2SUMO('02698145-a',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('02698301-a',[ (copy,subsumption)]).
adjMapping2SUMO('02698379-a',[ ('EngineeringComponent',subsumption)]).
adjMapping2SUMO('02698514-a',[ ('',undefined)]).
adjMapping2SUMO('02698663-a',[ ('',undefined)]).
adjMapping2SUMO('02698782-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('02698898-a',[ ('',undefined)]).
adjMapping2SUMO('02699011-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('02699121-a',[ ('',undefined)]).
adjMapping2SUMO('02699289-a',[ ('',undefined)]).
adjMapping2SUMO('02699451-a',[ ('Clothing',not(subsumption))]).
adjMapping2SUMO('02699524-a',[ ('EducationalOrganization',subsumption)]).
adjMapping2SUMO('02699792-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02700029-a',[ ('GeopoliticalArea',subsumption)]).
adjMapping2SUMO('02700199-a',[ ('Animal',subsumption)]).
adjMapping2SUMO('02700317-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02700434-a',[ ('',undefined)]).
adjMapping2SUMO('02700615-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('02700792-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02700918-a',[ ('GeopoliticalArea',subsumption)]).
adjMapping2SUMO('02701099-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('02701253-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02701377-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02701548-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('02701662-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('02701775-a',[ ('Contest',subsumption)]).
adjMapping2SUMO('02701922-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02702099-a',[ ('',undefined)]).
adjMapping2SUMO('02702209-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02702332-a',[ ('TherapeuticProcess',subsumption)]).
adjMapping2SUMO('02702473-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02702656-a',[ ('Contract',equivalence)]).
adjMapping2SUMO('02702807-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02703001-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02703438-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02703911-a',[ ('EngineeringComponent',not(subsumption))]).
adjMapping2SUMO('02704005-a',[ (refers,subsumption)]).
adjMapping2SUMO('02704120-a',[ ('ReproductiveBody',subsumption)]).
adjMapping2SUMO('02704245-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02704344-a',[ ('',undefined)]).
adjMapping2SUMO('02704461-a',[ ('Relation',subsumption)]).
adjMapping2SUMO('02704611-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02704686-a',[ ('',undefined)]).
adjMapping2SUMO('02704844-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('02704983-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02705138-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02705254-a',[ ('Relation',subsumption)]).
adjMapping2SUMO('02705409-a',[ ('',undefined)]).
adjMapping2SUMO('02705572-a',[ ('',undefined)]).
adjMapping2SUMO('02705692-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02705809-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02705928-a',[ ('',undefined)]).
adjMapping2SUMO('02706051-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02706160-a',[ ('',undefined)]).
adjMapping2SUMO('02706305-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02706480-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02706593-a',[ ('',undefined)]).
adjMapping2SUMO('02706691-a',[ ('',undefined)]).
adjMapping2SUMO('02707008-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02707164-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02707283-a',[ ('',undefined)]).
adjMapping2SUMO('02707429-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02707528-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('02707659-a',[ ('Cooking',equivalence)]).
adjMapping2SUMO('02707750-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('02707889-a',[ ('Metal',subsumption)]).
adjMapping2SUMO('02708020-a',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('02708140-a',[ ('',undefined)]).
adjMapping2SUMO('02708232-a',[ ('',undefined)]).
adjMapping2SUMO('02708334-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02708506-a',[ ('',undefined)]).
adjMapping2SUMO('02708649-a',[ ('',undefined)]).
adjMapping2SUMO('02708776-a',[ ('',undefined)]).
adjMapping2SUMO('02708931-a',[ ('',undefined)]).
adjMapping2SUMO('02709036-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02709190-a',[ ('AnatomicalStructure',subsumption)]).
adjMapping2SUMO('02709299-a',[ ('AnatomicalStructure',subsumption)]).
adjMapping2SUMO('02709441-a',[ ('Growth',subsumption)]).
adjMapping2SUMO('02709599-a',[ ('',undefined)]).
adjMapping2SUMO('02709752-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02709917-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02710043-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('02710294-a',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('02710438-a',[ ('',undefined)]).
adjMapping2SUMO('02710530-a',[ ('DemocraticParty',instance)]).
adjMapping2SUMO('02710672-a',[ ('Language',instance)]).
adjMapping2SUMO('02710825-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02710981-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02711098-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('02711194-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02711292-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('02711468-a',[ (capability,subsumption)]).
adjMapping2SUMO('02711599-a',[ (capability,subsumption)]).
adjMapping2SUMO('02711744-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('02711846-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02712125-a',[ (capability,subsumption)]).
adjMapping2SUMO('02712270-a',[ ('',undefined)]).
adjMapping2SUMO('02712403-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02712499-a',[ ('',undefined)]).
adjMapping2SUMO('02712678-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('02712810-a',[ (capability,subsumption)]).
adjMapping2SUMO('02712922-a',[ (equal,subsumption)]).
adjMapping2SUMO('02713096-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02713232-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02713368-a',[ ('',undefined)]).
adjMapping2SUMO('02713581-a',[ ('',undefined)]).
adjMapping2SUMO('02713715-a',[ ('PoliticalProcess',subsumption)]).
adjMapping2SUMO('02713855-a',[ ('',undefined)]).
adjMapping2SUMO('02713974-a',[ (orientation,subsumption)]).
adjMapping2SUMO('02714141-a',[ (orientation,subsumption)]).
adjMapping2SUMO('02714263-a',[ (orientation,subsumption)]).
adjMapping2SUMO('02714433-a',[ ('Fungus',subsumption)]).
adjMapping2SUMO('02714578-a',[ (orientation,subsumption)]).
adjMapping2SUMO('02714708-a',[ ('',undefined)]).
adjMapping2SUMO('02714800-a',[ (realization,subsumption)]).
adjMapping2SUMO('02714948-a',[ ('FruitOrVegetable',subsumption)]).
adjMapping2SUMO('02715047-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02715142-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02715244-a',[ ('Government',subsumption)]).
adjMapping2SUMO('02715365-a',[ ('PathologicProcess',subsumption)]).
adjMapping2SUMO('02715567-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02715677-a',[ ('',undefined)]).
adjMapping2SUMO('02715802-a',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('02715949-a',[ ('BiologicalProcess',subsumption)]).
adjMapping2SUMO('02716101-a',[ ('',undefined)]).
adjMapping2SUMO('02716247-a',[ ('',undefined)]).
adjMapping2SUMO('02716412-a',[ ('',undefined)]).
adjMapping2SUMO('02716516-a',[ ('',undefined)]).
adjMapping2SUMO('02716605-a',[ ('Economics',equivalence)]).
adjMapping2SUMO('02716739-a',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('02717021-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('02717149-a',[ ('',undefined)]).
adjMapping2SUMO('02717258-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02717402-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02717538-a',[ ('Election',equivalence)]).
adjMapping2SUMO('02717678-a',[ ('',undefined)]).
adjMapping2SUMO('02717784-a',[ ('',undefined)]).
adjMapping2SUMO('02717896-a',[ ('',undefined)]).
adjMapping2SUMO('02718008-a',[ ('',undefined)]).
adjMapping2SUMO('02718131-a',[ ('',undefined)]).
adjMapping2SUMO('02718256-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02718393-a',[ ('',undefined)]).
adjMapping2SUMO('02718497-a',[ ('ElectricDevice',subsumption)]).
adjMapping2SUMO('02718719-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02718845-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02719009-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02719244-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02719395-a',[ ('ElementalSubstance',equivalence)]).
adjMapping2SUMO('02719503-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02719685-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02719872-a',[ ('CognitiveAgent',subsumption)]).
adjMapping2SUMO('02720042-a',[ ('Region',subsumption)]).
adjMapping2SUMO('02720203-a',[ ('Pretending',subsumption)]).
adjMapping2SUMO('02720312-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('02720484-a',[ ('',undefined)]).
adjMapping2SUMO('02720601-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02720715-a',[ ('',undefined)]).
adjMapping2SUMO('02720818-a',[ ('',undefined)]).
adjMapping2SUMO('02720965-a',[ (inhabits,subsumption)]).
adjMapping2SUMO('02721057-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02721220-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02721342-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('02721439-a',[ ('HoofedMammal',subsumption)]).
adjMapping2SUMO('02721547-a',[ ('HoofedMammal',subsumption)]).
adjMapping2SUMO('02721618-a',[ ('TimePosition',subsumption)]).
adjMapping2SUMO('02721762-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02721877-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02721979-a',[ ('Fungus',subsumption)]).
adjMapping2SUMO('02722083-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02722187-a',[ (capability,subsumption)]).
adjMapping2SUMO('02722304-a',[ ('',undefined)]).
adjMapping2SUMO('02722421-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('02722501-a',[ ('',undefined)]).
adjMapping2SUMO('02722630-a',[ ('',undefined)]).
adjMapping2SUMO('02722801-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02722901-a',[ ('',undefined)]).
adjMapping2SUMO('02722988-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02723158-a',[ ('Nation',instance)]).
adjMapping2SUMO('02723312-a',[ ('Hormone',subsumption)]).
adjMapping2SUMO('02723420-a',[ ('WaterArea',subsumption)]).
adjMapping2SUMO('02723563-a',[ ('Philosophy',instance)]).
adjMapping2SUMO('02723723-a',[ (increasesLikelihood,subsumption)]).
adjMapping2SUMO('02723904-a',[ ('AnatomicalStructure',subsumption)]).
adjMapping2SUMO('02724050-a',[ ('OrganOrTissueProcess',subsumption)]).
adjMapping2SUMO('02724166-a',[ ('ContentDevelopment',subsumption)]).
adjMapping2SUMO('02724308-a',[ ('',undefined)]).
adjMapping2SUMO('02724483-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02724630-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02724759-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02724960-a',[ ('',undefined)]).
adjMapping2SUMO('02725058-a',[ ('',undefined)]).
adjMapping2SUMO('02725181-a',[ ('',undefined)]).
adjMapping2SUMO('02725350-a',[ ('',undefined)]).
adjMapping2SUMO('02725452-a',[ (capability,subsumption)]).
adjMapping2SUMO('02725548-a',[ ('',undefined)]).
adjMapping2SUMO('02725764-a',[ ('',undefined)]).
adjMapping2SUMO('02725829-a',[ ('NationalGovernment',subsumption)]).
adjMapping2SUMO('02726017-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02726151-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02726232-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02726345-a',[ ('',undefined)]).
adjMapping2SUMO('02726429-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('02726546-a',[ ('Government',subsumption)]).
adjMapping2SUMO('02726715-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02726921-a',[ ('DiseaseOrSyndrome',not(subsumption))]).
adjMapping2SUMO('02727009-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02727263-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02727369-a',[ ('Protein',subsumption)]).
adjMapping2SUMO('02727482-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02727579-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02727706-a',[ ('FictionalText',subsumption)]).
adjMapping2SUMO('02727912-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02728002-a',[ ('',undefined)]).
adjMapping2SUMO('02728113-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02728303-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02728444-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02728532-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02728683-a',[ ('Worm',subsumption)]).
adjMapping2SUMO('02728812-a',[ ('',undefined)]).
adjMapping2SUMO('02728929-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02729065-a',[ ('',undefined)]).
adjMapping2SUMO('02729182-a',[ ('SubjectiveWeakNegativeAttribute',subsumption)]).
adjMapping2SUMO('02729339-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02729457-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02729544-a',[ ('Maintaining',subsumption)]).
adjMapping2SUMO('02729665-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02729812-a',[ ('StreamWaterArea',subsumption)]).
adjMapping2SUMO('02729927-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02730102-a',[ ('',undefined)]).
adjMapping2SUMO('02730212-a',[ ('',undefined)]).
adjMapping2SUMO('02730304-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02730673-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02730770-a',[ ('Insect',subsumption)]).
adjMapping2SUMO('02730861-a',[ ('',undefined)]).
adjMapping2SUMO('02730982-a',[ ('',undefined)]).
adjMapping2SUMO('02731061-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02731174-a',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('02731334-a',[ ('',undefined)]).
adjMapping2SUMO('02731461-a',[ ('',undefined)]).
adjMapping2SUMO('02731616-a',[ ('',undefined)]).
adjMapping2SUMO('02731699-a',[ ('Organization',subsumption)]).
adjMapping2SUMO('02731850-a',[ ('MusicalInstrument',subsumption)]).
adjMapping2SUMO('02731953-a',[ ('MusicalInstrument',subsumption)]).
adjMapping2SUMO('02732059-a',[ ('Touching',subsumption)]).
adjMapping2SUMO('02732266-a',[ ('Touching',not(subsumption))]).
adjMapping2SUMO('02732405-a',[ ('Human',subsumption)]).
adjMapping2SUMO('02732569-a',[ ('Human',subsumption)]).
adjMapping2SUMO('02732806-a',[ ('Human',instance)]).
adjMapping2SUMO('02732935-a',[ ('',undefined)]).
adjMapping2SUMO('02733034-a',[ ('PerceptualAttribute',subsumption)]).
adjMapping2SUMO('02733187-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('02733390-a',[ ('',undefined)]).
adjMapping2SUMO('02733515-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02733652-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02733782-a',[ ('Replication',subsumption)]).
adjMapping2SUMO('02733873-a',[ ('',undefined)]).
adjMapping2SUMO('02734016-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02734192-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02734391-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02734544-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02734776-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02734914-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02735066-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('02735208-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02735375-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02735476-a',[ ('',undefined)]).
adjMapping2SUMO('02735669-a',[ ('',undefined)]).
adjMapping2SUMO('02735812-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02735911-a',[ ('',undefined)]).
adjMapping2SUMO('02736015-a',[ ('Water',subsumption)]).
adjMapping2SUMO('02736179-a',[ ('',undefined)]).
adjMapping2SUMO('02736276-a',[ ('Muscle',subsumption)]).
adjMapping2SUMO('02736393-a',[ ('',undefined)]).
adjMapping2SUMO('02736507-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02736596-a',[ ('AnatomicalStructure',subsumption)]).
adjMapping2SUMO('02736716-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02736808-a',[ ('Icon',subsumption)]).
adjMapping2SUMO('02736983-a',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('02737183-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02737371-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02737461-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02737655-a',[ ('',undefined)]).
adjMapping2SUMO('02737772-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02737981-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02738091-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02738346-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02738464-a',[ ('',undefined)]).
adjMapping2SUMO('02738760-a',[ ('',undefined)]).
adjMapping2SUMO('02739013-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02739085-a',[ ('Island',subsumption)]).
adjMapping2SUMO('02739189-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('02739578-a',[ ('',undefined)]).
adjMapping2SUMO('02739967-a',[ ('',undefined)]).
adjMapping2SUMO('02740070-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02740223-a',[ ('PathologicProcess',subsumption)]).
adjMapping2SUMO('02740380-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('02740508-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02740649-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02740793-a',[ ('AsexualReproduction',subsumption)]).
adjMapping2SUMO('02740899-a',[ ('',undefined)]).
adjMapping2SUMO('02741032-a',[ ('',undefined)]).
adjMapping2SUMO('02741150-a',[ ('',undefined)]).
adjMapping2SUMO('02741271-a',[ ('AsexualReproduction',subsumption)]).
adjMapping2SUMO('02741373-a',[ ('',undefined)]).
adjMapping2SUMO('02741557-a',[ ('',undefined)]).
adjMapping2SUMO('02741658-a',[ ('Number',subsumption)]).
adjMapping2SUMO('02741797-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02741943-a',[ ('',undefined)]).
adjMapping2SUMO('02742039-a',[ ('Character',subsumption)]).
adjMapping2SUMO('02742206-a',[ ('Character',subsumption)]).
adjMapping2SUMO('02742403-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02742564-a',[ ('',undefined)]).
adjMapping2SUMO('02742719-a',[ ('HoofedMammal',subsumption)]).
adjMapping2SUMO('02742844-a',[ (inhabits,subsumption)]).
adjMapping2SUMO('02742972-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02743112-a',[ ('HourDuration',equivalence)]).
adjMapping2SUMO('02743261-a',[ ('Human',equivalence)]).
adjMapping2SUMO('02743391-a',[ ('Human',equivalence)]).
adjMapping2SUMO('02743547-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02743750-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02743932-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02744247-a',[ ('',undefined)]).
adjMapping2SUMO('02744370-a',[ ('',undefined)]).
adjMapping2SUMO('02744460-a',[ ('',undefined)]).
adjMapping2SUMO('02744565-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02744720-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02744876-a',[ (capability,subsumption)]).
adjMapping2SUMO('02744985-a',[ ('',undefined)]).
adjMapping2SUMO('02745075-a',[ ('Insect',subsumption)]).
adjMapping2SUMO('02745203-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02745284-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02745453-a',[ ('Icon',subsumption)]).
adjMapping2SUMO('02745555-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02745739-a',[ ('',undefined)]).
adjMapping2SUMO('02745862-a',[ (capability,subsumption)]).
adjMapping2SUMO('02745991-a',[ ('',undefined)]).
adjMapping2SUMO('02746103-a',[ ('',undefined)]).
adjMapping2SUMO('02746290-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02746446-a',[ ('',undefined)]).
adjMapping2SUMO('02746555-a',[ (causes,subsumption)]).
adjMapping2SUMO('02746724-a',[ ('',undefined)]).
adjMapping2SUMO('02746897-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('02747036-a',[ ('Government',subsumption)]).
adjMapping2SUMO('02747246-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('02747371-a',[ ('',undefined)]).
adjMapping2SUMO('02747466-a',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('02747667-a',[ ('',undefined)]).
adjMapping2SUMO('02747989-a',[ ('',undefined)]).
adjMapping2SUMO('02748097-a',[ ('IntentionalProcess',subsumption)]).
adjMapping2SUMO('02748216-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02748322-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02748421-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02748542-a',[ ('',undefined)]).
adjMapping2SUMO('02748635-a',[ ('Industry',equivalence)]).
adjMapping2SUMO('02748757-a',[ (capability,subsumption)]).
adjMapping2SUMO('02748837-a',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('02748952-a',[ ('Reasoning',equivalence)]).
adjMapping2SUMO('02749150-a',[ ('',undefined)]).
adjMapping2SUMO('02749257-a',[ ('',undefined)]).
adjMapping2SUMO('02749365-a',[ ('Breathing',subsumption)]).
adjMapping2SUMO('02749510-a',[ ('',undefined)]).
adjMapping2SUMO('02749600-a',[ ('',undefined)]).
adjMapping2SUMO('02749690-a',[ ('',undefined)]).
adjMapping2SUMO('02749778-a',[ ('Organization',subsumption)]).
adjMapping2SUMO('02749971-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02750090-a',[ ('',undefined)]).
adjMapping2SUMO('02750166-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02750241-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02750377-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02750483-a',[ ('Island',equivalence)]).
adjMapping2SUMO('02750663-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02750752-a',[ ('Atom',subsumption)]).
adjMapping2SUMO('02750948-a',[ ('Building',subsumption)]).
adjMapping2SUMO('02751058-a',[ ('Building',subsumption)]).
adjMapping2SUMO('02751177-a',[ ('',undefined)]).
adjMapping2SUMO('02751367-a',[ ('Atom',subsumption)]).
adjMapping2SUMO('02751484-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('02751630-a',[ ('',undefined)]).
adjMapping2SUMO('02751733-a',[ ('',undefined)]).
adjMapping2SUMO('02751889-a',[ ('',undefined)]).
adjMapping2SUMO('02751990-a',[ ('',undefined)]).
adjMapping2SUMO('02752122-a',[ ('',undefined)]).
adjMapping2SUMO('02752234-a',[ ('',undefined)]).
adjMapping2SUMO('02752354-a',[ ('',undefined)]).
adjMapping2SUMO('02752496-a',[ ('Human',instance)]).
adjMapping2SUMO('02752678-a',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('02752787-a',[ ('',undefined)]).
adjMapping2SUMO('02752865-a',[ ('EmotionalState',subsumption)]).
adjMapping2SUMO('02752987-a',[ ('Government',subsumption)]).
adjMapping2SUMO('02753205-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02753345-a',[ ('OlfactoryAttribute',subsumption)]).
adjMapping2SUMO('02753478-a',[ ('',undefined)]).
adjMapping2SUMO('02753600-a',[ ('',undefined)]).
adjMapping2SUMO('02753724-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02753868-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02754012-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02754096-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02754197-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02754327-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02754417-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02754543-a',[ ('',undefined)]).
adjMapping2SUMO('02754618-a',[ ('',undefined)]).
adjMapping2SUMO('02754839-a',[ ('Mixture',subsumption)]).
adjMapping2SUMO('02754995-a',[ ('LandArea',instance)]).
adjMapping2SUMO('02755190-a',[ ('FruitOrVegetable',subsumption)]).
adjMapping2SUMO('02755301-a',[ ('Feline',subsumption)]).
adjMapping2SUMO('02755399-a',[ ('Text',instance)]).
adjMapping2SUMO('02755525-a',[ ('',undefined)]).
adjMapping2SUMO('02755634-a',[ ('',undefined)]).
adjMapping2SUMO('02755772-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('02755918-a',[ ('',undefined)]).
adjMapping2SUMO('02756025-a',[ ('',undefined)]).
adjMapping2SUMO('02756129-a',[ ('Living',equivalence)]).
adjMapping2SUMO('02756234-a',[ ('',undefined)]).
adjMapping2SUMO('02756346-a',[ ('Local',equivalence)]).
adjMapping2SUMO('02756620-a',[ ('',undefined)]).
adjMapping2SUMO('02756743-a',[ ('',undefined)]).
adjMapping2SUMO('02756894-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02757100-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02757215-a',[ ('',undefined)]).
adjMapping2SUMO('02757316-a',[ ('Moon',instance)]).
adjMapping2SUMO('02757446-a',[ ('Region',subsumption)]).
adjMapping2SUMO('02757599-a',[ ('Region',subsumption)]).
adjMapping2SUMO('02757863-a',[ ('',undefined)]).
adjMapping2SUMO('02757975-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('02758124-a',[ ('Canine',subsumption)]).
adjMapping2SUMO('02758222-a',[ ('',undefined)]).
adjMapping2SUMO('02758328-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02758500-a',[ ('',undefined)]).
adjMapping2SUMO('02758610-a',[ ('Language',subsumption)]).
adjMapping2SUMO('02758750-a',[ ('',undefined)]).
adjMapping2SUMO('02758935-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02759009-a',[ ('',undefined)]).
adjMapping2SUMO('02759190-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02759290-a',[ ('',undefined)]).
adjMapping2SUMO('02759367-a',[ (mother,subsumption)]).
adjMapping2SUMO('02759480-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('02759604-a',[ (father,subsumption)]).
adjMapping2SUMO('02759765-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02759910-a',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02760011-a',[ ('',undefined)]).
adjMapping2SUMO('02760116-a',[ ('MedicalScience',equivalence)]).
adjMapping2SUMO('02760316-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02760500-a',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('02760615-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02760820-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02760940-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02761053-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02761162-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02761251-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02761349-a',[ ('OrganismProcess',subsumption)]).
adjMapping2SUMO('02761455-a',[ ('',undefined)]).
adjMapping2SUMO('02761569-a',[ ('',undefined)]).
adjMapping2SUMO('02761686-a',[ ('',undefined)]).
adjMapping2SUMO('02761831-a',[ ('',undefined)]).
adjMapping2SUMO('02761944-a',[ ('',undefined)]).
adjMapping2SUMO('02762081-a',[ ('Damaging',equivalence)]).
adjMapping2SUMO('02762326-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('02762404-a',[ ('',undefined)]).
adjMapping2SUMO('02762522-a',[ ('',undefined)]).
adjMapping2SUMO('02762621-a',[ ('',undefined)]).
adjMapping2SUMO('02762782-a',[ ('',undefined)]).
adjMapping2SUMO('02762931-a',[ ('',undefined)]).
adjMapping2SUMO('02763056-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('02763140-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02763240-a',[ ('',undefined)]).
adjMapping2SUMO('02763308-a',[ ('',undefined)]).
adjMapping2SUMO('02763423-a',[ ('Separating',subsumption)]).
adjMapping2SUMO('02763520-a',[ ('Metal',subsumption)]).
adjMapping2SUMO('02763684-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02763824-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02763927-a',[ ('',undefined)]).
adjMapping2SUMO('02764031-a',[ ('',undefined)]).
adjMapping2SUMO('02764159-a',[ ('',undefined)]).
adjMapping2SUMO('02764251-a',[ ('MilitaryScience',equivalence)]).
adjMapping2SUMO('02764378-a',[ ('PoliticalOrganization',subsumption)]).
adjMapping2SUMO('02764549-a',[ ('',undefined)]).
adjMapping2SUMO('02764643-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02764828-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02764991-a',[ ('',undefined)]).
adjMapping2SUMO('02765076-a',[ ('',undefined)]).
adjMapping2SUMO('02765190-a',[ ('',undefined)]).
adjMapping2SUMO('02765308-a',[ ('',undefined)]).
adjMapping2SUMO('02765506-a',[ ('',undefined)]).
adjMapping2SUMO('02765640-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02765730-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02765825-a',[ ('',undefined)]).
adjMapping2SUMO('02765965-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02766085-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('02766229-a',[ ('',undefined)]).
adjMapping2SUMO('02766328-a',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('02766469-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('02766602-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02766699-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02766848-a',[ ('Tissue',not(subsumption))]).
adjMapping2SUMO('02766952-a',[ ('',undefined)]).
adjMapping2SUMO('02767110-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02767250-a',[ ('',undefined)]).
adjMapping2SUMO('02767378-a',[ ('Birth',equivalence)]).
adjMapping2SUMO('02767514-a',[ ('',undefined)]).
adjMapping2SUMO('02767596-a',[ ('',undefined)]).
adjMapping2SUMO('02767701-a',[ ('Government',subsumption)]).
adjMapping2SUMO('02767872-a',[ ('',undefined)]).
adjMapping2SUMO('02768002-a',[ ('',undefined)]).
adjMapping2SUMO('02768106-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('02768271-a',[ ('AnatomicalStructure',subsumption)]).
adjMapping2SUMO('02768421-a',[ ('',undefined)]).
adjMapping2SUMO('02768611-a',[ ('',undefined)]).
adjMapping2SUMO('02768740-a',[ ('',undefined)]).
adjMapping2SUMO('02768850-a',[ ('',undefined)]).
adjMapping2SUMO('02768958-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02769128-a',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('02769358-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02769463-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02769692-a',[ ('',undefined)]).
adjMapping2SUMO('02769811-a',[ ('',undefined)]).
adjMapping2SUMO('02769933-a',[ ('Number',equivalence)]).
adjMapping2SUMO('02770123-a',[ ('',undefined)]).
adjMapping2SUMO('02770229-a',[ ('',undefined)]).
adjMapping2SUMO('02770360-a',[ ('CognitiveAgent',subsumption)]).
adjMapping2SUMO('02770479-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02770629-a',[ ('OlfactoryAttribute',equivalence)]).
adjMapping2SUMO('02770742-a',[ ('Government',subsumption)]).
adjMapping2SUMO('02770951-a',[ ('',undefined)]).
adjMapping2SUMO('02771079-a',[ ('',undefined)]).
adjMapping2SUMO('02771174-a',[ ('',undefined)]).
adjMapping2SUMO('02771328-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02771485-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02771648-a',[ ('',undefined)]).
adjMapping2SUMO('02771740-a',[ ('',undefined)]).
adjMapping2SUMO('02771866-a',[ ('',undefined)]).
adjMapping2SUMO('02772012-a',[ ('',undefined)]).
adjMapping2SUMO('02772186-a',[ ('',undefined)]).
adjMapping2SUMO('02772465-a',[ ('',undefined)]).
adjMapping2SUMO('02772543-a',[ ('',undefined)]).
adjMapping2SUMO('02772654-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02772819-a',[ ('',undefined)]).
adjMapping2SUMO('02773062-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02773293-a',[ ('',undefined)]).
adjMapping2SUMO('02773401-a',[ ('',undefined)]).
adjMapping2SUMO('02773472-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02773612-a',[ ('',undefined)]).
adjMapping2SUMO('02773691-a',[ ('',undefined)]).
adjMapping2SUMO('02773862-a',[ ('',undefined)]).
adjMapping2SUMO('02774164-a',[ ('',undefined)]).
adjMapping2SUMO('02774269-a',[ ('',undefined)]).
adjMapping2SUMO('02774411-a',[ ('Government',subsumption)]).
adjMapping2SUMO('02774585-a',[ ('',undefined)]).
adjMapping2SUMO('02774705-a',[ ('Gland',subsumption)]).
adjMapping2SUMO('02774804-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02774923-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02775029-a',[ ('Bird',subsumption)]).
adjMapping2SUMO('02775175-a',[ ('Bird',subsumption)]).
adjMapping2SUMO('02775318-a',[ ('',undefined)]).
adjMapping2SUMO('02775417-a',[ ('',undefined)]).
adjMapping2SUMO('02775599-a',[ (capability,subsumption)]).
adjMapping2SUMO('02775713-a',[ ('',undefined)]).
adjMapping2SUMO('02775797-a',[ ('',undefined)]).
adjMapping2SUMO('02775934-a',[ ('CurrencyMeasure',subsumption)]).
adjMapping2SUMO('02776174-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02776296-a',[ ('',undefined)]).
adjMapping2SUMO('02776379-a',[ ('',undefined)]).
adjMapping2SUMO('02776496-a',[ ('',undefined)]).
adjMapping2SUMO('02776576-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('02776688-a',[ ('',undefined)]).
adjMapping2SUMO('02776813-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02776931-a',[ ('',undefined)]).
adjMapping2SUMO('02777055-a',[ ('Character',subsumption)]).
adjMapping2SUMO('02777160-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02777355-a',[ ('ContentDevelopment',subsumption)]).
adjMapping2SUMO('02777548-a',[ ('',undefined)]).
adjMapping2SUMO('02777686-a',[ ('OrganismProcess',subsumption)]).
adjMapping2SUMO('02777831-a',[ ('OrganismProcess',not(subsumption))]).
adjMapping2SUMO('02777931-a',[ ('',undefined)]).
adjMapping2SUMO('02778016-a',[ ('',undefined)]).
adjMapping2SUMO('02778122-a',[ ('Icon',subsumption)]).
adjMapping2SUMO('02778332-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02778439-a',[ ('',undefined)]).
adjMapping2SUMO('02778533-a',[ ('',undefined)]).
adjMapping2SUMO('02778668-a',[ ('Planet',subsumption)]).
adjMapping2SUMO('02778943-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02779044-a',[ ('Publication',subsumption)]).
adjMapping2SUMO('02779163-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02779310-a',[ ('Region',subsumption)]).
adjMapping2SUMO('02779420-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02779530-a',[ ('',undefined)]).
adjMapping2SUMO('02779654-a',[ ('',undefined)]).
adjMapping2SUMO('02779774-a',[ ('Physics',instance)]).
adjMapping2SUMO('02779960-a',[ ('',undefined)]).
adjMapping2SUMO('02780093-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02780355-a',[ ('Region',subsumption)]).
adjMapping2SUMO('02780538-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02780680-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02780837-a',[ (equal,subsumption)]).
adjMapping2SUMO('02780975-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('02781131-a',[ ('Metal',subsumption)]).
adjMapping2SUMO('02781247-a',[ ('Government',subsumption)]).
adjMapping2SUMO('02781425-a',[ ('',undefined)]).
adjMapping2SUMO('02781531-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('02781685-a',[ ('',undefined)]).
adjMapping2SUMO('02781783-a',[ ('',undefined)]).
adjMapping2SUMO('02781885-a',[ ('',undefined)]).
adjMapping2SUMO('02782106-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02782225-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02782367-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02782525-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02782629-a',[ (capability,subsumption)]).
adjMapping2SUMO('02782715-a',[ ('PositionalAttribute',equivalence)]).
adjMapping2SUMO('02782815-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02783085-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02783250-a',[ ('Food',subsumption)]).
adjMapping2SUMO('02783329-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02783412-a',[ ('',undefined)]).
adjMapping2SUMO('02783646-a',[ ('',undefined)]).
adjMapping2SUMO('02783795-a',[ ('',undefined)]).
adjMapping2SUMO('02783917-a',[ ('',undefined)]).
adjMapping2SUMO('02784068-a',[ ('',undefined)]).
adjMapping2SUMO('02784185-a',[ ('',undefined)]).
adjMapping2SUMO('02784317-a',[ ('Perception',subsumption)]).
adjMapping2SUMO('02784558-a',[ ('',undefined)]).
adjMapping2SUMO('02784701-a',[ ('',undefined)]).
adjMapping2SUMO('02784873-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02785018-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02785130-a',[ ('',undefined)]).
adjMapping2SUMO('02785279-a',[ ('Gland',subsumption)]).
adjMapping2SUMO('02785412-a',[ ('',undefined)]).
adjMapping2SUMO('02785525-a',[ ('',undefined)]).
adjMapping2SUMO('02785647-a',[ ('',undefined)]).
adjMapping2SUMO('02785757-a',[ ('Protein',equivalence)]).
adjMapping2SUMO('02785874-a',[ ('StateOrProvince',subsumption)]).
adjMapping2SUMO('02786006-a',[ ('',undefined)]).
adjMapping2SUMO('02786103-a',[ ('',undefined)]).
adjMapping2SUMO('02786215-a',[ ('',undefined)]).
adjMapping2SUMO('02786315-a',[ ('ChemicalDecomposition',subsumption)]).
adjMapping2SUMO('02786473-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02786549-a',[ ('',undefined)]).
adjMapping2SUMO('02786744-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02786866-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02787073-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02787210-a',[ ('Damaging',subsumption)]).
adjMapping2SUMO('02787290-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02787452-a',[ ('',undefined)]).
adjMapping2SUMO('02787627-a',[ ('Weapon',subsumption)]).
adjMapping2SUMO('02787740-a',[ ('',undefined)]).
adjMapping2SUMO('02787831-a',[ ('RecreationOrExercise',subsumption)]).
adjMapping2SUMO('02788005-a',[ ('ShapeChange',subsumption)]).
adjMapping2SUMO('02788252-a',[ ('',undefined)]).
adjMapping2SUMO('02788378-a',[ ('RepublicanParty',instance)]).
adjMapping2SUMO('02788554-a',[ ('',undefined)]).
adjMapping2SUMO('02788651-a',[ ('',undefined)]).
adjMapping2SUMO('02788779-a',[ ('',undefined)]).
adjMapping2SUMO('02788916-a',[ ('',undefined)]).
adjMapping2SUMO('02789031-a',[ ('',undefined)]).
adjMapping2SUMO('02789151-a',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('02789409-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02789579-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02789798-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02789920-a',[ ('HoofedMammal',subsumption)]).
adjMapping2SUMO('02790134-a',[ ('HoofedMammal',subsumption)]).
adjMapping2SUMO('02790222-a',[ ('Agriculture',subsumption)]).
adjMapping2SUMO('02790474-a',[ ('Maintaining',subsumption)]).
adjMapping2SUMO('02790726-a',[ ('Rural',equivalence)]).
adjMapping2SUMO('02790900-a',[ ('Region',instance)]).
adjMapping2SUMO('02791058-a',[ ('',undefined)]).
adjMapping2SUMO('02791161-a',[ ('',undefined)]).
adjMapping2SUMO('02791308-a',[ ('',undefined)]).
adjMapping2SUMO('02791483-a',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02791630-a',[ ('',undefined)]).
adjMapping2SUMO('02791735-a',[ ('',undefined)]).
adjMapping2SUMO('02791838-a',[ ('',undefined)]).
adjMapping2SUMO('02791943-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02792080-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02792214-a',[ ('Muscle',subsumption)]).
adjMapping2SUMO('02792326-a',[ ('Muscle',subsumption)]).
adjMapping2SUMO('02792424-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02792550-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02792661-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02792789-a',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('02792903-a',[ ('EducationalOrganization',subsumption)]).
adjMapping2SUMO('02793094-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02793273-a',[ ('Science',equivalence)]).
adjMapping2SUMO('02793394-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02793513-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02793681-a',[ (superficialPart,subsumption)]).
adjMapping2SUMO('02793793-a',[ ('',undefined)]).
adjMapping2SUMO('02793988-a',[ ('Position',not(subsumption))]).
adjMapping2SUMO('02794123-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02794253-a',[ ('',undefined)]).
adjMapping2SUMO('02794372-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02794543-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02794670-a',[ ('CaseRole',subsumption)]).
adjMapping2SUMO('02794853-a',[ ('',undefined)]).
adjMapping2SUMO('02795013-a',[ ('',undefined)]).
adjMapping2SUMO('02795109-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02795262-a',[ ('',undefined)]).
adjMapping2SUMO('02795399-a',[ ('',undefined)]).
adjMapping2SUMO('02795489-a',[ ('',undefined)]).
adjMapping2SUMO('02795640-a',[ ('',undefined)]).
adjMapping2SUMO('02795804-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02795925-a',[ (result,subsumption)]).
adjMapping2SUMO('02796042-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02796194-a',[ ('',undefined)]).
adjMapping2SUMO('02796301-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02796425-a',[ ('Perception',equivalence)]).
adjMapping2SUMO('02796588-a',[ ('',undefined)]).
adjMapping2SUMO('02796711-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02796854-a',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('02797021-a',[ ('List',subsumption)]).
adjMapping2SUMO('02797257-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02797408-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('02797550-a',[ ('',undefined)]).
adjMapping2SUMO('02797704-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02797907-a',[ ('',undefined)]).
adjMapping2SUMO('02798014-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('02798167-a',[ ('',undefined)]).
adjMapping2SUMO('02798267-a',[ ('',undefined)]).
adjMapping2SUMO('02798370-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02798597-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02798806-a',[ ('',undefined)]).
adjMapping2SUMO('02798901-a',[ ('',undefined)]).
adjMapping2SUMO('02799016-a',[ ('Sol',subsumption)]).
adjMapping2SUMO('02799173-a',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('02799301-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02799446-a',[ ('',undefined)]).
adjMapping2SUMO('02799595-a',[ ('Perception',subsumption)]).
adjMapping2SUMO('02799689-a',[ ('',undefined)]).
adjMapping2SUMO('02799797-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02799877-a',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('02799988-a',[ ('',undefined)]).
adjMapping2SUMO('02800132-a',[ ('Collection',subsumption)]).
adjMapping2SUMO('02800291-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('02800427-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02800529-a',[ ('Microorganism',subsumption)]).
adjMapping2SUMO('02800689-a',[ ('Sphere',subsumption)]).
adjMapping2SUMO('02800851-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02800941-a',[ ('',undefined)]).
adjMapping2SUMO('02801037-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02801156-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('02801349-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02801641-a',[ ('',undefined)]).
adjMapping2SUMO('02801749-a',[ ('Sport',equivalence)]).
adjMapping2SUMO('02801839-a',[ ('Sport',equivalence)]).
adjMapping2SUMO('02801964-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('02802092-a',[ ('',undefined)]).
adjMapping2SUMO('02802220-a',[ ('',undefined)]).
adjMapping2SUMO('02802341-a',[ (capability,subsumption)]).
adjMapping2SUMO('02802476-a',[ ('',undefined)]).
adjMapping2SUMO('02802576-a',[ ('',undefined)]).
adjMapping2SUMO('02802694-a',[ ('Bacterium',subsumption)]).
adjMapping2SUMO('02802848-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02802976-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('02803150-a',[ ('OuterSpaceRegion',subsumption)]).
adjMapping2SUMO('02803299-a',[ ('',undefined)]).
adjMapping2SUMO('02803389-a',[ ('Procedure',subsumption)]).
adjMapping2SUMO('02803579-a',[ ('Hormone',subsumption)]).
adjMapping2SUMO('02803740-a',[ ('Hormone',not(subsumption))]).
adjMapping2SUMO('02803876-a',[ ('',undefined)]).
adjMapping2SUMO('02803986-a',[ ('',undefined)]).
adjMapping2SUMO('02804139-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02804254-a',[ ('',undefined)]).
adjMapping2SUMO('02804391-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02804515-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02804590-a',[ ('Suburban',equivalence)]).
adjMapping2SUMO('02804777-a',[ ('',undefined)]).
adjMapping2SUMO('02804905-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('02805039-a',[ ('',undefined)]).
adjMapping2SUMO('02805148-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02805331-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('02805490-a',[ (superficialPart,subsumption)]).
adjMapping2SUMO('02805735-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02805872-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02805966-a',[ ('',undefined)]).
adjMapping2SUMO('02806098-a',[ ('Adjacent',subsumption)]).
adjMapping2SUMO('02806261-a',[ (capability,subsumption)]).
adjMapping2SUMO('02806435-a',[ (capability,subsumption)]).
adjMapping2SUMO('02806565-a',[ ('Character',subsumption)]).
adjMapping2SUMO('02806721-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02806907-a',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('02807163-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02807249-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02807478-a',[ ('',undefined)]).
adjMapping2SUMO('02807775-a',[ ('',undefined)]).
adjMapping2SUMO('02808126-a',[ ('Perception',subsumption)]).
adjMapping2SUMO('02808380-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02808548-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02808653-a',[ ('',undefined)]).
adjMapping2SUMO('02808830-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02809010-a',[ ('Island',instance)]).
adjMapping2SUMO('02809128-a',[ ('',undefined)]).
adjMapping2SUMO('02809220-a',[ ('SubjectiveStrongPositiveAttribute',subsumption)]).
adjMapping2SUMO('02809492-a',[ ('',undefined)]).
adjMapping2SUMO('02809592-a',[ ('',undefined)]).
adjMapping2SUMO('02809692-a',[ ('Engineering',subsumption)]).
adjMapping2SUMO('02809958-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02810102-a',[ (inhabits,subsumption)]).
adjMapping2SUMO('02810316-a',[ (located,subsumption)]).
adjMapping2SUMO('02810417-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('02810552-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02810739-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02810882-a',[ ('TimeMeasure',subsumption)]).
adjMapping2SUMO('02811081-a',[ ('Physical',subsumption)]).
adjMapping2SUMO('02811265-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02811428-a',[ ('',undefined)]).
adjMapping2SUMO('02811547-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02811660-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02811774-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02811908-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02811980-a',[ ('',undefined)]).
adjMapping2SUMO('02812147-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('02812306-a',[ (located,subsumption)]).
adjMapping2SUMO('02812482-a',[ ('GeopoliticalArea',subsumption)]).
adjMapping2SUMO('02812697-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02812838-a',[ ('Certificate',subsumption)]).
adjMapping2SUMO('02812989-a',[ ('Stating',subsumption)]).
adjMapping2SUMO('02813162-a',[ ('Expressing',subsumption)]).
adjMapping2SUMO('02813315-a',[ (realization,subsumption)]).
adjMapping2SUMO('02813437-a',[ ('',undefined)]).
adjMapping2SUMO('02813557-a',[ ('',undefined)]).
adjMapping2SUMO('02813680-a',[ (refers,subsumption)]).
adjMapping2SUMO('02813819-a',[ (refers,subsumption)]).
adjMapping2SUMO('02813978-a',[ (refers,subsumption)]).
adjMapping2SUMO('02814104-a',[ ('',undefined)]).
adjMapping2SUMO('02814352-a',[ ('',undefined)]).
adjMapping2SUMO('02814453-a',[ ('Heating',equivalence)]).
adjMapping2SUMO('02814758-a',[ ('Heating',not(subsumption))]).
adjMapping2SUMO('02814878-a',[ ('Heating',subsumption)]).
adjMapping2SUMO('02815039-a',[ ('',undefined)]).
adjMapping2SUMO('02815135-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('02815241-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02815361-a',[ ('',undefined)]).
adjMapping2SUMO('02815459-a',[ ('',undefined)]).
adjMapping2SUMO('02815635-a',[ ('',undefined)]).
adjMapping2SUMO('02815753-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02815843-a',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('02815998-a',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('02816198-a',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('02816340-a',[ (holdsRight,subsumption)]).
adjMapping2SUMO('02816522-a',[ ('',undefined)]).
adjMapping2SUMO('02816663-a',[ ('TonalLanguage',subsumption)]).
adjMapping2SUMO('02816888-a',[ ('PhysiologicProcess',subsumption)]).
adjMapping2SUMO('02817113-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02817339-a',[ ('List',subsumption)]).
adjMapping2SUMO('02817533-a',[ ('',undefined)]).
adjMapping2SUMO('02817647-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02817796-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02817999-a',[ ('',undefined)]).
adjMapping2SUMO('02818111-a',[ ('Government',subsumption)]).
adjMapping2SUMO('02818402-a',[ ('',undefined)]).
adjMapping2SUMO('02818600-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02818751-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02818958-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02819139-a',[ ('',undefined)]).
adjMapping2SUMO('02819219-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02819346-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('02819475-a',[ ('',undefined)]).
adjMapping2SUMO('02819582-a',[ ('',undefined)]).
adjMapping2SUMO('02819734-a',[ ('',undefined)]).
adjMapping2SUMO('02819848-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('02819988-a',[ ('Character',subsumption)]).
adjMapping2SUMO('02820153-a',[ ('',undefined)]).
adjMapping2SUMO('02820395-a',[ ('OrganicObject',subsumption)]).
adjMapping2SUMO('02820490-a',[ ('',undefined)]).
adjMapping2SUMO('02820598-a',[ ('UnitOfMeasure',subsumption)]).
adjMapping2SUMO('02820808-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02820991-a',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('02821071-a',[ ('Urban',equivalence)]).
adjMapping2SUMO('02821243-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02821373-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02821475-a',[ ('',undefined)]).
adjMapping2SUMO('02821586-a',[ ('',undefined)]).
adjMapping2SUMO('02821723-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02821875-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02822055-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02822229-a',[ ('Expressing',subsumption)]).
adjMapping2SUMO('02822472-a',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('02822601-a',[ ('',undefined)]).
adjMapping2SUMO('02822746-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02822929-a',[ ('MusicalInstrument',subsumption)]).
adjMapping2SUMO('02823018-a',[ ('',undefined)]).
adjMapping2SUMO('02823131-a',[ ('',undefined)]).
adjMapping2SUMO('02823266-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02823423-a',[ (capability,subsumption)]).
adjMapping2SUMO('02823559-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02823724-a',[ ('Verb',equivalence)]).
adjMapping2SUMO('02823920-a',[ ('Word',equivalence)]).
adjMapping2SUMO('02824040-a',[ ('Vertical',equivalence)]).
adjMapping2SUMO('02824194-a',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('02824444-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02824585-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02824740-a',[ ('',undefined)]).
adjMapping2SUMO('02824825-a',[ ('PositiveInteger',instance)]).
adjMapping2SUMO('02824922-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('02825060-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02825213-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02825355-a',[ (capability,subsumption)]).
adjMapping2SUMO('02825533-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02825770-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02825985-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02826169-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02826443-a',[ (believes,subsumption)]).
adjMapping2SUMO('02826701-a',[ ('RadiatingElectromagnetic',equivalence)]).
adjMapping2SUMO('02826877-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02827160-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02827413-a',[ (capability,subsumption)]).
adjMapping2SUMO('02827571-a',[ (capability,subsumption)]).
adjMapping2SUMO('02827662-a',[ (capability,subsumption)]).
adjMapping2SUMO('02827790-a',[ (capability,subsumption)]).
adjMapping2SUMO('02827950-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02828123-a',[ ('FunctionQuantity',subsumption)]).
adjMapping2SUMO('02828310-a',[ ('FunctionQuantity',subsumption)]).
adjMapping2SUMO('02828482-a',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('02828564-a',[ ('Region',subsumption)]).
adjMapping2SUMO('02828688-a',[ ('PhysicalState',subsumption)]).
adjMapping2SUMO('02828802-a',[ ('',undefined)]).
adjMapping2SUMO('02828917-a',[ (equal,subsumption)]).
adjMapping2SUMO('02829094-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02829238-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02829422-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02829565-a',[ ('Government',subsumption)]).
adjMapping2SUMO('02829711-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02829826-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02830010-a',[ ('',undefined)]).
adjMapping2SUMO('02830223-a',[ ('',undefined)]).
adjMapping2SUMO('02830345-a',[ ('LengthMeasure',subsumption)]).
adjMapping2SUMO('02830501-a',[ ('FictionalText',equivalence)]).
adjMapping2SUMO('02830645-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02830849-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02830954-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('02831031-a',[ ('Gland',subsumption)]).
adjMapping2SUMO('02831143-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('02831272-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02831364-a',[ ('',undefined)]).
adjMapping2SUMO('02831478-a',[ ('',undefined)]).
adjMapping2SUMO('02831596-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02831736-a',[ ('Region',subsumption)]).
adjMapping2SUMO('02831979-a',[ ('Amphibian',equivalence)]).
adjMapping2SUMO('02832164-a',[ ('Insect',equivalence)]).
adjMapping2SUMO('02832272-a',[ ('Mammal',equivalence)]).
adjMapping2SUMO('02832382-a',[ ('Fish',equivalence)]).
adjMapping2SUMO('02832458-a',[ ('Reptile',equivalence)]).
adjMapping2SUMO('02832586-a',[ ('Alga',equivalence)]).
adjMapping2SUMO('02832678-a',[ ('Fungus',equivalence)]).
adjMapping2SUMO('02832818-a',[ (capability,subsumption)]).
adjMapping2SUMO('02832969-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02833070-a',[ ('',undefined)]).
adjMapping2SUMO('02833235-a',[ ('Plant',equivalence)]).
adjMapping2SUMO('02833331-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02833544-a',[ ('Bacterium',equivalence)]).
adjMapping2SUMO('02833692-a',[ ('',undefined)]).
adjMapping2SUMO('02833873-a',[ (capability,subsumption)]).
adjMapping2SUMO('02833979-a',[ ('Bacterium',subsumption)]).
adjMapping2SUMO('02834164-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02834246-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02834340-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02834480-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02834603-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02834730-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02834862-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02834992-a',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('02835145-a',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('02835329-a',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('02835481-a',[ ('PoliticalProcess',subsumption)]).
adjMapping2SUMO('02835654-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('02835887-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02836161-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02836314-a',[ ('Bird',subsumption)]).
adjMapping2SUMO('02836479-a',[ ('Morpheme',subsumption)]).
adjMapping2SUMO('02836626-a',[ ('RadiatingLight',equivalence)]).
adjMapping2SUMO('02836757-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02836910-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02837047-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('02837145-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02837278-a',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('02837404-a',[ ('Separating',subsumption)]).
adjMapping2SUMO('02837489-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('02837588-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('02837700-a',[ ('HoofedMammal',subsumption)]).
adjMapping2SUMO('02837794-a',[ ('AnatomicalStructure',subsumption)]).
adjMapping2SUMO('02837910-a',[ ('Corporation',subsumption)]).
adjMapping2SUMO('02838005-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02838220-a',[ ('',undefined)]).
adjMapping2SUMO('02838374-a',[ ('',undefined)]).
adjMapping2SUMO('02838470-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02838592-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02838805-a',[ ('RadiatingLight',subsumption)]).
adjMapping2SUMO('02838894-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02839036-a',[ ('',undefined)]).
adjMapping2SUMO('02839179-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02839357-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02839505-a',[ ('Profession',subsumption)]).
adjMapping2SUMO('02839695-a',[ ('Profession',equivalence)]).
adjMapping2SUMO('02839865-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02840006-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02840203-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02840328-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02840478-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02840711-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02840840-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02840935-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02841066-a',[ ('SpatialRelation',equivalence)]).
adjMapping2SUMO('02841422-a',[ ('SpatialRelation',not(subsumption))]).
adjMapping2SUMO('02841534-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02841678-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02841776-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02841919-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02842042-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02842185-a',[ ('HoofedMammal',subsumption)]).
adjMapping2SUMO('02842320-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('02842445-a',[ ('LinguisticExpression',equivalence)]).
adjMapping2SUMO('02842704-a',[ ('LinguisticExpression',not(subsumption))]).
adjMapping2SUMO('02842862-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02842981-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02843095-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02843218-a',[ ('Linguistics',instance)]).
adjMapping2SUMO('02843382-a',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('02843495-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02843717-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('02843816-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02843959-a',[ ('GeographicArea',instance)]).
adjMapping2SUMO('02844174-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02844273-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('02844419-a',[ ('',undefined)]).
adjMapping2SUMO('02844578-a',[ ('Unconscious',subsumption)]).
adjMapping2SUMO('02844728-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02845048-a',[ ('Building',subsumption)]).
adjMapping2SUMO('02845158-a',[ ('Bird',subsumption)]).
adjMapping2SUMO('02845244-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02845379-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02845585-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02845704-a',[ ('',undefined)]).
adjMapping2SUMO('02845871-a',[ (believes,subsumption)]).
adjMapping2SUMO('02845996-a',[ ('',undefined)]).
adjMapping2SUMO('02846168-a',[ ('Fish',subsumption)]).
adjMapping2SUMO('02846322-a',[ ('Food',subsumption)]).
adjMapping2SUMO('02846630-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02846743-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('02846927-a',[ ('Sunday',equivalence)]).
adjMapping2SUMO('02847025-a',[ (believes,subsumption)]).
adjMapping2SUMO('02847126-a',[ ('',undefined)]).
adjMapping2SUMO('02847207-a',[ ('',undefined)]).
adjMapping2SUMO('02847370-a',[ ('Building',subsumption)]).
adjMapping2SUMO('02847473-a',[ ('',undefined)]).
adjMapping2SUMO('02847619-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('02847786-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02847894-a',[ ('FinancialTransaction',equivalence)]).
adjMapping2SUMO('02848119-a',[ ('FinancialTransaction',not(subsumption))]).
adjMapping2SUMO('02848227-a',[ ('',undefined)]).
adjMapping2SUMO('02848388-a',[ ('Contract',subsumption)]).
adjMapping2SUMO('02848658-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02848787-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02848948-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02849098-a',[ ('Collection',subsumption)]).
adjMapping2SUMO('02849257-a',[ ('Region',subsumption)]).
adjMapping2SUMO('02849367-a',[ ('Region',subsumption)]).
adjMapping2SUMO('02849475-a',[ ('CognitiveAgent',subsumption)]).
adjMapping2SUMO('02849594-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02849732-a',[ ('',undefined)]).
adjMapping2SUMO('02849904-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02850047-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02850132-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02850309-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02850483-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02850701-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('02850826-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02851001-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02851122-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02851296-a',[ ('ChemicalProcess',subsumption)]).
adjMapping2SUMO('02851451-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02851550-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02851709-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02851944-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02852052-a',[ ('',undefined)]).
adjMapping2SUMO('02852128-a',[ ('',undefined)]).
adjMapping2SUMO('02852265-a',[ ('Heating',subsumption)]).
adjMapping2SUMO('02852589-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02852679-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('02852756-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02852920-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('02853146-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02853254-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('02853434-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02853534-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02853663-a',[ ('AquaticMammal',subsumption)]).
adjMapping2SUMO('02853740-a',[ ('Reptile',subsumption)]).
adjMapping2SUMO('02853905-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02854013-a',[ ('Beverage',subsumption)]).
adjMapping2SUMO('02854154-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02854257-a',[ ('PositiveInteger',instance)]).
adjMapping2SUMO('02854350-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02854521-a',[ ('ChristianBible',subsumption)]).
adjMapping2SUMO('02854747-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02854968-a',[ ('',undefined)]).
adjMapping2SUMO('02855055-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02855185-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02855503-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02855757-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02855970-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02856124-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02856286-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02856460-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02856584-a',[ ('',undefined)]).
adjMapping2SUMO('02856654-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02856851-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02856972-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02857099-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02857295-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('02857407-a',[ ('PoliticalProcess',equivalence)]).
adjMapping2SUMO('02857587-a',[ ('PoliticalProcess',subsumption)]).
adjMapping2SUMO('02857726-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02857893-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02858086-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02858231-a',[ ('Philosophy',instance)]).
adjMapping2SUMO('02858539-a',[ ('Human',instance)]).
adjMapping2SUMO('02858707-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02858816-a',[ ('TraitAttribute',subsumption)]).
adjMapping2SUMO('02858941-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02859053-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02859221-a',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('02859341-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02859500-a',[ ('Human',subsumption)]).
adjMapping2SUMO('02859708-a',[ ('Process',subsumption)]).
adjMapping2SUMO('02859817-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02859974-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('02860183-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('02860389-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02860564-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02860719-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02860919-a',[ ('Birth',equivalence)]).
adjMapping2SUMO('02861072-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02861206-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02861402-a',[ ('Building',subsumption)]).
adjMapping2SUMO('02861483-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02861617-a',[ ('Icon',subsumption)]).
adjMapping2SUMO('02861859-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02861997-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02862251-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02862444-a',[ ('Region',subsumption)]).
adjMapping2SUMO('02862629-a',[ ('Region',subsumption)]).
adjMapping2SUMO('02862797-a',[ ('',undefined)]).
adjMapping2SUMO('02862964-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02863111-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02863247-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02863464-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02863724-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('02863959-a',[ ('',undefined)]).
adjMapping2SUMO('02864068-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02864165-a',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('02864400-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02864551-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02864699-a',[ ('PositiveInteger',instance)]).
adjMapping2SUMO('02864824-a',[ ('TimeDuration',subsumption)]).
adjMapping2SUMO('02865018-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02865172-a',[ ('City',equivalence)]).
adjMapping2SUMO('02865315-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('02865479-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02865814-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02865963-a',[ ('',undefined)]).
adjMapping2SUMO('02866183-a',[ ('TimePosition',subsumption)]).
adjMapping2SUMO('02866278-a',[ ('Metal',subsumption)]).
adjMapping2SUMO('02866448-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02866674-a',[ ('AstronomicalBody',instance)]).
adjMapping2SUMO('02866825-a',[ ('',undefined)]).
adjMapping2SUMO('02866976-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02867141-a',[ ('',undefined)]).
adjMapping2SUMO('02867242-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02867419-a',[ ('',undefined)]).
adjMapping2SUMO('02867505-a',[ ('',undefined)]).
adjMapping2SUMO('02867611-a',[ ('',undefined)]).
adjMapping2SUMO('02867783-a',[ ('Music',equivalence)]).
adjMapping2SUMO('02867945-a',[ ('',undefined)]).
adjMapping2SUMO('02868051-a',[ ('Perception',subsumption)]).
adjMapping2SUMO('02868142-a',[ ('Perception',subsumption)]).
adjMapping2SUMO('02868235-a',[ ('Perception',subsumption)]).
adjMapping2SUMO('02868326-a',[ ('Perception',subsumption)]).
adjMapping2SUMO('02868489-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02868704-a',[ ('Hearing',equivalence)]).
adjMapping2SUMO('02868916-a',[ ('Tasting',equivalence)]).
adjMapping2SUMO('02869097-a',[ ('TactilePerception',equivalence)]).
adjMapping2SUMO('02869368-a',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('02869437-a',[ ('Number',subsumption)]).
adjMapping2SUMO('02869563-a',[ ('Seeing',equivalence)]).
adjMapping2SUMO('02869823-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02870178-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02870315-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02870453-a',[ ('TactilePerception',subsumption)]).
adjMapping2SUMO('02870663-a',[ ('CognitiveAgent',subsumption)]).
adjMapping2SUMO('02870846-a',[ ('CognitiveAgent',subsumption)]).
adjMapping2SUMO('02871060-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('02871229-a',[ ('Region',subsumption)]).
adjMapping2SUMO('02871347-a',[ ('Region',subsumption)]).
adjMapping2SUMO('02871449-a',[ ('GeopoliticalArea',subsumption)]).
adjMapping2SUMO('02871575-a',[ ('GeopoliticalArea',subsumption)]).
adjMapping2SUMO('02871695-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02871858-a',[ (located,subsumption)]).
adjMapping2SUMO('02871957-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02872066-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02872265-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02872362-a',[ ('Maintaining',subsumption)]).
adjMapping2SUMO('02872501-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02872654-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02872776-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02872908-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('02873042-a',[ (forall,subsumption)]).
adjMapping2SUMO('02873213-a',[ ('',undefined)]).
adjMapping2SUMO('02873359-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02873557-a',[ ('',undefined)]).
adjMapping2SUMO('02873654-a',[ (realization,subsumption)]).
adjMapping2SUMO('02873811-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02874053-a',[ ('BodyVessel',not(subsumption))]).
adjMapping2SUMO('02874130-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02874282-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02874543-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02874700-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02874876-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02875104-a',[ ('',undefined)]).
adjMapping2SUMO('02875282-a',[ (believes,subsumption)]).
adjMapping2SUMO('02875374-a',[ (believes,subsumption)]).
adjMapping2SUMO('02875499-a',[ ('PoliticalOrganization',instance)]).
adjMapping2SUMO('02875707-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02875930-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02876088-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02876360-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02876514-a',[ ('Covering',subsumption)]).
adjMapping2SUMO('02876601-a',[ (capability,subsumption)]).
adjMapping2SUMO('02876745-a',[ ('',undefined)]).
adjMapping2SUMO('02876829-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02876936-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02877131-a',[ ('',undefined)]).
adjMapping2SUMO('02877313-a',[ ('Decreasing',subsumption)]).
adjMapping2SUMO('02877503-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02877704-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02877910-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02878045-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02878147-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02878252-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02878368-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02878580-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02878680-a',[ ('Region',subsumption)]).
adjMapping2SUMO('02878902-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('02879044-a',[ ('',undefined)]).
adjMapping2SUMO('02879152-a',[ (capability,subsumption)]).
adjMapping2SUMO('02879273-a',[ (capability,subsumption)]).
adjMapping2SUMO('02879424-a',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('02879535-a',[ ('LinguisticExpression',not(subsumption))]).
adjMapping2SUMO('02879638-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02879947-a',[ ('GeographicArea',instance)]).
adjMapping2SUMO('02880076-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02880201-a',[ ('Virus',equivalence)]).
adjMapping2SUMO('02880322-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02880557-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02880808-a',[ ('',undefined)]).
adjMapping2SUMO('02880924-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('02881057-a',[ ('Linguistics',instance)]).
adjMapping2SUMO('02881246-a',[ ('Procedure',subsumption)]).
adjMapping2SUMO('02881438-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02881567-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02881711-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('02881888-a',[ ('Feline',equivalence)]).
adjMapping2SUMO('02881995-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02882135-a',[ ('',undefined)]).
adjMapping2SUMO('02882275-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02882373-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('02882467-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('02882570-a',[ ('Muscle',equivalence)]).
adjMapping2SUMO('02882726-a',[ ('',undefined)]).
adjMapping2SUMO('02882838-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02882943-a',[ ('',undefined)]).
adjMapping2SUMO('02883112-a',[ ('',undefined)]).
adjMapping2SUMO('02883210-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02883344-a',[ ('',undefined)]).
adjMapping2SUMO('02883459-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02883599-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('02883710-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02883805-a',[ ('',undefined)]).
adjMapping2SUMO('02883914-a',[ ('',undefined)]).
adjMapping2SUMO('02884085-a',[ (parent,equivalence)]).
adjMapping2SUMO('02884275-a',[ (familyRelation,subsumption)]).
adjMapping2SUMO('02884456-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('02884619-a',[ ('Atom',equivalence)]).
adjMapping2SUMO('02884766-a',[ ('',undefined)]).
adjMapping2SUMO('02884949-a',[ ('Molecule',subsumption)]).
adjMapping2SUMO('02885076-a',[ ('',undefined)]).
adjMapping2SUMO('02885192-a',[ ('SubatomicParticle',equivalence)]).
adjMapping2SUMO('02885370-a',[ ('',undefined)]).
adjMapping2SUMO('02885529-a',[ ('MedicalClinic',equivalence)]).
adjMapping2SUMO('02885790-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02885934-a',[ ('Organization',subsumption)]).
adjMapping2SUMO('02886090-a',[ ('Continent',equivalence)]).
adjMapping2SUMO('02886263-a',[ ('Europe',instance)]).
adjMapping2SUMO('02886406-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('02886629-a',[ ('Word',equivalence)]).
adjMapping2SUMO('02886767-a',[ ('Word',not(subsumption))]).
adjMapping2SUMO('02886869-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02886971-a',[ (believes,subsumption)]).
adjMapping2SUMO('02887115-a',[ ('',undefined)]).
adjMapping2SUMO('02887266-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02887399-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('02887578-a',[ ('SexualReproduction',equivalence)]).
adjMapping2SUMO('02887741-a',[ ('SexualReproduction',subsumption)]).
adjMapping2SUMO('02887899-a',[ ('WaterArea',subsumption)]).
adjMapping2SUMO('02888000-a',[ ('Government',subsumption)]).
adjMapping2SUMO('02888198-a',[ ('',undefined)]).
adjMapping2SUMO('02888295-a',[ ('',undefined)]).
adjMapping2SUMO('02888531-a',[ ('',undefined)]).
adjMapping2SUMO('02888659-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('02888757-a',[ ('WaterArea',subsumption)]).
adjMapping2SUMO('02888968-a',[ ('TherapeuticProcess',subsumption)]).
adjMapping2SUMO('02889157-a',[ ('TherapeuticProcess',not(subsumption))]).
adjMapping2SUMO('02889271-a',[ ('',undefined)]).
adjMapping2SUMO('02889406-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02889516-a',[ ('',undefined)]).
adjMapping2SUMO('02889619-a',[ ('TherapeuticProcess',subsumption)]).
adjMapping2SUMO('02889746-a',[ ('Transportation',subsumption)]).
adjMapping2SUMO('02889978-a',[ ('WaterArea',subsumption)]).
adjMapping2SUMO('02890216-a',[ ('WaterArea',subsumption)]).
adjMapping2SUMO('02890492-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02890613-a',[ ('Carnivore',subsumption)]).
adjMapping2SUMO('02890703-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02890874-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('02890983-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02891236-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02891444-a',[ ('Animal',equivalence)]).
adjMapping2SUMO('02891564-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02891733-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02891869-a',[ ('Microorganism',subsumption)]).
adjMapping2SUMO('02892033-a',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('02892164-a',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('02892277-a',[ ('Microorganism',subsumption)]).
adjMapping2SUMO('02892389-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02892656-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02892819-a',[ ('Embryonic',subsumption)]).
adjMapping2SUMO('02892980-a',[ ('NonFullyFormed',subsumption)]).
adjMapping2SUMO('02893195-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02893338-a',[ (holdsRight,subsumption)]).
adjMapping2SUMO('02893637-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02893827-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02893994-a',[ ('Gland',subsumption)]).
adjMapping2SUMO('02894119-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02894327-a',[ ('Perception',subsumption)]).
adjMapping2SUMO('02894436-a',[ (capability,subsumption)]).
adjMapping2SUMO('02894591-a',[ ('Position',equivalence)]).
adjMapping2SUMO('02894741-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02894878-a',[ ('Region',subsumption)]).
adjMapping2SUMO('02895044-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02895268-a',[ ('Organization',subsumption)]).
adjMapping2SUMO('02895418-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02895565-a',[ ('',undefined)]).
adjMapping2SUMO('02895668-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02895861-a',[ ('',undefined)]).
adjMapping2SUMO('02896017-a',[ (hasPurpose,subsumption)]).
adjMapping2SUMO('02896222-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('02896383-a',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('02896497-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02896692-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02896789-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02897040-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02897158-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02897335-a',[ ('PoliticalProcess',subsumption)]).
adjMapping2SUMO('02897524-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02897730-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02897957-a',[ ('Architecture',instance)]).
adjMapping2SUMO('02898121-a',[ ('Making',subsumption)]).
adjMapping2SUMO('02898276-a',[ ('Organization',equivalence)]).
adjMapping2SUMO('02898433-a',[ ('IntentionalPsychologicalProcess',subsumption)]).
adjMapping2SUMO('02898584-a',[ ('IntentionalPsychologicalProcess',subsumption)]).
adjMapping2SUMO('02898750-a',[ ('PsychologicalProcess',equivalence)]).
adjMapping2SUMO('02898922-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02899112-a',[ ('True',subsumption)]).
adjMapping2SUMO('02899271-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02899383-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02899486-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02899666-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02899912-a',[ (believes,subsumption)]).
adjMapping2SUMO('02900081-a',[ ('Mole',equivalence)]).
adjMapping2SUMO('02900219-a',[ ('Solution',subsumption)]).
adjMapping2SUMO('02900381-a',[ ('Solution',subsumption)]).
adjMapping2SUMO('02900545-a',[ ('',undefined)]).
adjMapping2SUMO('02900700-a',[ ('Molecule',equivalence)]).
adjMapping2SUMO('02900932-a',[ ('Molecule',subsumption)]).
adjMapping2SUMO('02901028-a',[ ('',undefined)]).
adjMapping2SUMO('02901178-a',[ ('Molecule',subsumption)]).
adjMapping2SUMO('02901331-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02901491-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02901649-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02901806-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02902068-a',[ ('EngineeringComponent',subsumption)]).
adjMapping2SUMO('02902214-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02902361-a',[ ('Molecule',subsumption)]).
adjMapping2SUMO('02902531-a',[ ('Atom',subsumption)]).
adjMapping2SUMO('02902658-a',[ ('',undefined)]).
adjMapping2SUMO('02902744-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02902883-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('02902976-a',[ ('',undefined)]).
adjMapping2SUMO('02903062-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02903177-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02903281-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02903352-a',[ ('',undefined)]).
adjMapping2SUMO('02903477-a',[ ('',undefined)]).
adjMapping2SUMO('02903593-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02903793-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02903946-a',[ ('Mixture',subsumption)]).
adjMapping2SUMO('02904075-a',[ ('Managing',equivalence)]).
adjMapping2SUMO('02904223-a',[ ('Managing',equivalence)]).
adjMapping2SUMO('02904372-a',[ ('Managing',subsumption)]).
adjMapping2SUMO('02904518-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02904691-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02904780-a',[ ('LengthMeasure',subsumption)]).
adjMapping2SUMO('02904916-a',[ ('City',instance)]).
adjMapping2SUMO('02905050-a',[ ('Substance',subsumption)]).
adjMapping2SUMO('02905151-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02905356-a',[ ('Molecule',subsumption)]).
adjMapping2SUMO('02905485-a',[ ('Metal',subsumption)]).
adjMapping2SUMO('02905591-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02905794-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02905943-a',[ ('',undefined)]).
adjMapping2SUMO('02906059-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('02906206-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02906351-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02906478-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02906778-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02907000-a',[ ('Theology',equivalence)]).
adjMapping2SUMO('02907175-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02907330-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02907473-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02907656-a',[ ('Sport',subsumption)]).
adjMapping2SUMO('02907798-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02907935-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02908041-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02908235-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02908366-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02908525-a',[ ('Digesting',subsumption)]).
adjMapping2SUMO('02908647-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02908768-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02908887-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02909006-a',[ ('Guiding',subsumption)]).
adjMapping2SUMO('02909168-a',[ ('Number',subsumption)]).
adjMapping2SUMO('02909336-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02909517-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02909651-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02909808-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02909952-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02910074-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02910248-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02910506-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02910644-a',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('02910789-a',[ ('Directing',subsumption)]).
adjMapping2SUMO('02911008-a',[ ('Predicting',subsumption)]).
adjMapping2SUMO('02911112-a',[ ('',undefined)]).
adjMapping2SUMO('02911243-a',[ ('Predicting',subsumption)]).
adjMapping2SUMO('02911346-a',[ ('Procedure',subsumption)]).
adjMapping2SUMO('02911488-a',[ ('Procedure',subsumption)]).
adjMapping2SUMO('02911627-a',[ ('Procedure',subsumption)]).
adjMapping2SUMO('02911757-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02911876-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02912054-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02912250-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02912383-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02912518-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02912686-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02912848-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02913004-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02913243-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02913428-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02913737-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02913870-a',[ ('',undefined)]).
adjMapping2SUMO('02914038-a',[ ('TherapeuticProcess',subsumption)]).
adjMapping2SUMO('02914213-a',[ ('TherapeuticProcess',equivalence)]).
adjMapping2SUMO('02914414-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02914599-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02914740-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02914902-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02915055-a',[ ('Gland',subsumption)]).
adjMapping2SUMO('02915271-a',[ ('',undefined)]).
adjMapping2SUMO('02915381-a',[ ('Gland',subsumption)]).
adjMapping2SUMO('02915507-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02915666-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02915815-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02916006-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02916230-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02916403-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02916539-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02916730-a',[ (age,subsumption)]).
adjMapping2SUMO('02916852-a',[ ('',undefined)]).
adjMapping2SUMO('02916969-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02917221-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02917327-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('02917470-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02917694-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02917893-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02918132-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('02918271-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('02918490-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('02918615-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02918724-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02918844-a',[ ('Microscope',subsumption)]).
adjMapping2SUMO('02919100-a',[ ('PoliticalProcess',subsumption)]).
adjMapping2SUMO('02919275-a',[ ('Planning',subsumption)]).
adjMapping2SUMO('02919594-a',[ (inhabits,subsumption)]).
adjMapping2SUMO('02919733-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02919863-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02919986-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02920121-a',[ ('History',equivalence)]).
adjMapping2SUMO('02920321-a',[ ('',undefined)]).
adjMapping2SUMO('02920464-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02920594-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02920769-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02920951-a',[ ('RomanCatholicChurch',equivalence)]).
adjMapping2SUMO('02921108-a',[ ('ReligiousOrganization',instance)]).
adjMapping2SUMO('02921199-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('02921325-a',[ ('City',instance)]).
adjMapping2SUMO('02921569-a',[ ('City',instance)]).
adjMapping2SUMO('02921753-a',[ ('ReligiousOrganization',instance)]).
adjMapping2SUMO('02922086-a',[ ('',undefined)]).
adjMapping2SUMO('02922263-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('02922448-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('02922690-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('02922814-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02923005-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02923281-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02923510-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02923745-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02923981-a',[ ('',undefined)]).
adjMapping2SUMO('02924102-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02924286-a',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('02924428-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('02924600-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02924739-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02924932-a',[ ('ReligiousOrganization',instance)]).
adjMapping2SUMO('02925084-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02925195-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02925342-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02925492-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02925655-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02925879-a',[ ('Text',equivalence)]).
adjMapping2SUMO('02926025-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02926188-a',[ ('Magnetism',subsumption)]).
adjMapping2SUMO('02926320-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02926519-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02926708-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02926858-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02926936-a',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('02927048-a',[ ('Maintaining',subsumption)]).
adjMapping2SUMO('02927169-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02927303-a',[ ('LandArea',instance)]).
adjMapping2SUMO('02927512-a',[ ('UnitedStates',equivalence)]).
adjMapping2SUMO('02927803-a',[ ('',undefined)]).
adjMapping2SUMO('02927944-a',[ ('',undefined)]).
adjMapping2SUMO('02928066-a',[ ('EthnicGroup',subsumption)]).
adjMapping2SUMO('02928347-a',[ ('LandArea',instance)]).
adjMapping2SUMO('02928566-a',[ ('LandArea',instance)]).
adjMapping2SUMO('02928728-a',[ ('LandArea',instance)]).
adjMapping2SUMO('02928926-a',[ ('',undefined)]).
adjMapping2SUMO('02929071-a',[ ('Function',subsumption)]).
adjMapping2SUMO('02929216-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02929500-a',[ ('',undefined)]).
adjMapping2SUMO('02929637-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02929769-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02929901-a',[ ('RationalNumber',equivalence)]).
adjMapping2SUMO('02930083-a',[ ('IrrationalNumber',equivalence)]).
adjMapping2SUMO('02930255-a',[ ('Atom',subsumption)]).
adjMapping2SUMO('02930387-a',[ ('Atom',subsumption)]).
adjMapping2SUMO('02930503-a',[ ('CognitiveAgent',instance)]).
adjMapping2SUMO('02930616-a',[ ('AngleMeasure',equivalence)]).
adjMapping2SUMO('02930765-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02930987-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02931096-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02931227-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02931345-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02931554-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02931675-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02931826-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('02931947-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02932081-a',[ (measure,equivalence)]).
adjMapping2SUMO('02932161-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('02932231-a',[ (superficialPart,subsumption)]).
adjMapping2SUMO('02932334-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02932462-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('02932561-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('02932685-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('02932802-a',[ ('',undefined)]).
adjMapping2SUMO('02932931-a',[ ('ReproductiveBody',subsumption)]).
adjMapping2SUMO('02933027-a',[ ('ReproductiveBody',subsumption)]).
adjMapping2SUMO('02933132-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('02933230-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02933304-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('02933426-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02933540-a',[ ('',undefined)]).
adjMapping2SUMO('02933692-a',[ ('SexualReproduction',subsumption)]).
adjMapping2SUMO('02933807-a',[ ('SexualReproduction',subsumption)]).
adjMapping2SUMO('02933954-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02934066-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02934216-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('02934314-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02934458-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02934594-a',[ ('Stomach',subsumption)]).
adjMapping2SUMO('02934744-a',[ ('Hormone',equivalence)]).
adjMapping2SUMO('02934876-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02934994-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02935115-a',[ ('Lung',subsumption)]).
adjMapping2SUMO('02935285-a',[ ('',undefined)]).
adjMapping2SUMO('02935437-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02935530-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02935725-a',[ ('Skeleton',equivalence)]).
adjMapping2SUMO('02935913-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02936020-a',[ ('Adjective',equivalence)]).
adjMapping2SUMO('02936235-a',[ ('Adverb',equivalence)]).
adjMapping2SUMO('02936410-a',[ ('Morpheme',equivalence)]).
adjMapping2SUMO('02936511-a',[ ('Word',subsumption)]).
adjMapping2SUMO('02936627-a',[ ('Word',subsumption)]).
adjMapping2SUMO('02936764-a',[ ('Word',subsumption)]).
adjMapping2SUMO('02936859-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02936971-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02937108-a',[ ('Phrase',equivalence)]).
adjMapping2SUMO('02937294-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('02937433-a',[ ('ParticleWord',subsumption)]).
adjMapping2SUMO('02937534-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02937648-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02937720-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('02937876-a',[ ('Mathematics',instance)]).
adjMapping2SUMO('02938143-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02938236-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02938361-a',[ ('Writing',equivalence)]).
adjMapping2SUMO('02938485-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02938590-a',[ (refers,subsumption)]).
adjMapping2SUMO('02938689-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02938854-a',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('02939099-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('02939272-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('02939406-a',[ ('AstronomicalBody',instance)]).
adjMapping2SUMO('02939542-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02939656-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02939781-a',[ ('',undefined)]).
adjMapping2SUMO('02939919-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02940115-a',[ ('EngineeringComponent',subsumption)]).
adjMapping2SUMO('02940292-a',[ ('',undefined)]).
adjMapping2SUMO('02940392-a',[ ('Experimenting',equivalence)]).
adjMapping2SUMO('02940509-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02940759-a',[ (familyRelation,equivalence)]).
adjMapping2SUMO('02940953-a',[ (causes,subsumption)]).
adjMapping2SUMO('02941235-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02941513-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02941652-a',[ ('IntentionalProcess',subsumption)]).
adjMapping2SUMO('02941790-a',[ ('Continent',instance)]).
adjMapping2SUMO('02941957-a',[ ('',undefined)]).
adjMapping2SUMO('02942077-a',[ ('',undefined)]).
adjMapping2SUMO('02942200-a',[ ('LandArea',instance)]).
adjMapping2SUMO('02942347-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02942542-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02942769-a',[ ('Growth',subsumption)]).
adjMapping2SUMO('02942958-a',[ ('BiologicalProcess',subsumption)]).
adjMapping2SUMO('02943151-a',[ (result,subsumption)]).
adjMapping2SUMO('02943303-a',[ (causes,subsumption)]).
adjMapping2SUMO('02943463-a',[ ('Procedure',subsumption)]).
adjMapping2SUMO('02943631-a',[ ('Collection',subsumption)]).
adjMapping2SUMO('02943771-a',[ (part,subsumption)]).
adjMapping2SUMO('02943954-a',[ ('',undefined)]).
adjMapping2SUMO('02944089-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02944235-a',[ ('Transfer',subsumption)]).
adjMapping2SUMO('02944327-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('02944694-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02944872-a',[ ('Injuring',subsumption)]).
adjMapping2SUMO('02945002-a',[ ('',undefined)]).
adjMapping2SUMO('02945120-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02945202-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02945292-a',[ ('',undefined)]).
adjMapping2SUMO('02945377-a',[ ('Perception',equivalence)]).
adjMapping2SUMO('02945514-a',[ ('PsychologicalAttribute',subsumption)]).
adjMapping2SUMO('02945660-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02945820-a',[ ('Growth',subsumption)]).
adjMapping2SUMO('02945971-a',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('02946221-a',[ ('EducationalProcess',equivalence)]).
adjMapping2SUMO('02946359-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('02946507-a',[ ('GeographicArea',instance)]).
adjMapping2SUMO('02946644-a',[ ('GeographicArea',instance)]).
adjMapping2SUMO('02946777-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02946888-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02947019-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02947252-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02947477-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02947653-a',[ ('Throat',subsumption)]).
adjMapping2SUMO('02947799-a',[ ('BodyJunction',subsumption)]).
adjMapping2SUMO('02947928-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02948068-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02948198-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02948281-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02948363-a',[ ('Attaching',subsumption)]).
adjMapping2SUMO('02948482-a',[ ('BronchialDuct',subsumption)]).
adjMapping2SUMO('02948640-a',[ ('Artery',subsumption)]).
adjMapping2SUMO('02948774-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02948892-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02948984-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02949082-a',[ ('Physiology',equivalence)]).
adjMapping2SUMO('02949275-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02949511-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02949931-a',[ ('',undefined)]).
adjMapping2SUMO('02950154-a',[ (inhibits,subsumption)]).
adjMapping2SUMO('02950264-a',[ ('Ohm',equivalence)]).
adjMapping2SUMO('02950371-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02950471-a',[ ('Death',equivalence)]).
adjMapping2SUMO('02950588-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('02950711-a',[ ('Planning',subsumption)]).
adjMapping2SUMO('02951000-a',[ ('Planning',subsumption)]).
adjMapping2SUMO('02951184-a',[ ('',undefined)]).
adjMapping2SUMO('02951306-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02951425-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02951565-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02951702-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02951869-a',[ ('ShapeChange',subsumption)]).
adjMapping2SUMO('02952109-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('02952275-a',[ ('Christianity',equivalence)]).
adjMapping2SUMO('02952450-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02952622-a',[ ('Protestantism',equivalence)]).
adjMapping2SUMO('02952814-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02952975-a',[ ('Christianity',subsumption)]).
adjMapping2SUMO('02953235-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02953420-a',[ ('Judaism',subsumption)]).
adjMapping2SUMO('02953598-a',[ ('EasternOrthodoxChristianity',equivalence)]).
adjMapping2SUMO('02953847-a',[ ('Radiating',equivalence)]).
adjMapping2SUMO('02953973-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02954143-a',[ ('ShapeChange',subsumption)]).
adjMapping2SUMO('02954331-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02954459-a',[ ('Anglicanism',equivalence)]).
adjMapping2SUMO('02954633-a',[ ('Protestantism',subsumption)]).
adjMapping2SUMO('02954799-a',[ ('Protestantism',subsumption)]).
adjMapping2SUMO('02954981-a',[ ('Protestantism',subsumption)]).
adjMapping2SUMO('02955216-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('02955358-a',[ ('Protestantism',subsumption)]).
adjMapping2SUMO('02955562-a',[ ('Protestantism',subsumption)]).
adjMapping2SUMO('02955806-a',[ ('ReligiousOrganization',instance)]).
adjMapping2SUMO('02955996-a',[ ('ReligiousOrganization',instance)]).
adjMapping2SUMO('02956137-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02956272-a',[ ('Music',subsumption)]).
adjMapping2SUMO('02956371-a',[ ('Communication',equivalence)]).
adjMapping2SUMO('02956502-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02956623-a',[ (capability,subsumption)]).
adjMapping2SUMO('02956752-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02956880-a',[ ('List',subsumption)]).
adjMapping2SUMO('02957066-a',[ ('Nation',instance)]).
adjMapping2SUMO('02957276-a',[ ('Russia',equivalence)]).
adjMapping2SUMO('02957469-a',[ ('Germany',equivalence)]).
adjMapping2SUMO('02957699-a',[ ('Nation',instance)]).
adjMapping2SUMO('02957823-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('02958017-a',[ ('Nation',instance)]).
adjMapping2SUMO('02958126-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('02958392-a',[ ('Nation',instance)]).
adjMapping2SUMO('02958576-a',[ ('Nation',instance)]).
adjMapping2SUMO('02958714-a',[ ('LandArea',instance)]).
adjMapping2SUMO('02958844-a',[ ('LandArea',instance)]).
adjMapping2SUMO('02959007-a',[ ('Nation',instance)]).
adjMapping2SUMO('02959224-a',[ ('LandArea',instance)]).
adjMapping2SUMO('02959406-a',[ ('Nation',instance)]).
adjMapping2SUMO('02959553-a',[ ('Nation',instance)]).
adjMapping2SUMO('02959720-a',[ ('Nation',instance)]).
adjMapping2SUMO('02959912-a',[ ('Nation',instance)]).
adjMapping2SUMO('02960130-a',[ ('LandArea',instance)]).
adjMapping2SUMO('02960338-a',[ ('Nation',instance)]).
adjMapping2SUMO('02960507-a',[ ('Nation',instance)]).
adjMapping2SUMO('02960686-a',[ ('Nation',instance)]).
adjMapping2SUMO('02960832-a',[ ('Nation',instance)]).
adjMapping2SUMO('02960975-a',[ ('Nation',instance)]).
adjMapping2SUMO('02961099-a',[ ('Nation',instance)]).
adjMapping2SUMO('02961258-a',[ ('Nation',instance)]).
adjMapping2SUMO('02961396-a',[ ('',undefined)]).
adjMapping2SUMO('02961505-a',[ ('Nation',instance)]).
adjMapping2SUMO('02961688-a',[ ('Nation',instance)]).
adjMapping2SUMO('02962013-a',[ ('Nation',instance)]).
adjMapping2SUMO('02962272-a',[ ('Nation',instance)]).
adjMapping2SUMO('02962551-a',[ ('GeographicArea',instance)]).
adjMapping2SUMO('02962659-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('02962818-a',[ ('Nation',instance)]).
adjMapping2SUMO('02962961-a',[ ('Nation',instance)]).
adjMapping2SUMO('02963128-a',[ ('',undefined)]).
adjMapping2SUMO('02963272-a',[ ('',undefined)]).
adjMapping2SUMO('02963404-a',[ ('',undefined)]).
adjMapping2SUMO('02963535-a',[ ('',undefined)]).
adjMapping2SUMO('02963665-a',[ ('',undefined)]).
adjMapping2SUMO('02963810-a',[ ('',undefined)]).
adjMapping2SUMO('02963942-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('02964107-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('02964291-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('02964482-a',[ ('',undefined)]).
adjMapping2SUMO('02964629-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('02964782-a',[ ('Nation',instance)]).
adjMapping2SUMO('02964904-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('02965043-a',[ ('Nation',instance)]).
adjMapping2SUMO('02965274-a',[ ('ExponentiationFn',equivalence)]).
adjMapping2SUMO('02965415-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02965552-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02965696-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('02965861-a',[ ('LandArea',instance)]).
adjMapping2SUMO('02965985-a',[ ('Nation',instance)]).
adjMapping2SUMO('02966154-a',[ ('Nation',instance)]).
adjMapping2SUMO('02966324-a',[ ('Nation',instance)]).
adjMapping2SUMO('02966482-a',[ ('Nation',instance)]).
adjMapping2SUMO('02966656-a',[ ('Nation',instance)]).
adjMapping2SUMO('02966829-a',[ ('Nation',instance)]).
adjMapping2SUMO('02966972-a',[ ('Nation',instance)]).
adjMapping2SUMO('02967179-a',[ ('Nation',instance)]).
adjMapping2SUMO('02967333-a',[ ('Nation',instance)]).
adjMapping2SUMO('02967485-a',[ ('Nation',instance)]).
adjMapping2SUMO('02967618-a',[ ('Nation',instance)]).
adjMapping2SUMO('02967791-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('02967990-a',[ ('Nation',instance)]).
adjMapping2SUMO('02968166-a',[ ('Nation',instance)]).
adjMapping2SUMO('02968325-a',[ ('Europe',equivalence)]).
adjMapping2SUMO('02968525-a',[ ('AsianEthnicity',equivalence)]).
adjMapping2SUMO('02968828-a',[ ('Nation',instance)]).
adjMapping2SUMO('02969060-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('02969241-a',[ ('Nation',instance)]).
adjMapping2SUMO('02969375-a',[ ('Nation',instance)]).
adjMapping2SUMO('02969591-a',[ ('Nation',instance)]).
adjMapping2SUMO('02969775-a',[ ('StateOrProvince',instance)]).
adjMapping2SUMO('02969925-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('02970073-a',[ ('ReligiousOrganization',instance)]).
adjMapping2SUMO('02970241-a',[ ('',undefined)]).
adjMapping2SUMO('02970360-a',[ ('',undefined)]).
adjMapping2SUMO('02970442-a',[ ('City',instance)]).
adjMapping2SUMO('02970576-a',[ ('City',instance)]).
adjMapping2SUMO('02970689-a',[ ('LandArea',instance)]).
adjMapping2SUMO('02970820-a',[ ('City',instance)]).
adjMapping2SUMO('02971007-a',[ ('LandArea',instance)]).
adjMapping2SUMO('02971192-a',[ ('City',instance)]).
adjMapping2SUMO('02971311-a',[ ('City',instance)]).
adjMapping2SUMO('02971469-a',[ ('Nation',instance)]).
adjMapping2SUMO('02971672-a',[ ('LandArea',instance)]).
adjMapping2SUMO('02971839-a',[ ('Nation',instance)]).
adjMapping2SUMO('02972194-a',[ ('Nation',instance)]).
adjMapping2SUMO('02972344-a',[ ('LandArea',instance)]).
adjMapping2SUMO('02972499-a',[ ('City',instance)]).
adjMapping2SUMO('02972690-a',[ ('City',instance)]).
adjMapping2SUMO('02972821-a',[ ('',undefined)]).
adjMapping2SUMO('02972925-a',[ ('Nation',instance)]).
adjMapping2SUMO('02973056-a',[ ('City',instance)]).
adjMapping2SUMO('02973241-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02973392-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02973540-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02973733-a',[ (depth,subsumption)]).
adjMapping2SUMO('02973836-a',[ ('',undefined)]).
adjMapping2SUMO('02974023-a',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('02974248-a',[ (depth,subsumption)]).
adjMapping2SUMO('02974393-a',[ (depth,subsumption)]).
adjMapping2SUMO('02974507-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02974615-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('02974812-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('02974979-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02975096-a',[ ('OrganOrTissueProcess',subsumption)]).
adjMapping2SUMO('02975216-a',[ ('PathologicProcess',subsumption)]).
adjMapping2SUMO('02975349-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('02975469-a',[ ('Organ',not(subsumption))]).
adjMapping2SUMO('02975538-a',[ ('DiagnosticProcess',equivalence)]).
adjMapping2SUMO('02975697-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02975840-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02976040-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02976164-a',[ ('Perception',subsumption)]).
adjMapping2SUMO('02976260-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02976525-a',[ ('Neurosis',subsumption)]).
adjMapping2SUMO('02976681-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02976870-a',[ ('Attribute',subsumption)]).
adjMapping2SUMO('02976983-a',[ ('',undefined)]).
adjMapping2SUMO('02977198-a',[ ('Quantity',equivalence)]).
adjMapping2SUMO('02977320-a',[ ('',undefined)]).
adjMapping2SUMO('02977465-a',[ ('StateOrProvince',instance)]).
adjMapping2SUMO('02977638-a',[ ('Island',subsumption)]).
adjMapping2SUMO('02977826-a',[ ('Nation',instance)]).
adjMapping2SUMO('02978000-a',[ ('LandArea',instance)]).
adjMapping2SUMO('02978155-a',[ ('Nation',instance)]).
adjMapping2SUMO('02978335-a',[ ('StateOrProvince',instance)]).
adjMapping2SUMO('02978495-a',[ ('City',instance)]).
adjMapping2SUMO('02978635-a',[ ('PhysiologicProcess',subsumption)]).
adjMapping2SUMO('02978781-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02978928-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02979028-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02979139-a',[ ('Retina',subsumption)]).
adjMapping2SUMO('02979285-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02979443-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02979593-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02979722-a',[ ('Growth',subsumption)]).
adjMapping2SUMO('02979878-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02979995-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02980122-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02980247-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02980416-a',[ ('Meteorite',subsumption)]).
adjMapping2SUMO('02980583-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('02980696-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('02980854-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('02980972-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('02981115-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02981224-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02981329-a',[ ('Gland',subsumption)]).
adjMapping2SUMO('02981508-a',[ ('Medicine',subsumption)]).
adjMapping2SUMO('02981648-a',[ ('Government',subsumption)]).
adjMapping2SUMO('02981759-a',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('02981935-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02982102-a',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('02982288-a',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('02982473-a',[ ('Nation',instance)]).
adjMapping2SUMO('02982602-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02982729-a',[ ('Hypothalamus',equivalence)]).
adjMapping2SUMO('02982840-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02982956-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02983097-a',[ ('PhysiologicProcess',subsumption)]).
adjMapping2SUMO('02983236-a',[ ('PhysiologicProcess',subsumption)]).
adjMapping2SUMO('02983431-a',[ ('Hormone',subsumption)]).
adjMapping2SUMO('02983577-a',[ ('EmotionalState',equivalence)]).
adjMapping2SUMO('02983739-a',[ ('Food',subsumption)]).
adjMapping2SUMO('02983891-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02983978-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02984104-a',[ ('President',subsumption)]).
adjMapping2SUMO('02984333-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02984491-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('02984607-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('02984781-a',[ ('Corporation',equivalence)]).
adjMapping2SUMO('02984911-a',[ ('',undefined)]).
adjMapping2SUMO('02984998-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('02985102-a',[ ('ConstantQuantity',subsumption)]).
adjMapping2SUMO('02985206-a',[ ('',undefined)]).
adjMapping2SUMO('02985474-a',[ ('VolumeMeasure',equivalence)]).
adjMapping2SUMO('02985662-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02985782-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02985904-a',[ ('RecreationOrExercise',subsumption)]).
adjMapping2SUMO('02986098-a',[ ('Bacterium',subsumption)]).
adjMapping2SUMO('02986218-a',[ ('Planning',subsumption)]).
adjMapping2SUMO('02986392-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02986509-a',[ ('Organism',equivalence)]).
adjMapping2SUMO('02986740-a',[ ('Artifact',equivalence)]).
adjMapping2SUMO('02986893-a',[ ('',undefined)]).
adjMapping2SUMO('02987017-a',[ ('',undefined)]).
adjMapping2SUMO('02987177-a',[ ('PathologicProcess',subsumption)]).
adjMapping2SUMO('02987332-a',[ ('PathologicProcess',subsumption)]).
adjMapping2SUMO('02987454-a',[ ('PathologicProcess',subsumption)]).
adjMapping2SUMO('02987623-a',[ ('Impacting',subsumption)]).
adjMapping2SUMO('02987760-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02987910-a',[ ('Chromatography',subsumption)]).
adjMapping2SUMO('02988060-a',[ ('Nation',equivalence)]).
adjMapping2SUMO('02988281-a',[ ('EthnicGroup',subsumption)]).
adjMapping2SUMO('02988402-a',[ ('EthnicGroup',subsumption)]).
adjMapping2SUMO('02988550-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02988793-a',[ (believes,subsumption)]).
adjMapping2SUMO('02989069-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02989167-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02989316-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02989459-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02989601-a',[ ('Investigating',subsumption)]).
adjMapping2SUMO('02989754-a',[ ('TimeInterval',instance)]).
adjMapping2SUMO('02989921-a',[ ('',undefined)]).
adjMapping2SUMO('02990035-a',[ ('',undefined)]).
adjMapping2SUMO('02990154-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02990304-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02990501-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('02990660-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('02990819-a',[ ('Government',subsumption)]).
adjMapping2SUMO('02990954-a',[ ('Comparing',equivalence)]).
adjMapping2SUMO('02991122-a',[ ('ArtWork',equivalence)]).
adjMapping2SUMO('02991287-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02991463-a',[ ('Position',subsumption)]).
adjMapping2SUMO('02991586-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02991690-a',[ ('Sentence',equivalence)]).
adjMapping2SUMO('02991819-a',[ ('Sentence',subsumption)]).
adjMapping2SUMO('02991962-a',[ ('Sentence',subsumption)]).
adjMapping2SUMO('02992070-a',[ ('Relation',subsumption)]).
adjMapping2SUMO('02992241-a',[ ('Ape',equivalence)]).
adjMapping2SUMO('02992363-a',[ ('HoofedMammal',subsumption)]).
adjMapping2SUMO('02992453-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('02992601-a',[ ('Bird',subsumption)]).
adjMapping2SUMO('02992691-a',[ ('Day',subsumption)]).
adjMapping2SUMO('02992796-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02992914-a',[ ('Morpheme',subsumption)]).
adjMapping2SUMO('02993094-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02993258-a',[ ('',undefined)]).
adjMapping2SUMO('02993362-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('02993591-a',[ ('Icon',subsumption)]).
adjMapping2SUMO('02993702-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('02993853-a',[ ('Word',subsumption)]).
adjMapping2SUMO('02994089-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('02994217-a',[ ('StaticWaterArea',subsumption)]).
adjMapping2SUMO('02994312-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02994448-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02994617-a',[ ('LogFn',equivalence)]).
adjMapping2SUMO('02994754-a',[ ('',undefined)]).
adjMapping2SUMO('02994872-a',[ ('TextureAttribute',subsumption)]).
adjMapping2SUMO('02995039-a',[ ('',undefined)]).
adjMapping2SUMO('02995161-a',[ ('SubatomicParticle',equivalence)]).
adjMapping2SUMO('02995373-a',[ ('Marsupial',equivalence)]).
adjMapping2SUMO('02995482-a',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('02995636-a',[ ('UnitOfMeasure',subsumption)]).
adjMapping2SUMO('02995864-a',[ ('',undefined)]).
adjMapping2SUMO('02995972-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02996123-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('02996239-a',[ ('NormativeAttribute',equivalence)]).
adjMapping2SUMO('02996373-a',[ ('',undefined)]).
adjMapping2SUMO('02996466-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('02996605-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02996801-a',[ ('',undefined)]).
adjMapping2SUMO('02996904-a',[ ('Text',subsumption)]).
adjMapping2SUMO('02997099-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02997227-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('02997329-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('02997529-a',[ (wants,subsumption)]).
adjMapping2SUMO('02997632-a',[ (causes,subsumption)]).
adjMapping2SUMO('02997740-a',[ ('Promise',equivalence)]).
adjMapping2SUMO('02997900-a',[ ('',undefined)]).
adjMapping2SUMO('02998046-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('02998184-a',[ ('',undefined)]).
adjMapping2SUMO('02998269-a',[ ('',undefined)]).
adjMapping2SUMO('02998438-a',[ ('Device',subsumption)]).
adjMapping2SUMO('02998561-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('02998669-a',[ ('ChemicalDecomposition',subsumption)]).
adjMapping2SUMO('02998844-a',[ ('',undefined)]).
adjMapping2SUMO('02998988-a',[ ('TimeDuration',subsumption)]).
adjMapping2SUMO('02999190-a',[ ('TimeDuration',subsumption)]).
adjMapping2SUMO('02999398-a',[ ('TimeDuration',subsumption)]).
adjMapping2SUMO('02999616-a',[ ('',undefined)]).
adjMapping2SUMO('02999718-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('02999904-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('03000110-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('03000341-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03000447-a',[ ('ChemicalDecomposition',subsumption)]).
adjMapping2SUMO('03000608-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('03000725-a',[ ('BiologicalProcess',subsumption)]).
adjMapping2SUMO('03000868-a',[ ('Predicting',subsumption)]).
adjMapping2SUMO('03001012-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('03001153-a',[ ('Human',instance)]).
adjMapping2SUMO('03001278-a',[ ('Writing',subsumption)]).
adjMapping2SUMO('03001428-a',[ ('',undefined)]).
adjMapping2SUMO('03001527-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('03001653-a',[ ('Text',subsumption)]).
adjMapping2SUMO('03001853-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('03002040-a',[ ('PolyphonicMusic',subsumption)]).
adjMapping2SUMO('03002190-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03002351-a',[ ('Nutrient',subsumption)]).
adjMapping2SUMO('03002617-a',[ ('Magnetism',equivalence)]).
adjMapping2SUMO('03002724-a',[ ('Motion',equivalence)]).
adjMapping2SUMO('03002841-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('03003031-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('03003223-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('03003344-a',[ ('UnitedKingdom',equivalence)]).
adjMapping2SUMO('03003616-a',[ ('UnitedKingdom',equivalence)]).
adjMapping2SUMO('03003744-a',[ ('Ireland',equivalence)]).
adjMapping2SUMO('03003928-a',[ ('Nation',instance)]).
adjMapping2SUMO('03004196-a',[ ('LandArea',instance)]).
adjMapping2SUMO('03004358-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('03004561-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('03004701-a',[ ('Music',subsumption)]).
adjMapping2SUMO('03004852-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('03005039-a',[ ('Enzyme',equivalence)]).
adjMapping2SUMO('03005155-a',[ ('Enzyme',not(subsumption))]).
adjMapping2SUMO('03005276-a',[ ('Iodine',subsumption)]).
adjMapping2SUMO('03005423-a',[ ('Text',subsumption)]).
adjMapping2SUMO('03005593-a',[ ('SocialRole',subsumption)]).
adjMapping2SUMO('03005728-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('03005862-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03006126-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('03006225-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('03006389-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('03006513-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03006699-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03006854-a',[ ('RecreationOrExercise',subsumption)]).
adjMapping2SUMO('03007038-a',[ ('RecreationOrExercise',subsumption)]).
adjMapping2SUMO('03007149-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03007245-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('03007354-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03007530-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03007718-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('03007826-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('03007929-a',[ (causes,subsumption)]).
adjMapping2SUMO('03008013-a',[ ('AutonomicProcess',equivalence)]).
adjMapping2SUMO('03008207-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03008345-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03008447-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03008659-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('03008785-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('03008885-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03009016-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03009131-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03009253-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('03009360-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03009476-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('03009594-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('03009696-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('03009792-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('03009911-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03010071-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('03010176-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03010337-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03010428-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03010553-a',[ ('Perception',subsumption)]).
adjMapping2SUMO('03010664-a',[ ('Vertebrate',equivalence)]).
adjMapping2SUMO('03010781-a',[ ('Brain',subsumption)]).
adjMapping2SUMO('03010904-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03011036-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03011126-a',[ ('Music',subsumption)]).
adjMapping2SUMO('03011248-a',[ ('NervousSystem',subsumption)]).
adjMapping2SUMO('03011380-a',[ ('BiologicallyActiveSubstance',subsumption)]).
adjMapping2SUMO('03011592-a',[ ('Gland',subsumption)]).
adjMapping2SUMO('03011750-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03011858-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03011972-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03012094-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('03012209-a',[ ('PrimeNumber',equivalence)]).
adjMapping2SUMO('03012377-a',[ (equal,subsumption)]).
adjMapping2SUMO('03012477-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('03012599-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('03012707-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('03012793-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('03012954-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('03013037-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('03013124-a',[ ('Muscle',subsumption)]).
adjMapping2SUMO('03013231-a',[ ('Muscle',equivalence)]).
adjMapping2SUMO('03013300-a',[ ('',undefined)]).
adjMapping2SUMO('03013412-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03013550-a',[ ('Human',instance)]).
adjMapping2SUMO('03013726-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('03013904-a',[ ('Human',instance)]).
adjMapping2SUMO('03014030-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('03014166-a',[ ('Larval',equivalence)]).
adjMapping2SUMO('03014288-a',[ ('IntentionalProcess',subsumption)]).
adjMapping2SUMO('03014485-a',[ ('Microorganism',subsumption)]).
adjMapping2SUMO('03014655-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03014770-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03014941-a',[ ('',undefined)]).
adjMapping2SUMO('03015113-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03015336-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03015441-a',[ ('Substance',subsumption)]).
adjMapping2SUMO('03015589-a',[ ('Text',subsumption)]).
adjMapping2SUMO('03015805-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03016027-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03016202-a',[ ('Nation',instance)]).
adjMapping2SUMO('03016519-a',[ ('Nation',instance)]).
adjMapping2SUMO('03016684-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03016857-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03017025-a',[ ('LandArea',instance)]).
adjMapping2SUMO('03017159-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03017286-a',[ ('City',instance)]).
adjMapping2SUMO('03017468-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('03017659-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('03017788-a',[ ('City',instance)]).
adjMapping2SUMO('03017922-a',[ ('Position',subsumption)]).
adjMapping2SUMO('03018112-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03018375-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('03018498-a',[ ('Relation',subsumption)]).
adjMapping2SUMO('03018802-a',[ ('Classifying',equivalence)]).
adjMapping2SUMO('03018964-a',[ ('Mammal',subsumption)]).
adjMapping2SUMO('03019114-a',[ ('ChemicalDecomposition',subsumption)]).
adjMapping2SUMO('03019219-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03019322-a',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('03019483-a',[ ('',undefined)]).
adjMapping2SUMO('03019576-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03019709-a',[ ('',undefined)]).
adjMapping2SUMO('03019836-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03019955-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03020075-a',[ ('',undefined)]).
adjMapping2SUMO('03020193-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03020354-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('03020463-a',[ ('Text',subsumption)]).
adjMapping2SUMO('03020663-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('03020750-a',[ ('BiologicalProcess',subsumption)]).
adjMapping2SUMO('03020884-a',[ (located,subsumption)]).
adjMapping2SUMO('03021051-a',[ (located,subsumption)]).
adjMapping2SUMO('03021194-a',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('03021347-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('03021459-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('03021543-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03021693-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03021866-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('03022003-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03022177-a',[ ('UnitedKingdomOfGreatBritainAndNorthernIreland',equivalence)]).
adjMapping2SUMO('03022349-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('03022469-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('03022593-a',[ ('Planning',subsumption)]).
adjMapping2SUMO('03022739-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03022917-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('03023077-a',[ ('Fungus',subsumption)]).
adjMapping2SUMO('03023216-a',[ ('Music',subsumption)]).
adjMapping2SUMO('03023348-a',[ ('MusicalInstrument',subsumption)]).
adjMapping2SUMO('03023449-a',[ ('City',instance)]).
adjMapping2SUMO('03023644-a',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('03023852-a',[ ('Nation',instance)]).
adjMapping2SUMO('03023995-a',[ ('LandArea',instance)]).
adjMapping2SUMO('03024132-a',[ ('LandArea',instance)]).
adjMapping2SUMO('03024420-a',[ ('Nation',instance)]).
adjMapping2SUMO('03024647-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('03025252-a',[ ('Island',instance)]).
adjMapping2SUMO('03025403-a',[ ('Island',instance)]).
adjMapping2SUMO('03025590-a',[ ('LandArea',instance)]).
adjMapping2SUMO('03025746-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('03025853-a',[ ('LandArea',instance)]).
adjMapping2SUMO('03025967-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('03026095-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03026244-a',[ ('',undefined)]).
adjMapping2SUMO('03026319-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03026504-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03026652-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03026758-a',[ ('Human',instance)]).
adjMapping2SUMO('03026902-a',[ ('Nation',instance)]).
adjMapping2SUMO('03027040-a',[ ('Building',subsumption)]).
adjMapping2SUMO('03027213-a',[ ('Human',instance)]).
adjMapping2SUMO('03027335-a',[ ('Human',instance)]).
adjMapping2SUMO('03027538-a',[ ('Human',instance)]).
adjMapping2SUMO('03027692-a',[ ('Human',instance)]).
adjMapping2SUMO('03027793-a',[ ('Human',instance)]).
adjMapping2SUMO('03028005-a',[ ('Human',instance)]).
adjMapping2SUMO('03028216-a',[ ('Human',instance)]).
adjMapping2SUMO('03028338-a',[ ('Human',instance)]).
adjMapping2SUMO('03028465-a',[ ('Human',instance)]).
adjMapping2SUMO('03028778-a',[ ('Human',instance)]).
adjMapping2SUMO('03028863-a',[ ('Human',instance)]).
adjMapping2SUMO('03028987-a',[ ('Human',instance)]).
adjMapping2SUMO('03029133-a',[ ('Human',instance)]).
adjMapping2SUMO('03029274-a',[ ('Human',instance)]).
adjMapping2SUMO('03029400-a',[ ('Human',instance)]).
adjMapping2SUMO('03029573-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('03029801-a',[ ('Human',instance)]).
adjMapping2SUMO('03029984-a',[ ('Human',instance)]).
adjMapping2SUMO('03030096-a',[ ('TimeInterval',instance)]).
adjMapping2SUMO('03030235-a',[ ('Human',instance)]).
adjMapping2SUMO('03030364-a',[ ('',undefined)]).
adjMapping2SUMO('03030515-a',[ ('Human',instance)]).
adjMapping2SUMO('03030635-a',[ ('Human',instance)]).
adjMapping2SUMO('03030753-a',[ ('Human',instance)]).
adjMapping2SUMO('03030919-a',[ ('Human',instance)]).
adjMapping2SUMO('03031102-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03031247-a',[ ('Human',instance)]).
adjMapping2SUMO('03031400-a',[ ('Human',instance)]).
adjMapping2SUMO('03031615-a',[ ('Human',instance)]).
adjMapping2SUMO('03031733-a',[ ('Human',instance)]).
adjMapping2SUMO('03031886-a',[ ('Human',instance)]).
adjMapping2SUMO('03032009-a',[ ('Human',instance)]).
adjMapping2SUMO('03032131-a',[ ('Human',instance)]).
adjMapping2SUMO('03032219-a',[ ('Human',instance)]).
adjMapping2SUMO('03032383-a',[ ('Human',instance)]).
adjMapping2SUMO('03032518-a',[ ('Human',instance)]).
adjMapping2SUMO('03032642-a',[ ('Human',instance)]).
adjMapping2SUMO('03032736-a',[ ('Human',instance)]).
adjMapping2SUMO('03032887-a',[ ('',undefined)]).
adjMapping2SUMO('03033024-a',[ ('Human',instance)]).
adjMapping2SUMO('03033108-a',[ ('Human',instance)]).
adjMapping2SUMO('03033259-a',[ ('Human',instance)]).
adjMapping2SUMO('03033397-a',[ ('Human',instance)]).
adjMapping2SUMO('03033522-a',[ ('Human',instance)]).
adjMapping2SUMO('03033636-a',[ ('Human',instance)]).
adjMapping2SUMO('03033785-a',[ ('Human',instance)]).
adjMapping2SUMO('03033914-a',[ ('Human',instance)]).
adjMapping2SUMO('03034035-a',[ ('Human',instance)]).
adjMapping2SUMO('03034192-a',[ ('Human',instance)]).
adjMapping2SUMO('03034283-a',[ ('Human',instance)]).
adjMapping2SUMO('03034487-a',[ ('Human',instance)]).
adjMapping2SUMO('03034580-a',[ ('Human',instance)]).
adjMapping2SUMO('03034741-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('03034903-a',[ ('Human',instance)]).
adjMapping2SUMO('03035021-a',[ ('Human',instance)]).
adjMapping2SUMO('03035113-a',[ ('Human',instance)]).
adjMapping2SUMO('03035313-a',[ ('Human',instance)]).
adjMapping2SUMO('03035446-a',[ ('',undefined)]).
adjMapping2SUMO('03035675-a',[ ('Human',instance)]).
adjMapping2SUMO('03035876-a',[ ('Human',instance)]).
adjMapping2SUMO('03036014-a',[ ('Human',instance)]).
adjMapping2SUMO('03036191-a',[ ('Human',instance)]).
adjMapping2SUMO('03036316-a',[ ('Human',instance)]).
adjMapping2SUMO('03036464-a',[ ('Human',instance)]).
adjMapping2SUMO('03036595-a',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('03036805-a',[ ('Human',instance)]).
adjMapping2SUMO('03036974-a',[ ('',undefined)]).
adjMapping2SUMO('03037093-a',[ ('StateOrProvince',instance)]).
adjMapping2SUMO('03037236-a',[ ('City',instance)]).
adjMapping2SUMO('03037407-a',[ ('Government',instance)]).
adjMapping2SUMO('03037579-a',[ ('Human',instance)]).
adjMapping2SUMO('03037712-a',[ ('Human',instance)]).
adjMapping2SUMO('03037799-a',[ ('Human',instance)]).
adjMapping2SUMO('03037924-a',[ ('Human',instance)]).
adjMapping2SUMO('03038065-a',[ ('Human',instance)]).
adjMapping2SUMO('03038199-a',[ ('Human',instance)]).
adjMapping2SUMO('03038401-a',[ ('Human',instance)]).
adjMapping2SUMO('03038536-a',[ ('Human',instance)]).
adjMapping2SUMO('03038683-a',[ ('Human',instance)]).
adjMapping2SUMO('03038796-a',[ ('Human',instance)]).
adjMapping2SUMO('03038894-a',[ ('Human',instance)]).
adjMapping2SUMO('03039004-a',[ ('Human',instance)]).
adjMapping2SUMO('03039087-a',[ ('Language',instance)]).
adjMapping2SUMO('03039314-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03039556-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('03039648-a',[ ('Birth',subsumption)]).
adjMapping2SUMO('03039907-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('03039997-a',[ ('Radiating',subsumption)]).
adjMapping2SUMO('03040103-a',[ ('Position',subsumption)]).
adjMapping2SUMO('03040264-a',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('03040408-a',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('03040525-a',[ ('',undefined)]).
adjMapping2SUMO('03040635-a',[ ('',undefined)]).
adjMapping2SUMO('03040740-a',[ ('',undefined)]).
adjMapping2SUMO('03040846-a',[ ('Position',subsumption)]).
adjMapping2SUMO('03040974-a',[ ('Microorganism',subsumption)]).
adjMapping2SUMO('03041331-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03041491-a',[ ('',undefined)]).
adjMapping2SUMO('03041636-a',[ ('Noun',subsumption)]).
adjMapping2SUMO('03041739-a',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('03042005-a',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('03042249-a',[ ('',undefined)]).
adjMapping2SUMO('03042394-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03042661-a',[ ('Dry',subsumption)]).
adjMapping2SUMO('03042812-a',[ ('Nation',instance)]).
adjMapping2SUMO('03042986-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('03043173-a',[ (earlier,subsumption)]).
adjMapping2SUMO('03043371-a',[ (earlier,subsumption)]).
adjMapping2SUMO('03043482-a',[ (believes,subsumption)]).
adjMapping2SUMO('03043667-a',[ ('Island',instance)]).
adjMapping2SUMO('03043838-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03043937-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03044083-a',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('03044331-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03044462-a',[ ('HoofedMammal',subsumption)]).
adjMapping2SUMO('03044566-a',[ ('LandArea',instance)]).
adjMapping2SUMO('03044740-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03044869-a',[ ('Relation',subsumption)]).
adjMapping2SUMO('03045059-a',[ ('Icon',subsumption)]).
adjMapping2SUMO('03045196-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('03045377-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03045457-a',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('03045585-a',[ ('TimeInterval',instance)]).
adjMapping2SUMO('03045750-a',[ ('Nation',instance)]).
adjMapping2SUMO('03045992-a',[ ('Nation',instance)]).
adjMapping2SUMO('03046184-a',[ ('Nation',instance)]).
adjMapping2SUMO('03046349-a',[ ('Nation',instance)]).
adjMapping2SUMO('03046559-a',[ ('Language',subsumption)]).
adjMapping2SUMO('03046708-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03046931-a',[ ('',undefined)]).
adjMapping2SUMO('03047071-a',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('03047188-a',[ ('Nation',instance)]).
adjMapping2SUMO('03047388-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03047501-a',[ ('ReligiousOrganization',instance)]).
adjMapping2SUMO('03047611-a',[ ('Human',instance)]).
adjMapping2SUMO('03047714-a',[ ('LandArea',instance)]).
adjMapping2SUMO('03047898-a',[ ('Nation',instance)]).
adjMapping2SUMO('03048046-a',[ ('Nation',instance)]).
adjMapping2SUMO('03048204-a',[ ('Nation',instance)]).
adjMapping2SUMO('03048385-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('03048558-a',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('03048680-a',[ ('Text',subsumption)]).
adjMapping2SUMO('03048845-a',[ ('Mixture',subsumption)]).
adjMapping2SUMO('03048971-a',[ ('Mixture',subsumption)]).
adjMapping2SUMO('03049071-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('03049220-a',[ ('Relation',subsumption)]).
adjMapping2SUMO('03049350-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('03049475-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('03049642-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('03049812-a',[ ('Embryonic',subsumption)]).
adjMapping2SUMO('03050012-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03050164-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('03050324-a',[ ('Cell',subsumption)]).
adjMapping2SUMO('03050430-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03050560-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03050716-a',[ ('Embryonic',subsumption)]).
adjMapping2SUMO('03050870-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('03051035-a',[ ('Nation',instance)]).
adjMapping2SUMO('03051194-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03051307-a',[ ('Nation',instance)]).
adjMapping2SUMO('03051512-a',[ ('Building',subsumption)]).
adjMapping2SUMO('03051619-a',[ ('Organization',subsumption)]).
adjMapping2SUMO('03051889-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('03052018-a',[ ('Nation',instance)]).
adjMapping2SUMO('03052218-a',[ ('Nation',instance)]).
adjMapping2SUMO('03052403-a',[ ('StateOrProvince',instance)]).
adjMapping2SUMO('03052588-a',[ ('Nation',instance)]).
adjMapping2SUMO('03052770-a',[ ('Eating',subsumption)]).
adjMapping2SUMO('03052963-a',[ ('StateOrProvince',subsumption)]).
adjMapping2SUMO('03053044-a',[ ('TimeInterval',instance)]).
adjMapping2SUMO('03053199-a',[ ('ReligiousOrganization',instance)]).
adjMapping2SUMO('03053336-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03053460-a',[ ('Reasoning',subsumption)]).
adjMapping2SUMO('03053657-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03053859-a',[ ('Language',instance)]).
adjMapping2SUMO('03054020-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('03054216-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03054409-a',[ ('ChemicalProcess',subsumption)]).
adjMapping2SUMO('03054551-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03054743-a',[ ('Nation',instance)]).
adjMapping2SUMO('03054978-a',[ ('',undefined)]).
adjMapping2SUMO('03055059-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('03055237-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('03055374-a',[ ('Attribute',subsumption)]).
adjMapping2SUMO('03055543-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03055658-a',[ ('Language',instance)]).
adjMapping2SUMO('03055809-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('03056010-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03056115-a',[ ('LandArea',instance)]).
adjMapping2SUMO('03056304-a',[ ('Position',subsumption)]).
adjMapping2SUMO('03056463-a',[ ('ReligiousOrganization',instance)]).
adjMapping2SUMO('03056693-a',[ ('Nation',instance)]).
adjMapping2SUMO('03056871-a',[ ('',undefined)]).
adjMapping2SUMO('03057075-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('03057253-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03057413-a',[ ('Language',subsumption)]).
adjMapping2SUMO('03057591-a',[ ('TimeInterval',instance)]).
adjMapping2SUMO('03057732-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('03057807-a',[ ('Device',subsumption)]).
adjMapping2SUMO('03057949-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('03058223-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('03058501-a',[ ('CognitiveAgent',subsumption)]).
adjMapping2SUMO('03058635-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03058754-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('03059033-a',[ ('Language',subsumption)]).
adjMapping2SUMO('03059198-a',[ ('',undefined)]).
adjMapping2SUMO('03059340-a',[ ('Text',subsumption)]).
adjMapping2SUMO('03059477-a',[ ('FloweringPlant',subsumption)]).
adjMapping2SUMO('03059551-a',[ ('GeographicArea',instance)]).
adjMapping2SUMO('03059688-a',[ ('City',instance)]).
adjMapping2SUMO('03059847-a',[ ('',undefined)]).
adjMapping2SUMO('03059966-a',[ ('Organization',subsumption)]).
adjMapping2SUMO('03060114-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('03060257-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('03060385-a',[ ('Digesting',equivalence)]).
adjMapping2SUMO('03060601-a',[ ('City',instance)]).
adjMapping2SUMO('03060782-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03060971-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03061081-a',[ ('FieldOfStudy',subsumption)]).
adjMapping2SUMO('03061250-a',[ ('FieldOfStudy',subsumption)]).
adjMapping2SUMO('03061455-a',[ ('RegulatoryProcess',subsumption)]).
adjMapping2SUMO('03061626-a',[ ('Organization',subsumption)]).
adjMapping2SUMO('03061762-a',[ ('Nation',instance)]).
adjMapping2SUMO('03061982-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('03062151-a',[ ('',undefined)]).
adjMapping2SUMO('03062280-a',[ (inhabits,subsumption)]).
adjMapping2SUMO('03062466-a',[ ('ReligiousOrganization',instance)]).
adjMapping2SUMO('03062595-a',[ ('Nation',instance)]).
adjMapping2SUMO('03062754-a',[ ('Position',subsumption)]).
adjMapping2SUMO('03062899-a',[ ('BodyVessel',not(subsumption))]).
adjMapping2SUMO('03062990-a',[ ('TimeInterval',instance)]).
adjMapping2SUMO('03063176-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03063305-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03063492-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('03063601-a',[ ('Device',subsumption)]).
adjMapping2SUMO('03063721-a',[ ('BodyVessel',subsumption)]).
adjMapping2SUMO('03063868-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03064076-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('03064239-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('03064382-a',[ ('Position',subsumption)]).
adjMapping2SUMO('03064520-a',[ ('StateOrProvince',instance)]).
adjMapping2SUMO('03064693-a',[ ('Nation',instance)]).
adjMapping2SUMO('03064883-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03065047-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03065227-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03065414-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('03065516-a',[ ('SubjectiveStrongNegativeAttribute',subsumption)]).
adjMapping2SUMO('03065685-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03065804-a',[ ('Government',subsumption)]).
adjMapping2SUMO('03065969-a',[ ('Nation',instance)]).
adjMapping2SUMO('03066180-a',[ ('Nation',instance)]).
adjMapping2SUMO('03066448-a',[ ('LandArea',instance)]).
adjMapping2SUMO('03066658-a',[ ('ReligiousOrganization',instance)]).
adjMapping2SUMO('03066825-a',[ ('Nation',instance)]).
adjMapping2SUMO('03066978-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('03067153-a',[ ('Nation',instance)]).
adjMapping2SUMO('03067329-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03067506-a',[ ('Human',subsumption)]).
adjMapping2SUMO('03067712-a',[ ('StateOrProvince',instance)]).
adjMapping2SUMO('03067957-a',[ ('Nation',instance)]).
adjMapping2SUMO('03068198-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('03068330-a',[ ('Language',instance)]).
adjMapping2SUMO('03068473-a',[ ('Nation',instance)]).
adjMapping2SUMO('03068737-a',[ ('LandArea',instance)]).
adjMapping2SUMO('03068909-a',[ ('Human',instance)]).
adjMapping2SUMO('03069079-a',[ ('ViolentContest',subsumption)]).
adjMapping2SUMO('03069238-a',[ ('Gland',equivalence)]).
adjMapping2SUMO('03069388-a',[ ('Hormone',subsumption)]).
adjMapping2SUMO('03069542-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03069643-a',[ ('Language',instance)]).
adjMapping2SUMO('03069797-a',[ ('',undefined)]).
adjMapping2SUMO('03069937-a',[ ('',undefined)]).
adjMapping2SUMO('03070101-a',[ ('',undefined)]).
adjMapping2SUMO('03070230-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('03070352-a',[ ('Human',instance)]).
adjMapping2SUMO('03070517-a',[ ('Human',instance)]).
adjMapping2SUMO('03070697-a',[ ('Nation',instance)]).
adjMapping2SUMO('03070879-a',[ ('Growth',equivalence)]).
adjMapping2SUMO('03071022-a',[ ('Nation',instance)]).
adjMapping2SUMO('03071201-a',[ ('Nation',instance)]).
adjMapping2SUMO('03071374-a',[ ('Nation',instance)]).
adjMapping2SUMO('03071535-a',[ ('Device',subsumption)]).
adjMapping2SUMO('03071651-a',[ ('Nation',instance)]).
adjMapping2SUMO('03071838-a',[ ('Government',instance)]).
adjMapping2SUMO('03072028-a',[ ('Island',instance)]).
adjMapping2SUMO('03072158-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03072365-a',[ ('',undefined)]).
adjMapping2SUMO('03072518-a',[ ('Human',instance)]).
adjMapping2SUMO('03072673-a',[ ('',undefined)]).
adjMapping2SUMO('03072816-a',[ ('Human',instance)]).
adjMapping2SUMO('03072966-a',[ ('TherapeuticProcess',subsumption)]).
adjMapping2SUMO('03073110-a',[ ('TherapeuticProcess',subsumption)]).
adjMapping2SUMO('03073251-a',[ ('Human',instance)]).
adjMapping2SUMO('03073420-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03073574-a',[ ('Text',subsumption)]).
adjMapping2SUMO('03073751-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03073888-a',[ ('Device',subsumption)]).
adjMapping2SUMO('03074039-a',[ ('TherapeuticProcess',subsumption)]).
adjMapping2SUMO('03074173-a',[ ('Nation',instance)]).
adjMapping2SUMO('03074368-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03074565-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03074777-a',[ ('Language',subsumption)]).
adjMapping2SUMO('03074922-a',[ ('Group',subsumption)]).
adjMapping2SUMO('03075087-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('03075191-a',[ ('Nation',instance)]).
adjMapping2SUMO('03075470-a',[ ('Nation',instance)]).
adjMapping2SUMO('03075662-a',[ ('Language',subsumption)]).
adjMapping2SUMO('03075798-a',[ ('Character',subsumption)]).
adjMapping2SUMO('03075944-a',[ ('Human',instance)]).
adjMapping2SUMO('03076108-a',[ ('Human',instance)]).
adjMapping2SUMO('03076230-a',[ ('PoliticalOrganization',instance)]).
adjMapping2SUMO('03076432-a',[ ('Nation',instance)]).
adjMapping2SUMO('03076663-a',[ ('Nation',instance)]).
adjMapping2SUMO('03076935-a',[ ('ReligiousOrganization',instance)]).
adjMapping2SUMO('03077235-a',[ ('Nation',instance)]).
adjMapping2SUMO('03077419-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03077599-a',[ ('CognitiveAgent',instance)]).
adjMapping2SUMO('03077765-a',[ ('AstronomicalBody',instance)]).
adjMapping2SUMO('03077930-a',[ ('Human',instance)]).
adjMapping2SUMO('03078076-a',[ ('',undefined)]).
adjMapping2SUMO('03078234-a',[ ('LandArea',instance)]).
adjMapping2SUMO('03078445-a',[ ('',undefined)]).
adjMapping2SUMO('03078586-a',[ ('Nation',subsumption)]).
adjMapping2SUMO('03078753-a',[ ('',undefined)]).
adjMapping2SUMO('03078832-a',[ ('',undefined)]).
adjMapping2SUMO('03078975-a',[ ('City',instance)]).
adjMapping2SUMO('03079151-a',[ ('Nation',instance)]).
adjMapping2SUMO('03079293-a',[ ('City',instance)]).
adjMapping2SUMO('03079460-a',[ ('Government',instance)]).
adjMapping2SUMO('03079627-a',[ ('Nation',instance)]).
adjMapping2SUMO('03079803-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03079951-a',[ ('',undefined)]).
adjMapping2SUMO('03080101-a',[ ('Language',instance)]).
adjMapping2SUMO('03080238-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('03080351-a',[ ('Language',subsumption)]).
adjMapping2SUMO('03080492-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03080619-a',[ ('Nation',instance)]).
adjMapping2SUMO('03080756-a',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('03080862-a',[ ('LandArea',instance)]).
adjMapping2SUMO('03081006-a',[ ('Nation',instance)]).
adjMapping2SUMO('03081160-a',[ ('Nation',instance)]).
adjMapping2SUMO('03081328-a',[ ('Nation',instance)]).
adjMapping2SUMO('03081485-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('03081681-a',[ ('Publication',subsumption)]).
adjMapping2SUMO('03081813-a',[ ('City',instance)]).
adjMapping2SUMO('03081986-a',[ ('Nation',instance)]).
adjMapping2SUMO('03082125-a',[ ('City',instance)]).
adjMapping2SUMO('03082253-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('03082394-a',[ ('Human',instance)]).
adjMapping2SUMO('03082589-a',[ ('Island',instance)]).
adjMapping2SUMO('03082745-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03082875-a',[ ('Nation',instance)]).
adjMapping2SUMO('03083069-a',[ ('LandArea',instance)]).
adjMapping2SUMO('03083417-a',[ ('Nation',instance)]).
adjMapping2SUMO('03083678-a',[ ('Nation',instance)]).
adjMapping2SUMO('03083842-a',[ ('Nation',instance)]).
adjMapping2SUMO('03084010-a',[ ('Human',instance)]).
adjMapping2SUMO('03084196-a',[ ('City',instance)]).
adjMapping2SUMO('03084397-a',[ ('Building',subsumption)]).
adjMapping2SUMO('03084548-a',[ ('Island',instance)]).
adjMapping2SUMO('03084759-a',[ ('Nation',instance)]).
adjMapping2SUMO('03085072-a',[ ('Position',subsumption)]).
adjMapping2SUMO('03085213-a',[ ('WaterArea',instance)]).
adjMapping2SUMO('03085394-a',[ ('StationaryArtifact',subsumption)]).
adjMapping2SUMO('03085572-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('03085715-a',[ ('Human',instance)]).
adjMapping2SUMO('03085877-a',[ ('Mixture',subsumption)]).
adjMapping2SUMO('03086002-a',[ ('',undefined)]).
adjMapping2SUMO('03086167-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('03086294-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03086476-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('03086603-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('03086712-a',[ ('Mammal',subsumption)]).
adjMapping2SUMO('03086852-a',[ ('',undefined)]).
adjMapping2SUMO('03086974-a',[ ('Mineral',equivalence)]).
adjMapping2SUMO('03087088-a',[ ('LandArea',instance)]).
adjMapping2SUMO('03087424-a',[ ('Nation',instance)]).
adjMapping2SUMO('03087579-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03087685-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03087909-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('03088038-a',[ ('Island',instance)]).
adjMapping2SUMO('03088220-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03088384-a',[ ('Nation',instance)]).
adjMapping2SUMO('03088558-a',[ ('Nation',instance)]).
adjMapping2SUMO('03088695-a',[ ('City',instance)]).
adjMapping2SUMO('03088838-a',[ ('Nation',instance)]).
adjMapping2SUMO('03088968-a',[ ('Nation',instance)]).
adjMapping2SUMO('03089121-a',[ ('Hominid',subsumption)]).
adjMapping2SUMO('03089377-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('03089615-a',[ ('',undefined)]).
adjMapping2SUMO('03089713-a',[ ('',undefined)]).
adjMapping2SUMO('03089804-a',[ ('TimeInterval',instance)]).
adjMapping2SUMO('03089951-a',[ ('TimeInterval',instance)]).
adjMapping2SUMO('03090086-a',[ ('TimeInterval',instance)]).
adjMapping2SUMO('03090263-a',[ ('TimeInterval',instance)]).
adjMapping2SUMO('03090456-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03090612-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03090782-a',[ ('',undefined)]).
adjMapping2SUMO('03090939-a',[ ('Nation',instance)]).
adjMapping2SUMO('03091080-a',[ ('Nation',instance)]).
adjMapping2SUMO('03091307-a',[ ('Nation',instance)]).
adjMapping2SUMO('03091464-a',[ ('Language',subsumption)]).
adjMapping2SUMO('03091618-a',[ ('StreamWaterArea',instance)]).
adjMapping2SUMO('03091751-a',[ ('',undefined)]).
adjMapping2SUMO('03091861-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('03091996-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('03092198-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('03092376-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('03092527-a',[ ('LandArea',instance)]).
adjMapping2SUMO('03092661-a',[ ('Language',subsumption)]).
adjMapping2SUMO('03092824-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03092958-a',[ ('StateOrProvince',instance)]).
adjMapping2SUMO('03093076-a',[ ('Sport',subsumption)]).
adjMapping2SUMO('03093184-a',[ ('CognitiveAgent',subsumption)]).
adjMapping2SUMO('03093379-a',[ ('LandArea',instance)]).
adjMapping2SUMO('03093551-a',[ ('Nation',instance)]).
adjMapping2SUMO('03093695-a',[ ('',undefined)]).
adjMapping2SUMO('03093862-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('03094006-a',[ (wants,subsumption)]).
adjMapping2SUMO('03094107-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('03094239-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03094404-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('03094520-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('03094740-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('03094928-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03095068-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03095257-a',[ ('',undefined)]).
adjMapping2SUMO('03095372-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('03095588-a',[ ('City',instance)]).
adjMapping2SUMO('03095813-a',[ ('EducationalOrganization',instance)]).
adjMapping2SUMO('03095964-a',[ ('Nation',instance)]).
adjMapping2SUMO('03096141-a',[ ('Building',subsumption)]).
adjMapping2SUMO('03096269-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03096448-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03096635-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('03096747-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('03096931-a',[ ('Nation',instance)]).
adjMapping2SUMO('03097103-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('03097289-a',[ ('Separating',subsumption)]).
adjMapping2SUMO('03097502-a',[ (part,subsumption)]).
adjMapping2SUMO('03097689-a',[ ('ContentBearingObject',subsumption)]).
adjMapping2SUMO('03097826-a',[ ('Carbohydrate',subsumption)]).
adjMapping2SUMO('03097952-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03098096-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03098252-a',[ ('LandArea',subsumption)]).
adjMapping2SUMO('03098390-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('03098491-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('03098628-a',[ ('ReligiousOrganization',subsumption)]).
adjMapping2SUMO('03098803-a',[ ('Corporation',subsumption)]).
adjMapping2SUMO('03099131-a',[ ('',undefined)]).
adjMapping2SUMO('03099259-a',[ ('Music',subsumption)]).
adjMapping2SUMO('03099392-a',[ ('',undefined)]).
adjMapping2SUMO('03099549-a',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('03099638-a',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('03099742-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('03099928-a',[ ('Gland',subsumption)]).
adjMapping2SUMO('03100026-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03100184-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('03100315-a',[ ('Pursuing',subsumption)]).
adjMapping2SUMO('03100479-a',[ ('Gland',subsumption)]).
adjMapping2SUMO('03100611-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('03100751-a',[ ('Relation',subsumption)]).
adjMapping2SUMO('03100921-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03101056-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('03101227-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('03101415-a',[ ('',undefined)]).
adjMapping2SUMO('03101553-a',[ (earlier,subsumption)]).
adjMapping2SUMO('03101667-a',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('03101818-a',[ ('Position',subsumption)]).
adjMapping2SUMO('03102110-a',[ ('ArtWork',subsumption)]).
adjMapping2SUMO('03102278-a',[ ('ParticleWord',subsumption)]).
adjMapping2SUMO('03102427-a',[ ('',undefined)]).
adjMapping2SUMO('03102558-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('03102723-a',[ ('GeopoliticalArea',subsumption)]).
adjMapping2SUMO('03102871-a',[ ('ProbabilityRelation',equivalence)]).
adjMapping2SUMO('03103058-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('03103198-a',[ ('Procedure',equivalence)]).
adjMapping2SUMO('03103380-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('03103520-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('03103655-a',[ ('Position',subsumption)]).
adjMapping2SUMO('03103815-a',[ ('Advertising',equivalence)]).
adjMapping2SUMO('03103932-a',[ (occupiesPosition,subsumption)]).
adjMapping2SUMO('03104040-a',[ (causes,subsumption)]).
adjMapping2SUMO('03104149-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('03104332-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03104461-a',[ ('Human',subsumption)]).
adjMapping2SUMO('03104585-a',[ ('Sport',subsumption)]).
adjMapping2SUMO('03104740-a',[ ('City',instance)]).
adjMapping2SUMO('03104988-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03105129-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03105296-a',[ ('',undefined)]).
adjMapping2SUMO('03105430-a',[ ('',undefined)]).
adjMapping2SUMO('03105571-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03105674-a',[ ('',undefined)]).
adjMapping2SUMO('03105742-a',[ ('',undefined)]).
adjMapping2SUMO('03105856-a',[ ('',undefined)]).
adjMapping2SUMO('03106005-a',[ ('',undefined)]).
adjMapping2SUMO('03106176-a',[ ('',undefined)]).
adjMapping2SUMO('03106279-a',[ ('',undefined)]).
adjMapping2SUMO('03106446-a',[ ('',undefined)]).
adjMapping2SUMO('03106565-a',[ ('',undefined)]).
adjMapping2SUMO('03106748-a',[ ('',undefined)]).
adjMapping2SUMO('03106846-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03107061-a',[ ('Human',instance)]).
adjMapping2SUMO('03107285-a',[ ('Text',subsumption)]).
adjMapping2SUMO('03107450-a',[ ('Dancing',subsumption)]).
adjMapping2SUMO('03107596-a',[ ('Nation',instance)]).
adjMapping2SUMO('03107801-a',[ ('ExponentiationFn',subsumption)]).
adjMapping2SUMO('03107913-a',[ ('ExponentiationFn',subsumption)]).
adjMapping2SUMO('03108077-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('03108193-a',[ ('Device',subsumption)]).
adjMapping2SUMO('03108429-a',[ ('TimeDuration',subsumption)]).
adjMapping2SUMO('03108623-a',[ ('',undefined)]).
adjMapping2SUMO('03108861-a',[ ('Human',instance)]).
adjMapping2SUMO('03109032-a',[ ('',undefined)]).
adjMapping2SUMO('03109141-a',[ ('',undefined)]).
adjMapping2SUMO('03109261-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('03109399-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03109663-a',[ ('MilitaryUnit',subsumption)]).
adjMapping2SUMO('03109795-a',[ ('Position',subsumption)]).
adjMapping2SUMO('03109963-a',[ (holdsRight,subsumption)]).
adjMapping2SUMO('03110183-a',[ ('FunctionQuantity',subsumption)]).
adjMapping2SUMO('03110322-a',[ ('Breathing',equivalence)]).
adjMapping2SUMO('03110485-a',[ ('Breathing',subsumption)]).
adjMapping2SUMO('03110610-a',[ ('Breathing',subsumption)]).
adjMapping2SUMO('03110741-a',[ ('LinguisticCommunication',subsumption)]).
adjMapping2SUMO('03110952-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03111065-a',[ ('Giving',subsumption)]).
adjMapping2SUMO('03111283-a',[ ('GeographicArea',instance)]).
adjMapping2SUMO('03111451-a',[ ('',undefined)]).
adjMapping2SUMO('03111573-a',[ ('',undefined)]).
adjMapping2SUMO('03111656-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('03111832-a',[ ('IntentionalProcess',subsumption)]).
adjMapping2SUMO('03112046-a',[ ('Nation',instance)]).
adjMapping2SUMO('03112177-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03112379-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('03112486-a',[ ('Nation',instance)]).
adjMapping2SUMO('03112615-a',[ ('GeographicArea',instance)]).
adjMapping2SUMO('03112747-a',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('03112867-a',[ ('TimeInterval',subsumption)]).
adjMapping2SUMO('03112989-a',[ ('',undefined)]).
adjMapping2SUMO('03113164-a',[ ('Bone',subsumption)]).
adjMapping2SUMO('03113271-a',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('03113404-a',[ ('GeographicArea',instance)]).
adjMapping2SUMO('03113562-a',[ ('Nation',instance)]).
adjMapping2SUMO('03113705-a',[ ('GeographicArea',instance)]).
adjMapping2SUMO('03113881-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03114139-a',[ ('Nation',instance)]).
adjMapping2SUMO('03114359-a',[ (inhabits,subsumption)]).
adjMapping2SUMO('03114508-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03114843-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03115053-a',[ ('Separating',subsumption)]).
adjMapping2SUMO('03115277-a',[ ('PsychologicalDysfunction',subsumption)]).
adjMapping2SUMO('03115436-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03115598-a',[ ('',undefined)]).
adjMapping2SUMO('03115693-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03115874-a',[ ('Language',subsumption)]).
adjMapping2SUMO('03116043-a',[ ('Nation',instance)]).
adjMapping2SUMO('03116224-a',[ ('Maintaining',subsumption)]).
adjMapping2SUMO('03116391-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('03116517-a',[ ('LandArea',instance)]).
adjMapping2SUMO('03116651-a',[ ('Nation',instance)]).
adjMapping2SUMO('03116809-a',[ ('Language',subsumption)]).
adjMapping2SUMO('03117012-a',[ ('',undefined)]).
adjMapping2SUMO('03117272-a',[ ('GeographicArea',instance)]).
adjMapping2SUMO('03117503-a',[ ('',undefined)]).
adjMapping2SUMO('03117653-a',[ ('City',instance)]).
adjMapping2SUMO('03117835-a',[ ('Nation',instance)]).
adjMapping2SUMO('03118050-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03118215-a',[ ('Language',subsumption)]).
adjMapping2SUMO('03118413-a',[ ('Nation',instance)]).
adjMapping2SUMO('03118661-a',[ ('Language',subsumption)]).
adjMapping2SUMO('03118790-a',[ ('Language',subsumption)]).
adjMapping2SUMO('03118960-a',[ ('',undefined)]).
adjMapping2SUMO('03119182-a',[ ('Nation',instance)]).
adjMapping2SUMO('03119441-a',[ ('Language',subsumption)]).
adjMapping2SUMO('03119608-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03119811-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03119937-a',[ ('',undefined)]).
adjMapping2SUMO('03120034-a',[ ('Text',subsumption)]).
adjMapping2SUMO('03120176-a',[ ('VisualAttribute',subsumption)]).
adjMapping2SUMO('03120323-a',[ ('Device',subsumption)]).
adjMapping2SUMO('03120454-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03120610-a',[ ('Organism',subsumption)]).
adjMapping2SUMO('03120681-a',[ ('UnilateralGetting',subsumption)]).
adjMapping2SUMO('03120834-a',[ ('Noun',equivalence)]).
adjMapping2SUMO('03121060-a',[ ('Verb',subsumption)]).
adjMapping2SUMO('03121212-a',[ ('Nation',instance)]).
adjMapping2SUMO('03121394-a',[ ('ElementalSubstance',subsumption)]).
adjMapping2SUMO('03121573-a',[ ('Island',instance)]).
adjMapping2SUMO('03121723-a',[ ('Nation',instance)]).
adjMapping2SUMO('03121855-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03121996-a',[ ('',undefined)]).
adjMapping2SUMO('03122108-a',[ ('',undefined)]).
adjMapping2SUMO('03122221-a',[ ('Island',instance)]).
adjMapping2SUMO('03122400-a',[ ('Nation',instance)]).
adjMapping2SUMO('03122633-a',[ ('Text',subsumption)]).
adjMapping2SUMO('03122750-a',[ ('Language',instance)]).
adjMapping2SUMO('03122923-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('03123013-a',[ ('Nation',instance)]).
adjMapping2SUMO('03123143-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('03123296-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('03123434-a',[ ('Device',subsumption)]).
adjMapping2SUMO('03123561-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('03123695-a',[ ('Dancing',equivalence)]).
adjMapping2SUMO('03123830-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('03123964-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03124111-a',[ ('',undefined)]).
adjMapping2SUMO('03124201-a',[ ('',undefined)]).
adjMapping2SUMO('03124290-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('03124392-a',[ ('StateOrProvince',instance)]).
adjMapping2SUMO('03124541-a',[ ('Fabric',equivalence)]).
adjMapping2SUMO('03124657-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03124786-a',[ ('SubatomicParticle',subsumption)]).
adjMapping2SUMO('03124931-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('03125096-a',[ ('Device',subsumption)]).
adjMapping2SUMO('03125227-a',[ (realization,subsumption)]).
adjMapping2SUMO('03125370-a',[ ('Island',instance)]).
adjMapping2SUMO('03125505-a',[ ('Nation',instance)]).
adjMapping2SUMO('03125643-a',[ ('Nation',instance)]).
adjMapping2SUMO('03125792-a',[ ('Position',subsumption)]).
adjMapping2SUMO('03125925-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('03126054-a',[ ('',undefined)]).
adjMapping2SUMO('03126175-a',[ ('Island',instance)]).
adjMapping2SUMO('03126310-a',[ ('',undefined)]).
adjMapping2SUMO('03126399-a',[ ('PureSubstance',subsumption)]).
adjMapping2SUMO('03126499-a',[ ('Text',subsumption)]).
adjMapping2SUMO('03126638-a',[ ('City',instance)]).
adjMapping2SUMO('03126787-a',[ ('',undefined)]).
adjMapping2SUMO('03126922-a',[ ('BiologicalAttribute',subsumption)]).
adjMapping2SUMO('03127030-a',[ ('Nation',instance)]).
adjMapping2SUMO('03127197-a',[ ('City',instance)]).
adjMapping2SUMO('03127324-a',[ ('',undefined)]).
adjMapping2SUMO('03127435-a',[ ('EducationalProcess',subsumption)]).
adjMapping2SUMO('03127583-a',[ ('Nation',instance)]).
adjMapping2SUMO('03127718-a',[ ('BodySubstance',subsumption)]).
adjMapping2SUMO('03127822-a',[ ('',undefined)]).
adjMapping2SUMO('03127937-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03128070-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03128193-a',[ ('Device',subsumption)]).
adjMapping2SUMO('03128327-a',[ ('TransportationDevice',subsumption)]).
adjMapping2SUMO('03128472-a',[ ('CognitiveAgent',instance)]).
adjMapping2SUMO('03128583-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('03128699-a',[ ('Clothing',subsumption)]).
adjMapping2SUMO('03128816-a',[ ('FieldOfStudy',instance)]).
adjMapping2SUMO('03128963-a',[ ('Bacterium',subsumption)]).
adjMapping2SUMO('03129098-a',[ ('Position',subsumption)]).
adjMapping2SUMO('03129222-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03129490-a',[ ('Noun',subsumption)]).
adjMapping2SUMO('03129648-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03129915-a',[ ('',undefined)]).
adjMapping2SUMO('03130073-a',[ ('GeopoliticalArea',instance)]).
adjMapping2SUMO('03130337-a',[ ('Food',subsumption)]).
adjMapping2SUMO('03130509-a',[ ('',undefined)]).
adjMapping2SUMO('03130585-a',[ ('Food',subsumption)]).
adjMapping2SUMO('03130689-a',[ ('Fabric',subsumption)]).
adjMapping2SUMO('03130858-a',[ ('Device',subsumption)]).
adjMapping2SUMO('03130962-a',[ ('Nation',instance)]).
adjMapping2SUMO('03131116-a',[ ('Nation',instance)]).
adjMapping2SUMO('03131331-a',[ ('Nation',instance)]).
adjMapping2SUMO('03131480-a',[ ('Nation',instance)]).
adjMapping2SUMO('03131633-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('03131750-a',[ ('Nation',instance)]).
adjMapping2SUMO('03131904-a',[ (believes,subsumption)]).
adjMapping2SUMO('03132067-a',[ ('Proposition',subsumption)]).
adjMapping2SUMO('03132185-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('03132360-a',[ ('GeographicArea',subsumption)]).
adjMapping2SUMO('03132560-a',[ ('AstronomicalBody',subsumption)]).
adjMapping2SUMO('03132715-a',[ ('CompoundSubstance',subsumption)]).
adjMapping2SUMO('03132826-a',[ ('EthnicGroup',instance)]).
adjMapping2SUMO('03132982-a',[ ('ColorAttribute',subsumption)]).
adjMapping2SUMO('03133141-a',[ ('ObjectAttitude',subsumption)]).
adjMapping2SUMO('03133413-a',[ ('North',subsumption)]).
adjMapping2SUMO('03133530-a',[ ('North',subsumption)]).
adjMapping2SUMO('03133666-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03133791-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03133883-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03133994-a',[ ('Mineral',subsumption)]).
adjMapping2SUMO('03134166-a',[ ('Human',instance)]).
adjMapping2SUMO('03134282-a',[ ('Human',instance)]).
adjMapping2SUMO('03134550-a',[ ('Meeting',subsumption)]).
adjMapping2SUMO('03134675-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03134771-a',[ ('PhysicalQuantity',subsumption)]).
adjMapping2SUMO('03134979-a',[ ('PhysicalQuantity',subsumption)]).
adjMapping2SUMO('03135137-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03135290-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03135403-a',[ ('Word',subsumption)]).
adjMapping2SUMO('03135608-a',[ ('',undefined)]).
adjMapping2SUMO('03135786-a',[ ('ReligiousProcess',subsumption)]).
adjMapping2SUMO('03135937-a',[ ('',undefined)]).
adjMapping2SUMO('03136057-a',[ ('',undefined)]).
adjMapping2SUMO('03136162-a',[ ('',undefined)]).
adjMapping2SUMO('03136242-a',[ ('',undefined)]).
adjMapping2SUMO('03136371-a',[ ('',undefined)]).
adjMapping2SUMO('03136487-a',[ ('',undefined)]).
adjMapping2SUMO('03136568-a',[ ('',undefined)]).
adjMapping2SUMO('03136699-a',[ ('',undefined)]).
adjMapping2SUMO('03136855-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('03136940-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('03137031-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('03137130-a',[ ('',undefined)]).
adjMapping2SUMO('03137260-a',[ ('Device',subsumption)]).
adjMapping2SUMO('03137397-a',[ ('LinguisticExpression',subsumption)]).
adjMapping2SUMO('03137558-a',[ ('FinancialTransaction',subsumption)]).
adjMapping2SUMO('03137726-a',[ ('Insect',subsumption)]).
adjMapping2SUMO('03137840-a',[ ('Insect',subsumption)]).
adjMapping2SUMO('03137958-a',[ ('Obligation',equivalence)]).
adjMapping2SUMO('03138122-a',[ ('Bird',subsumption)]).
adjMapping2SUMO('03138224-a',[ ('Bone',equivalence)]).
adjMapping2SUMO('03138396-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03138545-a',[ ('Bone',equivalence)]).
adjMapping2SUMO('03138664-a',[ ('Bone',equivalence)]).
adjMapping2SUMO('03138752-a',[ ('NormativeAttribute',subsumption)]).
adjMapping2SUMO('03138895-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03139045-a',[ ('Government',subsumption)]).
adjMapping2SUMO('03139235-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('03139363-a',[ ('Getting',subsumption)]).
adjMapping2SUMO('03139452-a',[ ('Bird',subsumption)]).
adjMapping2SUMO('03139585-a',[ ('OrganOrTissueProcess',subsumption)]).
adjMapping2SUMO('03139749-a',[ ('SocialInteraction',subsumption)]).
adjMapping2SUMO('03139930-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03140110-a',[ ('BodyPart',not(subsumption))]).
adjMapping2SUMO('03140220-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03140338-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03140494-a',[ ('',undefined)]).
adjMapping2SUMO('03140621-a',[ ('',undefined)]).
adjMapping2SUMO('03140707-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03140875-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03141026-a',[ ('Device',subsumption)]).
adjMapping2SUMO('03141177-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('03141315-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('03141421-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03141487-a',[ ('BodyPart',subsumption)]).
adjMapping2SUMO('03141609-a',[ ('Human',subsumption)]).
adjMapping2SUMO('03141756-a',[ ('Music',subsumption)]).
adjMapping2SUMO('03141878-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('03142022-a',[ ('',undefined)]).
adjMapping2SUMO('03142114-a',[ ('Bacterium',subsumption)]).
adjMapping2SUMO('03142313-a',[ ('PositionalAttribute',subsumption)]).
adjMapping2SUMO('03142399-a',[ ('',undefined)]).
adjMapping2SUMO('03142512-a',[ ('Plant',subsumption)]).
adjMapping2SUMO('03142636-a',[ ('PathologicProcess',subsumption)]).
adjMapping2SUMO('03142799-a',[ (capability,subsumption)]).
adjMapping2SUMO('03142927-a',[ ('',undefined)]).
adjMapping2SUMO('03143018-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03143155-a',[ ('',undefined)]).
adjMapping2SUMO('03143286-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03143374-a',[ ('Selling',subsumption)]).
adjMapping2SUMO('03143502-a',[ ('Tissue',subsumption)]).
adjMapping2SUMO('03143662-a',[ ('Organ',subsumption)]).
adjMapping2SUMO('03143794-a',[ ('Measuring',subsumption)]).
adjMapping2SUMO('03144004-a',[ (capability,subsumption)]).
adjMapping2SUMO('03144152-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03144265-a',[ ('Rodent',subsumption)]).
adjMapping2SUMO('03144356-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('03144441-a',[ ('',undefined)]).
adjMapping2SUMO('03144546-a',[ ('',undefined)]).
adjMapping2SUMO('03144729-a',[ ('Impelling',subsumption)]).
adjMapping2SUMO('03144862-a',[ ('',undefined)]).
adjMapping2SUMO('03144955-a',[ ('',undefined)]).
adjMapping2SUMO('03145054-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03145145-a',[ ('',undefined)]).
adjMapping2SUMO('03145310-a',[ ('',undefined)]).
adjMapping2SUMO('03145467-a',[ ('',undefined)]).
adjMapping2SUMO('03145622-a',[ ('',undefined)]).
adjMapping2SUMO('03145734-a',[ ('',undefined)]).
adjMapping2SUMO('03145851-a',[ ('',undefined)]).
adjMapping2SUMO('03145956-a',[ ('',undefined)]).
adjMapping2SUMO('03146117-a',[ ('',undefined)]).
adjMapping2SUMO('03146237-a',[ ('',undefined)]).
adjMapping2SUMO('03146310-a',[ ('',undefined)]).
adjMapping2SUMO('03146602-a',[ ('',undefined)]).
adjMapping2SUMO('03146895-a',[ ('',undefined)]).
adjMapping2SUMO('03147163-a',[ ('',undefined)]).
adjMapping2SUMO('03147281-a',[ ('',undefined)]).
adjMapping2SUMO('03147408-a',[ ('',undefined)]).
adjMapping2SUMO('03147543-a',[ ('ShapeChange',subsumption)]).
adjMapping2SUMO('03147643-a',[ ('',undefined)]).
adjMapping2SUMO('03147793-a',[ ('BodyMotion',subsumption)]).
adjMapping2SUMO('03147919-a',[ ('',undefined)]).
adjMapping2SUMO('03148137-a',[ ('',undefined)]).
adjMapping2SUMO('03148333-a',[ ('',undefined)]).
adjMapping2SUMO('03148487-a',[ ('',undefined)]).
adjMapping2SUMO('03148653-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('03148724-a',[ ('TimeDuration',subsumption)]).
adjMapping2SUMO('03148831-a',[ ('Device',subsumption)]).
adjMapping2SUMO('03149025-a',[ ('ShapeChange',subsumption)]).
adjMapping2SUMO('03149169-a',[ ('Artifact',subsumption)]).
adjMapping2SUMO('03149347-a',[ ('Guiding',subsumption)]).
adjMapping2SUMO('03149478-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03149619-a',[ ('On',subsumption)]).
adjMapping2SUMO('03149732-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03149843-a',[ (partiallyFills,subsumption)]).
adjMapping2SUMO('03149960-a',[ ('',undefined)]).
adjMapping2SUMO('03150124-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('03150301-a',[ ('',undefined)]).
adjMapping2SUMO('03150431-a',[ ('',undefined)]).
adjMapping2SUMO('03150569-a',[ ('Walking',subsumption)]).
adjMapping2SUMO('03150670-a',[ ('',undefined)]).
adjMapping2SUMO('03150897-a',[ ('DiseaseOrSyndrome',subsumption)]).
adjMapping2SUMO('03150985-a',[ ('Process',subsumption)]).
adjMapping2SUMO('03151122-a',[ ('ChemicalProcess',subsumption)]).
adjMapping2SUMO('03151302-a',[ (located,subsumption)]).
adjMapping2SUMO('03151423-a',[ ('ChemicalProcess',subsumption)]).
adjMapping2SUMO('03151582-a',[ ('ChemicalProcess',not(subsumption))]).
adjMapping2SUMO('03151711-a',[ ('ContentDevelopment',subsumption)]).
adjMapping2SUMO('03151871-a',[ ('SoundAttribute',subsumption)]).
adjMapping2SUMO('03152015-a',[ (agent,subsumption)]).
adjMapping2SUMO('03152135-a',[ ('',undefined)]).
adjMapping2SUMO('03152249-a',[ ('',undefined)]).
adjMapping2SUMO('03152350-a',[ ('',undefined)]).
adjMapping2SUMO('03152480-a',[ ('',undefined)]).
adjMapping2SUMO('03152577-a',[ ('IntentionalPsychologicalProcess',subsumption)]).
adjMapping2SUMO('03152759-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03152874-a',[ ('Pursuing',subsumption)]).
adjMapping2SUMO('03153018-a',[ ('SubjectiveAssessmentAttribute',subsumption)]).
adjMapping2SUMO('03153155-a',[ ('Creation',subsumption)]).
adjMapping2SUMO('03153255-a',[ ('Growth',subsumption)]).
adjMapping2SUMO('03153361-a',[ ('ShapeAttribute',subsumption)]).
adjMapping2SUMO('03153554-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('03153653-a',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('03153755-a',[ ('ShapeChange',subsumption)]).
adjMapping2SUMO('03153849-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('03153960-a',[ ('Removing',subsumption)]).
adjMapping2SUMO('03154143-a',[ ('ShapeChange',subsumption)]).
adjMapping2SUMO('03154289-a',[ ('Putting',subsumption)]).
adjMapping2SUMO('03154362-a',[ ('Attaching',subsumption)]).
adjMapping2SUMO('03154463-a',[ ('StateChange',subsumption)]).
adjMapping2SUMO('03154649-a',[ ('RadiatingSound',subsumption)]).
adjMapping2SUMO('03154786-a',[ ('Motion',subsumption)]).
adjMapping2SUMO('03154886-a',[ ('Pursuing',equivalence)]).
adjMapping2SUMO('03154986-a',[ ('Disseminating',subsumption)]).
adjMapping2SUMO('03155193-a',[ ('',undefined)]).
adjMapping2SUMO('03155306-a',[ ('',undefined)]).
