%%%
%%%	This file has been obtained from Mappings/WordNetMappings30-noun.txt
%%%
%%%	For each synset, we include a fact using "nounMapping2SUMO/2" where
%%%
%%%		-	The first argument is the synset itself
%%%		-	The second argument is the SUMO concept
%%%		-	The third argument is the type of relation between the synset and
%%%				the SUMO concept
%%%
%%%			The type of relations are
%%%
%%%			* equivalence (originally denoted by '=') (3401 occurrences)
%%%			* subsumption (originally denoted by '+') (69411 occurrences)
%%%			* instance (originally denoted by '@') (9853 occurrences)
%%%
%%%			and its complements:
%%%
%%%			* not(equivalence) (originally denoted by ':') (2 occurrences)
%%%			* not(subsumption) (originally denoted by '[') (29 occurrences)
%%%			* not(instance) (originally denoted by ']') (0 occurrences)
%%%
%%%	7 synsets are not correctly mapped to SUMO
%%%
%%%		-	1 synset(s) do not have mapping class and relation
%%%		-	0 synset(s) do not have mapping class
%%%		-	6 synset(s) do not have relation class

nounMapping2SUMO('00001740-n',[ ('Entity',equivalence)]).
nounMapping2SUMO('00001930-n',[ ('Physical',equivalence)]).
nounMapping2SUMO('00002137-n',[ ('Abstract',equivalence)]).
nounMapping2SUMO('00002452-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('00002684-n',[ ('CorpuscularObject',equivalence)]).
nounMapping2SUMO('00003553-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('00003993-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('00004258-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('00004475-n',[ ('Organism',equivalence)]).
nounMapping2SUMO('00005787-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('00005930-n',[ ('Human',subsumption)]).
nounMapping2SUMO('00006024-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('00006150-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('00006269-n',[ ('Organism',equivalence)]).
nounMapping2SUMO('00006400-n',[ ('Organism',equivalence)]).
nounMapping2SUMO('00006484-n',[ ('Cell',equivalence)]).
nounMapping2SUMO('00007347-n',[ ('Agent',equivalence)]).
nounMapping2SUMO('00007846-n',[ ('Human',equivalence)]).
nounMapping2SUMO('00015388-n',[ ('Animal',equivalence)]).
nounMapping2SUMO('00017222-n',[ ('Plant',equivalence)]).
nounMapping2SUMO('00019046-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('00019128-n',[ ('Artifact',not(equivalence))]).
nounMapping2SUMO('00019613-n',[ ('Object',equivalence)]).
nounMapping2SUMO('00020090-n',[ ('Object',equivalence)]).
nounMapping2SUMO('00020827-n',[ ('Object',equivalence)]).
nounMapping2SUMO('00021265-n',[ ('Food',equivalence)]).
nounMapping2SUMO('00021734-n',[ ('Food',equivalence)]).
nounMapping2SUMO('00021939-n',[ ('Artifact',equivalence)]).
nounMapping2SUMO('00022903-n',[ ('Artifact',equivalence)]).
nounMapping2SUMO('00023100-n',[ ('PsychologicalAttribute',equivalence)]).
nounMapping2SUMO('00023271-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('00023773-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('00024264-n',[ ('Attribute',equivalence)]).
nounMapping2SUMO('00024720-n',[ ('Attribute',equivalence)]).
nounMapping2SUMO('00026192-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('00027167-n',[ ('Region',equivalence)]).
nounMapping2SUMO('00027807-n',[ ('ShapeAttribute',equivalence)]).
nounMapping2SUMO('00028270-n',[ ('TimeMeasure',equivalence)]).
nounMapping2SUMO('00028651-n',[ ('SpaceRegion',equivalence)]).
nounMapping2SUMO('00029007-n',[ ('SpaceRegion',subsumption)]).
nounMapping2SUMO('00029114-n',[ ('SpaceRegion',subsumption)]).
nounMapping2SUMO('00029378-n',[ ('Process',equivalence)]).
nounMapping2SUMO('00029677-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00030358-n',[ ('IntentionalProcess',equivalence)]).
nounMapping2SUMO('00031264-n',[ ('Group',equivalence)]).
nounMapping2SUMO('00031921-n',[ ('BinaryRelation',equivalence)]).
nounMapping2SUMO('00032613-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('00032823-n',[ ('SocialInteraction',equivalence)]).
nounMapping2SUMO('00033020-n',[ ('ContentBearingObject',equivalence)]).
nounMapping2SUMO('00033615-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('00034213-n',[ ('Physical',equivalence)]).
nounMapping2SUMO('00034479-n',[ ('IntentionalProcess',equivalence)]).
nounMapping2SUMO('00034574-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00034777-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00034939-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00035189-n',[ ('IntentionalProcess',equivalence)]).
nounMapping2SUMO('00035697-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('00035891-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00036061-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00036299-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00036580-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00036762-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00037006-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00037090-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00037200-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00037396-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00038175-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00038262-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00038573-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00038863-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00039021-n',[ ('Transaction',equivalence)]).
nounMapping2SUMO('00039211-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00039297-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('00039545-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('00039740-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('00039916-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00039990-n',[ ('Transaction',subsumption)]).
nounMapping2SUMO('00040152-n',[ ('Transaction',equivalence)]).
nounMapping2SUMO('00040420-n',[ ('Transaction',subsumption)]).
nounMapping2SUMO('00040545-n',[ ('Transaction',subsumption)]).
nounMapping2SUMO('00040804-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('00040962-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00041188-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00041468-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00041614-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00041740-n',[ ('Bowling',equivalence)]).
nounMapping2SUMO('00041899-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00042311-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00042541-n',[ ('Birth',equivalence)]).
nounMapping2SUMO('00042757-n',[ ('Leaving',subsumption)]).
nounMapping2SUMO('00043116-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00043195-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('00043609-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00043902-n',[ ('Score',equivalence)]).
nounMapping2SUMO('00044150-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00044455-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00044673-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00044900-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00045114-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00045250-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00045646-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('00045907-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00046177-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00046344-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00046522-n',[ ('Touching',equivalence)]).
nounMapping2SUMO('00047018-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00047106-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00047356-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00047550-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00047745-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00047941-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00048051-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00048225-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00048374-n',[ ('Arriving',subsumption)]).
nounMapping2SUMO('00048656-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00048828-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00049003-n',[ ('Arriving',subsumption)]).
nounMapping2SUMO('00049344-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00049530-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00049636-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00049789-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00049909-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00050037-n',[ ('Registering',subsumption)]).
nounMapping2SUMO('00050195-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('00050484-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('00050693-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('00050887-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('00051077-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('00051192-n',[ ('Returning',subsumption)]).
nounMapping2SUMO('00051385-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00051525-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00051712-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00051897-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00052052-n',[ ('Arriving',subsumption)]).
nounMapping2SUMO('00052146-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00052334-n',[ ('Arriving',subsumption)]).
nounMapping2SUMO('00052500-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00052791-n',[ ('Landing',subsumption)]).
nounMapping2SUMO('00053020-n',[ ('Leaving',subsumption)]).
nounMapping2SUMO('00053097-n',[ ('Leaving',equivalence)]).
nounMapping2SUMO('00053405-n',[ ('Leaving',subsumption)]).
nounMapping2SUMO('00053525-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('00053609-n',[ ('Disappearing',subsumption)]).
nounMapping2SUMO('00053806-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('00053913-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00054328-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00054483-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00054652-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00054821-n',[ ('Evacuation',equivalence)]).
nounMapping2SUMO('00055038-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00055227-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00055315-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00055633-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00055793-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00055932-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('00056087-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00056311-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00056551-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00056688-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00056912-n',[ ('Returning',subsumption)]).
nounMapping2SUMO('00057162-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00057306-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00057486-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00057657-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00057748-n',[ ('Battle',subsumption)]).
nounMapping2SUMO('00058002-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00058247-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00058337-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00058519-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00058608-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00058743-n',[ ('Escaping',subsumption)]).
nounMapping2SUMO('00059127-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00059376-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00059552-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00059728-n',[ ('Embracing',subsumption)]).
nounMapping2SUMO('00059895-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00059989-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00060201-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00060414-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00060548-n',[ ('Escaping',instance)]).
nounMapping2SUMO('00060747-n',[ ('Escaping',subsumption)]).
nounMapping2SUMO('00060817-n',[ ('Organization',instance)]).
nounMapping2SUMO('00061014-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00061171-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00061290-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00061453-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00061598-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00061792-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00061917-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00062133-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('00062331-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('00062451-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00062671-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00062806-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00063014-n',[ ('BreakingRecord',equivalence)]).
nounMapping2SUMO('00063310-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00063559-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00063652-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00064018-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00064151-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00064370-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00064504-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00064789-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00065098-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00065216-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00065336-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00065418-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00065575-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00065855-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00066075-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('00066216-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00066397-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00066636-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00066901-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00067153-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00067254-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00067397-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00067526-n',[ ('Lost',equivalence)]).
nounMapping2SUMO('00067707-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00067990-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00068170-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00068333-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00068617-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00068755-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00068901-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00069060-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00069173-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00069444-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00069604-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00069685-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00069815-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00069918-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00070077-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00070215-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00070363-n',[ ('DirectionalAttribute',subsumption)]).
nounMapping2SUMO('00070462-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00070641-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00070807-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00070965-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00071546-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00071700-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00071864-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00072068-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00072261-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00072473-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('00072691-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00072808-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('00073032-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00073177-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('00073525-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('00073713-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00073828-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00074092-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00074324-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00074524-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00074624-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00074790-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00075283-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00075471-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00075618-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00075790-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00075912-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00076072-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00076196-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00076323-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00076393-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00076563-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00076884-n',[ ('Falling',subsumption)]).
nounMapping2SUMO('00077169-n',[ ('Falling',subsumption)]).
nounMapping2SUMO('00077249-n',[ ('Falling',subsumption)]).
nounMapping2SUMO('00077419-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00077856-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00077981-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('00078217-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00078393-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00078536-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00078821-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00079018-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('00079212-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('00079398-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00079603-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00079752-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00079908-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('00080096-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('00080242-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00080474-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00080619-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00080743-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('00080968-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('00081174-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00081395-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('00081572-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('00081836-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00082081-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00082223-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('00082347-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('00082525-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00082754-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00082870-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00083260-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00083448-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('00083585-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00083729-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00083975-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00084371-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00084642-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00084895-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00085041-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00085219-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00085432-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00085678-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00085829-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00086140-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00086297-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00086547-n',[ ('SeizingProperty',subsumption)]).
nounMapping2SUMO('00086654-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('00086809-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00087073-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00087218-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00087423-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('00087663-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('00087849-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('00088154-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('00088367-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('00088481-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00088725-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00089027-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00089234-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00089351-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00089657-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00089891-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00090076-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00090253-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00090393-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('00090610-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00090779-n',[ ('UnilateralGiving',equivalence)]).
nounMapping2SUMO('00091013-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('00091234-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00091404-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00091503-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00091670-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00091779-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00091893-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00091977-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('00092212-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('00092366-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('00092663-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('00092847-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('00093006-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('00093127-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('00093354-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00093483-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00093874-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00094001-n',[ ('ReligiousProcess',equivalence)]).
nounMapping2SUMO('00094240-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00094500-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00094788-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('00094954-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('00095121-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('00095329-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('00095502-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00095873-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00095971-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00096211-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00096343-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00096513-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00096720-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00096851-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00096969-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00097122-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00097244-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('00097348-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('00097504-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00097923-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00098051-n',[ ('LinguisticCommunication',subsumption)]).
nounMapping2SUMO('00098385-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('00098625-n',[ ('Serving',equivalence)]).
nounMapping2SUMO('00098822-n',[ ('Serving',subsumption)]).
nounMapping2SUMO('00098939-n',[ ('Serving',subsumption)]).
nounMapping2SUMO('00099061-n',[ ('ValetParking',equivalence)]).
nounMapping2SUMO('00099267-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00099439-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00099588-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00099799-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00099951-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00100253-n',[ ('MusicalPerformance',equivalence)]).
nounMapping2SUMO('00100437-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('00100543-n',[ ('Performing',subsumption)]).
nounMapping2SUMO('00100889-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('00101003-n',[ ('Interpreting',subsumption)]).
nounMapping2SUMO('00101191-n',[ ('MakingInstrumentalMusic',equivalence)]).
nounMapping2SUMO('00101410-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00101570-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00101708-n',[ ('MakingInstrumentalMusic',subsumption)]).
nounMapping2SUMO('00101809-n',[ ('MakingInstrumentalMusic',subsumption)]).
nounMapping2SUMO('00102039-n',[ ('MakingInstrumentalMusic',subsumption)]).
nounMapping2SUMO('00102162-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('00102374-n',[ ('MusicalPerformance',subsumption)]).
nounMapping2SUMO('00102457-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00102779-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00102927-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00103140-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00103291-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00103419-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00103590-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00103737-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00103834-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00104088-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00104249-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00104409-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00104539-n',[ ('Throwing',subsumption)]).
nounMapping2SUMO('00104976-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00105164-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00105271-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00105479-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00105624-n',[ ('Throwing',subsumption)]).
nounMapping2SUMO('00105820-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00106104-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00106272-n',[ ('Pitching',subsumption)]).
nounMapping2SUMO('00106726-n',[ ('Throwing',subsumption)]).
nounMapping2SUMO('00106888-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00107016-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00107137-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00107279-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00107400-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00107551-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00107684-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00107875-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00108081-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00108181-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00108427-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00108545-n',[ ('Pitching',subsumption)]).
nounMapping2SUMO('00108665-n',[ ('Pitching',subsumption)]).
nounMapping2SUMO('00108818-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00108965-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00109081-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00109227-n',[ ('Pitching',subsumption)]).
nounMapping2SUMO('00109414-n',[ ('BaseballStrike',equivalence)]).
nounMapping2SUMO('00109771-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00109892-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00110057-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00110415-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00110554-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00110745-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00110834-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00110964-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00111222-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00111358-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00111503-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00111660-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00111839-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00111962-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00112072-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00112185-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00112312-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00112674-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00112828-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00112997-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00113113-n',[ ('Pushing',subsumption)]).
nounMapping2SUMO('00113532-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00113726-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00113954-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00114095-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00114298-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00114431-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00114871-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00115036-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00115292-n',[ ('Pulling',subsumption)]).
nounMapping2SUMO('00115500-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00115667-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00115803-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00116008-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00116122-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00116376-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00116687-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00116989-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00117124-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00117267-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00117578-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00117810-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00117959-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00118268-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00118445-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00118552-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00118733-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00119079-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00119210-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00119297-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00119402-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('00119568-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00119893-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00120010-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00120202-n',[ ('Jumping',subsumption)]).
nounMapping2SUMO('00120515-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00120647-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00120804-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00120943-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00121166-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00121366-n',[ ('Messaging',subsumption)]).
nounMapping2SUMO('00121645-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00121904-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00122106-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00122338-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00122530-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00122661-n',[ ('Shooting',equivalence)]).
nounMapping2SUMO('00122954-n',[ ('Shooting',equivalence)]).
nounMapping2SUMO('00123143-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00123234-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00123430-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00123652-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00123783-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00124008-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00124151-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00124256-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00124342-n',[ ('SkeetShooting',equivalence)]).
nounMapping2SUMO('00124536-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00124617-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00124766-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00124880-n',[ ('Touching',equivalence)]).
nounMapping2SUMO('00125126-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00125315-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00125436-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00125629-n',[ ('Impacting',equivalence)]).
nounMapping2SUMO('00126100-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00126236-n',[ ('Impacting',equivalence)]).
nounMapping2SUMO('00126447-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00126584-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00126721-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00126886-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00127021-n',[ ('Golf',equivalence)]).
nounMapping2SUMO('00127151-n',[ ('Pitching',subsumption)]).
nounMapping2SUMO('00127286-n',[ ('BaseballWalk',subsumption)]).
nounMapping2SUMO('00127531-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00127672-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00127866-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00128091-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00128324-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00128477-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00128638-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00128867-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00128976-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00129089-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00129317-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00129435-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00129527-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00129743-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00130093-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00130347-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00130512-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00130673-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00130846-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00130987-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00131090-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00131347-n',[ ('GameShot',subsumption)]).
nounMapping2SUMO('00131485-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00131608-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00131791-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00131877-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00131991-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00132105-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00132219-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00132355-n',[ ('HomeRun',equivalence)]).
nounMapping2SUMO('00132497-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00132601-n',[ ('BaseballSingle',subsumption)]).
nounMapping2SUMO('00132756-n',[ ('BaseballHit',subsumption)]).
nounMapping2SUMO('00132982-n',[ ('BaseballHit',subsumption)]).
nounMapping2SUMO('00133160-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00133234-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00133338-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00133567-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00133668-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00133875-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00133981-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00134099-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00134246-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00134391-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00134472-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00134574-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00134780-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00135148-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00135311-n',[ ('Poking',subsumption)]).
nounMapping2SUMO('00135504-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00135637-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00135799-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00135952-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00136048-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00136152-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00136230-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00136329-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00136691-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00136876-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00136984-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00137279-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00137534-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00137709-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('00137877-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00138078-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00138221-n',[ ('Kissing',subsumption)]).
nounMapping2SUMO('00138441-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00138599-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00138734-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00138799-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00138956-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00139544-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00139758-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00139919-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00140112-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00140264-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00140393-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00140652-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00140900-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00141027-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00141176-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00141396-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00141669-n',[ ('CheckInService',equivalence)]).
nounMapping2SUMO('00141806-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00142140-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00142361-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00142665-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('00143057-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00143251-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00143536-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00143626-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00143763-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00143885-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00144182-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00144445-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00144632-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00144778-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00145024-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00145218-n',[ ('Touching',equivalence)]).
nounMapping2SUMO('00145779-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00145929-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00146111-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00146277-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00146443-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00146572-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00146856-n',[ ('Meeting',equivalence)]).
nounMapping2SUMO('00147091-n',[ ('Meeting',equivalence)]).
nounMapping2SUMO('00147187-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('00147314-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00147454-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00147595-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00147862-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00148057-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00148242-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00148446-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00148653-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00148762-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00148836-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00148978-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00149084-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00149262-n',[ ('Detaching',subsumption)]).
nounMapping2SUMO('00149508-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00149699-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00149895-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00150097-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00150228-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00150379-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00150591-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00150762-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00150932-n',[ ('Tracing',subsumption)]).
nounMapping2SUMO('00151087-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('00151314-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('00151409-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('00151497-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('00151914-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('00152018-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('00152230-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('00152338-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00152519-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00152727-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('00152990-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('00153105-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('00153288-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('00153499-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('00153665-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('00153809-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('00153961-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00154233-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00154433-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00154689-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00154894-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00155085-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00155298-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('00155487-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('00155797-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('00155970-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('00156119-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('00156293-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('00156390-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00156625-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00156812-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00157081-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00157318-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00157463-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00157687-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00157877-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00157957-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00158185-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00158443-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00158805-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('00158996-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('00159177-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00159396-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00159620-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00159899-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('00160073-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('00160297-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00160415-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00160532-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00160688-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00160922-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00161044-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00161243-n',[ ('Selecting',equivalence)]).
nounMapping2SUMO('00161603-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00161739-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00161888-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00162055-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00162236-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00162417-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('00162632-n',[ ('Deciding',subsumption)]).
nounMapping2SUMO('00163047-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00163233-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00163406-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00163630-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00163779-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('00164152-n',[ ('Appointing',subsumption)]).
nounMapping2SUMO('00164345-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00164579-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00164801-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00164999-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00165178-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00165298-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00165563-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('00165793-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00165942-n',[ ('Deciding',equivalence)]).
nounMapping2SUMO('00166172-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00166355-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00166552-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00166702-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00166865-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00167063-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00167278-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00167446-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00167580-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00167764-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00167950-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00168121-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00168237-n',[ ('Maneuver',equivalence)]).
nounMapping2SUMO('00168505-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00168658-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00168911-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00169047-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00169147-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00169305-n',[ ('FlyingAircraft',subsumption)]).
nounMapping2SUMO('00169522-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00169651-n',[ ('FlyingAircraft',subsumption)]).
nounMapping2SUMO('00169811-n',[ ('FlyingAircraft',subsumption)]).
nounMapping2SUMO('00170005-n',[ ('Flying',subsumption)]).
nounMapping2SUMO('00170172-n',[ ('Flying',subsumption)]).
nounMapping2SUMO('00170340-n',[ ('FlyingAircraft',subsumption)]).
nounMapping2SUMO('00170536-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00170643-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00170710-n',[ ('FlyingAircraft',subsumption)]).
nounMapping2SUMO('00170844-n',[ ('FlyingAircraft',subsumption)]).
nounMapping2SUMO('00171050-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00171249-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00171507-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00171618-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00171882-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00172073-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00172217-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00172347-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00172490-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00172598-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00172710-n',[ ('RelationalAttribute',subsumption)]).
nounMapping2SUMO('00173172-n',[ ('RelationalAttribute',subsumption)]).
nounMapping2SUMO('00173283-n',[ ('RelationalAttribute',subsumption)]).
nounMapping2SUMO('00173487-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00173761-n',[ ('Device',subsumption)]).
nounMapping2SUMO('00174003-n',[ ('Road',equivalence)]).
nounMapping2SUMO('00174127-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('00174260-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('00174412-n',[ ('Procedure',equivalence)]).
nounMapping2SUMO('00174663-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00174782-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00174950-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00175174-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('00175433-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('00175605-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00175875-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00176052-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00176312-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00176449-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00176609-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00176766-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00176994-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00177127-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('00177448-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('00177638-n',[ ('Device',subsumption)]).
nounMapping2SUMO('00177783-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('00178024-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00178177-n',[ ('Experimenting',subsumption)]).
nounMapping2SUMO('00178551-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('00178700-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('00178832-n',[ ('RelationalAttribute',subsumption)]).
nounMapping2SUMO('00178972-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00179125-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00179275-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00179380-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00179576-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00179683-n',[ ('Device',subsumption)]).
nounMapping2SUMO('00179916-n',[ ('Wing',equivalence)]).
nounMapping2SUMO('00180054-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00180228-n',[ ('Deciding',subsumption)]).
nounMapping2SUMO('00180413-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00180770-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00180962-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00181191-n',[ ('Voting',subsumption)]).
nounMapping2SUMO('00181373-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00181495-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00181640-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00181781-n',[ ('Election',equivalence)]).
nounMapping2SUMO('00182213-n',[ ('Voting',subsumption)]).
nounMapping2SUMO('00182435-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00182571-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00182723-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00182897-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00183084-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00183240-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00183357-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00183505-n',[ ('Voting',subsumption)]).
nounMapping2SUMO('00183995-n',[ ('Voting',subsumption)]).
nounMapping2SUMO('00184135-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00184362-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00184501-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('00184652-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('00184802-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00184981-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00185104-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('00185307-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('00185438-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('00185612-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('00185778-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00186251-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('00186549-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('00186634-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00187056-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('00187144-n',[ ('Score',equivalence)]).
nounMapping2SUMO('00187337-n',[ ('Score',subsumption)]).
nounMapping2SUMO('00187499-n',[ ('Score',subsumption)]).
nounMapping2SUMO('00187710-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('00187890-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('00188007-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('00188183-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00188341-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('00188449-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00188620-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00188766-n',[ ('FootballTouchdown',subsumption)]).
nounMapping2SUMO('00188934-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00189106-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00189257-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00189476-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('00189565-n',[ ('BaseballRun',subsumption)]).
nounMapping2SUMO('00189896-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00190040-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00190180-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00190338-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('00190431-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00190579-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00190783-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00190931-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00191142-n',[ ('Process',equivalence)]).
nounMapping2SUMO('00191980-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00192149-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00192300-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00192457-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00192613-n',[ ('Saving',subsumption)]).
nounMapping2SUMO('00192910-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00193099-n',[ ('Saving',subsumption)]).
nounMapping2SUMO('00193225-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00193406-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00193622-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00193811-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00194005-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00194127-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00194257-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00194414-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00194645-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00194831-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00194969-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00195194-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00195415-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00195569-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00195938-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00196084-n',[ ('Substituting',subsumption)]).
nounMapping2SUMO('00196402-n',[ ('Substituting',subsumption)]).
nounMapping2SUMO('00196485-n',[ ('Substituting',subsumption)]).
nounMapping2SUMO('00196848-n',[ ('Substituting',subsumption)]).
nounMapping2SUMO('00197136-n',[ ('Substituting',subsumption)]).
nounMapping2SUMO('00197229-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00197419-n',[ ('Substituting',subsumption)]).
nounMapping2SUMO('00197610-n',[ ('Substituting',subsumption)]).
nounMapping2SUMO('00197772-n',[ ('Substituting',subsumption)]).
nounMapping2SUMO('00198118-n',[ ('Substituting',subsumption)]).
nounMapping2SUMO('00198270-n',[ ('Substituting',subsumption)]).
nounMapping2SUMO('00198451-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00198631-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00198793-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00198919-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00199130-n',[ ('Process',equivalence)]).
nounMapping2SUMO('00199707-n',[ ('Process',equivalence)]).
nounMapping2SUMO('00200041-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('00200244-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00200379-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00200563-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('00200768-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00201058-n',[ ('Translocation',equivalence)]).
nounMapping2SUMO('00201269-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00201397-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00201516-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00201671-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00201923-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00202284-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00202620-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00202816-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('00203020-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00203208-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00203342-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00203649-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00203753-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00204022-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00204199-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00204334-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00204439-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('00204659-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('00204814-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00204943-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00205079-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00205349-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('00205543-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('00205649-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00205891-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('00206130-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00206302-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00206600-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00206779-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00206927-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00207306-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00207434-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00207622-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00207761-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00208141-n',[ ('Removing',instance)]).
nounMapping2SUMO('00208277-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00208521-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00208694-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00208797-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00208943-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00209132-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00209301-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00209446-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00209546-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00209680-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00209789-n',[ ('Voting',subsumption)]).
nounMapping2SUMO('00209943-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00210518-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00210797-n',[ ('EndFn',subsumption)]).
nounMapping2SUMO('00210940-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('00211110-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00211462-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00211593-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00211776-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00212065-n',[ ('Graduation',equivalence)]).
nounMapping2SUMO('00212205-n',[ ('Unemployed',subsumption)]).
nounMapping2SUMO('00212377-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('00212551-n',[ ('Unemployed',subsumption)]).
nounMapping2SUMO('00212678-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00212808-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('00213052-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('00213186-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('00213343-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('00213482-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('00213694-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('00213903-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00214148-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00214315-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00214526-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00214794-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('00215013-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00215314-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00215534-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00215683-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00215838-n',[ ('Subversion',equivalence)]).
nounMapping2SUMO('00216038-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00216174-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00216607-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00216723-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00216834-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00217014-n',[ ('Destruction',equivalence)]).
nounMapping2SUMO('00217499-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00217593-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00217773-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00218045-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00218208-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00218427-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00218602-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00218753-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00218902-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00219012-n',[ ('Killing',equivalence)]).
nounMapping2SUMO('00219463-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00219575-n',[ ('Killing',equivalence)]).
nounMapping2SUMO('00219738-n',[ ('Shooting',subsumption), ('Murder',subsumption)]).
nounMapping2SUMO('00219856-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00220023-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00220219-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00220409-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00220522-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00221056-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00221178-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00221343-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00221480-n',[ ('Murder',subsumption)]).
nounMapping2SUMO('00221596-n',[ ('Murder',subsumption)]).
nounMapping2SUMO('00221727-n',[ ('Murder',subsumption)]).
nounMapping2SUMO('00221819-n',[ ('Murder',subsumption)]).
nounMapping2SUMO('00221900-n',[ ('Murder',subsumption)]).
nounMapping2SUMO('00221981-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00222064-n',[ ('Murder',subsumption)]).
nounMapping2SUMO('00222155-n',[ ('Murder',subsumption)]).
nounMapping2SUMO('00222248-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00222376-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00222485-n',[ ('Suicide',subsumption)]).
nounMapping2SUMO('00222766-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00222939-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00223144-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00223268-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00223362-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00223575-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00223720-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00223854-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00223983-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00224260-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00224599-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00224738-n',[ ('Poisoning',subsumption)]).
nounMapping2SUMO('00224936-n',[ ('Poisoning',subsumption)]).
nounMapping2SUMO('00225070-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00225150-n',[ ('Shooting',subsumption), ('Murder',subsumption)]).
nounMapping2SUMO('00225361-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00225484-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00225593-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00225786-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00226107-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00226319-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00226511-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00226711-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00226951-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00227137-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00227264-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00227484-n',[ ('Stealing',subsumption)]).
nounMapping2SUMO('00227595-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00227848-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00227969-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00228078-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00228181-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('00228283-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00228535-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('00228762-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('00228911-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('00229034-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('00229260-n',[ ('CeasingOperations',subsumption)]).
nounMapping2SUMO('00229587-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00229688-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00229814-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00229934-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00230172-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('00230324-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00230475-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('00230703-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('00230824-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('00230997-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00231161-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00231315-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00231412-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00231567-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00231887-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00232147-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00232386-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00232604-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00232765-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00232863-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00233212-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00233386-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00233614-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00233795-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00233980-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00234105-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00234277-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00234423-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00234675-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00234892-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00235074-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00235208-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00235435-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00236194-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00236581-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00236821-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00236953-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('00237078-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('00237705-n',[ ('Repairing',subsumption)]).
nounMapping2SUMO('00237869-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('00238022-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00238326-n',[ ('TherapeuticProcess',subsumption), ('Cutting',subsumption)]).
nounMapping2SUMO('00238527-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00238778-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00238871-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00239024-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00239230-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00239483-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00239666-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00239766-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00239910-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00240184-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00240754-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00240938-n',[ ('Installing',subsumption)]).
nounMapping2SUMO('00241245-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00241507-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00241699-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00242003-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00242146-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00242431-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00242583-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00242808-n',[ ('PhysiologicProcess',subsumption)]).
nounMapping2SUMO('00243102-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('00243237-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00243373-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00243577-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00243662-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00243813-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00243918-n',[ ('Cooking',equivalence)]).
nounMapping2SUMO('00246341-n',[ ('Cooking',subsumption)]).
nounMapping2SUMO('00246460-n',[ ('Cooking',subsumption)]).
nounMapping2SUMO('00246552-n',[ ('Cooking',subsumption)]).
nounMapping2SUMO('00246754-n',[ ('Cooking',subsumption)]).
nounMapping2SUMO('00246940-n',[ ('Frying',equivalence)]).
nounMapping2SUMO('00247081-n',[ ('Cooking',subsumption)]).
nounMapping2SUMO('00247229-n',[ ('Cooking',subsumption)]).
nounMapping2SUMO('00247342-n',[ ('Cooking',subsumption)]).
nounMapping2SUMO('00247442-n',[ ('Cooking',subsumption)]).
nounMapping2SUMO('00247654-n',[ ('Cooking',subsumption)]).
nounMapping2SUMO('00247792-n',[ ('Cooking',subsumption)]).
nounMapping2SUMO('00247955-n',[ ('Cooking',subsumption)]).
nounMapping2SUMO('00248063-n',[ ('Cooking',subsumption)]).
nounMapping2SUMO('00248252-n',[ ('Cooking',subsumption)]).
nounMapping2SUMO('00248368-n',[ ('Cooking',subsumption)]).
nounMapping2SUMO('00248534-n',[ ('Cooking',subsumption)]).
nounMapping2SUMO('00248636-n',[ ('Cooking',subsumption)]).
nounMapping2SUMO('00248748-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00248977-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00249501-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00249780-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00249987-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00250143-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00250259-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('00250597-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00250710-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('00250882-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('00251013-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00251520-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00251636-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00251780-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00252020-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00252169-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00252307-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00252430-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00252662-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00252894-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00253070-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00253270-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00253395-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('00253577-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00253773-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00253919-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00254166-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00254415-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00254597-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00254769-n',[ ('HairRemoval',subsumption)]).
nounMapping2SUMO('00254922-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00255065-n',[ ('HairRemoval',subsumption)]).
nounMapping2SUMO('00255214-n',[ ('Washing',subsumption)]).
nounMapping2SUMO('00255450-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00255600-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00255710-n',[ ('Washing',subsumption)]).
nounMapping2SUMO('00256122-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00256217-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00256309-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00256407-n',[ ('Coloring',subsumption)]).
nounMapping2SUMO('00256501-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00256620-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00256746-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00256961-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00257115-n',[ ('Bathing',subsumption)]).
nounMapping2SUMO('00257228-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00257468-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00257580-n',[ ('Bathing',subsumption)]).
nounMapping2SUMO('00257770-n',[ ('Bathing',subsumption)]).
nounMapping2SUMO('00257969-n',[ ('Bathing',subsumption)]).
nounMapping2SUMO('00258093-n',[ ('Bathing',subsumption)]).
nounMapping2SUMO('00258301-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00258403-n',[ ('Bathing',subsumption)]).
nounMapping2SUMO('00258530-n',[ ('SteamBath',equivalence)]).
nounMapping2SUMO('00258695-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00258854-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00259177-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00259392-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00259544-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00259643-n',[ ('Transaction',subsumption)]).
nounMapping2SUMO('00259894-n',[ ('Transaction',subsumption)]).
nounMapping2SUMO('00260051-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00260494-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00260622-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00260881-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('00261029-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00261258-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00261405-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00261604-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00261797-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00261972-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00262249-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00262596-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00262743-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00262908-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00263000-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00263164-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00263272-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00263353-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00263492-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00263642-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00263813-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00263947-n',[ ('Coloring',subsumption)]).
nounMapping2SUMO('00264088-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00264192-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00264366-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00264529-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00264775-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00264913-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00265119-n',[ ('Repairing',subsumption)]).
nounMapping2SUMO('00265472-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00265773-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00265992-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00266149-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00266253-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00266401-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00266560-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00266645-n',[ ('Substituting',subsumption)]).
nounMapping2SUMO('00266806-n',[ ('Repairing',equivalence)]).
nounMapping2SUMO('00267217-n',[ ('Repairing',subsumption)]).
nounMapping2SUMO('00267349-n',[ ('Repairing',subsumption)]).
nounMapping2SUMO('00267522-n',[ ('Maintaining',equivalence)]).
nounMapping2SUMO('00267821-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00267917-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00268025-n',[ ('Substituting',subsumption)]).
nounMapping2SUMO('00268112-n',[ ('Repairing',subsumption)]).
nounMapping2SUMO('00268341-n',[ ('Repairing',subsumption)]).
nounMapping2SUMO('00268457-n',[ ('Repairing',subsumption)]).
nounMapping2SUMO('00268557-n',[ ('Repairing',equivalence)]).
nounMapping2SUMO('00268824-n',[ ('Repairing',subsumption)]).
nounMapping2SUMO('00269018-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00269258-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00269471-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00269674-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00269856-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00269963-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00270186-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00270275-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00270403-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00270539-n',[ ('Repairing',subsumption)]).
nounMapping2SUMO('00270648-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00270800-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00270919-n',[ ('Promise',subsumption)]).
nounMapping2SUMO('00271155-n',[ ('Promise',subsumption)]).
nounMapping2SUMO('00271263-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00271636-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00271879-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00272123-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00272303-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00272448-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00272713-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00272878-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00273077-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00273319-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00273449-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00273601-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00273690-n',[ ('Coloring',equivalence)]).
nounMapping2SUMO('00273877-n',[ ('Coloring',subsumption)]).
nounMapping2SUMO('00274009-n',[ ('Coloring',subsumption)]).
nounMapping2SUMO('00274206-n',[ ('Coloring',subsumption)]).
nounMapping2SUMO('00274437-n',[ ('Coloring',subsumption)]).
nounMapping2SUMO('00274586-n',[ ('Coloring',subsumption)]).
nounMapping2SUMO('00274707-n',[ ('Coloring',subsumption)]).
nounMapping2SUMO('00274941-n',[ ('Coloring',equivalence)]).
nounMapping2SUMO('00275151-n',[ ('Coloring',subsumption)]).
nounMapping2SUMO('00275307-n',[ ('Coloring',subsumption)]).
nounMapping2SUMO('00275424-n',[ ('Coloring',subsumption)]).
nounMapping2SUMO('00275572-n',[ ('Coloring',subsumption)]).
nounMapping2SUMO('00275751-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('00276189-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00276342-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00276620-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00276813-n',[ ('Coloring',equivalence)]).
nounMapping2SUMO('00276987-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00277267-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00277376-n',[ ('Wetting',equivalence)]).
nounMapping2SUMO('00277569-n',[ ('Wetting',subsumption)]).
nounMapping2SUMO('00277811-n',[ ('Wetting',subsumption)]).
nounMapping2SUMO('00278040-n',[ ('Wetting',subsumption)]).
nounMapping2SUMO('00278221-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00278403-n',[ ('Wetting',equivalence)]).
nounMapping2SUMO('00278555-n',[ ('Wetting',subsumption)]).
nounMapping2SUMO('00278810-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00279136-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00279235-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00279377-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00279534-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00279674-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00279835-n',[ ('Translocation',equivalence)]).
nounMapping2SUMO('00280586-n',[ ('Transfer',equivalence)]).
nounMapping2SUMO('00280853-n',[ ('Arriving',subsumption)]).
nounMapping2SUMO('00281132-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00281291-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00281462-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00281752-n',[ ('Landing',subsumption)]).
nounMapping2SUMO('00281898-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00282050-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00282485-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00282613-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('00282840-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00282953-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00283127-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00283450-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00283568-n',[ ('Walking',equivalence)]).
nounMapping2SUMO('00283951-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00284101-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00284409-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00284544-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00284665-n',[ ('Walking',equivalence)]).
nounMapping2SUMO('00284798-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00285141-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00285387-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('00285557-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00285889-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00286112-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00286240-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00286360-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00286497-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00286756-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00286957-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00287142-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00287276-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00287449-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00287561-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00287762-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00287889-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00288000-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00288190-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00288384-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00288486-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00288671-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00288880-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00288970-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00289175-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00289267-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00289388-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00289555-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00289659-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00289737-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00289906-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00290015-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00290125-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00290276-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00290406-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00290579-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00291004-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00291154-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00291286-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00291400-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00291663-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00291796-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00291876-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00291965-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00292125-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00292269-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00292386-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00292599-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00292712-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00292981-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00293125-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00293307-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00293417-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00293545-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00293657-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00293753-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00293916-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00294190-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00294366-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00294452-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00294577-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00294748-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00294868-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00295172-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00295422-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00295563-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00295701-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00296263-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00296478-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00296585-n',[ ('Translocation',equivalence)]).
nounMapping2SUMO('00296946-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00297062-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00297318-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00297404-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00297532-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00297657-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00297863-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00297951-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00298047-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00298161-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00298351-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00298497-n',[ ('Driving',equivalence)]).
nounMapping2SUMO('00299112-n',[ ('Driving',subsumption)]).
nounMapping2SUMO('00299217-n',[ ('HorseRiding',equivalence)]).
nounMapping2SUMO('00299680-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00299826-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00299933-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00300037-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00300113-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00300206-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00300333-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00300441-n',[ ('AirTransportation',subsumption)]).
nounMapping2SUMO('00301192-n',[ ('AirTransportation',subsumption)]).
nounMapping2SUMO('00301443-n',[ ('AirTransportation',subsumption)]).
nounMapping2SUMO('00301598-n',[ ('AirTransportation',subsumption)]).
nounMapping2SUMO('00301728-n',[ ('AirTransportation',subsumption)]).
nounMapping2SUMO('00301857-n',[ ('AirTransportation',subsumption)]).
nounMapping2SUMO('00302001-n',[ ('AirTransportation',subsumption)]).
nounMapping2SUMO('00302185-n',[ ('AirTransportation',subsumption)]).
nounMapping2SUMO('00302394-n',[ ('AirTransportation',subsumption)]).
nounMapping2SUMO('00302861-n',[ ('FlyingAircraft',subsumption)]).
nounMapping2SUMO('00303049-n',[ ('FlyingAircraft',subsumption)]).
nounMapping2SUMO('00303221-n',[ ('AirTransportation',subsumption)]).
nounMapping2SUMO('00303297-n',[ ('FlyingAircraft',subsumption)]).
nounMapping2SUMO('00303495-n',[ ('FlyingAircraft',subsumption)]).
nounMapping2SUMO('00303748-n',[ ('FlyingAircraft',subsumption)]).
nounMapping2SUMO('00303849-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00304040-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00304208-n',[ ('AirTransportation',subsumption)]).
nounMapping2SUMO('00304349-n',[ ('AirTransportation',subsumption)]).
nounMapping2SUMO('00304442-n',[ ('AirTransportation',subsumption)]).
nounMapping2SUMO('00304592-n',[ ('AirTransportation',subsumption)]).
nounMapping2SUMO('00304729-n',[ ('FlyingAircraft',subsumption)]).
nounMapping2SUMO('00304851-n',[ ('AirTransportation',subsumption)]).
nounMapping2SUMO('00305005-n',[ ('Landing',equivalence)]).
nounMapping2SUMO('00305153-n',[ ('Landing',equivalence)]).
nounMapping2SUMO('00305326-n',[ ('Landing',subsumption)]).
nounMapping2SUMO('00305519-n',[ ('Landing',subsumption)]).
nounMapping2SUMO('00305707-n',[ ('Landing',subsumption)]).
nounMapping2SUMO('00305858-n',[ ('Landing',subsumption)]).
nounMapping2SUMO('00305980-n',[ ('Landing',subsumption)]).
nounMapping2SUMO('00306102-n',[ ('TakingOff',equivalence)]).
nounMapping2SUMO('00306210-n',[ ('Flying',subsumption)]).
nounMapping2SUMO('00306318-n',[ ('AirTransportation',subsumption)]).
nounMapping2SUMO('00306426-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00306900-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00307102-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00307176-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('00307314-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00307455-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00307631-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00308073-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00308208-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00308279-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00308370-n',[ ('Translocation',equivalence)]).
nounMapping2SUMO('00308681-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00308779-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00308871-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00309011-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00309115-n',[ ('WaterTransportation',subsumption)]).
nounMapping2SUMO('00309276-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00309368-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00309540-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00309647-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00309802-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00309906-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00310063-n',[ ('Discovering',subsumption)]).
nounMapping2SUMO('00310201-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00310347-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00310425-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00310516-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00310666-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00311091-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00311195-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00311381-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00311528-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00311687-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00311809-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00312160-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00312266-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00312403-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00312553-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00312691-n',[ ('Translocation',equivalence)]).
nounMapping2SUMO('00312784-n',[ ('WaterTransportation',equivalence)]).
nounMapping2SUMO('00312932-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00313096-n',[ ('WaterTransportation',subsumption)]).
nounMapping2SUMO('00313245-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00313385-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00313502-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00313647-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00313806-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00313971-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00314094-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00314271-n',[ ('Building',subsumption)]).
nounMapping2SUMO('00314395-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00314469-n',[ ('Sailor',subsumption)]).
nounMapping2SUMO('00315307-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00315390-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00315534-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00315700-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00315830-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00315986-n',[ ('Transportation',equivalence)]).
nounMapping2SUMO('00316460-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00316594-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00316806-n',[ ('Transportation',instance)]).
nounMapping2SUMO('00316989-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00317207-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00317485-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00317594-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00317709-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00317917-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00318035-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('00318186-n',[ ('DeliveryService',subsumption)]).
nounMapping2SUMO('00318391-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('00318567-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00318735-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00319176-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00319312-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00319513-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00319608-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00319717-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00319825-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00319939-n',[ ('Pursuing',equivalence)]).
nounMapping2SUMO('00320284-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00320486-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00320625-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00320742-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00320852-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00321195-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00321562-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00321731-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00321956-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00322228-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00322391-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00322488-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00322634-n',[ ('Inserting',subsumption)]).
nounMapping2SUMO('00322778-n',[ ('Inserting',subsumption)]).
nounMapping2SUMO('00322962-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00323056-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00323152-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00323262-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00323436-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00323532-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00323766-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00323923-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00324056-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00324233-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00324384-n',[ ('MotionUpward',subsumption)]).
nounMapping2SUMO('00324699-n',[ ('MotionUpward',subsumption)]).
nounMapping2SUMO('00324834-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00324978-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00325110-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00325364-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00325502-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00325631-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00325785-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00325975-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00326094-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00326291-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00326440-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00326677-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00326809-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00327033-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00327134-n',[ ('FlyingAircraft',subsumption)]).
nounMapping2SUMO('00327279-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00327366-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00327510-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00327683-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00327824-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00328015-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00328230-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00328327-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00328502-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00328885-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00329031-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00329227-n',[ ('LiquidMotion',subsumption)]).
nounMapping2SUMO('00329468-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00329619-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00329819-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00329943-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00330035-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00330160-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00330457-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00330674-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('00330836-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00330984-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00331102-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00331531-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00331655-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00331950-n',[ ('BodyMotion',equivalence)]).
nounMapping2SUMO('00333037-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00333203-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00333366-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00333572-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00333733-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00333829-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00334174-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00334356-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00334509-n',[ ('Gesture',equivalence)]).
nounMapping2SUMO('00334711-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00334935-n',[ ('Poking',subsumption)]).
nounMapping2SUMO('00335285-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00335384-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00335653-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00335814-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00335988-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00336274-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00336430-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00336561-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00336654-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00336805-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00337078-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00337210-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00337486-n',[ ('EyeMotion',subsumption)]).
nounMapping2SUMO('00337605-n',[ ('EyeMotion',subsumption), ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('00337844-n',[ ('EyeMotion',subsumption), ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('00338088-n',[ ('EyeMotion',subsumption), ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('00338271-n',[ ('EyeMotion',subsumption)]).
nounMapping2SUMO('00338404-n',[ ('EyeMotion',subsumption), ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('00338641-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00338821-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00338994-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00339173-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00339463-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00339646-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00339776-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00339907-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00340192-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00340463-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00340662-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00340838-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00340989-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00341109-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00341243-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00341435-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00341548-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00341695-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00341890-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00342028-n',[ ('Rotating',subsumption)]).
nounMapping2SUMO('00342424-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00342565-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00342755-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00342916-n',[ ('Rotating',subsumption)]).
nounMapping2SUMO('00343091-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00343249-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00343606-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00343730-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00343894-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00344040-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00344259-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00344421-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00344699-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00344942-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00345149-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00345297-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00345454-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00345641-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00345817-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00345926-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00346095-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00346296-n',[ ('DirectionChange',equivalence)]).
nounMapping2SUMO('00346532-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('00346693-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('00346936-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('00347087-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('00347180-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00347359-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00347490-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00347652-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00347853-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00348008-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00348312-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('00348571-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00348801-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00348953-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00349080-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00349213-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00349369-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00349520-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00349705-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00349886-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('00350030-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('00350380-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('00350878-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00351000-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('00351168-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('00351334-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('00351485-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00351638-n',[ ('Decreasing',equivalence)]).
nounMapping2SUMO('00352331-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00352585-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00352683-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00352778-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00352861-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00353013-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00353100-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00353249-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00353469-n',[ ('Decreasing',equivalence)]).
nounMapping2SUMO('00353611-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00353782-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00353903-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00353992-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00354183-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00354342-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00354583-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00354785-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00354884-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00355252-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00355420-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00355547-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00355691-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00355919-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00356199-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00356367-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00356516-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('00356621-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00356790-n',[ ('Compressing',equivalence)]).
nounMapping2SUMO('00357023-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00357275-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00357451-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00357680-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00357906-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00358089-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00358290-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00358528-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00358702-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00358931-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00359135-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00359238-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00359492-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00359614-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00359822-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00359903-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00360143-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00360242-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00360404-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00360485-n',[ ('Decreasing',equivalence)]).
nounMapping2SUMO('00360601-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00360757-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00361041-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00361192-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00361333-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00361459-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00361684-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00361795-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00361932-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00362103-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00362258-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00362355-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00362546-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00362659-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00362862-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00363052-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00363260-n',[ ('Increasing',equivalence)]).
nounMapping2SUMO('00363788-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00364053-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00364260-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00364440-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00364600-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00364787-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00365012-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00365231-n',[ ('Increasing',equivalence)]).
nounMapping2SUMO('00365329-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00365471-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00365709-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00365995-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00366207-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00366317-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00366521-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00366675-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00366846-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00367066-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00367280-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00367427-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00367552-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00367768-n',[ ('Increasing',equivalence)]).
nounMapping2SUMO('00367976-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00368302-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00368515-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00368592-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00368939-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00369138-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00369399-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00369532-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('00369694-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00369802-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00370127-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00370261-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00370458-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00370688-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00370885-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00371059-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00371314-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00371487-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00371735-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00371846-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00372013-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00372226-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00372448-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('00372607-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('00372977-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('00373130-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00373278-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00373418-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('00373544-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00373862-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00374063-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00374224-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00374446-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00374677-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00374835-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00375071-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00375348-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00375625-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00375938-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00376063-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00376400-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00376715-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00376825-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00376994-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00377169-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00377364-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00377686-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00377813-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00377907-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('00378069-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('00378296-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('00378479-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('00378706-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('00378880-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('00378985-n',[ ('Combining',equivalence)]).
nounMapping2SUMO('00379422-n',[ ('Attaching',equivalence)]).
nounMapping2SUMO('00379588-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00379754-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00379993-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00380083-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('00380568-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('00380696-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('00380881-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('00380994-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('00381326-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00381567-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('00381680-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00382109-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('00382474-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00382739-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00382906-n',[ ('Detaching',subsumption)]).
nounMapping2SUMO('00383071-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00383281-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00383390-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00383606-n',[ ('Separating',equivalence)]).
nounMapping2SUMO('00383952-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00384329-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00384510-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00384658-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00384802-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00384933-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00385104-n',[ ('Separating',instance)]).
nounMapping2SUMO('00385266-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00385501-n',[ ('Detaching',subsumption)]).
nounMapping2SUMO('00385649-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00385791-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00386164-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00386345-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00386450-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00386553-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00386676-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00386915-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00387214-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00387326-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00387424-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00387526-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00387657-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00387897-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00388065-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00388210-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00388392-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00388710-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00388842-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00388959-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00389043-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00389135-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00389308-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00389508-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00389610-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00389763-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('00389953-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00390198-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00390445-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00390581-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00390735-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00390906-n',[ ('Detaching',equivalence)]).
nounMapping2SUMO('00391086-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00391293-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00391407-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00391599-n',[ ('Removing',equivalence)]).
nounMapping2SUMO('00392093-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00392335-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00392468-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00392582-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00392709-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00392848-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00392950-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00393161-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00393369-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00394242-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00394485-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00394610-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00394803-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00395017-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00395199-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00395333-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00395503-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00395654-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00395797-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00396029-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00396213-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00396344-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00396509-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00396642-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00396825-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00397010-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00397191-n',[ ('Text',subsumption)]).
nounMapping2SUMO('00397347-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00397545-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00397647-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00397760-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00397953-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00398427-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00398585-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00398704-n',[ ('Process',equivalence)]).
nounMapping2SUMO('00399030-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00399223-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00399393-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00399717-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00399846-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00400083-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00400278-n',[ ('Afforestation',equivalence)]).
nounMapping2SUMO('00400449-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00400645-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00400851-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00400995-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00401194-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00401314-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00401459-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00401639-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00401783-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00402128-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00402308-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00402535-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00402671-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00402789-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00402951-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00403092-n',[ ('Damaging',equivalence)]).
nounMapping2SUMO('00403334-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('00403466-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('00403783-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00403911-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00404058-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00404170-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00404403-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00404726-n',[ ('ShapeChange',subsumption)]).
nounMapping2SUMO('00404959-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00405106-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00405206-n',[ ('ShapeChange',subsumption)]).
nounMapping2SUMO('00405360-n',[ ('ShapeChange',subsumption)]).
nounMapping2SUMO('00405628-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00405766-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00405892-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00406007-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00406114-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00406234-n',[ ('ShapeChange',subsumption)]).
nounMapping2SUMO('00406365-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00406485-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00406612-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00406800-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00406939-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00407090-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('00407270-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00407407-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00407535-n',[ ('IntentionalProcess',equivalence)]).
nounMapping2SUMO('00409075-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00409211-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00409483-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00409823-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00409943-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00410096-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00410247-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('00411048-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00411235-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('00411384-n',[ ('Cooperation',equivalence)]).
nounMapping2SUMO('00411553-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00411717-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00411859-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00412006-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00412130-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('00412271-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00412449-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00412572-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00412727-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00412839-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00412982-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00413086-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00413239-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00413554-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00413674-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00413795-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00413904-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00414071-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00414179-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00414599-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00414790-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00414881-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00415000-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00415098-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00415226-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00415333-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00415442-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00415540-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00415676-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('00415988-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00416129-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00416216-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00416409-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00416646-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00416737-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00416914-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('00417005-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00417131-n',[ ('Confining',subsumption)]).
nounMapping2SUMO('00417397-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00417643-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00417859-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00418025-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00418305-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00418394-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00418615-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00418787-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00418903-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00419315-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00419464-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00419644-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00419908-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00420218-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00420336-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00420477-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00420712-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00420877-n',[ ('Poking',subsumption)]).
nounMapping2SUMO('00421047-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00421210-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00421321-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('00421437-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00422114-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('00422261-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('00422391-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('00422551-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00422719-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00422834-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00423028-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00423222-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00423423-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00423563-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00423769-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00423916-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00424034-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00424186-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00424324-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00424599-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00424767-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00424934-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00425090-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('00425182-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00425278-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00425451-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00425615-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00425781-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00425905-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00426275-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00426388-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00426526-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00426757-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00426928-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00427580-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00427853-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00428000-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('00428270-n',[ ('Dancing',equivalence)]).
nounMapping2SUMO('00429048-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00429322-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00429440-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00429713-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00429949-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00430140-n',[ ('Betting',subsumption)]).
nounMapping2SUMO('00430606-n',[ ('Game',equivalence)]).
nounMapping2SUMO('00431005-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00431292-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00431552-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00431893-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00432164-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00432356-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00432587-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00432689-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00432881-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00433113-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('00433216-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00433458-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00433661-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00433802-n',[ ('Gymnastics',equivalence)]).
nounMapping2SUMO('00434075-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00434231-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00434396-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00434568-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00434657-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00434844-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00435013-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00435182-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00435401-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00435563-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00435778-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00436187-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00436339-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00436609-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00436702-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00436817-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00436953-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00437067-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00437219-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00437321-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00437487-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00437639-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00437788-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00437929-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00438065-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00438338-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00438606-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00438725-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00438893-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00439043-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00439284-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00439484-n',[ ('Somersaulting',subsumption)]).
nounMapping2SUMO('00439749-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00439826-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00440039-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00440218-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00440382-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00440509-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00440643-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00440747-n',[ ('Skiing',equivalence)]).
nounMapping2SUMO('00440941-n',[ ('CrossCountrySkiing',equivalence)]).
nounMapping2SUMO('00441073-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00441235-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00441501-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00441686-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('00441824-n',[ ('WaterSport',equivalence)]).
nounMapping2SUMO('00442115-n',[ ('Swimming',equivalence)]).
nounMapping2SUMO('00442437-n',[ ('Swimming',equivalence)]).
nounMapping2SUMO('00442569-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00442654-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00442759-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00442847-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00442981-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00443231-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00443375-n',[ ('Prostrate',subsumption)]).
nounMapping2SUMO('00443517-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00443692-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00443803-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00443917-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00444142-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00444340-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00444490-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00444651-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00444846-n',[ ('ScubaDiving',equivalence)]).
nounMapping2SUMO('00444937-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00445055-n',[ ('Surfing',equivalence)]).
nounMapping2SUMO('00445226-n',[ ('WaterSkiing',equivalence)]).
nounMapping2SUMO('00445351-n',[ ('Rowing',equivalence)]).
nounMapping2SUMO('00445529-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00445685-n',[ ('Rowing',subsumption)]).
nounMapping2SUMO('00445802-n',[ ('Boxing',equivalence)]).
nounMapping2SUMO('00446311-n',[ ('Boxing',subsumption)]).
nounMapping2SUMO('00446411-n',[ ('Boxing',subsumption)]).
nounMapping2SUMO('00446493-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00446632-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00446804-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00446980-n',[ ('Archery',equivalence)]).
nounMapping2SUMO('00447073-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00447221-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00447361-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00447463-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00447540-n',[ ('Wrestling',equivalence)]).
nounMapping2SUMO('00447879-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00447957-n',[ ('Wrestling',subsumption)]).
nounMapping2SUMO('00448126-n',[ ('Wrestling',subsumption)]).
nounMapping2SUMO('00448232-n',[ ('Wrestling',subsumption)]).
nounMapping2SUMO('00448466-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00448640-n',[ ('IceSkating',equivalence)]).
nounMapping2SUMO('00448748-n',[ ('FigureSkating',equivalence)]).
nounMapping2SUMO('00448872-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00448958-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00449054-n',[ ('Skateboarding',equivalence)]).
nounMapping2SUMO('00449168-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('00449295-n',[ ('Racing',equivalence)]).
nounMapping2SUMO('00449517-n',[ ('CarRacing',equivalence)]).
nounMapping2SUMO('00449695-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('00449796-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('00449892-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('00449977-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('00450070-n',[ ('HorseRacing',equivalence)]).
nounMapping2SUMO('00450230-n',[ ('HorseRacing',subsumption)]).
nounMapping2SUMO('00450335-n',[ ('Equitation',equivalence)]).
nounMapping2SUMO('00450700-n',[ ('Equitation',subsumption)]).
nounMapping2SUMO('00450866-n',[ ('Equitation',subsumption)]).
nounMapping2SUMO('00450998-n',[ ('Equitation',subsumption)]).
nounMapping2SUMO('00451186-n',[ ('Equitation',subsumption)]).
nounMapping2SUMO('00451370-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00451563-n',[ ('Cycling',equivalence)]).
nounMapping2SUMO('00451635-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00451768-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00451866-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00452034-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00452152-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00452293-n',[ ('Hunting',subsumption)]).
nounMapping2SUMO('00452734-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00452864-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00452947-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00453126-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00453313-n',[ ('Hunting',subsumption)]).
nounMapping2SUMO('00453396-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00453478-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00453631-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00453731-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00453935-n',[ ('FishingSport',equivalence)]).
nounMapping2SUMO('00454121-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00454237-n',[ ('FishingSport',subsumption)]).
nounMapping2SUMO('00454395-n',[ ('FishingSport',subsumption)]).
nounMapping2SUMO('00454493-n',[ ('FishingSport',subsumption)]).
nounMapping2SUMO('00454624-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00454855-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00454983-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00455076-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00455173-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('00455348-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00455599-n',[ ('Game',equivalence)]).
nounMapping2SUMO('00456199-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00456465-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00456563-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00456690-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00456804-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00456899-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00457038-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00457228-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00457382-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00457723-n',[ ('GameShot',subsumption)]).
nounMapping2SUMO('00457890-n',[ ('GameShot',subsumption)]).
nounMapping2SUMO('00458094-n',[ ('GameShot',subsumption)]).
nounMapping2SUMO('00458286-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00458456-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00458641-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00458800-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00458890-n',[ ('VideoGame',equivalence)]).
nounMapping2SUMO('00459013-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00459284-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00459465-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00459570-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00459727-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00459845-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00459979-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00460078-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00460344-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00460541-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00460706-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00460844-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00460951-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00461162-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00461294-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00461402-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00461611-n',[ ('Curling',equivalence)]).
nounMapping2SUMO('00461782-n',[ ('Bowling',equivalence)]).
nounMapping2SUMO('00462116-n',[ ('BaseballInning',equivalence)]).
nounMapping2SUMO('00462241-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00462383-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00462557-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00462686-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00462804-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00462997-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00463116-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00463246-n',[ ('Sport',equivalence)]).
nounMapping2SUMO('00463543-n',[ ('IceHockey',equivalence)]).
nounMapping2SUMO('00464037-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00464277-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00464478-n',[ ('WaterSport',subsumption)]).
nounMapping2SUMO('00464651-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00464894-n',[ ('Golf',equivalence)]).
nounMapping2SUMO('00466273-n',[ ('Golf',subsumption)]).
nounMapping2SUMO('00466377-n',[ ('Golf',subsumption)]).
nounMapping2SUMO('00466524-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('00466630-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('00466712-n',[ ('MiniatureGolf',equivalence)]).
nounMapping2SUMO('00466880-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00467122-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00467320-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00467536-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00467719-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00467995-n',[ ('Hockey',subsumption)]).
nounMapping2SUMO('00468299-n',[ ('Hockey',subsumption)]).
nounMapping2SUMO('00468480-n',[ ('Football',subsumption)]).
nounMapping2SUMO('00469651-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00470554-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00470682-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00470830-n',[ ('Hockey',subsumption)]).
nounMapping2SUMO('00470966-n',[ ('Rugby',equivalence)]).
nounMapping2SUMO('00471277-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00471437-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00471613-n',[ ('Baseball',equivalence)]).
nounMapping2SUMO('00474568-n',[ ('Baseball',equivalence)]).
nounMapping2SUMO('00474657-n',[ ('Baseball',equivalence)]).
nounMapping2SUMO('00474769-n',[ ('Baseball',equivalence)]).
nounMapping2SUMO('00474881-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00475014-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00475142-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00475273-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00475403-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00475535-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00475661-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00475787-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00476140-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00476235-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00476389-n',[ ('Cricket',equivalence)]).
nounMapping2SUMO('00476788-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00476952-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00477097-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00477268-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00477392-n',[ ('Lacrosse',equivalence)]).
nounMapping2SUMO('00477639-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00477827-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00477986-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00478262-n',[ ('Soccer',equivalence)]).
nounMapping2SUMO('00478647-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00478855-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00479076-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00479440-n',[ ('Handball',equivalence)]).
nounMapping2SUMO('00479616-n',[ ('Racquetball',equivalence)]).
nounMapping2SUMO('00479734-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00479887-n',[ ('SquashSport',equivalence)]).
nounMapping2SUMO('00480211-n',[ ('Volleyball',equivalence)]).
nounMapping2SUMO('00480366-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00480508-n',[ ('Badminton',equivalence)]).
nounMapping2SUMO('00480885-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00480993-n',[ ('Basketball',equivalence)]).
nounMapping2SUMO('00481666-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00481803-n',[ ('Basketball',subsumption)]).
nounMapping2SUMO('00481938-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00482122-n',[ ('Netball',equivalence)]).
nounMapping2SUMO('00482298-n',[ ('Tennis',equivalence)]).
nounMapping2SUMO('00482892-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('00483098-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('00483205-n',[ ('Tennis',subsumption)]).
nounMapping2SUMO('00483313-n',[ ('Tennis',subsumption)]).
nounMapping2SUMO('00483409-n',[ ('Badminton',subsumption)]).
nounMapping2SUMO('00483508-n',[ ('Tennis',subsumption)]).
nounMapping2SUMO('00483605-n',[ ('Badminton',subsumption)]).
nounMapping2SUMO('00483705-n',[ ('Tennis',subsumption)]).
nounMapping2SUMO('00483848-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00483935-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00484362-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00484532-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00484802-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00484910-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00485081-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00485262-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00485450-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00485632-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00485815-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00485998-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00486130-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00486358-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00486490-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00486670-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00487072-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00487228-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00487326-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00487453-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00487617-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00487874-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00488051-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00488225-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00489475-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00489730-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00489933-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00490155-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00490350-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00490569-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00491037-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00491161-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00491366-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00491561-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00491713-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00491901-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00492083-n',[ ('Bed',subsumption)]).
nounMapping2SUMO('00492195-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00492309-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00492497-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00492724-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00492871-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00493031-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00493308-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00493742-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00493858-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00494100-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00494293-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00494406-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00494768-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00495103-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00495331-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00495524-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00495677-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00495774-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00496167-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00496437-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00496599-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00496760-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00496877-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00497060-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00497321-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00497425-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00497536-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00497713-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00497819-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00497924-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00498086-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00498220-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00498427-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00498558-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00498700-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00498828-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00498947-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00499066-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00499263-n',[ ('TableTennis',equivalence)]).
nounMapping2SUMO('00499477-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00499599-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00499924-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00500280-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00500449-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00500669-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00500927-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00501080-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00501304-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00501479-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00501722-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00501870-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00502030-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00502161-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00502415-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00502822-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00502952-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00503237-n',[ ('Chess',equivalence)]).
nounMapping2SUMO('00503981-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00504209-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00504325-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00504526-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00504660-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00504844-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00504975-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00505126-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00505238-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00505446-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00505615-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00505726-n',[ ('Chess',subsumption)]).
nounMapping2SUMO('00505871-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00506060-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00506207-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00506554-n',[ ('IntentionalPsychologicalProcess',subsumption)]).
nounMapping2SUMO('00506658-n',[ ('Betting',equivalence)]).
nounMapping2SUMO('00506919-n',[ ('Betting',subsumption)]).
nounMapping2SUMO('00507025-n',[ ('Betting',subsumption)]).
nounMapping2SUMO('00507162-n',[ ('Betting',subsumption)]).
nounMapping2SUMO('00507271-n',[ ('Betting',subsumption)]).
nounMapping2SUMO('00507425-n',[ ('Betting',subsumption)]).
nounMapping2SUMO('00507539-n',[ ('Betting',subsumption)]).
nounMapping2SUMO('00507673-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00507887-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00508091-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00508340-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00508547-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00508672-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00508800-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00508952-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00509302-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00509399-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00509566-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00509706-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00509846-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00510050-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00510189-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00510383-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00510475-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00510624-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('00510723-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00510922-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00511041-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00511212-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00511555-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00511676-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00511817-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00512267-n',[ ('Jumping',subsumption)]).
nounMapping2SUMO('00512351-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00512522-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('00512843-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00513089-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00513251-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00513401-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00513597-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00513761-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00513841-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00513952-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00514041-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00514128-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00514356-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00514471-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00514658-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00514787-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00515069-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00515159-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00515297-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00515414-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00515578-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00515684-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00515791-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00515952-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00516086-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00516381-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00516559-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00516720-n',[ ('OlympicGames',equivalence)]).
nounMapping2SUMO('00516900-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00517080-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00517231-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00517418-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00517564-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('00517728-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00518039-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00518152-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00518303-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00518442-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00518555-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00518669-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00518770-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('00519118-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('00519251-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00519333-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('00519492-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00519579-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00519669-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00519739-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('00519941-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('00520059-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00520257-n',[ ('Demonstrating',equivalence)]).
nounMapping2SUMO('00520672-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00520783-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00520880-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('00521085-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00521209-n',[ ('Demonstrating',subsumption)]).
nounMapping2SUMO('00521450-n',[ ('Demonstrating',subsumption)]).
nounMapping2SUMO('00521562-n',[ ('Demonstrating',subsumption)]).
nounMapping2SUMO('00521970-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('00522145-n',[ ('Demonstrating',subsumption)]).
nounMapping2SUMO('00522338-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00522537-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('00522736-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('00522939-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00523078-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00523148-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00523263-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('00523513-n',[ ('Sport',equivalence)]).
nounMapping2SUMO('00526259-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00526412-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00526663-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00526793-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00526948-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00527061-n',[ ('Phrase',equivalence)]).
nounMapping2SUMO('00527198-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00527319-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00527498-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00527695-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00527872-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00528059-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00528156-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00528298-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00528397-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00528667-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00529101-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00529224-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00529400-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00529511-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00529622-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00529784-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00529902-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00530018-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00530208-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00530386-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00530554-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00530755-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00530874-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00531077-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00531201-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00531355-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00531490-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00531745-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00531886-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00532110-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00532441-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00532567-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00532739-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00532896-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00533036-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00533224-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00533322-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00533404-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00533535-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00533691-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00533805-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00533922-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00534152-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00534344-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00534480-n',[ ('Rotating',subsumption)]).
nounMapping2SUMO('00534631-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00534849-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00535321-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00535455-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00535557-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00535732-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00535873-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00535956-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00536120-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00536249-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00536359-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00536516-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00536655-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00536778-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00536872-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00536964-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00537085-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00537192-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00537297-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00537423-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00537534-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00537682-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00538052-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00538144-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00538266-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00538368-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00538510-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00538668-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00538791-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00538876-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00538991-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00539121-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00539510-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00539674-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00539827-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00539951-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00540211-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00540396-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00540485-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00540616-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00540701-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00540895-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00541035-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00541178-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00541338-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00541479-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00541779-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00541972-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00542065-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00542149-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00542323-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00542458-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00542584-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00542711-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00542841-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00542992-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00543114-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('00543233-n',[ ('MakingMusic',equivalence)]).
nounMapping2SUMO('00544441-n',[ ('MakingInstrumentalMusic',subsumption)]).
nounMapping2SUMO('00544605-n',[ ('MakingInstrumentalMusic',subsumption)]).
nounMapping2SUMO('00544731-n',[ ('MakingInstrumentalMusic',subsumption)]).
nounMapping2SUMO('00544842-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('00545059-n',[ ('MakingInstrumentalMusic',subsumption)]).
nounMapping2SUMO('00545194-n',[ ('MakingInstrumentalMusic',subsumption)]).
nounMapping2SUMO('00545344-n',[ ('MakingVocalMusic',equivalence)]).
nounMapping2SUMO('00545501-n',[ ('MakingVocalMusic',equivalence)]).
nounMapping2SUMO('00546070-n',[ ('MakingVocalMusic',equivalence)]).
nounMapping2SUMO('00546216-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('00546299-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('00546389-n',[ ('MakingVocalMusic',equivalence)]).
nounMapping2SUMO('00546613-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('00546738-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('00546861-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('00546972-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('00547101-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('00547244-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('00547454-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('00547616-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('00547765-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00547960-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00548068-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00548173-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('00548326-n',[ ('DramaticActing',subsumption)]).
nounMapping2SUMO('00548802-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00549106-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00549284-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00549472-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00549610-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00549766-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('00550016-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00550242-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00550341-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00550545-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00550771-n',[ ('Performance',equivalence)]).
nounMapping2SUMO('00551215-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00551407-n',[ ('Performance',equivalence)]).
nounMapping2SUMO('00551508-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00551585-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00551714-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00551913-n',[ ('DramaticActing',subsumption)]).
nounMapping2SUMO('00552097-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00552219-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00552312-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00552436-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00552568-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00552679-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00552922-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00553173-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00553362-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00553655-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('00553823-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('00553995-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00554107-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00554200-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00554300-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00554433-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00554541-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00554726-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00554850-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00555138-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00555325-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00555525-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00555648-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00555983-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00556142-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00556313-n',[ ('Maneuver',equivalence)]).
nounMapping2SUMO('00556834-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00556992-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00557184-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00557287-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00557419-n',[ ('FootballPass',subsumption)]).
nounMapping2SUMO('00557588-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00557865-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00558008-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00558181-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00558396-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('00558630-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00558883-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00559329-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00559555-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00559724-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00559916-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00560141-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00560293-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00560529-n',[ ('FootballPass',subsumption)]).
nounMapping2SUMO('00560866-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('00561078-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00561226-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00561376-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00561570-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00561707-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00561820-n',[ ('FootballPass',subsumption)]).
nounMapping2SUMO('00561985-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00562179-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00562280-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00562398-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00562643-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00562823-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00562935-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00563097-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00563212-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00563330-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00563494-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00563665-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00563823-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00563998-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00564177-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00564373-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00564477-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00564583-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00564710-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00564897-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00565051-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00565219-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00565302-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00565809-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00566040-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00566135-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00566298-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00566690-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00566889-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00567044-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00567280-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00567418-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00567685-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00567896-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00568057-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00568166-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00568286-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00568430-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00568701-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00568813-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00569073-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00569234-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00569361-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00569474-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00569608-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00569733-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('00569898-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00570066-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00570366-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00570572-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00570683-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00570854-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00571060-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00571283-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00571444-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00571609-n',[ ('GolfManeuver',subsumption)]).
nounMapping2SUMO('00571956-n',[ ('GolfManeuver',subsumption)]).
nounMapping2SUMO('00572043-n',[ ('GolfManeuver',subsumption)]).
nounMapping2SUMO('00572285-n',[ ('GolfManeuver',subsumption)]).
nounMapping2SUMO('00572489-n',[ ('GolfDrive',equivalence)]).
nounMapping2SUMO('00572706-n',[ ('GolfManeuver',subsumption)]).
nounMapping2SUMO('00572838-n',[ ('GolfPutt',equivalence)]).
nounMapping2SUMO('00573106-n',[ ('Golf',subsumption)]).
nounMapping2SUMO('00573268-n',[ ('GolfManeuver',subsumption)]).
nounMapping2SUMO('00573530-n',[ ('GolfManeuver',subsumption)]).
nounMapping2SUMO('00573664-n',[ ('GolfManeuver',subsumption)]).
nounMapping2SUMO('00573775-n',[ ('GolfManeuver',subsumption)]).
nounMapping2SUMO('00573945-n',[ ('GolfManeuver',subsumption)]).
nounMapping2SUMO('00574077-n',[ ('GolfDrive',equivalence)]).
nounMapping2SUMO('00574227-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00574430-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00574608-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00574790-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00574925-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00575083-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00575214-n',[ ('Swimming',subsumption)]).
nounMapping2SUMO('00575365-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00575657-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00575741-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00576451-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00576717-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00576877-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00577068-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00577357-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('00577525-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00577749-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00577931-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00578154-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00578405-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00578549-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00578708-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00578795-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00579082-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00579201-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00579334-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00579564-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00579834-n',[ ('Transaction',subsumption)]).
nounMapping2SUMO('00579977-n',[ ('Transaction',subsumption)]).
nounMapping2SUMO('00580081-n',[ ('Transaction',subsumption)]).
nounMapping2SUMO('00580190-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00580370-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00580565-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00580880-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00580961-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00581090-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00581241-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('00581382-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('00581517-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00581621-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00581772-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00581885-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00581991-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00582071-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00582195-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00582388-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00582868-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00583089-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00583246-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('00583461-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('00583747-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('00583933-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00584160-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00584248-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00584367-n',[ ('Position',equivalence)]).
nounMapping2SUMO('00584769-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00584891-n',[ ('ServiceProcess',equivalence)]).
nounMapping2SUMO('00585018-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00585174-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00585406-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('00585660-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00585810-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00585964-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00586105-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('00586262-n',[ ('Position',equivalence)]).
nounMapping2SUMO('00588473-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00588598-n',[ ('Accountant',equivalence)]).
nounMapping2SUMO('00588703-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00588780-n',[ ('Ambassador',equivalence)]).
nounMapping2SUMO('00588881-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00588998-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00589103-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00589217-n',[ ('Attorney',equivalence)]).
nounMapping2SUMO('00589318-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00589415-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00589494-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00589596-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00589691-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00589769-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00589948-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00590047-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00590148-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00590269-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00590383-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00590518-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00590626-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00590806-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00590913-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00591006-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00591111-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00591236-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00591446-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00591523-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00591622-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00591725-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00591858-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00592001-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00592102-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00592199-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00592292-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00592367-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00592446-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00592535-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00592652-n',[ ('FlagOfficerRank',subsumption)]).
nounMapping2SUMO('00592795-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00592894-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00592999-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00593108-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00593219-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00593389-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00593512-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00593613-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00593732-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00593837-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00593944-n',[ ('Judge',equivalence)]).
nounMapping2SUMO('00594070-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00594146-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00594260-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00594374-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00594477-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00594580-n',[ ('USMilitaryRankO2',subsumption)]).
nounMapping2SUMO('00594738-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00594836-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00594953-n',[ ('Man',subsumption)]).
nounMapping2SUMO('00595032-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00595146-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00595333-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00595410-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00595545-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00595684-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00595785-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00595894-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00596081-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00596193-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00596290-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00596393-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00596496-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00596592-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00596692-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00596807-n',[ ('President',equivalence)]).
nounMapping2SUMO('00597265-n',[ ('President',subsumption)]).
nounMapping2SUMO('00597532-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00597629-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00597728-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00597821-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00597957-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00598056-n',[ ('Professor',equivalence)]).
nounMapping2SUMO('00598215-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00598318-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00598439-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00598678-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('00598767-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00598868-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00598970-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00599064-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00599234-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00599329-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00599472-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00599917-n',[ ('AttorneyGeneral',subsumption)]).
nounMapping2SUMO('00600200-n',[ ('Position',instance)]).
nounMapping2SUMO('00600435-n',[ ('Position',instance)]).
nounMapping2SUMO('00600655-n',[ ('SecretaryOfDefense',equivalence)]).
nounMapping2SUMO('00600871-n',[ ('Position',instance)]).
nounMapping2SUMO('00601088-n',[ ('Position',instance)]).
nounMapping2SUMO('00601296-n',[ ('Position',instance)]).
nounMapping2SUMO('00601557-n',[ ('Position',instance)]).
nounMapping2SUMO('00601822-n',[ ('Position',instance)]).
nounMapping2SUMO('00602026-n',[ ('Position',instance)]).
nounMapping2SUMO('00602220-n',[ ('SecretaryOfTheInterior',equivalence)]).
nounMapping2SUMO('00602448-n',[ ('SecretaryOfTheTreasury',equivalence)]).
nounMapping2SUMO('00602669-n',[ ('Position',instance)]).
nounMapping2SUMO('00602909-n',[ ('Position',instance)]).
nounMapping2SUMO('00603131-n',[ ('Position',instance)]).
nounMapping2SUMO('00603319-n',[ ('Position',instance)]).
nounMapping2SUMO('00603512-n',[ ('Position',instance)]).
nounMapping2SUMO('00603684-n',[ ('Position',instance)]).
nounMapping2SUMO('00603866-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('00603995-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('00604131-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00604228-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00604321-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00604424-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00604523-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00604694-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00604811-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00604910-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00605023-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00605246-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00605349-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00605430-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('00605511-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00605616-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00605715-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00605812-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00605909-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00606006-n',[ ('Woman',subsumption)]).
nounMapping2SUMO('00606119-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00606227-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00606370-n',[ ('OccupationalTrade',equivalence)]).
nounMapping2SUMO('00607075-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00607185-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00607293-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00607374-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00607458-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00607542-n',[ ('Carpenter',subsumption)]).
nounMapping2SUMO('00607775-n',[ ('Carpenter',subsumption)]).
nounMapping2SUMO('00608037-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('00608162-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('00608265-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00608354-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00608551-n',[ ('Designing',subsumption)]).
nounMapping2SUMO('00608645-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00608789-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00608896-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00609159-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00609236-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00609423-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00609506-n',[ ('Pilot',equivalence)]).
nounMapping2SUMO('00609669-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00609868-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00609953-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('00610222-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00610373-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('00610592-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('00610738-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('00611143-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('00611433-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00611674-n',[ ('Journalist',subsumption)]).
nounMapping2SUMO('00611874-n',[ ('Journalist',subsumption)]).
nounMapping2SUMO('00611972-n',[ ('GovernmentOfficer',subsumption)]).
nounMapping2SUMO('00612160-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('00613282-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('00613473-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('00613685-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('00613819-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('00613973-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('00614224-n',[ ('Writing',equivalence)]).
nounMapping2SUMO('00614489-n',[ ('Encoding',equivalence)]).
nounMapping2SUMO('00614730-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('00615011-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('00615182-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('00615336-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('00615462-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('00615659-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('00615887-n',[ ('Encoding',equivalence)]).
nounMapping2SUMO('00616083-n',[ ('Encoding',subsumption)]).
nounMapping2SUMO('00616279-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00616398-n',[ ('Text',subsumption)]).
nounMapping2SUMO('00616641-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00616807-n',[ ('Encoding',subsumption)]).
nounMapping2SUMO('00616951-n',[ ('Encoding',subsumption)]).
nounMapping2SUMO('00617059-n',[ ('Decoding',equivalence)]).
nounMapping2SUMO('00617337-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('00617601-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00617692-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00617865-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00617989-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00618119-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00618264-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00618436-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00618536-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00618642-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00618734-n',[ ('Accountant',subsumption)]).
nounMapping2SUMO('00619011-n',[ ('Accountant',subsumption)]).
nounMapping2SUMO('00619142-n',[ ('Accountant',subsumption)]).
nounMapping2SUMO('00619230-n',[ ('Accountant',subsumption)]).
nounMapping2SUMO('00619419-n',[ ('Accountant',subsumption)]).
nounMapping2SUMO('00619578-n',[ ('Accountant',subsumption)]).
nounMapping2SUMO('00619738-n',[ ('Accountant',subsumption)]).
nounMapping2SUMO('00619889-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00620084-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00620258-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00620424-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00620554-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00620752-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00621198-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00621326-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00621476-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00621627-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00622068-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00622266-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00622584-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00622859-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00622957-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00623052-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00623162-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00623370-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00623545-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00623670-n',[ ('Substituting',subsumption)]).
nounMapping2SUMO('00623862-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00624147-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00624285-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00624436-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00624553-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00624738-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00625427-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00625551-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00625699-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00625858-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00625993-n',[ ('Bodybuilding',subsumption)]).
nounMapping2SUMO('00626188-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00626423-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00626574-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00626728-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00626838-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00627013-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00627196-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00627321-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00627437-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00627664-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00627849-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00628131-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00628390-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00628539-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00628692-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00628883-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00629009-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('00629176-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00629318-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00629496-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00629597-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00629803-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00629911-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00630071-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00630268-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00630401-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00630526-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00630634-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00630786-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00630960-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00631168-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00631378-n',[ ('Position',equivalence)]).
nounMapping2SUMO('00631712-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00631887-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00632017-n',[ ('Dentist',subsumption)]).
nounMapping2SUMO('00632104-n',[ ('Lawyer',subsumption)]).
nounMapping2SUMO('00632201-n',[ ('MedicalDoctor',subsumption)]).
nounMapping2SUMO('00632342-n',[ ('MedicalDoctor',subsumption)]).
nounMapping2SUMO('00632531-n',[ ('MedicalDoctor',subsumption)]).
nounMapping2SUMO('00632716-n',[ ('MedicalDoctor',subsumption)]).
nounMapping2SUMO('00632820-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00633108-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00633329-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00633479-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00633613-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00633717-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00633864-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00634276-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00634586-n',[ ('Counting',equivalence)]).
nounMapping2SUMO('00635012-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00635205-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00635422-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('00635544-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00635699-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00635850-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00636461-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('00636728-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00636921-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00637145-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('00637354-n',[ ('Investigating',equivalence)]).
nounMapping2SUMO('00637546-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00637677-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00637810-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00637912-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00638080-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00638243-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('00638448-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('00638602-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('00638770-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('00639007-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('00639267-n',[ ('Experimenting',subsumption)]).
nounMapping2SUMO('00639398-n',[ ('Experimenting',subsumption)]).
nounMapping2SUMO('00639556-n',[ ('Experimenting',subsumption)]).
nounMapping2SUMO('00639833-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00639975-n',[ ('Experimenting',subsumption)]).
nounMapping2SUMO('00640188-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00640434-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00640560-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00640721-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00640889-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00641109-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00641222-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00641421-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00641522-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00641693-n',[ ('Investigating',instance)]).
nounMapping2SUMO('00641820-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00642045-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00642325-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00642446-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00642604-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00642762-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00642910-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00643067-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00643208-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00643389-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00643621-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00643772-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00643943-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00644156-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00644366-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00644503-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00644702-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00644967-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00645162-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00645365-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00645622-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00645843-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00646024-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00646187-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00646332-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00646504-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00646680-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00646833-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00647147-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00647270-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00647536-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00647713-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00647919-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('00648087-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('00648237-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00648542-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00648692-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00648790-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00648931-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00649090-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00649266-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00649482-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00649760-n',[ ('Dialysis',equivalence)]).
nounMapping2SUMO('00649992-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00650267-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00650402-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00650543-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00650743-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00650912-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00651088-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('00651176-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00651531-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('00651670-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('00651813-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('00651954-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00652069-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00652311-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00652466-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00652659-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00652803-n',[ ('Counting',subsumption)]).
nounMapping2SUMO('00652975-n',[ ('Counting',subsumption)]).
nounMapping2SUMO('00653171-n',[ ('Counting',subsumption)]).
nounMapping2SUMO('00653388-n',[ ('Counting',subsumption)]).
nounMapping2SUMO('00653518-n',[ ('Counting',subsumption)]).
nounMapping2SUMO('00653719-n',[ ('Counting',subsumption)]).
nounMapping2SUMO('00653811-n',[ ('Counting',subsumption)]).
nounMapping2SUMO('00653958-n',[ ('Counting',subsumption)]).
nounMapping2SUMO('00654113-n',[ ('Counting',subsumption)]).
nounMapping2SUMO('00654234-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00654400-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00654563-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00654683-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00654765-n',[ ('SurveillanceSystem',equivalence)]).
nounMapping2SUMO('00654885-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00655540-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00655727-n',[ ('ChildCareService',equivalence)]).
nounMapping2SUMO('00655878-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00656033-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00656192-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00656292-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00656386-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00656524-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00656643-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00656835-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00657080-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00657257-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00657420-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00657604-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00658082-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00658627-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00658796-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00658946-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00659048-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00659349-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00659667-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00659834-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00659946-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00660173-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00660324-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00660570-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('00660783-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00660957-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00661091-n',[ ('TherapeuticProcess',equivalence)]).
nounMapping2SUMO('00661847-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00662017-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00662196-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00662340-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00662527-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00662681-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00662972-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00663094-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00663333-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00663488-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00663714-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00663878-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00664110-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00664285-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00664388-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00664577-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00664849-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00664997-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00665079-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00665221-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00665358-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00665476-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00665679-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00665781-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00665970-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00666107-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00666232-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00666350-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00666468-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00666600-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00666733-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00666884-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00667096-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00667246-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00667384-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00667612-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00667847-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00668112-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00668404-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00668552-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00668736-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00668829-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00669000-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00669155-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00669262-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00669481-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00669687-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00669932-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00670105-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00670250-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00670703-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00670897-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00671022-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00671190-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00671351-n',[ ('Surgery',equivalence)]).
nounMapping2SUMO('00673109-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00673234-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00673347-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00673494-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00673578-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00673710-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00673863-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00674158-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00674562-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00674760-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00674864-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00675064-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00675219-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00675357-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00675540-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00675808-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00676160-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00676453-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00676693-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00676834-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00677038-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00677174-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00677299-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00677434-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00677613-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00677719-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00677808-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00678010-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00678425-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00678632-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00678752-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00678988-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00679140-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00679379-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00679566-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00679724-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00679910-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00680018-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00680183-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00680336-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00680511-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00680658-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00680803-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00680914-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00681071-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00681299-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00681441-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00681613-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00681869-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00682080-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00682243-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00682436-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00682538-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00682625-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00682738-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00682856-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00683012-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00683214-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00683358-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00683470-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00683590-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00683722-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00683915-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00684128-n',[ ('Detaching',subsumption)]).
nounMapping2SUMO('00684450-n',[ ('Detaching',subsumption)]).
nounMapping2SUMO('00684648-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00684837-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00684988-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00685196-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00685349-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00685508-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00685675-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00685837-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00686027-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00686168-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00686282-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00686385-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00686471-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00686570-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00686682-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00686826-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00686913-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00687027-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00687135-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00687252-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00687365-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00687472-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00687619-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00687769-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00687857-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00687964-n',[ ('Detaching',subsumption)]).
nounMapping2SUMO('00688098-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00688220-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00688317-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00688462-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00688557-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00688647-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00688766-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00688915-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00689062-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00689186-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00689302-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00689467-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00689550-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00689729-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00689995-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00690132-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00690281-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00690501-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00690848-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00690933-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00691050-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00691190-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00691330-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00691541-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00691648-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00691879-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00692130-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00692349-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00692506-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00692726-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00692840-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00692991-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00693109-n',[ ('Experimenting',subsumption)]).
nounMapping2SUMO('00693399-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00693679-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00694088-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00694276-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00694420-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00694578-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00694681-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('00694866-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00694990-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00695160-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00695300-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00695448-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00695717-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00695944-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00696147-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00696300-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00696487-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00696650-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00696882-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00697024-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00697249-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00697365-n',[ ('Injecting',equivalence)]).
nounMapping2SUMO('00697614-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00697734-n',[ ('TherapeuticProcess',subsumption), ('Removing',subsumption)]).
nounMapping2SUMO('00697887-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00698004-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00698234-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00698348-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00698474-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00698609-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00698794-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00698959-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00699146-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00699320-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00699517-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00699736-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00699872-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00700000-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00700260-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00700421-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00700652-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00700979-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00701325-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00701491-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00701755-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00702202-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00702418-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00702659-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00702992-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00703236-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00703422-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00703688-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00703926-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00704064-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00704159-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00704305-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00705319-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00705433-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00705580-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00705886-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00706019-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00706133-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00706222-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00706371-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00706605-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00706847-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00707028-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00707213-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00707344-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00707537-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00707785-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00707967-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00708168-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00708332-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00708489-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00708676-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00708957-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00709205-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00709395-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00709521-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00709659-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00709843-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00710015-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00710155-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00710338-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00710550-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00710692-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00710889-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00711127-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00711265-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00711413-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00711523-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00711727-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00711799-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00711897-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00712031-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00712225-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00712833-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00712979-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00713135-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00713250-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00713493-n',[ ('Repairing',subsumption)]).
nounMapping2SUMO('00713594-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00713784-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('00713952-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00714173-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00714357-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00714477-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00714693-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00714806-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00714944-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00715674-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00715843-n',[ ('Cooking',subsumption)]).
nounMapping2SUMO('00715949-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00716055-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00716179-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00716397-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00716520-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00716676-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00716777-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('00716945-n',[ ('Lubricating',equivalence)]).
nounMapping2SUMO('00717081-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00717208-n',[ ('Painting',subsumption)]).
nounMapping2SUMO('00717468-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00717640-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00717748-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00718066-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00718195-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00718325-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00718573-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00718689-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00718815-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00719016-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00719148-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00719274-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00719388-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00719494-n',[ ('Obligation',equivalence)]).
nounMapping2SUMO('00719705-n',[ ('Working',equivalence)]).
nounMapping2SUMO('00720166-n',[ ('Working',subsumption)]).
nounMapping2SUMO('00720331-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00720431-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00720565-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00720951-n',[ ('Position',subsumption)]).
nounMapping2SUMO('00721141-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00721282-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('00721431-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00721660-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('00721929-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00722061-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00722253-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00722479-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00722984-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00723241-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00723547-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00723783-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00723984-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00724168-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00724433-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00724684-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00724898-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00725152-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00725383-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00725506-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00725673-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00725775-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00726100-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00726369-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00726567-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00726867-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00727002-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00727137-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00727333-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00727500-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00727743-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00727901-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00728065-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00728218-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00728342-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00728464-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('00728641-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00728849-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00728975-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00729108-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00729285-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00729478-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00729637-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00729731-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00729825-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00729919-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00730134-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00730247-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00730538-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00730708-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00730984-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00731136-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00731222-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00731569-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00731648-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00731756-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00731947-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00732076-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00732201-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00732369-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00732492-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00732576-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00732746-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00733317-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00733483-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00733753-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00733883-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00734107-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00734303-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00734482-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00734783-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00735017-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00735198-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00735553-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00735686-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00735832-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00735936-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00736219-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00736375-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00736786-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00736894-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00736989-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00737070-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00737188-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00737399-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00737536-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00737705-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00737894-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00738058-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('00738270-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('00738372-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('00738598-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('00738697-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00738785-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00738872-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00738966-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00739078-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00739270-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00739632-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00739850-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00740048-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00740342-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00740609-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00740712-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00741158-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00741272-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00741478-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00741685-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00741797-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00741925-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00742020-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00742130-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00742314-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00742474-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00742645-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00743155-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00743251-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00743348-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00743500-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00743641-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00743822-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00744004-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00744131-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00744305-n',[ ('Injuring',equivalence)]).
nounMapping2SUMO('00744443-n',[ ('Injuring',equivalence)]).
nounMapping2SUMO('00744616-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00744758-n',[ ('Injuring',equivalence)]).
nounMapping2SUMO('00744862-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00745005-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00745431-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00745637-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00745863-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00745943-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00746033-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00746116-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00746232-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00746375-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00746587-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00746866-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00747029-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00747215-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00747519-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00747671-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00748011-n',[ ('Drinking',subsumption)]).
nounMapping2SUMO('00748155-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('00748307-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00748515-n',[ ('Drinking',subsumption)]).
nounMapping2SUMO('00748834-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('00748919-n',[ ('HotelPackage',subsumption)]).
nounMapping2SUMO('00749105-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00749232-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('00749491-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('00749574-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00749767-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00749991-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00750216-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00750306-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00750405-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00750730-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00750890-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00751145-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00751398-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00751529-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00751779-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00751944-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00752144-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00752298-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00752431-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00752798-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00752954-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00753240-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00753472-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00753685-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00753973-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00754118-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00754280-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00754424-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00754593-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00754767-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00754956-n',[ ('Pretending',equivalence)]).
nounMapping2SUMO('00755277-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00755500-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00755673-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00755863-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00756034-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00756194-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00756331-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00756470-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00756598-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00756780-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00756919-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00757080-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00757337-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00757483-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00757730-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00758033-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00758175-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('00758335-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00758525-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00758795-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00758972-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00759186-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00759335-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00759500-n',[ ('Human',subsumption)]).
nounMapping2SUMO('00759694-n',[ ('TerroristAttack',equivalence)]).
nounMapping2SUMO('00763132-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00763282-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00763630-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00763787-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00764031-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00764258-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00764436-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00764588-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00764891-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00765081-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00765193-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00765343-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00765488-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00765791-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00766234-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00767477-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00767633-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00767826-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00768063-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00768203-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00768353-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00768483-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00768701-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00768921-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00769092-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00769401-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00769695-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00769944-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00770151-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00770270-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00770543-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00770834-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00770997-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00771198-n',[ ('Maneuver',subsumption), ('Impelling',subsumption)]).
nounMapping2SUMO('00771356-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00771604-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00771713-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00772026-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00772253-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00772381-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00772550-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00772813-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00773047-n',[ ('CriminalAction',subsumption)]).
nounMapping2SUMO('00773235-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00773402-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00773673-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00773814-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00774009-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00774107-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00774506-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00774796-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00775006-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00775095-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00775286-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00775460-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00775702-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00775943-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00776165-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00776262-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00776466-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00776581-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00776732-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00777069-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00777324-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00777439-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00777587-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00777679-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00777806-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00778017-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00778213-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00778405-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00778575-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00778809-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00779035-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00779248-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00779599-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00779809-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00780148-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00780466-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00780615-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('00780731-n',[ ('Game',subsumption)]).
nounMapping2SUMO('00780889-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00781355-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00781480-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00781685-n',[ ('Robbing',subsumption)]).
nounMapping2SUMO('00781912-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00782072-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00782241-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00782338-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00782518-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00782629-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00782792-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00782927-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00783063-n',[ ('Robbing',subsumption)]).
nounMapping2SUMO('00783199-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00783419-n',[ ('Robbing',subsumption)]).
nounMapping2SUMO('00783527-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00783762-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00783902-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00784083-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00784271-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00784388-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00784598-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00784755-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00784934-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('00785045-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00785263-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00785482-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00785596-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00785818-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00785959-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00786102-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00786195-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00786887-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00787061-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00787218-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00787307-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00787465-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('00787727-n',[ ('RelationalAttribute',subsumption)]).
nounMapping2SUMO('00787832-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00788007-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00788097-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('00788362-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00788473-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00788632-n',[ ('GameShot',equivalence)]).
nounMapping2SUMO('00788766-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00788973-n',[ ('Contest',equivalence)]).
nounMapping2SUMO('00789237-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00789391-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00789534-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('00789735-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('00789906-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('00790086-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00790205-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00790347-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('00790498-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('00790677-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('00790817-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00790947-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('00791078-n',[ ('Experimenting',equivalence)]).
nounMapping2SUMO('00791527-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00791875-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00792142-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00792356-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00792720-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00792954-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00793212-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00793529-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00793844-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00794123-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00794367-n',[ ('Experimenting',equivalence)]).
nounMapping2SUMO('00794614-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00794772-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00794870-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00795008-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00795161-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00795352-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00795508-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00795625-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00795720-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00796197-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('00796315-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00796586-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00796767-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00796886-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00797207-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00797361-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00797468-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00797581-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00797723-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00797878-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00798108-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00798245-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00798959-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00799125-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00799236-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00799409-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00799537-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00799809-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00800121-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00800270-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00800421-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00800657-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00800825-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00800940-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00801125-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00801277-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00801450-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('00801598-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00801724-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00801834-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00801966-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00802111-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00802238-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00802629-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00802785-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00802962-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00803091-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00803208-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00803394-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00803617-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00804180-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00804271-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00804379-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00804535-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00804708-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00804909-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00805034-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00805337-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00805524-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00805766-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00805868-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00806075-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00806366-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('00806484-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00806621-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00806902-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00807078-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00807273-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('00807500-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('00807768-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00807925-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('00808182-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00808485-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00808614-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00808767-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00808967-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00809074-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00809201-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00809279-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00809373-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00809465-n',[ ('RelationalAttribute',subsumption)]).
nounMapping2SUMO('00809702-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00809886-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00810026-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00810234-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00810498-n',[ ('CriminalAction',subsumption)]).
nounMapping2SUMO('00810598-n',[ ('Keeping',equivalence)]).
nounMapping2SUMO('00810794-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('00811036-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00811221-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00811355-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('00811491-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('00811661-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('00811825-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('00811921-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('00812055-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('00812154-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('00812274-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00812526-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('00812977-n',[ ('Embracing',subsumption)]).
nounMapping2SUMO('00813220-n',[ ('Embracing',subsumption)]).
nounMapping2SUMO('00813336-n',[ ('Embracing',subsumption)]).
nounMapping2SUMO('00813571-n',[ ('Embracing',subsumption)]).
nounMapping2SUMO('00813800-n',[ ('Embracing',subsumption)]).
nounMapping2SUMO('00813975-n',[ ('Embracing',subsumption)]).
nounMapping2SUMO('00814106-n',[ ('Embracing',subsumption)]).
nounMapping2SUMO('00814274-n',[ ('Embracing',subsumption)]).
nounMapping2SUMO('00814458-n',[ ('Embracing',subsumption)]).
nounMapping2SUMO('00814665-n',[ ('Embracing',subsumption)]).
nounMapping2SUMO('00814899-n',[ ('Embracing',subsumption)]).
nounMapping2SUMO('00815036-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00815173-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('00815320-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('00815644-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('00815801-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('00816419-n',[ ('FlyingAircraft',subsumption)]).
nounMapping2SUMO('00816530-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('00816665-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('00816841-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('00817017-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('00817191-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('00817394-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('00817507-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00817680-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00818170-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00818362-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00818466-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00818678-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00819024-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00819274-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00819524-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00819641-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00819756-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00819858-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00819958-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00820091-n',[ ('Reserving',subsumption)]).
nounMapping2SUMO('00820232-n',[ ('GovernmentOrganization',subsumption)]).
nounMapping2SUMO('00820406-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00820583-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00820721-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00820845-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('00821083-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('00821295-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('00821518-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('00821752-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('00821973-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('00822159-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('00822350-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('00822544-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('00822755-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('00822970-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00823316-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00823532-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00823750-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00823884-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00824054-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00824357-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00824614-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00824808-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00825005-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00825096-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00825192-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00825331-n',[ ('Aikido',equivalence)]).
nounMapping2SUMO('00825443-n',[ ('MartialArt',equivalence)]).
nounMapping2SUMO('00825773-n',[ ('Judo',equivalence)]).
nounMapping2SUMO('00825951-n',[ ('MartialArt',subsumption)]).
nounMapping2SUMO('00826213-n',[ ('MartialArt',subsumption)]).
nounMapping2SUMO('00826397-n',[ ('Karate',equivalence)]).
nounMapping2SUMO('00826606-n',[ ('KungFu',equivalence)]).
nounMapping2SUMO('00826681-n',[ ('TaeKwonDo',equivalence)]).
nounMapping2SUMO('00826789-n',[ ('MartialArt',subsumption)]).
nounMapping2SUMO('00827010-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00827240-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00827379-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00827535-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00827638-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('00827782-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00827974-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00828082-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00828237-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00828462-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00828559-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00828704-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00828862-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00828990-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00829170-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00829378-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00829721-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00829918-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00830099-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00830257-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00830448-n',[ ('PhysiologicProcess',subsumption)]).
nounMapping2SUMO('00830733-n',[ ('PhysiologicProcess',subsumption)]).
nounMapping2SUMO('00830811-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00831191-n',[ ('Breathing',equivalence)]).
nounMapping2SUMO('00831782-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('00831919-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00832092-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00832306-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('00832471-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('00832626-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00833119-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00833296-n',[ ('Breathing',subsumption)]).
nounMapping2SUMO('00833491-n',[ ('Breathing',subsumption)]).
nounMapping2SUMO('00833578-n',[ ('Breathing',subsumption)]).
nounMapping2SUMO('00833772-n',[ ('Breathing',subsumption)]).
nounMapping2SUMO('00833870-n',[ ('Breathing',subsumption)]).
nounMapping2SUMO('00834135-n',[ ('Breathing',subsumption)]).
nounMapping2SUMO('00834290-n',[ ('Breathing',subsumption)]).
nounMapping2SUMO('00834460-n',[ ('Breathing',subsumption)]).
nounMapping2SUMO('00834636-n',[ ('Smoking',equivalence)]).
nounMapping2SUMO('00834866-n',[ ('Smoking',subsumption)]).
nounMapping2SUMO('00835032-n',[ ('Breathing',subsumption)]).
nounMapping2SUMO('00835267-n',[ ('Breathing',subsumption)]).
nounMapping2SUMO('00835501-n',[ ('Breathing',subsumption)]).
nounMapping2SUMO('00835830-n',[ ('Breathing',subsumption)]).
nounMapping2SUMO('00835976-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('00836149-n',[ ('Breathing',subsumption)]).
nounMapping2SUMO('00836407-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('00836537-n',[ ('Breathing',subsumption)]).
nounMapping2SUMO('00836639-n',[ ('Breathing',subsumption)]).
nounMapping2SUMO('00836788-n',[ ('Breathing',subsumption)]).
nounMapping2SUMO('00837098-n',[ ('Inhaling',subsumption)]).
nounMapping2SUMO('00837293-n',[ ('Breathing',subsumption)]).
nounMapping2SUMO('00837675-n',[ ('Smoking',subsumption)]).
nounMapping2SUMO('00837965-n',[ ('Smoking',subsumption)]).
nounMapping2SUMO('00838098-n',[ ('Ingesting',equivalence)]).
nounMapping2SUMO('00838367-n',[ ('Eating',equivalence)]).
nounMapping2SUMO('00838816-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00839023-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00839163-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00839292-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('00839597-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('00839778-n',[ ('Drinking',subsumption)]).
nounMapping2SUMO('00840057-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('00840189-n',[ ('Drinking',subsumption)]).
nounMapping2SUMO('00840363-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00840517-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00840630-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00840751-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00840898-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00841091-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00841297-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00841393-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00841527-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00841628-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00841777-n',[ ('Drinking',subsumption)]).
nounMapping2SUMO('00841901-n',[ ('Drinking',subsumption)]).
nounMapping2SUMO('00842197-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00842281-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00842419-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00842519-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00842597-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('00842692-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00842997-n',[ ('Ingesting',subsumption)]).
nounMapping2SUMO('00843128-n',[ ('Drinking',equivalence)]).
nounMapping2SUMO('00843325-n',[ ('Drinking',subsumption)]).
nounMapping2SUMO('00843494-n',[ ('Drinking',subsumption)]).
nounMapping2SUMO('00843575-n',[ ('Drinking',subsumption)]).
nounMapping2SUMO('00843681-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00843831-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00844048-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00844254-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00844847-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00844994-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00845178-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00845352-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00845523-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00846021-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00846326-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00846432-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00846515-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00846817-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00846961-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00847167-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00847340-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00847770-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00847932-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00848098-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00848282-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00848466-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00848745-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00848891-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00849059-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00849294-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00849523-n',[ ('SexualReproduction',equivalence)]).
nounMapping2SUMO('00849768-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00849982-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00850260-n',[ ('Replication',equivalence)]).
nounMapping2SUMO('00850425-n',[ ('Replication',subsumption)]).
nounMapping2SUMO('00850873-n',[ ('Replication',subsumption)]).
nounMapping2SUMO('00850986-n',[ ('Replication',subsumption)]).
nounMapping2SUMO('00851146-n',[ ('Replication',subsumption)]).
nounMapping2SUMO('00851316-n',[ ('Replication',subsumption)]).
nounMapping2SUMO('00851587-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00851689-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00851994-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00852181-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00852400-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00852522-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00852825-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00853145-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00853487-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00853649-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00853835-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00854000-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00854393-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00854538-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00854717-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('00854876-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00855055-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00855169-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00855301-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00855407-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00855527-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00855674-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00855936-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00856076-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00856193-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('00856342-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00856559-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00856733-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00856847-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00857160-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00857275-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00857424-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00857530-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00857664-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00857872-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00858060-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00858188-n',[ ('Asleep',equivalence)]).
nounMapping2SUMO('00858377-n',[ ('Asleep',subsumption)]).
nounMapping2SUMO('00858631-n',[ ('Asleep',subsumption)]).
nounMapping2SUMO('00858742-n',[ ('Asleep',subsumption)]).
nounMapping2SUMO('00858849-n',[ ('Asleep',subsumption)]).
nounMapping2SUMO('00859001-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('00859490-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00859691-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00859863-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00860011-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('00860434-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00860857-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00861046-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00861199-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00861382-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00861611-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00861894-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00861990-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00862079-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00862170-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00862310-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00862399-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00862488-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00862595-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00862686-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00862859-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00863017-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00863121-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00863222-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00863417-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00863513-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00864226-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00864535-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00864680-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00864859-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00865031-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00865284-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00865471-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00865600-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00865808-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00866079-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00866273-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00866423-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00866606-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('00866882-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00867163-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00867357-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00867606-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('00867790-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('00867983-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('00868196-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('00868523-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('00868669-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('00868799-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('00868910-n',[ ('Calculating',equivalence)]).
nounMapping2SUMO('00869260-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00869467-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00869583-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00870101-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00870312-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00870453-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00870640-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00870786-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00870912-n',[ ('DivisionFn',equivalence)]).
nounMapping2SUMO('00871123-n',[ ('DivisionFn',subsumption)]).
nounMapping2SUMO('00871263-n',[ ('DivisionFn',subsumption)]).
nounMapping2SUMO('00871418-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00871576-n',[ ('MultiplicationFn',equivalence)]).
nounMapping2SUMO('00871862-n',[ ('SubtractionFn',equivalence)]).
nounMapping2SUMO('00872107-n',[ ('AdditionFn',equivalence)]).
nounMapping2SUMO('00872411-n',[ ('ExponentiationFn',equivalence)]).
nounMapping2SUMO('00872541-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00872722-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00872900-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00872986-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00873084-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00873238-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00873381-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00873671-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00873798-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('00874067-n',[ ('Deciding',equivalence)]).
nounMapping2SUMO('00874457-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('00874621-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('00874806-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('00874977-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('00875246-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('00875519-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('00875671-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('00875838-n',[ ('Deciding',subsumption)]).
nounMapping2SUMO('00876062-n',[ ('LinguisticCommunication',subsumption)]).
nounMapping2SUMO('00876239-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00876377-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00876542-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00876737-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('00876874-n',[ ('Perception',equivalence)]).
nounMapping2SUMO('00877127-n',[ ('Looking',subsumption)]).
nounMapping2SUMO('00877625-n',[ ('Looking',subsumption)]).
nounMapping2SUMO('00877786-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('00877924-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('00878052-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('00878221-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('00878328-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('00878456-n',[ ('Looking',subsumption)]).
nounMapping2SUMO('00878648-n',[ ('Looking',subsumption)]).
nounMapping2SUMO('00878797-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('00878926-n',[ ('Looking',subsumption)]).
nounMapping2SUMO('00879037-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('00879156-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('00879271-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00879531-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00879607-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00879759-n',[ ('Looking',subsumption)]).
nounMapping2SUMO('00880046-n',[ ('Looking',subsumption)]).
nounMapping2SUMO('00880269-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('00880431-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('00880563-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('00880662-n',[ ('Looking',subsumption)]).
nounMapping2SUMO('00880893-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('00881035-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00881257-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('00881441-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('00881545-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('00881649-n',[ ('Looking',subsumption)]).
nounMapping2SUMO('00881914-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('00882045-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('00882159-n',[ ('Hearing',subsumption)]).
nounMapping2SUMO('00882460-n',[ ('Hearing',subsumption)]).
nounMapping2SUMO('00882554-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('00882702-n',[ ('Tasting',equivalence)]).
nounMapping2SUMO('00882961-n',[ ('Smelling',equivalence)]).
nounMapping2SUMO('00883139-n',[ ('Smelling',equivalence)]).
nounMapping2SUMO('00883297-n',[ ('EducationalProcess',equivalence)]).
nounMapping2SUMO('00884202-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00884311-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00884466-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00885088-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00885297-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00885457-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00885574-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00885764-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00885858-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00886039-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00886272-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00886456-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00886582-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00886699-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00886807-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00886968-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00887081-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00887544-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('00887702-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00887882-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00888037-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00888162-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00888284-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00888409-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00888546-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00888693-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00888796-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00888960-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00889082-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00889294-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00889472-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00889682-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00889760-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00889883-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00889971-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00890059-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00890145-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00890227-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00890320-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00890441-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00890568-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00890808-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00890941-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00891071-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00891224-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00891345-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00891512-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00891642-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00891850-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00892036-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00892145-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00892254-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00892413-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00892538-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00892711-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00892861-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00893088-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00893243-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00893402-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00893498-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00893649-n',[ ('Running',subsumption)]).
nounMapping2SUMO('00893836-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00893955-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00894359-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00894552-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00894979-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00895135-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('00895292-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('00895501-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00895680-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00895879-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00895983-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00896114-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00896228-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00896348-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00896526-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00896688-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00896832-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00897026-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00897365-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00897506-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00897608-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00897811-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00897989-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('00898127-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00898286-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00898425-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('00898518-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00898804-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00899049-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00899292-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00899501-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00899657-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('00899761-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00899927-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00900070-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00900207-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00900375-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00900581-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00900726-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00900957-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00901083-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00901316-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00901476-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00901789-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00902108-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00902240-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00902376-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00902579-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00902757-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00902975-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00903201-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00903309-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00903559-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00904428-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00904623-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00904904-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('00905192-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00905336-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00905528-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00905742-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00905842-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00906046-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00906140-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00906290-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00906470-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00906664-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00906829-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00906975-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00907071-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00907235-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00907340-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('00907500-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00907642-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00907788-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00907919-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00908133-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00908292-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00908405-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00908492-n',[ ('Making',equivalence)]).
nounMapping2SUMO('00908772-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('00908909-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('00909193-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00909281-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00909386-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00909471-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00909565-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00909672-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00909796-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00909899-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00910070-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00910203-n',[ ('Recording',equivalence)]).
nounMapping2SUMO('00910533-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00910856-n',[ ('Recording',subsumption)]).
nounMapping2SUMO('00911048-n',[ ('Constructing',equivalence)]).
nounMapping2SUMO('00911572-n',[ ('Constructing',subsumption)]).
nounMapping2SUMO('00911752-n',[ ('Constructing',subsumption)]).
nounMapping2SUMO('00911905-n',[ ('Constructing',subsumption)]).
nounMapping2SUMO('00912001-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('00912165-n',[ ('Constructing',subsumption)]).
nounMapping2SUMO('00912274-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00912576-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00912733-n',[ ('Constructing',subsumption)]).
nounMapping2SUMO('00912822-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00912960-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('00913274-n',[ ('Constructing',subsumption)]).
nounMapping2SUMO('00913427-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('00913585-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00913705-n',[ ('Manufacture',equivalence)]).
nounMapping2SUMO('00914182-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('00914343-n',[ ('Manfacture',subsumption)]).
nounMapping2SUMO('00914509-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('00914632-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('00914795-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('00914929-n',[ ('Replication',subsumption)]).
nounMapping2SUMO('00915140-n',[ ('Cooking',subsumption)]).
nounMapping2SUMO('00915347-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00915497-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00915574-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00915646-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('00915722-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00916023-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00916147-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00916285-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00916464-n',[ ('Agriculture',subsumption)]).
nounMapping2SUMO('00917211-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00917614-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00917759-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00917961-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00918055-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00918176-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00918289-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00918383-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00918644-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00918820-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00918976-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00919201-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00919396-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00919513-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00919692-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00919877-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00920062-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00920211-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00920357-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00920510-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('00920727-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('00920956-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00921160-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00921289-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00921399-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('00921530-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('00921627-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00921790-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00921926-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('00922054-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('00922144-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('00922327-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00922727-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00922848-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00922968-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00923130-n',[ ('Poking',subsumption)]).
nounMapping2SUMO('00923303-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('00923444-n',[ ('Manufacture',equivalence)]).
nounMapping2SUMO('00923802-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('00923995-n',[ ('Creation',equivalence)]).
nounMapping2SUMO('00924438-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('00924579-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00924714-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('00924825-n',[ ('Manufacture',equivalence)]).
nounMapping2SUMO('00925207-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00925489-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00925622-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00925732-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00925866-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00926026-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('00926179-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00926277-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('00926468-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('00926668-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00926923-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('00927062-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('00927161-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('00927261-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('00927516-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('00927694-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00927845-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00927961-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00928077-n',[ ('Designing',subsumption)]).
nounMapping2SUMO('00928371-n',[ ('Planning',subsumption)]).
nounMapping2SUMO('00928542-n',[ ('Planning',subsumption)]).
nounMapping2SUMO('00928751-n',[ ('Planning',subsumption)]).
nounMapping2SUMO('00928947-n',[ ('ComputerProgramming',equivalence)]).
nounMapping2SUMO('00929285-n',[ ('ComputerProgramming',subsumption)]).
nounMapping2SUMO('00929432-n',[ ('ComputerProgramming',subsumption)]).
nounMapping2SUMO('00929586-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00929718-n',[ ('Writing',equivalence)]).
nounMapping2SUMO('00930481-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('00930736-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('00930868-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('00931040-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('00931217-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('00931300-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('00931453-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('00931608-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('00931721-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('00931847-n',[ ('ExtensionFn',subsumption)]).
nounMapping2SUMO('00932088-n',[ ('ExtensionFn',subsumption)]).
nounMapping2SUMO('00932298-n',[ ('ExtensionFn',subsumption)]).
nounMapping2SUMO('00932624-n',[ ('ExtensionFn',subsumption)]).
nounMapping2SUMO('00932804-n',[ ('ExtensionFn',subsumption)]).
nounMapping2SUMO('00933000-n',[ ('ExtensionFn',subsumption)]).
nounMapping2SUMO('00933154-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00933259-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00933420-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('00935005-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00935247-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00935453-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00935608-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('00935786-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00935940-n',[ ('Drawing',equivalence)]).
nounMapping2SUMO('00936194-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00936296-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('00936456-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00936620-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00936901-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00937105-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00937250-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00937394-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00937476-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00937656-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00937895-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00938134-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00938240-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00938419-n',[ ('Tracing',subsumption)]).
nounMapping2SUMO('00938538-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00938642-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('00938791-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00938992-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00939091-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00939231-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00939338-n',[ ('Making',subsumption)]).
nounMapping2SUMO('00939452-n',[ ('ComposingMusic',equivalence)]).
nounMapping2SUMO('00939628-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00939818-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00940043-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00940217-n',[ ('Text',subsumption)]).
nounMapping2SUMO('00940412-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('00940560-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('00940709-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('00940842-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('00941140-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('00941451-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('00941604-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('00941777-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00941974-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00942234-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00942440-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('00942574-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('00942799-n',[ ('Poking',subsumption)]).
nounMapping2SUMO('00942900-n',[ ('Poking',subsumption)]).
nounMapping2SUMO('00942988-n',[ ('Poking',subsumption)]).
nounMapping2SUMO('00943187-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00943471-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00943600-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00943861-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00943963-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00944068-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00944296-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('00944456-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('00944633-n',[ ('Poking',subsumption)]).
nounMapping2SUMO('00944789-n',[ ('Poking',subsumption)]).
nounMapping2SUMO('00944965-n',[ ('Poking',subsumption)]).
nounMapping2SUMO('00945205-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('00945401-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00945777-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00945916-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00946060-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00946281-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00946432-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00946529-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00946650-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00946806-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00947041-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00947128-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00947596-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00947719-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00947923-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00948064-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00948206-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00948640-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00948737-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00948868-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00949042-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00949134-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00949516-n',[ ('Process',subsumption)]).
nounMapping2SUMO('00949619-n',[ ('Engineering',equivalence)]).
nounMapping2SUMO('00949948-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('00950070-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('00950217-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('00950356-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('00950526-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('00950705-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('00950858-n',[ ('Engineering',subsumption)]).
nounMapping2SUMO('00951037-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('00951233-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('00951433-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00951626-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00951781-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('00952214-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('00952386-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('00952615-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00952787-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00952963-n',[ ('Battle',subsumption)]).
nounMapping2SUMO('00953280-n',[ ('War',subsumption)]).
nounMapping2SUMO('00953410-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('00953559-n',[ ('Battle',equivalence)]).
nounMapping2SUMO('00954086-n',[ ('Blockade',subsumption)]).
nounMapping2SUMO('00954311-n',[ ('DefensiveManeuver',subsumption)]).
nounMapping2SUMO('00954751-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('00955060-n',[ ('MilitaryOperation',equivalence)]).
nounMapping2SUMO('00955565-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00955806-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00955987-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00956172-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('00956340-n',[ ('War',subsumption)]).
nounMapping2SUMO('00956485-n',[ ('Battle',subsumption)]).
nounMapping2SUMO('00958477-n',[ ('Battle',subsumption)]).
nounMapping2SUMO('00958896-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00959376-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00959537-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00959645-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00959800-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00959992-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00960192-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('00960395-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('00960546-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('00960688-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('00960851-n',[ ('Battle',subsumption)]).
nounMapping2SUMO('00961001-n',[ ('Battle',subsumption)]).
nounMapping2SUMO('00961177-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('00961328-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('00961594-n',[ ('DefensiveManeuver',subsumption)]).
nounMapping2SUMO('00961794-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('00961962-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('00962129-n',[ ('PoliticalRevolution',subsumption)]).
nounMapping2SUMO('00962567-n',[ ('CivilWar',equivalence)]).
nounMapping2SUMO('00962722-n',[ ('PoliticalRevolution',subsumption)]).
nounMapping2SUMO('00963057-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00963241-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00963447-n',[ ('PoliticalRevolution',subsumption)]).
nounMapping2SUMO('00963749-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('00963896-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00964105-n',[ ('Contest',instance)]).
nounMapping2SUMO('00964343-n',[ ('Battle',subsumption)]).
nounMapping2SUMO('00964569-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00964781-n',[ ('War',equivalence)]).
nounMapping2SUMO('00964952-n',[ ('Battle',subsumption)]).
nounMapping2SUMO('00965183-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('00965404-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00965718-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00965895-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00966294-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00966384-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00966504-n',[ ('Stealing',subsumption)]).
nounMapping2SUMO('00966599-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00966718-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('00966869-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00967157-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00967310-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00967446-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('00967622-n',[ ('War',subsumption)]).
nounMapping2SUMO('00967780-n',[ ('War',subsumption)]).
nounMapping2SUMO('00967993-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('00968155-n',[ ('War',subsumption)]).
nounMapping2SUMO('00968479-n',[ ('War',subsumption)]).
nounMapping2SUMO('00968715-n',[ ('War',subsumption)]).
nounMapping2SUMO('00969087-n',[ ('War',instance)]).
nounMapping2SUMO('00969225-n',[ ('War',instance)]).
nounMapping2SUMO('00969421-n',[ ('War',instance)]).
nounMapping2SUMO('00969684-n',[ ('War',instance)]).
nounMapping2SUMO('00969858-n',[ ('War',instance)]).
nounMapping2SUMO('00970079-n',[ ('War',instance)]).
nounMapping2SUMO('00970331-n',[ ('War',instance)]).
nounMapping2SUMO('00970478-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00970645-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00970903-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00971004-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00971096-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('00971309-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('00971463-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('00971802-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00971984-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00972112-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00972319-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00972521-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('00972621-n',[ ('Attack',equivalence)]).
nounMapping2SUMO('00973077-n',[ ('War',equivalence)]).
nounMapping2SUMO('00974111-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00974224-n',[ ('Battle',subsumption)]).
nounMapping2SUMO('00974358-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00974444-n',[ ('MilitaryAssault',equivalence)]).
nounMapping2SUMO('00974630-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00974762-n',[ ('Attack',equivalence)]).
nounMapping2SUMO('00974994-n',[ ('Attack',subsumption)]).
nounMapping2SUMO('00975074-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00975270-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00975452-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00975658-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00975781-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00975955-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00976085-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00976270-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('00976531-n',[ ('Battle',subsumption)]).
nounMapping2SUMO('00976698-n',[ ('MilitaryInfiltration',subsumption)]).
nounMapping2SUMO('00976953-n',[ ('Raid',equivalence)]).
nounMapping2SUMO('00977132-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00977214-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00977301-n',[ ('Attack',equivalence)]).
nounMapping2SUMO('00977551-n',[ ('Attack',subsumption)]).
nounMapping2SUMO('00977857-n',[ ('Attack',subsumption)]).
nounMapping2SUMO('00978005-n',[ ('Attack',subsumption)]).
nounMapping2SUMO('00978173-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00978413-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00978580-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('00978764-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00978993-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00979180-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00979348-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00979557-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00979742-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('00979902-n',[ ('SuicideBombing',equivalence)]).
nounMapping2SUMO('00980038-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00980200-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00980394-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00980779-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00980904-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('00981180-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00981369-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('00981711-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00981830-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00982153-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00982347-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00982536-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00982679-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00982852-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00983102-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00983287-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00983482-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00983651-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00983811-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00983982-n',[ ('PsychologicalOperation',equivalence)]).
nounMapping2SUMO('00984195-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00984357-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00984490-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00984609-n',[ ('ReconnaissanceOperation',equivalence)]).
nounMapping2SUMO('00985008-n',[ ('ReconnaissanceOperation',equivalence)]).
nounMapping2SUMO('00985106-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00985356-n',[ ('AirReconnaissance',equivalence)]).
nounMapping2SUMO('00985516-n',[ ('ReconnaissanceByFire',equivalence)]).
nounMapping2SUMO('00985746-n',[ ('ReconnaissanceInForce',equivalence)]).
nounMapping2SUMO('00985921-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00986080-n',[ ('ElectronicReconnaissance',equivalence)]).
nounMapping2SUMO('00986275-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00986663-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00986813-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00986938-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00987775-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00987863-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00988177-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00988320-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00988556-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00988696-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00988893-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00989122-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00989385-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00989583-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00989773-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00989937-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00990071-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00990195-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00990319-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00990474-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00990590-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00990719-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00990843-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00990963-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00991070-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00991164-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00991336-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00991496-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00991642-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00991772-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00991914-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00992102-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00992221-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00992331-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00992544-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00992732-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00992995-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00993228-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00993377-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00993488-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('00993651-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00993787-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('00993956-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00994144-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00994321-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00994449-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00994623-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00994745-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00994895-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00994989-n',[ ('Shooting',subsumption)]).
nounMapping2SUMO('00995134-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('00995356-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('00995588-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('00995855-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('00996056-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('00996180-n',[ ('War',subsumption)]).
nounMapping2SUMO('00996513-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('00996673-n',[ ('War',subsumption)]).
nounMapping2SUMO('00996817-n',[ ('War',subsumption)]).
nounMapping2SUMO('00996969-n',[ ('Measuring',equivalence)]).
nounMapping2SUMO('00998037-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('00998196-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('00998329-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('00998423-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('00998514-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('00998604-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('00998768-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('00998982-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('00999089-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('00999245-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('00999588-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('00999787-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('01000068-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01000276-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('01000411-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('01000610-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01000843-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01000969-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01001097-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01001344-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01001489-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01001640-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('01001814-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01001923-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01002008-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01002165-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01002284-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01002413-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01002554-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01002677-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01002872-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01002956-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01003113-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01003272-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01003435-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('01003570-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01003729-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01003936-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01004072-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('01004377-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01004582-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01004775-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01004961-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01005100-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01005284-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01005473-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01005579-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01005814-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01005957-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('01006054-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('01006188-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('01006313-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('01006536-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('01006675-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01007053-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01007273-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01007372-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01007463-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01007609-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('01007907-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('01008097-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('01008271-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01008378-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01008801-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01009001-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01009190-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01009507-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01009637-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('01009871-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01010245-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01010334-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01010458-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01010684-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01010901-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01011028-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01011166-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01011425-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01011720-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01011883-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('01012030-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('01012125-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('01012257-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('01012360-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01012608-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01012712-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('01013156-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('01013316-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('01013434-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('01013604-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('01013770-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('01013971-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('01014066-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01014490-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('01014607-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01014731-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01014990-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01015175-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01015310-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01015477-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01015551-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01015689-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('01015843-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01015996-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('01016201-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01016420-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('01016628-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('01016748-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('01016832-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('01016973-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01017167-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('01017320-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('01017550-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('01017701-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01017987-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01018366-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('01018630-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01018951-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01019129-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01019248-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01019372-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01019524-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01019703-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01019901-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01020117-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('01020362-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('01020488-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('01020628-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('01020770-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('01020936-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('01021119-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('01021270-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('01021396-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('01021579-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01021889-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01022008-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01022178-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01022292-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('01022483-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01022824-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01022992-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01023138-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01023242-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01023636-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('01023820-n',[ ('IntentionalProcess',equivalence)]).
nounMapping2SUMO('01024392-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01024547-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('01024643-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('01024811-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('01024968-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('01025254-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('01025411-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('01025563-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('01025678-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('01026020-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01026191-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01026316-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01026482-n',[ ('Procedure',equivalence)]).
nounMapping2SUMO('01026633-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01026744-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01026897-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01027231-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01027379-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01027662-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('01027859-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01028082-n',[ ('ReligiousProcess',equivalence)]).
nounMapping2SUMO('01028381-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('01028534-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01028655-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01029114-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01029323-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01029406-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01029671-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01029883-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01030033-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01030152-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01030280-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01030488-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01030642-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01030820-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01031023-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01031194-n',[ ('Circumision',equivalence)]).
nounMapping2SUMO('01031392-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01031563-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('01031705-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01031858-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01032040-n',[ ('ReligiousService',equivalence)]).
nounMapping2SUMO('01032368-n',[ ('ChristianService',subsumption)]).
nounMapping2SUMO('01032810-n',[ ('ReligiousService',subsumption)]).
nounMapping2SUMO('01032892-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01033024-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01033184-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01033345-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01033458-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01033714-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01033903-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01034077-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01034233-n',[ ('ReligiousService',subsumption)]).
nounMapping2SUMO('01034385-n',[ ('ReligiousService',subsumption)]).
nounMapping2SUMO('01034571-n',[ ('ReligiousService',subsumption)]).
nounMapping2SUMO('01034685-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01034816-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01034925-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01035504-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01035667-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01035853-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01036194-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01036333-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01036624-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01036778-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01036903-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01036996-n',[ ('MarriageContract',equivalence)]).
nounMapping2SUMO('01037294-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01037469-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01037577-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01037710-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01037819-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01038147-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01038261-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01038375-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01038485-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01038629-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01038761-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01038895-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01039140-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01039307-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01039560-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01039637-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01039822-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01039925-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01040128-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01040390-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01040646-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01040943-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01041111-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01041349-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01041498-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('01041674-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01041835-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01041968-n',[ ('Praying',subsumption)]).
nounMapping2SUMO('01042242-n',[ ('ChristianService',equivalence)]).
nounMapping2SUMO('01042465-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01042578-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01042661-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01042764-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01042998-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01043189-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01043333-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01043693-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01043820-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01043989-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01044084-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01044268-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01044363-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01044448-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01044761-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01044867-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01044983-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01045091-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01045202-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01045306-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01045413-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01045520-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01045621-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01045714-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01045807-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01045924-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01046006-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01046167-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01046257-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01046348-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01046441-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01046571-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01046664-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01046792-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01046888-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('01046984-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01047191-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01047338-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01047803-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01047937-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01048059-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01048210-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('01048466-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01048697-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01048912-n',[ ('Disseminating',not(subsumption))]).
nounMapping2SUMO('01049266-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('01049475-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01049685-n',[ ('Covering',subsumption)]).
nounMapping2SUMO('01049992-n',[ ('Disseminating',not(subsumption))]).
nounMapping2SUMO('01050187-n',[ ('Disseminating',not(subsumption))]).
nounMapping2SUMO('01050356-n',[ ('Disseminating',not(subsumption))]).
nounMapping2SUMO('01050627-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01050763-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01050872-n',[ ('Disseminating',not(subsumption))]).
nounMapping2SUMO('01051082-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('01051221-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01051331-n',[ ('Putting',equivalence)]).
nounMapping2SUMO('01051801-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01052078-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01052215-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01052372-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01052450-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01052618-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01052739-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01052853-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01053067-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01053207-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('01053404-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01053617-n',[ ('Living',subsumption)]).
nounMapping2SUMO('01053920-n',[ ('Living',subsumption)]).
nounMapping2SUMO('01054227-n',[ ('Living',subsumption)]).
nounMapping2SUMO('01054335-n',[ ('Living',subsumption)]).
nounMapping2SUMO('01054545-n',[ ('Living',subsumption)]).
nounMapping2SUMO('01054876-n',[ ('Living',subsumption)]).
nounMapping2SUMO('01055065-n',[ ('Living',subsumption)]).
nounMapping2SUMO('01055165-n',[ ('Living',subsumption)]).
nounMapping2SUMO('01055360-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01055493-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01055688-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('01055954-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01056236-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01056411-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('01056713-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('01056804-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('01056941-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('01057053-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('01057200-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01057631-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01057759-n',[ ('Ingesting',subsumption)]).
nounMapping2SUMO('01058049-n',[ ('Ingesting',subsumption)]).
nounMapping2SUMO('01058181-n',[ ('Ingesting',subsumption)]).
nounMapping2SUMO('01058291-n',[ ('Ingesting',subsumption)]).
nounMapping2SUMO('01058539-n',[ ('Drinking',subsumption)]).
nounMapping2SUMO('01058715-n',[ ('Drinking',subsumption)]).
nounMapping2SUMO('01058870-n',[ ('Ingesting',subsumption)]).
nounMapping2SUMO('01058983-n',[ ('Ingesting',subsumption)]).
nounMapping2SUMO('01059096-n',[ ('Ingesting',subsumption)]).
nounMapping2SUMO('01059189-n',[ ('Ingesting',subsumption)]).
nounMapping2SUMO('01059306-n',[ ('Ingesting',subsumption)]).
nounMapping2SUMO('01059445-n',[ ('Ingesting',subsumption)]).
nounMapping2SUMO('01059719-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01059900-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('01060101-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('01060234-n',[ ('Making',subsumption)]).
nounMapping2SUMO('01060530-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01060745-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01060924-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01061029-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01061203-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('01061333-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('01061526-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('01061726-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('01061945-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('01062136-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('01062255-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('01062468-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('01062583-n',[ ('Motion',not(subsumption))]).
nounMapping2SUMO('01062817-n',[ ('Motion',not(subsumption))]).
nounMapping2SUMO('01062997-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('01063234-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('01063350-n',[ ('Motion',not(subsumption))]).
nounMapping2SUMO('01063578-n',[ ('Motion',not(subsumption))]).
nounMapping2SUMO('01063697-n',[ ('Motion',not(subsumption))]).
nounMapping2SUMO('01063939-n',[ ('Motion',not(subsumption))]).
nounMapping2SUMO('01064148-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('01064468-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('01064613-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01064758-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('01064863-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('01065057-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('01065286-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('01065441-n',[ ('Unemployed',subsumption)]).
nounMapping2SUMO('01065607-n',[ ('Unemployed',subsumption)]).
nounMapping2SUMO('01065687-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('01065805-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('01065945-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('01066061-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('01066163-n',[ ('Process',not(subsumption))]).
nounMapping2SUMO('01066545-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('01066689-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01066881-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01067070-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01067192-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01067362-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01067577-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('01067819-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01068012-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('01068184-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01068423-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01068528-n',[ ('EndFn',subsumption)]).
nounMapping2SUMO('01068633-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01068773-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01069012-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01069125-n',[ ('SexualReproduction',not(equivalence))]).
nounMapping2SUMO('01069311-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01069578-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01069777-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01069867-n',[ ('Drinking',not(subsumption))]).
nounMapping2SUMO('01069980-n',[ ('Eating',not(subsumption))]).
nounMapping2SUMO('01070187-n',[ ('Ingesting',subsumption)]).
nounMapping2SUMO('01070432-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('01070566-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('01070708-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01070892-n',[ ('IntentionalPsychologicalProcess',subsumption)]).
nounMapping2SUMO('01071090-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01071213-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01071411-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01071746-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01071921-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01072072-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01072236-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01072402-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('01072565-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01072780-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01072984-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01073097-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01073241-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01073556-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01073655-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01073824-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01073995-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01074252-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('01074498-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01074694-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01074970-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01075117-n',[ ('MilitaryAssault',subsumption)]).
nounMapping2SUMO('01075567-n',[ ('Battle',subsumption)]).
nounMapping2SUMO('01075725-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('01075893-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('01076046-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01076359-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01076488-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('01076724-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('01076863-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01077190-n',[ ('MilitaryAssault',subsumption)]).
nounMapping2SUMO('01077350-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01077738-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01077881-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01078086-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01078279-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01078572-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01079042-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01079295-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01079396-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01079604-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01079951-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('01080062-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01080366-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01081197-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('01081346-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01081456-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('01081628-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('01081867-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('01082061-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('01082274-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('01082350-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('01082548-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01082720-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('01082886-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('01083077-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01083350-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01083504-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01083645-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01084180-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01084489-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01084637-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01084848-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01084932-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01085098-n',[ ('Sharing',equivalence)]).
nounMapping2SUMO('01085337-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01085567-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01085656-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01085793-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01085937-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01086081-n',[ ('Giving',equivalence)]).
nounMapping2SUMO('01086356-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('01086572-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01086744-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('01086945-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('01087178-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01087498-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01087740-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('01087939-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('01088168-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('01088304-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('01088437-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01088563-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01088656-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01088757-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01088857-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01089009-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('01089179-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('01089297-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01089483-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('01089635-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('01089778-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('01090018-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01090117-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('01090225-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('01090342-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('01090446-n',[ ('CommercialService',subsumption)]).
nounMapping2SUMO('01091905-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01092315-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01092403-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01092643-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01092769-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01092974-n',[ ('CommercialService',subsumption)]).
nounMapping2SUMO('01093085-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01093380-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01093532-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01093666-n',[ ('Lending',equivalence)]).
nounMapping2SUMO('01093855-n',[ ('Lending',subsumption)]).
nounMapping2SUMO('01093965-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01094293-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01094575-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01094725-n',[ ('CommercialService',subsumption)]).
nounMapping2SUMO('01095753-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01095966-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('01096245-n',[ ('FinancialTransaction',equivalence)]).
nounMapping2SUMO('01096454-n',[ ('CommercialService',equivalence)]).
nounMapping2SUMO('01096674-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01096873-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01096997-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01097119-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('01097292-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01097739-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01097920-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01098071-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01098265-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01098404-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01098541-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('01098698-n',[ ('Financing',subsumption)]).
nounMapping2SUMO('01098968-n',[ ('Financing',subsumption)]).
nounMapping2SUMO('01099109-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01099231-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01099436-n',[ ('Investing',subsumption)]).
nounMapping2SUMO('01099768-n',[ ('Investing',subsumption)]).
nounMapping2SUMO('01099946-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01100147-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01100273-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01100491-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01100658-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01100877-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('01101114-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01101227-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01101329-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01101571-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01101661-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01101753-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01101958-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('01102256-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('01102436-n',[ ('Text',subsumption)]).
nounMapping2SUMO('01102574-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('01102712-n',[ ('Text',subsumption)]).
nounMapping2SUMO('01102862-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('01103000-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('01103159-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('01103374-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('01103492-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('01103614-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('01103788-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01103964-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01104174-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01104324-n',[ ('CateringService',equivalence)]).
nounMapping2SUMO('01104406-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('01104544-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('01104637-n',[ ('Constructing',subsumption)]).
nounMapping2SUMO('01105038-n',[ ('Constructing',subsumption)]).
nounMapping2SUMO('01105152-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01105259-n',[ ('TransportationService',equivalence)]).
nounMapping2SUMO('01105635-n',[ ('AirTransportationService',subsumption)]).
nounMapping2SUMO('01105737-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('01105909-n',[ ('LandTransportationService',subsumption)]).
nounMapping2SUMO('01106118-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('01106272-n',[ ('TransportationService',subsumption)]).
nounMapping2SUMO('01106460-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('01106587-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('01106715-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01106808-n',[ ('Transaction',equivalence)]).
nounMapping2SUMO('01107359-n',[ ('Transaction',subsumption)]).
nounMapping2SUMO('01107549-n',[ ('Transaction',subsumption)]).
nounMapping2SUMO('01107726-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01107932-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01108150-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01108402-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01108641-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01108753-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01108971-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01109114-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01109311-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01109467-n',[ ('Transaction',equivalence)]).
nounMapping2SUMO('01109687-n',[ ('Transaction',subsumption)]).
nounMapping2SUMO('01109934-n',[ ('Transaction',subsumption)]).
nounMapping2SUMO('01110063-n',[ ('Transaction',subsumption)]).
nounMapping2SUMO('01110274-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01110633-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01110720-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01110811-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01110973-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01111133-n',[ ('Borrowing',subsumption)]).
nounMapping2SUMO('01111236-n',[ ('Borrowing',subsumption)]).
nounMapping2SUMO('01111375-n',[ ('Borrowing',subsumption)]).
nounMapping2SUMO('01111569-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('01111750-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('01111952-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('01112132-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('01112289-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('01112420-n',[ ('CommercialService',subsumption)]).
nounMapping2SUMO('01112739-n',[ ('Advertising',subsumption)]).
nounMapping2SUMO('01112885-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('01113068-n',[ ('Selling',equivalence)]).
nounMapping2SUMO('01113595-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01113867-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01114055-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01114172-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01114284-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01114458-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01114646-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01114824-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01115017-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01115162-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01115348-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01115589-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01115734-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01115866-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01116026-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01116206-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01116360-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01116466-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01116696-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01116876-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01116968-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01117164-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('01117318-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('01117454-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01117541-n',[ ('Selling',equivalence)]).
nounMapping2SUMO('01117723-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01118182-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01118338-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01118495-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01118614-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01118776-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01118890-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01119012-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01119116-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01119250-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01119401-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01119620-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01119850-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01119949-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01120176-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('01120259-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('01120348-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('01120448-n',[ ('Payment',equivalence)]).
nounMapping2SUMO('01120855-n',[ ('CommercialService',subsumption)]).
nounMapping2SUMO('01121070-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('01121245-n',[ ('Payment',subsumption)]).
nounMapping2SUMO('01121390-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('01121492-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('01121585-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('01121690-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01121855-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('01122037-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01122149-n',[ ('Buying',equivalence)]).
nounMapping2SUMO('01122387-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('01122488-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('01122601-n',[ ('Buying',equivalence)]).
nounMapping2SUMO('01122754-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('01122938-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('01123095-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('01123304-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('01123420-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('01123598-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('01124110-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('01124246-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('01124384-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01124508-n',[ ('GovernmentOfficer',subsumption)]).
nounMapping2SUMO('01124794-n',[ ('RegulatoryProcess',equivalence)]).
nounMapping2SUMO('01125562-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01125693-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01125959-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('01126151-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('01126335-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01126564-n',[ ('Making',subsumption)]).
nounMapping2SUMO('01126709-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('01126856-n',[ ('PassingABill',subsumption)]).
nounMapping2SUMO('01127019-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01127245-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('01127379-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01127623-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01127874-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01128137-n',[ ('LawEnforcement',subsumption)]).
nounMapping2SUMO('01128266-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01128390-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01128547-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01128655-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01128806-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01128984-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('01129363-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('01129532-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('01129920-n',[ ('Obligation',equivalence)]).
nounMapping2SUMO('01130560-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01130735-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01130905-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01131004-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01131135-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01131224-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01131330-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01131425-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01131515-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01131656-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01131794-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01131993-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('01132148-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01132327-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('01132472-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01132590-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01132709-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01132864-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01133106-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01133281-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01133760-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01133933-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01134037-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('01134244-n',[ ('Position',subsumption)]).
nounMapping2SUMO('01134330-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01134479-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01134699-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01134861-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01135163-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01135372-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01135529-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01135795-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01135952-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01136265-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01136375-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01136519-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01136985-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01137206-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01137455-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01137597-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01137760-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01137987-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01138399-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01138547-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01138670-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01139000-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01139194-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01139490-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01139636-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01139749-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01139830-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01140029-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01140193-n',[ ('Accrediting',subsumption)]).
nounMapping2SUMO('01140471-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01140658-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01140839-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01141160-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01141366-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01141482-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01141593-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01141729-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01141841-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01142014-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01142150-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01142324-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01142519-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01142843-n',[ ('Constructing',subsumption)]).
nounMapping2SUMO('01143040-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01143409-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01143580-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01143760-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01143957-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01144046-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01144133-n',[ ('Planning',equivalence)]).
nounMapping2SUMO('01144355-n',[ ('Planning',subsumption)]).
nounMapping2SUMO('01144555-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('01144716-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('01144876-n',[ ('Guiding',equivalence)]).
nounMapping2SUMO('01145015-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01145219-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01145359-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01145688-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01145905-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01146039-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01146288-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('01146576-n',[ ('Confining',equivalence)]).
nounMapping2SUMO('01146768-n',[ ('Confining',subsumption)]).
nounMapping2SUMO('01146993-n',[ ('Confining',subsumption)]).
nounMapping2SUMO('01147135-n',[ ('Confining',subsumption)]).
nounMapping2SUMO('01147222-n',[ ('Confining',subsumption)]).
nounMapping2SUMO('01147347-n',[ ('Confining',subsumption)]).
nounMapping2SUMO('01147451-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('01147676-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('01147950-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01148182-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01148283-n',[ ('Managing',subsumption)]).
nounMapping2SUMO('01148398-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01148491-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01148614-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01148904-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01149115-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01149303-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('01149480-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('01149621-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('01149793-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01149911-n',[ ('Compressing',subsumption)]).
nounMapping2SUMO('01150096-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('01150200-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01150467-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('01150662-n',[ ('Eating',not(subsumption))]).
nounMapping2SUMO('01150938-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01151097-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01151407-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01151605-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01151788-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01152033-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01152300-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01152461-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01152583-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('01152787-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01152973-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('01153139-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01153305-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('01153548-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01153861-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01154083-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01154237-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01154373-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01154487-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01154661-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01154772-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01154900-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01155044-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01155253-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01155465-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01155722-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01155893-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01156070-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01156262-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01156438-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01156899-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01157138-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01157275-n',[ ('Repairing',subsumption)]).
nounMapping2SUMO('01157384-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01157557-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01157850-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('01158064-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('01158190-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01158543-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01158690-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01159025-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01159461-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01159776-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01159964-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01160170-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01160342-n',[ ('Punishing',subsumption)]).
nounMapping2SUMO('01160729-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01161017-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01161161-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01161411-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01161635-n',[ ('Punishing',subsumption)]).
nounMapping2SUMO('01161821-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01162062-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01162257-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01162376-n',[ ('Imprisoning',subsumption)]).
nounMapping2SUMO('01162529-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01162672-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01162784-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('01162928-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01163047-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01163316-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01163429-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01163586-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01163779-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01164063-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01164275-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01164394-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01164618-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01164730-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01164874-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01165112-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01165224-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01165337-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01165537-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01165692-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01165919-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01166092-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('01166258-n',[ ('Transaction',equivalence)]).
nounMapping2SUMO('01166517-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('01166760-n',[ ('Transaction',subsumption)]).
nounMapping2SUMO('01166926-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01167146-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01167385-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01167548-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01167710-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01167847-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01167952-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01168199-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01168369-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01168569-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01168840-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01168961-n',[ ('Contest',equivalence)]).
nounMapping2SUMO('01169112-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01169200-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01169317-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01169598-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01169744-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01170047-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01170175-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01170320-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01170406-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01170502-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01170666-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01170813-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01170962-n',[ ('ViolentContest',equivalence)]).
nounMapping2SUMO('01171644-n',[ ('Fencing',equivalence)]).
nounMapping2SUMO('01172031-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01172173-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01172252-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01172441-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01172598-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01172784-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01173038-n',[ ('Impacting',equivalence)]).
nounMapping2SUMO('01173569-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('01173660-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('01173826-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01173965-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('01174251-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('01174495-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('01174645-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('01174825-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('01174988-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('01175099-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('01175195-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('01175316-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('01175633-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('01175831-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('01176031-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('01176115-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01176219-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01176335-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01176431-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01176540-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01176649-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01176757-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01176931-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01177033-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01177327-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01177583-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01177703-n',[ ('Demonstration',equivalence)]).
nounMapping2SUMO('01177990-n',[ ('Demonstrating',subsumption)]).
nounMapping2SUMO('01178195-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01178415-n',[ ('Demonstration',instance)]).
nounMapping2SUMO('01178728-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01178850-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01179004-n',[ ('Demonstration',subsumption)]).
nounMapping2SUMO('01179167-n',[ ('Demonstration',subsumption)]).
nounMapping2SUMO('01179393-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01179564-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01179707-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01179927-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01180200-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01180398-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01180557-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01180718-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01180858-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01181066-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01181212-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01181475-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01181902-n',[ ('LegalAction',equivalence)]).
nounMapping2SUMO('01182312-n',[ ('PoliticalProcess',equivalence)]).
nounMapping2SUMO('01182654-n',[ ('LegalAction',equivalence)]).
nounMapping2SUMO('01183031-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01183166-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01183373-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01183497-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01183638-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01183798-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01184045-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01184230-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01184407-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01184565-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01184720-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01184814-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01185292-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01185611-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01185981-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01186192-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01186397-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01186578-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01186810-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01187085-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01187230-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01187463-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01187620-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01187810-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01188273-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01188537-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01188783-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01189001-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01189282-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01189650-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01189929-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01190172-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01190364-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01190561-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01190884-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01191158-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01191364-n',[ ('JudicialProcess',instance)]).
nounMapping2SUMO('01191610-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('01191755-n',[ ('GameCall',subsumption)]).
nounMapping2SUMO('01191975-n',[ ('Discovering',subsumption)]).
nounMapping2SUMO('01192150-n',[ ('Deciding',subsumption)]).
nounMapping2SUMO('01192463-n',[ ('Judging',subsumption)]).
nounMapping2SUMO('01192633-n',[ ('Judging',subsumption)]).
nounMapping2SUMO('01192814-n',[ ('Judging',subsumption)]).
nounMapping2SUMO('01193044-n',[ ('Judging',subsumption)]).
nounMapping2SUMO('01193176-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01193362-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01193535-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01193672-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01193886-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01194021-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01194125-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01194225-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01194331-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01194615-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01194711-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01194904-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01195187-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01195380-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01195584-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01195867-n',[ ('JudicialProcess',equivalence)]).
nounMapping2SUMO('01196316-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01196477-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01196759-n',[ ('JudicialProcess',instance)]).
nounMapping2SUMO('01197119-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01197258-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01197479-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01197658-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01197928-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('01198068-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01198307-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01198588-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('01198750-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('01199035-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('01199252-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01199365-n',[ ('JudicialProcess',subsumption)]).
nounMapping2SUMO('01199697-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('01200000-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('01200266-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('01200502-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('01200857-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('01201021-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01201271-n',[ ('Divorcing',subsumption)]).
nounMapping2SUMO('01201429-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01201645-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01201773-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01201906-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01202029-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01202184-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01202415-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('01202665-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('01202799-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01202904-n',[ ('Cooperation',equivalence)]).
nounMapping2SUMO('01203277-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01203494-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01203676-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01204055-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01204294-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01204419-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01204623-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01204711-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01204845-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01205010-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01205156-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01205341-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01205564-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01205702-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01205827-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01205961-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01206153-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01206553-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01206774-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01206910-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01206986-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('01207108-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('01207187-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01207342-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01207521-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01207609-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01208291-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01208460-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01208597-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01208797-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01208924-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('01209079-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01209220-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01209487-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01209576-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01209791-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01209963-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('01210102-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01210281-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01210439-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('01210547-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01210699-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('01210816-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('01211019-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01211185-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01211339-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01211489-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01211667-n',[ ('Helping',subsumption)]).
nounMapping2SUMO('01211888-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01212037-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01212225-n',[ ('RationalNumberFn',equivalence)]).
nounMapping2SUMO('01212519-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01212882-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01213234-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01213406-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01213548-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01213702-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01213886-n',[ ('Helping',subsumption)]).
nounMapping2SUMO('01214171-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01214408-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01214557-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01214746-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01214863-n',[ ('Helping',subsumption)]).
nounMapping2SUMO('01215036-n',[ ('Helping',subsumption)]).
nounMapping2SUMO('01215168-n',[ ('Helping',subsumption)]).
nounMapping2SUMO('01215392-n',[ ('Helping',subsumption)]).
nounMapping2SUMO('01215719-n',[ ('Helping',subsumption)]).
nounMapping2SUMO('01215902-n',[ ('Helping',undefined)]).
nounMapping2SUMO('01216191-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('01216515-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01216738-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01216908-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01217052-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01217306-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01217499-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01217720-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01217859-n',[ ('Hiring',subsumption)]).
nounMapping2SUMO('01218050-n',[ ('Hiring',subsumption)]).
nounMapping2SUMO('01218213-n',[ ('Hiring',subsumption)]).
nounMapping2SUMO('01218327-n',[ ('Reservation',equivalence)]).
nounMapping2SUMO('01218593-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01218766-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01218932-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01219075-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01219306-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01219551-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('01219722-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('01219893-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01220074-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01220152-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01220336-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('01220619-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('01220754-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01220984-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('01221254-n',[ ('BodyMotion',equivalence)]).
nounMapping2SUMO('01221464-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('01221611-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01221790-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01222034-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01222157-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01222333-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01222477-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('01222666-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01222859-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01223032-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01223143-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01223257-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01223488-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01223672-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('01223766-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('01223877-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('01224031-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01224346-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('01224517-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01224700-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('01224828-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01224914-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01225027-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01225299-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01225397-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01225562-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01225783-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01225997-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01226181-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01226289-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01226679-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01226837-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01226941-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01227083-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01227190-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01227351-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('01227495-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01227691-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01227805-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01227908-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01228102-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01228245-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01228380-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01228544-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01228645-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01228792-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01228877-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('01229223-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('01229350-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('01229549-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('01229712-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('01229793-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01229938-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01230283-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('01230566-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('01230685-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('01230850-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01230965-n',[ ('Meeting',equivalence)]).
nounMapping2SUMO('01231296-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('01231435-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01231548-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01231686-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01231819-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01231980-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01232091-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01232246-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01232412-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01232684-n',[ ('Translocation',equivalence)]).
nounMapping2SUMO('01232842-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01232978-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('01233156-n',[ ('Translocation',equivalence)]).
nounMapping2SUMO('01233397-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01233627-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01233802-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01233917-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01234090-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01234243-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('01234345-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01234528-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01234612-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01234729-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01234952-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01235137-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01235258-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01235463-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01235946-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01236049-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01236173-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01236296-n',[ ('Contest',equivalence)]).
nounMapping2SUMO('01236491-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01236633-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('01236947-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01237080-n',[ ('Transaction',subsumption)]).
nounMapping2SUMO('01237167-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01237294-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01237415-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('01237872-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01238058-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01238267-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('01238424-n',[ ('OrganizationalMerging',subsumption)]).
nounMapping2SUMO('01238607-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('01238847-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('01239064-n',[ ('IntentionalProcess',equivalence)]).
nounMapping2SUMO('01239487-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01239717-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01239868-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('01240064-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01240210-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('01240432-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('01240628-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('01240745-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01240850-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01240979-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01241216-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01241331-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01241594-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01241767-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('01241997-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01242164-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01242354-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01242539-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('01242716-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01242962-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01243089-n',[ ('Eating',not(subsumption))]).
nounMapping2SUMO('01243262-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01243453-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('01243674-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01243969-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01244127-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01244341-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01244451-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01244593-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01244895-n',[ ('Sabotage',equivalence)]).
nounMapping2SUMO('01245061-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('01245159-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('01245318-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('01245471-n',[ ('Killing',instance)]).
nounMapping2SUMO('01245618-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('01245813-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('01245950-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('01246086-n',[ ('Throwing',subsumption)]).
nounMapping2SUMO('01246206-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('01246334-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01246541-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01246697-n',[ ('TerroristAttack',equivalence)]).
nounMapping2SUMO('01246926-n',[ ('Ambush',equivalence)]).
nounMapping2SUMO('01247156-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01247306-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('01247413-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01247647-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01247807-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01247969-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('01248075-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01248191-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01248418-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01248608-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01248752-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01248852-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01248961-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01249060-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01249315-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01249483-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('01249616-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('01249816-n',[ ('Vandalism',equivalence)]).
nounMapping2SUMO('01249991-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('01250101-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01250208-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('01250335-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('01250492-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('01250569-n',[ ('Killing',subsumption), ('Shooting',subsumption)]).
nounMapping2SUMO('01250671-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('01250745-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('01250826-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01251010-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01251138-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01251270-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('01251489-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('01251724-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('01251923-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('01252124-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('01252280-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01252566-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('01252800-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01252918-n',[ ('Radiating',equivalence)]).
nounMapping2SUMO('01253060-n',[ ('Radiating',equivalence)]).
nounMapping2SUMO('01253277-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01253379-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('01253665-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01253778-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('01253944-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('01254051-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('01254253-n',[ ('Separating',equivalence)]).
nounMapping2SUMO('01254473-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('01254685-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('01254882-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('01254978-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('01255125-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('01255302-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('01255452-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('01255549-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('01255648-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('01255808-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('01255935-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('01256124-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('01256270-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('01256417-n',[ ('Managing',equivalence)]).
nounMapping2SUMO('01256615-n',[ ('Position',subsumption)]).
nounMapping2SUMO('01256743-n',[ ('Position',subsumption)]).
nounMapping2SUMO('01257033-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('01257145-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01257418-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01257542-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01257701-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01257969-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('01258161-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('01258251-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01258579-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('01258719-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('01258852-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01259034-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('01259211-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('01259380-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('01259594-n',[ ('RecreationOrExercise',subsumption)]).
nounMapping2SUMO('01259773-n',[ ('Awake',subsumption)]).
nounMapping2SUMO('01260008-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01260182-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('01260309-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('01260556-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01260731-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01260867-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('01261113-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('01261293-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('01261490-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01261712-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01261845-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01261974-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01262109-n',[ ('PhysiologicProcess',subsumption)]).
nounMapping2SUMO('01262345-n',[ ('PhysiologicProcess',subsumption)]).
nounMapping2SUMO('01262441-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01262574-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01262713-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01262868-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01263018-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01263257-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('01263418-n',[ ('Driving',subsumption)]).
nounMapping2SUMO('01263582-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01263711-n',[ ('Registering',subsumption)]).
nounMapping2SUMO('01263924-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('01264050-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01264243-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01264447-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01264667-n',[ ('Process',subsumption)]).
nounMapping2SUMO('01264795-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('01264933-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('01265071-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('01265176-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('01265325-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('01265475-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01265632-n',[ ('RegulatoryProcess',subsumption)]).
nounMapping2SUMO('01265734-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01265921-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01266152-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01266364-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01266491-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01266745-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01266945-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01267135-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01267344-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('01267588-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01267808-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('01267901-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('01268020-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01268183-n',[ ('Position',subsumption)]).
nounMapping2SUMO('01268271-n',[ ('Surgery',subsumption)]).
nounMapping2SUMO('01268457-n',[ ('Battle',instance)]).
nounMapping2SUMO('01268633-n',[ ('Battle',instance)]).
nounMapping2SUMO('01268886-n',[ ('Battle',instance)]).
nounMapping2SUMO('01269161-n',[ ('Battle',instance)]).
nounMapping2SUMO('01269360-n',[ ('Battle',instance)]).
nounMapping2SUMO('01269633-n',[ ('Battle',instance)]).
nounMapping2SUMO('01269857-n',[ ('Battle',instance)]).
nounMapping2SUMO('01270153-n',[ ('Battle',instance)]).
nounMapping2SUMO('01270343-n',[ ('Battle',instance)]).
nounMapping2SUMO('01270628-n',[ ('Battle',instance)]).
nounMapping2SUMO('01270860-n',[ ('Battle',instance)]).
nounMapping2SUMO('01271107-n',[ ('Battle',instance)]).
nounMapping2SUMO('01271428-n',[ ('Battle',instance)]).
nounMapping2SUMO('01271669-n',[ ('Battle',instance)]).
nounMapping2SUMO('01271915-n',[ ('Battle',instance)]).
nounMapping2SUMO('01272134-n',[ ('Battle',instance)]).
nounMapping2SUMO('01272367-n',[ ('Battle',instance)]).
nounMapping2SUMO('01272582-n',[ ('Battle',instance)]).
nounMapping2SUMO('01272787-n',[ ('Battle',instance)]).
nounMapping2SUMO('01273081-n',[ ('Battle',instance)]).
nounMapping2SUMO('01273230-n',[ ('Battle',instance)]).
nounMapping2SUMO('01273491-n',[ ('Battle',instance)]).
nounMapping2SUMO('01273735-n',[ ('Battle',instance)]).
nounMapping2SUMO('01274000-n',[ ('Battle',instance)]).
nounMapping2SUMO('01274171-n',[ ('Battle',instance)]).
nounMapping2SUMO('01274374-n',[ ('Battle',instance)]).
nounMapping2SUMO('01274531-n',[ ('Battle',instance)]).
nounMapping2SUMO('01274733-n',[ ('Battle',instance)]).
nounMapping2SUMO('01274909-n',[ ('Battle',instance)]).
nounMapping2SUMO('01275142-n',[ ('Battle',instance)]).
nounMapping2SUMO('01275389-n',[ ('Battle',instance)]).
nounMapping2SUMO('01275697-n',[ ('Battle',instance)]).
nounMapping2SUMO('01275934-n',[ ('War',instance)]).
nounMapping2SUMO('01276194-n',[ ('Battle',instance)]).
nounMapping2SUMO('01276436-n',[ ('Battle',instance)]).
nounMapping2SUMO('01276634-n',[ ('Battle',instance)]).
nounMapping2SUMO('01276875-n',[ ('Battle',instance)]).
nounMapping2SUMO('01277065-n',[ ('Battle',instance)]).
nounMapping2SUMO('01277288-n',[ ('Battle',instance)]).
nounMapping2SUMO('01277540-n',[ ('Battle',instance)]).
nounMapping2SUMO('01277755-n',[ ('Battle',instance)]).
nounMapping2SUMO('01277938-n',[ ('Battle',instance)]).
nounMapping2SUMO('01278232-n',[ ('Battle',instance)]).
nounMapping2SUMO('01278509-n',[ ('Battle',instance)]).
nounMapping2SUMO('01278692-n',[ ('Battle',instance)]).
nounMapping2SUMO('01278873-n',[ ('Battle',instance)]).
nounMapping2SUMO('01279120-n',[ ('Battle',instance)]).
nounMapping2SUMO('01279342-n',[ ('Battle',instance)]).
nounMapping2SUMO('01279615-n',[ ('Battle',instance)]).
nounMapping2SUMO('01279866-n',[ ('Battle',instance)]).
nounMapping2SUMO('01280055-n',[ ('Battle',instance)]).
nounMapping2SUMO('01280308-n',[ ('Battle',instance)]).
nounMapping2SUMO('01280514-n',[ ('Battle',instance)]).
nounMapping2SUMO('01280792-n',[ ('Battle',instance)]).
nounMapping2SUMO('01280990-n',[ ('Battle',instance)]).
nounMapping2SUMO('01281154-n',[ ('PoliticalRevolution',instance)]).
nounMapping2SUMO('01281427-n',[ ('Battle',instance)]).
nounMapping2SUMO('01281638-n',[ ('Battle',instance)]).
nounMapping2SUMO('01281813-n',[ ('Battle',instance)]).
nounMapping2SUMO('01282022-n',[ ('Battle',instance)]).
nounMapping2SUMO('01282289-n',[ ('Battle',instance)]).
nounMapping2SUMO('01282466-n',[ ('Battle',instance)]).
nounMapping2SUMO('01282711-n',[ ('Battle',instance)]).
nounMapping2SUMO('01282966-n',[ ('Battle',instance)]).
nounMapping2SUMO('01283185-n',[ ('Battle',instance)]).
nounMapping2SUMO('01283389-n',[ ('Battle',instance)]).
nounMapping2SUMO('01283565-n',[ ('Battle',instance)]).
nounMapping2SUMO('01283753-n',[ ('Battle',instance)]).
nounMapping2SUMO('01283935-n',[ ('Battle',instance)]).
nounMapping2SUMO('01284124-n',[ ('Battle',instance)]).
nounMapping2SUMO('01284444-n',[ ('Battle',instance)]).
nounMapping2SUMO('01284928-n',[ ('Battle',instance)]).
nounMapping2SUMO('01285101-n',[ ('Battle',instance)]).
nounMapping2SUMO('01285305-n',[ ('Battle',instance)]).
nounMapping2SUMO('01285567-n',[ ('War',instance)]).
nounMapping2SUMO('01285784-n',[ ('Battle',instance)]).
nounMapping2SUMO('01286000-n',[ ('Battle',instance)]).
nounMapping2SUMO('01286181-n',[ ('Battle',instance)]).
nounMapping2SUMO('01286393-n',[ ('Battle',instance)]).
nounMapping2SUMO('01286569-n',[ ('Battle',instance)]).
nounMapping2SUMO('01286745-n',[ ('Battle',instance)]).
nounMapping2SUMO('01286938-n',[ ('Battle',instance)]).
nounMapping2SUMO('01287179-n',[ ('Battle',instance)]).
nounMapping2SUMO('01287431-n',[ ('Battle',instance)]).
nounMapping2SUMO('01287782-n',[ ('Battle',instance)]).
nounMapping2SUMO('01288057-n',[ ('Battle',instance)]).
nounMapping2SUMO('01288272-n',[ ('Battle',instance)]).
nounMapping2SUMO('01288549-n',[ ('Battle',instance)]).
nounMapping2SUMO('01288795-n',[ ('Battle',instance)]).
nounMapping2SUMO('01289061-n',[ ('Battle',instance)]).
nounMapping2SUMO('01289444-n',[ ('Battle',instance)]).
nounMapping2SUMO('01289631-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('01289830-n',[ ('Battle',instance)]).
nounMapping2SUMO('01289997-n',[ ('Battle',instance)]).
nounMapping2SUMO('01290162-n',[ ('Battle',instance)]).
nounMapping2SUMO('01290435-n',[ ('Battle',instance)]).
nounMapping2SUMO('01290711-n',[ ('Battle',instance)]).
nounMapping2SUMO('01290840-n',[ ('Battle',instance)]).
nounMapping2SUMO('01290997-n',[ ('Battle',instance)]).
nounMapping2SUMO('01291310-n',[ ('Battle',instance)]).
nounMapping2SUMO('01291517-n',[ ('Battle',instance)]).
nounMapping2SUMO('01291674-n',[ ('Battle',instance)]).
nounMapping2SUMO('01291839-n',[ ('Battle',instance)]).
nounMapping2SUMO('01292017-n',[ ('Battle',instance)]).
nounMapping2SUMO('01292200-n',[ ('Battle',instance)]).
nounMapping2SUMO('01292343-n',[ ('Battle',instance)]).
nounMapping2SUMO('01292553-n',[ ('Battle',instance)]).
nounMapping2SUMO('01292735-n',[ ('Battle',instance)]).
nounMapping2SUMO('01292928-n',[ ('Battle',instance)]).
nounMapping2SUMO('01293167-n',[ ('Battle',instance)]).
nounMapping2SUMO('01293438-n',[ ('Battle',instance)]).
nounMapping2SUMO('01293650-n',[ ('Battle',instance)]).
nounMapping2SUMO('01293832-n',[ ('Battle',instance)]).
nounMapping2SUMO('01294127-n',[ ('Battle',instance)]).
nounMapping2SUMO('01294330-n',[ ('Battle',instance)]).
nounMapping2SUMO('01294502-n',[ ('Battle',instance)]).
nounMapping2SUMO('01294791-n',[ ('Battle',instance)]).
nounMapping2SUMO('01295153-n',[ ('Battle',instance)]).
nounMapping2SUMO('01295373-n',[ ('Battle',instance)]).
nounMapping2SUMO('01295528-n',[ ('Battle',instance)]).
nounMapping2SUMO('01295684-n',[ ('Battle',instance)]).
nounMapping2SUMO('01295918-n',[ ('Battle',instance)]).
nounMapping2SUMO('01296127-n',[ ('Battle',instance)]).
nounMapping2SUMO('01296296-n',[ ('Battle',instance)]).
nounMapping2SUMO('01296505-n',[ ('Battle',instance)]).
nounMapping2SUMO('01296697-n',[ ('Battle',instance)]).
nounMapping2SUMO('01296946-n',[ ('Battle',instance)]).
nounMapping2SUMO('01297095-n',[ ('Battle',instance)]).
nounMapping2SUMO('01297291-n',[ ('Battle',instance)]).
nounMapping2SUMO('01297484-n',[ ('Battle',instance)]).
nounMapping2SUMO('01297706-n',[ ('Battle',instance)]).
nounMapping2SUMO('01297978-n',[ ('Battle',instance)]).
nounMapping2SUMO('01298162-n',[ ('Battle',instance)]).
nounMapping2SUMO('01298371-n',[ ('Battle',instance)]).
nounMapping2SUMO('01298573-n',[ ('Battle',instance)]).
nounMapping2SUMO('01298797-n',[ ('Battle',instance)]).
nounMapping2SUMO('01299037-n',[ ('Battle',instance)]).
nounMapping2SUMO('01299224-n',[ ('Battle',instance)]).
nounMapping2SUMO('01299476-n',[ ('Battle',instance)]).
nounMapping2SUMO('01299735-n',[ ('Battle',instance)]).
nounMapping2SUMO('01299994-n',[ ('Battle',instance)]).
nounMapping2SUMO('01300242-n',[ ('Battle',instance)]).
nounMapping2SUMO('01300508-n',[ ('Battle',instance)]).
nounMapping2SUMO('01300782-n',[ ('Battle',instance)]).
nounMapping2SUMO('01301080-n',[ ('Battle',instance)]).
nounMapping2SUMO('01301423-n',[ ('Battle',instance)]).
nounMapping2SUMO('01301630-n',[ ('War',instance)]).
nounMapping2SUMO('01302086-n',[ ('War',instance)]).
nounMapping2SUMO('01302449-n',[ ('War',instance)]).
nounMapping2SUMO('01302683-n',[ ('War',instance)]).
nounMapping2SUMO('01302935-n',[ ('War',subsumption)]).
nounMapping2SUMO('01303252-n',[ ('War',instance)]).
nounMapping2SUMO('01303582-n',[ ('War',instance)]).
nounMapping2SUMO('01303739-n',[ ('War',instance)]).
nounMapping2SUMO('01303934-n',[ ('PoliticalRevolution',instance)]).
nounMapping2SUMO('01304121-n',[ ('War',instance)]).
nounMapping2SUMO('01304356-n',[ ('War',instance)]).
nounMapping2SUMO('01304629-n',[ ('War',instance)]).
nounMapping2SUMO('01304820-n',[ ('War',instance)]).
nounMapping2SUMO('01305007-n',[ ('War',instance)]).
nounMapping2SUMO('01305147-n',[ ('War',instance)]).
nounMapping2SUMO('01305310-n',[ ('War',instance)]).
nounMapping2SUMO('01305551-n',[ ('War',instance)]).
nounMapping2SUMO('01305796-n',[ ('War',instance)]).
nounMapping2SUMO('01306007-n',[ ('War',instance)]).
nounMapping2SUMO('01306358-n',[ ('War',instance)]).
nounMapping2SUMO('01306736-n',[ ('War',instance)]).
nounMapping2SUMO('01306911-n',[ ('War',instance)]).
nounMapping2SUMO('01307090-n',[ ('War',instance)]).
nounMapping2SUMO('01307299-n',[ ('War',instance)]).
nounMapping2SUMO('01307606-n',[ ('War',instance)]).
nounMapping2SUMO('01307754-n',[ ('War',instance)]).
nounMapping2SUMO('01308008-n',[ ('War',instance)]).
nounMapping2SUMO('01308260-n',[ ('War',instance)]).
nounMapping2SUMO('01308438-n',[ ('War',instance)]).
nounMapping2SUMO('01308668-n',[ ('War',instance)]).
nounMapping2SUMO('01308837-n',[ ('War',instance)]).
nounMapping2SUMO('01309109-n',[ ('War',instance)]).
nounMapping2SUMO('01309395-n',[ ('War',instance)]).
nounMapping2SUMO('01309807-n',[ ('War',instance)]).
nounMapping2SUMO('01310074-n',[ ('War',instance)]).
nounMapping2SUMO('01310347-n',[ ('War',instance)]).
nounMapping2SUMO('01310536-n',[ ('War',instance)]).
nounMapping2SUMO('01310789-n',[ ('War',instance)]).
nounMapping2SUMO('01311045-n',[ ('War',instance)]).
nounMapping2SUMO('01311344-n',[ ('War',instance)]).
nounMapping2SUMO('01311520-n',[ ('War',instance)]).
nounMapping2SUMO('01312096-n',[ ('War',instance)]).
nounMapping2SUMO('01313093-n',[ ('Animal',equivalence)]).
nounMapping2SUMO('01313888-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01314026-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01314145-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01314388-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01314663-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01314781-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01314910-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01315062-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01315213-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01315330-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01315581-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01315805-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01315980-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01316288-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01316422-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01316579-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01316734-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01316838-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01316949-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01317089-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01317294-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01317391-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01317541-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01317813-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01317916-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01318053-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01318279-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01318381-n',[ ('DomesticAnimal',equivalence)]).
nounMapping2SUMO('01318478-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01318660-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01318894-n',[ ('DomesticAnimal',subsumption)]).
nounMapping2SUMO('01319001-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01319187-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01319339-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01319467-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01319685-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01319932-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01320093-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01320314-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01320479-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01320692-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01320872-n',[ ('Female',equivalence)]).
nounMapping2SUMO('01321123-n',[ ('Female',subsumption)]).
nounMapping2SUMO('01321230-n',[ ('Male',equivalence), ('Animal',subsumption)]).
nounMapping2SUMO('01321456-n',[ ('FullyFormed',equivalence)]).
nounMapping2SUMO('01321579-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01321770-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01321854-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01322221-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01322343-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01322508-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01322604-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01322685-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01322898-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01322983-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01323068-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01323155-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01323261-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01323355-n',[ ('Male',subsumption), ('Animal',subsumption)]).
nounMapping2SUMO('01323493-n',[ ('Female',subsumption), ('Animal',subsumption)]).
nounMapping2SUMO('01323599-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01323781-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01323901-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('01324019-n',[ ('Microorganism',equivalence)]).
nounMapping2SUMO('01324142-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('01324305-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01324431-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01324610-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01324799-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01324916-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01325060-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01325206-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01325417-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01325658-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01325775-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01325853-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01326015-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01326198-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01326291-n',[ ('Microorganism',equivalence)]).
nounMapping2SUMO('01326751-n',[ ('Atom',subsumption)]).
nounMapping2SUMO('01326897-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01327028-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01327204-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01327322-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01327765-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01327909-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01328121-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01328302-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('01328515-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01328702-n',[ ('Virus',equivalence)]).
nounMapping2SUMO('01329186-n',[ ('HepatitisVirus',subsumption)]).
nounMapping2SUMO('01329794-n',[ ('OrganicObject',subsumption)]).
nounMapping2SUMO('01329935-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01330126-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01330314-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01330497-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01330696-n',[ ('JuninVirus',equivalence)]).
nounMapping2SUMO('01330852-n',[ ('LassaVirus',equivalence)]).
nounMapping2SUMO('01330966-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01331188-n',[ ('MachupoVirus',equivalence)]).
nounMapping2SUMO('01331345-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01331522-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01331659-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01331867-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01332009-n',[ ('EbolaVirus',equivalence)]).
nounMapping2SUMO('01332181-n',[ ('MarburgVirus',equivalence)]).
nounMapping2SUMO('01332347-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01332488-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01332653-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01332795-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01332940-n',[ ('WestNileVirus',equivalence)]).
nounMapping2SUMO('01333082-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01333301-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01333483-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01333610-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01333731-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01333890-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01334036-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01334217-n',[ ('VariolaMajor',equivalence)]).
nounMapping2SUMO('01334368-n',[ ('VariolaMinor',equivalence)]).
nounMapping2SUMO('01334518-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01334690-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01334862-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01335218-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01335333-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01335460-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01335659-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01336076-n',[ ('HepatitisVirus',subsumption)]).
nounMapping2SUMO('01336282-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01336599-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01336718-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01336910-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01337078-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01337191-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01337329-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01337583-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01337734-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01337822-n',[ ('HepatitisAVirus',equivalence)]).
nounMapping2SUMO('01337915-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01338178-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01338333-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01338537-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01338685-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01338908-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01339083-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01339206-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01339336-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01339471-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01339623-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01339801-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01340014-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01340155-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01340331-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01340522-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01340648-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01340785-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01340935-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01341090-n',[ ('Rotavirus',equivalence)]).
nounMapping2SUMO('01341183-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01341410-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01341580-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01341727-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01341876-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01342269-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01342529-n',[ ('Animal',equivalence)]).
nounMapping2SUMO('01347199-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01347431-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01347583-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01347858-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01348075-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01348232-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01348388-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01348530-n',[ ('Bacterium',equivalence)]).
nounMapping2SUMO('01349333-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01349495-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01349735-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01349948-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01350226-n',[ ('BacillusAnthracis',equivalence)]).
nounMapping2SUMO('01350485-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01350701-n',[ ('YersiniaPestis',equivalence)]).
nounMapping2SUMO('01350855-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01350994-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01351170-n',[ ('BrucellaBacterium',equivalence)]).
nounMapping2SUMO('01351315-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01351453-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01351688-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01351959-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01352059-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01352574-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01353411-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01353658-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01353773-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01353932-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01354149-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01354324-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01354521-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01354724-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01354869-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01355326-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01356086-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01356459-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01356670-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01356888-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01357156-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01357328-n',[ ('ClostridiumBotulinum',equivalence)]).
nounMapping2SUMO('01357507-n',[ ('ClostridiumPerfringens',equivalence)]).
nounMapping2SUMO('01357707-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01357967-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01358135-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01358259-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01358572-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01358904-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01359070-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01359203-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01359365-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01359488-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01359631-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01359762-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01359945-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01360180-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01360330-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01360712-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01360937-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01361113-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01361261-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01361465-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01361683-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01361840-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01361973-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01362196-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01362336-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01362480-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01362623-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01362769-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01362999-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01363121-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01363288-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01363423-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01363600-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01363719-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01363887-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01364008-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01364162-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01364329-n',[ ('VibrioCholera',equivalence)]).
nounMapping2SUMO('01364472-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01364587-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01364866-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01365122-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01365322-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01365474-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01365684-n',[ ('FrancisellaTularensis',equivalence)]).
nounMapping2SUMO('01365885-n',[ ('NeisseriaGonorrhoeae',equivalence)]).
nounMapping2SUMO('01366015-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01366276-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01366415-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01366700-n',[ ('CorynebacteriumDiphtheriae',equivalence)]).
nounMapping2SUMO('01366881-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01367083-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01367208-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01367430-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01367772-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01368095-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01368216-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01368338-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01368552-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01368672-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01368853-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01368973-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01369210-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01369358-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01369484-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01369633-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01369819-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01370142-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01370260-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01370465-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01370581-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01370698-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01370816-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01370913-n',[ ('RickettsialAgent',equivalence)]).
nounMapping2SUMO('01371092-n',[ ('RickettsialAgent',equivalence)]).
nounMapping2SUMO('01371342-n',[ ('RickettsialAgent',equivalence)]).
nounMapping2SUMO('01371483-n',[ ('RickettsialAgent',equivalence)]).
nounMapping2SUMO('01371777-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01371928-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01372038-n',[ ('Object',subsumption)]).
nounMapping2SUMO('01372199-n',[ ('Virus',subsumption)]).
nounMapping2SUMO('01372372-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01372544-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01372709-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01372944-n',[ ('ChlamydiaPsittaci',equivalence)]).
nounMapping2SUMO('01373090-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01373272-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01373440-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01373675-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01373826-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01374063-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01374224-n',[ ('Legionella',equivalence)]).
nounMapping2SUMO('01374457-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01374703-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01374846-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01374989-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01375204-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01375460-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01375617-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01375760-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01375913-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01376092-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01376237-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01376437-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01376543-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01376647-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01376801-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01376948-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01377092-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01377278-n',[ ('MycobacteriumTuberculosis',equivalence)]).
nounMapping2SUMO('01377392-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01377510-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01377602-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01377694-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01377804-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01377906-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01378137-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01378346-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01378545-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01378800-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01379116-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01379252-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01379389-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01379636-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01379954-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01380118-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01380298-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01380489-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01380610-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01380754-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01380902-n',[ ('StreptococcusA',equivalence)]).
nounMapping2SUMO('01381044-n',[ ('StreptococcusA',equivalence)]).
nounMapping2SUMO('01381285-n',[ ('StreptococcusA',equivalence)]).
nounMapping2SUMO('01381399-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01381604-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01381829-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01382033-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01382273-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01382482-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01382699-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01382839-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01383027-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01383151-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01383332-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01383502-n',[ ('Bacterium',subsumption)]).
nounMapping2SUMO('01383638-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01383896-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('01384084-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01384164-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01384313-n',[ ('Group',subsumption)]).
nounMapping2SUMO('01384491-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01384687-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01385017-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01385330-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01385527-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01385749-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01385878-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01386007-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01386182-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('01386354-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01386494-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01387065-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01387208-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01387451-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01387617-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01388130-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01388992-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01389188-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01389507-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01389875-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01390123-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01390287-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01390466-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01390627-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01390763-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01390899-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01391028-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01391174-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01391391-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01391569-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01391779-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01391933-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01392122-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01392275-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01392380-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01392692-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01392843-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01393030-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01393237-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01393364-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01393486-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01393604-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01393753-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01393873-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01394040-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01394193-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01394366-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01394492-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01394635-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01394771-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01394901-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01395254-n',[ ('Protozoa',subsumption)]).
nounMapping2SUMO('01395531-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01395773-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01395885-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01396048-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01396170-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01396322-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01396458-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01396617-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01396776-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01396951-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01397114-n',[ ('Alga',equivalence)]).
nounMapping2SUMO('01397497-n',[ ('Seaweed',equivalence)]).
nounMapping2SUMO('01397690-n',[ ('Seaweed',subsumption)]).
nounMapping2SUMO('01397778-n',[ ('Seaweed',subsumption)]).
nounMapping2SUMO('01397871-n',[ ('Seaweed',subsumption)]).
nounMapping2SUMO('01398064-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('01398212-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('01398481-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('01398632-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('01398803-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('01398941-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('01399065-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('01399236-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('01399366-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('01399450-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('01399529-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01399772-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01400247-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01400391-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01400575-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01400772-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01400891-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01401106-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01401296-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01401517-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01401686-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01401842-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01402039-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01402169-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01402381-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01402600-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01402831-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01403052-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01403284-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01403457-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01403595-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01403713-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01403805-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01403968-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01404129-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01404365-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01404495-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01404628-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01404813-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01405007-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01405107-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01405250-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01405442-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01405616-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01405737-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01405858-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01406092-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01406262-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01406426-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01406565-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01406736-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01406904-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01407065-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01407465-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01407798-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01408088-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01408253-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01408383-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01408547-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01408743-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01408880-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01409065-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01409244-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01409477-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01409665-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01409940-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01410109-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01410330-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01410457-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01410568-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01410689-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01410847-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01411036-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01411240-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01411450-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01411556-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01411727-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01411871-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01412085-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01412279-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01412479-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01412694-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01412925-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01413071-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01413188-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01413324-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01413457-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01413551-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01413744-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01413942-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01414216-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01414359-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01414502-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01414633-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01414841-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01414986-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01415139-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01415256-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01415393-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01415524-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01415626-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('01415920-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01416213-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01416354-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01416585-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01417041-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01417361-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01417553-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01417674-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01417807-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01417982-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01418114-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01418237-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01418498-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01418620-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01418794-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01418947-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01419082-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01419332-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01419444-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01419573-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01419740-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01419888-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01420000-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01420164-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01420314-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01420525-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01420655-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01420860-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01421012-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01421164-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01421333-n',[ ('Alga',subsumption)]).
nounMapping2SUMO('01421496-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01421807-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01422185-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01422335-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01422450-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01422594-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01422835-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01423001-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01423160-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01423302-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01423464-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01423617-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01423757-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01423971-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01424165-n',[ ('MalarialPlasmodium',equivalence)]).
nounMapping2SUMO('01424282-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01424420-n',[ ('MalarialPlasmodium',subsumption)]).
nounMapping2SUMO('01424607-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01424782-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01424938-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01425076-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01425223-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01425336-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01425501-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01425634-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01425817-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01425983-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01426160-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01426314-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01426466-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01426625-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01426784-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01427005-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01427143-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01427241-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01427399-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01427547-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01427703-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01427848-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01428003-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01428155-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01428580-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01429172-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01429349-n',[ ('Fish',equivalence)]).
nounMapping2SUMO('01432517-n',[ ('Fish',equivalence)]).
nounMapping2SUMO('01437805-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01438208-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01438461-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01438581-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01438720-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01439121-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01439514-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01439657-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01439808-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01440160-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01440242-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01440344-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01440467-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01440655-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01440764-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01440949-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01441117-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01441272-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01441425-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01441625-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01441742-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01441910-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01442055-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01442166-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01442335-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01442450-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01442591-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01442710-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01442855-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01442972-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01443126-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01443243-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01443398-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01443537-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01443736-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01443831-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01443998-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01444164-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01444339-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01444520-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01444783-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01444922-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01445173-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01445305-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01445429-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01445593-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01445718-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01445857-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01445998-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01446152-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01446283-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01446589-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01446760-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01447001-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01447139-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01447331-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01447551-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01447658-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01447822-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01447946-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01448165-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01448291-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01448496-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01448594-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01448767-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01448951-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01449252-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01449374-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01449586-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01449712-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01449857-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01449980-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01450081-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01450281-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01450453-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01450661-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01450950-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01451115-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01451295-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01451426-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01451524-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01451726-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01451863-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01452051-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01452200-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01452345-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01452496-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01452633-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01452798-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01452954-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01453087-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01453188-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01453330-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01453475-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01453591-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01453742-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01453852-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01454260-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01454393-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01454545-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01454702-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01454856-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01455141-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01455317-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01455461-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01455592-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01455778-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01455986-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01456137-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01456296-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01456454-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01456631-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01456756-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01456939-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01457082-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01457276-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01457407-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01457576-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01457708-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01457852-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01458010-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01458105-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01458302-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01458509-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('01458616-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01458746-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01458842-n',[ ('Embryonic',equivalence)]).
nounMapping2SUMO('01459242-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01459480-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01459664-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('01459791-n',[ ('Embryonic',subsumption)]).
nounMapping2SUMO('01460108-n',[ ('Embryonic',subsumption)]).
nounMapping2SUMO('01460303-n',[ ('Embryonic',subsumption)]).
nounMapping2SUMO('01460457-n',[ ('Egg',equivalence)]).
nounMapping2SUMO('01460813-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01460963-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('01461146-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('01461315-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('01461445-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('01461532-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('01461646-n',[ ('Embryonic',subsumption)]).
nounMapping2SUMO('01462042-n',[ ('Embryonic',subsumption)]).
nounMapping2SUMO('01462209-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('01462544-n',[ ('Embryonic',subsumption)]).
nounMapping2SUMO('01462803-n',[ ('Embryonic',subsumption)]).
nounMapping2SUMO('01462945-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01463115-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01463259-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01463419-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('01463519-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01463739-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01463933-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01464077-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01464318-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01464441-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('01464573-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01464766-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('01464844-n',[ ('EggYolk',equivalence)]).
nounMapping2SUMO('01465046-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01465243-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01465472-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01465593-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01465713-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01465994-n',[ ('Vertebrate',equivalence)]).
nounMapping2SUMO('01466257-n',[ ('Vertebrate',equivalence)]).
nounMapping2SUMO('01466472-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('01466701-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('01466828-n',[ ('Vertebrate',equivalence)]).
nounMapping2SUMO('01466996-n',[ ('Vertebrate',equivalence)]).
nounMapping2SUMO('01467180-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01467336-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01467504-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01467675-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01467804-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01467986-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01468238-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01468532-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01468712-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01468913-n',[ ('Device',subsumption)]).
nounMapping2SUMO('01469103-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01469222-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01469425-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01469586-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01469723-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01469886-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01470018-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01470145-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01470287-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01470479-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01470586-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01470733-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01470895-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01471070-n',[ ('Vertebrate',equivalence)]).
nounMapping2SUMO('01471682-n',[ ('Vertebrate',equivalence)]).
nounMapping2SUMO('01472303-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01472502-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01472638-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01472939-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01473188-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01473393-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01473620-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01473806-n',[ ('Vertebrate',subsumption)]).
nounMapping2SUMO('01473990-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01474283-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01474641-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01474864-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01475025-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01475232-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01475421-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01475648-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01475794-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01475940-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01476135-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01476418-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01476696-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01476829-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01477080-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01477184-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01477373-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01477525-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01477745-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01477875-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01478073-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01478300-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01478511-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01478816-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01478969-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01479066-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01479213-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01479329-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01479459-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01479643-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01479820-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01479937-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01480106-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01480336-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01480516-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01480715-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01480880-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01481063-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01481203-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01481331-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01481498-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01481599-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01482071-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01482330-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01482754-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01482887-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01483021-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01483188-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01483370-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01483522-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01483707-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01483830-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01483980-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01484097-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01484285-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01484447-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01484562-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01484717-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01484850-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01485073-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01485306-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01485479-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01485673-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01485801-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01486010-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01486241-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01486411-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01486540-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01486706-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01486838-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01487077-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01487312-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01487506-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01487743-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01487914-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01488038-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01488234-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01488385-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01488539-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01488918-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01489275-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01489501-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01489709-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01489920-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01490112-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01490360-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01490546-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01490670-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01490885-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01491006-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01491235-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01491361-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01491520-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01491661-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01491874-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01491991-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01492212-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01492357-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01492569-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01492708-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01492860-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01493012-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01493146-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01493366-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01493541-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01493687-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01493829-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01494041-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01494188-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01494339-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01494475-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01494757-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01494882-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01495006-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01495192-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01495340-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01495493-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01495701-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01496037-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01496199-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01496331-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01496617-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01496944-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01497118-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01497278-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01497413-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01497579-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01497738-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01497878-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01498041-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01498268-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01498406-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01498577-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01498699-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01498822-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01498989-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01499261-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01499396-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01499595-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01499732-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01499898-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01500091-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01500360-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01500476-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01500721-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01500854-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01500995-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01501160-n',[ ('Skate',equivalence)]).
nounMapping2SUMO('01501450-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('01501641-n',[ ('Skate',subsumption)]).
nounMapping2SUMO('01501777-n',[ ('Skate',subsumption)]).
nounMapping2SUMO('01501948-n',[ ('Skate',subsumption)]).
nounMapping2SUMO('01502101-n',[ ('Skate',subsumption)]).
nounMapping2SUMO('01502262-n',[ ('Bird',equivalence)]).
nounMapping2SUMO('01503061-n',[ ('Bird',equivalence)]).
nounMapping2SUMO('01503976-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01504179-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01504344-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01504437-n',[ ('Bird',equivalence)]).
nounMapping2SUMO('01507175-n',[ ('Bird',equivalence)]).
nounMapping2SUMO('01514431-n',[ ('Breast',subsumption)]).
nounMapping2SUMO('01514549-n',[ ('Throat',equivalence)]).
nounMapping2SUMO('01514668-n',[ ('Male',subsumption), ('Bird',subsumption)]).
nounMapping2SUMO('01514752-n',[ ('Male',subsumption), ('Bird',subsumption)]).
nounMapping2SUMO('01514859-n',[ ('Female',subsumption), ('Bird',subsumption), ('FullyFormed',subsumption)]).
nounMapping2SUMO('01514926-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01515078-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01515217-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01515303-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01515398-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01515583-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01515811-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01516064-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01516212-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01516487-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01516609-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01516878-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01517036-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01517265-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01517389-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01517565-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01517966-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01518170-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01518347-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01518564-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01518718-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01518878-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01519046-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01519228-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01519401-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01519563-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01519719-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01519873-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01520058-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01520284-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01520442-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01520576-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01520789-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01521014-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01521197-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01521399-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01521602-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01521756-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01521980-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01522147-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01522305-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01522450-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01522594-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01522789-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01522952-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01523105-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01523248-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01523379-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01523493-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01523656-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01523908-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01524359-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01524761-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01524885-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01525720-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01526521-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01526635-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01526766-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01526925-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01527055-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01527194-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01527347-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01527480-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01527617-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01527774-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01527917-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01528087-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01528244-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01528396-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01528542-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01528654-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01528845-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01529036-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01529672-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01530256-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01530439-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01530575-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01530691-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01530846-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01531178-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01531344-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01531512-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01531639-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01531811-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01531971-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01532107-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01532325-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01532511-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01532664-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01532829-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01533000-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01533169-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01533339-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01533481-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01533651-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01533780-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01533893-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01534034-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01534155-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01534321-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01534433-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01534582-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01534762-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01535005-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01535140-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01535310-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01535469-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01535690-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01535842-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01536035-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01536186-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01536334-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01536474-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01536644-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01536780-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01536916-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01537134-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01537360-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01537544-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01537710-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01537895-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01538059-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01538200-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01538362-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01538498-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01538630-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01538775-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01538955-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01539136-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01539272-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01539377-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01539573-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01539772-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01539925-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01540090-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01540233-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01540432-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01540566-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01540697-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01540832-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01540969-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01541102-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01541261-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01541386-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01541618-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01541760-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01541922-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01542055-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01542168-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01542316-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01542433-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01542567-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01542786-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01543059-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01543175-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01543272-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01543383-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01543508-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01543632-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01543817-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01543936-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01544067-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01544208-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01544389-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01544544-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01544704-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01544877-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01545010-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01545149-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01545303-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01545425-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01545574-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01545752-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01545889-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01546039-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01546223-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01546348-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01546506-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01546660-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01546921-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01547143-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01547459-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01547832-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01548143-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01548301-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01548492-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01548694-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01548865-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01549053-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01549314-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01549430-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01549641-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01549769-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01549886-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01550033-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01550172-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01550429-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01550625-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01550761-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01550953-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01551080-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01551300-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01551430-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01551549-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01551711-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01551915-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01552034-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01552192-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01552333-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01552523-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01552654-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01552813-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01552956-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01553142-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01553380-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01553527-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01553620-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01553762-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01553879-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01554017-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01554139-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01554311-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01554448-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01554708-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01554825-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01555004-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01555172-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01555305-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01555586-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01555809-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01556040-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01556182-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01556368-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01556514-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01556671-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01557028-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01557185-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01557697-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01557962-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01558149-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01558307-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01558461-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01558594-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01558765-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01558993-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01559160-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01559294-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01559477-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01559639-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01559804-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01559964-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01560105-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01560280-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01560419-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01560511-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01560636-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01560793-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01560935-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01561059-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01561181-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01561318-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01561452-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01561613-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01561732-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01561884-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01562014-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01562116-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01562265-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01562451-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01562584-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01562978-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01563128-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01563313-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01563449-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01563579-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01563746-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01563945-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01564101-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01564217-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01564394-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01564630-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01564773-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01564914-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01565078-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01565238-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01565345-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01565480-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01565599-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01565804-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01565930-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01566082-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01566207-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01566386-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01566509-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01566645-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01566888-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01567133-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01567530-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01567678-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01567879-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01568019-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01568132-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01568294-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01568493-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01568720-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01568892-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01569060-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01569262-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01569423-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01569566-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01569713-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01569836-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01569971-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01570112-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01570267-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01570421-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01570549-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01570676-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01570839-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01570969-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01571126-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01571297-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01571410-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01571578-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01571904-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01572174-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01572328-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01572489-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01572654-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01572782-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01572910-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01573074-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01573240-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01573360-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01573483-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01573627-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01573775-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01573898-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01574045-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01574270-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01574390-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01574560-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01574671-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01574801-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01574997-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01575117-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01575270-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01575401-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01575577-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01575745-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01575941-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01576076-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01576212-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01576358-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01576506-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01576695-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01576863-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01577035-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01577265-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01577458-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01577659-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01577818-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01577941-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01578086-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01578180-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01578341-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01578575-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01578821-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01579028-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01579149-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01579260-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01579410-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01579578-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01579729-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01579868-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01580077-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01580225-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01580379-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01580490-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01580644-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01580772-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01580870-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01581041-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01581166-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01581434-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01581607-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01581730-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01581874-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01581984-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01582111-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01582220-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01582398-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01582498-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01582625-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01582856-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01583043-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01583209-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01583373-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01583495-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01583636-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01583828-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01584004-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01584225-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01584529-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01584695-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01584853-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01584994-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01585121-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01585287-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01585422-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01585577-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01585715-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01585890-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01586020-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01586170-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01586374-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01586541-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01586791-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01586941-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01587148-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01587278-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01587406-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01587526-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01587713-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01587834-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01588002-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01588172-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01588431-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01588589-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01588725-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01588858-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01588996-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01589125-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01589286-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01589582-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01589718-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01589893-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01590042-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01590220-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01590443-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01590583-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01590837-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01591005-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01591123-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01591301-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01591490-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01591697-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01591910-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01592084-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01592257-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01592387-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01592540-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01592694-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01592892-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01593028-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01593156-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01593282-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01593423-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01593553-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01593705-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01593857-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01594004-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01594157-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01594372-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01594611-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01594787-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01594968-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01595168-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01595330-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01595450-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01595624-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01595841-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01595974-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01596142-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01596273-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01596479-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01596608-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01596761-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01596887-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01597022-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01597194-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01597336-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01597551-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01597737-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01597906-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01598074-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01598271-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01598432-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01598588-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01598820-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01598988-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01599159-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01599269-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01599388-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01599556-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01599741-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01599919-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01600085-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01600197-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01600341-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01600480-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01600657-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01600909-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01601068-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01601268-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01601410-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01601550-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01601694-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01601919-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01602080-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01602209-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01602353-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01602506-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01602630-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01602832-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01603000-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01603152-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01603316-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01603478-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01603600-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01603812-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01603953-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01604123-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01604330-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01604625-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01604968-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01605119-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01605630-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01606097-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01606177-n',[ ('Male',subsumption), ('Bird',subsumption)]).
nounMapping2SUMO('01606335-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01606522-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01606672-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01606809-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01606978-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01607103-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01607309-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01607429-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01607600-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01607812-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01607962-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01608086-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01608265-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01608432-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01608685-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01608814-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01608934-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01609062-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01609236-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01609391-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01609549-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01609751-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01609956-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01610100-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01610226-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01610426-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01610552-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01610758-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01610955-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01611252-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01611472-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01611674-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01611800-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01611969-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01612122-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01612275-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01612476-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01612628-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01612803-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01612955-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01613177-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01613294-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01613615-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01613807-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01613909-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01614038-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01614195-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01614343-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01614556-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01614690-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01614769-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01614925-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01615121-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01615303-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01615458-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01615703-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01615825-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01615949-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01616086-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01616318-n',[ ('Vulture',subsumption)]).
nounMapping2SUMO('01616551-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01616764-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01616970-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01617095-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01617289-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01617443-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01617633-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01617766-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01617949-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01618082-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01618220-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01618356-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01618503-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01618671-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01618922-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01619152-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01619310-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01619536-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01619675-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01619835-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01620003-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01620135-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01620282-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01620414-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01620575-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01620735-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01620967-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01621127-n',[ ('Owl',subsumption)]).
nounMapping2SUMO('01621635-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01621714-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01621994-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01622120-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01622230-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01622352-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01622483-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01622596-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01622779-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01622959-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01623110-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01623284-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01623425-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01623615-n',[ ('Owl',subsumption)]).
nounMapping2SUMO('01623706-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01623880-n',[ ('Owl',subsumption)]).
nounMapping2SUMO('01624115-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01624212-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01624305-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01624406-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01624537-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01624707-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01624833-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01624987-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01625121-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01625275-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01625417-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01625562-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01625747-n',[ ('Amphibian',equivalence)]).
nounMapping2SUMO('01626134-n',[ ('Amphibian',equivalence)]).
nounMapping2SUMO('01626600-n',[ ('Amphibian',equivalence)]).
nounMapping2SUMO('01627424-n',[ ('Amphibian',equivalence)]).
nounMapping2SUMO('01627786-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01627976-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01628148-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01628331-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01628450-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01628770-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01628885-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01629093-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01629276-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01629819-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01629962-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01630148-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01630284-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01630533-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01630670-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01630795-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01630901-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01631035-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01631175-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01631354-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01631512-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01631663-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01631759-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01631903-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01632047-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01632308-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01632458-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01632601-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01632777-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01632952-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01633047-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01633250-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01633406-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01633578-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01633781-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01633949-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01634092-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01634227-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01634392-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01634522-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01634684-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01634891-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01635027-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01635176-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01635343-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01635480-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01635659-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01635964-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01636127-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01636352-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01636510-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01636675-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01636829-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01636984-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01637112-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01637338-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01637478-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01637615-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01637796-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01637932-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01638194-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01638329-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01638482-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01638611-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01638722-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01638952-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01639071-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01639187-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01639369-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01639765-n',[ ('Toad',subsumption)]).
nounMapping2SUMO('01640383-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01640567-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01640846-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01641206-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01641391-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01641577-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01641739-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01641930-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01642097-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01642257-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01642391-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01642539-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01642671-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01642943-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01643092-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01643255-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01643374-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01643507-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01643687-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01643896-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01644104-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01644245-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01644373-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01644542-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01644699-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01644900-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01645093-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01645278-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01645466-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01645634-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01645776-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01646134-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01646292-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01646388-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01646555-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01646648-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01646802-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01646902-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01647033-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01647180-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01647303-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01647466-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01647640-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01647803-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01648001-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01648139-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01648356-n',[ ('Toad',subsumption)]).
nounMapping2SUMO('01648494-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01648620-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01648818-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01648993-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01649170-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01649412-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01649556-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01649726-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01649948-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01650167-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01650509-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01650690-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01650901-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01651059-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01651285-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01651370-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01651487-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01651641-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01651778-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01651900-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01652026-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01652163-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01652297-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01652583-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01652850-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01653026-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01653223-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01653384-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01653509-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01653610-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01653773-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01653975-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01654083-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01654245-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01654429-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01654637-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01654863-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01654957-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01655116-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01655344-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01655577-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01655951-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01656078-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01656340-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01656576-n',[ ('Amphibian',subsumption)]).
nounMapping2SUMO('01656813-n',[ ('Reptile',equivalence)]).
nounMapping2SUMO('01657723-n',[ ('Reptile',equivalence)]).
nounMapping2SUMO('01660719-n',[ ('Reptile',equivalence)]).
nounMapping2SUMO('01661091-n',[ ('Reptile',equivalence)]).
nounMapping2SUMO('01661404-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01661592-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01661818-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01662060-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01662274-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01662622-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01662784-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01663169-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01663401-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01663659-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01663782-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01663939-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01664065-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01664244-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01664369-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01664492-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01664674-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01664862-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01664990-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01665238-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01665372-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01665541-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01665761-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01665932-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01666102-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01666228-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01666431-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01666585-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01666802-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01666967-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01667114-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01667302-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01667432-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01667570-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01667778-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01667959-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01668091-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01668257-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01668436-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01668665-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01668892-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01669068-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01669191-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01669372-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01669527-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01669654-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01669883-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01670092-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01670378-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01670535-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01670673-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01670802-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01670961-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01671125-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01671312-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01671479-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01671705-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01671874-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01672032-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01672275-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01672432-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01672611-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01672767-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01672950-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01673118-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01673282-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01673503-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01673668-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01674216-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01674464-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01674850-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01674990-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01675225-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01675352-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01675599-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01675722-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01675964-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01676113-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01676313-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01676755-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01677242-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01677366-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01677613-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01677747-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01677913-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01678043-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01678237-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01678343-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01678522-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01678657-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01678887-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01679005-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01679178-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01679307-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01679494-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01679626-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01679837-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01679962-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01680137-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01680264-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01680478-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01680655-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01680813-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01680983-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01681200-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01681328-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01681513-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01681653-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01681812-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01681940-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01682172-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01682293-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01682435-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01682588-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01682714-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01682920-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01683036-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01683201-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01683428-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01683558-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01683724-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01683900-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01684012-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01684133-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01684435-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01684578-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01684741-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01684941-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01685107-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01685277-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01685439-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01685679-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01685808-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01686044-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01686220-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01686403-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01686609-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01686808-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01687009-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01687128-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01687290-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01687441-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01687665-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01687856-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01687978-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01688106-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01688243-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01688428-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01688589-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01688812-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01688961-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01689081-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01689226-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01689411-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01689678-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01689811-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01690005-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01690149-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01690339-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01690466-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01690703-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01690857-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01691085-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01691217-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01691384-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01691525-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01691652-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01691782-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01691951-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01692143-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01692333-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01692523-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01692713-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01692864-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01693020-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01693175-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01693334-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01693472-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01693783-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01693995-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01694178-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01694311-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01694430-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01694558-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01694709-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01694955-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01695060-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01695259-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01695681-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01696026-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01696151-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01696282-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01696525-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01696633-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01696849-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01697002-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01697178-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01697457-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01697611-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01697749-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01697837-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01697978-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01698144-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01698303-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01698434-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01698640-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01698782-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01698936-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01699040-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01699254-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01699415-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01699537-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01699675-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01699831-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01700076-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01700470-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01700754-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01700924-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01701052-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01701205-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01701334-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01701551-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01701697-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01701859-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01702087-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01702256-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01702479-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01702623-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01702862-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01703011-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01703161-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01703341-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01703569-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01703866-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01703996-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01704103-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01704184-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01704323-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01704497-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01704626-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01704847-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01705010-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01705247-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01705591-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01705717-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01705934-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01706247-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01706401-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01706533-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01706686-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01706865-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01707000-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01707149-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01707294-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01707433-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01707566-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01707698-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01707895-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01708106-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01708332-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01708648-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01708778-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01708998-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01709278-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01709484-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01709723-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01709876-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01710035-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01710177-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01710348-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01710529-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01710747-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01710993-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01711160-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01711297-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01711496-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01711662-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01712008-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01712432-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01712606-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01712752-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01713040-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01713170-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01713310-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01713508-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01713635-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01713764-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01714059-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01714231-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01714404-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01714536-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01714686-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01714843-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01714982-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01715134-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01715249-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01715383-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01715518-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01715692-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01715888-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01716122-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01716298-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01716459-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01716594-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01716732-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01717016-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01717229-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01717335-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01717467-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01717666-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01717860-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01717957-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01718096-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01718276-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01718414-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01718632-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01718808-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01719175-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01719403-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01719645-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01719914-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01720117-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01720266-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01720496-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01720767-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01720867-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01721010-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01721174-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01721269-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01721404-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01721567-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01721718-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01721898-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01722085-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01722254-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01722389-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01722538-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01722670-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01722828-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01722998-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01723259-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01723425-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01723579-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01723678-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01723883-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01724055-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01724231-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01724470-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01724703-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01724840-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01724947-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01725086-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01725240-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01725427-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01725570-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01725713-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01725933-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01726079-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01726203-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01726390-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01726692-n',[ ('Snake',equivalence)]).
nounMapping2SUMO('01726960-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01727646-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01728266-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01728445-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01728572-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01728738-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01728920-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01729133-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01729322-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01729533-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01729672-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01729838-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01729977-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01730185-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01730307-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01730429-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01730563-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01730679-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01730812-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01730960-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01731137-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01731277-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01731418-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01731545-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01731764-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01731941-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01732093-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01732244-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01732445-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01732614-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01732789-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01732989-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01733094-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01733214-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01733346-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01733466-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01733634-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01733757-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01733957-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01734104-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01734273-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01734418-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01734637-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01734808-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01735062-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01735189-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01735439-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01735577-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01735728-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01735898-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01736032-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01736256-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01736375-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01736569-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01736696-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01736796-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01737021-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01737197-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01737356-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01737472-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01737728-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01737875-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01738065-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01738175-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01738306-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01738470-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01738601-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01738731-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01738965-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01739094-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01739260-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01739381-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01739518-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01739647-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01739871-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01740005-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01740131-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01740283-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01740393-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01740551-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01740721-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01740885-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01741116-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01741232-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01741442-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01741562-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01741744-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01741943-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01742172-n',[ ('ConstrictorSnake',subsumption)]).
nounMapping2SUMO('01742310-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01742447-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01742680-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01742821-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01742967-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01743086-n',[ ('ConstrictorSnake',subsumption)]).
nounMapping2SUMO('01743223-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01743449-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01743605-n',[ ('ConstrictorSnake',subsumption)]).
nounMapping2SUMO('01743787-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01743936-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01744100-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01744270-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01744401-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01744555-n',[ ('ConstrictorSnake',subsumption)]).
nounMapping2SUMO('01744657-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01745125-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01745484-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01745780-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01745902-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01746063-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01746191-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01746359-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01746565-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01746727-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01746818-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01746952-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01747144-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01747285-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01747466-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01747589-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01747739-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01747885-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01748100-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('01748264-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01748389-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01748560-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01748686-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01748906-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01749141-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01749244-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01749428-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01749582-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01749742-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01749939-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01750027-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01750167-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01750315-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01750437-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01750598-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01750743-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01750920-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01751036-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01751215-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01751353-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01751472-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01751621-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01751748-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01751979-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01752165-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01752433-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01752585-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01752736-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01752889-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01753032-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01753180-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01753354-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01753488-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01753721-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01753959-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01754190-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01754370-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01754533-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01754737-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01754876-n',[ ('Rattlesnake',subsumption)]).
nounMapping2SUMO('01755274-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01755581-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01755740-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01755952-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01756089-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01756291-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01756508-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01756733-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01756916-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01757115-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01757343-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01757547-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01757677-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01757901-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01758019-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01758141-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01758308-n',[ ('Reptile',subsumption)]).
nounMapping2SUMO('01758510-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01758637-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01758757-n',[ ('Dead',subsumption)]).
nounMapping2SUMO('01758895-n',[ ('Dead',subsumption)]).
nounMapping2SUMO('01759009-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01759182-n',[ ('Arthropod',equivalence)]).
nounMapping2SUMO('01762525-n',[ ('Arthropod',equivalence)]).
nounMapping2SUMO('01767199-n',[ ('Arthropod',equivalence)]).
nounMapping2SUMO('01767661-n',[ ('Arthropod',equivalence)]).
nounMapping2SUMO('01768244-n',[ ('Arthropod',subsumption)]).
nounMapping2SUMO('01768402-n',[ ('Arthropod',subsumption)]).
nounMapping2SUMO('01768596-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01768808-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01768969-n',[ ('Arachnid',equivalence)]).
nounMapping2SUMO('01769347-n',[ ('Arachnid',equivalence)]).
nounMapping2SUMO('01769635-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01769789-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01769930-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01770081-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01770263-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01770393-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01770553-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01770795-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01770967-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01771100-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01771246-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01771417-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01771624-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01771766-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01771966-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01772222-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01772664-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01772782-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01772985-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01773157-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01773319-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01773549-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01773797-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01773930-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01774097-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01774252-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01774384-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01774595-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01774750-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01774918-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01775062-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01775230-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01775370-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01775592-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01775730-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01775879-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01776192-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01776313-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01776546-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01776705-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01777032-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01777304-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01777467-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01777649-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01777909-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01778217-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01778487-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01778621-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01778801-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01778984-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01779148-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01779340-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01779463-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01779629-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01779939-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01780026-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01780142-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01780302-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01780426-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01780551-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01780696-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01780919-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01781071-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01781274-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01781410-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01781570-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01781698-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01781875-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01782050-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01782209-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01782378-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01782516-n',[ ('Arachnid',subsumption)]).
nounMapping2SUMO('01782675-n',[ ('Myriapod',equivalence)]).
nounMapping2SUMO('01783017-n',[ ('Myriapod',equivalence)]).
nounMapping2SUMO('01783205-n',[ ('Myriapod',subsumption)]).
nounMapping2SUMO('01783384-n',[ ('Myriapod',subsumption)]).
nounMapping2SUMO('01783571-n',[ ('Myriapod',subsumption)]).
nounMapping2SUMO('01783706-n',[ ('Myriapod',subsumption)]).
nounMapping2SUMO('01783936-n',[ ('Myriapod',subsumption)]).
nounMapping2SUMO('01784293-n',[ ('Myriapod',subsumption)]).
nounMapping2SUMO('01784427-n',[ ('Myriapod',subsumption)]).
nounMapping2SUMO('01784675-n',[ ('Myriapod',subsumption)]).
nounMapping2SUMO('01784925-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01785092-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01785234-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01785392-n',[ ('Myriapod',subsumption)]).
nounMapping2SUMO('01785532-n',[ ('Myriapod',subsumption)]).
nounMapping2SUMO('01785667-n',[ ('Myriapod',subsumption)]).
nounMapping2SUMO('01785831-n',[ ('Myriapod',subsumption)]).
nounMapping2SUMO('01786048-n',[ ('Myriapod',subsumption)]).
nounMapping2SUMO('01786219-n',[ ('Myriapod',subsumption)]).
nounMapping2SUMO('01786402-n',[ ('Myriapod',subsumption)]).
nounMapping2SUMO('01786646-n',[ ('Myriapod',subsumption)]).
nounMapping2SUMO('01786879-n',[ ('Arthropod',subsumption)]).
nounMapping2SUMO('01787006-n',[ ('Arthropod',subsumption)]).
nounMapping2SUMO('01787191-n',[ ('Arthropod',subsumption)]).
nounMapping2SUMO('01787401-n',[ ('Arthropod',subsumption)]).
nounMapping2SUMO('01787546-n',[ ('Arthropod',subsumption)]).
nounMapping2SUMO('01787693-n',[ ('Arthropod',subsumption)]).
nounMapping2SUMO('01787835-n',[ ('Arthropod',subsumption)]).
nounMapping2SUMO('01788157-n',[ ('Arthropod',subsumption)]).
nounMapping2SUMO('01788291-n',[ ('Arthropod',subsumption)]).
nounMapping2SUMO('01788420-n',[ ('Arthropod',subsumption)]).
nounMapping2SUMO('01788579-n',[ ('Arthropod',subsumption)]).
nounMapping2SUMO('01788730-n',[ ('Arthropod',subsumption)]).
nounMapping2SUMO('01788864-n',[ ('Arthropod',subsumption)]).
nounMapping2SUMO('01789064-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01789386-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01789740-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01790171-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01790304-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01790398-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01790557-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01790711-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01790812-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01790943-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01791107-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01791314-n',[ ('Male',subsumption), ('Bird',subsumption)]).
nounMapping2SUMO('01791388-n',[ ('Female',subsumption), ('Bird',subsumption)]).
nounMapping2SUMO('01791463-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01791625-n',[ ('Chicken',equivalence)]).
nounMapping2SUMO('01791954-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01792042-n',[ ('NonFullyFormed',subsumption), ('Bird',subsumption)]).
nounMapping2SUMO('01792158-n',[ ('Rooster',equivalence)]).
nounMapping2SUMO('01792255-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01792429-n',[ ('Male',subsumption), ('Chicken',subsumption)]).
nounMapping2SUMO('01792530-n',[ ('Male',subsumption), ('Chicken',subsumption)]).
nounMapping2SUMO('01792640-n',[ ('Hen',equivalence)]).
nounMapping2SUMO('01792808-n',[ ('Female',subsumption), ('Chicken',subsumption)]).
nounMapping2SUMO('01792955-n',[ ('Female',subsumption), ('Chicken',subsumption)]).
nounMapping2SUMO('01793085-n',[ ('Hen',subsumption)]).
nounMapping2SUMO('01793159-n',[ ('Hen',subsumption)]).
nounMapping2SUMO('01793249-n',[ ('Female',subsumption), ('Chicken',subsumption)]).
nounMapping2SUMO('01793340-n',[ ('Chicken',subsumption)]).
nounMapping2SUMO('01793435-n',[ ('Chicken',subsumption)]).
nounMapping2SUMO('01793565-n',[ ('Chicken',subsumption)]).
nounMapping2SUMO('01793715-n',[ ('Chicken',subsumption)]).
nounMapping2SUMO('01793818-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01793988-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01794158-n',[ ('Turkey',equivalence)]).
nounMapping2SUMO('01794344-n',[ ('Male',subsumption), ('Turkey',subsumption)]).
nounMapping2SUMO('01794460-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01794651-n',[ ('Turkey',subsumption)]).
nounMapping2SUMO('01794813-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01795088-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01795425-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01795545-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01795735-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01795900-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01796019-n',[ ('Male',subsumption), ('Bird',subsumption)]).
nounMapping2SUMO('01796105-n',[ ('Female',subsumption), ('Bird',subsumption)]).
nounMapping2SUMO('01796222-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01796340-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01796519-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01796729-n',[ ('Female',subsumption), ('Bird',subsumption)]).
nounMapping2SUMO('01796800-n',[ ('Male',subsumption), ('Bird',subsumption)]).
nounMapping2SUMO('01796870-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01797020-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01797180-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01797307-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01797472-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01797601-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01797767-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01797886-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01798052-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01798168-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01798352-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01798484-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01798706-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01798839-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01798979-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01799086-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01799302-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01799540-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01799679-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01799876-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01800042-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01800195-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01800286-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01800424-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01800633-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01800759-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01800963-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01801088-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01801371-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01801479-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01801672-n',[ ('Female',subsumption), ('Bird',subsumption)]).
nounMapping2SUMO('01801753-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01801876-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01802033-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01802159-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01802309-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01802721-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01802895-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01803078-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01803362-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01803548-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01803641-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01803764-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01803893-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01804029-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01804163-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01804340-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01804478-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01804653-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01804796-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01804921-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01805070-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01805199-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01805321-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01805446-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01805692-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01805801-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01806061-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01806143-n',[ ('Male',subsumption), ('Bird',subsumption)]).
nounMapping2SUMO('01806297-n',[ ('Female',subsumption), ('Bird',subsumption)]).
nounMapping2SUMO('01806364-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01806467-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01806567-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01806740-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01806847-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01806984-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01807105-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01807265-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01807496-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01807701-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01807828-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01807988-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01808140-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01808291-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01808447-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01808596-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01808785-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01808989-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01809106-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01809371-n',[ ('Female',subsumption), ('Bird',subsumption)]).
nounMapping2SUMO('01809446-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01809592-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01809752-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01809977-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01810132-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01810268-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01810466-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01810700-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01810946-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01811104-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01811243-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01811394-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01811542-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01811682-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01811909-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01812187-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01812337-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01812471-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01812662-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01812866-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01813088-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01813256-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01813385-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01813532-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01813658-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01813811-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01813948-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01814091-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01814217-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01814370-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01814549-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01814620-n',[ ('Carrying',equivalence)]).
nounMapping2SUMO('01814755-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01814921-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01815036-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01815135-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01815270-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01815431-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01815601-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01815855-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01816017-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01816140-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01816336-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01816474-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01816635-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01816887-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01817263-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01817346-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01817424-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01817772-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01817953-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01818169-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01818299-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01818409-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01818515-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01818704-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01818832-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01818959-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01819115-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01819313-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01819465-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01819600-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01819734-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01819918-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01820052-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01820190-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01820348-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01820546-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01820664-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01820801-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01820937-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01821076-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01821203-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01821418-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01821554-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01821727-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01821869-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01822164-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01822300-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01822423-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01822602-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01822773-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01823013-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01823279-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01823414-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01823610-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01823740-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01823912-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01824035-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01824227-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01824344-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01824443-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01824575-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01824749-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01824862-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01825009-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01825155-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01825278-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01825417-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01825758-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01825930-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01826223-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01826364-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01826542-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01826680-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01826844-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01826998-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01827202-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('01827403-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01827658-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01827793-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01827948-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01828096-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01828267-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01828397-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01828556-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01828714-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01828856-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01828970-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01829143-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01829288-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01829413-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01829602-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01829739-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01829869-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01830042-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01830183-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01830316-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01830479-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01830623-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01830799-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01830915-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01831078-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01831231-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01831360-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01831519-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01831712-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01831930-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01832167-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01832381-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01832493-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01832684-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01832813-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01832979-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01833112-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01833283-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01833415-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01833619-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01833805-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01834039-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01834177-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01834284-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01834412-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01834540-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01834702-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01834918-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01835087-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01835276-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01835584-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01835769-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01835918-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01836087-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01836246-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01836384-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01836527-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01836673-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01836809-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01836953-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01837072-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01837230-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01837363-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01837526-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01837746-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01838038-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01838326-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01838598-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01838961-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01839086-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01839221-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01839330-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01839470-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01839598-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01839750-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01839949-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01840120-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01840278-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01840412-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01840643-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01840775-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01840968-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01841102-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01841288-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01841441-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01841569-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01841679-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01841815-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01841943-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01842111-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01842235-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01842380-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01842504-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01842655-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01842788-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01842942-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01843065-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01843238-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01843383-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01843576-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01843719-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01843805-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01843932-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01844125-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01844231-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01844414-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01844551-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01844746-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01844917-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01845132-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01845272-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01845477-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01845627-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01846156-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01846331-n',[ ('Duck',equivalence)]).
nounMapping2SUMO('01847000-n',[ ('Male',subsumption), ('Duck',subsumption)]).
nounMapping2SUMO('01847089-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01847170-n',[ ('NonFullyFormed',subsumption), ('Duck',subsumption)]).
nounMapping2SUMO('01847253-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01847407-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01847565-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01847806-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01847978-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01848123-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01848323-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01848453-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01848555-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01848648-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01848840-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01848976-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01849157-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01849348-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01849466-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01849676-n',[ ('Female',subsumption), ('Duck',subsumption)]).
nounMapping2SUMO('01849747-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01849863-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01850035-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01850192-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01850373-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01850553-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01850676-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01850873-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01851038-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01851207-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01851375-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01851573-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01851731-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01851895-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01851996-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01852142-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01852329-n',[ ('Male',subsumption), ('Duck',subsumption)]).
nounMapping2SUMO('01852400-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01852544-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01852671-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01852861-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01853072-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01853195-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01853379-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01853498-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01853666-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01853763-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01853870-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01854047-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01854223-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01854415-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01854700-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01854838-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01855032-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01855188-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01855343-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01855476-n',[ ('Duck',subsumption)]).
nounMapping2SUMO('01855672-n',[ ('Goose',equivalence)]).
nounMapping2SUMO('01856072-n',[ ('NonFullyFormed',subsumption), ('Goose',subsumption)]).
nounMapping2SUMO('01856155-n',[ ('Male',subsumption), ('Goose',subsumption)]).
nounMapping2SUMO('01856225-n',[ ('Goose',subsumption)]).
nounMapping2SUMO('01856380-n',[ ('Goose',subsumption)]).
nounMapping2SUMO('01856553-n',[ ('Goose',subsumption)]).
nounMapping2SUMO('01856748-n',[ ('Goose',subsumption)]).
nounMapping2SUMO('01856890-n',[ ('Goose',subsumption)]).
nounMapping2SUMO('01857079-n',[ ('Goose',subsumption)]).
nounMapping2SUMO('01857171-n',[ ('Goose',subsumption)]).
nounMapping2SUMO('01857325-n',[ ('Goose',subsumption)]).
nounMapping2SUMO('01857512-n',[ ('Goose',subsumption)]).
nounMapping2SUMO('01857632-n',[ ('Goose',subsumption)]).
nounMapping2SUMO('01857851-n',[ ('Goose',subsumption)]).
nounMapping2SUMO('01858023-n',[ ('Goose',subsumption)]).
nounMapping2SUMO('01858162-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01858281-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01858441-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01858780-n',[ ('Male',subsumption), ('Bird',subsumption)]).
nounMapping2SUMO('01858845-n',[ ('Female',subsumption), ('Bird',subsumption)]).
nounMapping2SUMO('01858906-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01858989-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01859190-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01859325-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01859496-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01859689-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01859852-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01860002-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01860187-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01860337-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01860497-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01860713-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01860864-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01861025-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01861148-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01861330-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('01861465-n',[ ('Mammal',equivalence)]).
nounMapping2SUMO('01861778-n',[ ('Mammal',equivalence)]).
nounMapping2SUMO('01862399-n',[ ('Female',subsumption), ('Mammal',subsumption)]).
nounMapping2SUMO('01862557-n',[ ('Mammal',equivalence)]).
nounMapping2SUMO('01864707-n',[ ('Mammal',equivalence)]).
nounMapping2SUMO('01871265-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01871406-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01871543-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01871699-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01871875-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01872094-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01872244-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01872401-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01872635-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01872772-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01873007-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01873144-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01873310-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01873622-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01873850-n',[ ('Marsupial',equivalence)]).
nounMapping2SUMO('01873982-n',[ ('Marsupial',equivalence)]).
nounMapping2SUMO('01874126-n',[ ('Marsupial',equivalence)]).
nounMapping2SUMO('01874434-n',[ ('Marsupial',equivalence)]).
nounMapping2SUMO('01874784-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01874928-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01875165-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01875313-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01875610-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01875717-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01875880-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01876034-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01876180-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01876326-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01876535-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01876667-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01876843-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01877134-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01877407-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01877606-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01877812-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01878061-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01878203-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01878335-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01878500-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01878639-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01878803-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01878929-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01879095-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01879217-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01879379-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01879509-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01879701-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01879837-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01879983-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01880152-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01880355-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01880473-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01880570-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01880716-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01880813-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01880937-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01881171-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01881416-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01881564-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01881717-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01881857-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01881991-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01882125-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01882372-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01882508-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01882607-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01882714-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01882948-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01883070-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01883212-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01883513-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01883762-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01883920-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01884104-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01884203-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01884348-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01884476-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01884703-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01884834-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01885032-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01885158-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01885367-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01885498-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01885724-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01885856-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01886045-n',[ ('Marsupial',subsumption)]).
nounMapping2SUMO('01886220-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01886756-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01887474-n',[ ('DomesticAnimal',equivalence)]).
nounMapping2SUMO('01887623-n',[ ('Male',subsumption), ('Mammal',subsumption)]).
nounMapping2SUMO('01887787-n',[ ('Female',subsumption), ('Mammal',subsumption)]).
nounMapping2SUMO('01887896-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01888045-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01888181-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01888264-n',[ ('Male',subsumption), ('Mammal',subsumption)]).
nounMapping2SUMO('01888411-n',[ ('Female',subsumption), ('Mammal',subsumption)]).
nounMapping2SUMO('01888520-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01888821-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01888948-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01889074-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01889328-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01889520-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01889740-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01889849-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01890033-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01890144-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01890274-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01890411-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01890564-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01890718-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01890860-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01891013-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01891145-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01891274-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01891438-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01891633-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01891865-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01892030-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01892145-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01892271-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01892385-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01892551-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01892744-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01892876-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01893021-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01893164-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01893294-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01893399-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01893535-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01893666-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01893825-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01894040-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01894207-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01894381-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01894522-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01894670-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01894803-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01894956-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('01895128-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01895219-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01895355-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01895511-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01895630-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01895735-n',[ ('Skin',subsumption)]).
nounMapping2SUMO('01895850-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01896031-n',[ ('Feather',subsumption)]).
nounMapping2SUMO('01896561-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01896735-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01896844-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01896960-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01897053-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01897146-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01897257-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01897426-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01897536-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01897667-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01897851-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01897991-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01898185-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01898328-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01898459-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01898593-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01898731-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01898906-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01899062-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01899238-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01899367-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01899593-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01899746-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01899894-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01900006-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01900150-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01900341-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01900488-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01900719-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01900837-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01900985-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01901091-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01901213-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01901348-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01901492-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01901610-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01901694-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01901828-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01902022-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01902132-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01902274-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01902368-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01902568-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01902750-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01902877-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01903110-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01903234-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01903346-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01903498-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01903631-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01903756-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01904029-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01904182-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01904461-n',[ ('Device',subsumption)]).
nounMapping2SUMO('01904583-n',[ ('Device',subsumption)]).
nounMapping2SUMO('01904699-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01904806-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01904886-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01904965-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01905121-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01905321-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01905416-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01905543-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01905661-n',[ ('Invertebrate',equivalence)]).
nounMapping2SUMO('01906178-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01906328-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01906552-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01906749-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01907034-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01907149-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('01907287-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('01907495-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01907738-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01907902-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01908042-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01908287-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01908415-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01908703-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01908958-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('01909111-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01909422-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01909788-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01909906-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01910252-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01910529-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01910747-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01910998-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01911063-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01911271-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01911403-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01911511-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01911839-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01912050-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01912152-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01912272-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01912454-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01912688-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01912809-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01913035-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01913166-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01913346-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01913440-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01913533-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01913691-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01913838-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01914163-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01914415-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01914609-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01914830-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01914961-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01915093-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01915290-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01915414-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01915541-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01915700-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01915811-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01916010-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01916187-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01916388-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01916481-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01916588-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01916738-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01916925-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01917167-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01917289-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01917434-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01917611-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01917751-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01917882-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01918010-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01918152-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01918310-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01918585-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01918744-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01919099-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01919258-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01919385-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01919504-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01919714-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01919912-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01920051-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01920178-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01920302-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01920438-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01920582-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01920735-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01920939-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01921059-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01921216-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01921440-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01921559-n',[ ('Worm',equivalence)]).
nounMapping2SUMO('01921887-n',[ ('Worm',equivalence)]).
nounMapping2SUMO('01922303-n',[ ('Worm',equivalence)]).
nounMapping2SUMO('01922717-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01922948-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('01923025-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01923171-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01923404-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01923637-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01923890-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01924151-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01924309-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01924416-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01924590-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01924800-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('01924916-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01925133-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01925270-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01925469-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01925695-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01925916-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('01926090-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01926247-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01926379-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01926549-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01926689-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01926840-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01926988-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01927159-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01927301-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01927456-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01927665-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01927816-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01927928-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01928073-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01928215-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01928360-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01928517-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01928737-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01928865-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01929047-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01929186-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01929396-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01929788-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01929951-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01930112-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01930485-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01930672-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01930852-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01930995-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01931140-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01931277-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01931398-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01931520-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01931714-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01931845-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01931984-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01932151-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01932358-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01932495-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01932643-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01932800-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01932936-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01933151-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01933342-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01933478-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01933686-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01933834-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01933988-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01934207-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01934440-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01934705-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01934844-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01935012-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01935176-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01935395-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01935743-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01935997-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01936219-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01936391-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01936671-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01936858-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01937015-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01937234-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01937422-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01937579-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01937719-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01937909-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01938155-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01938312-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01938454-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01938618-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01938735-n',[ ('Worm',subsumption)]).
nounMapping2SUMO('01938850-n',[ ('Mollusk',equivalence)]).
nounMapping2SUMO('01939598-n',[ ('Mollusk',equivalence)]).
nounMapping2SUMO('01940488-n',[ ('Mollusk',equivalence)]).
nounMapping2SUMO('01940736-n',[ ('Mollusk',equivalence)]).
nounMapping2SUMO('01941030-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01941223-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01941340-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01941538-n',[ ('Lip',equivalence)]).
nounMapping2SUMO('01941670-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01942177-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01942601-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01942724-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01942869-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01943087-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01943213-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01943367-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01943541-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01943754-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01943899-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01944118-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01944217-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01944390-n',[ ('Gastropod',subsumption)]).
nounMapping2SUMO('01944617-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01944812-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01944955-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01945143-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01945340-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01945443-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01945580-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01945685-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01945845-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01946118-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01946277-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01946487-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01946630-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01946827-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01947020-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01947139-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01947275-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01947396-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01947613-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01947735-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01947874-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01947997-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01948154-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01948284-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01948446-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01948573-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01948788-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01948917-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01949085-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01949195-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01949330-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01949499-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01949684-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01949817-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01949973-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01950195-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01950457-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01950731-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01950952-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01951107-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01951274-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01951472-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01951613-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01951721-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01951845-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01952029-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01952162-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01952429-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01952557-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01952712-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01952812-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01953032-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01953197-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01953361-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01953594-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01953762-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01953877-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('01954004-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('01954202-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01954340-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01954516-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01954729-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01954962-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01955084-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01955318-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01955463-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01955933-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01956344-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('01956481-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01956764-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01956849-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('01956924-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01957075-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01957202-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01957335-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01957591-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01957739-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01957923-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01958038-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01958346-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01958435-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01958531-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01958790-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01958914-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01959029-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01959187-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01959333-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01959492-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01959668-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01959834-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01959985-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01960177-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01960301-n',[ ('Oyster',equivalence)]).
nounMapping2SUMO('01960459-n',[ ('Oyster',equivalence)]).
nounMapping2SUMO('01960787-n',[ ('Oyster',subsumption)]).
nounMapping2SUMO('01960900-n',[ ('Oyster',subsumption)]).
nounMapping2SUMO('01961059-n',[ ('Oyster',subsumption)]).
nounMapping2SUMO('01961234-n',[ ('Oyster',subsumption)]).
nounMapping2SUMO('01961468-n',[ ('Oyster',subsumption)]).
nounMapping2SUMO('01961600-n',[ ('Oyster',subsumption)]).
nounMapping2SUMO('01961736-n',[ ('Oyster',subsumption)]).
nounMapping2SUMO('01961862-n',[ ('Oyster',subsumption)]).
nounMapping2SUMO('01961985-n',[ ('Oyster',subsumption)]).
nounMapping2SUMO('01962223-n',[ ('Oyster',subsumption)]).
nounMapping2SUMO('01962350-n',[ ('Oyster',subsumption)]).
nounMapping2SUMO('01962506-n',[ ('Oyster',subsumption)]).
nounMapping2SUMO('01962662-n',[ ('Oyster',subsumption)]).
nounMapping2SUMO('01962788-n',[ ('Oyster',subsumption)]).
nounMapping2SUMO('01963017-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01963136-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01963317-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01963479-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01963571-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01963730-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01963876-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01964049-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01964271-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01964441-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01964636-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01964821-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01964957-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01965111-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01965252-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01965404-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01965529-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01965747-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01965889-n',[ ('Scallop',equivalence)]).
nounMapping2SUMO('01966204-n',[ ('Scallop',subsumption)]).
nounMapping2SUMO('01966377-n',[ ('Scallop',subsumption)]).
nounMapping2SUMO('01966586-n',[ ('Scallop',subsumption)]).
nounMapping2SUMO('01966797-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01966961-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01967094-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01967308-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01967396-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01967517-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01967677-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01967812-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01967963-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01968115-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01968315-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01968591-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01968732-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01968897-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01969103-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01969429-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01969550-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01969726-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01969893-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01970030-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01970164-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01970342-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01970502-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01970667-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01970866-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01971094-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01971280-n',[ ('Squid',equivalence)]).
nounMapping2SUMO('01971517-n',[ ('Squid',subsumption)]).
nounMapping2SUMO('01971620-n',[ ('Squid',subsumption)]).
nounMapping2SUMO('01971728-n',[ ('Squid',subsumption)]).
nounMapping2SUMO('01971850-n',[ ('Squid',subsumption)]).
nounMapping2SUMO('01972017-n',[ ('Squid',subsumption)]).
nounMapping2SUMO('01972131-n',[ ('Squid',subsumption)]).
nounMapping2SUMO('01972283-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01972411-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01972541-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01972733-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01972947-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01973148-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01973375-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01973566-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('01973723-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('01974055-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('01974229-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('01974399-n',[ ('Crustacean',equivalence)]).
nounMapping2SUMO('01974773-n',[ ('Crustacean',equivalence)]).
nounMapping2SUMO('01975117-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('01975312-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01975687-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01975880-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01976146-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01976477-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01976868-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01976957-n',[ ('Crab',equivalence)]).
nounMapping2SUMO('01977366-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01977485-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01977684-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01977832-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01978010-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01978136-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01978287-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01978455-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01978587-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01978744-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01978930-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01979124-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01979269-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01979395-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01979526-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01979738-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01979874-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01980053-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01980166-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01980328-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01980471-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01980655-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01980830-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01980993-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01981137-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01981276-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01981543-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01981702-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01981884-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01982068-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01982211-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01982347-n',[ ('Crab',subsumption)]).
nounMapping2SUMO('01982482-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01982650-n',[ ('Lobster',equivalence)]).
nounMapping2SUMO('01982895-n',[ ('Lobster',subsumption)]).
nounMapping2SUMO('01983048-n',[ ('Lobster',subsumption)]).
nounMapping2SUMO('01983277-n',[ ('Lobster',subsumption)]).
nounMapping2SUMO('01983481-n',[ ('Lobster',subsumption)]).
nounMapping2SUMO('01983674-n',[ ('Lobster',subsumption)]).
nounMapping2SUMO('01983829-n',[ ('Lobster',subsumption)]).
nounMapping2SUMO('01983958-n',[ ('Lobster',subsumption)]).
nounMapping2SUMO('01984131-n',[ ('Lobster',subsumption)]).
nounMapping2SUMO('01984245-n',[ ('Lobster',subsumption)]).
nounMapping2SUMO('01984416-n',[ ('Lobster',subsumption)]).
nounMapping2SUMO('01984547-n',[ ('Lobster',subsumption)]).
nounMapping2SUMO('01984695-n',[ ('Crayfish',equivalence)]).
nounMapping2SUMO('01984958-n',[ ('Crayfish',subsumption)]).
nounMapping2SUMO('01985128-n',[ ('Crayfish',subsumption)]).
nounMapping2SUMO('01985331-n',[ ('Crayfish',subsumption)]).
nounMapping2SUMO('01985493-n',[ ('Crayfish',subsumption)]).
nounMapping2SUMO('01985667-n',[ ('Crayfish',subsumption)]).
nounMapping2SUMO('01985797-n',[ ('Crayfish',subsumption)]).
nounMapping2SUMO('01985947-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01986072-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01986214-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01986367-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01986538-n',[ ('Shrimp',equivalence)]).
nounMapping2SUMO('01986681-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01986806-n',[ ('Shrimp',equivalence)]).
nounMapping2SUMO('01987076-n',[ ('Shrimp',subsumption)]).
nounMapping2SUMO('01987228-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01987353-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01987545-n',[ ('Prawn',equivalence)]).
nounMapping2SUMO('01987727-n',[ ('Prawn',subsumption)]).
nounMapping2SUMO('01987938-n',[ ('Prawn',subsumption)]).
nounMapping2SUMO('01988064-n',[ ('Prawn',subsumption)]).
nounMapping2SUMO('01988203-n',[ ('Prawn',subsumption)]).
nounMapping2SUMO('01988319-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01988481-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01988701-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01988869-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01988971-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01989097-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01989254-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01989390-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01989516-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01989701-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01989869-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01990007-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01990186-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01990383-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01990516-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01990627-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01990800-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01991028-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01991233-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01991367-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01991520-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01991676-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01991808-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01991982-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01992113-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01992262-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01992423-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01992516-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01992773-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01992935-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01993065-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01993214-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01993400-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01993525-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01993714-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01993830-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01993949-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01994176-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01994492-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01994801-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01994910-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01995137-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01995323-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01995514-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01995686-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01995803-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01995975-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01996091-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01996280-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01996392-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01996585-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01996895-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01997002-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01997119-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01997436-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01997605-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01997698-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01997825-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01998019-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01998183-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01998467-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01998599-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01998741-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01998920-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01999048-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01999186-n',[ ('Crustacean',subsumption)]).
nounMapping2SUMO('01999374-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('01999767-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02000036-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02000195-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02000354-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02000502-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02000618-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02000764-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02000954-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02001428-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02001821-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02002075-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02002384-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02002556-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02002724-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02002875-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02003037-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02003204-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02003456-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02003577-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02003735-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02003839-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02003994-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02004131-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02004343-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02004492-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02004661-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02004855-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02005102-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02005238-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02005399-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02005598-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02005790-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02005962-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02006063-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02006211-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02006364-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02006510-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02006656-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02006827-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02006985-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02007161-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02007284-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02007422-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02007558-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02007721-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02008041-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02008316-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02008497-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02008643-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02008796-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02009015-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02009229-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02009380-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02009508-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02009620-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02009750-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02009912-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02010144-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02010272-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02010453-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02010592-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02010728-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02010881-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02011016-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02011156-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02011281-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02011460-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02011668-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02011805-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02011943-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02012063-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02012185-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02012306-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02012715-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02012849-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02013034-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02013177-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02013362-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02013567-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02013706-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02013889-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02014061-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02014237-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02014406-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02014524-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02014646-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02014941-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02015221-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02015357-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02015554-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02015685-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02015797-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02015944-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02016066-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02016198-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02016358-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02016659-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02016816-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02016956-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02017093-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02017213-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02017335-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02017475-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02017607-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02017725-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02017878-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02018027-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02018207-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02018368-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02018485-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02018638-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02018795-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02019044-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02019190-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02019308-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02019438-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02019566-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02019762-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02019929-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02020219-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02020345-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02020450-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02020578-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02020777-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02020902-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02021050-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02021281-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02021438-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02021795-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02022135-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02022498-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02022684-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02023133-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02023341-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02023664-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02023855-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02023992-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02024185-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02024353-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02024479-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02024636-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02024763-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02024923-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02025043-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02025239-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02025389-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02025530-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02026059-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02026498-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02026629-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02026798-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02026948-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02027075-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02027209-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02027357-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02027492-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02027730-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02027897-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02028035-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02028175-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02028342-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02028451-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02028556-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02028727-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02028900-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02029087-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02029243-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02029378-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02029571-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02029706-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02029914-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02030035-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02030224-n',[ ('Female',subsumption), ('Bird',subsumption)]).
nounMapping2SUMO('02030287-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02030442-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02030568-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02030709-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02030837-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02030996-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02031143-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02031298-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02031455-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02031585-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02031752-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02031934-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02032222-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02032355-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02032480-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02032646-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02032769-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02032915-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02033041-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02033208-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02033324-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02033444-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02033561-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02033779-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02033882-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02034016-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02034129-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02034295-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02034394-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02034661-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02034971-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02035210-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02035402-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02035656-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02035845-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02036053-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02036228-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02036399-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02036548-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02036711-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02036864-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02036982-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02037110-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02037278-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02037464-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02037713-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02037869-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02038010-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02038141-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02038329-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02038466-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02038617-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02038837-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02038993-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02039171-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02039377-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02039497-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02039660-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02039780-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02039942-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02040113-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02040266-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02040505-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02040698-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02040872-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02041085-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02041246-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02041492-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02041678-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02041875-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02042046-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02042180-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02042342-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02042472-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02042637-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02042759-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02042923-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02043063-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02043207-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02043333-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02043497-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02043659-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02043808-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02043999-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02044178-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02044358-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02044517-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02044659-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02044778-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02044908-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02045024-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02045369-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02045596-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02045705-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02045864-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02046045-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02046171-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02046321-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02046442-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02046613-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02046759-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02046939-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02047045-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02047152-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02047260-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02047411-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02047517-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02047614-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02047835-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02047975-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02048115-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02048242-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02048353-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02048514-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02048698-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02048832-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02048952-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02049088-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02049299-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02049532-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02049672-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02049855-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02050004-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02050313-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02050442-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02050586-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02050809-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02050921-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02051059-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02051213-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02051474-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02051701-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02051845-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02052044-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02052204-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02052365-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02052511-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02052639-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02052775-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02052936-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02053083-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02053279-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02053425-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02053584-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02053720-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02053859-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02054036-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02054251-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02054376-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02054502-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02054711-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02054834-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02054966-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02055107-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02055280-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02055431-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02055658-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02055803-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02056091-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02056228-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02056421-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02056570-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02056728-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02056873-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02057035-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02057208-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02057330-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02057478-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02057731-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02057898-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02058074-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02058221-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02058453-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02058594-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02058747-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02058933-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02059162-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02059393-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02059541-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02059723-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02059852-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02060016-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02060133-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02060290-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02060411-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02060569-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02060719-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02060889-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02061073-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02061217-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02061425-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02061560-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02061716-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02061853-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02062017-n',[ ('AquaticMammal',equivalence)]).
nounMapping2SUMO('02062209-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02062430-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02062744-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02062991-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02063224-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02063516-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02063662-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02063846-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02064000-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02064154-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02064338-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02064608-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02064816-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02065026-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02065263-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02065407-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02065599-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02065726-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02065932-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02066086-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02066245-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02066450-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02066707-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02066950-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02067100-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02067240-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02067462-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02067603-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02067768-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02067941-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02068206-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02068408-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02068541-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02068735-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02068974-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02069271-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02069412-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02069569-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02069701-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02069974-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02070174-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02070311-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02070430-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02070624-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02070776-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02070923-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02071028-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02071173-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02071294-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02071506-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02071636-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02071905-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02072040-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02072209-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02072355-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02072493-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02072665-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02072798-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02072953-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02073041-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02073250-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02073532-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02073679-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02073831-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02074004-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02074214-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02074367-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02074542-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02074726-n',[ ('AquaticMammal',subsumption)]).
nounMapping2SUMO('02074915-n',[ ('Carnivore',equivalence)]).
nounMapping2SUMO('02075296-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02075612-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('02075727-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02075927-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02076196-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02076402-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02076535-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02076779-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02077023-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02077152-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02077384-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02077533-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02077658-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02077787-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02077923-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02078159-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02078292-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02078436-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02078574-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02078738-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02078882-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02079005-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02079170-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02079389-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02079706-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02079851-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02080022-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02080146-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02080291-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02080415-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02080586-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02080713-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02080934-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02081060-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02081282-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02081423-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02081571-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02081798-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02081927-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02082056-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02082190-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02082358-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02082498-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02082632-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02082791-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02083038-n',[ ('Canine',equivalence)]).
nounMapping2SUMO('02083346-n',[ ('Canine',equivalence)]).
nounMapping2SUMO('02083672-n',[ ('Female',subsumption), ('Canine',subsumption)]).
nounMapping2SUMO('02083780-n',[ ('Female',subsumption), ('Canine',subsumption)]).
nounMapping2SUMO('02083863-n',[ ('Canine',equivalence)]).
nounMapping2SUMO('02084071-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02084732-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02084861-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02085019-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02085118-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02085272-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02085374-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02085620-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02085782-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02085936-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02086079-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02086240-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02086346-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02086478-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02086646-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02086753-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02086910-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02087046-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02087122-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02087314-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02087394-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02087551-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02088094-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02088238-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02088364-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02088466-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02088632-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02088745-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02088839-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02088992-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02089078-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02089232-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02089468-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02089555-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02089725-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02089867-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02089973-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02090129-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02090253-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02090379-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02090475-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02090622-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02090721-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02090827-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02091032-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02091134-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02091244-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02091467-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02091635-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02091831-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02092002-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02092173-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02092339-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02092468-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02093056-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02093256-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02093428-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02093647-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02093754-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02093859-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02093991-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02094114-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02094258-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02094433-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02094562-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02094721-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02094931-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02095050-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02095212-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02095314-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02095412-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02095570-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02095727-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02095889-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02096051-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02096177-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02096294-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02096437-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02096585-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02096756-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02097047-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02097130-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02097209-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02097298-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02097474-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02097658-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02097786-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02097967-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02098105-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02098286-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02098413-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02098550-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02098806-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02098906-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02099029-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02099267-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02099429-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02099601-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02099712-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02099849-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02099997-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02100236-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02100399-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02100583-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02100735-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02100877-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02101006-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02101108-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02101388-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02101556-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02101670-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02101861-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02102040-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02102177-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02102318-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02102480-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02102605-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02102806-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02102973-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02103181-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02103406-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02103841-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02104029-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02104184-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02104280-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02104365-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02104523-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02104882-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02105056-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02105162-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02105251-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02105412-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02105505-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02105641-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02105855-n',[ ('Working',equivalence)]).
nounMapping2SUMO('02106030-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02106166-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02106382-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02106550-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02106662-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02106854-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02106966-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02107142-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02107312-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02107420-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02107574-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02107683-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02107908-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02108000-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02108089-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02108254-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02108422-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02108551-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02108672-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02108915-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02109047-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02109150-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02109256-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02109391-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02109525-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02109687-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02109811-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02109961-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02110063-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02110185-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02110341-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02110532-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02110627-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02110806-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02110958-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02111129-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02111277-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02111500-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02111626-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02111889-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02112018-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02112137-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02112350-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02112497-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02112706-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02112826-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02113023-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02113186-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02113335-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02113624-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02113712-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02113799-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02113892-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02113978-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02114100-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02114367-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02114548-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02114712-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02114855-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02115012-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02115096-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02115335-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02115641-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02115775-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02115913-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02116079-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02116185-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02116322-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02116450-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02116630-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02116738-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02116959-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02117135-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02117369-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02117512-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02117646-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02117772-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02117900-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02118058-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02118176-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02118333-n',[ ('Fox',subsumption)]).
nounMapping2SUMO('02118643-n',[ ('Female',subsumption), ('Fox',subsumption)]).
nounMapping2SUMO('02118707-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02118854-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02119022-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02119247-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02119359-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02119477-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02119634-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02119789-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02119961-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02120079-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02120278-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02120387-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02120505-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('02120692-n',[ ('Feline',equivalence)]).
nounMapping2SUMO('02120997-n',[ ('Feline',equivalence)]).
nounMapping2SUMO('02121234-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02121620-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02121808-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02122298-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02122430-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02122510-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02122580-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02122725-n',[ ('Male',subsumption), ('Feline',subsumption)]).
nounMapping2SUMO('02122810-n',[ ('Male',subsumption), ('Feline',subsumption)]).
nounMapping2SUMO('02122878-n',[ ('Female',subsumption), ('Feline',subsumption)]).
nounMapping2SUMO('02122948-n',[ ('NonFullyFormed',subsumption), ('Feline',subsumption)]).
nounMapping2SUMO('02123045-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02123159-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02123242-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02123394-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02123478-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02123597-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02123785-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02123917-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02124075-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02124157-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02124313-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02124484-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02124623-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02125010-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02125081-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02125311-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02125494-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02125689-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02125872-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02126028-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02126139-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02126317-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02126465-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02126640-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02126787-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02126951-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02127052-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02127292-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02127381-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02127482-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02127586-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02127678-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02127808-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02128120-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02128385-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02128598-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02128669-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02128757-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02128925-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02129165-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02129463-n',[ ('Female',subsumption), ('Feline',subsumption)]).
nounMapping2SUMO('02129530-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('02129604-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02129837-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02129923-n',[ ('Female',subsumption), ('Feline',subsumption)]).
nounMapping2SUMO('02129991-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02130086-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02130190-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02130308-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02130545-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02130795-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02130925-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02131076-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02131211-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('02131418-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02131653-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02131942-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02132136-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02132320-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02132466-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02132580-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02132788-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02132974-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02133161-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02133400-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02133512-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02133704-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02133902-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02134084-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02134240-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02134418-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02134589-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02134971-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02135220-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02135486-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02135610-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02135726-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02135844-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02135981-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02136103-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02136285-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02136452-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02136623-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02136794-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02136901-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02137015-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02137172-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02137302-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02137428-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02137549-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02137722-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02137888-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02138042-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02138169-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02138323-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02138441-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02138647-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02138777-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02138921-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02139199-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02139479-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02139671-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02139914-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02140049-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02140179-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02140268-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02140357-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02140491-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02140719-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02140858-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02140970-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02141306-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02141611-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02141713-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02142064-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02142295-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02142407-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02142575-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02142734-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02142898-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02142993-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02143142-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02143293-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02143439-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02143594-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02143759-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02143891-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02144110-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02144251-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02144442-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02144593-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02144792-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02144936-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02145084-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02145424-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02145767-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02145910-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02146064-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02146201-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02146371-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02146526-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02146700-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02146879-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02147034-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02147173-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02147328-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02147452-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02147591-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02147747-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02147947-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02148088-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02148245-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02148377-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02148512-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02148698-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02148835-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02148991-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02149136-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02149297-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02149420-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02149653-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02149861-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02150016-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02150134-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02150306-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02150482-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02150730-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02150885-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02151108-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02151230-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02151448-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('02151625-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02151940-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02152064-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02152212-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02152446-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02152559-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02152740-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02152881-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('02152991-n',[ ('Pursuing',equivalence)]).
nounMapping2SUMO('02153109-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('02153203-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02153445-n',[ ('Foot',subsumption)]).
nounMapping2SUMO('02153712-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02153809-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02153959-n',[ ('Hoof',subsumption)]).
nounMapping2SUMO('02154133-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('02154264-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02154416-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02154620-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02154742-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02154824-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02155014-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02155206-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02155313-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02155448-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02155678-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02155872-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02156031-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02156140-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02156320-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02156413-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02156532-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02156732-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02156871-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('02157206-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('02157285-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('02157415-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02157557-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02157954-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02158066-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02158213-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02158354-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02158494-n',[ ('Food',subsumption)]).
nounMapping2SUMO('02158619-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02158739-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02158846-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02158972-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02159117-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02159271-n',[ ('Insect',equivalence)]).
nounMapping2SUMO('02159955-n',[ ('Insect',equivalence)]).
nounMapping2SUMO('02160947-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02161078-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02161225-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02161338-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02161457-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02161588-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02161737-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('02161944-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('02162235-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02162404-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('02162561-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02162831-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('02163008-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02163144-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02163297-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02163616-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02163763-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02163982-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02164464-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02164973-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02165105-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02165247-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02165456-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02165754-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02165877-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02166024-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02166229-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02166436-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02166567-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02166674-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02166826-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02166986-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02167151-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02167375-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02167505-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02167645-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02167820-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02167944-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02168121-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02168245-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02168427-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02168542-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02168699-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02168876-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02169023-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02169218-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02169345-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02169497-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02169705-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02169833-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02169974-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02170269-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02170400-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02170599-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02170738-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02170848-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02170993-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02171164-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02171254-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02171453-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02171633-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02171869-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02172182-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02172387-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02172518-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02172678-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02172761-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02172870-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02173113-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02173240-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02173373-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02173571-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02173784-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02174001-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02174153-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02174355-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02174521-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02174659-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02174870-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02175014-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02175263-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02175440-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02175569-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02175791-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02175916-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02176073-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02176261-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02176439-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02176611-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02176747-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02176916-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02177068-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02177196-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02177376-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02177506-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02177644-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02177775-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02177972-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02178244-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02178411-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02178563-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02178717-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02178886-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02179012-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02179192-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02179340-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02179429-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02179714-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02179891-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02180046-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02180233-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02180427-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02180742-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02180875-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02181013-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02181235-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02181477-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02181599-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02181724-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02181863-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02182045-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02182220-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02182355-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02182498-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02182642-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02182796-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02182930-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02183096-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02183353-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02183507-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02183697-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02183857-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02184114-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02184270-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02184473-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02184589-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02184720-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02184881-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02185007-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02185167-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02185337-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02185481-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02185694-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02185814-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02185973-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02186153-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02186399-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02186586-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02186717-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02186834-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02187022-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02187150-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02187279-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02187427-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02187554-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02187759-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02187900-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02188065-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02188699-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02189214-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02189363-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02189535-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02189670-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02189822-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02190015-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02190166-n',[ ('FlyInsect',subsumption)]).
nounMapping2SUMO('02190465-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02190648-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02190790-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02190963-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02191131-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02191273-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02191449-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02191617-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02191773-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02191979-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02192127-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02192252-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02192388-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02192513-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02192673-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02192814-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02193009-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02193163-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02193357-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02193496-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02193665-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02193799-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02193955-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02194078-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02194249-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02194414-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02194599-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02194750-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02194887-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02195091-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02195257-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('02195403-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02195526-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02195693-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02195819-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02195996-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02196119-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02196344-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02196542-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02196761-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02196896-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02197048-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02197185-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02197413-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02197545-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02197689-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02197877-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02198021-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02198129-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02198332-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02198532-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02198714-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02198859-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02198996-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02199170-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02199352-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02199502-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02199712-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02199999-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02200198-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02200509-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02200630-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02200705-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02200850-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02201000-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02201252-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02201497-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02201626-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02201758-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02202006-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02202124-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02202287-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02202509-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02202678-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02202878-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02203008-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02203152-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02203332-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02203457-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02203592-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02203739-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02203978-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02204084-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02204249-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02204460-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02204585-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02204722-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02204907-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02205095-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02205219-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02205383-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02205523-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02205673-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02205896-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02206270-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02206624-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02206856-n',[ ('Bee',equivalence)]).
nounMapping2SUMO('02207179-n',[ ('Male',subsumption), ('Bee',subsumption)]).
nounMapping2SUMO('02207345-n',[ ('Female',subsumption), ('Bee',subsumption)]).
nounMapping2SUMO('02207449-n',[ ('WorkerInsect',subsumption)]).
nounMapping2SUMO('02207647-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02207805-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02207942-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02208143-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02208280-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02208498-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02208848-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02208979-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02209111-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02209230-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02209354-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02209508-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02209624-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02209755-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02209964-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02210096-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02210291-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02210427-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02210567-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02210728-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02210921-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02211099-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02211283-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02211444-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02211627-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02211773-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02211896-n',[ ('Bee',subsumption)]).
nounMapping2SUMO('02212062-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02212323-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02212602-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02212811-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02212958-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02213107-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02213239-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02213362-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02213543-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02213663-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02213788-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02213967-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02214096-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02214203-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02214341-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02214499-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02214660-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02214773-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02214972-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02215161-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02215334-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02215496-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02215621-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02215770-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02215941-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02216066-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02216211-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02216365-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02216547-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02216740-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02216924-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02217050-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02217201-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02217334-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02217563-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02217839-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02217997-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02218134-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02218235-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02218371-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02218563-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02218713-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02218912-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02219015-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02219234-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02219486-n',[ ('AntInsect',subsumption)]).
nounMapping2SUMO('02219901-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02220055-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02220225-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02220393-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02220518-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02220676-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02220804-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02220960-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02221083-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02221240-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02221414-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02221571-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02221715-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02221820-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02222035-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02222199-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02222321-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02222459-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02222582-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02222718-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02223009-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02223151-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02223266-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02223520-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02223694-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02223901-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02224023-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02224141-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02224323-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02224466-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02224713-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02224937-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02225081-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02225231-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02225407-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02225577-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02225798-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02225959-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02226183-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02226429-n',[ ('Grasshopper',subsumption)]).
nounMapping2SUMO('02226598-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02226821-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02226970-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02227119-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02227247-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02227430-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02227604-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02227773-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02227966-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02228215-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02228341-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02228565-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02228697-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02228874-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02229023-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02229156-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02229385-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02229544-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02229765-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02229867-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02230023-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02230187-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02230355-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02230480-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02230634-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02230782-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02231052-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02231307-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02231487-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02231680-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02231803-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02231930-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02232086-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02232223-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02232408-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02232606-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02232951-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02233096-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02233338-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02233577-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02233767-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02233943-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02234181-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02234355-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02234570-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02234719-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02234848-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02235078-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02235205-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02235321-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02235465-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02235575-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02235761-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02235911-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02236044-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02236241-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02236355-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02236495-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02236896-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02237239-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02237424-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02237581-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02237730-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02237868-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02238113-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02238235-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02238358-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02238474-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02238594-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02238743-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02238887-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02239073-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02239192-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02239347-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02239528-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02239659-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02239774-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02239934-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02240068-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02240223-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02240377-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02240517-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02240706-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02240852-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02241008-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02241184-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02241426-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02241569-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02241799-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02242004-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02242137-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02242293-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02242455-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02242669-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02242816-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02242942-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02243065-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02243209-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02243351-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02243562-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02243744-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02243878-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02244007-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02244173-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02244396-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02244515-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02244670-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02244797-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02244963-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02245111-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02245239-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02245443-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02245592-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02246011-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02246284-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02246487-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02246628-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02246822-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02246941-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02247076-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02247216-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02247363-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02247511-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02247655-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02247950-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02248062-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02248147-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02248368-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02248510-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02248744-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02248887-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02249011-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02249134-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02249256-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02249365-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02249515-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02249673-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02249809-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02249995-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02250133-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02250280-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02250464-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02250653-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02250822-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02251067-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02251233-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02251452-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02251593-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02251775-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02252039-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02252226-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02252429-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02252608-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02252799-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02252972-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02253127-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02253264-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02253391-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02253494-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02253592-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02253715-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02253913-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02254110-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02254246-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02254370-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02254531-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02254697-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02254901-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02255023-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02255144-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02255270-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02255391-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02255567-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02255698-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02255855-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02256010-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02256172-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02256365-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02256542-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02256656-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02256882-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02257003-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02257149-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02257284-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02257536-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02257715-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02257985-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02258065-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02258198-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02258354-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02258508-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02258629-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02258780-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02258910-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02259136-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02259212-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02259377-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02259565-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02259708-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02259844-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02259987-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02260183-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02260421-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02260623-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02260863-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02261063-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02261184-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02261286-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02261419-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02261630-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02261757-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02261883-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02262062-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02262178-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02262324-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02262449-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02262679-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02262803-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02263038-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02263378-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02263717-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02263848-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02264021-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02264232-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02264363-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02264591-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02264734-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02264885-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02265076-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02265177-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02265330-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02265471-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02265717-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02265860-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02266050-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02266269-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02266421-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02266580-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02266732-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02266864-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02267019-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02267208-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02267356-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02267483-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02267644-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02267826-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02267975-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02268148-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02268334-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02268443-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02268746-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02268853-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02269015-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02269196-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02269340-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02269522-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02269657-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02269829-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02270011-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02270200-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02270326-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02270473-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02270623-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02270810-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02270945-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02271087-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02271222-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02271427-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02271570-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02271740-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02271897-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02272152-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02272286-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02272428-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02272552-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02272707-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02272871-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02273120-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02273254-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02273392-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02273545-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02274024-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02274259-n',[ ('Butterfly',equivalence)]).
nounMapping2SUMO('02274516-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02274822-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02275372-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02275560-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02275773-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02275921-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02276078-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02276258-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02276355-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02276527-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02276749-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02276902-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02277094-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02277268-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02277422-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02277556-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02277742-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02277895-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02278024-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02278210-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02278343-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02278463-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02278601-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02278704-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02278839-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02278980-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02279127-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02279257-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02279442-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02279637-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02279819-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02279972-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02280223-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02280458-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02280649-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02280845-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02281015-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02281136-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02281267-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02281406-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02281552-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02281787-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02281987-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02282257-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02282385-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02282553-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02282716-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02282903-n',[ ('Butterfly',subsumption)]).
nounMapping2SUMO('02283077-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02283201-n',[ ('Moth',subsumption)]).
nounMapping2SUMO('02283617-n',[ ('Moth',subsumption)]).
nounMapping2SUMO('02283728-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02283951-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02284224-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02284367-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02284513-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02284611-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02284771-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02284884-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02285052-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02285179-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02285359-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02285548-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02285801-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02285909-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02286089-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02286271-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02286425-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02286654-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02286815-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02287004-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02287204-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02287352-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02287476-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02287622-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02287799-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02287987-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02288122-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02288268-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02288473-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02288789-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02289061-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02289177-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02289307-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02289466-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02289610-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02289845-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02289988-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02290153-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02290340-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02290521-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02290664-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02290870-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02291024-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02291220-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02291391-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02291572-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02291748-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02291940-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02292085-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02292272-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02292401-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02292564-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02292692-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02292850-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02292980-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02293135-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02293352-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02293560-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02293715-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02293868-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02293974-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02294097-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02294279-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02294407-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02294577-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02294761-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02295064-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02295390-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02295570-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02295717-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02295870-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02296021-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02296150-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02296276-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02296480-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02296612-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02296756-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02296912-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02297127-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02297294-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02297442-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02297635-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02297819-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02297938-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02298095-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02298218-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02298379-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02298541-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02298833-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02299039-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02299157-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02299378-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02299505-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02299715-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02299846-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02300018-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02300173-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02300378-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02300554-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02300797-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02301072-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02301452-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02301782-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02301935-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02302124-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02302244-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02302459-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02302620-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02302853-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02302969-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02303167-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02303284-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02303448-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02303585-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02303777-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02303917-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02304036-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02304229-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02304432-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02304657-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02304797-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02304967-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02305085-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02305245-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02305407-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02305636-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02305799-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02305929-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02306159-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02306433-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02306672-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02306825-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02307007-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02307176-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02307325-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02307515-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02307681-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02307910-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02308033-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02308139-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02308325-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02308471-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02308618-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02308735-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02308852-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02308998-n',[ ('Insect',subsumption)]).
nounMapping2SUMO('02309120-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02309242-n',[ ('Arthropod',subsumption)]).
nounMapping2SUMO('02309337-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02309841-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02310000-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02310149-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02310334-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02310585-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02310717-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02310941-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02311060-n',[ ('Larval',equivalence)]).
nounMapping2SUMO('02311617-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02311748-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02311879-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02312006-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02312175-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02312325-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02312427-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('02312640-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('02312744-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02312912-n',[ ('FullyFormed',subsumption)]).
nounMapping2SUMO('02313008-n',[ ('QueenInsect',equivalence)]).
nounMapping2SUMO('02313195-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02313360-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02313495-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02313709-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02314001-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02314158-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02314321-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02314492-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02314717-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02315024-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02315309-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02315487-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02315696-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02315821-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02316038-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02316180-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02316392-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02316707-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02317025-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02317212-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02317335-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02317488-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02317653-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02317781-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02317983-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02318167-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02318437-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02318538-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02318687-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02318798-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02318915-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02319095-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02319308-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02319423-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02319555-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02319689-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02319829-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02319967-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02320127-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02320339-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02320465-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02320621-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02320769-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02320888-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02321062-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02321170-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02321342-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02321529-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02321759-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02321903-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02322047-n',[ ('Invertebrate',subsumption)]).
nounMapping2SUMO('02322213-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02322387-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02322624-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('02322712-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('02322817-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02322992-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02323186-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02323449-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02323715-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02323902-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02324045-n',[ ('Rabbit',equivalence)]).
nounMapping2SUMO('02324431-n',[ ('Ear',subsumption)]).
nounMapping2SUMO('02324514-n',[ ('Male',subsumption), ('Rabbit',subsumption)]).
nounMapping2SUMO('02324587-n',[ ('NonFullyFormed',subsumption), ('Rabbit',subsumption)]).
nounMapping2SUMO('02324717-n',[ ('Rabbit',subsumption)]).
nounMapping2SUMO('02324850-n',[ ('Rabbit',subsumption)]).
nounMapping2SUMO('02325211-n',[ ('Rabbit',subsumption)]).
nounMapping2SUMO('02325366-n',[ ('Rabbit',subsumption)]).
nounMapping2SUMO('02325722-n',[ ('Rabbit',subsumption)]).
nounMapping2SUMO('02325884-n',[ ('Rabbit',subsumption)]).
nounMapping2SUMO('02326074-n',[ ('Rabbit',subsumption)]).
nounMapping2SUMO('02326237-n',[ ('Rabbit',subsumption)]).
nounMapping2SUMO('02326432-n',[ ('Rabbit',subsumption)]).
nounMapping2SUMO('02326763-n',[ ('Rabbit',subsumption)]).
nounMapping2SUMO('02326862-n',[ ('Rabbit',subsumption)]).
nounMapping2SUMO('02327028-n',[ ('Rabbit',subsumption)]).
nounMapping2SUMO('02327175-n',[ ('Rabbit',subsumption)]).
nounMapping2SUMO('02327435-n',[ ('Rabbit',subsumption)]).
nounMapping2SUMO('02327656-n',[ ('Rabbit',subsumption)]).
nounMapping2SUMO('02327842-n',[ ('Rabbit',subsumption)]).
nounMapping2SUMO('02328009-n',[ ('Rabbit',subsumption)]).
nounMapping2SUMO('02328150-n',[ ('Rabbit',subsumption)]).
nounMapping2SUMO('02328270-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02328429-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02328662-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02328820-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02328942-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02329093-n',[ ('Rodent',equivalence)]).
nounMapping2SUMO('02329401-n',[ ('Rodent',equivalence)]).
nounMapping2SUMO('02330245-n',[ ('Mouse',equivalence)]).
nounMapping2SUMO('02330582-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02330830-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02331046-n',[ ('Rat',subsumption)]).
nounMapping2SUMO('02331309-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02331479-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02331842-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02331960-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02332156-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02332315-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02332447-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02332606-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02332755-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02332954-n',[ ('Mouse',subsumption)]).
nounMapping2SUMO('02333190-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02333368-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02333546-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02333733-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02333819-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02333909-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02334079-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02334201-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02334337-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02334460-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02334609-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02334728-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02334849-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02335007-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02335127-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02335231-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02335349-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02336011-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02336129-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02336275-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02336451-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02336641-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02336826-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02337001-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02337171-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02337332-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02337480-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02337598-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02337774-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02337902-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02338029-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02338145-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02338319-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02338449-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02338592-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02338722-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02338901-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02339282-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02339376-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02339768-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02339922-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02340186-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02340358-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02340521-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02340640-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02340813-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02340930-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02341108-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02341288-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02341475-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02341616-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02341805-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02341974-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02342109-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02342250-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02342413-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02342534-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02342727-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02342885-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02343058-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02343187-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02343320-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02343487-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02343633-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02343772-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02344006-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02344175-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02344270-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02344408-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02344528-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02344785-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02344918-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02345078-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02345213-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02345340-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02345471-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02345600-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02345774-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02345890-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02345997-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02346170-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02346315-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02346627-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02346823-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02346998-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02347140-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02347274-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02347443-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02347573-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02347744-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02347865-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02348036-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02348173-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02348405-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02348788-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02349040-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02349205-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02349390-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02349557-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02349730-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02349847-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02349980-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02350105-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02350357-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02350537-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02350670-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02350845-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02350989-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02351212-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02351343-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02351518-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02351686-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02351870-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02352002-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02352175-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02352290-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02352390-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02352591-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02352804-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02352932-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02353037-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02353172-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02353297-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02353411-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02353529-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02353709-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02353861-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02354162-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02354320-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02354470-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02354621-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02354781-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02354950-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02355227-n',[ ('Squirrel',subsumption)]).
nounMapping2SUMO('02355477-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02355711-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02356108-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02356381-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02356612-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02356798-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02356977-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02357111-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02357280-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02357401-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02357585-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02357741-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02357911-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02358091-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02358390-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02358584-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02358712-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02358890-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02359047-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02359204-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02359324-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02359556-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02359667-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02359775-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02359915-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02360135-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02360282-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02360480-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02360643-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02360781-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02360933-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02361090-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02361222-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02361337-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02361587-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02361706-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02361850-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02362025-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02362194-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02362420-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02362569-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02362721-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02362862-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02363005-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02363245-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02363351-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02363511-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02363681-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02363818-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02363996-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02364221-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02364377-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02364520-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02364673-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02364840-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02364989-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02365108-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02365244-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02365356-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02365480-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02365672-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02365848-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02366002-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02366203-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02366301-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02366453-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02366579-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02366702-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02366825-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02366959-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02367131-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02367360-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02367492-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02367678-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02367812-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02367993-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02368116-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02368280-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02368399-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02368563-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02368687-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02368821-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02369012-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02369170-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02369293-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02369424-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02369555-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02369680-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02369935-n',[ ('Female',subsumption), ('Rat',subsumption)]).
nounMapping2SUMO('02370137-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02370265-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02370360-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('02370525-n',[ ('HoofedMammal',equivalence)]).
nounMapping2SUMO('02370806-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02371125-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02371344-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02371471-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02371647-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02371801-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02372046-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02372140-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02372251-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02372397-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02372584-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02372813-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02372952-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02373093-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02373336-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02373601-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02373843-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02374149-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02374451-n',[ ('Horse',equivalence)]).
nounMapping2SUMO('02375302-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02375438-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02375592-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02375757-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02375862-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02376016-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02376135-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02376303-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02376423-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02376542-n',[ ('NonFullyFormed',subsumption), ('Horse',subsumption)]).
nounMapping2SUMO('02376679-n',[ ('Female',subsumption), ('Horse',subsumption)]).
nounMapping2SUMO('02376791-n',[ ('Male',subsumption), ('Horse',subsumption)]).
nounMapping2SUMO('02376918-n',[ ('Male',subsumption), ('Horse',subsumption)]).
nounMapping2SUMO('02377063-n',[ ('Male',subsumption), ('Horse',subsumption)]).
nounMapping2SUMO('02377181-n',[ ('Male',subsumption), ('Horse',subsumption)]).
nounMapping2SUMO('02377291-n',[ ('Male',subsumption), ('Horse',subsumption)]).
nounMapping2SUMO('02377388-n',[ ('Male',subsumption), ('Horse',subsumption)]).
nounMapping2SUMO('02377480-n',[ ('Female',subsumption), ('Horse',subsumption)]).
nounMapping2SUMO('02377603-n',[ ('Female',subsumption), ('Horse',subsumption)]).
nounMapping2SUMO('02377703-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02378149-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02378299-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02378415-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02378541-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02378625-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02378755-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02378870-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02378969-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02379081-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02379183-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02379329-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02379430-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02379630-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02379743-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02379908-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02380052-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02380335-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02380464-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02380583-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02380745-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02380875-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02381004-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02381119-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02381261-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02381364-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02381460-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02381609-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02381744-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02381831-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02382039-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02382132-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02382204-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02382338-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02382437-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02382635-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02382750-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02382850-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02382948-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02383231-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02383604-n',[ ('Horse',instance)]).
nounMapping2SUMO('02383708-n',[ ('Horse',instance)]).
nounMapping2SUMO('02383813-n',[ ('Horse',instance)]).
nounMapping2SUMO('02383912-n',[ ('Horse',instance)]).
nounMapping2SUMO('02384017-n',[ ('Horse',instance)]).
nounMapping2SUMO('02384120-n',[ ('Horse',instance)]).
nounMapping2SUMO('02384225-n',[ ('Horse',instance)]).
nounMapping2SUMO('02384326-n',[ ('Horse',instance)]).
nounMapping2SUMO('02384428-n',[ ('Horse',instance)]).
nounMapping2SUMO('02384533-n',[ ('Horse',instance)]).
nounMapping2SUMO('02384639-n',[ ('Horse',instance)]).
nounMapping2SUMO('02384741-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02384858-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02385002-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('02385098-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02385214-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02385348-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02385461-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02385580-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02385676-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02385776-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02385898-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02386014-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02386141-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02386224-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02386310-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02386496-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02386746-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02386853-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02386968-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02387093-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02387254-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02387346-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02387452-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02387581-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02387722-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02387887-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02387983-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02388143-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02388276-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02388453-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02388588-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02388735-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02388832-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02388917-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02389026-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02389128-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02389261-n',[ ('Horse',subsumption)]).
nounMapping2SUMO('02389346-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02389559-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02389779-n',[ ('Donkey',subsumption)]).
nounMapping2SUMO('02389865-n',[ ('Donkey',subsumption)]).
nounMapping2SUMO('02389943-n',[ ('Male',subsumption), ('Donkey',subsumption)]).
nounMapping2SUMO('02390015-n',[ ('Female',subsumption), ('Donkey',subsumption)]).
nounMapping2SUMO('02390101-n',[ ('Mule',subsumption)]).
nounMapping2SUMO('02390258-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02390454-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02390640-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02390738-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02390834-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02390938-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02391049-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02391234-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02391373-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02391508-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02391617-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02391782-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02391994-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02392282-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02392434-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02392555-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02392710-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02392824-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02393024-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02393161-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02393300-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02393445-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02393580-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02393807-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02393940-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02394068-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02394477-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02394822-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02395003-n',[ ('Pig',subsumption)]).
nounMapping2SUMO('02395244-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02395406-n',[ ('Pig',equivalence)]).
nounMapping2SUMO('02395694-n',[ ('NonFullyFormed',subsumption), ('Pig',subsumption)]).
nounMapping2SUMO('02395855-n',[ ('NonFullyFormed',subsumption), ('Pig',subsumption)]).
nounMapping2SUMO('02395931-n',[ ('HoofedMammal',subsumption), ('Pig',subsumption)]).
nounMapping2SUMO('02396014-n',[ ('Male',subsumption), ('Pig',subsumption)]).
nounMapping2SUMO('02396088-n',[ ('Female',subsumption), ('Pig',subsumption)]).
nounMapping2SUMO('02396157-n',[ ('Pig',subsumption)]).
nounMapping2SUMO('02396427-n',[ ('Pig',subsumption)]).
nounMapping2SUMO('02396667-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02396796-n',[ ('Pig',subsumption)]).
nounMapping2SUMO('02396970-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02397096-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02397251-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02397377-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02397529-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02397744-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02397987-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02398141-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02398252-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02398386-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02398521-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02398732-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02399000-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02399424-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02399648-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02399791-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02399942-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02400139-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02401031-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02401305-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02401509-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02401661-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02402010-n',[ ('Cattle',subsumption)]).
nounMapping2SUMO('02402175-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02402425-n',[ ('Cow',equivalence)]).
nounMapping2SUMO('02403003-n',[ ('Bull',subsumption)]).
nounMapping2SUMO('02403153-n',[ ('Bull',subsumption)]).
nounMapping2SUMO('02403231-n',[ ('Bull',subsumption)]).
nounMapping2SUMO('02403325-n',[ ('Bull',equivalence)]).
nounMapping2SUMO('02403454-n',[ ('FemaleCow',equivalence)]).
nounMapping2SUMO('02403644-n',[ ('FemaleCow',subsumption)]).
nounMapping2SUMO('02403740-n',[ ('Cow',subsumption)]).
nounMapping2SUMO('02403820-n',[ ('Bull',subsumption), ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('02403920-n',[ ('NonFullyFormed',subsumption), ('Cow',subsumption)]).
nounMapping2SUMO('02404028-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02404186-n',[ ('Cow',subsumption)]).
nounMapping2SUMO('02404432-n',[ ('Cow',subsumption)]).
nounMapping2SUMO('02404573-n',[ ('Cow',subsumption)]).
nounMapping2SUMO('02404906-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02405101-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02405302-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02405440-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02405577-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02405692-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02405799-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02405929-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02406046-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02406174-n',[ ('FemaleCow',subsumption)]).
nounMapping2SUMO('02406432-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02406533-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02406647-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02406749-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02406859-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02406952-n',[ ('Cow',subsumption)]).
nounMapping2SUMO('02407071-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02407172-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02407276-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02407390-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02407521-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02407625-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02407763-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02407959-n',[ ('Buffalo',equivalence)]).
nounMapping2SUMO('02408217-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02408429-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02408660-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02408817-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02408903-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02409038-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02409202-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02409369-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02409508-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02409702-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02409870-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02410011-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02410141-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02410313-n',[ ('Buffalo',subsumption)]).
nounMapping2SUMO('02410509-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02410702-n',[ ('Buffalo',subsumption)]).
nounMapping2SUMO('02410900-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02411075-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02411206-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02411427-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02411705-n',[ ('Sheep',equivalence)]).
nounMapping2SUMO('02411999-n',[ ('Female',subsumption), ('Sheep',subsumption)]).
nounMapping2SUMO('02412080-n',[ ('Male',subsumption), ('Sheep',subsumption)]).
nounMapping2SUMO('02412210-n',[ ('Male',subsumption), ('Sheep',subsumption)]).
nounMapping2SUMO('02412337-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02412440-n',[ ('Lamb',equivalence)]).
nounMapping2SUMO('02412629-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('02412700-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02412787-n',[ ('Lamb',subsumption)]).
nounMapping2SUMO('02412909-n',[ ('Lamb',subsumption)]).
nounMapping2SUMO('02412977-n',[ ('Lamb',subsumption)]).
nounMapping2SUMO('02413050-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02413131-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02413484-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02413593-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02413717-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02413824-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02413917-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02414043-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02414209-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02414290-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02414442-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02414578-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02414763-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02414904-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02415130-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02415253-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02415435-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02415577-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02415829-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02415971-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02416104-n',[ ('Sheep',subsumption)]).
nounMapping2SUMO('02416270-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('02416410-n',[ ('Goat',equivalence)]).
nounMapping2SUMO('02416519-n',[ ('Goat',equivalence)]).
nounMapping2SUMO('02416820-n',[ ('NonFullyFormed',subsumption), ('Goat',subsumption)]).
nounMapping2SUMO('02416880-n',[ ('Male',subsumption), ('Goat',subsumption)]).
nounMapping2SUMO('02416964-n',[ ('Female',subsumption), ('Goat',subsumption)]).
nounMapping2SUMO('02417070-n',[ ('Goat',equivalence)]).
nounMapping2SUMO('02417242-n',[ ('Goat',subsumption)]).
nounMapping2SUMO('02417387-n',[ ('Goat',subsumption)]).
nounMapping2SUMO('02417534-n',[ ('Goat',subsumption)]).
nounMapping2SUMO('02417663-n',[ ('Goat',subsumption)]).
nounMapping2SUMO('02417785-n',[ ('Goat',subsumption)]).
nounMapping2SUMO('02417914-n',[ ('Goat',subsumption)]).
nounMapping2SUMO('02418064-n',[ ('Goat',subsumption)]).
nounMapping2SUMO('02418341-n',[ ('Goat',subsumption)]).
nounMapping2SUMO('02418465-n',[ ('Goat',subsumption)]).
nounMapping2SUMO('02418648-n',[ ('Goat',subsumption)]).
nounMapping2SUMO('02418770-n',[ ('Goat',subsumption)]).
nounMapping2SUMO('02418934-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02419056-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02419217-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02419336-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02419515-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02419634-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02419796-n',[ ('Antelope',subsumption)]).
nounMapping2SUMO('02420389-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02420509-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02420675-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02420828-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02420994-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02421136-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02421308-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02421449-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02421612-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02421792-n',[ ('Antelope',subsumption)]).
nounMapping2SUMO('02421962-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02422106-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02422249-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02422391-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02422561-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02422699-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02422860-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02423022-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02423218-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02423362-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02423465-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02423589-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02423787-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02424085-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02424305-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02424486-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02424589-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02424695-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02424909-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02425086-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02425228-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02425393-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02425532-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02425756-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02425887-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02426054-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02426176-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02426339-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02426481-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02426634-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02426813-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02427032-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02427183-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02427337-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02427470-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02427576-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02427724-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02427958-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02428089-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02428229-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02428349-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02428508-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02428653-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02428842-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02429123-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02429276-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02429456-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02429695-n',[ ('Deer',equivalence)]).
nounMapping2SUMO('02430045-n',[ ('Deer',equivalence)]).
nounMapping2SUMO('02430559-n',[ ('Male',subsumption), ('Deer',subsumption)]).
nounMapping2SUMO('02430643-n',[ ('Male',subsumption), ('Deer',subsumption)]).
nounMapping2SUMO('02430748-n',[ ('Male',subsumption), ('Deer',subsumption)]).
nounMapping2SUMO('02430830-n',[ ('NonFullyFormed',subsumption), ('Deer',subsumption)]).
nounMapping2SUMO('02430929-n',[ ('Deer',subsumption)]).
nounMapping2SUMO('02431122-n',[ ('Deer',subsumption)]).
nounMapping2SUMO('02431337-n',[ ('Male',subsumption), ('Deer',subsumption)]).
nounMapping2SUMO('02431441-n',[ ('Female',subsumption), ('Deer',subsumption)]).
nounMapping2SUMO('02431542-n',[ ('Male',subsumption), ('Deer',subsumption)]).
nounMapping2SUMO('02431628-n',[ ('Deer',subsumption)]).
nounMapping2SUMO('02431785-n',[ ('Deer',subsumption)]).
nounMapping2SUMO('02431976-n',[ ('Deer',subsumption)]).
nounMapping2SUMO('02432139-n',[ ('Deer',subsumption)]).
nounMapping2SUMO('02432291-n',[ ('Deer',subsumption)]).
nounMapping2SUMO('02432511-n',[ ('Deer',subsumption)]).
nounMapping2SUMO('02432704-n',[ ('Deer',subsumption)]).
nounMapping2SUMO('02432867-n',[ ('Deer',subsumption)]).
nounMapping2SUMO('02432983-n',[ ('Deer',subsumption)]).
nounMapping2SUMO('02433205-n',[ ('Deer',subsumption)]).
nounMapping2SUMO('02433318-n',[ ('Deer',subsumption)]).
nounMapping2SUMO('02433426-n',[ ('Deer',subsumption)]).
nounMapping2SUMO('02433546-n',[ ('Deer',subsumption)]).
nounMapping2SUMO('02433729-n',[ ('Male',subsumption), ('Deer',subsumption)]).
nounMapping2SUMO('02433796-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02433925-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02434190-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02434415-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02434598-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02434712-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02434834-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02434954-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02435099-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02435216-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02435386-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02435517-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02435689-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02435853-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02436067-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02436224-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02436353-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02436514-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02436645-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02436813-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02436993-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02437136-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02437312-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02437482-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02437616-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02437825-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02437971-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02438173-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02438272-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02438452-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02438580-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02438774-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02438897-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02439033-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02439286-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02439398-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02439568-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02439728-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02439829-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02439929-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02440121-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02440250-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02440523-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02440705-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02441326-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02441723-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02441942-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02442172-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02442336-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02442446-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02442572-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02442668-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02442845-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02443015-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02443114-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02443346-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02443484-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02443683-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02443808-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02443959-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02444103-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02444251-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02444384-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02444500-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02444647-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02444819-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02445004-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02445171-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02445276-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02445394-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02445564-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02445715-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02446014-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02446206-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02446352-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02446512-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02446645-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02446888-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02447021-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02447220-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02447366-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02447591-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02447762-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02447896-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02448060-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02448200-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02448318-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02448502-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02448633-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02448754-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02448885-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02449060-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02449183-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02449350-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02449464-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02449582-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02449699-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02449921-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02450034-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02450295-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02450426-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02450561-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02450677-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02450829-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02450992-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02451125-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02451292-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02451415-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02451575-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('02451818-n',[ ('Rodent',subsumption)]).
nounMapping2SUMO('02451912-n',[ ('Rodent',instance)]).
nounMapping2SUMO('02452014-n',[ ('Rodent',instance)]).
nounMapping2SUMO('02452138-n',[ ('Rodent',instance)]).
nounMapping2SUMO('02452225-n',[ ('Bird',instance)]).
nounMapping2SUMO('02452347-n',[ ('Rodent',instance)]).
nounMapping2SUMO('02452464-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02452637-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02452813-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02452967-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02453108-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('02453373-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02453611-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02453890-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02454119-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02454379-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02454657-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02454794-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02454999-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02455135-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02455310-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02455428-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02455584-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02455720-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02455887-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02456008-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02456147-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02456275-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02456505-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02456645-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02456776-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02456962-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02457249-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02457408-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02457586-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02457756-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02457945-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02458135-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02458356-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02458517-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02458675-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02458822-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02459001-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02459190-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02459313-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02459485-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02459636-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02459808-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02460009-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02460275-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02460451-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02460684-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02460817-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02461014-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02461128-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02461372-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02461556-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02461701-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02461830-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02462066-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02462213-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02462349-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02462464-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('02462602-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02462828-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02463024-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02463205-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('02463403-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02463611-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02463810-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02463913-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02464065-n',[ ('Knee',subsumption)]).
nounMapping2SUMO('02464223-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02464327-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02464461-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02464626-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02464785-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02464965-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02465084-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02465257-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02465414-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02465585-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02465693-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02465929-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02466132-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02466400-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02466564-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02466731-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02466957-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02467133-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02467320-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02467491-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02467581-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02467746-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02467884-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02468017-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('02468178-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('02468368-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('02468504-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('02468617-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02468735-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02468864-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02469080-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02469248-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02469344-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02469472-n',[ ('Larval',subsumption)]).
nounMapping2SUMO('02469588-n',[ ('Primate',equivalence)]).
nounMapping2SUMO('02469914-n',[ ('Primate',equivalence)]).
nounMapping2SUMO('02470238-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02470325-n',[ ('Ape',equivalence)]).
nounMapping2SUMO('02470451-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02470709-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02470899-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02471072-n',[ ('Hominid',equivalence)]).
nounMapping2SUMO('02471300-n',[ ('Hominid',equivalence)]).
nounMapping2SUMO('02471467-n',[ ('Hominid',equivalence)]).
nounMapping2SUMO('02471762-n',[ ('Hominid',equivalence)]).
nounMapping2SUMO('02472012-n',[ ('Hominid',equivalence)]).
nounMapping2SUMO('02472293-n',[ ('Hominid',equivalence)]).
nounMapping2SUMO('02472987-n',[ ('Human',equivalence)]).
nounMapping2SUMO('02473307-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02473554-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02473720-n',[ ('Hominid',instance)]).
nounMapping2SUMO('02473857-n',[ ('Hominid',instance)]).
nounMapping2SUMO('02473983-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02474110-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02474282-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02474431-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02474605-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02474777-n',[ ('Human',subsumption)]).
nounMapping2SUMO('02475078-n',[ ('Human',subsumption)]).
nounMapping2SUMO('02475358-n',[ ('Human',subsumption)]).
nounMapping2SUMO('02475478-n',[ ('Human',subsumption)]).
nounMapping2SUMO('02475669-n',[ ('Human',subsumption)]).
nounMapping2SUMO('02475821-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02476074-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02476219-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02476567-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02476736-n',[ ('Hominid',instance)]).
nounMapping2SUMO('02476870-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02477028-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02477187-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02477329-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02477516-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02477647-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02477782-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02477890-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02478077-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02478239-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02478416-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02478539-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02478662-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02478875-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02478990-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02479205-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02479332-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02479482-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02479634-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('02479896-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02480153-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02480346-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02480495-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02480673-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02480855-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02481103-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02481235-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02481366-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02481500-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02481629-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02481823-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02482060-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02482286-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02482474-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02482650-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02482820-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02483092-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02483224-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02483362-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02483564-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02483708-n',[ ('Ape',subsumption)]).
nounMapping2SUMO('02483915-n',[ ('Monkey',equivalence)]).
nounMapping2SUMO('02484322-n',[ ('Monkey',equivalence)]).
nounMapping2SUMO('02484473-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02484813-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02484975-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02485225-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02485371-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02485536-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02485688-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02485865-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02485988-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02486138-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02486261-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02486410-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02486565-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02486657-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02486787-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02486908-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02487079-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02487217-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02487347-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02487547-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02487675-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02487847-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02488003-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02488149-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02488291-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02488415-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02488578-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02488702-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02488894-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02489060-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02489166-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02489288-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02489589-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02490030-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02490219-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02490435-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02490597-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02490686-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02490811-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02490964-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02491107-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02491329-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02491474-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02491590-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02491906-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02492035-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02492240-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02492356-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02492536-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02492660-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02492833-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02492948-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02493109-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02493224-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02493390-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02493509-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02493673-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02493793-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02493974-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02494079-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02494257-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02494383-n',[ ('Monkey',subsumption)]).
nounMapping2SUMO('02494538-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02494866-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02495099-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02495242-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02495446-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02495570-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02495789-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02496052-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02496210-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02496576-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02496913-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02497214-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02497408-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02497550-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02497673-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02497832-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02497983-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02498153-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02498355-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02498620-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02498743-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02498888-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02499022-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02499178-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02499316-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02499434-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02499568-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02499700-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02499808-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02499990-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02500144-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02500267-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02500472-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02500596-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02500749-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02501101-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02501275-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02501432-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02501583-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02501923-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02502006-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02502085-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02502212-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02502357-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02502514-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02502807-n',[ ('Primate',subsumption)]).
nounMapping2SUMO('02502902-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02503127-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02503313-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02503517-n',[ ('Elephant',subsumption)]).
nounMapping2SUMO('02503756-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02503868-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02504013-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02504196-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02504323-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02504458-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02504635-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02504770-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02505063-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02505238-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02505342-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02505485-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02505646-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02505809-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02505998-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02506248-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02506466-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02506630-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02506783-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02506947-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02507148-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02507337-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02507649-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02507863-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02508021-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02508213-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02508346-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02508458-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02508615-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02508742-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02509071-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02509197-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02509405-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02509515-n',[ ('Mammal',subsumption)]).
nounMapping2SUMO('02509694-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02509815-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02510065-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02510240-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02510455-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('02510769-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02510978-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02511107-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02511303-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02511510-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02511633-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02511730-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('02511824-n',[ ('Fish',equivalence)]).
nounMapping2SUMO('02512053-n',[ ('Fish',equivalence)]).
nounMapping2SUMO('02512752-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02512830-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02512938-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02513248-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02513355-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02513560-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('02513727-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('02513805-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02513939-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02514041-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02514198-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02514320-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02514575-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02514825-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02514988-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02515214-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02515410-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02515560-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02515713-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02515914-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02516188-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02516427-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02516615-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02516776-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02516867-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02516994-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02517169-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02517442-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02517768-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02517938-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02518178-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02518324-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02518488-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02518622-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02518813-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02518990-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02519148-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02519340-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02519472-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02519576-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02519686-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02519862-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02520015-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02520147-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02520391-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02520525-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02520669-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02520810-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02520985-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02521129-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02521241-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02521472-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02521646-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02521916-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02522247-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02522399-n',[ ('Cod',equivalence)]).
nounMapping2SUMO('02522637-n',[ ('Cod',subsumption)]).
nounMapping2SUMO('02522722-n',[ ('Cod',subsumption)]).
nounMapping2SUMO('02522866-n',[ ('Cod',subsumption)]).
nounMapping2SUMO('02522990-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02523110-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02523338-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02523427-n',[ ('Cod',subsumption)]).
nounMapping2SUMO('02523617-n',[ ('Cod',subsumption)]).
nounMapping2SUMO('02523750-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02523877-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02524081-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02524202-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02524424-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02524524-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02524659-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02524811-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02524928-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02525012-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02525120-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02525287-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02525382-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02525543-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02525703-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02525866-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02526121-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02526425-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('02526486-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02526673-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02526818-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02527057-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02527145-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02527271-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02527498-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02527622-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02527813-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02528163-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02528534-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02528949-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02529111-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02529293-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02529515-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02529772-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02530052-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('02530188-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('02530294-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02530421-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02530637-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02530831-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02530999-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02531114-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02531362-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02531503-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02531625-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02531820-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02532028-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02532272-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02532451-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02532602-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02532786-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('02532918-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02533075-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02533209-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02533424-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02533545-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02533708-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02533834-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02534036-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02534165-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02534352-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02534559-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02534734-n',[ ('Salmon',equivalence)]).
nounMapping2SUMO('02535080-n',[ ('Salmon',subsumption)]).
nounMapping2SUMO('02535163-n',[ ('Female',subsumption), ('Salmon',subsumption)]).
nounMapping2SUMO('02535258-n',[ ('Male',subsumption), ('Salmon',subsumption)]).
nounMapping2SUMO('02535349-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02535537-n',[ ('Salmon',subsumption)]).
nounMapping2SUMO('02535759-n',[ ('Salmon',subsumption)]).
nounMapping2SUMO('02535909-n',[ ('Salmon',subsumption)]).
nounMapping2SUMO('02536165-n',[ ('Salmon',subsumption)]).
nounMapping2SUMO('02536456-n',[ ('Salmon',subsumption)]).
nounMapping2SUMO('02536685-n',[ ('Salmon',subsumption)]).
nounMapping2SUMO('02536864-n',[ ('Salmon',subsumption)]).
nounMapping2SUMO('02537085-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02537319-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02537525-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02537716-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02537847-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02538010-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02538216-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02538406-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02538562-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02538730-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02538985-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02539251-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02539424-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02539573-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02539752-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02539894-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02540091-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02540255-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02540412-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02540637-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02540791-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02540983-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02541139-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02541257-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02541431-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02541583-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02541687-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02541875-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02542017-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02542162-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02542283-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02542432-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02542598-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02542804-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02542958-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02543093-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02543255-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02543412-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02543565-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02543737-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02543952-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02544086-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02544274-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02544475-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02544596-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02544754-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02544960-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02545153-n',[ ('Battle',instance)]).
nounMapping2SUMO('02545387-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02545569-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02545687-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02545841-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02546028-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02546177-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02546331-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02546477-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02546627-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02546744-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02546873-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02547014-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02547213-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02547562-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02547733-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02547947-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02548128-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02548247-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02548522-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02548689-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02548884-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02548990-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02549248-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02549376-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02549533-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02549796-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02549989-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02550203-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02550296-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02550460-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02550655-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02550780-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02550915-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02551134-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02551316-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02551494-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02551668-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02551824-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02552171-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02552737-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02552894-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02553028-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02553196-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02554512-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02554730-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02555863-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02556014-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02556195-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02556373-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02556623-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02556846-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02557033-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02557182-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02557318-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02557461-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02557591-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02557749-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02557909-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02558079-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02558206-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02558350-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02558560-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02558724-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02558860-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02558980-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02559144-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02559232-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02559383-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02559606-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02559862-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02559974-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02560110-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02560271-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02560383-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02560546-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02560823-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02560964-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02561108-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02561381-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02561514-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02561661-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02561803-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02561937-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02562085-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02562315-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02562680-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02562796-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02562971-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02563079-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02563182-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02563497-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02563648-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02563792-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02563949-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02564130-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02564270-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02564403-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02564572-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02564720-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02564935-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02565072-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02565324-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02565573-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02565728-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02566109-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02566325-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02566489-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02566665-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02566834-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02567201-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02567334-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02567484-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02567633-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02567772-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02567960-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02568087-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02568326-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02568447-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02568636-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02568807-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02568959-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02569151-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02569334-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02569484-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02569631-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02569770-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02569905-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02570038-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02570164-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02570312-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02570484-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02570648-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02570838-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02571034-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02571167-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02571300-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02571486-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02571652-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02571810-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02571983-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02572196-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02572369-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02572484-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02572628-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02572763-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02572904-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02573075-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02573249-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02573406-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02573563-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02573704-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02573918-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02574093-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02574271-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02574489-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02574651-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02574910-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02575168-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02575325-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02575455-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02575590-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02575766-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02576223-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02576460-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02576575-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02576906-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02577041-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02577164-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02577291-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02577403-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02577532-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02577662-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02577823-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02577952-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02578125-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02578233-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02578454-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02578604-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02578771-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02578928-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02579091-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02579303-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02579420-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02579557-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02579762-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02579928-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02580055-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02580188-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02580336-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02580546-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02580679-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02580830-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02580991-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02581108-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02581289-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02581482-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02581642-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02581803-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02581957-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02582220-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02582349-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02582437-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02582591-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02582721-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02582919-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02583096-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02583211-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02583457-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02583567-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02583768-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02583890-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02584004-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02584145-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02584325-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02584449-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02584643-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('02584915-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02585168-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02585285-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02585446-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02585732-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02585872-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02586129-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02586238-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02586382-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02586543-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02586865-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02587051-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02587300-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02587479-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02587618-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02587761-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02587877-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02588108-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02588286-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02588580-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02588794-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02588945-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02589062-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02589196-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02589316-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02589486-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02589623-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02589796-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02589955-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02590094-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02590237-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02590495-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02590702-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02590987-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02591205-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02591330-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02591493-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02591613-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02591757-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02591911-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02592055-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02592244-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02592371-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02592607-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02592734-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02592866-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02593019-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02593191-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02593353-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02593453-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02593679-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02593863-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02594250-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02594552-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02594807-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02594942-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02595056-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02595217-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02595339-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02595569-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02595702-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02595902-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02596067-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02596252-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02596381-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02596592-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02596720-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02596888-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02597004-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02597173-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02597367-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02597608-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02597818-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02597972-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02598134-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02598252-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02598438-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02598573-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02598747-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02598878-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02599052-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02599207-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02599347-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02599557-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02599784-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02599958-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02600135-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02600298-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02600503-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02600657-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02600798-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02600953-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02601200-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02601344-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02601589-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02601767-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02601921-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02602059-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02602215-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02602405-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02602620-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02602760-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02602970-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02603174-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02603317-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02603540-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02603737-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02603862-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02604014-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02604157-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02604342-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02604480-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02604657-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02604811-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02604954-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02605139-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02605316-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02605571-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02605703-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02605809-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02605936-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02606052-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02606194-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02606384-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02606590-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02606751-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02606926-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02607072-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02607201-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02607345-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02607470-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02607630-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02607862-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02608151-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02608284-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02608429-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02608547-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02608708-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02608860-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02608996-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02609169-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02609302-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02609466-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02609617-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02609823-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02609951-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02610066-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02610234-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02610373-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02610541-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02610664-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02610834-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02610980-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02611154-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02611294-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02611425-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02611561-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02611767-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02611898-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02612046-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02612167-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02612393-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02612657-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02612982-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02613181-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02613434-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02613572-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02613687-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02613820-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02613960-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02614140-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02614288-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02614482-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02614653-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02614788-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02614978-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02615157-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02615298-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02615494-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02615642-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02615829-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02615980-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02616128-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02616251-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02616397-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02616572-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02616705-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02616851-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02617029-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02617207-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02617402-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02617537-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02617689-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02617819-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02617956-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02618094-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02618244-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02618372-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02618513-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02618697-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02618827-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02619029-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02619165-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02619409-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02619550-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02619738-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02619861-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02620033-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02620167-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02620318-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02620443-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02620578-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02620826-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02620956-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02621107-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02621258-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02621419-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02621577-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02621721-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02621908-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02622130-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02622249-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02622408-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02622547-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02622712-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02622823-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02622955-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02623170-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02623445-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02623868-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02624167-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02624377-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02624551-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02624807-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02624987-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02625132-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02625258-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02625418-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02625612-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02625851-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02626089-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02626265-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02626471-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02626590-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02626762-n',[ ('Tuna',equivalence)]).
nounMapping2SUMO('02627037-n',[ ('Tuna',subsumption)]).
nounMapping2SUMO('02627292-n',[ ('Tuna',subsumption)]).
nounMapping2SUMO('02627532-n',[ ('Tuna',subsumption)]).
nounMapping2SUMO('02627686-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02627835-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02628062-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02628259-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02628467-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02628600-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02628856-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02629048-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02629230-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02629435-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02629581-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02629716-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02630052-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02630281-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02630468-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02630615-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02630739-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02630926-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02631041-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02631330-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02631475-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02631628-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02631775-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02631899-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02632039-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02632239-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02632359-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02632494-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02632694-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02632989-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02633287-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02633422-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02633555-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02633677-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02633844-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02633977-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02634156-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02634285-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02634414-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02634545-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02634717-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02634858-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02635013-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02635154-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02635310-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02635459-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02635580-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02635781-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02635911-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02636035-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02636170-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02636405-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02636550-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02636666-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02636854-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02637046-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02637179-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02637337-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02637475-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02637637-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02637839-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02637977-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02638104-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('02638323-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02638596-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02638835-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02638960-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02639087-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02639312-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02639464-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02639605-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02639786-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02639922-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02640093-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02640242-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02640453-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02640626-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02640857-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02641063-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02641215-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02641379-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02641608-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02641825-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02642107-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02642430-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02642644-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02642935-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02643112-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02643316-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02643448-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02643566-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02643713-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02643836-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02643989-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02644113-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02644360-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02644501-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02644665-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02644817-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02644967-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02645143-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02645304-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02645538-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02645691-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02645823-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02645953-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02646117-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02646241-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02646377-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02646508-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02646667-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02646892-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02646985-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02647144-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02647294-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02647503-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02647660-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02647903-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02648035-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02648174-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02648313-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02648456-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02648625-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02648769-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02648916-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02649082-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02649218-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02649400-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02649546-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02649689-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02650050-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02650282-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02650413-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02650541-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02650696-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02650928-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02651060-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02651215-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02651412-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02651617-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02651846-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02652005-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02652132-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02652335-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02652668-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02652979-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02653145-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02653359-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02653497-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02653655-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02653786-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02653965-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02654112-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02654256-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02654425-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02654609-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02654745-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02654890-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02655020-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02655355-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02655523-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02655694-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02655848-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02656032-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02656171-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02656301-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02656426-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02656550-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02656670-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02656969-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02657083-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02657368-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02657694-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02657805-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02658079-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02658381-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02658531-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02658670-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02658811-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02658944-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02659176-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02659342-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02659478-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02659667-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02659808-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02659961-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02660091-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02660208-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02660412-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02660519-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02660640-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02660769-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02661017-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02661317-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02661473-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02661618-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02661765-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02661892-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02662081-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02662239-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02662397-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02662559-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02662688-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02662825-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02662993-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02663086-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02663211-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02663352-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02663485-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02663657-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02663849-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02664136-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02664285-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02664399-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02664511-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02664642-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02664823-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02664960-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02665119-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02665250-n',[ ('Fish',subsumption)]).
nounMapping2SUMO('02665413-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02665543-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02665687-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02665812-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('02665985-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02666079-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02666196-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02666347-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02666501-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02666624-n',[ ('Battery',subsumption)]).
nounMapping2SUMO('02666735-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02666943-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02667093-n',[ ('Abayah',equivalence)]).
nounMapping2SUMO('02667244-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02667379-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('02667478-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('02667576-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('02667693-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02667906-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02668093-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02668393-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02668613-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02668747-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02669001-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02669079-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02669295-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02669442-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02669534-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02669723-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02669885-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('02670049-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02670186-n',[ ('VehicleThrottle',subsumption)]).
nounMapping2SUMO('02670382-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02670683-n',[ ('GasPedal',equivalence)]).
nounMapping2SUMO('02670935-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02671062-n',[ ('Transitway',subsumption)]).
nounMapping2SUMO('02671224-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('02671421-n',[ ('Object',subsumption)]).
nounMapping2SUMO('02671780-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02671988-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('02672152-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02672371-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02672646-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02672831-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('02673078-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02673291-n',[ ('PlayingCard',subsumption)]).
nounMapping2SUMO('02673480-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02673637-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02674101-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02674184-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02674273-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02674358-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02674482-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02674912-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02675077-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02675219-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02675354-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02675522-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02675657-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02675885-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02675987-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02676097-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('02676261-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02676566-n',[ ('Guitar',subsumption)]).
nounMapping2SUMO('02676670-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02676805-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02676938-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02677028-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02677136-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('02677232-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02677436-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02677602-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02677718-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02678010-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02678174-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('02678384-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02678528-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02678738-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02678897-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02679142-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02679257-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02679415-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('02679788-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('02679961-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02680110-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02680337-n',[ ('Tape',subsumption)]).
nounMapping2SUMO('02680512-n',[ ('Road',subsumption)]).
nounMapping2SUMO('02680638-n',[ ('AdjoiningRoom',equivalence)]).
nounMapping2SUMO('02680754-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02680947-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02681084-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('02681392-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('02681518-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('02682038-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02682207-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('02682311-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02682407-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('02682569-n',[ ('Aerator',equivalence)]).
nounMapping2SUMO('02682699-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02682811-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02682922-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02683183-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02683323-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02683454-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02683558-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02683692-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02683791-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('02683936-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02684083-n',[ ('String',subsumption)]).
nounMapping2SUMO('02684248-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02684356-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02684515-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02684649-n',[ ('Container',subsumption)]).
nounMapping2SUMO('02684789-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02684962-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('02685082-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02685253-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02685365-n',[ ('Airbag',equivalence)]).
nounMapping2SUMO('02685585-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02685701-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02685855-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02685995-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02686121-n',[ ('JetAirplane',subsumption)]).
nounMapping2SUMO('02686227-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02686379-n',[ ('AirConditioner',equivalence)]).
nounMapping2SUMO('02686568-n',[ ('Aircraft',equivalence)]).
nounMapping2SUMO('02687172-n',[ ('AircraftCarrier',subsumption)]).
nounMapping2SUMO('02687423-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02687539-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02687682-n',[ ('Damper',subsumption)]).
nounMapping2SUMO('02687821-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02687992-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02688273-n',[ ('AirFilter',equivalence)]).
nounMapping2SUMO('02688443-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02688895-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('02689144-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02689274-n',[ ('Gun',subsumption)]).
nounMapping2SUMO('02689434-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02689556-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('02689648-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('02689748-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02689819-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02689961-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('02690081-n',[ ('Airline',equivalence)]).
nounMapping2SUMO('02690270-n',[ ('Hose',subsumption)]).
nounMapping2SUMO('02690373-n',[ ('Airplane',subsumption)]).
nounMapping2SUMO('02690583-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02690715-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02690809-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02690941-n',[ ('Airway',subsumption)]).
nounMapping2SUMO('02691156-n',[ ('Airplane',equivalence)]).
nounMapping2SUMO('02692086-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02692232-n',[ ('Airport',subsumption)]).
nounMapping2SUMO('02692513-n',[ ('AirPump',equivalence)]).
nounMapping2SUMO('02692680-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02692787-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('02692877-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02693070-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02693246-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02693413-n',[ ('AAM',equivalence)]).
nounMapping2SUMO('02693540-n',[ ('AGM',equivalence)]).
nounMapping2SUMO('02693709-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02693860-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('02694045-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('02694182-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('02694279-n',[ ('Artifact',instance)]).
nounMapping2SUMO('02694426-n',[ ('SecurityAlarm',subsumption)]).
nounMapping2SUMO('02694662-n',[ ('AlarmClock',equivalence)]).
nounMapping2SUMO('02694776-n',[ ('TransportationDevice',instance)]).
nounMapping2SUMO('02694966-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02695079-n',[ ('Book',subsumption)]).
nounMapping2SUMO('02695321-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02695627-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02695762-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('02696048-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02696165-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02696246-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02696384-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02696569-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02696669-n',[ ('Building',instance)]).
nounMapping2SUMO('02696843-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02697022-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02697221-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02697438-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('02697576-n',[ ('Screw',subsumption)]).
nounMapping2SUMO('02697675-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02697759-n',[ ('Road',subsumption)]).
nounMapping2SUMO('02697876-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02698036-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02698244-n',[ ('Holder',subsumption)]).
nounMapping2SUMO('02698366-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02698473-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02698634-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02698769-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02699096-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('02699343-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02699494-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02699629-n',[ ('Table',subsumption)]).
nounMapping2SUMO('02699770-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02699915-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02700064-n',[ ('Alternator',equivalence)]).
nounMapping2SUMO('02700258-n',[ ('Altimeter',equivalence)]).
nounMapping2SUMO('02700422-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02700622-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02700767-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02700895-n',[ ('Violin',subsumption)]).
nounMapping2SUMO('02701002-n',[ ('Ambulance',subsumption)]).
nounMapping2SUMO('02701125-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02701260-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02701393-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02701566-n',[ ('Flag',subsumption)]).
nounMapping2SUMO('02701730-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('02701871-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('02701984-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02702166-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02702304-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02702575-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02702809-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02702989-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02703124-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02703275-n',[ ('Bullet',equivalence)]).
nounMapping2SUMO('02703499-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02703692-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02703894-n',[ ('Penicillin',subsumption)]).
nounMapping2SUMO('02704153-n',[ ('Stimulant',subsumption)]).
nounMapping2SUMO('02704462-n',[ ('Stimulant',subsumption)]).
nounMapping2SUMO('02704645-n',[ ('Airplane',subsumption)]).
nounMapping2SUMO('02704792-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02704949-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02705201-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02705429-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02705558-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02705651-n',[ ('Penicillin',subsumption)]).
nounMapping2SUMO('02705944-n',[ ('Amplifier',subsumption)]).
nounMapping2SUMO('02706221-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02706373-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02706586-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02706806-n',[ ('MercantileOrganization',subsumption)]).
nounMapping2SUMO('02706916-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02707036-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('02707188-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02707344-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02707547-n',[ ('Stimulant',subsumption)]).
nounMapping2SUMO('02707683-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02708093-n',[ ('Clock',subsumption)]).
nounMapping2SUMO('02708224-n',[ ('Computer',subsumption)]).
nounMapping2SUMO('02708433-n',[ ('WatchClock',subsumption)]).
nounMapping2SUMO('02708555-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02708711-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02708885-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('02709101-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02709265-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02709367-n',[ ('Anchor',equivalence)]).
nounMapping2SUMO('02709637-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02709763-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('02709908-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02710044-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02710201-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02710324-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02710429-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02710600-n',[ ('PressureMeasuringDevice',subsumption)]).
nounMapping2SUMO('02710766-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02711110-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02711237-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('02711422-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02711573-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('02711780-n',[ ('Microscope',subsumption)]).
nounMapping2SUMO('02711890-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02712134-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02712280-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02712393-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02712545-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02712643-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02712762-n',[ ('Bridge',subsumption)]).
nounMapping2SUMO('02712907-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('02713003-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02713097-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02713218-n',[ ('Sock',subsumption)]).
nounMapping2SUMO('02713364-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('02713496-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02713594-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02713769-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02713835-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02713992-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02714139-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02714315-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02714535-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02714751-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02714883-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02715096-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02715229-n',[ ('Antenna',subsumption)]).
nounMapping2SUMO('02715513-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02715712-n',[ ('ArtilleryGun',subsumption)]).
nounMapping2SUMO('02715941-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02716205-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02716626-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02716866-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02717901-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02718084-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02718259-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02718469-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02718811-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02719105-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02719294-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02719450-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02719588-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02719750-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02719951-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02720048-n',[ ('Paint',subsumption)]).
nounMapping2SUMO('02720201-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02720576-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02720725-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02721160-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02721538-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02721813-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02721948-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02722166-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02722349-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02722458-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02722997-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02723165-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02723292-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02723491-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02723595-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02723754-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02724026-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02724207-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02724533-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02724722-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02724838-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02724966-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02725242-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02725367-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02725596-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('02725872-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02726017-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02726210-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02726305-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02726681-n',[ ('ApartmentBuilding',subsumption)]).
nounMapping2SUMO('02726861-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02727016-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('02727141-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02727281-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02727426-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02727566-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02727660-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02727825-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02728440-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02728763-n',[ ('Object',subsumption)]).
nounMapping2SUMO('02728968-n',[ ('Object',subsumption)]).
nounMapping2SUMO('02729060-n',[ ('Road',instance)]).
nounMapping2SUMO('02729222-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02729345-n',[ ('FruitOrVegetable',instance)]).
nounMapping2SUMO('02729755-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02729837-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02729965-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02730265-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02730437-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02730568-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02730748-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('02730930-n',[ ('Apron',subsumption)]).
nounMapping2SUMO('02731123-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02731251-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02731398-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02731629-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02731900-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02732072-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02732295-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02732433-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02732572-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02732696-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02732827-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02733075-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('02733213-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02733378-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02733524-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02734217-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02734423-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02734725-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02734835-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02734994-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02735086-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('02735268-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02735361-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02735538-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02735688-n',[ ('StationaryArtifact',equivalence)]).
nounMapping2SUMO('02736396-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('02736511-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02736645-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02736798-n',[ ('Sock',subsumption)]).
nounMapping2SUMO('02736934-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02737166-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02737351-n',[ ('TransportationDevice',instance)]).
nounMapping2SUMO('02737467-n',[ ('Artifact',instance)]).
nounMapping2SUMO('02737660-n',[ ('Object',subsumption)]).
nounMapping2SUMO('02737833-n',[ ('Object',subsumption)]).
nounMapping2SUMO('02738031-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02738271-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02738449-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02738535-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('02738741-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02738859-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02738978-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('02739123-n',[ ('Jewelry',subsumption)]).
nounMapping2SUMO('02739248-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02739427-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02739550-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02739668-n',[ ('Armor',equivalence)]).
nounMapping2SUMO('02739889-n',[ ('MilitaryVehicle',subsumption), ('LandVehicle',subsumption)]).
nounMapping2SUMO('02740061-n',[ ('LandVehicle',subsumption)]).
nounMapping2SUMO('02740300-n',[ ('APC',equivalence)]).
nounMapping2SUMO('02740533-n',[ ('ArmoredVehicle',equivalence)]).
nounMapping2SUMO('02740764-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02741367-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02741475-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02741587-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02741681-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('02741981-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02742070-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02742194-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('02742322-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02742468-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02742663-n',[ ('Door',subsumption)]).
nounMapping2SUMO('02742753-n',[ ('ArrowProjectile',equivalence)]).
nounMapping2SUMO('02743050-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02743207-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02743426-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02743547-n',[ ('ArtWork',equivalence)]).
nounMapping2SUMO('02744077-n',[ ('ReligiousBuilding',instance)]).
nounMapping2SUMO('02744323-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('02744423-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('02744532-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('02744634-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02744844-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('02744961-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02745091-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02745228-n',[ ('Ladder',subsumption)]).
nounMapping2SUMO('02745395-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02745492-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02745611-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02745816-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02746008-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02746225-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02746365-n',[ ('ArtilleryGun',subsumption)]).
nounMapping2SUMO('02746595-n',[ ('ProjectileShell',subsumption)]).
nounMapping2SUMO('02746683-n',[ ('LoftStyle',subsumption)]).
nounMapping2SUMO('02746841-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02746978-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('02747063-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02747177-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02747379-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02747541-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02747672-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02747802-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02747915-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02748088-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02748183-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02748359-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02748491-n',[ ('Pump',subsumption)]).
nounMapping2SUMO('02748618-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02749169-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02749292-n',[ ('MilitaryVehicle',subsumption), ('LandVehicle',subsumption)]).
nounMapping2SUMO('02749479-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02749670-n',[ ('Spear',subsumption)]).
nounMapping2SUMO('02749790-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('02749953-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02750070-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02750169-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02750320-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02750652-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02750835-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02751067-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02751215-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02751295-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02751490-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02751623-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('02751782-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02752039-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02752199-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02752311-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02752496-n',[ ('Sock',subsumption)]).
nounMapping2SUMO('02752615-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02752810-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02752917-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02753044-n',[ ('NuclearWeapon',subsumption)]).
nounMapping2SUMO('02753394-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02753569-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02753710-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02753881-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02754103-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02754421-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02754656-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02754756-n',[ ('Atropine',equivalence)]).
nounMapping2SUMO('02755140-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02755244-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02755352-n',[ ('Object',subsumption)]).
nounMapping2SUMO('02755529-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02755675-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02755823-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02755984-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02756098-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02756601-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02756751-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02756854-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02756977-n',[ ('AudioCassette',equivalence)]).
nounMapping2SUMO('02757061-n',[ ('CompactDisc',subsumption)]).
nounMapping2SUMO('02757211-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('02757337-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('02757462-n',[ ('MediaSystem',subsumption)]).
nounMapping2SUMO('02757714-n',[ ('AudioCassette',equivalence)]).
nounMapping2SUMO('02757810-n',[ ('AudioRecording',equivalence)]).
nounMapping2SUMO('02757927-n',[ ('MediaSystem',subsumption)]).
nounMapping2SUMO('02758134-n',[ ('Auditorium',equivalence)]).
nounMapping2SUMO('02758270-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('02758490-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02758600-n',[ ('Prison',instance)]).
nounMapping2SUMO('02758753-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02758863-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02758960-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02759257-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02759387-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02759615-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02759700-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02759963-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02760099-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02760199-n',[ ('VendingDevice',subsumption)]).
nounMapping2SUMO('02760298-n',[ ('EngineChoke',subsumption)]).
nounMapping2SUMO('02760429-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02760658-n',[ ('Pistol',subsumption)]).
nounMapping2SUMO('02760855-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02761034-n',[ ('AutomobileTransmission',subsumption)]).
nounMapping2SUMO('02761206-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02761392-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02761557-n',[ ('Engine',subsumption)]).
nounMapping2SUMO('02761696-n',[ ('IndustrialPlant',subsumption)]).
nounMapping2SUMO('02761834-n',[ ('ElectricDevice',subsumption)]).
nounMapping2SUMO('02762044-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02762169-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02762371-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('02762508-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02762609-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02762725-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02762909-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02763083-n',[ ('Pump',subsumption)]).
nounMapping2SUMO('02763198-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02763306-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02763472-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02763604-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02763714-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02763901-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02764044-n',[ ('CuttingDevice',subsumption)]).
nounMapping2SUMO('02764398-n',[ ('Handle',subsumption)]).
nounMapping2SUMO('02764505-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02764614-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02764779-n',[ ('Axle',subsumption)]).
nounMapping2SUMO('02764935-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02765028-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02765247-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('02765429-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('02765656-n',[ ('Antibiotic',subsumption)]).
nounMapping2SUMO('02765868-n',[ ('Antibiotic',subsumption)]).
nounMapping2SUMO('02766044-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02766168-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02766320-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02766534-n',[ ('UnpoweredVehicle',subsumption)]).
nounMapping2SUMO('02766792-n',[ ('Piano',subsumption)]).
nounMapping2SUMO('02766961-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02767038-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02767147-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('02767240-n',[ ('Bacitracin',equivalence)]).
nounMapping2SUMO('02767433-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('02767665-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02767815-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02767956-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02768114-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02768226-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02768433-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02768655-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02768744-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02768864-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02768973-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02769075-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02769290-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02769460-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02769669-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02769748-n',[ ('Bag',subsumption)]).
nounMapping2SUMO('02769963-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02770078-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02770211-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02770293-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02770441-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02770585-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02770721-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02770830-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02771004-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02771166-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02771286-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02771383-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('02771547-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02771750-n',[ ('Sword',subsumption)]).
nounMapping2SUMO('02771840-n',[ ('Object',subsumption)]).
nounMapping2SUMO('02772101-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02772197-n',[ ('Lawn',subsumption)]).
nounMapping2SUMO('02772282-n',[ ('Filter',subsumption)]).
nounMapping2SUMO('02772435-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02772554-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02772700-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02772868-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02773037-n',[ ('Container',subsumption)]).
nounMapping2SUMO('02773838-n',[ ('TravelContainer',subsumption)]).
nounMapping2SUMO('02774152-n',[ ('Bag',subsumption)]).
nounMapping2SUMO('02774502-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('02774630-n',[ ('TravelContainer',subsumption)]).
nounMapping2SUMO('02774921-n',[ ('TravelContainer',subsumption)]).
nounMapping2SUMO('02775039-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('02775178-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02775359-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02775483-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('02775689-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02775813-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02775897-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02776007-n',[ ('PotOrPan',subsumption)]).
nounMapping2SUMO('02776205-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02776505-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02776631-n',[ ('Bakery',equivalence)]).
nounMapping2SUMO('02776825-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02776978-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('02777100-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02777292-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02777402-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02777638-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02777734-n',[ ('Balcony',equivalence)]).
nounMapping2SUMO('02777927-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02778131-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02778294-n',[ ('Belt',subsumption)]).
nounMapping2SUMO('02778456-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02778588-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02778669-n',[ ('Ball',equivalence)]).
nounMapping2SUMO('02779435-n',[ ('Ball',equivalence)]).
nounMapping2SUMO('02779609-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02779719-n',[ ('BallJoint',equivalence)]).
nounMapping2SUMO('02779845-n',[ ('Object',subsumption)]).
nounMapping2SUMO('02779971-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02780121-n',[ ('ResistorElement',subsumption)]).
nounMapping2SUMO('02780315-n',[ ('BallBearing',equivalence)]).
nounMapping2SUMO('02780445-n',[ ('Cartridge',subsumption)]).
nounMapping2SUMO('02780588-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02780704-n',[ ('Dress',subsumption)]).
nounMapping2SUMO('02780815-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02780916-n',[ ('BaseballField',equivalence)]).
nounMapping2SUMO('02781121-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02781213-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02781338-n',[ ('BallisticMissile',equivalence)]).
nounMapping2SUMO('02781517-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02781764-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02782093-n',[ ('Balloon',equivalence)]).
nounMapping2SUMO('02782329-n',[ ('Balloon',equivalence)]).
nounMapping2SUMO('02782432-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('02782602-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02782681-n',[ ('Box',subsumption)]).
nounMapping2SUMO('02782778-n',[ ('SportsFacility',subsumption)]).
nounMapping2SUMO('02783035-n',[ ('Hammer',subsumption)]).
nounMapping2SUMO('02783161-n',[ ('WritingDevice',subsumption)]).
nounMapping2SUMO('02783324-n',[ ('DanceHall',equivalence)]).
nounMapping2SUMO('02783459-n',[ ('Valve',subsumption)]).
nounMapping2SUMO('02783567-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('02783708-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('02783790-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('02783900-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('02783994-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02784124-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02784218-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02784732-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02784998-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('02785191-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02785365-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02785570-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02785648-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02786058-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('02786198-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02786331-n',[ ('Box',subsumption)]).
nounMapping2SUMO('02786463-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02786611-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02786736-n',[ ('MusicalInstrument',subsumption)]).
nounMapping2SUMO('02786837-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02786984-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02787120-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02787269-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02787435-n',[ ('PersonalAdornment',subsumption)]).
nounMapping2SUMO('02787622-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('02787772-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02788021-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02788148-n',[ ('Handle',subsumption)]).
nounMapping2SUMO('02788386-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02788462-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02788572-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02788689-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('02789271-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('02789487-n',[ ('Tavern',subsumption)]).
nounMapping2SUMO('02789770-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02790012-n',[ ('HeatingDevice',subsumption)]).
nounMapping2SUMO('02790154-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02790322-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02790550-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02790669-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02790823-n',[ ('Wire',subsumption)]).
nounMapping2SUMO('02790996-n',[ ('AnaerobicExerciseDevice',subsumption)]).
nounMapping2SUMO('02791124-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('02791270-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('02791385-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02791532-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02791665-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02791795-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02791894-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02792049-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02792305-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02792409-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('02792552-n',[ ('CargoShip',subsumption)]).
nounMapping2SUMO('02792822-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('02792948-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02793089-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('02793199-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('02793296-n',[ ('Magnet',subsumption)]).
nounMapping2SUMO('02793414-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02793495-n',[ ('Barn',equivalence)]).
nounMapping2SUMO('02793684-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02793842-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02793930-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02794008-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02794156-n',[ ('PressureMeasuringDevice',subsumption)]).
nounMapping2SUMO('02794368-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02794474-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02794664-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02794779-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02794972-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02795169-n',[ ('FluidContainer',subsumption)]).
nounMapping2SUMO('02795528-n',[ ('GunBarrel',subsumption)]).
nounMapping2SUMO('02795670-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('02795783-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('02795978-n',[ ('MusicalInstrument',subsumption)]).
nounMapping2SUMO('02796207-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02796318-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02796412-n',[ ('Barricade',equivalence)]).
nounMapping2SUMO('02796623-n',[ ('Barrier',equivalence)]).
nounMapping2SUMO('02796995-n',[ ('Tavern',subsumption)]).
nounMapping2SUMO('02797295-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02797455-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('02797535-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02797692-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02797881-n',[ ('BaseballBase',subsumption)]).
nounMapping2SUMO('02798117-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02798290-n',[ ('MilitaryInstallation',subsumption)]).
nounMapping2SUMO('02798574-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02798769-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('02799071-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('02799175-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02799323-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('02799442-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('02799593-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02799897-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02800213-n',[ ('Glove',subsumption)]).
nounMapping2SUMO('02800354-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02800497-n',[ ('Basement',subsumption)]).
nounMapping2SUMO('02800675-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02800793-n',[ ('Object',subsumption)]).
nounMapping2SUMO('02800940-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02801047-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02801184-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02801450-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02801525-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02801823-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02801938-n',[ ('Container',subsumption)]).
nounMapping2SUMO('02802215-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02802426-n',[ ('BasketBall',equivalence)]).
nounMapping2SUMO('02802544-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02802721-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02802886-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02802990-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02803129-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02803349-n',[ ('MusicalInstrument',subsumption)]).
nounMapping2SUMO('02803539-n',[ ('Clarinet',subsumption)]).
nounMapping2SUMO('02803666-n',[ ('Drum',subsumption)]).
nounMapping2SUMO('02803809-n',[ ('Clarinet',subsumption)]).
nounMapping2SUMO('02803934-n',[ ('Violin',subsumption)]).
nounMapping2SUMO('02804123-n',[ ('Guitar',subsumption)]).
nounMapping2SUMO('02804252-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('02804414-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02804515-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02804610-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('02804772-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('02805111-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('02805283-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02805443-n',[ ('Prison',subsumption)]).
nounMapping2SUMO('02805584-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('02805845-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02805983-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02806088-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02806274-n',[ ('Cocaine',subsumption)]).
nounMapping2SUMO('02806379-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02806530-n',[ ('FluidContainer',subsumption)]).
nounMapping2SUMO('02806762-n',[ ('Wheelchair',subsumption)]).
nounMapping2SUMO('02806875-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02806992-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02807133-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('02807260-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02807401-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02807523-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('02807616-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02807731-n',[ ('Bathroom',equivalence)]).
nounMapping2SUMO('02807998-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('02808097-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02808185-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('02808304-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02808440-n',[ ('BathTub',equivalence)]).
nounMapping2SUMO('02808695-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02808829-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02808968-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02809105-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02809241-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02809364-n',[ ('Baton',subsumption)]).
nounMapping2SUMO('02809491-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02809605-n',[ ('Baton',subsumption)]).
nounMapping2SUMO('02809736-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02809866-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('02810008-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02810139-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02810270-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02810471-n',[ ('Battery',subsumption)]).
nounMapping2SUMO('02810782-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02810930-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('02811059-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02811204-n',[ ('Glove',subsumption), ('GameArtifact',subsumption)]).
nounMapping2SUMO('02811350-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('02811468-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02811618-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02811719-n',[ ('UniformClothing',subsumption)]).
nounMapping2SUMO('02811842-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02811936-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02812201-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02812342-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02812505-n',[ ('Door',subsumption)]).
nounMapping2SUMO('02812631-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02812785-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02812949-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02813089-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02813252-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('02813399-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02813544-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('02813645-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02813752-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02813874-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02813981-n',[ ('Battery',subsumption)]).
nounMapping2SUMO('02814116-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02814224-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02814338-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02814428-n',[ ('Towel',subsumption)]).
nounMapping2SUMO('02814533-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('02814774-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02814860-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02815071-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02815237-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02815389-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02815478-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02815600-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02815749-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02815834-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02815950-n',[ ('BoardOrBlock',subsumption)]).
nounMapping2SUMO('02816381-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02816494-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02816656-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02816768-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02816895-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02817031-n',[ ('Bearing',equivalence)]).
nounMapping2SUMO('02817251-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02817386-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02817516-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('02817650-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02817799-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('02818027-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02818135-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02818254-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02818402-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02818507-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02818687-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02818832-n',[ ('Bed',equivalence)]).
nounMapping2SUMO('02819474-n',[ ('CultivatedLandArea',subsumption)]).
nounMapping2SUMO('02819697-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02819881-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02820085-n',[ ('TravelerAccommodation',subsumption)]).
nounMapping2SUMO('02820210-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02820432-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02820556-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02820675-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02820798-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('02821030-n',[ ('BedLinen',equivalence)]).
nounMapping2SUMO('02821202-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02821328-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02821415-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02821543-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02821627-n',[ ('Bedroom',subsumption)]).
nounMapping2SUMO('02821943-n',[ ('Furniture',subsumption)]).
nounMapping2SUMO('02822064-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02822220-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02822399-n',[ ('WireSpring',subsumption)]).
nounMapping2SUMO('02822579-n',[ ('BedFrame',equivalence)]).
nounMapping2SUMO('02822762-n',[ ('Photograph',subsumption)]).
nounMapping2SUMO('02822865-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02823030-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('02823124-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02823335-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02823428-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02823510-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02823586-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('02823750-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02823848-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02823964-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02824058-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02824152-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02824319-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02824448-n',[ ('Bell',equivalence)]).
nounMapping2SUMO('02824858-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('02825004-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02825153-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02825240-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02825442-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('02825657-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02825775-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02825872-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02825961-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02826068-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02826259-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02826459-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02826589-n',[ ('SwitchDevice',subsumption)]).
nounMapping2SUMO('02826683-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02826812-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02826886-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02827020-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02827148-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02827289-n',[ ('Transitway',subsumption)]).
nounMapping2SUMO('02827466-n',[ ('Prison',instance)]).
nounMapping2SUMO('02827606-n',[ ('Belt',subsumption)]).
nounMapping2SUMO('02827883-n',[ ('Drivebelt',equivalence)]).
nounMapping2SUMO('02828115-n',[ ('Bullet',subsumption)]).
nounMapping2SUMO('02828299-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02828427-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('02828555-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02828648-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('02828884-n',[ ('Seat',subsumption)]).
nounMapping2SUMO('02829116-n',[ ('Seat',subsumption)]).
nounMapping2SUMO('02829246-n',[ ('Clamp',subsumption)]).
nounMapping2SUMO('02829353-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02829510-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02829596-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02829696-n',[ ('Transitway',subsumption)]).
nounMapping2SUMO('02830013-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02830157-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02830294-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('02830430-n',[ ('Wood',subsumption)]).
nounMapping2SUMO('02830596-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02830721-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02830852-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02831237-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02831335-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02831455-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02831595-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02831724-n',[ ('Bed',subsumption)]).
nounMapping2SUMO('02831894-n',[ ('Broom',subsumption)]).
nounMapping2SUMO('02831998-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02832168-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02832652-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('02832838-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02833040-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02833140-n',[ ('RetailStore',subsumption)]).
nounMapping2SUMO('02833275-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02833403-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02833576-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02833793-n',[ ('BevelGear',equivalence)]).
nounMapping2SUMO('02833943-n',[ ('Object',subsumption)]).
nounMapping2SUMO('02834027-n',[ ('Clarinet',subsumption)]).
nounMapping2SUMO('02834147-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02834295-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02834397-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02834506-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02834642-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02834778-n',[ ('Bicycle',equivalence)]).
nounMapping2SUMO('02835271-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02835412-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02835551-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02835724-n',[ ('Pump',subsumption)]).
nounMapping2SUMO('02835829-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02835915-n',[ ('Seat',subsumption)]).
nounMapping2SUMO('02836035-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02836174-n',[ ('Bidet',equivalence)]).
nounMapping2SUMO('02836268-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02836392-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02836513-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02836607-n',[ ('EyeGlass',subsumption)]).
nounMapping2SUMO('02836766-n',[ ('Clock',instance)]).
nounMapping2SUMO('02836900-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02837134-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('02837309-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02837416-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02837567-n',[ ('Object',subsumption)]).
nounMapping2SUMO('02837702-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02837789-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02837887-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02838014-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02838178-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02838345-n',[ ('Pump',subsumption)]).
nounMapping2SUMO('02838448-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02838577-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02838728-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02838958-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02839110-n',[ ('Sign',subsumption)]).
nounMapping2SUMO('02839200-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02839351-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('02839477-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02839592-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02839758-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02839910-n',[ ('Container',subsumption)]).
nounMapping2SUMO('02840134-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02840245-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02840361-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02840515-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02840619-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02840927-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02841063-n',[ ('Container',subsumption)]).
nounMapping2SUMO('02841187-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02841315-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02841506-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02841641-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02841847-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02842008-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02842133-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02842219-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02842303-n',[ ('BiologicalWeapon',subsumption)]).
nounMapping2SUMO('02842573-n',[ ('Airplane',subsumption)]).
nounMapping2SUMO('02842684-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02842809-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02843029-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02843158-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02843276-n',[ ('TrapOrCage',subsumption)]).
nounMapping2SUMO('02843365-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02843465-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02843553-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02843684-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02843777-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02843909-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02844056-n',[ ('GamePiece',subsumption)]).
nounMapping2SUMO('02844214-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02844307-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02844714-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02845002-n',[ ('LinguisticCommunication',subsumption)]).
nounMapping2SUMO('02845130-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02845293-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02845425-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('02845576-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02845763-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02845860-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02845985-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('02846141-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02846260-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02846399-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('02846511-n',[ ('Blackboard',equivalence)]).
nounMapping2SUMO('02846619-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02846733-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02846874-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('02847009-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02847223-n',[ ('Prison',instance)]).
nounMapping2SUMO('02847461-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02847631-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02847728-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02847852-n',[ ('Paint',subsumption)]).
nounMapping2SUMO('02847942-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('02848118-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02848216-n',[ ('Blade',equivalence)]).
nounMapping2SUMO('02848523-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02848806-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02848921-n',[ ('Cartridge',subsumption)]).
nounMapping2SUMO('02849051-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('02849154-n',[ ('Blanket',subsumption)]).
nounMapping2SUMO('02849419-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02849565-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('02849729-n',[ ('CorpuscularObject',instance)]).
nounMapping2SUMO('02849885-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02850060-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02850218-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('02850358-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02850552-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02850732-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02850950-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02851099-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02851384-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02851540-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02851675-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02851795-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('02851939-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02852043-n',[ ('Jewelry',subsumption)]).
nounMapping2SUMO('02852173-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('02852360-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02852523-n',[ ('BoardOrBlock',equivalence)]).
nounMapping2SUMO('02853016-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02853218-n',[ ('MilitaryManeuver',subsumption)]).
nounMapping2SUMO('02853336-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02853449-n',[ ('Object',subsumption)]).
nounMapping2SUMO('02853745-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02853870-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02853991-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('02854156-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02854378-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02854532-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02854630-n',[ ('PoweredVehicle',subsumption), ('LandVehicle',subsumption)]).
nounMapping2SUMO('02854739-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02854926-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02855089-n',[ ('Aerator',subsumption)]).
nounMapping2SUMO('02855253-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02855390-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02855560-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('02855701-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('02855793-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02855925-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02856013-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02856109-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('02856237-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02856362-n',[ ('FileDevice',subsumption)]).
nounMapping2SUMO('02856463-n',[ ('BoardOrBlock',equivalence)]).
nounMapping2SUMO('02857023-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02857365-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02857477-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02857644-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02857812-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02857907-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02858044-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02858179-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02858304-n',[ ('WaterVehicle',equivalence)]).
nounMapping2SUMO('02859084-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02859184-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('02859343-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02859443-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02859557-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02859729-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02859829-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02859955-n',[ ('Factory',subsumption)]).
nounMapping2SUMO('02860063-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02860239-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02860415-n',[ ('Reel',equivalence)]).
nounMapping2SUMO('02860640-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02860847-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02861022-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02861147-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('02861286-n',[ ('RetailStore',subsumption)]).
nounMapping2SUMO('02861387-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02861509-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02861658-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02861777-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02861886-n',[ ('Artifact',equivalence)]).
nounMapping2SUMO('02862048-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02862770-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02862916-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('02863014-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02863176-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02863340-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02863426-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02863536-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02863638-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02863750-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02863995-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02864122-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02864342-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02864504-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02864593-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02864878-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02864987-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02865108-n',[ ('AudioRecording',subsumption)]).
nounMapping2SUMO('02865214-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02865351-n',[ ('TieClothing',subsumption)]).
nounMapping2SUMO('02865509-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02865665-n',[ ('Bolt',equivalence)]).
nounMapping2SUMO('02865931-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02866106-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02866286-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02866386-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02866474-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02866578-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('02867267-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('02867401-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02867592-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02867715-n',[ ('Bomber',subsumption)]).
nounMapping2SUMO('02867966-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02868068-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('02868240-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('02868429-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02868546-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('02868638-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02868870-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02868975-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02869155-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02869249-n',[ ('PercussionInstrument',subsumption)]).
nounMapping2SUMO('02869563-n',[ ('Vehicle',subsumption)]).
nounMapping2SUMO('02869737-n',[ ('Drum',subsumption)]).
nounMapping2SUMO('02869837-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('02869965-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('02870092-n',[ ('Book',subsumption)]).
nounMapping2SUMO('02870526-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02870676-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02870772-n',[ ('Workshop',subsumption)]).
nounMapping2SUMO('02870880-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02871005-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02871147-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02871314-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02871439-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02871525-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('02871631-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02871824-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02871963-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02872172-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('02872333-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02872529-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02872752-n',[ ('Shoe',equivalence)]).
nounMapping2SUMO('02873244-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02873363-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02873520-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02873623-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02873733-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02873839-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02874086-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02874214-n',[ ('Table',subsumption)]).
nounMapping2SUMO('02874336-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02874442-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02874537-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02874642-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02874750-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02874876-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02875013-n',[ ('Object',subsumption)]).
nounMapping2SUMO('02875233-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('02875436-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02875626-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02875815-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02875948-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('02876084-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02876193-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('02876326-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02876457-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02876537-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02876657-n',[ ('Bottle',equivalence)]).
nounMapping2SUMO('02877266-n',[ ('Bottle',equivalence)]).
nounMapping2SUMO('02877513-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02877642-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02877765-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02877865-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('02877962-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02878107-n',[ ('IndustrialPlant',subsumption)]).
nounMapping2SUMO('02878222-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('02878425-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02878534-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02878628-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02878796-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02878883-n',[ ('WaterVehicle',instance)]).
nounMapping2SUMO('02879087-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02879228-n',[ ('Organization',instance)]).
nounMapping2SUMO('02879309-n',[ ('RetailStore',subsumption)]).
nounMapping2SUMO('02879422-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('02879517-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02879718-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02880008-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02880189-n',[ ('Tying',subsumption)]).
nounMapping2SUMO('02880308-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('02880393-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02880546-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('02880842-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02880940-n',[ ('Dish',subsumption)]).
nounMapping2SUMO('02881193-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02881397-n',[ ('Container',subsumption)]).
nounMapping2SUMO('02881546-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('02881757-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('02881906-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('02882014-n',[ ('BowlingLane',equivalence)]).
nounMapping2SUMO('02882190-n',[ ('BowlingFacility',equivalence)]).
nounMapping2SUMO('02882301-n',[ ('BowlingBall',equivalence)]).
nounMapping2SUMO('02882483-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02882647-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02882894-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('02883004-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02883101-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02883205-n',[ ('TieClothing',subsumption)]).
nounMapping2SUMO('02883344-n',[ ('Box',equivalence)]).
nounMapping2SUMO('02884011-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02884225-n',[ ('AuditoriumSeat',subsumption)]).
nounMapping2SUMO('02884450-n',[ ('Seat',subsumption)]).
nounMapping2SUMO('02884607-n',[ ('GameArtifact',subsumption)]).
nounMapping2SUMO('02884859-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02884994-n',[ ('Camera',subsumption)]).
nounMapping2SUMO('02885108-n',[ ('Boxcar',subsumption)]).
nounMapping2SUMO('02885233-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('02885338-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02885462-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02885663-n',[ ('BoxingRing',equivalence)]).
nounMapping2SUMO('02885785-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02885882-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02886035-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('02886183-n',[ ('Seat',subsumption)]).
nounMapping2SUMO('02886321-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02886434-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02886599-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02886907-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02887079-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02887209-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02887489-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02887683-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02887832-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02887970-n',[ ('Jewelry',subsumption)]).
nounMapping2SUMO('02888133-n',[ ('Food',subsumption)]).
nounMapping2SUMO('02888270-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02888429-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02888569-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02888817-n',[ ('Nail',subsumption)]).
nounMapping2SUMO('02888898-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02889035-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02889228-n',[ ('String',subsumption)]).
nounMapping2SUMO('02889332-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02889425-n',[ ('Brake',equivalence)]).
nounMapping2SUMO('02889646-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02889856-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02889996-n',[ ('BrakeMasterCylinder',equivalence)]).
nounMapping2SUMO('02890188-n',[ ('BrakeRotor',equivalence)]).
nounMapping2SUMO('02890351-n',[ ('BrakeDrum',equivalence)]).
nounMapping2SUMO('02890513-n',[ ('WearingFrictionSurface',subsumption)]).
nounMapping2SUMO('02890662-n',[ ('BrakePad',equivalence)]).
nounMapping2SUMO('02890804-n',[ ('BrakePedal',equivalence)]).
nounMapping2SUMO('02890940-n',[ ('BrakeShoe',equivalence)]).
nounMapping2SUMO('02891188-n',[ ('VehicleBrake',equivalence)]).
nounMapping2SUMO('02891430-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02891566-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02891788-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('02892201-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02892304-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02892392-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02892499-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('02892626-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02892767-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02892948-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02893148-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02893269-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02893418-n',[ ('HeatingDevice',subsumption)]).
nounMapping2SUMO('02893608-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02893692-n',[ ('Container',subsumption)]).
nounMapping2SUMO('02893800-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02893941-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02894024-n',[ ('Fragile',equivalence)]).
nounMapping2SUMO('02894158-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02894337-n',[ ('Table',subsumption)]).
nounMapping2SUMO('02894431-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02894605-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02894847-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02895008-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02895154-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02895328-n',[ ('Pocket',subsumption)]).
nounMapping2SUMO('02895438-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02895606-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02895881-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02896074-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02896294-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02896442-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('02896694-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02896856-n',[ ('Gun',subsumption)]).
nounMapping2SUMO('02896949-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02897097-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02897237-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('02897389-n',[ ('Brewpub',equivalence)]).
nounMapping2SUMO('02897572-n',[ ('SmokingPipe',subsumption)]).
nounMapping2SUMO('02897692-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02897820-n',[ ('Brick',subsumption)]).
nounMapping2SUMO('02898093-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02898173-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02898269-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02898369-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02898478-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02898585-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02898711-n',[ ('Bridge',subsumption)]).
nounMapping2SUMO('02899257-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02899439-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02899569-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02899694-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02899808-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02900011-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02900160-n',[ ('AnimalController',subsumption)]).
nounMapping2SUMO('02900459-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02900594-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02900705-n',[ ('TravelContainer',subsumption)]).
nounMapping2SUMO('02900857-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('02900987-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02901114-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02901259-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02901377-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('02901481-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02901620-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('02901793-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('02901901-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02902079-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02902250-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02902411-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02902535-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('02902687-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02902816-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02902916-n',[ ('ArrowProjectile',subsumption)]).
nounMapping2SUMO('02903006-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02903126-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02903204-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02903405-n',[ ('BroadcastingStation',equivalence)]).
nounMapping2SUMO('02903588-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02903727-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02903852-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02903964-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02904109-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02904233-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02904348-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02904505-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02904640-n',[ ('Sword',subsumption)]).
nounMapping2SUMO('02904803-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02904927-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('02905036-n',[ ('CookingOven',subsumption)]).
nounMapping2SUMO('02905152-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02905288-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('02905422-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02905612-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02905886-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02906027-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('02906175-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02906254-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('02906438-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02906578-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('02906734-n',[ ('Broom',equivalence)]).
nounMapping2SUMO('02906963-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02907082-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02907194-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02907296-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02907391-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02907656-n',[ ('M2Browning',equivalence)]).
nounMapping2SUMO('02907873-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02907985-n',[ ('University',instance)]).
nounMapping2SUMO('02908123-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02908217-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02908605-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02908773-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02908951-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02909053-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02909165-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02909285-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02909408-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02909543-n',[ ('Prison',instance)]).
nounMapping2SUMO('02909706-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02909870-n',[ ('Container',subsumption)]).
nounMapping2SUMO('02910145-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02910241-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('02910353-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02910542-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02910701-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02910864-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02910964-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02911158-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02911332-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02911485-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02911890-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02912065-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02912319-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02912440-n',[ ('Microphone',subsumption)]).
nounMapping2SUMO('02912557-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02912673-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02912894-n',[ ('Bugle',subsumption)]).
nounMapping2SUMO('02913035-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02913152-n',[ ('Building',equivalence)]).
nounMapping2SUMO('02914813-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02914991-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02915199-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('02915379-n',[ ('Bed',subsumption)]).
nounMapping2SUMO('02915480-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02915675-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02915807-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('02915904-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02916065-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02916179-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02916350-n',[ ('Bullet',equivalence)]).
nounMapping2SUMO('02916538-n',[ ('Sign',subsumption)]).
nounMapping2SUMO('02916684-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02916936-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02917067-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02917163-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('02917377-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02917521-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('02917607-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02917742-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02917964-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02918112-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02918204-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02918330-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02918455-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02918595-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02918831-n',[ ('Cup',subsumption)]).
nounMapping2SUMO('02918964-n',[ ('PoweredVehicle',subsumption), ('LandVehicle',subsumption)]).
nounMapping2SUMO('02919148-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02919308-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02919414-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('02919648-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02919792-n',[ ('House',subsumption)]).
nounMapping2SUMO('02919890-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02919976-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('02920083-n',[ ('Bed',subsumption)]).
nounMapping2SUMO('02920164-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02920259-n',[ ('BunkBed',subsumption)]).
nounMapping2SUMO('02920369-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02920503-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02920658-n',[ ('Container',subsumption)]).
nounMapping2SUMO('02920785-n',[ ('AntiArmorWeapon',subsumption)]).
nounMapping2SUMO('02921029-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02921195-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02921292-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02921406-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02921592-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02921756-n',[ ('SecurityAlarm',subsumption)]).
nounMapping2SUMO('02921884-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02922159-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02922292-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02922461-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02922578-n',[ ('Cloak',subsumption)]).
nounMapping2SUMO('02922798-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02922877-n',[ ('Bag',subsumption)]).
nounMapping2SUMO('02922996-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('02923129-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02923331-n',[ ('HeatingDevice',subsumption)]).
nounMapping2SUMO('02923535-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02923682-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02923802-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('02923915-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02924023-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('02924116-n',[ ('PassengerVehicle',subsumption)]).
nounMapping2SUMO('02924554-n',[ ('RoadVehicle',subsumption)]).
nounMapping2SUMO('02924713-n',[ ('Conductor',subsumption)]).
nounMapping2SUMO('02925009-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02925107-n',[ ('Object',subsumption)]).
nounMapping2SUMO('02925250-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('02925385-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02925519-n',[ ('ClothingSuit',subsumption)]).
nounMapping2SUMO('02925666-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02925808-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('02925901-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('02926044-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02926188-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02926288-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02926426-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02926591-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02926727-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02926886-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02927053-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02927161-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('02927296-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02927399-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('02927608-n',[ ('FluidContainer',subsumption)]).
nounMapping2SUMO('02927764-n',[ ('Dish',subsumption)]).
nounMapping2SUMO('02927887-n',[ ('Valve',subsumption)]).
nounMapping2SUMO('02928049-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02928172-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('02928299-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02928413-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02928608-n',[ ('Button',subsumption)]).
nounMapping2SUMO('02928841-n',[ ('Button',subsumption)]).
nounMapping2SUMO('02928930-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('02929059-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('02929184-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02929289-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02929462-n',[ ('ArrowProjectile',subsumption)]).
nounMapping2SUMO('02929582-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('02929749-n',[ ('Stimulant',subsumption)]).
nounMapping2SUMO('02929923-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02930080-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02930214-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02930339-n',[ ('CapacitorElement',subsumption)]).
nounMapping2SUMO('02930492-n',[ ('Product',subsumption)]).
nounMapping2SUMO('02930645-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('02930766-n',[ ('Taxicab',subsumption)]).
nounMapping2SUMO('02931013-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02931148-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02931294-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02931417-n',[ ('NightClub',subsumption)]).
nounMapping2SUMO('02931836-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02932019-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02932227-n',[ ('Bedroom',subsumption)]).
nounMapping2SUMO('02932400-n',[ ('House',subsumption)]).
nounMapping2SUMO('02932523-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('02932693-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02932891-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02933112-n',[ ('ChestOrCabinet',subsumption)]).
nounMapping2SUMO('02933340-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02933462-n',[ ('SafeContainer',subsumption)]).
nounMapping2SUMO('02933649-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02933750-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02933842-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02933990-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02934168-n',[ ('Cable',equivalence)]).
nounMapping2SUMO('02934451-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02934641-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02934888-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02935017-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02935316-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('02935387-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02935490-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02935658-n',[ ('Coffeeshop',equivalence)]).
nounMapping2SUMO('02935891-n',[ ('Cafeteria',equivalence)]).
nounMapping2SUMO('02936020-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02936176-n',[ ('Tray',subsumption)]).
nounMapping2SUMO('02936281-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('02936402-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02936570-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02936714-n',[ ('TrapOrCage',subsumption)]).
nounMapping2SUMO('02936921-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02937010-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02937093-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02937237-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02937336-n',[ ('MilitaryVehicle',subsumption)]).
nounMapping2SUMO('02937469-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02937614-n',[ ('SmokingPipe',subsumption)]).
nounMapping2SUMO('02937766-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('02937958-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02938095-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02938218-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('02938321-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('02938514-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02938886-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02939185-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02939291-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('02939565-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02939763-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02939866-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02940143-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02940289-n',[ ('Sign',subsumption)]).
nounMapping2SUMO('02940385-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('02940570-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02940706-n',[ ('MusicalInstrument',subsumption)]).
nounMapping2SUMO('02940878-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('02941095-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02941228-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('02941408-n',[ ('SmokingPipe',subsumption)]).
nounMapping2SUMO('02941605-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02941716-n',[ ('Cam',equivalence)]).
nounMapping2SUMO('02941845-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02942015-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02942147-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02942227-n',[ ('University',instance)]).
nounMapping2SUMO('02942349-n',[ ('Camera',subsumption)]).
nounMapping2SUMO('02942460-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02942577-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02942699-n',[ ('Camera',equivalence)]).
nounMapping2SUMO('02943241-n',[ ('Lens',subsumption)]).
nounMapping2SUMO('02943465-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02943686-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02943871-n',[ ('Tripod',subsumption)]).
nounMapping2SUMO('02943964-n',[ ('Shirt',subsumption)]).
nounMapping2SUMO('02944075-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02944146-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02944256-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02944375-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02944459-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('02944579-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02944826-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02945161-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02945379-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('02945594-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('02945813-n',[ ('Camp',subsumption)]).
nounMapping2SUMO('02945964-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('02946127-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02946270-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02946348-n',[ ('Vehicle',subsumption)]).
nounMapping2SUMO('02946509-n',[ ('Trailer',subsumption)]).
nounMapping2SUMO('02946633-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('02946753-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('02946824-n',[ ('Camshaft',equivalence)]).
nounMapping2SUMO('02946921-n',[ ('Container',subsumption)]).
nounMapping2SUMO('02947212-n',[ ('Canal',equivalence)]).
nounMapping2SUMO('02947660-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('02947818-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02947977-n',[ ('Camera',subsumption)]).
nounMapping2SUMO('02948072-n',[ ('Candle',equivalence)]).
nounMapping2SUMO('02948293-n',[ ('GamePiece',subsumption)]).
nounMapping2SUMO('02948403-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02948557-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02948719-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02948834-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02948942-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('02949084-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02949202-n',[ ('WalkingCane',equivalence)]).
nounMapping2SUMO('02949356-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02949542-n',[ ('Container',subsumption)]).
nounMapping2SUMO('02949691-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('02950018-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('02950120-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02950186-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02950256-n',[ ('ArtilleryCannon',equivalence)]).
nounMapping2SUMO('02950482-n',[ ('ArtilleryCannon',subsumption)]).
nounMapping2SUMO('02950632-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02950826-n',[ ('ArtilleryCannon',subsumption)]).
nounMapping2SUMO('02950943-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02951090-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02951170-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('02951358-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02951585-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02951703-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02951843-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02952109-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02952237-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02952374-n',[ ('Bottle',equivalence)]).
nounMapping2SUMO('02952485-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02952585-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02952674-n',[ ('Restaurant',subsumption)]).
nounMapping2SUMO('02952798-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('02952935-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02953056-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02953197-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02953455-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02953552-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02953673-n',[ ('CottonFabric',subsumption)]).
nounMapping2SUMO('02953850-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02954068-n',[ ('OilPicture',subsumption)]).
nounMapping2SUMO('02954163-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02954340-n',[ ('Hat',equivalence)]).
nounMapping2SUMO('02954938-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02955065-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02955247-n',[ ('CapacitorElement',equivalence)]).
nounMapping2SUMO('02955540-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02955767-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02955944-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02956069-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('02956247-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02956393-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02956500-n',[ ('GovernmentBuilding',instance)]).
nounMapping2SUMO('02956699-n',[ ('GovernmentBuilding',subsumption)]).
nounMapping2SUMO('02956795-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02956883-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02957008-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02957135-n',[ ('Screw',subsumption)]).
nounMapping2SUMO('02957252-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02957427-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02957586-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02957755-n',[ ('Container',subsumption)]).
nounMapping2SUMO('02957862-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('02958002-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02958264-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02958343-n',[ ('Automobile',equivalence)]).
nounMapping2SUMO('02959942-n',[ ('RailVehicle',equivalence)]).
nounMapping2SUMO('02960352-n',[ ('Elevator',subsumption)]).
nounMapping2SUMO('02960501-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02960690-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02960903-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02961035-n',[ ('TravelerAccommodation',subsumption)]).
nounMapping2SUMO('02961225-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02961451-n',[ ('Rifle',subsumption)]).
nounMapping2SUMO('02961544-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('02961714-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02961851-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02961947-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02962061-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02962200-n',[ ('Carburetor',equivalence)]).
nounMapping2SUMO('02962414-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02962545-n',[ ('PlayingCard',subsumption)]).
nounMapping2SUMO('02962843-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02962938-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02963159-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02963302-n',[ ('Text',subsumption)]).
nounMapping2SUMO('02963503-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02963692-n',[ ('Microphone',subsumption)]).
nounMapping2SUMO('02963821-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02963987-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02964075-n',[ ('Table',subsumption)]).
nounMapping2SUMO('02964196-n',[ ('Table',subsumption)]).
nounMapping2SUMO('02964295-n',[ ('FerryBoat',subsumption)]).
nounMapping2SUMO('02964389-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02964634-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02964843-n',[ ('Container',subsumption)]).
nounMapping2SUMO('02964934-n',[ ('Door',subsumption)]).
nounMapping2SUMO('02965024-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02965122-n',[ ('Helicopter',subsumption)]).
nounMapping2SUMO('02965216-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02965300-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02965529-n',[ ('MusicalInstrument',subsumption)]).
nounMapping2SUMO('02965617-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02965783-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02965936-n',[ ('University',instance)]).
nounMapping2SUMO('02966068-n',[ ('UnpoweredVehicle',subsumption)]).
nounMapping2SUMO('02966193-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02966372-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02966545-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02966687-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('02966786-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02966942-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02967081-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02967170-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02967294-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02967407-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02967540-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02967626-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02967782-n',[ ('CleaningDevice',subsumption)]).
nounMapping2SUMO('02967991-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02968074-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02968210-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('02968333-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02968473-n',[ ('UnpoweredVehicle',subsumption)]).
nounMapping2SUMO('02969010-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02969163-n',[ ('Bolt',subsumption)]).
nounMapping2SUMO('02969323-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02969527-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02969634-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('02969754-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02969886-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02970100-n',[ ('Truck',subsumption)]).
nounMapping2SUMO('02970311-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02970408-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02970534-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02970685-n',[ ('Chair',subsumption), ('VehicleSafetyDevice',subsumption)]).
nounMapping2SUMO('02970849-n',[ ('Wagon',subsumption)]).
nounMapping2SUMO('02971167-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02971356-n',[ ('Box',subsumption)]).
nounMapping2SUMO('02971473-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02971579-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02971691-n',[ ('Cartridge',equivalence)]).
nounMapping2SUMO('02971940-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02972182-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02972397-n',[ ('Belt',subsumption)]).
nounMapping2SUMO('02972533-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02972714-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02972934-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02973017-n',[ ('Container',subsumption)]).
nounMapping2SUMO('02973236-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02973395-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02973558-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02973805-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('02973904-n',[ ('Knife',subsumption)]).
nounMapping2SUMO('02974003-n',[ ('Wheel',subsumption)]).
nounMapping2SUMO('02974219-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02974348-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02974454-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02974565-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02974697-n',[ ('Container',equivalence)]).
nounMapping2SUMO('02975212-n',[ ('Container',subsumption)]).
nounMapping2SUMO('02975412-n',[ ('BedLinen',subsumption)]).
nounMapping2SUMO('02975589-n',[ ('Container',equivalence)]).
nounMapping2SUMO('02975994-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('02976123-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02976249-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02976350-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02976455-n',[ ('Window',subsumption)]).
nounMapping2SUMO('02976552-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02976641-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02976815-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('02976939-n',[ ('SafeContainer',subsumption)]).
nounMapping2SUMO('02977058-n',[ ('ATMMachine',equivalence)]).
nounMapping2SUMO('02977330-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02977438-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02977619-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02977822-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02977936-n',[ ('Casino',equivalence)]).
nounMapping2SUMO('02978055-n',[ ('Box',subsumption)]).
nounMapping2SUMO('02978205-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02978367-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02978478-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02978753-n',[ ('Dish',subsumption)]).
nounMapping2SUMO('02978881-n',[ ('TapeCassette',equivalence)]).
nounMapping2SUMO('02979074-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02979186-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02979290-n',[ ('TapeRecorder',equivalence)]).
nounMapping2SUMO('02979399-n',[ ('TapeCassette',equivalence)]).
nounMapping2SUMO('02979516-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02979662-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02979836-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02980036-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02980203-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02980325-n',[ ('Soap',subsumption)]).
nounMapping2SUMO('02980441-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02980625-n',[ ('GamePiece',subsumption)]).
nounMapping2SUMO('02980841-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('02981024-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02981198-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02981321-n',[ ('CatalyticConverter',equivalence)]).
nounMapping2SUMO('02981565-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02981792-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02981911-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('02982232-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02982416-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02982515-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02982599-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02982790-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02983072-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02983189-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('02983357-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02983507-n',[ ('LandVehicle',subsumption)]).
nounMapping2SUMO('02983741-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02983904-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02984061-n',[ ('ReligiousBuilding',subsumption)]).
nounMapping2SUMO('02984203-n',[ ('Building',subsumption)]).
nounMapping2SUMO('02984328-n',[ ('ExplosiveDevice',subsumption)]).
nounMapping2SUMO('02984469-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('02984699-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02984937-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02985137-n',[ ('ComputerTerminal',subsumption)]).
nounMapping2SUMO('02985506-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02985606-n',[ ('Whip',subsumption)]).
nounMapping2SUMO('02985758-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02985828-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02985963-n',[ ('Bottle',subsumption)]).
nounMapping2SUMO('02986066-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('02986160-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02986348-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('02986480-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02986605-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02986757-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02986920-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('02987047-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02987379-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('02987492-n',[ ('Sword',subsumption)]).
nounMapping2SUMO('02987706-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02987823-n',[ ('Wall',subsumption)]).
nounMapping2SUMO('02987950-n',[ ('Battery',subsumption)]).
nounMapping2SUMO('02988066-n',[ ('Clamp',subsumption)]).
nounMapping2SUMO('02988156-n',[ ('AudioCDSystem',equivalence)]).
nounMapping2SUMO('02988304-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02988486-n',[ ('CompactDisc',subsumption)]).
nounMapping2SUMO('02988679-n',[ ('CDROM',equivalence)]).
nounMapping2SUMO('02988963-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('02989099-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02989178-n',[ ('Antibiotic',subsumption)]).
nounMapping2SUMO('02989313-n',[ ('Antibiotic',subsumption)]).
nounMapping2SUMO('02989475-n',[ ('Antibiotic',subsumption)]).
nounMapping2SUMO('02989685-n',[ ('Antibiotic',subsumption)]).
nounMapping2SUMO('02989893-n',[ ('Antibiotic',subsumption)]).
nounMapping2SUMO('02990103-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('02990373-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02990561-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('02990758-n',[ ('MusicalInstrument',subsumption)]).
nounMapping2SUMO('02990920-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('02991048-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('02991302-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02991555-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02991711-n',[ ('Object',subsumption)]).
nounMapping2SUMO('02991847-n',[ ('Room',subsumption)]).
nounMapping2SUMO('02991950-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02992032-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02992211-n',[ ('Cello',equivalence)]).
nounMapping2SUMO('02992368-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('02992529-n',[ ('MobileCellPhone',equivalence)]).
nounMapping2SUMO('02992795-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02993081-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('02993194-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02993368-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02993546-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('02993877-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02994012-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02994219-n',[ ('Region',subsumption)]).
nounMapping2SUMO('02994419-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02994573-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02994743-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('02994858-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02995151-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('02995345-n',[ ('CPU',subsumption)]).
nounMapping2SUMO('02995770-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('02995871-n',[ ('Pump',subsumption)]).
nounMapping2SUMO('02995998-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02996249-n',[ ('Keflex',equivalence)]).
nounMapping2SUMO('02996570-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02996703-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02996840-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02997292-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02997391-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02997607-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02997773-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('02997910-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02998003-n',[ ('Box',subsumption)]).
nounMapping2SUMO('02998107-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('02998209-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('02998363-n',[ ('ContraceptiveDevice',subsumption)]).
nounMapping2SUMO('02998563-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02998696-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02998841-n',[ ('Veil',subsumption), ('Cloak',subsumption)]).
nounMapping2SUMO('02999001-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02999138-n',[ ('Device',subsumption)]).
nounMapping2SUMO('02999272-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02999410-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('02999757-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('02999936-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03000021-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03000134-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03000247-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03000530-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03000684-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03000808-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03000966-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03001115-n',[ ('RetailStore',subsumption)]).
nounMapping2SUMO('03001282-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03001540-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03001627-n',[ ('Chair',equivalence)]).
nounMapping2SUMO('03002096-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03002210-n',[ ('GovernmentPerson',subsumption)]).
nounMapping2SUMO('03002341-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03002555-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03002711-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('03002816-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03002948-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03003091-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03003378-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03003548-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03003633-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03003730-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03004146-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03004275-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03004409-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03004531-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03004620-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03004713-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03004824-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03005033-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03005147-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03005285-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('03005425-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03005515-n',[ ('Candle',subsumption)]).
nounMapping2SUMO('03005619-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03005769-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03005920-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03006105-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03006398-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03006626-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03006788-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03006903-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03007130-n',[ ('ReligiousBuilding',subsumption)]).
nounMapping2SUMO('03007297-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03007444-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03007591-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03007824-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03007955-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03008080-n',[ ('Stove',subsumption)]).
nounMapping2SUMO('03008177-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03008275-n',[ ('ExplosiveDevice',subsumption)]).
nounMapping2SUMO('03008565-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03008817-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03008976-n',[ ('Charger',equivalence)]).
nounMapping2SUMO('03009111-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03009269-n',[ ('MilitaryVehicle',subsumption), ('LandVehicle',subsumption)]).
nounMapping2SUMO('03009477-n',[ ('ShipBerth',instance)]).
nounMapping2SUMO('03009633-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03009794-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03009920-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('03010057-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03010138-n',[ ('ReligiousBuilding',instance)]).
nounMapping2SUMO('03010283-n',[ ('Pursuing',equivalence)]).
nounMapping2SUMO('03010473-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03010656-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03010795-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03010915-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03011018-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03011162-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03011355-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03011521-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03011741-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03011892-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03012013-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03012159-n',[ ('Tray',subsumption)]).
nounMapping2SUMO('03012263-n',[ ('Photograph',subsumption)]).
nounMapping2SUMO('03012373-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03012499-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03012644-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03012734-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('03012897-n',[ ('IndustrialPlant',subsumption)]).
nounMapping2SUMO('03013006-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03013162-n',[ ('ChemicalWeapon',equivalence)]).
nounMapping2SUMO('03013438-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03013580-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03013718-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03013850-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03013992-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03014119-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03014204-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03014317-n',[ ('GameBoard',subsumption)]).
nounMapping2SUMO('03014440-n',[ ('GamePiece',subsumption)]).
nounMapping2SUMO('03014705-n',[ ('Box',subsumption)]).
nounMapping2SUMO('03015052-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03015149-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03015254-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03015478-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03015631-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03015851-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03015975-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03016056-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03016209-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03016389-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03016511-n',[ ('Farm',subsumption)]).
nounMapping2SUMO('03016609-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03016737-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03016868-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03016953-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03017070-n',[ ('ChildrenSuite',subsumption)]).
nounMapping2SUMO('03017168-n',[ ('PercussionInstrument',subsumption)]).
nounMapping2SUMO('03017428-n',[ ('Chimney',equivalence)]).
nounMapping2SUMO('03017698-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03017835-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03017931-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03018058-n',[ ('Chimney',subsumption)]).
nounMapping2SUMO('03018209-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('03018349-n',[ ('ChestOrCabinet',subsumption)]).
nounMapping2SUMO('03018493-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03018614-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03018712-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('03018848-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03018971-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03019198-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03019304-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03019434-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('03019535-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03019685-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03019806-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03019938-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03020034-n',[ ('ComputerHardware',subsumption)]).
nounMapping2SUMO('03020416-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03020563-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03020692-n',[ ('CuttingDevice',subsumption)]).
nounMapping2SUMO('03020927-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03021121-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03021228-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03021360-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03021531-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03021696-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03021858-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03022041-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03022250-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03022406-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03022634-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03022788-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03022978-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03023175-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03023415-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03023623-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03023878-n',[ ('WheelChock',equivalence)]).
nounMapping2SUMO('03024064-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03024233-n',[ ('LoftStyle',subsumption)]).
nounMapping2SUMO('03024333-n',[ ('EngineChoke',equivalence)]).
nounMapping2SUMO('03024518-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03024746-n',[ ('Collar',subsumption)]).
nounMapping2SUMO('03024882-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03025070-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03025165-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03025250-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('03025357-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03025513-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03025641-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03025755-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03025886-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('03026093-n',[ ('Map',subsumption)]).
nounMapping2SUMO('03026350-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03026506-n',[ ('Sock',subsumption)]).
nounMapping2SUMO('03026626-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('03026741-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('03026907-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03027001-n',[ ('Clock',subsumption)]).
nounMapping2SUMO('03027108-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03027250-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03027505-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03027625-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('03027797-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('03027935-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03028079-n',[ ('ReligiousBuilding',subsumption)]).
nounMapping2SUMO('03028596-n',[ ('Bell',subsumption)]).
nounMapping2SUMO('03028785-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03028907-n',[ ('GameArtifact',subsumption)]).
nounMapping2SUMO('03029066-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03029197-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03029296-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('03029445-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03029603-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03029812-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03029925-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03030035-n',[ ('CigarOrCigarette',subsumption)]).
nounMapping2SUMO('03030262-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03030353-n',[ ('Box',subsumption)]).
nounMapping2SUMO('03030433-n',[ ('CigarOrCigarette',subsumption)]).
nounMapping2SUMO('03030557-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03030663-n',[ ('CigarOrCigarette',subsumption)]).
nounMapping2SUMO('03030880-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03031012-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03031152-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('03031306-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03031422-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03031553-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03031756-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03031957-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03032158-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03032252-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03032453-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03032576-n',[ ('Ciprofloxacin',equivalence)]).
nounMapping2SUMO('03032811-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03033019-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03033267-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03033362-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03033986-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03034244-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03034405-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03034516-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03034663-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03034860-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03035089-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03035252-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03035510-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03035715-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03035832-n',[ ('Guitar',subsumption)]).
nounMapping2SUMO('03036022-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03036149-n',[ ('PaintedPicture',subsumption)]).
nounMapping2SUMO('03036244-n',[ ('University',subsumption)]).
nounMapping2SUMO('03036341-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03036469-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03036701-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03036866-n',[ ('Clamp',subsumption)]).
nounMapping2SUMO('03037108-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03037228-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03037404-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03037590-n',[ ('UnpoweredVehicle',subsumption)]).
nounMapping2SUMO('03037709-n',[ ('Clarinet',equivalence)]).
nounMapping2SUMO('03037899-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03038041-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03038190-n',[ ('CigarOrCigarette',subsumption)]).
nounMapping2SUMO('03038281-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03038480-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03038595-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03038685-n',[ ('Classroom',subsumption)]).
nounMapping2SUMO('03038870-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('03039015-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('03039156-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03039259-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03039353-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03039493-n',[ ('Knife',subsumption)]).
nounMapping2SUMO('03039618-n',[ ('SmokingPipe',subsumption)]).
nounMapping2SUMO('03039711-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03039827-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03039947-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03040229-n',[ ('CleaningDevice',subsumption)]).
nounMapping2SUMO('03040376-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03040587-n',[ ('Detergent',subsumption)]).
nounMapping2SUMO('03040836-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('03040983-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03041114-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03041265-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03041449-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('03041632-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03041810-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03041964-n',[ ('Collar',subsumption)]).
nounMapping2SUMO('03042139-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03042384-n',[ ('String',subsumption)]).
nounMapping2SUMO('03042490-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03042697-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03042829-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03042984-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03043173-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03043274-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03043423-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03043693-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03043798-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03043958-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03044166-n',[ ('Jewelry',subsumption)]).
nounMapping2SUMO('03044278-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03044418-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03044537-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03044671-n',[ ('JumperCable',subsumption)]).
nounMapping2SUMO('03044801-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03044934-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03045074-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03045228-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('03045337-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03045698-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03045800-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03045928-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03046029-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03046133-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03046257-n',[ ('Clock',equivalence)]).
nounMapping2SUMO('03046657-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03046802-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03046921-n',[ ('RadioReceiver',subsumption), ('Clock',subsumption)]).
nounMapping2SUMO('03047052-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03047171-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03047353-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03047553-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03047690-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03047799-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03047941-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03048094-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03048322-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03048412-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03048598-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03048883-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03049066-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03049326-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03049457-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03049605-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03049695-n',[ ('Photograph',subsumption)]).
nounMapping2SUMO('03049782-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03049924-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03050026-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03050453-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03050546-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03050655-n',[ ('ClothesDryer',equivalence)]).
nounMapping2SUMO('03050864-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03051041-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03051152-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03051249-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03051396-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03051540-n',[ ('Clothing',equivalence)]).
nounMapping2SUMO('03052464-n',[ ('RetailStore',subsumption)]).
nounMapping2SUMO('03052628-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03052917-n',[ ('Nail',subsumption)]).
nounMapping2SUMO('03053047-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03053163-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03053272-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03053474-n',[ ('WalkingCane',subsumption)]).
nounMapping2SUMO('03053788-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03053976-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('03054098-n',[ ('IllicitDrug',subsumption)]).
nounMapping2SUMO('03054311-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03054491-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03054605-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('03054901-n',[ ('Clutch',equivalence)]).
nounMapping2SUMO('03055159-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03055418-n',[ ('Bag',subsumption)]).
nounMapping2SUMO('03055537-n',[ ('Building',instance)]).
nounMapping2SUMO('03055670-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03055857-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03056010-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03056097-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('03056215-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03056288-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03056368-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03056493-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03056583-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03056701-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03056873-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03057021-n',[ ('Coat',equivalence)]).
nounMapping2SUMO('03057541-n',[ ('Button',subsumption)]).
nounMapping2SUMO('03057636-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03057724-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03057841-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('03057920-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03058107-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03058603-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03058726-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03058949-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03059103-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03059236-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03059366-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03059528-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03059685-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('03059806-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('03059934-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('03060074-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('03060294-n',[ ('Cocaine',equivalence)]).
nounMapping2SUMO('03060599-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03060728-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03061050-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('03061211-n',[ ('RecreationOrExerciseDevice',subsumption)]).
nounMapping2SUMO('03061345-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03061428-n',[ ('LoftStyle',subsumption)]).
nounMapping2SUMO('03061505-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03061674-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03061819-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03061893-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03062015-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03062122-n',[ ('Tavern',subsumption)]).
nounMapping2SUMO('03062245-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03062336-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('03062461-n',[ ('Opium',subsumption)]).
nounMapping2SUMO('03062651-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03062798-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03062985-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03063073-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03063199-n',[ ('Filter',subsumption)]).
nounMapping2SUMO('03063338-n',[ ('ElectricCoffeeMaker',equivalence)]).
nounMapping2SUMO('03063485-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03063599-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03063689-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03063834-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03063968-n',[ ('Table',subsumption)]).
nounMapping2SUMO('03064118-n',[ ('Book',subsumption)]).
nounMapping2SUMO('03064250-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03064350-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03064443-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03064562-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03064758-n',[ ('Coffin',subsumption)]).
nounMapping2SUMO('03064935-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03065063-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03065243-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03065424-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('03065708-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03066029-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('03066130-n',[ ('ContraceptiveDevice',subsumption)]).
nounMapping2SUMO('03066232-n',[ ('IgnitionCoil',equivalence)]).
nounMapping2SUMO('03066359-n',[ ('WireSpring',equivalence)]).
nounMapping2SUMO('03066464-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03066606-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03066743-n',[ ('Cocaine',equivalence)]).
nounMapping2SUMO('03066849-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03066965-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03067093-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03067212-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03067339-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03067518-n',[ ('Box',subsumption)]).
nounMapping2SUMO('03067690-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03067810-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03067912-n',[ ('Collage',subsumption)]).
nounMapping2SUMO('03068181-n',[ ('Collar',subsumption)]).
nounMapping2SUMO('03068486-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03068707-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03068862-n',[ ('Collar',subsumption)]).
nounMapping2SUMO('03068998-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03069213-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03069381-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03069567-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03069752-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('03069919-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03070059-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03070193-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03070396-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03070587-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03070854-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03071021-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03071160-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03071288-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03071431-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03071552-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03071782-n',[ ('Book',subsumption)]).
nounMapping2SUMO('03071923-n',[ ('NationalFlag',subsumption)]).
nounMapping2SUMO('03072056-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03072201-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03072440-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03072682-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03072828-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03073016-n',[ ('Sculpture',instance)]).
nounMapping2SUMO('03073296-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03073384-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03073545-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03073694-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03073832-n',[ ('University',instance)]).
nounMapping2SUMO('03073977-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03074380-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03074574-n',[ ('Filter',equivalence)]).
nounMapping2SUMO('03074855-n',[ ('BrushOrComb',subsumption)]).
nounMapping2SUMO('03075097-n',[ ('BrushOrComb',subsumption)]).
nounMapping2SUMO('03075248-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03075370-n',[ ('Lock',subsumption)]).
nounMapping2SUMO('03075500-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03075634-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03075768-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03075946-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03076104-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03076298-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03076411-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03076623-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03076708-n',[ ('Product',equivalence)]).
nounMapping2SUMO('03077074-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03077304-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03077442-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03077616-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03077741-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03077958-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03078287-n',[ ('CommunicationSystem',equivalence)]).
nounMapping2SUMO('03078506-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03078670-n',[ ('SwitchDevice',subsumption)]).
nounMapping2SUMO('03078802-n',[ ('Train',subsumption)]).
nounMapping2SUMO('03078995-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03079136-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('03079230-n',[ ('CompactDisc',equivalence)]).
nounMapping2SUMO('03079494-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03079616-n',[ ('Ladder',subsumption)]).
nounMapping2SUMO('03079741-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03080309-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03080497-n',[ ('Compass',equivalence)]).
nounMapping2SUMO('03080633-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03080731-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03080904-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03081021-n',[ ('EngineeringComponent',equivalence)]).
nounMapping2SUMO('03081660-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03081859-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03081986-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03082127-n',[ ('Lever',subsumption)]).
nounMapping2SUMO('03082280-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03082450-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03082656-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03082807-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03082979-n',[ ('Computer',equivalence)]).
nounMapping2SUMO('03084204-n',[ ('ComputerHardware',subsumption)]).
nounMapping2SUMO('03084420-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03084647-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03084834-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03085013-n',[ ('ComputerInputDevice',subsumption)]).
nounMapping2SUMO('03085219-n',[ ('ComputerTerminal',subsumption)]).
nounMapping2SUMO('03085333-n',[ ('ComputerNetwork',subsumption)]).
nounMapping2SUMO('03085602-n',[ ('ComputerTerminal',subsumption)]).
nounMapping2SUMO('03085781-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03085915-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03086183-n',[ ('Prison',subsumption)]).
nounMapping2SUMO('03086457-n',[ ('Piano',subsumption)]).
nounMapping2SUMO('03086580-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03086670-n',[ ('MusicalInstrument',subsumption)]).
nounMapping2SUMO('03086868-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03086963-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03087069-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03087245-n',[ ('Pump',subsumption)]).
nounMapping2SUMO('03087366-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03087521-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03087643-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03087816-n',[ ('Microphone',subsumption)]).
nounMapping2SUMO('03088020-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03088164-n',[ ('ContraceptiveDevice',subsumption)]).
nounMapping2SUMO('03088389-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03088580-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03088707-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03089014-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('03089348-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03089477-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03089624-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03089753-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03089879-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03090000-n',[ ('Table',subsumption)]).
nounMapping2SUMO('03090172-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03090278-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03090437-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03090598-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03090710-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('03090856-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03091044-n',[ ('EngineConnectingRod',equivalence)]).
nounMapping2SUMO('03091223-n',[ ('AdjoiningRoom',equivalence)]).
nounMapping2SUMO('03091374-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03091907-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03092053-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03092166-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03092314-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('03092476-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03092656-n',[ ('ComputerTerminal',subsumption)]).
nounMapping2SUMO('03092883-n',[ ('Table',subsumption)]).
nounMapping2SUMO('03093018-n',[ ('MilitaryShip',instance)]).
nounMapping2SUMO('03093427-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03093574-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03093792-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03094159-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03094347-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03094503-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03095699-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03095965-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03096142-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03096273-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03096439-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03096593-n',[ ('ContraceptiveDevice',equivalence)]).
nounMapping2SUMO('03096960-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03097362-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03097535-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03097673-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03097890-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03098140-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03098515-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03098688-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03098806-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03098959-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03099147-n',[ ('RoomHeater',subsumption)]).
nounMapping2SUMO('03099274-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03099454-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('03099622-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03099771-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03099945-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03100240-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('03100346-n',[ ('Sofa',subsumption), ('SofaBed',equivalence)]).
nounMapping2SUMO('03100490-n',[ ('TransportationDevice',equivalence)]).
nounMapping2SUMO('03100897-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03101156-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03101302-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03101375-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03101517-n',[ ('CuttingDevice',subsumption)]).
nounMapping2SUMO('03101664-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03101796-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03101986-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03102371-n',[ ('Stove',equivalence)]).
nounMapping2SUMO('03102516-n',[ ('CoolingDevice',subsumption)]).
nounMapping2SUMO('03102654-n',[ ('Refrigerator',subsumption)]).
nounMapping2SUMO('03102771-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03102859-n',[ ('CoolingDevice',equivalence)]).
nounMapping2SUMO('03103128-n',[ ('EngineCoolingSystem',equivalence)]).
nounMapping2SUMO('03103396-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03103563-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03103682-n',[ ('University',instance)]).
nounMapping2SUMO('03103904-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03104019-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03104147-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03104247-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03104413-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03104512-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03104594-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03105088-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03105214-n',[ ('Dish',subsumption)]).
nounMapping2SUMO('03105306-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03105467-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03105645-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03105810-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03105974-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03106110-n',[ ('String',subsumption)]).
nounMapping2SUMO('03106722-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03106898-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03107046-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03107152-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03107383-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03107488-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('03107609-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('03107716-n',[ ('Magnet',subsumption)]).
nounMapping2SUMO('03107904-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03108069-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03108455-n',[ ('Drill',subsumption)]).
nounMapping2SUMO('03108624-n',[ ('Drill',subsumption)]).
nounMapping2SUMO('03108759-n',[ ('Drill',subsumption)]).
nounMapping2SUMO('03108853-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03109033-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03109150-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03109253-n',[ ('Bed',subsumption)]).
nounMapping2SUMO('03109350-n',[ ('University',instance)]).
nounMapping2SUMO('03109486-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03109693-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03109881-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03110100-n',[ ('GameArtifact',subsumption)]).
nounMapping2SUMO('03110202-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03110332-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03110470-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03110669-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03110937-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03111041-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03111177-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03111296-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03111483-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03111564-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03111690-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03111899-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03112099-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03112240-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03112431-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03112605-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03112719-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03112869-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03113035-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03113152-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03113337-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03113505-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03113657-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03113835-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03114041-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03114236-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03114379-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03114504-n',[ ('Bed',subsumption)]).
nounMapping2SUMO('03114634-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03114743-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03114839-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03115014-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03115180-n',[ ('CottonFiber',subsumption)]).
nounMapping2SUMO('03115301-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03115400-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03115525-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03115663-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03115762-n',[ ('Sofa',subsumption)]).
nounMapping2SUMO('03115897-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03116008-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03116163-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03116333-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03116435-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03116530-n',[ ('Table',subsumption)]).
nounMapping2SUMO('03116767-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03116942-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03117199-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03117420-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03117642-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03117776-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03117939-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03118051-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03118245-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03118346-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03118539-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03118846-n',[ ('OfficeBuilding',subsumption)]).
nounMapping2SUMO('03118969-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03119203-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03119396-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('03119510-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03119790-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03120029-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03120198-n',[ ('Courtyard',equivalence)]).
nounMapping2SUMO('03120491-n',[ ('SportsGround',equivalence)]).
nounMapping2SUMO('03120778-n',[ ('CourtRoom',subsumption)]).
nounMapping2SUMO('03121040-n',[ ('ExecutiveResidence',equivalence)]).
nounMapping2SUMO('03121190-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03121298-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03121431-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03121556-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03121698-n',[ ('CoverRecording',equivalence)]).
nounMapping2SUMO('03121897-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03122073-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03122202-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03122295-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03122573-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('03122748-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03123553-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03123666-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03123809-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03123917-n',[ ('Bell',subsumption)]).
nounMapping2SUMO('03124043-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03124170-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('03124313-n',[ ('Whip',subsumption)]).
nounMapping2SUMO('03124474-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03124590-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03124700-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03125057-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03125184-n',[ ('Cocaine',subsumption)]).
nounMapping2SUMO('03125352-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03125588-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03125729-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03125870-n',[ ('Vehicle',subsumption)]).
nounMapping2SUMO('03126090-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03126251-n',[ ('Clamp',subsumption)]).
nounMapping2SUMO('03126385-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03126580-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03126707-n',[ ('Crane',equivalence)]).
nounMapping2SUMO('03126927-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03127024-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03127203-n',[ ('Crankcase',equivalence)]).
nounMapping2SUMO('03127302-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03127408-n',[ ('Crankshaft',equivalence)]).
nounMapping2SUMO('03127531-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('03127747-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03127925-n',[ ('Box',subsumption)]).
nounMapping2SUMO('03128085-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03128248-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03128427-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03128519-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03128868-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03129001-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03129123-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03129471-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03129636-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03129753-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03129848-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03129944-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03130066-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03130233-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03130340-n',[ ('SpaceRegion',subsumption)]).
nounMapping2SUMO('03130563-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03130761-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03130866-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03131038-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03131193-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03131325-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03131431-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03131574-n',[ ('Crib',equivalence)]).
nounMapping2SUMO('03131669-n',[ ('Bed',subsumption)]).
nounMapping2SUMO('03131791-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03131967-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('03132076-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03132261-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03132438-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03132666-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03132776-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03132879-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03133050-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03133177-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03133415-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03133538-n',[ ('Dish',subsumption)]).
nounMapping2SUMO('03133744-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03133878-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03134015-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03134118-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03134232-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03134394-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03134496-n',[ ('Handle',subsumption)]).
nounMapping2SUMO('03134595-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('03134739-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('03134853-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03135030-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03135152-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03135532-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03135656-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03135788-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03135917-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03136051-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03136254-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03136369-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03136504-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03136657-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03136773-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03137044-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03137228-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03137473-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03137579-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03137744-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03137863-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03137973-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('03138128-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03138217-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03138344-n',[ ('Lever',subsumption)]).
nounMapping2SUMO('03138534-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03138669-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03138856-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03138981-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03139089-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03139341-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('03139464-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03139640-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03139731-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03139887-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03139998-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03140126-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03140292-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03140431-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03140546-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03140652-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03140771-n',[ ('Missile',subsumption), ('Bomb',subsumption)]).
nounMapping2SUMO('03140900-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03141065-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('03141327-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03141455-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03141612-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03141702-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03141823-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03141991-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03142099-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('03142205-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03142325-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03142431-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03142579-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03142679-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03142834-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03142912-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('03143131-n',[ ('Sphere',subsumption)]).
nounMapping2SUMO('03143255-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03143400-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03143572-n',[ ('Microphone',subsumption)]).
nounMapping2SUMO('03143754-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03143982-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03144156-n',[ ('RadioReceiver',subsumption)]).
nounMapping2SUMO('03144262-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03144365-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03144486-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03144592-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('03144756-n',[ ('CigarOrCigarette',subsumption)]).
nounMapping2SUMO('03144873-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03144982-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03145147-n',[ ('Clock',subsumption)]).
nounMapping2SUMO('03145277-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03145384-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03145522-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03145719-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('03145843-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03146075-n',[ ('Jewelry',subsumption)]).
nounMapping2SUMO('03146219-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03146342-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03146449-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03146560-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03146687-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03146777-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03146846-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03147084-n',[ ('Rifle',subsumption)]).
nounMapping2SUMO('03147156-n',[ ('ArtilleryGun',subsumption)]).
nounMapping2SUMO('03147280-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03147397-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03147509-n',[ ('Cup',equivalence)]).
nounMapping2SUMO('03147901-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03148130-n',[ ('GolfHole',equivalence)]).
nounMapping2SUMO('03148324-n',[ ('Closet',subsumption)]).
nounMapping2SUMO('03148518-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03148632-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03148727-n',[ ('Dome',subsumption)]).
nounMapping2SUMO('03148808-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03148920-n',[ ('Curb',subsumption)]).
nounMapping2SUMO('03149135-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03149261-n',[ ('StockMarket',instance)]).
nounMapping2SUMO('03149401-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03149531-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03149686-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03149810-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03149951-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03150232-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03150511-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03150661-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03150795-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03151077-n',[ ('Curtain',subsumption)]).
nounMapping2SUMO('03151401-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03151500-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03151800-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03151916-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03152062-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03152144-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03152303-n',[ ('GovernmentBuilding',subsumption)]).
nounMapping2SUMO('03152483-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03152619-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03152743-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03152830-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('03152951-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03153145-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03153246-n',[ ('Sword',subsumption)]).
nounMapping2SUMO('03153375-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('03153585-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03153681-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03153821-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03153948-n',[ ('SwitchDevice',subsumption)]).
nounMapping2SUMO('03154073-n',[ ('CuttingDevice',equivalence)]).
nounMapping2SUMO('03154316-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('03154446-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03154616-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03154745-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('03154895-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03155055-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03155178-n',[ ('Restaurant',subsumption)]).
nounMapping2SUMO('03155334-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03155502-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03155661-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03155788-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03155915-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03156071-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03156279-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03156405-n',[ ('EngineCylinder',equivalence)]).
nounMapping2SUMO('03156606-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03156767-n',[ ('Lock',subsumption)]).
nounMapping2SUMO('03156990-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03157215-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03157348-n',[ ('PercussionInstrument',subsumption)]).
nounMapping2SUMO('03157582-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03157751-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03157987-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03158186-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03158259-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03158414-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03158542-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03158668-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03158796-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03158885-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03159176-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03159331-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03159535-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03159640-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03159828-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03160001-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03160186-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03160309-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03160593-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03160740-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03160894-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03161016-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03161228-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03161450-n',[ ('Damper',equivalence)]).
nounMapping2SUMO('03161725-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03161893-n',[ ('Damper',subsumption)]).
nounMapping2SUMO('03162080-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03162171-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03162297-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03162460-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03162556-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03162714-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03162818-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03162940-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03163081-n',[ ('EducationalOrganization',instance)]).
nounMapping2SUMO('03163222-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03163381-n',[ ('Shirt',subsumption)]).
nounMapping2SUMO('03163488-n',[ ('Damper',subsumption)]).
nounMapping2SUMO('03163649-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03163798-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03163973-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03164192-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03164344-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03164532-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03164605-n',[ ('SofaBed',subsumption)]).
nounMapping2SUMO('03164722-n',[ ('Desk',subsumption)]).
nounMapping2SUMO('03164809-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03164929-n',[ ('Crane',subsumption)]).
nounMapping2SUMO('03165096-n',[ ('Sofa',subsumption), ('Bed',subsumption)]).
nounMapping2SUMO('03165211-n',[ ('Book',subsumption)]).
nounMapping2SUMO('03165343-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03165466-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03165616-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('03165718-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03165823-n',[ ('Axle',subsumption)]).
nounMapping2SUMO('03165955-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03166120-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03166213-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03166360-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('03166514-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03166600-n',[ ('Bed',subsumption)]).
nounMapping2SUMO('03166685-n',[ ('Prison',subsumption)]).
nounMapping2SUMO('03166809-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03166951-n',[ ('Bell',subsumption)]).
nounMapping2SUMO('03167053-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03167153-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03167337-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03167464-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03167666-n',[ ('BoatDeck',subsumption)]).
nounMapping2SUMO('03167978-n',[ ('BoatDeck',subsumption)]).
nounMapping2SUMO('03168107-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03168217-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03168364-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03168543-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03168663-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03168774-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03168933-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03169063-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03169176-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03169271-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03169390-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03170292-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03170459-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03170635-n',[ ('Freezer',subsumption)]).
nounMapping2SUMO('03170872-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('03171002-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('03171094-n',[ ('Laboratory',subsumption)]).
nounMapping2SUMO('03171228-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03171356-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03171635-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03171910-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03172038-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03172211-n',[ ('HeatingDevice',subsumption)]).
nounMapping2SUMO('03172432-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03172602-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03172738-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03172965-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03173142-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03173270-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03173387-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03173524-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03173736-n',[ ('Manufacture',subsumption)]).
nounMapping2SUMO('03173929-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03174079-n',[ ('Airplane',subsumption)]).
nounMapping2SUMO('03174211-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03174450-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03174605-n',[ ('HeatingDevice',subsumption)]).
nounMapping2SUMO('03174731-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03174829-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03174991-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03175081-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03175189-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03175301-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03175457-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03175604-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03175843-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03175983-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03176084-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03176238-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03176386-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03176594-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03176763-n',[ ('RetailStore',subsumption)]).
nounMapping2SUMO('03176970-n',[ ('Door',subsumption)]).
nounMapping2SUMO('03177059-n',[ ('SittingArea',subsumption)]).
nounMapping2SUMO('03177165-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03177349-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03177708-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03177856-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('03178000-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03178173-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03178316-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03178430-n',[ ('Crane',subsumption)]).
nounMapping2SUMO('03178538-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03178674-n',[ ('Pistol',subsumption)]).
nounMapping2SUMO('03178782-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03179318-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03179489-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03179701-n',[ ('Desk',equivalence)]).
nounMapping2SUMO('03179910-n',[ ('Telephone',subsumption)]).
nounMapping2SUMO('03180011-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03180153-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03180280-n',[ ('Tray',subsumption)]).
nounMapping2SUMO('03180384-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('03180504-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03180732-n',[ ('MilitaryWaterVehicle',subsumption)]).
nounMapping2SUMO('03180865-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03180969-n',[ ('MeasuringDevice',subsumption)]).
nounMapping2SUMO('03181293-n',[ ('ReceiverDevice',subsumption)]).
nounMapping2SUMO('03181501-n',[ ('ReceiverDevice',subsumption)]).
nounMapping2SUMO('03181667-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03181899-n',[ ('Detergent',subsumption)]).
nounMapping2SUMO('03182140-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03182232-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03182506-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('03182683-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03182795-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03182912-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03183080-n',[ ('Device',equivalence)]).
nounMapping2SUMO('03185562-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03185746-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03185868-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03186005-n',[ ('Stimulant',subsumption)]).
nounMapping2SUMO('03186199-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03186285-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('03186399-n',[ ('Blueprint',subsumption)]).
nounMapping2SUMO('03186696-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03186818-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03187037-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03187153-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03187268-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03187595-n',[ ('Telephone',subsumption)]).
nounMapping2SUMO('03187751-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03187972-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03188168-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03188290-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03188416-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03188531-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03188725-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03188871-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03188979-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03189083-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03189311-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03189461-n',[ ('ContraceptiveDevice',subsumption)]).
nounMapping2SUMO('03189707-n',[ ('Book',subsumption)]).
nounMapping2SUMO('03189818-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03189995-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03190303-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03190458-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03190655-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03190763-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03190897-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03191029-n',[ ('GameDie',subsumption)]).
nounMapping2SUMO('03191286-n',[ ('Container',subsumption), ('GameArtifact',subsumption)]).
nounMapping2SUMO('03191451-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03191561-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03191776-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03191967-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03192142-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03192347-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03192543-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03192653-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03192790-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03192907-n',[ ('MechanicalDie',equivalence)]).
nounMapping2SUMO('03193107-n',[ ('InternalCombustionEngine',subsumption)]).
nounMapping2SUMO('03193260-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03193423-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03193597-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03193754-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03193882-n',[ ('Steroid',subsumption)]).
nounMapping2SUMO('03194170-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03194297-n',[ ('Differential',equivalence)]).
nounMapping2SUMO('03194538-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03194812-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03194992-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03195118-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03195332-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03195485-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03195659-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03195799-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03195959-n',[ ('DigitalAudioTapeCassette',equivalence)]).
nounMapping2SUMO('03196062-n',[ ('Camera',subsumption)]).
nounMapping2SUMO('03196217-n',[ ('Clock',subsumption)]).
nounMapping2SUMO('03196324-n',[ ('Computer',subsumption)]).
nounMapping2SUMO('03196598-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03196841-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03196990-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03197201-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03197337-n',[ ('WatchClock',subsumption)]).
nounMapping2SUMO('03197446-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03197666-n',[ ('Toxin',subsumption)]).
nounMapping2SUMO('03197804-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('03198028-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03198223-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03198383-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03198500-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03198637-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03198819-n',[ ('BoatDeck',subsumption)]).
nounMapping2SUMO('03198951-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03199142-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03199358-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03199488-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03199647-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03199775-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03199901-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03200152-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('03200231-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03200357-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('03200539-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03200701-n',[ ('DiningRoom',subsumption)]).
nounMapping2SUMO('03200906-n',[ ('Furniture',subsumption)]).
nounMapping2SUMO('03201035-n',[ ('Table',subsumption)]).
nounMapping2SUMO('03201208-n',[ ('Table',subsumption)]).
nounMapping2SUMO('03201529-n',[ ('Bell',subsumption)]).
nounMapping2SUMO('03201638-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03201776-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03201895-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03201996-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03202123-n',[ ('Dish',subsumption)]).
nounMapping2SUMO('03202246-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('03202354-n',[ ('Table',subsumption)]).
nounMapping2SUMO('03202481-n',[ ('Auditorium',subsumption)]).
nounMapping2SUMO('03202622-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03202760-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03202940-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03203089-n',[ ('Candle',subsumption)]).
nounMapping2SUMO('03203225-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03203441-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03203641-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03203806-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03203959-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03204134-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03204306-n',[ ('Cup',subsumption)]).
nounMapping2SUMO('03204436-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03204558-n',[ ('SwitchDevice',subsumption)]).
nounMapping2SUMO('03204810-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03204955-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03205143-n',[ ('Microphone',subsumption)]).
nounMapping2SUMO('03205304-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03205458-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03205574-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03205669-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03205760-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03205903-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03206023-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('03206158-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03206282-n',[ ('NightClub',equivalence)]).
nounMapping2SUMO('03206405-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03206602-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03206718-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03206908-n',[ ('Dish',equivalence)]).
nounMapping2SUMO('03207305-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03207548-n',[ ('PotOrPan',subsumption)]).
nounMapping2SUMO('03207630-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03207743-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03207835-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03207941-n',[ ('Dishwasher',subsumption)]).
nounMapping2SUMO('03208062-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03208229-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03208556-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03208815-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('03208938-n',[ ('DiscBrake',equivalence)]).
nounMapping2SUMO('03209141-n',[ ('ComputerMemory',subsumption)]).
nounMapping2SUMO('03209359-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03209477-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03209666-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03209910-n',[ ('DataStorageDevice',subsumption)]).
nounMapping2SUMO('03210245-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03210372-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03210552-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03210683-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03210940-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03211117-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03211413-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03211616-n',[ ('Sign',subsumption)]).
nounMapping2SUMO('03211789-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03212003-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03212114-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03212247-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('03212406-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03212535-n',[ ('PaintedPicture',subsumption)]).
nounMapping2SUMO('03212698-n',[ ('Paint',subsumption)]).
nounMapping2SUMO('03212811-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03213014-n',[ ('Distributor',equivalence)]).
nounMapping2SUMO('03213361-n',[ ('Cam',subsumption)]).
nounMapping2SUMO('03213538-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03213715-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03213826-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03214051-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03214253-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03214450-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03214582-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03214670-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03214966-n',[ ('Sofa',subsumption)]).
nounMapping2SUMO('03215076-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03215191-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03215337-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03215508-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03215749-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03215930-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03216080-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03216199-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03216402-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03216562-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03216710-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03216828-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03217191-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03217333-n',[ ('PerformanceStage',subsumption)]).
nounMapping2SUMO('03217458-n',[ ('Text',equivalence)]).
nounMapping2SUMO('03217653-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03217739-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03217814-n',[ ('AnimalController',subsumption)]).
nounMapping2SUMO('03217889-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03218100-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03218198-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03218334-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03218446-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03218545-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('03219010-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03219135-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03219362-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03219483-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03219612-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03219732-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03219859-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03219966-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03220095-n',[ ('Sleeve',subsumption)]).
nounMapping2SUMO('03220237-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03220401-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03220513-n',[ ('Dome',subsumption)]).
nounMapping2SUMO('03220692-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03220802-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03221059-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03221205-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03221351-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03221540-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03221643-n',[ ('LandVehicle',subsumption), ('PoweredVehicle',subsumption)]).
nounMapping2SUMO('03221720-n',[ ('Door',subsumption)]).
nounMapping2SUMO('03222176-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03222318-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03222516-n',[ ('SwitchDevice',subsumption)]).
nounMapping2SUMO('03222722-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03222857-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03222959-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03223162-n',[ ('Lock',subsumption)]).
nounMapping2SUMO('03223299-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03223441-n',[ ('Nail',subsumption)]).
nounMapping2SUMO('03223553-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03223686-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03223923-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03224032-n',[ ('Door',subsumption)]).
nounMapping2SUMO('03224387-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03224490-n',[ ('Radar',subsumption)]).
nounMapping2SUMO('03224603-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03224753-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03224893-n',[ ('Dormitory',subsumption)]).
nounMapping2SUMO('03225108-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03225238-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('03225458-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03225616-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03225777-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03225988-n',[ ('DoubleBed',equivalence)]).
nounMapping2SUMO('03226090-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03226254-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03226375-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('03226538-n',[ ('ClothingSuit',subsumption)]).
nounMapping2SUMO('03226660-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03226743-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03226880-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03227010-n',[ ('Window',subsumption)]).
nounMapping2SUMO('03227184-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03227317-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03227505-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03227721-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03227856-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03228016-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03228254-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03228365-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03228533-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03228692-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03228796-n',[ ('Opium',subsumption)]).
nounMapping2SUMO('03228967-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03229115-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03229244-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03229420-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03229526-n',[ ('PerformanceStage',subsumption)]).
nounMapping2SUMO('03229656-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03229905-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03230149-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03230247-n',[ ('Doxycycline',equivalence)]).
nounMapping2SUMO('03230446-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03230670-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('03230785-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03230914-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03231024-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03231160-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03231368-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03231476-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03231723-n',[ ('Food',subsumption)]).
nounMapping2SUMO('03231819-n',[ ('Rifle',subsumption)]).
nounMapping2SUMO('03231912-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03232158-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('03232309-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03232417-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03232543-n',[ ('Filter',subsumption)]).
nounMapping2SUMO('03232676-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03232815-n',[ ('Plug',subsumption)]).
nounMapping2SUMO('03232923-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03233123-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03233246-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03233423-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03233624-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('03233744-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03233905-n',[ ('Compartment',subsumption)]).
nounMapping2SUMO('03234164-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03234306-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03234795-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03234952-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03235042-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03235180-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('03235327-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03235433-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03235560-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03235796-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03235979-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03236093-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03236217-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03236423-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03236580-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03236735-n',[ ('Dress',subsumption)]).
nounMapping2SUMO('03237212-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03237340-n',[ ('ChestOrCabinet',subsumption)]).
nounMapping2SUMO('03237416-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('03237639-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03237839-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03237992-n',[ ('Cloak',subsumption)]).
nounMapping2SUMO('03238131-n',[ ('DressingRoom',subsumption)]).
nounMapping2SUMO('03238286-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03238407-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03238586-n',[ ('Table',subsumption)]).
nounMapping2SUMO('03238762-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03238879-n',[ ('Shirt',subsumption)]).
nounMapping2SUMO('03239054-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03239259-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03239399-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03239607-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03239726-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03240140-n',[ ('ElectricDevice',subsumption)]).
nounMapping2SUMO('03240327-n',[ ('Drill',subsumption)]).
nounMapping2SUMO('03240482-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03240683-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03240892-n',[ ('Drill',subsumption)]).
nounMapping2SUMO('03241093-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03241236-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03241335-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03241496-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03241660-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03241903-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('03242120-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03242264-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03242390-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03242506-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03242595-n',[ ('Stone',subsumption)]).
nounMapping2SUMO('03242713-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('03242995-n',[ ('DriveComponent',subsumption)]).
nounMapping2SUMO('03243218-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03243501-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03243625-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03243903-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03244047-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03244231-n',[ ('Driveshaft',equivalence)]).
nounMapping2SUMO('03244388-n',[ ('Driveway',subsumption)]).
nounMapping2SUMO('03244660-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03244775-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03244919-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03245075-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03245271-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03245421-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03245553-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03245724-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03245889-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03246052-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03246197-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03246312-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03246454-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03246653-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03246788-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03246933-n',[ ('Table',subsumption)]).
nounMapping2SUMO('03247083-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03247351-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03247495-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03247620-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03248560-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03248835-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03248958-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03249342-n',[ ('DrugStore',equivalence)]).
nounMapping2SUMO('03249569-n',[ ('Drum',equivalence)]).
nounMapping2SUMO('03249956-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03250089-n',[ ('DrumBrake',equivalence)]).
nounMapping2SUMO('03250279-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03250405-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03250588-n',[ ('ElectricDevice',subsumption)]).
nounMapping2SUMO('03250847-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03250952-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03251100-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('03251280-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03251533-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03251766-n',[ ('ClothesDryer',equivalence)]).
nounMapping2SUMO('03251932-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03252064-n',[ ('Product',subsumption)]).
nounMapping2SUMO('03252231-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03252324-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03252422-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03252542-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03252637-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03252787-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03252959-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('03253071-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03253187-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03253279-n',[ ('GamePiece',subsumption)]).
nounMapping2SUMO('03253398-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03253516-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03253714-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03253796-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03253886-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03254046-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('03254189-n',[ ('BaseballDugout',subsumption)]).
nounMapping2SUMO('03254374-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03254505-n',[ ('University',instance)]).
nounMapping2SUMO('03254625-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('03254737-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('03254862-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('03255030-n',[ ('RecreationOrExerciseDevice',subsumption)]).
nounMapping2SUMO('03255167-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('03255322-n',[ ('Elevator',subsumption)]).
nounMapping2SUMO('03255488-n',[ ('Bullet',subsumption)]).
nounMapping2SUMO('03255648-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03255790-n',[ ('Warehouse',subsumption)]).
nounMapping2SUMO('03255899-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03256032-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03256166-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03256472-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03256631-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('03256788-n',[ ('LandVehicle',subsumption), ('PoweredVehicle',subsumption)]).
nounMapping2SUMO('03256928-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03257065-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03257210-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03257343-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03257586-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03257877-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03258049-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03258192-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03258330-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03258456-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03258577-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03258730-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03258905-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03259009-n',[ ('CleaningDevice',subsumption)]).
nounMapping2SUMO('03259118-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03259280-n',[ ('CookingOven',subsumption)]).
nounMapping2SUMO('03259401-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03259505-n',[ ('Home',equivalence)]).
nounMapping2SUMO('03260206-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03260293-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03260504-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03260733-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03260849-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('03261019-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03261157-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03261263-n',[ ('Radar',subsumption)]).
nounMapping2SUMO('03261395-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03261603-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03261776-n',[ ('Earphone',equivalence)]).
nounMapping2SUMO('03262072-n',[ ('HearingProtection',subsumption)]).
nounMapping2SUMO('03262248-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03262349-n',[ ('Jewelry',subsumption)]).
nounMapping2SUMO('03262519-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03262717-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03262809-n',[ ('Easel',equivalence)]).
nounMapping2SUMO('03262932-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03263076-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03263206-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('03263338-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03263474-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03263640-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03263758-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03263888-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03264021-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03264136-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03264542-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03264906-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03265032-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03265479-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03265754-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03265874-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03266195-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03266371-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03266498-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03266620-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03266749-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03266906-n',[ ('Building',instance)]).
nounMapping2SUMO('03267113-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('03267256-n',[ ('Nail',subsumption)]).
nounMapping2SUMO('03267340-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03267468-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03267696-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03267821-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03267972-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03268142-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03268311-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03268470-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03268553-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03268645-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03268790-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('03268918-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03269073-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03269203-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03269401-n',[ ('ElectricDevice',equivalence)]).
nounMapping2SUMO('03270165-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03270579-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03270695-n',[ ('Bell',subsumption), ('ElectricDevice',subsumption)]).
nounMapping2SUMO('03270854-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03271030-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03271260-n',[ ('Clock',subsumption)]).
nounMapping2SUMO('03271376-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03271574-n',[ ('FanDevice',equivalence)]).
nounMapping2SUMO('03271765-n',[ ('PotOrPan',subsumption)]).
nounMapping2SUMO('03271865-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03272010-n',[ ('Guitar',subsumption)]).
nounMapping2SUMO('03272125-n',[ ('ElectricDevice',subsumption)]).
nounMapping2SUMO('03272239-n',[ ('RoomHeater',subsumption)]).
nounMapping2SUMO('03272383-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03272562-n',[ ('MotorizedRailwayCar',subsumption)]).
nounMapping2SUMO('03272696-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03272810-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03272940-n',[ ('ElectricDevice',subsumption)]).
nounMapping2SUMO('03273061-n',[ ('ElectricMotor',equivalence)]).
nounMapping2SUMO('03273551-n',[ ('MusicalInstrument',subsumption)]).
nounMapping2SUMO('03273740-n',[ ('Stove',subsumption)]).
nounMapping2SUMO('03273913-n',[ ('Refrigerator',equivalence)]).
nounMapping2SUMO('03274137-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03274265-n',[ ('ElectricDevice',subsumption)]).
nounMapping2SUMO('03274435-n',[ ('ElectricDevice',subsumption)]).
nounMapping2SUMO('03274561-n',[ ('Microphone',equivalence)]).
nounMapping2SUMO('03274796-n',[ ('ElectricDevice',subsumption)]).
nounMapping2SUMO('03275125-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03275311-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03275451-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03275566-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03275681-n',[ ('CapacitorElement',subsumption)]).
nounMapping2SUMO('03275864-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03276179-n',[ ('Electromagnet',equivalence)]).
nounMapping2SUMO('03276431-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03276574-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03276696-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03276839-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03277004-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03277149-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03277459-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03277602-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03277771-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03278248-n',[ ('ElectricDevice',subsumption)]).
nounMapping2SUMO('03278914-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03279153-n',[ ('MusicalInstrument',subsumption)]).
nounMapping2SUMO('03279364-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03279508-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03279804-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03279918-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03280064-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03280216-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03280394-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03280644-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03280813-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03281052-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03281145-n',[ ('Elevator',equivalence)]).
nounMapping2SUMO('03281524-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03281673-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03281821-n',[ ('Character',subsumption)]).
nounMapping2SUMO('03281935-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('03282060-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03282295-n',[ ('EmbassyBuilding',subsumption)]).
nounMapping2SUMO('03282401-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03282591-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03282933-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03283221-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03283413-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03283519-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03283717-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03283827-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03283973-n',[ ('Building',instance)]).
nounMapping2SUMO('03284120-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03284308-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03284482-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03284743-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03284886-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03284981-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03285106-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03285348-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03285578-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03285730-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03285912-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03286383-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03286572-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03286878-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03287178-n',[ ('Product',subsumption)]).
nounMapping2SUMO('03287351-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03287459-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03287627-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03287733-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03288003-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03288225-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03288500-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03288643-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03288742-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03288886-n',[ ('Saddle',subsumption)]).
nounMapping2SUMO('03289025-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03289268-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03289462-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('03289660-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03289819-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03289985-n',[ ('Outfit',subsumption)]).
nounMapping2SUMO('03290096-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03290195-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03290489-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03290653-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03290771-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03291243-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03291413-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03291551-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03291741-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03291819-n',[ ('Envelope',subsumption)]).
nounMapping2SUMO('03291963-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03292085-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03292210-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03292362-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03292475-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03292603-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03292736-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03292960-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03293095-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03293321-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03293471-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03293741-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03293863-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03294048-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03294604-n',[ ('ComputerMemory',subsumption)]).
nounMapping2SUMO('03294833-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03295012-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03295140-n',[ ('Building',equivalence)]).
nounMapping2SUMO('03295246-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03295357-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03295773-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03295928-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03296081-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03296217-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03296328-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03296478-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03296597-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('03296759-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03296963-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03297103-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03297226-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03297354-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03297495-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03297644-n',[ ('Restaurant',subsumption)]).
nounMapping2SUMO('03297735-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03298089-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03298211-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03298352-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03298565-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03298716-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03298858-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03299006-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03299261-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03299406-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03299519-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03299648-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03299788-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03299929-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03300216-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03300443-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03300578-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03300786-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03300907-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03301066-n',[ ('Collar',subsumption)]).
nounMapping2SUMO('03301175-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03301291-n',[ ('Bag',subsumption)]).
nounMapping2SUMO('03301389-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03301568-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03301696-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03301833-n',[ ('CoolingDevice',subsumption)]).
nounMapping2SUMO('03301940-n',[ ('Bag',subsumption)]).
nounMapping2SUMO('03302030-n',[ ('Sword',instance)]).
nounMapping2SUMO('03302121-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03302487-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03302671-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03302790-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03302938-n',[ ('ExhaustSystem',equivalence)]).
nounMapping2SUMO('03303217-n',[ ('FanDevice',subsumption)]).
nounMapping2SUMO('03303333-n',[ ('ExhaustManifold',equivalence)]).
nounMapping2SUMO('03303510-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03303669-n',[ ('ExhaustValve',equivalence)]).
nounMapping2SUMO('03303831-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03303965-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03304197-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03304323-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03304465-n',[ ('Bolt',subsumption)]).
nounMapping2SUMO('03304605-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03304730-n',[ ('ExplosiveDevice',subsumption)]).
nounMapping2SUMO('03305135-n',[ ('ExplosiveDevice',subsumption)]).
nounMapping2SUMO('03305300-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03305522-n',[ ('ExplosiveDevice',equivalence)]).
nounMapping2SUMO('03305844-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03305953-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03306207-n',[ ('Physical',subsumption)]).
nounMapping2SUMO('03306385-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03306610-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03306869-n',[ ('Telephone',subsumption)]).
nounMapping2SUMO('03307037-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03307156-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03307274-n',[ ('Door',subsumption)]).
nounMapping2SUMO('03307573-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03307792-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03307981-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03308152-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03308297-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03308481-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03308614-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03308853-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03309110-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03309214-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03309356-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03309465-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03309687-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03309808-n',[ ('Fabric',equivalence)]).
nounMapping2SUMO('03313333-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03313456-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03313602-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03313873-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03314028-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03314227-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03314378-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03314608-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03314780-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03314884-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03315023-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03315644-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03315805-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03315990-n',[ ('Veneer',subsumption)]).
nounMapping2SUMO('03316105-n',[ ('FaxMachine',equivalence)]).
nounMapping2SUMO('03316274-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03316406-n',[ ('IndustrialPlant',subsumption)]).
nounMapping2SUMO('03316873-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03316988-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03317136-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03317233-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('03317340-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03317510-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03317673-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('03317788-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03317889-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03317990-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03318136-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03318294-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('03318438-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03318707-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03318865-n',[ ('Sword',subsumption)]).
nounMapping2SUMO('03318983-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03319167-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03319296-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03319457-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03319576-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03319653-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03319745-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03319858-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03320046-n',[ ('FanDevice',subsumption)]).
nounMapping2SUMO('03320262-n',[ ('FanBelt',equivalence)]).
nounMapping2SUMO('03320421-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03320519-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03320735-n',[ ('Product',subsumption)]).
nounMapping2SUMO('03320845-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03320959-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03321103-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03321419-n',[ ('Airplane',subsumption)]).
nounMapping2SUMO('03321563-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03321672-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03321843-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03321954-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03322099-n',[ ('Farm',equivalence)]).
nounMapping2SUMO('03322570-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03322704-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03322836-n',[ ('FarmBuilding',subsumption)]).
nounMapping2SUMO('03322940-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03323096-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03323211-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03323319-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03323485-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03323593-n',[ ('WearableItem',subsumption)]).
nounMapping2SUMO('03323703-n',[ ('AttachingDevice',subsumption)]).
nounMapping2SUMO('03324502-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03324629-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03324814-n',[ ('WellnessDaySpa',subsumption)]).
nounMapping2SUMO('03324928-n',[ ('UniformClothing',subsumption)]).
nounMapping2SUMO('03325088-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03325288-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03325403-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03325481-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03325584-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03325691-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03325769-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03325941-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('03326073-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03326239-n',[ ('Transitway',subsumption)]).
nounMapping2SUMO('03326371-n',[ ('FarmBuilding',subsumption)]).
nounMapping2SUMO('03326475-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03326660-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03326795-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03326948-n',[ ('WritingDevice',subsumption)]).
nounMapping2SUMO('03327133-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('03327234-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03327553-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03327691-n',[ ('Sword',subsumption)]).
nounMapping2SUMO('03327841-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03328076-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03328201-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03328392-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03328650-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03329058-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03329180-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03329302-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03329536-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03329663-n',[ ('WaterVehicle',subsumption), ('PassengerVehicle',subsumption)]).
nounMapping2SUMO('03329880-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03330002-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03330120-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03330274-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03330441-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03330665-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03330792-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03330947-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03331077-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03331244-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03331390-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03331599-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03331820-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03332005-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03332173-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03332271-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03332393-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03332591-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03332784-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03332989-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03333129-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03333252-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('03333349-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03333480-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03333610-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03333711-n',[ ('Lens',subsumption)]).
nounMapping2SUMO('03333851-n',[ ('Magnet',subsumption)]).
nounMapping2SUMO('03334017-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03334291-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03334382-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03334492-n',[ ('Flute',subsumption)]).
nounMapping2SUMO('03334667-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03334775-n',[ ('Bearing',subsumption)]).
nounMapping2SUMO('03334912-n',[ ('Wheel',subsumption)]).
nounMapping2SUMO('03335030-n',[ ('Fighter',subsumption)]).
nounMapping2SUMO('03335333-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('03335461-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03335600-n',[ ('RepresentationalArtWork',equivalence)]).
nounMapping2SUMO('03335846-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03336070-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03336168-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03336282-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03336459-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03336575-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03336742-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03336839-n',[ ('FileDevice',equivalence)]).
nounMapping2SUMO('03337140-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03337383-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03337494-n',[ ('Computer',subsumption)]).
nounMapping2SUMO('03337727-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03337822-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03338009-n',[ ('Tobacco',subsumption)]).
nounMapping2SUMO('03338143-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03338287-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('03338648-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('03338821-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03339296-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03339529-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03339643-n',[ ('Filter',equivalence)]).
nounMapping2SUMO('03340009-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03340183-n',[ ('Filter',subsumption)]).
nounMapping2SUMO('03340306-n',[ ('AirFilter',subsumption)]).
nounMapping2SUMO('03340463-n',[ ('CigarOrCigarette',subsumption)]).
nounMapping2SUMO('03340581-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03340723-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03340923-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03341035-n',[ ('BrushOrComb',subsumption)]).
nounMapping2SUMO('03341153-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03341297-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03341606-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03341707-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03341850-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03342015-n',[ ('Paint',subsumption)]).
nounMapping2SUMO('03342127-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03342262-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03342432-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03342529-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03342657-n',[ ('Paint',subsumption)]).
nounMapping2SUMO('03342863-n',[ ('Paint',subsumption)]).
nounMapping2SUMO('03342961-n',[ ('Human',subsumption)]).
nounMapping2SUMO('03343047-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03343234-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03343354-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03343560-n',[ ('Fireplace',subsumption)]).
nounMapping2SUMO('03343737-n',[ ('FireAlarm',equivalence)]).
nounMapping2SUMO('03343853-n',[ ('Firearm',equivalence)]).
nounMapping2SUMO('03344205-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03344305-n',[ ('Bell',subsumption)]).
nounMapping2SUMO('03344393-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03344509-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03344642-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03344784-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03344935-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03345115-n',[ ('ExplosiveDevice',subsumption)]).
nounMapping2SUMO('03345362-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03345487-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03345658-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03345837-n',[ ('FireExtinguisher',equivalence)]).
nounMapping2SUMO('03346004-n',[ ('Hose',subsumption)]).
nounMapping2SUMO('03346135-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03346289-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03346455-n',[ ('Fireplace',equivalence)]).
nounMapping2SUMO('03346898-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03347037-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03347191-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03347338-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03347472-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03347617-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03347731-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03347855-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03347980-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03348142-n',[ ('ComputerHardware',subsumption)]).
nounMapping2SUMO('03348454-n',[ ('ExplosiveDevice',subsumption)]).
nounMapping2SUMO('03348868-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03349020-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03349150-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03349296-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03349367-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03349469-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('03349599-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03349771-n',[ ('BaseballBase',subsumption)]).
nounMapping2SUMO('03349892-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03350011-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03350204-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03350352-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03350456-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03350602-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03350880-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03351036-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03351151-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03351262-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('03351434-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03351768-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03351979-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03352232-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03352366-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03352484-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03352628-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03352853-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03352961-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03353147-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03353281-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03353467-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03353616-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03353783-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03353951-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03354082-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03354207-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03354350-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03354613-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03354816-n',[ ('ExplosiveDevice',subsumption)]).
nounMapping2SUMO('03354903-n',[ ('Flag',subsumption)]).
nounMapping2SUMO('03355339-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03355468-n',[ ('MusicalInstrument',subsumption)]).
nounMapping2SUMO('03355641-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03355768-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03355925-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03356038-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03356158-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03356279-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03356446-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03356559-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03356670-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03356858-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03356982-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03357081-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('03357267-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03357376-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03357716-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03357893-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03358046-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03358172-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03358380-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03358593-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03358726-n',[ ('Camera',subsumption)]).
nounMapping2SUMO('03358841-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03359008-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03359137-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('03359285-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03359436-n',[ ('ComputerMemory',subsumption)]).
nounMapping2SUMO('03359566-n',[ ('Bottle',subsumption)]).
nounMapping2SUMO('03359755-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03359950-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03360038-n',[ ('Box',subsumption)]).
nounMapping2SUMO('03360133-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03360300-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03360431-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03360622-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03360731-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('03360845-n',[ ('Paint',subsumption)]).
nounMapping2SUMO('03361109-n',[ ('FileDevice',subsumption)]).
nounMapping2SUMO('03361194-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03361297-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03361380-n',[ ('ComputerOutputDevice',subsumption)]).
nounMapping2SUMO('03361550-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03361683-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03361837-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03361945-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('03362119-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03362223-n',[ ('TravelerAccommodation',subsumption)]).
nounMapping2SUMO('03362293-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03362393-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03362639-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03362771-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03362890-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03363059-n',[ ('Stairway',subsumption)]).
nounMapping2SUMO('03363216-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03363363-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03363549-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03363749-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03363887-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03364008-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('03364156-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03364340-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03364599-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03364775-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03364937-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03365078-n',[ ('ExplosiveMine',subsumption)]).
nounMapping2SUMO('03365231-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03365374-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('03365592-n',[ ('Floor',subsumption)]).
nounMapping2SUMO('03365991-n',[ ('BuildingLevel',subsumption)]).
nounMapping2SUMO('03366301-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03366464-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03366630-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03366721-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03366823-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03366974-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03367059-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03367147-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03367321-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03367410-n',[ ('Florists',equivalence)]).
nounMapping2SUMO('03367545-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03367663-n',[ ('Fleet',subsumption)]).
nounMapping2SUMO('03367740-n',[ ('Fleet',subsumption)]).
nounMapping2SUMO('03367875-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('03367969-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03368048-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03368141-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03368352-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03368508-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03368637-n',[ ('CultivatedLandArea',subsumption)]).
nounMapping2SUMO('03368750-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03368878-n',[ ('Chimney',subsumption)]).
nounMapping2SUMO('03369011-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03369178-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03369276-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03369407-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03369512-n',[ ('Flywheel',subsumption)]).
nounMapping2SUMO('03369640-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03369767-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03369866-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03370020-n',[ ('Depressant',subsumption)]).
nounMapping2SUMO('03370260-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03370387-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03370646-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03370821-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03370927-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03371258-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03371363-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03371532-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03371728-n',[ ('Toilet',subsumption)]).
nounMapping2SUMO('03371875-n',[ ('Toilet',subsumption)]).
nounMapping2SUMO('03372029-n',[ ('Flute',equivalence)]).
nounMapping2SUMO('03372355-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03372549-n',[ ('DrinkingCup',subsumption)]).
nounMapping2SUMO('03372656-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03372822-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03372933-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03373060-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03373237-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03373415-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03373611-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03373752-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03373943-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03374102-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03374282-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03374372-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03374473-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03374570-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03374649-n',[ ('Flywheel',equivalence)]).
nounMapping2SUMO('03374838-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03374978-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03375070-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03375171-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03375329-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03375443-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03375575-n',[ ('Sword',subsumption)]).
nounMapping2SUMO('03375694-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03375956-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03376159-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03376279-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03376438-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03376595-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('03376771-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03376938-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03377077-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03377245-n',[ ('Book',subsumption)]).
nounMapping2SUMO('03377451-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03377582-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('03377845-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('03378005-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('03378174-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03378342-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03378442-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03378593-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03378765-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03378915-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03379051-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03379204-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03379343-n',[ ('BathingDevice',subsumption)]).
nounMapping2SUMO('03379461-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03379592-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03379719-n',[ ('VehicleBrake',subsumption)]).
nounMapping2SUMO('03379828-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03379989-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03380134-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03380301-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03380461-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03380647-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03380724-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('03380867-n',[ ('Shoe',equivalence)]).
nounMapping2SUMO('03381126-n',[ ('Shoe',equivalence)]).
nounMapping2SUMO('03381231-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03381450-n',[ ('Pump',subsumption)]).
nounMapping2SUMO('03381565-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('03381664-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03381776-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03382104-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03382292-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03382413-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03382533-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03382708-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03382856-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03382969-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03383099-n',[ ('Sail',subsumption)]).
nounMapping2SUMO('03383211-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03383378-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03383468-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03383562-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03383646-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03383821-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03383948-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('03384167-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03384352-n',[ ('CargoVehicle',subsumption), ('LandVehicle',subsumption)]).
nounMapping2SUMO('03384535-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03384706-n',[ ('CultivatedLandArea',subsumption)]).
nounMapping2SUMO('03384891-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03385117-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03385295-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03385420-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03385557-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03386011-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03386343-n',[ ('Pistol',subsumption)]).
nounMapping2SUMO('03386420-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03386544-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03386726-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03386870-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03387016-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03387323-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03387506-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03387653-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03387815-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03387926-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('03388043-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03388183-n',[ ('WritingDevice',subsumption)]).
nounMapping2SUMO('03388323-n',[ ('TieClothing',subsumption)]).
nounMapping2SUMO('03388466-n',[ ('Nail',subsumption)]).
nounMapping2SUMO('03388549-n',[ ('FourPosterBed',equivalence)]).
nounMapping2SUMO('03388711-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03388826-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03388990-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03389353-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03389611-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03389761-n',[ ('PoweredVehicle',subsumption), ('LandVehicle',subsumption)]).
nounMapping2SUMO('03389889-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03389983-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03390075-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03390207-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03390327-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('03390673-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03390786-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03390886-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03390983-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03391301-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03391464-n',[ ('Photograph',subsumption)]).
nounMapping2SUMO('03391613-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03391770-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03392648-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03392741-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03392908-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03393017-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03393199-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03393324-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03393534-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03393761-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03393912-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('03394149-n',[ ('Elevator',subsumption)]).
nounMapping2SUMO('03394272-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03394480-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03394649-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03394816-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03394916-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03395095-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03395256-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03395401-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03395514-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03395630-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03395745-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('03395859-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03396074-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03396311-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03396580-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03396654-n',[ ('Clutch',subsumption)]).
nounMapping2SUMO('03396841-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03396997-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03397087-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03397266-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03397412-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03397532-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03397762-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03397947-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03398153-n',[ ('Dress',subsumption)]).
nounMapping2SUMO('03398228-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('03398382-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03398467-n',[ ('FrontFn',equivalence)]).
nounMapping2SUMO('03398775-n',[ ('Road',subsumption)]).
nounMapping2SUMO('03398950-n',[ ('Curtain',subsumption)]).
nounMapping2SUMO('03399047-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03399240-n',[ ('Door',subsumption)]).
nounMapping2SUMO('03399391-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03399500-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03399579-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03399677-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03399761-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03399852-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03399971-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03400231-n',[ ('PotOrPan',subsumption)]).
nounMapping2SUMO('03400389-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03400798-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03400972-n',[ ('FuelFilter',equivalence)]).
nounMapping2SUMO('03401129-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03401279-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03401500-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03401721-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03402080-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03402188-n',[ ('UniformClothing',subsumption)]).
nounMapping2SUMO('03402369-n',[ ('Bullet',subsumption)]).
nounMapping2SUMO('03402511-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03402621-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03402785-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03402941-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03403169-n',[ ('Product',subsumption)]).
nounMapping2SUMO('03403325-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03403431-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03403643-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03403873-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('03404012-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03404149-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03404251-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('03404360-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('03404449-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03404900-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('03405111-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03405265-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03405595-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03405725-n',[ ('Furniture',equivalence)]).
nounMapping2SUMO('03406597-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03406759-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03406838-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03406966-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03407122-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03407369-n',[ ('ElectricalComponent',subsumption)]).
nounMapping2SUMO('03407616-n',[ ('MatchDevice',subsumption)]).
nounMapping2SUMO('03407744-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03407865-n',[ ('DriveComponent',subsumption)]).
nounMapping2SUMO('03408054-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03408264-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03408340-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03408444-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03408621-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03408721-n',[ ('Product',subsumption)]).
nounMapping2SUMO('03408918-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03409070-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03409297-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03409393-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03409591-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03409806-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03409920-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03410022-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03410147-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03410303-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03410423-n',[ ('Sail',subsumption)]).
nounMapping2SUMO('03410571-n',[ ('Sail',subsumption)]).
nounMapping2SUMO('03410740-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03410938-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03411079-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('03411208-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03411339-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('03411544-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03411762-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03411927-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03412058-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03412220-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03412387-n',[ ('KitchenArea',subsumption)]).
nounMapping2SUMO('03412511-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03412674-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03412906-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03413124-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03413264-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03413428-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03413684-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03413828-n',[ ('GameArtifact',equivalence)]).
nounMapping2SUMO('03414029-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03414162-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03414574-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03414676-n',[ ('Table',subsumption)]).
nounMapping2SUMO('03414814-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03415083-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('03415252-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03415363-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('03415486-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03415626-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03415749-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03415868-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03416094-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03416329-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03416489-n',[ ('Garage',equivalence)]).
nounMapping2SUMO('03416640-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03416775-n',[ ('Rifle',subsumption)]).
nounMapping2SUMO('03416900-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03417042-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03417202-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03417345-n',[ ('CultivatedLandArea',subsumption)]).
nounMapping2SUMO('03417749-n',[ ('CultivatedLandArea',subsumption)]).
nounMapping2SUMO('03417871-n',[ ('Hose',subsumption)]).
nounMapping2SUMO('03417970-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03418052-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03418158-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03418242-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03418402-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03418488-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03418618-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03418749-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03418915-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03419014-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03420345-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03420440-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03420559-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03420801-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03420935-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03421117-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03421324-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03421485-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03421669-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('03421768-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('03421960-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03422072-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03422288-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03422484-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03422589-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03422771-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03422934-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03423099-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03423224-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03423306-n',[ ('Gun',subsumption)]).
nounMapping2SUMO('03423387-n',[ ('HeatingDevice',subsumption)]).
nounMapping2SUMO('03423479-n',[ ('HeatingDevice',subsumption)]).
nounMapping2SUMO('03423568-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03423719-n',[ ('Gasket',equivalence)]).
nounMapping2SUMO('03423877-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03423966-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03424103-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03424204-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03424325-n',[ ('Respirator',equivalence)]).
nounMapping2SUMO('03424489-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03424630-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03424862-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03425092-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03425241-n',[ ('CookingOven',subsumption)]).
nounMapping2SUMO('03425325-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03425413-n',[ ('Pump',subsumption)]).
nounMapping2SUMO('03425595-n',[ ('Stove',subsumption), ('Oven',subsumption)]).
nounMapping2SUMO('03425769-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03425956-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03426134-n',[ ('GasTank',equivalence)]).
nounMapping2SUMO('03426285-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('03426462-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03426574-n',[ ('Turbine',equivalence)]).
nounMapping2SUMO('03426871-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03426984-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03427084-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03427202-n',[ ('Pistol',subsumption)]).
nounMapping2SUMO('03427296-n',[ ('Door',equivalence)]).
nounMapping2SUMO('03427656-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03427909-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03428090-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03428226-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03428349-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03428477-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03428571-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03428805-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03429003-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03429137-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03429288-n',[ ('MeasuringDevice',subsumption)]).
nounMapping2SUMO('03429682-n',[ ('Glove',subsumption)]).
nounMapping2SUMO('03429771-n',[ ('Glove',subsumption)]).
nounMapping2SUMO('03429914-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03430091-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03430313-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03430418-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03430551-n',[ ('Gear',equivalence)]).
nounMapping2SUMO('03430959-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03431243-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03431570-n',[ ('Gearbox',equivalence)]).
nounMapping2SUMO('03431745-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03432061-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03432129-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03432360-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03432509-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03432668-n',[ ('Paint',subsumption)]).
nounMapping2SUMO('03432796-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03432972-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03433079-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03433247-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03433434-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03433637-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('03433877-n',[ ('Generator',equivalence)]).
nounMapping2SUMO('03434188-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03434285-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03434428-n',[ ('Product',subsumption)]).
nounMapping2SUMO('03434549-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03434830-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03434943-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03435290-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03435382-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03435593-n',[ ('Dome',subsumption)]).
nounMapping2SUMO('03435743-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03435825-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03435991-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03436075-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03436182-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03436290-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('03436417-n',[ ('GiftNoveltyAndSouvenirShops',subsumption)]).
nounMapping2SUMO('03436549-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03436656-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03436772-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('03436891-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03436990-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03437184-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03437295-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03437430-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03437581-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03437741-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03437829-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03437941-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03438071-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03438257-n',[ ('Cup',equivalence)]).
nounMapping2SUMO('03438661-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03438780-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03438863-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03438952-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03439064-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03439260-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03439348-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03439491-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03439631-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03439814-n',[ ('GliderPlane',equivalence)]).
nounMapping2SUMO('03440024-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03440216-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03440512-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03440682-n',[ ('PercussionInstrument',subsumption)]).
nounMapping2SUMO('03440876-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03441009-n',[ ('Photograph',subsumption)]).
nounMapping2SUMO('03441112-n',[ ('Glove',subsumption)]).
nounMapping2SUMO('03441345-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03441465-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03441582-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03441778-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03441930-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03442164-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03442288-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03442487-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('03442597-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03442756-n',[ ('GameGoal',equivalence)]).
nounMapping2SUMO('03443005-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03443149-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03443371-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03443461-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03443543-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03443669-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03443775-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03443912-n',[ ('ProtectiveEyewear',equivalence)]).
nounMapping2SUMO('03444034-n',[ ('PassengerVehicle',subsumption), ('LandVehicle',subsumption), ('PoweredVehicle',subsumption)]).
nounMapping2SUMO('03444169-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03444268-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03444376-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03444601-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03444728-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03444838-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03444942-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03445120-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03445217-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03445326-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03445472-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03445617-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03445777-n',[ ('GolfBall',equivalence)]).
nounMapping2SUMO('03445924-n',[ ('PoweredVehicle',subsumption), ('LandVehicle',subsumption), ('PassengerVehicle',subsumption)]).
nounMapping2SUMO('03446070-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03446268-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03446528-n',[ ('GolfCourse',equivalence)]).
nounMapping2SUMO('03446832-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03447075-n',[ ('Glove',subsumption)]).
nounMapping2SUMO('03447224-n',[ ('DrivingRange',equivalence)]).
nounMapping2SUMO('03447358-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03447447-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03447593-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03447721-n',[ ('PercussionInstrument',subsumption)]).
nounMapping2SUMO('03447894-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03448031-n',[ ('Attaching',instance)]).
nounMapping2SUMO('03448253-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03448491-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03448590-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03448696-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03448814-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03448956-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03449103-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03449217-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03449309-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03449451-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('03449564-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03449858-n',[ ('OfficeBuilding',subsumption)]).
nounMapping2SUMO('03450018-n',[ ('SpeedGovernor',equivalence)]).
nounMapping2SUMO('03450230-n',[ ('Dress',subsumption)]).
nounMapping2SUMO('03450516-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03450734-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03450881-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03450974-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03451120-n',[ ('GrabBar',equivalence)]).
nounMapping2SUMO('03451253-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03451365-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03451473-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03451711-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03451798-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03451909-n',[ ('Artifact',instance)]).
nounMapping2SUMO('03452055-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03452267-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03452449-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03452594-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03452741-n',[ ('Piano',subsumption)]).
nounMapping2SUMO('03452953-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03453162-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03453231-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03453320-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03453443-n',[ ('CultivatedLandArea',subsumption)]).
nounMapping2SUMO('03453547-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03453696-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03453809-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03453985-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03454110-n',[ ('Anchor',subsumption)]).
nounMapping2SUMO('03454211-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03454442-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03454536-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03454707-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03454885-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03455033-n',[ ('Tomb',subsumption)]).
nounMapping2SUMO('03455279-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03455355-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03455488-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03455642-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03455802-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03455923-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03456024-n',[ ('Dish',subsumption)]).
nounMapping2SUMO('03456186-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03456299-n',[ ('Pump',subsumption)]).
nounMapping2SUMO('03456447-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03456548-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03456665-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('03456854-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03457008-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03457184-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03457332-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03457451-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03457578-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03457686-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03457793-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('03457902-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03458128-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03458271-n',[ ('Grenade',subsumption)]).
nounMapping2SUMO('03458422-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03458552-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03458753-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03458961-n',[ ('Reef',equivalence)]).
nounMapping2SUMO('03459159-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('03459328-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03459498-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03459591-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03459775-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03459914-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03460040-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03460147-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03460297-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03460455-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03460526-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03460674-n',[ ('Penicillin',subsumption)]).
nounMapping2SUMO('03460899-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03461037-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03461119-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03461288-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03461385-n',[ ('GroceryStore',equivalence)]).
nounMapping2SUMO('03461651-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03461783-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03461882-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03461988-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03462110-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03462211-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03462315-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03462441-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03462594-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03462747-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03462972-n',[ ('Food',subsumption)]).
nounMapping2SUMO('03463073-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03463185-n',[ ('CommunicationDevice',subsumption)]).
nounMapping2SUMO('03463381-n',[ ('BuildingLevel',subsumption)]).
nounMapping2SUMO('03463561-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03463666-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03463832-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03464053-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03464266-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03464467-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03464628-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03464757-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03464952-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03465040-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03465151-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03465320-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('03465426-n',[ ('Table',subsumption)]).
nounMapping2SUMO('03465500-n',[ ('Violin',subsumption)]).
nounMapping2SUMO('03465605-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03465718-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03465818-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03466027-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03466162-n',[ ('GuidedMissile',equivalence)]).
nounMapping2SUMO('03466493-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03466600-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03466726-n',[ ('String',subsumption)]).
nounMapping2SUMO('03466839-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03466947-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03467068-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03467254-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03467380-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03467517-n',[ ('Guitar',equivalence)]).
nounMapping2SUMO('03467796-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03467887-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03467984-n',[ ('Gun',equivalence)]).
nounMapping2SUMO('03468570-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03468696-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03468821-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03468900-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03469031-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03469175-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03469346-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('03469493-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03469687-n',[ ('GunBarrel',subsumption)]).
nounMapping2SUMO('03469832-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03469903-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03470005-n',[ ('Gun',subsumption)]).
nounMapping2SUMO('03470222-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03470387-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03470629-n',[ ('GunTrigger',subsumption)]).
nounMapping2SUMO('03470802-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03470948-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03471030-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03471190-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03471347-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03471473-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03471685-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03471779-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03471974-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03472112-n',[ ('ExerciseCenter',equivalence)]).
nounMapping2SUMO('03472232-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03472535-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('03472672-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03472796-n',[ ('UniformClothing',subsumption)]).
nounMapping2SUMO('03472937-n',[ ('Taxicab',subsumption)]).
nounMapping2SUMO('03473078-n',[ ('Compass',subsumption)]).
nounMapping2SUMO('03473227-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03473465-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03473704-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03473817-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03473966-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03474167-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03474352-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03474467-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03474635-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03474779-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03474896-n',[ ('Handle',equivalence)]).
nounMapping2SUMO('03475118-n',[ ('Building',instance)]).
nounMapping2SUMO('03475421-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03475581-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03475674-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03475823-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03475961-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03476083-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03476313-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03476458-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03476542-n',[ ('Shirt',subsumption)]).
nounMapping2SUMO('03476684-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03476843-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03476991-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03477143-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03477303-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03477410-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03477512-n',[ ('Book',subsumption)]).
nounMapping2SUMO('03477674-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03477773-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03477902-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03478033-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03478141-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03478261-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03478400-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03478491-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03478589-n',[ ('PoweredVehicle',subsumption), ('LandVehicle',subsumption)]).
nounMapping2SUMO('03478756-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03478907-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03479121-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03479266-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03479397-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03479502-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03479647-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03479952-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03480186-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03480367-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03480579-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03480719-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03480863-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03480973-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03481172-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03481521-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03481674-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03481824-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03482001-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03482128-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03482252-n',[ ('Hammock',equivalence)]).
nounMapping2SUMO('03482405-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03482523-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03482727-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03482877-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('03482988-n',[ ('SportsGround',subsumption)]).
nounMapping2SUMO('03483086-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03483230-n',[ ('MusicalInstrument',subsumption)]).
nounMapping2SUMO('03483316-n',[ ('HairDryer',equivalence)]).
nounMapping2SUMO('03483531-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03483637-n',[ ('ParkingBrake',equivalence)]).
nounMapping2SUMO('03483823-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03483971-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('03484083-n',[ ('AgentPoweredVehicle',subsumption), ('LandVehicle',subsumption), ('CargoVehicle',subsumption)]).
nounMapping2SUMO('03484487-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03484576-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03484809-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03484931-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03485198-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03485309-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03485407-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03485575-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03485655-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03485794-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03485997-n',[ ('Handle',subsumption)]).
nounMapping2SUMO('03487090-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03487222-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03487331-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03487444-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03487533-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03487642-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03487774-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03487886-n',[ ('Pump',subsumption)]).
nounMapping2SUMO('03487963-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03488111-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03488188-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03488438-n',[ ('TelephoneHandset',equivalence)]).
nounMapping2SUMO('03488603-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03488784-n',[ ('Handle',subsumption)]).
nounMapping2SUMO('03488887-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03489048-n',[ ('Lever',subsumption)]).
nounMapping2SUMO('03489162-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03490006-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03490119-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03490324-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03490449-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03490649-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03490784-n',[ ('Airplane',subsumption)]).
nounMapping2SUMO('03490884-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03491032-n',[ ('GliderPlane',subsumption)]).
nounMapping2SUMO('03491178-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03491491-n',[ ('CultivatedLandArea',instance)]).
nounMapping2SUMO('03491724-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03491988-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03492087-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03492250-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03492391-n',[ ('Book',subsumption)]).
nounMapping2SUMO('03492542-n',[ ('DataStorageDevice',subsumption)]).
nounMapping2SUMO('03492717-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03492922-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03493079-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03493219-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('03493333-n',[ ('ComputerHardware',equivalence)]).
nounMapping2SUMO('03493664-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03493792-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03493911-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03494105-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03494278-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03494537-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03494706-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03495039-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03495258-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('03495570-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03495671-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03495941-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03496042-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03496183-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03496296-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('03496486-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03496612-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03496749-n',[ ('University',instance)]).
nounMapping2SUMO('03496892-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03497100-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03497182-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03497352-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03497531-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03497657-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('03498316-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03498441-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03498536-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03498662-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03498781-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('03498866-n',[ ('BrushOrComb',subsumption)]).
nounMapping2SUMO('03498962-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03499142-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03499354-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03499468-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03499611-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03499796-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03499907-n',[ ('Guitar',subsumption)]).
nounMapping2SUMO('03500090-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03500209-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03500295-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03500389-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03500457-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03500557-n',[ ('LoftStyle',subsumption)]).
nounMapping2SUMO('03500699-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03500838-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03500971-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03501068-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03501152-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03501288-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03501520-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03501614-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03501811-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03502042-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03502200-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03502331-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03502509-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('03502777-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03502897-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03503097-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03503233-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03503358-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03503477-n',[ ('Gasket',subsumption)]).
nounMapping2SUMO('03503567-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03503718-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03503908-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03503997-n',[ ('Headlight',subsumption)]).
nounMapping2SUMO('03504205-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03504293-n',[ ('GamePiece',subsumption)]).
nounMapping2SUMO('03504420-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03504723-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03505015-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03505133-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03505207-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03505383-n',[ ('Sail',subsumption)]).
nounMapping2SUMO('03505504-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03505667-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03505764-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03505942-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03506028-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03506184-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03506370-n',[ ('ExerciseCenter',equivalence)]).
nounMapping2SUMO('03506560-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03506727-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03506880-n',[ ('LandVehicle',subsumption)]).
nounMapping2SUMO('03507048-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03507241-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03507458-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03507554-n',[ ('Fireplace',subsumption)]).
nounMapping2SUMO('03507658-n',[ ('Pump',subsumption)]).
nounMapping2SUMO('03507857-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03507963-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03508101-n',[ ('RoomHeater',subsumption)]).
nounMapping2SUMO('03508485-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03508628-n',[ ('HeatingDevice',subsumption)]).
nounMapping2SUMO('03508881-n',[ ('HeatingDevice',subsumption)]).
nounMapping2SUMO('03509025-n',[ ('RoomHeater',subsumption)]).
nounMapping2SUMO('03509394-n',[ ('RoomHeater',subsumption)]).
nounMapping2SUMO('03509608-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03509843-n',[ ('GuidedMissile',subsumption)]).
nounMapping2SUMO('03510072-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03510244-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03510384-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03510487-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03510583-n',[ ('Aircraft',subsumption)]).
nounMapping2SUMO('03510866-n',[ ('Oboe',subsumption)]).
nounMapping2SUMO('03510987-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03511175-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03511333-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03511426-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03511786-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03511949-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03512030-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03512147-n',[ ('Helicopter',equivalence)]).
nounMapping2SUMO('03512452-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03512624-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03512830-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03512911-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03513137-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03513376-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03513627-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03513961-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03514129-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03514340-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03514451-n',[ ('Clamp',subsumption)]).
nounMapping2SUMO('03514588-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03514693-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03514894-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03514974-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('03515338-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03515500-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03515644-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03515728-n',[ ('Sculpture',subsumption)]).
nounMapping2SUMO('03515934-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03516011-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03516266-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03516367-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03516647-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03516844-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03516996-n',[ ('ReceiverDevice',subsumption)]).
nounMapping2SUMO('03517271-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03517427-n',[ ('MechanicalNut',subsumption)]).
nounMapping2SUMO('03517509-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03517647-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03517760-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03517899-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03517982-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03518135-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03518230-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03518305-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03518445-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('03518631-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('03518829-n',[ ('PercussionInstrument',subsumption)]).
nounMapping2SUMO('03518943-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03519081-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03519226-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03519387-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03519578-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03519674-n',[ ('Table',subsumption)]).
nounMapping2SUMO('03519848-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03519981-n',[ ('Expressway',subsumption)]).
nounMapping2SUMO('03520275-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03520399-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03520493-n',[ ('Hijab',equivalence)]).
nounMapping2SUMO('03520654-n',[ ('Handle',subsumption)]).
nounMapping2SUMO('03520811-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03521076-n',[ ('Hinge',subsumption)]).
nounMapping2SUMO('03521431-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03521544-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('03521675-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03521771-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03521899-n',[ ('Pocket',subsumption)]).
nounMapping2SUMO('03522003-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03522100-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03522239-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03522559-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('03522634-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03522863-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03522990-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03523134-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03523288-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03523398-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03523506-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03523633-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03523849-n',[ ('Nail',subsumption)]).
nounMapping2SUMO('03523987-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03524150-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03524287-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03524425-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03524574-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03524745-n',[ ('Handle',subsumption)]).
nounMapping2SUMO('03524840-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03524976-n',[ ('FluidContainer',subsumption)]).
nounMapping2SUMO('03525074-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03525252-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03525372-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03525454-n',[ ('Holder',equivalence)]).
nounMapping2SUMO('03525693-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03525827-n',[ ('AttachingDevice',subsumption)]).
nounMapping2SUMO('03526062-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03526198-n',[ ('Hole',equivalence)]).
nounMapping2SUMO('03526805-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('03527000-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03527149-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03527243-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03527444-n',[ ('Holster',subsumption)]).
nounMapping2SUMO('03527565-n',[ ('Belt',subsumption)]).
nounMapping2SUMO('03527675-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03527930-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03528100-n',[ ('CareOrganization',subsumption)]).
nounMapping2SUMO('03528263-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03528523-n',[ ('Computer',subsumption)]).
nounMapping2SUMO('03528622-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03528761-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03528901-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03529175-n',[ ('Classroom',subsumption)]).
nounMapping2SUMO('03529444-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03529629-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03529740-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03529860-n',[ ('Auditorium',subsumption)]).
nounMapping2SUMO('03530041-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03530189-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03530326-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03530511-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03530642-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03530803-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03530910-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03531281-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03531447-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03531546-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03531691-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03531808-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03531982-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03532080-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03532187-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03532342-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03532672-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03532919-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03533014-n',[ ('SmokingDevice',subsumption)]).
nounMapping2SUMO('03533392-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03533486-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03533654-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03533845-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03533972-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03534429-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03534580-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03534695-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03534776-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03534890-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03535024-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03535186-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03535284-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03535429-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03535526-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03535647-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03535780-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03535970-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03536122-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03536348-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03536568-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03536761-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03536931-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03537085-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03537241-n',[ ('ElectricDevice',subsumption)]).
nounMapping2SUMO('03537412-n',[ ('SwitchDevice',subsumption)]).
nounMapping2SUMO('03537550-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03537714-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03537866-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03538037-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03538179-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('03538300-n',[ ('UnpoweredVehicle',subsumption)]).
nounMapping2SUMO('03538406-n',[ ('UnpoweredVehicle',subsumption)]).
nounMapping2SUMO('03538542-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03538634-n',[ ('UnpoweredVehicle',subsumption), ('LandVehicle',subsumption)]).
nounMapping2SUMO('03538817-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03538957-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03539103-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03539293-n',[ ('Pistol',subsumption)]).
nounMapping2SUMO('03539433-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03539546-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03539678-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03539754-n',[ ('Whip',subsumption)]).
nounMapping2SUMO('03539875-n',[ ('Hose',equivalence)]).
nounMapping2SUMO('03540090-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03540267-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03540476-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03540595-n',[ ('Hospital',subsumption)]).
nounMapping2SUMO('03540914-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03541091-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03541269-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03541393-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03541537-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03541696-n',[ ('TravelerAccommodation',subsumption)]).
nounMapping2SUMO('03541923-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03542073-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03542220-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03542333-n',[ ('TravelerAccommodation',equivalence)]).
nounMapping2SUMO('03542605-n',[ ('CasinoHotels',equivalence)]).
nounMapping2SUMO('03542727-n',[ ('CasinoHotels',equivalence)]).
nounMapping2SUMO('03542860-n',[ ('HotelRoom',equivalence)]).
nounMapping2SUMO('03543012-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03543112-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03543254-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03543394-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('03543511-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03543603-n',[ ('BathTub',subsumption)]).
nounMapping2SUMO('03543735-n',[ ('FluidContainer',subsumption)]).
nounMapping2SUMO('03543945-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03544143-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03544238-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03544360-n',[ ('House',equivalence)]).
nounMapping2SUMO('03545150-n',[ ('House',equivalence)]).
nounMapping2SUMO('03545470-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03545585-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('03545756-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03545961-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03546112-n',[ ('Paint',subsumption)]).
nounMapping2SUMO('03546235-n',[ ('Roof',equivalence)]).
nounMapping2SUMO('03546340-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03546766-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03547054-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03547229-n',[ ('Aircraft',subsumption)]).
nounMapping2SUMO('03547397-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03547530-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03547658-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03547861-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03548086-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03548195-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03548320-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03548402-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03548533-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03548626-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03548797-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03548930-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03549097-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03549199-n',[ ('RoadVehicle',subsumption)]).
nounMapping2SUMO('03549350-n',[ ('WatchClock',subsumption)]).
nounMapping2SUMO('03549473-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03549589-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03549732-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03549897-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03550153-n',[ ('SingleFamilyResidence',equivalence)]).
nounMapping2SUMO('03550289-n',[ ('TrapOrCage',subsumption)]).
nounMapping2SUMO('03550420-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('03550533-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03550671-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03550916-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03551084-n',[ ('VehicleBrake',subsumption)]).
nounMapping2SUMO('03551395-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03551582-n',[ ('Pump',subsumption)]).
nounMapping2SUMO('03551790-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03552001-n',[ ('Gearbox',subsumption)]).
nounMapping2SUMO('03552169-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03552449-n',[ ('Turbine',subsumption)]).
nounMapping2SUMO('03552639-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03552749-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03553019-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03553248-n',[ ('NuclearWeapon',subsumption)]).
nounMapping2SUMO('03553486-n',[ ('Hydrometer',equivalence)]).
nounMapping2SUMO('03553708-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03553908-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03554131-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03554375-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03554460-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03554645-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03554795-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03555006-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03555217-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03555426-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03555564-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03555662-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03555862-n',[ ('Altimeter',subsumption)]).
nounMapping2SUMO('03555996-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03556173-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03556281-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03556679-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03556811-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('03556992-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03557141-n',[ ('Water',subsumption)]).
nounMapping2SUMO('03557270-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03557360-n',[ ('IceSkatingRink',subsumption)]).
nounMapping2SUMO('03557512-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03557590-n',[ ('IceMachine',subsumption)]).
nounMapping2SUMO('03557692-n',[ ('IceMachine',subsumption)]).
nounMapping2SUMO('03557840-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03558007-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03558176-n',[ ('IceSkatingRink',equivalence)]).
nounMapping2SUMO('03558404-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03558633-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03558739-n',[ ('Holder',subsumption)]).
nounMapping2SUMO('03558841-n',[ ('Trailer',subsumption)]).
nounMapping2SUMO('03558971-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03559144-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03559373-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03559531-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03559841-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03559999-n',[ ('Pulley',subsumption)]).
nounMapping2SUMO('03560161-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03560430-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03560567-n',[ ('AutomobileIgnitionSystem',subsumption)]).
nounMapping2SUMO('03560860-n',[ ('IgnitionCoil',equivalence)]).
nounMapping2SUMO('03561047-n',[ ('Key',subsumption)]).
nounMapping2SUMO('03561169-n',[ ('SwitchDevice',subsumption)]).
nounMapping2SUMO('03561345-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03561573-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03561657-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('03561889-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03562126-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('03562262-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('03562408-n',[ ('HeatingDevice',subsumption)]).
nounMapping2SUMO('03562565-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03562739-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03562958-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03563200-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03563358-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03563460-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03563611-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03563710-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03563967-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03564667-n',[ ('Physical',subsumption)]).
nounMapping2SUMO('03564849-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03565051-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03565288-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03565402-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03565565-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03565710-n',[ ('Turbine',subsumption)]).
nounMapping2SUMO('03565830-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03565991-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('03566193-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03566329-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03566555-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03566730-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03566860-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03567066-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03567325-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03567474-n',[ ('Building',instance)]).
nounMapping2SUMO('03567635-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03567788-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('03567912-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03568008-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03568117-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03568430-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03568561-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03568653-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03568818-n',[ ('ElectricalTransformer',subsumption)]).
nounMapping2SUMO('03569014-n',[ ('InductorElement',subsumption)]).
nounMapping2SUMO('03569174-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03569293-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03569494-n',[ ('AirPump',subsumption)]).
nounMapping2SUMO('03569657-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03569964-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03570372-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03570526-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03570709-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('03570838-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03571155-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03571280-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03571439-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03571625-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03571706-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03571853-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03571942-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03572107-n',[ ('Tape',subsumption)]).
nounMapping2SUMO('03572205-n',[ ('Holder',subsumption)]).
nounMapping2SUMO('03572321-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03572449-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03572631-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03572832-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03573005-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('03573154-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03573282-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03573464-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03573574-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03573739-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03573848-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03574004-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('03574243-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03574416-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03574555-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03574816-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03575240-n',[ ('Device',equivalence)]).
nounMapping2SUMO('03575691-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03575958-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03576215-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03576443-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03576617-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03576779-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03576955-n',[ ('IntakeValve',equivalence)]).
nounMapping2SUMO('03577090-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03577312-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03577474-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03577672-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03577818-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03578055-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03578251-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03578435-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03578656-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03578981-n',[ ('MeasuringDevice',subsumption)]).
nounMapping2SUMO('03579137-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('03579355-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03579538-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03579699-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03579791-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03579982-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03580518-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03580615-n',[ ('Internet',subsumption)]).
nounMapping2SUMO('03580845-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03580990-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03581125-n',[ ('RoadJunction',subsumption)]).
nounMapping2SUMO('03581354-n',[ ('Expressway',subsumption)]).
nounMapping2SUMO('03581531-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03581634-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03581756-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03581897-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03582096-n',[ ('ContraceptiveDevice',subsumption)]).
nounMapping2SUMO('03582305-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03582508-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('03582658-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03582840-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03582959-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03583109-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03583252-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03583419-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03583621-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03583809-n',[ ('Pump',subsumption)]).
nounMapping2SUMO('03583967-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03584111-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03584254-n',[ ('MediaSystem',subsumption)]).
nounMapping2SUMO('03584400-n',[ ('MediaSystem',subsumption)]).
nounMapping2SUMO('03584526-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03584649-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03584829-n',[ ('FabricIron',equivalence)]).
nounMapping2SUMO('03585073-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03585337-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03585438-n',[ ('AnimalController',subsumption)]).
nounMapping2SUMO('03585551-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03585682-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03585778-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03585875-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03586090-n',[ ('IroningBoard',equivalence)]).
nounMapping2SUMO('03586219-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03586448-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03586631-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03586760-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03586911-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03587050-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03587205-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03587318-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03587442-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03587623-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03587715-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03587874-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03588046-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03588216-n',[ ('Cloak',subsumption)]).
nounMapping2SUMO('03588414-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03588668-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03588841-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03588951-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03589093-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03589220-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03589313-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03589513-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03589672-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('03589791-n',[ ('Coat',equivalence)]).
nounMapping2SUMO('03590306-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03590475-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03590588-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03590732-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('03590841-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03590932-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03591028-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03591116-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03591313-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03591465-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03591592-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03591798-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03591901-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03592055-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03592245-n',[ ('Prison',subsumption)]).
nounMapping2SUMO('03592669-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03592773-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03592931-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03593034-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03593122-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03593222-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03593362-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03593526-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03593862-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03594010-n',[ ('UnpoweredVehicle',subsumption)]).
nounMapping2SUMO('03594148-n',[ ('Spear',subsumption)]).
nounMapping2SUMO('03594277-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03594523-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03594734-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('03594945-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('03595055-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03595179-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03595264-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03595409-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03595523-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03595614-n',[ ('Shirt',subsumption)]).
nounMapping2SUMO('03595737-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03595860-n',[ ('JetAirplane',equivalence)]).
nounMapping2SUMO('03596099-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03596285-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03596543-n',[ ('JetAirplane',subsumption)]).
nounMapping2SUMO('03596639-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03596787-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('03597147-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03597317-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03597469-n',[ ('Jewelry',equivalence)]).
nounMapping2SUMO('03597916-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('03598151-n',[ ('Sail',subsumption)]).
nounMapping2SUMO('03598299-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03598385-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('03598515-n',[ ('Dancing',subsumption)]).
nounMapping2SUMO('03598646-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03598783-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03598930-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03599111-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03599212-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03599351-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03599486-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03599628-n',[ ('PlaceOfCommerce',subsumption)]).
nounMapping2SUMO('03599761-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03599964-n',[ ('OfficeBuilding',subsumption)]).
nounMapping2SUMO('03600169-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03600285-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('03600475-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03600617-n',[ ('University',instance)]).
nounMapping2SUMO('03600722-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03600806-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03600977-n',[ ('MechanicalJoint',equivalence)]).
nounMapping2SUMO('03601335-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03601442-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03601638-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03601840-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03601964-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03602081-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03602194-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03602267-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03602365-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03602465-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03602562-n',[ ('Book',subsumption)]).
nounMapping2SUMO('03602686-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03602790-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03602883-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03603119-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03603199-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03603442-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03603594-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('03603722-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03603878-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03603958-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03604156-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03604311-n',[ ('JetAirplane',subsumption)]).
nounMapping2SUMO('03604400-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03604536-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03604629-n',[ ('JumperCable',subsumption)]).
nounMapping2SUMO('03604763-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03604843-n',[ ('JumperCable',equivalence)]).
nounMapping2SUMO('03605073-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03605233-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03605417-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03605504-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03605598-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03605722-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03605915-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03606106-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03606251-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03606347-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03606465-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03606572-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03606719-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03607029-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03607186-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03607358-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03607527-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('03607659-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03607756-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03607923-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03608074-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03608224-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03608356-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03608504-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03608661-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03608870-n',[ ('Stimulant',subsumption)]).
nounMapping2SUMO('03609147-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03609235-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03609397-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03609542-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03609786-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03609959-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03610098-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03610270-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03610418-n',[ ('FluidContainer',subsumption)]).
nounMapping2SUMO('03610524-n',[ ('Kennel',equivalence)]).
nounMapping2SUMO('03610682-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03610836-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03610992-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03611169-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03611314-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03611590-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03612010-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('03612134-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03612378-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03612559-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03612814-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03612965-n',[ ('PercussionInstrument',subsumption)]).
nounMapping2SUMO('03613294-n',[ ('Key',equivalence)]).
nounMapping2SUMO('03613592-n',[ ('Lever',subsumption)]).
nounMapping2SUMO('03613873-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03614007-n',[ ('ComputerInputDevice',subsumption)]).
nounMapping2SUMO('03614383-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03614532-n',[ ('MusicalInstrument',subsumption)]).
nounMapping2SUMO('03614782-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03614887-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03615037-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03615133-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03615300-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03615406-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03615563-n',[ ('UniformClothing',subsumption)]).
nounMapping2SUMO('03615655-n',[ ('Veil',subsumption)]).
nounMapping2SUMO('03615790-n',[ ('CuttingDevice',subsumption)]).
nounMapping2SUMO('03615987-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03616091-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03616225-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03616428-n',[ ('Rod',subsumption)]).
nounMapping2SUMO('03616763-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03616979-n',[ ('Glove',subsumption)]).
nounMapping2SUMO('03617095-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03617312-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03617480-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03617594-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03617834-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03618101-n',[ ('GamePiece',subsumption)]).
nounMapping2SUMO('03618219-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03618339-n',[ ('GameShot',subsumption)]).
nounMapping2SUMO('03618546-n',[ ('Bolt',subsumption)]).
nounMapping2SUMO('03618678-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03618797-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03618982-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03619050-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03619196-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03619275-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03619396-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('03619650-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03619793-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03619890-n',[ ('Kitchen',equivalence)]).
nounMapping2SUMO('03620052-n',[ ('MajorAppliance',subsumption)]).
nounMapping2SUMO('03620353-n',[ ('KitchenArea',subsumption)]).
nounMapping2SUMO('03620443-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03620600-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03620730-n',[ ('MatchDevice',subsumption)]).
nounMapping2SUMO('03620889-n',[ ('WashBasin',subsumption)]).
nounMapping2SUMO('03620967-n',[ ('Table',subsumption)]).
nounMapping2SUMO('03621049-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03621377-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03621473-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03621694-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03621826-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03621935-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03622058-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03622207-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03622401-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03622526-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03622698-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03622839-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03622931-n',[ ('Sock',subsumption)]).
nounMapping2SUMO('03623073-n',[ ('BoardOrBlock',subsumption)]).
nounMapping2SUMO('03623198-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03623338-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03623448-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03623556-n',[ ('CuttingDevice',subsumption)]).
nounMapping2SUMO('03624134-n',[ ('CuttingDevice',subsumption)]).
nounMapping2SUMO('03624400-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03624497-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03624653-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03624767-n',[ ('GamePiece',subsumption)]).
nounMapping2SUMO('03624966-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03625226-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03625355-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03625539-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03625646-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03625783-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03625943-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03626014-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03626115-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03626272-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03626418-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03626502-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03626658-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03626760-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03626925-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('03627021-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03627232-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03627819-n',[ ('Whip',subsumption)]).
nounMapping2SUMO('03627954-n',[ ('MechanicalJoint',subsumption)]).
nounMapping2SUMO('03628071-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03628215-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('03628421-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03628511-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03628590-n',[ ('Building',instance)]).
nounMapping2SUMO('03628728-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03628831-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03628984-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03629100-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03629231-n',[ ('Shirt',subsumption)]).
nounMapping2SUMO('03629401-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03629520-n',[ ('Cup',subsumption)]).
nounMapping2SUMO('03629643-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03629857-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03629986-n',[ ('Laboratory',subsumption)]).
nounMapping2SUMO('03630262-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03630383-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('03630544-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03630849-n',[ ('Prison',subsumption)]).
nounMapping2SUMO('03630992-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03631177-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03631445-n',[ ('AttachingDevice',subsumption)]).
nounMapping2SUMO('03631710-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03631811-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03631922-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03632100-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('03632189-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03632277-n',[ ('Ladder',equivalence)]).
nounMapping2SUMO('03632577-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03632729-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('03632852-n',[ ('Truck',subsumption)]).
nounMapping2SUMO('03632963-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03633091-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03633341-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03633474-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03633632-n',[ ('PercussionInstrument',subsumption)]).
nounMapping2SUMO('03633886-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03634034-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03634189-n',[ ('Artifact',instance)]).
nounMapping2SUMO('03634469-n',[ ('Artifact',instance)]).
nounMapping2SUMO('03634723-n',[ ('Lake',instance)]).
nounMapping2SUMO('03634899-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03635032-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03635108-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03635236-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03635330-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03635452-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03635516-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03635668-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03635932-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03636062-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03636248-n',[ ('LightFixture',equivalence)]).
nounMapping2SUMO('03636649-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03636891-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03637027-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03637181-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03637318-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03637480-n',[ ('Lanai',equivalence)]).
nounMapping2SUMO('03637618-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03637787-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03637898-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03638014-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03638180-n',[ ('Spacecraft',subsumption)]).
nounMapping2SUMO('03638321-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03638511-n',[ ('Stairway',subsumption)]).
nounMapping2SUMO('03638623-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03638743-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03638883-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03639077-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03639230-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03639360-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03639497-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03639675-n',[ ('ExplosiveMine',subsumption)]).
nounMapping2SUMO('03639880-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03640011-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03640166-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03640288-n',[ ('CultivatedLandArea',subsumption)]).
nounMapping2SUMO('03640456-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03640589-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03640660-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03640850-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03640988-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('03641134-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03641302-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03641451-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03641569-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03641706-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03641947-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03642144-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03642341-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03642444-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03642573-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03642716-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03642806-n',[ ('Computer',subsumption)]).
nounMapping2SUMO('03642928-n',[ ('Left',subsumption)]).
nounMapping2SUMO('03643149-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03643253-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03643491-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('03643737-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03643907-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03644073-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03644248-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03644378-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03644532-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03644698-n',[ ('String',subsumption)]).
nounMapping2SUMO('03644858-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03645011-n',[ ('Lock',subsumption)]).
nounMapping2SUMO('03645168-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03645290-n',[ ('Key',subsumption)]).
nounMapping2SUMO('03645411-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03645577-n',[ ('Sail',subsumption)]).
nounMapping2SUMO('03645730-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03645866-n',[ ('Building',instance)]).
nounMapping2SUMO('03646020-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03646148-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03646296-n',[ ('Lathe',equivalence)]).
nounMapping2SUMO('03646546-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03646695-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03646809-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03646916-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03647108-n',[ ('Opium',subsumption)]).
nounMapping2SUMO('03647291-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03647423-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03647520-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03647691-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03647872-n',[ ('SelfServiceLaundry',equivalence)]).
nounMapping2SUMO('03648066-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03648219-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03648431-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03648527-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03648667-n',[ ('ValetLaundryService',subsumption)]).
nounMapping2SUMO('03648804-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03649003-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03649161-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03649288-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03649459-n',[ ('Government',subsumption)]).
nounMapping2SUMO('03649674-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('03649797-n',[ ('Furniture',subsumption)]).
nounMapping2SUMO('03649909-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03650084-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03650173-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03650551-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03650682-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03650803-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03650973-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03651084-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03651265-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03651388-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03651605-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03651739-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03651843-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03651947-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03652100-n',[ ('Pencil',equivalence)]).
nounMapping2SUMO('03652226-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03652389-n',[ ('LeafSpring',equivalence)]).
nounMapping2SUMO('03652530-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03652729-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03652826-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03652932-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03653110-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03653220-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03653376-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03653454-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03653583-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03653740-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03653833-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03653975-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03654086-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03654374-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03654576-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03654826-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03655072-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03655295-n',[ ('RecreationOrExerciseDevice',subsumption)]).
nounMapping2SUMO('03655470-n',[ ('CapacitorElement',subsumption)]).
nounMapping2SUMO('03655589-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03655720-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03655838-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03656011-n',[ ('Forest',subsumption)]).
nounMapping2SUMO('03656091-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03656231-n',[ ('LengthMeasure',equivalence)]).
nounMapping2SUMO('03656374-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03656484-n',[ ('Lens',subsumption)]).
nounMapping2SUMO('03656957-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03657121-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03657239-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03657511-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03657825-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('03657918-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('03658102-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03658185-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03658373-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03658635-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03658759-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03658858-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03659122-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03659292-n',[ ('Lever',equivalence)]).
nounMapping2SUMO('03659686-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03659809-n',[ ('Lever',equivalence)]).
nounMapping2SUMO('03659950-n',[ ('Lock',subsumption)]).
nounMapping2SUMO('03660124-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03660228-n',[ ('Bell',instance)]).
nounMapping2SUMO('03660394-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03660562-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03660664-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03660909-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03661043-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03661180-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03661340-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03661621-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03661861-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03662016-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03662207-n',[ ('BoatDeck',subsumption)]).
nounMapping2SUMO('03662301-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03662452-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03662601-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03662719-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03662887-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03663069-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03663234-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03663332-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03663433-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03663531-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03663781-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03663910-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03664159-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03664374-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03664514-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03664675-n',[ ('HoistingDevice',subsumption)]).
nounMapping2SUMO('03664840-n',[ ('Pump',subsumption)]).
nounMapping2SUMO('03664943-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03665083-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03665232-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03665366-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('03665851-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03665924-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03666238-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03666362-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03666591-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03666917-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03667060-n',[ ('OpticalDevice',subsumption)]).
nounMapping2SUMO('03667235-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03667380-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03667552-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03667664-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03667829-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03668067-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03668279-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03668488-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03668642-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03668803-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03668906-n',[ ('Circle',subsumption)]).
nounMapping2SUMO('03669094-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03669245-n',[ ('UnpoweredVehicle',subsumption), ('LandVehicle',subsumption)]).
nounMapping2SUMO('03669367-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03669534-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03669665-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03669886-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03670208-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03670339-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03670456-n',[ ('Monument',instance)]).
nounMapping2SUMO('03670622-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03670849-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03671272-n',[ ('RailroadTrack',subsumption)]).
nounMapping2SUMO('03671473-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03671668-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03671914-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03672097-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03672245-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03672352-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03672521-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03672638-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03672827-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03673027-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03673270-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03673450-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03673594-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03673767-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03673971-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03674270-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03674440-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03674591-n',[ ('GolfCourse',subsumption)]).
nounMapping2SUMO('03674731-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03674842-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03674946-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03675076-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03675235-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03675445-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03675558-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('03675780-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03675907-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03676006-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03676087-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03676175-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03676483-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03676623-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03676759-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03677026-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03677115-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03677231-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03677308-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03677540-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03677682-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03677766-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03677976-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03678220-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('03678362-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03678558-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03678729-n',[ ('Auditorium',subsumption)]).
nounMapping2SUMO('03678879-n',[ ('Axle',subsumption)]).
nounMapping2SUMO('03679037-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('03679174-n',[ ('UniformClothing',subsumption)]).
nounMapping2SUMO('03679274-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03679384-n',[ ('Residence',subsumption)]).
nounMapping2SUMO('03679712-n',[ ('SittingArea',subsumption)]).
nounMapping2SUMO('03679986-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03680248-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03680355-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('03680512-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('03680629-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03680734-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03680858-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03680942-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03681148-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03681477-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03681813-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03682024-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('03682189-n',[ ('Region',equivalence)]).
nounMapping2SUMO('03682380-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03682487-n',[ ('Lock',subsumption)]).
nounMapping2SUMO('03682877-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03683079-n',[ ('CanalLockGate',subsumption)]).
nounMapping2SUMO('03683341-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03683457-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03683606-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03683708-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03683995-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03684143-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03684224-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03684338-n',[ ('MechanicalNut',subsumption)]).
nounMapping2SUMO('03684489-n',[ ('WasherForBolt',subsumption)]).
nounMapping2SUMO('03684611-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03684740-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03684823-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('03685307-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03685486-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03685640-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03685820-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03685962-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03686130-n',[ ('LoftStyle',subsumption)]).
nounMapping2SUMO('03686363-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03686470-n',[ ('LoftStyle',subsumption)]).
nounMapping2SUMO('03686658-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03686924-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03687003-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03687137-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03687306-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03687448-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03687604-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03687688-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03687820-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('03687928-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03688066-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03688192-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03688316-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03688405-n',[ ('Sleeve',subsumption)]).
nounMapping2SUMO('03688504-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03688605-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('03688707-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03688832-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03688943-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03689157-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03689347-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03689443-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03689570-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03689700-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03689840-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03690005-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03690168-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03690279-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03690473-n',[ ('Truck',subsumption)]).
nounMapping2SUMO('03690600-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03690695-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03690851-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03690938-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03691128-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03691459-n',[ ('SpeakerDevice',subsumption)]).
nounMapping2SUMO('03691817-n',[ ('SittingArea',subsumption)]).
nounMapping2SUMO('03692004-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03692136-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03692272-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03692379-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03692522-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03692676-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03692842-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03692942-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03693089-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03693293-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03693474-n',[ ('Sofa',subsumption)]).
nounMapping2SUMO('03693617-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03693707-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03693860-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03693973-n',[ ('Below',subsumption)]).
nounMapping2SUMO('03694098-n',[ ('Below',subsumption)]).
nounMapping2SUMO('03694196-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03694356-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03694490-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03694639-n',[ ('AudioRecording',subsumption)]).
nounMapping2SUMO('03694761-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03694949-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03695122-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03695452-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('03695616-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03695753-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03695857-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03695957-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03696065-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03696301-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03696445-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('03696568-n',[ ('Sail',subsumption)]).
nounMapping2SUMO('03696746-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03696909-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('03697007-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03697109-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03697265-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03697366-n',[ ('Spacecraft',subsumption)]).
nounMapping2SUMO('03697552-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03697665-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03697812-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03697913-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03698123-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03698226-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03698360-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('03698604-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03698723-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03698815-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03698977-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('03699138-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03699280-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('03699396-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03699591-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03699754-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03699975-n',[ ('Machine',equivalence)]).
nounMapping2SUMO('03700963-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03701191-n',[ ('Bolt',subsumption)]).
nounMapping2SUMO('03701391-n',[ ('AutomaticGun',subsumption)]).
nounMapping2SUMO('03701640-n',[ ('Machine',equivalence)]).
nounMapping2SUMO('03701790-n',[ ('Screw',subsumption)]).
nounMapping2SUMO('03701947-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03702067-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03702248-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03702440-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03702582-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03702719-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03702904-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03703075-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03703203-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03703320-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03703463-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('03703590-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03703730-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03703862-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03703945-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03704038-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03704210-n',[ ('Book',subsumption)]).
nounMapping2SUMO('03704376-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03704549-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03704640-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03704834-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03704926-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03705134-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03705379-n',[ ('Magnet',equivalence)]).
nounMapping2SUMO('03705808-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03706016-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03706229-n',[ ('Compass',subsumption)]).
nounMapping2SUMO('03706415-n',[ ('ComputerMemory',subsumption)]).
nounMapping2SUMO('03706653-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03706939-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03707171-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03707372-n',[ ('Magnet',subsumption)]).
nounMapping2SUMO('03707597-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03707766-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03708036-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03708425-n',[ ('ElectricDevice',subsumption)]).
nounMapping2SUMO('03708672-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03708843-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03708962-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03709206-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03709363-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03709454-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03709545-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03709644-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03709823-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03709960-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03710079-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03710193-n',[ ('Mailbox',subsumption)]).
nounMapping2SUMO('03710294-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('03710421-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03710528-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03710637-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03710721-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03710819-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03710937-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03711044-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03711145-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03711384-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03711459-n',[ ('Above',subsumption)]).
nounMapping2SUMO('03711603-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03711711-n',[ ('Computer',subsumption)]).
nounMapping2SUMO('03711897-n',[ ('Transitway',subsumption)]).
nounMapping2SUMO('03711999-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03712111-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03712337-n',[ ('Sail',subsumption)]).
nounMapping2SUMO('03712444-n',[ ('Spring',subsumption)]).
nounMapping2SUMO('03712637-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03712729-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03712887-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03712981-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03713069-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03713151-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03713254-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03713436-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03713556-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03713736-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03714235-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03714610-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('03714721-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03714899-n',[ ('Creation',equivalence)]).
nounMapping2SUMO('03715114-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03715275-n',[ ('WalkingCane',subsumption)]).
nounMapping2SUMO('03715386-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03715669-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03715892-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03716091-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03716228-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03716327-n',[ ('GamePiece',subsumption)]).
nounMapping2SUMO('03716656-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03716887-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('03716966-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('03717131-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03717285-n',[ ('ClothesDryer',subsumption)]).
nounMapping2SUMO('03717447-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03717622-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03717750-n',[ ('Manifold',equivalence)]).
nounMapping2SUMO('03717921-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03718056-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03718212-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03718335-n',[ ('PressureMeasuringDevice',subsumption)]).
nounMapping2SUMO('03718458-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03718581-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03718699-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03718789-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03718935-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03719053-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03719249-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03719343-n',[ ('Shelf',subsumption)]).
nounMapping2SUMO('03719560-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03719650-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03719743-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03719826-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03719911-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03720005-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('03720163-n',[ ('Map',subsumption)]).
nounMapping2SUMO('03720443-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03720665-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03720891-n',[ ('PercussionInstrument',subsumption)]).
nounMapping2SUMO('03721047-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('03721169-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03721252-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03721384-n',[ ('PercussionInstrument',subsumption)]).
nounMapping2SUMO('03721590-n',[ ('Harbor',subsumption)]).
nounMapping2SUMO('03721691-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03721797-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03722007-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03722169-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03722288-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03722552-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03722646-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03722827-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03722944-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03723054-n',[ ('ExplosiveDevice',subsumption)]).
nounMapping2SUMO('03723153-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03723267-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03723439-n',[ ('Bed',subsumption)]).
nounMapping2SUMO('03723534-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03723653-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03723781-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03723885-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03724066-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03724176-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03724417-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03724538-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03724623-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03724756-n',[ ('ReligiousBuilding',subsumption)]).
nounMapping2SUMO('03724870-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03725035-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03725198-n',[ ('PerformanceStage',subsumption)]).
nounMapping2SUMO('03725355-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03725506-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03725600-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03725717-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03725869-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03725968-n',[ ('University',instance)]).
nounMapping2SUMO('03726116-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03726233-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03726371-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03726516-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03726760-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03726993-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03727067-n',[ ('Tomb',subsumption)]).
nounMapping2SUMO('03727274-n',[ ('Recording',subsumption)]).
nounMapping2SUMO('03727465-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03727605-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03727738-n',[ ('Mast',subsumption)]).
nounMapping2SUMO('03727837-n',[ ('Rug',subsumption)]).
nounMapping2SUMO('03727946-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03728131-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03728318-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03728437-n',[ ('MatchDevice',subsumption)]).
nounMapping2SUMO('03728811-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03728982-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03729131-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03729308-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03729402-n',[ ('Box',subsumption)]).
nounMapping2SUMO('03729482-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03729647-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03729826-n',[ ('Wood',subsumption)]).
nounMapping2SUMO('03729951-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03730153-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03730334-n',[ ('Hospital',subsumption)]).
nounMapping2SUMO('03730494-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03730655-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03730788-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03730893-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03731019-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03731164-n',[ ('Mattress',equivalence)]).
nounMapping2SUMO('03731483-n',[ ('BedLinen',subsumption)]).
nounMapping2SUMO('03731590-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03731695-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03731882-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03732020-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03732114-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03732252-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03732458-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03732543-n',[ ('AutomaticGun',subsumption)]).
nounMapping2SUMO('03732658-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('03732828-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03732992-n',[ ('TransportationDevice',instance)]).
nounMapping2SUMO('03733131-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03733281-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03733465-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03733547-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03733644-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03733805-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03733925-n',[ ('MeasuringDevice',equivalence)]).
nounMapping2SUMO('03735637-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03735963-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03736064-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03736147-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03736269-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03736372-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03736470-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('03736674-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03736809-n',[ ('RecreationOrExerciseDevice',subsumption)]).
nounMapping2SUMO('03736970-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03737912-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03738066-n',[ ('Piano',subsumption)]).
nounMapping2SUMO('03738241-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03738472-n',[ ('EngineeringComponent',equivalence)]).
nounMapping2SUMO('03739136-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03739327-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03739518-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03739693-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03740161-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03742019-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03742115-n',[ ('ChestOrCabinet',subsumption)]).
nounMapping2SUMO('03742238-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03742416-n',[ ('SmokingPipe',subsumption)]).
nounMapping2SUMO('03742531-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03742728-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03743016-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03743279-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03743422-n',[ ('NuclearWeapon',subsumption)]).
nounMapping2SUMO('03743577-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03743761-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03743902-n',[ ('Monument',subsumption)]).
nounMapping2SUMO('03744276-n',[ ('ComputerMemory',equivalence)]).
nounMapping2SUMO('03744684-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03744840-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03745146-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03745285-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03745487-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03745571-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03745712-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('03745864-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('03746005-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03746155-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03746330-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03746486-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03746574-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03746861-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03746994-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03747103-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03747281-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03747508-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03747746-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03748002-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03748162-n',[ ('RetailStore',subsumption)]).
nounMapping2SUMO('03748456-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03748691-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03748886-n',[ ('Product',subsumption)]).
nounMapping2SUMO('03749409-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03749504-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03749634-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03749807-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('03750206-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03750437-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03750540-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03750614-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03750748-n',[ ('WaterVehicle',instance)]).
nounMapping2SUMO('03750912-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03751065-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03751269-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03751458-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03751590-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03751757-n',[ ('MeasuringDevice',subsumption)]).
nounMapping2SUMO('03751977-n',[ ('String',subsumption)]).
nounMapping2SUMO('03752071-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03752185-n',[ ('Screw',subsumption)]).
nounMapping2SUMO('03752262-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03752398-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03752521-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03752649-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03752922-n',[ ('Balloon',subsumption)]).
nounMapping2SUMO('03753077-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03753514-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03753657-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03753826-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03754014-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03754295-n',[ ('Stimulant',subsumption)]).
nounMapping2SUMO('03754676-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03754822-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03754979-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03755140-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03755388-n',[ ('Penicillin',subsumption)]).
nounMapping2SUMO('03755545-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03755712-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03755991-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03756184-n',[ ('Stimulant',subsumption)]).
nounMapping2SUMO('03756624-n',[ ('Stimulant',subsumption)]).
nounMapping2SUMO('03756857-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03757138-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03757428-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03757604-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03757723-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03757925-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03758089-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03758220-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03758334-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03758478-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03758614-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03758720-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03758894-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03758992-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03759114-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03759243-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('03759432-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('03759661-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03759795-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03759954-n',[ ('Microphone',equivalence)]).
nounMapping2SUMO('03760164-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03760310-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03760671-n',[ ('Microscope',subsumption)]).
nounMapping2SUMO('03760944-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03761084-n',[ ('Microwave',equivalence)]).
nounMapping2SUMO('03761333-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('03761588-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03761731-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03761845-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03762067-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03762238-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03762332-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03762434-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03762602-n',[ ('PrayerMat',subsumption)]).
nounMapping2SUMO('03762809-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03762982-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03763133-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03763403-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03763727-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03763968-n',[ ('UniformClothing',subsumption)]).
nounMapping2SUMO('03764276-n',[ ('MilitaryVehicle',equivalence)]).
nounMapping2SUMO('03764606-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03764736-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03764822-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03764995-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03765128-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('03765269-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03765467-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03765561-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03765934-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03766044-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03766218-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03766322-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('03766508-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03766600-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03766697-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03766816-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03766935-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03767112-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03767203-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03767363-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03767459-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03767745-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03767846-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03767966-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03768132-n',[ ('ExplosiveMine',equivalence)]).
nounMapping2SUMO('03768346-n',[ ('Mine',equivalence)]).
nounMapping2SUMO('03768683-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03768823-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03768916-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03769100-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03769235-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03769397-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03769610-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03769722-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03769881-n',[ ('PassengerVehicle',subsumption)]).
nounMapping2SUMO('03769967-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('03770085-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('03770224-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03770316-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03770439-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03770520-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03770679-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('03770834-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03770954-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03771066-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03771261-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03771443-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03771820-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03772077-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03772269-n',[ ('IndustrialPlant',subsumption)]).
nounMapping2SUMO('03772417-n',[ ('Gun',subsumption)]).
nounMapping2SUMO('03772584-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03772674-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03772881-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03773035-n',[ ('Mirror',subsumption)]).
nounMapping2SUMO('03773268-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03773504-n',[ ('Missile',equivalence)]).
nounMapping2SUMO('03773835-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03773970-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03774124-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03774327-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03774461-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03774673-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03774842-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03775071-n',[ ('Glove',subsumption)]).
nounMapping2SUMO('03775199-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03775388-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03775546-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03775636-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03775747-n',[ ('Sail',subsumption)]).
nounMapping2SUMO('03775847-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03776050-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03776167-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03776291-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03776460-n',[ ('Trailer',subsumption)]).
nounMapping2SUMO('03776673-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03776877-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('03776997-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03777126-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03777283-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03777568-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('03777754-n',[ ('Modem',equivalence)]).
nounMapping2SUMO('03777961-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03778135-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03778302-n',[ ('Process',subsumption)]).
nounMapping2SUMO('03778459-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03778600-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03778817-n',[ ('ComputerHardware',subsumption)]).
nounMapping2SUMO('03779000-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03779128-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03779246-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03779370-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03779621-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03779884-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03780047-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03780247-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03780392-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03780799-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03780896-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03781055-n',[ ('MolotovCocktail',equivalence)]).
nounMapping2SUMO('03781244-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03781467-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03781594-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03781683-n',[ ('Belt',subsumption)]).
nounMapping2SUMO('03781787-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03782006-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03782190-n',[ ('ComputerTerminal',subsumption)]).
nounMapping2SUMO('03782430-n',[ ('WaterVehicle',instance)]).
nounMapping2SUMO('03782558-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03782689-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03782794-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03782929-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03783017-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03783304-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03783430-n',[ ('EyeGlass',subsumption)]).
nounMapping2SUMO('03783575-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03783755-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03783873-n',[ ('Airplane',subsumption)]).
nounMapping2SUMO('03783959-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03784053-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03784139-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03784270-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03784475-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03784666-n',[ ('Anchor',subsumption)]).
nounMapping2SUMO('03784793-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03784896-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03785016-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03785142-n',[ ('Handle',subsumption)]).
nounMapping2SUMO('03785237-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03785361-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03785499-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03785721-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03785843-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('03786096-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03786194-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03786313-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03786417-n',[ ('Opium',subsumption)]).
nounMapping2SUMO('03786621-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03786715-n',[ ('MortarGun',subsumption)]).
nounMapping2SUMO('03786901-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03787032-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03787164-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03787308-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03787523-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03787759-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03787904-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03788047-n',[ ('ElectricDevice',subsumption)]).
nounMapping2SUMO('03788195-n',[ ('ReligiousBuilding',subsumption)]).
nounMapping2SUMO('03788365-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03788498-n',[ ('TravelerAccommodation',subsumption)]).
nounMapping2SUMO('03788601-n',[ ('HotelRoom',subsumption)]).
nounMapping2SUMO('03788703-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03788914-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03789014-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03789171-n',[ ('Camera',subsumption)]).
nounMapping2SUMO('03789400-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03789603-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03789794-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03789946-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03790230-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03790512-n',[ ('PoweredVehicle',subsumption), ('LandVehicle',subsumption), ('PassengerVehicle',subsumption)]).
nounMapping2SUMO('03790755-n',[ ('TravelerAccommodation',subsumption)]).
nounMapping2SUMO('03790953-n',[ ('Wheelchair',subsumption)]).
nounMapping2SUMO('03791053-n',[ ('PassengerVehicle',subsumption), ('PoweredVehicle',subsumption), ('LandVehicle',subsumption)]).
nounMapping2SUMO('03791235-n',[ ('Automobile',equivalence)]).
nounMapping2SUMO('03792048-n',[ ('Hill',subsumption)]).
nounMapping2SUMO('03792334-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03792526-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03792782-n',[ ('Bicycle',subsumption)]).
nounMapping2SUMO('03792972-n',[ ('Tent',subsumption)]).
nounMapping2SUMO('03793090-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('03793186-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03793387-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03793489-n',[ ('ComputerInputDevice',subsumption)]).
nounMapping2SUMO('03793850-n',[ ('SwitchDevice',subsumption)]).
nounMapping2SUMO('03793954-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03794056-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03794136-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03794291-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03794392-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03794540-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03794655-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03794798-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03794957-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('03795123-n',[ ('Microphone',subsumption)]).
nounMapping2SUMO('03795269-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03795419-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03795580-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03795758-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03795976-n',[ ('MultimediaProjector',subsumption)]).
nounMapping2SUMO('03796181-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03796401-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03796522-n',[ ('Brick',subsumption)]).
nounMapping2SUMO('03796605-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03796848-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03796974-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03797062-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03797182-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03797264-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03797390-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03797548-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03797703-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03797896-n',[ ('Soil',subsumption)]).
nounMapping2SUMO('03798061-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03798165-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03798268-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03798442-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03798610-n',[ ('Airplane',subsumption)]).
nounMapping2SUMO('03798729-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03798982-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('03799113-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03799240-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03799375-n',[ ('Rocket',subsumption)]).
nounMapping2SUMO('03799610-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03799710-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03799876-n',[ ('MurphyBed',equivalence)]).
nounMapping2SUMO('03800001-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03800371-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03800485-n',[ ('Oboe',subsumption)]).
nounMapping2SUMO('03800563-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03800772-n',[ ('Anchor',subsumption)]).
nounMapping2SUMO('03800933-n',[ ('MusicalInstrument',equivalence)]).
nounMapping2SUMO('03801353-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03801533-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03801671-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('03801760-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03801880-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('03802007-n',[ ('Rifle',subsumption)]).
nounMapping2SUMO('03802228-n',[ ('Bullet',subsumption)]).
nounMapping2SUMO('03802393-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03802507-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03802643-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03802800-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03802973-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03803116-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03803284-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03803488-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03803610-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03803780-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03803911-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03804048-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03804211-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03804311-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03804493-n',[ ('Penicillin',subsumption)]).
nounMapping2SUMO('03804744-n',[ ('Nail',equivalence)]).
nounMapping2SUMO('03805180-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03805280-n',[ ('FileDevice',subsumption)]).
nounMapping2SUMO('03805374-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03805503-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03805634-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03805725-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03805933-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03806040-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03806180-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03806381-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03806547-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03806652-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03806748-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03806904-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03807052-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03807334-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03807537-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03807780-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03807895-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03808144-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03808424-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03808564-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03808977-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03809211-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03809312-n',[ ('Airplane',subsumption)]).
nounMapping2SUMO('03809456-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03809603-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03809686-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03809802-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03809939-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03810186-n',[ ('Organization',instance)]).
nounMapping2SUMO('03810412-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('03810561-n',[ ('Building',instance)]).
nounMapping2SUMO('03810741-n',[ ('Building',instance)]).
nounMapping2SUMO('03810952-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('03811163-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('03811295-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03811444-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03811648-n',[ ('Map',subsumption)]).
nounMapping2SUMO('03811847-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03811965-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03812119-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03812263-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03812382-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03812541-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('03812789-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03812924-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03813078-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03813176-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03813369-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('03813612-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03813704-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03813834-n',[ ('Near',subsumption)]).
nounMapping2SUMO('03813946-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03814112-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03814348-n',[ ('Peninsula',subsumption)]).
nounMapping2SUMO('03814528-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03814639-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03814727-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03814817-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03814906-n',[ ('Jewelry',subsumption)]).
nounMapping2SUMO('03815149-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03815278-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03815482-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03815615-n',[ ('TieClothing',subsumption)]).
nounMapping2SUMO('03816005-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03816136-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03816394-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03816530-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03816659-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03816849-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03817062-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03817191-n',[ ('Photograph',subsumption)]).
nounMapping2SUMO('03817331-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03817522-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03817647-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03817830-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03818001-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03818090-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03818343-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03818629-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03818843-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03819047-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03819217-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03819336-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03819448-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03819595-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03819994-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03820154-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03820318-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03820474-n',[ ('BroadcastNetwork',subsumption)]).
nounMapping2SUMO('03820728-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03820950-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03821145-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03821259-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03821424-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03821518-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03821660-n',[ ('Building',instance)]).
nounMapping2SUMO('03821898-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('03822015-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03822171-n',[ ('Newspaper',equivalence)]).
nounMapping2SUMO('03822361-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03822504-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03822656-n',[ ('NewsDealersAndNewsstands',subsumption)]).
nounMapping2SUMO('03822767-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03822951-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03823111-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03823216-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03823312-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03823540-n',[ ('Cutting',subsumption)]).
nounMapping2SUMO('03823673-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03823906-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03824014-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03824197-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03824284-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03824381-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03824589-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03824713-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('03824867-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03824999-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03825080-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03825271-n',[ ('GamePiece',subsumption)]).
nounMapping2SUMO('03825442-n',[ ('BowlingBall',subsumption)]).
nounMapping2SUMO('03825548-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03825673-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03825788-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('03825913-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03826039-n',[ ('Niqab',equivalence)]).
nounMapping2SUMO('03826186-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03826331-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03826443-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03826762-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03826945-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03827107-n',[ ('Computer',subsumption)]).
nounMapping2SUMO('03827284-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03827420-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03827536-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03827716-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03827830-n',[ ('Computer',subsumption)]).
nounMapping2SUMO('03828020-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('03828155-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03828465-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03829085-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03829340-n',[ ('ComputerMemory',subsumption)]).
nounMapping2SUMO('03829563-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03829857-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03829954-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03830111-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03830278-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03830448-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03830582-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03830835-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03831062-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03831203-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03831382-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03831537-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03831757-n',[ ('Flute',subsumption)]).
nounMapping2SUMO('03831899-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03832008-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03832144-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03832305-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03832405-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03832673-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03832799-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03832973-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03833065-n',[ ('Book',subsumption)]).
nounMapping2SUMO('03833294-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('03833409-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03833564-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03833750-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03833907-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03834040-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03834472-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03834604-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03834836-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03835197-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03835298-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03835412-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03835582-n',[ ('Computer',subsumption)]).
nounMapping2SUMO('03835729-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03835853-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('03835941-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03836062-n',[ ('Nursery',equivalence)]).
nounMapping2SUMO('03836191-n',[ ('MechanicalNut',equivalence)]).
nounMapping2SUMO('03836451-n',[ ('AttachingDevice',subsumption)]).
nounMapping2SUMO('03836602-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03836699-n',[ ('Stimulant',subsumption)]).
nounMapping2SUMO('03836906-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03836976-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03837157-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03837422-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03837606-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03837698-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03837869-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03838024-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('03838160-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('03838298-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03838535-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03838748-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03838899-n',[ ('Oboe',equivalence)]).
nounMapping2SUMO('03839172-n',[ ('Oboe',subsumption)]).
nounMapping2SUMO('03839276-n',[ ('Oboe',subsumption)]).
nounMapping2SUMO('03839424-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03839534-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03839671-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03839795-n',[ ('Process',subsumption)]).
nounMapping2SUMO('03839993-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03840327-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03840507-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('03840681-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03840823-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03841011-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03841143-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03841290-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03841417-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03841666-n',[ ('OfficeBuilding',equivalence)]).
nounMapping2SUMO('03842012-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03842156-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03842276-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03842377-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03842585-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03842754-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03842868-n',[ ('University',instance)]).
nounMapping2SUMO('03842986-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03843092-n',[ ('Paint',subsumption)]).
nounMapping2SUMO('03843221-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03843316-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03843438-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03843555-n',[ ('Filter',subsumption)]).
nounMapping2SUMO('03843724-n',[ ('FinancialContract',subsumption)]).
nounMapping2SUMO('03843883-n',[ ('HeatingDevice',subsumption)]).
nounMapping2SUMO('03844045-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03844233-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03844349-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03844459-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03844550-n',[ ('Pump',subsumption)]).
nounMapping2SUMO('03844673-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03844815-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03844965-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03845107-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03845190-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03845360-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03845550-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03845990-n',[ ('TieClothing',subsumption)]).
nounMapping2SUMO('03846100-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03846234-n',[ ('UniformClothing',subsumption)]).
nounMapping2SUMO('03846431-n',[ ('Sculpture',subsumption)]).
nounMapping2SUMO('03846677-n',[ ('PotOrPan',subsumption)]).
nounMapping2SUMO('03846772-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03846970-n',[ ('ReceiverDevice',subsumption)]).
nounMapping2SUMO('03847214-n',[ ('GamePiece',subsumption)]).
nounMapping2SUMO('03847334-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03847471-n',[ ('Roof',subsumption)]).
nounMapping2SUMO('03847622-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03847823-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03848033-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03848168-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03848348-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03848537-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03848729-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03849275-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03849412-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03849538-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03849679-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03849814-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03849943-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03850053-n',[ ('Microscope',subsumption)]).
nounMapping2SUMO('03850245-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03850492-n',[ ('Table',subsumption)]).
nounMapping2SUMO('03850613-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03850746-n',[ ('Opium',subsumption)]).
nounMapping2SUMO('03850966-n',[ ('Opium',equivalence)]).
nounMapping2SUMO('03851124-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03851219-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03851341-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03851787-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03852031-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03852280-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03852544-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03852688-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03852908-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03853023-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03853103-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('03853178-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03853291-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03853454-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03853588-n',[ ('Book',subsumption)]).
nounMapping2SUMO('03853734-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03853924-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03854065-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03854421-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03854506-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03854722-n',[ ('LoftStyle',subsumption)]).
nounMapping2SUMO('03854815-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03854998-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03855214-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03855333-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03855464-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03855604-n',[ ('ORing',equivalence)]).
nounMapping2SUMO('03855756-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03855908-n',[ ('Below',subsumption)]).
nounMapping2SUMO('03856012-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03856148-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03856335-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03856465-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03856728-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03857026-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03857156-n',[ ('Aircraft',subsumption)]).
nounMapping2SUMO('03857291-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03857430-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03857588-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('03857687-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03857828-n',[ ('ElectricDevice',subsumption)]).
nounMapping2SUMO('03858085-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03858183-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03858418-n',[ ('Seat',subsumption)]).
nounMapping2SUMO('03858533-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03858662-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03858837-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03859000-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03859170-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03859280-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03859495-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03859608-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03859717-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03859958-n',[ ('Outfit',equivalence)]).
nounMapping2SUMO('03860234-n',[ ('RetailStore',subsumption)]).
nounMapping2SUMO('03860404-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03860569-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03860741-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03860882-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03861048-n',[ ('ComputerOutputDevice',equivalence)]).
nounMapping2SUMO('03861271-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03861430-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03861596-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03861731-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03861842-n',[ ('Mirror',subsumption)]).
nounMapping2SUMO('03861959-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03862190-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('03862379-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03862531-n',[ ('OfficeBuilding',instance)]).
nounMapping2SUMO('03862676-n',[ ('CookingOven',equivalence)]).
nounMapping2SUMO('03862862-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('03862984-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03863108-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('03863262-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03863442-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03863657-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('03863783-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03863923-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03864139-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03864254-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03864356-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03864542-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03864692-n',[ ('MultimediaProjector',subsumption)]).
nounMapping2SUMO('03864834-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03864994-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03865171-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('03865288-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03865371-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03865557-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03865704-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('03865820-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03865949-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03866082-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03866176-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03866350-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03866555-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03866721-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03866908-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03867070-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03867201-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03867355-n',[ ('Penicillin',subsumption)]).
nounMapping2SUMO('03867515-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03867675-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03867854-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03868044-n',[ ('University',instance)]).
nounMapping2SUMO('03868242-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03868324-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03868406-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('03868509-n',[ ('University',instance)]).
nounMapping2SUMO('03868643-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03868763-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03868863-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03869044-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03869222-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03869389-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03869685-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03869838-n',[ ('Tavern',subsumption)]).
nounMapping2SUMO('03869976-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03870105-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('03870290-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03870461-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03870546-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03870672-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03870822-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03870980-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03871083-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03871255-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03871371-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03871524-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03871628-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03871724-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03871860-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03872016-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03872167-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03872273-n',[ ('Saddle',subsumption)]).
nounMapping2SUMO('03872386-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03872495-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03872885-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03873064-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03873416-n',[ ('Oar',subsumption)]).
nounMapping2SUMO('03873574-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03873699-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03873848-n',[ ('GameArtifact',subsumption)]).
nounMapping2SUMO('03873996-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03874138-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03874293-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03874487-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03874599-n',[ ('Lock',subsumption)]).
nounMapping2SUMO('03874823-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03874965-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03875088-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03875218-n',[ ('Paint',subsumption)]).
nounMapping2SUMO('03875806-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03875955-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03876111-n',[ ('Box',subsumption)]).
nounMapping2SUMO('03876231-n',[ ('PaintingDevice',subsumption)]).
nounMapping2SUMO('03876352-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03876519-n',[ ('PaintedPicture',equivalence)]).
nounMapping2SUMO('03877229-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03877351-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03877472-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03877674-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('03877845-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03878066-n',[ ('House',subsumption)]).
nounMapping2SUMO('03878211-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03878294-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03878418-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03878511-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('03878674-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03878828-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03878963-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03879116-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03879336-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03879456-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03879582-n',[ ('Holder',subsumption)]).
nounMapping2SUMO('03879705-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03879854-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03880032-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03880129-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03880323-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03880531-n',[ ('PotOrPan',equivalence)]).
nounMapping2SUMO('03880770-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03880951-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03881034-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03881207-n',[ ('CigarOrCigarette',subsumption)]).
nounMapping2SUMO('03881305-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03881404-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03881534-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('03881625-n',[ ('Artifact',instance)]).
nounMapping2SUMO('03881893-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03882058-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03882346-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03882430-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('03882611-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03882861-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('03882960-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03883054-n',[ ('SwitchDevice',subsumption)]).
nounMapping2SUMO('03883278-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03883385-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03883524-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03883664-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03883773-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03883944-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03884072-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03884232-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03884397-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03884554-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('03884639-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03884778-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03884926-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03885028-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03885194-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03885293-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03885410-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03885535-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03885669-n',[ ('ClothingSuit',subsumption)]).
nounMapping2SUMO('03885788-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03885904-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03886053-n',[ ('ArmoredVehicle',subsumption)]).
nounMapping2SUMO('03886151-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03886237-n',[ ('Opium',subsumption)]).
nounMapping2SUMO('03886432-n',[ ('Book',subsumption)]).
nounMapping2SUMO('03886641-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03886762-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03886940-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03887066-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03887185-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03887330-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03887512-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03887603-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('03887697-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03887797-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03887899-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03888022-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03888257-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03888605-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03888808-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03888998-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03889208-n',[ ('Magnet',subsumption)]).
nounMapping2SUMO('03889397-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03889503-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03889626-n',[ ('Wall',subsumption)]).
nounMapping2SUMO('03889726-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03889871-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03889974-n',[ ('Opium',subsumption)]).
nounMapping2SUMO('03890093-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03890233-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03890358-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03890514-n',[ ('Computer',subsumption)]).
nounMapping2SUMO('03890713-n',[ ('University',instance)]).
nounMapping2SUMO('03890881-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03891051-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03891251-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03891332-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03891538-n',[ ('SittingArea',subsumption)]).
nounMapping2SUMO('03891664-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('03891851-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03892035-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03892178-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03892273-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03892425-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03892557-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03892728-n',[ ('Table',subsumption)]).
nounMapping2SUMO('03892891-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03893603-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03893732-n',[ ('Building',instance)]).
nounMapping2SUMO('03893935-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03894051-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03894217-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03894379-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03894677-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03894762-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03894933-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03895038-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03895170-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03895293-n',[ ('Transitway',subsumption)]).
nounMapping2SUMO('03895585-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03895866-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('03896103-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03896233-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03896419-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03896526-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03896628-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03896984-n',[ ('Key',subsumption)]).
nounMapping2SUMO('03897130-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03897334-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03897520-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03897634-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03897759-n',[ ('Food',subsumption)]).
nounMapping2SUMO('03897943-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03898129-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03898271-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03898395-n',[ ('Pocket',subsumption)]).
nounMapping2SUMO('03898500-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03898633-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03898787-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03898936-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03899100-n',[ ('Elevator',subsumption)]).
nounMapping2SUMO('03899328-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03899533-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('03899612-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03899768-n',[ ('Patio',equivalence)]).
nounMapping2SUMO('03899933-n',[ ('Bakery',subsumption)]).
nounMapping2SUMO('03900028-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03900104-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03900194-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03900301-n',[ ('PotOrPan',subsumption)]).
nounMapping2SUMO('03900393-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03900509-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03900750-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03900979-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03901074-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03901229-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03901338-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03901548-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03901750-n',[ ('GamePiece',subsumption)]).
nounMapping2SUMO('03901974-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03902125-n',[ ('Telephone',subsumption)]).
nounMapping2SUMO('03902220-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03902381-n',[ ('Pistol',subsumption)]).
nounMapping2SUMO('03902482-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03902564-n',[ ('Artifact',instance)]).
nounMapping2SUMO('03902756-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03902869-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03902972-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03903133-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03903290-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03903424-n',[ ('Lever',subsumption)]).
nounMapping2SUMO('03903733-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('03903868-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03904060-n',[ ('Table',subsumption)]).
nounMapping2SUMO('03904183-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03904433-n',[ ('SelfPoweredRoadVehicle',subsumption)]).
nounMapping2SUMO('03904657-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03904782-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03904909-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03905053-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03905208-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03905361-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03905540-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03905730-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03905947-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03906106-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03906224-n',[ ('DisplayArtifact',subsumption)]).
nounMapping2SUMO('03906355-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03906463-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03906590-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03906789-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03906894-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03906997-n',[ ('WritingDevice',subsumption)]).
nounMapping2SUMO('03907227-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03907475-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03907654-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03907908-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03908111-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03908204-n',[ ('Pencil',equivalence)]).
nounMapping2SUMO('03908456-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03908618-n',[ ('Box',subsumption)]).
nounMapping2SUMO('03908714-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03908831-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03909020-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03909160-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03909406-n',[ ('Clock',subsumption)]).
nounMapping2SUMO('03909516-n',[ ('WatchClock',subsumption)]).
nounMapping2SUMO('03909658-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('03909835-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03910033-n',[ ('Penicillin',equivalence)]).
nounMapping2SUMO('03910417-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03910601-n',[ ('Penicillin',subsumption)]).
nounMapping2SUMO('03910723-n',[ ('Penicillin',subsumption)]).
nounMapping2SUMO('03910887-n',[ ('Penicillin',subsumption)]).
nounMapping2SUMO('03911039-n',[ ('Penicillin',subsumption)]).
nounMapping2SUMO('03911251-n',[ ('Penicillin',subsumption)]).
nounMapping2SUMO('03911406-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03911513-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03911658-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03911767-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03911866-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03911992-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03912105-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03912218-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03912328-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03912496-n',[ ('Building',instance)]).
nounMapping2SUMO('03912664-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03912821-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03912929-n',[ ('PaintedPicture',subsumption)]).
nounMapping2SUMO('03913129-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03913343-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03913437-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03913702-n',[ ('Stimulant',subsumption)]).
nounMapping2SUMO('03913930-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03914106-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03914231-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03914337-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03914438-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03914583-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03914831-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03914919-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03915118-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03915320-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03915437-n',[ ('PercussionInstrument',subsumption)]).
nounMapping2SUMO('03915900-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03916031-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03916289-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03916385-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03916470-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('03916581-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03916720-n',[ ('ComputerHardware',subsumption)]).
nounMapping2SUMO('03917048-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03917198-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03917327-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03917455-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03917622-n',[ ('Magnet',subsumption)]).
nounMapping2SUMO('03917814-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03917973-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('03918074-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03918297-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03918480-n',[ ('Computer',subsumption)]).
nounMapping2SUMO('03918737-n',[ ('Computer',subsumption)]).
nounMapping2SUMO('03919096-n',[ ('APC',subsumption)]).
nounMapping2SUMO('03919289-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03919430-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03919702-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03919808-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03919974-n',[ ('Collar',subsumption)]).
nounMapping2SUMO('03920087-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03920181-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('03920288-n',[ ('Dish',subsumption)]).
nounMapping2SUMO('03920384-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03920497-n',[ ('Building',instance)]).
nounMapping2SUMO('03920641-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03920737-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03920867-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03920989-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03921209-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03921337-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03921499-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03921749-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03921915-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03922109-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03922412-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03922561-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03922722-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03922863-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03923004-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03923229-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03923379-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03923564-n',[ ('Screw',subsumption)]).
nounMapping2SUMO('03923692-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03923801-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03923918-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03924069-n',[ ('AudioRecording',subsumption)]).
nounMapping2SUMO('03924407-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03924532-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03924679-n',[ ('Photocopier',equivalence)]).
nounMapping2SUMO('03924811-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03924978-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03925226-n',[ ('Photograph',equivalence)]).
nounMapping2SUMO('03926061-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03926148-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03926412-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03926575-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03926757-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03926876-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03927091-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03927201-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03927299-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03927539-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03927652-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03927792-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03928001-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03928116-n',[ ('Piano',equivalence)]).
nounMapping2SUMO('03928589-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03928814-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03928994-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03929091-n',[ ('Flute',subsumption)]).
nounMapping2SUMO('03929202-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03929443-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03929660-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03929855-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03929952-n',[ ('Fence',subsumption)]).
nounMapping2SUMO('03930087-n',[ ('Vehicle',subsumption)]).
nounMapping2SUMO('03930229-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03930313-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03930431-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03930515-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03930630-n',[ ('Truck',subsumption)]).
nounMapping2SUMO('03930777-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03930946-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03931044-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03931651-n',[ ('Book',subsumption)]).
nounMapping2SUMO('03931765-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03931885-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03931980-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03932080-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03932203-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('03932499-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('03932670-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03933183-n',[ ('Leather',subsumption)]).
nounMapping2SUMO('03933391-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03933529-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03933933-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03934042-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03934229-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03934311-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03934416-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('03934565-n',[ ('Table',subsumption)]).
nounMapping2SUMO('03934656-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03934780-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03934890-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03934998-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('03935116-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03935234-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03935335-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03935450-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03935698-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03935789-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03935883-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03936045-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03936269-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03936466-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03936568-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03936764-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03936895-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('03937437-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03937543-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03937633-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03937751-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03937835-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03937931-n',[ ('VehicleSeat',subsumption)]).
nounMapping2SUMO('03938037-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03938244-n',[ ('Pillow',subsumption)]).
nounMapping2SUMO('03938401-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03938522-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03938725-n',[ ('BedLinen',subsumption)]).
nounMapping2SUMO('03938838-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03938951-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03939062-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03939178-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03939281-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03939440-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03939565-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03939677-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03939844-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03940022-n',[ ('GameBoard',instance)]).
nounMapping2SUMO('03940154-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('03940256-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03940713-n',[ ('Jewelry',subsumption)]).
nounMapping2SUMO('03940894-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03941013-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03941231-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03941417-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03941586-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03941684-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03941887-n',[ ('Lever',subsumption)]).
nounMapping2SUMO('03942028-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03942126-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03942244-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03942397-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03942600-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03942692-n',[ ('Sonar',subsumption)]).
nounMapping2SUMO('03942813-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('03942920-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03943010-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03943115-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03943266-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03943448-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03943544-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03943623-n',[ ('Poking',subsumption)]).
nounMapping2SUMO('03943714-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03943833-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03943920-n',[ ('ClothingSuit',subsumption)]).
nounMapping2SUMO('03944024-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03944138-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('03944341-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03944530-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03944672-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('03945167-n',[ ('SmokingPipe',equivalence)]).
nounMapping2SUMO('03945459-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03945615-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03945817-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('03945928-n',[ ('CleaningDevice',subsumption)]).
nounMapping2SUMO('03946076-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03946162-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03946325-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03946532-n',[ ('Penicillin',subsumption)]).
nounMapping2SUMO('03946723-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03946814-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03946933-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03947111-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03947343-n',[ ('Clamp',subsumption)]).
nounMapping2SUMO('03947466-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03947681-n',[ ('String',subsumption)]).
nounMapping2SUMO('03947798-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03947888-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03948041-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03948242-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03948347-n',[ ('SportsGround',subsumption)]).
nounMapping2SUMO('03948459-n',[ ('Pistol',subsumption)]).
nounMapping2SUMO('03948830-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03948950-n',[ ('Piston',equivalence)]).
nounMapping2SUMO('03949145-n',[ ('PistonRing',equivalence)]).
nounMapping2SUMO('03949317-n',[ ('EngineConnectingRod',equivalence)]).
nounMapping2SUMO('03949442-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03949663-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03949761-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03949924-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03950113-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03950228-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03950359-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03950537-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03950647-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03950818-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03950899-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03951068-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03951213-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03951453-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03951690-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03951800-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03951971-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03952150-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03952277-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03952576-n',[ ('Restaurant',subsumption)]).
nounMapping2SUMO('03952696-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('03952886-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03953020-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03953416-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03953743-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('03953901-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03954012-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03954199-n',[ ('Blueprint',equivalence)]).
nounMapping2SUMO('03954393-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('03954507-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03954731-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03955296-n',[ ('Planer',equivalence)]).
nounMapping2SUMO('03955489-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('03955615-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03955809-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03955941-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03956157-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03956331-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03956531-n',[ ('Bed',subsumption)]).
nounMapping2SUMO('03956623-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03956785-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03956922-n',[ ('IndustrialPlant',subsumption)]).
nounMapping2SUMO('03957315-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03957420-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03957567-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03957762-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03957991-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03958097-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('03958227-n',[ ('Bag',subsumption)]).
nounMapping2SUMO('03958338-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('03958448-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03958630-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03958752-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('03958910-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03959014-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03959123-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03959227-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03959350-n',[ ('Map',subsumption)]).
nounMapping2SUMO('03959485-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('03959701-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('03959936-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('03960374-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03960490-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03960664-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03960783-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03960950-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03961070-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('03961250-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('03961394-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03961503-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03961630-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03961711-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03961828-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03961939-n',[ ('PerformanceStage',subsumption)]).
nounMapping2SUMO('03962525-n',[ ('MilitaryVehicle',subsumption)]).
nounMapping2SUMO('03962685-n',[ ('Computer',subsumption)]).
nounMapping2SUMO('03962852-n',[ ('Bed',subsumption)]).
nounMapping2SUMO('03962932-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('03963028-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03963198-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('03963294-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03963483-n',[ ('Box',subsumption)]).
nounMapping2SUMO('03963645-n',[ ('PlayArea',subsumption)]).
nounMapping2SUMO('03963813-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03963982-n',[ ('PlayingCard',equivalence)]).
nounMapping2SUMO('03964495-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03964611-n',[ ('Outfit',subsumption)]).
nounMapping2SUMO('03964744-n',[ ('RecreationOrExerciseDevice',subsumption)]).
nounMapping2SUMO('03965456-n',[ ('ShoppingMall',equivalence)]).
nounMapping2SUMO('03965907-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03966206-n',[ ('Region',subsumption)]).
nounMapping2SUMO('03966325-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03966582-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('03966751-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03966976-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03967270-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('03967396-n',[ ('ComputerOutputDevice',subsumption)]).
nounMapping2SUMO('03967562-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03967788-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03967942-n',[ ('Plug',equivalence)]).
nounMapping2SUMO('03968293-n',[ ('ElectricalPlug',equivalence)]).
nounMapping2SUMO('03968479-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03968581-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03968728-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03968886-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03969041-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03969259-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03969510-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03969627-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03969902-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03969998-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03970156-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03970363-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('03970546-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03970673-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03970884-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03971040-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03971218-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03971321-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03971422-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03971771-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03971960-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03972146-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03972372-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03972524-n',[ ('Pocket',equivalence)]).
nounMapping2SUMO('03972799-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03973003-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03973170-n',[ ('Book',subsumption)]).
nounMapping2SUMO('03973285-n',[ ('BrushOrComb',subsumption)]).
nounMapping2SUMO('03973402-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03973520-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03973628-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03973839-n',[ ('Clock',subsumption)]).
nounMapping2SUMO('03973945-n',[ ('FluidContainer',subsumption)]).
nounMapping2SUMO('03974070-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03974215-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03974671-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03974769-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('03974915-n',[ ('Camera',subsumption)]).
nounMapping2SUMO('03975035-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03975232-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03975419-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03975657-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03975788-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03975926-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03976105-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03976268-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03976467-n',[ ('Camera',subsumption)]).
nounMapping2SUMO('03976657-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03976960-n',[ ('Magnet',subsumption)]).
nounMapping2SUMO('03977158-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03977266-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03977430-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03977592-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03977678-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03977966-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03978130-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03978300-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03978421-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03978575-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('03978686-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03978815-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03978966-n',[ ('Shirt',subsumption)]).
nounMapping2SUMO('03979100-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('03979212-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03979377-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03979492-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03979717-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03979847-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03980026-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('03980178-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03980332-n',[ ('Handle',subsumption)]).
nounMapping2SUMO('03980478-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03980734-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03980874-n',[ ('Cloak',subsumption)]).
nounMapping2SUMO('03980986-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03981094-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03981204-n',[ ('Bridge',instance)]).
nounMapping2SUMO('03981340-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03981464-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03981566-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03981760-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03981924-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('03982060-n',[ ('WaterArea',equivalence)]).
nounMapping2SUMO('03982232-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('03982331-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03982430-n',[ ('GameArtifact',subsumption)]).
nounMapping2SUMO('03982642-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03982767-n',[ ('Box',subsumption)]).
nounMapping2SUMO('03982895-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('03983068-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03983396-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03983499-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03983612-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('03983712-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03983814-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03983928-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03984125-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03984234-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03984381-n',[ ('Porch',equivalence)]).
nounMapping2SUMO('03984643-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('03984759-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03984908-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03985069-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03985232-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03985441-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03985588-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('03985684-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03985881-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03986071-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03986224-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03986355-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03986562-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03986704-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03986857-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03986949-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03987079-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03987266-n',[ ('Camera',subsumption)]).
nounMapping2SUMO('03987376-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03987509-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('03987674-n',[ ('Object',subsumption)]).
nounMapping2SUMO('03987865-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03987990-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03988170-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03988758-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03988926-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03989074-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03989199-n',[ ('LandVehicle',subsumption)]).
nounMapping2SUMO('03989349-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03989447-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('03989553-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('03989665-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03989777-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('03989898-n',[ ('TravelerAccommodation',subsumption)]).
nounMapping2SUMO('03990025-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('03990210-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03990385-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('03990474-n',[ ('Pottery',subsumption)]).
nounMapping2SUMO('03990834-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('03991062-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03991202-n',[ ('HeatingDevice',subsumption)]).
nounMapping2SUMO('03991321-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('03991443-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03991646-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03991837-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03991969-n',[ ('CultivatedLandArea',subsumption)]).
nounMapping2SUMO('03992115-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03992208-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03992325-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03992436-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('03992509-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03992703-n',[ ('Pottery',equivalence)]).
nounMapping2SUMO('03992888-n',[ ('Workshop',subsumption)]).
nounMapping2SUMO('03992975-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03993053-n',[ ('Toilet',subsumption)]).
nounMapping2SUMO('03993180-n',[ ('Container',subsumption)]).
nounMapping2SUMO('03993403-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03993703-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03993878-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03994008-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('03994297-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('03994417-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03994614-n',[ ('Container',subsumption), ('Horn',subsumption)]).
nounMapping2SUMO('03994757-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03994874-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03995018-n',[ ('Brake',subsumption)]).
nounMapping2SUMO('03995265-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03995372-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03995535-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03995661-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03995746-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('03995856-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03996004-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('03996145-n',[ ('Saw',subsumption)]).
nounMapping2SUMO('03996416-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03996655-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03996849-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03997027-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03997274-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03997484-n',[ ('SelfPoweredDevice',subsumption)]).
nounMapping2SUMO('03997745-n',[ ('DrivingRange',equivalence)]).
nounMapping2SUMO('03997875-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('03997980-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('03998194-n',[ ('PrayerMat',equivalence)]).
nounMapping2SUMO('03998333-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('03998525-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03998673-n',[ ('Device',subsumption)]).
nounMapping2SUMO('03998867-n',[ ('Computer',subsumption)]).
nounMapping2SUMO('03999064-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03999160-n',[ ('Building',subsumption)]).
nounMapping2SUMO('03999280-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('03999621-n',[ ('Room',subsumption)]).
nounMapping2SUMO('03999763-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('03999992-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04000311-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04000480-n',[ ('Clamp',subsumption)]).
nounMapping2SUMO('04000592-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04000716-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04000867-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('04000998-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('04001132-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04001265-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04001397-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04001499-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04001661-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04001845-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04002026-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('04002262-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04002371-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04002452-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04002536-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04002629-n',[ ('WireCoil',subsumption)]).
nounMapping2SUMO('04002931-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04003110-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04003241-n',[ ('Stove',subsumption)]).
nounMapping2SUMO('04003359-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04003453-n',[ ('University',instance)]).
nounMapping2SUMO('04003597-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04003856-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04003982-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('04004099-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04004210-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04004475-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04004767-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04004990-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04005090-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04005197-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('04005340-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04005630-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04005912-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04006067-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04006227-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04006330-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04006411-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04006584-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04006727-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04006953-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04007126-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04007239-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04007415-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04007510-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04007664-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04007894-n',[ ('Manufacture',equivalence)]).
nounMapping2SUMO('04008385-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04008634-n',[ ('Projectile',subsumption)]).
nounMapping2SUMO('04008947-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04009382-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04009552-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04009801-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04009923-n',[ ('String',subsumption)]).
nounMapping2SUMO('04010057-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04010205-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04010348-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04010566-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04010779-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04010927-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04011130-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('04011242-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04011409-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04011609-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('04011827-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04012084-n',[ ('PropellerPlane',subsumption)]).
nounMapping2SUMO('04012260-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04012482-n',[ ('PropellerJet',equivalence)]).
nounMapping2SUMO('04012665-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04012852-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04013060-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04013176-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04013362-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04013600-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04013729-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04013993-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04014297-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04015204-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04015652-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04015786-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04015908-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04016015-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04016133-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04016240-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04016479-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04016576-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04016684-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04016846-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('04017019-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04017137-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04017429-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04017571-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04017807-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04017993-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04018155-n',[ ('PublicAddressSystem',equivalence)]).
nounMapping2SUMO('04018399-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04018667-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04018951-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04019101-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('04019335-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04019541-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04019696-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04019881-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04020087-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04020298-n',[ ('Pulley',equivalence)]).
nounMapping2SUMO('04020617-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04020744-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04020912-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('04021028-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04021164-n',[ ('CleaningDevice',subsumption)]).
nounMapping2SUMO('04021362-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04021503-n',[ ('ElectricDevice',subsumption)]).
nounMapping2SUMO('04021704-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04021798-n',[ ('Pump',equivalence)]).
nounMapping2SUMO('04022332-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('04022434-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04022708-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04022866-n',[ ('WellnessDaySpa',subsumption)]).
nounMapping2SUMO('04023021-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04023119-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04023249-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04023422-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04023695-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04023808-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04023962-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04024137-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04024274-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04024396-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('04024576-n',[ ('LandVehicle',subsumption)]).
nounMapping2SUMO('04024676-n',[ ('FanDevice',subsumption)]).
nounMapping2SUMO('04024862-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04024983-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04025130-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04025350-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04025508-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04025633-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04025748-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04026053-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04026180-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04026304-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04026417-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04026518-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04026688-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04026813-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04026918-n',[ ('Broom',subsumption)]).
nounMapping2SUMO('04027023-n',[ ('SwitchDevice',subsumption)]).
nounMapping2SUMO('04027367-n',[ ('RadioReceiver',subsumption)]).
nounMapping2SUMO('04027504-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04027706-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04027820-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04027935-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04028074-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04028221-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04028315-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04028472-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04028581-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04028764-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04028881-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04029015-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04029125-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04029416-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04029541-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04029647-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04029734-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('04029913-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04030054-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04030161-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04030274-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04030414-n',[ ('Box',subsumption)]).
nounMapping2SUMO('04030518-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04030655-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04030846-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04030965-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04031166-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04031370-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04031481-n',[ ('ArrowProjectile',subsumption)]).
nounMapping2SUMO('04031600-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04031770-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04031884-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04032049-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04032242-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04032392-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04032509-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04032603-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04032710-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('04032936-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04033082-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04033178-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('04033287-n',[ ('GamePiece',subsumption)]).
nounMapping2SUMO('04033425-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04033557-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04033647-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('04033801-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04033901-n',[ ('WritingDevice',subsumption)]).
nounMapping2SUMO('04033995-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04034262-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04034367-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04034477-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04034641-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04034884-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04035086-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04035231-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04035397-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04035481-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04035634-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04035748-n',[ ('Whip',subsumption)]).
nounMapping2SUMO('04035836-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04035912-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04036004-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04036155-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04036303-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04036494-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04036648-n',[ ('Collar',subsumption)]).
nounMapping2SUMO('04036776-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04036963-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04037076-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04037220-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04037298-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04037443-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('04037625-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04037873-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04037964-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04038109-n',[ ('SportsGround',subsumption)]).
nounMapping2SUMO('04038231-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04038338-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04038440-n',[ ('Holder',subsumption)]).
nounMapping2SUMO('04038727-n',[ ('Holder',subsumption)]).
nounMapping2SUMO('04039041-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04039209-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04039381-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04039742-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('04039848-n',[ ('Radar',equivalence)]).
nounMapping2SUMO('04040247-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04040373-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04040540-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04040759-n',[ ('Radiator',equivalence)]).
nounMapping2SUMO('04041069-n',[ ('RoomHeater',subsumption)]).
nounMapping2SUMO('04041243-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04041408-n',[ ('Hose',subsumption)]).
nounMapping2SUMO('04041544-n',[ ('RadioReceiver',subsumption)]).
nounMapping2SUMO('04041747-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04041930-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04042076-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04042204-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04042358-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04042632-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04042795-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04042985-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04043168-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04043268-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04043411-n',[ ('RadioReceiver',subsumption)]).
nounMapping2SUMO('04043619-n',[ ('ContentBearingPhysical',subsumption)]).
nounMapping2SUMO('04043733-n',[ ('RadioReceiver',subsumption)]).
nounMapping2SUMO('04044119-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04044307-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('04044498-n',[ ('Telephone',subsumption)]).
nounMapping2SUMO('04044716-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04044955-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04045085-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04045255-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04045397-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04045644-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04045787-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04045941-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04046091-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04046172-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04046277-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04046400-n',[ ('Sleeve',subsumption)]).
nounMapping2SUMO('04046590-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04046810-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04046974-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04047139-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04047291-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04047401-n',[ ('Handle',subsumption)]).
nounMapping2SUMO('04047733-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04047834-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04047949-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04048075-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04048441-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04048568-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04048979-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04049098-n',[ ('TrainStation',subsumption)]).
nounMapping2SUMO('04049303-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04049405-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('04049585-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04049753-n',[ ('PercussionInstrument',subsumption)]).
nounMapping2SUMO('04050066-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04050313-n',[ ('Handle',subsumption)]).
nounMapping2SUMO('04050410-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04050600-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04050933-n',[ ('Dish',subsumption)]).
nounMapping2SUMO('04051068-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('04051269-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04051439-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04051549-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04051705-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04051825-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04052235-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04052346-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04052442-n',[ ('Farm',subsumption)]).
nounMapping2SUMO('04052658-n',[ ('House',subsumption)]).
nounMapping2SUMO('04052757-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04053218-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04053508-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04053677-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04053767-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04053995-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04054213-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04054361-n',[ ('Sword',subsumption)]).
nounMapping2SUMO('04054471-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04054566-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04054670-n',[ ('FileDevice',subsumption)]).
nounMapping2SUMO('04054795-n',[ ('ElectricDevice',subsumption)]).
nounMapping2SUMO('04055030-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04055180-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04055447-n',[ ('VehicleWheel',subsumption)]).
nounMapping2SUMO('04055595-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04055700-n',[ ('Restaurant',subsumption)]).
nounMapping2SUMO('04055861-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04056073-n',[ ('FileDevice',subsumption)]).
nounMapping2SUMO('04056180-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04056289-n',[ ('RecreationOrExerciseDevice',subsumption)]).
nounMapping2SUMO('04056413-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04056491-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04056599-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04056718-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04056932-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04057047-n',[ ('CuttingDevice',subsumption)]).
nounMapping2SUMO('04057215-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04057323-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04057435-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04057673-n',[ ('Turbine',subsumption)]).
nounMapping2SUMO('04057846-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04057981-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04058096-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04058239-n',[ ('ComputerMemory',subsumption)]).
nounMapping2SUMO('04058486-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04058594-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04058721-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04058921-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04059157-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04059298-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04059399-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04059516-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04059701-n',[ ('BackFn',equivalence)]).
nounMapping2SUMO('04059947-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04060065-n',[ ('RearWindow',subsumption)]).
nounMapping2SUMO('04060198-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('04060316-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04060448-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04060647-n',[ ('ReceiverDevice',subsumption)]).
nounMapping2SUMO('04060904-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04061442-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04061681-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04061793-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04061969-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04062179-n',[ ('InternalCombustionEngine',subsumption)]).
nounMapping2SUMO('04062428-n',[ ('Recliner',equivalence)]).
nounMapping2SUMO('04062644-n',[ ('Airplane',subsumption)]).
nounMapping2SUMO('04062807-n',[ ('MilitaryVehicle',subsumption), ('Automobile',subsumption)]).
nounMapping2SUMO('04062989-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04063154-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04063373-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04063661-n',[ ('Recording',equivalence)]).
nounMapping2SUMO('04063868-n',[ ('DataStorageDevice',subsumption)]).
nounMapping2SUMO('04064107-n',[ ('RecordingStudio',equivalence)]).
nounMapping2SUMO('04064213-n',[ ('AudioRecorder',equivalence)]).
nounMapping2SUMO('04064307-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04064401-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04064747-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04064862-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04064988-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04065132-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04065272-n',[ ('RecreationalVehicle',equivalence)]).
nounMapping2SUMO('04065464-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04065632-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04065789-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04065909-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04066023-n',[ ('University',subsumption)]).
nounMapping2SUMO('04066270-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04066388-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04066476-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04066659-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04066767-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04066888-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04067143-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04067231-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04067353-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04067472-n',[ ('Reel',equivalence)]).
nounMapping2SUMO('04067658-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04067818-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04067921-n',[ ('Table',subsumption)]).
nounMapping2SUMO('04068055-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04068261-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04068441-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04068601-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04068976-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04069166-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04069276-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04069434-n',[ ('Camera',subsumption)]).
nounMapping2SUMO('04069582-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04069777-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('04070003-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04070207-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04070415-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04070545-n',[ ('Refrigerator',equivalence)]).
nounMapping2SUMO('04070727-n',[ ('Refrigerator',subsumption)]).
nounMapping2SUMO('04070964-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('04071102-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04071263-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04071393-n',[ ('UniformClothing',subsumption)]).
nounMapping2SUMO('04071536-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04071712-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04071876-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04072193-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04072551-n',[ ('AnimalController',subsumption)]).
nounMapping2SUMO('04072811-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04072960-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04073208-n',[ ('Product',subsumption)]).
nounMapping2SUMO('04073425-n',[ ('Button',subsumption)]).
nounMapping2SUMO('04073547-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04073669-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04073948-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04074185-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04074329-n',[ ('Making',subsumption)]).
nounMapping2SUMO('04074482-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04074876-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04074963-n',[ ('RemoteControl',equivalence)]).
nounMapping2SUMO('04075160-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('04075291-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04075468-n',[ ('ElectronicDataStorageDevice',subsumption)]).
nounMapping2SUMO('04075615-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04075715-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04075813-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04075916-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04076052-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04076284-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04076433-n',[ ('Warehouse',subsumption)]).
nounMapping2SUMO('04076533-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04076713-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04076846-n',[ ('ContentBearingObject',equivalence)]).
nounMapping2SUMO('04077430-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04077594-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04077734-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04077889-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04078002-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04078150-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04078236-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04078574-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04078747-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04078955-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04079106-n',[ ('SwitchDevice',subsumption)]).
nounMapping2SUMO('04079244-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04079603-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04079746-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('04079933-n',[ ('ResistorElement',equivalence)]).
nounMapping2SUMO('04080138-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04080237-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04080454-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04080705-n',[ ('TravelerAccommodation',subsumption)]).
nounMapping2SUMO('04080833-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04081044-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04081281-n',[ ('Restaurant',subsumption)]).
nounMapping2SUMO('04081699-n',[ ('TravelerAccommodation',subsumption)]).
nounMapping2SUMO('04081844-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04082344-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04082562-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04082710-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04082886-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04083113-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04083309-n',[ ('Bag',subsumption)]).
nounMapping2SUMO('04083468-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04083649-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04083800-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04083942-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04084089-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04084234-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04084363-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04084517-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04084682-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04084889-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04085017-n',[ ('MechanicalDevice',subsumption)]).
nounMapping2SUMO('04085181-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('04085365-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04085574-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04085746-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('04085873-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04086066-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04086150-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04086273-n',[ ('RevolverGun',equivalence)]).
nounMapping2SUMO('04086446-n',[ ('Door',subsumption)]).
nounMapping2SUMO('04086663-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04086794-n',[ ('ResistorElement',subsumption)]).
nounMapping2SUMO('04086937-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04087126-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('04087290-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04087432-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04087524-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04087709-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04087826-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('04087899-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04088058-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04088229-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04088343-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04088441-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04088593-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04088696-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04088797-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04088982-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04089152-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04089376-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04089522-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04089666-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('04089836-n',[ ('Whip',subsumption)]).
nounMapping2SUMO('04089976-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04090064-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04090263-n',[ ('Rifle',equivalence)]).
nounMapping2SUMO('04090548-n',[ ('Bullet',subsumption)]).
nounMapping2SUMO('04090682-n',[ ('GunStock',subsumption)]).
nounMapping2SUMO('04090781-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04090923-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04091097-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04091247-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04091466-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04091584-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('04091693-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04091839-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04092013-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('04092168-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04092305-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04092447-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04092609-n',[ ('Jewelry',subsumption)]).
nounMapping2SUMO('04092959-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04093157-n',[ ('Jewelry',subsumption)]).
nounMapping2SUMO('04093223-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04093478-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04093625-n',[ ('IceSkatingRink',subsumption)]).
nounMapping2SUMO('04093775-n',[ ('Firearm',subsumption)]).
nounMapping2SUMO('04093915-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04094060-n',[ ('String',subsumption)]).
nounMapping2SUMO('04094250-n',[ ('Lever',subsumption)]).
nounMapping2SUMO('04094438-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04094608-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04094720-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04094859-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04094983-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('04095109-n',[ ('TravelerAccommodation',instance)]).
nounMapping2SUMO('04095210-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04095342-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04095577-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04095725-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04095853-n',[ ('SmokingDevice',subsumption)]).
nounMapping2SUMO('04095938-n',[ ('SmokingDevice',subsumption)]).
nounMapping2SUMO('04096066-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('04096733-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04096848-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04097085-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04097256-n',[ ('Map',subsumption)]).
nounMapping2SUMO('04097373-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04097527-n',[ ('Road',subsumption)]).
nounMapping2SUMO('04097622-n',[ ('Roadway',equivalence)]).
nounMapping2SUMO('04097760-n',[ ('PotOrPan',subsumption)]).
nounMapping2SUMO('04097866-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04098032-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04098169-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04098260-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04098399-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04098513-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04098710-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04098795-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04099003-n',[ ('RockerArm',equivalence)]).
nounMapping2SUMO('04099175-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04099429-n',[ ('Vehicle',subsumption), ('PoweredVehicle',subsumption), ('Rocket',equivalence)]).
nounMapping2SUMO('04099649-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04099761-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04099854-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04099969-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('04100174-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04100519-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04100620-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04100994-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('04101232-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04101375-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04101497-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04101701-n',[ ('VehicleWheel',subsumption)]).
nounMapping2SUMO('04101860-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04102037-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04102162-n',[ ('UnpoweredVehicle',subsumption)]).
nounMapping2SUMO('04102285-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04102406-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04102618-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04102760-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04102872-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04102962-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04103094-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04103206-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04103364-n',[ ('Group',subsumption)]).
nounMapping2SUMO('04103491-n',[ ('CigarOrCigarette',subsumption)]).
nounMapping2SUMO('04103665-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04103769-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04103918-n',[ ('Vehicle',subsumption)]).
nounMapping2SUMO('04104147-n',[ ('Text',subsumption)]).
nounMapping2SUMO('04104384-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04104500-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04104641-n',[ ('ExplosiveDevice',subsumption)]).
nounMapping2SUMO('04104770-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04104925-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04105068-n',[ ('Roof',equivalence)]).
nounMapping2SUMO('04105438-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04105609-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04105704-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04105791-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04105893-n',[ ('Room',equivalence)]).
nounMapping2SUMO('04107598-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04107743-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('04107870-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04107984-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04108137-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04108268-n',[ ('String',subsumption)]).
nounMapping2SUMO('04108822-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04108908-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04108999-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04109104-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04109240-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04109335-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04109471-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04109599-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04109702-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04109899-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04110068-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('04110178-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04110281-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04110439-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04110654-n',[ ('InternalCombustionEngine',subsumption)]).
nounMapping2SUMO('04110841-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04110955-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04111190-n',[ ('Shaft',equivalence)]).
nounMapping2SUMO('04111414-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04111531-n',[ ('CookingOven',subsumption)]).
nounMapping2SUMO('04111668-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04111962-n',[ ('Rotor',subsumption)]).
nounMapping2SUMO('04112147-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04112252-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04112430-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04112579-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04112654-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04112752-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('04112921-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04113038-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04113124-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04113194-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04113316-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('04113406-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04113641-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('04113765-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04113968-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04114069-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04114193-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04114301-n',[ ('FileDevice',subsumption)]).
nounMapping2SUMO('04114428-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04114554-n',[ ('Table',instance)]).
nounMapping2SUMO('04114719-n',[ ('SelfPoweredDevice',subsumption)]).
nounMapping2SUMO('04114844-n',[ ('ComputerHardware',subsumption)]).
nounMapping2SUMO('04114996-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04115144-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04115256-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04115456-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04115542-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04115670-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04115802-n',[ ('Above',subsumption)]).
nounMapping2SUMO('04115906-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04115996-n',[ ('Above',subsumption)]).
nounMapping2SUMO('04116098-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04116294-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04116389-n',[ ('Bullet',subsumption)]).
nounMapping2SUMO('04116512-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04116744-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04116919-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('04117089-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04117216-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04117464-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04117639-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04117747-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04117917-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('04118021-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04118538-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04118635-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04118776-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04119091-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04119230-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04119360-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('04119478-n',[ ('GameRoom',subsumption)]).
nounMapping2SUMO('04119630-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('04119751-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04119892-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04120093-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04120266-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04120339-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04120489-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('04120593-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04120695-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04120842-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04120998-n',[ ('PerformanceStage',subsumption)]).
nounMapping2SUMO('04121142-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04121228-n',[ ('Candle',subsumption)]).
nounMapping2SUMO('04121342-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04121426-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04121511-n',[ ('Sword',subsumption)]).
nounMapping2SUMO('04121728-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04122011-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04122262-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04122349-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04122492-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04122578-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('04122685-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04122825-n',[ ('Bag',equivalence)]).
nounMapping2SUMO('04123026-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04123123-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('04123228-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04123317-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04123448-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('04123567-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04123740-n',[ ('Saddle',equivalence)]).
nounMapping2SUMO('04123980-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04124098-n',[ ('Bag',subsumption)]).
nounMapping2SUMO('04124202-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04124370-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04124488-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04124573-n',[ ('Seat',subsumption)]).
nounMapping2SUMO('04124764-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('04124887-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04125021-n',[ ('SafeContainer',equivalence)]).
nounMapping2SUMO('04125116-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04125257-n',[ ('SafeContainer',subsumption)]).
nounMapping2SUMO('04125466-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04125541-n',[ ('House',subsumption)]).
nounMapping2SUMO('04125692-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04125853-n',[ ('SafetyDevice',subsumption)]).
nounMapping2SUMO('04126066-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04126244-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04126373-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04126541-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04126659-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04126852-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04126980-n',[ ('MatchDevice',subsumption)]).
nounMapping2SUMO('04127117-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04127249-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04127395-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04127521-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04127633-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04127904-n',[ ('Sail',equivalence)]).
nounMapping2SUMO('04128413-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04128499-n',[ ('Sailboat',equivalence)]).
nounMapping2SUMO('04128710-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04128837-n',[ ('Sailboat',equivalence)]).
nounMapping2SUMO('04129490-n',[ ('MilitaryShip',subsumption), ('Sailboat',subsumption)]).
nounMapping2SUMO('04129688-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04129766-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04129872-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04130143-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04130257-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04130357-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('04130447-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('04130566-n',[ ('Hydrometer',subsumption)]).
nounMapping2SUMO('04130715-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04130907-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04131015-n',[ ('SittingArea',subsumption)]).
nounMapping2SUMO('04131113-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04131208-n',[ ('BarberShops',equivalence)]).
nounMapping2SUMO('04131368-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04131499-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04131610-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04131690-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04131811-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04131929-n',[ ('Tray',subsumption)]).
nounMapping2SUMO('04132056-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04132158-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('04132354-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04132465-n',[ ('Belt',subsumption)]).
nounMapping2SUMO('04132603-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('04132829-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04132985-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04133114-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04133211-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04133346-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04133497-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04133648-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('04133789-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('04134008-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04134170-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04134339-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04134523-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04134632-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04134862-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04135024-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04135118-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04135315-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04135516-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('04135710-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04135933-n',[ ('Silk',subsumption)]).
nounMapping2SUMO('04136045-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04136161-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04136333-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04136510-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04136676-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04136800-n',[ ('SecurityDevice',subsumption)]).
nounMapping2SUMO('04136997-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04137089-n',[ ('Window',subsumption)]).
nounMapping2SUMO('04137217-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04137355-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04137444-n',[ ('ArtificialSatellite',subsumption)]).
nounMapping2SUMO('04137773-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04137897-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04138131-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04138261-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04138398-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04138560-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04138671-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04138869-n',[ ('Pistol',subsumption)]).
nounMapping2SUMO('04138977-n',[ ('PotOrPan',subsumption)]).
nounMapping2SUMO('04139140-n',[ ('PotOrPan',subsumption)]).
nounMapping2SUMO('04139291-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04139395-n',[ ('SteamBath',equivalence)]).
nounMapping2SUMO('04139534-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04139642-n',[ ('Sail',subsumption)]).
nounMapping2SUMO('04139748-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04139859-n',[ ('SafeContainer',subsumption)]).
nounMapping2SUMO('04140064-n',[ ('Saw',equivalence)]).
nounMapping2SUMO('04140340-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04140434-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04140539-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04140631-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04140777-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04140853-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04140976-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04141076-n',[ ('Saxophone',equivalence)]).
nounMapping2SUMO('04141198-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('04141327-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04141423-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04141573-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04141712-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04141838-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04141975-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04142175-n',[ ('ElectricDevice',subsumption)]).
nounMapping2SUMO('04142327-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04142434-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04142549-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04142731-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04142999-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04143140-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04143365-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04143492-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04143712-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04143897-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04144241-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04144434-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04144539-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04144651-n',[ ('CuttingDevice',subsumption)]).
nounMapping2SUMO('04144782-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04145056-n',[ ('PerformanceStage',subsumption)]).
nounMapping2SUMO('04145322-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04145417-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04145578-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04145735-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04145863-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04146050-n',[ ('School',subsumption)]).
nounMapping2SUMO('04146343-n',[ ('Bag',subsumption)]).
nounMapping2SUMO('04146504-n',[ ('Bell',subsumption)]).
nounMapping2SUMO('04146614-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04146721-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04146862-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04146976-n',[ ('School',subsumption)]).
nounMapping2SUMO('04147183-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('04147291-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('04147364-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('04147495-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04147793-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04147916-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04148054-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04148285-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04148464-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04148579-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04148703-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04148801-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04148936-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04149083-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04149208-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04149374-n',[ ('AgentPoweredVehicle',subsumption)]).
nounMapping2SUMO('04149490-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04149813-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04149968-n',[ ('Whip',subsumption)]).
nounMapping2SUMO('04150153-n',[ ('CleaningDevice',subsumption)]).
nounMapping2SUMO('04150273-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04150371-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04150474-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04150668-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('04150860-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04150980-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04151108-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04151228-n',[ ('ComputerMemory',subsumption)]).
nounMapping2SUMO('04151405-n',[ ('BoardOrBlock',subsumption)]).
nounMapping2SUMO('04151581-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04151940-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04152387-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04152593-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04152829-n',[ ('ProjectionScreen',subsumption)]).
nounMapping2SUMO('04153025-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04153330-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04153436-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('04153751-n',[ ('Screw',subsumption)]).
nounMapping2SUMO('04154152-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04154340-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04154565-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04154753-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04154854-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04154938-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04155068-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04155177-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04155310-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04155457-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04155625-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04155735-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04155889-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04156040-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04156140-n',[ ('CleaningDevice',subsumption)]).
nounMapping2SUMO('04156297-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04156411-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('04156591-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04156720-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04156814-n',[ ('Oar',subsumption)]).
nounMapping2SUMO('04156946-n',[ ('Oar',subsumption)]).
nounMapping2SUMO('04157099-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04157320-n',[ ('Sculpture',subsumption)]).
nounMapping2SUMO('04157703-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04157883-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04158002-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04158138-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04158250-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04158457-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04158672-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04158807-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04158956-n',[ ('Box',subsumption)]).
nounMapping2SUMO('04159058-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04159354-n',[ ('AttachingDevice',subsumption)]).
nounMapping2SUMO('04159545-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('04159676-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04159850-n',[ ('ExplosiveDevice',subsumption)]).
nounMapping2SUMO('04160036-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('04160261-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04160372-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04160586-n',[ ('Airplane',subsumption)]).
nounMapping2SUMO('04160847-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('04161010-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04161102-n',[ ('Building',instance)]).
nounMapping2SUMO('04161233-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04161358-n',[ ('Seat',subsumption)]).
nounMapping2SUMO('04161981-n',[ ('Seat',equivalence)]).
nounMapping2SUMO('04162433-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04162599-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04162706-n',[ ('SeatBelt',equivalence)]).
nounMapping2SUMO('04162895-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04162998-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04163364-n',[ ('Waterway',subsumption)]).
nounMapping2SUMO('04163530-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04163740-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04164002-n',[ ('WireCoil',subsumption)]).
nounMapping2SUMO('04164199-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04164406-n',[ ('BaseballBase',subsumption)]).
nounMapping2SUMO('04164529-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04164757-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04164868-n',[ ('Desk',subsumption)]).
nounMapping2SUMO('04164989-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04165409-n',[ ('Furniture',subsumption)]).
nounMapping2SUMO('04165551-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04165675-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04165811-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04165945-n',[ ('SecurityDevice',subsumption)]).
nounMapping2SUMO('04166111-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04166281-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('04166436-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04166553-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04166841-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04167122-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04167228-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04167346-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04167489-n',[ ('Projectile',subsumption)]).
nounMapping2SUMO('04167661-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04167759-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04168084-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04168199-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04168472-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04168541-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04168716-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04168840-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04169035-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04169152-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04169437-n',[ ('SwitchDevice',subsumption)]).
nounMapping2SUMO('04169597-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04169707-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04169935-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04170037-n',[ ('Vehicle',subsumption)]).
nounMapping2SUMO('04170384-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('04170515-n',[ ('ElectricMotor',subsumption)]).
nounMapping2SUMO('04170694-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04170933-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04171066-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04171208-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04171373-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04171459-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04171629-n',[ ('Pistol',subsumption)]).
nounMapping2SUMO('04171831-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04172107-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04172230-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('04172342-n',[ ('Trailer',subsumption)]).
nounMapping2SUMO('04172512-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04172607-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04172776-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04172904-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04173046-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04173172-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04173344-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04173511-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04173698-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04173907-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04174026-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04174101-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04174234-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04174394-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04174500-n',[ ('MusicalInstrument',subsumption)]).
nounMapping2SUMO('04174596-n',[ ('ExplosiveDevice',subsumption)]).
nounMapping2SUMO('04174705-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('04174853-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('04175039-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04175147-n',[ ('Computer',subsumption)]).
nounMapping2SUMO('04175380-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('04175574-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('04175669-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04175859-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04176068-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04176190-n',[ ('Dish',subsumption)]).
nounMapping2SUMO('04176295-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04176528-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04176747-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04176889-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04177041-n',[ ('Gun',subsumption)]).
nounMapping2SUMO('04177202-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04177329-n',[ ('Screw',subsumption)]).
nounMapping2SUMO('04177545-n',[ ('Screw',subsumption)]).
nounMapping2SUMO('04177654-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04177755-n',[ ('Sofa',subsumption)]).
nounMapping2SUMO('04177820-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04177931-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('04178062-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04178190-n',[ ('AudioRecording',subsumption)]).
nounMapping2SUMO('04178329-n',[ ('Monument',subsumption)]).
nounMapping2SUMO('04178668-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04178784-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04178897-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04179126-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04179271-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04179385-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04179712-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04179824-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('04179913-n',[ ('MechanicalDevice',subsumption)]).
nounMapping2SUMO('04180063-n',[ ('MechanicalDevice',subsumption)]).
nounMapping2SUMO('04180229-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04180314-n',[ ('AttachingDevice',subsumption)]).
nounMapping2SUMO('04180888-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04181083-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04181228-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04181561-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04181718-n',[ ('Unilluminated',subsumption)]).
nounMapping2SUMO('04181983-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('04182152-n',[ ('Box',subsumption)]).
nounMapping2SUMO('04182322-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04182514-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04182708-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04182890-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04183076-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04183217-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04183329-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04183516-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('04183663-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04183819-n',[ ('MechanicalDevice',subsumption)]).
nounMapping2SUMO('04183957-n',[ ('MechanicalDevice',subsumption)]).
nounMapping2SUMO('04184095-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04184316-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04184435-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04184600-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04184701-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04184880-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04184957-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04185071-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04185329-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04185529-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04185656-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04185804-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04185946-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04186051-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('04186268-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04186455-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04186624-n',[ ('Oboe',subsumption)]).
nounMapping2SUMO('04186709-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04186848-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04187061-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04187233-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04187547-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04187751-n',[ ('Bell',subsumption)]).
nounMapping2SUMO('04187885-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04187970-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('04188064-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04188179-n',[ ('BedLinen',equivalence)]).
nounMapping2SUMO('04188368-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04188643-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04188985-n',[ ('Anchor',subsumption)]).
nounMapping2SUMO('04189092-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04189282-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04189392-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('04189482-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('04189651-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04189816-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04189913-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('04190052-n',[ ('Shelf',subsumption)]).
nounMapping2SUMO('04190376-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04190464-n',[ ('Grenade',subsumption)]).
nounMapping2SUMO('04190747-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04190997-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04191150-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('04191346-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04191502-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04191595-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04191943-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04192238-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04192361-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('04192521-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04192698-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04192858-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04193035-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04193179-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04193377-n',[ ('ComputerKeyboard',subsumption)]).
nounMapping2SUMO('04193552-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04193742-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04193883-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04194009-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('04194127-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04194289-n',[ ('WaterVehicle',equivalence)]).
nounMapping2SUMO('04196080-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04196337-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04196502-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04196677-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04196803-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04196925-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04197110-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04197235-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04197391-n',[ ('Shirt',equivalence)]).
nounMapping2SUMO('04197781-n',[ ('Button',subsumption)]).
nounMapping2SUMO('04197878-n',[ ('Dress',subsumption)]).
nounMapping2SUMO('04198015-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04198233-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04198355-n',[ ('Sleeve',subsumption)]).
nounMapping2SUMO('04198453-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04198562-n',[ ('Shirt',subsumption)]).
nounMapping2SUMO('04198722-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04198797-n',[ ('Damper',equivalence)]).
nounMapping2SUMO('04199027-n',[ ('Shoe',equivalence)]).
nounMapping2SUMO('04200000-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04200138-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04200258-n',[ ('Box',subsumption)]).
nounMapping2SUMO('04200390-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04200537-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04200637-n',[ ('AttachingDevice',subsumption)]).
nounMapping2SUMO('04200800-n',[ ('RetailStore',subsumption)]).
nounMapping2SUMO('04200908-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04201064-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('04201297-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04201435-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('04201618-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('04201733-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('04201845-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04201992-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04202142-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04202282-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04202417-n',[ ('RetailStore',equivalence)]).
nounMapping2SUMO('04203356-n',[ ('Bell',subsumption)]).
nounMapping2SUMO('04203514-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04203705-n',[ ('FrontFn',subsumption)]).
nounMapping2SUMO('04203889-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('04204081-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04204238-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04204347-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04204468-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04204619-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04204755-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04204953-n',[ ('Transitway',subsumption)]).
nounMapping2SUMO('04205062-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04205192-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04205318-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('04205505-n',[ ('Sleeve',subsumption)]).
nounMapping2SUMO('04205613-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04205759-n',[ ('Projectile',equivalence)]).
nounMapping2SUMO('04205983-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('04206070-n',[ ('ShotBall',equivalence)]).
nounMapping2SUMO('04206225-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04206356-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04206570-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04206695-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('04206790-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04206948-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('04207151-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04207343-n',[ ('Bag',subsumption)]).
nounMapping2SUMO('04207473-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04207596-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04207763-n',[ ('Holster',subsumption)]).
nounMapping2SUMO('04207903-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04208065-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04208210-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04208427-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04208582-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('04208760-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04208936-n',[ ('Shower',equivalence)]).
nounMapping2SUMO('04209133-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04209239-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04209383-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04209509-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04209613-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04209811-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04210012-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04210120-n',[ ('PaperShredder',equivalence)]).
nounMapping2SUMO('04210288-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04210390-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04210591-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04210723-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04210858-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04211001-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04211219-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04211356-n',[ ('WindowCovering',subsumption)]).
nounMapping2SUMO('04211528-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04211755-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04211857-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04211970-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04212165-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04212282-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04212467-n',[ ('Helicopter',subsumption)]).
nounMapping2SUMO('04212573-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('04212810-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04212943-n',[ ('Bag',subsumption)]).
nounMapping2SUMO('04213105-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04213264-n',[ ('Bed',subsumption)]).
nounMapping2SUMO('04213353-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04213530-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04213626-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04214046-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04214154-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04214282-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04214413-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04214535-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04214649-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04214871-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04214958-n',[ ('GameArtifact',subsumption)]).
nounMapping2SUMO('04215056-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04215153-n',[ ('Saddle',subsumption)]).
nounMapping2SUMO('04215287-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('04215402-n',[ ('Sidewalk',equivalence)]).
nounMapping2SUMO('04215588-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04215684-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04215800-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04215910-n',[ ('AIM9',equivalence)]).
nounMapping2SUMO('04216013-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04216106-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04216302-n',[ ('Chair',instance)]).
nounMapping2SUMO('04216508-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('04216634-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04216860-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04216963-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04217200-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('04217387-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04217546-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04217718-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04217882-n',[ ('Sign',equivalence)]).
nounMapping2SUMO('04218142-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04218271-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04218383-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('04218564-n',[ ('AutomobileMuffler',equivalence)]).
nounMapping2SUMO('04218773-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('04218921-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04219067-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04219185-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04219277-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04219424-n',[ ('Silk',subsumption)]).
nounMapping2SUMO('04219580-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04219718-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04220036-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04220250-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04220344-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04220523-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04220717-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04220805-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04220945-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04221076-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04221241-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04221424-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04221586-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04221673-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('04221823-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04221994-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('04222210-n',[ ('SingleBed',equivalence)]).
nounMapping2SUMO('04222307-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('04222470-n',[ ('ClothingSuit',subsumption)]).
nounMapping2SUMO('04222594-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04222723-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04222847-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('04223066-n',[ ('Helicopter',subsumption)]).
nounMapping2SUMO('04223170-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04223299-n',[ ('Shirt',subsumption)]).
nounMapping2SUMO('04223435-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04223580-n',[ ('WashBasin',subsumption)]).
nounMapping2SUMO('04223778-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04223915-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04224155-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('04224395-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04224543-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04224671-n',[ ('ReligiousBuilding',instance)]).
nounMapping2SUMO('04224842-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('04225031-n',[ ('BathTub',subsumption)]).
nounMapping2SUMO('04225222-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04225337-n',[ ('Nail',subsumption)]).
nounMapping2SUMO('04225417-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04225578-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04225729-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04225987-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04226172-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04226322-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04226464-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04226537-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04226826-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04226962-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04227050-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04227144-n',[ ('Sketch',subsumption)]).
nounMapping2SUMO('04227370-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04227519-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04227618-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04227787-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04227900-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04228054-n',[ ('SnowSki',equivalence)]).
nounMapping2SUMO('04228215-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04228422-n',[ ('Vehicle',subsumption)]).
nounMapping2SUMO('04228581-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('04228693-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04228844-n',[ ('BoardOrBlock',subsumption)]).
nounMapping2SUMO('04229007-n',[ ('LandVehicle',subsumption), ('PoweredVehicle',subsumption)]).
nounMapping2SUMO('04229107-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04229195-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04229363-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04229480-n',[ ('DisplacementHullWaterVehicle',subsumption)]).
nounMapping2SUMO('04229620-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04229737-n',[ ('TravelerAccommodation',subsumption)]).
nounMapping2SUMO('04229816-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04229959-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04230093-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04230221-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04230387-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04230487-n',[ ('Airplane',subsumption)]).
nounMapping2SUMO('04230603-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04230707-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04230808-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04231272-n',[ ('Dress',subsumption)]).
nounMapping2SUMO('04231444-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04231575-n',[ ('SkiingFacility',subsumption)]).
nounMapping2SUMO('04231693-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04231905-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04232034-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04232153-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04232312-n',[ ('AuditoriumSeat',subsumption)]).
nounMapping2SUMO('04232437-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04232543-n',[ ('Helicopter',subsumption)]).
nounMapping2SUMO('04232691-n',[ ('TransportationDevice',instance)]).
nounMapping2SUMO('04232800-n',[ ('Skylight',subsumption)]).
nounMapping2SUMO('04232902-n',[ ('ExplosiveDevice',subsumption)]).
nounMapping2SUMO('04233027-n',[ ('Sail',subsumption)]).
nounMapping2SUMO('04233124-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04233295-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04233405-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04233556-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04233715-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('04233832-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04233960-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04234160-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04234260-n',[ ('Pocket',subsumption)]).
nounMapping2SUMO('04234455-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04234670-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04234763-n',[ ('Pencil',subsumption)]).
nounMapping2SUMO('04234887-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04234969-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04235165-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04235291-n',[ ('UnpoweredVehicle',subsumption), ('LandVehicle',subsumption)]).
nounMapping2SUMO('04235646-n',[ ('Furniture',subsumption)]).
nounMapping2SUMO('04235771-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04235860-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04236001-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('04236182-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04236377-n',[ ('Sleeve',subsumption)]).
nounMapping2SUMO('04236702-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04236809-n',[ ('Bed',subsumption)]).
nounMapping2SUMO('04236935-n',[ ('Bell',subsumption)]).
nounMapping2SUMO('04237086-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04237174-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04237287-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04237423-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04237565-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04237654-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('04237773-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04237924-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04238128-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04238321-n',[ ('AttachingDevice',subsumption)]).
nounMapping2SUMO('04238617-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04238763-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04238953-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04239074-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04239218-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04239333-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04239436-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04239639-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04239786-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('04239900-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04240097-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04240327-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04240434-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04240576-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('04240752-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04240867-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04241042-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04241249-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04241394-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('04241573-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04241782-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04241940-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('04242084-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('04242315-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04242408-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('04242587-n',[ ('MilitaryShip',subsumption)]).
nounMapping2SUMO('04242704-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04242871-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04243003-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04243142-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04243251-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04243370-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('04243546-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04243727-n',[ ('ComputerHardware',subsumption)]).
nounMapping2SUMO('04243941-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04244152-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04244278-n',[ ('MatchDevice',subsumption)]).
nounMapping2SUMO('04244379-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04244615-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04244847-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('04244997-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04245218-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04245412-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04245508-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04245703-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04245847-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('04246060-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04246156-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04246271-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04246459-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('04246633-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('04246731-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04246855-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('04247011-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04247175-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04247336-n',[ ('Tobacco',subsumption)]).
nounMapping2SUMO('04247440-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04247544-n',[ ('Firearm',subsumption)]).
nounMapping2SUMO('04247630-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04247736-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04247876-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04248010-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04248209-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04248396-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04248507-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('04248607-n',[ ('Photograph',subsumption)]).
nounMapping2SUMO('04248851-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04249029-n',[ ('PercussionInstrument',subsumption)]).
nounMapping2SUMO('04249204-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04249415-n',[ ('Drum',subsumption)]).
nounMapping2SUMO('04249582-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04249705-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04249882-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('04250026-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04250224-n',[ ('Rifle',subsumption)]).
nounMapping2SUMO('04250473-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04250599-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04250692-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04250850-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04251144-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04251377-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04251560-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04251701-n',[ ('Water',subsumption)]).
nounMapping2SUMO('04251791-n',[ ('BoardOrBlock',subsumption)]).
nounMapping2SUMO('04251983-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04252077-n',[ ('LandVehicle',subsumption), ('PoweredVehicle',subsumption)]).
nounMapping2SUMO('04252225-n',[ ('LandVehicle',subsumption), ('PoweredVehicle',subsumption)]).
nounMapping2SUMO('04252331-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04252560-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04252653-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04252814-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04252939-n',[ ('Tobacco',subsumption)]).
nounMapping2SUMO('04253057-n',[ ('Box',subsumption)]).
nounMapping2SUMO('04253168-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04253304-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04253437-n',[ ('Detergent',subsumption)]).
nounMapping2SUMO('04253751-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04253931-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04254009-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04254120-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04254205-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('04254319-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('04254450-n',[ ('CleaningDevice',subsumption)]).
nounMapping2SUMO('04254535-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('04254680-n',[ ('SoccerBall',subsumption)]).
nounMapping2SUMO('04254777-n',[ ('Sock',subsumption)]).
nounMapping2SUMO('04255034-n',[ ('ElectricalOutlet',equivalence)]).
nounMapping2SUMO('04255163-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04255346-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04255499-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04255586-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04255670-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04255768-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04255899-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04256033-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04256152-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04256318-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04256520-n',[ ('Sofa',equivalence)]).
nounMapping2SUMO('04256758-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04256891-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('04256993-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04257223-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04257385-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('04257533-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('04257684-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04257790-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04257986-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04258138-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04258333-n',[ ('HeatingDevice',subsumption)]).
nounMapping2SUMO('04258438-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04258618-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04258732-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04258859-n',[ ('SolderingIron',equivalence)]).
nounMapping2SUMO('04258982-n',[ ('ShoeSole',equivalence)]).
nounMapping2SUMO('04259202-n',[ ('Solenoid',equivalence)]).
nounMapping2SUMO('04259364-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04259468-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04259630-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('04259771-n',[ ('Sonar',subsumption)]).
nounMapping2SUMO('04260192-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04260364-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04260589-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04260816-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04260934-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04261116-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04261281-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04261369-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04261506-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04261638-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04261767-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04261868-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('04262010-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('04262161-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04262410-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04262530-n',[ ('Rocket',subsumption)]).
nounMapping2SUMO('04262678-n',[ ('AudioRecording',equivalence)]).
nounMapping2SUMO('04262869-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04262969-n',[ ('Music',subsumption)]).
nounMapping2SUMO('04263139-n',[ ('Truck',subsumption)]).
nounMapping2SUMO('04263257-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04263336-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04263417-n',[ ('Dish',subsumption)]).
nounMapping2SUMO('04263502-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('04263614-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04263760-n',[ ('LightFixture',equivalence)]).
nounMapping2SUMO('04263950-n',[ ('MusicalInstrument',subsumption)]).
nounMapping2SUMO('04264050-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04264134-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04264233-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04264361-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('04264485-n',[ ('FinancialInstrument',subsumption)]).
nounMapping2SUMO('04264628-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04264765-n',[ ('Spacecraft',subsumption)]).
nounMapping2SUMO('04264914-n',[ ('Spacecraft',subsumption)]).
nounMapping2SUMO('04265275-n',[ ('RoomHeater',subsumption)]).
nounMapping2SUMO('04265428-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04265535-n',[ ('Building',instance)]).
nounMapping2SUMO('04265668-n',[ ('Rocket',subsumption)]).
nounMapping2SUMO('04265904-n',[ ('Rocket',subsumption)]).
nounMapping2SUMO('04266014-n',[ ('Spacecraft',subsumption)]).
nounMapping2SUMO('04266162-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04266375-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04266486-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04266660-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04266849-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04266968-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04267091-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04267165-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04267246-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04267435-n',[ ('Sail',subsumption)]).
nounMapping2SUMO('04267577-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04267870-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04267985-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04268142-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04268275-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04268418-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04268565-n',[ ('WireCoil',subsumption)]).
nounMapping2SUMO('04268680-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04268799-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04268969-n',[ ('Flammable',subsumption)]).
nounMapping2SUMO('04269086-n',[ ('Lever',subsumption)]).
nounMapping2SUMO('04269270-n',[ ('SparkPlug',equivalence)]).
nounMapping2SUMO('04269502-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04269668-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04269822-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04269944-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04270147-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04270276-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04270371-n',[ ('Telephone',subsumption)]).
nounMapping2SUMO('04270576-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04270765-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('04270891-n',[ ('Spear',subsumption)]).
nounMapping2SUMO('04271148-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04271371-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04271531-n',[ ('RetailStore',subsumption)]).
nounMapping2SUMO('04271640-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04271793-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04271891-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04272054-n',[ ('EyeGlass',subsumption)]).
nounMapping2SUMO('04272389-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04272541-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04272638-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04272782-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04272928-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04273064-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04273285-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04273433-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04273569-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04273659-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04273796-n',[ ('MechanicalDevice',subsumption)]).
nounMapping2SUMO('04273972-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04274110-n',[ ('SportsGround',subsumption)]).
nounMapping2SUMO('04274214-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04274309-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04274396-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04274530-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04274686-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04274807-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04274985-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04275093-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04275175-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04275283-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04275363-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('04275548-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04275661-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04275904-n',[ ('Nail',subsumption)]).
nounMapping2SUMO('04276050-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04276249-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04276404-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04276531-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04276808-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04276929-n',[ ('Microphone',subsumption)]).
nounMapping2SUMO('04277034-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04277204-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04277352-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04277493-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04277669-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('04277826-n',[ ('ClothesDryer',subsumption)]).
nounMapping2SUMO('04277980-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04278247-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('04278353-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('04278447-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04278605-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04278751-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04278932-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04279063-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04279172-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04279353-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04279462-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04279666-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04279858-n',[ ('Bandage',subsumption)]).
nounMapping2SUMO('04279987-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04280259-n',[ ('WireSpring',subsumption)]).
nounMapping2SUMO('04280373-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('04280487-n',[ ('HeatingDevice',subsumption)]).
nounMapping2SUMO('04280603-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04280706-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04280845-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04280970-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04281131-n',[ ('Projectile',subsumption)]).
nounMapping2SUMO('04281260-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04281375-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04281571-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04281749-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04281880-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04281998-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04282231-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04282379-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04282494-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04282664-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('04282872-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04282992-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04283096-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04283255-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04283378-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04283585-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04283784-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04283905-n',[ ('CleaningDevice',subsumption)]).
nounMapping2SUMO('04284002-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('04284341-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04284438-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04284572-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04284735-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04284869-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04285008-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('04285146-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04285622-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04285803-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04285965-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('04286128-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04286307-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04286575-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04286796-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('04286960-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04287153-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('04287351-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04287451-n',[ ('WheelChock',subsumption)]).
nounMapping2SUMO('04287610-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('04287747-n',[ ('PaintingDevice',subsumption)]).
nounMapping2SUMO('04287898-n',[ ('Paint',subsumption)]).
nounMapping2SUMO('04287986-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04288165-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04288272-n',[ ('Spring',subsumption)]).
nounMapping2SUMO('04288533-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04288673-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04288784-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04288919-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04289027-n',[ ('WaterSprinkler',subsumption)]).
nounMapping2SUMO('04289195-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04289449-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04289576-n',[ ('Sail',subsumption)]).
nounMapping2SUMO('04289690-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04289827-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04289964-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04290079-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04290259-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04290507-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04290615-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04290762-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04290875-n',[ ('Sofa',subsumption)]).
nounMapping2SUMO('04290945-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04291069-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04291242-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04291511-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('04291759-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04291912-n',[ ('MechanicalNut',subsumption)]).
nounMapping2SUMO('04291992-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('04292080-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04292221-n',[ ('Ball',subsumption)]).
nounMapping2SUMO('04292313-n',[ ('SportsFacility',subsumption)]).
nounMapping2SUMO('04292414-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04292572-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04292733-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04292921-n',[ ('CleaningDevice',subsumption)]).
nounMapping2SUMO('04293119-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04293258-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04293450-n',[ ('ExplosiveDevice',subsumption)]).
nounMapping2SUMO('04293608-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('04293744-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04293902-n',[ ('TrapOrCage',subsumption)]).
nounMapping2SUMO('04294041-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04294212-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04294426-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04294614-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('04294879-n',[ ('FarmBuilding',subsumption)]).
nounMapping2SUMO('04295081-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04295353-n',[ ('AnimalResidence',subsumption)]).
nounMapping2SUMO('04295475-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04295571-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04295777-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04295881-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04296261-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04296562-n',[ ('PerformanceStage',equivalence)]).
nounMapping2SUMO('04296949-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04297098-n',[ ('StageCoach',subsumption)]).
nounMapping2SUMO('04297327-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04297476-n',[ ('PerformanceStage',subsumption)]).
nounMapping2SUMO('04297750-n',[ ('Window',subsumption)]).
nounMapping2SUMO('04297847-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04297944-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04298053-n',[ ('Rod',subsumption)]).
nounMapping2SUMO('04298171-n',[ ('Steps',equivalence)]).
nounMapping2SUMO('04298308-n',[ ('Steps',equivalence)]).
nounMapping2SUMO('04298661-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04298765-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04298906-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04299066-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04299215-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04299370-n',[ ('AnimalResidence',equivalence)]).
nounMapping2SUMO('04299526-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04299699-n',[ ('AnimalResidence',equivalence)]).
nounMapping2SUMO('04299828-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04299963-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04300080-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04300281-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04300358-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04300509-n',[ ('SelfPoweredDevice',subsumption)]).
nounMapping2SUMO('04300643-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04300741-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04301000-n',[ ('Table',subsumption)]).
nounMapping2SUMO('04301140-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04301242-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04301474-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04301626-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('04301760-n',[ ('AutomobileTransmission',subsumption)]).
nounMapping2SUMO('04301919-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04302034-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04302200-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04302334-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04302527-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04302598-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04302740-n',[ ('University',instance)]).
nounMapping2SUMO('04302863-n',[ ('UnpoweredVehicle',subsumption)]).
nounMapping2SUMO('04302988-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('04303095-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04303258-n',[ ('Nail',subsumption)]).
nounMapping2SUMO('04303357-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04303497-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04303672-n',[ ('Right',subsumption)]).
nounMapping2SUMO('04303852-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04304084-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04304215-n',[ ('Spacecraft',subsumption)]).
nounMapping2SUMO('04304375-n',[ ('ElectricMotor',subsumption)]).
nounMapping2SUMO('04304557-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04304680-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04304812-n',[ ('House',subsumption)]).
nounMapping2SUMO('04305016-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04305210-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04305323-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04305471-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04305572-n',[ ('Bedroom',subsumption)]).
nounMapping2SUMO('04305641-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04305947-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04306080-n',[ ('CommercialBuilding',equivalence)]).
nounMapping2SUMO('04306454-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('04306592-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04306847-n',[ ('Sculpture',subsumption)]).
nounMapping2SUMO('04307106-n',[ ('ArtWork',instance)]).
nounMapping2SUMO('04307269-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04307419-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04307619-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04307767-n',[ ('Sail',subsumption)]).
nounMapping2SUMO('04307878-n',[ ('Steakhouse',equivalence)]).
nounMapping2SUMO('04307986-n',[ ('Knife',subsumption)]).
nounMapping2SUMO('04308084-n',[ ('Aircraft',subsumption)]).
nounMapping2SUMO('04308273-n',[ ('Bomber',subsumption)]).
nounMapping2SUMO('04308397-n',[ ('Fighter',subsumption)]).
nounMapping2SUMO('04308583-n',[ ('SteamBath',equivalence)]).
nounMapping2SUMO('04308807-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04308915-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04309049-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04309348-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04309548-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04309682-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04309833-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04309925-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04310018-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04310157-n',[ ('LandVehicle',subsumption)]).
nounMapping2SUMO('04310347-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04310507-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04310604-n',[ ('Turbine',subsumption)]).
nounMapping2SUMO('04310721-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04310904-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('04311004-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04311174-n',[ ('Drum',subsumption)]).
nounMapping2SUMO('04311397-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('04311485-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('04311595-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04311799-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('04311873-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04312020-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04312154-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04312311-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04312432-n',[ ('Steeple',equivalence)]).
nounMapping2SUMO('04312654-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04312756-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04312916-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04313220-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04313503-n',[ ('SteeringWheel',subsumption)]).
nounMapping2SUMO('04313628-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04313771-n',[ ('Tube',subsumption), ('SmokingDevice',subsumption)]).
nounMapping2SUMO('04313867-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04313986-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04314107-n',[ ('WatchClock',subsumption)]).
nounMapping2SUMO('04314216-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04314522-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04314632-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04314735-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('04314914-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04315185-n',[ ('BoardOrBlock',subsumption)]).
nounMapping2SUMO('04315342-n',[ ('ElectricalTransformer',subsumption)]).
nounMapping2SUMO('04315444-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04315599-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04315713-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('04315828-n',[ ('ElectricalTransformer',subsumption)]).
nounMapping2SUMO('04315948-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04316275-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04316498-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04316646-n',[ ('BackFn',subsumption)]).
nounMapping2SUMO('04316815-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04316924-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04317063-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04317175-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04317325-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04317420-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('04317833-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('04317976-n',[ ('VehicleController',subsumption)]).
nounMapping2SUMO('04318131-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('04318384-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04318551-n',[ ('RecreationOrExerciseDevice',subsumption)]).
nounMapping2SUMO('04318690-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04318787-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04318892-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04318982-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04319248-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04319432-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04319545-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04319774-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04319937-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04320126-n',[ ('Stimulant',equivalence)]).
nounMapping2SUMO('04320405-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04320598-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('04320731-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('04320871-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04320973-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04321121-n',[ ('Pump',subsumption)]).
nounMapping2SUMO('04321238-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04321453-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('04321534-n',[ ('Product',subsumption)]).
nounMapping2SUMO('04321804-n',[ ('Handle',subsumption)]).
nounMapping2SUMO('04322026-n',[ ('GunStock',equivalence)]).
nounMapping2SUMO('04322387-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('04322531-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04322692-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('04322801-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('04322924-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('04323026-n',[ ('StockMarket',subsumption)]).
nounMapping2SUMO('04323519-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04323645-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04323819-n',[ ('Sock',subsumption)]).
nounMapping2SUMO('04324120-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04324297-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04324387-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04324515-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04324741-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04324910-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04325041-n',[ ('Saddle',subsumption)]).
nounMapping2SUMO('04325208-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04325335-n',[ ('CigarOrCigarette',subsumption)]).
nounMapping2SUMO('04325409-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04325592-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04325704-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04325804-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04325968-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04326084-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04326547-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04326676-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04326799-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04326896-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('04327110-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04327204-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04327324-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04327544-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('04327682-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04327825-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04328054-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04328186-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04328329-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04328580-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04328703-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04328946-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04329190-n',[ ('Warehouse',subsumption)]).
nounMapping2SUMO('04329477-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04329681-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04329834-n',[ ('Door',subsumption)]).
nounMapping2SUMO('04329958-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04330109-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04330189-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04330267-n',[ ('HeatingDevice',equivalence)]).
nounMapping2SUMO('04330340-n',[ ('Stove',subsumption)]).
nounMapping2SUMO('04330669-n',[ ('Bolt',subsumption)]).
nounMapping2SUMO('04330746-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04330896-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('04330998-n',[ ('Violin',subsumption)]).
nounMapping2SUMO('04331126-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04331277-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('04331443-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04331639-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04331765-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04331892-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04332074-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04332243-n',[ ('Filter',subsumption)]).
nounMapping2SUMO('04332466-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04332580-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04332783-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04332987-n',[ ('Whip',subsumption)]).
nounMapping2SUMO('04333129-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04333500-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04333709-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04333869-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04334105-n',[ ('Dress',subsumption)]).
nounMapping2SUMO('04334232-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('04334365-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04334504-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04334599-n',[ ('Roadway',equivalence)]).
nounMapping2SUMO('04335209-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('04335435-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('04335693-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04335886-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04336034-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04336380-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04336533-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04336645-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04336792-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04336996-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04337157-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04337287-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('04337400-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04337503-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04337650-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04337740-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04337974-n',[ ('String',subsumption)]).
nounMapping2SUMO('04338143-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04338359-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04338517-n',[ ('StringInstrument',equivalence)]).
nounMapping2SUMO('04338963-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04339062-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04339191-n',[ ('TieClothing',subsumption)]).
nounMapping2SUMO('04339291-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04339638-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04339879-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('04340019-n',[ ('RetailStore',subsumption)]).
nounMapping2SUMO('04340231-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04340378-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04340521-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04340750-n',[ ('SafeContainer',equivalence)]).
nounMapping2SUMO('04340935-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04341133-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04341288-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04341414-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04341686-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04343148-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04343272-n',[ ('Nail',subsumption)]).
nounMapping2SUMO('04343346-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04343511-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04343630-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04343740-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04343919-n',[ ('Farm',subsumption)]).
nounMapping2SUMO('04344003-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('04344246-n',[ ('ArtStudio',equivalence)]).
nounMapping2SUMO('04344544-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04344734-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04344873-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04345028-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04345201-n',[ ('Classroom',subsumption)]).
nounMapping2SUMO('04345288-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04345458-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('04345595-n',[ ('MechanicalDevice',subsumption)]).
nounMapping2SUMO('04345787-n',[ ('MechanicalNut',subsumption)]).
nounMapping2SUMO('04345915-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('04346003-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04346157-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04346328-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04346428-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04346511-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04346679-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04346855-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('04347004-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04347119-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('04347225-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04347519-n',[ ('Gun',subsumption)]).
nounMapping2SUMO('04347754-n',[ ('Submarine',subsumption)]).
nounMapping2SUMO('04348070-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04348184-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04348359-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04348548-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('04348702-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04348854-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04348988-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04349077-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04349189-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04349306-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04349401-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04349526-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04349701-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04349913-n',[ ('AttachingDevice',subsumption)]).
nounMapping2SUMO('04350104-n',[ ('Pump',subsumption)]).
nounMapping2SUMO('04350235-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04350347-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04350458-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04350581-n',[ ('Dish',subsumption)]).
nounMapping2SUMO('04350688-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04350769-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('04350905-n',[ ('ClothingSuit',subsumption)]).
nounMapping2SUMO('04351233-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04351550-n',[ ('Suite',equivalence)]).
nounMapping2SUMO('04351699-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04351776-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04351936-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04352070-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04352435-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04352580-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04352759-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04352906-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04353016-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04353189-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04353410-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04353573-n',[ ('LandVehicle',subsumption), ('UnpoweredVehicle',subsumption)]).
nounMapping2SUMO('04353687-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04353803-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('04354026-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04354182-n',[ ('GameArtifact',subsumption)]).
nounMapping2SUMO('04354287-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('04354387-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04354487-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04354589-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04354723-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04354828-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04354966-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04355115-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04355267-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04355338-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04355511-n',[ ('Dress',subsumption)]).
nounMapping2SUMO('04355684-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04355821-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04355933-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04356056-n',[ ('ProtectiveEyewear',subsumption)]).
nounMapping2SUMO('04356306-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04356423-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04356595-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('04356772-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04356925-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04357121-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04357314-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04357531-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04357639-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04357795-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04357930-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04358117-n',[ ('Computer',subsumption)]).
nounMapping2SUMO('04358256-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04358381-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04358491-n',[ ('ComputerNetwork',subsumption)]).
nounMapping2SUMO('04358707-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04358874-n',[ ('Above',subsumption)]).
nounMapping2SUMO('04359034-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04359124-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04359217-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04359335-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04359500-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04359589-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04360501-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04360798-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04360914-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04361095-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04361260-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04361381-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04361529-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04361641-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04361801-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04361937-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04362025-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04362624-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04362821-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04362972-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04363082-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04363210-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04363412-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04363559-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04363671-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04363777-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('04363874-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04363991-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04364160-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04364397-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04364545-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04364827-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04364994-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04365112-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04365229-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04365328-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04365484-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04365751-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04366033-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04366116-n',[ ('AutomobileSuspension',equivalence)]).
nounMapping2SUMO('04366367-n',[ ('Bridge',subsumption)]).
nounMapping2SUMO('04366832-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04367011-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04367205-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04367371-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04367480-n',[ ('CleaningDevice',subsumption)]).
nounMapping2SUMO('04367746-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04367950-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04368109-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('04368235-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04368365-n',[ ('WalkingCane',subsumption)]).
nounMapping2SUMO('04368496-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04368695-n',[ ('Vehicle',subsumption), ('PoweredVehicle',subsumption)]).
nounMapping2SUMO('04368840-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04368949-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04369025-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04369146-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04369282-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04369485-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04369618-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04369732-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04369856-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04369973-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04370048-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04370288-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('04370456-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04370600-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04370774-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04370955-n',[ ('Oar',subsumption)]).
nounMapping2SUMO('04371050-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04371225-n',[ ('SwimmingPool',equivalence)]).
nounMapping2SUMO('04371430-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('04371563-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04371774-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04371979-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04372171-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04372370-n',[ ('SwitchDevice',equivalence)]).
nounMapping2SUMO('04372756-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04372948-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04373089-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04373264-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04373428-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04373563-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04373704-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('04373795-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04373894-n',[ ('Sword',subsumption)]).
nounMapping2SUMO('04374315-n',[ ('Weapon',subsumption), ('WalkingCane',subsumption)]).
nounMapping2SUMO('04374421-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04374521-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04374608-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('04374735-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04374907-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04375080-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04375241-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04375405-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04375615-n',[ ('ElectricMotor',subsumption)]).
nounMapping2SUMO('04375775-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04375926-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04376259-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04376400-n',[ ('MusicalInstrument',subsumption)]).
nounMapping2SUMO('04376715-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04376876-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04377057-n',[ ('PhysicalSystem',equivalence)]).
nounMapping2SUMO('04377842-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04378024-n',[ ('Clock',subsumption)]).
nounMapping2SUMO('04378123-n',[ ('BoardOrBlock',subsumption)]).
nounMapping2SUMO('04378489-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04378651-n',[ ('Container',instance)]).
nounMapping2SUMO('04378842-n',[ ('ReligiousBuilding',instance)]).
nounMapping2SUMO('04378956-n',[ ('Sock',subsumption)]).
nounMapping2SUMO('04379096-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04379243-n',[ ('Table',equivalence)]).
nounMapping2SUMO('04379964-n',[ ('Table',subsumption)]).
nounMapping2SUMO('04380143-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04380255-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('04380346-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04380533-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04380617-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04380801-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04380916-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04381073-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('04381183-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04381302-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04381450-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('04381587-n',[ ('GameArtifact',subsumption)]).
nounMapping2SUMO('04381724-n',[ ('GameArtifact',subsumption)]).
nounMapping2SUMO('04381860-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04381994-n',[ ('Tableware',equivalence)]).
nounMapping2SUMO('04382334-n',[ ('Drum',subsumption)]).
nounMapping2SUMO('04382438-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('04382537-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04382695-n',[ ('Tachometer',subsumption)]).
nounMapping2SUMO('04382880-n',[ ('Tachometer',equivalence)]).
nounMapping2SUMO('04383015-n',[ ('MeasuringDevice',subsumption)]).
nounMapping2SUMO('04383130-n',[ ('Nail',subsumption)]).
nounMapping2SUMO('04383301-n',[ ('Hammer',subsumption)]).
nounMapping2SUMO('04383401-n',[ ('FixedBridge',instance)]).
nounMapping2SUMO('04383537-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('04383696-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04383839-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04383923-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04384016-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04384199-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04384406-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04384593-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04384757-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04384910-n',[ ('VehicleLight',subsumption)]).
nounMapping2SUMO('04385079-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04385157-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04385272-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04385431-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04385536-n',[ ('Tailpipe',equivalence)]).
nounMapping2SUMO('04385669-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04385799-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04386051-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04386283-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('04386456-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04386664-n',[ ('Sandal',subsumption)]).
nounMapping2SUMO('04386792-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('04386962-n',[ ('AudioRecording',subsumption)]).
nounMapping2SUMO('04387095-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04387201-n',[ ('Drum',subsumption)]).
nounMapping2SUMO('04387261-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04387400-n',[ ('Drum',subsumption)]).
nounMapping2SUMO('04387531-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04387706-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04387932-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04388040-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04388162-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04388372-n',[ ('Truck',subsumption)]).
nounMapping2SUMO('04388473-n',[ ('CookingOven',subsumption)]).
nounMapping2SUMO('04388574-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04388743-n',[ ('FluidContainer',subsumption)]).
nounMapping2SUMO('04389033-n',[ ('MilitaryTank',equivalence)]).
nounMapping2SUMO('04389340-n',[ ('PaintedPicture',subsumption)]).
nounMapping2SUMO('04389430-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04389521-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('04389637-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04389718-n',[ ('MilitaryVehicle',subsumption), ('LandVehicle',subsumption), ('PoweredVehicle',subsumption)]).
nounMapping2SUMO('04389854-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04389999-n',[ ('Airplane',subsumption)]).
nounMapping2SUMO('04390156-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04390338-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('04390483-n',[ ('ProjectileShell',subsumption)]).
nounMapping2SUMO('04390577-n',[ ('Shirt',subsumption)]).
nounMapping2SUMO('04390759-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04390873-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04390977-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04391158-n',[ ('MechanicalTap',equivalence)]).
nounMapping2SUMO('04391276-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04391445-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04391569-n',[ ('Tape',equivalence)]).
nounMapping2SUMO('04391838-n',[ ('Recording',subsumption)]).
nounMapping2SUMO('04392113-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04392370-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04392526-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04392764-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04392985-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04393095-n',[ ('TapeRecorder',equivalence)]).
nounMapping2SUMO('04393301-n',[ ('FileDevice',subsumption)]).
nounMapping2SUMO('04393404-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04393549-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04393681-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04393808-n',[ ('Lever',subsumption)]).
nounMapping2SUMO('04393913-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04394031-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('04394261-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04394421-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04394630-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('04394821-n',[ ('PlayingCard',subsumption)]).
nounMapping2SUMO('04395024-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04395106-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04395201-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04395332-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04395495-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04395651-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04395760-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04395875-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04396093-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04396226-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04396335-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04396466-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04396650-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04396808-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04396902-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04397027-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04397168-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04397261-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04397378-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04397452-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04397553-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04397645-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04397768-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04397860-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04397949-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04398044-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04398167-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04398309-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04398497-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04398688-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('04398834-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04398951-n',[ ('Table',subsumption)]).
nounMapping2SUMO('04399046-n',[ ('Tray',subsumption)]).
nounMapping2SUMO('04399158-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04399269-n',[ ('Truck',subsumption)]).
nounMapping2SUMO('04399382-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04399537-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04399700-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04399846-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04400109-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04400289-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04400499-n',[ ('Telegraph',subsumption)]).
nounMapping2SUMO('04400737-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04400899-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04401088-n',[ ('Telephone',equivalence)]).
nounMapping2SUMO('04401578-n',[ ('Bell',subsumption)]).
nounMapping2SUMO('04401680-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04401828-n',[ ('Cable',subsumption)]).
nounMapping2SUMO('04401949-n',[ ('ElectricalPlug',subsumption)]).
nounMapping2SUMO('04402057-n',[ ('Cable',subsumption)]).
nounMapping2SUMO('04402342-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04402449-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04402580-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04402746-n',[ ('TelephoneSystem',subsumption)]).
nounMapping2SUMO('04402984-n',[ ('TelephoneLine',subsumption)]).
nounMapping2SUMO('04403167-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04403279-n',[ ('Photograph',subsumption)]).
nounMapping2SUMO('04403413-n',[ ('OpticalDevice',subsumption)]).
nounMapping2SUMO('04403524-n',[ ('CommunicationDevice',subsumption)]).
nounMapping2SUMO('04403638-n',[ ('OpticalDevice',subsumption)]).
nounMapping2SUMO('04403925-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04404072-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('04404200-n',[ ('Telex',equivalence)]).
nounMapping2SUMO('04404412-n',[ ('TelevisionStation',equivalence)]).
nounMapping2SUMO('04404817-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04404997-n',[ ('Camera',subsumption)]).
nounMapping2SUMO('04405309-n',[ ('CommunicationDevice',subsumption)]).
nounMapping2SUMO('04405540-n',[ ('CommunicationDevice',subsumption)]).
nounMapping2SUMO('04405762-n',[ ('CommunicationDevice',subsumption)]).
nounMapping2SUMO('04405907-n',[ ('TelevisionSet',equivalence)]).
nounMapping2SUMO('04406239-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04406350-n',[ ('TelevisionStation',equivalence)]).
nounMapping2SUMO('04406552-n',[ ('TelevisionStation',subsumption)]).
nounMapping2SUMO('04406687-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04406817-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04407007-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04407257-n',[ ('Paint',subsumption)]).
nounMapping2SUMO('04407435-n',[ ('ReligiousBuilding',subsumption)]).
nounMapping2SUMO('04407686-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04407844-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('04408174-n',[ ('ReligiousBuilding',instance)]).
nounMapping2SUMO('04408330-n',[ ('Building',instance)]).
nounMapping2SUMO('04408871-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04409011-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04409128-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04409279-n',[ ('RailVehicle',subsumption)]).
nounMapping2SUMO('04409384-n',[ ('ApartmentBuilding',subsumption)]).
nounMapping2SUMO('04409515-n',[ ('TennisBall',equivalence)]).
nounMapping2SUMO('04409625-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('04409712-n',[ ('TennisCourt',equivalence)]).
nounMapping2SUMO('04409806-n',[ ('GameArtifact',subsumption)]).
nounMapping2SUMO('04409911-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04410086-n',[ ('Drum',subsumption)]).
nounMapping2SUMO('04410190-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04410365-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('04410485-n',[ ('Nail',subsumption)]).
nounMapping2SUMO('04410565-n',[ ('GamePiece',subsumption)]).
nounMapping2SUMO('04410663-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04410760-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04410886-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04411019-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04411142-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04411264-n',[ ('Tent',equivalence)]).
nounMapping2SUMO('04411835-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04411966-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04412097-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04412300-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04412416-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04412550-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04412727-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04412901-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04413151-n',[ ('ElectricDevice',subsumption)]).
nounMapping2SUMO('04413419-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04413631-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04413723-n',[ ('Sculpture',subsumption)]).
nounMapping2SUMO('04413969-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04414101-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04414199-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04414319-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04414476-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04414675-n',[ ('ElectricalTransformer',subsumption)]).
nounMapping2SUMO('04414821-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04414909-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04415078-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04415257-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04415354-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04415460-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04415578-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04415663-n',[ ('Rocket',subsumption)]).
nounMapping2SUMO('04415815-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04415921-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04416005-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04416201-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04416338-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04416530-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04416785-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04416901-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04417086-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04417180-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04417361-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04417467-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04417672-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04417809-n',[ ('Auditorium',subsumption)]).
nounMapping2SUMO('04418357-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04418644-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('04418818-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04419073-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04419315-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04419642-n',[ ('MusicalInstrument',subsumption)]).
nounMapping2SUMO('04419868-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04420024-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04420206-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04420461-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('04420720-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('04421083-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('04421258-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('04421417-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04421582-n',[ ('Hydrometer',subsumption)]).
nounMapping2SUMO('04421740-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04421872-n',[ ('Thermometer',equivalence)]).
nounMapping2SUMO('04422409-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04422566-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('04422727-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04422875-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04423174-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04423288-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04423552-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04423687-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04423845-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04424003-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04424218-n',[ ('Artifact',equivalence)]).
nounMapping2SUMO('04424418-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('04424692-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04424826-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04424936-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04425262-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04425445-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04425544-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04425656-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04425804-n',[ ('BaseballBase',subsumption)]).
nounMapping2SUMO('04425977-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04426184-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04426316-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04426427-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04426618-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04426788-n',[ ('String',subsumption)]).
nounMapping2SUMO('04427216-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04427376-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04427473-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04427559-n',[ ('Radar',subsumption)]).
nounMapping2SUMO('04427715-n',[ ('ClothingSuit',subsumption)]).
nounMapping2SUMO('04427857-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04428008-n',[ ('SwitchDevice',subsumption)]).
nounMapping2SUMO('04428191-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04428382-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04428502-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04428634-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04428763-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04428920-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04429038-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04429169-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04429376-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('04429613-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04429756-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('04429971-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04430158-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04430364-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04430475-n',[ ('Bearing',subsumption)]).
nounMapping2SUMO('04430605-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04430738-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04430896-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04431025-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('04431158-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('04431296-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04431436-n',[ ('Screw',subsumption)]).
nounMapping2SUMO('04431547-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04431648-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04431745-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04431925-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04432043-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04432203-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04432308-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04432393-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04432538-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04432662-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04432785-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04432942-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04433077-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04433185-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04433377-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04433585-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04433800-n',[ ('Jewelry',subsumption)]).
nounMapping2SUMO('04433905-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('04434059-n',[ ('String',subsumption)]).
nounMapping2SUMO('04434207-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04434285-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04434531-n',[ ('TieRod',equivalence)]).
nounMapping2SUMO('04434670-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04434780-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04434932-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04435180-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04435378-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04435552-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04435653-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04435759-n',[ ('VehicleController',subsumption)]).
nounMapping2SUMO('04435870-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04436012-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04436185-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04436329-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04436401-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04436542-n',[ ('Drum',subsumption)]).
nounMapping2SUMO('04436675-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04436832-n',[ ('Bomb',subsumption)]).
nounMapping2SUMO('04436992-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04437131-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04437276-n',[ ('Clock',subsumption)]).
nounMapping2SUMO('04437380-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04437552-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04437670-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04437793-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04437953-n',[ ('Clock',subsumption)]).
nounMapping2SUMO('04438304-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04438507-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04438643-n',[ ('SwitchDevice',subsumption), ('Clock',subsumption)]).
nounMapping2SUMO('04438742-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04438897-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04439039-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04439122-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04439305-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04439505-n',[ ('Box',subsumption)]).
nounMapping2SUMO('04439585-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04439712-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('04439840-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('04440059-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04440210-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04440399-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04440486-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04440597-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04440749-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04440963-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04441093-n',[ ('Lever',subsumption)]).
nounMapping2SUMO('04441282-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04441528-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('04441662-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04441790-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04441902-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04442016-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04442143-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('04442312-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04442441-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04442582-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('04442741-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04442831-n',[ ('Tobacco',equivalence)]).
nounMapping2SUMO('04443164-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04443257-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04443433-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04443588-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04443766-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04443918-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04444121-n',[ ('Bell',subsumption)]).
nounMapping2SUMO('04444218-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04444345-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('04444522-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04444749-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04444953-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('04445040-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04445154-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04445327-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04445610-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04445782-n',[ ('MechanicalJoint',subsumption)]).
nounMapping2SUMO('04445952-n',[ ('SwitchDevice',subsumption)]).
nounMapping2SUMO('04446162-n',[ ('Clothing',equivalence)]).
nounMapping2SUMO('04446276-n',[ ('Bathroom',subsumption)]).
nounMapping2SUMO('04446521-n',[ ('Toilet',subsumption)]).
nounMapping2SUMO('04446844-n',[ ('Bag',subsumption)]).
nounMapping2SUMO('04447028-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04447156-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04447276-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('04447443-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04447861-n',[ ('Seat',subsumption)]).
nounMapping2SUMO('04447965-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('04448070-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('04448185-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04448361-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04448511-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04448680-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04448826-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04449046-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04449290-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04449449-n',[ ('Bridge',subsumption)]).
nounMapping2SUMO('04449550-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04449700-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04449796-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04449966-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04450133-n',[ ('Gun',subsumption)]).
nounMapping2SUMO('04450243-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04450465-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04450640-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('04450749-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04450994-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04451139-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04451318-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04451473-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04451636-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04451818-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04452528-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04452615-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04452757-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04452848-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04453037-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04453156-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04453298-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('04453390-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04453557-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('04453666-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04453910-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04454240-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04454540-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04454654-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04454792-n',[ ('Sail',subsumption)]).
nounMapping2SUMO('04454908-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04455048-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04455169-n',[ ('WearableItem',subsumption)]).
nounMapping2SUMO('04455250-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04455442-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04455579-n',[ ('Coat',subsumption)]).
nounMapping2SUMO('04455652-n',[ ('Sail',subsumption)]).
nounMapping2SUMO('04455835-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04456011-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('04456115-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('04456276-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04456472-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04456734-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04456964-n',[ ('ExplosiveDevice',subsumption)]).
nounMapping2SUMO('04457157-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04457326-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04457474-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04457638-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('04457767-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04457910-n',[ ('TorqueWrench',equivalence)]).
nounMapping2SUMO('04458045-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04458201-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04458299-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04458409-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04458633-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04458843-n',[ ('VideoDisplay',subsumption)]).
nounMapping2SUMO('04459018-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04459122-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('04459243-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04459362-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04459610-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04459773-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04459909-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04460038-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04460130-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04460634-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('04460947-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('04461148-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('04461294-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04461437-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04461570-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04461696-n',[ ('Truck',subsumption)]).
nounMapping2SUMO('04461879-n',[ ('RecreationOrExerciseDevice',subsumption)]).
nounMapping2SUMO('04462011-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04462102-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04462240-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04462318-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04462407-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04462576-n',[ ('MeasuringDevice',subsumption)]).
nounMapping2SUMO('04462707-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04462835-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04463017-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04463141-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04463273-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04463510-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04463679-n',[ ('RailroadTrack',subsumption)]).
nounMapping2SUMO('04463983-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04464125-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04464211-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04464418-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04464615-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04464852-n',[ ('LandVehicle',subsumption)]).
nounMapping2SUMO('04465050-n',[ ('House',subsumption)]).
nounMapping2SUMO('04465203-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04465358-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04465501-n',[ ('LandVehicle',subsumption), ('PoweredVehicle',subsumption)]).
nounMapping2SUMO('04465666-n',[ ('Truck',subsumption)]).
nounMapping2SUMO('04465795-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('04465933-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04466169-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04466386-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('04466613-n',[ ('Trail',subsumption)]).
nounMapping2SUMO('04466871-n',[ ('PoweredVehicle',subsumption), ('LandVehicle',subsumption), ('PassengerVehicle',subsumption)]).
nounMapping2SUMO('04467099-n',[ ('Trailer',equivalence)]).
nounMapping2SUMO('04467307-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04467506-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04467665-n',[ ('Truck',subsumption)]).
nounMapping2SUMO('04467899-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04468005-n',[ ('Train',equivalence)]).
nounMapping2SUMO('04468476-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04468707-n',[ ('RecreationOrExerciseDevice',subsumption)]).
nounMapping2SUMO('04468847-n',[ ('Streetcar',subsumption)]).
nounMapping2SUMO('04469003-n',[ ('RailroadTrack',subsumption)]).
nounMapping2SUMO('04469147-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04469251-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04469345-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04469514-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04469684-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04469813-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04470037-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('04470232-n',[ ('Depressant',subsumption)]).
nounMapping2SUMO('04470605-n',[ ('Recording',subsumption)]).
nounMapping2SUMO('04470741-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04470953-n',[ ('Transducer',equivalence)]).
nounMapping2SUMO('04471148-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04471315-n',[ ('ElectricalTransformer',equivalence)]).
nounMapping2SUMO('04471632-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04471912-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04472098-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04472243-n',[ ('Transmission',equivalence)]).
nounMapping2SUMO('04472563-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04472726-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04472961-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04473108-n',[ ('Window',subsumption)]).
nounMapping2SUMO('04473275-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04473432-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04473884-n',[ ('Crane',subsumption)]).
nounMapping2SUMO('04474035-n',[ ('Truck',subsumption)]).
nounMapping2SUMO('04474187-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04474317-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04474466-n',[ ('TrapOrCage',subsumption)]).
nounMapping2SUMO('04474843-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04474922-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04475032-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04475195-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04475309-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04475411-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04475496-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04475631-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04475749-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04475900-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04476116-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04476259-n',[ ('Tray',equivalence)]).
nounMapping2SUMO('04476526-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04476633-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('04476831-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04476972-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04477091-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04477219-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04477387-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04477548-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04477638-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04477725-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04477825-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04477966-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04478066-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04478257-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04478383-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04478512-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04478657-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04478889-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('04479046-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04479155-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04479287-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04479405-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04479526-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04479694-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04479823-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04479939-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04480033-n',[ ('Table',subsumption)]).
nounMapping2SUMO('04480141-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04480303-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('04480415-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04480527-n',[ ('Balloon',subsumption)]).
nounMapping2SUMO('04480625-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04480853-n',[ ('PercussionInstrument',subsumption)]).
nounMapping2SUMO('04480995-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04481144-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04481255-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04481373-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04481524-n',[ ('Table',subsumption)]).
nounMapping2SUMO('04481642-n',[ ('DiningRoom',subsumption)]).
nounMapping2SUMO('04481796-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04481946-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04482177-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04482297-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04482393-n',[ ('SelfPoweredRoadVehicle',subsumption)]).
nounMapping2SUMO('04482543-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04482975-n',[ ('Spear',subsumption)]).
nounMapping2SUMO('04483073-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04483210-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('04483307-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04483399-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04483584-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04483779-n',[ ('CapacitorElement',subsumption)]).
nounMapping2SUMO('04483925-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04484024-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04484160-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04484432-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04484647-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04484780-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04484952-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04485082-n',[ ('Tripod',equivalence)]).
nounMapping2SUMO('04485226-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04485423-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04485586-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04485750-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04485884-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04486054-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04486213-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04486322-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04486445-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04486616-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04486718-n',[ ('Artifact',instance)]).
nounMapping2SUMO('04486934-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04487081-n',[ ('Bus',subsumption)]).
nounMapping2SUMO('04487268-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04487394-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('04487576-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04487724-n',[ ('PassengerVehicle',subsumption)]).
nounMapping2SUMO('04487894-n',[ ('WaterVehicle',subsumption), ('PassengerVehicle',subsumption)]).
nounMapping2SUMO('04487996-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04488202-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04488295-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04488427-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04488530-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('04488742-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04488857-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04489008-n',[ ('Trousers',subsumption)]).
nounMapping2SUMO('04489695-n',[ ('Outfit',subsumption)]).
nounMapping2SUMO('04489817-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04490091-n',[ ('Truck',equivalence)]).
nounMapping2SUMO('04490490-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04490614-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04490730-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04490859-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04491135-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04491312-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04491388-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04491545-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04491638-n',[ ('Bed',subsumption)]).
nounMapping2SUMO('04491769-n',[ ('Box',subsumption)]).
nounMapping2SUMO('04491934-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04492060-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04492157-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04492264-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04492375-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04492585-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04492749-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04492856-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04493109-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04493259-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04493381-n',[ ('FluidContainer',subsumption)]).
nounMapping2SUMO('04493505-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('04494204-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04494762-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04494906-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04495051-n',[ ('Box',subsumption)]).
nounMapping2SUMO('04495183-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04495310-n',[ ('Bag',subsumption)]).
nounMapping2SUMO('04495450-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('04495555-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04495698-n',[ ('Veil',subsumption)]).
nounMapping2SUMO('04495843-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04496035-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('04496173-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('04496404-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04496519-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04496614-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04496726-n',[ ('ClothesDryer',subsumption)]).
nounMapping2SUMO('04496872-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04497005-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04497249-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04497442-n',[ ('FluidContainer',subsumption)]).
nounMapping2SUMO('04497570-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04497801-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04497962-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04498275-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04498389-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('04498523-n',[ ('Turbine',subsumption)]).
nounMapping2SUMO('04498873-n',[ ('Generator',subsumption)]).
nounMapping2SUMO('04499062-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04499180-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04499300-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04499446-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04499554-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04499660-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04499810-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04500060-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04500294-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04500390-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04500504-n',[ ('Process',subsumption)]).
nounMapping2SUMO('04500613-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04500704-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04500866-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('04501018-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04501127-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04501281-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04501370-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04501550-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04501713-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04501837-n',[ ('Tray',subsumption)]).
nounMapping2SUMO('04501947-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04502059-n',[ ('Clock',subsumption)]).
nounMapping2SUMO('04502197-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04502364-n',[ ('Collar',subsumption)]).
nounMapping2SUMO('04502502-n',[ ('Wool',subsumption)]).
nounMapping2SUMO('04502670-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04502851-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04502989-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04503073-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04503155-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04503269-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04503413-n',[ ('SingleBed',subsumption)]).
nounMapping2SUMO('04503499-n',[ ('JetAirplane',subsumption)]).
nounMapping2SUMO('04503593-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04503705-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04503836-n',[ ('CuttingDevice',subsumption)]).
nounMapping2SUMO('04504038-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04504141-n',[ ('ClothingSuit',subsumption)]).
nounMapping2SUMO('04504297-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('04504486-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04504770-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04504935-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04505036-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04505345-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04505470-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04505706-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04505888-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('04506005-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04506125-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04506289-n',[ ('Guitar',subsumption)]).
nounMapping2SUMO('04506402-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04506506-n',[ ('MeasuringDevice',subsumption)]).
nounMapping2SUMO('04506688-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04506895-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04506994-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04507155-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04507326-n',[ ('Tent',subsumption)]).
nounMapping2SUMO('04507453-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04507609-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04507689-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('04507891-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('04508062-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04508163-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04508489-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04508804-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04508949-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04509171-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04509260-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04509417-n',[ ('LandVehicle',subsumption), ('AgentPoweredVehicle',subsumption)]).
nounMapping2SUMO('04509592-n',[ ('UniformClothing',equivalence)]).
nounMapping2SUMO('04509815-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04509985-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04510090-n',[ ('GovernmentOrganization',subsumption)]).
nounMapping2SUMO('04510456-n',[ ('GovernmentOrganization',subsumption)]).
nounMapping2SUMO('04510706-n',[ ('UniversalJoint',equivalence)]).
nounMapping2SUMO('04511002-n',[ ('University',equivalence)]).
nounMapping2SUMO('04511832-n',[ ('University',instance)]).
nounMapping2SUMO('04511971-n',[ ('University',instance)]).
nounMapping2SUMO('04512092-n',[ ('University',instance)]).
nounMapping2SUMO('04512216-n',[ ('University',instance)]).
nounMapping2SUMO('04512338-n',[ ('University',instance)]).
nounMapping2SUMO('04512476-n',[ ('University',instance)]).
nounMapping2SUMO('04512652-n',[ ('University',instance)]).
nounMapping2SUMO('04512783-n',[ ('University',instance)]).
nounMapping2SUMO('04512933-n',[ ('University',instance)]).
nounMapping2SUMO('04513048-n',[ ('University',instance)]).
nounMapping2SUMO('04513171-n',[ ('University',instance)]).
nounMapping2SUMO('04513297-n',[ ('University',instance)]).
nounMapping2SUMO('04513432-n',[ ('University',instance)]).
nounMapping2SUMO('04513556-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('04513686-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04513827-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04513998-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04514095-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04514241-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04514359-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04514648-n',[ ('Above',subsumption)]).
nounMapping2SUMO('04514738-n',[ ('Above',subsumption)]).
nounMapping2SUMO('04514899-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04515003-n',[ ('Piano',subsumption)]).
nounMapping2SUMO('04515129-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04515444-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04515630-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04515729-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04515890-n',[ ('FluidContainer',subsumption)]).
nounMapping2SUMO('04515991-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04516116-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04516214-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04516354-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('04516477-n',[ ('TransportationDevice',instance)]).
nounMapping2SUMO('04516672-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04516874-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04517211-n',[ ('Gun',instance)]).
nounMapping2SUMO('04517408-n',[ ('House',subsumption)]).
nounMapping2SUMO('04517535-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04517823-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04517999-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04518132-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04518343-n',[ ('VacuumGauge',equivalence)]).
nounMapping2SUMO('04518468-n',[ ('Medicine',instance)]).
nounMapping2SUMO('04518643-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04518764-n',[ ('TravelContainer',subsumption)]).
nounMapping2SUMO('04518854-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04519019-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('04519153-n',[ ('Valve',equivalence)]).
nounMapping2SUMO('04519536-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04519728-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04519887-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04520020-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04520170-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04520382-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04520480-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04520618-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04520784-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04520962-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04521125-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04521428-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('04521571-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04521699-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04521863-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04521987-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('04522168-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04522309-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('04522421-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04522904-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04523201-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04523380-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('04523525-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04523690-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04523831-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04523993-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04524142-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04524313-n',[ ('Vehicle',equivalence)]).
nounMapping2SUMO('04524594-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04524716-n',[ ('Bicycle',subsumption)]).
nounMapping2SUMO('04524833-n',[ ('SportsGround',subsumption)]).
nounMapping2SUMO('04524941-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04525038-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04525191-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04525305-n',[ ('VendingDevice',equivalence)]).
nounMapping2SUMO('04525417-n',[ ('Veneer',subsumption)]).
nounMapping2SUMO('04525584-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04525729-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04525821-n',[ ('Blueprint',subsumption)]).
nounMapping2SUMO('04526112-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04526241-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('04526416-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('04526520-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04526800-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04526964-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04527182-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04527310-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04527475-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04527648-n',[ ('Porch',subsumption)]).
nounMapping2SUMO('04527808-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04528079-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04528256-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04528354-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('04528490-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04528630-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04528968-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04529108-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04529312-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('04529486-n',[ ('City',instance)]).
nounMapping2SUMO('04529681-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04529795-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04529962-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04530176-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04530283-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04530456-n',[ ('Pistol',subsumption)]).
nounMapping2SUMO('04530566-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04531098-n',[ ('FluidContainer',subsumption)]).
nounMapping2SUMO('04531873-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04532022-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04532106-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04532398-n',[ ('Pocket',subsumption)]).
nounMapping2SUMO('04532504-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04532670-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04532831-n',[ ('PercussionInstrument',subsumption)]).
nounMapping2SUMO('04533042-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04533199-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04533373-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04533499-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04533594-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04533700-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04533802-n',[ ('VCRSystem',equivalence)]).
nounMapping2SUMO('04533946-n',[ ('DVD',equivalence)]).
nounMapping2SUMO('04534127-n',[ ('VideoRecording',equivalence)]).
nounMapping2SUMO('04534359-n',[ ('VideoCassette',equivalence)]).
nounMapping2SUMO('04534520-n',[ ('VideoCassette',equivalence)]).
nounMapping2SUMO('04534651-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04534779-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04534895-n',[ ('Candle',subsumption)]).
nounMapping2SUMO('04535011-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04535153-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04535252-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04535370-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04535524-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04535634-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04535826-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04536038-n',[ ('CultivatedLandArea',subsumption)]).
nounMapping2SUMO('04536153-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('04536335-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('04536465-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('04536595-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('04536765-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('04536866-n',[ ('Violin',equivalence)]).
nounMapping2SUMO('04537235-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04537436-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('04537602-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04537816-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04537919-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04538249-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04538403-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04538552-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04538759-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04538878-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04539053-n',[ ('VideoDisplay',subsumption)]).
nounMapping2SUMO('04539203-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04539407-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04539535-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04539648-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04539794-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04539876-n',[ ('ComputerMemory',subsumption)]).
nounMapping2SUMO('04540053-n',[ ('VolleyBall',equivalence)]).
nounMapping2SUMO('04540153-n',[ ('SportsFacility',subsumption)]).
nounMapping2SUMO('04540255-n',[ ('GameArtifact',subsumption)]).
nounMapping2SUMO('04540397-n',[ ('ElectricalTransformer',subsumption)]).
nounMapping2SUMO('04540547-n',[ ('Battery',subsumption)]).
nounMapping2SUMO('04540761-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04541136-n',[ ('Battery',subsumption)]).
nounMapping2SUMO('04541320-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04541475-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04541662-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04541777-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04541987-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04542095-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04542221-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04542329-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('04542474-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('04542595-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('04542715-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04542858-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04542943-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04543158-n',[ ('Trailer',subsumption)]).
nounMapping2SUMO('04543509-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04543636-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04543772-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04543924-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04543996-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04544138-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04544325-n',[ ('Wall',subsumption)]).
nounMapping2SUMO('04544450-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04544626-n',[ ('BoardOrBlock',subsumption)]).
nounMapping2SUMO('04544805-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04544979-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04545305-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04545471-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04545748-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('04545858-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04545984-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04546081-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('04546194-n',[ ('WalkingCane',subsumption)]).
nounMapping2SUMO('04546340-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04546481-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04546595-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04546734-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04546855-n',[ ('Wall',equivalence)]).
nounMapping2SUMO('04547592-n',[ ('Fence',subsumption)]).
nounMapping2SUMO('04547821-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04547991-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04548280-n',[ ('Clock',subsumption)]).
nounMapping2SUMO('04548362-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04548503-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04548613-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04548771-n',[ ('ElectricalOutlet',equivalence)]).
nounMapping2SUMO('04549028-n',[ ('Tent',subsumption)]).
nounMapping2SUMO('04549122-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04549276-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('04549407-n',[ ('Currency',subsumption)]).
nounMapping2SUMO('04549629-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04549721-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04549919-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04550184-n',[ ('Closet',subsumption)]).
nounMapping2SUMO('04550426-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04550546-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04550676-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04550840-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04551055-n',[ ('Warehouse',subsumption)]).
nounMapping2SUMO('04551205-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04551375-n',[ ('Weapon',subsumption), ('ExplosiveDevice',subsumption)]).
nounMapping2SUMO('04551638-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04551833-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04551950-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04552097-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04552195-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('04552348-n',[ ('MilitaryAircraft',subsumption)]).
nounMapping2SUMO('04552551-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04552696-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04553245-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04553389-n',[ ('Paint',subsumption)]).
nounMapping2SUMO('04553561-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04553703-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04553920-n',[ ('WashBasin',subsumption)]).
nounMapping2SUMO('04554211-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04554406-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04554523-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04554684-n',[ ('ClothesWashingMachine',subsumption)]).
nounMapping2SUMO('04554871-n',[ ('Gasket',subsumption)]).
nounMapping2SUMO('04554998-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04555101-n',[ ('Monument',instance)]).
nounMapping2SUMO('04555291-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04555400-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04555600-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04555700-n',[ ('Wastebasket',subsumption)]).
nounMapping2SUMO('04555897-n',[ ('WatchClock',equivalence)]).
nounMapping2SUMO('04556204-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04556408-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04556533-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04556664-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04556816-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04556948-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04557111-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04557308-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('04557522-n',[ ('WaterBed',equivalence)]).
nounMapping2SUMO('04557648-n',[ ('Bottle',subsumption)]).
nounMapping2SUMO('04557751-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04557872-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04558059-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04558199-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04558347-n',[ ('Clock',subsumption)]).
nounMapping2SUMO('04558478-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04558578-n',[ ('WatercolorPicture',subsumption)]).
nounMapping2SUMO('04558804-n',[ ('WatercolorPaint',subsumption)]).
nounMapping2SUMO('04559023-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04559166-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04559275-n',[ ('Waterway',equivalence)]).
nounMapping2SUMO('04559451-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04559620-n',[ ('Filter',subsumption)]).
nounMapping2SUMO('04559730-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04559910-n',[ ('Cup',subsumption)]).
nounMapping2SUMO('04559994-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04560113-n',[ ('WaterHeater',equivalence)]).
nounMapping2SUMO('04560292-n',[ ('FluidContainer',subsumption)]).
nounMapping2SUMO('04560502-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04560619-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04560804-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04560882-n',[ ('Water',subsumption)]).
nounMapping2SUMO('04561010-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04561167-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04561287-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04561422-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04561548-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04561734-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04561857-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('04561965-n',[ ('EngineWaterPump',equivalence)]).
nounMapping2SUMO('04562122-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04562262-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04562390-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04562496-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04562658-n',[ ('Water',subsumption)]).
nounMapping2SUMO('04562935-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04563020-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04563204-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04563413-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04563560-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04563790-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04563942-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04564118-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04564278-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04564413-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04564581-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04564698-n',[ ('Transitway',subsumption)]).
nounMapping2SUMO('04565039-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04565233-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04565375-n',[ ('Weapon',equivalence)]).
nounMapping2SUMO('04565963-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04566257-n',[ ('Weapon',equivalence)]).
nounMapping2SUMO('04566561-n',[ ('MilitaryVehicle',subsumption), ('Truck',subsumption)]).
nounMapping2SUMO('04566756-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04566862-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04567098-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04567222-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04567480-n',[ ('Radar',subsumption)]).
nounMapping2SUMO('04567593-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04567746-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04567870-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04568069-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04568298-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04568557-n',[ ('TrapOrCage',subsumption)]).
nounMapping2SUMO('04568713-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04568841-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04568944-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04569063-n',[ ('Camera',subsumption)]).
nounMapping2SUMO('04569205-n',[ ('Photograph',subsumption)]).
nounMapping2SUMO('04569338-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04569520-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04569822-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04569983-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04570118-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('04570214-n',[ ('Pottery',subsumption)]).
nounMapping2SUMO('04570416-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04570532-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04570680-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04570815-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04570958-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04571088-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04571292-n',[ ('RecreationOrExerciseDevice',subsumption)]).
nounMapping2SUMO('04571566-n',[ ('Dam',subsumption)]).
nounMapping2SUMO('04571686-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04571800-n',[ ('Vehicle',subsumption)]).
nounMapping2SUMO('04571958-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04572121-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04572235-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04572344-n',[ ('MineOrWell',subsumption)]).
nounMapping2SUMO('04572559-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04572800-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04572935-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04573045-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04573129-n',[ ('Tube',subsumption)]).
nounMapping2SUMO('04573281-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04573379-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04573513-n',[ ('WetBar',equivalence)]).
nounMapping2SUMO('04573625-n',[ ('Thermometer',subsumption)]).
nounMapping2SUMO('04573832-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04573937-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04574067-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04574234-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04574348-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04574471-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04574606-n',[ ('ProjectileLauncher',subsumption)]).
nounMapping2SUMO('04574761-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04574861-n',[ ('FinancialInstrument',subsumption)]).
nounMapping2SUMO('04574999-n',[ ('VehicleWheel',equivalence)]).
nounMapping2SUMO('04575723-n',[ ('Wheel',equivalence)]).
nounMapping2SUMO('04575824-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04576002-n',[ ('Wheelchair',equivalence)]).
nounMapping2SUMO('04576211-n',[ ('LandVehicle',subsumption)]).
nounMapping2SUMO('04576861-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04576971-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04577139-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04577293-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('04577426-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04577567-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04577769-n',[ ('Whip',equivalence)]).
nounMapping2SUMO('04578112-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04578220-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04578329-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04578459-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04578559-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04578708-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04578801-n',[ ('Broom',subsumption)]).
nounMapping2SUMO('04578934-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04579056-n',[ ('Bottle',subsumption)]).
nounMapping2SUMO('04579145-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04579230-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04579432-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('04579667-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('04579795-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04579986-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04580126-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04580298-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04580493-n',[ ('MajorAppliance',equivalence)]).
nounMapping2SUMO('04580777-n',[ ('Building',instance)]).
nounMapping2SUMO('04580994-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04581102-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('04581262-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04581425-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04581595-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04581829-n',[ ('LightFixture',subsumption)]).
nounMapping2SUMO('04582044-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04582205-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04582349-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04582454-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04582625-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04582771-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04582869-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04583022-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04583212-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04583477-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04583620-n',[ ('Airplane',subsumption)]).
nounMapping2SUMO('04583776-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04583888-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04583967-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04584056-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04584207-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04584373-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04584512-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04584639-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04584794-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04584944-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04585128-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04585318-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04585456-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04585626-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04585745-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04585980-n',[ ('Rifle',subsumption)]).
nounMapping2SUMO('04586072-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04586225-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04586421-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04586581-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04586761-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04586932-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('04587327-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('04587404-n',[ ('Generator',subsumption)]).
nounMapping2SUMO('04587559-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04587648-n',[ ('Window',equivalence)]).
nounMapping2SUMO('04588365-n',[ ('Window',subsumption)]).
nounMapping2SUMO('04588587-n',[ ('Window',subsumption)]).
nounMapping2SUMO('04588739-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04588986-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04589190-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04589325-n',[ ('Box',subsumption)]).
nounMapping2SUMO('04589434-n',[ ('Envelope',subsumption)]).
nounMapping2SUMO('04589593-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04589745-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04589890-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04590021-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04590129-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04590263-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04590416-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04590553-n',[ ('Windshield',equivalence)]).
nounMapping2SUMO('04590746-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04590933-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04591056-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('04591157-n',[ ('TieClothing',subsumption)]).
nounMapping2SUMO('04591249-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04591359-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04591517-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04591631-n',[ ('Tavern',subsumption)]).
nounMapping2SUMO('04591713-n',[ ('Bottle',subsumption)]).
nounMapping2SUMO('04591887-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04592005-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04592099-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04592243-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04592356-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04592465-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04592596-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04592741-n',[ ('WingDevice',subsumption)]).
nounMapping2SUMO('04592962-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04593077-n',[ ('Chair',subsumption)]).
nounMapping2SUMO('04593185-n',[ ('MechanicalNut',subsumption)]).
nounMapping2SUMO('04593376-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04593524-n',[ ('Shoe',subsumption)]).
nounMapping2SUMO('04593629-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04593866-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04594114-n',[ ('ElectricMotor',subsumption)]).
nounMapping2SUMO('04594218-n',[ ('Wire',equivalence)]).
nounMapping2SUMO('04594489-n',[ ('Wire',equivalence)]).
nounMapping2SUMO('04594742-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04594828-n',[ ('CuttingDevice',subsumption)]).
nounMapping2SUMO('04594919-n',[ ('MeasuringDevice',subsumption)]).
nounMapping2SUMO('04595028-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04595285-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04595501-n',[ ('TapeRecorder',subsumption)]).
nounMapping2SUMO('04595611-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04595762-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04595855-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04595998-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04596116-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04596224-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04596397-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04596492-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04596630-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('04596742-n',[ ('PotOrPan',subsumption)]).
nounMapping2SUMO('04596852-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04597066-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04597309-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04597400-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04597536-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04597706-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04597804-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04597913-n',[ ('Tableware',subsumption)]).
nounMapping2SUMO('04598010-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04598136-n',[ ('Screw',subsumption)]).
nounMapping2SUMO('04598318-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04598416-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04598582-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('04598792-n',[ ('WoodArtifact',subsumption)]).
nounMapping2SUMO('04598965-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04599124-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04599235-n',[ ('Wool',subsumption)]).
nounMapping2SUMO('04599396-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04600131-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04600312-n',[ ('Container',subsumption)]).
nounMapping2SUMO('04600486-n',[ ('Table',subsumption)]).
nounMapping2SUMO('04600627-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04600764-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('04600912-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04601041-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04601159-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04601291-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04601473-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04601587-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04601690-n',[ ('ArtWork',equivalence)]).
nounMapping2SUMO('04601938-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('04602044-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04602762-n',[ ('Room',subsumption)]).
nounMapping2SUMO('04602840-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04602956-n',[ ('Shirt',subsumption)]).
nounMapping2SUMO('04603081-n',[ ('Workshop',subsumption)]).
nounMapping2SUMO('04603399-n',[ ('Computer',subsumption)]).
nounMapping2SUMO('04603558-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04603729-n',[ ('Table',subsumption)]).
nounMapping2SUMO('04603872-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04604009-n',[ ('Building',instance)]).
nounMapping2SUMO('04604276-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04604513-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04604644-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04604806-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04605057-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04605163-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04605321-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04605446-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04605572-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04605726-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04606014-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('04606251-n',[ ('DamagedVehicle',subsumption)]).
nounMapping2SUMO('04606358-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04606574-n',[ ('Wrench',equivalence)]).
nounMapping2SUMO('04607035-n',[ ('GameArtifact',subsumption)]).
nounMapping2SUMO('04607141-n',[ ('SportsFacility',subsumption)]).
nounMapping2SUMO('04607242-n',[ ('ClothesDryer',subsumption)]).
nounMapping2SUMO('04607398-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04607532-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04607640-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04607759-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04607869-n',[ ('WatchClock',subsumption)]).
nounMapping2SUMO('04607982-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04608127-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04608329-n',[ ('Desk',subsumption)]).
nounMapping2SUMO('04608435-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04608567-n',[ ('WritingDevice',equivalence)]).
nounMapping2SUMO('04608809-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04608923-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04609235-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04609354-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04609531-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04609651-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04609811-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04610013-n',[ ('WaterVehicle',subsumption)]).
nounMapping2SUMO('04610176-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04610274-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04610368-n',[ ('University',instance)]).
nounMapping2SUMO('04610503-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04610676-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04610879-n',[ ('LandArea',equivalence)]).
nounMapping2SUMO('04611154-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04611351-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04611470-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('04611654-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('04611795-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04611916-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04612026-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04612159-n',[ ('Veil',subsumption)]).
nounMapping2SUMO('04612257-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('04612373-n',[ ('Sailboat',subsumption)]).
nounMapping2SUMO('04612504-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04612623-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04612722-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('04612840-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04613015-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('04613158-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('04613350-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04613555-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04613696-n',[ ('Building',subsumption)]).
nounMapping2SUMO('04613939-n',[ ('Machine',subsumption)]).
nounMapping2SUMO('04614083-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04614244-n',[ ('Device',subsumption)]).
nounMapping2SUMO('04614372-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('04614505-n',[ ('Number',subsumption)]).
nounMapping2SUMO('04614655-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('04614844-n',[ ('PercussionInstrument',subsumption)]).
nounMapping2SUMO('04615018-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('04615149-n',[ ('Pistol',subsumption)]).
nounMapping2SUMO('04615226-n',[ ('StringInstrument',subsumption)]).
nounMapping2SUMO('04615456-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04615644-n',[ ('ClothingSuit',subsumption)]).
nounMapping2SUMO('04615728-n',[ ('Steps',subsumption)]).
nounMapping2SUMO('04615866-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04616059-n',[ ('TraitAttribute',equivalence)]).
nounMapping2SUMO('04616916-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04617106-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04617289-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04617441-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04617562-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04618070-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04618359-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04618581-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04618781-n',[ ('CognitiveAgent',equivalence)]).
nounMapping2SUMO('04618921-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04619083-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04619420-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04619596-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04619791-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04619946-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04620216-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04620558-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('04620741-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04621010-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04621314-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04621524-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04621738-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04621963-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04622216-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04622415-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04622672-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04622772-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04622932-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04623113-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04623443-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04623612-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04624289-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04624517-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04624687-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04624826-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04624959-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04625129-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04625284-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04625515-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04625716-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04625882-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('04626062-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04626194-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04626280-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04626705-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04626879-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04627000-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04627241-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04627367-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04627506-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04627809-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04627936-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04628080-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04628192-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('04628336-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('04628466-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04628632-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04628747-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04628850-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04629030-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('04629194-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04629417-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04629604-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04629958-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04630137-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04630378-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04630547-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04630689-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('04631067-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04631298-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04631470-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04631700-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04632063-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04632157-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04632703-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04632866-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04632963-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04633197-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04633453-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04633570-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04633716-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04633797-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04633959-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04634161-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('04634299-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04634415-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04634540-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04634739-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04634833-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04635010-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04635104-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04635482-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04635631-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04635953-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04636250-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04636397-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04636610-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04636881-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04637108-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04637290-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04637444-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04637571-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04637722-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04637923-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04638175-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04638472-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04638585-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04638857-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04639030-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04639113-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04639371-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04639591-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04639732-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04640176-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04640356-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04640538-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04640722-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04640830-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04640927-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04641153-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04641447-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04641700-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04641869-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04642057-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04642258-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04642596-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04642746-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04642866-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04642980-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04643099-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04643221-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04643397-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04643662-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04643875-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04643979-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04644161-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04644306-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04644512-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04644719-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04645020-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04645473-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04645599-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04645943-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04646372-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04646548-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04646990-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04647185-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('04647478-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04647826-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04648059-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04648207-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04648440-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04648596-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04648749-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04648866-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04649051-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04649261-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04649560-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04649651-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04649835-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04650010-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04650201-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04650527-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04650731-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04650913-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04651009-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04651195-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04651382-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04651683-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04651784-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04651974-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04652177-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04652345-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04652438-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04652635-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04652930-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04653357-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04653479-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04653627-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04653869-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04654066-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04654337-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04654652-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04654998-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04655168-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04655442-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04655649-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04655829-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04655929-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04656051-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04656282-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04656448-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04656598-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04656748-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04656996-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04657244-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04657407-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04657631-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04657876-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04658106-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04658268-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04658361-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04658524-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04658686-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04658816-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04658942-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04659090-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04659287-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04659567-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04659730-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04660080-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04660261-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04660536-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04660805-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04660981-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04661151-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04661389-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('04661546-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04661706-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04661926-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04662182-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04662283-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04662390-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04662504-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04662730-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04662858-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04662951-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04663204-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04663319-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04663494-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04663763-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04664058-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04664314-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04664413-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04664628-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04664778-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04664964-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04665210-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04665406-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04665543-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04665813-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04666083-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04666416-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04666615-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04666837-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04667076-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04667180-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04667258-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04667406-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04667660-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04667821-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04667923-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04668033-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04668139-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04668713-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04668819-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04669063-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04669247-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04669692-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04669828-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04670022-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04670531-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04670746-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04671075-n',[ ('Solid',equivalence)]).
nounMapping2SUMO('04671394-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04671841-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04672210-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04672355-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04672605-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04672858-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04673006-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04673173-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04673341-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04673470-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04673668-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04673965-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04674624-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04674715-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04674861-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04674968-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04675193-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04675314-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04675646-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('04675777-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('04676064-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('04676308-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('04676540-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('04676830-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('04676959-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('04677113-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('04677385-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04677514-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04677716-n',[ ('TraitAttribute',equivalence)]).
nounMapping2SUMO('04677952-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04678401-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04678712-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04678804-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04678908-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('04679074-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('04679300-n',[ ('True',equivalence)]).
nounMapping2SUMO('04679419-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('04679549-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04679738-n',[ ('FacialExpression',equivalence)]).
nounMapping2SUMO('04680027-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04680133-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04680285-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04680465-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04680752-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04680893-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04681058-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04681230-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04681387-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04681621-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04681797-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04682018-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04682184-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04682319-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('04682462-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04683002-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04683136-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04683453-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04683600-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04683707-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04683814-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04684255-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04684358-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04684654-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04684765-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04684872-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04685062-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04685195-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04685396-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04685649-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04685840-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04686003-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04686257-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04686388-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04686537-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04686748-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04686935-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04687119-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04687333-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04687633-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04687822-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04687957-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04688058-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('04688246-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04688648-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04688842-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04689048-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04689198-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04689330-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04689450-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04689660-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04689834-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04689942-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04690196-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04690476-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04690592-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04690769-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04690933-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04691061-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04691178-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04691476-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04691651-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04691861-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04691992-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04692157-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04692638-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('04692787-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04692908-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04693096-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04693274-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('04693384-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04693557-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04693717-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04693804-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('04693900-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04694090-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04694293-n',[ ('Region',subsumption)]).
nounMapping2SUMO('04694441-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04694809-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04694980-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04695102-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04695176-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04695504-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04695605-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04695693-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04695805-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04695884-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04695963-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04696085-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('04696193-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('04696316-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('04696432-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('04696695-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('04696797-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('04696969-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('04697084-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('04697267-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04697442-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04697666-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04697819-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04698112-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04698307-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04698511-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04698656-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04698998-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04699157-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04699298-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04699474-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04699637-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04699767-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04699936-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04700199-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04700327-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04700496-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04700642-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('04701039-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('04701162-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('04701267-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04701460-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04701943-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04702127-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04702351-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04702545-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04702688-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04702957-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('04703104-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04703235-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04703424-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04703698-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04703932-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04704116-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04704346-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04704675-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04704839-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04705013-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04705196-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04705324-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04705536-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04705671-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04705950-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04706087-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04706290-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04706727-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04706882-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04707110-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04707252-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04707409-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04707636-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04707808-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04707964-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04708113-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04708543-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04708796-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04709011-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04709253-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04709585-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04709759-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04709944-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04710127-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04710390-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04710588-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04710866-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04711031-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04711256-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04711435-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04711665-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04711919-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04712001-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04712130-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04712405-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04712568-n',[ ('Flammable',subsumption)]).
nounMapping2SUMO('04712735-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04712978-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04713118-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04713332-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04713428-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('04713692-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('04713853-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04714058-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('04714156-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04714440-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04714679-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04714847-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04715075-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04715308-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04715487-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04715818-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04715947-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04716210-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04716491-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04716703-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('04716864-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04717139-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04717552-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04717787-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04718030-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04718134-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04718306-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04718563-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04718826-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04718999-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04719376-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04719502-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04719661-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04719805-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04720024-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('04720226-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04720393-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04720536-n',[ ('Text',subsumption)]).
nounMapping2SUMO('04720685-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04720879-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04721058-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04721428-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04721650-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04722051-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04722231-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04722373-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04722574-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04722715-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04722910-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04723107-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04723286-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04723436-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04723622-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04723816-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04726724-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04726938-n',[ ('Human',subsumption)]).
nounMapping2SUMO('04727214-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('04727559-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04727694-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04727883-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04728068-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04728376-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04728604-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04728786-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04728999-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04729127-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04729328-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04729710-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04729984-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04730191-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04730285-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04730367-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04730580-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04730797-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04730985-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04731207-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04731309-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04731497-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04731925-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04732067-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04732237-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04732386-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04732543-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04732709-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04732852-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04733118-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04733204-n',[ ('Gas',equivalence)]).
nounMapping2SUMO('04733347-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('04733539-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04733640-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04734145-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04734272-n',[ ('Liquid',equivalence)]).
nounMapping2SUMO('04734551-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04734698-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04734885-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04735075-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04735233-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04735556-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04735711-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04735828-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04735929-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04736337-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04736516-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04736757-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04737020-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04737234-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04737430-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04737568-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04737743-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04737934-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04738398-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04738641-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04738995-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04739262-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04739535-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04739630-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04739768-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04739932-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04740173-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04740326-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04740655-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04740864-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04741075-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04741195-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04741311-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04741530-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04741655-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04741807-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04742084-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04742251-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04742418-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04742535-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04742766-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04743024-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04743370-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04743486-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04743605-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04744032-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04744161-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04744319-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04744555-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04744645-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04744814-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04745240-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04745370-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04745679-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04745932-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04746134-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04746262-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04746430-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04746607-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04746842-n',[ ('Comparing',equivalence)]).
nounMapping2SUMO('04747115-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('04747246-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04747445-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04747616-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04747710-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04747798-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04747899-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04748187-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04748273-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04748426-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04748498-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04748654-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04748836-n',[ ('SubtractionFn',subsumption)]).
nounMapping2SUMO('04749310-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04749439-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04749572-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04749709-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04749991-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04750164-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04750414-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04750547-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04750764-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04750940-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04751098-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04751305-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04751652-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04751847-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04752034-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04752221-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04752414-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04752530-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04752734-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04752859-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04753060-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04753331-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04753455-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04753799-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04753929-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04754056-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04754237-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04754440-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04754780-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04754862-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04755218-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04755466-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04755630-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04755783-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04756025-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04756172-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04756504-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04756635-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04756887-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04757350-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04757522-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04757864-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04758181-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04758313-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04758452-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04758776-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04758980-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04759134-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04759428-n',[ ('True',equivalence)]).
nounMapping2SUMO('04759712-n',[ ('False',equivalence)]).
nounMapping2SUMO('04759849-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04760024-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04760296-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('04760611-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04760771-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04761212-n',[ ('Object',subsumption)]).
nounMapping2SUMO('04761517-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('04761815-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04761960-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04762134-n',[ ('Abstract',equivalence)]).
nounMapping2SUMO('04762355-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04762492-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04762633-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04762915-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04763147-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04763293-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04763650-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04763925-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04764242-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04764412-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04764741-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04765038-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04765166-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04765355-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04765586-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04765691-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04765851-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04766059-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04766275-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04766620-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04766852-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04767023-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04767182-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04767347-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04767805-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04768028-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04768186-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04768309-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('04768483-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04768657-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04769049-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04769234-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04769362-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04769456-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04769716-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04769988-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04770068-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04770211-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04770535-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04770720-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04770911-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04771128-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04771332-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04771535-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04771738-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04771890-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04772191-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04772388-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04772557-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04772691-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04772844-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04772955-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04773068-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04773182-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04773351-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04773596-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04773761-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04773899-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04774198-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04774365-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04774511-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04774743-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04774901-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04775185-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04775357-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04775562-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04775747-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04776021-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04776176-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04776299-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04776453-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04776572-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04776699-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04776940-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04777098-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04777421-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04777634-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04777852-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04778114-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04778267-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04778401-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04778630-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04779053-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04779336-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04779521-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04779649-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04779895-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04780114-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04780232-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04780396-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04780605-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04780755-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04780958-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04781349-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04781755-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04781967-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04782116-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04782466-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04782610-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04782878-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04783247-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04783445-n',[ ('True',equivalence)]).
nounMapping2SUMO('04783567-n',[ ('TruthValue',subsumption)]).
nounMapping2SUMO('04783724-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04783888-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04784142-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04784322-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04784525-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('04784664-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04784978-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04785195-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04785414-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04785669-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04785908-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04786326-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04786490-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04786595-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04786763-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04786994-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04787154-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04787324-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04787530-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04787763-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04788011-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04788159-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04788332-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04788494-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04788693-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04788853-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04788982-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04789274-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04789406-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04789613-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04789689-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04789897-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04790070-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04790238-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04790449-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04790774-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04790942-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04791081-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04791321-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04791453-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04791591-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04791740-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04791928-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04792127-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04792357-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04792679-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04793016-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04793209-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04793355-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04793555-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04793731-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04793925-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04794236-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04794408-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04794580-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04794751-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04795061-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04795252-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04795413-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04795545-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04795878-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04796086-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04796291-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04796490-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04796725-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04796946-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04797130-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04797295-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04797482-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04797824-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04798020-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04798185-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04798365-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04798511-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04798700-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04798881-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04799011-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04799133-n',[ ('EthnicGroup',equivalence)]).
nounMapping2SUMO('04799344-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04799612-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04799789-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04799881-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04800152-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04800359-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04800596-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04800729-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04800885-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04801030-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04801168-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04801313-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04801532-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04801763-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04801877-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04802079-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04802198-n',[ ('True',subsumption)]).
nounMapping2SUMO('04802403-n',[ ('False',subsumption)]).
nounMapping2SUMO('04802629-n',[ ('False',subsumption)]).
nounMapping2SUMO('04802776-n',[ ('False',subsumption)]).
nounMapping2SUMO('04802907-n',[ ('True',subsumption)]).
nounMapping2SUMO('04803209-n',[ ('RoundFn',subsumption)]).
nounMapping2SUMO('04803430-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04803702-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04803880-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04804169-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04804306-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04804451-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04804611-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04804787-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04804947-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04805136-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04805304-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04805472-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04805635-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04805813-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04806067-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04806169-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04806316-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04806512-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04806655-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04806804-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04807050-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04807342-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04807489-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04807626-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04807776-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04807971-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04808281-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04808516-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04808639-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04808965-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04809089-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04809237-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04809453-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04809642-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04809784-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04810035-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04810194-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04810327-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04810510-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04810727-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04810865-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04811126-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04811296-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04811476-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04811628-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04811767-n',[ ('Illuminated',subsumption)]).
nounMapping2SUMO('04811995-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04812268-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04812636-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04812871-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04813066-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04813283-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04813395-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04813540-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04813712-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04814025-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04814238-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04814872-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04815002-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04815177-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04815321-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04815624-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04815916-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04816125-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04816302-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04816528-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04816761-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04817020-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04817168-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04817280-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04817564-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04817788-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04817923-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04818284-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04818460-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04818700-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04819026-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04819285-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04819496-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04819694-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04819822-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04819953-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04820102-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04820258-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04820908-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04821084-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04821277-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04821451-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04821615-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04821802-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04822032-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04822223-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04822524-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04822685-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04822870-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04823031-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04823258-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04823416-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04823706-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04823866-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04824118-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04824350-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04824695-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04824819-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04824977-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04825114-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04825383-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04825576-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04825815-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04826235-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04826485-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04826623-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04826771-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04826999-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04827175-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04827392-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04827503-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04827652-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04827957-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04828126-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04828255-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04828485-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04828612-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04828754-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04828925-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04829182-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04829282-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04829550-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04829764-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04829922-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04830102-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04830343-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04830578-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('04830689-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04830904-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04831031-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04831264-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04831437-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04831727-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04832050-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04832244-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04832401-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04832518-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04832716-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04832951-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04833276-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04833458-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04833687-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04834073-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04834228-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04834339-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04834457-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04834605-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04834817-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04835028-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04835260-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04835488-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04835724-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04835950-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04836074-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04836268-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04836491-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04836583-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04836683-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04836960-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04837232-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04837425-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04837615-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04837814-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04837931-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04838210-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04838510-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04838727-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04839009-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04839154-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04839445-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04839555-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04839676-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04839877-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04840011-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04840285-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04840405-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04840537-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04840715-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04840981-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04841245-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04841358-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04841664-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04841810-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04842029-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04842232-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04842313-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04842515-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04842788-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04842993-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04843270-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04843429-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04843675-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('04843875-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04844024-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04844343-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04844478-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04844625-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('04844891-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04845146-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04845312-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04845475-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04845684-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04845863-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04845967-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04846243-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04846383-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04846533-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04846770-n',[ ('DeonticAttribute',subsumption)]).
nounMapping2SUMO('04847133-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04847298-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04847482-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04847600-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04847733-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04847991-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04848262-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04848383-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04848492-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04848686-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04848866-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04849074-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04849241-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04849614-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04849759-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04849972-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04850117-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04850341-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04850589-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04850996-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04851421-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04851585-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04851715-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04851865-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04851962-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04852088-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04852534-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04852750-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04852962-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04853124-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04853212-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04853361-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04853503-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04853765-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04853873-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04853948-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04854259-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04854389-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04854604-n',[ ('Prohibition',subsumption)]).
nounMapping2SUMO('04854893-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04854976-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04855138-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04855332-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04855524-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04855641-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04855840-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04856014-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04856182-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04856308-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04856460-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04856621-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04856721-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04856899-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04857083-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04857490-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04857738-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04858089-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04858222-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04858317-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04858455-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04858632-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04858785-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04859177-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04859323-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04859449-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04859636-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04859816-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04860065-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04860272-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04860369-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04860586-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04860759-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04860985-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04861143-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04861221-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04861319-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04861486-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04862005-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04862236-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04862382-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04862592-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04862747-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04862888-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04863074-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04863358-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04863497-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04863675-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04863793-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04863969-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04864200-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04864515-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04864824-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04865016-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04865114-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04865502-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04865722-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04865921-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04866078-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04866238-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04866365-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04866465-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04866671-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04866866-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04867130-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04867440-n',[ ('True',equivalence)]).
nounMapping2SUMO('04867539-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04867700-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04867871-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04868148-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04868350-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04868505-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04868748-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04869106-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04869256-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04869405-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04869569-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04869811-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04870040-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04870206-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04870340-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04870643-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04870889-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04871002-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04871259-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04871374-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04871720-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04872016-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04872236-n',[ ('True',equivalence)]).
nounMapping2SUMO('04872414-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04872531-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04872676-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04872826-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04872958-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04873305-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04873550-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04873804-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04873939-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04874086-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04874223-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04874409-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04874672-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04874939-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04875113-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04875352-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04875468-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04875556-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04875728-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04875935-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04876053-n',[ ('False',equivalence)]).
nounMapping2SUMO('04876235-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04876374-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04876561-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04876705-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04876888-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04876985-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04877264-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04877421-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04877530-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04877783-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04877938-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04878101-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04878434-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04878539-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04878646-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04878861-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04879092-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04879340-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04879498-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04879658-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04879879-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04879964-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04880138-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04880273-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04880573-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04880830-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04881033-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04881156-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04881369-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04881623-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04881829-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04881998-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04882214-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04882438-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04882622-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04882813-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04882968-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04883243-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04883436-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04883614-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04883804-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04883942-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04884072-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04884177-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04884302-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04884450-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04884627-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04884817-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04884995-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04885091-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04885271-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04885398-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04885609-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04885784-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('04885990-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04886101-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04886235-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04886402-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04886646-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04886790-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04886881-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04887129-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04887373-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04887497-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04887701-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04887790-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04887912-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04888268-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04888510-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04888703-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04888788-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04889000-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04889162-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04889337-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04889527-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04889779-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04889966-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04890112-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04890361-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04890546-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04890865-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04891010-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04891184-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04891333-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04891558-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04891683-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04891944-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04892084-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04892344-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04892544-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('04892794-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04892970-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04893172-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04893358-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04893525-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04893787-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04894037-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04894204-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04894444-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04894552-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04894807-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04894964-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04895246-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04895558-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04895695-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04895773-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04895979-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04896161-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04896317-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04896515-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04896724-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04896878-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04896995-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04897152-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('04897428-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04897604-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04897762-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04898087-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04898208-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04898334-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04898437-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04898804-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04899031-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04899201-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04899416-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04899573-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04899713-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04899980-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04900121-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04900236-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04900357-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04900597-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04900739-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04900947-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04901152-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04901326-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04901599-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04901754-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04901996-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04902165-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04902283-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04902470-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04902668-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04902797-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04902925-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04903136-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04903247-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04903368-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04903678-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04903813-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04904162-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04904352-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04904560-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04904664-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04904851-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04904996-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04905188-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04905546-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04905697-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04905842-n',[ ('Tranquility',subsumption)]).
nounMapping2SUMO('04906026-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04906273-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04906471-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04906712-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04906923-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04907020-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04907153-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04907269-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04907575-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04907826-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04907991-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04908182-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04908283-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04908396-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04908721-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04908835-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04909018-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('04909270-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04909414-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04909563-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04909721-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04909887-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04910135-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04910377-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04910562-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04910684-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04910848-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04910973-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04911420-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04911777-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04911894-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04912052-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04912240-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04912506-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04912610-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04912732-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04912982-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04913212-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04913322-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04913568-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04913738-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04913839-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04914133-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04914292-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04914576-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04914694-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04914881-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04914991-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04915121-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04915365-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04915462-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04915687-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04915866-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04916200-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04916342-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04917292-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04917439-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04917680-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04917870-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04918053-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04918210-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04918498-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04918767-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04919011-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04919209-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04919458-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04919580-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04919712-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04919872-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04920000-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04920237-n',[ ('Rural',subsumption)]).
nounMapping2SUMO('04920435-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('04920568-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04920867-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04921011-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04921308-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04921417-n',[ ('PastFn',subsumption)]).
nounMapping2SUMO('04921576-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('04921754-n',[ ('PastFn',subsumption)]).
nounMapping2SUMO('04921900-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('04922113-n',[ ('PastFn',subsumption)]).
nounMapping2SUMO('04922338-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04922597-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04922787-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04923024-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04923299-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04923496-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04923743-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04923907-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04924003-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04924103-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04924491-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04924674-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04924878-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04925064-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04925218-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04925348-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04925577-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04925756-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04925895-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04926038-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04926217-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04926308-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04926427-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04926620-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04926728-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04927098-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04927268-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04927445-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04927632-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04927792-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04927890-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04928008-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04928194-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04928416-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04928585-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04928760-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04928903-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04929422-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04929742-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04929976-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04930139-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04930307-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04930478-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04930632-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04930850-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04931041-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04931152-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04931267-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04931428-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04931567-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04931733-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04931837-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04931965-n',[ ('InternalAttribute',equivalence)]).
nounMapping2SUMO('04932278-n',[ ('InternalAttribute',subsumption)]).
nounMapping2SUMO('04932561-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04932875-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04933197-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04933363-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04933544-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04933852-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04934043-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04934220-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04934546-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('04935003-n',[ ('PhysicalState',subsumption)]).
nounMapping2SUMO('04935239-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04935405-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04935528-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04935904-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04936213-n',[ ('PhysicalState',subsumption)]).
nounMapping2SUMO('04936403-n',[ ('PhysicalState',subsumption)]).
nounMapping2SUMO('04936585-n',[ ('PhysicalState',subsumption)]).
nounMapping2SUMO('04936690-n',[ ('PhysicalState',subsumption)]).
nounMapping2SUMO('04936846-n',[ ('PhysicalState',subsumption)]).
nounMapping2SUMO('04937043-n',[ ('Liquid',equivalence)]).
nounMapping2SUMO('04937427-n',[ ('Liquid',subsumption)]).
nounMapping2SUMO('04937587-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04937848-n',[ ('Rigid',equivalence)]).
nounMapping2SUMO('04938110-n',[ ('Rigid',equivalence)]).
nounMapping2SUMO('04938228-n',[ ('Pliable',equivalence)]).
nounMapping2SUMO('04938474-n',[ ('Pliable',subsumption)]).
nounMapping2SUMO('04938702-n',[ ('Rigid',subsumption)]).
nounMapping2SUMO('04938838-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04939046-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04939198-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04939324-n',[ ('BreakabilityAttribute',equivalence)]).
nounMapping2SUMO('04939547-n',[ ('Fragile',subsumption)]).
nounMapping2SUMO('04939742-n',[ ('Fragile',subsumption)]).
nounMapping2SUMO('04939872-n',[ ('Fragile',subsumption)]).
nounMapping2SUMO('04939987-n',[ ('Unbreakable',equivalence)]).
nounMapping2SUMO('04940146-n',[ ('SaturationAttribute',subsumption)]).
nounMapping2SUMO('04940379-n',[ ('SaturationAttribute',subsumption)]).
nounMapping2SUMO('04940496-n',[ ('SaturationAttribute',subsumption)]).
nounMapping2SUMO('04940730-n',[ ('SaturationAttribute',subsumption)]).
nounMapping2SUMO('04940964-n',[ ('SaturationAttribute',subsumption)]).
nounMapping2SUMO('04941124-n',[ ('Solid',equivalence)]).
nounMapping2SUMO('04941325-n',[ ('Solid',subsumption)]).
nounMapping2SUMO('04941453-n',[ ('DensityFn',equivalence)]).
nounMapping2SUMO('04941687-n',[ ('DensityFn',subsumption)]).
nounMapping2SUMO('04941809-n',[ ('DensityFn',subsumption)]).
nounMapping2SUMO('04941942-n',[ ('SaturationAttribute',subsumption)]).
nounMapping2SUMO('04942172-n',[ ('SaturationAttribute',subsumption)]).
nounMapping2SUMO('04942373-n',[ ('SaturationAttribute',subsumption)]).
nounMapping2SUMO('04942516-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04942738-n',[ ('SaturationAttribute',subsumption)]).
nounMapping2SUMO('04942869-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04943154-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04943367-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04943464-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04943578-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04943704-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04944048-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04944412-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('04944513-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04944710-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04944910-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04945057-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04945254-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04945530-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04945758-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04945942-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04946078-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04946266-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04946400-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('04946553-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04946760-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04946877-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04947087-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04947186-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04947494-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04947628-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04947888-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('04948069-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04948241-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04948603-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04948722-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04948905-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04949066-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04949256-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04949453-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04949560-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04949681-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04949799-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04950026-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('04950126-n',[ ('VisualAttribute',equivalence)]).
nounMapping2SUMO('04950336-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04950537-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04950713-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04950952-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04951071-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04951186-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('04951373-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04951716-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04951875-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04951978-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04952120-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04952242-n',[ ('Illuminated',equivalence)]).
nounMapping2SUMO('04952570-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04952821-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04952944-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04953186-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04953296-n',[ ('Illuminated',subsumption)]).
nounMapping2SUMO('04953380-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04953678-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04953954-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04954412-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('04954534-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04954683-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04954920-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04955160-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04955426-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04955554-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('04955633-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04955907-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04956110-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('04956419-n',[ ('Pliable',equivalence)]).
nounMapping2SUMO('04956594-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04957176-n',[ ('PrimaryColor',equivalence)]).
nounMapping2SUMO('04957356-n',[ ('PrimaryColor',subsumption)]).
nounMapping2SUMO('04957589-n',[ ('PrimaryColor',subsumption)]).
nounMapping2SUMO('04957854-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04958146-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04958302-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04958460-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04958634-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04958865-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04959061-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04959230-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04959567-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04959672-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04960079-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04960277-n',[ ('Black',subsumption)]).
nounMapping2SUMO('04960582-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04960729-n',[ ('White',subsumption)]).
nounMapping2SUMO('04961062-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04961136-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04961331-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04961472-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04961583-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04961691-n',[ ('Gray',subsumption)]).
nounMapping2SUMO('04962062-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04962240-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04962395-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04962548-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04962689-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04962784-n',[ ('Red',subsumption)]).
nounMapping2SUMO('04963111-n',[ ('Red',subsumption)]).
nounMapping2SUMO('04963201-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04963307-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04963449-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04963588-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04963740-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04963905-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04964001-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04964079-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04964162-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04964287-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04964443-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04964586-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04964799-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04964878-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04964977-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04965179-n',[ ('OrangeColor',subsumption)]).
nounMapping2SUMO('04965371-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('04965451-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04965574-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04965661-n',[ ('Yellow',subsumption)]).
nounMapping2SUMO('04966017-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04966114-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04966240-n',[ ('Yellow',subsumption)]).
nounMapping2SUMO('04966428-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04966543-n',[ ('Yellow',subsumption)]).
nounMapping2SUMO('04966649-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04966717-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04966841-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04966941-n',[ ('Yellow',subsumption)]).
nounMapping2SUMO('04967094-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04967191-n',[ ('Green',subsumption)]).
nounMapping2SUMO('04967561-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04967674-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04967801-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04967882-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04967974-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04968056-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04968139-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04968257-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04968426-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04968619-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04968749-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04968895-n',[ ('Blue',subsumption)]).
nounMapping2SUMO('04969242-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04969431-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04969540-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04969617-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04969703-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04969798-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04969952-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04970059-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04970312-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04970398-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04970470-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('04970544-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04970631-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04970758-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04970916-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04971131-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04971211-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04971313-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04971447-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04971522-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04971675-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04971820-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04971928-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04972268-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04972350-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('04972451-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04972603-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('04972801-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04972950-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('04973020-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04973110-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04973291-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04973386-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04973585-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04973669-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04973816-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04973957-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04974145-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04974248-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04974340-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04974463-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04974575-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04974681-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04974774-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04974859-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04974968-n',[ ('ColorAttribute',equivalence)]).
nounMapping2SUMO('04975122-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04975340-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04975612-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04975739-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04975988-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04976188-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04976319-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04976489-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04976567-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04976687-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04976870-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('04976952-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04977247-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04977412-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04977561-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04977946-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04978050-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04978216-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04978371-n',[ ('White',subsumption)]).
nounMapping2SUMO('04978561-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04978792-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04979002-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04979203-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04979307-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04979425-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04979758-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04979870-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('04980008-n',[ ('OlfactoryAttribute',equivalence)]).
nounMapping2SUMO('04980463-n',[ ('OlfactoryAttribute',subsumption)]).
nounMapping2SUMO('04980656-n',[ ('OlfactoryAttribute',subsumption)]).
nounMapping2SUMO('04980920-n',[ ('OlfactoryAttribute',subsumption)]).
nounMapping2SUMO('04981044-n',[ ('OlfactoryAttribute',subsumption)]).
nounMapping2SUMO('04981139-n',[ ('RadiatingSound',equivalence)]).
nounMapping2SUMO('04981474-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04981658-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04981781-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04981941-n',[ ('Speaking',equivalence)]).
nounMapping2SUMO('04982113-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04982207-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04982478-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04982745-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04982856-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04983013-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04983122-n',[ ('SoundAttribute',equivalence)]).
nounMapping2SUMO('04983402-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04983688-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04983848-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04984007-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04984180-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04984351-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04984514-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04984698-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04984809-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04984938-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04985064-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('04985198-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04985580-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04985790-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04985930-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04986054-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04986147-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04986258-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04986414-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04986526-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04986637-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04986796-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04986883-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04987169-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04987356-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04987620-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04988078-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('04988258-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04988478-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04988666-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04988861-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04989015-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04989362-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04989512-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04989657-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04990021-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04990220-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04990525-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('04990692-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('04990781-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04990877-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04991137-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04991225-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('04991389-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04991511-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04991738-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04991879-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04992008-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('04992163-n',[ ('TasteAttribute',equivalence)]).
nounMapping2SUMO('04992431-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04992570-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04992834-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04993108-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04993312-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04993413-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04993604-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('04993752-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('04993882-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04994126-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04994264-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04994413-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04994614-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04994727-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04994824-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04995009-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04995100-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04995211-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04995421-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04995531-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04995793-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04995940-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04996113-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04996215-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04996355-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04996571-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04996823-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04997032-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04997282-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('04997472-n',[ ('Food',equivalence)]).
nounMapping2SUMO('04997645-n',[ ('Food',subsumption)]).
nounMapping2SUMO('04997812-n',[ ('Food',subsumption)]).
nounMapping2SUMO('04997988-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04998254-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04998417-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04998530-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04998700-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04998816-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04998966-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04999111-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04999214-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04999306-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04999401-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04999741-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('04999964-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05000116-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('05000342-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05000537-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05000717-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05000809-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('05000913-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05001089-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05001302-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05001482-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05001724-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05001867-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05002155-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05002352-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05002540-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05002680-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05002822-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05003090-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05003273-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05003423-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05003590-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05003850-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05004091-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05004294-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05004532-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05004700-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05004895-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05005064-n',[ ('PhysiologicProcess',equivalence)]).
nounMapping2SUMO('05005250-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05005447-n',[ ('Living',subsumption)]).
nounMapping2SUMO('05005809-n',[ ('Living',subsumption)]).
nounMapping2SUMO('05006020-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('05006285-n',[ ('Dead',equivalence)]).
nounMapping2SUMO('05006519-n',[ ('Dead',equivalence)]).
nounMapping2SUMO('05006749-n',[ ('Dead',equivalence)]).
nounMapping2SUMO('05006898-n',[ ('SexAttribute',equivalence)]).
nounMapping2SUMO('05007280-n',[ ('SexAttribute',subsumption)]).
nounMapping2SUMO('05007560-n',[ ('SexAttribute',subsumption)]).
nounMapping2SUMO('05007800-n',[ ('SexAttribute',subsumption)]).
nounMapping2SUMO('05008085-n',[ ('SexAttribute',subsumption)]).
nounMapping2SUMO('05008227-n',[ ('Male',equivalence)]).
nounMapping2SUMO('05008449-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05008591-n',[ ('SexAttribute',subsumption)]).
nounMapping2SUMO('05008746-n',[ ('SexAttribute',subsumption)]).
nounMapping2SUMO('05008943-n',[ ('Female',equivalence)]).
nounMapping2SUMO('05009170-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05009758-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05009921-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('05010062-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05010314-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05010506-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05010627-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05010801-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('05011089-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('05011162-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('05011277-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05011431-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05011568-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05011790-n',[ ('TemperatureMeasure',equivalence)]).
nounMapping2SUMO('05012272-n',[ ('TemperatureMeasure',equivalence)]).
nounMapping2SUMO('05012585-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('05012941-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('05013095-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05013204-n',[ ('TemperatureMeasure',instance)]).
nounMapping2SUMO('05013461-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05013642-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05013809-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05013967-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05014099-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05014308-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05014442-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05014556-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05014710-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05014879-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05015117-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05015463-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05015678-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05015878-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05016001-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05016171-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05016451-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('05016553-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05016667-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05016753-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05016936-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05017121-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('05017230-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05017458-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05017757-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05017909-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05018103-n',[ ('RadiatingLight',equivalence)]).
nounMapping2SUMO('05018542-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05018674-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('05018785-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('05018934-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05019163-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05019339-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05019499-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05019661-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05020019-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05020225-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05020358-n',[ ('Pliable',subsumption)]).
nounMapping2SUMO('05020697-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05020981-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05021151-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05021345-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05021535-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05021740-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05021884-n',[ ('Pliable',subsumption)]).
nounMapping2SUMO('05022173-n',[ ('Pliable',subsumption)]).
nounMapping2SUMO('05022359-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05022457-n',[ ('Pliable',subsumption)]).
nounMapping2SUMO('05022709-n',[ ('Pliable',equivalence)]).
nounMapping2SUMO('05022902-n',[ ('Pliable',subsumption)]).
nounMapping2SUMO('05023022-n',[ ('Pliable',equivalence)]).
nounMapping2SUMO('05023233-n',[ ('Rigid',equivalence)]).
nounMapping2SUMO('05023404-n',[ ('Rigid',subsumption)]).
nounMapping2SUMO('05023591-n',[ ('Rigid',equivalence)]).
nounMapping2SUMO('05023741-n',[ ('Rigid',equivalence)]).
nounMapping2SUMO('05023974-n',[ ('Rigid',subsumption)]).
nounMapping2SUMO('05024093-n',[ ('Rigid',subsumption)]).
nounMapping2SUMO('05024254-n',[ ('MassMeasure',equivalence)]).
nounMapping2SUMO('05024616-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05024691-n',[ ('DensityFn',subsumption)]).
nounMapping2SUMO('05024797-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05024931-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05025129-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05025413-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05025520-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05025693-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05025935-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05026171-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05026312-n',[ ('Amu',subsumption)]).
nounMapping2SUMO('05026508-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05026744-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05026843-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05027135-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05027276-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05027446-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05027529-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05027837-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05028159-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05028348-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05028429-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05028562-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05028700-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05028963-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05029137-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05029327-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05029594-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05029706-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05030149-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05030251-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05030418-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05030680-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05030806-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05031012-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05031214-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05031367-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05031560-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05031726-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05031849-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05032028-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05032193-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05032351-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05032565-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05032795-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05032918-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05033046-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05033171-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05033291-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05033410-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05033569-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05033681-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05033906-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05034048-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05034225-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05034473-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05034761-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05034989-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05035264-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05035353-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05035712-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05035820-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05035961-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05036237-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05036394-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05036715-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05037037-n',[ ('OlfactoryAttribute',subsumption)]).
nounMapping2SUMO('05037197-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05037394-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05037617-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05037737-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05037813-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05038251-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05038593-n',[ ('DensityFn',subsumption)]).
nounMapping2SUMO('05038823-n',[ ('DensityFn',subsumption)]).
nounMapping2SUMO('05038959-n',[ ('DensityFn',subsumption)]).
nounMapping2SUMO('05039106-n',[ ('DensityFn',subsumption)]).
nounMapping2SUMO('05039526-n',[ ('DensityFn',subsumption)]).
nounMapping2SUMO('05039633-n',[ ('DensityFn',subsumption)]).
nounMapping2SUMO('05039709-n',[ ('DensityFn',subsumption)]).
nounMapping2SUMO('05039819-n',[ ('DensityFn',subsumption)]).
nounMapping2SUMO('05039907-n',[ ('DensityFn',subsumption)]).
nounMapping2SUMO('05040081-n',[ ('DensityFn',subsumption)]).
nounMapping2SUMO('05040275-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05040833-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05040939-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05041165-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('05041320-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05041503-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05041595-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05041712-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('05041871-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05042012-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05042138-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05042283-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05042468-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05042573-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05042720-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05042871-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05043091-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05043349-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05043459-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05043621-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05043755-n',[ ('Fragile',equivalence)]).
nounMapping2SUMO('05043973-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05044215-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05044387-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05044528-n',[ ('TemporalRelation',equivalence)]).
nounMapping2SUMO('05044673-n',[ ('TemporalRelation',subsumption)]).
nounMapping2SUMO('05044822-n',[ ('TemporalRelation',subsumption)]).
nounMapping2SUMO('05045208-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05045381-n',[ ('TemporalRelation',subsumption)]).
nounMapping2SUMO('05045680-n',[ ('TemporalRelation',subsumption)]).
nounMapping2SUMO('05045841-n',[ ('TemporalRelation',subsumption)]).
nounMapping2SUMO('05046009-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05046471-n',[ ('TemporalRelation',subsumption)]).
nounMapping2SUMO('05046659-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05046865-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05047059-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05047279-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05047617-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05047778-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('05047956-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('05048123-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05048301-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05048690-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05048833-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05048948-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05049137-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05049253-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05049458-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05049656-n',[ ('PastFn',equivalence)]).
nounMapping2SUMO('05049808-n',[ ('ImmediatePastFn',equivalence)]).
nounMapping2SUMO('05049930-n',[ ('FutureFn',equivalence)]).
nounMapping2SUMO('05050115-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05050379-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05050668-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05051088-n',[ ('TemporalRelation',subsumption)]).
nounMapping2SUMO('05051249-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05051601-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05051734-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05051896-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05052243-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('05052387-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05052587-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05052832-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05053042-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05053215-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05053527-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05053688-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05054130-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05054312-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05054426-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05054537-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05054746-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05054863-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05055141-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05055278-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05055503-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05055689-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05055878-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05055974-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05056102-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05056234-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05056386-n',[ ('FrequencyMeasure',subsumption)]).
nounMapping2SUMO('05056490-n',[ ('FrequencyMeasure',subsumption)]).
nounMapping2SUMO('05056811-n',[ ('FrequencyMeasure',subsumption)]).
nounMapping2SUMO('05057061-n',[ ('FrequencyMeasure',subsumption)]).
nounMapping2SUMO('05057163-n',[ ('FrequencyMeasure',subsumption)]).
nounMapping2SUMO('05057275-n',[ ('FrequencyMeasure',subsumption)]).
nounMapping2SUMO('05057382-n',[ ('FrequencyMeasure',subsumption)]).
nounMapping2SUMO('05057485-n',[ ('FrequencyMeasure',subsumption)]).
nounMapping2SUMO('05057593-n',[ ('FrequencyMeasure',subsumption)]).
nounMapping2SUMO('05057695-n',[ ('FrequencyMeasure',subsumption)]).
nounMapping2SUMO('05057805-n',[ ('FrequencyMeasure',subsumption)]).
nounMapping2SUMO('05057917-n',[ ('FrequencyMeasure',subsumption)]).
nounMapping2SUMO('05058025-n',[ ('FrequencyMeasure',subsumption)]).
nounMapping2SUMO('05058140-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05058580-n',[ ('PerFn',equivalence)]).
nounMapping2SUMO('05058893-n',[ ('FrequencyMeasure',subsumption)]).
nounMapping2SUMO('05059017-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05059132-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05059525-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05059830-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05060052-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05060189-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05060476-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05060783-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05061003-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05061149-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05061345-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05061619-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05061805-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05061977-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05062255-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05062370-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05062518-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05062748-n',[ ('SpatialRelation',equivalence)]).
nounMapping2SUMO('05062993-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05063218-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05063349-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05063564-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05063729-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05063853-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05064037-n',[ ('ShapeAttribute',equivalence)]).
nounMapping2SUMO('05064541-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05064722-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05064827-n',[ ('SymmetricShape',subsumption)]).
nounMapping2SUMO('05065211-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05065386-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05065555-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05065717-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05066012-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05066195-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05066333-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('05066490-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05066626-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05066867-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05067007-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05067199-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05067367-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05067514-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05067679-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05067807-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05067928-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05068080-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('05068461-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('05068716-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('05068918-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('05069085-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('05069199-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('05069447-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('05069624-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05069853-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05070032-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05070197-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05070290-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05070453-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05070622-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05070849-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05071027-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('05071185-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('05071368-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05071556-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05071726-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05071869-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05072078-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05072208-n',[ ('AngleMeasure',subsumption)]).
nounMapping2SUMO('05072406-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05072523-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05072663-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05072911-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05073131-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05073403-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05073559-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05073723-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05073888-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05074057-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05074218-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05074374-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05074559-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05074690-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05074774-n',[ ('PositionalAttribute',equivalence)]).
nounMapping2SUMO('05075602-n',[ ('Designing',subsumption)]).
nounMapping2SUMO('05076069-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('05076237-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05076384-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05076472-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05076709-n',[ ('Designing',subsumption)]).
nounMapping2SUMO('05076827-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05077146-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05077348-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05077524-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05077661-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05077863-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('05078025-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05078147-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05078289-n',[ ('FrontFn',equivalence)]).
nounMapping2SUMO('05078450-n',[ ('BackFn',subsumption)]).
nounMapping2SUMO('05078623-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05078894-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05079074-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05079180-n',[ ('North',equivalence)]).
nounMapping2SUMO('05079309-n',[ ('South',equivalence)]).
nounMapping2SUMO('05079474-n',[ ('Horizontal',equivalence)]).
nounMapping2SUMO('05079638-n',[ ('Vertical',equivalence)]).
nounMapping2SUMO('05079866-n',[ ('BodyPosition',subsumption)]).
nounMapping2SUMO('05080382-n',[ ('BodyPosition',subsumption)]).
nounMapping2SUMO('05080526-n',[ ('BodyPosition',subsumption)]).
nounMapping2SUMO('05080616-n',[ ('BodyPosition',subsumption)]).
nounMapping2SUMO('05080753-n',[ ('BodyPosition',subsumption)]).
nounMapping2SUMO('05080923-n',[ ('BodyPosition',subsumption)]).
nounMapping2SUMO('05081057-n',[ ('BodyPosition',subsumption)]).
nounMapping2SUMO('05081300-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05081434-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05081660-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05081802-n',[ ('BodyPosition',subsumption)]).
nounMapping2SUMO('05081957-n',[ ('BodyPosition',subsumption)]).
nounMapping2SUMO('05082116-n',[ ('BodyPosition',subsumption)]).
nounMapping2SUMO('05082222-n',[ ('BodyPosition',subsumption)]).
nounMapping2SUMO('05082337-n',[ ('BodyPosition',subsumption)]).
nounMapping2SUMO('05082507-n',[ ('BodyPosition',subsumption)]).
nounMapping2SUMO('05082648-n',[ ('BodyPosition',subsumption)]).
nounMapping2SUMO('05082790-n',[ ('BodyPosition',subsumption)]).
nounMapping2SUMO('05083054-n',[ ('BodyPosition',subsumption)]).
nounMapping2SUMO('05083200-n',[ ('Designing',subsumption)]).
nounMapping2SUMO('05083328-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05083567-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('05083687-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05083905-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05084067-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05084201-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05084733-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05084889-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05084982-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05085165-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('05085436-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('05085572-n',[ ('Near',equivalence)]).
nounMapping2SUMO('05085867-n',[ ('Near',equivalence)]).
nounMapping2SUMO('05085991-n',[ ('Adjacent',equivalence)]).
nounMapping2SUMO('05086269-n',[ ('Hertz',equivalence)]).
nounMapping2SUMO('05086450-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05086563-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05086740-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05086903-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05087061-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05087173-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05087297-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05087664-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05087894-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05088056-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05088189-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05088324-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05088645-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05088804-n',[ ('DensityFn',subsumption)]).
nounMapping2SUMO('05089048-n',[ ('DensityFn',subsumption)]).
nounMapping2SUMO('05089199-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05089367-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('05089612-n',[ ('DensityFn',subsumption)]).
nounMapping2SUMO('05089782-n',[ ('DensityFn',subsumption)]).
nounMapping2SUMO('05089947-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05090111-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05090255-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05090441-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05090979-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05091194-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05091316-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('05091527-n',[ ('InformationMeasure',subsumption)]).
nounMapping2SUMO('05091770-n',[ ('ProbabilityRelation',equivalence)]).
nounMapping2SUMO('05092236-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('05092421-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('05092635-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('05092969-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('05093080-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('05093181-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('05093293-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('05093418-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('05093581-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05093890-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05094424-n',[ ('Human',subsumption)]).
nounMapping2SUMO('05094565-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05094725-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05094863-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05095111-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05095324-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05095561-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05095691-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05096095-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05096191-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05096294-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05096408-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05096577-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05096708-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05096820-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05096972-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05097081-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05097166-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05097278-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05097361-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05097536-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05097706-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05097845-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05098099-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05098225-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05098311-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05098425-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05098520-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05098620-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05098750-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05098857-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05098942-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05099231-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05099389-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05099662-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05099796-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05100156-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05100269-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05100525-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05100751-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05100866-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05100981-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05101174-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('05101261-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05101407-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05101512-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05101675-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05101815-n',[ ('Attribute',undefined)]).
nounMapping2SUMO('05102101-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05102300-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05102435-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05102578-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('05102764-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05102889-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05103072-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05103283-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05103430-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05103503-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05103648-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05103946-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05104256-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05104421-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05104548-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05105009-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05105265-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05105745-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05105879-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05106024-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05106220-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05106317-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05106633-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05106928-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05107216-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05107322-n',[ ('TextureAttribute',subsumption)]).
nounMapping2SUMO('05107495-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05107668-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05107765-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05108109-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05108262-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('05108412-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05108740-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05108947-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05109324-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05109511-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('05109808-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05109986-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05110107-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05110185-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('05110408-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('05110583-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05110772-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05110988-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('05111141-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05111248-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('05111511-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05111704-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05111835-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05112215-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05112308-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('05112474-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05112609-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05112910-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05113133-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05113462-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05113929-n',[ ('Liquid',subsumption)]).
nounMapping2SUMO('05114262-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05114371-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05114652-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05114781-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05115040-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05115418-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05115568-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05115804-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05116128-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05116243-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05116486-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05116590-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('05116730-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('05116953-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05117140-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05117237-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05117406-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05117660-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05117977-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05118062-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05118251-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05118437-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05118707-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05118862-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05119096-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05119223-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05119367-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05119714-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05119837-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05120000-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05120116-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05120310-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05120564-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05120683-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05120835-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05121095-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05121418-n',[ ('Number',equivalence)]).
nounMapping2SUMO('05121908-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05122099-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05122295-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05122419-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05122557-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05122850-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05123098-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05123206-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05123416-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05123760-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05123935-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('05124057-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05124404-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05124534-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05124792-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('05124928-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05125193-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05125377-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05126066-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05126228-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05126362-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05126611-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('05126849-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('05127150-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('05127357-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('05127500-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('05127640-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05127782-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05127959-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05128096-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05128219-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05128370-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('05128519-n',[ ('AreaMeasure',equivalence)]).
nounMapping2SUMO('05128870-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('05129054-n',[ ('AreaMeasure',subsumption)]).
nounMapping2SUMO('05129201-n',[ ('LengthMeasure',equivalence)]).
nounMapping2SUMO('05129565-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05129928-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05130028-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05130210-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05130402-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05130614-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05130735-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05130875-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05131023-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05131194-n',[ ('Mile',equivalence)]).
nounMapping2SUMO('05131283-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05131537-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05131647-n',[ ('AltitudeMeasure',equivalence)]).
nounMapping2SUMO('05131902-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05132045-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05132221-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05132340-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05132542-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05132667-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05132827-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05132962-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05133107-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05133287-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05133535-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05133748-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05133839-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05133944-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05134122-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('05134238-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05134353-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05134547-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05134880-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05135155-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05135288-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05135451-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('05135582-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05135725-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05135951-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05136150-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05136343-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05136546-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05136662-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05136788-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05136978-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05137165-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('05137402-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05137557-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05137778-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05137938-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05138065-n',[ ('VolumeMeasure',equivalence)]).
nounMapping2SUMO('05138208-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05138488-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05138958-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05139094-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05139342-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05139436-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05139561-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05139942-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05140086-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('05140278-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05140454-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05140593-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05140793-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05141040-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05141222-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05141492-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05141683-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05141840-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05142008-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05142180-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05142641-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05142863-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05143077-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05143300-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05143558-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05143690-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05143864-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05144079-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05144453-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05144663-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05144880-n',[ ('Agent',instance)]).
nounMapping2SUMO('05145118-n',[ ('Attribute',equivalence)]).
nounMapping2SUMO('05145573-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('05145708-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('05145891-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05146055-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('05146178-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('05146272-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05146471-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05146739-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05146904-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05147237-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05147381-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05147586-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05147940-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05148186-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05148399-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05148539-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05148699-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05149127-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05149325-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05149589-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05149695-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05149832-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05149978-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05150129-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05150458-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05150588-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05150855-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05150986-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05151088-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05151372-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05151576-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05151701-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05151869-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05152150-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05152364-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05152518-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05152696-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05152902-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05153037-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05153155-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05153359-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05153520-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05153795-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05153897-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05154114-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05154241-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05154517-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('05154676-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05154908-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05155123-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05155349-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05155476-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05155650-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05155821-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05156319-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05156481-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05156673-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05156822-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05156993-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05157143-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05157274-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05157406-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05157574-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05157732-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05157866-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05158095-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05158296-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05158431-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05158619-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05158857-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05158975-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05159123-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05159225-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05159495-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05159606-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05159725-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05159854-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05159948-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05160173-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('05160399-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05160574-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05160796-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05161150-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05161436-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05161614-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05161967-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05162217-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05162455-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05162642-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05162807-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05162985-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05163189-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05163401-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05163582-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('05163807-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05164101-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05164353-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05164521-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05164673-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05164845-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05165028-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05165175-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05165303-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05165533-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05165745-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05165904-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05166072-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05166260-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05166397-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05166560-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05166805-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05167117-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05167237-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05167412-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05167618-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('05167927-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05168063-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05168261-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05168697-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05168795-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05168890-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05169037-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05169242-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05169412-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05169507-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05169601-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05169813-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05170088-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05170236-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05170400-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05170574-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05170923-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05171045-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05171352-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05171491-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05171800-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05171978-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05172131-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05172322-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05172596-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05172815-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05172953-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05173205-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05173443-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05173579-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05173795-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05174023-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05174326-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05174517-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05174653-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05175467-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05175613-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05175771-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05175904-n',[ ('Permission',subsumption)]).
nounMapping2SUMO('05176082-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05176188-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05176341-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05176477-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05176607-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05176846-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05177285-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05177705-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05177897-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05178220-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05178394-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05178571-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05178715-n',[ ('Permission',subsumption)]).
nounMapping2SUMO('05179027-n',[ ('Promise',subsumption)]).
nounMapping2SUMO('05179180-n',[ ('Permission',subsumption)]).
nounMapping2SUMO('05179410-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05179567-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05179838-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05179993-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05180135-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05180286-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05180483-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05180677-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05180881-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05181078-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05181199-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05181513-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05181754-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05181975-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05182080-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05182157-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05182240-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05182354-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05182452-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05182563-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05183242-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05183453-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05183624-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05183779-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05183932-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05184082-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05184313-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05184461-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05184620-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05184810-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05185106-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05185270-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05185444-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05185598-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05185752-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05185921-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05186090-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05186306-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05186626-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05186766-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05186998-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05187187-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05187446-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05187711-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05187857-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05187941-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05188095-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05188220-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05188367-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05188547-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05188646-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05188801-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05189057-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05189208-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05189396-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05189591-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05189819-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('05189946-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('05190106-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05190356-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05190586-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05190804-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05191486-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05191695-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05191832-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05192130-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05192240-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05192451-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05192897-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05193160-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05193338-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05193621-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('05193781-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05194043-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05194151-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05194435-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05194578-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05194874-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05195175-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05195362-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05195548-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05195653-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05195796-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05195920-n',[ ('Device',subsumption)]).
nounMapping2SUMO('05196054-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05196220-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05196375-n',[ ('Guiding',equivalence)]).
nounMapping2SUMO('05196582-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05197043-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05197232-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05197388-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('05197574-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05197701-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05197797-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05197945-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05198036-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05198132-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05198321-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05198427-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05198622-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05198756-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05198928-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05199151-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05199286-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05199680-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05199869-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05200169-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05200670-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05200816-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05201060-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05201183-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05201342-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05201452-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05201659-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05201813-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05202034-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05202284-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05202413-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05202497-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05202954-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05203207-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05203397-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05203649-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('05204004-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05204143-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05204316-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05204473-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05204637-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05204982-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05205220-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05205340-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05205537-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('05205739-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05206006-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05206237-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05206445-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05206573-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05206829-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('05207130-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05207352-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05207570-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05207846-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05207963-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05208291-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05208422-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05208595-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05208690-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05208796-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05208896-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05208988-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05209113-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05209324-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05209659-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05209822-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05210003-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05210116-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05210221-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05210373-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05210534-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05210717-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05210820-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05211044-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05211254-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05211451-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05211793-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('05211974-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('05212168-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('05212264-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('05212362-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05212493-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05212609-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05212808-n',[ ('DeviceAttribute',subsumption)]).
nounMapping2SUMO('05212973-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05213201-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05213693-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('05213894-n',[ ('InternalAttribute',instance)]).
nounMapping2SUMO('05214121-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05214211-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05214374-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05214469-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05214599-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05214851-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05214976-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05215257-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05215483-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05215699-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05215921-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05216102-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05216240-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05216365-n',[ ('Animal',equivalence)]).
nounMapping2SUMO('05217061-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('05217168-n',[ ('Human',equivalence)]).
nounMapping2SUMO('05217688-n',[ ('Human',equivalence)]).
nounMapping2SUMO('05217859-n',[ ('HumanCorpse',equivalence)]).
nounMapping2SUMO('05218119-n',[ ('HumanCorpse',equivalence)]).
nounMapping2SUMO('05218533-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('05218630-n',[ ('HumanCorpse',subsumption)]).
nounMapping2SUMO('05218788-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('05218899-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05219097-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('05219297-n',[ ('Human',subsumption)]).
nounMapping2SUMO('05219420-n',[ ('Human',subsumption)]).
nounMapping2SUMO('05219561-n',[ ('Human',subsumption)]).
nounMapping2SUMO('05219724-n',[ ('Man',subsumption)]).
nounMapping2SUMO('05219923-n',[ ('Woman',subsumption)]).
nounMapping2SUMO('05220126-n',[ ('Woman',subsumption)]).
nounMapping2SUMO('05220306-n',[ ('Man',subsumption)]).
nounMapping2SUMO('05220461-n',[ ('BodyPart',equivalence)]).
nounMapping2SUMO('05221526-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05221649-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05221895-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05222467-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05222591-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05222790-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('05222940-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05223110-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05223248-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05223370-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05223550-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05223823-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05224080-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05224358-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05224585-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05224755-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05224966-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05225090-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05225439-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05225602-n',[ ('AnatomicalStructure',equivalence)]).
nounMapping2SUMO('05226937-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05227079-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05227209-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05227438-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05227572-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05227868-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05228020-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05228264-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05228374-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05228496-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05228732-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05228881-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05229049-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05229198-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05229341-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05229468-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05229622-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('05229805-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05229990-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05230171-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05230357-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05230603-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05231264-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05231397-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05231592-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05231769-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05231940-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05232074-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05232221-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05232345-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05232503-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05232691-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05232972-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05233100-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05233238-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05233420-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05233601-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05233741-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05233875-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05234016-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05234162-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05234315-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05234438-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05234593-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05234737-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05234911-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05235100-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05235217-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05235350-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05235461-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05235607-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05235745-n',[ ('Object',subsumption)]).
nounMapping2SUMO('05235879-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05236029-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05236152-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05236322-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05236582-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05236709-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05236848-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05237227-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05237755-n',[ ('BodyCovering',equivalence)]).
nounMapping2SUMO('05238036-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05238282-n',[ ('Skin',subsumption)]).
nounMapping2SUMO('05239039-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05239243-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05239437-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05239589-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05239680-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05239808-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05240076-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05240211-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05240522-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05240710-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05240850-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05241072-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05241218-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05241374-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05241485-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05241662-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05241827-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05242070-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05242239-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05242396-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05242525-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05242622-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05242752-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05242928-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05243077-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05243259-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05243435-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05243704-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05243879-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05244045-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05244239-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05244421-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05244619-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05244755-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05244934-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05245192-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05245387-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05245521-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05245626-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05245775-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05245906-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05246089-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05246215-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05246511-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05246796-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05246969-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05247057-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05247178-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05247369-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05247621-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05247804-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05248006-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05248181-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05248553-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05248667-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05248921-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05249094-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05249232-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05249420-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('05249636-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05250190-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05250310-n',[ ('Throat',subsumption)]).
nounMapping2SUMO('05250420-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05250550-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05250659-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05251537-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05251655-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05251789-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05252016-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05252259-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05252402-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05252567-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05252705-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05252834-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05252970-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05253165-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05253338-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05253443-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05253561-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05253829-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05253951-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05254077-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05254197-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05254393-n',[ ('Hair',equivalence)]).
nounMapping2SUMO('05254627-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05254795-n',[ ('Hair',equivalence)]).
nounMapping2SUMO('05255435-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05255578-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05255692-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05255939-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05256085-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05256220-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05256358-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05256562-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05256702-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05256862-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05257393-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05257476-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05257593-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05257737-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05257967-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05258051-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05258177-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05258299-n',[ ('BodyHair',subsumption)]).
nounMapping2SUMO('05258462-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05258627-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05258743-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05258889-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05258985-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05259109-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05259240-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05259426-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05259512-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05259726-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05259823-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05259914-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05259991-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05260127-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05260240-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05260380-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05260533-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05260714-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05260821-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05260928-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05261088-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05261203-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05261310-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05261404-n',[ ('FacialHair',equivalence)]).
nounMapping2SUMO('05261566-n',[ ('FacialHair',subsumption)]).
nounMapping2SUMO('05261894-n',[ ('FacialHair',subsumption)]).
nounMapping2SUMO('05261999-n',[ ('FacialHair',subsumption)]).
nounMapping2SUMO('05262120-n',[ ('FacialHair',subsumption)]).
nounMapping2SUMO('05262185-n',[ ('FacialHair',subsumption)]).
nounMapping2SUMO('05262422-n',[ ('FacialHair',subsumption)]).
nounMapping2SUMO('05262534-n',[ ('FacialHair',subsumption)]).
nounMapping2SUMO('05262698-n',[ ('FacialHair',subsumption)]).
nounMapping2SUMO('05262802-n',[ ('FacialHair',subsumption)]).
nounMapping2SUMO('05263029-n',[ ('FacialHair',subsumption)]).
nounMapping2SUMO('05263183-n',[ ('FacialHair',subsumption)]).
nounMapping2SUMO('05263316-n',[ ('FacialHair',subsumption)]).
nounMapping2SUMO('05263448-n',[ ('FacialHair',subsumption)]).
nounMapping2SUMO('05263587-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05263732-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('05263850-n',[ ('BodySubstance',equivalence)]).
nounMapping2SUMO('05264081-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05264247-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05264417-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05264545-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05264756-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05264913-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05265038-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05265139-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05265417-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05265736-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05265861-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05265981-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05266096-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05266239-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05266486-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05266759-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05266879-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05267073-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05267211-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05267345-n',[ ('Tissue',equivalence)]).
nounMapping2SUMO('05267548-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05268112-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05268255-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05268383-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05268510-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05268619-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05268797-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05268965-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05269401-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05269495-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('05269668-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05269784-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05269901-n',[ ('Bone',equivalence)]).
nounMapping2SUMO('05271383-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05271607-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05271685-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05271814-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05272110-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05272276-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05272423-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05272545-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05272745-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05272891-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05273073-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05273223-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05273408-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05273555-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05273684-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05273822-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05274105-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05274247-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05274446-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05274590-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05274808-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05274959-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05275162-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05275315-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05275466-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05275651-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05275905-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05276290-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05276425-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05276566-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05276668-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05276860-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05277100-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05277261-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05277405-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05277532-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05277728-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05277941-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05278152-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05278395-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05278584-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05278714-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05278922-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05279026-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05279321-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05279407-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05279688-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05279953-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05280154-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05280365-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05280512-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05280698-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05280831-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05280998-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05281189-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05281452-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05281584-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05281691-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05281874-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05282000-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05282247-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05282339-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05282433-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('05282652-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05282746-n',[ ('Tooth',equivalence)]).
nounMapping2SUMO('05283326-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05283498-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05283649-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05283816-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05284020-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05284132-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05284333-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05284617-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05284851-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05285101-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05285275-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05285480-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05285623-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05285835-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05286008-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05286167-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05286272-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05286412-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05286536-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05287090-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05287368-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05287607-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05287731-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05287882-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05288091-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05288396-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05288593-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05288739-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05288912-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05289057-n',[ ('Muscle',equivalence)]).
nounMapping2SUMO('05289297-n',[ ('Muscle',equivalence)]).
nounMapping2SUMO('05289601-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05289743-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05289861-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05290756-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05290897-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05291010-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05291230-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05291373-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05291495-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05291604-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05291728-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05291945-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05292073-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05292200-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05292359-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05292468-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05292587-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05292736-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05292856-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05293040-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05293268-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05293420-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05293597-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05293773-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05293944-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05294068-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05294256-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05294374-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05294606-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05294819-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05294995-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05295160-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05295381-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05295593-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05295740-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05296001-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05296127-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05296253-n',[ ('Tendon',subsumption)]).
nounMapping2SUMO('05296503-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05296639-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05296775-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05296968-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05297163-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05297363-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05297523-n',[ ('Organ',equivalence)]).
nounMapping2SUMO('05298159-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05298313-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05298421-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05298572-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05298729-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05298988-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05299178-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05299687-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05299814-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05299927-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05300128-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05300231-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05300397-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05300507-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05300675-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05300926-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05301072-n',[ ('Tongue',equivalence)]).
nounMapping2SUMO('05301392-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05301526-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05301752-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05301908-n',[ ('Mouth',equivalence)]).
nounMapping2SUMO('05302307-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05302422-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05302499-n',[ ('Mouth',subsumption)]).
nounMapping2SUMO('05302899-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05303020-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05303232-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05303402-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05304252-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05304341-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('05304603-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05304795-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05304932-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05305136-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05305389-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05305614-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05305806-n',[ ('Lip',equivalence)]).
nounMapping2SUMO('05306055-n',[ ('Lip',subsumption)]).
nounMapping2SUMO('05306122-n',[ ('Lip',subsumption)]).
nounMapping2SUMO('05306190-n',[ ('Tooth',subsumption)]).
nounMapping2SUMO('05306390-n',[ ('Tooth',subsumption)]).
nounMapping2SUMO('05306476-n',[ ('Tooth',subsumption)]).
nounMapping2SUMO('05306604-n',[ ('Tooth',subsumption)]).
nounMapping2SUMO('05306708-n',[ ('Tooth',subsumption)]).
nounMapping2SUMO('05306894-n',[ ('Tooth',subsumption)]).
nounMapping2SUMO('05307091-n',[ ('Tooth',subsumption)]).
nounMapping2SUMO('05307358-n',[ ('Tooth',subsumption)]).
nounMapping2SUMO('05307521-n',[ ('Tooth',subsumption)]).
nounMapping2SUMO('05307641-n',[ ('Tooth',subsumption)]).
nounMapping2SUMO('05307773-n',[ ('Tooth',subsumption)]).
nounMapping2SUMO('05307952-n',[ ('Tooth',subsumption)]).
nounMapping2SUMO('05308141-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05308310-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05308481-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05308655-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05308810-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05308950-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05309050-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05309245-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05309392-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05309591-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05309725-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05309965-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05310206-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05310351-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05310596-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05310790-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05311054-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05311795-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05312040-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05312149-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05312227-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05312306-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05312427-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05312614-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05312782-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05313115-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05313344-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05313535-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05313679-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05313822-n',[ ('Eyelid',subsumption)]).
nounMapping2SUMO('05314075-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05314255-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05314462-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05314549-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05314639-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05314834-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05314919-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05315095-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05315382-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05315612-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05315855-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05316025-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05316175-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05316407-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05316590-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05316674-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05316850-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05317013-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05317191-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05317354-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05317603-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05317815-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05317960-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05318137-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05318263-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05318407-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05318606-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05318831-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05319028-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05319144-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05319279-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05319419-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05319588-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05319760-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05319936-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05320183-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05320362-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05320636-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05320764-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05320899-n',[ ('Ear',equivalence)]).
nounMapping2SUMO('05321144-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05321307-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05321664-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05321917-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05322103-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05322247-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05322432-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05322570-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05322735-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05322855-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05323036-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05323228-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05323454-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05323588-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05323723-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05323889-n',[ ('Ear',subsumption)]).
nounMapping2SUMO('05324134-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05324276-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05324388-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05324553-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05324691-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05324888-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05325153-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05325378-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05325606-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05325786-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05325943-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05326060-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05326200-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05326340-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05326465-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05326624-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05326900-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05327134-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05327373-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05327652-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05327767-n',[ ('Gland',equivalence)]).
nounMapping2SUMO('05328115-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05328232-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05328508-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05328695-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05328867-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05329215-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05329533-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05329735-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05330244-n',[ ('ThyroidGland',subsumption)]).
nounMapping2SUMO('05330365-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05330518-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05330659-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05330848-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05331035-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05331171-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05331404-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05331653-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05331812-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05331988-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05332225-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05332438-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05332569-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05332802-n',[ ('Kidney',equivalence)]).
nounMapping2SUMO('05333259-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05333467-n',[ ('Spleen',subsumption)]).
nounMapping2SUMO('05333777-n',[ ('Artery',subsumption)]).
nounMapping2SUMO('05335310-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05335515-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05335700-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05335850-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05335971-n',[ ('Artery',subsumption)]).
nounMapping2SUMO('05336246-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05336377-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05336487-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05336635-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05336748-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05336893-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05337055-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05337178-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05337301-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05337485-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05337663-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05337855-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05338025-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05338166-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05338410-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05338614-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05338847-n',[ ('Artery',subsumption)]).
nounMapping2SUMO('05339047-n',[ ('Artery',equivalence)]).
nounMapping2SUMO('05339168-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05339357-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05339583-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05339751-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05339946-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05340121-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05340317-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05340599-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05340795-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05340972-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05341089-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05341206-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05341416-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05341641-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05341789-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05341920-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05342070-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05342214-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05342374-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05342499-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05342673-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05342854-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05343037-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05343218-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05343408-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05343542-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05343718-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05343941-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05344073-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05344213-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05344350-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05344514-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05344697-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05344848-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05345038-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05345247-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05345421-n',[ ('Artery',subsumption)]).
nounMapping2SUMO('05345581-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05345783-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05345978-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05346191-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05346406-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05346585-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05346714-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05346892-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05347146-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05347359-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05347465-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05347631-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05347871-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05348054-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05348269-n',[ ('Artery',subsumption)]).
nounMapping2SUMO('05348540-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05348698-n',[ ('Artery',subsumption)]).
nounMapping2SUMO('05348884-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05349101-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05349273-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05349445-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05349659-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05349906-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05350061-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05350256-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05350453-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05350679-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05350900-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05351058-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05351278-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05351442-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05351572-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05351746-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05351968-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05352112-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05352291-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05352433-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05352601-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05352754-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05352896-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05353070-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05353241-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05353364-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05353507-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05353683-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05353819-n',[ ('PulmonaryArtery',equivalence)]).
nounMapping2SUMO('05354026-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05354238-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05354381-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05354580-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05354744-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05354955-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05355146-n',[ ('Artery',subsumption)]).
nounMapping2SUMO('05355341-n',[ ('Artery',subsumption)]).
nounMapping2SUMO('05355527-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05355706-n',[ ('Artery',subsumption)]).
nounMapping2SUMO('05355890-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05356083-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05356291-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05356442-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05356657-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05356889-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05357160-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05357366-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05357500-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05357682-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05357867-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05358036-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05358226-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05358345-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05358507-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05358764-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05358944-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05359124-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05359347-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05359516-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05359695-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05359828-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05360042-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05360170-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05360297-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05360470-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05360678-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05360880-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05361123-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05361278-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05361391-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05361640-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05361805-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05362016-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05362197-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05362405-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05362593-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05362745-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05362912-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05363064-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05363270-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05363428-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05363559-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05363676-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05363868-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05364000-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05364184-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05364345-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05364448-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05364612-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05364730-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05364905-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05365059-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05365164-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05365284-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05365420-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05365633-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05365838-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05366043-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05366206-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05366341-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05366485-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05366640-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05366812-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05367003-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05367165-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05367341-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05367508-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05367735-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05367912-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05368100-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05368278-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05368444-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05368594-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05368739-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05368874-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05369092-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05369254-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05369404-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05369566-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05369757-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05369924-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05370125-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05370293-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05370410-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05370636-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05370781-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05370918-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05371144-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05371301-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05371482-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05371663-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05371829-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05371977-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05372125-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05372290-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05372428-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05372593-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05372725-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05372924-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05373145-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05373300-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05373495-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05373616-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05373790-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05373924-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05374101-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05374280-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05374475-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05374658-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05374861-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05374980-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05375169-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05375322-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05375530-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05375729-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05375881-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05376050-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05376219-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05376391-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05376541-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05376721-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05376844-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05377098-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05377252-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05377371-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05377515-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05377665-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05377833-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05378022-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05378137-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05378234-n',[ ('PulmonaryVein',subsumption)]).
nounMapping2SUMO('05378458-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05378654-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05378850-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05379039-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05379247-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05379438-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05379635-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05379734-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05379944-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05380122-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05380252-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05380404-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05380532-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05380697-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05380822-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05381036-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05381148-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05381325-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05381491-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05381666-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05381779-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05381956-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05382135-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05382316-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05382432-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05382589-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05382729-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05382855-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05383004-n',[ ('Vein',subsumption)]).
nounMapping2SUMO('05383216-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05383348-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05383467-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05383598-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05383791-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05383956-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05384128-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05384300-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05384446-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05384560-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05384691-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05384817-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05384999-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05385161-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05385363-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05385534-n',[ ('Liver',equivalence)]).
nounMapping2SUMO('05386139-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05386309-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05386426-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05386544-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05386845-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05387028-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05387167-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05387395-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05387544-n',[ ('Lung',equivalence)]).
nounMapping2SUMO('05387842-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05387959-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05388115-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05388311-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05388437-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05388527-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05388665-n',[ ('SpaceRegion',subsumption)]).
nounMapping2SUMO('05388805-n',[ ('Heart',subsumption)]).
nounMapping2SUMO('05389182-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05389310-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05389460-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05389625-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05389762-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05389939-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05390233-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05390479-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05390761-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05391000-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05391118-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05391269-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05391540-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05391763-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05391977-n',[ ('BodyCavity',subsumption)]).
nounMapping2SUMO('05392157-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05392348-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05392562-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05392744-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05392906-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05393023-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05393230-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05393429-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05393629-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05393813-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05393996-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05394277-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05394526-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05394707-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05394904-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05395098-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05395286-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05395548-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05395690-n',[ ('Stomach',subsumption)]).
nounMapping2SUMO('05396071-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05396229-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05396366-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05396690-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05396807-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05397032-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05397178-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05397333-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05397468-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05398023-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05398298-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05398462-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05398609-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05398760-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05398871-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05399034-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05399243-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05399356-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05399486-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05399627-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05399847-n',[ ('Blood',equivalence)]).
nounMapping2SUMO('05400445-n',[ ('Blood',subsumption)]).
nounMapping2SUMO('05400601-n',[ ('Human',subsumption)]).
nounMapping2SUMO('05400860-n',[ ('Human',subsumption)]).
nounMapping2SUMO('05400978-n',[ ('Human',subsumption)]).
nounMapping2SUMO('05401096-n',[ ('Human',subsumption)]).
nounMapping2SUMO('05401229-n',[ ('Human',subsumption)]).
nounMapping2SUMO('05401411-n',[ ('Human',subsumption)]).
nounMapping2SUMO('05401587-n',[ ('Human',subsumption)]).
nounMapping2SUMO('05401753-n',[ ('Blood',subsumption)]).
nounMapping2SUMO('05401851-n',[ ('Blood',subsumption)]).
nounMapping2SUMO('05401951-n',[ ('Blood',subsumption)]).
nounMapping2SUMO('05402091-n',[ ('Blood',subsumption)]).
nounMapping2SUMO('05402333-n',[ ('Blood',subsumption)]).
nounMapping2SUMO('05402472-n',[ ('Blood',subsumption)]).
nounMapping2SUMO('05402576-n',[ ('Blood',subsumption)]).
nounMapping2SUMO('05402788-n',[ ('Blood',subsumption)]).
nounMapping2SUMO('05402961-n',[ ('Blood',subsumption)]).
nounMapping2SUMO('05403149-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05403427-n',[ ('LiquidBodySubstance',subsumption)]).
nounMapping2SUMO('05403702-n',[ ('Serum',subsumption)]).
nounMapping2SUMO('05403849-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05404074-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05404336-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05404598-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05404728-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05405139-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05405324-n',[ ('TearSubstance',subsumption)]).
nounMapping2SUMO('05405554-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05405751-n',[ ('Sweat',subsumption)]).
nounMapping2SUMO('05405946-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05406128-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05406397-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05406570-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05406782-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05406958-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05407119-n',[ ('Hormone',equivalence)]).
nounMapping2SUMO('05407772-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05407890-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05408113-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05408388-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05408684-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05408908-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05409136-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05409426-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05409663-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05409945-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05410131-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05410315-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05410646-n',[ ('Insulin',equivalence)]).
nounMapping2SUMO('05410901-n',[ ('Insulin',subsumption)]).
nounMapping2SUMO('05411049-n',[ ('Insulin',subsumption)]).
nounMapping2SUMO('05411338-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05411430-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05411571-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('05411785-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05412053-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05412242-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05412649-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05412912-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05413102-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05413241-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05413465-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05413647-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05413873-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05414147-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('05414534-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05414724-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05414931-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05415200-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05415395-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05415815-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05416048-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05416128-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05416198-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05416545-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05416678-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05416861-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05416979-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05417162-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05417272-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05417472-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05417698-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05417821-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05417975-n',[ ('BloodVessel',subsumption)]).
nounMapping2SUMO('05418177-n',[ ('Artery',subsumption)]).
nounMapping2SUMO('05418432-n',[ ('Artery',subsumption)]).
nounMapping2SUMO('05418585-n',[ ('BloodVessel',subsumption)]).
nounMapping2SUMO('05418717-n',[ ('Vein',subsumption)]).
nounMapping2SUMO('05421414-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05421586-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05421723-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05421900-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05421997-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05422135-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05422317-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05422457-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05422574-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05422668-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05422852-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05423095-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05423319-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05423443-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05423595-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05423779-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05423882-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05424074-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05424199-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05424351-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05424504-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05424679-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05424796-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05424963-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05425207-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05425436-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05425581-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05425703-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05425910-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05426087-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05426243-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05426989-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05427346-n',[ ('NerveCell',subsumption)]).
nounMapping2SUMO('05427570-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05427739-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05427946-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05428136-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05428331-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05428473-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05428645-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05428794-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05428974-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05429195-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05429404-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05429525-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05429658-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05429840-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05429994-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05430095-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05430300-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05430454-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05430628-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05431177-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05431285-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05431402-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05431585-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05431762-n',[ ('CellNucleus',subsumption)]).
nounMapping2SUMO('05431926-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05432230-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('05432420-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('05432623-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05432736-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05432948-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05433400-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05433496-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05433709-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05433856-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05433953-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05434053-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05434203-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05434361-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05434557-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05434784-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05434927-n',[ ('CellNucleus',equivalence)]).
nounMapping2SUMO('05435277-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('05435477-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05435722-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05435855-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05436080-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05436381-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05436548-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05436752-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05437600-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05437785-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05438130-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('05438315-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05438483-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05438642-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05438778-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05438956-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05439100-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05439286-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05439413-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05439582-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05439810-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05439942-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05440046-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05440207-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('05440410-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05440555-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05440756-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05440875-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05441053-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05441224-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05441338-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05441468-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05441686-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05441806-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05441929-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05442022-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('05442131-n',[ ('DNAMolecule',subsumption)]).
nounMapping2SUMO('05442594-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05442789-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05442916-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05443050-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05443211-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05443333-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05443484-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05443651-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05443966-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05444175-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05444324-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05444610-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05444709-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05444876-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05445099-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05445247-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05445389-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05445546-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05445668-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05446006-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05446181-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05446394-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05446767-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05446971-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05447087-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05447218-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05447423-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05447599-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05447757-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05447962-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05448053-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05448149-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05448257-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05448400-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05448501-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05448597-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05448704-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05448827-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05448928-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05449073-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05449196-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05449268-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05449538-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05449661-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05449797-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05449959-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05450370-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05450617-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05450740-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05450888-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05451099-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05451265-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05451384-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05451695-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05451981-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05452204-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05452516-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05452765-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05452845-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05453057-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05453145-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05453267-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05453412-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05453523-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05453657-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05453815-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05453943-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05454070-n',[ ('RedBloodCell',subsumption)]).
nounMapping2SUMO('05454452-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05454578-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05454702-n',[ ('RedBloodCell',subsumption)]).
nounMapping2SUMO('05454833-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05454978-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05455113-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05455206-n',[ ('RedBloodCell',subsumption)]).
nounMapping2SUMO('05455375-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05455563-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05455690-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05455912-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05456082-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05456257-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05456456-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05456622-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05456732-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05456945-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05457201-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05457343-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05457469-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05457795-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05457973-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05458173-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05458300-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05458412-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05458576-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05458703-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05458859-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05458990-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05459101-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05459232-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05459457-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05459590-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05459769-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05459953-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05460163-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05460291-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05460473-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05460759-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05460870-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05461179-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05461349-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05461610-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05461816-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05462057-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05462315-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05462674-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05463449-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05463533-n',[ ('NerveCell',subsumption)]).
nounMapping2SUMO('05463873-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05464104-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05464378-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05464534-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05464685-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05464939-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05465071-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05465228-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05465392-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05465567-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05465868-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05466005-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05466244-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05466393-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05466575-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05466696-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05466892-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05467054-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05467432-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05467619-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05467758-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05467922-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05468098-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05468211-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05468351-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05468523-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05468739-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05468849-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05469032-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05469240-n',[ ('NerveCell',subsumption)]).
nounMapping2SUMO('05469424-n',[ ('NerveCell',subsumption)]).
nounMapping2SUMO('05469664-n',[ ('NerveCell',subsumption)]).
nounMapping2SUMO('05469861-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05470013-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05470189-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05471181-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05471427-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05471629-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05471837-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05472032-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05472205-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05472394-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05472538-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05472681-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05472846-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05472959-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05473104-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05473318-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05473507-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05473593-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05473735-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05473928-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05474195-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05474346-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05474738-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05474976-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05475134-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05475397-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05475562-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05475681-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05475878-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05476094-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05476256-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05476592-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05476754-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05476915-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05477112-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05477305-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05477510-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05477686-n',[ ('NerveCell',subsumption)]).
nounMapping2SUMO('05477946-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05478139-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05478336-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05478526-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05478684-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05478896-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05479108-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05479314-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05479503-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05479786-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05480076-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05480401-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05480607-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05480794-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05481095-n',[ ('Brain',subsumption)]).
nounMapping2SUMO('05481549-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05481746-n',[ ('Brain',subsumption)]).
nounMapping2SUMO('05481870-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05481997-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05482129-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05482328-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05482529-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05482676-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05482800-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05482922-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05483122-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05483388-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05483677-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05483890-n',[ ('PituitaryGland',subsumption)]).
nounMapping2SUMO('05484198-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05484355-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05484573-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05484711-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05484862-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05485098-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05485314-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05485554-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05485856-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05485988-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05486159-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05486319-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05486510-n',[ ('Brain',subsumption)]).
nounMapping2SUMO('05486920-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05487224-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05487423-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05487694-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05487941-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05488223-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05488385-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05488615-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05488750-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05488909-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05489070-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05489231-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05489394-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05489640-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05489810-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05489998-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05490204-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05490370-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05490578-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05490799-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05490983-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05491154-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05491308-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05491461-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05491612-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05491993-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05492259-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05492426-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05492655-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05492806-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05493002-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05493141-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05493303-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05493650-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05493758-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05493992-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05494130-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05494365-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05494617-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05494933-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05495172-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05495571-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05495981-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05496261-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05496592-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05496802-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05496990-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05497363-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05497741-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05497922-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05498048-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05498300-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05498460-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05498581-n',[ ('CellNucleus',subsumption)]).
nounMapping2SUMO('05498773-n',[ ('Brain',subsumption)]).
nounMapping2SUMO('05499044-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05499172-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05499379-n',[ ('Hypothalamus',equivalence)]).
nounMapping2SUMO('05499542-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05499828-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05500006-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05500312-n',[ ('NerveCell',subsumption)]).
nounMapping2SUMO('05500465-n',[ ('NerveCell',subsumption)]).
nounMapping2SUMO('05500594-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05500812-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05500992-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05501185-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05501485-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('05501711-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05501932-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05502090-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05502375-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05502556-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05502855-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05503009-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05503196-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05503401-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05503555-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05503705-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05504107-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05504336-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05504532-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05504807-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05505131-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05505479-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05505679-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05506034-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05506229-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05506369-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05506507-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05506648-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05506832-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05506976-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05507109-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05507268-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05507427-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05507642-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05507756-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05507977-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05508113-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05508211-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05508403-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05508534-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05508735-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05508943-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05509146-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05509452-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05509889-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05510173-n',[ ('BodyVessel',subsumption), ('Airway',subsumption)]).
nounMapping2SUMO('05510358-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05510506-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05510702-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05510907-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05511061-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05511286-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05511618-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05511975-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05512139-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05512337-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05512505-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05512670-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05512835-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05513020-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05513302-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05513529-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05513807-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05514081-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05514272-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05514410-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05514717-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05514905-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05515157-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05515287-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05515545-n',[ ('AbnormalAnatomicalStructure',subsumption)]).
nounMapping2SUMO('05515670-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05516067-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05516230-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05516366-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05516554-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05516711-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05516848-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05517145-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05517268-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05517406-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05517578-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05517837-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05518094-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05518257-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05518449-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05518614-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05518870-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05519085-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05519401-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05519559-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05519707-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05519820-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05520168-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05520292-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05520479-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05520699-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05520965-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05521111-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05521514-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05521636-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05521934-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05522148-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05522283-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05522456-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05522674-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05522784-n',[ ('BodyCavity',subsumption)]).
nounMapping2SUMO('05522998-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05523108-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05523269-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05523420-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05523629-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05523859-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05524062-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05524243-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05524430-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05524615-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05525100-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05525252-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05525391-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05525628-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05525807-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05525970-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05526175-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05526384-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05526713-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05526860-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05526957-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05527085-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05527216-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05527389-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05527597-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05527848-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05528060-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05528245-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05528395-n',[ ('Alveolus',subsumption)]).
nounMapping2SUMO('05528604-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05528854-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05529012-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05529159-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05529286-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05529729-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05530092-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05530296-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05530429-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05530657-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05530871-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05531161-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05531379-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05531511-n',[ ('BronchialDuct',subsumption)]).
nounMapping2SUMO('05531666-n',[ ('BronchialDuct',equivalence)]).
nounMapping2SUMO('05531814-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05532050-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05532225-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05532641-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05532795-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05532944-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05533212-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05533392-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05533635-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05533948-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05534174-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05534333-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05534578-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05534712-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05534955-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05535095-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05535247-n',[ ('Intestine',subsumption)]).
nounMapping2SUMO('05535367-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05535484-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05535869-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05536178-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05536370-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05536638-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05536858-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05537060-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05537243-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05537417-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05537576-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05537806-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05538016-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05538215-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05538338-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05538494-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05538625-n',[ ('Head',equivalence)]).
nounMapping2SUMO('05539012-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05539138-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05539370-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05539454-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05539595-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05539717-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05539834-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05539947-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05540121-n',[ ('Skull',subsumption)]).
nounMapping2SUMO('05540407-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05540513-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05540976-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05541097-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05541231-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05541509-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05541645-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05541872-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05542052-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05542193-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05542416-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05542539-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05542686-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05542893-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05543177-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05543425-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05543541-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05543917-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05544078-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05544264-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05544432-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05544575-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05544725-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05544906-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05545047-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05545212-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05545439-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05545611-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05545879-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05546040-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05546298-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('05546383-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05546540-n',[ ('Neck',equivalence)]).
nounMapping2SUMO('05546997-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('05547149-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('05547313-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05547396-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05547508-n',[ ('Throat',equivalence)]).
nounMapping2SUMO('05547904-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05548032-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05548203-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05548314-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05548521-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05548726-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05548840-n',[ ('Shoulder',equivalence)]).
nounMapping2SUMO('05549061-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05549350-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05549576-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05549830-n',[ ('Torso',subsumption)]).
nounMapping2SUMO('05550330-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05550494-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05550688-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05550908-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05551142-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05551318-n',[ ('Object',subsumption)]).
nounMapping2SUMO('05551494-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05551617-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05551711-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05551939-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05552106-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05552287-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05552467-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05552607-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05553049-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05553288-n',[ ('Breast',subsumption)]).
nounMapping2SUMO('05553486-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05553618-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05553768-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05553897-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05554051-n',[ ('BodyVessel',subsumption)]).
nounMapping2SUMO('05554189-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05554405-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05554653-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05554804-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05555017-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05555167-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05555294-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('05555473-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05555688-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05555840-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05555917-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05556071-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05556204-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05556325-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05556472-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05556595-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05556943-n',[ ('Stomach',subsumption)]).
nounMapping2SUMO('05557339-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05557500-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05557723-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05557839-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05558078-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05558345-n',[ ('BodyCavity',subsumption)]).
nounMapping2SUMO('05558555-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05558717-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05559023-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05559122-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05559256-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05559727-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05559908-n',[ ('Limb',equivalence)]).
nounMapping2SUMO('05560244-n',[ ('Limb',subsumption)]).
nounMapping2SUMO('05560631-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05560787-n',[ ('Limb',equivalence)]).
nounMapping2SUMO('05561390-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05561507-n',[ ('Limb',subsumption)]).
nounMapping2SUMO('05561707-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05561834-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05562015-n',[ ('Limb',subsumption)]).
nounMapping2SUMO('05562161-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05562249-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05562595-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('05562756-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05562902-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05563034-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05563266-n',[ ('Foot',subsumption)]).
nounMapping2SUMO('05563770-n',[ ('Arm',equivalence)]).
nounMapping2SUMO('05564229-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05564323-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05564590-n',[ ('Hand',subsumption)]).
nounMapping2SUMO('05565064-n',[ ('Fist',equivalence)]).
nounMapping2SUMO('05565192-n',[ ('Hand',subsumption)]).
nounMapping2SUMO('05565337-n',[ ('Hand',subsumption)]).
nounMapping2SUMO('05565548-n',[ ('Hand',subsumption)]).
nounMapping2SUMO('05565696-n',[ ('Hand',subsumption)]).
nounMapping2SUMO('05565937-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05566097-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05566366-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05566504-n',[ ('Finger',equivalence)]).
nounMapping2SUMO('05566919-n',[ ('Limb',equivalence)]).
nounMapping2SUMO('05567117-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05567217-n',[ ('Thumb',subsumption)]).
nounMapping2SUMO('05567381-n',[ ('Finger',subsumption)]).
nounMapping2SUMO('05567489-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05567604-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05567727-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05567875-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05568104-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05568349-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05568550-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05568767-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05569053-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05569427-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05569577-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05569690-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05569835-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05569979-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05570129-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05570396-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05570500-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05570600-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05570704-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05570839-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05571132-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05571341-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05571501-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05571713-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05571904-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05572057-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05572227-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05572396-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05572629-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05572782-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05572940-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05573099-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05573306-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05573474-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05573602-n',[ ('Knee',subsumption)]).
nounMapping2SUMO('05573895-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05574151-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05574332-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05574519-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05574633-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05574862-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05575002-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05575185-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05575374-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05575582-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05575743-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05575960-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05576074-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05576194-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05576421-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05576573-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05576827-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05576950-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05577060-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05577190-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05577304-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05577410-n',[ ('Toe',equivalence)]).
nounMapping2SUMO('05577654-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05577741-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05577866-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05577969-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05578095-n',[ ('Foot',subsumption)]).
nounMapping2SUMO('05578251-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05578442-n',[ ('Ankle',subsumption)]).
nounMapping2SUMO('05578740-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05578911-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05579053-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05579239-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05579436-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05579604-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05579753-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05579944-n',[ ('Elbow',subsumption)]).
nounMapping2SUMO('05580286-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05580416-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05580662-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05580929-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05581161-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05581349-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05581514-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05581693-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05581932-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05582038-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05582191-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05582305-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05582513-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05582690-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05582859-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05583158-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05583386-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05583624-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05583822-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05584008-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05584152-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05584265-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05584390-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05584486-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05584605-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05584746-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05584928-n',[ ('Wrist',subsumption)]).
nounMapping2SUMO('05585205-n',[ ('Knuckle',subsumption)]).
nounMapping2SUMO('05585383-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05585665-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05585999-n',[ ('List',subsumption)]).
nounMapping2SUMO('05586111-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05586280-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05586446-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05586759-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05587034-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05587288-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05587531-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05587628-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05587814-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05587997-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05588174-n',[ ('SpinalColumn',subsumption)]).
nounMapping2SUMO('05588551-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05588746-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05588840-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05588991-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05589132-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05589378-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05589596-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05589756-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05589896-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05590144-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05590366-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05590740-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05590939-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05591096-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05591256-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05591503-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05591661-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05591770-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05591999-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05592126-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05592302-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('05592504-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05592733-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05592870-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05593017-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05593181-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05593318-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05593476-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05593654-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05593871-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05594037-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05594201-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05594367-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05594568-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05594822-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05595083-n',[ ('BodyJoint',subsumption)]).
nounMapping2SUMO('05595531-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05595837-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05596004-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05596224-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05596442-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05596651-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05597050-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05597188-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('05597436-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05597594-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05597734-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05597980-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05598147-n',[ ('Nose',subsumption)]).
nounMapping2SUMO('05598707-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05598868-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05598982-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05599084-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05599203-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05599398-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05599501-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05599617-n',[ ('Chin',subsumption)]).
nounMapping2SUMO('05599769-n',[ ('Chin',subsumption)]).
nounMapping2SUMO('05599874-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05600030-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05600109-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05600270-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05600431-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05600637-n',[ ('Face',subsumption)]).
nounMapping2SUMO('05601198-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05601357-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05601662-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05601758-n',[ ('Face',subsumption)]).
nounMapping2SUMO('05602132-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05602304-n',[ ('Muscle',subsumption)]).
nounMapping2SUMO('05602548-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05602683-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05602835-n',[ ('Face',equivalence)]).
nounMapping2SUMO('05602982-n',[ ('Face',subsumption)]).
nounMapping2SUMO('05603160-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05603342-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05603475-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05603650-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05603854-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05604022-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05604254-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05604434-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05604535-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05604854-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05604950-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05605192-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05605498-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05605762-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('05605944-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05606247-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05606429-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05606528-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05606633-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('05606801-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05607001-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05607126-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05607271-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05607402-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05607602-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05607863-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05608044-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05608206-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('05608419-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05608615-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05608868-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05609111-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05609524-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05609884-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05610008-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05610198-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05610365-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('05610520-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05610734-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05610919-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('05611062-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('05611221-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05611302-n',[ ('Brain',subsumption)]).
nounMapping2SUMO('05611684-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05611822-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('05612067-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05612241-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05612358-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05612531-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05612706-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05612809-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05613043-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05613170-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('05613274-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05613478-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05613625-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05613794-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05613962-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05614175-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05614476-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05614657-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05615028-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05615147-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05615258-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05615373-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05615500-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05615749-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05615869-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05616092-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05616246-n',[ ('Process',subsumption)]).
nounMapping2SUMO('05616786-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05616955-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05617107-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05617310-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05617467-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05617606-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05618056-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05618293-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05618607-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05618849-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05619059-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05619226-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05619345-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05619553-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05619743-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05619903-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05620050-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('05620190-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05620294-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05620468-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('05620754-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05620955-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05621178-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05621439-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05621808-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05621946-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05622076-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05622196-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05622456-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05622617-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05622723-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05622956-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05623181-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05623444-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05623628-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05623818-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05623937-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05624042-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05624254-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05624461-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05624615-n',[ ('VisualAcuityAttribute',subsumption)]).
nounMapping2SUMO('05624700-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05625066-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05625210-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05625373-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05625465-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05625879-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05626524-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05626618-n',[ ('Region',instance)]).
nounMapping2SUMO('05626767-n',[ ('Region',instance)]).
nounMapping2SUMO('05626929-n',[ ('Island',instance)]).
nounMapping2SUMO('05627083-n',[ ('Region',instance)]).
nounMapping2SUMO('05627222-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05627385-n',[ ('Region',instance)]).
nounMapping2SUMO('05627514-n',[ ('Region',instance)]).
nounMapping2SUMO('05627682-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05627785-n',[ ('Region',instance)]).
nounMapping2SUMO('05628031-n',[ ('Region',instance)]).
nounMapping2SUMO('05628193-n',[ ('Region',instance)]).
nounMapping2SUMO('05628403-n',[ ('Region',instance)]).
nounMapping2SUMO('05628565-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05628658-n',[ ('Region',instance)]).
nounMapping2SUMO('05628939-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05629104-n',[ ('Region',instance)]).
nounMapping2SUMO('05629204-n',[ ('Region',instance)]).
nounMapping2SUMO('05629381-n',[ ('Region',instance)]).
nounMapping2SUMO('05629682-n',[ ('Region',instance)]).
nounMapping2SUMO('05630145-n',[ ('Region',instance)]).
nounMapping2SUMO('05630277-n',[ ('Region',instance)]).
nounMapping2SUMO('05630409-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05630539-n',[ ('Region',instance)]).
nounMapping2SUMO('05630734-n',[ ('Region',instance)]).
nounMapping2SUMO('05630874-n',[ ('Region',instance)]).
nounMapping2SUMO('05631076-n',[ ('Region',instance)]).
nounMapping2SUMO('05631175-n',[ ('Region',instance)]).
nounMapping2SUMO('05631304-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05631449-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05631681-n',[ ('Region',instance)]).
nounMapping2SUMO('05631841-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05632056-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05632175-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05632272-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05632446-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05632732-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05632927-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05633044-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05633228-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05633385-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('05633672-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05633860-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05634059-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05634219-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('05634457-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05634613-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05634767-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05634910-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05635055-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05635188-n',[ ('FlyingAircraft',subsumption)]).
nounMapping2SUMO('05635321-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('05635448-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05635624-n',[ ('MilitaryScience',subsumption)]).
nounMapping2SUMO('05635764-n',[ ('Theology',subsumption)]).
nounMapping2SUMO('05635841-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05635970-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05636048-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05636171-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05636294-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05636402-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05636554-n',[ ('Science',subsumption)]).
nounMapping2SUMO('05636666-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05636887-n',[ ('Proposition',equivalence)]).
nounMapping2SUMO('05637106-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05637222-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05637356-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05637558-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05637965-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05638063-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05638374-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05638486-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05638606-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05638700-n',[ ('Position',subsumption)]).
nounMapping2SUMO('05638778-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05638882-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05638987-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05639431-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05639556-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05639651-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05639832-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05639941-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05640040-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05640184-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05640339-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05640433-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05640729-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05640924-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05641089-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05641205-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05641432-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05641556-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05641720-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05641834-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05641959-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05642175-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05642553-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05642678-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05642815-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05642947-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05643072-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05643190-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05643491-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05643611-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05643722-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05643807-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05643908-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05644016-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05644334-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05644423-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05644527-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05644727-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05644922-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05645199-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05645465-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05645597-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05645854-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05646039-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05646218-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05646535-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05646723-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05646828-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05646926-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05647015-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05647156-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05647451-n',[ ('SpaceRegion',equivalence)]).
nounMapping2SUMO('05647643-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05647772-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05647867-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05648011-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05648146-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05648247-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05648459-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05648756-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05648953-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05649116-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05649256-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05649385-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05649538-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05649628-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05649785-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05649960-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05650180-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05650329-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05650579-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05650820-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05651068-n',[ ('Word',subsumption)]).
nounMapping2SUMO('05651242-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05651399-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05651680-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05651971-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05652396-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05652593-n',[ ('IntentionalProcess',equivalence)]).
nounMapping2SUMO('05652843-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05652926-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05653327-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('05653475-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05653575-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05653710-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05653848-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05654052-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05654201-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05654362-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05654783-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05654873-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05655119-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05655482-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05655567-n',[ ('VisualAcuityAttribute',subsumption)]).
nounMapping2SUMO('05655810-n',[ ('VisualAcuityAttribute',subsumption)]).
nounMapping2SUMO('05655966-n',[ ('VisualAcuityAttribute',subsumption)]).
nounMapping2SUMO('05656042-n',[ ('VisualAcuityAttribute',subsumption)]).
nounMapping2SUMO('05656160-n',[ ('VisualAcuityAttribute',subsumption)]).
nounMapping2SUMO('05656294-n',[ ('VisualAcuityAttribute',subsumption)]).
nounMapping2SUMO('05656418-n',[ ('VisualAcuityAttribute',subsumption)]).
nounMapping2SUMO('05656537-n',[ ('VisualAcuityAttribute',subsumption)]).
nounMapping2SUMO('05656722-n',[ ('VisualAcuityAttribute',subsumption)]).
nounMapping2SUMO('05656803-n',[ ('VisualAcuityAttribute',subsumption)]).
nounMapping2SUMO('05656890-n',[ ('VisualAcuityAttribute',subsumption)]).
nounMapping2SUMO('05656997-n',[ ('VisualAcuityAttribute',subsumption)]).
nounMapping2SUMO('05657166-n',[ ('VisualAcuityAttribute',subsumption)]).
nounMapping2SUMO('05657373-n',[ ('VisualAcuityAttribute',subsumption)]).
nounMapping2SUMO('05657515-n',[ ('VisualAcuityAttribute',subsumption)]).
nounMapping2SUMO('05657718-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05657999-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05658106-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05658226-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05658603-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05658826-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05658985-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05659260-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05659365-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05659621-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05659856-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05660268-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05660631-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05660801-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05660937-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05661118-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05661294-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05661400-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05661551-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05661668-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05661825-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05661996-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05662532-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05662876-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05663104-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05663275-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05663491-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05663671-n',[ ('Government',equivalence)]).
nounMapping2SUMO('05663878-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05664069-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05664344-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05664487-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05664640-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05664803-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05664986-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05665146-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05665421-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05665625-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05665769-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05665984-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05666176-n',[ ('ComputerProcess',subsumption)]).
nounMapping2SUMO('05666324-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05666530-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05666700-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05667086-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05667196-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05667404-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('05667613-n',[ ('NormativeAttribute',equivalence)]).
nounMapping2SUMO('05667951-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05668095-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('05668359-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('05668581-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05668725-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05668915-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05669034-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05669181-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('05669350-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05669618-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05669797-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05669934-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05670343-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('05670512-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('05670615-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('05670710-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05670972-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05671217-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05671325-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05671526-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05671676-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('05671842-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05671974-n',[ ('Human',subsumption)]).
nounMapping2SUMO('05672178-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05672286-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('05672391-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('05672698-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('05672862-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('05673088-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('05673209-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('05673323-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('05673439-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('05673710-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('05673908-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05674134-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05674319-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('05674584-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05674927-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05675130-n',[ ('ConsciousnessAttribute',equivalence)]).
nounMapping2SUMO('05675437-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05675601-n',[ ('CognitiveAgent',equivalence)]).
nounMapping2SUMO('05675715-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05675905-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('05676476-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05676605-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05676755-n',[ ('ObjectAttribute',subsumption)]).
nounMapping2SUMO('05676911-n',[ ('ObjectAttribute',subsumption)]).
nounMapping2SUMO('05677097-n',[ ('ObjectAttribute',subsumption)]).
nounMapping2SUMO('05677340-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05677504-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05677744-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05677850-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05677952-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05678148-n',[ ('Awake',subsumption)]).
nounMapping2SUMO('05678300-n',[ ('Awake',equivalence)]).
nounMapping2SUMO('05678474-n',[ ('Awake',equivalence)]).
nounMapping2SUMO('05678745-n',[ ('Awake',subsumption)]).
nounMapping2SUMO('05678855-n',[ ('Awake',subsumption)]).
nounMapping2SUMO('05678932-n',[ ('Unconscious',equivalence)]).
nounMapping2SUMO('05679305-n',[ ('Unconscious',subsumption)]).
nounMapping2SUMO('05679611-n',[ ('Unconscious',subsumption)]).
nounMapping2SUMO('05679800-n',[ ('Unconscious',subsumption)]).
nounMapping2SUMO('05679906-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('05680193-n',[ ('Unconscious',subsumption)]).
nounMapping2SUMO('05680423-n',[ ('Unconscious',subsumption)]).
nounMapping2SUMO('05680573-n',[ ('Unconscious',subsumption)]).
nounMapping2SUMO('05680684-n',[ ('Unconscious',subsumption)]).
nounMapping2SUMO('05680839-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('05680982-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('05681117-n',[ ('Asleep',equivalence)]).
nounMapping2SUMO('05681252-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('05681334-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('05681543-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('05681701-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('05681855-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('05682055-n',[ ('Unconscious',subsumption)]).
nounMapping2SUMO('05682196-n',[ ('Unconscious',subsumption)]).
nounMapping2SUMO('05682431-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('05682570-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05682798-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05682950-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05683197-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05683390-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05683582-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05684003-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05684249-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05684440-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05684561-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05684739-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05684839-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05685030-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05685363-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05685538-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05685879-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05686086-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05686272-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05686481-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05686690-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05686955-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05687338-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05687654-n',[ ('Region',subsumption)]).
nounMapping2SUMO('05687832-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05687958-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05688030-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05688169-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05688397-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05688486-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05688630-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05688770-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05688907-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05688990-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05689109-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05689249-n',[ ('Process',subsumption)]).
nounMapping2SUMO('05689645-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05689801-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05689909-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05690091-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05690269-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05690684-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05690916-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05691144-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05691241-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05691376-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05691492-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05691689-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05691963-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05692094-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05692234-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05692419-n',[ ('Process',subsumption)]).
nounMapping2SUMO('05692758-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05692910-n',[ ('Process',subsumption)]).
nounMapping2SUMO('05693206-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05693383-n',[ ('Process',subsumption)]).
nounMapping2SUMO('05693537-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05693669-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05693919-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05694232-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05694527-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05694791-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05695002-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05695232-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05695446-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05695554-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05695806-n',[ ('Object',subsumption)]).
nounMapping2SUMO('05696020-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05696199-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05696297-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05696425-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05696701-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05696803-n',[ ('Object',subsumption)]).
nounMapping2SUMO('05696941-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05697135-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05697363-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05697789-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05697976-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05698247-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05698620-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05698791-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05698982-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05699172-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05699434-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05699600-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05699770-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05699906-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('05700087-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05700401-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05700625-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05700793-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05700925-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('05701107-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('05701209-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05701363-n',[ ('PsychologicalProcess',equivalence)]).
nounMapping2SUMO('05701738-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05701944-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05702275-n',[ ('IntentionalPsychologicalProcess',equivalence)]).
nounMapping2SUMO('05702602-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('05702726-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05703070-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05703205-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05703307-n',[ ('Looking',subsumption)]).
nounMapping2SUMO('05703429-n',[ ('Perception',equivalence)]).
nounMapping2SUMO('05703803-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05703956-n',[ ('Perception',equivalence)]).
nounMapping2SUMO('05704096-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05704266-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05704550-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05704694-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05705075-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05705184-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05705355-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05705484-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05705583-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05705722-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05706076-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05706228-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05706375-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05706547-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05706629-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05706815-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05706954-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05707146-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05707269-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05707495-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05707718-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05707885-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05708030-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05708207-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05708322-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05708432-n',[ ('Perception',equivalence)]).
nounMapping2SUMO('05708658-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05708818-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05709148-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05709343-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05709507-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05709766-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05710020-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05710210-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05710356-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05710481-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05710573-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05710687-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05710860-n',[ ('Seeing',equivalence)]).
nounMapping2SUMO('05711084-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('05711206-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('05711308-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('05711414-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('05711503-n',[ ('Hearing',subsumption)]).
nounMapping2SUMO('05711674-n',[ ('Hearing',subsumption)]).
nounMapping2SUMO('05711791-n',[ ('Hearing',subsumption)]).
nounMapping2SUMO('05711915-n',[ ('Hearing',subsumption)]).
nounMapping2SUMO('05712076-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05712426-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05712559-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05712698-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05712892-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05713101-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05713347-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05713524-n',[ ('Seeing',equivalence)]).
nounMapping2SUMO('05713737-n',[ ('Smelling',equivalence)]).
nounMapping2SUMO('05714161-n',[ ('OlfactoryAttribute',subsumption)]).
nounMapping2SUMO('05714332-n',[ ('OlfactoryAttribute',subsumption)]).
nounMapping2SUMO('05714466-n',[ ('OlfactoryAttribute',subsumption)]).
nounMapping2SUMO('05714745-n',[ ('OlfactoryAttribute',subsumption)]).
nounMapping2SUMO('05714894-n',[ ('OlfactoryAttribute',subsumption)]).
nounMapping2SUMO('05715150-n',[ ('OlfactoryAttribute',subsumption)]).
nounMapping2SUMO('05715283-n',[ ('Tasting',equivalence)]).
nounMapping2SUMO('05715864-n',[ ('Tasting',subsumption)]).
nounMapping2SUMO('05716342-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('05716462-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('05716577-n',[ ('Sweetness',equivalence)]).
nounMapping2SUMO('05716744-n',[ ('Sourness',equivalence)]).
nounMapping2SUMO('05716961-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('05717115-n',[ ('Bitterness',equivalence)]).
nounMapping2SUMO('05717266-n',[ ('OlfactoryAttribute',subsumption)]).
nounMapping2SUMO('05717342-n',[ ('Saltiness',equivalence)]).
nounMapping2SUMO('05717549-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('05717747-n',[ ('Tasting',subsumption)]).
nounMapping2SUMO('05717953-n',[ ('SpatialRelation',subsumption)]).
nounMapping2SUMO('05718118-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('05718254-n',[ ('Hearing',subsumption)]).
nounMapping2SUMO('05718556-n',[ ('MakingMusic',equivalence)]).
nounMapping2SUMO('05718935-n',[ ('MakingMusic',equivalence)]).
nounMapping2SUMO('05719325-n',[ ('MakingInstrumentalMusic',subsumption)]).
nounMapping2SUMO('05719466-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('05719605-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('05719804-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('05719958-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('05720093-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('05720248-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('05720521-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('05720602-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05720826-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05721019-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05721180-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05721500-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05721728-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('05721990-n',[ ('TactilePerception',equivalence)]).
nounMapping2SUMO('05722208-n',[ ('TactilePerception',subsumption)]).
nounMapping2SUMO('05722427-n',[ ('TactilePerception',subsumption)]).
nounMapping2SUMO('05722754-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05722868-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05723080-n',[ ('TactilePerception',subsumption)]).
nounMapping2SUMO('05723210-n',[ ('TactilePerception',subsumption)]).
nounMapping2SUMO('05723417-n',[ ('TactilePerception',subsumption)]).
nounMapping2SUMO('05723563-n',[ ('TactilePerception',subsumption)]).
nounMapping2SUMO('05723811-n',[ ('TactilePerception',subsumption)]).
nounMapping2SUMO('05724019-n',[ ('TactilePerception',subsumption)]).
nounMapping2SUMO('05724121-n',[ ('TactilePerception',subsumption)]).
nounMapping2SUMO('05724234-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05724357-n',[ ('TactilePerception',subsumption)]).
nounMapping2SUMO('05724475-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05724694-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05724965-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05725137-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05725269-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05725378-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05725527-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05725676-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05725879-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05726093-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05726237-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05726345-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05726596-n',[ ('Procedure',equivalence)]).
nounMapping2SUMO('05727220-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05727427-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05727808-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('05728024-n',[ ('Graph',subsumption)]).
nounMapping2SUMO('05728271-n',[ ('Graph',subsumption)]).
nounMapping2SUMO('05728493-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05728678-n',[ ('SpatialRelation',equivalence)]).
nounMapping2SUMO('05729036-n',[ ('Set',subsumption)]).
nounMapping2SUMO('05729362-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05729483-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05729609-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05729875-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05730046-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('05730163-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('05730365-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('05730591-n',[ ('Graph',subsumption)]).
nounMapping2SUMO('05730724-n',[ ('Graph',subsumption)]).
nounMapping2SUMO('05730930-n',[ ('Graph',subsumption)]).
nounMapping2SUMO('05731062-n',[ ('Graph',subsumption)]).
nounMapping2SUMO('05731223-n',[ ('Graph',subsumption)]).
nounMapping2SUMO('05731405-n',[ ('Graph',subsumption)]).
nounMapping2SUMO('05731568-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('05731779-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('05732086-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05732273-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05732446-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05732614-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05732756-n',[ ('Classifying',equivalence)]).
nounMapping2SUMO('05733090-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('05733221-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05733361-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05733583-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('05733864-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('05734018-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('05734288-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('05734381-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('05734477-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('05734559-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('05734909-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('05735145-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('05735256-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('05735478-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('05735680-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('05735789-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('05736002-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('05736149-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('05736468-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05736593-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05736736-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05736893-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('05737025-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('05737153-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05737532-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('05737752-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('05737982-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('05738204-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('05738404-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05738625-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('05738894-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('05739043-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05739400-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05739613-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05739965-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05740162-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05740300-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05740560-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05740804-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05740929-n',[ ('Biopsy',subsumption)]).
nounMapping2SUMO('05741139-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05741340-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05741578-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05741765-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05741949-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05742241-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05742551-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05742703-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05742962-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05743174-n',[ ('Biopsy',subsumption)]).
nounMapping2SUMO('05743296-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05743496-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('05743770-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05743870-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05744010-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05744288-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05744421-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05744620-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05744792-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05744976-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05745098-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05745369-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05745486-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05745648-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05745744-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05745907-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05746163-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05746424-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05746708-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05746868-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05747056-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05747160-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05747322-n',[ ('DiagnosticProcess',subsumption)]).
nounMapping2SUMO('05747495-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('05747582-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('05747815-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('05747937-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05748054-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('05748285-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05748614-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('05748786-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('05749042-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05749210-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05749402-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('05749619-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05750027-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05750163-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05750471-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05750657-n',[ ('Clothing',equivalence)]).
nounMapping2SUMO('05750948-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05751063-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05751173-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05751430-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05751533-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05751707-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05751794-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05752020-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05752179-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05752296-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05752422-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05752544-n',[ ('Learning',equivalence)]).
nounMapping2SUMO('05752921-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('05753207-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05753379-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05753564-n',[ ('EducationalProcess',equivalence)]).
nounMapping2SUMO('05753954-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05754197-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05754519-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05754730-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05754899-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05755007-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05755156-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05755393-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05755486-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05755714-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05755883-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05756203-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05756414-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05756698-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('05756888-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('05757049-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05757234-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05757423-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('05757536-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('05757731-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('05757902-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('05758059-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05758382-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05758548-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05758692-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('05758907-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('05759017-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('05759182-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('05759487-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('05759696-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('05759949-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('05760202-n',[ ('Remembering',equivalence)]).
nounMapping2SUMO('05760611-n',[ ('Remembering',subsumption)]).
nounMapping2SUMO('05760751-n',[ ('Remembering',subsumption)]).
nounMapping2SUMO('05760877-n',[ ('Remembering',subsumption)]).
nounMapping2SUMO('05761044-n',[ ('Remembering',subsumption)]).
nounMapping2SUMO('05761160-n',[ ('Remembering',subsumption)]).
nounMapping2SUMO('05761277-n',[ ('Remembering',subsumption)]).
nounMapping2SUMO('05761380-n',[ ('Remembering',subsumption)]).
nounMapping2SUMO('05761559-n',[ ('Remembering',subsumption)]).
nounMapping2SUMO('05761918-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05762149-n',[ ('Remembering',equivalence)]).
nounMapping2SUMO('05762258-n',[ ('Remembering',subsumption)]).
nounMapping2SUMO('05762483-n',[ ('Remembering',subsumption)]).
nounMapping2SUMO('05762671-n',[ ('Remembering',subsumption)]).
nounMapping2SUMO('05762848-n',[ ('Remembering',subsumption)]).
nounMapping2SUMO('05762998-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('05763412-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05763767-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('05763916-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('05764197-n',[ ('Argument',subsumption)]).
nounMapping2SUMO('05764365-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05764613-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05764779-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05764973-n',[ ('Remembering',subsumption)]).
nounMapping2SUMO('05765159-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05765415-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('05765901-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('05766077-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('05766247-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05766698-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05766984-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05767245-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05767386-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('05767580-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05767733-n',[ ('Imagining',subsumption)]).
nounMapping2SUMO('05768107-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05768252-n',[ ('Imagining',equivalence)]).
nounMapping2SUMO('05768415-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05768553-n',[ ('Dreaming',subsumption)]).
nounMapping2SUMO('05768806-n',[ ('Imagining',subsumption)]).
nounMapping2SUMO('05769062-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05769156-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05769314-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05769471-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05769726-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05769833-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05769930-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('05770058-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05770257-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05770391-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05770664-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05770926-n',[ ('Reasoning',equivalence)]).
nounMapping2SUMO('05771532-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05771679-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05771836-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05772044-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05772215-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05772356-n',[ ('Reasoning',equivalence)]).
nounMapping2SUMO('05772667-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('05773049-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05773407-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05773548-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05773776-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05773923-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05774129-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05774415-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05774614-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05775081-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('05775293-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('05775407-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('05775695-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('05775829-n',[ ('Imagining',subsumption)]).
nounMapping2SUMO('05775919-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05776015-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('05776212-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('05776592-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('05776679-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('05776875-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('05777149-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('05777298-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('05777439-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('05777599-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('05777722-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('05777830-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('05778029-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('05778131-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('05778646-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('05778749-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('05778954-n',[ ('Process',subsumption)]).
nounMapping2SUMO('05779116-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05779371-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05779568-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05779712-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05779923-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05780104-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05780339-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05780563-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05780718-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05780885-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05781145-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05781347-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05781541-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05781663-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05781800-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05781953-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05782140-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05782245-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05782448-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05782563-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05782713-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('05782884-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05783041-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('05783357-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('05783658-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05783768-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05783940-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05784152-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('05784242-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05784482-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05784560-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05784699-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05784831-n',[ ('IntentionalProcess',undefined)]).
nounMapping2SUMO('05785067-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05785311-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05785508-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05785885-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05786184-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05786372-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05786655-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05786871-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05787005-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('05787175-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('05787498-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('05787848-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05788029-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05788149-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('05788552-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05788713-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('05788924-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('05789089-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('05789432-n',[ ('Judging',subsumption)]).
nounMapping2SUMO('05789666-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('05789808-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('05790012-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05790242-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('05790452-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05790572-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05790758-n',[ ('Favorite',equivalence)]).
nounMapping2SUMO('05790944-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05791311-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05791452-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05791602-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05791764-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05791864-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('05792010-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('05792192-n',[ ('',undefined)]).
nounMapping2SUMO('05792312-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05792446-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05792575-n',[ ('Selecting',subsumption)]).
nounMapping2SUMO('05792691-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05792842-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05793000-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('05793210-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05793554-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05793907-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05794057-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05794189-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('05794403-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05794618-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05794694-n',[ ('Planning',equivalence)]).
nounMapping2SUMO('05795044-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('05795244-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('05795334-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('05795460-n',[ ('Reservation',equivalence)]).
nounMapping2SUMO('05795654-n',[ ('Offering',subsumption)]).
nounMapping2SUMO('05795835-n',[ ('Planning',subsumption)]).
nounMapping2SUMO('05795957-n',[ ('Planning',subsumption)]).
nounMapping2SUMO('05796222-n',[ ('Planning',subsumption)]).
nounMapping2SUMO('05796423-n',[ ('Planning',subsumption)]).
nounMapping2SUMO('05796617-n',[ ('Planning',subsumption)]).
nounMapping2SUMO('05796750-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05796937-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05797177-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05797473-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05797597-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05797899-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('05798043-n',[ ('Experimenting',subsumption)]).
nounMapping2SUMO('05798315-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05798413-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05798569-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05798863-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05799071-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05799212-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05799581-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05799761-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05799952-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05800153-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05800272-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('05800387-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05800527-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05800611-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05800838-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05800998-n',[ ('Polling',subsumption)]).
nounMapping2SUMO('05801286-n',[ ('Polling',subsumption)]).
nounMapping2SUMO('05801465-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05801594-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('05802185-n',[ ('Calculating',equivalence)]).
nounMapping2SUMO('05802547-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('05802730-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('05802912-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('05803095-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('05803212-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('05803379-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('05803747-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05803938-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('05804136-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('05804274-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('05804491-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('05804793-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05805012-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05805157-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05805277-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05805475-n',[ ('Interpreting',equivalence)]).
nounMapping2SUMO('05805902-n',[ ('Interpreting',subsumption)]).
nounMapping2SUMO('05806231-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05806380-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05806498-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05806623-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05806855-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05807012-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05807147-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05807306-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05807540-n',[ ('Interpreting',subsumption)]).
nounMapping2SUMO('05807933-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05808102-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05808218-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05808442-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05808557-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05808794-n',[ ('Interpreting',equivalence)]).
nounMapping2SUMO('05809082-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05809192-n',[ ('Proposition',equivalence)]).
nounMapping2SUMO('05809745-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05809878-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05810143-n',[ ('AbstractionFn',subsumption)]).
nounMapping2SUMO('05810250-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05810440-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05810561-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05810768-n',[ ('Imagining',subsumption)]).
nounMapping2SUMO('05810948-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05811214-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05811380-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05811466-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('05811662-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05811884-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05812038-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05812370-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05812485-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05812646-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05812813-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05812921-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05813109-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05813229-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05813457-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05813626-n',[ ('Process',subsumption)]).
nounMapping2SUMO('05813822-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('05813912-n',[ ('Process',subsumption)]).
nounMapping2SUMO('05814019-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05814162-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05814291-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05814650-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05814952-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05815075-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05815267-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05815412-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05815517-n',[ ('FieldOfStudy',equivalence)]).
nounMapping2SUMO('05815691-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05815890-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('05816154-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05816287-n',[ ('FactualText',equivalence)]).
nounMapping2SUMO('05816622-n',[ ('True',subsumption)]).
nounMapping2SUMO('05816790-n',[ ('True',subsumption)]).
nounMapping2SUMO('05817145-n',[ ('True',subsumption)]).
nounMapping2SUMO('05817396-n',[ ('Fact',equivalence)]).
nounMapping2SUMO('05817743-n',[ ('True',subsumption)]).
nounMapping2SUMO('05817845-n',[ ('Fact',equivalence)]).
nounMapping2SUMO('05818182-n',[ ('True',subsumption)]).
nounMapping2SUMO('05818388-n',[ ('True',subsumption)]).
nounMapping2SUMO('05818620-n',[ ('True',subsumption)]).
nounMapping2SUMO('05818741-n',[ ('True',subsumption)]).
nounMapping2SUMO('05818978-n',[ ('True',subsumption)]).
nounMapping2SUMO('05819149-n',[ ('True',subsumption)]).
nounMapping2SUMO('05819338-n',[ ('True',subsumption)]).
nounMapping2SUMO('05819453-n',[ ('True',equivalence)]).
nounMapping2SUMO('05819644-n',[ ('True',subsumption)]).
nounMapping2SUMO('05819773-n',[ ('True',subsumption)]).
nounMapping2SUMO('05819890-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05820023-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05820170-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05820325-n',[ ('Fact',subsumption)]).
nounMapping2SUMO('05820462-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05820620-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05821102-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05821246-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05821486-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05821646-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05821775-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05822001-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05822085-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('05822239-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05822337-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05822507-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('05822612-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('05822746-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('05823054-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05823317-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05823517-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05823747-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('05823932-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05824313-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('05824514-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05824739-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05824985-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05825245-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05825688-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05825802-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('05825942-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05826092-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05826291-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05826469-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05826722-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05826832-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05826914-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05827129-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05827253-n',[ ('Process',subsumption)]).
nounMapping2SUMO('05827509-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05827684-n',[ ('Process',subsumption)]).
nounMapping2SUMO('05828102-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05828263-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05828425-n',[ ('Process',subsumption)]).
nounMapping2SUMO('05828552-n',[ ('Process',subsumption)]).
nounMapping2SUMO('05828820-n',[ ('Process',subsumption)]).
nounMapping2SUMO('05829012-n',[ ('Process',subsumption)]).
nounMapping2SUMO('05829213-n',[ ('Process',subsumption)]).
nounMapping2SUMO('05829342-n',[ ('Process',subsumption)]).
nounMapping2SUMO('05829480-n',[ ('Process',subsumption)]).
nounMapping2SUMO('05829656-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05829782-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05830059-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05830527-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05830832-n',[ ('ObjectiveNorm',subsumption)]).
nounMapping2SUMO('05831057-n',[ ('ObjectiveNorm',subsumption)]).
nounMapping2SUMO('05831270-n',[ ('ObjectiveNorm',subsumption)]).
nounMapping2SUMO('05831412-n',[ ('ObjectiveNorm',subsumption)]).
nounMapping2SUMO('05831566-n',[ ('Physical',subsumption)]).
nounMapping2SUMO('05831784-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05831939-n',[ ('Physical',subsumption)]).
nounMapping2SUMO('05832113-n',[ ('Physical',subsumption)]).
nounMapping2SUMO('05832264-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05832621-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05832745-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05833022-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05833169-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05833252-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05833371-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05833511-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05833683-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('05833840-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05834567-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05834758-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05834946-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05835162-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05835292-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05835449-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05835568-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05835747-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05836275-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05836468-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05836598-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05836714-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05836921-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05837128-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05837271-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05837370-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05837651-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05837743-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('05837850-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05837957-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05838176-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05838530-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05838765-n',[ ('Class',equivalence)]).
nounMapping2SUMO('05839024-n',[ ('Class',equivalence)]).
nounMapping2SUMO('05839547-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05839663-n',[ ('Class',subsumption)]).
nounMapping2SUMO('05839776-n',[ ('Class',subsumption)]).
nounMapping2SUMO('05839910-n',[ ('Class',subsumption)]).
nounMapping2SUMO('05840076-n',[ ('Class',subsumption)]).
nounMapping2SUMO('05840188-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05840431-n',[ ('Class',subsumption)]).
nounMapping2SUMO('05840650-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05841029-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05841151-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('05841351-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('05841624-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('05841740-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('05841985-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('05842191-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('05842290-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('05842387-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('05842706-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('05843042-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('05843236-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('05843513-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('05843687-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('05843895-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('05844105-n',[ ('Class',subsumption)]).
nounMapping2SUMO('05844282-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('05844433-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05844545-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05844663-n',[ ('Class',subsumption)]).
nounMapping2SUMO('05844881-n',[ ('Class',subsumption)]).
nounMapping2SUMO('05845013-n',[ ('Class',subsumption)]).
nounMapping2SUMO('05845140-n',[ ('Class',subsumption)]).
nounMapping2SUMO('05845332-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('05845419-n',[ ('Human',subsumption)]).
nounMapping2SUMO('05845562-n',[ ('Class',subsumption)]).
nounMapping2SUMO('05845652-n',[ ('Product',equivalence)]).
nounMapping2SUMO('05845749-n',[ ('Class',subsumption)]).
nounMapping2SUMO('05845888-n',[ ('Class',subsumption)]).
nounMapping2SUMO('05846054-n',[ ('DeonticAttribute',equivalence)]).
nounMapping2SUMO('05846355-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('05846626-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('05846932-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05847320-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05847438-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05847658-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05847753-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05847956-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05848182-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05848357-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05848541-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05848691-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05848912-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05849040-n',[ ('Attribute',equivalence)]).
nounMapping2SUMO('05849284-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05849667-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05849789-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05850212-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05850432-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05850624-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05850823-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05851131-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05851330-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05851517-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05851744-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05852007-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05852125-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05852287-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('05852430-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('05852553-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05852819-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05852973-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05853100-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05853273-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05853449-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05853636-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05853820-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('05853924-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05854150-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05854474-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05854812-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('05855004-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05855125-n',[ ('Quantity',equivalence)]).
nounMapping2SUMO('05855517-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05855748-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05855904-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05856066-n',[ ('Number',equivalence)]).
nounMapping2SUMO('05856217-n',[ ('Number',subsumption)]).
nounMapping2SUMO('05856388-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05856589-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05856867-n',[ ('PhysicalQuantity',equivalence)]).
nounMapping2SUMO('05856979-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05857165-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('05857346-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05857459-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05857781-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05857974-n',[ ('Number',subsumption)]).
nounMapping2SUMO('05858093-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05858317-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05858407-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05858551-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05858699-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05858936-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05859071-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05859277-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05859477-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05859630-n',[ ('MultiplicationFn',subsumption)]).
nounMapping2SUMO('05859811-n',[ ('MultiplicationFn',subsumption)]).
nounMapping2SUMO('05859991-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05860200-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05860377-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05860498-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05860639-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05860869-n',[ ('AdditionFn',subsumption)]).
nounMapping2SUMO('05860975-n',[ ('AdditionFn',subsumption)]).
nounMapping2SUMO('05861067-n',[ ('AdditionFn',subsumption)]).
nounMapping2SUMO('05861317-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05861463-n',[ ('AdditionFn',subsumption)]).
nounMapping2SUMO('05861579-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05861716-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05861855-n',[ ('AdditionFn',subsumption)]).
nounMapping2SUMO('05862113-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05862268-n',[ ('AdditionFn',subsumption)]).
nounMapping2SUMO('05862410-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('05862501-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05862613-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05862721-n',[ ('AdditionFn',subsumption)]).
nounMapping2SUMO('05862970-n',[ ('AdditionFn',subsumption)]).
nounMapping2SUMO('05863106-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('05863302-n',[ ('AdditionFn',subsumption)]).
nounMapping2SUMO('05863480-n',[ ('AdditionFn',subsumption)]).
nounMapping2SUMO('05863583-n',[ ('AdditionFn',subsumption)]).
nounMapping2SUMO('05863736-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05863919-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05864047-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05864177-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05864351-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05864481-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('05864577-n',[ ('FunctionQuantity',equivalence)]).
nounMapping2SUMO('05864758-n',[ ('MultiplicationFn',subsumption)]).
nounMapping2SUMO('05864884-n',[ ('MultiplicationFn',subsumption)]).
nounMapping2SUMO('05865034-n',[ ('AdditionFn',subsumption)]).
nounMapping2SUMO('05865174-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05865311-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05865454-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05865652-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05865774-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05865998-n',[ ('GeometricPoint',equivalence)]).
nounMapping2SUMO('05866199-n',[ ('GeometricPoint',subsumption)]).
nounMapping2SUMO('05866489-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05866653-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05866822-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05867283-n',[ ('GeometricPoint',subsumption)]).
nounMapping2SUMO('05867413-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05868051-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05868272-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05868477-n',[ ('EndFn',equivalence)]).
nounMapping2SUMO('05868779-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05868954-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05869407-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05869584-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('05869857-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('05870055-n',[ ('Number',equivalence)]).
nounMapping2SUMO('05870180-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('05870365-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('05870615-n',[ ('Object',subsumption)]).
nounMapping2SUMO('05870790-n',[ ('Object',subsumption)]).
nounMapping2SUMO('05870916-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('05871140-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05871245-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05871362-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05871618-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05871792-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05872098-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05872362-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05872477-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05872742-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05872982-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05873884-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05874017-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05874232-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05874716-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05874941-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05875148-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05875392-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05875723-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05875988-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05876148-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05876469-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05876912-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05877178-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05877412-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05877718-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05877991-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05878229-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05878440-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05878771-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05879003-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05879204-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05879441-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05879693-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05879856-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05880187-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05880432-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05880715-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05880854-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05881102-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05881303-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05881578-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05881867-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05882226-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05882537-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05882793-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05883035-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05883296-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05883473-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05883688-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05883992-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05884433-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05884736-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05884984-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05885187-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05885412-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05885622-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05885822-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05886039-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05886266-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05886455-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05886613-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05886939-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05887156-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05887365-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05887712-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05887911-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05888215-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05888377-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05888572-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05888929-n',[ ('Explanation',equivalence)]).
nounMapping2SUMO('05889575-n',[ ('Explanation',subsumption)]).
nounMapping2SUMO('05889762-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05889896-n',[ ('True',subsumption)]).
nounMapping2SUMO('05890021-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05890249-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05890642-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05890809-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05890963-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05891232-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05891426-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05891572-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05891783-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05892096-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05892427-n',[ ('Necessity',equivalence)]).
nounMapping2SUMO('05892651-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05892880-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05892991-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05893143-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05893261-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05893356-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05893512-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05893653-n',[ ('False',subsumption)]).
nounMapping2SUMO('05893916-n',[ ('False',subsumption)]).
nounMapping2SUMO('05894143-n',[ ('False',subsumption)]).
nounMapping2SUMO('05894311-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05894460-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05894631-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05894814-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05894972-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05895138-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05895373-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05895465-n',[ ('False',subsumption)]).
nounMapping2SUMO('05895588-n',[ ('False',subsumption)]).
nounMapping2SUMO('05895723-n',[ ('False',subsumption)]).
nounMapping2SUMO('05896059-n',[ ('False',subsumption)]).
nounMapping2SUMO('05896379-n',[ ('False',subsumption)]).
nounMapping2SUMO('05896515-n',[ ('False',subsumption)]).
nounMapping2SUMO('05896618-n',[ ('False',subsumption)]).
nounMapping2SUMO('05896733-n',[ ('False',subsumption)]).
nounMapping2SUMO('05896998-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('05897255-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('05897553-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05897825-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05898035-n',[ ('Ship',instance)]).
nounMapping2SUMO('05898171-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05898430-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05898568-n',[ ('Plan',equivalence)]).
nounMapping2SUMO('05899087-n',[ ('PublicProgram',equivalence)]).
nounMapping2SUMO('05899442-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05899621-n',[ ('Organization',instance)]).
nounMapping2SUMO('05899831-n',[ ('Organization',instance)]).
nounMapping2SUMO('05900010-n',[ ('Organization',instance)]).
nounMapping2SUMO('05900263-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05900430-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05900583-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05900716-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05900888-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('05901248-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05901410-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05901508-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05901840-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05902014-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05902327-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05902545-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05902786-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05902872-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05903112-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05903229-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05903445-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05903738-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05903878-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05904010-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05904135-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05904313-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05904616-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05904918-n',[ ('PricingScheme',subsumption)]).
nounMapping2SUMO('05905027-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('05905152-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05905348-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05905706-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05905802-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('05906080-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('05906305-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('05906554-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('05906734-n',[ ('CounterTerrorismStrategy',equivalence)]).
nounMapping2SUMO('05906867-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05906998-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05907251-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05907479-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05907682-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05908000-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05908391-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05908520-n',[ ('Planning',subsumption)]).
nounMapping2SUMO('05908727-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05908882-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05909097-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05909306-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05909384-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05909585-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05909730-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05909921-n',[ ('EducationalProgram',equivalence)]).
nounMapping2SUMO('05910070-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05910328-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05910453-n',[ ('Plan',equivalence)]).
nounMapping2SUMO('05910577-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05910712-n',[ ('EducationalProgram',subsumption)]).
nounMapping2SUMO('05910810-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05910940-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05911124-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05911255-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05911560-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05912012-n',[ ('PensionPlan',subsumption)]).
nounMapping2SUMO('05912243-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05912399-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05912552-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05912814-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05912969-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05913160-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05913275-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05913538-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05913842-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05913994-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05914234-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('05914359-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('05914591-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05914851-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('05915034-n',[ ('Hajj',equivalence)]).
nounMapping2SUMO('05915356-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05915584-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05915811-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05916155-n',[ ('Requesting',equivalence)]).
nounMapping2SUMO('05916306-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05916520-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('05916739-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05917174-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05917328-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05917477-n',[ ('Process',subsumption)]).
nounMapping2SUMO('05917675-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05917869-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('05917994-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('05918171-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('05918267-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05918379-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05918704-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('05919034-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05919263-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05919431-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05919549-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05919866-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05920159-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05920272-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05920482-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05920651-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('05920791-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05921123-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05921685-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05921868-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05922014-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05922175-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05922305-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05922450-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05922651-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05922809-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05922949-n',[ ('Word',subsumption)]).
nounMapping2SUMO('05923314-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05923566-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05923696-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05923983-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05924165-n',[ ('Learning',subsumption)]).
nounMapping2SUMO('05924408-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05924519-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05924730-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05924920-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05925177-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05925366-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05925702-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05925862-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05926049-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05926150-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05926236-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05926358-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05926676-n',[ ('Imagining',equivalence)]).
nounMapping2SUMO('05927169-n',[ ('Imagining',subsumption)]).
nounMapping2SUMO('05927364-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05927586-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05927813-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05928118-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('05928391-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('05928513-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05928733-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05928840-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05929008-n',[ ('DramaticActing',subsumption)]).
nounMapping2SUMO('05929363-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('05929461-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('05929582-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('05929670-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('05929780-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('05929887-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('05930010-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05930136-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05930386-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05930574-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('05930736-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05931152-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05931341-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05931512-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05931658-n',[ ('Device',subsumption)]).
nounMapping2SUMO('05931827-n',[ ('Device',subsumption)]).
nounMapping2SUMO('05931980-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05932062-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05932282-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('05932477-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('05932709-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('05932891-n',[ ('Object',subsumption)]).
nounMapping2SUMO('05933054-n',[ ('Seeing',equivalence)]).
nounMapping2SUMO('05933246-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('05933638-n',[ ('Object',subsumption)]).
nounMapping2SUMO('05933834-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('05934029-n',[ ('Object',subsumption)]).
nounMapping2SUMO('05934123-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('05934278-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('05934396-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('05934550-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('05934673-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('05934780-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('05934852-n',[ ('Object',subsumption)]).
nounMapping2SUMO('05934962-n',[ ('Object',subsumption)]).
nounMapping2SUMO('05935060-n',[ ('Remembering',equivalence)]).
nounMapping2SUMO('05935292-n',[ ('Remembering',equivalence)]).
nounMapping2SUMO('05935381-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('05935535-n',[ ('Remembering',subsumption)]).
nounMapping2SUMO('05935717-n',[ ('Remembering',subsumption)]).
nounMapping2SUMO('05935871-n',[ ('Remembering',subsumption)]).
nounMapping2SUMO('05936016-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('05936130-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('05936300-n',[ ('Tasting',subsumption)]).
nounMapping2SUMO('05936381-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('05936561-n',[ ('Seeing',subsumption)]).
nounMapping2SUMO('05936704-n',[ ('Imagining',equivalence)]).
nounMapping2SUMO('05936995-n',[ ('Hearing',subsumption)]).
nounMapping2SUMO('05937112-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05937417-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05937524-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05937878-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05938014-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05938170-n',[ ('Object',subsumption)]).
nounMapping2SUMO('05938314-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05938400-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05938633-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05938795-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05938976-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05939109-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05939244-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05939432-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05939636-n',[ ('False',subsumption)]).
nounMapping2SUMO('05939809-n',[ ('False',subsumption)]).
nounMapping2SUMO('05939948-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('05940090-n',[ ('False',subsumption)]).
nounMapping2SUMO('05940214-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05940302-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05940414-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05940688-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('05940869-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('05941037-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05941210-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05941423-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05942104-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05942338-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05942579-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05942888-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05943066-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05943300-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05944686-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05944958-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05945227-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05945383-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05945508-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05945642-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05946089-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05946234-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05946406-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05946582-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05946687-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05948264-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05948537-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05948716-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05948857-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05949088-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05949266-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05949336-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05949472-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05949603-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05949726-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05949937-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05950234-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05950475-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05950559-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05950733-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05950982-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('05951072-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05951180-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05951323-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05951566-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05951692-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05951820-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05951969-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05952199-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05952367-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05952490-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05952678-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05952829-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05952979-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05953263-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('05953416-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05953614-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05953804-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05953881-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05954100-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05954366-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05954481-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05954672-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05954807-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('05954894-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05955095-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05955186-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05955323-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('05955593-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('05955848-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05956019-n',[ ('ObjectiveNorm',subsumption)]).
nounMapping2SUMO('05956287-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05956489-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05956651-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05956906-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05957078-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05957238-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05957428-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05957737-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05957913-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05958114-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05958208-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05958337-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05958427-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05958549-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05958712-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05958919-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05959082-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05959263-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05959407-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05959578-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05959785-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('05959954-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05960121-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05960464-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05960698-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05960925-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05961141-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05961278-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05961429-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05961608-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05961745-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05961867-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05962043-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05962166-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05962252-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05962414-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05962602-n',[ ('RepresentationalArtWork',equivalence)]).
nounMapping2SUMO('05962785-n',[ ('ArtWork',equivalence)]).
nounMapping2SUMO('05962936-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05963101-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05963299-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05963494-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05963744-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05963973-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05964098-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05964322-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05964445-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05964643-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05964805-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05965022-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05965195-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05965388-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05965586-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05965749-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05965933-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05966129-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05966602-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05966798-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05966958-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05967097-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05967191-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05967402-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05967588-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05967773-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05967894-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05967977-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('05968209-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05968288-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05968450-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('05968553-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05968710-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05968835-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05968971-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05969194-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05969537-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05969758-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05970012-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05970311-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05970564-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05970755-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05971086-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05971394-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05971621-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05971913-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05972103-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05972264-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05972417-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05972585-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05972781-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05973007-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05973198-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05973372-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05973603-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('05974156-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05974363-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05974564-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05974798-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05975051-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05975258-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05975473-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05975659-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05975846-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05976065-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05976257-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05976471-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05976649-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05976805-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05976948-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05977135-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05977340-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05977619-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05977800-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05977977-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05978159-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('05978370-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05978472-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('05978623-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('05978812-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('05979198-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('05979350-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('05979454-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05979595-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05979800-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05979909-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05980051-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05980256-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05980412-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05980750-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05980875-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05981230-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05981546-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05981648-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05981768-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05981936-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('05982024-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05982152-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05982720-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05982915-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05983122-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05983217-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05983347-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05983463-n',[ ('PsychologicalAttribute',equivalence)]).
nounMapping2SUMO('05983654-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('05983801-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05983943-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05984066-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05984182-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('05984287-n',[ ('EducationalProcess',equivalence)]).
nounMapping2SUMO('05984584-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05984936-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05985126-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05985381-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05985602-n',[ ('FictionalText',equivalence)]).
nounMapping2SUMO('05985999-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05986295-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('05986395-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('05986594-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('05986822-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05986948-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05987283-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05987397-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05987522-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05987650-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('05987835-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('05987969-n',[ ('EducationalProcess',subsumption)]).
nounMapping2SUMO('05988097-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('05988282-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05988498-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05988743-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05988956-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05989265-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05989386-n',[ ('Proposition',not(subsumption))]).
nounMapping2SUMO('05989479-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05990089-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05990480-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05990738-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05990981-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05991242-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05991441-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05991776-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05992015-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05992274-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05992624-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('05992804-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05992949-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05993235-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05993367-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05993622-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05993844-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05994484-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05994706-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05994935-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05995220-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05995355-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05995576-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05995726-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05995898-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05996110-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05996353-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05996646-n',[ ('FieldOfStudy',equivalence)]).
nounMapping2SUMO('05997361-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('05997659-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('05997814-n',[ ('FieldOfStudy',equivalence)]).
nounMapping2SUMO('05998052-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('05998225-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('05998356-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('05998526-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('05998724-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('05998893-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('05998994-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('05999134-n',[ ('FieldOfStudy',equivalence)]).
nounMapping2SUMO('05999266-n',[ ('FieldOfStudy',equivalence)]).
nounMapping2SUMO('05999455-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('05999540-n',[ ('Science',subsumption)]).
nounMapping2SUMO('05999797-n',[ ('Science',subsumption)]).
nounMapping2SUMO('06000400-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06000644-n',[ ('Mathematics',instance)]).
nounMapping2SUMO('06003682-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06004067-n',[ ('Mathematics',instance)]).
nounMapping2SUMO('06004599-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06004685-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06005399-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06005518-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06005692-n',[ ('Proposition',instance)]).
nounMapping2SUMO('06005999-n',[ ('Proposition',instance)]).
nounMapping2SUMO('06006117-n',[ ('Proposition',instance)]).
nounMapping2SUMO('06006243-n',[ ('Proposition',instance)]).
nounMapping2SUMO('06006364-n',[ ('Proposition',instance)]).
nounMapping2SUMO('06006458-n',[ ('Proposition',instance)]).
nounMapping2SUMO('06006609-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06006777-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06007046-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06007381-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06007642-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06007859-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06008007-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06008148-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06008382-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06008609-n',[ ('GraphPath',subsumption)]).
nounMapping2SUMO('06008896-n',[ ('GraphPath',subsumption)]).
nounMapping2SUMO('06009086-n',[ ('GraphNode',subsumption)]).
nounMapping2SUMO('06009233-n',[ ('GraphPath',subsumption)]).
nounMapping2SUMO('06009334-n',[ ('GraphPath',subsumption)]).
nounMapping2SUMO('06009433-n',[ ('GraphPath',subsumption)]).
nounMapping2SUMO('06009537-n',[ ('GraphPath',subsumption)]).
nounMapping2SUMO('06009685-n',[ ('GraphPath',subsumption)]).
nounMapping2SUMO('06009857-n',[ ('GraphPath',subsumption)]).
nounMapping2SUMO('06009988-n',[ ('GraphPath',subsumption)]).
nounMapping2SUMO('06010105-n',[ ('GraphPath',subsumption)]).
nounMapping2SUMO('06010381-n',[ ('GraphPath',subsumption)]).
nounMapping2SUMO('06010583-n',[ ('Graph',subsumption)]).
nounMapping2SUMO('06010737-n',[ ('Physical',subsumption)]).
nounMapping2SUMO('06010930-n',[ ('GraphNode',subsumption)]).
nounMapping2SUMO('06011092-n',[ ('GraphNode',subsumption)]).
nounMapping2SUMO('06011446-n',[ ('GraphPath',subsumption)]).
nounMapping2SUMO('06011589-n',[ ('GraphNode',subsumption)]).
nounMapping2SUMO('06011692-n',[ ('GraphNode',subsumption)]).
nounMapping2SUMO('06011793-n',[ ('GraphNode',subsumption)]).
nounMapping2SUMO('06011903-n',[ ('GraphNode',subsumption)]).
nounMapping2SUMO('06012108-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06012225-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06012340-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06012513-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06012726-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06012998-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06013126-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06013298-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06013471-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06013584-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06013741-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06014043-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06014278-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06014435-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06014730-n',[ ('Function',subsumption)]).
nounMapping2SUMO('06015053-n',[ ('Function',subsumption)]).
nounMapping2SUMO('06015271-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06015505-n',[ ('Function',subsumption)]).
nounMapping2SUMO('06015700-n',[ ('Function',subsumption)]).
nounMapping2SUMO('06015863-n',[ ('Function',subsumption)]).
nounMapping2SUMO('06015978-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06016121-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06016276-n',[ ('Set',subsumption)]).
nounMapping2SUMO('06016462-n',[ ('Set',subsumption)]).
nounMapping2SUMO('06016600-n',[ ('Set',subsumption)]).
nounMapping2SUMO('06016746-n',[ ('Set',subsumption)]).
nounMapping2SUMO('06016853-n',[ ('Set',subsumption)]).
nounMapping2SUMO('06017053-n',[ ('Set',subsumption)]).
nounMapping2SUMO('06017193-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06017334-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06017472-n',[ ('Set',subsumption)]).
nounMapping2SUMO('06017594-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06017895-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06018022-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06018267-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06018465-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06020737-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06021013-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06021247-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06021499-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06021761-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06022076-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06022291-n',[ ('SubtractionFn',subsumption)]).
nounMapping2SUMO('06022509-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06022727-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06023022-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06023243-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('06023369-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06023476-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06023675-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06023821-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06023969-n',[ ('Number',subsumption)]).
nounMapping2SUMO('06024230-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06024431-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06024576-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06024761-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06024936-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06025172-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06025287-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06025521-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06025689-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06025854-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06026088-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06026276-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('06026508-n',[ ('SetOrClass',subsumption)]).
nounMapping2SUMO('06026635-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('06026885-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('06027051-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('06027264-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06027613-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06027843-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06028021-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06028260-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06028566-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('06028904-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('06029118-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('06029306-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('06029547-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('06029676-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06029830-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06030049-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06030196-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06030601-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06030906-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06031248-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06031657-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06031866-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06032066-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06032246-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('06032752-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06032898-n',[ ('PositiveRealNumber',subsumption)]).
nounMapping2SUMO('06033172-n',[ ('NegativeRealNumber',subsumption)]).
nounMapping2SUMO('06033427-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06033692-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06033889-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06034101-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06034301-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06034611-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06034870-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06035014-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06035213-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06035413-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06035674-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06035918-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06036157-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06036506-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06036697-n',[ ('RelationExtendedToQuantities',subsumption)]).
nounMapping2SUMO('06036939-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06037108-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06037298-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06037666-n',[ ('Biology',instance)]).
nounMapping2SUMO('06041466-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06041600-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06041805-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06041955-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06042187-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06042312-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06042486-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06042690-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06042905-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06043075-n',[ ('MedicalScience',instance)]).
nounMapping2SUMO('06045562-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06045847-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06046037-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06046245-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06046383-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06046528-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06046692-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06046898-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06047096-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06047275-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06047430-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06047923-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06048052-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06048184-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06048373-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06048552-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06048851-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06049091-n',[ ('MedicalScience',subsumption)]).
nounMapping2SUMO('06049250-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06049500-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06049673-n',[ ('MedicalScience',subsumption)]).
nounMapping2SUMO('06049850-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06050024-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06050257-n',[ ('MedicalScience',subsumption)]).
nounMapping2SUMO('06050490-n',[ ('MedicalScience',subsumption)]).
nounMapping2SUMO('06050650-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06050901-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06051134-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06051380-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06051542-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06051925-n',[ ('Chemistry',subsumption)]).
nounMapping2SUMO('06052165-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06052300-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06052521-n',[ ('MedicalScience',subsumption)]).
nounMapping2SUMO('06052685-n',[ ('MedicalScience',subsumption)]).
nounMapping2SUMO('06052864-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06053101-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06053280-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06053439-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06053854-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06053982-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06054266-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06054446-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06054700-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06054892-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06055300-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06055529-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06055692-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06055824-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06055946-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06056787-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06056923-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06057172-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06057326-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06057435-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06057539-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06059125-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06059282-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06059412-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06059540-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06059709-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06059865-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06060049-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06060208-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06060336-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06060463-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06060732-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06060845-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06061631-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06061917-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06062076-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06062225-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06062407-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06062655-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06062842-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06063072-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06063275-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06063417-n',[ ('MedicalScience',subsumption)]).
nounMapping2SUMO('06063588-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06064106-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06064345-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06064462-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06064683-n',[ ('MedicalScience',subsumption)]).
nounMapping2SUMO('06064838-n',[ ('MedicalScience',subsumption)]).
nounMapping2SUMO('06065020-n',[ ('MedicalScience',subsumption)]).
nounMapping2SUMO('06065208-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06065423-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06065640-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06065819-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06066072-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06066267-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06066414-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06066555-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06069747-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06069886-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06069996-n',[ ('Biology',subsumption)]).
nounMapping2SUMO('06070179-n',[ ('Freezing',subsumption)]).
nounMapping2SUMO('06070503-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06070738-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06070929-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06071426-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06071722-n',[ ('Biology',subsumption)]).
nounMapping2SUMO('06071934-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06072145-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06072275-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06072476-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06072619-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06072776-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06072912-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06073067-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06073215-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06073331-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06073494-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06073647-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06073748-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06073888-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06074189-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06074372-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06074507-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06074613-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06074728-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06074860-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06075016-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06075112-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06075218-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06075378-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06075527-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06077087-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06077276-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06077413-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06077648-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06077916-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06078088-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06078327-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06078511-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06078724-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06078978-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06079247-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06079439-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06079620-n',[ ('Biochemistry',instance)]).
nounMapping2SUMO('06080192-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06080361-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06080522-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06081602-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06081833-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06082025-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06082136-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06082310-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06082459-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06082610-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06082709-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06082834-n',[ ('Biology',subsumption)]).
nounMapping2SUMO('06082972-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06083243-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06084469-n',[ ('Chemistry',instance)]).
nounMapping2SUMO('06088995-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06089314-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06089447-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06089728-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06089857-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06090064-n',[ ('Chemistry',subsumption)]).
nounMapping2SUMO('06090304-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06090397-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06090540-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06090678-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06090869-n',[ ('Physics',equivalence)]).
nounMapping2SUMO('06094587-n',[ ('Physics',equivalence)]).
nounMapping2SUMO('06094774-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06095022-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06096451-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06096600-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06096759-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06096913-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06097231-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06097478-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06097594-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06097775-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06097983-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06098088-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06098195-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06098687-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06098876-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06099107-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06099269-n',[ ('Electronics',equivalence)]).
nounMapping2SUMO('06100101-n',[ ('Physics',subsumption)]).
nounMapping2SUMO('06100236-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06100555-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06100778-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06101180-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06101333-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06101551-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06101849-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06101973-n',[ ('Physics',subsumption)]).
nounMapping2SUMO('06102116-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('06102316-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06102476-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06102865-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06103270-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06103422-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06103746-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06104073-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06104372-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06104578-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06104844-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06105107-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06105314-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06105609-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06105873-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06106084-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06106305-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06106502-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06106820-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06107083-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06107436-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06107660-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06107850-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06108079-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06108339-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06108487-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06108643-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06108850-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06109227-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06109487-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06109771-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06109972-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06110091-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06110267-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06110426-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06110598-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06110823-n',[ ('Chemistry',subsumption)]).
nounMapping2SUMO('06111003-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06111253-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06111335-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06111479-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06111728-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06111961-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06112223-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06112505-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06112681-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06113009-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06113170-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06113301-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06113415-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06113597-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06113777-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06113914-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06114069-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06114246-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06114351-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06114578-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06114849-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06115004-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06115179-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06115322-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06115476-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06115701-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06117202-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06117395-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06117562-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06117855-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06118146-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06118236-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06118370-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06118563-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06119226-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06119377-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06119496-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06119608-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06119729-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06119904-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06120111-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06120317-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06120496-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06120653-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06120769-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06120881-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06121113-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06121375-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06121554-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06121690-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06121854-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06122033-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06122178-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06122445-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06122578-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06122747-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06122976-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06123126-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06123363-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06124395-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06124532-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06124706-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06124864-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06125041-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06125698-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06125996-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06126177-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06126336-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06126523-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06126761-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06127057-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06127209-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06127460-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06127683-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06127873-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06128024-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06128307-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06128570-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06132724-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('06133018-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06133203-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06133503-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06133654-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06133802-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06133935-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06134075-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06134271-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06134510-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06134716-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06134899-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06135095-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06135335-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06135503-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06135659-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06135806-n',[ ('Science',subsumption)]).
nounMapping2SUMO('06135915-n',[ ('Science',subsumption)]).
nounMapping2SUMO('06136105-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06136258-n',[ ('Psychology',instance)]).
nounMapping2SUMO('06137759-n',[ ('Psychology',subsumption)]).
nounMapping2SUMO('06137918-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06138099-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06138347-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06138582-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06138789-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06138941-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06139135-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06139285-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06139491-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06139764-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06140054-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06140268-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06140437-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06140587-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06140799-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06141023-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06141197-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06141324-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06141561-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06141768-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06141962-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06142118-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06142412-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06142598-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06142861-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06143154-n',[ ('SocialScience',instance)]).
nounMapping2SUMO('06143454-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06143546-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06144081-n',[ ('Archaeology',equivalence)]).
nounMapping2SUMO('06144762-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06144855-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06144970-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06145062-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06145158-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06145326-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06145446-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06145586-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06145729-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06145897-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06146053-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06146142-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06146260-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06146407-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06146546-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06146760-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06146880-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06147141-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06147308-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06147522-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06147770-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06147873-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06148002-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06148148-n',[ ('PoliticalScience',instance)]).
nounMapping2SUMO('06148748-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06148915-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06149038-n',[ ('PoliticalScience',subsumption)]).
nounMapping2SUMO('06149192-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06149344-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06149484-n',[ ('Economics',instance)]).
nounMapping2SUMO('06150222-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06150449-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06150633-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06150933-n',[ ('Economics',subsumption)]).
nounMapping2SUMO('06151108-n',[ ('Economics',subsumption)]).
nounMapping2SUMO('06151282-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06151550-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06151693-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06151942-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06152125-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06152311-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06152460-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06152631-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06152734-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06152821-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06152973-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06153186-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06153402-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06153698-n',[ ('Science',subsumption)]).
nounMapping2SUMO('06153846-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06154464-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('06154724-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06155075-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06155432-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06155567-n',[ ('History',equivalence)]).
nounMapping2SUMO('06155891-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06156015-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06156169-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06156346-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06156521-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06156752-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06156968-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06157326-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06158057-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06158185-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06158346-n',[ ('Philosophy',instance)]).
nounMapping2SUMO('06159473-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06159777-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06159924-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06160055-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06160244-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06160418-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06160596-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06160781-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06161048-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06161223-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06161606-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06161718-n',[ ('FieldOfLaw',instance)]).
nounMapping2SUMO('06162042-n',[ ('FieldOfLaw',subsumption)]).
nounMapping2SUMO('06162223-n',[ ('FieldOfLaw',subsumption)]).
nounMapping2SUMO('06162377-n',[ ('FieldOfLaw',subsumption)]).
nounMapping2SUMO('06162528-n',[ ('FieldOfLaw',subsumption)]).
nounMapping2SUMO('06162653-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06162847-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06162979-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06163223-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06163396-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06163548-n',[ ('Arguing',subsumption)]).
nounMapping2SUMO('06163751-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06164665-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06165000-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06165147-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06165364-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06165623-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('06165823-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06166046-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06166166-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06166274-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06166394-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06166494-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06166644-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06166748-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06166898-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06167106-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06167328-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06168152-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06168334-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06168552-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06168703-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06168855-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06169050-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06169285-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06169488-n',[ ('Literature',instance)]).
nounMapping2SUMO('06169667-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06169806-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06169932-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06170025-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06170371-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06170498-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06170892-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06171040-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06171265-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06171388-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06171524-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06171650-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06172071-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06172294-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06172502-n',[ ('Science',subsumption)]).
nounMapping2SUMO('06172789-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06174404-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06175829-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06175967-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06176107-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('06176322-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06176519-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06176837-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06177033-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06177450-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06177729-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('06177923-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06178042-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06178238-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06178380-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06178510-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06178660-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06178812-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06178995-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06179145-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06179290-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06179492-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06179574-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06179792-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06179985-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('06180282-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06180412-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06180548-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06180720-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06180890-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06181034-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06181123-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06181284-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06181448-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06181584-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06181893-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06182144-n',[ ('Theology',equivalence)]).
nounMapping2SUMO('06182757-n',[ ('Theology',subsumption)]).
nounMapping2SUMO('06182866-n',[ ('Theology',subsumption)]).
nounMapping2SUMO('06183004-n',[ ('Theology',subsumption)]).
nounMapping2SUMO('06183162-n',[ ('Theology',subsumption)]).
nounMapping2SUMO('06183398-n',[ ('Theology',subsumption)]).
nounMapping2SUMO('06183518-n',[ ('Theology',subsumption)]).
nounMapping2SUMO('06183652-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06183745-n',[ ('Theology',subsumption)]).
nounMapping2SUMO('06183899-n',[ ('Theology',subsumption)]).
nounMapping2SUMO('06184270-n',[ ('Theology',subsumption)]).
nounMapping2SUMO('06184574-n',[ ('Theology',subsumption)]).
nounMapping2SUMO('06184733-n',[ ('Theology',subsumption)]).
nounMapping2SUMO('06184963-n',[ ('Theology',subsumption)]).
nounMapping2SUMO('06185138-n',[ ('Theology',subsumption)]).
nounMapping2SUMO('06185302-n',[ ('Theology',subsumption)]).
nounMapping2SUMO('06185458-n',[ ('Theology',subsumption)]).
nounMapping2SUMO('06185581-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06185748-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06185955-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06186166-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06186301-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06187013-n',[ ('Proposition',instance)]).
nounMapping2SUMO('06187154-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06187350-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06187529-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06187756-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06187960-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06188146-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06188292-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06188603-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06188721-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06188889-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06188989-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06189241-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06189341-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06189551-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06189776-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06190060-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06190305-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06190554-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06190809-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06191018-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06191212-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06191483-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06191687-n',[ ('Theology',subsumption)]).
nounMapping2SUMO('06191854-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06192027-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06192186-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06192411-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06192665-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06192789-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06192908-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06193203-n',[ ('PropositionalAttitude',subsumption)]).
nounMapping2SUMO('06193727-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06194030-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06194216-n',[ ('PropositionalAttitude',subsumption)]).
nounMapping2SUMO('06194409-n',[ ('PropositionalAttitude',subsumption)]).
nounMapping2SUMO('06194736-n',[ ('PropositionalAttitude',subsumption)]).
nounMapping2SUMO('06194894-n',[ ('PropositionalAttitude',subsumption)]).
nounMapping2SUMO('06195096-n',[ ('PropositionalAttitude',subsumption)]).
nounMapping2SUMO('06195249-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06195418-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06195555-n',[ ('PropositionalAttitude',subsumption)]).
nounMapping2SUMO('06195698-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06195839-n',[ ('TraitAttribute',equivalence)]).
nounMapping2SUMO('06196071-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06196284-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06196442-n',[ ('PropositionalAttitude',subsumption)]).
nounMapping2SUMO('06196584-n',[ ('TraitAttribute',equivalence)]).
nounMapping2SUMO('06197215-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06197503-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06197664-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06197958-n',[ ('Process',subsumption)]).
nounMapping2SUMO('06198083-n',[ ('Process',subsumption)]).
nounMapping2SUMO('06198313-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06198505-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06198708-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('06198876-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06199142-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06199446-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06199561-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06199702-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06199893-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('06200010-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('06200178-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06200344-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06200617-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06200741-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06200929-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06201042-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06201136-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06201476-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('06201667-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('06201778-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06201908-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06202296-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06202429-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06202553-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06202686-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06202907-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06203030-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06203222-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06203472-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06203603-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06203758-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06203956-n',[ ('Antisemitism',equivalence)]).
nounMapping2SUMO('06204126-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06204289-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06204406-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06204623-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06204820-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06205018-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06205154-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06205411-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('06205698-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06205827-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06205937-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06206021-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06206210-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06206334-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06206470-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06206576-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06206800-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06207029-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06207199-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06207437-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06207561-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06207733-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06207874-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06208021-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06208265-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06208409-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06208614-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06208751-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06209101-n',[ ('PropositionalAttitude',subsumption)]).
nounMapping2SUMO('06209242-n',[ ('PropositionalAttitude',subsumption)]).
nounMapping2SUMO('06209419-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06209770-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06209940-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06210171-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06210363-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('06210791-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06210964-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06211078-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06211206-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06211389-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06211529-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06211702-n',[ ('PropositionalAttitude',subsumption)]).
nounMapping2SUMO('06211811-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06211963-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06212155-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06212302-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06212422-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06212650-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06212839-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06213688-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06213890-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06214020-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06214164-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06214379-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06214580-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06214744-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06215043-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('06215152-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06215495-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('06215618-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06215977-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06216160-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06216408-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06216634-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06216805-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06216948-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06217103-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06217318-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06217464-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06217657-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06217806-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06217944-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06218162-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06218308-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06218459-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06218623-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06218824-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06219009-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06219185-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06219300-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06219415-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06219613-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06219711-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06219875-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06220041-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06220199-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06220299-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06220449-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06220616-n',[ ('SocialistEconomy',equivalence)]).
nounMapping2SUMO('06220819-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06220955-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06221119-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06221224-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06221323-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06221485-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06221659-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06221790-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06221974-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06222236-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06222336-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('06222508-n',[ ('Agnosticism',equivalence)]).
nounMapping2SUMO('06222731-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06222959-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06223204-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06223468-n',[ ('Atheism',equivalence)]).
nounMapping2SUMO('06223669-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06223922-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06224136-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('06224305-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('06224439-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('06224657-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('06224831-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('06224975-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('06225235-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('06225357-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('06225505-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('06225667-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('06225855-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('06226057-n',[ ('Christianity',equivalence)]).
nounMapping2SUMO('06226934-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('06227121-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('06227263-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('06227453-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('06227562-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('06227708-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('06228086-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('06228346-n',[ ('EasternOrthodoxChristianity',equivalence)]).
nounMapping2SUMO('06228549-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('06229106-n',[ ('Anglicanism',equivalence)]).
nounMapping2SUMO('06229240-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('06229410-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06229586-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06229853-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('06230060-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06230208-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('06230358-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06230502-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06230613-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06230809-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06231030-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06231191-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06231328-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06231494-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06231680-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06231794-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('06232047-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('06232166-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06232298-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('06232499-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('06232635-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('06232880-n',[ ('Judaism',equivalence)]).
nounMapping2SUMO('06234104-n',[ ('Judaism',subsumption)]).
nounMapping2SUMO('06234257-n',[ ('Judaism',subsumption)]).
nounMapping2SUMO('06234415-n',[ ('Judaism',subsumption)]).
nounMapping2SUMO('06234619-n',[ ('Judaism',subsumption)]).
nounMapping2SUMO('06234728-n',[ ('Judaism',subsumption)]).
nounMapping2SUMO('06234825-n',[ ('Islam',equivalence)]).
nounMapping2SUMO('06235829-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06235977-n',[ ('Islam',subsumption)]).
nounMapping2SUMO('06236309-n',[ ('Islam',subsumption)]).
nounMapping2SUMO('06236492-n',[ ('ShiiteSect',subsumption)]).
nounMapping2SUMO('06236602-n',[ ('Islam',subsumption)]).
nounMapping2SUMO('06236802-n',[ ('Hinduism',equivalence)]).
nounMapping2SUMO('06237865-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06238036-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06238265-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06238574-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06238831-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06238931-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06239076-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06239215-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06239361-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06239655-n',[ ('Jainism',equivalence)]).
nounMapping2SUMO('06239931-n',[ ('Sikhism',equivalence)]).
nounMapping2SUMO('06240244-n',[ ('Buddhism',equivalence)]).
nounMapping2SUMO('06240865-n',[ ('Buddhism',subsumption)]).
nounMapping2SUMO('06241156-n',[ ('Buddhism',subsumption)]).
nounMapping2SUMO('06241576-n',[ ('Buddhism',subsumption)]).
nounMapping2SUMO('06241825-n',[ ('Buddhism',subsumption)]).
nounMapping2SUMO('06242048-n',[ ('Buddhism',subsumption)]).
nounMapping2SUMO('06242237-n',[ ('Buddhism',subsumption)]).
nounMapping2SUMO('06242427-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06242780-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06242970-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06243096-n',[ ('Taoism',equivalence)]).
nounMapping2SUMO('06243347-n',[ ('Shinto',equivalence)]).
nounMapping2SUMO('06243575-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06243963-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06244149-n',[ ('Zoroastrianism',equivalence)]).
nounMapping2SUMO('06244445-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06244552-n',[ ('Bahaism',equivalence)]).
nounMapping2SUMO('06244852-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06245084-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06245286-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06245462-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06245674-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06245816-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06246076-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06246241-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06246361-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06246529-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06246700-n',[ ('Imagining',subsumption)]).
nounMapping2SUMO('06246896-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('06247181-n',[ ('PropositionalAttitude',subsumption)]).
nounMapping2SUMO('06247484-n',[ ('PropositionalAttitude',subsumption)]).
nounMapping2SUMO('06247701-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06247867-n',[ ('PropositionalAttitude',subsumption)]).
nounMapping2SUMO('06248043-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06248214-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06248361-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06248530-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06248693-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06248863-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06248968-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06249177-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06249421-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06249685-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06249910-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06250061-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06250208-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06250444-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06250597-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06250771-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06251033-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06251295-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06251424-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06251553-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06251781-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06252138-n',[ ('Communication',equivalence)]).
nounMapping2SUMO('06252743-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06252954-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06253140-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06253371-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06253518-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06253690-n',[ ('Text',equivalence)]).
nounMapping2SUMO('06254007-n',[ ('Broadcasting',subsumption)]).
nounMapping2SUMO('06254239-n',[ ('Encoding',subsumption)]).
nounMapping2SUMO('06254371-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06254475-n',[ ('Device',subsumption)]).
nounMapping2SUMO('06254669-n',[ ('Device',subsumption)]).
nounMapping2SUMO('06254915-n',[ ('Device',subsumption)]).
nounMapping2SUMO('06255081-n',[ ('Device',subsumption)]).
nounMapping2SUMO('06255354-n',[ ('ElectronicSignalling',subsumption)]).
nounMapping2SUMO('06255613-n',[ ('Paper',subsumption)]).
nounMapping2SUMO('06255777-n',[ ('Paper',subsumption)]).
nounMapping2SUMO('06256041-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06256229-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06256494-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06256591-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06256697-n',[ ('Page',equivalence)]).
nounMapping2SUMO('06257141-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06257250-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06257372-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06257484-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06257569-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06257653-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06257772-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06257909-n',[ ('Page',subsumption)]).
nounMapping2SUMO('06258031-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06258228-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06258361-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06258541-n',[ ('Page',subsumption)]).
nounMapping2SUMO('06258680-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('06258852-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06259027-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06259166-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06259297-n',[ ('Paper',subsumption)]).
nounMapping2SUMO('06259487-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('06259584-n',[ ('Paper',subsumption)]).
nounMapping2SUMO('06259736-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06259898-n',[ ('ElectronicSignalling',subsumption)]).
nounMapping2SUMO('06260121-n',[ ('ElectronicSignalling',subsumption)]).
nounMapping2SUMO('06260518-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('06260628-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('06260817-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06261060-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06261260-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06261464-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06261586-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06261744-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06261922-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06262176-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06262567-n',[ ('MotionPicture',equivalence)]).
nounMapping2SUMO('06262943-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('06263020-n',[ ('NewsReporter',subsumption)]).
nounMapping2SUMO('06263202-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06263369-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06263609-n',[ ('Newspaper',subsumption)]).
nounMapping2SUMO('06263762-n',[ ('Device',subsumption)]).
nounMapping2SUMO('06263895-n',[ ('ComputerComponent',subsumption)]).
nounMapping2SUMO('06264176-n',[ ('RadioBroadcasting',subsumption)]).
nounMapping2SUMO('06264398-n',[ ('Mailing',subsumption)]).
nounMapping2SUMO('06264812-n',[ ('Mailing',subsumption)]).
nounMapping2SUMO('06264932-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06265142-n',[ ('DeliveryService',subsumption)]).
nounMapping2SUMO('06265272-n',[ ('Mailing',subsumption)]).
nounMapping2SUMO('06265475-n',[ ('Mailing',subsumption)]).
nounMapping2SUMO('06265636-n',[ ('Mailing',subsumption)]).
nounMapping2SUMO('06265815-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('06265983-n',[ ('Mailing',subsumption)]).
nounMapping2SUMO('06266077-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06266296-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('06266417-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('06266633-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('06266710-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06266878-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06266973-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06267145-n',[ ('Newspaper',equivalence)]).
nounMapping2SUMO('06267564-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06267655-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06267758-n',[ ('Newspaper',subsumption)]).
nounMapping2SUMO('06267893-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06267991-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06268096-n',[ ('Report',equivalence)]).
nounMapping2SUMO('06268357-n',[ ('Newspaper',subsumption)]).
nounMapping2SUMO('06268567-n',[ ('Article',subsumption)]).
nounMapping2SUMO('06268784-n',[ ('Article',subsumption)]).
nounMapping2SUMO('06269014-n',[ ('Article',subsumption)]).
nounMapping2SUMO('06269130-n',[ ('Article',subsumption)]).
nounMapping2SUMO('06269396-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06269674-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06269785-n',[ ('Article',subsumption)]).
nounMapping2SUMO('06269956-n',[ ('Article',subsumption)]).
nounMapping2SUMO('06270129-n',[ ('Report',subsumption)]).
nounMapping2SUMO('06270308-n',[ ('EditionFn',subsumption)]).
nounMapping2SUMO('06270541-n',[ ('EditionFn',subsumption)]).
nounMapping2SUMO('06270690-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06270879-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06271055-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06271192-n',[ ('Article',subsumption)]).
nounMapping2SUMO('06271288-n',[ ('Article',subsumption)]).
nounMapping2SUMO('06271403-n',[ ('Article',subsumption)]).
nounMapping2SUMO('06271514-n',[ ('Article',subsumption)]).
nounMapping2SUMO('06271620-n',[ ('Device',subsumption)]).
nounMapping2SUMO('06271778-n',[ ('Device',subsumption)]).
nounMapping2SUMO('06272290-n',[ ('Device',subsumption)]).
nounMapping2SUMO('06272612-n',[ ('VoiceMail',equivalence)]).
nounMapping2SUMO('06272803-n',[ ('TelephoneCommunication',equivalence)]).
nounMapping2SUMO('06273207-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06273294-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06273414-n',[ ('Device',subsumption)]).
nounMapping2SUMO('06273555-n',[ ('Telephoning',subsumption)]).
nounMapping2SUMO('06273743-n',[ ('Device',subsumption)]).
nounMapping2SUMO('06273890-n',[ ('TelephoneCommunication',subsumption)]).
nounMapping2SUMO('06273986-n',[ ('TelephoneCommunication',subsumption)]).
nounMapping2SUMO('06274092-n',[ ('TelephoneCommunication',subsumption)]).
nounMapping2SUMO('06274292-n',[ ('TelephoneCommunication',subsumption)]).
nounMapping2SUMO('06274408-n',[ ('TelephoneCommunication',subsumption)]).
nounMapping2SUMO('06274546-n',[ ('WakeUpService',equivalence)]).
nounMapping2SUMO('06274760-n',[ ('TelephoneCommunication',equivalence)]).
nounMapping2SUMO('06274921-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06275095-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06275219-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06275353-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06275471-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06275634-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06275977-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06276141-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06276287-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06276401-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06276501-n',[ ('Device',subsumption)]).
nounMapping2SUMO('06276697-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06276902-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06277025-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06277135-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06277280-n',[ ('TelevisionBroadcasting',subsumption)]).
nounMapping2SUMO('06277803-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06277992-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06278136-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06278338-n',[ ('CableTelevisionSystem',equivalence)]).
nounMapping2SUMO('06278475-n',[ ('TelevisionBroadcasting',subsumption)]).
nounMapping2SUMO('06278662-n',[ ('ArtifactMediatedCommunication',subsumption)]).
nounMapping2SUMO('06278830-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06279071-n',[ ('Device',subsumption)]).
nounMapping2SUMO('06279326-n',[ ('Device',subsumption)]).
nounMapping2SUMO('06279805-n',[ ('Device',subsumption)]).
nounMapping2SUMO('06279939-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06280162-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06280244-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06280347-n',[ ('Device',subsumption)]).
nounMapping2SUMO('06280477-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06280604-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06280816-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06281040-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06281175-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06281295-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06281594-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06281721-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06281848-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('06281959-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06282093-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06282209-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06282383-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06282651-n',[ ('Language',equivalence)]).
nounMapping2SUMO('06283459-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06283647-n',[ ('Language',subsumption)]).
nounMapping2SUMO('06283764-n',[ ('Language',subsumption)]).
nounMapping2SUMO('06283912-n',[ ('Language',subsumption)]).
nounMapping2SUMO('06284067-n',[ ('Language',subsumption)]).
nounMapping2SUMO('06284225-n',[ ('LinguisticExpression',equivalence)]).
nounMapping2SUMO('06284573-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06284777-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06284898-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06285090-n',[ ('Sentence',equivalence)]).
nounMapping2SUMO('06285435-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('06285559-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('06285789-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('06285940-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('06286100-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('06286230-n',[ ('Function',subsumption)]).
nounMapping2SUMO('06286395-n',[ ('Word',equivalence)]).
nounMapping2SUMO('06287620-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06287859-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06288024-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06288350-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06288527-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06288947-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06289074-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06289250-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06289472-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06289693-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06290051-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06290246-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06290401-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06290539-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06290637-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06291122-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06291318-n',[ ('ParticleWord',subsumption)]).
nounMapping2SUMO('06291603-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06291809-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06292000-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06292154-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06292290-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06292478-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06292649-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06292836-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06292973-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06293106-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06293229-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06293460-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06293655-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06293746-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06293898-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06294147-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06294309-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06294441-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06294584-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06294716-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06294828-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06294941-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06295113-n',[ ('SymbolicString',subsumption)]).
nounMapping2SUMO('06295235-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06299916-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06300058-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06300193-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06300445-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06300632-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06300823-n',[ ('Article',subsumption)]).
nounMapping2SUMO('06301012-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06301302-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06301445-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06301672-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06301792-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06301953-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06302083-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06302269-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06302381-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06302542-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06302755-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06302967-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06303150-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06303315-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06303540-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06303682-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06303888-n',[ ('NounPhrase',equivalence)]).
nounMapping2SUMO('06304059-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06304338-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06304425-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06304576-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06304671-n',[ ('Syllable',equivalence)]).
nounMapping2SUMO('06305029-n',[ ('Syllable',subsumption)]).
nounMapping2SUMO('06305109-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06305223-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06305385-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06305474-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06305610-n',[ ('Syllable',subsumption)]).
nounMapping2SUMO('06305716-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06305838-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06306034-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06306233-n',[ ('Morpheme',equivalence)]).
nounMapping2SUMO('06306480-n',[ ('Morpheme',equivalence)]).
nounMapping2SUMO('06306606-n',[ ('Morpheme',subsumption)]).
nounMapping2SUMO('06306842-n',[ ('Morpheme',subsumption)]).
nounMapping2SUMO('06306945-n',[ ('Morpheme',subsumption)]).
nounMapping2SUMO('06307152-n',[ ('Morpheme',subsumption)]).
nounMapping2SUMO('06308049-n',[ ('Morpheme',subsumption)]).
nounMapping2SUMO('06308304-n',[ ('Morpheme',subsumption)]).
nounMapping2SUMO('06308436-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06308674-n',[ ('Morpheme',subsumption)]).
nounMapping2SUMO('06308765-n',[ ('Morpheme',subsumption)]).
nounMapping2SUMO('06308987-n',[ ('Morpheme',subsumption)]).
nounMapping2SUMO('06309131-n',[ ('Morpheme',subsumption)]).
nounMapping2SUMO('06309272-n',[ ('Morpheme',subsumption)]).
nounMapping2SUMO('06309383-n',[ ('Phrase',equivalence)]).
nounMapping2SUMO('06309684-n',[ ('Class',subsumption)]).
nounMapping2SUMO('06309931-n',[ ('NounPhrase',subsumption)]).
nounMapping2SUMO('06310125-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06310237-n',[ ('NounPhrase',subsumption)]).
nounMapping2SUMO('06310449-n',[ ('NounPhrase',subsumption)]).
nounMapping2SUMO('06310578-n',[ ('NounPhrase',subsumption)]).
nounMapping2SUMO('06310713-n',[ ('NounPhrase',subsumption)]).
nounMapping2SUMO('06310848-n',[ ('NounPhrase',subsumption)]).
nounMapping2SUMO('06310945-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06311160-n',[ ('NounPhrase',subsumption)]).
nounMapping2SUMO('06311334-n',[ ('NounPhrase',subsumption)]).
nounMapping2SUMO('06311557-n',[ ('NounPhrase',subsumption)]).
nounMapping2SUMO('06311723-n',[ ('NounPhrase',subsumption)]).
nounMapping2SUMO('06311852-n',[ ('NounPhrase',subsumption)]).
nounMapping2SUMO('06312001-n',[ ('NounPhrase',subsumption)]).
nounMapping2SUMO('06312237-n',[ ('NounPhrase',subsumption)]).
nounMapping2SUMO('06312418-n',[ ('NounPhrase',subsumption)]).
nounMapping2SUMO('06312612-n',[ ('NounPhrase',subsumption)]).
nounMapping2SUMO('06312767-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06312966-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06313300-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06313457-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06313651-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06314036-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06314144-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06314423-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06314595-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06314808-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06315096-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06315301-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06315454-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06315638-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06315755-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06315873-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06316048-n',[ ('Phrase',equivalence)]).
nounMapping2SUMO('06316376-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06316480-n',[ ('NounPhrase',equivalence)]).
nounMapping2SUMO('06316626-n',[ ('VerbPhrase',equivalence)]).
nounMapping2SUMO('06316813-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06317107-n',[ ('VerbPhrase',subsumption)]).
nounMapping2SUMO('06317247-n',[ ('PrepositionalPhrase',equivalence)]).
nounMapping2SUMO('06317351-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06317464-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06317672-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06317862-n',[ ('Noun',equivalence)]).
nounMapping2SUMO('06318062-n',[ ('Verb',equivalence)]).
nounMapping2SUMO('06318352-n',[ ('Noun',subsumption)]).
nounMapping2SUMO('06318513-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06318722-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06318904-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06319029-n',[ ('Adjective',equivalence)]).
nounMapping2SUMO('06319157-n',[ ('Adverb',equivalence)]).
nounMapping2SUMO('06319293-n',[ ('Noun',equivalence)]).
nounMapping2SUMO('06319575-n',[ ('Noun',subsumption)]).
nounMapping2SUMO('06319710-n',[ ('Noun',subsumption)]).
nounMapping2SUMO('06319799-n',[ ('Noun',subsumption)]).
nounMapping2SUMO('06319881-n',[ ('Noun',subsumption)]).
nounMapping2SUMO('06320004-n',[ ('Noun',subsumption)]).
nounMapping2SUMO('06320153-n',[ ('Noun',subsumption)]).
nounMapping2SUMO('06320314-n',[ ('Noun',subsumption)]).
nounMapping2SUMO('06320440-n',[ ('Noun',subsumption)]).
nounMapping2SUMO('06320569-n',[ ('Verb',equivalence)]).
nounMapping2SUMO('06320801-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06321054-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06321702-n',[ ('Adjective',equivalence)]).
nounMapping2SUMO('06321932-n',[ ('Adjective',subsumption)]).
nounMapping2SUMO('06322157-n',[ ('Adjective',subsumption)]).
nounMapping2SUMO('06322357-n',[ ('Adjective',subsumption)]).
nounMapping2SUMO('06322468-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06322693-n',[ ('Adjective',subsumption)]).
nounMapping2SUMO('06323284-n',[ ('Adjective',subsumption)]).
nounMapping2SUMO('06323612-n',[ ('Adverb',equivalence)]).
nounMapping2SUMO('06323822-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06324086-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06324355-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06324475-n',[ ('ParticleWord',subsumption)]).
nounMapping2SUMO('06324669-n',[ ('ParticleWord',subsumption)]).
nounMapping2SUMO('06324864-n',[ ('ParticleWord',subsumption)]).
nounMapping2SUMO('06325001-n',[ ('ParticleWord',subsumption)]).
nounMapping2SUMO('06325145-n',[ ('ParticleWord',subsumption)]).
nounMapping2SUMO('06325370-n',[ ('ParticleWord',subsumption)]).
nounMapping2SUMO('06325576-n',[ ('ParticleWord',subsumption)]).
nounMapping2SUMO('06325678-n',[ ('ParticleWord',subsumption)]).
nounMapping2SUMO('06325826-n',[ ('ParticleWord',subsumption)]).
nounMapping2SUMO('06326054-n',[ ('ParticleWord',subsumption)]).
nounMapping2SUMO('06326226-n',[ ('ParticleWord',subsumption)]).
nounMapping2SUMO('06326406-n',[ ('ParticleWord',equivalence)]).
nounMapping2SUMO('06326526-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06326797-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06327136-n',[ ('ParticleWord',subsumption)]).
nounMapping2SUMO('06327261-n',[ ('ParticleWord',subsumption)]).
nounMapping2SUMO('06327551-n',[ ('ParticleWord',subsumption)]).
nounMapping2SUMO('06327718-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06327870-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06328022-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06328207-n',[ ('ParticleWord',subsumption)]).
nounMapping2SUMO('06328386-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06328643-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06328996-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06329165-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06329313-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06329506-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06329734-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06329909-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06330037-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06330262-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06330401-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06330528-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06330764-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06331014-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06331154-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06331281-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06331477-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06331641-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06331803-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06332136-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06332364-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06332545-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06332731-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06332919-n',[ ('NounPhrase',subsumption)]).
nounMapping2SUMO('06333095-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06333285-n',[ ('NounPhrase',subsumption)]).
nounMapping2SUMO('06333478-n',[ ('NounPhrase',subsumption)]).
nounMapping2SUMO('06333653-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06334377-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06334512-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06334778-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06334985-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06335162-n',[ ('Label',subsumption)]).
nounMapping2SUMO('06335532-n',[ ('Label',subsumption)]).
nounMapping2SUMO('06335832-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06336149-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06336285-n',[ ('Label',subsumption)]).
nounMapping2SUMO('06336363-n',[ ('Label',subsumption)]).
nounMapping2SUMO('06336537-n',[ ('Label',subsumption)]).
nounMapping2SUMO('06336723-n',[ ('Label',subsumption)]).
nounMapping2SUMO('06336904-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06337111-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06337202-n',[ ('Label',subsumption)]).
nounMapping2SUMO('06337307-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06337458-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06337594-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06337693-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06338003-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06338158-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06338278-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06338485-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06338571-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06338653-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06338744-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06338908-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06339244-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06339416-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06340047-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06340182-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06340395-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('06340563-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('06340707-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('06340838-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('06340977-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('06341127-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('06341249-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('06341340-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('06341431-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('06341525-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('06341609-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('06341773-n',[ ('Word',instance)]).
nounMapping2SUMO('06341862-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('06342015-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('06342182-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('06342362-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('06342490-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('06342623-n',[ ('Word',instance)]).
nounMapping2SUMO('06342781-n',[ ('Word',instance)]).
nounMapping2SUMO('06342977-n',[ ('Word',instance)]).
nounMapping2SUMO('06343117-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06343364-n',[ ('Word',instance)]).
nounMapping2SUMO('06343440-n',[ ('Word',instance)]).
nounMapping2SUMO('06343520-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06343838-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06343971-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06344329-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06344461-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06344691-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06344846-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06344998-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06345131-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06345320-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06345441-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06345566-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06345773-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06345878-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06345993-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06346220-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06346461-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06346681-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06346891-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06347037-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06347122-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06347225-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06347388-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06347588-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06347811-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06347996-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06348215-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06348373-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06348500-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06348685-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06348885-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06349030-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06349220-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06349597-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06349828-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06349952-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06350127-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06350274-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06350592-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06350777-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06350918-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06351086-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06351202-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06351613-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06351888-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06352117-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06352301-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06352446-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06352618-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06352782-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06352954-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06353089-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06353225-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06353445-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('06353653-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('06353757-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06353934-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06354204-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('06354481-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06354626-n',[ ('Number',subsumption)]).
nounMapping2SUMO('06354774-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06355078-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06355183-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06355307-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06355459-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06355705-n',[ ('Number',subsumption)]).
nounMapping2SUMO('06355894-n',[ ('ComputerProgram',equivalence)]).
nounMapping2SUMO('06356299-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06356515-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06356755-n',[ ('Number',subsumption)]).
nounMapping2SUMO('06357078-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06357304-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06357424-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06357632-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06357814-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06357985-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06358159-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06358311-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06358513-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06358747-n',[ ('URL',equivalence)]).
nounMapping2SUMO('06358900-n',[ ('WebPage',equivalence)]).
nounMapping2SUMO('06359096-n',[ ('WebPage',subsumption)]).
nounMapping2SUMO('06359193-n',[ ('WebSite',equivalence)]).
nounMapping2SUMO('06359467-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06359657-n',[ ('WebSite',subsumption)]).
nounMapping2SUMO('06359877-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06360314-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06360599-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06360723-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06360850-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06360996-n',[ ('Word',instance)]).
nounMapping2SUMO('06361218-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06361314-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06361446-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06361635-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06361770-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06361934-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06362059-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06362172-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06362260-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06362441-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06362628-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06362792-n',[ ('Braille',subsumption)]).
nounMapping2SUMO('06362953-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06363778-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06364004-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06364149-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06364329-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06364641-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('06365102-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06365357-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06365467-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06365808-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06366002-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06366130-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06366269-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06366391-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06366581-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06366879-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06367107-n',[ ('FictionalText',equivalence)]).
nounMapping2SUMO('06367373-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06367571-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('06367702-n',[ ('FictionalText',subsumption)]).
nounMapping2SUMO('06367879-n',[ ('Novel',equivalence)]).
nounMapping2SUMO('06368142-n',[ ('Novel',subsumption)]).
nounMapping2SUMO('06368321-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06368425-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06368628-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06368814-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06368962-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06369077-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06369216-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06369405-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06369554-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06369690-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06369829-n',[ ('FictionalText',equivalence)]).
nounMapping2SUMO('06370178-n',[ ('FictionalText',subsumption)]).
nounMapping2SUMO('06370268-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06370403-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06370522-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06370792-n',[ ('MysteryStory',subsumption)]).
nounMapping2SUMO('06370985-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06371145-n',[ ('MysteryStory',subsumption)]).
nounMapping2SUMO('06371267-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06371413-n',[ ('FictionalText',equivalence)]).
nounMapping2SUMO('06371734-n',[ ('FictionalText',subsumption)]).
nounMapping2SUMO('06371999-n',[ ('ShortStory',subsumption)]).
nounMapping2SUMO('06372095-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06372428-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06372572-n',[ ('Text',instance)]).
nounMapping2SUMO('06372680-n',[ ('NarrativeText',equivalence)]).
nounMapping2SUMO('06372925-n',[ ('Text',instance)]).
nounMapping2SUMO('06373090-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06373314-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06373513-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06373645-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06373747-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06373991-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06374148-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06374241-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06374408-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06374587-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06374834-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06375008-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06375215-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06375329-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06375471-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06375624-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06376014-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('06376154-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06376572-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06376776-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06376860-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06377000-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06377133-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06377275-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06377442-n',[ ('FictionalText',subsumption)]).
nounMapping2SUMO('06377971-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06378104-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06378298-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06378427-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06378524-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06378627-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06378917-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06379094-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('06379253-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06379439-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06379568-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06379721-n',[ ('NarrativeText',subsumption)]).
nounMapping2SUMO('06380055-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06380256-n',[ ('NarrativeText',instance)]).
nounMapping2SUMO('06380373-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06380495-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06380603-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06380726-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06380879-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06381134-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06381274-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06381372-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06381594-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06381761-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06381869-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06382072-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06382193-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06382345-n',[ ('NarrativeText',instance)]).
nounMapping2SUMO('06382506-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06382590-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06382716-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06382923-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06383016-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06383107-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06383334-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06383523-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06383659-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06383819-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06383934-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06384034-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06384165-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06384269-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06384371-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06384480-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06384593-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06384708-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06384995-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06385080-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06385244-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06385434-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06385582-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06385728-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06385842-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06385997-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06386156-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06386345-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06386440-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06386693-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06386832-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06387053-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06387204-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06387332-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06387538-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06387727-n',[ ('DigitalFile',subsumption)]).
nounMapping2SUMO('06387864-n',[ ('DigitalFile',subsumption)]).
nounMapping2SUMO('06387980-n',[ ('Text',equivalence)]).
nounMapping2SUMO('06388579-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06388777-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06388918-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06389109-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06389230-n',[ ('AreaMeasure',subsumption)]).
nounMapping2SUMO('06389398-n',[ ('Region',subsumption)]).
nounMapping2SUMO('06389553-n',[ ('Region',subsumption)]).
nounMapping2SUMO('06389753-n',[ ('Region',subsumption)]).
nounMapping2SUMO('06389947-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('06390051-n',[ ('DigitalData',subsumption)]).
nounMapping2SUMO('06390227-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06390423-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06390512-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06390688-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06390805-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06390962-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06391171-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06391347-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06391566-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06391766-n',[ ('SeriesVolumeFn',subsumption)]).
nounMapping2SUMO('06391902-n',[ ('SeriesVolumeFn',subsumption)]).
nounMapping2SUMO('06392001-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06392660-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06392787-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06392935-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06393253-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06393424-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06393620-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06393800-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06394051-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06394282-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06394564-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06394701-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06394865-n',[ ('Chapter',equivalence)]).
nounMapping2SUMO('06396142-n',[ ('Chapter',equivalence)]).
nounMapping2SUMO('06396330-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06396468-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06396644-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06396812-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06396930-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06397171-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06397307-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06397476-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06397645-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06397789-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06397903-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06398090-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06398270-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06398401-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06398760-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('06398963-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('06399126-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06399337-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06399503-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06399631-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06399870-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06399995-n',[ ('Paragraph',subsumption)]).
nounMapping2SUMO('06400271-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06400510-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06400849-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06401004-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06401107-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06401222-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06401328-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06401526-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06401787-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06402031-n',[ ('Report',subsumption)]).
nounMapping2SUMO('06402202-n',[ ('Report',subsumption)]).
nounMapping2SUMO('06402425-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06402565-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06402770-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06402871-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06402970-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06403107-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06403291-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06403393-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06403679-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06403852-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06403969-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06404147-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06404322-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06404416-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06404582-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06404806-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06404907-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06405020-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06405198-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06405423-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06405589-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06405699-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06405891-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06406177-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06406317-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06406547-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06406625-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06406757-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06406865-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06406979-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06407094-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06407221-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06407372-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06407514-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06407733-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06407915-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06408239-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06408442-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06408651-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06408779-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06408990-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06409085-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06409290-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06409448-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06409562-n',[ ('Article',equivalence)]).
nounMapping2SUMO('06409752-n',[ ('Article',subsumption)]).
nounMapping2SUMO('06409937-n',[ ('Article',subsumption)]).
nounMapping2SUMO('06410070-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06410187-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06410283-n',[ ('Article',subsumption)]).
nounMapping2SUMO('06410391-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06410655-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06410776-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06410904-n',[ ('Book',equivalence)]).
nounMapping2SUMO('06411592-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06411753-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06411883-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06412213-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06412350-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06412497-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06412610-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06412771-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06413020-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06413130-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06413260-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06413459-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06413579-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06413666-n',[ ('SeriesVolumeFn',subsumption)]).
nounMapping2SUMO('06413889-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06414151-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06414267-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06414372-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06414727-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06414849-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06414948-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06415061-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06415186-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06415323-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06415419-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06415584-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06415688-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06415791-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06415922-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06416049-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06416206-n',[ ('Catalog',equivalence)]).
nounMapping2SUMO('06416452-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06416598-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06416766-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06416946-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06417096-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06417279-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06417467-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06417598-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06418006-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06418146-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06418258-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06418375-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06418558-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06418693-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06418901-n',[ ('Dictionary',subsumption)]).
nounMapping2SUMO('06419234-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06419354-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06419503-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06419628-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06419757-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06419912-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06420053-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06420219-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06420424-n',[ ('Book',instance)]).
nounMapping2SUMO('06420573-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06420678-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06420781-n',[ ('Dictionary',subsumption)]).
nounMapping2SUMO('06421016-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06421154-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06421301-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06421538-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06421685-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06421844-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06422032-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06422144-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06422364-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06422488-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06422643-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06422740-n',[ ('GuideBook',equivalence)]).
nounMapping2SUMO('06422912-n',[ ('GuideBook',subsumption)]).
nounMapping2SUMO('06423090-n',[ ('GuideBook',subsumption)]).
nounMapping2SUMO('06423233-n',[ ('GuideBook',subsumption)]).
nounMapping2SUMO('06423378-n',[ ('GuideBook',subsumption)]).
nounMapping2SUMO('06423496-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06423619-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06423754-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06423994-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06424275-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06424869-n',[ ('Key',equivalence)]).
nounMapping2SUMO('06425065-n',[ ('Number',equivalence)]).
nounMapping2SUMO('06425404-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06425534-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06425808-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06425960-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06426111-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06426279-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06426468-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06426655-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06426865-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06427086-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06427240-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06427387-n',[ ('Series',subsumption)]).
nounMapping2SUMO('06427710-n',[ ('Series',subsumption)]).
nounMapping2SUMO('06427831-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('06428105-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('06428216-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('06428537-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('06428646-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('06428792-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('06428976-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('06429145-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('06429316-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('06429483-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('06429590-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06430309-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06430385-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06430537-n',[ ('Series',subsumption)]).
nounMapping2SUMO('06430784-n',[ ('Text',instance)]).
nounMapping2SUMO('06430996-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06431156-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06431496-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06431740-n',[ ('ChristianBible',subsumption)]).
nounMapping2SUMO('06432376-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06432715-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06433035-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06433249-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06433475-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06433672-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06433923-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06434165-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06434368-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06434650-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06434826-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06435004-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06435198-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06435394-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06435651-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06435916-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06436183-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06436443-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06436717-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06436939-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06437137-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06437308-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06437531-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06437824-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06438126-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06438290-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06438477-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06438748-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06438995-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06439253-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06439408-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06439560-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06439712-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06439924-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06440102-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06440313-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06440489-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06440663-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06440937-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06441195-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06441464-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06441607-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06441803-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06441973-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06442239-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06442405-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06442616-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06443163-n',[ ('Text',instance)]).
nounMapping2SUMO('06443398-n',[ ('Text',instance)]).
nounMapping2SUMO('06443658-n',[ ('Text',instance)]).
nounMapping2SUMO('06443922-n',[ ('Text',instance)]).
nounMapping2SUMO('06444148-n',[ ('Text',instance)]).
nounMapping2SUMO('06444458-n',[ ('Text',instance)]).
nounMapping2SUMO('06444711-n',[ ('Text',instance)]).
nounMapping2SUMO('06444959-n',[ ('Text',instance)]).
nounMapping2SUMO('06445214-n',[ ('Text',instance)]).
nounMapping2SUMO('06445473-n',[ ('Text',instance)]).
nounMapping2SUMO('06445729-n',[ ('Text',instance)]).
nounMapping2SUMO('06445989-n',[ ('Text',instance)]).
nounMapping2SUMO('06446217-n',[ ('Text',instance)]).
nounMapping2SUMO('06446476-n',[ ('Text',instance)]).
nounMapping2SUMO('06446711-n',[ ('Text',instance)]).
nounMapping2SUMO('06446860-n',[ ('Text',instance)]).
nounMapping2SUMO('06447039-n',[ ('Text',instance)]).
nounMapping2SUMO('06447221-n',[ ('Text',instance)]).
nounMapping2SUMO('06447400-n',[ ('Text',instance)]).
nounMapping2SUMO('06447582-n',[ ('Text',instance)]).
nounMapping2SUMO('06447763-n',[ ('Text',instance)]).
nounMapping2SUMO('06447897-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06448283-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06448397-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06448594-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06448868-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06449095-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06449254-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06449361-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06449477-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06449620-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06449735-n',[ ('OldTestament',equivalence)]).
nounMapping2SUMO('06451891-n',[ ('Text',instance)]).
nounMapping2SUMO('06452223-n',[ ('Text',instance)]).
nounMapping2SUMO('06452363-n',[ ('Text',instance)]).
nounMapping2SUMO('06452601-n',[ ('Text',instance)]).
nounMapping2SUMO('06453119-n',[ ('Text',instance)]).
nounMapping2SUMO('06453324-n',[ ('Text',instance)]).
nounMapping2SUMO('06453723-n',[ ('Text',instance)]).
nounMapping2SUMO('06453849-n',[ ('Text',instance)]).
nounMapping2SUMO('06455138-n',[ ('Text',instance)]).
nounMapping2SUMO('06455497-n',[ ('Text',instance)]).
nounMapping2SUMO('06455682-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06455775-n',[ ('Book',instance)]).
nounMapping2SUMO('06455990-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06456276-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('06456384-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06456515-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06456642-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06456759-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06456945-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06457045-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06457171-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06457442-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06457612-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06457796-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06457952-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06458685-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06458836-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06459016-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06459173-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06459323-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06459450-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06459681-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06459834-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06459978-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06460167-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06460295-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06460524-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06460776-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06460926-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06461077-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06461406-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06461609-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06461830-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06462002-n',[ ('Text',instance)]).
nounMapping2SUMO('06462219-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06462396-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06462656-n',[ ('Text',instance)]).
nounMapping2SUMO('06462807-n',[ ('Text',instance)]).
nounMapping2SUMO('06463011-n',[ ('Text',instance)]).
nounMapping2SUMO('06463170-n',[ ('Text',instance)]).
nounMapping2SUMO('06463347-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06463559-n',[ ('Text',instance)]).
nounMapping2SUMO('06463786-n',[ ('Text',instance)]).
nounMapping2SUMO('06464024-n',[ ('Text',instance)]).
nounMapping2SUMO('06464241-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06464419-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06464838-n',[ ('Text',instance)]).
nounMapping2SUMO('06465008-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06465139-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06465255-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06465351-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06465457-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06465623-n',[ ('Text',instance)]).
nounMapping2SUMO('06465780-n',[ ('Text',instance)]).
nounMapping2SUMO('06466030-n',[ ('Text',instance)]).
nounMapping2SUMO('06466253-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06466479-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06466677-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06466787-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06467007-n',[ ('Summary',equivalence)]).
nounMapping2SUMO('06467445-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06467680-n',[ ('Summary',subsumption)]).
nounMapping2SUMO('06467868-n',[ ('Summary',subsumption)]).
nounMapping2SUMO('06467996-n',[ ('Summary',subsumption)]).
nounMapping2SUMO('06468123-n',[ ('Summary',subsumption)]).
nounMapping2SUMO('06468328-n',[ ('Summary',subsumption)]).
nounMapping2SUMO('06468403-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06468523-n',[ ('Summary',subsumption)]).
nounMapping2SUMO('06468640-n',[ ('Summary',subsumption)]).
nounMapping2SUMO('06468749-n',[ ('Summary',subsumption)]).
nounMapping2SUMO('06468818-n',[ ('Summary',subsumption)]).
nounMapping2SUMO('06468951-n',[ ('Summary',subsumption)]).
nounMapping2SUMO('06469223-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06469377-n',[ ('Summary',equivalence)]).
nounMapping2SUMO('06469597-n',[ ('Summary',subsumption)]).
nounMapping2SUMO('06469694-n',[ ('Summary',subsumption)]).
nounMapping2SUMO('06469874-n',[ ('Summary',subsumption)]).
nounMapping2SUMO('06470073-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('06470688-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06470922-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06471069-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06471242-n',[ ('Summary',subsumption)]).
nounMapping2SUMO('06471345-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('06471737-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06472025-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06472242-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06472409-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06472607-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06472824-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06473041-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('06473168-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06473381-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06473563-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06473837-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06473940-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06474030-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06474122-n',[ ('FormText',subsumption)]).
nounMapping2SUMO('06474289-n',[ ('FormText',subsumption)]).
nounMapping2SUMO('06474603-n',[ ('FormText',subsumption)]).
nounMapping2SUMO('06474972-n',[ ('FormText',instance)]).
nounMapping2SUMO('06475307-n',[ ('FormText',instance)]).
nounMapping2SUMO('06475589-n',[ ('FormText',instance)]).
nounMapping2SUMO('06475933-n',[ ('FormText',instance)]).
nounMapping2SUMO('06476200-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06476384-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06476475-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06476573-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06476741-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06476899-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06477003-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06477209-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06477371-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06477645-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06477818-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06477970-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06478097-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06478199-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06478331-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06478452-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06478582-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06478734-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06478988-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06479204-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06479374-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('06479494-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06479665-n',[ ('Contract',equivalence)]).
nounMapping2SUMO('06480506-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06480723-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06480991-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06481156-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06481320-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06482401-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06482868-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06482978-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06483061-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06483171-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06483339-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06483454-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('06483702-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('06483992-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06484279-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06484696-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('06484887-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06485001-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06485178-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06485261-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06485431-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06485593-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06485800-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06485933-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06486042-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06486161-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06486405-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('06486630-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06486874-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06487050-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06487172-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06487260-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06487395-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06487610-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06487729-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06487897-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06488224-n',[ ('Discography',equivalence)]).
nounMapping2SUMO('06488325-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06488473-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06488629-n',[ ('Catalog',subsumption)]).
nounMapping2SUMO('06488763-n',[ ('Catalog',subsumption)]).
nounMapping2SUMO('06488880-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06489070-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06489190-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06489410-n',[ ('Argument',subsumption)]).
nounMapping2SUMO('06489560-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06489659-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06489847-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06489968-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06490173-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06490451-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06490627-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06490743-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06490887-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06491026-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06491168-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06491277-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06491371-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06491561-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06491665-n',[ ('MusicChart',subsumption)]).
nounMapping2SUMO('06491786-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06492040-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06492188-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06492320-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06492438-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06492569-n',[ ('Report',subsumption)]).
nounMapping2SUMO('06492664-n',[ ('Report',subsumption)]).
nounMapping2SUMO('06492811-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06492939-n',[ ('Menu',equivalence)]).
nounMapping2SUMO('06493158-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06493392-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06493579-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06493721-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06493926-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06494016-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06494153-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06494373-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06494538-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06494646-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('06494816-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('06495000-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06495220-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06495328-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06495516-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06495625-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06495824-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06495948-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06496116-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06496299-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06496397-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06496499-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06496624-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06496773-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06496862-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06497013-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06497117-n',[ ('Menu',subsumption)]).
nounMapping2SUMO('06497233-n',[ ('SetMenu',subsumption)]).
nounMapping2SUMO('06497331-n',[ ('Menu',subsumption)]).
nounMapping2SUMO('06497459-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06497872-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06498569-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06499244-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06499796-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06500062-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06500262-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06500448-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06500639-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06500765-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06500937-n',[ ('Passport',equivalence)]).
nounMapping2SUMO('06501141-n',[ ('Patent',equivalence)]).
nounMapping2SUMO('06501311-n',[ ('PartyPlatform',equivalence)]).
nounMapping2SUMO('06501622-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06501748-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06501918-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06502054-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('06502192-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06502378-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06502858-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06503034-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06503224-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06503386-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06503551-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06503724-n',[ ('Writing',equivalence)]).
nounMapping2SUMO('06503884-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06504049-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06504155-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06504326-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06504462-n',[ ('FactualText',equivalence)]).
nounMapping2SUMO('06504662-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06504838-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06504965-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06505154-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06505252-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06505434-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('06505517-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06505705-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06505799-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06505935-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('06506037-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06506191-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06506315-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06506430-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06506603-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06506757-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06506926-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06507041-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06507330-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06507454-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06507592-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06507711-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06507815-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06507941-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06508112-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06508299-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06508417-n',[ ('Series',subsumption)]).
nounMapping2SUMO('06508579-n',[ ('Series',subsumption)]).
nounMapping2SUMO('06508816-n',[ ('FactualText',equivalence)]).
nounMapping2SUMO('06509075-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06509210-n',[ ('ComputerFile',equivalence)]).
nounMapping2SUMO('06509513-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06509675-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06509902-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06510103-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06510271-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06510478-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06510663-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06510836-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06510977-n',[ ('ComputerFile',subsumption)]).
nounMapping2SUMO('06511242-n',[ ('ComputerFile',subsumption)]).
nounMapping2SUMO('06511396-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06511560-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06511762-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06511874-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06512099-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06512324-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06512580-n',[ ('Application',equivalence)]).
nounMapping2SUMO('06512857-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06512943-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06513043-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06513154-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06513255-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06513366-n',[ ('Request',equivalence)]).
nounMapping2SUMO('06513624-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06513764-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('06513953-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('06514093-n',[ ('HistoricalAccount',subsumption)]).
nounMapping2SUMO('06514529-n',[ ('HistoricalAccount',subsumption)]).
nounMapping2SUMO('06514621-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06514786-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06514880-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06515054-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06515297-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06515489-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06515662-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06515827-n',[ ('Biography',subsumption)]).
nounMapping2SUMO('06516087-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06516242-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06516404-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06516495-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06516595-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06516782-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06516955-n',[ ('FinancialBill',subsumption)]).
nounMapping2SUMO('06517345-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06517447-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06517547-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06517663-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06517779-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06517867-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06517942-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06518068-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06518253-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06518420-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06518565-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06518719-n',[ ('Ticket',subsumption)]).
nounMapping2SUMO('06519077-n',[ ('Ticket',subsumption)]).
nounMapping2SUMO('06519253-n',[ ('Ticket',subsumption)]).
nounMapping2SUMO('06519369-n',[ ('Ticket',subsumption)]).
nounMapping2SUMO('06519480-n',[ ('Ticket',subsumption)]).
nounMapping2SUMO('06519607-n',[ ('Ticket',subsumption)]).
nounMapping2SUMO('06519728-n',[ ('Ticket',subsumption)]).
nounMapping2SUMO('06519846-n',[ ('Ticket',subsumption)]).
nounMapping2SUMO('06519936-n',[ ('Ticket',subsumption)]).
nounMapping2SUMO('06520092-n',[ ('Ticket',subsumption)]).
nounMapping2SUMO('06520222-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06520429-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06520571-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06520742-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06520944-n',[ ('Contract',equivalence)]).
nounMapping2SUMO('06521878-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06522119-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06522357-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06522501-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06522633-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06522784-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06522941-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06523132-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06523353-n',[ ('MarriageContract',equivalence)]).
nounMapping2SUMO('06523473-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06523641-n',[ ('InsurancePolicy',equivalence)]).
nounMapping2SUMO('06523842-n',[ ('PurchaseContract',equivalence)]).
nounMapping2SUMO('06523969-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06524111-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06524278-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06524454-n',[ ('ServiceContract',equivalence)]).
nounMapping2SUMO('06524552-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06524767-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06524935-n',[ ('Promise',subsumption)]).
nounMapping2SUMO('06525132-n',[ ('Agreement',subsumption)]).
nounMapping2SUMO('06525406-n',[ ('Promise',subsumption)]).
nounMapping2SUMO('06525588-n',[ ('Agreement',subsumption)]).
nounMapping2SUMO('06525813-n',[ ('Agreement',subsumption)]).
nounMapping2SUMO('06526004-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06526124-n',[ ('InsurancePolicy',subsumption)]).
nounMapping2SUMO('06526291-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06526486-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06526619-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06526811-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06526961-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06527170-n',[ ('Agreement',subsumption)]).
nounMapping2SUMO('06527320-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06527447-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06527576-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06527710-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06527851-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06528191-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('06528403-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('06528557-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('06528783-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06528992-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06529219-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('06529630-n',[ ('PurchaseContract',subsumption)]).
nounMapping2SUMO('06529798-n',[ ('PurchaseContract',subsumption)]).
nounMapping2SUMO('06529879-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06529996-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06530143-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06530255-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06530412-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06530586-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('06530703-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('06530789-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06530976-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06531141-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06531327-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06531481-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06531657-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06531908-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06532095-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06532330-n',[ ('Law',equivalence)]).
nounMapping2SUMO('06532763-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('06532910-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06533039-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06533297-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06533484-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06533648-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06533863-n',[ ('Certificate',instance)]).
nounMapping2SUMO('06534132-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06534548-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06534659-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06534918-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06535035-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06535222-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06535476-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06535652-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06535980-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06536227-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06536389-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06536737-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06536853-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06537124-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06537323-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06537562-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06537701-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06537832-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06537951-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06538105-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06538215-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06538412-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06538525-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06538655-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06538785-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06538895-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06539076-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06539178-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06539502-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06539770-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06540284-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06540527-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06540702-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06540863-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06541167-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06541301-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06541381-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06541578-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06541726-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06541820-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06542047-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06542267-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06542569-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06542742-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06542830-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06543246-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06543389-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06543536-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06543781-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06543949-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06544142-n',[ ('Testament',subsumption)]).
nounMapping2SUMO('06544432-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06544657-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06544841-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06545137-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06545528-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06545728-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06545843-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06545960-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06546157-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06546261-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06546408-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06546633-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06546783-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06546931-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06547059-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06547321-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06547615-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06547832-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06547992-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06548110-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06548317-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06548498-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06548671-n',[ ('TaxReturn',subsumption)]).
nounMapping2SUMO('06548991-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06549115-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06549318-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06549407-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06549566-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06549661-n',[ ('License',subsumption)]).
nounMapping2SUMO('06550046-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06550206-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06550381-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06550552-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06550763-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06550891-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06551070-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06551226-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06551339-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06551498-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06551627-n',[ ('Patent',equivalence)]).
nounMapping2SUMO('06551784-n',[ ('LegalDecision',equivalence)]).
nounMapping2SUMO('06552116-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06552320-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06552470-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06552639-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06552814-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06552984-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06553472-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06553631-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06553846-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06554078-n',[ ('ClosingContract',subsumption)]).
nounMapping2SUMO('06554373-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06554531-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06554675-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06554981-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06555191-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06555341-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06555570-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06555695-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06555847-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06555971-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06556150-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06556343-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06556481-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06556692-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06557047-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06557317-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06557585-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06557827-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06558088-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06558277-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06558434-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06558678-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06558893-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06559004-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06559114-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('06559365-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06559832-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06560021-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06560254-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06560758-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06560939-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06561138-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06561343-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06561461-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06561744-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06561942-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06562217-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06562436-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06562615-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06562802-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06562993-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06563168-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06563324-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06563478-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06563640-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06563801-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06563950-n',[ ('Agreement',subsumption)]).
nounMapping2SUMO('06564387-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06564640-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06564887-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06565201-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06565397-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06565788-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06565919-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06566077-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06566805-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06566949-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06567143-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06567400-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06567531-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06567689-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06567865-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06567960-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06568134-n',[ ('OperatingSystem',subsumption)]).
nounMapping2SUMO('06568422-n',[ ('OperatingSystem',subsumption)]).
nounMapping2SUMO('06568552-n',[ ('OperatingSystem',subsumption)]).
nounMapping2SUMO('06568706-n',[ ('OperatingSystem',subsumption)]).
nounMapping2SUMO('06568855-n',[ ('OperatingSystem',instance)]).
nounMapping2SUMO('06568978-n',[ ('ComputerProgram',equivalence)]).
nounMapping2SUMO('06569966-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06570110-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06570520-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06570647-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06570805-n',[ ('Photograph',subsumption)]).
nounMapping2SUMO('06570963-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('06571301-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06571538-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06571639-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06571724-n',[ ('Feline',subsumption)]).
nounMapping2SUMO('06571790-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06571862-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06571938-n',[ ('Building',subsumption)]).
nounMapping2SUMO('06572011-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06572204-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06572482-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06572654-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06572857-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06573020-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06573223-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06573337-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06573472-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06573600-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06573934-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06574027-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06574132-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06574231-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06574334-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06574473-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06574680-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06574841-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06575092-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06575227-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06575505-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06575681-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06575932-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06576153-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06576265-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06576376-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06576539-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06576727-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06576893-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06577063-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06577232-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06577369-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06577585-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06577781-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06577916-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06578060-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06578203-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06578323-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06578527-n',[ ('ComputerProgram',instance)]).
nounMapping2SUMO('06578654-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06578905-n',[ ('ComputerProgram',instance)]).
nounMapping2SUMO('06579127-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('06579294-n',[ ('ComputerProgram',instance)]).
nounMapping2SUMO('06579452-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06579592-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06579715-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06579952-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06580103-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06580219-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06580351-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06580543-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06580646-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06580866-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06581068-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06581268-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06581410-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06581823-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06581959-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06582085-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06582267-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06582403-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06582761-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('06582986-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('06583178-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06583354-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06583518-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06583645-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06583790-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06583929-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06584049-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06584162-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06584256-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06584376-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06584536-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06584702-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06584891-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('06585203-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06585552-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06585816-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06586098-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06586355-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('06586471-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('06586672-n',[ ('UniformResourceIdentifier',subsumption)]).
nounMapping2SUMO('06586886-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('06587048-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('06587217-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('06587399-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('06587596-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06587790-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06587980-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06588139-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06588326-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06588511-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06588785-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06588998-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06589151-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06589352-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06589574-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06590065-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06590210-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06590446-n',[ ('EditionFn',equivalence)]).
nounMapping2SUMO('06590601-n',[ ('EditionFn',subsumption)]).
nounMapping2SUMO('06590723-n',[ ('EditionFn',subsumption)]).
nounMapping2SUMO('06590885-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06591108-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06591224-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06591342-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06591442-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06591609-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06591815-n',[ ('Album',equivalence)]).
nounMapping2SUMO('06592078-n',[ ('Album',subsumption)]).
nounMapping2SUMO('06592281-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('06592421-n',[ ('Album',subsumption)]).
nounMapping2SUMO('06592576-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06592699-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06592844-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06592991-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06593099-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06593296-n',[ ('Periodical',equivalence)]).
nounMapping2SUMO('06593542-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06593668-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06593803-n',[ ('Periodical',equivalence)]).
nounMapping2SUMO('06594130-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06594258-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06594376-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06594505-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06594625-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06594751-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06594904-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06595056-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06595220-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06595351-n',[ ('Magazine',equivalence)]).
nounMapping2SUMO('06595797-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06596025-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06596179-n',[ ('Magazine',subsumption)]).
nounMapping2SUMO('06596364-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06596474-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06596607-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06596727-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06596845-n',[ ('Magazine',subsumption)]).
nounMapping2SUMO('06596978-n',[ ('PeriodicalIssueFn',equivalence)]).
nounMapping2SUMO('06597204-n',[ ('PeriodicalIssueFn',subsumption)]).
nounMapping2SUMO('06597349-n',[ ('PeriodicalIssueFn',subsumption)]).
nounMapping2SUMO('06597466-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06597617-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06597758-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06597930-n',[ ('Periodical',subsumption)]).
nounMapping2SUMO('06598030-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06598244-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06598445-n',[ ('Reading',subsumption)]).
nounMapping2SUMO('06598648-n',[ ('Reading',subsumption)]).
nounMapping2SUMO('06598746-n',[ ('Reading',subsumption)]).
nounMapping2SUMO('06598915-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06599655-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06599788-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06600139-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06600282-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06600421-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06600684-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06600903-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('06601053-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('06601217-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('06601327-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06601973-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('06602148-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('06602324-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('06602472-n',[ ('Proposition',equivalence)]).
nounMapping2SUMO('06602801-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('06602935-n',[ ('Class',subsumption)]).
nounMapping2SUMO('06603130-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06603242-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06603366-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06603494-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06603651-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06603816-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('06603927-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('06604066-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06604209-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06604319-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06604548-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06604743-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06604963-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('06605046-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06605396-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06605682-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06605780-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06605897-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06606044-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06606191-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06606464-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06606618-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06606694-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06606808-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('06607067-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06607204-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06607339-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06607809-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06608035-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06608143-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06608277-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06608405-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06608525-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06608617-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06608728-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06608977-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06609176-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06609296-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06609403-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06609503-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06609672-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06609785-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06609909-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06610063-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06610143-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06610332-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06610436-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06610557-n',[ ('False',subsumption)]).
nounMapping2SUMO('06610779-n',[ ('False',subsumption)]).
nounMapping2SUMO('06610897-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06610992-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06611147-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06611376-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06611681-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06611856-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06611998-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06612174-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06612266-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06612420-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06612538-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06612649-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06612865-n',[ ('MusicRecording',subsumption)]).
nounMapping2SUMO('06613056-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06613340-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06613448-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06613576-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06613686-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06614628-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06614729-n',[ ('MotionPictureShot',equivalence)]).
nounMapping2SUMO('06614901-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06615026-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06615216-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06615348-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06615458-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06615561-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06615736-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06615818-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06615927-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06616035-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06616216-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06616314-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06616464-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06616703-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06616806-n',[ ('Documentary',subsumption)]).
nounMapping2SUMO('06617011-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06617165-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06617413-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06617527-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06617644-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06617752-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06617866-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06618035-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06618234-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06618427-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06618549-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06618653-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06618822-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06618937-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06619065-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('06619428-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06619751-n',[ ('Broadcasting',subsumption)]).
nounMapping2SUMO('06619850-n',[ ('FactualText',equivalence)]).
nounMapping2SUMO('06620063-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06620227-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06620467-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06620579-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06620790-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06620906-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06621061-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06621215-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06621323-n',[ ('MotionPicture',subsumption)]).
nounMapping2SUMO('06621447-n',[ ('Series',subsumption)]).
nounMapping2SUMO('06621681-n',[ ('Series',subsumption)]).
nounMapping2SUMO('06621771-n',[ ('SeriesVolumeFn',subsumption)]).
nounMapping2SUMO('06621917-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06622020-n',[ ('Series',subsumption)]).
nounMapping2SUMO('06622252-n',[ ('Series',subsumption)]).
nounMapping2SUMO('06622366-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06622449-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06622595-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06622709-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06622877-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06622993-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06623100-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06623207-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06623316-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06623481-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06623614-n',[ ('Corresponding',subsumption)]).
nounMapping2SUMO('06623788-n',[ ('Text',instance)]).
nounMapping2SUMO('06623997-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06624161-n',[ ('Letter',subsumption)]).
nounMapping2SUMO('06624724-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06624816-n',[ ('Letter',subsumption)]).
nounMapping2SUMO('06624967-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06625062-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06625217-n',[ ('Letter',subsumption)]).
nounMapping2SUMO('06625329-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06625465-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06625601-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06625739-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06625850-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06625965-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06626060-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06626183-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06626286-n',[ ('Letter',subsumption)]).
nounMapping2SUMO('06626446-n',[ ('Letter',subsumption)]).
nounMapping2SUMO('06626618-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06626743-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06626860-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06627006-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06627260-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06627357-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06627450-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06627623-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06627722-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06627816-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06627938-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06628125-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06628228-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06628328-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06628450-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06628663-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06628861-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06629392-n',[ ('ExpressingFarewell',subsumption)]).
nounMapping2SUMO('06629610-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06629858-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06630017-n',[ ('Greeting',subsumption)]).
nounMapping2SUMO('06630459-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06630627-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06630852-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06631050-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06631140-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06631322-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06631506-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06631661-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06631833-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06631921-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06632097-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06632358-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06632511-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06632671-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06632807-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06632947-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06633041-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06633205-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06633363-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06633596-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06633692-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06633896-n',[ ('Congratulating',subsumption)]).
nounMapping2SUMO('06634095-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06634239-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('06634376-n',[ ('FactualText',equivalence)]).
nounMapping2SUMO('06634960-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06635104-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06635313-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06635509-n',[ ('FactualText',equivalence)]).
nounMapping2SUMO('06635759-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06635944-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06636113-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06636259-n',[ ('Fact',equivalence)]).
nounMapping2SUMO('06636524-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('06636806-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('06637149-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('06637350-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('06637677-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06637824-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06637973-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06638254-n',[ ('ContentBearingObject',instance)]).
nounMapping2SUMO('06638527-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06638739-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06638868-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06639023-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06639204-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06639428-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06639563-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06639674-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06640016-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06640317-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06640533-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06640848-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06640977-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06641181-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06641423-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06641524-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06641654-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06641818-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06641924-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('06642138-n',[ ('FactualText',equivalence)]).
nounMapping2SUMO('06642356-n',[ ('FactualText',equivalence)]).
nounMapping2SUMO('06642518-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('06642672-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06642899-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06643120-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06643185-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('06643303-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06643408-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('06643763-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('06643883-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06644105-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06644393-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06644658-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06644823-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06644916-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06645039-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06645266-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06645458-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06645623-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06645831-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06646022-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06646243-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06646531-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06646628-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06646854-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06647036-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06647206-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06647614-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06647864-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06647960-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06648046-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06648207-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06648462-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06648590-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06648724-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06649108-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06649223-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06649325-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06649426-n',[ ('Argument',equivalence)]).
nounMapping2SUMO('06649567-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06649704-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06649786-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06649915-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06650070-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06650238-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06650431-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06650701-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('06651047-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('06651145-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('06651302-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('06651463-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('06651577-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06651854-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06652064-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06652242-n',[ ('Obligation',equivalence)]).
nounMapping2SUMO('06652614-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06652712-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06652878-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06653160-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06653363-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06653727-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06653911-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06654074-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06654275-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06654490-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06654639-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06654791-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06654977-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06655074-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06655388-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06655569-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06655683-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06655805-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06655927-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06656143-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06656274-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06656408-n',[ ('Argument',equivalence)]).
nounMapping2SUMO('06656741-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06656961-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06657109-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06657202-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06657464-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06657646-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('06657913-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('06658118-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('06658269-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('06658441-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('06658545-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06658786-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06658994-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06659168-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06659397-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06659530-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06659685-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06660009-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06660224-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06660396-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06660520-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06660668-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06660816-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06660942-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('06661243-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06661396-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06661562-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06661747-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06661923-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06662057-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06662193-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06662366-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06662522-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06662712-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06662850-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06663018-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06663168-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06663308-n',[ ('Argument',subsumption)]).
nounMapping2SUMO('06663463-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06663617-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06663785-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06663940-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06664051-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06664213-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06664353-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06664473-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06664594-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06664845-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06664981-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06665108-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06665370-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06665612-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06665847-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06666030-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06666210-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06666486-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06666729-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06666829-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06667027-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06667169-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06667317-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06667625-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06667792-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06668019-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06668147-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06668432-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06668611-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06668813-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06669013-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06669193-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06669384-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('06669513-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06669673-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06669864-n',[ ('Equation',equivalence)]).
nounMapping2SUMO('06670137-n',[ ('LinearEquation',equivalence)]).
nounMapping2SUMO('06670240-n',[ ('NonlinearEquation',subsumption)]).
nounMapping2SUMO('06670390-n',[ ('NonlinearEquation',subsumption)]).
nounMapping2SUMO('06670521-n',[ ('DifferentialEquation',subsumption)]).
nounMapping2SUMO('06670711-n',[ ('SymbolicString',subsumption)]).
nounMapping2SUMO('06670866-n',[ ('PartialDifferentialEquation',equivalence)]).
nounMapping2SUMO('06671013-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06671150-n',[ ('SymbolicString',subsumption)]).
nounMapping2SUMO('06671339-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06671484-n',[ ('Requesting',equivalence)]).
nounMapping2SUMO('06671637-n',[ ('Requesting',equivalence)]).
nounMapping2SUMO('06671818-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('06672040-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06672297-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06672752-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06672953-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06673142-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06673435-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06673671-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06673770-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06674028-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06674188-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06674385-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06674542-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06674791-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06674947-n',[ ('Book',subsumption)]).
nounMapping2SUMO('06675122-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06675338-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('06675581-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06675691-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('06675799-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06675979-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06676109-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06676254-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06676416-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06676709-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06677089-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06677194-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06677302-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('06677974-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('06678146-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('06678302-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06678506-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06678664-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('06678784-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('06679041-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('06679167-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('06679308-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('06679457-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('06679726-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('06680002-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('06680195-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('06680333-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('06680431-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('06680570-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('06680818-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('06680913-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('06681035-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('06681177-n',[ ('FactualText',equivalence)]).
nounMapping2SUMO('06681454-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('06681551-n',[ ('Report',subsumption)]).
nounMapping2SUMO('06681976-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06682152-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06682290-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06682494-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06682683-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06682794-n',[ ('Report',subsumption)]).
nounMapping2SUMO('06682952-n',[ ('Report',subsumption)]).
nounMapping2SUMO('06683183-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06683359-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06683513-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06683595-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06683692-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06683784-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06684052-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('06684153-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('06684262-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('06684383-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('06684572-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('06684798-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('06685040-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('06685198-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06685456-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06685754-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('06685860-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('06685975-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06686174-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('06686467-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('06686573-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('06686736-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06687178-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06687358-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06687701-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06687883-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06688059-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06688274-n',[ ('ExpressingApproval',subsumption)]).
nounMapping2SUMO('06688522-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06688751-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06688913-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06689125-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06689297-n',[ ('Permission',subsumption)]).
nounMapping2SUMO('06689554-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06689667-n',[ ('Permission',subsumption)]).
nounMapping2SUMO('06689829-n',[ ('Permission',subsumption)]).
nounMapping2SUMO('06689948-n',[ ('Permission',subsumption)]).
nounMapping2SUMO('06690114-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06690226-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06690408-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06690647-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06690770-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06690928-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06691083-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06691267-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06691442-n',[ ('ExpressingApproval',subsumption)]).
nounMapping2SUMO('06691684-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06691989-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06692238-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06692369-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06692464-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06692572-n',[ ('Vocalizing',equivalence)]).
nounMapping2SUMO('06692740-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06692834-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06692973-n',[ ('Vocalizing',subsumption)]).
nounMapping2SUMO('06693086-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06693198-n',[ ('ExpressingApproval',subsumption)]).
nounMapping2SUMO('06693502-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06693655-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06693744-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06693870-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06694149-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06694359-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06694540-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06694796-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06695110-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06695227-n',[ ('ExpressingApproval',subsumption)]).
nounMapping2SUMO('06695424-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06695579-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06695753-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06695862-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('06696025-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('06696181-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06696308-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06696483-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06696991-n',[ ('ContentBearingPhysical',subsumption)]).
nounMapping2SUMO('06697195-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06697331-n',[ ('AcademicDegree',equivalence)]).
nounMapping2SUMO('06697703-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06697935-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06698031-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06698150-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06698252-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06698640-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06698775-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06698902-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06699012-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06699115-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06699225-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06699366-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06699465-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06699579-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06699685-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06699811-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06699926-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06700030-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06700169-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06700325-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06700447-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06700844-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06701001-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06701128-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06701251-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06701359-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06701495-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06701596-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06701698-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06701800-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06701906-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06702020-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06702139-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06702247-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06702358-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06702458-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06702888-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06703002-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06703114-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06703213-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06703321-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06703420-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06703522-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06703632-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06703733-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06703834-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06703953-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06704115-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06704295-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06704366-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06704482-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06704582-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06704740-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06704898-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06704990-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06705079-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06705306-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06705398-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06705495-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06705595-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06705698-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06705787-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06705891-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06705984-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06706125-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06706317-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06706504-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06706676-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06707178-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06707382-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06707555-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06707709-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06707846-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06708007-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06708167-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06708304-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06708475-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06708664-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06708866-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06708970-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06709112-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06709245-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06709349-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06709442-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('06709533-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06709692-n',[ ('ExpressingDisapproval',subsumption)]).
nounMapping2SUMO('06709998-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06710152-n',[ ('ExpressingDisapproval',subsumption)]).
nounMapping2SUMO('06710330-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('06710546-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06710960-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06711030-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06711159-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06711404-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06711539-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06711705-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06711855-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06712325-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06712498-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06712625-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06712761-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06712833-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06713026-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06713099-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06713187-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06713377-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06713512-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06713650-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06713752-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06713930-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06714184-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06714288-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06714420-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06714552-n',[ ('ExpressingApproval',subsumption)]).
nounMapping2SUMO('06714697-n',[ ('Statement',subsumption)]).
nounMapping2SUMO('06714874-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06714976-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06715223-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06715638-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06715786-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06715927-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06716117-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06716234-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06716483-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06716675-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06716796-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06716992-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06717170-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06718269-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06718434-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06718543-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06718862-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06719203-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06719299-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06719404-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06719579-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06719974-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06720137-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06720216-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06720371-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06720600-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06720784-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06720964-n',[ ('ExpressingDisapproval',subsumption)]).
nounMapping2SUMO('06721081-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06721269-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06721342-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06721461-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06721604-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06721813-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06721949-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06722186-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06722453-n',[ ('Statement',equivalence)]).
nounMapping2SUMO('06723452-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06723635-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06723908-n',[ ('LinguisticExpression',equivalence)]).
nounMapping2SUMO('06724066-n',[ ('True',subsumption)]).
nounMapping2SUMO('06724323-n',[ ('True',subsumption)]).
nounMapping2SUMO('06724437-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06724559-n',[ ('False',subsumption)]).
nounMapping2SUMO('06724763-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06724942-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06725067-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('06725249-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('06725467-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('06725680-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('06725877-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06726158-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06726478-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06726671-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06726761-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06726939-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06727133-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06727224-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06727416-n',[ ('Disseminating',instance)]).
nounMapping2SUMO('06727616-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06727758-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06728034-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06728331-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06728726-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06728998-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06729251-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06729499-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06729864-n',[ ('LegalAction',equivalence)]).
nounMapping2SUMO('06730068-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('06730241-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06730371-n',[ ('LegalAction',subsumption)]).
nounMapping2SUMO('06730563-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06730780-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06731069-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06731186-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06731378-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06731510-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06731697-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06731802-n',[ ('SymbolicString',subsumption)]).
nounMapping2SUMO('06732013-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06732169-n',[ ('SymbolicString',subsumption)]).
nounMapping2SUMO('06732350-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06732581-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06732710-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06732925-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06733119-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06733227-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06733476-n',[ ('Threatening',subsumption)]).
nounMapping2SUMO('06733682-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('06733782-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('06733939-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06734322-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06734467-n',[ ('Testifying',subsumption)]).
nounMapping2SUMO('06734702-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06734823-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06735077-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06735261-n',[ ('Law',subsumption)]).
nounMapping2SUMO('06735533-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06735731-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('06735922-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06736083-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06736217-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06736405-n',[ ('Testifying',subsumption)]).
nounMapping2SUMO('06736529-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06736769-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06736946-n',[ ('Testifying',subsumption)]).
nounMapping2SUMO('06737112-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('06737394-n',[ ('Promise',subsumption)]).
nounMapping2SUMO('06737628-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('06737758-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('06738008-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('06738162-n',[ ('LinguisticCommunication',equivalence)]).
nounMapping2SUMO('06738281-n',[ ('Explanation',equivalence)]).
nounMapping2SUMO('06738823-n',[ ('Statement',subsumption)]).
nounMapping2SUMO('06739013-n',[ ('Statement',subsumption)]).
nounMapping2SUMO('06739180-n',[ ('Explanation',subsumption)]).
nounMapping2SUMO('06739345-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06739509-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06739676-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06739782-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06739990-n',[ ('Explanation',equivalence)]).
nounMapping2SUMO('06740183-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06740402-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06740644-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06740919-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06741099-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06741305-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06741728-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06741993-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('06742173-n',[ ('Explanation',subsumption)]).
nounMapping2SUMO('06742426-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06742630-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06742772-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06742932-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06743230-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06743362-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06743506-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06743867-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06744000-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06744154-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06744396-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06744663-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06745015-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06745156-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06745285-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06745422-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06745628-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06745861-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06746005-n',[ ('Answering',subsumption)]).
nounMapping2SUMO('06746347-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06746471-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06746580-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06747008-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06747190-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06747369-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06747484-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06747670-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06747907-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('06748133-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06748270-n',[ ('Biography',instance)]).
nounMapping2SUMO('06748466-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06748703-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06748841-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06748969-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06749267-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06749468-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06749594-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06749729-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06749881-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06750154-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06750339-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06750514-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06750698-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06750804-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('06751142-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06751367-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('06751572-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('06751742-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('06751833-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('06751974-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06752293-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06752410-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06752695-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06753030-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06753299-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('06753550-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('06753800-n',[ ('Supposition',subsumption)]).
nounMapping2SUMO('06754184-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('06754415-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('06754658-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06754816-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06754972-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('06755156-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06755342-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06755454-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('06755568-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06755776-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06755947-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06756111-n',[ ('Supposition',subsumption)]).
nounMapping2SUMO('06756267-n',[ ('Statement',subsumption)]).
nounMapping2SUMO('06756407-n',[ ('False',equivalence)]).
nounMapping2SUMO('06756680-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06756831-n',[ ('False',subsumption)]).
nounMapping2SUMO('06757057-n',[ ('False',subsumption)]).
nounMapping2SUMO('06757289-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06757479-n',[ ('False',subsumption)]).
nounMapping2SUMO('06757676-n',[ ('False',subsumption)]).
nounMapping2SUMO('06757771-n',[ ('False',subsumption)]).
nounMapping2SUMO('06757891-n',[ ('False',subsumption)]).
nounMapping2SUMO('06758135-n',[ ('False',subsumption)]).
nounMapping2SUMO('06758225-n',[ ('False',subsumption)]).
nounMapping2SUMO('06758584-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('06758698-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('06758835-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('06759063-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06759256-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('06759349-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('06759602-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('06759776-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('06759974-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('06760076-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('06760249-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('06760508-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('06760722-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('06760969-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('06761099-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06761342-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06761482-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06761603-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06761798-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06761994-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06762245-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06762380-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06762602-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06762711-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06763052-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06763273-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06763681-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06764244-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06764380-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06764623-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06764751-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06764867-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06765044-n',[ ('Statement',equivalence)]).
nounMapping2SUMO('06765531-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06765656-n',[ ('LegalDecision',subsumption)]).
nounMapping2SUMO('06765887-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06766092-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06766190-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06766544-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06766654-n',[ ('Statement',subsumption)]).
nounMapping2SUMO('06766812-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06767035-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06767287-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06767512-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06767693-n',[ ('Statement',subsumption)]).
nounMapping2SUMO('06767777-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06767922-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06768259-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06768394-n',[ ('Statement',subsumption)]).
nounMapping2SUMO('06768528-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06768735-n',[ ('False',subsumption)]).
nounMapping2SUMO('06768901-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('06769032-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('06769238-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('06769392-n',[ ('False',subsumption)]).
nounMapping2SUMO('06769578-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06769670-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06769883-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06770028-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06770164-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('06770275-n',[ ('Agreement',equivalence)]).
nounMapping2SUMO('06770875-n',[ ('Text',equivalence)]).
nounMapping2SUMO('06771159-n',[ ('Agreement',subsumption)]).
nounMapping2SUMO('06771424-n',[ ('Agreement',subsumption)]).
nounMapping2SUMO('06771526-n',[ ('Agreement',subsumption)]).
nounMapping2SUMO('06771653-n',[ ('Agreement',subsumption)]).
nounMapping2SUMO('06771957-n',[ ('Agreement',subsumption)]).
nounMapping2SUMO('06772094-n',[ ('Agreement',subsumption)]).
nounMapping2SUMO('06772260-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('06772461-n',[ ('Agreement',subsumption)]).
nounMapping2SUMO('06772583-n',[ ('Agreement',subsumption)]).
nounMapping2SUMO('06772837-n',[ ('ServiceContract',subsumption)]).
nounMapping2SUMO('06773006-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06773150-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06773347-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06773434-n',[ ('Treaty',subsumption)]).
nounMapping2SUMO('06773684-n',[ ('Treaty',subsumption)]).
nounMapping2SUMO('06773857-n',[ ('Treaty',subsumption)]).
nounMapping2SUMO('06773976-n',[ ('Treaty',subsumption)]).
nounMapping2SUMO('06774192-n',[ ('Agreement',instance)]).
nounMapping2SUMO('06774316-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('06774468-n',[ ('Agreement',instance)]).
nounMapping2SUMO('06774650-n',[ ('Agreement',instance)]).
nounMapping2SUMO('06774871-n',[ ('Agreement',instance)]).
nounMapping2SUMO('06775086-n',[ ('Agreement',instance)]).
nounMapping2SUMO('06775218-n',[ ('Agreement',instance)]).
nounMapping2SUMO('06775409-n',[ ('Agreement',instance)]).
nounMapping2SUMO('06775602-n',[ ('Agreement',instance)]).
nounMapping2SUMO('06775812-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06775969-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06776138-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06776679-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06776783-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06776877-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06776986-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06777164-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06777687-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06777794-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06777961-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06778032-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06778102-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06778777-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06778925-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06779096-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06779210-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06779310-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06779511-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06779642-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06779713-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06779839-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06779914-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06780069-n',[ ('Drawing',subsumption)]).
nounMapping2SUMO('06780309-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06780678-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06780882-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06781151-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06781281-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06781383-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06781581-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06781811-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06781878-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06782019-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06782383-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06782680-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06783155-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06783265-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06783442-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06783598-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06783768-n',[ ('Stating',undefined)]).
nounMapping2SUMO('06784003-n',[ ('Question',equivalence)]).
nounMapping2SUMO('06784317-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06784470-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06784639-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06784966-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('06785101-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06785223-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06785367-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06785541-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06785654-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06785840-n',[ ('Question',subsumption)]).
nounMapping2SUMO('06786012-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06786209-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06786358-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06786486-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06786629-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06787037-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06787150-n',[ ('Address',equivalence)]).
nounMapping2SUMO('06787429-n',[ ('Address',subsumption)]).
nounMapping2SUMO('06787602-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06787835-n',[ ('ComputerLanguage',subsumption)]).
nounMapping2SUMO('06788007-n',[ ('ComputerLanguage',instance)]).
nounMapping2SUMO('06788262-n',[ ('ComputerLanguage',instance)]).
nounMapping2SUMO('06788463-n',[ ('Word',subsumption)]).
nounMapping2SUMO('06788565-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06788785-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06788897-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06789080-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06789215-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06789411-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06789801-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06790042-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06790235-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06790557-n',[ ('Proposition',instance)]).
nounMapping2SUMO('06790845-n',[ ('Proposition',instance)]).
nounMapping2SUMO('06791017-n',[ ('Proposition',instance)]).
nounMapping2SUMO('06791195-n',[ ('Proposition',instance)]).
nounMapping2SUMO('06791372-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06792188-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06792364-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06792526-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06792645-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06792818-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06792950-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('06793091-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06793231-n',[ ('Sign',equivalence)]).
nounMapping2SUMO('06793426-n',[ ('Sign',subsumption)]).
nounMapping2SUMO('06793817-n',[ ('Advertising',subsumption)]).
nounMapping2SUMO('06793959-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06794110-n',[ ('Sign',subsumption)]).
nounMapping2SUMO('06794216-n',[ ('Sign',subsumption)]).
nounMapping2SUMO('06794374-n',[ ('Sign',subsumption)]).
nounMapping2SUMO('06794537-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06794666-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06794980-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('06795168-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('06795290-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06795438-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06795543-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06795657-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06795746-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06795967-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06796119-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06796333-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06796506-n',[ ('AnimalLanguage',equivalence)]).
nounMapping2SUMO('06796642-n',[ ('AnimalLanguage',subsumption)]).
nounMapping2SUMO('06796942-n',[ ('AnimalLanguage',subsumption)]).
nounMapping2SUMO('06797047-n',[ ('AnimalLanguage',subsumption)]).
nounMapping2SUMO('06797169-n',[ ('ContentBearingObject',equivalence)]).
nounMapping2SUMO('06797671-n',[ ('True',subsumption)]).
nounMapping2SUMO('06797947-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('06798187-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('06798336-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06798472-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06798558-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06798750-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06799142-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06799260-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06799485-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06799588-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06799688-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('06799754-n',[ ('Object',subsumption)]).
nounMapping2SUMO('06799897-n',[ ('OneDimensionalFigure',equivalence)]).
nounMapping2SUMO('06800344-n',[ ('OneDimensionalFigure',subsumption)]).
nounMapping2SUMO('06800532-n',[ ('OneDimensionalFigure',subsumption)]).
nounMapping2SUMO('06800698-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06800871-n',[ ('OneDimensionalFigure',subsumption)]).
nounMapping2SUMO('06801033-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06801138-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06801313-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06801418-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06801580-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06801740-n',[ ('OneDimensionalFigure',subsumption)]).
nounMapping2SUMO('06801865-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06801965-n',[ ('OneDimensionalFigure',subsumption)]).
nounMapping2SUMO('06802138-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06802258-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06802347-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06802444-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06802571-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06802785-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06802880-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06803023-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06803157-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06803478-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06803636-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06803845-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06803954-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06804097-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06804199-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06804388-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06804483-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06804606-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06804728-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06804847-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06804988-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06805128-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06805297-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('06805497-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06805665-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06805826-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06805962-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06806098-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06806318-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06806469-n',[ ('Character',equivalence)]).
nounMapping2SUMO('06807056-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06807198-n',[ ('DigitCharacter',subsumption)]).
nounMapping2SUMO('06807501-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06807657-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06807849-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06807971-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06808121-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06808271-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06808408-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06808493-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06808720-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06809074-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06809291-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06809421-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06809756-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('06809905-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06810020-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06810238-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06810407-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06810544-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06810691-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06810790-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06810997-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06811109-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06811283-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06811419-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06811625-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06811867-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06811986-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06812085-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06812188-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06812289-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06812417-n',[ ('ExponentiationFn',equivalence)]).
nounMapping2SUMO('06812631-n',[ ('LogFn',equivalence)]).
nounMapping2SUMO('06812794-n',[ ('LogFn',subsumption)]).
nounMapping2SUMO('06812915-n',[ ('LogFn',subsumption)]).
nounMapping2SUMO('06813004-n',[ ('LogFn',subsumption)]).
nounMapping2SUMO('06813115-n',[ ('LogFn',subsumption)]).
nounMapping2SUMO('06813310-n',[ ('LogFn',subsumption)]).
nounMapping2SUMO('06813506-n',[ ('FloorFn',subsumption)]).
nounMapping2SUMO('06813700-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06814021-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06814236-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06814443-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06814655-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06814870-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06815458-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06815621-n',[ ('SheetMusic',equivalence)]).
nounMapping2SUMO('06815714-n',[ ('SheetMusic',subsumption)]).
nounMapping2SUMO('06815970-n',[ ('SheetMusic',subsumption)]).
nounMapping2SUMO('06816106-n',[ ('SheetMusic',equivalence)]).
nounMapping2SUMO('06816335-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06816445-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06816555-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06816785-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06816935-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06817173-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06817312-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06817459-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06817623-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06817782-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06818121-n',[ ('ArrowIcon',subsumption)]).
nounMapping2SUMO('06818317-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06818439-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06818603-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06818747-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06818970-n',[ ('Character',equivalence)]).
nounMapping2SUMO('06819557-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06819698-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('06819824-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06820023-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06820212-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06820425-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06820601-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06820837-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06820964-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06821279-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06821422-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06821581-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06821770-n',[ ('Object',subsumption)]).
nounMapping2SUMO('06821889-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06822034-n',[ ('Object',subsumption)]).
nounMapping2SUMO('06822198-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06822476-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06822576-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06822707-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06822831-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06822958-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06823102-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06823259-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06823440-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06823561-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06823760-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06823925-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06824041-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06824227-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06824757-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06824955-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06825120-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06825273-n',[ ('Script',subsumption)]).
nounMapping2SUMO('06825399-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06825736-n',[ ('Script',subsumption)]).
nounMapping2SUMO('06825863-n',[ ('Script',subsumption)]).
nounMapping2SUMO('06825996-n',[ ('Script',subsumption)]).
nounMapping2SUMO('06826214-n',[ ('Script',subsumption)]).
nounMapping2SUMO('06826407-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06826589-n',[ ('Script',subsumption)]).
nounMapping2SUMO('06826726-n',[ ('Script',subsumption)]).
nounMapping2SUMO('06826974-n',[ ('Script',subsumption)]).
nounMapping2SUMO('06827219-n',[ ('Script',subsumption)]).
nounMapping2SUMO('06827344-n',[ ('Script',subsumption)]).
nounMapping2SUMO('06827503-n',[ ('Script',subsumption)]).
nounMapping2SUMO('06827679-n',[ ('Script',subsumption)]).
nounMapping2SUMO('06827947-n',[ ('Script',subsumption)]).
nounMapping2SUMO('06828061-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('06828199-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06828389-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06828529-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06828662-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06828818-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06830561-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06830708-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06830838-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06830997-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06831177-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06831284-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06831391-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06831498-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06831605-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06831712-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06831819-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06831926-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06832033-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06832140-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06832248-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06832356-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06832464-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06832572-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06832680-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06832788-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06832896-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06833004-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06833112-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06833220-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06833328-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06833436-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06833544-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06833663-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06833776-n',[ ('AlphabeticCharacter',subsumption)]).
nounMapping2SUMO('06833890-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06834138-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06834245-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06834351-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06834458-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06834565-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06834674-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06834780-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06834885-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06834992-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06835098-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06835206-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06835315-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06835420-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06835525-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06835630-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06835740-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06835845-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06835951-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06836059-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06836165-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06836275-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06836381-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06836493-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06836599-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06836714-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06836822-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06836929-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06837037-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06837146-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06837251-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06837357-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06837465-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06837572-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06837679-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06837787-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06837895-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06838005-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06838112-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06838219-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06838329-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06838437-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06838543-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06838652-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06838760-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06838868-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06838975-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06839083-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06839190-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06839411-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06839637-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06839737-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06839858-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06840047-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06840187-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06840442-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06840530-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06840648-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06840890-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06841159-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06841287-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06841365-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06841873-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06841987-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06842165-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06842290-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06842452-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06842660-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06842852-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06843017-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06843148-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06843393-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06843520-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06843838-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06844040-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06844199-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06844427-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06844509-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06844594-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06844739-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06844903-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06845076-n',[ ('Character',subsumption)]).
nounMapping2SUMO('06845199-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06845303-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06845599-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06851516-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06851742-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06855035-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06855207-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06855432-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06855563-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06855817-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06855985-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06856189-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('06856487-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06856568-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('06856884-n',[ ('MakingInstrumentalMusic',subsumption)]).
nounMapping2SUMO('06857122-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06857264-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('06857487-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06857591-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('06857726-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06857867-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06857986-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06858144-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06858266-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06858384-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06858539-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06858674-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06858779-n',[ ('IntervalFn',subsumption)]).
nounMapping2SUMO('06859056-n',[ ('IntervalFn',subsumption)]).
nounMapping2SUMO('06859175-n',[ ('IntervalFn',subsumption)]).
nounMapping2SUMO('06859309-n',[ ('IntervalFn',subsumption)]).
nounMapping2SUMO('06859401-n',[ ('IntervalFn',subsumption)]).
nounMapping2SUMO('06859504-n',[ ('IntervalFn',subsumption)]).
nounMapping2SUMO('06859674-n',[ ('IntervalFn',subsumption)]).
nounMapping2SUMO('06859800-n',[ ('IntervalFn',subsumption)]).
nounMapping2SUMO('06859925-n',[ ('IntervalFn',subsumption)]).
nounMapping2SUMO('06860049-n',[ ('IntervalFn',subsumption)]).
nounMapping2SUMO('06860177-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06860323-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06860481-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06860699-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06860826-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06861020-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06861196-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06861315-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06861435-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06861630-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06861860-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06862059-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06862202-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06862399-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06862562-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06862805-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06862954-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06863086-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06863209-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06863326-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06863442-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06863618-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06863751-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06864014-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06864192-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06864308-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06864407-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('06864524-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06864725-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06864900-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06865049-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06865177-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06865345-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06865953-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06866124-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06866332-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06866442-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06866599-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06866757-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06866919-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06867057-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06867218-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06867345-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06867510-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06867675-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06867880-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06868043-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06868309-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06868445-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06868582-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06868709-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06868844-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06868986-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06869129-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06869271-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06869428-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06869610-n',[ ('Music',subsumption)]).
nounMapping2SUMO('06869742-n',[ ('Music',subsumption)]).
nounMapping2SUMO('06869815-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06869951-n',[ ('Music',subsumption)]).
nounMapping2SUMO('06870211-n',[ ('Music',subsumption)]).
nounMapping2SUMO('06870349-n',[ ('Music',subsumption)]).
nounMapping2SUMO('06870437-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06870576-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06870726-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06870844-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06870965-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06871127-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06871262-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06871384-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06871534-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06871675-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06871828-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('06871983-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06872122-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('06872354-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('06872479-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('06872562-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('06872676-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('06872785-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('06872905-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('06873017-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('06873139-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('06873252-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06873571-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06873927-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06874019-n',[ ('ContentBearingObject',subsumption), ('LightFixture',subsumption)]).
nounMapping2SUMO('06874185-n',[ ('TrafficLight',subsumption)]).
nounMapping2SUMO('06874391-n',[ ('ContentBearingObject',subsumption), ('LightFixture',subsumption)]).
nounMapping2SUMO('06874497-n',[ ('ContentBearingObject',subsumption), ('LightFixture',subsumption)]).
nounMapping2SUMO('06874571-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06874688-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06874837-n',[ ('ContentBearingObject',subsumption), ('LightFixture',subsumption)]).
nounMapping2SUMO('06874930-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06875094-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06875288-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06875392-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06875552-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06875697-n',[ ('ConstructedLanguage',subsumption)]).
nounMapping2SUMO('06875883-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06876007-n',[ ('ConstructedLanguage',subsumption)]).
nounMapping2SUMO('06876144-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06876309-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06876771-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06876892-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06877008-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06877078-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06877381-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06877509-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06877578-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06877742-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06877849-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06877990-n',[ ('Smiling',subsumption)]).
nounMapping2SUMO('06878071-n',[ ('Smiling',subsumption)]).
nounMapping2SUMO('06878404-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06878580-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06878706-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06878803-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06878934-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06879056-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06879180-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06879521-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06879766-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('06880013-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06880134-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('06880249-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06880533-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('06880664-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06881224-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('06881360-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06881494-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06881563-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06881662-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06881798-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06882009-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06882138-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06882244-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06882333-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06882561-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06882953-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06883073-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06883274-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06883383-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06883460-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06883565-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06883725-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06883956-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06884097-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06884337-n',[ ('Icon',instance)]).
nounMapping2SUMO('06884520-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06884670-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06884790-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06884954-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06885083-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06885389-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06885906-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06886273-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06886488-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06886655-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06886818-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06887055-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06887278-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('06887441-n',[ ('ComputerPassword',subsumption)]).
nounMapping2SUMO('06887599-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('06887726-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06887962-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('06888174-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06888345-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06888506-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06888674-n',[ ('Advertising',subsumption)]).
nounMapping2SUMO('06888848-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06888944-n',[ ('VisualContentBearingObject',subsumption)]).
nounMapping2SUMO('06889138-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06889330-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06889591-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06889701-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06889875-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06890000-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06890128-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('06890254-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06890373-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('06890470-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('06890577-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('06890688-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06890846-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('06891022-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06891339-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('06891493-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('06892016-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('06892358-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('06892534-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('06892657-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('06892775-n',[ ('MusicalPerformance',subsumption)]).
nounMapping2SUMO('06892979-n',[ ('MusicalPerformance',subsumption)]).
nounMapping2SUMO('06893065-n',[ ('MusicalPerformance',subsumption)]).
nounMapping2SUMO('06893183-n',[ ('DramaticPerformance',subsumption)]).
nounMapping2SUMO('06893285-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('06893441-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('06893565-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('06893772-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('06893885-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('06894111-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('06894243-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('06894371-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('06894544-n',[ ('ConstructedLanguage',equivalence)]).
nounMapping2SUMO('06895176-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06895266-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06895396-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06895601-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06895684-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06895791-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06895940-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06896059-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06896304-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06896500-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06896623-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06896716-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06896856-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06896961-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06897042-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06897129-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06897205-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06897306-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06897381-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06897474-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06897553-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06897627-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06897797-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06897976-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06898052-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06898129-n',[ ('ConstructedLanguage',instance)]).
nounMapping2SUMO('06898352-n',[ ('ComputerLanguage',subsumption)]).
nounMapping2SUMO('06898794-n',[ ('ComputerLanguage',subsumption)]).
nounMapping2SUMO('06898972-n',[ ('ComputerLanguage',subsumption)]).
nounMapping2SUMO('06899110-n',[ ('ComputerLanguage',subsumption)]).
nounMapping2SUMO('06899310-n',[ ('ComputerLanguage',subsumption)]).
nounMapping2SUMO('06899446-n',[ ('ComputerLanguage',subsumption)]).
nounMapping2SUMO('06899633-n',[ ('ComputerLanguage',subsumption)]).
nounMapping2SUMO('06899845-n',[ ('ComputerLanguage',subsumption)]).
nounMapping2SUMO('06900005-n',[ ('ComputerLanguage',subsumption)]).
nounMapping2SUMO('06900156-n',[ ('Language',subsumption)]).
nounMapping2SUMO('06900282-n',[ ('ComputerLanguage',subsumption)]).
nounMapping2SUMO('06900507-n',[ ('ComputerLanguage',subsumption)]).
nounMapping2SUMO('06900684-n',[ ('ComputerLanguage',subsumption)]).
nounMapping2SUMO('06901053-n',[ ('ComputerLanguage',instance)]).
nounMapping2SUMO('06901163-n',[ ('ComputerLanguage',subsumption)]).
nounMapping2SUMO('06901333-n',[ ('ComputerLanguage',subsumption)]).
nounMapping2SUMO('06901471-n',[ ('ComputerLanguage',subsumption)]).
nounMapping2SUMO('06901591-n',[ ('ComputerLanguage',subsumption)]).
nounMapping2SUMO('06901764-n',[ ('ComputerLanguage',instance)]).
nounMapping2SUMO('06901936-n',[ ('ComputerLanguage',instance)]).
nounMapping2SUMO('06902109-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06902193-n',[ ('ComputerLanguage',instance)]).
nounMapping2SUMO('06902362-n',[ ('ComputerLanguage',instance)]).
nounMapping2SUMO('06902521-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06902611-n',[ ('ComputerLanguage',instance)]).
nounMapping2SUMO('06902696-n',[ ('ComputerLanguage',instance)]).
nounMapping2SUMO('06902831-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06902909-n',[ ('ComputerLanguage',instance)]).
nounMapping2SUMO('06903115-n',[ ('ComputerLanguage',instance)]).
nounMapping2SUMO('06903255-n',[ ('ComputerProgram',subsumption)]).
nounMapping2SUMO('06903396-n',[ ('Language',subsumption)]).
nounMapping2SUMO('06903519-n',[ ('Language',subsumption)]).
nounMapping2SUMO('06903699-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('06903972-n',[ ('Language',subsumption)]).
nounMapping2SUMO('06904171-n',[ ('NaturalLanguage',equivalence)]).
nounMapping2SUMO('06904748-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06904943-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06905141-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06905243-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06905358-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06905513-n',[ ('HatianCreoleFrenchLanguage',equivalence)]).
nounMapping2SUMO('06905680-n',[ ('PidginLanguage',equivalence)]).
nounMapping2SUMO('06905828-n',[ ('ChinookWawaLanguage',equivalence)]).
nounMapping2SUMO('06906028-n',[ ('SangoLanguage',equivalence)]).
nounMapping2SUMO('06906116-n',[ ('HumanLanguage',subsumption)]).
nounMapping2SUMO('06906439-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06906971-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06907567-n',[ ('AtakapaLanguage',equivalence)]).
nounMapping2SUMO('06907728-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06908048-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06908159-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06908291-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06908401-n',[ ('BiloxiLanguage',equivalence)]).
nounMapping2SUMO('06908494-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06908605-n',[ ('CatawbaLanguage',equivalence)]).
nounMapping2SUMO('06908700-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06908801-n',[ ('ChiwereLanguage',equivalence)]).
nounMapping2SUMO('06908968-n',[ ('IowaOtoLanguage',equivalence)]).
nounMapping2SUMO('06909079-n',[ ('MissouriValleyLanguage',subsumption)]).
nounMapping2SUMO('06909190-n',[ ('IowaOtoLanguage',equivalence)]).
nounMapping2SUMO('06909298-n',[ ('CreeLanguage',equivalence)]).
nounMapping2SUMO('06909391-n',[ ('CrowLanguage',equivalence)]).
nounMapping2SUMO('06909478-n',[ ('DakotaLanguage',equivalence)]).
nounMapping2SUMO('06909571-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06909672-n',[ ('DhegihaLanguage',equivalence)]).
nounMapping2SUMO('06909848-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06909932-n',[ ('HidatsaLanguage',equivalence)]).
nounMapping2SUMO('06910039-n',[ ('SiouanLanguage',subsumption)]).
nounMapping2SUMO('06910134-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06910238-n',[ ('NaDeneLanguage',subsumption)]).
nounMapping2SUMO('06910323-n',[ ('KansaLanguage',equivalence)]).
nounMapping2SUMO('06910423-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06910517-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06910639-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06910755-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06910868-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06910958-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06911067-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06911180-n',[ ('OfoLanguage',equivalence)]).
nounMapping2SUMO('06911265-n',[ ('SouianLanguage',subsumption)]).
nounMapping2SUMO('06911366-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06911484-n',[ ('OmahaPoncaLanguage',subsumption)]).
nounMapping2SUMO('06911575-n',[ ('OsageLanguage',equivalence)]).
nounMapping2SUMO('06911666-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06911758-n',[ ('OmahaPoncaLanguage',subsumption)]).
nounMapping2SUMO('06911857-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06911962-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06912056-n',[ ('QuapawLanguage',equivalence)]).
nounMapping2SUMO('06912149-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06912248-n',[ ('AlabamaLanguage',equivalence)]).
nounMapping2SUMO('06912340-n',[ ('ChickasawLanguage',equivalence)]).
nounMapping2SUMO('06912436-n',[ ('ChoctawLanguage',equivalence)]).
nounMapping2SUMO('06912537-n',[ ('MuskogeanLanguage',instance)]).
nounMapping2SUMO('06912638-n',[ ('KoasatiLanguage',equivalence)]).
nounMapping2SUMO('06912737-n',[ ('MuskogeeLanguage',equivalence)]).
nounMapping2SUMO('06912838-n',[ ('SiouanLanguage',instance)]).
nounMapping2SUMO('06912931-n',[ ('MuskogeanLanguage',instance)]).
nounMapping2SUMO('06913025-n',[ ('NaDeneLanguage',instance)]).
nounMapping2SUMO('06913121-n',[ ('TuteloLanguage',equivalence)]).
nounMapping2SUMO('06913214-n',[ ('WinnebagoLanguage',equivalence)]).
nounMapping2SUMO('06913313-n',[ ('MuskogeanLanguage',equivalence)]).
nounMapping2SUMO('06913635-n',[ ('NaDeneLanguage',equivalence)]).
nounMapping2SUMO('06913768-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06913948-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06914069-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06914167-n',[ ('SalishanLanguage',equivalence)]).
nounMapping2SUMO('06914331-n',[ ('SalishanLanguage',subsumption)]).
nounMapping2SUMO('06914423-n',[ ('WakashanLanguage',equivalence)]).
nounMapping2SUMO('06914612-n',[ ('KwakiutlLanguage',equivalence)]).
nounMapping2SUMO('06914709-n',[ ('NootkaLanguage',equivalence)]).
nounMapping2SUMO('06914802-n',[ ('UtoAztecanLanguage',instance)]).
nounMapping2SUMO('06914930-n',[ ('UtoAztecanLanguage',instance)]).
nounMapping2SUMO('06915031-n',[ ('UtoAztecanLanguage',instance)]).
nounMapping2SUMO('06915124-n',[ ('UtoAztecanLanguage',instance)]).
nounMapping2SUMO('06915221-n',[ ('UtoAztecanLanguage',instance)]).
nounMapping2SUMO('06915313-n',[ ('UtoAztecanLanguage',subsumption)]).
nounMapping2SUMO('06915601-n',[ ('CaddoLanguage',equivalence)]).
nounMapping2SUMO('06915821-n',[ ('ArikaraLanguage',equivalence)]).
nounMapping2SUMO('06915927-n',[ ('PawneeLanguage',equivalence)]).
nounMapping2SUMO('06916021-n',[ ('CaddoanLanguage',instance)]).
nounMapping2SUMO('06916117-n',[ ('CherokeeLanguage',equivalence)]).
nounMapping2SUMO('06916217-n',[ ('CayugaLanguage',equivalence)]).
nounMapping2SUMO('06916313-n',[ ('MohawkLanguage',equivalence)]).
nounMapping2SUMO('06916409-n',[ ('SenecaLanguage',equivalence)]).
nounMapping2SUMO('06916505-n',[ ('OneidaLanguage',equivalence)]).
nounMapping2SUMO('06916601-n',[ ('OnondagaLanguage',equivalence)]).
nounMapping2SUMO('06916701-n',[ ('TuscaroraLanguage',equivalence)]).
nounMapping2SUMO('06916803-n',[ ('IroquoianLanguage',equivalence)]).
nounMapping2SUMO('06917083-n',[ ('QuechuanLanguage',equivalence)]).
nounMapping2SUMO('06917280-n',[ ('GuaraniLanguage',equivalence)]).
nounMapping2SUMO('06917392-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06917497-n',[ ('TupiLanguage',equivalence)]).
nounMapping2SUMO('06917602-n',[ ('TupiLanguage',subsumption)]).
nounMapping2SUMO('06917764-n',[ ('ArawakanLanguage',equivalence)]).
nounMapping2SUMO('06917926-n',[ ('CaribLanguage',equivalence)]).
nounMapping2SUMO('06918042-n',[ ('EskimoAleutLanguage',equivalence)]).
nounMapping2SUMO('06918215-n',[ ('EskimoAleutLanguage',instance)]).
nounMapping2SUMO('06918312-n',[ ('EskimoAleutLanguage',instance)]).
nounMapping2SUMO('06918396-n',[ ('UtoAztecanLanguage',subsumption)]).
nounMapping2SUMO('06918640-n',[ ('UtoAztecanLanguage',instance)]).
nounMapping2SUMO('06918734-n',[ ('UtoAztecanLanguage',instance)]).
nounMapping2SUMO('06918832-n',[ ('UtoAztecanLanguage',instance)]).
nounMapping2SUMO('06918932-n',[ ('UtoAztecanLanguage',instance)]).
nounMapping2SUMO('06919023-n',[ ('UtoAztecanLanguage',instance)]).
nounMapping2SUMO('06919122-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06919215-n',[ ('MayanLanguage',equivalence)]).
nounMapping2SUMO('06919433-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06919548-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06919630-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06919712-n',[ ('NavajoLanguage',equivalence)]).
nounMapping2SUMO('06919818-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06919911-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06920010-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06920129-n',[ ('SiouanLanguage',equivalence)]).
nounMapping2SUMO('06920497-n',[ ('KiowaTanoanLanguage',subsumption)]).
nounMapping2SUMO('06920665-n',[ ('KiowaTanoanLanguage',instance)]).
nounMapping2SUMO('06920756-n',[ ('HokanLanguage',equivalence)]).
nounMapping2SUMO('06920994-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06921092-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06921186-n',[ ('HokanLanguage',subsumption)]).
nounMapping2SUMO('06921300-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06921392-n',[ ('HokanLanguage',subsumption)]).
nounMapping2SUMO('06921506-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06921593-n',[ ('HokanLanguage',subsumption)]).
nounMapping2SUMO('06921755-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06921853-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06921951-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06922045-n',[ ('HokanLanguage',subsumption)]).
nounMapping2SUMO('06922389-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06922485-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06922579-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06922681-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06922777-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06922875-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06922965-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06923066-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06923182-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06923283-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06923398-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06923492-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06923580-n',[ ('HokanLanguage',subsumption)]).
nounMapping2SUMO('06923704-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06923792-n',[ ('HokanLanguage',instance)]).
nounMapping2SUMO('06923880-n',[ ('PenutianLanguage',equivalence)]).
nounMapping2SUMO('06924214-n',[ ('PenutianLanguage',subsumption)]).
nounMapping2SUMO('06924376-n',[ ('PenutianLanguage',instance)]).
nounMapping2SUMO('06924468-n',[ ('PenutianLanguage',instance)]).
nounMapping2SUMO('06924560-n',[ ('PenutianLanguage',instance)]).
nounMapping2SUMO('06924659-n',[ ('PenutianLanguage',instance)]).
nounMapping2SUMO('06924790-n',[ ('PenutianLanguage',instance)]).
nounMapping2SUMO('06924895-n',[ ('PenutianLanguage',instance)]).
nounMapping2SUMO('06924996-n',[ ('PenutianLanguage',instance)]).
nounMapping2SUMO('06925103-n',[ ('PenutianLanguage',instance)]).
nounMapping2SUMO('06925214-n',[ ('PenutianLanguage',instance)]).
nounMapping2SUMO('06925305-n',[ ('PenutianLanguage',instance)]).
nounMapping2SUMO('06925435-n',[ ('PenutianLanguage',instance)]).
nounMapping2SUMO('06925538-n',[ ('PenutianLanguage',instance)]).
nounMapping2SUMO('06925644-n',[ ('PenutianLanguage',instance)]).
nounMapping2SUMO('06925743-n',[ ('MayanLanguage',instance)]).
nounMapping2SUMO('06925833-n',[ ('MayanLanguage',instance)]).
nounMapping2SUMO('06925917-n',[ ('MayanLanguage',instance)]).
nounMapping2SUMO('06926020-n',[ ('MayanLanguage',instance)]).
nounMapping2SUMO('06926112-n',[ ('MayanLanguage',instance)]).
nounMapping2SUMO('06926212-n',[ ('AltaicLanguage',equivalence)]).
nounMapping2SUMO('06926458-n',[ ('TurkicLanguage',equivalence)]).
nounMapping2SUMO('06926798-n',[ ('TurkishLanguage',equivalence)]).
nounMapping2SUMO('06926889-n',[ ('TurkmenianLanguage',equivalence)]).
nounMapping2SUMO('06927007-n',[ ('AzerbaijaniLanguage',equivalence)]).
nounMapping2SUMO('06927128-n',[ ('KazakhLanguage',equivalence)]).
nounMapping2SUMO('06927228-n',[ ('TatarLanguage',equivalence)]).
nounMapping2SUMO('06927363-n',[ ('EasternTurkicLanguage',instance)]).
nounMapping2SUMO('06927486-n',[ ('UyghurLanguage',equivalence)]).
nounMapping2SUMO('06927645-n',[ ('TurkicLanguage',instance)]).
nounMapping2SUMO('06927736-n',[ ('KyrgyzLanguage',equivalence)]).
nounMapping2SUMO('06927851-n',[ ('TurkicLanguage',instance)]).
nounMapping2SUMO('06927952-n',[ ('ChuvashLanguage',equivalence)]).
nounMapping2SUMO('06928047-n',[ ('ChagataiLanguage',equivalence)]).
nounMapping2SUMO('06928234-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06928430-n',[ ('AltaicLanguage',subsumption)]).
nounMapping2SUMO('06928610-n',[ ('AltaicLanguage',instance)]).
nounMapping2SUMO('06928744-n',[ ('AltaicLanguage',instance)]).
nounMapping2SUMO('06928839-n',[ ('MongolianLanguage',equivalence)]).
nounMapping2SUMO('06929008-n',[ ('MongolianLanguage',instance)]).
nounMapping2SUMO('06929171-n',[ ('KoreanLanguage',equivalence)]).
nounMapping2SUMO('06929279-n',[ ('JapaneseLanguage',equivalence)]).
nounMapping2SUMO('06929459-n',[ ('RyukyuanLanguage',equivalence)]).
nounMapping2SUMO('06929618-n',[ ('ChineseLanguage',subsumption)]).
nounMapping2SUMO('06929742-n',[ ('ChineseLanguage',equivalence)]).
nounMapping2SUMO('06930093-n',[ ('ChineseLanguage',instance)]).
nounMapping2SUMO('06930298-n',[ ('ChineseLanguage',instance)]).
nounMapping2SUMO('06930427-n',[ ('ChineseLanguage',instance)]).
nounMapping2SUMO('06930633-n',[ ('ChineseLanguage',instance)]).
nounMapping2SUMO('06930804-n',[ ('ChineseLanguage',instance)]).
nounMapping2SUMO('06930934-n',[ ('ChineseLanguage',equivalence)]).
nounMapping2SUMO('06931199-n',[ ('TibetanLanguage',subsumption)]).
nounMapping2SUMO('06931499-n',[ ('TibetanLanguage',instance)]).
nounMapping2SUMO('06931605-n',[ ('TibetanLanguage',instance)]).
nounMapping2SUMO('06931724-n',[ ('TibetanLanguage',instance)]).
nounMapping2SUMO('06931891-n',[ ('TibetanLanguage',instance)]).
nounMapping2SUMO('06932130-n',[ ('TibetanLanguage',instance)]).
nounMapping2SUMO('06932265-n',[ ('TibetanLanguage',instance)]).
nounMapping2SUMO('06932435-n',[ ('BurmeseLanguage',instance)]).
nounMapping2SUMO('06932537-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06932734-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06932803-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06932879-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06932948-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06933022-n',[ ('TibetanLanguage',subsumption)]).
nounMapping2SUMO('06933185-n',[ ('TibetanLanguage',instance)]).
nounMapping2SUMO('06933279-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06933429-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06933546-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06933689-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06933824-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06933931-n',[ ('TibetanLanguage',instance)]).
nounMapping2SUMO('06934020-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06934132-n',[ ('TibetanLanguage',subsumption)]).
nounMapping2SUMO('06934309-n',[ ('TibetanLanguage',subsumption)]).
nounMapping2SUMO('06934389-n',[ ('TaiKadaiLanguage',equivalence)]).
nounMapping2SUMO('06934848-n',[ ('TaiKadaiLanguage',subsumption)]).
nounMapping2SUMO('06934933-n',[ ('TaiKadaiLanguage',subsumption)]).
nounMapping2SUMO('06935016-n',[ ('TaiKadaiLanguage',subsumption)]).
nounMapping2SUMO('06935111-n',[ ('TaiKadaiLanguage',subsumption)]).
nounMapping2SUMO('06935223-n',[ ('TaiKadaiLanguage',subsumption)]).
nounMapping2SUMO('06935314-n',[ ('TaiKadaiLanguage',subsumption)]).
nounMapping2SUMO('06935417-n',[ ('TaiKadaiLanguage',subsumption)]).
nounMapping2SUMO('06935513-n',[ ('TaiKadaiLanguage',subsumption)]).
nounMapping2SUMO('06935594-n',[ ('LaoLanguage',equivalence)]).
nounMapping2SUMO('06935741-n',[ ('TaiKadaiLanguage',subsumption)]).
nounMapping2SUMO('06935823-n',[ ('TaiKadaiLanguage',subsumption)]).
nounMapping2SUMO('06935911-n',[ ('TaiKadaiLanguage',subsumption)]).
nounMapping2SUMO('06935990-n',[ ('TaiKadaiLanguage',subsumption)]).
nounMapping2SUMO('06936070-n',[ ('TaiKadaiLanguage',subsumption)]).
nounMapping2SUMO('06936149-n',[ ('ThaiLanguage',equivalence)]).
nounMapping2SUMO('06936290-n',[ ('TaiKadaiLanguage',subsumption)]).
nounMapping2SUMO('06936379-n',[ ('ZhuangLanguage',equivalence)]).
nounMapping2SUMO('06936461-n',[ ('TaiKadaiLanguage',subsumption)]).
nounMapping2SUMO('06936540-n',[ ('TaiKadaiLanguage',subsumption)]).
nounMapping2SUMO('06936620-n',[ ('AustroAsiaticLanguage',equivalence)]).
nounMapping2SUMO('06936823-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06936948-n',[ ('AustroAsiaticLanguage',subsumption)]).
nounMapping2SUMO('06937098-n',[ ('HmongMienLanguage',subsumption)]).
nounMapping2SUMO('06937229-n',[ ('VietnameseLanguage',equivalence)]).
nounMapping2SUMO('06937348-n',[ ('KhmerLanguage',equivalence)]).
nounMapping2SUMO('06937441-n',[ ('AustroAsiaticLanguage',subsumption)]).
nounMapping2SUMO('06937531-n',[ ('AustronesianLanguage',equivalence)]).
nounMapping2SUMO('06937768-n',[ ('AustronesianLanguage',subsumption)]).
nounMapping2SUMO('06937985-n',[ ('AustronesianLanguage',subsumption)]).
nounMapping2SUMO('06938190-n',[ ('TonganLanguage',equivalence)]).
nounMapping2SUMO('06938294-n',[ ('TahitianLanguage',equivalence)]).
nounMapping2SUMO('06938386-n',[ ('MaoriLanguage',equivalence)]).
nounMapping2SUMO('06938493-n',[ ('AustronesianLanguage',instance)]).
nounMapping2SUMO('06938623-n',[ ('FijianLanguage',equivalence)]).
nounMapping2SUMO('06938729-n',[ ('FijianLanguage',subsumption)]).
nounMapping2SUMO('06938887-n',[ ('AustronesianLanguage',subsumption)]).
nounMapping2SUMO('06939051-n',[ ('MalayLanguage',equivalence)]).
nounMapping2SUMO('06939198-n',[ ('IndonesianLanguage',equivalence)]).
nounMapping2SUMO('06939431-n',[ ('JavaneseLanguage',equivalence)]).
nounMapping2SUMO('06939542-n',[ ('SundaneseLanguage',equivalence)]).
nounMapping2SUMO('06939656-n',[ ('IndonesianLanguage',subsumption)]).
nounMapping2SUMO('06939756-n',[ ('TagalogLanguage',subsumption)]).
nounMapping2SUMO('06940001-n',[ ('TagalogLanguage',equivalence)]).
nounMapping2SUMO('06940109-n',[ ('AustronesianLanguage',instance)]).
nounMapping2SUMO('06940290-n',[ ('AustralianLanguage',equivalence)]).
nounMapping2SUMO('06940502-n',[ ('AustralianLanguage',instance)]).
nounMapping2SUMO('06940601-n',[ ('AustralianLanguage',instance)]).
nounMapping2SUMO('06940701-n',[ ('AustronesianLanguage',subsumption)]).
nounMapping2SUMO('06940854-n',[ ('AustronesianLanguage',instance)]).
nounMapping2SUMO('06940969-n',[ ('AustronesianLanguage',instance)]).
nounMapping2SUMO('06941041-n',[ ('AustronesianLanguage',instance)]).
nounMapping2SUMO('06941115-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06941341-n',[ ('KhoisanLanguage',equivalence)]).
nounMapping2SUMO('06941479-n',[ ('KhoisanLanguage',subsumption)]).
nounMapping2SUMO('06941644-n',[ ('IndoEuropeanLanguage',equivalence)]).
nounMapping2SUMO('06942094-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06942252-n',[ ('AlbanianLanguage',equivalence)]).
nounMapping2SUMO('06942419-n',[ ('GhegAlbanianLanguage',equivalence)]).
nounMapping2SUMO('06942550-n',[ ('ToskAlbanianLanguage',equivalence)]).
nounMapping2SUMO('06942699-n',[ ('ArmenianLanguage',equivalence)]).
nounMapping2SUMO('06942874-n',[ ('IndoEuropeanLanguage',subsumption)]).
nounMapping2SUMO('06943027-n',[ ('IndoEuropeanLanguage',subsumption)]).
nounMapping2SUMO('06943221-n',[ ('IndoEuropeanLanguage',instance)]).
nounMapping2SUMO('06943378-n',[ ('IndoEuropeanLanguage',instance)]).
nounMapping2SUMO('06943558-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06943771-n',[ ('SlavicLanguage',equivalence)]).
nounMapping2SUMO('06944156-n',[ ('OldChurchSlavonicLanguage',equivalence)]).
nounMapping2SUMO('06944348-n',[ ('RussianLanguage',equivalence)]).
nounMapping2SUMO('06944480-n',[ ('BelarusanLanguage',equivalence)]).
nounMapping2SUMO('06944623-n',[ ('UkrainianLanguage',equivalence)]).
nounMapping2SUMO('06944720-n',[ ('PolishLanguage',equivalence)]).
nounMapping2SUMO('06944820-n',[ ('SlovakLanguage',equivalence)]).
nounMapping2SUMO('06944911-n',[ ('CzechLanguage',equivalence)]).
nounMapping2SUMO('06945010-n',[ ('SlovenianLanguage',equivalence)]).
nounMapping2SUMO('06945095-n',[ ('SerboCroatianLanguage',equivalence)]).
nounMapping2SUMO('06945344-n',[ ('SorbianLanguage',equivalence)]).
nounMapping2SUMO('06945473-n',[ ('MacedonianLanguage',equivalence)]).
nounMapping2SUMO('06945569-n',[ ('BulgarianLanguage',equivalence)]).
nounMapping2SUMO('06945679-n',[ ('BalticLanguage',equivalence)]).
nounMapping2SUMO('06946017-n',[ ('IndoEuropeanLanguage',subsumption)]).
nounMapping2SUMO('06946199-n',[ ('LithuanianLanguage',equivalence)]).
nounMapping2SUMO('06946355-n',[ ('LatvianLanguage',equivalence)]).
nounMapping2SUMO('06946497-n',[ ('GermanicLanguage',equivalence)]).
nounMapping2SUMO('06946823-n',[ ('WestGermanicLanguage',equivalence)]).
nounMapping2SUMO('06947032-n',[ ('EnglishLanguage',equivalence)]).
nounMapping2SUMO('06947479-n',[ ('EnglishLanguage',subsumption)]).
nounMapping2SUMO('06947658-n',[ ('EnglishLanguage',equivalence)]).
nounMapping2SUMO('06948017-n',[ ('EnglishLanguage',subsumption)]).
nounMapping2SUMO('06948149-n',[ ('EnglishLanguage',subsumption)]).
nounMapping2SUMO('06948260-n',[ ('EnglishLanguage',subsumption)]).
nounMapping2SUMO('06948396-n',[ ('EnglishLanguage',subsumption)]).
nounMapping2SUMO('06948761-n',[ ('EnglishLanguage',subsumption)]).
nounMapping2SUMO('06948943-n',[ ('EnglishLanguage',subsumption)]).
nounMapping2SUMO('06949121-n',[ ('EnglishLanguage',subsumption)]).
nounMapping2SUMO('06949207-n',[ ('ScotsLanguage',equivalence)]).
nounMapping2SUMO('06949326-n',[ ('EnglishLanguage',subsumption)]).
nounMapping2SUMO('06949407-n',[ ('EnglishLanguage',subsumption)]).
nounMapping2SUMO('06949506-n',[ ('EnglishLanguage',subsumption)]).
nounMapping2SUMO('06949591-n',[ ('EnglishLanguage',subsumption)]).
nounMapping2SUMO('06949762-n',[ ('EnglishLanguage',subsumption)]).
nounMapping2SUMO('06949852-n',[ ('EnglishLanguage',subsumption)]).
nounMapping2SUMO('06949946-n',[ ('EnglishLanguage',subsumption)]).
nounMapping2SUMO('06950049-n',[ ('EnglishLanguage',subsumption)]).
nounMapping2SUMO('06950209-n',[ ('EnglishLanguage',subsumption)]).
nounMapping2SUMO('06950400-n',[ ('ScotsLanguage',equivalence)]).
nounMapping2SUMO('06950528-n',[ ('GermanLanguage',equivalence)]).
nounMapping2SUMO('06950886-n',[ ('HighGermanLanguage',subsumption)]).
nounMapping2SUMO('06950973-n',[ ('HighGermanLanguage',subsumption)]).
nounMapping2SUMO('06951067-n',[ ('YiddishLanguage',equivalence)]).
nounMapping2SUMO('06952115-n',[ ('PennsylvaniaGermanLanguage',equivalence)]).
nounMapping2SUMO('06952249-n',[ ('PlautdietschLanguage',equivalence)]).
nounMapping2SUMO('06952400-n',[ ('PlautdietschLanguage',subsumption)]).
nounMapping2SUMO('06952480-n',[ ('PlautdietschLanguage',subsumption)]).
nounMapping2SUMO('06952572-n',[ ('DutchLanguage',equivalence)]).
nounMapping2SUMO('06952705-n',[ ('VlaamsLanguage',equivalence)]).
nounMapping2SUMO('06952861-n',[ ('AfrikaansLanguage',equivalence)]).
nounMapping2SUMO('06953054-n',[ ('GermanicLanguage',instance)]).
nounMapping2SUMO('06953167-n',[ ('GermanicLanguage',instance)]).
nounMapping2SUMO('06953332-n',[ ('GermanicLanguage',instance)]).
nounMapping2SUMO('06953471-n',[ ('Text',subsumption)]).
nounMapping2SUMO('06953731-n',[ ('NorthGermanicLanguage',equivalence)]).
nounMapping2SUMO('06954048-n',[ ('DanishLanguage',equivalence)]).
nounMapping2SUMO('06954183-n',[ ('IcelandicLanguage',equivalence)]).
nounMapping2SUMO('06954303-n',[ ('NorwegianLanguage',equivalence)]).
nounMapping2SUMO('06954461-n',[ ('BokmalNorwegianLanguage',equivalence)]).
nounMapping2SUMO('06954640-n',[ ('BokmalNorwegianLanguage',subsumption)]).
nounMapping2SUMO('06954768-n',[ ('NynorskNorwegianLanguage',equivalence)]).
nounMapping2SUMO('06954925-n',[ ('SwedishLanguage',equivalence)]).
nounMapping2SUMO('06955087-n',[ ('FaroeseLanguage',equivalence)]).
nounMapping2SUMO('06955242-n',[ ('FrisianLanguage',equivalence)]).
nounMapping2SUMO('06955418-n',[ ('FrisianLanguage',subsumption)]).
nounMapping2SUMO('06955560-n',[ ('EastGermanicLanguage',equivalence)]).
nounMapping2SUMO('06955706-n',[ ('GothicLanguage',equivalence)]).
nounMapping2SUMO('06955931-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06956129-n',[ ('UralicLanguage',equivalence)]).
nounMapping2SUMO('06956287-n',[ ('UralicLanguage',subsumption)]).
nounMapping2SUMO('06956544-n',[ ('UralicLanguage',subsumption)]).
nounMapping2SUMO('06956794-n',[ ('UralicLanguage',instance)]).
nounMapping2SUMO('06956896-n',[ ('UralicLanguage',subsumption)]).
nounMapping2SUMO('06957042-n',[ ('KomiLanguage',equivalence)]).
nounMapping2SUMO('06957140-n',[ ('UralicLanguage',subsumption)]).
nounMapping2SUMO('06957287-n',[ ('UralicLanguage',instance)]).
nounMapping2SUMO('06957403-n',[ ('UralicLanguage',instance)]).
nounMapping2SUMO('06957524-n',[ ('UralicLanguage',subsumption)]).
nounMapping2SUMO('06957768-n',[ ('UralicLanguage',instance)]).
nounMapping2SUMO('06957896-n',[ ('EstonianLanguage',equivalence)]).
nounMapping2SUMO('06958063-n',[ ('UralicLanguage',instance)]).
nounMapping2SUMO('06958178-n',[ ('UralicLanguage',instance)]).
nounMapping2SUMO('06958255-n',[ ('FinnishLanguage',equivalence)]).
nounMapping2SUMO('06958417-n',[ ('UralicLanguage',instance)]).
nounMapping2SUMO('06958522-n',[ ('UralicLanguage',instance)]).
nounMapping2SUMO('06958615-n',[ ('UralicLanguage',subsumption)]).
nounMapping2SUMO('06958836-n',[ ('HungarianLanguage',equivalence)]).
nounMapping2SUMO('06959018-n',[ ('UralicLanguage',instance)]).
nounMapping2SUMO('06959140-n',[ ('UralicLanguage',instance)]).
nounMapping2SUMO('06959261-n',[ ('UralicLanguage',subsumption)]).
nounMapping2SUMO('06959427-n',[ ('NorthernSamiLanguage',equivalence)]).
nounMapping2SUMO('06959584-n',[ ('UralicLanguage',subsumption)]).
nounMapping2SUMO('06959788-n',[ ('UralicLanguage',instance)]).
nounMapping2SUMO('06959932-n',[ ('UralicLanguage',instance)]).
nounMapping2SUMO('06960083-n',[ ('UralicLanguage',instance)]).
nounMapping2SUMO('06960180-n',[ ('UralicLanguage',instance)]).
nounMapping2SUMO('06960298-n',[ ('CelticLanguage',equivalence)]).
nounMapping2SUMO('06960566-n',[ ('GoidelicLanguage',equivalence)]).
nounMapping2SUMO('06960778-n',[ ('IrishGaelicLanguage',equivalence)]).
nounMapping2SUMO('06960948-n',[ ('IrishGaelicLanguage',subsumption)]).
nounMapping2SUMO('06961033-n',[ ('IrishGaelicLanguage',subsumption)]).
nounMapping2SUMO('06961122-n',[ ('ScotsGaelicLanguage',subsumption)]).
nounMapping2SUMO('06961221-n',[ ('ManxLanguage',equivalence)]).
nounMapping2SUMO('06961399-n',[ ('BrythonicLanguage',equivalence)]).
nounMapping2SUMO('06961557-n',[ ('WelshLanguage',equivalence)]).
nounMapping2SUMO('06961681-n',[ ('CornishLanguage',equivalence)]).
nounMapping2SUMO('06961771-n',[ ('BretonLanguage',equivalence)]).
nounMapping2SUMO('06961853-n',[ ('ItalicLanguage',equivalence)]).
nounMapping2SUMO('06962060-n',[ ('ItalicLanguage',subsumption)]).
nounMapping2SUMO('06962244-n',[ ('ItalicLanguage',instance)]).
nounMapping2SUMO('06962350-n',[ ('ItalicLanguage',instance)]).
nounMapping2SUMO('06962454-n',[ ('ItalicLanguage',instance)]).
nounMapping2SUMO('06962600-n',[ ('LatinLanguage',equivalence)]).
nounMapping2SUMO('06962954-n',[ ('LatinLanguage',subsumption)]).
nounMapping2SUMO('06963082-n',[ ('LatinLanguage',subsumption)]).
nounMapping2SUMO('06963292-n',[ ('LatinLanguage',subsumption)]).
nounMapping2SUMO('06963429-n',[ ('LatinLanguage',subsumption)]).
nounMapping2SUMO('06963571-n',[ ('LatinLanguage',subsumption)]).
nounMapping2SUMO('06963704-n',[ ('LatinLanguage',subsumption)]).
nounMapping2SUMO('06963822-n',[ ('LatinLanguage',subsumption)]).
nounMapping2SUMO('06963951-n',[ ('RomanceLanguage',equivalence)]).
nounMapping2SUMO('06964247-n',[ ('ItalianLanguage',equivalence)]).
nounMapping2SUMO('06964485-n',[ ('ItalianLanguage',subsumption)]).
nounMapping2SUMO('06964600-n',[ ('SardinianLanguage',equivalence)]).
nounMapping2SUMO('06964788-n',[ ('ItalianLanguage',subsumption)]).
nounMapping2SUMO('06964901-n',[ ('FrenchLanguage',equivalence)]).
nounMapping2SUMO('06965249-n',[ ('OielLanguage',subsumption)]).
nounMapping2SUMO('06965406-n',[ ('OielLanguage',subsumption)]).
nounMapping2SUMO('06965580-n',[ ('OielLanguage',subsumption)]).
nounMapping2SUMO('06965698-n',[ ('OielLanguage',subsumption)]).
nounMapping2SUMO('06965834-n',[ ('FrenchLanguage',subsumption)]).
nounMapping2SUMO('06965961-n',[ ('FrenchLanguage',subsumption)]).
nounMapping2SUMO('06966070-n',[ ('WalloonLanguage',equivalence)]).
nounMapping2SUMO('06966190-n',[ ('OielLanguage',subsumption)]).
nounMapping2SUMO('06966310-n',[ ('PortugueseLanguage',equivalence)]).
nounMapping2SUMO('06966454-n',[ ('GalicianLanguage',equivalence)]).
nounMapping2SUMO('06966695-n',[ ('BasqueLanguage',equivalence)]).
nounMapping2SUMO('06966825-n',[ ('SpanishLanguage',equivalence)]).
nounMapping2SUMO('06967185-n',[ ('CastilianLanguage',subsumption)]).
nounMapping2SUMO('06967282-n',[ ('LadinoLanguage',equivalence)]).
nounMapping2SUMO('06967428-n',[ ('SpanishLanguage',subsumption)]).
nounMapping2SUMO('06967529-n',[ ('CatalanValencianBalearLanguage',equivalence)]).
nounMapping2SUMO('06967710-n',[ ('RhaetianLanguage',equivalence)]).
nounMapping2SUMO('06967935-n',[ ('FriulianLanguage',equivalence)]).
nounMapping2SUMO('06968052-n',[ ('LadinLanguage',equivalence)]).
nounMapping2SUMO('06968174-n',[ ('RomanschLanguage',equivalence)]).
nounMapping2SUMO('06968343-n',[ ('RomanianLanguage',equivalence)]).
nounMapping2SUMO('06968454-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06968601-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06968707-n',[ ('IndoEuropeanLanguage',subsumption)]).
nounMapping2SUMO('06968909-n',[ ('IndoEuropeanLanguage',instance)]).
nounMapping2SUMO('06969018-n',[ ('IndoEuropeanLanguage',instance)]).
nounMapping2SUMO('06969129-n',[ ('SanskritLanguage',equivalence)]).
nounMapping2SUMO('06969705-n',[ ('SindhiLanguage',equivalence)]).
nounMapping2SUMO('06969822-n',[ ('RomaniGroupLanguage',instance)]).
nounMapping2SUMO('06969916-n',[ ('UrduLanguage',equivalence)]).
nounMapping2SUMO('06970103-n',[ ('HindiLanguage',equivalence)]).
nounMapping2SUMO('06970373-n',[ ('HindiLanguage',subsumption)]).
nounMapping2SUMO('06970510-n',[ ('BihariLanguage',equivalence)]).
nounMapping2SUMO('06970645-n',[ ('IndoIranianLanguage',subsumption)]).
nounMapping2SUMO('06970784-n',[ ('AssameseLanguage',equivalence)]).
nounMapping2SUMO('06970946-n',[ ('BengaliLanguage',equivalence)]).
nounMapping2SUMO('06971123-n',[ ('OriyaLanguage',equivalence)]).
nounMapping2SUMO('06971281-n',[ ('MarathiLanguage',equivalence)]).
nounMapping2SUMO('06971454-n',[ ('GujaratiGroupLanguage',instance)]).
nounMapping2SUMO('06971605-n',[ ('PanjabiGroupLanguage',instance)]).
nounMapping2SUMO('06971741-n',[ ('SinhaleseLanguage',equivalence)]).
nounMapping2SUMO('06971872-n',[ ('IndoIranianLanguage',equivalence)]).
nounMapping2SUMO('06972090-n',[ ('IndoAryanLanguage',equivalence)]).
nounMapping2SUMO('06972311-n',[ ('DardicLanguage',equivalence)]).
nounMapping2SUMO('06972558-n',[ ('DardicLanguage',instance)]).
nounMapping2SUMO('06972654-n',[ ('DardicLanguage',instance)]).
nounMapping2SUMO('06972756-n',[ ('DardicLanguage',instance)]).
nounMapping2SUMO('06972874-n',[ ('KashmiriLanguage',equivalence)]).
nounMapping2SUMO('06972985-n',[ ('NepaliLanguage',equivalence)]).
nounMapping2SUMO('06973092-n',[ ('IndoAryanLanguage',subsumption)]).
nounMapping2SUMO('06973334-n',[ ('PaliLanguage',equivalence)]).
nounMapping2SUMO('06973505-n',[ ('IndoAryanLanguage',subsumption)]).
nounMapping2SUMO('06973610-n',[ ('IranianLanguage',equivalence)]).
nounMapping2SUMO('06973941-n',[ ('AvestanLanguage',equivalence)]).
nounMapping2SUMO('06974047-n',[ ('IndoIranianLanguage',instance)]).
nounMapping2SUMO('06974127-n',[ ('PersianLanguage',subsumption)]).
nounMapping2SUMO('06974283-n',[ ('DariLanguage',equivalence)]).
nounMapping2SUMO('06974390-n',[ ('TajikiLanguage',equivalence)]).
nounMapping2SUMO('06974558-n',[ ('KurdishLanguage',equivalence)]).
nounMapping2SUMO('06974687-n',[ ('BalochiLanguage',equivalence)]).
nounMapping2SUMO('06974846-n',[ ('PersianLanguage',subsumption)]).
nounMapping2SUMO('06975007-n',[ ('IndoIranianLanguage',instance)]).
nounMapping2SUMO('06975132-n',[ ('PashtoLanguage',equivalence)]).
nounMapping2SUMO('06975368-n',[ ('OsseticLanguage',equivalence)]).
nounMapping2SUMO('06975469-n',[ ('IndoIranianLanguage',instance)]).
nounMapping2SUMO('06975594-n',[ ('IndoEuropeanLanguage',subsumption)]).
nounMapping2SUMO('06975902-n',[ ('IndoEuropeanLanguage',instance)]).
nounMapping2SUMO('06976087-n',[ ('IndoEuropeanLanguage',instance)]).
nounMapping2SUMO('06976161-n',[ ('IndoEuropeanLanguage',instance)]).
nounMapping2SUMO('06976244-n',[ ('IndoEuropeanLanguage',instance)]).
nounMapping2SUMO('06976318-n',[ ('IndoEuropeanLanguage',instance)]).
nounMapping2SUMO('06976392-n',[ ('GreekGroupLanguage',equivalence)]).
nounMapping2SUMO('06976680-n',[ ('GreekLanguage',equivalence)]).
nounMapping2SUMO('06976833-n',[ ('GreekLanguage',subsumption)]).
nounMapping2SUMO('06976959-n',[ ('GreekLanguage',subsumption)]).
nounMapping2SUMO('06977087-n',[ ('GreekGroupLanguage',instance)]).
nounMapping2SUMO('06977190-n',[ ('GreekGroupLanguage',instance)]).
nounMapping2SUMO('06977328-n',[ ('AncientGreekLanguage',equivalence)]).
nounMapping2SUMO('06977434-n',[ ('AncientGreekLanguage',subsumption)]).
nounMapping2SUMO('06977610-n',[ ('AtticGreekLanguage',instance)]).
nounMapping2SUMO('06977800-n',[ ('AtticGreekLanguage',instance)]).
nounMapping2SUMO('06977948-n',[ ('AtticGreekLanguage',instance)]).
nounMapping2SUMO('06978068-n',[ ('AtticGreekLanguage',instance)]).
nounMapping2SUMO('06978180-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06978422-n',[ ('ChechenLanguage',equivalence)]).
nounMapping2SUMO('06978527-n',[ ('NorthCaucasianLanguage',instance)]).
nounMapping2SUMO('06978656-n',[ ('AbkhazLanguage',equivalence)]).
nounMapping2SUMO('06978766-n',[ ('GeorgianLanguage',equivalence)]).
nounMapping2SUMO('06978904-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06979014-n',[ ('DravidianLanguage',equivalence)]).
nounMapping2SUMO('06979249-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06979492-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06979645-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06979743-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06979853-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06979957-n',[ ('KannadaLanguage',equivalence)]).
nounMapping2SUMO('06980085-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06980175-n',[ ('MalayalamLanguage',equivalence)]).
nounMapping2SUMO('06980315-n',[ ('TamilLanguage',equivalence)]).
nounMapping2SUMO('06980465-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06980721-n',[ ('TeluguLanguage',equivalence)]).
nounMapping2SUMO('06980837-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06980971-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06981085-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06981187-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06981289-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06981401-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06981498-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06981706-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06981818-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06981920-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06982022-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06982125-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06982221-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06982391-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06982487-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06982581-n',[ ('DravidianLanguage',instance)]).
nounMapping2SUMO('06982697-n',[ ('HausaLanguage',equivalence)]).
nounMapping2SUMO('06982855-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06982989-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06983114-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06983225-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06983320-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06983416-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06983521-n',[ ('ChadicLanguage',subsumption)]).
nounMapping2SUMO('06983795-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06983895-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06983997-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06984101-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06984247-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06984351-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06984446-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06984556-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06984650-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06984746-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06984858-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06984953-n',[ ('ChadicLanguage',subsumption)]).
nounMapping2SUMO('06985310-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06985404-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06985490-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06985573-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06985722-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06985807-n',[ ('ChadicLanguage',instance)]).
nounMapping2SUMO('06985892-n',[ ('ChadicLanguage',subsumption)]).
nounMapping2SUMO('06986100-n',[ ('ChadicLanguage',subsumption)]).
nounMapping2SUMO('06986276-n',[ ('ChadicLanguage',equivalence)]).
nounMapping2SUMO('06986558-n',[ ('AfroAsiaticLanguage',equivalence)]).
nounMapping2SUMO('06986894-n',[ ('SemiticLanguage',equivalence)]).
nounMapping2SUMO('06987124-n',[ ('HebrewLanguage',equivalence)]).
nounMapping2SUMO('06987409-n',[ ('HebrewLanguage',equivalence)]).
nounMapping2SUMO('06987525-n',[ ('SemiticLanguage',subsumption)]).
nounMapping2SUMO('06987659-n',[ ('SemiticLanguage',instance)]).
nounMapping2SUMO('06987812-n',[ ('AmharicLanguage',equivalence)]).
nounMapping2SUMO('06988057-n',[ ('ArabicLanguage',equivalence)]).
nounMapping2SUMO('06988307-n',[ ('SemiticLanguage',instance)]).
nounMapping2SUMO('06988540-n',[ ('SemiticLanguage',instance)]).
nounMapping2SUMO('06988684-n',[ ('SemiticLanguage',instance)]).
nounMapping2SUMO('06988808-n',[ ('SemiticLanguage',instance)]).
nounMapping2SUMO('06988913-n',[ ('MalteseLanguage',equivalence)]).
nounMapping2SUMO('06989146-n',[ ('SemiticLanguage',subsumption)]).
nounMapping2SUMO('06989325-n',[ ('SemiticLanguage',instance)]).
nounMapping2SUMO('06989473-n',[ ('SemiticLanguage',instance)]).
nounMapping2SUMO('06989657-n',[ ('SemiticLanguage',instance)]).
nounMapping2SUMO('06989769-n',[ ('SemiticLanguage',instance)]).
nounMapping2SUMO('06989869-n',[ ('AfroAsiaticLanguage',subsumption)]).
nounMapping2SUMO('06990000-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06990193-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06990371-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06990544-n',[ ('BerberLanguage',equivalence)]).
nounMapping2SUMO('06990741-n',[ ('BerberLanguage',instance)]).
nounMapping2SUMO('06990836-n',[ ('CushiticLanguage',equivalence)]).
nounMapping2SUMO('06991004-n',[ ('SomaliLanguage',equivalence)]).
nounMapping2SUMO('06991117-n',[ ('AfroAsiaticLanguage',subsumption)]).
nounMapping2SUMO('06991277-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06991622-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06991764-n',[ ('NigerCongoLanguage',equivalence)]).
nounMapping2SUMO('06991980-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06992600-n',[ ('ChichewaLanguage',equivalence)]).
nounMapping2SUMO('06992709-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06992807-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06992929-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06993015-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06993108-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06993225-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06993348-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06993445-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06993573-n',[ ('KinyarwandaLanguage',equivalence)]).
nounMapping2SUMO('06993647-n',[ ('SwahiliLanguage',equivalence)]).
nounMapping2SUMO('06993719-n',[ ('KongoLanguage',equivalence)]).
nounMapping2SUMO('06993870-n',[ ('LubaKatangaLanguage',equivalence)]).
nounMapping2SUMO('06993977-n',[ ('LugandaLanguage',equivalence)]).
nounMapping2SUMO('06994089-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06994157-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06994225-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06994329-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06994488-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06994608-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06994700-n',[ ('XhosaLanguage',equivalence)]).
nounMapping2SUMO('06994792-n',[ ('ZuluLanguage',equivalence)]).
nounMapping2SUMO('06994918-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06995016-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06995135-n',[ ('ShonaLanguage',equivalence)]).
nounMapping2SUMO('06995222-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06995439-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06995526-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06995664-n',[ ('TswanaLanguage',equivalence)]).
nounMapping2SUMO('06995792-n',[ ('SwahiliLanguage',equivalence)]).
nounMapping2SUMO('06996029-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06996160-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06996309-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06996510-n',[ ('FulaLanguage',equivalence)]).
nounMapping2SUMO('06996755-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06996894-n',[ ('WolofLanguage',equivalence)]).
nounMapping2SUMO('06997012-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06997168-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('06997368-n',[ ('YorubaLanguage',equivalence)]).
nounMapping2SUMO('06997486-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06997587-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('06997697-n',[ ('NiloSaharanLanguage',equivalence)]).
nounMapping2SUMO('06997938-n',[ ('NiloSaharanLanguage',subsumption)]).
nounMapping2SUMO('06998108-n',[ ('NiloSaharanLanguage',subsumption)]).
nounMapping2SUMO('06998322-n',[ ('NiloSaharanLanguage',instance)]).
nounMapping2SUMO('06998392-n',[ ('LuoLanguage',equivalence)]).
nounMapping2SUMO('06998460-n',[ ('NiloSaharanLanguage',instance)]).
nounMapping2SUMO('06998530-n',[ ('NiloSaharanLanguage',instance)]).
nounMapping2SUMO('06998631-n',[ ('NiloSaharanLanguage',instance)]).
nounMapping2SUMO('06998748-n',[ ('RepresentationalArtWork',subsumption)]).
nounMapping2SUMO('06999045-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('06999233-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06999436-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06999647-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('06999802-n',[ ('GraphDiagram',subsumption)]).
nounMapping2SUMO('07000065-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07000195-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07000716-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07000941-n',[ ('TwoDimensionalFigure',equivalence)]).
nounMapping2SUMO('07001065-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07001294-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07001446-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07001547-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07001717-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07001865-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07002022-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07002146-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07002312-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07002459-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07002599-n',[ ('Graph',equivalence)]).
nounMapping2SUMO('07002863-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07002992-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07003119-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07003352-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07003568-n',[ ('BaseballInning',equivalence)]).
nounMapping2SUMO('07003672-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07003807-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07003935-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07004057-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07004241-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07004422-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07004564-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07004738-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07004962-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07005158-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07005270-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07005523-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('07005715-n',[ ('GraphPath',subsumption)]).
nounMapping2SUMO('07005897-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07006018-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07006119-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('07006712-n',[ ('TheaterProfession',equivalence)]).
nounMapping2SUMO('07006951-n',[ ('Demonstrating',equivalence)]).
nounMapping2SUMO('07007171-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('07007341-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07007444-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07007556-n',[ ('Demonstrating',subsumption)]).
nounMapping2SUMO('07007684-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07007945-n',[ ('DramaticPlay',equivalence)]).
nounMapping2SUMO('07008544-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07008680-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07008849-n',[ ('DramaticPlay',subsumption)]).
nounMapping2SUMO('07008947-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07009042-n',[ ('LinguisticCommunication',subsumption)]).
nounMapping2SUMO('07009161-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07009421-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('07009538-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07009640-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('07009808-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('07009946-n',[ ('DramaticPlay',subsumption)]).
nounMapping2SUMO('07010275-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07010393-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07010541-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07010692-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07010821-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07011075-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07011209-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07011387-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07011529-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07011689-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07011803-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07012025-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07012135-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07012279-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07012414-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07012534-n',[ ('LinguisticExpression',equivalence)]).
nounMapping2SUMO('07012979-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07013269-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07013400-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07013549-n',[ ('List',subsumption)]).
nounMapping2SUMO('07013736-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07013933-n',[ ('SymbolicString',subsumption)]).
nounMapping2SUMO('07014029-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('07014187-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07014320-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07014596-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07014752-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07014854-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07014997-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07015151-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07015242-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('07015400-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07015510-n',[ ('DramaticPlay',equivalence)]).
nounMapping2SUMO('07015841-n',[ ('DramaticPlay',subsumption)]).
nounMapping2SUMO('07015928-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07016098-n',[ ('DramaticPlay',subsumption)]).
nounMapping2SUMO('07016250-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07016428-n',[ ('DramaticPlay',subsumption)]).
nounMapping2SUMO('07016542-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07016648-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07016797-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07016948-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07017161-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07017379-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07017534-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07017733-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07017877-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07017999-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07018211-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07018313-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07018444-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07018604-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07018724-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07018824-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07018931-n',[ ('DramaticPlay',equivalence)]).
nounMapping2SUMO('07019172-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07019396-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('07019500-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('07019633-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('07019743-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07019866-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('07020017-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('07020121-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('07020239-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('07020423-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('07020538-n',[ ('Dancing',equivalence)]).
nounMapping2SUMO('07020763-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07020895-n',[ ('MakingMusic',equivalence)]).
nounMapping2SUMO('07024607-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('07024705-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07024929-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07025151-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07025302-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07025419-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07025604-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07025900-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07026239-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07026352-n',[ ('Opera',equivalence)]).
nounMapping2SUMO('07026646-n',[ ('Opera',subsumption)]).
nounMapping2SUMO('07026827-n',[ ('Opera',subsumption)]).
nounMapping2SUMO('07026920-n',[ ('Opera',subsumption)]).
nounMapping2SUMO('07027090-n',[ ('Opera',subsumption)]).
nounMapping2SUMO('07027180-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07027458-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('07027651-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('07027805-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07027942-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07028221-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07028373-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('07028797-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07028964-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07029088-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07029247-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07029581-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07029682-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07029819-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07030012-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07030174-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07030376-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07030549-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07030718-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('07030976-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07031144-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07031276-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07031401-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07031534-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07031636-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07031752-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07032026-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('07032206-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('07032292-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07032426-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07032556-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07032753-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07033007-n',[ ('ReligiousMusic',equivalence)]).
nounMapping2SUMO('07033245-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07033433-n',[ ('ChristianMusic',subsumption)]).
nounMapping2SUMO('07033613-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07033753-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07033913-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07034035-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07034409-n',[ ('ReligiousMusic',subsumption)]).
nounMapping2SUMO('07034516-n',[ ('Book',subsumption)]).
nounMapping2SUMO('07034634-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07034865-n',[ ('ReligiousMusic',subsumption)]).
nounMapping2SUMO('07035061-n',[ ('ReligiousMusic',subsumption)]).
nounMapping2SUMO('07035153-n',[ ('ChristianMusic',subsumption)]).
nounMapping2SUMO('07035305-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07035420-n',[ ('ReligiousMusic',subsumption)]).
nounMapping2SUMO('07035598-n',[ ('ReligiousMusic',subsumption)]).
nounMapping2SUMO('07035747-n',[ ('ChristmasMusic',subsumption)]).
nounMapping2SUMO('07035870-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07036203-n',[ ('ChristianMusic',subsumption)]).
nounMapping2SUMO('07036328-n',[ ('ChristianMusic',subsumption)]).
nounMapping2SUMO('07036443-n',[ ('ChristianMusic',subsumption)]).
nounMapping2SUMO('07036546-n',[ ('ReligiousMusic',subsumption)]).
nounMapping2SUMO('07036699-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07036768-n',[ ('Song',instance)]).
nounMapping2SUMO('07036862-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07037059-n',[ ('ChristianMusic',subsumption)]).
nounMapping2SUMO('07037232-n',[ ('ReligiousMusic',subsumption)]).
nounMapping2SUMO('07037384-n',[ ('ReligiousMusic',subsumption)]).
nounMapping2SUMO('07037465-n',[ ('MusicalComposition',equivalence)]).
nounMapping2SUMO('07038400-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07038615-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07038767-n',[ ('MusicalComposition',equivalence)]).
nounMapping2SUMO('07038910-n',[ ('MusicalInstrument',subsumption)]).
nounMapping2SUMO('07039056-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('07039238-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07039478-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07039620-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07039770-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07039949-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('07040148-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('07040292-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07040413-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07040543-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07040693-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07040820-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07040939-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07041125-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07041344-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07041451-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07041595-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07041688-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07041795-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07041902-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07042023-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07042137-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07042249-n',[ ('ReligiousMusic',subsumption)]).
nounMapping2SUMO('07042405-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('07042498-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07042586-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07042735-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07042862-n',[ ('Musical',subsumption)]).
nounMapping2SUMO('07043026-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07043275-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07043389-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07043518-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07043675-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07043824-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07043968-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07044088-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07044276-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07044353-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07044543-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07044680-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07044760-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07044917-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07045245-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07045353-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07045519-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07045637-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07045788-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07045928-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07046030-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07046218-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07046339-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07046543-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07046737-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07046917-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07047011-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07047165-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07047275-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07047373-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07047505-n',[ ('MashupRecording',subsumption)]).
nounMapping2SUMO('07047679-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07047804-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07048000-n',[ ('Song',equivalence)]).
nounMapping2SUMO('07048627-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07048782-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('07048928-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07049055-n',[ ('NationalAnthemFn',equivalence)]).
nounMapping2SUMO('07049205-n',[ ('Music',instance)]).
nounMapping2SUMO('07049291-n',[ ('Music',instance)]).
nounMapping2SUMO('07049514-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07049634-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07049713-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07049849-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07049931-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07050042-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07050177-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07050379-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('07050503-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07050619-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07050827-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07050952-n',[ ('FolkMusic',equivalence)]).
nounMapping2SUMO('07051185-n',[ ('BluesMusic',subsumption)]).
nounMapping2SUMO('07051441-n',[ ('FolkMusic',subsumption)]).
nounMapping2SUMO('07051517-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07051620-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07051728-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07051851-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07051975-n',[ ('LyricalContent',equivalence)]).
nounMapping2SUMO('07052291-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07052619-n',[ ('LyricalContent',subsumption)]).
nounMapping2SUMO('07052700-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07052799-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07052925-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07053089-n',[ ('MakingVocalMusic',subsumption)]).
nounMapping2SUMO('07053364-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07053491-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07053606-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07053732-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07053884-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07053993-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07054122-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('07054336-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07054433-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07054994-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07055103-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07055203-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07055295-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07055401-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07055502-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07055612-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07055720-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07055805-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07055923-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07056021-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07056113-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07056265-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07056406-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07056504-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07056593-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07056680-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07056764-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07056895-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07057001-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07057095-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07057196-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07057385-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07057539-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07057829-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07057948-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07058064-n',[ ('ElectronicMusic',subsumption)]).
nounMapping2SUMO('07058184-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07058296-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07058468-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07058668-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07058762-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07058871-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07059028-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07059150-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07059255-n',[ ('PopMusic',equivalence)]).
nounMapping2SUMO('07059626-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07059821-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07059962-n',[ ('PopMusic',equivalence)]).
nounMapping2SUMO('07060167-n',[ ('FolkMusic',equivalence)]).
nounMapping2SUMO('07060440-n',[ ('CountryMusic',equivalence)]).
nounMapping2SUMO('07060697-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07060844-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07060976-n',[ ('JazzMusic',equivalence)]).
nounMapping2SUMO('07061180-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07061334-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07061677-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07061968-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07062190-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07062315-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07062451-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07062550-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07062697-n',[ ('JazzMusic',equivalence)]).
nounMapping2SUMO('07063101-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07063249-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07063413-n',[ ('JazzMusic',subsumption)]).
nounMapping2SUMO('07063585-n',[ ('FunkMusic',equivalence)]).
nounMapping2SUMO('07063775-n',[ ('JazzMusic',subsumption)]).
nounMapping2SUMO('07063921-n',[ ('JazzMusic',subsumption)]).
nounMapping2SUMO('07064055-n',[ ('HipHopMusic',equivalence)]).
nounMapping2SUMO('07064315-n',[ ('RhythmAndBluesMusic',equivalence)]).
nounMapping2SUMO('07064537-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07064715-n',[ ('RockAndRollMusic',equivalence)]).
nounMapping2SUMO('07065149-n',[ ('HeavyMetalMusic',equivalence)]).
nounMapping2SUMO('07065333-n',[ ('RockMusic',subsumption)]).
nounMapping2SUMO('07065562-n',[ ('RockMusic',subsumption)]).
nounMapping2SUMO('07065740-n',[ ('PunkRockMusic',equivalence)]).
nounMapping2SUMO('07065932-n',[ ('JazzMusic',subsumption)]).
nounMapping2SUMO('07066042-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07066285-n',[ ('ReggaeMusic',equivalence)]).
nounMapping2SUMO('07066459-n',[ ('MusicGenre',subsumption)]).
nounMapping2SUMO('07066659-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('07067591-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('07067760-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07067876-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07068048-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07068133-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07068324-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07068473-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('07068631-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07068844-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07069002-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07069074-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07069210-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07069517-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07069632-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07069747-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('07069948-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07070321-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07070429-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07070779-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('07070883-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07071017-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07071250-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('07071366-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('07071483-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('07071942-n',[ ('MusicGenre',equivalence)]).
nounMapping2SUMO('07072195-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('07072337-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07072434-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07072587-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07072698-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07072838-n',[ ('TasteAttribute',subsumption)]).
nounMapping2SUMO('07073071-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07073208-n',[ ('LinguisticCommunication',subsumption)]).
nounMapping2SUMO('07073447-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07075006-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07075172-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07080778-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07080868-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07081043-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07081177-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07081345-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07081473-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07081646-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07081739-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07082025-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07082198-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('07082346-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07082444-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07082573-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07082819-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07082972-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('07083136-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07083246-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07083441-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07083732-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07083958-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07084166-n',[ ('Stressed',subsumption)]).
nounMapping2SUMO('07084428-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07084560-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07084747-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07084927-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07085072-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07085210-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07085375-n',[ ('Stressed',equivalence)]).
nounMapping2SUMO('07085786-n',[ ('Stressed',subsumption)]).
nounMapping2SUMO('07085961-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07086088-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07086215-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07086323-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07086518-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07086861-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07086972-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07087102-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07087223-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07087346-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07087508-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07087641-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07087777-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07087940-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07088053-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07088319-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07088438-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07088645-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07088868-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('07089024-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07089276-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07089431-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07089531-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07089622-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('07089751-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07090019-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07090108-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07090379-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07090573-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07090721-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07090938-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07091087-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07091214-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07091385-n',[ ('True',subsumption)]).
nounMapping2SUMO('07091587-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07091737-n',[ ('Word',subsumption)]).
nounMapping2SUMO('07091902-n',[ ('Word',subsumption)]).
nounMapping2SUMO('07092158-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('07092356-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07092592-n',[ ('FictionalText',subsumption)]).
nounMapping2SUMO('07093158-n',[ ('FictionalText',subsumption)]).
nounMapping2SUMO('07093273-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07093489-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('07093603-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('07093759-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07093895-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07094093-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07094355-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07094508-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('07094621-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07094731-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07094843-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07095148-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07095280-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07095390-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07095516-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07095653-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07095775-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07095895-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07096029-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07096142-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07096237-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07096330-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07096425-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07096569-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07096661-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07096995-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07097094-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07097346-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07097548-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07097707-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07097831-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07097965-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07098093-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07098193-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07098989-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('07099135-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07099271-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07099598-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07099752-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07099844-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07099965-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07100113-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07100253-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07100387-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07100522-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07100678-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07100815-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07100942-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07101140-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07101250-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07101406-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07101557-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07101649-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07101778-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07101937-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07102034-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07102271-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07102373-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07102483-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('07102593-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07102802-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07102945-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07103106-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07103258-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07103402-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07103558-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('07103671-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('07103802-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('07103912-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('07104020-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('07104149-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07104292-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07104574-n',[ ('Word',subsumption)]).
nounMapping2SUMO('07104733-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07104912-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('07105045-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('07105238-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07105342-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07105475-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07106113-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('07106246-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07106502-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07106651-n',[ ('Word',subsumption)]).
nounMapping2SUMO('07106800-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07107083-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07107381-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07107522-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07107676-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07107896-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07108010-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('07108123-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07108282-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07108453-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07108657-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07108807-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07109019-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07109196-n',[ ('Speaking',subsumption)]).
nounMapping2SUMO('07109730-n',[ ('Word',subsumption)]).
nounMapping2SUMO('07109847-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07110457-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07110615-n',[ ('Vocalizing',equivalence)]).
nounMapping2SUMO('07111047-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07111510-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07111711-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07111933-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07112103-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07112282-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07112364-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07112550-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07112805-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07112942-n',[ ('Consonant',subsumption)]).
nounMapping2SUMO('07113080-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07113192-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07113337-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07113491-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('07113625-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07113732-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07113903-n',[ ('Vowel',subsumption)]).
nounMapping2SUMO('07114023-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07114154-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07114284-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07114409-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07114535-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07114712-n',[ ('Character',subsumption)]).
nounMapping2SUMO('07114870-n',[ ('Character',subsumption)]).
nounMapping2SUMO('07115021-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07115381-n',[ ('Character',subsumption)]).
nounMapping2SUMO('07115493-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07115684-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07115914-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07116304-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07116443-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07116641-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07116758-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07116869-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07117007-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07117193-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07117333-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07117472-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07117595-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07117788-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07118002-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07118210-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07118367-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07118554-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07118747-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07118990-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07119211-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07119358-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07119521-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07119643-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07119776-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07119897-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07120025-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07120176-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07120364-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07120524-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07121157-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07121361-n',[ ('Vocalizing',subsumption)]).
nounMapping2SUMO('07121904-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07122018-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07122118-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07122409-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07122555-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07122639-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07122730-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07123012-n',[ ('Vocalizing',subsumption)]).
nounMapping2SUMO('07123288-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07123404-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07123552-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07123710-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07123870-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07124172-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07124340-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07124736-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07124928-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07125096-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07125367-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07125523-n',[ ('Vocalizing',subsumption)]).
nounMapping2SUMO('07125786-n',[ ('Word',subsumption)]).
nounMapping2SUMO('07125958-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07126116-n',[ ('Vocalizing',subsumption)]).
nounMapping2SUMO('07126228-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07126383-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07126521-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('07126734-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07127006-n',[ ('Laughing',equivalence)]).
nounMapping2SUMO('07127252-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07127350-n',[ ('Laughing',subsumption)]).
nounMapping2SUMO('07127451-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07127563-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07127693-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07127790-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07127911-n',[ ('Laughing',subsumption)]).
nounMapping2SUMO('07128060-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07128225-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07128322-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07128527-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07128692-n',[ ('Speaking',subsumption)]).
nounMapping2SUMO('07128946-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07129202-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07129422-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07129602-n',[ ('Vocalizing',subsumption)]).
nounMapping2SUMO('07129758-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07129867-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07130050-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07130183-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07130341-n',[ ('Speaking',subsumption)]).
nounMapping2SUMO('07130580-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07130774-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07130918-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07131022-n',[ ('Word',subsumption)]).
nounMapping2SUMO('07131169-n',[ ('Word',subsumption)]).
nounMapping2SUMO('07131366-n',[ ('Word',subsumption)]).
nounMapping2SUMO('07131511-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07131741-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07131854-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07132226-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('07132415-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07132634-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07132729-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07132937-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07133143-n',[ ('PhysicalState',subsumption)]).
nounMapping2SUMO('07133313-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07133477-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07133701-n',[ ('Speaking',equivalence)]).
nounMapping2SUMO('07134179-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07134287-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07134445-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07134575-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07134706-n',[ ('Debating',subsumption)]).
nounMapping2SUMO('07134850-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07135080-n',[ ('LinguisticCommunication',subsumption)]).
nounMapping2SUMO('07135450-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07135627-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07135734-n',[ ('Speaking',subsumption)]).
nounMapping2SUMO('07136098-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07136206-n',[ ('Speaking',subsumption)]).
nounMapping2SUMO('07136315-n',[ ('Speaking',subsumption)]).
nounMapping2SUMO('07136469-n',[ ('Speaking',subsumption)]).
nounMapping2SUMO('07136578-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07136711-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07136940-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07137129-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07137315-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07137461-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07137622-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07137733-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07137807-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07137950-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07138085-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07138504-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07138736-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07138915-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07139151-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07139316-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07139532-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07139700-n',[ ('Directing',equivalence)]).
nounMapping2SUMO('07139873-n',[ ('Stating',equivalence)]).
nounMapping2SUMO('07140237-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07140348-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07140659-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07140978-n',[ ('Debating',equivalence)]).
nounMapping2SUMO('07141319-n',[ ('Debating',subsumption)]).
nounMapping2SUMO('07141437-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07141537-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07141644-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07141789-n',[ ('Speaking',subsumption)]).
nounMapping2SUMO('07141922-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07142005-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07142107-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07142242-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07142365-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07142566-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07142924-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07143044-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07143137-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07143450-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07143624-n',[ ('FormalMeeting',subsumption)]).
nounMapping2SUMO('07143869-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07144039-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07144190-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07144416-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07144571-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07144834-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07145026-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07145314-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07145508-n',[ ('FormalMeeting',equivalence)]).
nounMapping2SUMO('07145783-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07145958-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07146190-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07146300-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07146534-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07146640-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07146784-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07146980-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07147116-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07147267-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07147511-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07147733-n',[ ('FormalMeeting',subsumption)]).
nounMapping2SUMO('07147902-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07148022-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07148192-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07148573-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07148828-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07148938-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07149107-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07149348-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07149582-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07149836-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07150023-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07150138-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07150328-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07150499-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07150644-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07150850-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07151122-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07151285-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07151380-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07151892-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07152027-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07152151-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07152259-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07152463-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('07152590-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07152752-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07152948-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07153130-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07153385-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07153502-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07153641-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07153727-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07153838-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07154046-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07154243-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07154330-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07154666-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07154760-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07154868-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07155081-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07155426-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07155531-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07155661-n',[ ('SpokenHumanLanguage',subsumption)]).
nounMapping2SUMO('07156091-n',[ ('SpokenHumanLanguage',subsumption)]).
nounMapping2SUMO('07156219-n',[ ('Language',subsumption)]).
nounMapping2SUMO('07156375-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07156497-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07156693-n',[ ('Language',subsumption)]).
nounMapping2SUMO('07156819-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07157000-n',[ ('Language',subsumption)]).
nounMapping2SUMO('07157123-n',[ ('Language',subsumption)]).
nounMapping2SUMO('07157273-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07159276-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07159467-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07159791-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07160116-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07160296-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07160424-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07160635-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07160752-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07160883-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07161429-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07161613-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07161741-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07161912-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07162059-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07162194-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07162424-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07162545-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07162680-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07162975-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07163110-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07163272-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07163381-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07163593-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07163803-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07163988-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07164163-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('07164349-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07164546-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07164972-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07165086-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07165298-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07165410-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07165506-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07165778-n',[ ('Book',subsumption)]).
nounMapping2SUMO('07166101-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07166281-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07166432-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07166851-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07167041-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07167186-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07167326-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07167415-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07167578-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07167954-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('07168131-n',[ ('Ordering',equivalence)]).
nounMapping2SUMO('07168486-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('07168623-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('07168983-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('07169098-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('07169242-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('07169353-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('07169480-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('07169743-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('07169848-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('07169970-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07170080-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('07170282-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('07170467-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('07170572-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('07170660-n',[ ('Phrase',subsumption)]).
nounMapping2SUMO('07170753-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07171206-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07171513-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07171666-n',[ ('Classifying',subsumption)]).
nounMapping2SUMO('07171785-n',[ ('Interpreting',subsumption)]).
nounMapping2SUMO('07171940-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07172117-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07172557-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07172756-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07172979-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07173258-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07173389-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07173585-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07173766-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07173959-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07174138-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07174260-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07174433-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07174785-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07174877-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07175102-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07175241-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07175575-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07175863-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07176073-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07176243-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07176499-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07176682-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07176804-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07176962-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07177111-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07177192-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07177437-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07177622-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07177772-n',[ ('Reservation',subsumption)]).
nounMapping2SUMO('07177924-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07178182-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07178337-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07178525-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07178698-n',[ ('Agreement',subsumption)]).
nounMapping2SUMO('07178839-n',[ ('Agreement',subsumption)]).
nounMapping2SUMO('07178992-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07179192-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07179342-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07179609-n',[ ('Committing',instance)]).
nounMapping2SUMO('07179820-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07179943-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07180183-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07180372-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07180570-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07180787-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07181043-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07181208-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07181358-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07181453-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07181546-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07181713-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07181842-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07181935-n',[ ('Debating',subsumption)]).
nounMapping2SUMO('07182367-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07182485-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07182614-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07182744-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07182888-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07183000-n',[ ('Debating',subsumption)]).
nounMapping2SUMO('07183151-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07183660-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07183853-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('07184024-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('07184149-n',[ ('Debating',subsumption)]).
nounMapping2SUMO('07184391-n',[ ('Debating',equivalence)]).
nounMapping2SUMO('07184545-n',[ ('Debating',subsumption)]).
nounMapping2SUMO('07184652-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07184735-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07184965-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07185076-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('07185325-n',[ ('Requesting',equivalence)]).
nounMapping2SUMO('07185668-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07185870-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07186148-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07186528-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07186661-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07186828-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07187150-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07187297-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07187486-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07187638-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07187773-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07187996-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07188238-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07188385-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07188570-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07188685-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('07188979-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('07189130-n',[ ('Praying',subsumption)]).
nounMapping2SUMO('07189411-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07189562-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('07189633-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07189779-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07189932-n',[ ('Praying',subsumption)]).
nounMapping2SUMO('07190039-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07190188-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07190290-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07190474-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07190584-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07190693-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07190840-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07190941-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07191162-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('07191279-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07191569-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07191696-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07191777-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07191950-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07192129-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07192240-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07192511-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07192661-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07192845-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07192990-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07193184-n',[ ('Questioning',equivalence)]).
nounMapping2SUMO('07193405-n',[ ('Questioning',subsumption)]).
nounMapping2SUMO('07193596-n',[ ('Questioning',subsumption)]).
nounMapping2SUMO('07193958-n',[ ('Questioning',subsumption)]).
nounMapping2SUMO('07194293-n',[ ('Questioning',subsumption)]).
nounMapping2SUMO('07194499-n',[ ('Questioning',subsumption)]).
nounMapping2SUMO('07194676-n',[ ('Questioning',subsumption)]).
nounMapping2SUMO('07194811-n',[ ('Ordering',subsumption)]).
nounMapping2SUMO('07194950-n',[ ('Questioning',subsumption)]).
nounMapping2SUMO('07195241-n',[ ('Questioning',subsumption)]).
nounMapping2SUMO('07195404-n',[ ('Questioning',subsumption)]).
nounMapping2SUMO('07195630-n',[ ('Questioning',subsumption)]).
nounMapping2SUMO('07195765-n',[ ('Questioning',subsumption)]).
nounMapping2SUMO('07195969-n',[ ('Questioning',subsumption)]).
nounMapping2SUMO('07196075-n',[ ('Questioning',subsumption)]).
nounMapping2SUMO('07196405-n',[ ('Questioning',subsumption)]).
nounMapping2SUMO('07196575-n',[ ('Questioning',subsumption)]).
nounMapping2SUMO('07196682-n',[ ('Questioning',subsumption)]).
nounMapping2SUMO('07197021-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07197537-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07197889-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07198119-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07198276-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('07198437-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07198605-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('07198757-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('07198846-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('07199013-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('07199191-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('07199328-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07199456-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('07199565-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07199814-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07199922-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07200290-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07200421-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07200527-n',[ ('Answering',equivalence)]).
nounMapping2SUMO('07200692-n',[ ('Answering',subsumption)]).
nounMapping2SUMO('07200813-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07201105-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07201220-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07201365-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07201562-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07201804-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07202311-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07202391-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07202579-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07202812-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07203016-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07203126-n',[ ('Stating',equivalence)]).
nounMapping2SUMO('07203388-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07203613-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07203696-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07203900-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07204008-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07204110-n',[ ('Statement',subsumption)]).
nounMapping2SUMO('07204240-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07204401-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07204665-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07204822-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07204911-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07205104-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07205210-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07205308-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('07205439-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('07205573-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07205718-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07205946-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07206096-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07206302-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07206461-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07206596-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07206800-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07206887-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07207142-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('07207273-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07207410-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07207680-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07207860-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07208000-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07208184-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07208338-n',[ ('ExpressingDisapproval',subsumption)]).
nounMapping2SUMO('07208565-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07208708-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07208930-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07209089-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07209305-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07209533-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07209691-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07209868-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07209965-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07210225-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07210553-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07210801-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07210951-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07211092-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07211374-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07211503-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07211604-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07211752-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07211950-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07212190-n',[ ('Stating',equivalence)]).
nounMapping2SUMO('07212424-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07212612-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('07212874-n',[ ('Predicting',equivalence)]).
nounMapping2SUMO('07213079-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('07213232-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07213395-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07213717-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07213889-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07213989-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07214150-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07214267-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07214432-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('07214642-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07214894-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07214994-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07215185-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07215377-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07215568-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07215816-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07215948-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07216083-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07216228-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07216412-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07216615-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07216761-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07217117-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07217260-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07217349-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07217579-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07217673-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07217782-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07217924-n',[ ('Stating',equivalence)]).
nounMapping2SUMO('07218299-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07218470-n',[ ('Report',subsumption)]).
nounMapping2SUMO('07218853-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('07219004-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07219162-n',[ ('Report',subsumption)]).
nounMapping2SUMO('07219297-n',[ ('Report',subsumption)]).
nounMapping2SUMO('07219530-n',[ ('Report',subsumption)]).
nounMapping2SUMO('07219636-n',[ ('Report',subsumption)]).
nounMapping2SUMO('07219751-n',[ ('Report',subsumption)]).
nounMapping2SUMO('07219923-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07220045-n',[ ('Report',subsumption)]).
nounMapping2SUMO('07220178-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07220300-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07220466-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07220586-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07220773-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07221094-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07221623-n',[ ('Text',instance)]).
nounMapping2SUMO('07221756-n',[ ('HistoricalAccount',subsumption)]).
nounMapping2SUMO('07221939-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07222050-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07222230-n',[ ('Text',instance)]).
nounMapping2SUMO('07222433-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07222581-n',[ ('ShortStory',subsumption)]).
nounMapping2SUMO('07222728-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07222823-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07223094-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07223170-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07223450-n',[ ('HistoricalAccount',subsumption)]).
nounMapping2SUMO('07223635-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07223811-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07223985-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07224151-n',[ ('Predicting',equivalence)]).
nounMapping2SUMO('07224481-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('07224684-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07224774-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07224923-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('07225167-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07225333-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07225450-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07225577-n',[ ('Predicting',subsumption)]).
nounMapping2SUMO('07225696-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07225857-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07226015-n',[ ('Threatening',subsumption)]).
nounMapping2SUMO('07226151-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07226330-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07226545-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07226841-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07227055-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07227158-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07227301-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07227406-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07227589-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07227772-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07228105-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07228211-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07228349-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07228531-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07228630-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07228751-n',[ ('Committing',subsumption)]).
nounMapping2SUMO('07228971-n',[ ('Thanking',subsumption)]).
nounMapping2SUMO('07229111-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07229245-n',[ ('Thanking',subsumption)]).
nounMapping2SUMO('07229341-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07229530-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07229747-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07230089-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07230227-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07230320-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07230502-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07230796-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07230959-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07231048-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07231199-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07231294-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07231532-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07231728-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07231840-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07231943-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07232053-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07232189-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07232275-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07232421-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07232655-n',[ ('Interpreting',subsumption)]).
nounMapping2SUMO('07232811-n',[ ('Interpreting',subsumption)]).
nounMapping2SUMO('07232988-n',[ ('ExpressingDisapproval',subsumption)]).
nounMapping2SUMO('07233214-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07233304-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07233415-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07233542-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07233634-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07233863-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('07233996-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07234230-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07234657-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07234735-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07234881-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07235218-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07235335-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('07235574-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('07235696-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('07235790-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('07235936-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('07236077-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07236307-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07236466-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07236627-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07236759-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07236957-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07237038-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07237234-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07237409-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07237561-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07237647-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07237758-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07238102-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07238308-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07238455-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07238589-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07238694-n',[ ('Lecture',equivalence)]).
nounMapping2SUMO('07239183-n',[ ('Lecture',subsumption)]).
nounMapping2SUMO('07239327-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07239428-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07239550-n',[ ('Lecture',instance)]).
nounMapping2SUMO('07239788-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07239927-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07240077-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07240278-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07240417-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07240549-n',[ ('Lecture',subsumption)]).
nounMapping2SUMO('07240763-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07240925-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07241205-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07241551-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07241723-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07241837-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07242104-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07242324-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07242470-n',[ ('Reciting',subsumption)]).
nounMapping2SUMO('07242657-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07242912-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07243114-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07243193-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07243306-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07243382-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07243565-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07243837-n',[ ('Sermon',subsumption)]).
nounMapping2SUMO('07244154-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07244305-n',[ ('ChristianService',subsumption)]).
nounMapping2SUMO('07244433-n',[ ('Text',instance)]).
nounMapping2SUMO('07244613-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07244822-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07244949-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07245125-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07245472-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07245686-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07245885-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07246036-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07246215-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07246382-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07246469-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07246582-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07246742-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07246932-n',[ ('Weapon',equivalence)]).
nounMapping2SUMO('07247071-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07247451-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07247602-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07247803-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07247925-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07248060-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07248320-n',[ ('Advertising',subsumption)]).
nounMapping2SUMO('07248507-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07248653-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07248801-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('07249180-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('07249336-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('07249426-n',[ ('Advertising',subsumption)]).
nounMapping2SUMO('07249585-n',[ ('Advertising',subsumption)]).
nounMapping2SUMO('07249817-n',[ ('Advertising',subsumption)]).
nounMapping2SUMO('07249932-n',[ ('Advertising',subsumption)]).
nounMapping2SUMO('07250034-n',[ ('Advertising',subsumption)]).
nounMapping2SUMO('07250198-n',[ ('Advertising',subsumption)]).
nounMapping2SUMO('07250339-n',[ ('Advertising',subsumption)]).
nounMapping2SUMO('07250727-n',[ ('Advertising',subsumption)]).
nounMapping2SUMO('07250868-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('07251003-n',[ ('Advertising',subsumption)]).
nounMapping2SUMO('07251148-n',[ ('Book',subsumption)]).
nounMapping2SUMO('07251373-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07251619-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07251779-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07251984-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07252206-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07252378-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07252764-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07252967-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07253142-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07253482-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07253637-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('07253814-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07253948-n',[ ('Directing',subsumption)]).
nounMapping2SUMO('07254057-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07254267-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('07254456-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('07254594-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('07254836-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('07255027-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('07255174-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07255299-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07255401-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07255628-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07255791-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07255998-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07256230-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('07256375-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07256695-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('07256932-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('07257045-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('07257227-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07257393-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('07257582-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07257815-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07258109-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07258238-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07258332-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07258664-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07258964-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07259145-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07259319-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07259438-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07259610-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07259772-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('07259984-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('07260175-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07260332-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07260493-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('07260623-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07261143-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07261300-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('07261542-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07261782-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07261955-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07262108-n',[ ('Device',subsumption)]).
nounMapping2SUMO('07262278-n',[ ('Device',subsumption)]).
nounMapping2SUMO('07262354-n',[ ('Device',subsumption)]).
nounMapping2SUMO('07262462-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07262579-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07262704-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07262942-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('07263053-n',[ ('Device',subsumption)]).
nounMapping2SUMO('07263220-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07263358-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07263503-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07263745-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07263897-n',[ ('Device',subsumption)]).
nounMapping2SUMO('07264086-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07264213-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07264384-n',[ ('Weapon',subsumption)]).
nounMapping2SUMO('07264484-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('07264615-n',[ ('Device',subsumption)]).
nounMapping2SUMO('07264725-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07264820-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07264925-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07265075-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07265170-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07265276-n',[ ('FireAlarm',subsumption)]).
nounMapping2SUMO('07265381-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07265508-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07265619-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07265789-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('07265886-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('07265990-n',[ ('Device',subsumption)]).
nounMapping2SUMO('07266178-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('07266442-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('07266573-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('07266665-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('07266776-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('07266879-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('07266979-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('07267067-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07267160-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07267309-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07267461-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07267573-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07267702-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('07267795-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07267931-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07268035-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07268166-n',[ ('Belt',subsumption)]).
nounMapping2SUMO('07268302-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('07268413-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('07268603-n',[ ('Character',subsumption)]).
nounMapping2SUMO('07268759-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('07268967-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('07269163-n',[ ('Character',subsumption)]).
nounMapping2SUMO('07269430-n',[ ('Character',subsumption)]).
nounMapping2SUMO('07269552-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('07269758-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07269916-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07270179-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07270601-n',[ ('Character',subsumption)]).
nounMapping2SUMO('07270718-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07270893-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07271052-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07271167-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07271280-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07271478-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07271648-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07271791-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07271942-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07272084-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07272172-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07272416-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07272545-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07272694-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07272807-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07272920-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07273024-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07273136-n',[ ('Label',subsumption)]).
nounMapping2SUMO('07273416-n',[ ('Label',subsumption)]).
nounMapping2SUMO('07273616-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('07273802-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('07273924-n',[ ('Shrugging',subsumption)]).
nounMapping2SUMO('07274027-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('07274197-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('07274316-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('07274425-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('07274730-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('07274890-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('07275078-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('07275275-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('07275489-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('07275713-n',[ ('Bowing',subsumption)]).
nounMapping2SUMO('07275823-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('07276018-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07276242-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('07276414-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('07276538-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('07276732-n',[ ('LegalCharge',subsumption)]).
nounMapping2SUMO('07277158-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07277384-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07277697-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07277915-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07278014-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07278146-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07278256-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07278365-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07278510-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07278582-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07278652-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07278775-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07278925-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07279045-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('07279285-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07279453-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07279687-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07279968-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07280072-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('07280295-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07280424-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07280599-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('07280754-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07280941-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07281099-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07281219-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07281375-n',[ ('MusicalComposition',subsumption)]).
nounMapping2SUMO('07281523-n',[ ('Language',subsumption)]).
nounMapping2SUMO('07281635-n',[ ('ReligiousMusic',subsumption)]).
nounMapping2SUMO('07281871-n',[ ('Vocalizing',subsumption)]).
nounMapping2SUMO('07282006-n',[ ('Song',subsumption)]).
nounMapping2SUMO('07282166-n',[ ('Reciting',subsumption)]).
nounMapping2SUMO('07282289-n',[ ('Explanation',subsumption)]).
nounMapping2SUMO('07282497-n',[ ('Book',subsumption)]).
nounMapping2SUMO('07282695-n',[ ('Statement',subsumption)]).
nounMapping2SUMO('07282929-n',[ ('Book',instance)]).
nounMapping2SUMO('07283065-n',[ ('Book',instance)]).
nounMapping2SUMO('07283198-n',[ ('Book',instance)]).
nounMapping2SUMO('07283364-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07283473-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07283608-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07284554-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07284848-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07285036-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07285191-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07285403-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07285872-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07286014-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07286278-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07286368-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07286799-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07286905-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07286999-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07287088-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07287288-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07287472-n',[ ('Death',equivalence)]).
nounMapping2SUMO('07287610-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07287730-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07287812-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07288024-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07288215-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07288385-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07288485-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07288639-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('07288801-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07289014-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07289358-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07289481-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07289588-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07289831-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07289956-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07290144-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07290278-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07290503-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07290761-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07290905-n',[ ('BeginFn',equivalence)]).
nounMapping2SUMO('07291215-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07291312-n',[ ('EndFn',subsumption)]).
nounMapping2SUMO('07291794-n',[ ('EndFn',equivalence)]).
nounMapping2SUMO('07292118-n',[ ('EndFn',subsumption)]).
nounMapping2SUMO('07292273-n',[ ('EndFn',subsumption)]).
nounMapping2SUMO('07292418-n',[ ('EndFn',subsumption)]).
nounMapping2SUMO('07292577-n',[ ('EndFn',subsumption)]).
nounMapping2SUMO('07292694-n',[ ('Broadcasting',subsumption)]).
nounMapping2SUMO('07293080-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07293180-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07293391-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07293475-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07293546-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07293678-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07293903-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07294019-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07294260-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07294423-n',[ ('EndFn',subsumption)]).
nounMapping2SUMO('07294550-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07294699-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07294777-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07294907-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07295047-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07295391-n',[ ('EndFn',subsumption)]).
nounMapping2SUMO('07295507-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07295629-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07295850-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07295955-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07296083-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07296190-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07296428-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07297376-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07297633-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07297811-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07297927-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07298154-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07298396-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07298543-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07298624-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07298715-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07298982-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07299203-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07299439-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07299569-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07299790-n',[ ('Malfunctioning',subsumption)]).
nounMapping2SUMO('07299965-n',[ ('Malfunctioning',subsumption)]).
nounMapping2SUMO('07300092-n',[ ('Malfunctioning',subsumption)]).
nounMapping2SUMO('07300316-n',[ ('Malfunctioning',subsumption)]).
nounMapping2SUMO('07300494-n',[ ('Malfunctioning',subsumption)]).
nounMapping2SUMO('07300781-n',[ ('Malfunctioning',subsumption)]).
nounMapping2SUMO('07300960-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07301336-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07301543-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07301846-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07301950-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07302164-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07302267-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07302407-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07302542-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07302836-n',[ ('Fire',equivalence)]).
nounMapping2SUMO('07303153-n',[ ('Fire',subsumption)]).
nounMapping2SUMO('07303335-n',[ ('Fire',subsumption)]).
nounMapping2SUMO('07303466-n',[ ('Fire',subsumption)]).
nounMapping2SUMO('07303585-n',[ ('Fire',subsumption)]).
nounMapping2SUMO('07303697-n',[ ('Fire',subsumption)]).
nounMapping2SUMO('07303839-n',[ ('Fire',subsumption)]).
nounMapping2SUMO('07303988-n',[ ('Fire',subsumption)]).
nounMapping2SUMO('07304096-n',[ ('Combustion',subsumption)]).
nounMapping2SUMO('07304266-n',[ ('Fire',subsumption)]).
nounMapping2SUMO('07304353-n',[ ('Fire',subsumption)]).
nounMapping2SUMO('07304507-n',[ ('Fire',subsumption)]).
nounMapping2SUMO('07304630-n',[ ('Fire',subsumption)]).
nounMapping2SUMO('07304753-n',[ ('Fire',subsumption)]).
nounMapping2SUMO('07304852-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07305098-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07305234-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07305438-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07305551-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07305760-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07305907-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07306032-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07306160-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07306252-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07306481-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07306680-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07306963-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07307172-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07307297-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07307477-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07307646-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07307754-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('07307895-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('07308042-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('07308308-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('07308450-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('07308563-n',[ ('Explosion',subsumption)]).
nounMapping2SUMO('07308889-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07309223-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07309457-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07309599-n',[ ('IntentionalProcess',equivalence)]).
nounMapping2SUMO('07309781-n',[ ('Motion',equivalence)]).
nounMapping2SUMO('07310338-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07310507-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07310642-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07310839-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07310991-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07311115-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07311540-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07311661-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07311822-n',[ ('SubjectiveAssessmentAttribute',instance)]).
nounMapping2SUMO('07312018-n',[ ('SubjectiveAssessmentAttribute',instance)]).
nounMapping2SUMO('07312221-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07312503-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07312616-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07312829-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07313004-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07313241-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07313518-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07313636-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('07313814-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07314078-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('07314277-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07314427-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07314658-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07314838-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07315350-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07315631-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07315790-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07315965-n',[ ('Famine',instance)]).
nounMapping2SUMO('07316242-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07316403-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07316603-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07316724-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07316856-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07316999-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07317144-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07317285-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07317369-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07317519-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07317764-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('07318133-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07318299-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07318476-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07318618-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07318824-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07319103-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('07319399-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07319549-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07319652-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07319774-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07319909-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('07320176-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07320302-n',[ ('Birth',equivalence)]).
nounMapping2SUMO('07320622-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('07320734-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('07320894-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('07321012-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('07321142-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('07321247-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('07321387-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07321517-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('07321657-n',[ ('Death',subsumption)]).
nounMapping2SUMO('07321772-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('07321967-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('07322138-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('07322341-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('07322550-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('07322769-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07323024-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('07323231-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('07323436-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('07323605-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07323682-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('07323821-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07323922-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07324235-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('07324380-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('07324502-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('07324673-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('07324917-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('07325102-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('07325190-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('07325639-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('07325762-n',[ ('Menstruation',subsumption)]).
nounMapping2SUMO('07325864-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('07325990-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07326108-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('07326262-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('07326369-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('07326557-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07326880-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07327013-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07327288-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('07327608-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07327805-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07328058-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07328305-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07328436-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07328646-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('07328756-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07328942-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('07329169-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('07329363-n',[ ('Performance',subsumption)]).
nounMapping2SUMO('07329568-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('07329737-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('07329833-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07330007-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07330250-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07330362-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07330560-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07330666-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07330828-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('07331013-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('07331210-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07331400-n',[ ('Detaching',subsumption)]).
nounMapping2SUMO('07331600-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('07331759-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07331932-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07332148-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('07332313-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('07332550-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('07332691-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('07332864-n',[ ('Death',subsumption)]).
nounMapping2SUMO('07332956-n',[ ('Death',subsumption)]).
nounMapping2SUMO('07333162-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07333347-n',[ ('Death',subsumption)]).
nounMapping2SUMO('07333506-n',[ ('Death',subsumption)]).
nounMapping2SUMO('07333649-n',[ ('Death',equivalence)]).
nounMapping2SUMO('07333971-n',[ ('Death',subsumption)]).
nounMapping2SUMO('07334206-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07334490-n',[ ('Destruction',equivalence)]).
nounMapping2SUMO('07334876-n',[ ('Destruction',equivalence)]).
nounMapping2SUMO('07335097-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('07335243-n',[ ('Destruction',equivalence)]).
nounMapping2SUMO('07335414-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('07335581-n',[ ('Destruction',subsumption)]).
nounMapping2SUMO('07335716-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('07335917-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('07336104-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('07336214-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('07336346-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('07336612-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07336763-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07336999-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07337096-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07337390-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07337694-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07337935-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07338114-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('07338358-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('07338552-n',[ ('Impacting',equivalence)]).
nounMapping2SUMO('07338681-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07338970-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07339098-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07339329-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('07339653-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07339808-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07339941-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07340094-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07340249-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('07340453-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('07340592-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('07340725-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07340895-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07341038-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07341304-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('07341665-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07341860-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07342049-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07342383-n',[ ('Music',subsumption)]).
nounMapping2SUMO('07342495-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07342772-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07343017-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07343195-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07343363-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07343574-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('07343713-n',[ ('Remembering',subsumption)]).
nounMapping2SUMO('07343910-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07344015-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07344120-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07344233-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07344368-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07344528-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07344663-n',[ ('WaterWave',subsumption)]).
nounMapping2SUMO('07344875-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07345066-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07345166-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07345441-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07345593-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('07345960-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07346057-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07346195-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07346344-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('07346772-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07347051-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('07347224-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07347373-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07347468-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07347664-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('07347846-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07348041-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07348258-n',[ ('WaterWave',subsumption)]).
nounMapping2SUMO('07348399-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07348545-n',[ ('WaterWave',subsumption)]).
nounMapping2SUMO('07348694-n',[ ('WaterWave',subsumption)]).
nounMapping2SUMO('07348870-n',[ ('WaterWave',subsumption)]).
nounMapping2SUMO('07349069-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07349299-n',[ ('WaterWave',subsumption)]).
nounMapping2SUMO('07349532-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07349679-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07349880-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07350069-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07350192-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07350401-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07350567-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07350754-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07350893-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07351031-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('07351195-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07351380-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07351497-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07351612-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07351909-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07352048-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07352190-n',[ ('WaterWave',subsumption)]).
nounMapping2SUMO('07352617-n',[ ('WaterWave',subsumption)]).
nounMapping2SUMO('07352693-n',[ ('WaterWave',subsumption)]).
nounMapping2SUMO('07352835-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07353075-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07353232-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07353376-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07353716-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('07354009-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('07354080-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('07354243-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07354504-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('07354628-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('07354731-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('07354911-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('07355014-n',[ ('EndFn',subsumption)]).
nounMapping2SUMO('07355194-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07355347-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07355491-n',[ ('Death',equivalence)]).
nounMapping2SUMO('07355887-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07356266-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07356489-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07356676-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('07356970-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07357101-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07357253-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07357388-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07357679-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07357866-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07358060-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('07358377-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07358576-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07358768-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07358985-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07359184-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('07359377-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07359599-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('07359920-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07360077-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('07360211-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('07360293-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('07360477-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('07360647-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('07360841-n',[ ('IntentionalProcess',equivalence)]).
nounMapping2SUMO('07360957-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07361128-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07361416-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07361576-n',[ ('Killing',subsumption)]).
nounMapping2SUMO('07361717-n',[ ('Death',subsumption)]).
nounMapping2SUMO('07361863-n',[ ('Death',subsumption)]).
nounMapping2SUMO('07362075-n',[ ('EndFn',subsumption)]).
nounMapping2SUMO('07362218-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07362386-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07362699-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07362830-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07363067-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07363180-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07363346-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07363545-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07363668-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07363883-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07364115-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('07364434-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('07364573-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07364700-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07364851-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07365024-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07365193-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07365432-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07365524-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07365673-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07365849-n',[ ('EndFn',subsumption)]).
nounMapping2SUMO('07366145-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07366289-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07366627-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07366799-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07366971-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07367091-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07367231-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07367385-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07367548-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('07367708-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('07367812-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07368130-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07368256-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07368482-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07368646-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07368877-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07368993-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07369099-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07369206-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07369344-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07369470-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07369604-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07369922-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07370125-n',[ ('Arriving',subsumption)]).
nounMapping2SUMO('07370270-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07370410-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07370671-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07370968-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07371168-n',[ ('TakingOff',subsumption)]).
nounMapping2SUMO('07371293-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07372565-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07372779-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07372959-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07373277-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('07373481-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('07373602-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('07373803-n',[ ('Combining',equivalence)]).
nounMapping2SUMO('07374152-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('07374357-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('07374633-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('07374756-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('07375053-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('07375214-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('07375405-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('07375525-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07375635-n',[ ('TakingOff',equivalence)]).
nounMapping2SUMO('07375781-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07376008-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07376168-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07376257-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07376454-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07376539-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07376621-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07376731-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07376836-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07376937-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07377082-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07377244-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07377473-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07377682-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07377931-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07378059-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07378163-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07378234-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07378437-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07378569-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07378682-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07378781-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07378952-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07379094-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07379223-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07379409-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07379577-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07379695-n',[ ('Vocalizing',subsumption)]).
nounMapping2SUMO('07379852-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07379963-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07380144-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07380473-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07380686-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07380784-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07380934-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07381100-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07381231-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07381329-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07381423-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07381678-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07381864-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07382044-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07382286-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07382414-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07382572-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07383092-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07383257-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07383323-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07383475-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07383616-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07383696-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07383823-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07384023-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07384127-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07384244-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07384344-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07384473-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07384614-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07384741-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07384898-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07385249-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07385367-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07385548-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07385660-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07385803-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07385998-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07386194-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07386370-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07386614-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07386821-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07386920-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07387316-n',[ ('Vocalizing',subsumption)]).
nounMapping2SUMO('07387509-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07388706-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07388816-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07388987-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07389170-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07389330-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07389569-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07389757-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07389931-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07390049-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07390205-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07390307-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07390400-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07390645-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07390762-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07390857-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07390945-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07391079-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07391240-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07391516-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07391682-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07391863-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07392280-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07392373-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07392483-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07392783-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07392982-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07393161-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07393500-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07393589-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07393756-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07393919-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07393988-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07394115-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07394236-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07394478-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07394588-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07394814-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07395104-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07395303-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07395446-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07395623-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07395777-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07395867-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07395957-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07396120-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07396233-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07396414-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07396530-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07396658-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07396822-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07396945-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07397230-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07397355-n',[ ('Thunder',subsumption)]).
nounMapping2SUMO('07397552-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07397641-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07397761-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07397955-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07398097-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07398276-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07398362-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07398560-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07398659-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07398873-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07399027-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07399137-n',[ ('MakingMusic',subsumption)]).
nounMapping2SUMO('07399336-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07399452-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07399620-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07399735-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07399829-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07399917-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07400156-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07400361-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07400552-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07400701-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07400831-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07400906-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('07401236-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('07401409-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('07401604-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('07401726-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('07401960-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07402147-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07402271-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07402393-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07402519-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07402873-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07403030-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07403300-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07403459-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07403601-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07403779-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07403920-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07404114-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07404261-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07404443-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07404584-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07404798-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07404944-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07405137-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07405292-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07405411-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07405579-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07405652-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('07405817-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07405893-n',[ ('LiquidMotion',subsumption)]).
nounMapping2SUMO('07406350-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07406474-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07406601-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07406765-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07407137-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07407272-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07407459-n',[ ('LiquidMotion',subsumption)]).
nounMapping2SUMO('07407593-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07407777-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07407970-n',[ ('LiquidMotion',subsumption)]).
nounMapping2SUMO('07408086-n',[ ('Explosion',subsumption)]).
nounMapping2SUMO('07408171-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07408288-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07408386-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07408519-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07408621-n',[ ('Backfire',equivalence)]).
nounMapping2SUMO('07408796-n',[ ('Explosion',subsumption)]).
nounMapping2SUMO('07408965-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07409121-n',[ ('Explosion',subsumption)]).
nounMapping2SUMO('07409255-n',[ ('Explosion',subsumption)]).
nounMapping2SUMO('07409475-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('07409592-n',[ ('Touching',equivalence)]).
nounMapping2SUMO('07409930-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07410021-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07410207-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07410526-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07410613-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07410745-n',[ ('Impacting',subsumption)]).
nounMapping2SUMO('07410883-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('07411011-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07411160-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('07411350-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('07411490-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('07411645-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('07411851-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('07412092-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('07412310-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('07412478-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('07412668-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('07412876-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('07412993-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('07413237-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('07413452-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('07413629-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('07413714-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('07413815-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('07413899-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('07414068-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('07414222-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('07414370-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('07414566-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('07414740-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07414922-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07415167-n',[ ('Near',subsumption)]).
nounMapping2SUMO('07415396-n',[ ('Near',subsumption)]).
nounMapping2SUMO('07415561-n',[ ('Near',subsumption)]).
nounMapping2SUMO('07415730-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07415962-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07416107-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07416308-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07416441-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07416714-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07417043-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07417298-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07417405-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07417644-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07417851-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07418146-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07418497-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07418716-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07418822-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07418963-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07419233-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('07419408-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07419599-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07419792-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07419960-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('07420217-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('07420354-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07420435-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07420538-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('07420671-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07420770-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07420991-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07421316-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07421580-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07421669-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07421749-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07421859-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07422036-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07422244-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07422506-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07422629-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07422800-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07423001-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07423248-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07423365-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07423560-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07423818-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07423899-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07424109-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07424436-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07424797-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07425011-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('07425427-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07425577-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('07425726-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('07425903-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('07426108-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('07426241-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('07426406-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('07426573-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('07426732-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('07426893-n',[ ('Growth',not(subsumption))]).
nounMapping2SUMO('07427060-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('07427224-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('07427337-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07427534-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07427728-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07427951-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07428111-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('07428257-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('07428450-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07428797-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('07428954-n',[ ('Earthquake',subsumption)]).
nounMapping2SUMO('07429276-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07429484-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07429637-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07429782-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07429870-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07429976-n',[ ('Arriving',subsumption)]).
nounMapping2SUMO('07430211-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('07430480-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('07430770-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('07430964-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('07431119-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('07431247-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('07431369-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07431502-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('07431683-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('07431852-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07432034-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('07432119-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07432337-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07432559-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07432835-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07432973-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('07433145-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('07433336-n',[ ('WaterArea',instance)]).
nounMapping2SUMO('07433510-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('07433662-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('07433868-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('07433973-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07434102-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07434209-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07434320-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07434473-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07434678-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('07434782-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07434942-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07435149-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07435273-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07435533-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('07435713-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('07435891-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07436100-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07436352-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07436475-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('07436661-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07436986-n',[ ('Replication',subsumption)]).
nounMapping2SUMO('07437372-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('07437575-n',[ ('Replication',subsumption)]).
nounMapping2SUMO('07437870-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('07437990-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('07438190-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('07438396-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('07438655-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('07438792-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('07438983-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('07439167-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('07439284-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('07439570-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07439883-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07440045-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07440240-n',[ ('LiquidMotion',subsumption)]).
nounMapping2SUMO('07440411-n',[ ('LiquidMotion',subsumption)]).
nounMapping2SUMO('07440617-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07440852-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07440979-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('07441373-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('07441494-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('07441619-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('07441902-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('07442068-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07442288-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07442439-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07442569-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07442744-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07442874-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07443010-n',[ ('Detaching',subsumption)]).
nounMapping2SUMO('07443210-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07443539-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07443761-n',[ ('Substituting',equivalence)]).
nounMapping2SUMO('07444100-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07444278-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07444392-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07444495-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07444668-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('07444882-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07445010-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('07445149-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('07445265-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('07445480-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07445896-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('07446270-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07446404-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07446533-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07446599-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07446744-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07446920-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07447022-n',[ ('DirectionChange',subsumption)]).
nounMapping2SUMO('07447177-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('07447261-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('07447641-n',[ ('SocialParty',equivalence)]).
nounMapping2SUMO('07448038-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('07448121-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('07448232-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('07448394-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('07448608-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('07448717-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('07448885-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07449037-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07449157-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07449316-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07449452-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07449548-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('07449676-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07449862-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('07450055-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('07450229-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('07450343-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('07450463-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07450549-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07450651-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('07450842-n',[ ('FormalMeeting',subsumption)]).
nounMapping2SUMO('07451338-n',[ ('FormalMeeting',subsumption)]).
nounMapping2SUMO('07451463-n',[ ('Funeral',subsumption)]).
nounMapping2SUMO('07451687-n',[ ('Entombing',subsumption)]).
nounMapping2SUMO('07451903-n',[ ('Funeral',subsumption)]).
nounMapping2SUMO('07452074-n',[ ('Wedding',subsumption)]).
nounMapping2SUMO('07452251-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07452348-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('07452559-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('07452699-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('07452841-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07453063-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07453195-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('07453638-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('07453924-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('07454196-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('07454452-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07454632-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('07454758-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07455007-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07455151-n',[ ('FormalMeeting',subsumption)]).
nounMapping2SUMO('07455301-n',[ ('FormalMeeting',subsumption)]).
nounMapping2SUMO('07455640-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('07455760-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('07455984-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('07456188-n',[ ('Contest',equivalence)]).
nounMapping2SUMO('07456638-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07456906-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('07457016-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('07457126-n',[ ('OlympicGames',equivalence)]).
nounMapping2SUMO('07457311-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('07457485-n',[ ('OlympicGames',subsumption)]).
nounMapping2SUMO('07457599-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07457722-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('07457834-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('07457936-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07458099-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07458212-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07458453-n',[ ('Racing',equivalence)]).
nounMapping2SUMO('07458892-n',[ ('CarRacing',subsumption)]).
nounMapping2SUMO('07459066-n',[ ('CarRacing',subsumption)]).
nounMapping2SUMO('07459157-n',[ ('CarRacing',subsumption)]).
nounMapping2SUMO('07459249-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07459363-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07459523-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07459642-n',[ ('MotorcycleRacing',subsumption)]).
nounMapping2SUMO('07459778-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07459868-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07459992-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07460104-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07460403-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07460546-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07460651-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07460793-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07460904-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07461050-n',[ ('Equitation',subsumption)]).
nounMapping2SUMO('07461288-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07461411-n',[ ('HorseRacing',equivalence)]).
nounMapping2SUMO('07461650-n',[ ('HorseRacing',subsumption)]).
nounMapping2SUMO('07461831-n',[ ('HorseRacing',subsumption)]).
nounMapping2SUMO('07461956-n',[ ('HorseRacing',subsumption)]).
nounMapping2SUMO('07462119-n',[ ('HorseRacing',subsumption)]).
nounMapping2SUMO('07462269-n',[ ('HorseRacing',subsumption)]).
nounMapping2SUMO('07462405-n',[ ('HorseRacing',subsumption)]).
nounMapping2SUMO('07462547-n',[ ('HorseRacing',subsumption)]).
nounMapping2SUMO('07462693-n',[ ('HorseRacing',subsumption)]).
nounMapping2SUMO('07462808-n',[ ('HorseRacing',subsumption)]).
nounMapping2SUMO('07462917-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07463029-n',[ ('HorseRacing',subsumption)]).
nounMapping2SUMO('07463171-n',[ ('HorseRacing',subsumption)]).
nounMapping2SUMO('07463323-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07463470-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07463607-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07463733-n',[ ('Racing',subsumption), ('Skiing',subsumption)]).
nounMapping2SUMO('07463872-n',[ ('Racing',subsumption), ('Skiing',subsumption)]).
nounMapping2SUMO('07463950-n',[ ('Racing',subsumption), ('Skiing',subsumption)]).
nounMapping2SUMO('07464083-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07464234-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07464402-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07464568-n',[ ('Soccer',subsumption)]).
nounMapping2SUMO('07464725-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('07464969-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07465159-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07465290-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07465448-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07465657-n',[ ('Game',subsumption)]).
nounMapping2SUMO('07465781-n',[ ('Baseball',subsumption)]).
nounMapping2SUMO('07465960-n',[ ('Boxing',equivalence)]).
nounMapping2SUMO('07466108-n',[ ('Chess',equivalence)]).
nounMapping2SUMO('07466195-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('07466322-n',[ ('Cricket',equivalence)]).
nounMapping2SUMO('07466415-n',[ ('Diving',equivalence)]).
nounMapping2SUMO('07466557-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('07466832-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07467027-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07467212-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07467393-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07467579-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07467704-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07467846-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07468116-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07468244-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07468456-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07468534-n',[ ('SwimmingSport',subsumption)]).
nounMapping2SUMO('07468692-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('07468861-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07469043-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07469162-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07469325-n',[ ('Racing',subsumption)]).
nounMapping2SUMO('07469476-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('07469609-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('07469772-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('07469975-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('07470110-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('07470285-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('07470420-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('07470545-n',[ ('SwimmingSport',equivalence)]).
nounMapping2SUMO('07470671-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('07471037-n',[ ('Tennis',equivalence)]).
nounMapping2SUMO('07471126-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('07471246-n',[ ('Wrestling',equivalence)]).
nounMapping2SUMO('07471371-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('07471514-n',[ ('Maneuver',subsumption)]).
nounMapping2SUMO('07471708-n',[ ('Boxing',subsumption)]).
nounMapping2SUMO('07471806-n',[ ('Boxing',subsumption)]).
nounMapping2SUMO('07471972-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07472168-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07472327-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('07472460-n',[ ('ViolentContest',subsumption)]).
nounMapping2SUMO('07472657-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07472808-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07472929-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07473207-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07473332-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07473441-n',[ ('Won',equivalence)]).
nounMapping2SUMO('07474006-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07474185-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('07474318-n',[ ('Won',subsumption)]).
nounMapping2SUMO('07474533-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('07474645-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('07474809-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('07474911-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('07475035-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('07475107-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('07475242-n',[ ('Tennis',subsumption)]).
nounMapping2SUMO('07475364-n',[ ('Lost',subsumption)]).
nounMapping2SUMO('07475762-n',[ ('Won',subsumption)]).
nounMapping2SUMO('07475870-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07476092-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07476177-n',[ ('Lost',subsumption)]).
nounMapping2SUMO('07476282-n',[ ('Lost',subsumption)]).
nounMapping2SUMO('07476404-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('07476495-n',[ ('Sport',subsumption)]).
nounMapping2SUMO('07476623-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('07476851-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('07476952-n',[ ('Lost',subsumption)]).
nounMapping2SUMO('07477066-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('07477231-n',[ ('Experimenting',equivalence)]).
nounMapping2SUMO('07477413-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07477587-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07477945-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('07478169-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('07478318-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('07478531-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07478718-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07478874-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07479144-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07479366-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('07479525-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07479628-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07479799-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('07479926-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07480068-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07480356-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07480521-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07480666-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07480790-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07480896-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07481084-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07481223-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07481375-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07481625-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07481785-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07481951-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07482128-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07482267-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07482368-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07482521-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07482782-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07483005-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07483120-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07483305-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07483439-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07483622-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07483782-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07484109-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07484265-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07484547-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07484792-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07484929-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07485047-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07485203-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07485281-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07485475-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07485626-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07485916-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07486055-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('07486145-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07486229-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07486527-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07486628-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07486922-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07487063-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07487177-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07487276-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07487375-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07487493-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07487594-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07487695-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07487955-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07488340-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07488567-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07488676-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07488788-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07488875-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07489059-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07489294-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07489548-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07489714-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07489925-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07490042-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07490138-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07490214-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07490451-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07490579-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07490713-n',[ ('Happiness',equivalence)]).
nounMapping2SUMO('07491038-n',[ ('Happiness',subsumption)]).
nounMapping2SUMO('07491286-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07491476-n',[ ('Happiness',subsumption)]).
nounMapping2SUMO('07491591-n',[ ('Happiness',subsumption)]).
nounMapping2SUMO('07491708-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07491895-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07491981-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07492170-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07492368-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07492516-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07492655-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07492928-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07493095-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07493280-n',[ ('Happiness',equivalence)]).
nounMapping2SUMO('07493527-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07493682-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07493830-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07494018-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07494175-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07494363-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07494682-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07494787-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07494972-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07495156-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07495236-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07495327-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07495551-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07495878-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07495973-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07496166-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('07496291-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('07496463-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07496755-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('07496924-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07497019-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07497122-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07497473-n',[ ('Happiness',subsumption)]).
nounMapping2SUMO('07497797-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07497976-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07498210-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07498455-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07498614-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07498769-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07498854-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07499113-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07499276-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07499449-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07499615-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07499830-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07499930-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07500042-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07500159-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07500414-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07500612-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07500741-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07500957-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07501093-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07501194-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07501326-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07501420-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07501545-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07501922-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07502099-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('07502241-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07502387-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07502576-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07502669-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07502829-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07502980-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07503260-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07503430-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07503716-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07503849-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07503987-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07504111-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07504258-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07504343-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07504529-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07504711-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07504841-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07505047-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07505207-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07505347-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07505538-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07505676-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07505871-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07506031-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07506149-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07506382-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07506569-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07506797-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07506962-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07507098-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('07507329-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07507560-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07507742-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07507912-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07508092-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07508232-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07508486-n',[ ('Happiness',subsumption)]).
nounMapping2SUMO('07508705-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07508806-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07508996-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07509131-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07509325-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07509474-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07509572-n',[ ('Surprise',subsumption)]).
nounMapping2SUMO('07509827-n',[ ('Pursuing',subsumption)]).
nounMapping2SUMO('07509996-n',[ ('Surprise',subsumption)]).
nounMapping2SUMO('07510184-n',[ ('Happiness',subsumption)]).
nounMapping2SUMO('07510348-n',[ ('Surprise',equivalence)]).
nounMapping2SUMO('07510495-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07510625-n',[ ('Surprise',subsumption)]).
nounMapping2SUMO('07510923-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07511080-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07511238-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07511380-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07511524-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07511626-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07511733-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07511906-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07512039-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07512147-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07512315-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07512465-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07512719-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07512848-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07513035-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07513247-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07513413-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07513508-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07513711-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07513795-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07514071-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07514189-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07514345-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07514520-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07514600-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07514782-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07514968-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07515169-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07515328-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07515560-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07515790-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07515974-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07516222-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07516354-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07516756-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07516905-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07516997-n',[ ('Anger',equivalence)]).
nounMapping2SUMO('07517292-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07517417-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07517550-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07517737-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07517869-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07518000-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07518132-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07518261-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07518468-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07518663-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07518878-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07519040-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07519253-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07519773-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07519983-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07520112-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07520411-n',[ ('Anxiety',equivalence)]).
nounMapping2SUMO('07520507-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07520612-n',[ ('Anxiety',equivalence)]).
nounMapping2SUMO('07520925-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07521039-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07521437-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07521563-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07521674-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07522043-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07522128-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07522418-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07522536-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07522632-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07522729-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07523016-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07523180-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07523286-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07523485-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07523649-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07523760-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07523905-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07524242-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07524529-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07524760-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07524918-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07525057-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07525259-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07525367-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07525555-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07525760-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07526002-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07526182-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07526338-n',[ ('Happiness',equivalence)]).
nounMapping2SUMO('07526505-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07526757-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07527061-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07527167-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07527352-n',[ ('Happiness',subsumption)]).
nounMapping2SUMO('07527656-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07527817-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07528097-n',[ ('Happiness',subsumption)]).
nounMapping2SUMO('07528212-n',[ ('Happiness',subsumption)]).
nounMapping2SUMO('07528470-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07528807-n',[ ('Happiness',subsumption)]).
nounMapping2SUMO('07528976-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07529096-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07529245-n',[ ('Happiness',subsumption)]).
nounMapping2SUMO('07529377-n',[ ('Happiness',subsumption)]).
nounMapping2SUMO('07529563-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07529683-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07529817-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07530000-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07530124-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07530322-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07530478-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07530723-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07530866-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07531105-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07531255-n',[ ('Happiness',equivalence)]).
nounMapping2SUMO('07531536-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('07531713-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07531998-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07532112-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07532276-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07532440-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07532832-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07532945-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('07533097-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('07533257-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07533492-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07533607-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07533735-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07533877-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07533978-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07534108-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07534278-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07534430-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('07534700-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07534847-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('07535010-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('07535209-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07535430-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07535532-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07535670-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07536074-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07536245-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07536437-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07536870-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07537068-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07537259-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07537376-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07537485-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07537668-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07537973-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07538142-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07538272-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07538395-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07538674-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07538812-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07538965-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07539259-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07539367-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07539511-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07539790-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07539962-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07540081-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07540424-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('07540602-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('07540866-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('07541053-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07541316-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07541449-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07541558-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07541760-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07541923-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('07542249-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07542433-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07542560-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07542675-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('07542881-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07543033-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07543204-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07543288-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07543732-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07543910-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07544039-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07544129-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07544213-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07544351-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07544491-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07544647-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07545161-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07545303-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07545415-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07545594-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07545717-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('07545833-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07545957-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07546125-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07546279-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07546389-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07546465-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07546844-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07546973-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07547064-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07547219-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07547293-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07547397-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07547473-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07547547-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07547674-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07547805-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07548100-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07548224-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07548366-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07548567-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07548695-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07548860-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07548978-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07549265-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07549401-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07549536-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07549716-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07549979-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07550079-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07550204-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07550369-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07550551-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07550666-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07550891-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07551052-n',[ ('PsychologicalAttribute',equivalence)]).
nounMapping2SUMO('07551418-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('07551498-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07551691-n',[ ('Happiness',subsumption)]).
nounMapping2SUMO('07551890-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07552087-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07552252-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07552367-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07552549-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07552729-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07553016-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07553176-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07553301-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07553590-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07553741-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07553964-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('07554224-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('07554342-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07554500-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07554640-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07554758-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07554856-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07555014-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07555184-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07555402-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07555647-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07555775-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('07555863-n',[ ('SolidFood',equivalence)]).
nounMapping2SUMO('07556406-n',[ ('ComfortFood',equivalence)]).
nounMapping2SUMO('07556637-n',[ ('Food',equivalence)]).
nounMapping2SUMO('07556872-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07556970-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07557165-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07557434-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07560193-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07560331-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07560422-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07560542-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07560652-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07560903-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07561112-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07561590-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07561730-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07561848-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07562017-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07562172-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07562379-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07562495-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07562651-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07562881-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07562984-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07563207-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07563366-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07563509-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07563642-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07563800-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07564008-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07564101-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07564292-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07564515-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07564629-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07564796-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07564971-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07565083-n',[ ('Menu',equivalence)]).
nounMapping2SUMO('07565161-n',[ ('Meal',subsumption)]).
nounMapping2SUMO('07565259-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07565458-n',[ ('Meal',subsumption)]).
nounMapping2SUMO('07565608-n',[ ('Meal',subsumption)]).
nounMapping2SUMO('07565725-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07565945-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07566092-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07566231-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07566340-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07566863-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07567039-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07567139-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07567390-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07567611-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07567707-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07567980-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07568095-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07568241-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07568389-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07568502-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07568625-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07568706-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07568818-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07568991-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07569106-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07569423-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07569543-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07569644-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07569873-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07570021-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07570141-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07570237-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07570447-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07570530-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07570635-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07570720-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07571324-n',[ ('Cuisine',equivalence)]).
nounMapping2SUMO('07571547-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('07571765-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('07571903-n',[ ('FieldOfStudy',subsumption)]).
nounMapping2SUMO('07572134-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07572206-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07572353-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('07572519-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07572616-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07572712-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07572858-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07572957-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07573103-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07573241-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07573347-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07573453-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07573563-n',[ ('Eating',subsumption)]).
nounMapping2SUMO('07573696-n',[ ('Meal',equivalence)]).
nounMapping2SUMO('07574176-n',[ ('Meal',subsumption)]).
nounMapping2SUMO('07574426-n',[ ('Meal',subsumption)]).
nounMapping2SUMO('07574504-n',[ ('Meal',subsumption)]).
nounMapping2SUMO('07574602-n',[ ('Breakfast',equivalence)]).
nounMapping2SUMO('07574780-n',[ ('Breakfast',subsumption)]).
nounMapping2SUMO('07574923-n',[ ('Brunch',equivalence)]).
nounMapping2SUMO('07575076-n',[ ('Lunch',equivalence)]).
nounMapping2SUMO('07575226-n',[ ('Meal',subsumption)]).
nounMapping2SUMO('07575392-n',[ ('HighTea',equivalence)]).
nounMapping2SUMO('07575510-n',[ ('Meal',subsumption)]).
nounMapping2SUMO('07575726-n',[ ('Dinner',subsumption)]).
nounMapping2SUMO('07575984-n',[ ('Meal',subsumption)]).
nounMapping2SUMO('07576182-n',[ ('Buffet',equivalence)]).
nounMapping2SUMO('07576311-n',[ ('Meal',subsumption)]).
nounMapping2SUMO('07576438-n',[ ('Meal',subsumption)]).
nounMapping2SUMO('07576577-n',[ ('Meal',subsumption)]).
nounMapping2SUMO('07576781-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07576969-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07577144-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07577244-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07577374-n',[ ('Meal',subsumption)]).
nounMapping2SUMO('07577538-n',[ ('Meal',subsumption)]).
nounMapping2SUMO('07577657-n',[ ('Meal',subsumption)]).
nounMapping2SUMO('07577772-n',[ ('Meal',subsumption)]).
nounMapping2SUMO('07577918-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07578093-n',[ ('Meal',subsumption)]).
nounMapping2SUMO('07578363-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07578879-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07579076-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07579276-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07579399-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07579575-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07579688-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07579787-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07579917-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07580053-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07580253-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07580359-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07580470-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07580592-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07580782-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07581132-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07581249-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07581346-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07581607-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07581775-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07581931-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07582027-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07582152-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07582277-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07582441-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07582609-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07582811-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07582892-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07582970-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07583066-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07583197-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07583865-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07583978-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07584110-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07584228-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07584332-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07584423-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07584593-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07584727-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07584859-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07584938-n',[ ('SoupStock',subsumption)]).
nounMapping2SUMO('07585015-n',[ ('SoupStock',subsumption)]).
nounMapping2SUMO('07585107-n',[ ('SoupStock',subsumption)]).
nounMapping2SUMO('07585208-n',[ ('SoupStock',equivalence)]).
nounMapping2SUMO('07585474-n',[ ('SoupStock',subsumption)]).
nounMapping2SUMO('07585557-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07585644-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07585758-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07585906-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07585997-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07586099-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07586179-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07586318-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07586485-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07586604-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07586718-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07586894-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07587023-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07587111-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07587206-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07587331-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07587441-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07587618-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07587700-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07587819-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07587962-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07588111-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07588193-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07588299-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07588419-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07588574-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07588688-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07588817-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07588947-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07589458-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07589543-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07589724-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07589872-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07589967-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07590068-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07590177-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07590320-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07590502-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07590611-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07590752-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07590841-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07590974-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07591049-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07591162-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07591236-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07591330-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07591473-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07591586-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07591813-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07591961-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07592094-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07592317-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07592400-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07592481-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07592558-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07592656-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07592768-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07592922-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07593004-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07593107-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07593199-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07593471-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07593549-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07593774-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07593972-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07594066-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07594155-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07594250-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07594406-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07594511-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07594737-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07594840-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07595051-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('07595180-n',[ ('Sugar',subsumption)]).
nounMapping2SUMO('07595368-n',[ ('Sugar',subsumption)]).
nounMapping2SUMO('07595499-n',[ ('Sugar',subsumption)]).
nounMapping2SUMO('07595649-n',[ ('Sugar',subsumption)]).
nounMapping2SUMO('07595751-n',[ ('Sugar',subsumption)]).
nounMapping2SUMO('07595914-n',[ ('Sugar',subsumption)]).
nounMapping2SUMO('07596046-n',[ ('Sugar',subsumption)]).
nounMapping2SUMO('07596160-n',[ ('Sugar',subsumption)]).
nounMapping2SUMO('07596258-n',[ ('Sugar',subsumption)]).
nounMapping2SUMO('07596362-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('07596452-n',[ ('Sugar',subsumption)]).
nounMapping2SUMO('07596566-n',[ ('Sugar',subsumption)]).
nounMapping2SUMO('07596684-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07596967-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07597145-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07597263-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07597365-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07598256-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07598335-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('07598529-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07598622-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07598734-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07598928-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07599068-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07599161-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07599242-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07599383-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07599468-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07599554-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07599649-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07599783-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07599911-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07599998-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07600177-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07600285-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07600394-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07600506-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07600696-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07600895-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07601025-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07601175-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07601290-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07601407-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07601572-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07601686-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07601809-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07601999-n',[ ('Chocolate',equivalence)]).
nounMapping2SUMO('07602279-n',[ ('Chocolate',subsumption)]).
nounMapping2SUMO('07602454-n',[ ('Chocolate',subsumption)]).
nounMapping2SUMO('07602650-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07602829-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('07602996-n',[ ('Cocoa',subsumption)]).
nounMapping2SUMO('07603177-n',[ ('Cocoa',subsumption)]).
nounMapping2SUMO('07603411-n',[ ('Chocolate',subsumption)]).
nounMapping2SUMO('07603511-n',[ ('Chocolate',subsumption)]).
nounMapping2SUMO('07603613-n',[ ('Chocolate',subsumption)]).
nounMapping2SUMO('07603722-n',[ ('Cocoa',subsumption)]).
nounMapping2SUMO('07603930-n',[ ('Chocolate',subsumption)]).
nounMapping2SUMO('07604043-n',[ ('Cocoa',subsumption)]).
nounMapping2SUMO('07604182-n',[ ('Chocolate',subsumption)]).
nounMapping2SUMO('07604307-n',[ ('Chocolate',subsumption)]).
nounMapping2SUMO('07604587-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('07604840-n',[ ('Chocolate',subsumption)]).
nounMapping2SUMO('07604956-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07605040-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07605198-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07605282-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07605380-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07605474-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07605597-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07605693-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07605804-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07605944-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07606058-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07606191-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07606278-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07606419-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07606538-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07606669-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07606764-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07606933-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07607027-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07607138-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07607280-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07607361-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07607492-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07607605-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07607707-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07607832-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07607967-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07608098-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07608245-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07608339-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07608429-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07608533-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07608641-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07608721-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07608866-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07608980-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07609083-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07609215-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07609316-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07609407-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07609549-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07609632-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07609728-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07609840-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07610295-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07610502-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07610620-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07610746-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07610890-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07611046-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07611148-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07611267-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07611358-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07611733-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07611839-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07611991-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07612137-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07612273-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07612367-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07612530-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07612632-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07612996-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07613158-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07613266-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07613480-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07613671-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07613815-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07614004-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07614103-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07614198-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07614348-n',[ ('Sorbet',equivalence)]).
nounMapping2SUMO('07614500-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07614730-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07614825-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07614942-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07615052-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07615190-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07615289-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07615460-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07615569-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07615671-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07615774-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07615954-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07616046-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07616174-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07616265-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07616386-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07616487-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07616590-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07616748-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07616906-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07617051-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07617188-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07617344-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07617447-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07617526-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07617611-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07617708-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07617839-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07617932-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07618029-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07618119-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07618281-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07618432-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07618587-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07618684-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07618871-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07619004-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07619208-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07619301-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07619409-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07619508-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07619594-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07619786-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07619881-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07620047-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07620145-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07620327-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07620485-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07620597-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07620689-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07620822-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07621001-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07621140-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07621264-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07621388-n',[ ('Cream',subsumption)]).
nounMapping2SUMO('07621497-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07621618-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07621776-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07621976-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07622061-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07622261-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07622473-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07622587-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07622708-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07623136-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07623263-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07623363-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07623475-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07623576-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07623664-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07623834-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07623933-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07624130-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07624239-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07624339-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07624466-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07624666-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07624757-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07624924-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07625061-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07625201-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07625324-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07625493-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07625831-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07625977-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07626094-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07626174-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07626287-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07626405-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07626501-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07626602-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07626721-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07626833-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07626959-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07627086-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07627223-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07627310-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07627380-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07627478-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07627564-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07627693-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07627790-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07627931-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07628068-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07628181-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07628328-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07628470-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07628576-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07628691-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07628779-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07628870-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07629697-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07629797-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07629898-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07629988-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07630089-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07630220-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07630294-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07630398-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07630512-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07630667-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07630782-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07630909-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07631023-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07631109-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07631212-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07631350-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07631511-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07631672-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07631834-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07631926-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07632037-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07632240-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07632357-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07632515-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07632679-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07632802-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07632980-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07633064-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07633146-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07633229-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07633369-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07633511-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07633640-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07633743-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07633861-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07633960-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07634048-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07634141-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07634306-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07634406-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07634514-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07634605-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07634751-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07634901-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07635044-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07635155-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07635746-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07635827-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07635934-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07636020-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07636126-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07636271-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07636384-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07636534-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07636669-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07636779-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07636869-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07636957-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07637045-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07637178-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07637292-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07637398-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07637508-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07637652-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07637737-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07637949-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07638039-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07638128-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07638226-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07638317-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07638439-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07638574-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07638676-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07638898-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07639069-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07639188-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07639344-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07639475-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07639577-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07639716-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07639855-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07640014-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07640105-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07640203-n',[ ('Pancake',equivalence)]).
nounMapping2SUMO('07640560-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07640653-n',[ ('Pancake',subsumption)]).
nounMapping2SUMO('07640749-n',[ ('Pancake',subsumption)]).
nounMapping2SUMO('07640844-n',[ ('Pancake',subsumption)]).
nounMapping2SUMO('07640991-n',[ ('Pancake',subsumption)]).
nounMapping2SUMO('07641138-n',[ ('Pancake',subsumption)]).
nounMapping2SUMO('07641256-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07641380-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07641581-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07641699-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07641807-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07641928-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07642070-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07642182-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07642361-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07642471-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07642742-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07642833-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07642933-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07643026-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07643200-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07643306-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07643474-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07643577-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07643679-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07643764-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07643891-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07643981-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07644244-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07644382-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07644706-n',[ ('Poultry',equivalence)]).
nounMapping2SUMO('07644967-n',[ ('ChickenMeat',subsumption)]).
nounMapping2SUMO('07645242-n',[ ('ChickenMeat',subsumption)]).
nounMapping2SUMO('07645384-n',[ ('ChickenMeat',subsumption)]).
nounMapping2SUMO('07645469-n',[ ('ChickenMeat',subsumption)]).
nounMapping2SUMO('07645631-n',[ ('ChickenMeat',subsumption)]).
nounMapping2SUMO('07645769-n',[ ('ChickenMeat',subsumption)]).
nounMapping2SUMO('07645886-n',[ ('ChickenMeat',subsumption)]).
nounMapping2SUMO('07646067-n',[ ('ChickenMeat',subsumption)]).
nounMapping2SUMO('07646163-n',[ ('PoultryMeat',subsumption)]).
nounMapping2SUMO('07646284-n',[ ('PoultryMeat',subsumption)]).
nounMapping2SUMO('07646403-n',[ ('PoultryMeat',subsumption)]).
nounMapping2SUMO('07646578-n',[ ('DuckMeat',equivalence)]).
nounMapping2SUMO('07646718-n',[ ('DuckMeat',subsumption)]).
nounMapping2SUMO('07646821-n',[ ('GooseMeat',equivalence)]).
nounMapping2SUMO('07646927-n',[ ('PoultryMeat',subsumption)]).
nounMapping2SUMO('07647115-n',[ ('PoultryMeat',subsumption)]).
nounMapping2SUMO('07647321-n',[ ('PoultryMeat',subsumption)]).
nounMapping2SUMO('07647496-n',[ ('PoultryMeat',subsumption)]).
nounMapping2SUMO('07647602-n',[ ('PoultryMeat',subsumption)]).
nounMapping2SUMO('07647731-n',[ ('TurkeyMeat',subsumption)]).
nounMapping2SUMO('07647870-n',[ ('PoultryMeat',subsumption)]).
nounMapping2SUMO('07648036-n',[ ('TurkeyMeat',subsumption)]).
nounMapping2SUMO('07648150-n',[ ('ChickenMeat',subsumption)]).
nounMapping2SUMO('07648267-n',[ ('PoultryMeat',subsumption)]).
nounMapping2SUMO('07648408-n',[ ('PoultryMeat',subsumption)]).
nounMapping2SUMO('07648549-n',[ ('PoultryMeat',subsumption)]).
nounMapping2SUMO('07648717-n',[ ('TurkeyMeat',subsumption)]).
nounMapping2SUMO('07648814-n',[ ('ChickenMeat',subsumption)]).
nounMapping2SUMO('07648913-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07648997-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07649096-n',[ ('PoultryMeat',subsumption)]).
nounMapping2SUMO('07649202-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07649342-n',[ ('PoultryMeat',subsumption)]).
nounMapping2SUMO('07649463-n',[ ('PoultryMeat',subsumption)]).
nounMapping2SUMO('07649582-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07649854-n',[ ('Meat',equivalence)]).
nounMapping2SUMO('07650449-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07650637-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07650792-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07650903-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07651025-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07651159-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07651245-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07651325-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07651454-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07651774-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07651905-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07652052-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07652207-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07652310-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07652401-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07652488-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07652585-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07652696-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07652788-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07652881-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07652995-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07653126-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07653217-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07653311-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07653394-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07653982-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07654148-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07654298-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07654438-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07654538-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07654667-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07654886-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07655067-n',[ ('Veal',subsumption)]).
nounMapping2SUMO('07655263-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07655337-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07655505-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07655626-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07655790-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07655898-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07655988-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07656077-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07656452-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07656645-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07656741-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07656866-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07656961-n',[ ('Pork',subsumption)]).
nounMapping2SUMO('07657068-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07657233-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07657337-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07657440-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07657547-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07657664-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07657757-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07657903-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07658058-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07658168-n',[ ('Steak',equivalence)]).
nounMapping2SUMO('07658461-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07658580-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07658678-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07658814-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07658958-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07659196-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07659308-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07659425-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07659560-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07659684-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07659793-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07659968-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07660065-n',[ ('Steak',subsumption)]).
nounMapping2SUMO('07660283-n',[ ('Pork',subsumption)]).
nounMapping2SUMO('07660361-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07660463-n',[ ('Steak',subsumption)]).
nounMapping2SUMO('07660590-n',[ ('Steak',subsumption)]).
nounMapping2SUMO('07660686-n',[ ('Steak',subsumption)]).
nounMapping2SUMO('07660800-n',[ ('Steak',subsumption)]).
nounMapping2SUMO('07661002-n',[ ('Steak',subsumption)]).
nounMapping2SUMO('07661165-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07661273-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07661357-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07661486-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07661583-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07661711-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07661845-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07661950-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07662156-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07662275-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07662406-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07662517-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07662618-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07662719-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07662833-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07662978-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07663118-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07663220-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07663360-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07663492-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07663592-n',[ ('Beef',equivalence)]).
nounMapping2SUMO('07663796-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07663899-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07664007-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07664121-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07664266-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07664379-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07664468-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07664582-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07664770-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07664936-n',[ ('Beef',subsumption)]).
nounMapping2SUMO('07665013-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07665146-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07665308-n',[ ('Veal',equivalence)]).
nounMapping2SUMO('07665438-n',[ ('Veal',subsumption)]).
nounMapping2SUMO('07665595-n',[ ('Veal',subsumption)]).
nounMapping2SUMO('07665713-n',[ ('Veal',subsumption)]).
nounMapping2SUMO('07665844-n',[ ('Veal',subsumption)]).
nounMapping2SUMO('07665983-n',[ ('Veal',subsumption)]).
nounMapping2SUMO('07666071-n',[ ('Veal',subsumption)]).
nounMapping2SUMO('07666176-n',[ ('Veal',subsumption)]).
nounMapping2SUMO('07666303-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07666406-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07666521-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07666733-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07666847-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07666933-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07667042-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07667151-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07667326-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07667480-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07667636-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07667778-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07667872-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07667974-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07668073-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07668215-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07668356-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07668481-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07668588-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07668702-n',[ ('Pork',equivalence)]).
nounMapping2SUMO('07668902-n',[ ('Pork',subsumption)]).
nounMapping2SUMO('07669098-n',[ ('Pork',subsumption)]).
nounMapping2SUMO('07669211-n',[ ('Pork',subsumption)]).
nounMapping2SUMO('07669367-n',[ ('Pork',subsumption)]).
nounMapping2SUMO('07669470-n',[ ('Pork',subsumption)]).
nounMapping2SUMO('07669588-n',[ ('Pork',subsumption)]).
nounMapping2SUMO('07669713-n',[ ('Pork',subsumption)]).
nounMapping2SUMO('07669788-n',[ ('Pork',subsumption)]).
nounMapping2SUMO('07669891-n',[ ('Pork',subsumption)]).
nounMapping2SUMO('07670044-n',[ ('Pork',subsumption)]).
nounMapping2SUMO('07670147-n',[ ('Pork',subsumption)]).
nounMapping2SUMO('07670254-n',[ ('Pork',subsumption)]).
nounMapping2SUMO('07670328-n',[ ('Pork',subsumption)]).
nounMapping2SUMO('07670433-n',[ ('Bacon',equivalence)]).
nounMapping2SUMO('07670657-n',[ ('Bacon',subsumption)]).
nounMapping2SUMO('07670731-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07670902-n',[ ('Bacon',subsumption)]).
nounMapping2SUMO('07670995-n',[ ('Bacon',subsumption)]).
nounMapping2SUMO('07671107-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07671269-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07671363-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07671459-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07671581-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07671722-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07671845-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07671953-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07672135-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07672421-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07672583-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07672687-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07672790-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07672914-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07673145-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07673249-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07673397-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07673872-n',[ ('VegetableOil',subsumption)]).
nounMapping2SUMO('07674001-n',[ ('VegetableOil',subsumption)]).
nounMapping2SUMO('07674161-n',[ ('VegetableOil',subsumption)]).
nounMapping2SUMO('07674267-n',[ ('VegetableOil',subsumption)]).
nounMapping2SUMO('07674393-n',[ ('VegetableOil',subsumption)]).
nounMapping2SUMO('07674508-n',[ ('OliveOil',equivalence)]).
nounMapping2SUMO('07674617-n',[ ('PalmOil',equivalence)]).
nounMapping2SUMO('07674749-n',[ ('VegetableOil',subsumption)]).
nounMapping2SUMO('07674912-n',[ ('VegetableOil',subsumption)]).
nounMapping2SUMO('07675040-n',[ ('VegetableOil',subsumption)]).
nounMapping2SUMO('07675156-n',[ ('VegetableOil',subsumption)]).
nounMapping2SUMO('07675262-n',[ ('VegetableOil',subsumption)]).
nounMapping2SUMO('07675411-n',[ ('VegetableOil',subsumption)]).
nounMapping2SUMO('07675535-n',[ ('VegetableOil',subsumption)]).
nounMapping2SUMO('07675627-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07675962-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07676121-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07676273-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07676425-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07676520-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07676602-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07676855-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07676967-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07677071-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07677255-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07677360-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07677480-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07677593-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07677747-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07677860-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07677982-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07678065-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07678193-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07678313-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07678428-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07678586-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07678729-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07678953-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07679034-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07679140-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07679356-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07680168-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07680313-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07680416-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07680517-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07680655-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07680761-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07680932-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07681264-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07681355-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07681450-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07681691-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07681805-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07681926-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07682197-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07682316-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07682477-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07682624-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07682808-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07682952-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07683039-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07683138-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07683265-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07683360-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07683490-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07683617-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07683786-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07683973-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07684084-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07684164-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07684289-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07684422-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07684517-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07684600-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07684938-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07685031-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07685118-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07685218-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07685303-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07685399-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07685546-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07685730-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07685918-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07686021-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07686202-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07686299-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07686461-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07686634-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07686720-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07686873-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07687053-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07687211-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07687381-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07687469-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07687626-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07687789-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07688021-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07688130-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07688265-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07688412-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07688624-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07688757-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07688898-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07689003-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07689217-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07689313-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07689490-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07689624-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07689757-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07689842-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07690019-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07690152-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07690273-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07690431-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07690511-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07690585-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07690739-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07690892-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07691091-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07691237-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07691424-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07691539-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07691650-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07691758-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07691863-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07691954-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07692114-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07692248-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07692405-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07692517-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07692614-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07692887-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07693048-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07693223-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07693439-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07693590-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07693725-n',[ ('Bagel',equivalence)]).
nounMapping2SUMO('07693889-n',[ ('Bagel',subsumption)]).
nounMapping2SUMO('07693972-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07694169-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07694268-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07694403-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07694516-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07694659-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07694839-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07695012-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07695097-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07695187-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07695284-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07695410-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07695504-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07695652-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07695742-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07695878-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07695965-n',[ ('Sandwich',equivalence)]).
nounMapping2SUMO('07696403-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07696527-n',[ ('Sandwich',subsumption)]).
nounMapping2SUMO('07696625-n',[ ('Sandwich',subsumption)]).
nounMapping2SUMO('07696728-n',[ ('Sandwich',subsumption)]).
nounMapping2SUMO('07696839-n',[ ('Sandwich',subsumption)]).
nounMapping2SUMO('07696977-n',[ ('Sandwich',subsumption)]).
nounMapping2SUMO('07697100-n',[ ('Sandwich',subsumption)]).
nounMapping2SUMO('07697313-n',[ ('Sandwich',subsumption)]).
nounMapping2SUMO('07697408-n',[ ('Sandwich',subsumption)]).
nounMapping2SUMO('07697537-n',[ ('Sandwich',subsumption)]).
nounMapping2SUMO('07697699-n',[ ('Sandwich',subsumption)]).
nounMapping2SUMO('07697825-n',[ ('Sandwich',subsumption)]).
nounMapping2SUMO('07698250-n',[ ('Sandwich',subsumption)]).
nounMapping2SUMO('07698401-n',[ ('Sandwich',subsumption)]).
nounMapping2SUMO('07698543-n',[ ('Sandwich',subsumption)]).
nounMapping2SUMO('07698672-n',[ ('Sandwich',subsumption)]).
nounMapping2SUMO('07698782-n',[ ('Sandwich',subsumption)]).
nounMapping2SUMO('07698915-n',[ ('Pasta',equivalence)]).
nounMapping2SUMO('07699430-n',[ ('Pasta',subsumption)]).
nounMapping2SUMO('07699584-n',[ ('Pasta',subsumption)]).
nounMapping2SUMO('07699682-n',[ ('Pasta',subsumption)]).
nounMapping2SUMO('07699815-n',[ ('Pasta',subsumption)]).
nounMapping2SUMO('07699914-n',[ ('Spaghetti',equivalence)]).
nounMapping2SUMO('07700003-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07700095-n',[ ('Spaghetti',subsumption)]).
nounMapping2SUMO('07700167-n',[ ('Pasta',subsumption)]).
nounMapping2SUMO('07700255-n',[ ('Ziti',equivalence)]).
nounMapping2SUMO('07700348-n',[ ('Pasta',subsumption)]).
nounMapping2SUMO('07700439-n',[ ('Pasta',subsumption)]).
nounMapping2SUMO('07700539-n',[ ('Linguine',equivalence)]).
nounMapping2SUMO('07700638-n',[ ('Pasta',subsumption)]).
nounMapping2SUMO('07700766-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07700868-n',[ ('Pasta',subsumption)]).
nounMapping2SUMO('07700964-n',[ ('Pasta',subsumption)]).
nounMapping2SUMO('07701053-n',[ ('Pasta',subsumption)]).
nounMapping2SUMO('07701147-n',[ ('Penne',equivalence)]).
nounMapping2SUMO('07701244-n',[ ('Pasta',subsumption)]).
nounMapping2SUMO('07701372-n',[ ('Pasta',subsumption)]).
nounMapping2SUMO('07701457-n',[ ('Pasta',subsumption)]).
nounMapping2SUMO('07701597-n',[ ('Couscous',equivalence)]).
nounMapping2SUMO('07701715-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07701912-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07702057-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07702193-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07702362-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07702509-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07702642-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07702796-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07702957-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07703053-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07703177-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07703333-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07703515-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07703599-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07703743-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07703889-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07704054-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07704205-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07704305-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07704428-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07704579-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07704656-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07704755-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07704994-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07705137-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07705221-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07705303-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07705386-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07705473-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07705557-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07705633-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07705711-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07705931-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07707451-n',[ ('Vegetable',equivalence)]).
nounMapping2SUMO('07708124-n',[ ('Vegetable',subsumption)]).
nounMapping2SUMO('07708260-n',[ ('Vegetable',subsumption)]).
nounMapping2SUMO('07708398-n',[ ('Vegetable',subsumption)]).
nounMapping2SUMO('07708512-n',[ ('Vegetable',subsumption)]).
nounMapping2SUMO('07708685-n',[ ('Celery',subsumption)]).
nounMapping2SUMO('07708798-n',[ ('Vegetable',subsumption)]).
nounMapping2SUMO('07709046-n',[ ('Vegetable',subsumption)]).
nounMapping2SUMO('07709172-n',[ ('Vegetable',subsumption)]).
nounMapping2SUMO('07709333-n',[ ('Vegetable',subsumption)]).
nounMapping2SUMO('07709701-n',[ ('Vegetable',subsumption)]).
nounMapping2SUMO('07709881-n',[ ('Tofu',equivalence)]).
nounMapping2SUMO('07710007-n',[ ('Vegetable',subsumption)]).
nounMapping2SUMO('07710283-n',[ ('RootVegetable',equivalence)]).
nounMapping2SUMO('07710616-n',[ ('PotatoTuber',equivalence)]).
nounMapping2SUMO('07710952-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07711080-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07711232-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07711371-n',[ ('PotatoTuber',subsumption)]).
nounMapping2SUMO('07711471-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07711569-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07711683-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07711799-n',[ ('PotatoTuber',subsumption)]).
nounMapping2SUMO('07711907-n',[ ('Vegetable',subsumption)]).
nounMapping2SUMO('07712063-n',[ ('Vegetable',subsumption)]).
nounMapping2SUMO('07712267-n',[ ('Vegetable',subsumption)]).
nounMapping2SUMO('07712382-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07712559-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07712748-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07712856-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07712959-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07713074-n',[ ('Eggplant',equivalence)]).
nounMapping2SUMO('07713267-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07713395-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07713763-n',[ ('Mustard',equivalence)]).
nounMapping2SUMO('07713895-n',[ ('Cabbage',equivalence)]).
nounMapping2SUMO('07714078-n',[ ('Cabbage',subsumption)]).
nounMapping2SUMO('07714188-n',[ ('Cabbage',subsumption)]).
nounMapping2SUMO('07714287-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07714448-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07714571-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07714802-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07714895-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07714990-n',[ ('Broccoli',equivalence)]).
nounMapping2SUMO('07715103-n',[ ('Cauliflower',equivalence)]).
nounMapping2SUMO('07715221-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07715407-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07715561-n',[ ('Squash',equivalence)]).
nounMapping2SUMO('07715721-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('07716034-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('07716203-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('07716358-n',[ ('Zucchini',equivalence)]).
nounMapping2SUMO('07716504-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('07716649-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('07716750-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('07716906-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('07717070-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('07717410-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('07717556-n',[ ('ButternutSquash',equivalence)]).
nounMapping2SUMO('07717714-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('07717858-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('07718068-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('07718195-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('07718329-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('07718472-n',[ ('Cucumber',equivalence)]).
nounMapping2SUMO('07718671-n',[ ('Cucumber',subsumption)]).
nounMapping2SUMO('07718747-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07718920-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07719058-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07719213-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07719330-n',[ ('Bamboo',subsumption)]).
nounMapping2SUMO('07719437-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07719616-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07719756-n',[ ('Alfalfa',subsumption)]).
nounMapping2SUMO('07719839-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07719980-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07720084-n',[ ('SugarBeet',equivalence)]).
nounMapping2SUMO('07720185-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07720277-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07720442-n',[ ('Vegetable',subsumption)]).
nounMapping2SUMO('07720615-n',[ ('SweetPepper',equivalence)]).
nounMapping2SUMO('07720875-n',[ ('SweetPepper',subsumption)]).
nounMapping2SUMO('07721018-n',[ ('SweetPepper',subsumption)]).
nounMapping2SUMO('07721118-n',[ ('SweetPepper',subsumption)]).
nounMapping2SUMO('07721195-n',[ ('SweetPepper',subsumption)]).
nounMapping2SUMO('07721325-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07721456-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07721678-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07721833-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07721942-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07722052-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07722217-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07722390-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07722485-n',[ ('Scallion',equivalence)]).
nounMapping2SUMO('07722666-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07722763-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07722888-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07723039-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07723177-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07723330-n',[ ('LeafyGreenVegetable',subsumption)]).
nounMapping2SUMO('07723559-n',[ ('Lettuce',equivalence)]).
nounMapping2SUMO('07723753-n',[ ('Lettuce',subsumption)]).
nounMapping2SUMO('07723968-n',[ ('Lettuce',subsumption)]).
nounMapping2SUMO('07724078-n',[ ('Lettuce',subsumption)]).
nounMapping2SUMO('07724173-n',[ ('Lettuce',subsumption)]).
nounMapping2SUMO('07724269-n',[ ('Lettuce',subsumption)]).
nounMapping2SUMO('07724492-n',[ ('RomaineLettuce',equivalence)]).
nounMapping2SUMO('07724654-n',[ ('Lettuce',subsumption)]).
nounMapping2SUMO('07724819-n',[ ('LeafyGreenVegetable',subsumption)]).
nounMapping2SUMO('07724943-n',[ ('Bean',equivalence)]).
nounMapping2SUMO('07725158-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07725255-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07725376-n',[ ('Pea',equivalence)]).
nounMapping2SUMO('07725531-n',[ ('Pea',subsumption)]).
nounMapping2SUMO('07725663-n',[ ('Pea',subsumption)]).
nounMapping2SUMO('07725789-n',[ ('Pea',subsumption)]).
nounMapping2SUMO('07725888-n',[ ('Pea',subsumption)]).
nounMapping2SUMO('07726009-n',[ ('Pea',subsumption)]).
nounMapping2SUMO('07726095-n',[ ('Pea',subsumption)]).
nounMapping2SUMO('07726230-n',[ ('Pea',subsumption)]).
nounMapping2SUMO('07726386-n',[ ('Pea',subsumption)]).
nounMapping2SUMO('07726525-n',[ ('Pea',subsumption)]).
nounMapping2SUMO('07726672-n',[ ('Pea',subsumption)]).
nounMapping2SUMO('07726796-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07727048-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07727140-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07727252-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07727377-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07727458-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07727578-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07727741-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07727868-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07728053-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07728181-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07728284-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07728391-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07728585-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07728708-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07728804-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07729000-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07729142-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07729225-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07729384-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('07729485-n',[ ('Soybean',equivalence)]).
nounMapping2SUMO('07729828-n',[ ('Soybean',subsumption)]).
nounMapping2SUMO('07729926-n',[ ('Soybean',subsumption)]).
nounMapping2SUMO('07730033-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07730207-n',[ ('Carrot',equivalence)]).
nounMapping2SUMO('07730320-n',[ ('Carrot',subsumption)]).
nounMapping2SUMO('07730406-n',[ ('Celery',equivalence)]).
nounMapping2SUMO('07730562-n',[ ('Celery',subsumption)]).
nounMapping2SUMO('07730708-n',[ ('Celery',subsumption)]).
nounMapping2SUMO('07730855-n',[ ('Endive',subsumption)]).
nounMapping2SUMO('07731006-n',[ ('Radicchio',equivalence)]).
nounMapping2SUMO('07731122-n',[ ('Coffee',subsumption)]).
nounMapping2SUMO('07731284-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07731436-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07731587-n',[ ('Endive',subsumption)]).
nounMapping2SUMO('07731767-n',[ ('Endive',subsumption)]).
nounMapping2SUMO('07731952-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07732168-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07732302-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07732433-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07732525-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07732636-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07732747-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07732904-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07733005-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07733124-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07733217-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07733394-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07733567-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07733712-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07733847-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07734017-n',[ ('Tomato',equivalence)]).
nounMapping2SUMO('07734183-n',[ ('Tomato',subsumption)]).
nounMapping2SUMO('07734292-n',[ ('Tomato',subsumption)]).
nounMapping2SUMO('07734417-n',[ ('Tomato',subsumption)]).
nounMapping2SUMO('07734555-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07734744-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07734879-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07735052-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07735179-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07735294-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07735404-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07735510-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('07735687-n',[ ('Radish',equivalence)]).
nounMapping2SUMO('07735803-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07735981-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07736087-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07736256-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07736371-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07736527-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07736692-n',[ ('Spinach',equivalence)]).
nounMapping2SUMO('07736813-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07736971-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07737081-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07737594-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07737745-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07737980-n',[ ('WaterChestnut',equivalence)]).
nounMapping2SUMO('07738105-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07738224-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07738353-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07738570-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07738760-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07738905-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07739035-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07739125-n',[ ('Apple',equivalence)]).
nounMapping2SUMO('07739344-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07739506-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07739923-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07740033-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07740115-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07740220-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07740342-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07740461-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07740597-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07740744-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07740855-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07740954-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07741138-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07741235-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07741357-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07741461-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07741623-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07741706-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07741804-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07741888-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07742012-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07742224-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07742313-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07742415-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07742513-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07742605-n',[ ('Apple',subsumption)]).
nounMapping2SUMO('07742704-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07743224-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07743384-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07743544-n',[ ('Blueberry',equivalence)]).
nounMapping2SUMO('07743723-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07743902-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07744057-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07744246-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07744430-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07744559-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07744682-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07744811-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07745046-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07745197-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07745357-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07745466-n',[ ('Raspberry',equivalence)]).
nounMapping2SUMO('07745661-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07745803-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07745940-n',[ ('Strawberry',equivalence)]).
nounMapping2SUMO('07746038-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07746186-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07746334-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07746551-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07746749-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07746910-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07747055-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07747455-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07747607-n',[ ('OrangeFruit',equivalence)]).
nounMapping2SUMO('07747811-n',[ ('OrangeFruit',subsumption)]).
nounMapping2SUMO('07747951-n',[ ('OrangeFruit',subsumption)]).
nounMapping2SUMO('07748157-n',[ ('OrangeFruit',subsumption)]).
nounMapping2SUMO('07748276-n',[ ('OrangeFruit',subsumption)]).
nounMapping2SUMO('07748416-n',[ ('OrangeFruit',subsumption)]).
nounMapping2SUMO('07748574-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07748753-n',[ ('OrangeFruit',subsumption)]).
nounMapping2SUMO('07748912-n',[ ('OrangeFruit',subsumption)]).
nounMapping2SUMO('07749095-n',[ ('OrangeFruit',subsumption)]).
nounMapping2SUMO('07749192-n',[ ('OrangeFruit',subsumption)]).
nounMapping2SUMO('07749312-n',[ ('OrangeFruit',subsumption)]).
nounMapping2SUMO('07749446-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07749582-n',[ ('LemonFruit',equivalence)]).
nounMapping2SUMO('07749731-n',[ ('Lime',equivalence)]).
nounMapping2SUMO('07749870-n',[ ('Lime',subsumption)]).
nounMapping2SUMO('07749969-n',[ ('Grapefruit',equivalence)]).
nounMapping2SUMO('07750146-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07750299-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07750449-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07750586-n',[ ('Almond',equivalence)]).
nounMapping2SUMO('07750736-n',[ ('Almond',subsumption)]).
nounMapping2SUMO('07750872-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07751004-n',[ ('Peach',equivalence)]).
nounMapping2SUMO('07751148-n',[ ('Peach',subsumption)]).
nounMapping2SUMO('07751280-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07751451-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07751737-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07751858-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07751977-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07752109-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07752264-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07752377-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07752514-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07752602-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07752664-n',[ ('Raisin',equivalence)]).
nounMapping2SUMO('07752782-n',[ ('Raisin',subsumption)]).
nounMapping2SUMO('07752874-n',[ ('Raisin',subsumption)]).
nounMapping2SUMO('07752966-n',[ ('Raisin',subsumption)]).
nounMapping2SUMO('07753113-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07753275-n',[ ('Pineapple',equivalence)]).
nounMapping2SUMO('07753448-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07753592-n',[ ('Banana',equivalence)]).
nounMapping2SUMO('07753743-n',[ ('PassionFruit',equivalence)]).
nounMapping2SUMO('07753980-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07754155-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07754279-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07754451-n',[ ('Breadfruit',equivalence)]).
nounMapping2SUMO('07754684-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07754894-n',[ ('CocoaBean',equivalence)]).
nounMapping2SUMO('07755089-n',[ ('Cocoa',equivalence)]).
nounMapping2SUMO('07755262-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07755411-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07755619-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07755707-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07755929-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07756096-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07756325-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07756499-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07756641-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07756838-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07756951-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07757132-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07757312-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07757511-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07757602-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07757753-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07757874-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07757990-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07758125-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07758260-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07758407-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07758582-n',[ ('Pickle',equivalence)]).
nounMapping2SUMO('07758680-n',[ ('Grape',equivalence)]).
nounMapping2SUMO('07758950-n',[ ('Grape',subsumption)]).
nounMapping2SUMO('07759194-n',[ ('Grape',subsumption)]).
nounMapping2SUMO('07759324-n',[ ('Grape',subsumption)]).
nounMapping2SUMO('07759424-n',[ ('Grape',subsumption)]).
nounMapping2SUMO('07759576-n',[ ('Grape',subsumption)]).
nounMapping2SUMO('07759691-n',[ ('Grape',subsumption)]).
nounMapping2SUMO('07759816-n',[ ('Grape',subsumption)]).
nounMapping2SUMO('07760070-n',[ ('Grape',subsumption)]).
nounMapping2SUMO('07760153-n',[ ('Grape',subsumption)]).
nounMapping2SUMO('07760297-n',[ ('Grape',subsumption)]).
nounMapping2SUMO('07760395-n',[ ('Grape',subsumption)]).
nounMapping2SUMO('07760501-n',[ ('Grape',subsumption)]).
nounMapping2SUMO('07760673-n',[ ('Grape',subsumption)]).
nounMapping2SUMO('07760755-n',[ ('Grape',subsumption)]).
nounMapping2SUMO('07760859-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07761141-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07761309-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07761461-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07761611-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07761777-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07761954-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07762114-n',[ ('Papaw',equivalence)]).
nounMapping2SUMO('07762244-n',[ ('Papaya',equivalence)]).
nounMapping2SUMO('07762373-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07762534-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07762740-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07762913-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07763107-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07763290-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07763483-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07763629-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07763792-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07763987-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07764155-n',[ ('Mango',equivalence)]).
nounMapping2SUMO('07764315-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07764486-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07764630-n',[ ('TamarindFruit',equivalence)]).
nounMapping2SUMO('07764847-n',[ ('Avocado',equivalence)]).
nounMapping2SUMO('07765073-n',[ ('DateFruit',equivalence)]).
nounMapping2SUMO('07765208-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07765361-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07765517-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07765612-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07765728-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07765862-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07765999-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07766173-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07766409-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07766530-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07766723-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07766891-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07767002-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07767171-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07767344-n',[ ('Olive',equivalence)]).
nounMapping2SUMO('07767549-n',[ ('Olive',subsumption)]).
nounMapping2SUMO('07767709-n',[ ('Olive',subsumption)]).
nounMapping2SUMO('07767847-n',[ ('PearFruit',equivalence)]).
nounMapping2SUMO('07768068-n',[ ('PearFruit',subsumption)]).
nounMapping2SUMO('07768139-n',[ ('PearFruit',subsumption)]).
nounMapping2SUMO('07768230-n',[ ('PearFruit',subsumption)]).
nounMapping2SUMO('07768318-n',[ ('PearFruit',subsumption)]).
nounMapping2SUMO('07768423-n',[ ('Plantain',equivalence)]).
nounMapping2SUMO('07768590-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07768694-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07768858-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07769005-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07769102-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07769306-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07769465-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07769584-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07769731-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07769886-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07770034-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07770180-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07770289-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07770439-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07770571-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07770763-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07770869-n',[ ('Stimulant',subsumption), ('Nut',subsumption)]).
nounMapping2SUMO('07771082-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('07771212-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('07771405-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('07771539-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('07771731-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('07771891-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('07772026-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('07772147-n',[ ('CashewNut',equivalence)]).
nounMapping2SUMO('07772274-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('07772413-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('07772631-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('07772788-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('07772935-n',[ ('Coconut',equivalence)]).
nounMapping2SUMO('07773238-n',[ ('Coconut',subsumption)]).
nounMapping2SUMO('07773428-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07773572-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07773700-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07773827-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07774032-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07774182-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('07774295-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('07774479-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('07774596-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('07774719-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('07774842-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('07775050-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('07775197-n',[ ('SunflowerSeed',equivalence)]).
nounMapping2SUMO('07775375-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07775905-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07776545-n',[ ('Seafood',subsumption)]).
nounMapping2SUMO('07776866-n',[ ('Seafood',equivalence)]).
nounMapping2SUMO('07777189-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07777358-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07777512-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07777735-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07777840-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07777945-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07778103-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07778224-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07778342-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07778494-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07778680-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07778810-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07778938-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07779123-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07779263-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07779375-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07779535-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07779664-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07779747-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07779895-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07780038-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07780173-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07780307-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07780486-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07780627-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07780874-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07781022-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07781207-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07781319-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07781497-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07781689-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07781801-n',[ ('Calamari',equivalence)]).
nounMapping2SUMO('07781972-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07782204-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07782365-n',[ ('OctopusMeat',subsumption)]).
nounMapping2SUMO('07782475-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07782668-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07782804-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07782939-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07783102-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07783210-n',[ ('Shellfish',equivalence)]).
nounMapping2SUMO('07783550-n',[ ('MusselMeat',subsumption)]).
nounMapping2SUMO('07783667-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07783827-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07783967-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07784197-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07784274-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07784367-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07784522-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07784810-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07784991-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07785138-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07785235-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07785342-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07785487-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07785631-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07785783-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07785887-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07786005-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07786164-n',[ ('OysterMeat',equivalence)]).
nounMapping2SUMO('07786337-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07786484-n',[ ('OysterMeat',subsumption)]).
nounMapping2SUMO('07786686-n',[ ('ClamMeat',equivalence)]).
nounMapping2SUMO('07786856-n',[ ('ClamMeat',subsumption)]).
nounMapping2SUMO('07787108-n',[ ('ClamMeat',subsumption)]).
nounMapping2SUMO('07787270-n',[ ('ClamMeat',subsumption)]).
nounMapping2SUMO('07787429-n',[ ('ClamMeat',subsumption)]).
nounMapping2SUMO('07787613-n',[ ('ClamMeat',subsumption)]).
nounMapping2SUMO('07787715-n',[ ('CrabMeat',equivalence)]).
nounMapping2SUMO('07787980-n',[ ('CrabMeat',subsumption)]).
nounMapping2SUMO('07788106-n',[ ('CrabMeat',subsumption)]).
nounMapping2SUMO('07788198-n',[ ('CrabMeat',subsumption)]).
nounMapping2SUMO('07788340-n',[ ('CrabMeat',subsumption)]).
nounMapping2SUMO('07788435-n',[ ('CrabMeat',subsumption)]).
nounMapping2SUMO('07788609-n',[ ('CrabMeat',subsumption)]).
nounMapping2SUMO('07788730-n',[ ('CrabMeat',subsumption)]).
nounMapping2SUMO('07788885-n',[ ('CrayfishMeat',equivalence)]).
nounMapping2SUMO('07789063-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07789240-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07789382-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07789541-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07789745-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07789911-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07790081-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07790246-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07790400-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07790601-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07790800-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07790935-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07791039-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07791145-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07791274-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07791434-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07791535-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07791663-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07791808-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07791937-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07792027-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07792117-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07792219-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07792383-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07792470-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07792640-n',[ ('Shellfish',subsumption)]).
nounMapping2SUMO('07792725-n',[ ('LobsterMeat',equivalence)]).
nounMapping2SUMO('07792926-n',[ ('LobsterMeat',subsumption)]).
nounMapping2SUMO('07793133-n',[ ('LobsterMeat',subsumption)]).
nounMapping2SUMO('07793260-n',[ ('LobsterMeat',subsumption)]).
nounMapping2SUMO('07793521-n',[ ('LobsterMeat',subsumption)]).
nounMapping2SUMO('07793685-n',[ ('LobsterMeat',subsumption)]).
nounMapping2SUMO('07793795-n',[ ('LobsterMeat',subsumption)]).
nounMapping2SUMO('07793946-n',[ ('LobsterMeat',subsumption)]).
nounMapping2SUMO('07794063-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07794159-n',[ ('PrawnMeat',equivalence)]).
nounMapping2SUMO('07794353-n',[ ('PrawnMeat',subsumption)]).
nounMapping2SUMO('07794452-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07794605-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07794744-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07794893-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07795019-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07795133-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07795317-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07795459-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07795598-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07795751-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07796005-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07796165-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07796321-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07796468-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07796649-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07796750-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07796877-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07796970-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07797189-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07797357-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07797518-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07797641-n',[ ('ScallopMeat',subsumption)]).
nounMapping2SUMO('07797913-n',[ ('ScallopMeat',subsumption)]).
nounMapping2SUMO('07798025-n',[ ('ScallopMeat',subsumption)]).
nounMapping2SUMO('07798147-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07798233-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07798357-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07798554-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07798728-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07798872-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07798985-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07799132-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07799278-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07799447-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07799579-n',[ ('Caviar',equivalence)]).
nounMapping2SUMO('07799738-n',[ ('Caviar',subsumption)]).
nounMapping2SUMO('07799874-n',[ ('FishRoe',subsumption)]).
nounMapping2SUMO('07800004-n',[ ('FishMeat',subsumption)]).
nounMapping2SUMO('07800091-n',[ ('Fodder',subsumption)]).
nounMapping2SUMO('07800487-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07800636-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07800740-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07801007-n',[ ('CerealGrain',subsumption)]).
nounMapping2SUMO('07801091-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07801342-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07801508-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07801709-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07801779-n',[ ('Alfalfa',equivalence)]).
nounMapping2SUMO('07801892-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07802026-n',[ ('Hay',equivalence)]).
nounMapping2SUMO('07802152-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07802246-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07802417-n',[ ('CerealGrain',equivalence)]).
nounMapping2SUMO('07802767-n',[ ('CerealGrain',subsumption)]).
nounMapping2SUMO('07802863-n',[ ('CerealGrain',subsumption)]).
nounMapping2SUMO('07802963-n',[ ('MilletGrain',equivalence)]).
nounMapping2SUMO('07803093-n',[ ('BarleyGrain',equivalence)]).
nounMapping2SUMO('07803213-n',[ ('BarleyGrain',subsumption)]).
nounMapping2SUMO('07803310-n',[ ('CerealGrain',subsumption)]).
nounMapping2SUMO('07803408-n',[ ('CerealGrain',subsumption)]).
nounMapping2SUMO('07803545-n',[ ('WheatGrain',equivalence)]).
nounMapping2SUMO('07803779-n',[ ('WheatGrain',subsumption)]).
nounMapping2SUMO('07803895-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07803992-n',[ ('WheatGrain',subsumption)]).
nounMapping2SUMO('07804152-n',[ ('OatGrain',equivalence)]).
nounMapping2SUMO('07804323-n',[ ('RiceGrain',equivalence)]).
nounMapping2SUMO('07804543-n',[ ('RiceGrain',subsumption)]).
nounMapping2SUMO('07804657-n',[ ('RiceGrain',subsumption)]).
nounMapping2SUMO('07804771-n',[ ('RiceGrain',subsumption)]).
nounMapping2SUMO('07804900-n',[ ('RiceGrain',subsumption)]).
nounMapping2SUMO('07805006-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07805254-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07805389-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07805478-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07805594-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07805731-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07805872-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07805966-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07806043-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07806120-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07806221-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07806633-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07806774-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07806879-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07807002-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07807171-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07807317-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07807472-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07807594-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07807710-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07807834-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07807922-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07808022-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07808166-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07808268-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07808352-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07808479-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07808587-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07808675-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07808806-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07808904-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07809096-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07809368-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07810531-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07810633-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07810745-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07810825-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07810907-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07811416-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07812046-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07812184-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07812497-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07812662-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07812790-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07812913-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07813107-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07813324-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07813409-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07813495-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07813579-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07813717-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07813833-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07814007-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07814203-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07814390-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07814487-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07814634-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07814790-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07814925-n',[ ('Ginger',equivalence)]).
nounMapping2SUMO('07815163-n',[ ('Ginger',subsumption)]).
nounMapping2SUMO('07815294-n',[ ('Mace',equivalence)]).
nounMapping2SUMO('07815424-n',[ ('Nutmeg',equivalence)]).
nounMapping2SUMO('07815588-n',[ ('SpicePepper',equivalence)]).
nounMapping2SUMO('07815839-n',[ ('BlackPepper',equivalence)]).
nounMapping2SUMO('07815956-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07816052-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07816164-n',[ ('Basil',equivalence)]).
nounMapping2SUMO('07816296-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07816398-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07816575-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07816726-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07816839-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07817024-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07817160-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07817315-n',[ ('Cilantro',equivalence)]).
nounMapping2SUMO('07817465-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07817599-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07817758-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07817871-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07818029-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07818133-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07818277-n',[ ('Garlic',equivalence)]).
nounMapping2SUMO('07818422-n',[ ('Garlic',subsumption)]).
nounMapping2SUMO('07818572-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07818689-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07818825-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07818995-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07819166-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07819303-n',[ ('Seed',subsumption)]).
nounMapping2SUMO('07819480-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07819682-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07819769-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07819896-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07820036-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07820145-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07820297-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07820497-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07820683-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07820814-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07820960-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07821107-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07821260-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07821404-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07821610-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07821758-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07821919-n',[ ('Turmeric',equivalence)]).
nounMapping2SUMO('07822053-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07822197-n',[ ('Ketchup',equivalence)]).
nounMapping2SUMO('07822323-n',[ ('Cardamom',equivalence)]).
nounMapping2SUMO('07822518-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07822687-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07822845-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07823004-n',[ ('Vinegar',subsumption)]).
nounMapping2SUMO('07823105-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07823280-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07823369-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07823460-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07823591-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07823698-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07823814-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07823951-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07824191-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07824268-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07824383-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07824502-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07824702-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07824863-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07824988-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07825194-n',[ ('Pickle',subsumption)]).
nounMapping2SUMO('07825312-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07825399-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07825496-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07825597-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07825717-n',[ ('Pickle',subsumption)]).
nounMapping2SUMO('07825850-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07825972-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07826091-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07826250-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07826340-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07826453-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07826544-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07826653-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07826930-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07827130-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07827284-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07827410-n',[ ('SesameSeed',equivalence)]).
nounMapping2SUMO('07827554-n',[ ('Seed',subsumption)]).
nounMapping2SUMO('07827750-n',[ ('Seed',subsumption)]).
nounMapping2SUMO('07827896-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07828041-n',[ ('Seed',subsumption)]).
nounMapping2SUMO('07828156-n',[ ('Seed',subsumption)]).
nounMapping2SUMO('07828275-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07828378-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07828642-n',[ ('Vanilla',equivalence)]).
nounMapping2SUMO('07828807-n',[ ('Vanilla',subsumption)]).
nounMapping2SUMO('07828987-n',[ ('Vinegar',equivalence)]).
nounMapping2SUMO('07829248-n',[ ('Vinegar',subsumption)]).
nounMapping2SUMO('07829331-n',[ ('Vinegar',subsumption)]).
nounMapping2SUMO('07829412-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07830493-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07830593-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07830690-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07830841-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07830986-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07831146-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07831267-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07831450-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07831663-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07831821-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07831955-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07832099-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07832202-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07832307-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07832416-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07832592-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07832741-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07832902-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07833333-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07833535-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07833672-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07833816-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07833951-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07834065-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07834160-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07834286-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07834507-n',[ ('Mayonnaise',equivalence)]).
nounMapping2SUMO('07834618-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07834774-n',[ ('Aioli',equivalence)]).
nounMapping2SUMO('07834872-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07835051-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07835173-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07835331-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07835457-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07835547-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07835701-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07835823-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07835921-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07836077-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07836269-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07836456-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07836600-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07836731-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07836838-n',[ ('Chocolate',subsumption)]).
nounMapping2SUMO('07837002-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07837110-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07837234-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07837362-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07837545-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07837630-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07837755-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07837912-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07838073-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07838233-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07838441-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07838551-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07838659-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07838811-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07838905-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07839055-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07839172-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07839312-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07839478-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07839593-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07839730-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07839864-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07840027-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07840124-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07840219-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07840304-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07840395-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07840520-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07840672-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07840804-n',[ ('BirdEgg',equivalence)]).
nounMapping2SUMO('07841037-n',[ ('BirdEgg',subsumption)]).
nounMapping2SUMO('07841345-n',[ ('EggYolk',equivalence)]).
nounMapping2SUMO('07841495-n',[ ('BirdEgg',subsumption)]).
nounMapping2SUMO('07841639-n',[ ('BirdEgg',subsumption)]).
nounMapping2SUMO('07841800-n',[ ('BirdEgg',subsumption)]).
nounMapping2SUMO('07841907-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07842044-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07842130-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07842202-n',[ ('BirdEgg',subsumption)]).
nounMapping2SUMO('07842308-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07842433-n',[ ('BirdEgg',subsumption)]).
nounMapping2SUMO('07842605-n',[ ('BirdEgg',subsumption)]).
nounMapping2SUMO('07842753-n',[ ('Omelette',equivalence)]).
nounMapping2SUMO('07842972-n',[ ('Omelette',subsumption)]).
nounMapping2SUMO('07843117-n',[ ('Omelette',subsumption)]).
nounMapping2SUMO('07843220-n',[ ('Omelette',subsumption)]).
nounMapping2SUMO('07843348-n',[ ('Omelette',subsumption)]).
nounMapping2SUMO('07843464-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07843636-n',[ ('BirdEgg',subsumption)]).
nounMapping2SUMO('07843775-n',[ ('DiaryProduct',equivalence)]).
nounMapping2SUMO('07844042-n',[ ('Milk',equivalence)]).
nounMapping2SUMO('07844604-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07844786-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07844867-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07845087-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07845166-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07845335-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07845421-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07845495-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07845571-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07845702-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07845775-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07845863-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07846014-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07846143-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07846274-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07846359-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07846471-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07846557-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07846688-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07846802-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07846938-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07847047-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07847198-n',[ ('Cream',equivalence)]).
nounMapping2SUMO('07847453-n',[ ('Cream',subsumption)]).
nounMapping2SUMO('07847585-n',[ ('Cream',subsumption)]).
nounMapping2SUMO('07847706-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07847827-n',[ ('Cream',subsumption)]).
nounMapping2SUMO('07847917-n',[ ('Cream',subsumption)]).
nounMapping2SUMO('07848093-n',[ ('Milk',subsumption)]).
nounMapping2SUMO('07848196-n',[ ('Cream',subsumption)]).
nounMapping2SUMO('07848338-n',[ ('Butter',equivalence)]).
nounMapping2SUMO('07848645-n',[ ('Butter',subsumption)]).
nounMapping2SUMO('07848771-n',[ ('Butter',subsumption)]).
nounMapping2SUMO('07848936-n',[ ('Butter',subsumption)]).
nounMapping2SUMO('07849026-n',[ ('Butter',subsumption)]).
nounMapping2SUMO('07849186-n',[ ('Butter',subsumption)]).
nounMapping2SUMO('07849336-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07849506-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07849619-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07849733-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07849912-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07850083-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07850219-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07850329-n',[ ('Cheese',equivalence)]).
nounMapping2SUMO('07850957-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07851054-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07851298-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07851443-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07851554-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07851641-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07851767-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07851926-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07852045-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07852229-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07852302-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07852376-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07852452-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07852532-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07852614-n',[ ('Brie',equivalence)]).
nounMapping2SUMO('07852712-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07852833-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07852919-n',[ ('CheddarCheese',equivalence)]).
nounMapping2SUMO('07853125-n',[ ('CheddarCheese',subsumption)]).
nounMapping2SUMO('07853232-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07853345-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07853445-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07853560-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07853648-n',[ ('Gouda',equivalence)]).
nounMapping2SUMO('07853762-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07853852-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07853946-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07854066-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07854184-n',[ ('Mozzarella',equivalence)]).
nounMapping2SUMO('07854266-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07854348-n',[ ('ParmesanCheese',equivalence)]).
nounMapping2SUMO('07854455-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07854614-n',[ ('RicottaCheese',equivalence)]).
nounMapping2SUMO('07854707-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07854813-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07854982-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07855105-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07855188-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07855317-n',[ ('Cheese',subsumption)]).
nounMapping2SUMO('07855413-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07855510-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07855603-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07855721-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07855812-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07855907-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07856045-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07856186-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07856270-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07856756-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07856895-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07856992-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07857076-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07857170-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07857356-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07857598-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07857731-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07857959-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07858114-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07858197-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07858336-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07858484-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07858595-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07858841-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07858978-n',[ ('Honey',equivalence)]).
nounMapping2SUMO('07859142-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07859284-n',[ ('Sugar',equivalence)]).
nounMapping2SUMO('07859583-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07859796-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07859951-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07860103-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07860208-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07860331-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07860447-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07860548-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07860629-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07860805-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07860988-n',[ ('Dough',subsumption)]).
nounMapping2SUMO('07861158-n',[ ('Dough',subsumption)]).
nounMapping2SUMO('07861247-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07861334-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07861421-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07861557-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07861681-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07861813-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07861983-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07862095-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07862244-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07862348-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07862461-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07862611-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07862770-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07862946-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07863107-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07863229-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07863374-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07863547-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07863644-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07863802-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07863935-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07864065-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07864198-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07864317-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07864475-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07864638-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07864756-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07864934-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07865105-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07865196-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07865484-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07865575-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07865700-n',[ ('Seafood',subsumption)]).
nounMapping2SUMO('07865788-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07865911-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07866015-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07866151-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07866277-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07866409-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07866571-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07866723-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07866868-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07867021-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07867164-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07867324-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07867421-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07867616-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07867751-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07867883-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07868045-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07868200-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07868340-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07868508-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07868684-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07868830-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07868955-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07869111-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07869291-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07869391-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07869522-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07869611-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07869775-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07869937-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07870069-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07870167-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07870313-n',[ ('Seafood',subsumption)]).
nounMapping2SUMO('07870478-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07870620-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07870734-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07870894-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07871065-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07871234-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07871335-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07871436-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07871588-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07871720-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07871810-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07871940-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07872170-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07872284-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07872381-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07872492-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07872593-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07872748-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07872915-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07873057-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07873198-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07873348-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07873464-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07873679-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07873807-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07874063-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07874159-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07874259-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07874343-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07874441-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07874531-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07874674-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07874780-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07874995-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07875086-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07875152-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07875267-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07875436-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07875560-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07875693-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07875835-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07875926-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07876026-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07876189-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07876281-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07876460-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07876550-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07876651-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07876775-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07876893-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07877062-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07877187-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07877299-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07877411-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07877575-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07877675-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07877849-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07877961-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07878145-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07878283-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07878479-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07878647-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07878785-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07878926-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07879072-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07879174-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07879350-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('07879450-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07879560-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07879659-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07879821-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07879953-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07880080-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07880213-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07880325-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07880458-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07880583-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07880751-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07880880-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07880968-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07881117-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07881205-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07881310-n',[ ('BreadOrBiscuit',subsumption)]).
nounMapping2SUMO('07881404-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07881525-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07881625-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07881800-n',[ ('Beverage',equivalence)]).
nounMapping2SUMO('07882420-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07882497-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07882886-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07883031-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07883156-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07883251-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07883384-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('07883510-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('07883661-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07883860-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07883980-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07884182-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07884266-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07884413-n',[ ('Drinking',subsumption)]).
nounMapping2SUMO('07884567-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07885223-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07885705-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07885832-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07885937-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07886057-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07886176-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07886317-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07886463-n',[ ('Aperitif',equivalence)]).
nounMapping2SUMO('07886572-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07886849-n',[ ('Beer',equivalence)]).
nounMapping2SUMO('07887099-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07887192-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07887304-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07887461-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07887634-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07887967-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07888058-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07888229-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07888378-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('07888465-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07888709-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07888816-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07888909-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07889193-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07889274-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07889510-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07889814-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07889990-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07890068-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07890226-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07890352-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07890540-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07890617-n',[ ('Beer',subsumption)]).
nounMapping2SUMO('07890750-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07890890-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07890970-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07891095-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07891189-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07891309-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07891433-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07891613-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07891726-n',[ ('Wine',equivalence)]).
nounMapping2SUMO('07892418-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07892512-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07892813-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07893253-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07893425-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07893528-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07893642-n',[ ('Champagne',equivalence)]).
nounMapping2SUMO('07893792-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07893891-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07894102-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07894298-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07894451-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07894551-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07894703-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07894799-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07894965-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07895100-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07895237-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07895435-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07895595-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07895710-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07895839-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07895962-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07896060-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07896165-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07896287-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07896422-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07896560-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07896661-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07896765-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07896893-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07896994-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07897116-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07897200-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07897438-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07897600-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07897750-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07897865-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07897975-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07898117-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07898247-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07898333-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07898443-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07898617-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07898745-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07898895-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07899003-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07899108-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07899292-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07899434-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07899533-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07899660-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07899769-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07899899-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07899976-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07900225-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07900406-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07900616-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07900734-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07900825-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07900958-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07901176-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07901264-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07901355-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07901457-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07901587-n',[ ('DistilledAlcoholicBeverage',equivalence)]).
nounMapping2SUMO('07902121-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07902336-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07902443-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07902520-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07902698-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07902799-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07902937-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07903101-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07903208-n',[ ('Brandy',equivalence)]).
nounMapping2SUMO('07903543-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07903643-n',[ ('Brandy',subsumption)]).
nounMapping2SUMO('07903731-n',[ ('Brandy',subsumption)]).
nounMapping2SUMO('07903841-n',[ ('Brandy',subsumption)]).
nounMapping2SUMO('07903962-n',[ ('Brandy',subsumption)]).
nounMapping2SUMO('07904072-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07904190-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07904293-n',[ ('Brandy',subsumption)]).
nounMapping2SUMO('07904395-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07904637-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07904760-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07904865-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07904934-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07905038-n',[ ('Rum',equivalence)]).
nounMapping2SUMO('07905296-n',[ ('Rum',subsumption)]).
nounMapping2SUMO('07905386-n',[ ('Rum',subsumption)]).
nounMapping2SUMO('07905474-n',[ ('Schnapps',equivalence)]).
nounMapping2SUMO('07905618-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07905770-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07905979-n',[ ('Tequila',equivalence)]).
nounMapping2SUMO('07906111-n',[ ('Vodka',equivalence)]).
nounMapping2SUMO('07906284-n',[ ('Whiskey',equivalence)]).
nounMapping2SUMO('07906572-n',[ ('Whiskey',subsumption)]).
nounMapping2SUMO('07906718-n',[ ('Whiskey',subsumption)]).
nounMapping2SUMO('07906877-n',[ ('Whiskey',subsumption)]).
nounMapping2SUMO('07907037-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07907161-n',[ ('Whiskey',subsumption)]).
nounMapping2SUMO('07907342-n',[ ('Whiskey',subsumption)]).
nounMapping2SUMO('07907429-n',[ ('Whiskey',subsumption)]).
nounMapping2SUMO('07907548-n',[ ('Whiskey',subsumption)]).
nounMapping2SUMO('07907831-n',[ ('Whiskey',subsumption)]).
nounMapping2SUMO('07907943-n',[ ('Liqueur',equivalence)]).
nounMapping2SUMO('07908411-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07908567-n',[ ('Amaretto',equivalence)]).
nounMapping2SUMO('07908647-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07908812-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07908923-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07909129-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07909231-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07909362-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07909504-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07909593-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07909714-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07909811-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07909954-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07910048-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07910152-n',[ ('GrandMarnier',equivalence)]).
nounMapping2SUMO('07910245-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07910379-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07910538-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07910656-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07910799-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07910970-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07911061-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07911249-n',[ ('Liqueur',subsumption)]).
nounMapping2SUMO('07911371-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07911677-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07912093-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07912211-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07912499-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07912619-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07912726-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07912834-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07912933-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07913081-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07913180-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07913300-n',[ ('Wine',subsumption)]).
nounMapping2SUMO('07913393-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07913537-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07913644-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07913774-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07913882-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07914006-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07914128-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07914271-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07914413-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07914586-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07914686-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07914777-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07914887-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07914995-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07915094-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07915213-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07915366-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07915491-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07915618-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07915800-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07915918-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07916041-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07916183-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07916319-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07916437-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07916582-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07916773-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07916872-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07916970-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07917133-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07917272-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07917392-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07917507-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07917618-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07917791-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07917874-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07917951-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07918028-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07918193-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07918309-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07918454-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07918601-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07918706-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07918879-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07919055-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07919165-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07919310-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07919441-n',[ ('AlcoholicBeverage',subsumption), ('Coffee',subsumption)]).
nounMapping2SUMO('07919572-n',[ ('Coffee',subsumption)]).
nounMapping2SUMO('07919665-n',[ ('Coffee',subsumption)]).
nounMapping2SUMO('07919787-n',[ ('Coffee',subsumption)]).
nounMapping2SUMO('07919894-n',[ ('Coffee',subsumption)]).
nounMapping2SUMO('07920052-n',[ ('Espresso',equivalence)]).
nounMapping2SUMO('07920222-n',[ ('Espresso',subsumption)]).
nounMapping2SUMO('07920349-n',[ ('Cappuccino',equivalence)]).
nounMapping2SUMO('07920540-n',[ ('Coffee',subsumption)]).
nounMapping2SUMO('07920663-n',[ ('Coffee',subsumption)]).
nounMapping2SUMO('07920872-n',[ ('Coffee',subsumption)]).
nounMapping2SUMO('07920989-n',[ ('Coffee',subsumption)]).
nounMapping2SUMO('07921090-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07921239-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07921360-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07921455-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07921615-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07921834-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07921948-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07922041-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07922147-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07922299-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07922512-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07922607-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07922764-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07922955-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07923034-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07923176-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07923297-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07923495-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07923576-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07923665-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07923748-n',[ ('Juice',equivalence)]).
nounMapping2SUMO('07924033-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07924276-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07924366-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07924443-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07924560-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07924655-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07924747-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07924834-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07924955-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07925116-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07925229-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07925327-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07925423-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07925500-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07925608-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07925708-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07925808-n',[ ('AlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07925966-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07926127-n',[ ('DistilledAlcoholicBeverage',subsumption)]).
nounMapping2SUMO('07926250-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07926346-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07926442-n',[ ('Juice',subsumption)]).
nounMapping2SUMO('07926540-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07926642-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07926785-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07926920-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07927070-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07927197-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07927512-n',[ ('Soda',equivalence)]).
nounMapping2SUMO('07927716-n',[ ('Soda',subsumption)]).
nounMapping2SUMO('07927836-n',[ ('Soda',subsumption)]).
nounMapping2SUMO('07927931-n',[ ('Soda',subsumption)]).
nounMapping2SUMO('07928163-n',[ ('Soda',subsumption)]).
nounMapping2SUMO('07928264-n',[ ('Soda',subsumption)]).
nounMapping2SUMO('07928367-n',[ ('Soda',subsumption)]).
nounMapping2SUMO('07928488-n',[ ('Soda',subsumption)]).
nounMapping2SUMO('07928578-n',[ ('Soda',subsumption)]).
nounMapping2SUMO('07928696-n',[ ('Soda',subsumption)]).
nounMapping2SUMO('07928790-n',[ ('Soda',subsumption)]).
nounMapping2SUMO('07928887-n',[ ('Soda',subsumption)]).
nounMapping2SUMO('07928998-n',[ ('Soda',subsumption)]).
nounMapping2SUMO('07929172-n',[ ('Soda',subsumption)]).
nounMapping2SUMO('07929351-n',[ ('CoffeeBean',equivalence)]).
nounMapping2SUMO('07929519-n',[ ('Coffee',equivalence)]).
nounMapping2SUMO('07929940-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07930062-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07930205-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07930315-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07930433-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07930554-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07930864-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07931001-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07931096-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07931280-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07931452-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07931612-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('07931733-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07931870-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07932039-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07932176-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07932323-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07932454-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07932614-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07932762-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07932841-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07933154-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('07933274-n',[ ('Tea',equivalence)]).
nounMapping2SUMO('07933530-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07933652-n',[ ('Tea',subsumption)]).
nounMapping2SUMO('07933799-n',[ ('Tea',subsumption)]).
nounMapping2SUMO('07933891-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07934032-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07934152-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('07934282-n',[ ('Tea',subsumption)]).
nounMapping2SUMO('07934373-n',[ ('Tea',subsumption)]).
nounMapping2SUMO('07934530-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07934678-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07934800-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07934908-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07935043-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07935152-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07935288-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07935379-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('07935504-n',[ ('Water',equivalence)]).
nounMapping2SUMO('07935737-n',[ ('Water',subsumption)]).
nounMapping2SUMO('07935878-n',[ ('Water',subsumption)]).
nounMapping2SUMO('07936015-n',[ ('Water',subsumption)]).
nounMapping2SUMO('07936093-n',[ ('Water',subsumption)]).
nounMapping2SUMO('07936177-n',[ ('Water',subsumption)]).
nounMapping2SUMO('07936263-n',[ ('Water',subsumption)]).
nounMapping2SUMO('07936459-n',[ ('Water',subsumption)]).
nounMapping2SUMO('07936548-n',[ ('Water',subsumption)]).
nounMapping2SUMO('07936745-n',[ ('Water',subsumption)]).
nounMapping2SUMO('07936979-n',[ ('Water',subsumption)]).
nounMapping2SUMO('07937069-n',[ ('Water',subsumption)]).
nounMapping2SUMO('07937203-n',[ ('Water',subsumption)]).
nounMapping2SUMO('07937344-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07937461-n',[ ('PreparedFood',subsumption)]).
nounMapping2SUMO('07937621-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07937786-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07938007-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('07938149-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('07938313-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07938427-n',[ ('Food',subsumption)]).
nounMapping2SUMO('07938594-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('07938773-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07939159-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07939382-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07939638-n',[ ('Class',equivalence)]).
nounMapping2SUMO('07939880-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('07940121-n',[ ('Class',subsumption)]).
nounMapping2SUMO('07940242-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('07940448-n',[ ('Class',subsumption)]).
nounMapping2SUMO('07940552-n',[ ('Organism',equivalence)]).
nounMapping2SUMO('07940865-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('07941045-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('07941170-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('07941405-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('07941574-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('07941729-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07941945-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07942152-n',[ ('GroupOfPeople',equivalence)]).
nounMapping2SUMO('07943300-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('07943480-n',[ ('AgeGroup',equivalence)]).
nounMapping2SUMO('07943646-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('07943870-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07944050-n',[ ('HumanYouth',equivalence)]).
nounMapping2SUMO('07944242-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07944408-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07944618-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07944754-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07944900-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07945077-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('07945236-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07945369-n',[ ('CitizenryFn',subsumption)]).
nounMapping2SUMO('07945490-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07945657-n',[ ('HumanCorpse',subsumption)]).
nounMapping2SUMO('07945818-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07945949-n',[ ('Deaf',equivalence)]).
nounMapping2SUMO('07946135-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07946288-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07946516-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07946694-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07946851-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('07946969-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('07947069-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07947255-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07947675-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07947789-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07947958-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07948098-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07948183-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07948314-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07948518-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07948754-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07948971-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07949160-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('07949463-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('07949796-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('07950090-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('07950295-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07950418-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07950592-n',[ ('Dead',subsumption)]).
nounMapping2SUMO('07950685-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('07950786-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07950920-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07951464-n',[ ('Collection',equivalence)]).
nounMapping2SUMO('07953367-n',[ ('Device',subsumption)]).
nounMapping2SUMO('07953499-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07953603-n',[ ('Process',subsumption)]).
nounMapping2SUMO('07953827-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07954014-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07954211-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07954441-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07954576-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07954731-n',[ ('Collection',equivalence)]).
nounMapping2SUMO('07954863-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07954946-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07955057-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07955280-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07955455-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07955566-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07955726-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07955841-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07955961-n',[ ('Device',subsumption)]).
nounMapping2SUMO('07956112-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07956250-n',[ ('Object',subsumption)]).
nounMapping2SUMO('07956426-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07956552-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07956721-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07956887-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07957193-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07957327-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07957456-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07957546-n',[ ('GameAttribute',subsumption)]).
nounMapping2SUMO('07957655-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07957855-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07957986-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07958099-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07958196-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07958294-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07958407-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07958501-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07958642-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07958727-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('07958820-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('07959016-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07959269-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07959393-n',[ ('EditionFn',equivalence)]).
nounMapping2SUMO('07959659-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07959863-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07959943-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07960384-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07960569-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07960666-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07960769-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07960928-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07961016-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('07961270-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('07961379-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('07961480-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07961956-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07962124-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07962295-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07962405-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07962500-n',[ ('Object',subsumption)]).
nounMapping2SUMO('07962628-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07962707-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07962991-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07963087-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07963208-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07963330-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07963494-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07963613-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07963711-n',[ ('Combining',equivalence)]).
nounMapping2SUMO('07963987-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('07964144-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('07964324-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('07964495-n',[ ('Agreement',subsumption)]).
nounMapping2SUMO('07964809-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('07965085-n',[ ('GroupOfPeople',equivalence)]).
nounMapping2SUMO('07965817-n',[ ('Public',equivalence)]).
nounMapping2SUMO('07965937-n',[ ('Human',subsumption)]).
nounMapping2SUMO('07966140-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('07966421-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('07966570-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('07966719-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('07966927-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('07967129-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('07967382-n',[ ('EthnicGroup',equivalence)]).
nounMapping2SUMO('07967736-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('07967982-n',[ ('RacialEthnicGroup',subsumption)]).
nounMapping2SUMO('07968354-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('07968550-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('07968702-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('07968974-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07969192-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('07969366-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07969695-n',[ ('FamilyGroup',equivalence)]).
nounMapping2SUMO('07970079-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('07970301-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07970406-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('07970721-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('07971023-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('07971141-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('07971298-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07971449-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('07971582-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('07972279-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('07972425-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('07972674-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('07972888-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('07973088-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('07973241-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07973373-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('07973487-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('07973653-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('07973782-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('07973868-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('07974025-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07974766-n',[ ('AgeGroup',equivalence)]).
nounMapping2SUMO('07974850-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07975026-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('07975909-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07976069-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07976181-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07976420-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('07976596-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07976725-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07976851-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('07976936-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('07977108-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07977237-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07977344-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07977592-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07977870-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07978055-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07978170-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('07978276-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07978423-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07978924-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07979425-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07983170-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07983856-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('07984805-n',[ ('Collection',instance)]).
nounMapping2SUMO('07985135-n',[ ('Set',subsumption)]).
nounMapping2SUMO('07985223-n',[ ('CardinalityFn',equivalence)]).
nounMapping2SUMO('07985384-n',[ ('AnimalTeam',subsumption)]).
nounMapping2SUMO('07985533-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('07985628-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('07985825-n',[ ('Text',subsumption)]).
nounMapping2SUMO('07985948-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07986066-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07986198-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07986381-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('07986617-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07986771-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07986982-n',[ ('Government',subsumption)]).
nounMapping2SUMO('07987135-n',[ ('Government',subsumption)]).
nounMapping2SUMO('07987216-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07987380-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07987580-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07987689-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07987794-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07987903-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07988010-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07988089-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07988229-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07988369-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07988490-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07988604-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07988716-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07988857-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07989083-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07989220-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07989373-n',[ ('MarriageContract',equivalence)]).
nounMapping2SUMO('07989620-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('07989741-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('07989973-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('07990158-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07990377-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07990648-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('07990824-n',[ ('Brood',equivalence)]).
nounMapping2SUMO('07990956-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07991169-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07991272-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07991364-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('07991579-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07991780-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07991868-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07991994-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07992116-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07992222-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07992308-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('07992450-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('07993109-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('07993279-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('07993526-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07993643-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('07993776-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('07993929-n',[ ('GroupOfAnimals',equivalence)]).
nounMapping2SUMO('07994331-n',[ ('GroupOfAnimals',subsumption)]).
nounMapping2SUMO('07994555-n',[ ('GroupOfAnimals',subsumption)]).
nounMapping2SUMO('07994752-n',[ ('GroupOfAnimals',subsumption)]).
nounMapping2SUMO('07994818-n',[ ('GroupOfAnimals',subsumption)]).
nounMapping2SUMO('07994941-n',[ ('GroupOfAnimals',subsumption)]).
nounMapping2SUMO('07995074-n',[ ('GroupOfAnimals',subsumption)]).
nounMapping2SUMO('07995164-n',[ ('GroupOfAnimals',subsumption)]).
nounMapping2SUMO('07995278-n',[ ('GroupOfAnimals',subsumption)]).
nounMapping2SUMO('07995365-n',[ ('GroupOfAnimals',subsumption)]).
nounMapping2SUMO('07995453-n',[ ('GroupOfAnimals',subsumption)]).
nounMapping2SUMO('07995617-n',[ ('GroupOfAnimals',subsumption)]).
nounMapping2SUMO('07995856-n',[ ('GroupOfAnimals',subsumption)]).
nounMapping2SUMO('07996010-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('07996149-n',[ ('GroupOfAnimals',subsumption)]).
nounMapping2SUMO('07996412-n',[ ('GroupOfAnimals',subsumption)]).
nounMapping2SUMO('07996598-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('07996689-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07997338-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07997486-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07997581-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('07997703-n',[ ('Class',equivalence)]).
nounMapping2SUMO('07998206-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('07998323-n',[ ('Violin',subsumption)]).
nounMapping2SUMO('07998450-n',[ ('WindInstrument',subsumption)]).
nounMapping2SUMO('07998573-n',[ ('Class',equivalence)]).
nounMapping2SUMO('07998712-n',[ ('UnionFn',equivalence)]).
nounMapping2SUMO('07998904-n',[ ('UnionFn',subsumption)]).
nounMapping2SUMO('07999068-n',[ ('IntersectionFn',equivalence)]).
nounMapping2SUMO('07999291-n',[ ('SexAttribute',equivalence)]).
nounMapping2SUMO('07999471-n',[ ('Group',subsumption)]).
nounMapping2SUMO('07999584-n',[ ('GroupOfAnimals',subsumption)]).
nounMapping2SUMO('07999699-n',[ ('Set',equivalence)]).
nounMapping2SUMO('08000118-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('08000304-n',[ ('TraitAttribute',equivalence)]).
nounMapping2SUMO('08000644-n',[ ('Set',subsumption)]).
nounMapping2SUMO('08000881-n',[ ('Set',subsumption)]).
nounMapping2SUMO('08001083-n',[ ('SetOrClass',subsumption)]).
nounMapping2SUMO('08001209-n',[ ('Set',equivalence)]).
nounMapping2SUMO('08001344-n',[ ('NullSet',equivalence)]).
nounMapping2SUMO('08001441-n',[ ('Set',subsumption)]).
nounMapping2SUMO('08001685-n',[ ('Set',subsumption)]).
nounMapping2SUMO('08002015-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08002125-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08002269-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08002384-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08002578-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08002717-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08003035-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08003173-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08003306-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08003427-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08003525-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08003619-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08003717-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08003839-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08003935-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08004089-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08004210-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08004342-n',[ ('Set',subsumption)]).
nounMapping2SUMO('08004443-n',[ ('NullSet',subsumption)]).
nounMapping2SUMO('08004548-n',[ ('Set',subsumption)]).
nounMapping2SUMO('08004695-n',[ ('Set',subsumption)]).
nounMapping2SUMO('08004953-n',[ ('Set',subsumption)]).
nounMapping2SUMO('08005123-n',[ ('Set',subsumption)]).
nounMapping2SUMO('08005260-n',[ ('Set',subsumption)]).
nounMapping2SUMO('08005580-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08005761-n',[ ('FormText',subsumption)]).
nounMapping2SUMO('08005877-n',[ ('Set',subsumption)]).
nounMapping2SUMO('08005954-n',[ ('Set',subsumption)]).
nounMapping2SUMO('08006094-n',[ ('IntervalFn',equivalence)]).
nounMapping2SUMO('08006250-n',[ ('IntervalFn',subsumption)]).
nounMapping2SUMO('08006405-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('08006511-n',[ ('Word',subsumption)]).
nounMapping2SUMO('08006741-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('08006868-n',[ ('Verb',subsumption)]).
nounMapping2SUMO('08006989-n',[ ('Class',subsumption)]).
nounMapping2SUMO('08007204-n',[ ('Class',subsumption)]).
nounMapping2SUMO('08007430-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08007534-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08007667-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08007777-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08007897-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08008017-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08008254-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08008335-n',[ ('Organization',equivalence)]).
nounMapping2SUMO('08009239-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08009478-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08009659-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08009834-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08010191-n',[ ('Organization',instance)]).
nounMapping2SUMO('08010364-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08010559-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08010942-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08011266-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08011523-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08012028-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08012384-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08012765-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08013176-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08013453-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08013653-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08013845-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08014202-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08014615-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08014860-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08015116-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08015321-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08015731-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08016035-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08016385-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08016900-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08017257-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08017614-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08017974-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08018189-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08018666-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08018983-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08019281-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08019523-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08019913-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08020242-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08020785-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08021129-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08021464-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08021785-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08022087-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08022259-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08022666-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08022972-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08023374-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08023843-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08024096-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08024408-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08024732-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08025112-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08025497-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08025835-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08026197-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08026539-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08026904-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08027314-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08027518-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08027920-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08028148-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08028397-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08028623-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08028999-n',[ ('MilitaryOrganization',subsumption)]).
nounMapping2SUMO('08029421-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08029784-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08029908-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08030185-n',[ ('ParamilitaryOrganization',instance)]).
nounMapping2SUMO('08030379-n',[ ('ParamilitaryOrganization',instance)]).
nounMapping2SUMO('08030481-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08030711-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08031020-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08031386-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08031663-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08032023-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08032594-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08032955-n',[ ('MilitaryOrganization',instance)]).
nounMapping2SUMO('08033194-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08033454-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08033829-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08034028-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08034299-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08034579-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08034778-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08035233-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08035601-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08036005-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08036293-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08036669-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08036849-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08037118-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08037503-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08037861-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08038131-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08038379-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08038748-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08038995-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08039312-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08039601-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08040008-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08040257-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08040522-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08040762-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08041106-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08041484-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08041840-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08042183-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08042536-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08042856-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08043169-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08043499-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08043848-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08044265-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08044676-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08045140-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08045428-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08045681-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08046032-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08046346-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08046759-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08047032-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08047501-n',[ ('TerroristOrganization',instance)]).
nounMapping2SUMO('08047747-n',[ ('Organization',instance)]).
nounMapping2SUMO('08047890-n',[ ('Organization',instance)]).
nounMapping2SUMO('08048042-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08048300-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08048625-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08048743-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08048948-n',[ ('Process',subsumption)]).
nounMapping2SUMO('08049125-n',[ ('Organization',instance)]).
nounMapping2SUMO('08049401-n',[ ('Organization',equivalence)]).
nounMapping2SUMO('08049989-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08050385-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08050484-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08050678-n',[ ('Government',equivalence)]).
nounMapping2SUMO('08051384-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08051565-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08051739-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08051946-n',[ ('NationalGovernment',equivalence)]).
nounMapping2SUMO('08052135-n',[ ('NationalGovernment',subsumption)]).
nounMapping2SUMO('08052227-n',[ ('NationalGovernment',subsumption)]).
nounMapping2SUMO('08052330-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08052413-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08052549-n',[ ('NationalGovernment',equivalence)]).
nounMapping2SUMO('08052690-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08052874-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08053003-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08053121-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08053260-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08053407-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08053576-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08053905-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08054076-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08054226-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08054417-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08054613-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08054721-n',[ ('FinancialOrganization',equivalence)]).
nounMapping2SUMO('08055150-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08055321-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('08055516-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08055718-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08055824-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08055964-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08056128-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08056231-n',[ ('Corporation',equivalence)]).
nounMapping2SUMO('08056471-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08056601-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08056747-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08056873-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08057068-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08057206-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08057460-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08057633-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08057816-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08058098-n',[ ('Corporation',equivalence)]).
nounMapping2SUMO('08058937-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08059125-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08059250-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08059412-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08059870-n',[ ('Corporation',equivalence)]).
nounMapping2SUMO('08060193-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08060446-n',[ ('Manufacturer',subsumption)]).
nounMapping2SUMO('08060694-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08060878-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08061042-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08061609-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08061695-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08061801-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08061905-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08062092-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08062206-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08062326-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08062464-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08062623-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08062842-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08062970-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08063129-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08063303-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08063446-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08063650-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08063738-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08063836-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08063947-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08064039-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08064130-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08064372-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08064523-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08064742-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08064888-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08065093-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08065234-n',[ ('Industry',equivalence)]).
nounMapping2SUMO('08065937-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08066095-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08066186-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08066317-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08066491-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08066644-n',[ ('Manufacturer',subsumption)]).
nounMapping2SUMO('08066763-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08066965-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08067077-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08067218-n',[ ('FlyingAircraft',subsumption)]).
nounMapping2SUMO('08067342-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08067460-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08067565-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08067683-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08067801-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08067951-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08068151-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08068375-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08068457-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08068597-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08068691-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08068788-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08068924-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08069050-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08069241-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08069342-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08069487-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08069627-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08069768-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08069878-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08070130-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08070236-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08070341-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08070465-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08070674-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08070850-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08071229-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08071516-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08071756-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08071908-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08072104-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08072287-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08072536-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08072837-n',[ ('FillingAnOrder',subsumption)]).
nounMapping2SUMO('08073130-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('08073243-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('08073355-n',[ ('FillingAnOrder',subsumption)]).
nounMapping2SUMO('08073468-n',[ ('FillingAnOrder',subsumption)]).
nounMapping2SUMO('08073601-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('08073700-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08073844-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08073992-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08074109-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08074225-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08074330-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08074421-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08074582-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08074691-n',[ ('Industry',subsumption)]).
nounMapping2SUMO('08074879-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08075009-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08075140-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08075287-n',[ ('Human',subsumption)]).
nounMapping2SUMO('08075388-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08075647-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08075847-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08075929-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08076075-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08076253-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08076455-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08076578-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08076705-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08076833-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08076946-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08077035-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08077177-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08077292-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08077711-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08077842-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08078020-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('08078453-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('08078644-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08078819-n',[ ('SportsTeam',subsumption)]).
nounMapping2SUMO('08078976-n',[ ('SportsTeam',subsumption)]).
nounMapping2SUMO('08079151-n',[ ('BaseballTeam',subsumption)]).
nounMapping2SUMO('08079319-n',[ ('BaseballTeam',equivalence)]).
nounMapping2SUMO('08079613-n',[ ('BaseballTeam',equivalence)]).
nounMapping2SUMO('08079852-n',[ ('SportsTeam',subsumption)]).
nounMapping2SUMO('08080025-n',[ ('FootballTeam',equivalence)]).
nounMapping2SUMO('08080386-n',[ ('SportsTeam',subsumption)]).
nounMapping2SUMO('08080510-n',[ ('SportsTeam',subsumption)]).
nounMapping2SUMO('08080652-n',[ ('SportsTeam',subsumption)]).
nounMapping2SUMO('08080762-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08080947-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08081142-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08081244-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08081403-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08081668-n',[ ('ReligiousOrganization',equivalence)]).
nounMapping2SUMO('08082236-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08082602-n',[ ('Christianity',equivalence)]).
nounMapping2SUMO('08082899-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08083083-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('08083320-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08083599-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08085159-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08085359-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('08085535-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08085648-n',[ ('OrganizationalBoard',subsumption)]).
nounMapping2SUMO('08085824-n',[ ('Organization',instance)]).
nounMapping2SUMO('08086050-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08086219-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08086356-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08086646-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08086821-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08086987-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08087203-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08087319-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08087570-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08087776-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08087981-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08088472-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08088675-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08088792-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08088963-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08089205-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08089420-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08089627-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08089797-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08089955-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08090083-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08090329-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08090547-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08090803-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08090973-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08091152-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08091290-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08091412-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08091575-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08091744-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08091891-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08092040-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08092190-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08092340-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08092539-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08092713-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08092855-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08092960-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08093111-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08093269-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08093421-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('08093653-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08093813-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08094013-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08094262-n',[ ('OrganizationalBoard',subsumption)]).
nounMapping2SUMO('08094386-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08094659-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08094866-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08095160-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08095426-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08095647-n',[ ('Islam',subsumption)]).
nounMapping2SUMO('08096027-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08096301-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08096474-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08096624-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08096950-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08097072-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08097222-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08097391-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08097531-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08097766-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08098192-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08098346-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08098499-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08098708-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08099029-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08099264-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08099475-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08099647-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08099825-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08100033-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08100320-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08100481-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08100656-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08100778-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08100907-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08101085-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08101410-n',[ ('DomesticAnimal',subsumption)]).
nounMapping2SUMO('08101755-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('08101846-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('08101937-n',[ ('DescendantsFn',equivalence)]).
nounMapping2SUMO('08102282-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('08102402-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('08102555-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08103299-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08103457-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08103635-n',[ ('Language',subsumption)]).
nounMapping2SUMO('08103777-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08106661-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08106798-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08106934-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08107191-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08107343-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08107499-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08108304-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08108450-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08108627-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08108784-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08108972-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08109624-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08109772-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08109940-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08110197-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08110373-n',[ ('Organism',equivalence)]).
nounMapping2SUMO('08110648-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08110866-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08111027-n',[ ('Fish',equivalence)]).
nounMapping2SUMO('08111157-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08111419-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08111599-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08111783-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08112096-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('08112402-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08112630-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08112829-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08112976-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08113073-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08113197-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08113322-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08113443-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08113634-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08113710-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08113797-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08113910-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08114004-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08114152-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08114287-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08114400-n',[ ('Organization',instance)]).
nounMapping2SUMO('08114581-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08114861-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08115204-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08115602-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08115778-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08115912-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08116073-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08116240-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08116398-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08116565-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08116734-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08116879-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08117052-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08117225-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08117379-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08117540-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08117702-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08117872-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08118039-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08118260-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08118414-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08118592-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08118725-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08118849-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08118991-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08119226-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08119397-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08119525-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08119698-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08119821-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08120079-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08120235-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08120384-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08120624-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08120910-n',[ ('SecurityUnit',equivalence)]).
nounMapping2SUMO('08121117-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08121301-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08121394-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08121542-n',[ ('PoliceOrganization',subsumption)]).
nounMapping2SUMO('08121694-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08121867-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08122009-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08122141-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08122358-n',[ ('Organization',instance)]).
nounMapping2SUMO('08122596-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08122768-n',[ ('Organization',instance)]).
nounMapping2SUMO('08122960-n',[ ('Organization',instance)]).
nounMapping2SUMO('08123167-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08123696-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08123970-n',[ ('GovernmentOrganization',subsumption)]).
nounMapping2SUMO('08124256-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08124496-n',[ ('Organization',instance)]).
nounMapping2SUMO('08124649-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08124971-n',[ ('Organization',instance)]).
nounMapping2SUMO('08125420-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08125722-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08125993-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08126290-n',[ ('Organization',instance)]).
nounMapping2SUMO('08126483-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08126716-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08126921-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08127166-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08127304-n',[ ('GovernmentOrganization',subsumption)]).
nounMapping2SUMO('08127557-n',[ ('GovernmentOrganization',subsumption)]).
nounMapping2SUMO('08127760-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08128004-n',[ ('Organization',instance)]).
nounMapping2SUMO('08128159-n',[ ('JointChiefsOfStaff',equivalence)]).
nounMapping2SUMO('08128492-n',[ ('Organization',instance)]).
nounMapping2SUMO('08128645-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08128837-n',[ ('Organization',instance)]).
nounMapping2SUMO('08128964-n',[ ('Organization',instance)]).
nounMapping2SUMO('08129268-n',[ ('Organization',instance)]).
nounMapping2SUMO('08129621-n',[ ('Organization',instance)]).
nounMapping2SUMO('08129883-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08130292-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08130476-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08130712-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08131005-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08131254-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08131530-n',[ ('Organization',instance)]).
nounMapping2SUMO('08132046-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08132323-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08132637-n',[ ('Organization',instance)]).
nounMapping2SUMO('08132955-n',[ ('Organization',instance)]).
nounMapping2SUMO('08133189-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08133536-n',[ ('Organization',instance)]).
nounMapping2SUMO('08133855-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08134081-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08134415-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08134649-n',[ ('Organization',instance)]).
nounMapping2SUMO('08134807-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08135062-n',[ ('Organization',instance)]).
nounMapping2SUMO('08135342-n',[ ('Organization',instance)]).
nounMapping2SUMO('08135770-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08136027-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08136260-n',[ ('Organization',instance)]).
nounMapping2SUMO('08136502-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08136767-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08137028-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08137251-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08137495-n',[ ('Organization',instance)]).
nounMapping2SUMO('08137738-n',[ ('Organization',instance)]).
nounMapping2SUMO('08138079-n',[ ('City',instance)]).
nounMapping2SUMO('08138259-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08138466-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08138686-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08139000-n',[ ('Organization',instance)]).
nounMapping2SUMO('08139270-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08139637-n',[ ('Organization',instance)]).
nounMapping2SUMO('08139795-n',[ ('Organization',instance)]).
nounMapping2SUMO('08140219-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08140506-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08140767-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08141092-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08141374-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08141664-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08141951-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08142170-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08142370-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08142801-n',[ ('Organization',instance)]).
nounMapping2SUMO('08142972-n',[ ('Organization',instance)]).
nounMapping2SUMO('08143163-n',[ ('Organization',instance)]).
nounMapping2SUMO('08143321-n',[ ('Organization',instance)]).
nounMapping2SUMO('08143486-n',[ ('GovernmentOrganization',subsumption)]).
nounMapping2SUMO('08143653-n',[ ('Organization',instance)]).
nounMapping2SUMO('08143926-n',[ ('FederalAviationAdministration',equivalence)]).
nounMapping2SUMO('08144122-n',[ ('Organization',instance)]).
nounMapping2SUMO('08144308-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08144524-n',[ ('Organization',instance)]).
nounMapping2SUMO('08144720-n',[ ('Organization',instance)]).
nounMapping2SUMO('08144907-n',[ ('Organization',instance)]).
nounMapping2SUMO('08145092-n',[ ('Organization',instance)]).
nounMapping2SUMO('08145277-n',[ ('Organization',instance)]).
nounMapping2SUMO('08145553-n',[ ('UnitedStatesPostalService',instance)]).
nounMapping2SUMO('08145701-n',[ ('Organization',instance)]).
nounMapping2SUMO('08145871-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08146135-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08146410-n',[ ('Hospital',subsumption)]).
nounMapping2SUMO('08146593-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08146782-n',[ ('Christianity',equivalence)]).
nounMapping2SUMO('08147019-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('08147188-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08147670-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08147794-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08148067-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08148294-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08148388-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08148512-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08148601-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08148827-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08149004-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08149160-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08149314-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08149473-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08149781-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08150377-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08150576-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08150770-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08150892-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08151096-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08151229-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08151490-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08151753-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08152069-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('08152198-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('08152353-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('08152507-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08152657-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08152787-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08153022-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08153102-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08153337-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('08153437-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('08153874-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08154012-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08154213-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08154363-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08154548-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08154703-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08154960-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08155302-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08155518-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08155765-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08156054-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08156200-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08156392-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08156505-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08156685-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08156948-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08157182-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08157405-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08157672-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08157809-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08158089-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08158314-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08158460-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08158741-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08158920-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08159031-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08159331-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08159464-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08159591-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08159740-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08159924-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08160146-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('08160276-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08160586-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08160697-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08160808-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08160947-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08161068-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08161258-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08161477-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08161591-n',[ ('Government',instance)]).
nounMapping2SUMO('08161757-n',[ ('UnitedStatesCongress',equivalence)]).
nounMapping2SUMO('08161971-n',[ ('Government',instance)]).
nounMapping2SUMO('08162245-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08162575-n',[ ('LegislativeOrganization',subsumption)]).
nounMapping2SUMO('08162691-n',[ ('Government',instance)]).
nounMapping2SUMO('08162860-n',[ ('Government',instance)]).
nounMapping2SUMO('08163025-n',[ ('LegislativeOrganization',equivalence)]).
nounMapping2SUMO('08163273-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08163702-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08163792-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08164110-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08164261-n',[ ('Government',instance)]).
nounMapping2SUMO('08164464-n',[ ('Government',instance)]).
nounMapping2SUMO('08164585-n',[ ('OrganizationalBoard',equivalence)]).
nounMapping2SUMO('08165353-n',[ ('OrganizationalBoard',subsumption)]).
nounMapping2SUMO('08165455-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08165650-n',[ ('Government',instance)]).
nounMapping2SUMO('08165760-n',[ ('Government',instance)]).
nounMapping2SUMO('08165866-n',[ ('Government',instance)]).
nounMapping2SUMO('08165979-n',[ ('Government',instance)]).
nounMapping2SUMO('08166083-n',[ ('Government',instance)]).
nounMapping2SUMO('08166187-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08166318-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08166552-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08166931-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08167046-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08167249-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08167365-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08167779-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08167953-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08168117-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08168241-n',[ ('NewsReporter',equivalence)]).
nounMapping2SUMO('08168367-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08168531-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08168737-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08168831-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08168978-n',[ ('Nation',equivalence)]).
nounMapping2SUMO('08169573-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08169677-n',[ ('Nation',instance)]).
nounMapping2SUMO('08169919-n',[ ('Nation',instance)]).
nounMapping2SUMO('08170070-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08170255-n',[ ('Nation',instance)]).
nounMapping2SUMO('08170374-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08170535-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08170686-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08170978-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08171094-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08171210-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08171415-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08171592-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08171792-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08171992-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08172103-n',[ ('Organization',instance)]).
nounMapping2SUMO('08172695-n',[ ('Group',instance)]).
nounMapping2SUMO('08172877-n',[ ('Group',instance)]).
nounMapping2SUMO('08173030-n',[ ('Group',instance)]).
nounMapping2SUMO('08173165-n',[ ('Group',instance)]).
nounMapping2SUMO('08173289-n',[ ('Group',instance)]).
nounMapping2SUMO('08173515-n',[ ('EuropeanUnion',equivalence)]).
nounMapping2SUMO('08174167-n',[ ('MilitaryOrganization',instance)]).
nounMapping2SUMO('08174398-n',[ ('MilitaryOrganization',instance)]).
nounMapping2SUMO('08174995-n',[ ('MilitaryOrganization',instance)]).
nounMapping2SUMO('08175233-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('08175498-n',[ ('MilitaryOrganization',instance)]).
nounMapping2SUMO('08175700-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('08175875-n',[ ('Organization',instance)]).
nounMapping2SUMO('08176077-n',[ ('Organization',instance)]).
nounMapping2SUMO('08176901-n',[ ('Organization',instance)]).
nounMapping2SUMO('08177030-n',[ ('Organization',instance)]).
nounMapping2SUMO('08177487-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08177592-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08177781-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08177863-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08177958-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08178085-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08178321-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08178547-n',[ ('NationalGovernment',equivalence)]).
nounMapping2SUMO('08178741-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08178935-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08179033-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('08179205-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08179455-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08179689-n',[ ('Human',equivalence)]).
nounMapping2SUMO('08179879-n',[ ('ResidentFn',equivalence)]).
nounMapping2SUMO('08180067-n',[ ('ResidentFn',subsumption)]).
nounMapping2SUMO('08180190-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('08180484-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08180639-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('08180944-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08181075-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('08181267-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('08181375-n',[ ('Group',instance)]).
nounMapping2SUMO('08181540-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08181658-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08181820-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08181930-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08182105-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08182283-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08182379-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('08182716-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08182892-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08182962-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08183046-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08183290-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08183398-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08183541-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08183698-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08183802-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08183920-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08184052-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08184217-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08184335-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08184439-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08184600-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08184730-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08184861-n',[ ('SocialParty',equivalence)]).
nounMapping2SUMO('08185063-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08185211-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08185369-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08185501-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08185643-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08185758-n',[ ('GovernmentOrganization',subsumption)]).
nounMapping2SUMO('08186047-n',[ ('ServiceOrganization',equivalence)]).
nounMapping2SUMO('08186221-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08186393-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08186546-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08186655-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08186761-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08186898-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08187033-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08187370-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08187460-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08187569-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08187707-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08187837-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08187988-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08188235-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08188449-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08188638-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08188814-n',[ ('MusicalInstrument',subsumption)]).
nounMapping2SUMO('08188967-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08189089-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08189211-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08189371-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08189581-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08189659-n',[ ('Organization',equivalence)]).
nounMapping2SUMO('08190292-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08190482-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08190609-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08190754-n',[ ('MilitaryOrganization',subsumption)]).
nounMapping2SUMO('08191230-n',[ ('Army',subsumption)]).
nounMapping2SUMO('08191532-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08191701-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08191987-n',[ ('NavyBranchOfService',instance)]).
nounMapping2SUMO('08192361-n',[ ('Organization',instance)]).
nounMapping2SUMO('08192557-n',[ ('CoastGuard',subsumption)]).
nounMapping2SUMO('08192817-n',[ ('MarinesBranchOfService',instance)]).
nounMapping2SUMO('08192970-n',[ ('MarinesBranchOfService',instance)]).
nounMapping2SUMO('08193212-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08193448-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08193645-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08193854-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08194074-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08194266-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08194546-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08194815-n',[ ('Organization',instance)]).
nounMapping2SUMO('08194927-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08195132-n',[ ('Organization',instance)]).
nounMapping2SUMO('08195229-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08195323-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08195636-n',[ ('Organization',instance)]).
nounMapping2SUMO('08195797-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08196024-n',[ ('AirForce',equivalence)]).
nounMapping2SUMO('08196230-n',[ ('AirForceBranchOfService',instance)]).
nounMapping2SUMO('08196622-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08196892-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08197149-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08197386-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08197742-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08197895-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08198137-n',[ ('MilitaryService',equivalence)]).
nounMapping2SUMO('08198398-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08199025-n',[ ('MilitaryService',subsumption)]).
nounMapping2SUMO('08206460-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08206663-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08207001-n',[ ('MilitaryOrganization',instance)]).
nounMapping2SUMO('08207095-n',[ ('Organization',instance)]).
nounMapping2SUMO('08207209-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08207540-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08207672-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08207863-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08208016-n',[ ('GroupOfPeople',equivalence)]).
nounMapping2SUMO('08208444-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08208560-n',[ ('Organization',equivalence)]).
nounMapping2SUMO('08209076-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08209187-n',[ ('MilitaryForce',subsumption)]).
nounMapping2SUMO('08209386-n',[ ('TerroristOrganization',subsumption)]).
nounMapping2SUMO('08209519-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08209687-n',[ ('PoliceOrganization',subsumption)]).
nounMapping2SUMO('08210042-n',[ ('PoliceOrganization',subsumption)]).
nounMapping2SUMO('08210254-n',[ ('Organization',instance)]).
nounMapping2SUMO('08210411-n',[ ('PoliceOrganization',subsumption)]).
nounMapping2SUMO('08210670-n',[ ('Organization',instance)]).
nounMapping2SUMO('08210835-n',[ ('Organization',instance)]).
nounMapping2SUMO('08210982-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08211169-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08211290-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08211475-n',[ ('Organization',instance)]).
nounMapping2SUMO('08211584-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08211760-n',[ ('Organization',instance)]).
nounMapping2SUMO('08211924-n',[ ('PoliceOrganization',subsumption)]).
nounMapping2SUMO('08212146-n',[ ('MilitaryOrganization',subsumption)]).
nounMapping2SUMO('08212347-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08212527-n',[ ('MilitaryCorps',subsumption)]).
nounMapping2SUMO('08212740-n',[ ('MilitaryCorps',subsumption)]).
nounMapping2SUMO('08212920-n',[ ('Organization',instance)]).
nounMapping2SUMO('08213079-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08213205-n',[ ('MilitaryOrganization',subsumption)]).
nounMapping2SUMO('08213424-n',[ ('MilitaryOrganization',instance)]).
nounMapping2SUMO('08213671-n',[ ('MilitaryOrganization',subsumption)]).
nounMapping2SUMO('08213817-n',[ ('MilitaryOrganization',subsumption)]).
nounMapping2SUMO('08213978-n',[ ('Brigade',equivalence)]).
nounMapping2SUMO('08214083-n',[ ('Battalion',equivalence)]).
nounMapping2SUMO('08214272-n',[ ('CompanyMilitary',equivalence)]).
nounMapping2SUMO('08214470-n',[ ('Platoon',equivalence)]).
nounMapping2SUMO('08214698-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08214832-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08214966-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08215044-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08215248-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08215495-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08215603-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08215801-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08215989-n',[ ('Organization',instance)]).
nounMapping2SUMO('08216176-n',[ ('SecurityUnit',equivalence)]).
nounMapping2SUMO('08216295-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08216408-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08216535-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08216647-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08216795-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08216900-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08217135-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08217302-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08217450-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08217557-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08217738-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08217865-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08218004-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08218122-n',[ ('MilitarySquad',subsumption)]).
nounMapping2SUMO('08218212-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08218393-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08218592-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08218713-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08218832-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08218965-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('08219059-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08219226-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08219330-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08219493-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08219628-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08219768-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08219923-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08220089-n',[ ('CavalryUnit',subsumption)]).
nounMapping2SUMO('08220228-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08220367-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08220440-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08220534-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08220620-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08220714-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08220891-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('08221348-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08221747-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('08221897-n',[ ('Perception',subsumption)]).
nounMapping2SUMO('08222203-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08222293-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08222571-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08222750-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08222871-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08222966-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08223137-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08223263-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08223475-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08223581-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08223688-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('08223802-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('08224274-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08224413-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08224580-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08224684-n',[ ('Islam',subsumption)]).
nounMapping2SUMO('08224985-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08225090-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08225334-n',[ ('Device',subsumption)]).
nounMapping2SUMO('08225426-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08225581-n',[ ('City',subsumption)]).
nounMapping2SUMO('08225736-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08225853-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08226018-n',[ ('StateGovernment',subsumption)]).
nounMapping2SUMO('08226127-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08226335-n',[ ('City',subsumption)]).
nounMapping2SUMO('08226514-n',[ ('City',subsumption)]).
nounMapping2SUMO('08226699-n',[ ('City',subsumption)]).
nounMapping2SUMO('08226838-n',[ ('City',subsumption)]).
nounMapping2SUMO('08226978-n',[ ('City',subsumption)]).
nounMapping2SUMO('08227088-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08227214-n',[ ('Club',equivalence)]).
nounMapping2SUMO('08227916-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08228229-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08228405-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08228538-n',[ ('Club',subsumption)]).
nounMapping2SUMO('08228665-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08228838-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08228980-n',[ ('Organization',instance)]).
nounMapping2SUMO('08229134-n',[ ('Organization',instance)]).
nounMapping2SUMO('08229275-n',[ ('Club',subsumption)]).
nounMapping2SUMO('08229362-n',[ ('Club',subsumption)]).
nounMapping2SUMO('08229467-n',[ ('Club',subsumption)]).
nounMapping2SUMO('08229605-n',[ ('Club',subsumption)]).
nounMapping2SUMO('08229694-n',[ ('Club',subsumption)]).
nounMapping2SUMO('08229779-n',[ ('Club',subsumption)]).
nounMapping2SUMO('08229887-n',[ ('Club',subsumption)]).
nounMapping2SUMO('08230009-n',[ ('Club',subsumption)]).
nounMapping2SUMO('08230110-n',[ ('Club',subsumption)]).
nounMapping2SUMO('08230219-n',[ ('Club',subsumption)]).
nounMapping2SUMO('08230294-n',[ ('Club',subsumption)]).
nounMapping2SUMO('08230477-n',[ ('Club',subsumption)]).
nounMapping2SUMO('08230590-n',[ ('Club',subsumption)]).
nounMapping2SUMO('08230679-n',[ ('Club',subsumption)]).
nounMapping2SUMO('08230785-n',[ ('Club',subsumption)]).
nounMapping2SUMO('08230906-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08231065-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08231184-n',[ ('SportsLeague',subsumption)]).
nounMapping2SUMO('08231499-n',[ ('SportsLeague',subsumption)]).
nounMapping2SUMO('08231678-n',[ ('SportsLeague',subsumption)]).
nounMapping2SUMO('08231874-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08231999-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08232160-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08232299-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08232410-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08232496-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08232603-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08232706-n',[ ('SportsLeague',subsumption)]).
nounMapping2SUMO('08233056-n',[ ('UnionOrganization',equivalence)]).
nounMapping2SUMO('08233426-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08233627-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08233762-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08233913-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08234103-n',[ ('Organization',instance)]).
nounMapping2SUMO('08234298-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08234493-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08234628-n',[ ('BankFinancialOrganization',subsumption)]).
nounMapping2SUMO('08234792-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08234935-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08235076-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08235173-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08235343-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08235513-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08235623-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08235828-n',[ ('Club',subsumption)]).
nounMapping2SUMO('08236027-n',[ ('Club',instance)]).
nounMapping2SUMO('08236251-n',[ ('Club',instance)]).
nounMapping2SUMO('08236438-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08236621-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08236963-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08237202-n',[ ('CriminalGang',instance)]).
nounMapping2SUMO('08237400-n',[ ('CriminalGang',instance)]).
nounMapping2SUMO('08237699-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08237863-n',[ ('DramaticCast',subsumption)]).
nounMapping2SUMO('08238048-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08238156-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08238313-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08238463-n',[ ('GroupOfPeople',equivalence)]).
nounMapping2SUMO('08238660-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08238909-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08239024-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08239152-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08239383-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08239488-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08239590-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08239706-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08239808-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08240022-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08240169-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08240484-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08240633-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08240966-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08241309-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08241512-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08241654-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08241798-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08241964-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08242100-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08242223-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08242428-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('08242675-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08242799-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08243081-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08243248-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08243340-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08243492-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08243570-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08243695-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08243851-n',[ ('Organization',instance)]).
nounMapping2SUMO('08244062-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08244346-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08244532-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08244747-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08244895-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08245059-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08245172-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08245425-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08245549-n',[ ('Organization',instance)]).
nounMapping2SUMO('08245802-n',[ ('Organization',instance)]).
nounMapping2SUMO('08246036-n',[ ('Organization',instance)]).
nounMapping2SUMO('08246185-n',[ ('Organization',instance)]).
nounMapping2SUMO('08246302-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08246502-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08246613-n',[ ('MusicalGroup',equivalence)]).
nounMapping2SUMO('08247021-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08247152-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08247251-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08247400-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08247561-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08247703-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08247816-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08247935-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08248047-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08248157-n',[ ('Orchestra',equivalence)]).
nounMapping2SUMO('08248411-n',[ ('Orchestra',subsumption)]).
nounMapping2SUMO('08248521-n',[ ('Orchestra',subsumption)]).
nounMapping2SUMO('08248747-n',[ ('Orchestra',subsumption)]).
nounMapping2SUMO('08248856-n',[ ('Orchestra',subsumption)]).
nounMapping2SUMO('08249038-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08249207-n',[ ('MarchingBand',equivalence)]).
nounMapping2SUMO('08249336-n',[ ('Orchestra',subsumption)]).
nounMapping2SUMO('08249459-n',[ ('Orchestra',subsumption)]).
nounMapping2SUMO('08249608-n',[ ('Orchestra',subsumption)]).
nounMapping2SUMO('08249752-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08249854-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08249960-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08250168-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08250302-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08250409-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08250501-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08250635-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08250750-n',[ ('MusicalGroup',subsumption)]).
nounMapping2SUMO('08250889-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08250978-n',[ ('Organization',instance)]).
nounMapping2SUMO('08251104-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08251213-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08251303-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08251493-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08251605-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08251756-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08251877-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08252083-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08252211-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08252467-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08252602-n',[ ('SocialParty',equivalence)]).
nounMapping2SUMO('08253045-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08253141-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('08253268-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('08253450-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08253640-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08253815-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('08254055-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08254195-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08254331-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('08254540-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08254627-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('08254741-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08254876-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08254993-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08255109-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08255231-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08255373-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08255508-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08255660-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08255795-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08256005-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08256151-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08256229-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08256369-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08256567-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08256735-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08256968-n',[ ('PoliticalParty',equivalence)]).
nounMapping2SUMO('08257779-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08257971-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08258184-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08258358-n',[ ('PoliticalParty',subsumption)]).
nounMapping2SUMO('08258523-n',[ ('PoliticalParty',subsumption)]).
nounMapping2SUMO('08258744-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08258974-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08259156-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08259318-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08259611-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08259753-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08260002-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08260220-n',[ ('PoliticalParty',subsumption)]).
nounMapping2SUMO('08260386-n',[ ('PoliticalParty',subsumption)]).
nounMapping2SUMO('08260498-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08260691-n',[ ('PoliticalParty',subsumption)]).
nounMapping2SUMO('08260961-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08261162-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08261320-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08261589-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08261810-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08261958-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08262154-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08262309-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08262494-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08262695-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08262937-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08263113-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08263303-n',[ ('PoliticalParty',subsumption)]).
nounMapping2SUMO('08263560-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08263733-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08263870-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08264110-n',[ ('PoliticalParty',subsumption)]).
nounMapping2SUMO('08264203-n',[ ('PoliticalParty',instance)]).
nounMapping2SUMO('08264441-n',[ ('PoliticalParty',subsumption)]).
nounMapping2SUMO('08264583-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08264759-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08264897-n',[ ('GroupOfPeople',equivalence)]).
nounMapping2SUMO('08265252-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08265347-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08265469-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08265614-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08265692-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08265790-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08265912-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08266070-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08266235-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08266542-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08266669-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08266849-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08267008-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08267197-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08267446-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08267640-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08267956-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08268085-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08268321-n',[ ('Set',subsumption)]).
nounMapping2SUMO('08268636-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08268807-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08268962-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08269114-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08269257-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08269396-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08269506-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08269707-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08269939-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08270067-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08270169-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08270290-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('08270417-n',[ ('LineFormation',subsumption)]).
nounMapping2SUMO('08270662-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08270938-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08271042-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08271457-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08271656-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08271801-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08271941-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08272086-n',[ ('MilitaryOrganization',instance)]).
nounMapping2SUMO('08272248-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08272352-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08272460-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08272564-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08272652-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('08272774-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('08272860-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08272961-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08273167-n',[ ('GroupOfPeople',equivalence)]).
nounMapping2SUMO('08273406-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08273531-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08273645-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08273736-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08273843-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08274004-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08274126-n',[ ('PoliceOrganization',instance)]).
nounMapping2SUMO('08274354-n',[ ('Soldier',equivalence)]).
nounMapping2SUMO('08274443-n',[ ('CavalryUnit',subsumption)]).
nounMapping2SUMO('08274565-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08274718-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08274826-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08274923-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08275081-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08275185-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('08275497-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08275704-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08275843-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08276053-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08276342-n',[ ('EducationalOrganization',equivalence)]).
nounMapping2SUMO('08276539-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08276720-n',[ ('School',equivalence)]).
nounMapping2SUMO('08277393-n',[ ('School',equivalence)]).
nounMapping2SUMO('08277612-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08277709-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08277805-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08278032-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08278169-n',[ ('College',equivalence)]).
nounMapping2SUMO('08278324-n',[ ('College',equivalence)]).
nounMapping2SUMO('08278589-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08278707-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08278822-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08278924-n',[ ('School',subsumption)]).
nounMapping2SUMO('08279184-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08279298-n',[ ('SecondarySchool',subsumption)]).
nounMapping2SUMO('08279424-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08279524-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08279665-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08279800-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08279943-n',[ ('EducationalOrganization',instance)]).
nounMapping2SUMO('08280124-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08280462-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08280649-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08280813-n',[ ('EducationalOrganization',instance)]).
nounMapping2SUMO('08281029-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08281205-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08281409-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08281682-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08281812-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08281963-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08282109-n',[ ('School',subsumption)]).
nounMapping2SUMO('08282257-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08282364-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08282542-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08282696-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08282950-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08283051-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08283180-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08283507-n',[ ('MedicalSchool',subsumption)]).
nounMapping2SUMO('08283649-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08283757-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08283866-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08284054-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08284221-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08284370-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08284481-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08284847-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08284994-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08285109-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08285246-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08285407-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08285594-n',[ ('VocationalSchool',subsumption)]).
nounMapping2SUMO('08285719-n',[ ('CompanyMilitary',subsumption)]).
nounMapping2SUMO('08285896-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08286039-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08286163-n',[ ('University',equivalence)]).
nounMapping2SUMO('08286342-n',[ ('Dress',subsumption)]).
nounMapping2SUMO('08286569-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08286801-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08286946-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08287182-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08287335-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08287436-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08287586-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08287844-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('08288189-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08288390-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08288518-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08288753-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08288977-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08289089-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08289282-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08289449-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08289841-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08290156-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('08290435-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('08290616-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08290763-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('08290928-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('08291157-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('08291338-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08291582-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08291813-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08292051-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08292298-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08292418-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08292756-n',[ ('Fleet',equivalence)]).
nounMapping2SUMO('08293003-n',[ ('Fleet',subsumption)]).
nounMapping2SUMO('08293088-n',[ ('Fleet',instance)]).
nounMapping2SUMO('08293238-n',[ ('Fleet',subsumption)]).
nounMapping2SUMO('08293336-n',[ ('Fleet',subsumption)]).
nounMapping2SUMO('08293490-n',[ ('Fleet',subsumption)]).
nounMapping2SUMO('08293684-n',[ ('Fleet',subsumption)]).
nounMapping2SUMO('08293831-n',[ ('Fleet',subsumption)]).
nounMapping2SUMO('08293982-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08294395-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08294581-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08294696-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08295138-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08295580-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08295894-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08296059-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08296196-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08296332-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08296500-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08296720-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08296911-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08297284-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08297464-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08297646-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08297863-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08298074-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08298319-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08298521-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08298737-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08298918-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08299107-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08299307-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08299493-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08299911-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08300190-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08300429-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08300641-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08300783-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08301005-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08301155-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08301307-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08301525-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08301709-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08301871-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08302052-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08302257-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08302468-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08302724-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08302919-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08303097-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08303275-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08303504-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08303692-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08303862-n',[ ('Organization',instance)]).
nounMapping2SUMO('08304135-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08304744-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08304895-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08305114-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08305277-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08305568-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08305766-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08305942-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08306047-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08306194-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08306371-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08306665-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08306959-n',[ ('Group',instance)]).
nounMapping2SUMO('08307145-n',[ ('Group',instance)]).
nounMapping2SUMO('08307267-n',[ ('Group',instance)]).
nounMapping2SUMO('08307440-n',[ ('Group',instance)]).
nounMapping2SUMO('08307589-n',[ ('FormalMeeting',equivalence)]).
nounMapping2SUMO('08308039-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08308156-n',[ ('FormalMeeting',subsumption)]).
nounMapping2SUMO('08308313-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08308410-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08308497-n',[ ('FormalMeeting',equivalence)]).
nounMapping2SUMO('08308800-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08308922-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08309086-n',[ ('FormalMeeting',subsumption)]).
nounMapping2SUMO('08309226-n',[ ('FormalMeeting',subsumption)]).
nounMapping2SUMO('08309409-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08309611-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08309754-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08309854-n',[ ('FormalMeeting',subsumption)]).
nounMapping2SUMO('08310034-n',[ ('FormalMeeting',subsumption)]).
nounMapping2SUMO('08310168-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08310309-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08310389-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('08310722-n',[ ('OrganizationalBoard',subsumption)]).
nounMapping2SUMO('08310949-n',[ ('OrganizationalBoard',subsumption)]).
nounMapping2SUMO('08311282-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08311409-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08311522-n',[ ('OrganizationalBoard',subsumption)]).
nounMapping2SUMO('08311687-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08311848-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08311933-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08312241-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08312359-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08312462-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08312559-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08312988-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08313592-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08313790-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08313983-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08314153-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08314327-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08314501-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08314715-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08314901-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08315194-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08315442-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08315682-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08315860-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08316019-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08316346-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08316564-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08316748-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08316965-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08317139-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08317340-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08317529-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08317885-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08318032-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08318216-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08318423-n',[ ('LegislativeOrganization',instance)]).
nounMapping2SUMO('08318691-n',[ ('LegislativeOrganization',subsumption)]).
nounMapping2SUMO('08318777-n',[ ('LegislativeOrganization',subsumption)]).
nounMapping2SUMO('08318904-n',[ ('LegislativeOrganization',subsumption)]).
nounMapping2SUMO('08319061-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08319198-n',[ ('Parliament',equivalence)]).
nounMapping2SUMO('08319408-n',[ ('Parliament',instance)]).
nounMapping2SUMO('08319539-n',[ ('Parliament',instance)]).
nounMapping2SUMO('08319679-n',[ ('Parliament',instance)]).
nounMapping2SUMO('08319777-n',[ ('Parliament',instance)]).
nounMapping2SUMO('08319908-n',[ ('Parliament',instance)]).
nounMapping2SUMO('08320052-n',[ ('LegislativeOrganization',subsumption)]).
nounMapping2SUMO('08320201-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08320385-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08320923-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08321218-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08321469-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08321621-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08321807-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08321956-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08322187-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08322430-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08322520-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08322625-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08322756-n',[ ('Commission',subsumption)]).
nounMapping2SUMO('08322981-n',[ ('OrganizationalBoard',equivalence)]).
nounMapping2SUMO('08323301-n',[ ('JudicialOrganization',subsumption)]).
nounMapping2SUMO('08323471-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08323658-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08323825-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08323980-n',[ ('Government',instance)]).
nounMapping2SUMO('08324107-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08324274-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08324514-n',[ ('Commission',equivalence)]).
nounMapping2SUMO('08325124-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08325237-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08325386-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08325530-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08325686-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08325851-n',[ ('Commission',subsumption)]).
nounMapping2SUMO('08325993-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08326114-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08326266-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08326383-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08326487-n',[ ('Government',instance)]).
nounMapping2SUMO('08326706-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08326850-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08326976-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08327090-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08327212-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08327390-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08327616-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08327816-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08327906-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08328088-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08328327-n',[ ('Meeting',instance)]).
nounMapping2SUMO('08328563-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08328700-n',[ ('Judge',subsumption)]).
nounMapping2SUMO('08328876-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08329010-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08329113-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08329322-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08329453-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08330106-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08330298-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08330514-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08330843-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08331011-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08331121-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08331213-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08331357-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08331525-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08331762-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08331960-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08332090-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08332330-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08332485-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08332896-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08333030-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08333224-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08333639-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08333868-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08333995-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08334087-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08334319-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08334451-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08334581-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08334693-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08334873-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08335087-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08335253-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08335414-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08335599-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08335751-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08335886-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08336188-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08336355-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08336490-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08336627-n',[ ('Text',subsumption)]).
nounMapping2SUMO('08336844-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('08337108-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08337324-n',[ ('PoliticalOrganization',equivalence)]).
nounMapping2SUMO('08338847-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08339454-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08339706-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08339939-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08340153-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08340753-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08340989-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08341330-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08341551-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08341798-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08342039-n',[ ('GovernmentOrganization',subsumption)]).
nounMapping2SUMO('08342419-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08342670-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08342888-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08343102-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08343324-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08343534-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08343905-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08344301-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08344551-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08344756-n',[ ('PoliceOrganization',instance)]).
nounMapping2SUMO('08344917-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08345189-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08345366-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08345613-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08345770-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08346031-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08346286-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08346490-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08346655-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08346905-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08347206-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08347457-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08347704-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08348091-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08348400-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08348815-n',[ ('PoliceOrganization',subsumption)]).
nounMapping2SUMO('08349138-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08349350-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08349548-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08349681-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08349916-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08350244-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08350470-n',[ ('Government',instance)]).
nounMapping2SUMO('08350919-n',[ ('BankFinancialOrganization',subsumption)]).
nounMapping2SUMO('08351107-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08351380-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08351532-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08351777-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08352035-n',[ ('Government',instance)]).
nounMapping2SUMO('08352134-n',[ ('Government',instance)]).
nounMapping2SUMO('08352218-n',[ ('Government',instance)]).
nounMapping2SUMO('08352303-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08352473-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08352613-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08352720-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08352848-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08352994-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08353244-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08353406-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08353563-n',[ ('Government',instance)]).
nounMapping2SUMO('08353734-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08353912-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08354065-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08354243-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08354352-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08354523-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08354678-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08354842-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08355075-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08355324-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08355506-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08355692-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08355791-n',[ ('Government',instance)]).
nounMapping2SUMO('08356074-n',[ ('Government',instance)]).
nounMapping2SUMO('08356375-n',[ ('Government',instance)]).
nounMapping2SUMO('08356573-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08356903-n',[ ('Government',instance)]).
nounMapping2SUMO('08357129-n',[ ('Government',instance)]).
nounMapping2SUMO('08357258-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08357448-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08357529-n',[ ('OrganizationalBoard',subsumption)]).
nounMapping2SUMO('08357647-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08357784-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08357992-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08358165-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08358332-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08358492-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08358594-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08358824-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08358963-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08359316-n',[ ('TerroristOrganization',subsumption)]).
nounMapping2SUMO('08359432-n',[ ('TerroristOrganization',subsumption)]).
nounMapping2SUMO('08359581-n',[ ('TerroristOrganization',subsumption)]).
nounMapping2SUMO('08359753-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08359949-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08360248-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08360430-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08360540-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08360672-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08360849-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08361001-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08361172-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08361329-n',[ ('Democracy',equivalence)]).
nounMapping2SUMO('08361612-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08361720-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08361817-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08361924-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08362302-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08362455-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08362775-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08362917-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08363106-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08363428-n',[ ('TheocraticGovernment',equivalence)]).
nounMapping2SUMO('08363622-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08363711-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08363812-n',[ ('Monarchy',equivalence)]).
nounMapping2SUMO('08364044-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08364143-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08364367-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08364548-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08364757-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08364959-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08365222-n',[ ('EconomicAttribute',subsumption)]).
nounMapping2SUMO('08365344-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08365484-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08365672-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08365855-n',[ ('CommunistState',equivalence)]).
nounMapping2SUMO('08366071-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08366202-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08366440-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08366664-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08366753-n',[ ('EconomicAttribute',equivalence)]).
nounMapping2SUMO('08367100-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08367339-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08367579-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08367683-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('08367880-n',[ ('Government',equivalence)]).
nounMapping2SUMO('08368308-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08368516-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08368631-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08368757-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08368907-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('08369142-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('08369220-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('08369406-n',[ ('AgeGroup',subsumption)]).
nounMapping2SUMO('08369615-n',[ ('AgeGroup',instance)]).
nounMapping2SUMO('08369920-n',[ ('Organization',instance)]).
nounMapping2SUMO('08370204-n',[ ('Group',instance)]).
nounMapping2SUMO('08370505-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08370878-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08371200-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08371574-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08371838-n',[ ('AgeGroup',instance)]).
nounMapping2SUMO('08372020-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('08372190-n',[ ('AgeGroup',subsumption)]).
nounMapping2SUMO('08372299-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08372411-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08372574-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08372715-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08372847-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('08373055-n',[ ('Group',instance)]).
nounMapping2SUMO('08373244-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08373380-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08373544-n',[ ('List',subsumption)]).
nounMapping2SUMO('08373723-n',[ ('List',subsumption)]).
nounMapping2SUMO('08373818-n',[ ('List',subsumption)]).
nounMapping2SUMO('08373969-n',[ ('Group',instance)]).
nounMapping2SUMO('08374049-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08374653-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08374773-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08375031-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08375154-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08375369-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08375526-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08375722-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08375912-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08376051-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08376250-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08376526-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08376823-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08376948-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08377085-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08377332-n',[ ('Text',subsumption)]).
nounMapping2SUMO('08377454-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08377806-n',[ ('List',subsumption)]).
nounMapping2SUMO('08378066-n',[ ('List',subsumption)]).
nounMapping2SUMO('08378180-n',[ ('List',subsumption)]).
nounMapping2SUMO('08378356-n',[ ('List',subsumption)]).
nounMapping2SUMO('08378555-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08378698-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08378819-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08379353-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08379455-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08379630-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08379782-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08379882-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08380017-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08380340-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08380606-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('08380768-n',[ ('OrganizationalBoard',subsumption)]).
nounMapping2SUMO('08380975-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08381165-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08381296-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08381436-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08381636-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08381820-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08382056-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08382297-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08382570-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('08383067-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08383185-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08383310-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08383417-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08383690-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08383909-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08384041-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08384201-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08384342-n',[ ('Corporation',instance)]).
nounMapping2SUMO('08384539-n',[ ('Corporation',instance)]).
nounMapping2SUMO('08384738-n',[ ('Corporation',instance)]).
nounMapping2SUMO('08384900-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08385009-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08385280-n',[ ('FormalMeeting',subsumption)]).
nounMapping2SUMO('08385490-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08385602-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08385717-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08385849-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08385989-n',[ ('SocialParty',subsumption)]).
nounMapping2SUMO('08386143-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08386280-n',[ ('TransportationDevice',subsumption)]).
nounMapping2SUMO('08386365-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08386555-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08386853-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08387035-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08387213-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08387354-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08387495-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08387603-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08387685-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08387806-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08387930-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08388074-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08388207-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08388503-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08388636-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08388783-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08388871-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08388966-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08389094-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08389297-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08389438-n',[ ('Soldier',equivalence)]).
nounMapping2SUMO('08389572-n',[ ('ArtilleryBattery',equivalence)]).
nounMapping2SUMO('08389710-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08389900-n',[ ('CavalryUnit',equivalence)]).
nounMapping2SUMO('08390012-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08390157-n',[ ('InfantryUnit',equivalence)]).
nounMapping2SUMO('08390374-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08390511-n',[ ('MilitaryOrganization',subsumption)]).
nounMapping2SUMO('08390731-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08391021-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08391206-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08391387-n',[ ('Government',instance)]).
nounMapping2SUMO('08391696-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08391953-n',[ ('Government',instance)]).
nounMapping2SUMO('08392137-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08394423-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08394535-n',[ ('Government',instance)]).
nounMapping2SUMO('08394657-n',[ ('Government',instance)]).
nounMapping2SUMO('08394811-n',[ ('Army',subsumption)]).
nounMapping2SUMO('08394922-n',[ ('Government',instance)]).
nounMapping2SUMO('08395298-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08395465-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08395682-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08395991-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08396207-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08396537-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08396760-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08396990-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08397255-n',[ ('Soldier',equivalence)]).
nounMapping2SUMO('08397489-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('08397675-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('08397856-n',[ ('CavalryUnit',subsumption)]).
nounMapping2SUMO('08398036-n',[ ('MilitaryOrganization',subsumption)]).
nounMapping2SUMO('08398179-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08398467-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08398580-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08398773-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('08399287-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08399378-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08399586-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08399818-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08399977-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08400191-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08400331-n',[ ('Brood',subsumption)]).
nounMapping2SUMO('08400452-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08400605-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08400772-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08400870-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08400965-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08401248-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08401554-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08401711-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08401819-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08401970-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08402147-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08402222-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08402339-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08402442-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08402693-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08402828-n',[ ('Embassy',equivalence)]).
nounMapping2SUMO('08402944-n',[ ('Embassy',subsumption)]).
nounMapping2SUMO('08403082-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08403225-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('08403435-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08403631-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08403787-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08403907-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08404188-n',[ ('PoliticalParty',subsumption)]).
nounMapping2SUMO('08404373-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08404549-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08404735-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08404895-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08405124-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08405267-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08405490-n',[ ('PoliceOrganization',subsumption)]).
nounMapping2SUMO('08405603-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08405723-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08405873-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08406036-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08406160-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08406259-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08406361-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08406486-n',[ ('NonprofitOrganization',subsumption)]).
nounMapping2SUMO('08406619-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08406825-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08407000-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08407140-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08407330-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08407449-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08407619-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08407839-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('08407969-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('08408115-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('08408267-n',[ ('Disseminating',subsumption)]).
nounMapping2SUMO('08408418-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08408557-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08408709-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08408900-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08409130-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08409323-n',[ ('Group',instance)]).
nounMapping2SUMO('08409617-n',[ ('SecondarySchool',subsumption)]).
nounMapping2SUMO('08409835-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08409969-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08410092-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08410282-n',[ ('PublicSchool',subsumption)]).
nounMapping2SUMO('08410454-n',[ ('PublicSchool',subsumption)]).
nounMapping2SUMO('08410688-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08410891-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08411031-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08411170-n',[ ('PrivateSchool',subsumption)]).
nounMapping2SUMO('08411369-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08411483-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08411585-n',[ ('DaySchool',subsumption)]).
nounMapping2SUMO('08411701-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08411849-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08411970-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08412136-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08412265-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08412362-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08412492-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08412620-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08412749-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08412958-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08413092-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08413248-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08413408-n',[ ('EducationalOrganization',subsumption)]).
nounMapping2SUMO('08413529-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08413681-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08413834-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08414040-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08414119-n',[ ('Jury',equivalence)]).
nounMapping2SUMO('08414381-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08414608-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08414807-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08414964-n',[ ('Jury',subsumption)]).
nounMapping2SUMO('08415127-n',[ ('Jury',subsumption)]).
nounMapping2SUMO('08415272-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08415469-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08415661-n',[ ('MilitaryUnit',subsumption)]).
nounMapping2SUMO('08415774-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08415983-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08416137-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08416328-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08416523-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08416652-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08416890-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08417099-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08417178-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08417281-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08417436-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08417572-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08417673-n',[ ('Convoy',subsumption)]).
nounMapping2SUMO('08417801-n',[ ('Convoy',subsumption)]).
nounMapping2SUMO('08417920-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08418103-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08418316-n',[ ('BankFinancialOrganization',subsumption)]).
nounMapping2SUMO('08418420-n',[ ('BankFinancialOrganization',subsumption)]).
nounMapping2SUMO('08418631-n',[ ('BankFinancialOrganization',subsumption)]).
nounMapping2SUMO('08418763-n',[ ('BankFinancialOrganization',subsumption)]).
nounMapping2SUMO('08418885-n',[ ('BankFinancialOrganization',subsumption)]).
nounMapping2SUMO('08419033-n',[ ('BankFinancialOrganization',subsumption)]).
nounMapping2SUMO('08419163-n',[ ('BankFinancialOrganization',subsumption)]).
nounMapping2SUMO('08419354-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08419562-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08419774-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08419984-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08420278-n',[ ('BankFinancialOrganization',equivalence)]).
nounMapping2SUMO('08420839-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08421100-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08421291-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08421441-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08421644-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08421807-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08421975-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08422247-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08422524-n',[ ('BankFinancialOrganization',subsumption)]).
nounMapping2SUMO('08422714-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08422930-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08423057-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08423298-n',[ ('BankFinancialOrganization',subsumption)]).
nounMapping2SUMO('08423490-n',[ ('Government',instance)]).
nounMapping2SUMO('08423634-n',[ ('Government',instance)]).
nounMapping2SUMO('08423840-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08424044-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08424222-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08424501-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08424662-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08424769-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08424951-n',[ ('Buyer',subsumption)]).
nounMapping2SUMO('08425173-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08425303-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08425556-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08425657-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08425777-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08425888-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08426111-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08426211-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08426298-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08426378-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08426461-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08426816-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08426993-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08427163-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08427282-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08427453-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08427629-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('08427918-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08428019-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('08428252-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('08428383-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('08428485-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('08428623-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('08428756-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08428944-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('08429052-n',[ ('LineFormation',equivalence)]).
nounMapping2SUMO('08429167-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08429346-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08429482-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('08429556-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('08429744-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08429899-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08430054-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08430203-n',[ ('LineFormation',equivalence)]).
nounMapping2SUMO('08430568-n',[ ('LineFormation',equivalence)]).
nounMapping2SUMO('08430940-n',[ ('List',subsumption)]).
nounMapping2SUMO('08431048-n',[ ('List',subsumption)]).
nounMapping2SUMO('08431205-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08431345-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08431437-n',[ ('LineFormation',equivalence)]).
nounMapping2SUMO('08431600-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08431721-n',[ ('LineFormation',subsumption)]).
nounMapping2SUMO('08431942-n',[ ('LineFormation',equivalence)]).
nounMapping2SUMO('08432149-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08432264-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08432345-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08432606-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08432714-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08432820-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08432974-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08433077-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08433245-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08433343-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08433447-n',[ ('List',subsumption)]).
nounMapping2SUMO('08433575-n',[ ('List',subsumption)]).
nounMapping2SUMO('08433727-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08433861-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08434029-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08434259-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08434622-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08434704-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08435024-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08435246-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08435388-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08435937-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08436036-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08436203-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08436288-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08436452-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08436562-n',[ ('OccupationalTrade',equivalence)]).
nounMapping2SUMO('08436759-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('08437317-n',[ ('Reading',subsumption)]).
nounMapping2SUMO('08437515-n',[ ('Shrub',equivalence)]).
nounMapping2SUMO('08437721-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08437847-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('08437968-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('08438067-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('08438223-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('08438384-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('08438533-n',[ ('Forest',equivalence)]).
nounMapping2SUMO('08438840-n',[ ('Forest',subsumption)]).
nounMapping2SUMO('08438928-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('08439022-n',[ ('Forest',subsumption)]).
nounMapping2SUMO('08439126-n',[ ('Forest',subsumption)]).
nounMapping2SUMO('08439268-n',[ ('Forest',subsumption)]).
nounMapping2SUMO('08439369-n',[ ('Forest',subsumption)]).
nounMapping2SUMO('08439476-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('08439694-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('08439808-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('08439955-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08440382-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08440499-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08440630-n',[ ('Government',subsumption)]).
nounMapping2SUMO('08441039-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08441203-n',[ ('Law',subsumption)]).
nounMapping2SUMO('08453108-n',[ ('Law',subsumption)]).
nounMapping2SUMO('08453299-n',[ ('Law',subsumption)]).
nounMapping2SUMO('08453464-n',[ ('Law',subsumption)]).
nounMapping2SUMO('08453722-n',[ ('Law',subsumption)]).
nounMapping2SUMO('08454003-n',[ ('Law',subsumption)]).
nounMapping2SUMO('08454191-n',[ ('Law',subsumption)]).
nounMapping2SUMO('08454445-n',[ ('Law',subsumption)]).
nounMapping2SUMO('08454818-n',[ ('Law',subsumption)]).
nounMapping2SUMO('08455037-n',[ ('Law',subsumption)]).
nounMapping2SUMO('08455271-n',[ ('Law',subsumption)]).
nounMapping2SUMO('08455520-n',[ ('Law',subsumption)]).
nounMapping2SUMO('08455829-n',[ ('Law',subsumption)]).
nounMapping2SUMO('08456178-n',[ ('Law',subsumption)]).
nounMapping2SUMO('08456347-n',[ ('Law',subsumption)]).
nounMapping2SUMO('08456474-n',[ ('Law',subsumption)]).
nounMapping2SUMO('08456619-n',[ ('Law',subsumption)]).
nounMapping2SUMO('08456727-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08456888-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08456993-n',[ ('List',subsumption)]).
nounMapping2SUMO('08457369-n',[ ('List',subsumption)]).
nounMapping2SUMO('08457543-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('08457789-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('08457976-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08458504-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08458833-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08458912-n',[ ('List',subsumption)]).
nounMapping2SUMO('08459087-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08459252-n',[ ('List',subsumption)]).
nounMapping2SUMO('08459648-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08459908-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08460152-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08460395-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08460585-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08460769-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08460847-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08460924-n',[ ('List',subsumption)]).
nounMapping2SUMO('08461172-n',[ ('List',subsumption)]).
nounMapping2SUMO('08461424-n',[ ('List',subsumption)]).
nounMapping2SUMO('08461595-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08461875-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08461981-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08462066-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08462205-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08462320-n',[ ('FactualText',equivalence)]).
nounMapping2SUMO('08462534-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('08462721-n',[ ('FactualText',subsumption)]).
nounMapping2SUMO('08462858-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('08462964-n',[ ('Text',subsumption)]).
nounMapping2SUMO('08463063-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08463345-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08463509-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08463647-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08463817-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08463969-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08464098-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08464324-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08464449-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08464601-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08465118-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08465312-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08465558-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08465776-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08466010-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08466175-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08466412-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08466643-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08467258-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08467576-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08467757-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08467871-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08468084-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08468261-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08468499-n',[ ('Text',subsumption)]).
nounMapping2SUMO('08468721-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08468958-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08469233-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08469457-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08469678-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08469785-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08469917-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08470034-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08470210-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08470507-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08470710-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08470928-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08471185-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08471369-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08471589-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08471799-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08471949-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('08472120-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08472335-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08472590-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08472890-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08473173-n',[ ('UnionOrganization',subsumption)]).
nounMapping2SUMO('08473482-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('08473623-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08473787-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08474120-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('08474341-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('08474623-n',[ ('Group',instance)]).
nounMapping2SUMO('08474875-n',[ ('Group',instance)]).
nounMapping2SUMO('08475070-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08475332-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08475586-n',[ ('Group',instance)]).
nounMapping2SUMO('08475722-n',[ ('Group',instance)]).
nounMapping2SUMO('08475929-n',[ ('Group',instance)]).
nounMapping2SUMO('08476165-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('08476425-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08476629-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08476829-n',[ ('Group',instance)]).
nounMapping2SUMO('08476988-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08477077-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('08477164-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08477307-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08477511-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08477634-n',[ ('Female',subsumption)]).
nounMapping2SUMO('08477912-n',[ ('Female',subsumption)]).
nounMapping2SUMO('08478018-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08478171-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08478261-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08478371-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08478482-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08478702-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08478851-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08479095-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08479202-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08479407-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('08479615-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08479795-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08479894-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08479986-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08480135-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('08480303-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('08480512-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08480662-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08480847-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08481009-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08481184-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08481369-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08481604-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08481715-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08481832-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08481983-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08482113-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08482271-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08482577-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('08482700-n',[ ('BackFn',equivalence)]).
nounMapping2SUMO('08482866-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08483136-n',[ ('Human',subsumption)]).
nounMapping2SUMO('08483265-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08483353-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08483500-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08483650-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08483788-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08483935-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08484239-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08484386-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08484522-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08484648-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08484810-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08484986-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08485160-n',[ ('Group',instance)]).
nounMapping2SUMO('08485281-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('08485434-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08485598-n',[ ('GovernmentOrganization',instance)]).
nounMapping2SUMO('08485830-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08485977-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('08486075-n',[ ('Group',instance)]).
nounMapping2SUMO('08486189-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('08486306-n',[ ('Group',subsumption)]).
nounMapping2SUMO('08486538-n',[ ('Group',instance)]).
nounMapping2SUMO('08486971-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08487149-n',[ ('Organization',instance)]).
nounMapping2SUMO('08487319-n',[ ('Organization',instance)]).
nounMapping2SUMO('08487504-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('08487953-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08488081-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08488250-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08488411-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08488675-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08488833-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08489121-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08489285-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08489392-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('08489497-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08489627-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08489765-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08489890-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08490039-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08490199-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08490402-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('08490531-n',[ ('Region',instance)]).
nounMapping2SUMO('08490685-n',[ ('Region',instance)]).
nounMapping2SUMO('08490840-n',[ ('Region',instance)]).
nounMapping2SUMO('08491027-n',[ ('Address',equivalence)]).
nounMapping2SUMO('08491245-n',[ ('Address',subsumption)]).
nounMapping2SUMO('08491410-n',[ ('Address',subsumption)]).
nounMapping2SUMO('08491531-n',[ ('Address',subsumption)]).
nounMapping2SUMO('08491710-n',[ ('Address',subsumption)]).
nounMapping2SUMO('08491826-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08492354-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08492461-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08492546-n',[ ('AirTransitway',subsumption)]).
nounMapping2SUMO('08492747-n',[ ('AirTransitway',subsumption)]).
nounMapping2SUMO('08493064-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08493261-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08493493-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08493705-n',[ ('AirTransitway',equivalence)]).
nounMapping2SUMO('08493825-n',[ ('Room',subsumption)]).
nounMapping2SUMO('08493961-n',[ ('Airway',subsumption)]).
nounMapping2SUMO('08494133-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08494231-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08494459-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08494676-n',[ ('Region',instance)]).
nounMapping2SUMO('08494782-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08494987-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08495249-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08495420-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08495617-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08495908-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08496095-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08496199-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08496334-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08496477-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08496655-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08496798-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08497107-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('08497294-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08498163-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08498279-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08498424-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08498580-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08498732-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08498888-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08499057-n',[ ('EarthsAtmosphere',subsumption)]).
nounMapping2SUMO('08499357-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08499504-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08499680-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08499840-n',[ ('DependencyOrSpecialSovereigntyArea',subsumption)]).
nounMapping2SUMO('08500079-n',[ ('DependencyOrSpecialSovereigntyArea',subsumption)]).
nounMapping2SUMO('08500213-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08500433-n',[ ('OuterSpaceRegion',subsumption)]).
nounMapping2SUMO('08500819-n',[ ('OuterSpaceRegion',subsumption)]).
nounMapping2SUMO('08500989-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08501114-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08501275-n',[ ('Region',instance)]).
nounMapping2SUMO('08501565-n',[ ('Region',instance)]).
nounMapping2SUMO('08501729-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08501887-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08502051-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08502171-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08502317-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08502507-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08502672-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08502797-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08503004-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08503238-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08503477-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08503639-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08503921-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08504151-n',[ ('City',instance)]).
nounMapping2SUMO('08504375-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08504594-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08504851-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08505018-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08505110-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08505265-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08505402-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08505573-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08506347-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08506496-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08506641-n',[ ('MilitaryFront',subsumption)]).
nounMapping2SUMO('08506932-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08507109-n',[ ('MilitaryFront',instance)]).
nounMapping2SUMO('08507255-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08507381-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08507558-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('08508105-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('08508361-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('08508449-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('08508629-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('08508736-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('08508834-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08509111-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08509251-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08509442-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08509786-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08510030-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08510169-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08510350-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08510456-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08510666-n',[ ('Object',subsumption)]).
nounMapping2SUMO('08511017-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08511241-n',[ ('Object',subsumption)]).
nounMapping2SUMO('08511473-n',[ ('Object',subsumption)]).
nounMapping2SUMO('08511570-n',[ ('Object',subsumption)]).
nounMapping2SUMO('08511777-n',[ ('Object',subsumption)]).
nounMapping2SUMO('08511970-n',[ ('Object',subsumption)]).
nounMapping2SUMO('08512182-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('08512259-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08512736-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08513072-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08513163-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08513417-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08513718-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08514034-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08514233-n',[ ('DependencyOrSpecialSovereigntyArea',subsumption)]).
nounMapping2SUMO('08514412-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08514592-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('08514865-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08514975-n',[ ('Region',instance)]).
nounMapping2SUMO('08515126-n',[ ('Region',instance)]).
nounMapping2SUMO('08515349-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08515457-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08515581-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08515817-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08515911-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08516002-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08516080-n',[ ('AreaMeasure',subsumption)]).
nounMapping2SUMO('08516260-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08516431-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08516584-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08516660-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08516767-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08516885-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08517010-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08517127-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08517204-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08517327-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08517449-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08517554-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('08517676-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08517825-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08517966-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08518171-n',[ ('Campground',subsumption)]).
nounMapping2SUMO('08518374-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08518505-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08518747-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08518940-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('08519299-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('08519444-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('08519624-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08519916-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08520190-n',[ ('Region',instance)]).
nounMapping2SUMO('08520401-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08520728-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08520958-n',[ ('Region',instance)]).
nounMapping2SUMO('08521112-n',[ ('Region',instance)]).
nounMapping2SUMO('08521267-n',[ ('Region',instance)]).
nounMapping2SUMO('08521623-n',[ ('Cemetery',subsumption)]).
nounMapping2SUMO('08521816-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08522287-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08522518-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08522742-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08522872-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08523064-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08523217-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08523340-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08523483-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08524021-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08524130-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08524262-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08524404-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08524572-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08524735-n',[ ('City',equivalence)]).
nounMapping2SUMO('08537708-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08537837-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08538426-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08538584-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08538730-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08538917-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('08539072-n',[ ('Downtown',equivalence)]).
nounMapping2SUMO('08539276-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08539457-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08539557-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08539717-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08539893-n',[ ('Building',subsumption)]).
nounMapping2SUMO('08540016-n',[ ('City',subsumption)]).
nounMapping2SUMO('08540193-n',[ ('City',subsumption)]).
nounMapping2SUMO('08540266-n',[ ('City',subsumption)]).
nounMapping2SUMO('08540416-n',[ ('City',subsumption)]).
nounMapping2SUMO('08540532-n',[ ('CityDistrict',subsumption)]).
nounMapping2SUMO('08540770-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08540903-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08541130-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08541288-n',[ ('Field',subsumption)]).
nounMapping2SUMO('08541454-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08541609-n',[ ('County',subsumption)]).
nounMapping2SUMO('08541841-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08542081-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08542304-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08542403-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08542634-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08542884-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08543081-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08543223-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08543496-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08543625-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08543776-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08543916-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08544125-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('08544275-n',[ ('TwoDimensionalAngle',equivalence)]).
nounMapping2SUMO('08544419-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08544593-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08544719-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08544813-n',[ ('Nation',equivalence)]).
nounMapping2SUMO('08546183-n',[ ('County',equivalence)]).
nounMapping2SUMO('08546870-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08547048-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08547143-n',[ ('City',subsumption)]).
nounMapping2SUMO('08547300-n',[ ('City',subsumption)]).
nounMapping2SUMO('08547468-n',[ ('Field',subsumption)]).
nounMapping2SUMO('08547544-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08547655-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08547816-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08547938-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08548065-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08548239-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08548415-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08548605-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08548733-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08548924-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08549070-n',[ ('StationaryArtifact',equivalence)]).
nounMapping2SUMO('08549292-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08549480-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08549733-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('08549911-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08550076-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08550364-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08550455-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08550560-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08550664-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08550766-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08550862-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08550966-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08551177-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08551296-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08551420-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08551628-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08551984-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08552138-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08553132-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08553280-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08553424-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08553535-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08553887-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08554040-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08554206-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08554346-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08554440-n',[ ('Suburban',subsumption)]).
nounMapping2SUMO('08554762-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08554872-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08555001-n',[ ('City',subsumption)]).
nounMapping2SUMO('08555102-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08555333-n',[ ('Suburban',subsumption)]).
nounMapping2SUMO('08555443-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08555569-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08555710-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08555883-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('08556065-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('08556266-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('08556386-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('08556491-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08556950-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08557057-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08557131-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08557271-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08557396-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08557482-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08557754-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08557864-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08557976-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08558082-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08558155-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08558289-n',[ ('City',instance)]).
nounMapping2SUMO('08558488-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08558661-n',[ ('Region',instance)]).
nounMapping2SUMO('08558770-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08558882-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08558963-n',[ ('ResidentialBuilding',subsumption)]).
nounMapping2SUMO('08559155-n',[ ('Address',subsumption)]).
nounMapping2SUMO('08559508-n',[ ('Address',subsumption)]).
nounMapping2SUMO('08559766-n',[ ('Address',subsumption)]).
nounMapping2SUMO('08559922-n',[ ('Address',subsumption)]).
nounMapping2SUMO('08560027-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08560295-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('08560415-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08560560-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08560785-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08560952-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08561081-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08561230-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('08561351-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08561462-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('08561583-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08561714-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('08561835-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08561946-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('08562067-n',[ ('Region',instance)]).
nounMapping2SUMO('08562243-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08562454-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08562620-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08562757-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08562990-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08563085-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08563180-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08563478-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08563627-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08563990-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08564139-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08564307-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08564739-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08565006-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08565214-n',[ ('Region',instance)]).
nounMapping2SUMO('08565506-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08565701-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08565894-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08566028-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08566554-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08566707-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08566884-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08567072-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08567235-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08567600-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08567877-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08568142-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08568256-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08568430-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08568579-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08568719-n',[ ('Region',instance)]).
nounMapping2SUMO('08568978-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08569165-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08569319-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08569482-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08569591-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08569777-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08569998-n',[ ('Field',equivalence)]).
nounMapping2SUMO('08570242-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08570402-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08570533-n',[ ('IntentionalRelation',subsumption)]).
nounMapping2SUMO('08570634-n',[ ('Field',subsumption)]).
nounMapping2SUMO('08570758-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08571139-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08571275-n',[ ('SportsGround',subsumption)]).
nounMapping2SUMO('08571459-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08571642-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08571799-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08571898-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08572020-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08572162-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08572335-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08572467-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08572726-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08572877-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08573010-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08573140-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08573258-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08573472-n',[ ('FrontFn',equivalence)]).
nounMapping2SUMO('08573674-n',[ ('MilitaryFront',subsumption)]).
nounMapping2SUMO('08573842-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('08574038-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08574216-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08574314-n',[ ('GeographicArea',equivalence)]).
nounMapping2SUMO('08578032-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08578174-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08578364-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08578517-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08578706-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08578951-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08579134-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08579266-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08579352-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08579487-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08579780-n',[ ('PuttingGreen',equivalence)]).
nounMapping2SUMO('08580011-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08580134-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08580326-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08580447-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08580583-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08580803-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08580944-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('08581122-n',[ ('Roadway',instance)]).
nounMapping2SUMO('08581299-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08581503-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08581699-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08581897-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08582065-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08582157-n',[ ('Region',instance)]).
nounMapping2SUMO('08582337-n',[ ('Region',instance)]).
nounMapping2SUMO('08582613-n',[ ('Region',instance)]).
nounMapping2SUMO('08582837-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08583095-n',[ ('Hemisphere',subsumption)]).
nounMapping2SUMO('08583292-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08583455-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08583554-n',[ ('LineFormation',subsumption)]).
nounMapping2SUMO('08583682-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('08583793-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08583994-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08584218-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08584361-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08584449-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08584618-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08584787-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08584914-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08585056-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08585158-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08585298-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('08585447-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08585540-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08585657-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08585846-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08586036-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08586218-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08586330-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08586509-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('08586688-n',[ ('Region',instance)]).
nounMapping2SUMO('08586825-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08586978-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08587086-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08587174-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08587328-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08587439-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08587571-n',[ ('Park',subsumption)]).
nounMapping2SUMO('08587709-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08587828-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08587985-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08588152-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08588294-n',[ ('Inside',equivalence)]).
nounMapping2SUMO('08588486-n',[ ('Inside',subsumption)]).
nounMapping2SUMO('08588596-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08588699-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08588840-n',[ ('Inside',subsumption)]).
nounMapping2SUMO('08588916-n',[ ('Region',instance)]).
nounMapping2SUMO('08589140-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08589351-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('08589532-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('08589670-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('08589801-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('08590055-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('08590172-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('08590369-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08590719-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08590909-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08591269-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08591399-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08591486-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08591592-n',[ ('Lawn',equivalence)]).
nounMapping2SUMO('08591680-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08592165-n',[ ('BodyMotion',subsumption)]).
nounMapping2SUMO('08592352-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08592494-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08592656-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08592898-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08593014-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08593130-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('08593262-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08593924-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08594286-n',[ ('MilitaryFront',equivalence)]).
nounMapping2SUMO('08594543-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08594714-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08594886-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08595054-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08595171-n',[ ('AirTransitway',subsumption)]).
nounMapping2SUMO('08595299-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('08595398-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08595531-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('08595720-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08595958-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08596076-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08596214-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08596336-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('08596519-n',[ ('Roadway',instance)]).
nounMapping2SUMO('08596668-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08596830-n',[ ('Roadway',instance)]).
nounMapping2SUMO('08597023-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08597176-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08597323-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08597579-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08597727-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08597973-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('08598132-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08598301-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08598568-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08598696-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08598823-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08599174-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08599292-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08599488-n',[ ('Region',instance)]).
nounMapping2SUMO('08599662-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08599792-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08599976-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('08600147-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08600274-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08600443-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('08600618-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08600760-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08600992-n',[ ('PublicPark',equivalence)]).
nounMapping2SUMO('08602037-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08602254-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08602456-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08602650-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08602822-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08602997-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08603158-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08603308-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08603525-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08603704-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08603924-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08604085-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08604283-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08604487-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08604721-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08604891-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08605123-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08605261-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08605493-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08605720-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08605863-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08606012-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08606206-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08606370-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08606502-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08606688-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08606869-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08607066-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08607231-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08607408-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08607575-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08607752-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08607957-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08608157-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08608314-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08608505-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08608641-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08608813-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08608986-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08609131-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08609278-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08609487-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08609685-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08609858-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08610023-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('08610141-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08610305-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08610646-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08610810-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('08610975-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08611063-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08611218-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08611339-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08611421-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08611532-n',[ ('Region',instance)]).
nounMapping2SUMO('08611662-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08611836-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08611954-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08612049-n',[ ('Transitway',subsumption)]).
nounMapping2SUMO('08612340-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08612498-n',[ ('Transitway',subsumption)]).
nounMapping2SUMO('08612644-n',[ ('SpaceRegion',subsumption)]).
nounMapping2SUMO('08612786-n',[ ('LineFormation',subsumption)]).
nounMapping2SUMO('08613000-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08613078-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('08613202-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('08613345-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('08613472-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08613593-n',[ ('Outside',subsumption)]).
nounMapping2SUMO('08613733-n',[ ('Outdoors',subsumption)]).
nounMapping2SUMO('08613985-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08614104-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08614229-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('08614357-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08614545-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08614632-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08614746-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08614900-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08615001-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08615149-n',[ ('PublicPark',equivalence)]).
nounMapping2SUMO('08615374-n',[ ('Park',subsumption)]).
nounMapping2SUMO('08615638-n',[ ('ParkingLot',equivalence)]).
nounMapping2SUMO('08615810-n',[ ('ParkingRegion',equivalence)]).
nounMapping2SUMO('08615926-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08616050-n',[ ('Field',subsumption)]).
nounMapping2SUMO('08616311-n',[ ('Transitway',subsumption)]).
nounMapping2SUMO('08616872-n',[ ('Transitway',subsumption)]).
nounMapping2SUMO('08616985-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('08617311-n',[ ('LineFormation',subsumption)]).
nounMapping2SUMO('08617399-n',[ ('Transitway',subsumption)]).
nounMapping2SUMO('08617516-n',[ ('Transitway',subsumption)]).
nounMapping2SUMO('08617622-n',[ ('Transitway',subsumption)]).
nounMapping2SUMO('08617751-n',[ ('Waterway',subsumption)]).
nounMapping2SUMO('08617873-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08617963-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08618379-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08618669-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08618831-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08619006-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08619112-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08619250-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08619343-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08619457-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08619524-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08619620-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08619795-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08619949-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08620061-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08620763-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08620881-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08621099-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08621283-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08621393-n',[ ('Building',subsumption)]).
nounMapping2SUMO('08621472-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08621598-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('08622201-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('08622340-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08622586-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08622763-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('08622950-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08623260-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('08623424-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08623568-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08623676-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('08623800-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08623927-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08624095-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08624196-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('08624385-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08624656-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08624891-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('08625073-n',[ ('Right',equivalence)]).
nounMapping2SUMO('08625297-n',[ ('Right',subsumption)]).
nounMapping2SUMO('08625462-n',[ ('Left',equivalence)]).
nounMapping2SUMO('08625684-n',[ ('Left',subsumption)]).
nounMapping2SUMO('08625846-n',[ ('BackFn',subsumption)]).
nounMapping2SUMO('08626080-n',[ ('FrontFn',equivalence)]).
nounMapping2SUMO('08626283-n',[ ('City',subsumption)]).
nounMapping2SUMO('08626522-n',[ ('City',subsumption)]).
nounMapping2SUMO('08626758-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08626845-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08626947-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08627161-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08627316-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08627554-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08627665-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08627805-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08627919-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08628141-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08628308-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08628414-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08628578-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08628746-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08628921-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('08629199-n',[ ('Field',subsumption)]).
nounMapping2SUMO('08629508-n',[ ('BackFn',equivalence)]).
nounMapping2SUMO('08629746-n',[ ('BackFn',subsumption)]).
nounMapping2SUMO('08629922-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08630039-n',[ ('Region',equivalence)]).
nounMapping2SUMO('08630985-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08631531-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08631750-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08631945-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('08632096-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08632258-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08632423-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08632678-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08632894-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('08633191-n',[ ('AngleMeasure',subsumption)]).
nounMapping2SUMO('08633683-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08633851-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08633957-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08637771-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08638033-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08638141-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08638260-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('08638442-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08639058-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('08639367-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('08639479-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('08639586-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08639776-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('08639951-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('08640111-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('08640300-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('08640392-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('08640531-n',[ ('TravelerAccommodation',subsumption)]).
nounMapping2SUMO('08640739-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08640962-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08641113-n',[ ('Neighborhood',subsumption)]).
nounMapping2SUMO('08641744-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08641944-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08642037-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08642145-n',[ ('CityBlock',subsumption)]).
nounMapping2SUMO('08642331-n',[ ('Neighborhood',equivalence)]).
nounMapping2SUMO('08642517-n',[ ('Adjacent',subsumption)]).
nounMapping2SUMO('08642632-n',[ ('Adjacent',subsumption)]).
nounMapping2SUMO('08642870-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08643015-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08643267-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08643386-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08643499-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08643648-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08643729-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08643806-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08643933-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08644045-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08644213-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08644327-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08644426-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08644552-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08644722-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08645033-n',[ ('Rural',subsumption)]).
nounMapping2SUMO('08645104-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08645212-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08645318-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08645420-n',[ ('PublicPark',subsumption)]).
nounMapping2SUMO('08645571-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08645749-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08645847-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08645963-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08646188-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08646306-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08646486-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08646566-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08646787-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('08646902-n',[ ('GeographicArea',equivalence)]).
nounMapping2SUMO('08647049-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('08647121-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08647264-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08647354-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08647457-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('08647616-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08647945-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08648153-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08648322-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08648658-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08648781-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08648917-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08649067-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08649167-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08649345-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08649711-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08649873-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08649984-n',[ ('Adjacent',subsumption)]).
nounMapping2SUMO('08650073-n',[ ('East',subsumption)]).
nounMapping2SUMO('08650157-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08650305-n',[ ('North',subsumption)]).
nounMapping2SUMO('08650391-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08650507-n',[ ('South',subsumption)]).
nounMapping2SUMO('08650593-n',[ ('West',subsumption)]).
nounMapping2SUMO('08650677-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08650919-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08651104-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08651247-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08651735-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('08651832-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08652036-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08652156-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('08652256-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08652376-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08652480-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08652551-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08652717-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08652854-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08652970-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08653314-n',[ ('AtmosphericRegion',subsumption)]).
nounMapping2SUMO('08653474-n',[ ('Vacuum',equivalence)]).
nounMapping2SUMO('08653570-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08653706-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08653873-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08654029-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08654127-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08654260-n',[ ('StateOrProvince',subsumption)]).
nounMapping2SUMO('08654360-n',[ ('StateOrProvince',equivalence)]).
nounMapping2SUMO('08655464-n',[ ('AmericanState',equivalence)]).
nounMapping2SUMO('08656590-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('08656750-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('08656893-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08657100-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08657249-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('08657748-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08657887-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('08658001-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('08658118-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('08658309-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('08658469-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('08658612-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('08658776-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('08658918-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('08659076-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('08659242-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('08659331-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('08659446-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08659663-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08659759-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08659861-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08659993-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08660146-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('08660339-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08660817-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08660934-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08661063-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08661170-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08661277-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08661467-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08661697-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08661878-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08662155-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08662288-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08662427-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08662570-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08662914-n',[ ('AmusementAndThemeParks',subsumption)]).
nounMapping2SUMO('08663051-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('08663156-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08663354-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('08663703-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('08663774-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('08663860-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08664184-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08664365-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('08664443-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08665101-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('08665281-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08665504-n',[ ('City',subsumption)]).
nounMapping2SUMO('08671168-n',[ ('City',subsumption)]).
nounMapping2SUMO('08671293-n',[ ('City',subsumption)]).
nounMapping2SUMO('08671382-n',[ ('City',subsumption)]).
nounMapping2SUMO('08671509-n',[ ('City',subsumption)]).
nounMapping2SUMO('08671644-n',[ ('City',subsumption)]).
nounMapping2SUMO('08671822-n',[ ('City',subsumption)]).
nounMapping2SUMO('08672073-n',[ ('City',subsumption)]).
nounMapping2SUMO('08672199-n',[ ('City',subsumption)]).
nounMapping2SUMO('08672397-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08672562-n',[ ('City',subsumption)]).
nounMapping2SUMO('08672738-n',[ ('City',subsumption)]).
nounMapping2SUMO('08673039-n',[ ('City',subsumption)]).
nounMapping2SUMO('08673131-n',[ ('City',subsumption)]).
nounMapping2SUMO('08673273-n',[ ('City',subsumption)]).
nounMapping2SUMO('08673395-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08674251-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08674344-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08674464-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08674563-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08674739-n',[ ('CultivatedLandArea',subsumption)]).
nounMapping2SUMO('08674970-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08675145-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08675538-n',[ ('Region',instance)]).
nounMapping2SUMO('08675665-n',[ ('Region',instance)]).
nounMapping2SUMO('08675795-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08675967-n',[ ('City',equivalence)]).
nounMapping2SUMO('08676253-n',[ ('City',subsumption)]).
nounMapping2SUMO('08676349-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08676499-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08676622-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08676760-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08676951-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08677075-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08677250-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08677424-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08677525-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08677628-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08677801-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08677991-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08678151-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08678253-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08678405-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08678515-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08678615-n',[ ('WellnessDaySpa',subsumption)]).
nounMapping2SUMO('08678783-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('08679011-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('08679167-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('08679269-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('08679369-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08679562-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08679807-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08679972-n',[ ('LineFormation',subsumption)]).
nounMapping2SUMO('08680237-n',[ ('Transitway',subsumption)]).
nounMapping2SUMO('08680363-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('08680571-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08680888-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('08681084-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('08681222-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('08681422-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08681534-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08681649-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08681777-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('08681966-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08682188-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08682389-n',[ ('WesternHemisphere',instance)]).
nounMapping2SUMO('08682575-n',[ ('WesternHemisphere',instance)]).
nounMapping2SUMO('08682819-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08683177-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('08683286-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08683383-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08683548-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08683841-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08683986-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('08684107-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('08684191-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08684294-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08684572-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08684676-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('08684769-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08685019-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08685188-n',[ ('Region',instance)]).
nounMapping2SUMO('08685677-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08686129-n',[ ('Region',instance)]).
nounMapping2SUMO('08686332-n',[ ('Region',instance)]).
nounMapping2SUMO('08686495-n',[ ('Region',instance)]).
nounMapping2SUMO('08686658-n',[ ('Region',instance)]).
nounMapping2SUMO('08686821-n',[ ('Region',instance)]).
nounMapping2SUMO('08686979-n',[ ('Region',instance)]).
nounMapping2SUMO('08687150-n',[ ('Region',instance)]).
nounMapping2SUMO('08687345-n',[ ('Region',instance)]).
nounMapping2SUMO('08687525-n',[ ('Region',instance)]).
nounMapping2SUMO('08687709-n',[ ('Region',instance)]).
nounMapping2SUMO('08687884-n',[ ('Region',instance)]).
nounMapping2SUMO('08688076-n',[ ('Region',instance)]).
nounMapping2SUMO('08688247-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08688424-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('08688590-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08688779-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08689028-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08689357-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08689449-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08689646-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08689771-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('08689873-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08689947-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08690194-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08690352-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08690479-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08690665-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08690792-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08690974-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08691188-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08691276-n',[ ('TimeZone',equivalence)]).
nounMapping2SUMO('08691445-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08691669-n',[ ('City',subsumption)]).
nounMapping2SUMO('08695198-n',[ ('City',subsumption)]).
nounMapping2SUMO('08695539-n',[ ('City',subsumption)]).
nounMapping2SUMO('08696737-n',[ ('Continent',equivalence)]).
nounMapping2SUMO('08696931-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08697827-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08698038-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08698126-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08698379-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08699426-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08699654-n',[ ('Namibia',equivalence)]).
nounMapping2SUMO('08700133-n',[ ('City',instance)]).
nounMapping2SUMO('08700255-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08701161-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08701296-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08701410-n',[ ('Nation',instance)]).
nounMapping2SUMO('08701555-n',[ ('City',instance)]).
nounMapping2SUMO('08701719-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08701942-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08702402-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08702805-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08703035-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('08703454-n',[ ('Afghanistan',equivalence)]).
nounMapping2SUMO('08703972-n',[ ('City',instance)]).
nounMapping2SUMO('08704116-n',[ ('City',instance)]).
nounMapping2SUMO('08704237-n',[ ('City',instance)]).
nounMapping2SUMO('08704409-n',[ ('City',instance)]).
nounMapping2SUMO('08704554-n',[ ('City',instance)]).
nounMapping2SUMO('08704665-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08704822-n',[ ('Albania',equivalence)]).
nounMapping2SUMO('08705091-n',[ ('City',instance)]).
nounMapping2SUMO('08705251-n',[ ('City',instance)]).
nounMapping2SUMO('08705397-n',[ ('Algeria',equivalence)]).
nounMapping2SUMO('08706058-n',[ ('City',instance)]).
nounMapping2SUMO('08706247-n',[ ('City',instance)]).
nounMapping2SUMO('08706399-n',[ ('City',instance)]).
nounMapping2SUMO('08706502-n',[ ('City',instance)]).
nounMapping2SUMO('08706663-n',[ ('OranAlgeria',equivalence)]).
nounMapping2SUMO('08706823-n',[ ('City',instance)]).
nounMapping2SUMO('08707035-n',[ ('City',instance)]).
nounMapping2SUMO('08707145-n',[ ('City',instance)]).
nounMapping2SUMO('08707332-n',[ ('City',instance)]).
nounMapping2SUMO('08707431-n',[ ('City',instance)]).
nounMapping2SUMO('08707587-n',[ ('City',instance)]).
nounMapping2SUMO('08707710-n',[ ('GeopoliticalArea',instance)]).
nounMapping2SUMO('08707917-n',[ ('Angola',equivalence)]).
nounMapping2SUMO('08708304-n',[ ('City',instance)]).
nounMapping2SUMO('08708481-n',[ ('City',instance)]).
nounMapping2SUMO('08708609-n',[ ('City',instance)]).
nounMapping2SUMO('08708742-n',[ ('GeopoliticalArea',instance)]).
nounMapping2SUMO('08708870-n',[ ('Island',instance)]).
nounMapping2SUMO('08709038-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08709399-n',[ ('GeopoliticalArea',instance)]).
nounMapping2SUMO('08709593-n',[ ('City',instance)]).
nounMapping2SUMO('08709704-n',[ ('AntiguaAndBarbuda',equivalence)]).
nounMapping2SUMO('08709945-n',[ ('Island',instance)]).
nounMapping2SUMO('08710113-n',[ ('Island',instance)]).
nounMapping2SUMO('08710219-n',[ ('Island',instance)]).
nounMapping2SUMO('08710325-n',[ ('City',instance)]).
nounMapping2SUMO('08710535-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08710678-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08710873-n',[ ('City',instance)]).
nounMapping2SUMO('08710951-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08711143-n',[ ('BouvetIsland',equivalence)]).
nounMapping2SUMO('08711300-n',[ ('Island',instance)]).
nounMapping2SUMO('08711468-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08711655-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08711974-n',[ ('Argentina',equivalence)]).
nounMapping2SUMO('08712698-n',[ ('City',instance)]).
nounMapping2SUMO('08712876-n',[ ('City',instance)]).
nounMapping2SUMO('08713136-n',[ ('City',instance)]).
nounMapping2SUMO('08713285-n',[ ('City',instance)]).
nounMapping2SUMO('08713405-n',[ ('City',instance)]).
nounMapping2SUMO('08713539-n',[ ('City',instance)]).
nounMapping2SUMO('08713655-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08713772-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08714132-n',[ ('Bulgaria',equivalence)]).
nounMapping2SUMO('08714458-n',[ ('City',instance)]).
nounMapping2SUMO('08714624-n',[ ('City',instance)]).
nounMapping2SUMO('08714795-n',[ ('City',instance)]).
nounMapping2SUMO('08714966-n',[ ('City',instance)]).
nounMapping2SUMO('08715110-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08715390-n',[ ('Myanmar',equivalence)]).
nounMapping2SUMO('08715777-n',[ ('City',instance)]).
nounMapping2SUMO('08715952-n',[ ('City',instance)]).
nounMapping2SUMO('08716076-n',[ ('City',instance)]).
nounMapping2SUMO('08716219-n',[ ('Burundi',equivalence)]).
nounMapping2SUMO('08716517-n',[ ('City',instance)]).
nounMapping2SUMO('08716738-n',[ ('Cambodia',equivalence)]).
nounMapping2SUMO('08717059-n',[ ('City',instance)]).
nounMapping2SUMO('08717209-n',[ ('Cameroon',equivalence)]).
nounMapping2SUMO('08717510-n',[ ('City',instance)]).
nounMapping2SUMO('08717629-n',[ ('City',instance)]).
nounMapping2SUMO('08717730-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08717915-n',[ ('Island',instance)]).
nounMapping2SUMO('08718094-n',[ ('City',instance)]).
nounMapping2SUMO('08718253-n',[ ('Island',instance)]).
nounMapping2SUMO('08718391-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08718577-n',[ ('CentralAfricanRepublic',equivalence)]).
nounMapping2SUMO('08718801-n',[ ('City',instance)]).
nounMapping2SUMO('08718962-n',[ ('Island',instance)]).
nounMapping2SUMO('08719100-n',[ ('SriLanka',equivalence)]).
nounMapping2SUMO('08719465-n',[ ('City',instance)]).
nounMapping2SUMO('08719705-n',[ ('KandySriLanka',equivalence)]).
nounMapping2SUMO('08719892-n',[ ('Nation',instance)]).
nounMapping2SUMO('08720037-n',[ ('Chad',equivalence)]).
nounMapping2SUMO('08720280-n',[ ('City',instance)]).
nounMapping2SUMO('08720481-n',[ ('Chile',equivalence)]).
nounMapping2SUMO('08721145-n',[ ('City',instance)]).
nounMapping2SUMO('08721286-n',[ ('Island',instance)]).
nounMapping2SUMO('08721449-n',[ ('City',instance)]).
nounMapping2SUMO('08721559-n',[ ('SantiagoChile',equivalence)]).
nounMapping2SUMO('08721796-n',[ ('City',instance)]).
nounMapping2SUMO('08721961-n',[ ('City',instance)]).
nounMapping2SUMO('08722084-n',[ ('City',instance)]).
nounMapping2SUMO('08722270-n',[ ('City',instance)]).
nounMapping2SUMO('08722394-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08722645-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08722844-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08723006-n',[ ('China',equivalence)]).
nounMapping2SUMO('08724545-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08724726-n',[ ('City',instance)]).
nounMapping2SUMO('08724972-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('08725161-n',[ ('City',instance)]).
nounMapping2SUMO('08725336-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08725454-n',[ ('City',instance)]).
nounMapping2SUMO('08725692-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08725926-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08726072-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08726305-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08726463-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08726582-n',[ ('City',instance)]).
nounMapping2SUMO('08726745-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08727003-n',[ ('City',instance)]).
nounMapping2SUMO('08727230-n',[ ('City',instance)]).
nounMapping2SUMO('08727396-n',[ ('PortCity',instance)]).
nounMapping2SUMO('08727606-n',[ ('City',instance)]).
nounMapping2SUMO('08727806-n',[ ('City',instance)]).
nounMapping2SUMO('08727945-n',[ ('City',instance)]).
nounMapping2SUMO('08728066-n',[ ('City',instance)]).
nounMapping2SUMO('08728268-n',[ ('City',instance)]).
nounMapping2SUMO('08728462-n',[ ('City',instance)]).
nounMapping2SUMO('08728595-n',[ ('City',instance)]).
nounMapping2SUMO('08728749-n',[ ('City',instance)]).
nounMapping2SUMO('08728882-n',[ ('City',instance)]).
nounMapping2SUMO('08729094-n',[ ('Waterway',instance)]).
nounMapping2SUMO('08729283-n',[ ('City',instance)]).
nounMapping2SUMO('08729452-n',[ ('City',instance)]).
nounMapping2SUMO('08729626-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08729971-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08730218-n',[ ('City',instance)]).
nounMapping2SUMO('08730354-n',[ ('Island',instance)]).
nounMapping2SUMO('08730550-n',[ ('GeopoliticalArea',instance)]).
nounMapping2SUMO('08730895-n',[ ('City',instance)]).
nounMapping2SUMO('08731057-n',[ ('City',instance)]).
nounMapping2SUMO('08731148-n',[ ('City',instance)]).
nounMapping2SUMO('08731423-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08731606-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08731953-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08732116-n',[ ('Colombia',equivalence)]).
nounMapping2SUMO('08732807-n',[ ('City',instance)]).
nounMapping2SUMO('08732979-n',[ ('City',instance)]).
nounMapping2SUMO('08733163-n',[ ('CaliColombia',equivalence)]).
nounMapping2SUMO('08733291-n',[ ('MedellinColombia',equivalence)]).
nounMapping2SUMO('08733415-n',[ ('City',instance)]).
nounMapping2SUMO('08733563-n',[ ('City',instance)]).
nounMapping2SUMO('08733690-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08733897-n',[ ('Comoros',equivalence)]).
nounMapping2SUMO('08734044-n',[ ('DemocraticRepublicOfTheCongo',equivalence)]).
nounMapping2SUMO('08734250-n',[ ('City',instance)]).
nounMapping2SUMO('08734385-n',[ ('DemocraticRepublicOfTheCongo',equivalence)]).
nounMapping2SUMO('08734853-n',[ ('City',instance)]).
nounMapping2SUMO('08735008-n',[ ('City',instance)]).
nounMapping2SUMO('08735164-n',[ ('City',instance)]).
nounMapping2SUMO('08735345-n',[ ('City',instance)]).
nounMapping2SUMO('08735564-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08735705-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08736107-n',[ ('CostaRica',equivalence)]).
nounMapping2SUMO('08736376-n',[ ('SanJoseCostaRica',equivalence)]).
nounMapping2SUMO('08736517-n',[ ('CoteDIvoire',equivalence)]).
nounMapping2SUMO('08736779-n',[ ('City',instance)]).
nounMapping2SUMO('08736956-n',[ ('City',instance)]).
nounMapping2SUMO('08737041-n',[ ('Guatemala',equivalence)]).
nounMapping2SUMO('08737376-n',[ ('City',instance)]).
nounMapping2SUMO('08737521-n',[ ('Belize',equivalence)]).
nounMapping2SUMO('08737716-n',[ ('Honduras',equivalence)]).
nounMapping2SUMO('08738014-n',[ ('City',instance)]).
nounMapping2SUMO('08738151-n',[ ('City',instance)]).
nounMapping2SUMO('08738272-n',[ ('ElSalvador',equivalence)]).
nounMapping2SUMO('08738531-n',[ ('City',instance)]).
nounMapping2SUMO('08738715-n',[ ('City',instance)]).
nounMapping2SUMO('08738820-n',[ ('Nicaragua',equivalence)]).
nounMapping2SUMO('08739047-n',[ ('City',instance)]).
nounMapping2SUMO('08739206-n',[ ('Panama',equivalence)]).
nounMapping2SUMO('08739512-n',[ ('City',instance)]).
nounMapping2SUMO('08739669-n',[ ('City',instance)]).
nounMapping2SUMO('08739829-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08740022-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08740230-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08740367-n',[ ('City',instance)]).
nounMapping2SUMO('08740483-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08740617-n',[ ('City',instance)]).
nounMapping2SUMO('08740729-n',[ ('Island',instance)]).
nounMapping2SUMO('08740875-n',[ ('Mexico',equivalence)]).
nounMapping2SUMO('08742205-n',[ ('City',instance)]).
nounMapping2SUMO('08742455-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08742578-n',[ ('City',instance)]).
nounMapping2SUMO('08742743-n',[ ('City',instance)]).
nounMapping2SUMO('08742892-n',[ ('City',instance)]).
nounMapping2SUMO('08743003-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08743125-n',[ ('City',instance)]).
nounMapping2SUMO('08743229-n',[ ('City',instance)]).
nounMapping2SUMO('08743370-n',[ ('City',instance)]).
nounMapping2SUMO('08743557-n',[ ('City',instance)]).
nounMapping2SUMO('08743691-n',[ ('City',instance)]).
nounMapping2SUMO('08743786-n',[ ('City',instance)]).
nounMapping2SUMO('08743945-n',[ ('City',instance)]).
nounMapping2SUMO('08744105-n',[ ('City',instance)]).
nounMapping2SUMO('08744236-n',[ ('City',instance)]).
nounMapping2SUMO('08744509-n',[ ('City',instance)]).
nounMapping2SUMO('08744626-n',[ ('City',instance)]).
nounMapping2SUMO('08744750-n',[ ('City',instance)]).
nounMapping2SUMO('08744871-n',[ ('City',instance)]).
nounMapping2SUMO('08745011-n',[ ('City',instance)]).
nounMapping2SUMO('08745249-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08745407-n',[ ('City',instance)]).
nounMapping2SUMO('08745513-n',[ ('City',instance)]).
nounMapping2SUMO('08745687-n',[ ('Food',subsumption)]).
nounMapping2SUMO('08745800-n',[ ('City',instance)]).
nounMapping2SUMO('08745901-n',[ ('City',instance)]).
nounMapping2SUMO('08746023-n',[ ('City',instance)]).
nounMapping2SUMO('08746147-n',[ ('City',instance)]).
nounMapping2SUMO('08746363-n',[ ('City',instance)]).
nounMapping2SUMO('08746475-n',[ ('City',instance)]).
nounMapping2SUMO('08746636-n',[ ('City',instance)]).
nounMapping2SUMO('08746797-n',[ ('Island',instance)]).
nounMapping2SUMO('08746942-n',[ ('Island',instance)]).
nounMapping2SUMO('08747054-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08747494-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08747737-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08747887-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08748076-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08748280-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08748499-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08748794-n',[ ('Island',instance)]).
nounMapping2SUMO('08748917-n',[ ('Island',instance)]).
nounMapping2SUMO('08749042-n',[ ('Island',instance)]).
nounMapping2SUMO('08749167-n',[ ('Island',instance)]).
nounMapping2SUMO('08749312-n',[ ('Island',instance)]).
nounMapping2SUMO('08749447-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08749650-n',[ ('Island',instance)]).
nounMapping2SUMO('08749864-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08750151-n',[ ('Island',instance)]).
nounMapping2SUMO('08750334-n',[ ('Cuba',equivalence)]).
nounMapping2SUMO('08750612-n',[ ('City',instance)]).
nounMapping2SUMO('08750822-n',[ ('City',instance)]).
nounMapping2SUMO('08750986-n',[ ('City',instance)]).
nounMapping2SUMO('08751126-n',[ ('Island',instance)]).
nounMapping2SUMO('08751317-n',[ ('Island',instance)]).
nounMapping2SUMO('08751494-n',[ ('Haiti',equivalence)]).
nounMapping2SUMO('08751885-n',[ ('City',instance)]).
nounMapping2SUMO('08752021-n',[ ('DominicanRepublic',equivalence)]).
nounMapping2SUMO('08752293-n',[ ('City',instance)]).
nounMapping2SUMO('08752671-n',[ ('City',instance)]).
nounMapping2SUMO('08752814-n',[ ('Island',instance)]).
nounMapping2SUMO('08752974-n',[ ('PuertoRico',equivalence)]).
nounMapping2SUMO('08753294-n',[ ('City',instance)]).
nounMapping2SUMO('08753412-n',[ ('Island',instance)]).
nounMapping2SUMO('08753561-n',[ ('Island',instance)]).
nounMapping2SUMO('08753729-n',[ ('Island',instance)]).
nounMapping2SUMO('08753933-n',[ ('Jamaica',equivalence)]).
nounMapping2SUMO('08754238-n',[ ('City',instance)]).
nounMapping2SUMO('08754388-n',[ ('City',instance)]).
nounMapping2SUMO('08754529-n',[ ('VirginIslands',equivalence)]).
nounMapping2SUMO('08754814-n',[ ('BritishVirginIslands',instance)]).
nounMapping2SUMO('08755003-n',[ ('VirginIslands',instance)]).
nounMapping2SUMO('08755214-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08755436-n',[ ('Barbados',equivalence)]).
nounMapping2SUMO('08755664-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08755852-n',[ ('Island',instance)]).
nounMapping2SUMO('08756052-n',[ ('Island',instance)]).
nounMapping2SUMO('08756202-n',[ ('TrinidadAndTobago',equivalence)]).
nounMapping2SUMO('08756511-n',[ ('City',instance)]).
nounMapping2SUMO('08756735-n',[ ('Island',instance)]).
nounMapping2SUMO('08756884-n',[ ('Cyprus',equivalence)]).
nounMapping2SUMO('08757132-n',[ ('City',instance)]).
nounMapping2SUMO('08757264-n',[ ('CzechRepublic',equivalence)]).
nounMapping2SUMO('08757569-n',[ ('Nation',instance)]).
nounMapping2SUMO('08757791-n',[ ('City',instance)]).
nounMapping2SUMO('08757926-n',[ ('City',instance)]).
nounMapping2SUMO('08758172-n',[ ('City',instance)]).
nounMapping2SUMO('08758334-n',[ ('City',instance)]).
nounMapping2SUMO('08758487-n',[ ('City',instance)]).
nounMapping2SUMO('08758679-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08758882-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08759013-n',[ ('Slovakia',equivalence)]).
nounMapping2SUMO('08759263-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08759420-n',[ ('Benin',equivalence)]).
nounMapping2SUMO('08759684-n',[ ('City',instance)]).
nounMapping2SUMO('08759852-n',[ ('City',instance)]).
nounMapping2SUMO('08759986-n',[ ('Togo',equivalence)]).
nounMapping2SUMO('08760228-n',[ ('City',instance)]).
nounMapping2SUMO('08760393-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08760510-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08760856-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08761039-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08761244-n',[ ('Denmark',equivalence)]).
nounMapping2SUMO('08761697-n',[ ('Island',instance)]).
nounMapping2SUMO('08761868-n',[ ('City',instance)]).
nounMapping2SUMO('08762104-n',[ ('City',instance)]).
nounMapping2SUMO('08762243-n',[ ('City',instance)]).
nounMapping2SUMO('08762380-n',[ ('City',instance)]).
nounMapping2SUMO('08762495-n',[ ('Djibouti',equivalence)]).
nounMapping2SUMO('08762823-n',[ ('City',instance)]).
nounMapping2SUMO('08763010-n',[ ('Island',instance)]).
nounMapping2SUMO('08763193-n',[ ('Dominica',equivalence)]).
nounMapping2SUMO('08763387-n',[ ('City',instance)]).
nounMapping2SUMO('08763500-n',[ ('EquatorialGuinea',equivalence)]).
nounMapping2SUMO('08763765-n',[ ('City',instance)]).
nounMapping2SUMO('08763932-n',[ ('Island',instance)]).
nounMapping2SUMO('08764107-n',[ ('Norway',equivalence)]).
nounMapping2SUMO('08764561-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08764717-n',[ ('Island',instance)]).
nounMapping2SUMO('08764899-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08765069-n',[ ('City',instance)]).
nounMapping2SUMO('08765315-n',[ ('City',instance)]).
nounMapping2SUMO('08765460-n',[ ('City',instance)]).
nounMapping2SUMO('08765623-n',[ ('City',instance)]).
nounMapping2SUMO('08765771-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08765890-n',[ ('Sweden',equivalence)]).
nounMapping2SUMO('08766236-n',[ ('City',instance)]).
nounMapping2SUMO('08766455-n',[ ('City',instance)]).
nounMapping2SUMO('08766571-n',[ ('City',instance)]).
nounMapping2SUMO('08766667-n',[ ('City',instance)]).
nounMapping2SUMO('08766846-n',[ ('City',instance)]).
nounMapping2SUMO('08766988-n',[ ('Germany',equivalence)]).
nounMapping2SUMO('08768647-n',[ ('Nation',instance)]).
nounMapping2SUMO('08768881-n',[ ('Nation',instance)]).
nounMapping2SUMO('08769179-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08769329-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08769439-n',[ ('City',instance)]).
nounMapping2SUMO('08769645-n',[ ('City',instance)]).
nounMapping2SUMO('08769836-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08770013-n',[ ('City',instance)]).
nounMapping2SUMO('08770274-n',[ ('City',instance)]).
nounMapping2SUMO('08770518-n',[ ('City',instance)]).
nounMapping2SUMO('08770718-n',[ ('City',instance)]).
nounMapping2SUMO('08770932-n',[ ('City',instance)]).
nounMapping2SUMO('08771116-n',[ ('City',instance)]).
nounMapping2SUMO('08771277-n',[ ('City',instance)]).
nounMapping2SUMO('08771400-n',[ ('City',instance)]).
nounMapping2SUMO('08771596-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08771841-n',[ ('City',instance)]).
nounMapping2SUMO('08772028-n',[ ('Battle',instance)]).
nounMapping2SUMO('08772137-n',[ ('BonnGermany',equivalence)]).
nounMapping2SUMO('08772307-n',[ ('CologneGermany',equivalence)]).
nounMapping2SUMO('08772551-n',[ ('City',instance)]).
nounMapping2SUMO('08772667-n',[ ('City',instance)]).
nounMapping2SUMO('08772794-n',[ ('City',instance)]).
nounMapping2SUMO('08772922-n',[ ('FrankfurtGermany',equivalence)]).
nounMapping2SUMO('08773098-n',[ ('City',instance)]).
nounMapping2SUMO('08773336-n',[ ('City',instance)]).
nounMapping2SUMO('08773679-n',[ ('HannoverGermany',equivalence)]).
nounMapping2SUMO('08773880-n',[ ('City',instance)]).
nounMapping2SUMO('08774073-n',[ ('City',instance)]).
nounMapping2SUMO('08774227-n',[ ('MunchenGladbachGermany',equivalence)]).
nounMapping2SUMO('08774374-n',[ ('NuremburgGermany',equivalence)]).
nounMapping2SUMO('08774546-n',[ ('City',instance)]).
nounMapping2SUMO('08774704-n',[ ('City',instance)]).
nounMapping2SUMO('08774912-n',[ ('City',instance)]).
nounMapping2SUMO('08775053-n',[ ('City',instance)]).
nounMapping2SUMO('08775179-n',[ ('City',instance)]).
nounMapping2SUMO('08775297-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08775439-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08775597-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08775784-n',[ ('Nation',instance)]).
nounMapping2SUMO('08776138-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08776320-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08776435-n',[ ('EastTimor',equivalence)]).
nounMapping2SUMO('08776687-n',[ ('Ecuador',equivalence)]).
nounMapping2SUMO('08777130-n',[ ('City',instance)]).
nounMapping2SUMO('08777233-n',[ ('City',instance)]).
nounMapping2SUMO('08777348-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08777544-n',[ ('Eritrea',equivalence)]).
nounMapping2SUMO('08777815-n',[ ('City',instance)]).
nounMapping2SUMO('08777919-n',[ ('City',instance)]).
nounMapping2SUMO('08778061-n',[ ('Ethiopia',equivalence)]).
nounMapping2SUMO('08778401-n',[ ('AddisAbabaEthiopia',equivalence)]).
nounMapping2SUMO('08778597-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08778936-n',[ ('Island',instance)]).
nounMapping2SUMO('08779042-n',[ ('Island',instance)]).
nounMapping2SUMO('08779149-n',[ ('Fiji',equivalence)]).
nounMapping2SUMO('08779375-n',[ ('City',instance)]).
nounMapping2SUMO('08779504-n',[ ('Finland',equivalence)]).
nounMapping2SUMO('08779830-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08780018-n',[ ('City',instance)]).
nounMapping2SUMO('08780282-n',[ ('City',instance)]).
nounMapping2SUMO('08780380-n',[ ('City',instance)]).
nounMapping2SUMO('08780510-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08780720-n',[ ('City',instance)]).
nounMapping2SUMO('08780881-n',[ ('Greece',equivalence)]).
nounMapping2SUMO('08782319-n',[ ('Greece',equivalence)]).
nounMapping2SUMO('08782490-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08782627-n',[ ('Island',instance)]).
nounMapping2SUMO('08782847-n',[ ('Island',instance)]).
nounMapping2SUMO('08782976-n',[ ('Island',instance)]).
nounMapping2SUMO('08783149-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08783286-n',[ ('Island',instance)]).
nounMapping2SUMO('08783444-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('08783583-n',[ ('Island',instance)]).
nounMapping2SUMO('08783812-n',[ ('Island',instance)]).
nounMapping2SUMO('08784104-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08784333-n',[ ('Island',instance)]).
nounMapping2SUMO('08784581-n',[ ('City',instance)]).
nounMapping2SUMO('08784746-n',[ ('Island',instance)]).
nounMapping2SUMO('08784905-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08785132-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08785343-n',[ ('City',instance)]).
nounMapping2SUMO('08785743-n',[ ('SubjectiveAssessmentAttribute',instance)]).
nounMapping2SUMO('08785958-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('08786161-n',[ ('City',instance)]).
nounMapping2SUMO('08786283-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08786432-n',[ ('City',instance)]).
nounMapping2SUMO('08786660-n',[ ('City',instance)]).
nounMapping2SUMO('08786855-n',[ ('City',instance)]).
nounMapping2SUMO('08787049-n',[ ('City',instance)]).
nounMapping2SUMO('08787240-n',[ ('City',instance)]).
nounMapping2SUMO('08787466-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08787695-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08787878-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08788004-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08788190-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08788326-n',[ ('City',instance)]).
nounMapping2SUMO('08788588-n',[ ('PortCity',instance)]).
nounMapping2SUMO('08788887-n',[ ('City',instance)]).
nounMapping2SUMO('08789076-n',[ ('City',instance)]).
nounMapping2SUMO('08789243-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08789447-n',[ ('Battle',instance)]).
nounMapping2SUMO('08789605-n',[ ('City',instance)]).
nounMapping2SUMO('08789835-n',[ ('City',instance)]).
nounMapping2SUMO('08789970-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08790199-n',[ ('Battle',instance)]).
nounMapping2SUMO('08790353-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08790495-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08790748-n',[ ('Island',instance)]).
nounMapping2SUMO('08790953-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08791167-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08791978-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08792083-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08792295-n',[ ('Nation',instance)]).
nounMapping2SUMO('08792548-n',[ ('Israel',equivalence)]).
nounMapping2SUMO('08793310-n',[ ('City',instance)]).
nounMapping2SUMO('08793489-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08793746-n',[ ('NablusWestBank',equivalence)]).
nounMapping2SUMO('08793914-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08794193-n',[ ('City',instance)]).
nounMapping2SUMO('08794366-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08794574-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08794798-n',[ ('City',instance)]).
nounMapping2SUMO('08795232-n',[ ('City',instance)]).
nounMapping2SUMO('08795492-n',[ ('StaticWaterArea',instance)]).
nounMapping2SUMO('08795654-n',[ ('City',instance)]).
nounMapping2SUMO('08795880-n',[ ('Region',subsumption)]).
nounMapping2SUMO('08795974-n',[ ('City',instance)]).
nounMapping2SUMO('08796219-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08796351-n',[ ('SubjectiveAssessmentAttribute',instance)]).
nounMapping2SUMO('08796707-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08796844-n',[ ('SubjectiveAssessmentAttribute',instance)]).
nounMapping2SUMO('08797013-n',[ ('SubjectiveAssessmentAttribute',instance)]).
nounMapping2SUMO('08797254-n',[ ('SubjectiveAssessmentAttribute',instance)]).
nounMapping2SUMO('08797412-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08797619-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('08797840-n',[ ('City',instance)]).
nounMapping2SUMO('08798062-n',[ ('HaifaIsrael',equivalence)]).
nounMapping2SUMO('08798195-n',[ ('JaffaIsrael',equivalence)]).
nounMapping2SUMO('08798382-n',[ ('Nation',instance)]).
nounMapping2SUMO('08798771-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08799123-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08799271-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08799462-n',[ ('SamariaWestBank',equivalence)]).
nounMapping2SUMO('08799706-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08799958-n',[ ('Nation',instance)]).
nounMapping2SUMO('08800258-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08800676-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08800911-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08801099-n',[ ('City',instance)]).
nounMapping2SUMO('08801364-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08801546-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08801678-n',[ ('Italy',equivalence)]).
nounMapping2SUMO('08803382-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('08803883-n',[ ('City',instance)]).
nounMapping2SUMO('08804049-n',[ ('City',instance)]).
nounMapping2SUMO('08804154-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08804319-n',[ ('City',instance)]).
nounMapping2SUMO('08804487-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08804662-n',[ ('City',instance)]).
nounMapping2SUMO('08804845-n',[ ('City',instance)]).
nounMapping2SUMO('08804962-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08805122-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08805386-n',[ ('City',instance)]).
nounMapping2SUMO('08805565-n',[ ('City',instance)]).
nounMapping2SUMO('08805801-n',[ ('City',instance)]).
nounMapping2SUMO('08805953-n',[ ('Island',instance)]).
nounMapping2SUMO('08806142-n',[ ('Island',instance)]).
nounMapping2SUMO('08806311-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08806458-n',[ ('BolognaItaly',equivalence)]).
nounMapping2SUMO('08806617-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08806735-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08806897-n',[ ('City',instance)]).
nounMapping2SUMO('08807554-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08807716-n',[ ('City',instance)]).
nounMapping2SUMO('08807894-n',[ ('City',instance)]).
nounMapping2SUMO('08808077-n',[ ('City',instance)]).
nounMapping2SUMO('08808292-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08808452-n',[ ('City',instance)]).
nounMapping2SUMO('08808614-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08808792-n',[ ('City',instance)]).
nounMapping2SUMO('08808979-n',[ ('PortCity',instance)]).
nounMapping2SUMO('08809165-n',[ ('MilanItaly',equivalence)]).
nounMapping2SUMO('08809384-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08809492-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08809596-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08809749-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08809910-n',[ ('City',instance)]).
nounMapping2SUMO('08810051-n',[ ('City',instance)]).
nounMapping2SUMO('08810220-n',[ ('City',instance)]).
nounMapping2SUMO('08810358-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08810505-n',[ ('City',instance)]).
nounMapping2SUMO('08810631-n',[ ('Island',instance)]).
nounMapping2SUMO('08810786-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08810999-n',[ ('Island',instance)]).
nounMapping2SUMO('08811215-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08811473-n',[ ('City',instance)]).
nounMapping2SUMO('08811653-n',[ ('Battle',instance)]).
nounMapping2SUMO('08811812-n',[ ('City',instance)]).
nounMapping2SUMO('08811982-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08812166-n',[ ('City',instance)]).
nounMapping2SUMO('08812399-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08812552-n',[ ('City',instance)]).
nounMapping2SUMO('08812732-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08812842-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08812952-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08813156-n',[ ('City',instance)]).
nounMapping2SUMO('08813264-n',[ ('PortCity',instance)]).
nounMapping2SUMO('08813586-n',[ ('Canal',instance)]).
nounMapping2SUMO('08813699-n',[ ('City',instance)]).
nounMapping2SUMO('08813807-n',[ ('Nation',instance)]).
nounMapping2SUMO('08813978-n',[ ('Romania',equivalence)]).
nounMapping2SUMO('08814333-n',[ ('City',instance)]).
nounMapping2SUMO('08814474-n',[ ('City',instance)]).
nounMapping2SUMO('08814664-n',[ ('City',instance)]).
nounMapping2SUMO('08814781-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08815046-n',[ ('Rwanda',equivalence)]).
nounMapping2SUMO('08815346-n',[ ('City',instance)]).
nounMapping2SUMO('08815513-n',[ ('Nation',instance)]).
nounMapping2SUMO('08815858-n',[ ('Croatia',equivalence)]).
nounMapping2SUMO('08816236-n',[ ('SerbiaAndMontenegro',equivalence)]).
nounMapping2SUMO('08816807-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08816969-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08817235-n',[ ('Nation',instance)]).
nounMapping2SUMO('08817418-n',[ ('City',instance)]).
nounMapping2SUMO('08817630-n',[ ('Nation',instance)]).
nounMapping2SUMO('08818135-n',[ ('BosniaAndHerzegovina',equivalence)]).
nounMapping2SUMO('08818247-n',[ ('SarajevoBosniaAndHerzegovina',equivalence)]).
nounMapping2SUMO('08818444-n',[ ('Slovenia',equivalence)]).
nounMapping2SUMO('08818736-n',[ ('City',instance)]).
nounMapping2SUMO('08818835-n',[ ('City',instance)]).
nounMapping2SUMO('08819016-n',[ ('City',instance)]).
nounMapping2SUMO('08819128-n',[ ('City',instance)]).
nounMapping2SUMO('08819223-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08819397-n',[ ('Island',instance)]).
nounMapping2SUMO('08819683-n',[ ('Island',instance)]).
nounMapping2SUMO('08819883-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08820121-n',[ ('Canada',equivalence)]).
nounMapping2SUMO('08821187-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08821319-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08821578-n',[ ('StateOrProvince',subsumption)]).
nounMapping2SUMO('08821885-n',[ ('StateOrProvince',subsumption)]).
nounMapping2SUMO('08822202-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08822427-n',[ ('City',instance)]).
nounMapping2SUMO('08822546-n',[ ('City',instance)]).
nounMapping2SUMO('08822742-n',[ ('City',instance)]).
nounMapping2SUMO('08822855-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08823156-n',[ ('City',instance)]).
nounMapping2SUMO('08823314-n',[ ('City',instance)]).
nounMapping2SUMO('08823480-n',[ ('City',instance)]).
nounMapping2SUMO('08823728-n',[ ('Island',instance)]).
nounMapping2SUMO('08823968-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08824152-n',[ ('City',instance)]).
nounMapping2SUMO('08824323-n',[ ('City',instance)]).
nounMapping2SUMO('08824484-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08824654-n',[ ('City',instance)]).
nounMapping2SUMO('08824771-n',[ ('City',instance)]).
nounMapping2SUMO('08824937-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08825211-n',[ ('Island',instance)]).
nounMapping2SUMO('08825321-n',[ ('City',instance)]).
nounMapping2SUMO('08825477-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08825664-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08825987-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08826150-n',[ ('City',instance)]).
nounMapping2SUMO('08826306-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08826699-n',[ ('Island',instance)]).
nounMapping2SUMO('08826841-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08827002-n',[ ('City',instance)]).
nounMapping2SUMO('08827126-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08827486-n',[ ('City',instance)]).
nounMapping2SUMO('08827689-n',[ ('City',instance)]).
nounMapping2SUMO('08827853-n',[ ('City',instance)]).
nounMapping2SUMO('08828013-n',[ ('City',instance)]).
nounMapping2SUMO('08828151-n',[ ('City',instance)]).
nounMapping2SUMO('08828296-n',[ ('PortCity',instance)]).
nounMapping2SUMO('08828432-n',[ ('City',instance)]).
nounMapping2SUMO('08828627-n',[ ('City',instance)]).
nounMapping2SUMO('08828750-n',[ ('Island',instance)]).
nounMapping2SUMO('08828928-n',[ ('City',instance)]).
nounMapping2SUMO('08829071-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08829317-n',[ ('City',instance)]).
nounMapping2SUMO('08829533-n',[ ('City',instance)]).
nounMapping2SUMO('08829775-n',[ ('StateOrProvince',subsumption)]).
nounMapping2SUMO('08830005-n',[ ('City',instance)]).
nounMapping2SUMO('08830116-n',[ ('City',instance)]).
nounMapping2SUMO('08830256-n',[ ('City',instance)]).
nounMapping2SUMO('08830456-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08830720-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08830882-n',[ ('City',instance)]).
nounMapping2SUMO('08831004-n',[ ('Australia',equivalence)]).
nounMapping2SUMO('08832269-n',[ ('City',instance)]).
nounMapping2SUMO('08832447-n',[ ('StateOrProvince',subsumption)]).
nounMapping2SUMO('08832691-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08832877-n',[ ('City',instance)]).
nounMapping2SUMO('08833130-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08833295-n',[ ('City',instance)]).
nounMapping2SUMO('08833524-n',[ ('City',instance)]).
nounMapping2SUMO('08833682-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08833809-n',[ ('City',instance)]).
nounMapping2SUMO('08833981-n',[ ('Island',instance)]).
nounMapping2SUMO('08834123-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08834280-n',[ ('City',instance)]).
nounMapping2SUMO('08834408-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08834543-n',[ ('City',instance)]).
nounMapping2SUMO('08834654-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08834806-n',[ ('City',instance)]).
nounMapping2SUMO('08834916-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08835058-n',[ ('City',instance)]).
nounMapping2SUMO('08835188-n',[ ('Island',instance)]).
nounMapping2SUMO('08835390-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08835675-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08835875-n',[ ('Oceania',equivalence)]).
nounMapping2SUMO('08836165-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08836329-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08836630-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08836886-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08837048-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08837457-n',[ ('City',instance)]).
nounMapping2SUMO('08837552-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08837864-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08838070-n',[ ('Island',instance)]).
nounMapping2SUMO('08838319-n',[ ('Guam',equivalence)]).
nounMapping2SUMO('08838556-n',[ ('Island',instance)]).
nounMapping2SUMO('08838716-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08838887-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08839092-n',[ ('MarshallIslands',equivalence)]).
nounMapping2SUMO('08839296-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('08839475-n',[ ('Island',instance)]).
nounMapping2SUMO('08839714-n',[ ('Island',instance)]).
nounMapping2SUMO('08839916-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08840200-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08840374-n',[ ('Island',instance)]).
nounMapping2SUMO('08840657-n',[ ('City',instance)]).
nounMapping2SUMO('08840749-n',[ ('Island',instance)]).
nounMapping2SUMO('08840964-n',[ ('City',instance)]).
nounMapping2SUMO('08841075-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08841209-n',[ ('Island',instance)]).
nounMapping2SUMO('08841483-n',[ ('Island',instance)]).
nounMapping2SUMO('08841667-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08841956-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08842258-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08842427-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08842583-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08842819-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08843085-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08843215-n',[ ('Island',instance)]).
nounMapping2SUMO('08843571-n',[ ('Island',instance)]).
nounMapping2SUMO('08843735-n',[ ('Island',instance)]).
nounMapping2SUMO('08843958-n',[ ('Island',instance)]).
nounMapping2SUMO('08844108-n',[ ('Island',instance)]).
nounMapping2SUMO('08844279-n',[ ('Island',instance)]).
nounMapping2SUMO('08844557-n',[ ('PapuaNewGuinea',equivalence)]).
nounMapping2SUMO('08844923-n',[ ('Island',instance)]).
nounMapping2SUMO('08845053-n',[ ('City',instance)]).
nounMapping2SUMO('08845225-n',[ ('Island',instance)]).
nounMapping2SUMO('08845366-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08845555-n',[ ('Austria',equivalence)]).
nounMapping2SUMO('08846135-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08846324-n',[ ('City',instance)]).
nounMapping2SUMO('08846626-n',[ ('GrazAustria',equivalence)]).
nounMapping2SUMO('08846739-n',[ ('City',instance)]).
nounMapping2SUMO('08846885-n',[ ('City',instance)]).
nounMapping2SUMO('08847024-n',[ ('City',instance)]).
nounMapping2SUMO('08847165-n',[ ('Battle',instance)]).
nounMapping2SUMO('08847268-n',[ ('Island',instance)]).
nounMapping2SUMO('08847570-n',[ ('City',instance)]).
nounMapping2SUMO('08847694-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08848094-n',[ ('Bahrain',equivalence)]).
nounMapping2SUMO('08848421-n',[ ('Island',instance)]).
nounMapping2SUMO('08848568-n',[ ('City',instance)]).
nounMapping2SUMO('08848731-n',[ ('Bangladesh',equivalence)]).
nounMapping2SUMO('08849226-n',[ ('City',instance)]).
nounMapping2SUMO('08849372-n',[ ('ChittagongBangladesh',equivalence)]).
nounMapping2SUMO('08849549-n',[ ('Nation',instance)]).
nounMapping2SUMO('08849753-n',[ ('Belgium',equivalence)]).
nounMapping2SUMO('08850450-n',[ ('City',instance)]).
nounMapping2SUMO('08850663-n',[ ('City',instance)]).
nounMapping2SUMO('08850741-n',[ ('AntwerpBelgium',equivalence)]).
nounMapping2SUMO('08851034-n',[ ('City',instance)]).
nounMapping2SUMO('08851364-n',[ ('City',instance)]).
nounMapping2SUMO('08851500-n',[ ('City',instance)]).
nounMapping2SUMO('08851687-n',[ ('City',instance)]).
nounMapping2SUMO('08851830-n',[ ('City',instance)]).
nounMapping2SUMO('08852065-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('08852209-n',[ ('Bhutan',equivalence)]).
nounMapping2SUMO('08852389-n',[ ('Botswana',equivalence)]).
nounMapping2SUMO('08852685-n',[ ('City',instance)]).
nounMapping2SUMO('08852843-n',[ ('Bolivia',equivalence)]).
nounMapping2SUMO('08853308-n',[ ('City',instance)]).
nounMapping2SUMO('08853510-n',[ ('City',instance)]).
nounMapping2SUMO('08853612-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08853741-n',[ ('Brazil',equivalence)]).
nounMapping2SUMO('08854725-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08854855-n',[ ('City',instance)]).
nounMapping2SUMO('08855126-n',[ ('City',instance)]).
nounMapping2SUMO('08855308-n',[ ('City',instance)]).
nounMapping2SUMO('08855505-n',[ ('City',instance)]).
nounMapping2SUMO('08855609-n',[ ('City',instance)]).
nounMapping2SUMO('08855763-n',[ ('City',instance)]).
nounMapping2SUMO('08855909-n',[ ('City',instance)]).
nounMapping2SUMO('08856037-n',[ ('City',instance)]).
nounMapping2SUMO('08856162-n',[ ('City',instance)]).
nounMapping2SUMO('08856266-n',[ ('City',instance)]).
nounMapping2SUMO('08856475-n',[ ('City',instance)]).
nounMapping2SUMO('08856630-n',[ ('City',instance)]).
nounMapping2SUMO('08856793-n',[ ('City',instance)]).
nounMapping2SUMO('08856945-n',[ ('City',instance)]).
nounMapping2SUMO('08857099-n',[ ('City',instance)]).
nounMapping2SUMO('08857260-n',[ ('City',instance)]).
nounMapping2SUMO('08857405-n',[ ('City',instance)]).
nounMapping2SUMO('08857529-n',[ ('City',instance)]).
nounMapping2SUMO('08857682-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08858248-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08858529-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08858713-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08858942-n',[ ('Island',instance)]).
nounMapping2SUMO('08859173-n',[ ('Island',instance)]).
nounMapping2SUMO('08860001-n',[ ('Island',instance)]).
nounMapping2SUMO('08860123-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08871007-n',[ ('UnitedKingdom',equivalence)]).
nounMapping2SUMO('08872936-n',[ ('UnitedKingdom',instance)]).
nounMapping2SUMO('08873067-n',[ ('UnitedKingdom',instance)]).
nounMapping2SUMO('08873147-n',[ ('Nation',instance)]).
nounMapping2SUMO('08873269-n',[ ('City',instance)]).
nounMapping2SUMO('08873412-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08873622-n',[ ('LondonUnitedKingdom',equivalence)]).
nounMapping2SUMO('08874273-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08874469-n',[ ('County',subsumption)]).
nounMapping2SUMO('08874703-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08874920-n',[ ('GeopoliticalArea',instance)]).
nounMapping2SUMO('08875057-n',[ ('GeopoliticalArea',instance)]).
nounMapping2SUMO('08875202-n',[ ('GeopoliticalArea',instance)]).
nounMapping2SUMO('08875369-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08875547-n',[ ('CityDistrict',instance)]).
nounMapping2SUMO('08875843-n',[ ('House',instance)]).
nounMapping2SUMO('08875972-n',[ ('Roadway',instance)]).
nounMapping2SUMO('08876139-n',[ ('Roadway',instance)]).
nounMapping2SUMO('08876278-n',[ ('Building',instance)]).
nounMapping2SUMO('08876435-n',[ ('Building',instance)]).
nounMapping2SUMO('08876773-n',[ ('City',instance)]).
nounMapping2SUMO('08876975-n',[ ('ManchesterUnitedKingdom',equivalence)]).
nounMapping2SUMO('08877208-n',[ ('City',instance)]).
nounMapping2SUMO('08877382-n',[ ('PortCity',instance)]).
nounMapping2SUMO('08877613-n',[ ('City',instance)]).
nounMapping2SUMO('08877807-n',[ ('City',subsumption)]).
nounMapping2SUMO('08878016-n',[ ('City',instance)]).
nounMapping2SUMO('08878202-n',[ ('City',instance)]).
nounMapping2SUMO('08878367-n',[ ('City',instance)]).
nounMapping2SUMO('08878533-n',[ ('City',instance)]).
nounMapping2SUMO('08878708-n',[ ('City',instance)]).
nounMapping2SUMO('08878885-n',[ ('City',instance)]).
nounMapping2SUMO('08879028-n',[ ('City',instance)]).
nounMapping2SUMO('08879197-n',[ ('City',instance)]).
nounMapping2SUMO('08879388-n',[ ('City',instance)]).
nounMapping2SUMO('08879680-n',[ ('PortCity',instance)]).
nounMapping2SUMO('08879867-n',[ ('City',instance)]).
nounMapping2SUMO('08880083-n',[ ('City',instance)]).
nounMapping2SUMO('08880223-n',[ ('City',instance)]).
nounMapping2SUMO('08880375-n',[ ('City',instance)]).
nounMapping2SUMO('08880529-n',[ ('City',instance)]).
nounMapping2SUMO('08880713-n',[ ('City',instance)]).
nounMapping2SUMO('08880859-n',[ ('City',instance)]).
nounMapping2SUMO('08881017-n',[ ('City',instance)]).
nounMapping2SUMO('08881153-n',[ ('County',instance)]).
nounMapping2SUMO('08881256-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08881398-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08881549-n',[ ('County',instance)]).
nounMapping2SUMO('08881674-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08881944-n',[ ('County',instance)]).
nounMapping2SUMO('08882061-n',[ ('County',instance)]).
nounMapping2SUMO('08882224-n',[ ('County',instance)]).
nounMapping2SUMO('08882365-n',[ ('County',instance)]).
nounMapping2SUMO('08882530-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08882807-n',[ ('County',instance)]).
nounMapping2SUMO('08882934-n',[ ('County',instance)]).
nounMapping2SUMO('08883179-n',[ ('County',instance)]).
nounMapping2SUMO('08883309-n',[ ('County',instance)]).
nounMapping2SUMO('08883476-n',[ ('City',instance)]).
nounMapping2SUMO('08883643-n',[ ('County',instance)]).
nounMapping2SUMO('08883772-n',[ ('City',instance)]).
nounMapping2SUMO('08884012-n',[ ('County',instance)]).
nounMapping2SUMO('08884191-n',[ ('County',instance)]).
nounMapping2SUMO('08884328-n',[ ('County',instance)]).
nounMapping2SUMO('08884513-n',[ ('Battle',instance)]).
nounMapping2SUMO('08884673-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08884806-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08884961-n',[ ('County',instance)]).
nounMapping2SUMO('08885099-n',[ ('Battle',instance)]).
nounMapping2SUMO('08885211-n',[ ('County',instance)]).
nounMapping2SUMO('08885380-n',[ ('County',instance)]).
nounMapping2SUMO('08885490-n',[ ('County',instance)]).
nounMapping2SUMO('08885631-n',[ ('County',instance)]).
nounMapping2SUMO('08885773-n',[ ('County',instance)]).
nounMapping2SUMO('08885921-n',[ ('City',instance)]).
nounMapping2SUMO('08886037-n',[ ('Battle',instance)]).
nounMapping2SUMO('08886147-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08886277-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08886432-n',[ ('County',instance)]).
nounMapping2SUMO('08886636-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08886814-n',[ ('Wall',instance)]).
nounMapping2SUMO('08887013-n',[ ('Island',instance)]).
nounMapping2SUMO('08887238-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('08887344-n',[ ('HoofedMammal',subsumption)]).
nounMapping2SUMO('08887463-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08887716-n',[ ('Island',instance)]).
nounMapping2SUMO('08887841-n',[ ('Nation',instance)]).
nounMapping2SUMO('08888181-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08888367-n',[ ('City',instance)]).
nounMapping2SUMO('08888479-n',[ ('City',instance)]).
nounMapping2SUMO('08888676-n',[ ('Ireland',equivalence)]).
nounMapping2SUMO('08889191-n',[ ('City',instance)]).
nounMapping2SUMO('08889400-n',[ ('City',instance)]).
nounMapping2SUMO('08889521-n',[ ('City',instance)]).
nounMapping2SUMO('08889657-n',[ ('City',instance)]).
nounMapping2SUMO('08889784-n',[ ('City',instance)]).
nounMapping2SUMO('08889944-n',[ ('City',instance)]).
nounMapping2SUMO('08890097-n',[ ('Nation',instance)]).
nounMapping2SUMO('08891415-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08891595-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08891889-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08892058-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08892186-n',[ ('City',instance)]).
nounMapping2SUMO('08892327-n',[ ('City',instance)]).
nounMapping2SUMO('08892428-n',[ ('Building',instance)]).
nounMapping2SUMO('08892596-n',[ ('City',instance)]).
nounMapping2SUMO('08892766-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08892971-n',[ ('City',instance)]).
nounMapping2SUMO('08893223-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08893492-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08893717-n',[ ('Island',instance)]).
nounMapping2SUMO('08893868-n',[ ('Island',instance)]).
nounMapping2SUMO('08894011-n',[ ('Island',instance)]).
nounMapping2SUMO('08894133-n',[ ('Island',instance)]).
nounMapping2SUMO('08894319-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08894456-n',[ ('Nation',instance)]).
nounMapping2SUMO('08895148-n',[ ('City',instance)]).
nounMapping2SUMO('08895254-n',[ ('City',instance)]).
nounMapping2SUMO('08895386-n',[ ('City',instance)]).
nounMapping2SUMO('08895497-n',[ ('City',instance)]).
nounMapping2SUMO('08895623-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('08895771-n',[ ('City',instance)]).
nounMapping2SUMO('08895928-n',[ ('Island',instance)]).
nounMapping2SUMO('08896092-n',[ ('Brunei',equivalence)]).
nounMapping2SUMO('08896327-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08896440-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08896645-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08896831-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08897065-n',[ ('Egypt',equivalence)]).
nounMapping2SUMO('08897843-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08898002-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08898187-n',[ ('City',instance)]).
nounMapping2SUMO('08898457-n',[ ('City',instance)]).
nounMapping2SUMO('08898633-n',[ ('PortCity',instance)]).
nounMapping2SUMO('08898941-n',[ ('City',instance)]).
nounMapping2SUMO('08899149-n',[ ('City',instance)]).
nounMapping2SUMO('08899351-n',[ ('City',instance)]).
nounMapping2SUMO('08899478-n',[ ('City',instance)]).
nounMapping2SUMO('08899577-n',[ ('City',instance)]).
nounMapping2SUMO('08899776-n',[ ('City',instance)]).
nounMapping2SUMO('08900047-n',[ ('City',instance)]).
nounMapping2SUMO('08900204-n',[ ('City',instance)]).
nounMapping2SUMO('08900377-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('08900535-n',[ ('India',equivalence)]).
nounMapping2SUMO('08902097-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08902196-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08902321-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08902422-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08902569-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08902753-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08902894-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08903049-n',[ ('City',instance)]).
nounMapping2SUMO('08903220-n',[ ('City',instance)]).
nounMapping2SUMO('08903352-n',[ ('City',instance)]).
nounMapping2SUMO('08903487-n',[ ('City',instance)]).
nounMapping2SUMO('08903636-n',[ ('CalcuttaIndia',equivalence)]).
nounMapping2SUMO('08903872-n',[ ('City',instance)]).
nounMapping2SUMO('08904115-n',[ ('City',instance)]).
nounMapping2SUMO('08904269-n',[ ('HyderabadIndia',equivalence)]).
nounMapping2SUMO('08904392-n',[ ('City',instance)]).
nounMapping2SUMO('08904533-n',[ ('City',instance)]).
nounMapping2SUMO('08904731-n',[ ('City',instance)]).
nounMapping2SUMO('08904858-n',[ ('City',instance)]).
nounMapping2SUMO('08904954-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08905085-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08905186-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08905313-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08905467-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08905646-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08905751-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08905936-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08906053-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08906169-n',[ ('SubjectiveAssessmentAttribute',instance)]).
nounMapping2SUMO('08906272-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08906374-n',[ ('Nepal',equivalence)]).
nounMapping2SUMO('08906809-n',[ ('City',instance)]).
nounMapping2SUMO('08906952-n',[ ('Nation',instance)]).
nounMapping2SUMO('08907377-n',[ ('City',instance)]).
nounMapping2SUMO('08907606-n',[ ('Indonesia',equivalence)]).
nounMapping2SUMO('08908248-n',[ ('Island',instance)]).
nounMapping2SUMO('08908509-n',[ ('Island',instance)]).
nounMapping2SUMO('08908739-n',[ ('Island',instance)]).
nounMapping2SUMO('08908954-n',[ ('Island',instance)]).
nounMapping2SUMO('08909107-n',[ ('Island',instance)]).
nounMapping2SUMO('08909233-n',[ ('Island',instance)]).
nounMapping2SUMO('08909537-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08909719-n',[ ('City',instance)]).
nounMapping2SUMO('08909933-n',[ ('City',instance)]).
nounMapping2SUMO('08910106-n',[ ('MedanIndonesia',equivalence)]).
nounMapping2SUMO('08910230-n',[ ('City',instance)]).
nounMapping2SUMO('08910394-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('08910668-n',[ ('Iran',equivalence)]).
nounMapping2SUMO('08911421-n',[ ('City',instance)]).
nounMapping2SUMO('08911602-n',[ ('City',instance)]).
nounMapping2SUMO('08911726-n',[ ('City',instance)]).
nounMapping2SUMO('08911868-n',[ ('City',instance)]).
nounMapping2SUMO('08912012-n',[ ('City',instance)]).
nounMapping2SUMO('08912153-n',[ ('City',instance)]).
nounMapping2SUMO('08912279-n',[ ('City',instance)]).
nounMapping2SUMO('08912427-n',[ ('City',instance)]).
nounMapping2SUMO('08912559-n',[ ('City',instance)]).
nounMapping2SUMO('08912703-n',[ ('City',instance)]).
nounMapping2SUMO('08912842-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08913085-n',[ ('City',instance)]).
nounMapping2SUMO('08913242-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08913434-n',[ ('Iraq',equivalence)]).
nounMapping2SUMO('08914193-n',[ ('City',instance)]).
nounMapping2SUMO('08914413-n',[ ('City',instance)]).
nounMapping2SUMO('08914573-n',[ ('City',instance)]).
nounMapping2SUMO('08914850-n',[ ('City',instance)]).
nounMapping2SUMO('08915017-n',[ ('City',instance)]).
nounMapping2SUMO('08915159-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08915372-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08915660-n',[ ('City',instance)]).
nounMapping2SUMO('08915784-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08916111-n',[ ('City',instance)]).
nounMapping2SUMO('08916316-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08916832-n',[ ('City',instance)]).
nounMapping2SUMO('08917503-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08917881-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08918248-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08918800-n',[ ('City',instance)]).
nounMapping2SUMO('08918944-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08919241-n',[ ('City',instance)]).
nounMapping2SUMO('08919475-n',[ ('City',instance)]).
nounMapping2SUMO('08919693-n',[ ('Nation',instance)]).
nounMapping2SUMO('08919949-n',[ ('City',instance)]).
nounMapping2SUMO('08920207-n',[ ('City',instance)]).
nounMapping2SUMO('08920381-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08920722-n',[ ('Island',instance)]).
nounMapping2SUMO('08920924-n',[ ('Island',instance)]).
nounMapping2SUMO('08921392-n',[ ('Island',instance)]).
nounMapping2SUMO('08921613-n',[ ('Island',instance)]).
nounMapping2SUMO('08921850-n',[ ('Japan',equivalence)]).
nounMapping2SUMO('08923177-n',[ ('City',instance)]).
nounMapping2SUMO('08923348-n',[ ('City',instance)]).
nounMapping2SUMO('08923586-n',[ ('City',instance)]).
nounMapping2SUMO('08923755-n',[ ('City',instance)]).
nounMapping2SUMO('08923884-n',[ ('City',instance)]).
nounMapping2SUMO('08924023-n',[ ('OsakaJapan',equivalence)]).
nounMapping2SUMO('08924238-n',[ ('City',instance)]).
nounMapping2SUMO('08924400-n',[ ('Island',instance)]).
nounMapping2SUMO('08924560-n',[ ('City',instance)]).
nounMapping2SUMO('08924691-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08924913-n',[ ('City',instance)]).
nounMapping2SUMO('08925093-n',[ ('City',instance)]).
nounMapping2SUMO('08925287-n',[ ('City',instance)]).
nounMapping2SUMO('08925552-n',[ ('City',instance)]).
nounMapping2SUMO('08925700-n',[ ('City',instance)]).
nounMapping2SUMO('08925830-n',[ ('City',instance)]).
nounMapping2SUMO('08925957-n',[ ('City',instance)]).
nounMapping2SUMO('08926231-n',[ ('City',instance)]).
nounMapping2SUMO('08926381-n',[ ('City',instance)]).
nounMapping2SUMO('08926543-n',[ ('City',instance)]).
nounMapping2SUMO('08926681-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08926877-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08927068-n',[ ('Island',instance)]).
nounMapping2SUMO('08927186-n',[ ('Jordan',equivalence)]).
nounMapping2SUMO('08927548-n',[ ('City',instance)]).
nounMapping2SUMO('08927678-n',[ ('City',instance)]).
nounMapping2SUMO('08927836-n',[ ('City',instance)]).
nounMapping2SUMO('08928083-n',[ ('City',instance)]).
nounMapping2SUMO('08928193-n',[ ('Kenya',equivalence)]).
nounMapping2SUMO('08928582-n',[ ('City',instance)]).
nounMapping2SUMO('08928742-n',[ ('City',instance)]).
nounMapping2SUMO('08928933-n',[ ('MombassaKenya',equivalence)]).
nounMapping2SUMO('08929102-n',[ ('City',instance)]).
nounMapping2SUMO('08929243-n',[ ('Kuwait',equivalence)]).
nounMapping2SUMO('08929555-n',[ ('City',instance)]).
nounMapping2SUMO('08929722-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08929922-n',[ ('France',equivalence)]).
nounMapping2SUMO('08932568-n',[ ('ParisFrance',equivalence)]).
nounMapping2SUMO('08933084-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08933287-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08933437-n',[ ('City',instance)]).
nounMapping2SUMO('08933621-n',[ ('City',instance)]).
nounMapping2SUMO('08933770-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08933940-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08934067-n',[ ('Island',instance)]).
nounMapping2SUMO('08934174-n',[ ('Roadway',instance)]).
nounMapping2SUMO('08934313-n',[ ('City',instance)]).
nounMapping2SUMO('08934532-n',[ ('PortCity',instance)]).
nounMapping2SUMO('08934694-n',[ ('City',instance)]).
nounMapping2SUMO('08934868-n',[ ('City',instance)]).
nounMapping2SUMO('08935212-n',[ ('City',instance)]).
nounMapping2SUMO('08935381-n',[ ('City',instance)]).
nounMapping2SUMO('08935516-n',[ ('City',instance)]).
nounMapping2SUMO('08935674-n',[ ('PortCity',instance)]).
nounMapping2SUMO('08935848-n',[ ('City',instance)]).
nounMapping2SUMO('08935978-n',[ ('Battle',instance)]).
nounMapping2SUMO('08936180-n',[ ('City',instance)]).
nounMapping2SUMO('08936303-n',[ ('PortCity',instance)]).
nounMapping2SUMO('08936476-n',[ ('City',instance)]).
nounMapping2SUMO('08936647-n',[ ('LyonsFrance',equivalence)]).
nounMapping2SUMO('08936833-n',[ ('MarseillesFrance',equivalence)]).
nounMapping2SUMO('08936996-n',[ ('City',instance)]).
nounMapping2SUMO('08937109-n',[ ('PortCity',instance)]).
nounMapping2SUMO('08937251-n',[ ('City',instance)]).
nounMapping2SUMO('08937414-n',[ ('City',instance)]).
nounMapping2SUMO('08937594-n',[ ('City',instance)]).
nounMapping2SUMO('08937850-n',[ ('StrasbourgFrance',equivalence)]).
nounMapping2SUMO('08937995-n',[ ('City',instance)]).
nounMapping2SUMO('08938163-n',[ ('City',instance)]).
nounMapping2SUMO('08938351-n',[ ('City',instance)]).
nounMapping2SUMO('08938478-n',[ ('City',instance)]).
nounMapping2SUMO('08938619-n',[ ('City',instance)]).
nounMapping2SUMO('08938819-n',[ ('City',instance)]).
nounMapping2SUMO('08939028-n',[ ('City',instance)]).
nounMapping2SUMO('08939201-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08939437-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08939562-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08940209-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08940371-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08940517-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08940670-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08940835-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08940936-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08941057-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08941208-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08941426-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08941535-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08941681-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08941895-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08942091-n',[ ('Island',instance)]).
nounMapping2SUMO('08942277-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08942392-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08942508-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08942629-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08942780-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08942965-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08943104-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08943242-n',[ ('Island',instance)]).
nounMapping2SUMO('08943461-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08943601-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08943699-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08943810-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08943926-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08944089-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08944224-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08944378-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08944561-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08944818-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08944960-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08945110-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08945277-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('08945529-n',[ ('Gabon',equivalence)]).
nounMapping2SUMO('08945705-n',[ ('City',instance)]).
nounMapping2SUMO('08945821-n',[ ('Gambia',equivalence)]).
nounMapping2SUMO('08946042-n',[ ('City',instance)]).
nounMapping2SUMO('08946187-n',[ ('Ghana',equivalence)]).
nounMapping2SUMO('08946564-n',[ ('City',instance)]).
nounMapping2SUMO('08946715-n',[ ('City',instance)]).
nounMapping2SUMO('08946812-n',[ ('Food',subsumption)]).
nounMapping2SUMO('08946909-n',[ ('Island',instance)]).
nounMapping2SUMO('08947180-n',[ ('City',instance)]).
nounMapping2SUMO('08947319-n',[ ('Guinea',equivalence)]).
nounMapping2SUMO('08947617-n',[ ('City',instance)]).
nounMapping2SUMO('08947772-n',[ ('GuineaBissau',equivalence)]).
nounMapping2SUMO('08948027-n',[ ('City',instance)]).
nounMapping2SUMO('08948155-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08948346-n',[ ('Guyana',equivalence)]).
nounMapping2SUMO('08948704-n',[ ('City',instance)]).
nounMapping2SUMO('08948958-n',[ ('Group',instance)]).
nounMapping2SUMO('08949093-n',[ ('Netherlands',equivalence)]).
nounMapping2SUMO('08949737-n',[ ('City',instance)]).
nounMapping2SUMO('08950035-n',[ ('City',instance)]).
nounMapping2SUMO('08950230-n',[ ('City',instance)]).
nounMapping2SUMO('08950407-n',[ ('City',instance)]).
nounMapping2SUMO('08950649-n',[ ('City',instance)]).
nounMapping2SUMO('08950787-n',[ ('City',instance)]).
nounMapping2SUMO('08950907-n',[ ('City',instance)]).
nounMapping2SUMO('08951077-n',[ ('City',instance)]).
nounMapping2SUMO('08951278-n',[ ('City',instance)]).
nounMapping2SUMO('08951385-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08951513-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08951777-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08951957-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08952190-n',[ ('Hungary',equivalence)]).
nounMapping2SUMO('08952423-n',[ ('City',instance)]).
nounMapping2SUMO('08952628-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08952856-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08953029-n',[ ('City',instance)]).
nounMapping2SUMO('08953151-n',[ ('Island',instance)]).
nounMapping2SUMO('08953324-n',[ ('Iceland',equivalence)]).
nounMapping2SUMO('08953596-n',[ ('City',instance)]).
nounMapping2SUMO('08953829-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08954057-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08954269-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08954443-n',[ ('City',instance)]).
nounMapping2SUMO('08954611-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08954975-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('08955082-n',[ ('NorthKorea',equivalence)]).
nounMapping2SUMO('08955397-n',[ ('City',instance)]).
nounMapping2SUMO('08955626-n',[ ('SouthKorea',equivalence)]).
nounMapping2SUMO('08955951-n',[ ('City',instance)]).
nounMapping2SUMO('08956140-n',[ ('City',instance)]).
nounMapping2SUMO('08956305-n',[ ('City',instance)]).
nounMapping2SUMO('08956461-n',[ ('City',instance)]).
nounMapping2SUMO('08956574-n',[ ('City',instance)]).
nounMapping2SUMO('08956760-n',[ ('Laos',equivalence)]).
nounMapping2SUMO('08957064-n',[ ('City',instance)]).
nounMapping2SUMO('08957212-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08957381-n',[ ('Lebanon',equivalence)]).
nounMapping2SUMO('08957806-n',[ ('City',instance)]).
nounMapping2SUMO('08957993-n',[ ('City',instance)]).
nounMapping2SUMO('08958212-n',[ ('City',instance)]).
nounMapping2SUMO('08958334-n',[ ('PortCity',instance)]).
nounMapping2SUMO('08958535-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08958830-n',[ ('Lesotho',equivalence)]).
nounMapping2SUMO('08959105-n',[ ('City',instance)]).
nounMapping2SUMO('08959254-n',[ ('Liberia',equivalence)]).
nounMapping2SUMO('08959495-n',[ ('City',instance)]).
nounMapping2SUMO('08959683-n',[ ('Libya',equivalence)]).
nounMapping2SUMO('08960099-n',[ ('City',instance)]).
nounMapping2SUMO('08960363-n',[ ('City',instance)]).
nounMapping2SUMO('08960548-n',[ ('Liechtenstein',equivalence)]).
nounMapping2SUMO('08960843-n',[ ('City',instance)]).
nounMapping2SUMO('08960987-n',[ ('Luxembourg',equivalence)]).
nounMapping2SUMO('08961402-n',[ ('City',instance)]).
nounMapping2SUMO('08961630-n',[ ('Macedonia',equivalence)]).
nounMapping2SUMO('08961852-n',[ ('City',instance)]).
nounMapping2SUMO('08961970-n',[ ('Island',instance)]).
nounMapping2SUMO('08962187-n',[ ('Madagascar',equivalence)]).
nounMapping2SUMO('08962465-n',[ ('City',instance)]).
nounMapping2SUMO('08962610-n',[ ('Malawi',equivalence)]).
nounMapping2SUMO('08962951-n',[ ('City',instance)]).
nounMapping2SUMO('08963095-n',[ ('City',instance)]).
nounMapping2SUMO('08963244-n',[ ('City',instance)]).
nounMapping2SUMO('08963369-n',[ ('Malaysia',equivalence)]).
nounMapping2SUMO('08963813-n',[ ('City',instance)]).
nounMapping2SUMO('08963969-n',[ ('City',instance)]).
nounMapping2SUMO('08964099-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08964288-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08964474-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08964647-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08964810-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08965055-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08965251-n',[ ('Maldives',equivalence)]).
nounMapping2SUMO('08965475-n',[ ('City',instance)]).
nounMapping2SUMO('08965598-n',[ ('Mali',equivalence)]).
nounMapping2SUMO('08965958-n',[ ('City',instance)]).
nounMapping2SUMO('08966085-n',[ ('City',instance)]).
nounMapping2SUMO('08966239-n',[ ('Island',instance)]).
nounMapping2SUMO('08966408-n',[ ('Malta',equivalence)]).
nounMapping2SUMO('08966647-n',[ ('City',instance)]).
nounMapping2SUMO('08966820-n',[ ('Mauritania',equivalence)]).
nounMapping2SUMO('08967176-n',[ ('City',instance)]).
nounMapping2SUMO('08967329-n',[ ('Island',instance)]).
nounMapping2SUMO('08967484-n',[ ('Mauritius',equivalence)]).
nounMapping2SUMO('08967688-n',[ ('City',instance)]).
nounMapping2SUMO('08967868-n',[ ('Monaco',equivalence)]).
nounMapping2SUMO('08968125-n',[ ('City',instance)]).
nounMapping2SUMO('08968225-n',[ ('City',instance)]).
nounMapping2SUMO('08968390-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08968677-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08968879-n',[ ('Mongolia',equivalence)]).
nounMapping2SUMO('08969123-n',[ ('City',instance)]).
nounMapping2SUMO('08969291-n',[ ('Morocco',equivalence)]).
nounMapping2SUMO('08969798-n',[ ('City',instance)]).
nounMapping2SUMO('08969948-n',[ ('City',instance)]).
nounMapping2SUMO('08970064-n',[ ('City',instance)]).
nounMapping2SUMO('08970189-n',[ ('City',instance)]).
nounMapping2SUMO('08970318-n',[ ('City',instance)]).
nounMapping2SUMO('08970445-n',[ ('City',instance)]).
nounMapping2SUMO('08970611-n',[ ('City',instance)]).
nounMapping2SUMO('08970833-n',[ ('WesternSahara',equivalence)]).
nounMapping2SUMO('08971025-n',[ ('Mozambique',equivalence)]).
nounMapping2SUMO('08971404-n',[ ('City',instance)]).
nounMapping2SUMO('08971554-n',[ ('City',instance)]).
nounMapping2SUMO('08971693-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08971914-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08972148-n',[ ('Island',instance)]).
nounMapping2SUMO('08972335-n',[ ('Island',instance)]).
nounMapping2SUMO('08972521-n',[ ('NewZealand',equivalence)]).
nounMapping2SUMO('08972920-n',[ ('City',instance)]).
nounMapping2SUMO('08973064-n',[ ('City',instance)]).
nounMapping2SUMO('08973202-n',[ ('City',instance)]).
nounMapping2SUMO('08973330-n',[ ('Niger',equivalence)]).
nounMapping2SUMO('08973647-n',[ ('City',instance)]).
nounMapping2SUMO('08973776-n',[ ('Nigeria',equivalence)]).
nounMapping2SUMO('08974171-n',[ ('City',instance)]).
nounMapping2SUMO('08974330-n',[ ('City',instance)]).
nounMapping2SUMO('08974468-n',[ ('City',instance)]).
nounMapping2SUMO('08974604-n',[ ('City',instance)]).
nounMapping2SUMO('08974818-n',[ ('City',instance)]).
nounMapping2SUMO('08974974-n',[ ('City',instance)]).
nounMapping2SUMO('08975106-n',[ ('Oman',equivalence)]).
nounMapping2SUMO('08975435-n',[ ('City',instance)]).
nounMapping2SUMO('08975617-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08975902-n',[ ('Pakistan',equivalence)]).
nounMapping2SUMO('08976799-n',[ ('City',instance)]).
nounMapping2SUMO('08976913-n',[ ('City',instance)]).
nounMapping2SUMO('08977035-n',[ ('City',instance)]).
nounMapping2SUMO('08977211-n',[ ('KarachiPakistan',equivalence)]).
nounMapping2SUMO('08977428-n',[ ('LahorePakistan',equivalence)]).
nounMapping2SUMO('08977527-n',[ ('PeshawarPakistan',equivalence)]).
nounMapping2SUMO('08977665-n',[ ('RawalpindiPakistan',equivalence)]).
nounMapping2SUMO('08977845-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08977948-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08978161-n',[ ('Palau',equivalence)]).
nounMapping2SUMO('08978343-n',[ ('Paraguay',equivalence)]).
nounMapping2SUMO('08978667-n',[ ('City',instance)]).
nounMapping2SUMO('08978821-n',[ ('Nation',instance)]).
nounMapping2SUMO('08979054-n',[ ('Peru',equivalence)]).
nounMapping2SUMO('08979590-n',[ ('City',instance)]).
nounMapping2SUMO('08979740-n',[ ('City',instance)]).
nounMapping2SUMO('08979878-n',[ ('City',instance)]).
nounMapping2SUMO('08980119-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('08980300-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08980640-n',[ ('Island',instance)]).
nounMapping2SUMO('08980814-n',[ ('Island',instance)]).
nounMapping2SUMO('08980920-n',[ ('Island',instance)]).
nounMapping2SUMO('08981123-n',[ ('Island',instance)]).
nounMapping2SUMO('08981244-n',[ ('Philippines',equivalence)]).
nounMapping2SUMO('08981746-n',[ ('City',instance)]).
nounMapping2SUMO('08981922-n',[ ('City',instance)]).
nounMapping2SUMO('08982037-n',[ ('City',instance)]).
nounMapping2SUMO('08982181-n',[ ('City',instance)]).
nounMapping2SUMO('08982289-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08982452-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08982587-n',[ ('Poland',equivalence)]).
nounMapping2SUMO('08983105-n',[ ('City',instance)]).
nounMapping2SUMO('08983274-n',[ ('City',instance)]).
nounMapping2SUMO('08983413-n',[ ('City',instance)]).
nounMapping2SUMO('08983556-n',[ ('City',instance)]).
nounMapping2SUMO('08983742-n',[ ('City',instance)]).
nounMapping2SUMO('08984010-n',[ ('City',instance)]).
nounMapping2SUMO('08984122-n',[ ('City',instance)]).
nounMapping2SUMO('08984223-n',[ ('City',instance)]).
nounMapping2SUMO('08984332-n',[ ('City',instance)]).
nounMapping2SUMO('08984457-n',[ ('City',instance)]).
nounMapping2SUMO('08984567-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08984788-n',[ ('Portugal',equivalence)]).
nounMapping2SUMO('08985345-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08985559-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('08985724-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08985958-n',[ ('City',instance)]).
nounMapping2SUMO('08986066-n',[ ('City',instance)]).
nounMapping2SUMO('08986374-n',[ ('City',instance)]).
nounMapping2SUMO('08986526-n',[ ('City',instance)]).
nounMapping2SUMO('08986691-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08986905-n',[ ('Qatar',equivalence)]).
nounMapping2SUMO('08987262-n',[ ('City',instance)]).
nounMapping2SUMO('08987423-n',[ ('SaintKittsAndNevis',equivalence)]).
nounMapping2SUMO('08987879-n',[ ('Island',instance)]).
nounMapping2SUMO('08988068-n',[ ('City',instance)]).
nounMapping2SUMO('08988216-n',[ ('Island',instance)]).
nounMapping2SUMO('08988333-n',[ ('Island',instance)]).
nounMapping2SUMO('08988453-n',[ ('Island',instance)]).
nounMapping2SUMO('08988609-n',[ ('SaintLucia',equivalence)]).
nounMapping2SUMO('08988861-n',[ ('City',instance)]).
nounMapping2SUMO('08989031-n',[ ('SaintVincentAndTheGrenadines',equivalence)]).
nounMapping2SUMO('08989324-n',[ ('Island',instance)]).
nounMapping2SUMO('08989556-n',[ ('City',instance)]).
nounMapping2SUMO('08989697-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08989941-n',[ ('Island',instance)]).
nounMapping2SUMO('08990203-n',[ ('City',instance)]).
nounMapping2SUMO('08990344-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08990522-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08990701-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08990844-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08990999-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08991182-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08991491-n',[ ('Samoa',equivalence)]).
nounMapping2SUMO('08991752-n',[ ('City',instance)]).
nounMapping2SUMO('08991878-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08992067-n',[ ('City',instance)]).
nounMapping2SUMO('08992181-n',[ ('SanMarino',equivalence)]).
nounMapping2SUMO('08992508-n',[ ('City',instance)]).
nounMapping2SUMO('08992648-n',[ ('SaoTomeAndPrincipe',equivalence)]).
nounMapping2SUMO('08993037-n',[ ('City',instance)]).
nounMapping2SUMO('08993144-n',[ ('Island',instance)]).
nounMapping2SUMO('08993288-n',[ ('SaudiArabia',equivalence)]).
nounMapping2SUMO('08993871-n',[ ('City',instance)]).
nounMapping2SUMO('08994090-n',[ ('City',instance)]).
nounMapping2SUMO('08994339-n',[ ('City',instance)]).
nounMapping2SUMO('08994540-n',[ ('City',instance)]).
nounMapping2SUMO('08994834-n',[ ('City',instance)]).
nounMapping2SUMO('08995013-n',[ ('City',instance)]).
nounMapping2SUMO('08995120-n',[ ('City',instance)]).
nounMapping2SUMO('08995242-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08995515-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('08995862-n',[ ('Senegal',equivalence)]).
nounMapping2SUMO('08996118-n',[ ('City',instance)]).
nounMapping2SUMO('08996284-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08996483-n',[ ('Seychelles',equivalence)]).
nounMapping2SUMO('08996714-n',[ ('City',instance)]).
nounMapping2SUMO('08996871-n',[ ('SierraLeone',equivalence)]).
nounMapping2SUMO('08997132-n',[ ('City',instance)]).
nounMapping2SUMO('08997310-n',[ ('Island',instance)]).
nounMapping2SUMO('08997487-n',[ ('Singapore',equivalence)]).
nounMapping2SUMO('08997801-n',[ ('City',instance)]).
nounMapping2SUMO('08997976-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08998233-n',[ ('SolomonIslands',equivalence)]).
nounMapping2SUMO('08998451-n',[ ('City',instance)]).
nounMapping2SUMO('08998560-n',[ ('Somalia',equivalence)]).
nounMapping2SUMO('08998853-n',[ ('City',instance)]).
nounMapping2SUMO('08999049-n',[ ('City',instance)]).
nounMapping2SUMO('08999154-n',[ ('LandArea',instance)]).
nounMapping2SUMO('08999482-n',[ ('SouthAfrica',equivalence)]).
nounMapping2SUMO('09000272-n',[ ('City',instance)]).
nounMapping2SUMO('09000462-n',[ ('CapeTownSouthAfrica',equivalence)]).
nounMapping2SUMO('09000665-n',[ ('JohannesburgSouthAfrica',equivalence)]).
nounMapping2SUMO('09000854-n',[ ('City',instance)]).
nounMapping2SUMO('09001007-n',[ ('City',instance)]).
nounMapping2SUMO('09001184-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('09001373-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09001580-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('09001881-n',[ ('Region',instance)]).
nounMapping2SUMO('09002096-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('09002195-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09002325-n',[ ('City',instance)]).
nounMapping2SUMO('09002433-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09002630-n',[ ('Nation',instance)]).
nounMapping2SUMO('09002814-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09003284-n',[ ('Nation',instance)]).
nounMapping2SUMO('09003918-n',[ ('Nation',instance)]).
nounMapping2SUMO('09004068-n',[ ('City',instance)]).
nounMapping2SUMO('09004358-n',[ ('City',instance)]).
nounMapping2SUMO('09004495-n',[ ('City',instance)]).
nounMapping2SUMO('09004625-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09004992-n',[ ('GroznyChechnya',equivalence)]).
nounMapping2SUMO('09005153-n',[ ('City',instance)]).
nounMapping2SUMO('09005273-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09005457-n',[ ('City',instance)]).
nounMapping2SUMO('09005611-n',[ ('City',instance)]).
nounMapping2SUMO('09005712-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09006205-n',[ ('StateOrProvince',subsumption)]).
nounMapping2SUMO('09006413-n',[ ('Russia',equivalence)]).
nounMapping2SUMO('09007471-n',[ ('Nation',instance)]).
nounMapping2SUMO('09007613-n',[ ('Nation',instance)]).
nounMapping2SUMO('09007723-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('09008130-n',[ ('City',instance)]).
nounMapping2SUMO('09008333-n',[ ('City',instance)]).
nounMapping2SUMO('09008454-n',[ ('City',instance)]).
nounMapping2SUMO('09008723-n',[ ('City',instance)]).
nounMapping2SUMO('09008993-n',[ ('City',instance)]).
nounMapping2SUMO('09009174-n',[ ('City',instance)]).
nounMapping2SUMO('09009372-n',[ ('City',instance)]).
nounMapping2SUMO('09009490-n',[ ('RostovOnDonRussia',equivalence)]).
nounMapping2SUMO('09009693-n',[ ('City',instance)]).
nounMapping2SUMO('09009816-n',[ ('City',instance)]).
nounMapping2SUMO('09009978-n',[ ('City',instance)]).
nounMapping2SUMO('09010085-n',[ ('City',instance)]).
nounMapping2SUMO('09010300-n',[ ('City',instance)]).
nounMapping2SUMO('09010453-n',[ ('City',instance)]).
nounMapping2SUMO('09010565-n',[ ('City',instance)]).
nounMapping2SUMO('09010670-n',[ ('VladivostokRussia',equivalence)]).
nounMapping2SUMO('09010785-n',[ ('Island',instance)]).
nounMapping2SUMO('09010974-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09011151-n',[ ('Belarus',equivalence)]).
nounMapping2SUMO('09011518-n',[ ('City',instance)]).
nounMapping2SUMO('09011679-n',[ ('City',instance)]).
nounMapping2SUMO('09011820-n',[ ('City',instance)]).
nounMapping2SUMO('09011922-n',[ ('City',instance)]).
nounMapping2SUMO('09012101-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('09012297-n',[ ('Estonia',equivalence)]).
nounMapping2SUMO('09012530-n',[ ('City',instance)]).
nounMapping2SUMO('09012735-n',[ ('City',instance)]).
nounMapping2SUMO('09012898-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09013074-n',[ ('Latvia',equivalence)]).
nounMapping2SUMO('09013353-n',[ ('City',instance)]).
nounMapping2SUMO('09013603-n',[ ('City',instance)]).
nounMapping2SUMO('09013724-n',[ ('City',instance)]).
nounMapping2SUMO('09013830-n',[ ('Lithuania',equivalence)]).
nounMapping2SUMO('09014066-n',[ ('City',instance)]).
nounMapping2SUMO('09014273-n',[ ('City',instance)]).
nounMapping2SUMO('09014470-n',[ ('City',instance)]).
nounMapping2SUMO('09014586-n',[ ('Moldova',equivalence)]).
nounMapping2SUMO('09014850-n',[ ('City',instance)]).
nounMapping2SUMO('09014979-n',[ ('Ukraine',equivalence)]).
nounMapping2SUMO('09015460-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09015653-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09015907-n',[ ('City',instance)]).
nounMapping2SUMO('09016099-n',[ ('City',instance)]).
nounMapping2SUMO('09016232-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09016365-n',[ ('City',instance)]).
nounMapping2SUMO('09016539-n',[ ('City',instance)]).
nounMapping2SUMO('09016698-n',[ ('City',instance)]).
nounMapping2SUMO('09016860-n',[ ('City',instance)]).
nounMapping2SUMO('09017005-n',[ ('City',instance)]).
nounMapping2SUMO('09017168-n',[ ('City',instance)]).
nounMapping2SUMO('09017301-n',[ ('City',instance)]).
nounMapping2SUMO('09017526-n',[ ('Armenia',equivalence)]).
nounMapping2SUMO('09018030-n',[ ('City',instance)]).
nounMapping2SUMO('09018162-n',[ ('Azerbaijan',equivalence)]).
nounMapping2SUMO('09018426-n',[ ('City',instance)]).
nounMapping2SUMO('09018647-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09018848-n',[ ('RepublicOfGeorgia',equivalence)]).
nounMapping2SUMO('09019194-n',[ ('City',instance)]).
nounMapping2SUMO('09019355-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('09019592-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('09019726-n',[ ('Kazakhstan',equivalence)]).
nounMapping2SUMO('09020119-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09020299-n',[ ('City',instance)]).
nounMapping2SUMO('09020440-n',[ ('Kyrgyzstan',equivalence)]).
nounMapping2SUMO('09020792-n',[ ('City',instance)]).
nounMapping2SUMO('09020961-n',[ ('Tajikistan',equivalence)]).
nounMapping2SUMO('09021313-n',[ ('City',instance)]).
nounMapping2SUMO('09021503-n',[ ('Turkmenistan',equivalence)]).
nounMapping2SUMO('09021812-n',[ ('City',instance)]).
nounMapping2SUMO('09021958-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09022132-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09022265-n',[ ('Uzbekistan',equivalence)]).
nounMapping2SUMO('09022538-n',[ ('City',instance)]).
nounMapping2SUMO('09022667-n',[ ('City',instance)]).
nounMapping2SUMO('09022831-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09023118-n',[ ('Andorra',equivalence)]).
nounMapping2SUMO('09023321-n',[ ('Spain',equivalence)]).
nounMapping2SUMO('09024467-n',[ ('City',instance)]).
nounMapping2SUMO('09024668-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09024844-n',[ ('Island',instance)]).
nounMapping2SUMO('09024972-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09025189-n',[ ('BarcelonaSpain',equivalence)]).
nounMapping2SUMO('09025451-n',[ ('City',instance)]).
nounMapping2SUMO('09025584-n',[ ('City',instance)]).
nounMapping2SUMO('09025728-n',[ ('City',instance)]).
nounMapping2SUMO('09025863-n',[ ('GranadaSpain',equivalence)]).
nounMapping2SUMO('09026204-n',[ ('City',instance)]).
nounMapping2SUMO('09026360-n',[ ('City',instance)]).
nounMapping2SUMO('09026499-n',[ ('LogronoSpain',equivalence)]).
nounMapping2SUMO('09026614-n',[ ('MalagaSpain',equivalence)]).
nounMapping2SUMO('09026780-n',[ ('City',instance)]).
nounMapping2SUMO('09026911-n',[ ('SanSebastianSpain',equivalence)]).
nounMapping2SUMO('09027089-n',[ ('SevilleSpain',equivalence)]).
nounMapping2SUMO('09027292-n',[ ('City',instance)]).
nounMapping2SUMO('09027460-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09027679-n',[ ('City',instance)]).
nounMapping2SUMO('09027853-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09028062-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09028204-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09028367-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09028477-n',[ ('ValenciaSpain',equivalence)]).
nounMapping2SUMO('09028643-n',[ ('Island',instance)]).
nounMapping2SUMO('09028841-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09029242-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09029457-n',[ ('Sudan',equivalence)]).
nounMapping2SUMO('09029884-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09030096-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('09030210-n',[ ('City',instance)]).
nounMapping2SUMO('09030382-n',[ ('City',instance)]).
nounMapping2SUMO('09030467-n',[ ('City',instance)]).
nounMapping2SUMO('09030596-n',[ ('City',instance)]).
nounMapping2SUMO('09030752-n',[ ('Suriname',equivalence)]).
nounMapping2SUMO('09031061-n',[ ('City',instance)]).
nounMapping2SUMO('09031233-n',[ ('Swaziland',equivalence)]).
nounMapping2SUMO('09031501-n',[ ('City',instance)]).
nounMapping2SUMO('09031653-n',[ ('Switzerland',equivalence)]).
nounMapping2SUMO('09032191-n',[ ('StateOrProvince',subsumption)]).
nounMapping2SUMO('09032321-n',[ ('City',instance)]).
nounMapping2SUMO('09032483-n',[ ('City',instance)]).
nounMapping2SUMO('09032604-n',[ ('GenevaSwitzerland',equivalence)]).
nounMapping2SUMO('09032843-n',[ ('City',instance)]).
nounMapping2SUMO('09032981-n',[ ('City',instance)]).
nounMapping2SUMO('09033117-n',[ ('City',instance)]).
nounMapping2SUMO('09033333-n',[ ('Syria',equivalence)]).
nounMapping2SUMO('09033813-n',[ ('Nation',instance)]).
nounMapping2SUMO('09033936-n',[ ('City',instance)]).
nounMapping2SUMO('09034286-n',[ ('City',instance)]).
nounMapping2SUMO('09034402-n',[ ('City',instance)]).
nounMapping2SUMO('09034550-n',[ ('Tanzania',equivalence)]).
nounMapping2SUMO('09034967-n',[ ('City',instance)]).
nounMapping2SUMO('09035153-n',[ ('City',instance)]).
nounMapping2SUMO('09035305-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09035458-n',[ ('Island',instance)]).
nounMapping2SUMO('09035632-n',[ ('City',instance)]).
nounMapping2SUMO('09035735-n',[ ('City',instance)]).
nounMapping2SUMO('09035852-n',[ ('City',instance)]).
nounMapping2SUMO('09035951-n',[ ('City',instance)]).
nounMapping2SUMO('09036098-n',[ ('Field',instance)]).
nounMapping2SUMO('09036295-n',[ ('PublicPark',instance)]).
nounMapping2SUMO('09036452-n',[ ('Thailand',equivalence)]).
nounMapping2SUMO('09036880-n',[ ('City',instance)]).
nounMapping2SUMO('09037133-n',[ ('Tonga',equivalence)]).
nounMapping2SUMO('09037394-n',[ ('Tunisia',equivalence)]).
nounMapping2SUMO('09037838-n',[ ('City',instance)]).
nounMapping2SUMO('09037991-n',[ ('City',instance)]).
nounMapping2SUMO('09038079-n',[ ('City',instance)]).
nounMapping2SUMO('09038170-n',[ ('City',instance)]).
nounMapping2SUMO('09038272-n',[ ('City',instance)]).
nounMapping2SUMO('09038439-n',[ ('City',instance)]).
nounMapping2SUMO('09038597-n',[ ('GeopoliticalArea',instance)]).
nounMapping2SUMO('09038990-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09039260-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09039411-n',[ ('Turkey',equivalence)]).
nounMapping2SUMO('09040299-n',[ ('City',instance)]).
nounMapping2SUMO('09040475-n',[ ('AdanaTurkey',equivalence)]).
nounMapping2SUMO('09040601-n',[ ('AnkaraTurkey',equivalence)]).
nounMapping2SUMO('09040839-n',[ ('AntalyaTurkey',equivalence)]).
nounMapping2SUMO('09040998-n',[ ('City',instance)]).
nounMapping2SUMO('09041199-n',[ ('City',instance)]).
nounMapping2SUMO('09041371-n',[ ('WaterArea',instance)]).
nounMapping2SUMO('09041582-n',[ ('City',instance)]).
nounMapping2SUMO('09041785-n',[ ('IstanbulTurkey',equivalence)]).
nounMapping2SUMO('09042213-n',[ ('City',instance)]).
nounMapping2SUMO('09042322-n',[ ('IzmirTurkey',equivalence)]).
nounMapping2SUMO('09042451-n',[ ('City',instance)]).
nounMapping2SUMO('09042675-n',[ ('City',instance)]).
nounMapping2SUMO('09042924-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09043052-n',[ ('Uganda',equivalence)]).
nounMapping2SUMO('09043411-n',[ ('StateOrProvince',instance)]).
nounMapping2SUMO('09043556-n',[ ('City',instance)]).
nounMapping2SUMO('09043802-n',[ ('City',instance)]).
nounMapping2SUMO('09043926-n',[ ('City',instance)]).
nounMapping2SUMO('09044094-n',[ ('City',instance)]).
nounMapping2SUMO('09044190-n',[ ('UnitedArabEmirates',equivalence)]).
nounMapping2SUMO('09044536-n',[ ('City',instance)]).
nounMapping2SUMO('09044714-n',[ ('City',instance)]).
nounMapping2SUMO('09044862-n',[ ('UnitedStates',equivalence)]).
nounMapping2SUMO('09048127-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09048303-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09048460-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09048880-n',[ ('NewEngland',equivalence)]).
nounMapping2SUMO('09049303-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09049599-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09049909-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09050089-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09050244-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09050730-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('09051235-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09051609-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09051726-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09051898-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09052100-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09052314-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09052652-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09052835-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09053019-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09053185-n',[ ('Alabama',equivalence)]).
nounMapping2SUMO('09053801-n',[ ('City',instance)]).
nounMapping2SUMO('09053947-n',[ ('City',instance)]).
nounMapping2SUMO('09054110-n',[ ('City',instance)]).
nounMapping2SUMO('09054233-n',[ ('City',instance)]).
nounMapping2SUMO('09054350-n',[ ('City',instance)]).
nounMapping2SUMO('09054480-n',[ ('City',instance)]).
nounMapping2SUMO('09054616-n',[ ('City',instance)]).
nounMapping2SUMO('09054797-n',[ ('City',instance)]).
nounMapping2SUMO('09054915-n',[ ('City',instance)]).
nounMapping2SUMO('09055015-n',[ ('Alaska',equivalence)]).
nounMapping2SUMO('09055786-n',[ ('City',instance)]).
nounMapping2SUMO('09055906-n',[ ('City',instance)]).
nounMapping2SUMO('09056055-n',[ ('City',instance)]).
nounMapping2SUMO('09056278-n',[ ('City',instance)]).
nounMapping2SUMO('09056476-n',[ ('City',instance)]).
nounMapping2SUMO('09056677-n',[ ('City',instance)]).
nounMapping2SUMO('09056837-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09057021-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09057170-n',[ ('Island',instance)]).
nounMapping2SUMO('09057311-n',[ ('Arizona',equivalence)]).
nounMapping2SUMO('09057930-n',[ ('City',instance)]).
nounMapping2SUMO('09058071-n',[ ('City',instance)]).
nounMapping2SUMO('09058219-n',[ ('City',instance)]).
nounMapping2SUMO('09058376-n',[ ('City',instance)]).
nounMapping2SUMO('09058635-n',[ ('City',instance)]).
nounMapping2SUMO('09058735-n',[ ('City',instance)]).
nounMapping2SUMO('09058841-n',[ ('City',instance)]).
nounMapping2SUMO('09059125-n',[ ('City',instance)]).
nounMapping2SUMO('09059274-n',[ ('Arkansas',equivalence)]).
nounMapping2SUMO('09059741-n',[ ('City',instance)]).
nounMapping2SUMO('09059876-n',[ ('City',instance)]).
nounMapping2SUMO('09060024-n',[ ('City',instance)]).
nounMapping2SUMO('09060176-n',[ ('City',instance)]).
nounMapping2SUMO('09060280-n',[ ('City',instance)]).
nounMapping2SUMO('09060480-n',[ ('City',instance)]).
nounMapping2SUMO('09060615-n',[ ('City',instance)]).
nounMapping2SUMO('09060768-n',[ ('California',equivalence)]).
nounMapping2SUMO('09062015-n',[ ('City',instance)]).
nounMapping2SUMO('09062184-n',[ ('Corporation',instance)]).
nounMapping2SUMO('09062320-n',[ ('City',instance)]).
nounMapping2SUMO('09062478-n',[ ('City',instance)]).
nounMapping2SUMO('09062585-n',[ ('City',instance)]).
nounMapping2SUMO('09062791-n',[ ('City',instance)]).
nounMapping2SUMO('09062961-n',[ ('City',instance)]).
nounMapping2SUMO('09063125-n',[ ('City',instance)]).
nounMapping2SUMO('09063259-n',[ ('City',instance)]).
nounMapping2SUMO('09063477-n',[ ('City',instance)]).
nounMapping2SUMO('09063673-n',[ ('LosAngelesCalifornia',equivalence)]).
nounMapping2SUMO('09063950-n',[ ('GeopoliticalArea',instance)]).
nounMapping2SUMO('09064080-n',[ ('City',instance)]).
nounMapping2SUMO('09064264-n',[ ('City',instance)]).
nounMapping2SUMO('09064468-n',[ ('City',instance)]).
nounMapping2SUMO('09064594-n',[ ('City',instance)]).
nounMapping2SUMO('09064729-n',[ ('City',instance)]).
nounMapping2SUMO('09064861-n',[ ('City',instance)]).
nounMapping2SUMO('09064966-n',[ ('City',instance)]).
nounMapping2SUMO('09065191-n',[ ('City',instance)]).
nounMapping2SUMO('09065328-n',[ ('City',instance)]).
nounMapping2SUMO('09065557-n',[ ('SanFranciscoCalifornia',equivalence)]).
nounMapping2SUMO('09065899-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09066017-n',[ ('City',instance)]).
nounMapping2SUMO('09066249-n',[ ('City',instance)]).
nounMapping2SUMO('09066375-n',[ ('City',instance)]).
nounMapping2SUMO('09066534-n',[ ('City',instance)]).
nounMapping2SUMO('09066665-n',[ ('City',instance)]).
nounMapping2SUMO('09066799-n',[ ('City',instance)]).
nounMapping2SUMO('09066948-n',[ ('Island',instance)]).
nounMapping2SUMO('09067138-n',[ ('City',instance)]).
nounMapping2SUMO('09067277-n',[ ('Colorado',equivalence)]).
nounMapping2SUMO('09067721-n',[ ('City',instance)]).
nounMapping2SUMO('09067878-n',[ ('City',instance)]).
nounMapping2SUMO('09068107-n',[ ('City',instance)]).
nounMapping2SUMO('09068320-n',[ ('City',instance)]).
nounMapping2SUMO('09068444-n',[ ('Connecticut',equivalence)]).
nounMapping2SUMO('09068805-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09068921-n',[ ('City',instance)]).
nounMapping2SUMO('09069072-n',[ ('City',instance)]).
nounMapping2SUMO('09069190-n',[ ('City',instance)]).
nounMapping2SUMO('09069415-n',[ ('City',instance)]).
nounMapping2SUMO('09069569-n',[ ('City',instance)]).
nounMapping2SUMO('09069752-n',[ ('City',instance)]).
nounMapping2SUMO('09069862-n',[ ('Delaware',equivalence)]).
nounMapping2SUMO('09070120-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09070233-n',[ ('City',instance)]).
nounMapping2SUMO('09070363-n',[ ('City',instance)]).
nounMapping2SUMO('09070487-n',[ ('WashingtonDC',equivalence)]).
nounMapping2SUMO('09070793-n',[ ('WashingtonDC',equivalence)]).
nounMapping2SUMO('09071246-n',[ ('City',instance)]).
nounMapping2SUMO('09071349-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09071571-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09071690-n',[ ('Florida',equivalence)]).
nounMapping2SUMO('09072611-n',[ ('City',instance)]).
nounMapping2SUMO('09072810-n',[ ('City',instance)]).
nounMapping2SUMO('09073034-n',[ ('City',instance)]).
nounMapping2SUMO('09073138-n',[ ('City',instance)]).
nounMapping2SUMO('09073258-n',[ ('City',instance)]).
nounMapping2SUMO('09073442-n',[ ('City',instance)]).
nounMapping2SUMO('09073584-n',[ ('City',instance)]).
nounMapping2SUMO('09073697-n',[ ('City',instance)]).
nounMapping2SUMO('09073938-n',[ ('City',instance)]).
nounMapping2SUMO('09074140-n',[ ('City',instance)]).
nounMapping2SUMO('09074285-n',[ ('City',instance)]).
nounMapping2SUMO('09074431-n',[ ('City',instance)]).
nounMapping2SUMO('09074596-n',[ ('City',instance)]).
nounMapping2SUMO('09074707-n',[ ('City',instance)]).
nounMapping2SUMO('09074834-n',[ ('City',instance)]).
nounMapping2SUMO('09075007-n',[ ('City',instance)]).
nounMapping2SUMO('09075170-n',[ ('City',instance)]).
nounMapping2SUMO('09075329-n',[ ('City',instance)]).
nounMapping2SUMO('09075496-n',[ ('City',instance)]).
nounMapping2SUMO('09075688-n',[ ('Corporation',instance)]).
nounMapping2SUMO('09075842-n',[ ('Georgia',equivalence)]).
nounMapping2SUMO('09076421-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09076533-n',[ ('City',instance)]).
nounMapping2SUMO('09076675-n',[ ('City',instance)]).
nounMapping2SUMO('09076982-n',[ ('City',instance)]).
nounMapping2SUMO('09077111-n',[ ('City',instance)]).
nounMapping2SUMO('09077266-n',[ ('City',instance)]).
nounMapping2SUMO('09077410-n',[ ('City',instance)]).
nounMapping2SUMO('09077556-n',[ ('City',instance)]).
nounMapping2SUMO('09077681-n',[ ('City',instance)]).
nounMapping2SUMO('09077821-n',[ ('City',instance)]).
nounMapping2SUMO('09077977-n',[ ('City',instance)]).
nounMapping2SUMO('09078102-n',[ ('City',instance)]).
nounMapping2SUMO('09078231-n',[ ('Hawaii',equivalence)]).
nounMapping2SUMO('09078654-n',[ ('City',instance)]).
nounMapping2SUMO('09078784-n',[ ('City',instance)]).
nounMapping2SUMO('09079001-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09079153-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09079505-n',[ ('Island',instance)]).
nounMapping2SUMO('09079747-n',[ ('Island',instance)]).
nounMapping2SUMO('09079875-n',[ ('Island',instance)]).
nounMapping2SUMO('09080006-n',[ ('Island',instance)]).
nounMapping2SUMO('09080146-n',[ ('Island',instance)]).
nounMapping2SUMO('09080273-n',[ ('Island',instance)]).
nounMapping2SUMO('09080415-n',[ ('Island',instance)]).
nounMapping2SUMO('09080554-n',[ ('Island',instance)]).
nounMapping2SUMO('09080782-n',[ ('StaticWaterArea',instance)]).
nounMapping2SUMO('09080989-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09081213-n',[ ('Idaho',equivalence)]).
nounMapping2SUMO('09081560-n',[ ('City',instance)]).
nounMapping2SUMO('09081688-n',[ ('City',instance)]).
nounMapping2SUMO('09081830-n',[ ('City',instance)]).
nounMapping2SUMO('09081955-n',[ ('City',instance)]).
nounMapping2SUMO('09082058-n',[ ('City',instance)]).
nounMapping2SUMO('09082158-n',[ ('City',instance)]).
nounMapping2SUMO('09082273-n',[ ('City',instance)]).
nounMapping2SUMO('09082395-n',[ ('City',instance)]).
nounMapping2SUMO('09082540-n',[ ('Illinois',equivalence)]).
nounMapping2SUMO('09082988-n',[ ('City',instance)]).
nounMapping2SUMO('09083151-n',[ ('City',instance)]).
nounMapping2SUMO('09083255-n',[ ('City',instance)]).
nounMapping2SUMO('09083390-n',[ ('City',instance)]).
nounMapping2SUMO('09083659-n',[ ('City',instance)]).
nounMapping2SUMO('09083795-n',[ ('City',instance)]).
nounMapping2SUMO('09083949-n',[ ('City',instance)]).
nounMapping2SUMO('09084075-n',[ ('City',instance)]).
nounMapping2SUMO('09084196-n',[ ('City',instance)]).
nounMapping2SUMO('09084298-n',[ ('City',instance)]).
nounMapping2SUMO('09084483-n',[ ('City',instance)]).
nounMapping2SUMO('09084615-n',[ ('City',instance)]).
nounMapping2SUMO('09084750-n',[ ('Indiana',equivalence)]).
nounMapping2SUMO('09085089-n',[ ('City',instance)]).
nounMapping2SUMO('09085209-n',[ ('City',instance)]).
nounMapping2SUMO('09085334-n',[ ('City',instance)]).
nounMapping2SUMO('09085441-n',[ ('City',instance)]).
nounMapping2SUMO('09085593-n',[ ('City',instance)]).
nounMapping2SUMO('09085830-n',[ ('City',instance)]).
nounMapping2SUMO('09085967-n',[ ('City',instance)]).
nounMapping2SUMO('09086070-n',[ ('City',instance)]).
nounMapping2SUMO('09086173-n',[ ('Iowa',equivalence)]).
nounMapping2SUMO('09086509-n',[ ('City',instance)]).
nounMapping2SUMO('09086635-n',[ ('City',instance)]).
nounMapping2SUMO('09086793-n',[ ('City',instance)]).
nounMapping2SUMO('09086894-n',[ ('City',instance)]).
nounMapping2SUMO('09086995-n',[ ('City',instance)]).
nounMapping2SUMO('09087126-n',[ ('City',instance)]).
nounMapping2SUMO('09087247-n',[ ('City',instance)]).
nounMapping2SUMO('09087352-n',[ ('City',instance)]).
nounMapping2SUMO('09087450-n',[ ('City',instance)]).
nounMapping2SUMO('09087599-n',[ ('Kansas',equivalence)]).
nounMapping2SUMO('09087996-n',[ ('City',instance)]).
nounMapping2SUMO('09088151-n',[ ('City',instance)]).
nounMapping2SUMO('09088301-n',[ ('City',instance)]).
nounMapping2SUMO('09088396-n',[ ('City',instance)]).
nounMapping2SUMO('09088556-n',[ ('City',instance)]).
nounMapping2SUMO('09088718-n',[ ('City',instance)]).
nounMapping2SUMO('09088815-n',[ ('City',instance)]).
nounMapping2SUMO('09088989-n',[ ('City',instance)]).
nounMapping2SUMO('09089139-n',[ ('Kentucky',equivalence)]).
nounMapping2SUMO('09089524-n',[ ('City',instance)]).
nounMapping2SUMO('09089631-n',[ ('City',instance)]).
nounMapping2SUMO('09089782-n',[ ('City',instance)]).
nounMapping2SUMO('09089923-n',[ ('City',instance)]).
nounMapping2SUMO('09090128-n',[ ('City',instance)]).
nounMapping2SUMO('09090271-n',[ ('City',instance)]).
nounMapping2SUMO('09090389-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09090559-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09090825-n',[ ('Louisiana',equivalence)]).
nounMapping2SUMO('09091285-n',[ ('City',instance)]).
nounMapping2SUMO('09091398-n',[ ('City',instance)]).
nounMapping2SUMO('09091538-n',[ ('City',instance)]).
nounMapping2SUMO('09091668-n',[ ('City',instance)]).
nounMapping2SUMO('09091774-n',[ ('City',instance)]).
nounMapping2SUMO('09091909-n',[ ('City',instance)]).
nounMapping2SUMO('09092352-n',[ ('City',instance)]).
nounMapping2SUMO('09092497-n',[ ('Maine',equivalence)]).
nounMapping2SUMO('09092822-n',[ ('City',instance)]).
nounMapping2SUMO('09092948-n',[ ('City',instance)]).
nounMapping2SUMO('09093072-n',[ ('City',instance)]).
nounMapping2SUMO('09093187-n',[ ('City',instance)]).
nounMapping2SUMO('09093315-n',[ ('City',instance)]).
nounMapping2SUMO('09093472-n',[ ('City',instance)]).
nounMapping2SUMO('09093608-n',[ ('Maryland',equivalence)]).
nounMapping2SUMO('09093980-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09094093-n',[ ('City',instance)]).
nounMapping2SUMO('09094217-n',[ ('City',instance)]).
nounMapping2SUMO('09094381-n',[ ('City',instance)]).
nounMapping2SUMO('09094581-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('09094791-n',[ ('City',instance)]).
nounMapping2SUMO('09094919-n',[ ('City',instance)]).
nounMapping2SUMO('09095023-n',[ ('Massachusetts',equivalence)]).
nounMapping2SUMO('09095606-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09095751-n',[ ('City',instance)]).
nounMapping2SUMO('09096089-n',[ ('StaticWaterArea',instance)]).
nounMapping2SUMO('09096190-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09096343-n',[ ('SubjectiveAssessmentAttribute',instance)]).
nounMapping2SUMO('09096498-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09096664-n',[ ('City',instance)]).
nounMapping2SUMO('09096903-n',[ ('City',instance)]).
nounMapping2SUMO('09097079-n',[ ('City',instance)]).
nounMapping2SUMO('09097283-n',[ ('City',instance)]).
nounMapping2SUMO('09097461-n',[ ('City',instance)]).
nounMapping2SUMO('09097599-n',[ ('City',instance)]).
nounMapping2SUMO('09097707-n',[ ('City',instance)]).
nounMapping2SUMO('09097871-n',[ ('City',instance)]).
nounMapping2SUMO('09098027-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09098184-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09098358-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('09098488-n',[ ('Island',instance)]).
nounMapping2SUMO('09098592-n',[ ('Island',instance)]).
nounMapping2SUMO('09098721-n',[ ('City',instance)]).
nounMapping2SUMO('09098885-n',[ ('Group',instance)]).
nounMapping2SUMO('09099098-n',[ ('CorpuscularObject',instance)]).
nounMapping2SUMO('09099264-n',[ ('City',instance)]).
nounMapping2SUMO('09099411-n',[ ('City',instance)]).
nounMapping2SUMO('09099526-n',[ ('Michigan',equivalence)]).
nounMapping2SUMO('09100080-n',[ ('City',instance)]).
nounMapping2SUMO('09100223-n',[ ('City',instance)]).
nounMapping2SUMO('09100394-n',[ ('PortCity',instance)]).
nounMapping2SUMO('09100690-n',[ ('City',instance)]).
nounMapping2SUMO('09100837-n',[ ('City',instance)]).
nounMapping2SUMO('09100982-n',[ ('City',instance)]).
nounMapping2SUMO('09101127-n',[ ('City',instance)]).
nounMapping2SUMO('09101233-n',[ ('City',instance)]).
nounMapping2SUMO('09101318-n',[ ('City',instance)]).
nounMapping2SUMO('09101495-n',[ ('City',instance)]).
nounMapping2SUMO('09101639-n',[ ('City',instance)]).
nounMapping2SUMO('09101753-n',[ ('City',instance)]).
nounMapping2SUMO('09101882-n',[ ('City',instance)]).
nounMapping2SUMO('09102016-n',[ ('Minnesota',equivalence)]).
nounMapping2SUMO('09102415-n',[ ('City',instance)]).
nounMapping2SUMO('09102517-n',[ ('City',instance)]).
nounMapping2SUMO('09102655-n',[ ('City',instance)]).
nounMapping2SUMO('09102781-n',[ ('City',instance)]).
nounMapping2SUMO('09102883-n',[ ('City',instance)]).
nounMapping2SUMO('09103112-n',[ ('City',instance)]).
nounMapping2SUMO('09103217-n',[ ('City',instance)]).
nounMapping2SUMO('09103377-n',[ ('City',instance)]).
nounMapping2SUMO('09103648-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09103803-n',[ ('City',instance)]).
nounMapping2SUMO('09103943-n',[ ('Mississippi',equivalence)]).
nounMapping2SUMO('09104474-n',[ ('City',instance)]).
nounMapping2SUMO('09104604-n',[ ('City',instance)]).
nounMapping2SUMO('09104737-n',[ ('City',instance)]).
nounMapping2SUMO('09104894-n',[ ('City',instance)]).
nounMapping2SUMO('09105003-n',[ ('City',instance)]).
nounMapping2SUMO('09105156-n',[ ('City',instance)]).
nounMapping2SUMO('09105260-n',[ ('City',instance)]).
nounMapping2SUMO('09105390-n',[ ('City',instance)]).
nounMapping2SUMO('09105494-n',[ ('City',instance)]).
nounMapping2SUMO('09105821-n',[ ('Missouri',equivalence)]).
nounMapping2SUMO('09106393-n',[ ('City',instance)]).
nounMapping2SUMO('09106502-n',[ ('City',instance)]).
nounMapping2SUMO('09106614-n',[ ('City',instance)]).
nounMapping2SUMO('09106770-n',[ ('City',instance)]).
nounMapping2SUMO('09106912-n',[ ('City',instance)]).
nounMapping2SUMO('09107098-n',[ ('KansasCityMissouri',equivalence)]).
nounMapping2SUMO('09107305-n',[ ('City',instance)]).
nounMapping2SUMO('09107412-n',[ ('City',instance)]).
nounMapping2SUMO('09107626-n',[ ('City',instance)]).
nounMapping2SUMO('09107950-n',[ ('City',instance)]).
nounMapping2SUMO('09108055-n',[ ('City',instance)]).
nounMapping2SUMO('09108164-n',[ ('Montana',equivalence)]).
nounMapping2SUMO('09108586-n',[ ('City',instance)]).
nounMapping2SUMO('09108728-n',[ ('City',instance)]).
nounMapping2SUMO('09108884-n',[ ('City',instance)]).
nounMapping2SUMO('09109012-n',[ ('City',instance)]).
nounMapping2SUMO('09109180-n',[ ('City',instance)]).
nounMapping2SUMO('09109333-n',[ ('City',instance)]).
nounMapping2SUMO('09109444-n',[ ('Nebraska',equivalence)]).
nounMapping2SUMO('09109771-n',[ ('City',instance)]).
nounMapping2SUMO('09109882-n',[ ('City',instance)]).
nounMapping2SUMO('09110099-n',[ ('City',instance)]).
nounMapping2SUMO('09110229-n',[ ('City',instance)]).
nounMapping2SUMO('09110422-n',[ ('Nevada',equivalence)]).
nounMapping2SUMO('09110784-n',[ ('City',instance)]).
nounMapping2SUMO('09110939-n',[ ('City',instance)]).
nounMapping2SUMO('09111168-n',[ ('City',instance)]).
nounMapping2SUMO('09111366-n',[ ('NewHampshire',equivalence)]).
nounMapping2SUMO('09111636-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09111754-n',[ ('City',instance)]).
nounMapping2SUMO('09111955-n',[ ('ManchesterNewHampshire',equivalence)]).
nounMapping2SUMO('09112123-n',[ ('City',instance)]).
nounMapping2SUMO('09112282-n',[ ('NewJersey',equivalence)]).
nounMapping2SUMO('09112742-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09112857-n',[ ('City',instance)]).
nounMapping2SUMO('09113022-n',[ ('City',instance)]).
nounMapping2SUMO('09113207-n',[ ('City',instance)]).
nounMapping2SUMO('09113333-n',[ ('City',instance)]).
nounMapping2SUMO('09113479-n',[ ('City',instance)]).
nounMapping2SUMO('09113611-n',[ ('City',instance)]).
nounMapping2SUMO('09113762-n',[ ('City',instance)]).
nounMapping2SUMO('09113901-n',[ ('City',instance)]).
nounMapping2SUMO('09114020-n',[ ('City',instance)]).
nounMapping2SUMO('09114128-n',[ ('City',instance)]).
nounMapping2SUMO('09114262-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09114401-n',[ ('Island',instance)]).
nounMapping2SUMO('09114696-n',[ ('NewMexico',equivalence)]).
nounMapping2SUMO('09115315-n',[ ('City',instance)]).
nounMapping2SUMO('09115478-n',[ ('City',instance)]).
nounMapping2SUMO('09115646-n',[ ('City',instance)]).
nounMapping2SUMO('09115756-n',[ ('City',instance)]).
nounMapping2SUMO('09115886-n',[ ('City',instance)]).
nounMapping2SUMO('09116010-n',[ ('City',instance)]).
nounMapping2SUMO('09116214-n',[ ('City',instance)]).
nounMapping2SUMO('09116318-n',[ ('City',instance)]).
nounMapping2SUMO('09116488-n',[ ('City',instance)]).
nounMapping2SUMO('09116599-n',[ ('City',instance)]).
nounMapping2SUMO('09116709-n',[ ('Island',instance)]).
nounMapping2SUMO('09116876-n',[ ('Group',instance)]).
nounMapping2SUMO('09117118-n',[ ('DependencyOrSpecialSovereigntyArea',instance)]).
nounMapping2SUMO('09117351-n',[ ('NewYork',equivalence)]).
nounMapping2SUMO('09118181-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09118313-n',[ ('City',instance)]).
nounMapping2SUMO('09118505-n',[ ('City',instance)]).
nounMapping2SUMO('09118639-n',[ ('City',instance)]).
nounMapping2SUMO('09118817-n',[ ('StreamWaterArea',instance)]).
nounMapping2SUMO('09119070-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('09119277-n',[ ('NewYorkCityUnitedStates',equivalence)]).
nounMapping2SUMO('09119989-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09120087-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09120207-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09120353-n',[ ('Island',instance)]).
nounMapping2SUMO('09120594-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09120939-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09121101-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('09121230-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09121334-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09121458-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09121619-n',[ ('GeopoliticalArea',instance)]).
nounMapping2SUMO('09121814-n',[ ('City',instance)]).
nounMapping2SUMO('09121936-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09122086-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09122258-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09122397-n',[ ('Corporation',subsumption)]).
nounMapping2SUMO('09122542-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09122779-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09122968-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09123182-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09123281-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09123387-n',[ ('StreamWaterArea',instance)]).
nounMapping2SUMO('09123538-n',[ ('StreamWaterArea',instance)]).
nounMapping2SUMO('09123662-n',[ ('StreamWaterArea',instance)]).
nounMapping2SUMO('09123809-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('09124039-n',[ ('Island',instance)]).
nounMapping2SUMO('09124252-n',[ ('City',instance)]).
nounMapping2SUMO('09124399-n',[ ('JohnFKennedyInternationalNYAirport',equivalence)]).
nounMapping2SUMO('09124589-n',[ ('City',instance)]).
nounMapping2SUMO('09124732-n',[ ('City',instance)]).
nounMapping2SUMO('09124845-n',[ ('City',instance)]).
nounMapping2SUMO('09125016-n',[ ('City',instance)]).
nounMapping2SUMO('09125203-n',[ ('City',instance)]).
nounMapping2SUMO('09125354-n',[ ('City',instance)]).
nounMapping2SUMO('09125528-n',[ ('City',instance)]).
nounMapping2SUMO('09125629-n',[ ('City',instance)]).
nounMapping2SUMO('09125727-n',[ ('City',instance)]).
nounMapping2SUMO('09125881-n',[ ('City',instance)]).
nounMapping2SUMO('09125984-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09126305-n',[ ('NorthCarolina',equivalence)]).
nounMapping2SUMO('09126895-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09127014-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09127161-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09127274-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09127461-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09127701-n',[ ('Island',instance)]).
nounMapping2SUMO('09127844-n',[ ('City',instance)]).
nounMapping2SUMO('09128040-n',[ ('City',instance)]).
nounMapping2SUMO('09128201-n',[ ('City',instance)]).
nounMapping2SUMO('09128372-n',[ ('City',instance)]).
nounMapping2SUMO('09128536-n',[ ('City',instance)]).
nounMapping2SUMO('09128691-n',[ ('City',instance)]).
nounMapping2SUMO('09128808-n',[ ('City',instance)]).
nounMapping2SUMO('09128947-n',[ ('City',instance)]).
nounMapping2SUMO('09129062-n',[ ('City',instance)]).
nounMapping2SUMO('09129187-n',[ ('City',instance)]).
nounMapping2SUMO('09129324-n',[ ('City',instance)]).
nounMapping2SUMO('09129442-n',[ ('NorthDakota',equivalence)]).
nounMapping2SUMO('09129719-n',[ ('City',instance)]).
nounMapping2SUMO('09129926-n',[ ('City',instance)]).
nounMapping2SUMO('09130076-n',[ ('Ohio',equivalence)]).
nounMapping2SUMO('09130452-n',[ ('City',instance)]).
nounMapping2SUMO('09130599-n',[ ('City',instance)]).
nounMapping2SUMO('09130714-n',[ ('City',instance)]).
nounMapping2SUMO('09130883-n',[ ('City',instance)]).
nounMapping2SUMO('09131001-n',[ ('City',instance)]).
nounMapping2SUMO('09131205-n',[ ('City',instance)]).
nounMapping2SUMO('09131324-n',[ ('City',instance)]).
nounMapping2SUMO('09131428-n',[ ('City',instance)]).
nounMapping2SUMO('09131553-n',[ ('City',instance)]).
nounMapping2SUMO('09131654-n',[ ('Oklahoma',equivalence)]).
nounMapping2SUMO('09132053-n',[ ('City',instance)]).
nounMapping2SUMO('09132163-n',[ ('City',instance)]).
nounMapping2SUMO('09132266-n',[ ('City',instance)]).
nounMapping2SUMO('09132367-n',[ ('City',instance)]).
nounMapping2SUMO('09132474-n',[ ('City',instance)]).
nounMapping2SUMO('09132597-n',[ ('City',instance)]).
nounMapping2SUMO('09132778-n',[ ('City',instance)]).
nounMapping2SUMO('09133010-n',[ ('Oregon',equivalence)]).
nounMapping2SUMO('09133364-n',[ ('City',instance)]).
nounMapping2SUMO('09133500-n',[ ('City',instance)]).
nounMapping2SUMO('09133643-n',[ ('City',instance)]).
nounMapping2SUMO('09133775-n',[ ('City',instance)]).
nounMapping2SUMO('09133895-n',[ ('City',instance)]).
nounMapping2SUMO('09134202-n',[ ('City',instance)]).
nounMapping2SUMO('09134386-n',[ ('Pennsylvania',equivalence)]).
nounMapping2SUMO('09134882-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09134999-n',[ ('City',instance)]).
nounMapping2SUMO('09135142-n',[ ('City',instance)]).
nounMapping2SUMO('09135246-n',[ ('City',instance)]).
nounMapping2SUMO('09135447-n',[ ('City',instance)]).
nounMapping2SUMO('09135590-n',[ ('City',instance)]).
nounMapping2SUMO('09135733-n',[ ('City',instance)]).
nounMapping2SUMO('09135894-n',[ ('City',instance)]).
nounMapping2SUMO('09135993-n',[ ('City',instance)]).
nounMapping2SUMO('09136182-n',[ ('City',instance)]).
nounMapping2SUMO('09136582-n',[ ('City',instance)]).
nounMapping2SUMO('09136929-n',[ ('City',instance)]).
nounMapping2SUMO('09137032-n',[ ('RhodeIsland',equivalence)]).
nounMapping2SUMO('09137334-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09137451-n',[ ('City',instance)]).
nounMapping2SUMO('09137682-n',[ ('City',instance)]).
nounMapping2SUMO('09137869-n',[ ('SouthCarolina',equivalence)]).
nounMapping2SUMO('09138239-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09138358-n',[ ('City',instance)]).
nounMapping2SUMO('09138538-n',[ ('City',instance)]).
nounMapping2SUMO('09138676-n',[ ('City',instance)]).
nounMapping2SUMO('09138808-n',[ ('City',instance)]).
nounMapping2SUMO('09138935-n',[ ('SouthDakota',equivalence)]).
nounMapping2SUMO('09139380-n',[ ('City',instance)]).
nounMapping2SUMO('09139508-n',[ ('City',instance)]).
nounMapping2SUMO('09139698-n',[ ('City',instance)]).
nounMapping2SUMO('09139849-n',[ ('City',instance)]).
nounMapping2SUMO('09139993-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09140148-n',[ ('Tennessee',equivalence)]).
nounMapping2SUMO('09140569-n',[ ('City',instance)]).
nounMapping2SUMO('09140674-n',[ ('City',instance)]).
nounMapping2SUMO('09140781-n',[ ('City',instance)]).
nounMapping2SUMO('09140882-n',[ ('City',instance)]).
nounMapping2SUMO('09140993-n',[ ('City',instance)]).
nounMapping2SUMO('09141119-n',[ ('City',instance)]).
nounMapping2SUMO('09141297-n',[ ('City',instance)]).
nounMapping2SUMO('09141526-n',[ ('Texas',equivalence)]).
nounMapping2SUMO('09142674-n',[ ('City',instance)]).
nounMapping2SUMO('09142771-n',[ ('City',instance)]).
nounMapping2SUMO('09142887-n',[ ('City',instance)]).
nounMapping2SUMO('09143017-n',[ ('City',instance)]).
nounMapping2SUMO('09143205-n',[ ('City',instance)]).
nounMapping2SUMO('09143321-n',[ ('City',instance)]).
nounMapping2SUMO('09143549-n',[ ('City',instance)]).
nounMapping2SUMO('09143649-n',[ ('City',instance)]).
nounMapping2SUMO('09143786-n',[ ('DallasTexas',equivalence)]).
nounMapping2SUMO('09143973-n',[ ('City',instance)]).
nounMapping2SUMO('09144117-n',[ ('City',instance)]).
nounMapping2SUMO('09144323-n',[ ('City',instance)]).
nounMapping2SUMO('09144484-n',[ ('City',instance)]).
nounMapping2SUMO('09144605-n',[ ('Island',instance)]).
nounMapping2SUMO('09144730-n',[ ('City',instance)]).
nounMapping2SUMO('09144851-n',[ ('City',instance)]).
nounMapping2SUMO('09145083-n',[ ('City',instance)]).
nounMapping2SUMO('09145217-n',[ ('City',instance)]).
nounMapping2SUMO('09145341-n',[ ('City',instance)]).
nounMapping2SUMO('09145437-n',[ ('City',instance)]).
nounMapping2SUMO('09145553-n',[ ('City',instance)]).
nounMapping2SUMO('09145655-n',[ ('City',instance)]).
nounMapping2SUMO('09145751-n',[ ('City',instance)]).
nounMapping2SUMO('09145851-n',[ ('City',instance)]).
nounMapping2SUMO('09145970-n',[ ('City',instance)]).
nounMapping2SUMO('09146111-n',[ ('City',instance)]).
nounMapping2SUMO('09146324-n',[ ('City',instance)]).
nounMapping2SUMO('09146451-n',[ ('City',instance)]).
nounMapping2SUMO('09146584-n',[ ('City',instance)]).
nounMapping2SUMO('09146681-n',[ ('City',instance)]).
nounMapping2SUMO('09146813-n',[ ('City',instance)]).
nounMapping2SUMO('09146912-n',[ ('City',instance)]).
nounMapping2SUMO('09147046-n',[ ('Utah',equivalence)]).
nounMapping2SUMO('09147504-n',[ ('City',instance)]).
nounMapping2SUMO('09147618-n',[ ('City',instance)]).
nounMapping2SUMO('09147737-n',[ ('City',instance)]).
nounMapping2SUMO('09147964-n',[ ('Vermont',equivalence)]).
nounMapping2SUMO('09148259-n',[ ('City',instance)]).
nounMapping2SUMO('09148422-n',[ ('City',instance)]).
nounMapping2SUMO('09148529-n',[ ('City',instance)]).
nounMapping2SUMO('09148662-n',[ ('City',instance)]).
nounMapping2SUMO('09148871-n',[ ('City',instance)]).
nounMapping2SUMO('09148970-n',[ ('Virginia',equivalence)]).
nounMapping2SUMO('09149934-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09150047-n',[ ('City',instance)]).
nounMapping2SUMO('09150284-n',[ ('City',instance)]).
nounMapping2SUMO('09150448-n',[ ('City',instance)]).
nounMapping2SUMO('09150662-n',[ ('City',instance)]).
nounMapping2SUMO('09150863-n',[ ('City',instance)]).
nounMapping2SUMO('09151114-n',[ ('City',instance)]).
nounMapping2SUMO('09151216-n',[ ('City',instance)]).
nounMapping2SUMO('09151411-n',[ ('City',instance)]).
nounMapping2SUMO('09151516-n',[ ('PortCity',instance)]).
nounMapping2SUMO('09151800-n',[ ('Battle',instance)]).
nounMapping2SUMO('09151963-n',[ ('Battle',instance)]).
nounMapping2SUMO('09152080-n',[ ('Battle',instance)]).
nounMapping2SUMO('09152218-n',[ ('Battle',instance)]).
nounMapping2SUMO('09152401-n',[ ('Battle',instance)]).
nounMapping2SUMO('09152570-n',[ ('Battle',instance)]).
nounMapping2SUMO('09152769-n',[ ('StationaryArtifact',instance)]).
nounMapping2SUMO('09152944-n',[ ('Washington',equivalence)]).
nounMapping2SUMO('09153570-n',[ ('City',instance)]).
nounMapping2SUMO('09153710-n',[ ('City',instance)]).
nounMapping2SUMO('09153873-n',[ ('City',instance)]).
nounMapping2SUMO('09154000-n',[ ('City',instance)]).
nounMapping2SUMO('09154178-n',[ ('PortCity',instance)]).
nounMapping2SUMO('09154607-n',[ ('City',instance)]).
nounMapping2SUMO('09154731-n',[ ('City',instance)]).
nounMapping2SUMO('09154905-n',[ ('City',instance)]).
nounMapping2SUMO('09155065-n',[ ('City',instance)]).
nounMapping2SUMO('09155199-n',[ ('City',instance)]).
nounMapping2SUMO('09155306-n',[ ('WestVirginia',equivalence)]).
nounMapping2SUMO('09155692-n',[ ('City',instance)]).
nounMapping2SUMO('09155798-n',[ ('City',instance)]).
nounMapping2SUMO('09155986-n',[ ('City',instance)]).
nounMapping2SUMO('09156095-n',[ ('City',instance)]).
nounMapping2SUMO('09156241-n',[ ('City',instance)]).
nounMapping2SUMO('09156395-n',[ ('City',instance)]).
nounMapping2SUMO('09156666-n',[ ('City',instance)]).
nounMapping2SUMO('09156889-n',[ ('City',instance)]).
nounMapping2SUMO('09157021-n',[ ('City',instance)]).
nounMapping2SUMO('09157163-n',[ ('Wisconson',equivalence)]).
nounMapping2SUMO('09157555-n',[ ('City',instance)]).
nounMapping2SUMO('09157657-n',[ ('City',instance)]).
nounMapping2SUMO('09157766-n',[ ('City',instance)]).
nounMapping2SUMO('09157896-n',[ ('City',instance)]).
nounMapping2SUMO('09158024-n',[ ('City',instance)]).
nounMapping2SUMO('09158268-n',[ ('City',instance)]).
nounMapping2SUMO('09158501-n',[ ('City',instance)]).
nounMapping2SUMO('09158649-n',[ ('City',instance)]).
nounMapping2SUMO('09158789-n',[ ('City',instance)]).
nounMapping2SUMO('09158897-n',[ ('City',instance)]).
nounMapping2SUMO('09159003-n',[ ('Wyoming',equivalence)]).
nounMapping2SUMO('09159546-n',[ ('City',instance)]).
nounMapping2SUMO('09159675-n',[ ('City',instance)]).
nounMapping2SUMO('09159859-n',[ ('City',instance)]).
nounMapping2SUMO('09159958-n',[ ('City',instance)]).
nounMapping2SUMO('09160056-n',[ ('City',instance)]).
nounMapping2SUMO('09160168-n',[ ('City',instance)]).
nounMapping2SUMO('09160295-n',[ ('Uruguay',equivalence)]).
nounMapping2SUMO('09160571-n',[ ('City',instance)]).
nounMapping2SUMO('09160775-n',[ ('Island',instance)]).
nounMapping2SUMO('09160968-n',[ ('City',instance)]).
nounMapping2SUMO('09161090-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('09161452-n',[ ('City',instance)]).
nounMapping2SUMO('09161615-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09161803-n',[ ('Venezuela',equivalence)]).
nounMapping2SUMO('09162276-n',[ ('City',instance)]).
nounMapping2SUMO('09162414-n',[ ('PortCity',instance)]).
nounMapping2SUMO('09162581-n',[ ('City',instance)]).
nounMapping2SUMO('09162803-n',[ ('PortCity',instance)]).
nounMapping2SUMO('09162955-n',[ ('City',instance)]).
nounMapping2SUMO('09163077-n',[ ('City',instance)]).
nounMapping2SUMO('09163192-n',[ ('Vietnam',equivalence)]).
nounMapping2SUMO('09163584-n',[ ('Nation',instance)]).
nounMapping2SUMO('09163844-n',[ ('Nation',instance)]).
nounMapping2SUMO('09164095-n',[ ('City',instance)]).
nounMapping2SUMO('09164241-n',[ ('City',instance)]).
nounMapping2SUMO('09164417-n',[ ('City',instance)]).
nounMapping2SUMO('09164561-n',[ ('Yemen',equivalence)]).
nounMapping2SUMO('09164903-n',[ ('AdenYemen',equivalence)]).
nounMapping2SUMO('09165146-n',[ ('City',instance)]).
nounMapping2SUMO('09165294-n',[ ('MukallahAdenYemen',equivalence)]).
nounMapping2SUMO('09165464-n',[ ('SanaaYemen',equivalence)]).
nounMapping2SUMO('09165613-n',[ ('Zambia',equivalence)]).
nounMapping2SUMO('09165996-n',[ ('City',instance)]).
nounMapping2SUMO('09166127-n',[ ('Nation',subsumption)]).
nounMapping2SUMO('09166304-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09166534-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09166756-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09166902-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09167101-n',[ ('Zimbabwe',equivalence)]).
nounMapping2SUMO('09167505-n',[ ('City',instance)]).
nounMapping2SUMO('09167652-n',[ ('City',instance)]).
nounMapping2SUMO('09167767-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09168020-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09168193-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09168336-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09168592-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09168707-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09168915-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09169038-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09169188-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09169303-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09169557-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09169690-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09169801-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09169930-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09170109-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09170294-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09170475-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09170633-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09170788-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09170996-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09171204-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09171376-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09171560-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09171674-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09171853-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09171984-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09172111-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09172283-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09172480-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09172634-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09172751-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09172910-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09173023-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09173288-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09173417-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09173623-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09173777-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09174015-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09174166-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09174301-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09174457-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09174566-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09174718-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09174908-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09175016-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09175322-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09175459-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09175617-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09175767-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09175915-n',[ ('Island',instance)]).
nounMapping2SUMO('09176159-n',[ ('Island',instance)]).
nounMapping2SUMO('09176342-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09176446-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09176608-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09176732-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09176844-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09176955-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09177103-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09177249-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09177385-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09177647-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09177883-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09178141-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09178310-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09178481-n',[ ('GeopoliticalArea',subsumption)]).
nounMapping2SUMO('09178596-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09178727-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('09178821-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('09178999-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('09179264-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('09179382-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('09179606-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('09179776-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('09179962-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('09180118-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('09180259-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('09180431-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('09180616-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('09180791-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('09180967-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('09181114-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('09181330-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('09181557-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09181889-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09181993-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09182142-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09182273-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09182401-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09182524-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09182650-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09182784-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09182929-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09183031-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09183140-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('09183255-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09183532-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09183693-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('09183971-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('09184136-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('09184405-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('09184543-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('09184668-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('09184834-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('09184975-n',[ ('Process',subsumption)]).
nounMapping2SUMO('09185280-n',[ ('Process',subsumption)]).
nounMapping2SUMO('09185440-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('09185612-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('09185865-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09186064-n',[ ('River',instance)]).
nounMapping2SUMO('09186225-n',[ ('Bay',instance)]).
nounMapping2SUMO('09186359-n',[ ('LowlandArea',subsumption)]).
nounMapping2SUMO('09186592-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('09186709-n',[ ('River',instance)]).
nounMapping2SUMO('09186928-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09187036-n',[ ('OrganicObject',subsumption)]).
nounMapping2SUMO('09187204-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09187407-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09187594-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09187743-n',[ ('River',instance)]).
nounMapping2SUMO('09187923-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09188094-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09188229-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('09188383-n',[ ('Sea',instance)]).
nounMapping2SUMO('09188609-n',[ ('Sea',instance)]).
nounMapping2SUMO('09188894-n',[ ('Creek',instance)]).
nounMapping2SUMO('09189157-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('09189289-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09189411-n',[ ('Africa',equivalence)]).
nounMapping2SUMO('09190918-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09191427-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('09191635-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('09191707-n',[ ('River',instance)]).
nounMapping2SUMO('09191875-n',[ ('River',instance)]).
nounMapping2SUMO('09192122-n',[ ('Peninsula',instance)]).
nounMapping2SUMO('09192280-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09192462-n',[ ('Star',instance)]).
nounMapping2SUMO('09192566-n',[ ('Star',instance)]).
nounMapping2SUMO('09192708-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09192973-n',[ ('River',instance)]).
nounMapping2SUMO('09193282-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09193551-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09193705-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09193772-n',[ ('Star',instance)]).
nounMapping2SUMO('09193933-n',[ ('Star',instance)]).
nounMapping2SUMO('09194052-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09194227-n',[ ('Glacier',subsumption)]).
nounMapping2SUMO('09194357-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09194710-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09194938-n',[ ('Star',instance)]).
nounMapping2SUMO('09195098-n',[ ('WaterCloud',subsumption)]).
nounMapping2SUMO('09195235-n',[ ('WaterCloud',subsumption)]).
nounMapping2SUMO('09195372-n',[ ('River',instance)]).
nounMapping2SUMO('09195615-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09195796-n',[ ('Waterfall',instance)]).
nounMapping2SUMO('09195958-n',[ ('Indicating',subsumption)]).
nounMapping2SUMO('09196103-n',[ ('River',instance)]).
nounMapping2SUMO('09196302-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09196454-n',[ ('Sea',instance)]).
nounMapping2SUMO('09196611-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09197271-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09197432-n',[ ('River',instance)]).
nounMapping2SUMO('09197660-n',[ ('Waterfall',instance)]).
nounMapping2SUMO('09197815-n',[ ('Atom',subsumption)]).
nounMapping2SUMO('09197945-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09198106-n',[ ('Antarctica',equivalence)]).
nounMapping2SUMO('09198574-n',[ ('SouthernOcean',instance)]).
nounMapping2SUMO('09198755-n',[ ('Peninsula',instance)]).
nounMapping2SUMO('09198997-n',[ ('Star',instance)]).
nounMapping2SUMO('09199101-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09199219-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09199341-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09199498-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09199581-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09199728-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09199817-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09199904-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09200193-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09200317-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09200419-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09200527-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09200649-n',[ ('River',instance)]).
nounMapping2SUMO('09200874-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09201031-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09201189-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09201301-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09201714-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09201840-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09201998-n',[ ('Water',subsumption)]).
nounMapping2SUMO('09202142-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09202285-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09202405-n',[ ('Sea',instance)]).
nounMapping2SUMO('09202603-n',[ ('Sea',instance)]).
nounMapping2SUMO('09202810-n',[ ('River',instance)]).
nounMapping2SUMO('09203032-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09203217-n',[ ('River',instance)]).
nounMapping2SUMO('09203481-n',[ ('River',instance)]).
nounMapping2SUMO('09203677-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09203827-n',[ ('Archipelago',equivalence)]).
nounMapping2SUMO('09204977-n',[ ('ArcticOcean',instance)]).
nounMapping2SUMO('09205334-n',[ ('Star',instance)]).
nounMapping2SUMO('09205509-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09205607-n',[ ('Collection',instance)]).
nounMapping2SUMO('09205890-n',[ ('River',instance)]).
nounMapping2SUMO('09206133-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09206289-n',[ ('Hole',instance)]).
nounMapping2SUMO('09206375-n',[ ('River',instance)]).
nounMapping2SUMO('09206693-n',[ ('River',instance)]).
nounMapping2SUMO('09206896-n',[ ('Creek',subsumption)]).
nounMapping2SUMO('09206985-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09207288-n',[ ('Asia',equivalence)]).
nounMapping2SUMO('09208496-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09208702-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09209025-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09209132-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09209263-n',[ ('AtlanticOcean',equivalence)]).
nounMapping2SUMO('09210236-n',[ ('ShoreArea',instance)]).
nounMapping2SUMO('09210346-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09210604-n',[ ('Atmosphere',equivalence)]).
nounMapping2SUMO('09210862-n',[ ('Atoll',equivalence)]).
nounMapping2SUMO('09211056-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09211266-n',[ ('Australia',equivalence)]).
nounMapping2SUMO('09211735-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09211944-n',[ ('River',instance)]).
nounMapping2SUMO('09212151-n',[ ('River',instance)]).
nounMapping2SUMO('09212360-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('09212572-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09212690-n',[ ('Bay',instance)]).
nounMapping2SUMO('09212935-n',[ ('Lake',instance)]).
nounMapping2SUMO('09213076-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09213254-n',[ ('Sea',instance)]).
nounMapping2SUMO('09213434-n',[ ('UplandArea',subsumption)]).
nounMapping2SUMO('09213565-n',[ ('ShoreArea',equivalence)]).
nounMapping2SUMO('09213828-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09214060-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09214269-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09214422-n',[ ('Sea',instance)]).
nounMapping2SUMO('09214581-n',[ ('Barrier',equivalence)]).
nounMapping2SUMO('09214760-n',[ ('Island',instance)]).
nounMapping2SUMO('09214916-n',[ ('Reef',equivalence)]).
nounMapping2SUMO('09215023-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09215315-n',[ ('Region',subsumption)]).
nounMapping2SUMO('09215437-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09215664-n',[ ('Bay',equivalence)]).
nounMapping2SUMO('09216442-n',[ ('Bay',instance)]).
nounMapping2SUMO('09216588-n',[ ('Bay',instance)]).
nounMapping2SUMO('09216781-n',[ ('Bay',instance)]).
nounMapping2SUMO('09216968-n',[ ('Bay',instance)]).
nounMapping2SUMO('09217086-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('09217230-n',[ ('ShoreArea',equivalence)]).
nounMapping2SUMO('09217414-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09217508-n',[ ('Sea',instance)]).
nounMapping2SUMO('09217638-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09217867-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09218044-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09218159-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('09218315-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('09218494-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09218641-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09218782-n',[ ('Sea',instance)]).
nounMapping2SUMO('09218963-n',[ ('Strait',instance)]).
nounMapping2SUMO('09219078-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09219233-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09219349-n',[ ('Star',instance)]).
nounMapping2SUMO('09219467-n',[ ('Star',instance)]).
nounMapping2SUMO('09219592-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09219731-n',[ ('Star',instance)]).
nounMapping2SUMO('09219858-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09220046-n',[ ('River',instance)]).
nounMapping2SUMO('09220239-n',[ ('Bay',subsumption)]).
nounMapping2SUMO('09220434-n',[ ('Bay',instance)]).
nounMapping2SUMO('09220574-n',[ ('River',instance)]).
nounMapping2SUMO('09220770-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09220922-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('09221070-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09221424-n',[ ('BiologicalAgent',equivalence)]).
nounMapping2SUMO('09221571-n',[ ('Nest',subsumption)]).
nounMapping2SUMO('09221723-n',[ ('Bay',instance)]).
nounMapping2SUMO('09221900-n',[ ('Sea',instance)]).
nounMapping2SUMO('09222051-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09222406-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09222742-n',[ ('Forest',instance)]).
nounMapping2SUMO('09222880-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09223177-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09223325-n',[ ('Sea',instance)]).
nounMapping2SUMO('09223487-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09223591-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09223725-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('09223911-n',[ ('Barrier',subsumption)]).
nounMapping2SUMO('09224193-n',[ ('River',instance)]).
nounMapping2SUMO('09224325-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09224566-n',[ ('AtmosphericRegion',subsumption)]).
nounMapping2SUMO('09224725-n',[ ('UplandArea',subsumption)]).
nounMapping2SUMO('09224828-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09224911-n',[ ('SelfConnectedObject',equivalence)]).
nounMapping2SUMO('09225146-n',[ ('WaterArea',equivalence)]).
nounMapping2SUMO('09225943-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('09226209-n',[ ('WaterArea',instance)]).
nounMapping2SUMO('09226367-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09226498-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09226591-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09226738-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09226869-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09226997-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09227219-n',[ ('Strait',instance)]).
nounMapping2SUMO('09227428-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09227530-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09227683-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09227839-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09228055-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09228144-n',[ ('River',instance)]).
nounMapping2SUMO('09228324-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09228492-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('09228619-n',[ ('River',instance)]).
nounMapping2SUMO('09228801-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09228928-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09229158-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('09229249-n',[ ('Channel',instance)]).
nounMapping2SUMO('09229409-n',[ ('Creek',subsumption)]).
nounMapping2SUMO('09229641-n',[ ('Creek',subsumption)]).
nounMapping2SUMO('09229709-n',[ ('Bubble',subsumption)]).
nounMapping2SUMO('09229941-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09230041-n',[ ('Burrow',subsumption)]).
nounMapping2SUMO('09230202-n',[ ('Butte',equivalence)]).
nounMapping2SUMO('09230361-n',[ ('Bay',instance)]).
nounMapping2SUMO('09230500-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09230646-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09230768-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09231117-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09231263-n',[ ('Moon',instance)]).
nounMapping2SUMO('09231361-n',[ ('River',instance)]).
nounMapping2SUMO('09231587-n',[ ('River',instance)]).
nounMapping2SUMO('09231761-n',[ ('Plateau',instance)]).
nounMapping2SUMO('09231890-n',[ ('River',instance)]).
nounMapping2SUMO('09232165-n',[ ('Waterfall',instance)]).
nounMapping2SUMO('09232317-n',[ ('Region',subsumption)]).
nounMapping2SUMO('09232526-n',[ ('Lake',instance)]).
nounMapping2SUMO('09232687-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09232841-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09232989-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09233134-n',[ ('Star',instance)]).
nounMapping2SUMO('09233284-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09233446-n',[ ('Canyon',subsumption)]).
nounMapping2SUMO('09233603-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09233715-n',[ ('Cape',subsumption)]).
nounMapping2SUMO('09234104-n',[ ('Cape',instance)]).
nounMapping2SUMO('09234374-n',[ ('Bay',instance)]).
nounMapping2SUMO('09234491-n',[ ('River',instance)]).
nounMapping2SUMO('09234654-n',[ ('Star',instance)]).
nounMapping2SUMO('09234756-n',[ ('Cape',instance)]).
nounMapping2SUMO('09234885-n',[ ('Cape',instance)]).
nounMapping2SUMO('09235053-n',[ ('Cape',instance)]).
nounMapping2SUMO('09235244-n',[ ('Cape',instance)]).
nounMapping2SUMO('09235469-n',[ ('Peninsula',instance)]).
nounMapping2SUMO('09235713-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09235894-n',[ ('Sea',instance)]).
nounMapping2SUMO('09236077-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09236251-n',[ ('Hole',instance)]).
nounMapping2SUMO('09236423-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09236766-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('09236957-n',[ ('Waterfall',subsumption)]).
nounMapping2SUMO('09237076-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09237404-n',[ ('Sea',instance)]).
nounMapping2SUMO('09237627-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09237749-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09237918-n',[ ('Waterfall',subsumption)]).
nounMapping2SUMO('09238030-n',[ ('Canyon',instance)]).
nounMapping2SUMO('09238143-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09238294-n',[ ('Atom',subsumption)]).
nounMapping2SUMO('09238425-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09238674-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09238926-n',[ ('Cave',equivalence)]).
nounMapping2SUMO('09239302-n',[ ('Cave',subsumption)]).
nounMapping2SUMO('09239451-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09239581-n',[ ('Lake',instance)]).
nounMapping2SUMO('09239740-n',[ ('AstronomicalBody',equivalence)]).
nounMapping2SUMO('09240051-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09240272-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09240409-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09240507-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09240621-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('09240889-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09241047-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09241247-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09241712-n',[ ('River',instance)]).
nounMapping2SUMO('09241929-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09242037-n',[ ('River',instance)]).
nounMapping2SUMO('09242232-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09242389-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09242514-n',[ ('River',instance)]).
nounMapping2SUMO('09242767-n',[ ('Lake',instance)]).
nounMapping2SUMO('09242956-n',[ ('Lake',instance)]).
nounMapping2SUMO('09243100-n',[ ('Lake',instance)]).
nounMapping2SUMO('09243209-n',[ ('Lake',instance)]).
nounMapping2SUMO('09243405-n',[ ('Bay',instance)]).
nounMapping2SUMO('09243615-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09243769-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09243906-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('09244022-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09244191-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09244331-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09244469-n',[ ('Region',subsumption)]).
nounMapping2SUMO('09244683-n',[ ('Peninsula',instance)]).
nounMapping2SUMO('09244831-n',[ ('Sea',instance)]).
nounMapping2SUMO('09244972-n',[ ('River',instance)]).
nounMapping2SUMO('09245212-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09245370-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09245515-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09245650-n',[ ('WaterCloud',subsumption)]).
nounMapping2SUMO('09245833-n',[ ('WaterCloud',subsumption)]).
nounMapping2SUMO('09245964-n',[ ('WaterCloud',subsumption)]).
nounMapping2SUMO('09246134-n',[ ('Rock',subsumption)]).
nounMapping2SUMO('09246292-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09246464-n',[ ('SlopedArea',subsumption)]).
nounMapping2SUMO('09246660-n',[ ('River',instance)]).
nounMapping2SUMO('09246883-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('09247071-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09247410-n',[ ('Cloud',equivalence)]).
nounMapping2SUMO('09247847-n',[ ('WaterCloud',subsumption)]).
nounMapping2SUMO('09247942-n',[ ('River',subsumption)]).
nounMapping2SUMO('09248153-n',[ ('SlopedArea',subsumption)]).
nounMapping2SUMO('09248294-n',[ ('Plain',subsumption)]).
nounMapping2SUMO('09248399-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09248477-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09248724-n',[ ('River',instance)]).
nounMapping2SUMO('09248914-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09249034-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09249155-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09249272-n',[ ('Region',subsumption)]).
nounMapping2SUMO('09249418-n',[ ('River',instance)]).
nounMapping2SUMO('09250016-n',[ ('River',instance)]).
nounMapping2SUMO('09250165-n',[ ('Plateau',instance)]).
nounMapping2SUMO('09250551-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09250678-n',[ ('River',instance)]).
nounMapping2SUMO('09251002-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09251229-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09251407-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09251689-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('09251832-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09252078-n',[ ('River',instance)]).
nounMapping2SUMO('09252273-n',[ ('River',instance)]).
nounMapping2SUMO('09252586-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('09252766-n',[ ('Lake',instance)]).
nounMapping2SUMO('09252970-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09254614-n',[ ('Continent',equivalence)]).
nounMapping2SUMO('09255070-n',[ ('Glacier',subsumption)]).
nounMapping2SUMO('09255207-n',[ ('SaltWaterArea',subsumption)]).
nounMapping2SUMO('09255343-n',[ ('SaltWaterArea',subsumption)]).
nounMapping2SUMO('09255519-n',[ ('WaterCloud',subsumption)]).
nounMapping2SUMO('09255768-n',[ ('Strait',instance)]).
nounMapping2SUMO('09255921-n',[ ('River',instance)]).
nounMapping2SUMO('09256182-n',[ ('Hole',instance)]).
nounMapping2SUMO('09256272-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('09256360-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('09256479-n',[ ('Reef',subsumption)]).
nounMapping2SUMO('09256663-n',[ ('Sea',instance)]).
nounMapping2SUMO('09256815-n',[ ('Region',subsumption)]).
nounMapping2SUMO('09256895-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('09257011-n',[ ('Region',subsumption)]).
nounMapping2SUMO('09257141-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09257280-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09257429-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09257563-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09257761-n',[ ('Cove',equivalence)]).
nounMapping2SUMO('09257843-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09257949-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09258587-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09258715-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09259025-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09259104-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09259219-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09259376-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09259500-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09259677-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09259746-n',[ ('WaterArea',instance)]).
nounMapping2SUMO('09260010-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09260218-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('09260466-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09260744-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09260907-n',[ ('CultivatedLandArea',equivalence)]).
nounMapping2SUMO('09261138-n',[ ('River',instance)]).
nounMapping2SUMO('09261407-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09261604-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09261772-n',[ ('WaterCloud',subsumption)]).
nounMapping2SUMO('09261960-n',[ ('WaterCloud',subsumption)]).
nounMapping2SUMO('09262082-n',[ ('Waterfall',instance)]).
nounMapping2SUMO('09262233-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09262371-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09262490-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09262690-n',[ ('Valley',subsumption)]).
nounMapping2SUMO('09262798-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('09262955-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('09263087-n',[ ('River',instance)]).
nounMapping2SUMO('09263479-n',[ ('FreshWaterArea',instance)]).
nounMapping2SUMO('09263619-n',[ ('Sea',instance)]).
nounMapping2SUMO('09263811-n',[ ('Ocean',subsumption)]).
nounMapping2SUMO('09263912-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09264021-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09264116-n',[ ('River',instance)]).
nounMapping2SUMO('09264425-n',[ ('Bay',instance)]).
nounMapping2SUMO('09264599-n',[ ('Forest',subsumption)]).
nounMapping2SUMO('09264680-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09264803-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09265025-n',[ ('Electron',subsumption)]).
nounMapping2SUMO('09265134-n',[ ('River',subsumption)]).
nounMapping2SUMO('09265274-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09265392-n',[ ('Star',instance)]).
nounMapping2SUMO('09265492-n',[ ('Star',instance)]).
nounMapping2SUMO('09265620-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09265910-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('09266052-n',[ ('River',instance)]).
nounMapping2SUMO('09266287-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09266453-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09266604-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09266790-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09266946-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09267128-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('09267227-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('09267490-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('09267602-n',[ ('River',subsumption)]).
nounMapping2SUMO('09267758-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('09267854-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('09268007-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09268236-n',[ ('River',instance)]).
nounMapping2SUMO('09268480-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('09268592-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09268778-n',[ ('River',instance)]).
nounMapping2SUMO('09268927-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09269174-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09269341-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09269472-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09269573-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09269717-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09269882-n',[ ('Creek',subsumption)]).
nounMapping2SUMO('09269972-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('09270160-n',[ ('Nest',subsumption)]).
nounMapping2SUMO('09270233-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09270414-n',[ ('Ice',subsumption)]).
nounMapping2SUMO('09270508-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('09270657-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09270735-n',[ ('Sand',subsumption)]).
nounMapping2SUMO('09270894-n',[ ('PlanetEarth',equivalence)]).
nounMapping2SUMO('09271291-n',[ ('Sea',instance)]).
nounMapping2SUMO('09271415-n',[ ('River',instance)]).
nounMapping2SUMO('09271558-n',[ ('River',instance)]).
nounMapping2SUMO('09271774-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('09271904-n',[ ('Electron',equivalence)]).
nounMapping2SUMO('09272085-n',[ ('SubatomicParticle',equivalence)]).
nounMapping2SUMO('09272468-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('09272595-n',[ ('River',instance)]).
nounMapping2SUMO('09272773-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09272927-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09273130-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09273291-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09273447-n',[ ('Channel',instance)]).
nounMapping2SUMO('09273681-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09273776-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('09273928-n',[ ('Star',instance)]).
nounMapping2SUMO('09274032-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09274152-n',[ ('SlopedArea',subsumption)]).
nounMapping2SUMO('09274305-n',[ ('UplandArea',subsumption)]).
nounMapping2SUMO('09274500-n',[ ('Estuary',equivalence)]).
nounMapping2SUMO('09274739-n',[ ('River',instance)]).
nounMapping2SUMO('09275016-n',[ ('Continent',instance)]).
nounMapping2SUMO('09275335-n',[ ('Moon',instance)]).
nounMapping2SUMO('09275473-n',[ ('Europe',equivalence)]).
nounMapping2SUMO('09276872-n',[ ('PlanetVenus',equivalence)]).
nounMapping2SUMO('09277010-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09277279-n',[ ('Swamp',instance)]).
nounMapping2SUMO('09277432-n',[ ('AtmosphericRegion',subsumption)]).
nounMapping2SUMO('09277538-n',[ ('Region',subsumption)]).
nounMapping2SUMO('09277686-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09277913-n',[ ('Lake',instance)]).
nounMapping2SUMO('09278162-n',[ ('Peninsula',instance)]).
nounMapping2SUMO('09278295-n',[ ('CultivatedLandArea',subsumption)]).
nounMapping2SUMO('09278432-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09278537-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09278997-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09279161-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09279345-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09279458-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09279727-n',[ ('Cave',instance)]).
nounMapping2SUMO('09279870-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('09279986-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('09280113-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09280236-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09280380-n',[ ('Estuary',subsumption)]).
nounMapping2SUMO('09280573-n',[ ('Estuary',instance)]).
nounMapping2SUMO('09280731-n',[ ('Estuary',instance)]).
nounMapping2SUMO('09280913-n',[ ('FreshWaterArea',subsumption)]).
nounMapping2SUMO('09280995-n',[ ('Star',subsumption)]).
nounMapping2SUMO('09281104-n',[ ('InletPassage',subsumption)]).
nounMapping2SUMO('09281252-n',[ ('Star',subsumption)]).
nounMapping2SUMO('09281411-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09281545-n',[ ('River',instance)]).
nounMapping2SUMO('09281777-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('09281914-n',[ ('Plain',subsumption)]).
nounMapping2SUMO('09282084-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09282208-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09282363-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09282534-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('09282724-n',[ ('Bubble',subsumption)]).
nounMapping2SUMO('09283066-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09283193-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('09283405-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09283514-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09283623-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09283767-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09283866-n',[ ('ShoreArea',subsumption)]).
nounMapping2SUMO('09284015-n',[ ('Forest',equivalence)]).
nounMapping2SUMO('09284308-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09284433-n',[ ('River',instance)]).
nounMapping2SUMO('09284589-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09284917-n',[ ('StreamWaterArea',instance)]).
nounMapping2SUMO('09285128-n',[ ('River',instance)]).
nounMapping2SUMO('09285254-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09285648-n',[ ('Electron',subsumption)]).
nounMapping2SUMO('09285828-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09285979-n',[ ('Moon',instance)]).
nounMapping2SUMO('09286200-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09286318-n',[ ('Bay',instance)]).
nounMapping2SUMO('09286478-n',[ ('Bay',instance)]).
nounMapping2SUMO('09286630-n',[ ('River',instance)]).
nounMapping2SUMO('09286843-n',[ ('River',instance)]).
nounMapping2SUMO('09287033-n',[ ('Moon',instance)]).
nounMapping2SUMO('09287124-n',[ ('River',instance)]).
nounMapping2SUMO('09287289-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09287415-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09287613-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09287817-n',[ ('Rock',subsumption)]).
nounMapping2SUMO('09287968-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09288635-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09288769-n',[ ('Star',subsumption)]).
nounMapping2SUMO('09288946-n',[ ('River',instance)]).
nounMapping2SUMO('09289177-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09289331-n',[ ('Glacier',equivalence)]).
nounMapping2SUMO('09289596-n',[ ('Valley',subsumption)]).
nounMapping2SUMO('09289709-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09289802-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09289913-n',[ ('Strait',instance)]).
nounMapping2SUMO('09290121-n',[ ('Continent',instance)]).
nounMapping2SUMO('09290350-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09290444-n',[ ('Valley',subsumption)]).
nounMapping2SUMO('09290626-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09290777-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09291027-n',[ ('Valley',subsumption)]).
nounMapping2SUMO('09291185-n',[ ('River',instance)]).
nounMapping2SUMO('09291340-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09291513-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09291633-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09291781-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('09292007-n',[ ('Bay',instance)]).
nounMapping2SUMO('09292189-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09292348-n',[ ('Reef',instance)]).
nounMapping2SUMO('09292545-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09292751-n',[ ('FreshWaterArea',subsumption)]).
nounMapping2SUMO('09293011-n',[ ('Plain',instance)]).
nounMapping2SUMO('09293340-n',[ ('Valley',instance)]).
nounMapping2SUMO('09293613-n',[ ('Lake',instance)]).
nounMapping2SUMO('09293744-n',[ ('Lake',instance)]).
nounMapping2SUMO('09293917-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09294066-n',[ ('River',instance)]).
nounMapping2SUMO('09294285-n',[ ('Sea',instance)]).
nounMapping2SUMO('09294413-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09294599-n',[ ('Forest',subsumption)]).
nounMapping2SUMO('09294716-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09294877-n',[ ('Cave',subsumption)]).
nounMapping2SUMO('09294984-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('09295210-n',[ ('Iceberg',subsumption)]).
nounMapping2SUMO('09295338-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('09295455-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09295576-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09295790-n',[ ('Bay',instance)]).
nounMapping2SUMO('09295946-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09296053-n',[ ('Valley',subsumption)]).
nounMapping2SUMO('09296121-n',[ ('Gulf',equivalence)]).
nounMapping2SUMO('09296695-n',[ ('ShoreArea',instance)]).
nounMapping2SUMO('09296804-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09296937-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09297104-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09297240-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09297423-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09297584-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09297729-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09297920-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09298100-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09298267-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09298410-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09298569-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09298698-n',[ ('GulfOfMexico',equivalence)]).
nounMapping2SUMO('09298974-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09299125-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09299265-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09299397-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09299584-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09299727-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09299885-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09300030-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09300199-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09300306-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09300483-n',[ ('Strait',subsumption)]).
nounMapping2SUMO('09300559-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09300674-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09300905-n',[ ('Water',subsumption)]).
nounMapping2SUMO('09301044-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('09301249-n',[ ('Channel',instance)]).
nounMapping2SUMO('09301461-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09301625-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09301738-n',[ ('Bay',instance)]).
nounMapping2SUMO('09301844-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('09302031-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09302127-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09302263-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09302400-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('09302616-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09302804-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('09303008-n',[ ('Hill',equivalence)]).
nounMapping2SUMO('09303528-n',[ ('SlopedArea',subsumption)]).
nounMapping2SUMO('09303647-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09304164-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09304376-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09304465-n',[ ('Hole',equivalence)]).
nounMapping2SUMO('09304750-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09305031-n',[ ('Valley',subsumption)]).
nounMapping2SUMO('09305229-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09305358-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('09305479-n',[ ('Cape',instance)]).
nounMapping2SUMO('09305646-n',[ ('FreshWaterArea',subsumption)]).
nounMapping2SUMO('09305728-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09305898-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09306031-n',[ ('River',instance)]).
nounMapping2SUMO('09306257-n',[ ('River',instance)]).
nounMapping2SUMO('09306497-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09306642-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09306840-n',[ ('River',instance)]).
nounMapping2SUMO('09307031-n',[ ('Sea',instance)]).
nounMapping2SUMO('09307140-n',[ ('Estuary',instance)]).
nounMapping2SUMO('09307300-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09307552-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09307719-n',[ ('Hydrogen',subsumption)]).
nounMapping2SUMO('09307902-n',[ ('Region',subsumption)]).
nounMapping2SUMO('09308116-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09308242-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09308398-n',[ ('Ice',subsumption)]).
nounMapping2SUMO('09308572-n',[ ('Iceberg',equivalence)]).
nounMapping2SUMO('09308743-n',[ ('Ice',subsumption)]).
nounMapping2SUMO('09308918-n',[ ('Glacier',subsumption)]).
nounMapping2SUMO('09309046-n',[ ('Ice',subsumption)]).
nounMapping2SUMO('09309168-n',[ ('Ice',subsumption)]).
nounMapping2SUMO('09309292-n',[ ('Ice',subsumption)]).
nounMapping2SUMO('09309456-n',[ ('Waterfall',instance)]).
nounMapping2SUMO('09309666-n',[ ('River',instance)]).
nounMapping2SUMO('09309820-n',[ ('Lake',instance)]).
nounMapping2SUMO('09310011-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09310162-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09310314-n',[ ('River',instance)]).
nounMapping2SUMO('09310460-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('09310616-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09310806-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('09311067-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09311259-n',[ ('IndianOcean',equivalence)]).
nounMapping2SUMO('09311710-n',[ ('River',instance)]).
nounMapping2SUMO('09311885-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('09312094-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09312231-n',[ ('River',instance)]).
nounMapping2SUMO('09312516-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09312645-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('09312843-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('09312999-n',[ ('Planet',subsumption)]).
nounMapping2SUMO('09313159-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('09313241-n',[ ('WaterArea',instance)]).
nounMapping2SUMO('09313454-n',[ ('Sea',instance)]).
nounMapping2SUMO('09313716-n',[ ('Inlet',equivalence)]).
nounMapping2SUMO('09314013-n',[ ('Roadway',subsumption)]).
nounMapping2SUMO('09314128-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09314263-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09314398-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09314603-n',[ ('OuterSpaceRegion',subsumption)]).
nounMapping2SUMO('09314829-n',[ ('OuterSpaceRegion',subsumption)]).
nounMapping2SUMO('09314964-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09315057-n',[ ('Moon',instance)]).
nounMapping2SUMO('09315159-n',[ ('Atom',subsumption)]).
nounMapping2SUMO('09315455-n',[ ('Sea',instance)]).
nounMapping2SUMO('09315624-n',[ ('Sea',instance)]).
nounMapping2SUMO('09315762-n',[ ('Iron',subsumption)]).
nounMapping2SUMO('09315870-n',[ ('River',instance)]).
nounMapping2SUMO('09316066-n',[ ('River',instance)]).
nounMapping2SUMO('09316312-n',[ ('River',instance)]).
nounMapping2SUMO('09316454-n',[ ('Island',equivalence)]).
nounMapping2SUMO('09319456-n',[ ('Island',subsumption)]).
nounMapping2SUMO('09319604-n',[ ('Isthmus',equivalence)]).
nounMapping2SUMO('09319902-n',[ ('Isthmus',instance)]).
nounMapping2SUMO('09320111-n',[ ('Isthmus',instance)]).
nounMapping2SUMO('09320239-n',[ ('Isthmus',instance)]).
nounMapping2SUMO('09320485-n',[ ('Isthmus',instance)]).
nounMapping2SUMO('09320611-n',[ ('Isthmus',instance)]).
nounMapping2SUMO('09320826-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('09320985-n',[ ('River',instance)]).
nounMapping2SUMO('09321180-n',[ ('River',instance)]).
nounMapping2SUMO('09321338-n',[ ('Bay',instance)]).
nounMapping2SUMO('09321527-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09321694-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09321901-n',[ ('River',instance)]).
nounMapping2SUMO('09322087-n',[ ('Planet',subsumption)]).
nounMapping2SUMO('09322349-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09322454-n',[ ('PlanetJupiter',equivalence)]).
nounMapping2SUMO('09322701-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09322930-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09323085-n',[ ('River',instance)]).
nounMapping2SUMO('09323221-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09323470-n',[ ('River',instance)]).
nounMapping2SUMO('09323660-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09323824-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09324118-n',[ ('Sea',instance)]).
nounMapping2SUMO('09324322-n',[ ('Isthmus',instance)]).
nounMapping2SUMO('09324474-n',[ ('River',instance)]).
nounMapping2SUMO('09324859-n',[ ('Strait',instance)]).
nounMapping2SUMO('09325038-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09325246-n',[ ('Lake',instance)]).
nounMapping2SUMO('09325395-n',[ ('Reef',subsumption)]).
nounMapping2SUMO('09325530-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09325824-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09325963-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09326139-n',[ ('River',instance)]).
nounMapping2SUMO('09326299-n',[ ('Lake',instance)]).
nounMapping2SUMO('09326467-n',[ ('River',instance)]).
nounMapping2SUMO('09326662-n',[ ('Hill',subsumption)]).
nounMapping2SUMO('09326844-n',[ ('Island',instance)]).
nounMapping2SUMO('09327077-n',[ ('Hill',subsumption)]).
nounMapping2SUMO('09327201-n',[ ('Bay',instance)]).
nounMapping2SUMO('09327361-n',[ ('Strait',instance)]).
nounMapping2SUMO('09327538-n',[ ('Region',subsumption)]).
nounMapping2SUMO('09327705-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09327881-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09328148-n',[ ('River',instance)]).
nounMapping2SUMO('09328311-n',[ ('Peninsula',instance)]).
nounMapping2SUMO('09328596-n',[ ('Sea',instance)]).
nounMapping2SUMO('09328746-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('09328904-n',[ ('Lake',equivalence)]).
nounMapping2SUMO('09330061-n',[ ('Lake',instance)]).
nounMapping2SUMO('09330233-n',[ ('Lake',instance)]).
nounMapping2SUMO('09330378-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09330467-n',[ ('Lake',instance)]).
nounMapping2SUMO('09330604-n',[ ('Lake',instance)]).
nounMapping2SUMO('09330913-n',[ ('Lake',instance)]).
nounMapping2SUMO('09331066-n',[ ('Lake',instance)]).
nounMapping2SUMO('09331251-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09331328-n',[ ('Lake',instance)]).
nounMapping2SUMO('09331535-n',[ ('Lake',instance)]).
nounMapping2SUMO('09331654-n',[ ('Lake',instance)]).
nounMapping2SUMO('09331819-n',[ ('Lake',instance)]).
nounMapping2SUMO('09332050-n',[ ('Lake',instance)]).
nounMapping2SUMO('09332246-n',[ ('Lake',instance)]).
nounMapping2SUMO('09332394-n',[ ('Lake',instance)]).
nounMapping2SUMO('09332598-n',[ ('Lake',instance)]).
nounMapping2SUMO('09332770-n',[ ('Lake',instance)]).
nounMapping2SUMO('09332890-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09332976-n',[ ('Lake',instance)]).
nounMapping2SUMO('09333171-n',[ ('Lake',instance)]).
nounMapping2SUMO('09333334-n',[ ('Lake',instance)]).
nounMapping2SUMO('09333512-n',[ ('Lake',instance)]).
nounMapping2SUMO('09333706-n',[ ('Lake',instance)]).
nounMapping2SUMO('09333905-n',[ ('Lake',instance)]).
nounMapping2SUMO('09334049-n',[ ('Lake',instance)]).
nounMapping2SUMO('09334266-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09334396-n',[ ('LandArea',equivalence)]).
nounMapping2SUMO('09335240-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09335693-n',[ ('ShoreArea',subsumption)]).
nounMapping2SUMO('09335809-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09335916-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09336052-n',[ ('Sea',instance)]).
nounMapping2SUMO('09336271-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09336416-n',[ ('Cave',instance)]).
nounMapping2SUMO('09336555-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('09336702-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09336853-n',[ ('Continent',instance)]).
nounMapping2SUMO('09337048-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09337253-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09337406-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('09337531-n',[ ('River',instance)]).
nounMapping2SUMO('09337686-n',[ ('River',instance)]).
nounMapping2SUMO('09337833-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09338013-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09338243-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09338361-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('09338453-n',[ ('River',instance)]).
nounMapping2SUMO('09338712-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09338910-n',[ ('Peninsula',instance)]).
nounMapping2SUMO('09339109-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09339272-n',[ ('Sea',instance)]).
nounMapping2SUMO('09339414-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('09339512-n',[ ('River',instance)]).
nounMapping2SUMO('09339668-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('09339810-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09340024-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09340203-n',[ ('River',instance)]).
nounMapping2SUMO('09340452-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09340644-n',[ ('River',instance)]).
nounMapping2SUMO('09340935-n',[ ('River',instance)]).
nounMapping2SUMO('09341145-n',[ ('River',instance)]).
nounMapping2SUMO('09341319-n',[ ('Plain',subsumption)]).
nounMapping2SUMO('09341465-n',[ ('Plateau',instance)]).
nounMapping2SUMO('09341673-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09341874-n',[ ('Lake',subsumption)]).
nounMapping2SUMO('09341987-n',[ ('Inlet',subsumption)]).
nounMapping2SUMO('09342141-n',[ ('Lake',instance)]).
nounMapping2SUMO('09342245-n',[ ('Inlet',instance)]).
nounMapping2SUMO('09342386-n',[ ('Lake',instance)]).
nounMapping2SUMO('09342563-n',[ ('Star',subsumption)]).
nounMapping2SUMO('09342729-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09342937-n',[ ('River',instance)]).
nounMapping2SUMO('09343123-n',[ ('Valley',instance)]).
nounMapping2SUMO('09343266-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('09343422-n',[ ('Sound',instance)]).
nounMapping2SUMO('09343587-n',[ ('Lake',subsumption)]).
nounMapping2SUMO('09343660-n',[ ('Cove',instance)]).
nounMapping2SUMO('09343761-n',[ ('Peninsula',instance)]).
nounMapping2SUMO('09343943-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09344050-n',[ ('Peninsula',instance)]).
nounMapping2SUMO('09344198-n',[ ('LowlandArea',subsumption)]).
nounMapping2SUMO('09344324-n',[ ('Region',subsumption)]).
nounMapping2SUMO('09344449-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09344559-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09344724-n',[ ('LandArea',subsumption), ('Hole',subsumption)]).
nounMapping2SUMO('09344863-n',[ ('River',instance)]).
nounMapping2SUMO('09345002-n',[ ('AtmosphericRegion',subsumption)]).
nounMapping2SUMO('09345127-n',[ ('River',instance)]).
nounMapping2SUMO('09345265-n',[ ('River',instance)]).
nounMapping2SUMO('09345503-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09345693-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('09345792-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09345932-n',[ ('SaltWaterArea',subsumption)]).
nounMapping2SUMO('09346120-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09346284-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09346450-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09346613-n',[ ('Region',subsumption)]).
nounMapping2SUMO('09346735-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('09346874-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('09347008-n',[ ('MediterraneanSea',equivalence)]).
nounMapping2SUMO('09347116-n',[ ('WaterCloud',subsumption)]).
nounMapping2SUMO('09347208-n',[ ('Sea',instance)]).
nounMapping2SUMO('09347445-n',[ ('PlanetMars',equivalence)]).
nounMapping2SUMO('09347779-n',[ ('Swamp',subsumption)]).
nounMapping2SUMO('09348055-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09348236-n',[ ('Bay',instance)]).
nounMapping2SUMO('09348460-n',[ ('MountainRange',subsumption)]).
nounMapping2SUMO('09348643-n',[ ('Plateau',instance)]).
nounMapping2SUMO('09348827-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09348949-n',[ ('Wood',subsumption)]).
nounMapping2SUMO('09349055-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('09349192-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09349425-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09349648-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('09349797-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('09350045-n',[ ('MediterraneanSea',equivalence)]).
nounMapping2SUMO('09350524-n',[ ('River',instance)]).
nounMapping2SUMO('09350776-n',[ ('Strait',instance)]).
nounMapping2SUMO('09350922-n',[ ('Glacier',instance)]).
nounMapping2SUMO('09351086-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09351257-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09351408-n',[ ('PlanetMercury',equivalence)]).
nounMapping2SUMO('09351547-n',[ ('Lake',subsumption)]).
nounMapping2SUMO('09351647-n',[ ('River',instance)]).
nounMapping2SUMO('09351905-n',[ ('Mesa',equivalence)]).
nounMapping2SUMO('09352108-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09352282-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09352578-n',[ ('AtmosphericRegion',subsumption)]).
nounMapping2SUMO('09352721-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('09352849-n',[ ('Meteorite',subsumption)]).
nounMapping2SUMO('09353109-n',[ ('Meteoroid',equivalence)]).
nounMapping2SUMO('09353338-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09353437-n',[ ('River',instance)]).
nounMapping2SUMO('09353603-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09353815-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09353918-n',[ ('Meteorite',subsumption)]).
nounMapping2SUMO('09354142-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09354283-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09354511-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09354608-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('09354780-n',[ ('River',instance)]).
nounMapping2SUMO('09354984-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09355261-n',[ ('Lake',subsumption)]).
nounMapping2SUMO('09355397-n',[ ('Bay',instance)]).
nounMapping2SUMO('09355623-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09355850-n',[ ('Swamp',subsumption)]).
nounMapping2SUMO('09356080-n',[ ('MississippiRiver',equivalence)]).
nounMapping2SUMO('09356320-n',[ ('River',instance)]).
nounMapping2SUMO('09356639-n',[ ('River',instance)]).
nounMapping2SUMO('09356781-n',[ ('Bay',instance)]).
nounMapping2SUMO('09356929-n',[ ('River',instance)]).
nounMapping2SUMO('09357080-n',[ ('Region',instance)]).
nounMapping2SUMO('09357346-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09357447-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09357580-n',[ ('River',instance)]).
nounMapping2SUMO('09357847-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09358096-n',[ ('Bay',instance)]).
nounMapping2SUMO('09358226-n',[ ('Moon',equivalence)]).
nounMapping2SUMO('09358358-n',[ ('EarthsMoon',equivalence)]).
nounMapping2SUMO('09358550-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('09358751-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09358907-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('09359031-n',[ ('Inlet',instance)]).
nounMapping2SUMO('09359150-n',[ ('River',instance)]).
nounMapping2SUMO('09359312-n',[ ('Bay',instance)]).
nounMapping2SUMO('09359471-n',[ ('PlanetVenus',subsumption)]).
nounMapping2SUMO('09359631-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('09359803-n',[ ('Mountain',equivalence)]).
nounMapping2SUMO('09360122-n',[ ('Mountain',subsumption)]).
nounMapping2SUMO('09361517-n',[ ('SlopedArea',subsumption)]).
nounMapping2SUMO('09361681-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09361816-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09362050-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09362207-n',[ ('Nest',subsumption)]).
nounMapping2SUMO('09362316-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09362469-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09362666-n',[ ('Channel',instance)]).
nounMapping2SUMO('09362820-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('09362945-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09363064-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09363214-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09363420-n',[ ('River',instance)]).
nounMapping2SUMO('09363620-n',[ ('River',instance)]).
nounMapping2SUMO('09363810-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09363970-n',[ ('Necessity',subsumption)]).
nounMapping2SUMO('09364086-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('09364249-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09364426-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09364582-n',[ ('Cloud',subsumption)]).
nounMapping2SUMO('09364778-n',[ ('River',instance)]).
nounMapping2SUMO('09364954-n',[ ('River',instance)]).
nounMapping2SUMO('09365128-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09365288-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09365443-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09365587-n',[ ('GeographicArea',instance)]).
nounMapping2SUMO('09365730-n',[ ('Bay',instance)]).
nounMapping2SUMO('09365863-n',[ ('Strait',equivalence)]).
nounMapping2SUMO('09366017-n',[ ('LowlandArea',subsumption)]).
nounMapping2SUMO('09366317-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09366597-n',[ ('Physical',equivalence)]).
nounMapping2SUMO('09366762-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09366940-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09367137-n',[ ('Cloud',subsumption)]).
nounMapping2SUMO('09367203-n',[ ('Necessity',subsumption)]).
nounMapping2SUMO('09367733-n',[ ('Peninsula',subsumption)]).
nounMapping2SUMO('09367827-n',[ ('River',instance)]).
nounMapping2SUMO('09367991-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('09368224-n',[ ('Near',subsumption)]).
nounMapping2SUMO('09368479-n',[ ('River',instance)]).
nounMapping2SUMO('09368699-n',[ ('PlanetNeptune',equivalence)]).
nounMapping2SUMO('09369039-n',[ ('ShoreArea',subsumption)]).
nounMapping2SUMO('09369169-n',[ ('Nest',equivalence)]).
nounMapping2SUMO('09369412-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09369520-n',[ ('Neutron',equivalence)]).
nounMapping2SUMO('09369692-n',[ ('Star',subsumption)]).
nounMapping2SUMO('09369844-n',[ ('River',instance)]).
nounMapping2SUMO('09370006-n',[ ('Glacier',subsumption)]).
nounMapping2SUMO('09370168-n',[ ('River',instance)]).
nounMapping2SUMO('09370383-n',[ ('Bay',instance)]).
nounMapping2SUMO('09370552-n',[ ('River',instance)]).
nounMapping2SUMO('09370773-n',[ ('Waterfall',instance)]).
nounMapping2SUMO('09371028-n',[ ('Nest',subsumption)]).
nounMapping2SUMO('09371151-n',[ ('River',instance)]).
nounMapping2SUMO('09371360-n',[ ('River',instance)]).
nounMapping2SUMO('09371686-n',[ ('WaterCloud',subsumption)]).
nounMapping2SUMO('09371816-n',[ ('River',instance)]).
nounMapping2SUMO('09371941-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09372176-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09372313-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09372504-n',[ ('NorthAmerica',equivalence)]).
nounMapping2SUMO('09373016-n',[ ('NorthAtlanticOcean',equivalence)]).
nounMapping2SUMO('09373175-n',[ ('Channel',instance)]).
nounMapping2SUMO('09373333-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09373485-n',[ ('NorthPacificOcean',equivalence)]).
nounMapping2SUMO('09373623-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09373716-n',[ ('River',instance)]).
nounMapping2SUMO('09374036-n',[ ('NorthSea',instance)]).
nounMapping2SUMO('09374306-n',[ ('Sea',instance)]).
nounMapping2SUMO('09374493-n',[ ('Star',subsumption)]).
nounMapping2SUMO('09374646-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09374773-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('09374886-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09375085-n',[ ('AtomicNucleus',equivalence)]).
nounMapping2SUMO('09375223-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09375481-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('09375606-n',[ ('Valley',subsumption)]).
nounMapping2SUMO('09375693-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09375891-n',[ ('River',instance)]).
nounMapping2SUMO('09376078-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('09376198-n',[ ('Ocean',equivalence)]).
nounMapping2SUMO('09376526-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09376786-n',[ ('ShoreArea',subsumption)]).
nounMapping2SUMO('09376866-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09376979-n',[ ('River',instance)]).
nounMapping2SUMO('09377125-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('09377315-n',[ ('River',instance)]).
nounMapping2SUMO('09377511-n',[ ('Liquid',subsumption)]).
nounMapping2SUMO('09377657-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09377861-n',[ ('Lake',instance)]).
nounMapping2SUMO('09378014-n',[ ('Swamp',instance)]).
nounMapping2SUMO('09378178-n',[ ('StreamWaterArea',instance)]).
nounMapping2SUMO('09378349-n',[ ('Valley',instance)]).
nounMapping2SUMO('09378529-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09378801-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09378929-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('09379111-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09379572-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09379705-n',[ ('River',instance)]).
nounMapping2SUMO('09379868-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09379938-n',[ ('River',instance)]).
nounMapping2SUMO('09380117-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09380299-n',[ ('River',instance)]).
nounMapping2SUMO('09380446-n',[ ('Bay',instance)]).
nounMapping2SUMO('09380588-n',[ ('River',instance)]).
nounMapping2SUMO('09380817-n',[ ('River',instance)]).
nounMapping2SUMO('09381048-n',[ ('River',instance)]).
nounMapping2SUMO('09381242-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09381480-n',[ ('Planet',subsumption)]).
nounMapping2SUMO('09381781-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09381880-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09382019-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('09382099-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09382191-n',[ ('Lake',subsumption)]).
nounMapping2SUMO('09382362-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09382570-n',[ ('Region',subsumption)]).
nounMapping2SUMO('09382726-n',[ ('AtmosphericRegion',subsumption)]).
nounMapping2SUMO('09382990-n',[ ('PacificOcean',equivalence)]).
nounMapping2SUMO('09383793-n',[ ('ShoreArea',instance)]).
nounMapping2SUMO('09383901-n',[ ('Ice',subsumption)]).
nounMapping2SUMO('09383998-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09384106-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09384223-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09384532-n',[ ('Continent',instance)]).
nounMapping2SUMO('09384771-n',[ ('River',instance)]).
nounMapping2SUMO('09384921-n',[ ('River',instance)]).
nounMapping2SUMO('09385137-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09385416-n',[ ('River',instance)]).
nounMapping2SUMO('09385586-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09385911-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09386422-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09386842-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09387222-n',[ ('Transitway',subsumption)]).
nounMapping2SUMO('09387624-n',[ ('Waterfall',instance)]).
nounMapping2SUMO('09387764-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09387880-n',[ ('River',instance)]).
nounMapping2SUMO('09388023-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09388121-n',[ ('River',instance)]).
nounMapping2SUMO('09388318-n',[ ('River',instance)]).
nounMapping2SUMO('09388530-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09388653-n',[ ('Plain',subsumption)]).
nounMapping2SUMO('09388848-n',[ ('Peninsula',equivalence)]).
nounMapping2SUMO('09389601-n',[ ('River',instance)]).
nounMapping2SUMO('09389746-n',[ ('Bay',instance)]).
nounMapping2SUMO('09389867-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09389999-n',[ ('Island',instance)]).
nounMapping2SUMO('09390146-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09390236-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09390424-n',[ ('PersianGulf',equivalence)]).
nounMapping2SUMO('09390680-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09390873-n',[ ('Moon',instance)]).
nounMapping2SUMO('09390967-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09391089-n',[ ('Electron',subsumption)]).
nounMapping2SUMO('09391223-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09391386-n',[ ('Region',subsumption)]).
nounMapping2SUMO('09391524-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09391644-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09391774-n',[ ('Glacier',subsumption)]).
nounMapping2SUMO('09391996-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09392162-n',[ ('SelfConnectedObject',instance)]).
nounMapping2SUMO('09392402-n',[ ('Forest',subsumption)]).
nounMapping2SUMO('09392507-n',[ ('River',instance)]).
nounMapping2SUMO('09392656-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09392824-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09392961-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09393108-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09393403-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09393524-n',[ ('ShoreArea',subsumption)]).
nounMapping2SUMO('09393605-n',[ ('Plain',subsumption)]).
nounMapping2SUMO('09394007-n',[ ('Planet',equivalence)]).
nounMapping2SUMO('09394646-n',[ ('Planet',equivalence)]).
nounMapping2SUMO('09394797-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09395086-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09395266-n',[ ('DNAMolecule',subsumption)]).
nounMapping2SUMO('09395457-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09395592-n',[ ('River',instance)]).
nounMapping2SUMO('09395763-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09395899-n',[ ('PlanetPluto',instance)]).
nounMapping2SUMO('09396150-n',[ ('River',instance)]).
nounMapping2SUMO('09396275-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09396465-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09396608-n',[ ('Glacier',subsumption)]).
nounMapping2SUMO('09396712-n',[ ('Star',instance)]).
nounMapping2SUMO('09397001-n',[ ('LowlandArea',subsumption)]).
nounMapping2SUMO('09397150-n',[ ('Star',instance)]).
nounMapping2SUMO('09397268-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('09397391-n',[ ('Lake',subsumption)]).
nounMapping2SUMO('09397607-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('09397896-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09398076-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09398217-n',[ ('River',instance)]).
nounMapping2SUMO('09398533-n',[ ('Lake',instance)]).
nounMapping2SUMO('09398677-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09398769-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('09398935-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('09399198-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('09399485-n',[ ('Star',instance)]).
nounMapping2SUMO('09399592-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09399899-n',[ ('Protein',equivalence)]).
nounMapping2SUMO('09400037-n',[ ('Proton',equivalence)]).
nounMapping2SUMO('09400190-n',[ ('Star',instance)]).
nounMapping2SUMO('09400337-n',[ ('Bay',instance)]).
nounMapping2SUMO('09400485-n',[ ('OrganicObject',subsumption)]).
nounMapping2SUMO('09400584-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09400667-n',[ ('Sound',instance)]).
nounMapping2SUMO('09400826-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09400987-n',[ ('Star',subsumption)]).
nounMapping2SUMO('09401159-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09401340-n',[ ('River',instance)]).
nounMapping2SUMO('09401474-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09401613-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09401750-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09401834-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09402370-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09402553-n',[ ('Sound',instance)]).
nounMapping2SUMO('09402704-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('09402944-n',[ ('Sand',subsumption)]).
nounMapping2SUMO('09403086-n',[ ('Burrow',subsumption)]).
nounMapping2SUMO('09403211-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09403333-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09403427-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('09403581-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09403734-n',[ ('MountainRange',subsumption)]).
nounMapping2SUMO('09405078-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09405169-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09405396-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09405515-n',[ ('River',instance)]).
nounMapping2SUMO('09405683-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09405787-n',[ ('Valley',subsumption)]).
nounMapping2SUMO('09405949-n',[ ('River',instance)]).
nounMapping2SUMO('09406198-n',[ ('Star',subsumption)]).
nounMapping2SUMO('09406368-n',[ ('Star',subsumption)]).
nounMapping2SUMO('09406551-n',[ ('Sea',instance)]).
nounMapping2SUMO('09406793-n',[ ('Reef',equivalence)]).
nounMapping2SUMO('09406944-n',[ ('Star',instance)]).
nounMapping2SUMO('09407043-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('09407194-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09407346-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09407541-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('09407632-n',[ ('River',instance)]).
nounMapping2SUMO('09407867-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('09408105-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('09408250-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('09408412-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09408540-n',[ ('River',instance)]).
nounMapping2SUMO('09408795-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09408977-n',[ ('River',instance)]).
nounMapping2SUMO('09409203-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09409512-n',[ ('UplandArea',subsumption)]).
nounMapping2SUMO('09409752-n',[ ('MountainRange',subsumption)]).
nounMapping2SUMO('09409898-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09410026-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09410101-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09410224-n',[ ('Valley',subsumption)]).
nounMapping2SUMO('09410365-n',[ ('Star',instance)]).
nounMapping2SUMO('09410460-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09410558-n',[ ('River',instance)]).
nounMapping2SUMO('09410724-n',[ ('River',instance)]).
nounMapping2SUMO('09410928-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09411189-n',[ ('Forest',subsumption)]).
nounMapping2SUMO('09411295-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09411430-n',[ ('River',equivalence)]).
nounMapping2SUMO('09415584-n',[ ('RiverBank',equivalence)]).
nounMapping2SUMO('09415671-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09415793-n',[ ('Rock',subsumption)]).
nounMapping2SUMO('09415938-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09416076-n',[ ('Rock',equivalence)]).
nounMapping2SUMO('09416570-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09416890-n',[ ('Roof',equivalence)]).
nounMapping2SUMO('09417097-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09417240-n',[ ('Sea',instance)]).
nounMapping2SUMO('09417365-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09417560-n',[ ('River',instance)]).
nounMapping2SUMO('09417668-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09417926-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('09418059-n',[ ('River',instance)]).
nounMapping2SUMO('09418169-n',[ ('River',instance)]).
nounMapping2SUMO('09418331-n',[ ('River',instance)]).
nounMapping2SUMO('09418484-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09418629-n',[ ('River',instance)]).
nounMapping2SUMO('09418810-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09418954-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09419112-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09419281-n',[ ('River',instance)]).
nounMapping2SUMO('09419536-n',[ ('River',instance)]).
nounMapping2SUMO('09419783-n',[ ('River',instance)]).
nounMapping2SUMO('09420030-n',[ ('River',instance)]).
nounMapping2SUMO('09420273-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09420423-n',[ ('River',instance)]).
nounMapping2SUMO('09420550-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09420689-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09420794-n',[ ('Swamp',subsumption)]).
nounMapping2SUMO('09420911-n',[ ('Lake',instance)]).
nounMapping2SUMO('09421031-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09421191-n',[ ('River',instance)]).
nounMapping2SUMO('09421425-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09421604-n',[ ('LandArea',instance)]).
nounMapping2SUMO('09421799-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09421951-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09422048-n',[ ('Bay',instance)]).
nounMapping2SUMO('09422190-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09422294-n',[ ('Valley',instance)]).
nounMapping2SUMO('09422486-n',[ ('Bay',instance)]).
nounMapping2SUMO('09422631-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09422751-n',[ ('River',instance)]).
nounMapping2SUMO('09422964-n',[ ('Valley',instance)]).
nounMapping2SUMO('09423112-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09423379-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09423617-n',[ ('River',instance)]).
nounMapping2SUMO('09423754-n',[ ('River',instance)]).
nounMapping2SUMO('09423943-n',[ ('Sea',instance)]).
nounMapping2SUMO('09424118-n',[ ('Gulf',instance)]).
nounMapping2SUMO('09424270-n',[ ('Satellite',subsumption)]).
nounMapping2SUMO('09424489-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('09424642-n',[ ('PlanetSaturn',instance)]).
nounMapping2SUMO('09424865-n',[ ('River',instance)]).
nounMapping2SUMO('09425019-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09425159-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09425344-n',[ ('UplandArea',subsumption)]).
nounMapping2SUMO('09425607-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('09425835-n',[ ('River',instance)]).
nounMapping2SUMO('09426038-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09426143-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09426307-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09426494-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09426621-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('09426788-n',[ ('Sea',equivalence)]).
nounMapping2SUMO('09427752-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09427876-n',[ ('Sea',instance)]).
nounMapping2SUMO('09428036-n',[ ('Sea',instance)]).
nounMapping2SUMO('09428171-n',[ ('Sea',instance)]).
nounMapping2SUMO('09428293-n',[ ('ShoreArea',equivalence)]).
nounMapping2SUMO('09428628-n',[ ('ShoreArea',subsumption)]).
nounMapping2SUMO('09428741-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09428967-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('09429194-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09429387-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09429630-n',[ ('Sand',subsumption)]).
nounMapping2SUMO('09429752-n',[ ('River',instance)]).
nounMapping2SUMO('09429934-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09430100-n',[ ('Lake',instance)]).
nounMapping2SUMO('09430259-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09430416-n',[ ('Waterfall',instance)]).
nounMapping2SUMO('09430615-n',[ ('WorldOcean',equivalence)]).
nounMapping2SUMO('09430771-n',[ ('River',instance)]).
nounMapping2SUMO('09430990-n',[ ('River',instance)]).
nounMapping2SUMO('09431133-n',[ ('River',instance)]).
nounMapping2SUMO('09431283-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09431409-n',[ ('River',instance)]).
nounMapping2SUMO('09431569-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09431744-n',[ ('River',instance)]).
nounMapping2SUMO('09431902-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09432060-n',[ ('Flat',subsumption)]).
nounMapping2SUMO('09432163-n',[ ('Water',subsumption)]).
nounMapping2SUMO('09432283-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('09432430-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('09432549-n',[ ('Valley',instance)]).
nounMapping2SUMO('09432785-n',[ ('Forest',instance)]).
nounMapping2SUMO('09432990-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('09433134-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('09433312-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09433442-n',[ ('ShoreArea',equivalence)]).
nounMapping2SUMO('09433721-n',[ ('Rock',subsumption)]).
nounMapping2SUMO('09433839-n',[ ('ShoreArea',subsumption)]).
nounMapping2SUMO('09433952-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('09434125-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09434237-n',[ ('Meteorite',subsumption)]).
nounMapping2SUMO('09434345-n',[ ('MountainRange',subsumption)]).
nounMapping2SUMO('09434469-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09434661-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09434845-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09435065-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09435232-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09435405-n',[ ('Forest',subsumption)]).
nounMapping2SUMO('09435512-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09435739-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09435965-n',[ ('Star',instance)]).
nounMapping2SUMO('09436132-n',[ ('Cape',instance)]).
nounMapping2SUMO('09436299-n',[ ('Strait',instance)]).
nounMapping2SUMO('09436444-n',[ ('SkiingFacility',subsumption)]).
nounMapping2SUMO('09436531-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09436708-n',[ ('SpaceRegion',equivalence)]).
nounMapping2SUMO('09436906-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('09437098-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09437241-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09437369-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09437454-n',[ ('SlopedArea',equivalence)]).
nounMapping2SUMO('09437887-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('09438055-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('09438212-n',[ ('Swamp',subsumption)]).
nounMapping2SUMO('09438313-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('09438408-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09438554-n',[ ('River',instance)]).
nounMapping2SUMO('09438844-n',[ ('Ice',subsumption)]).
nounMapping2SUMO('09438940-n',[ ('Ice',subsumption)]).
nounMapping2SUMO('09439032-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09439120-n',[ ('Bubble',subsumption)]).
nounMapping2SUMO('09439213-n',[ ('Bubble',subsumption)]).
nounMapping2SUMO('09439433-n',[ ('SolarSystem',subsumption)]).
nounMapping2SUMO('09439879-n',[ ('Strait',instance)]).
nounMapping2SUMO('09440036-n',[ ('Inlet',instance)]).
nounMapping2SUMO('09440186-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('09440400-n',[ ('SouthAmerica',equivalence)]).
nounMapping2SUMO('09440948-n',[ ('SouthAtlanticOcean',equivalence)]).
nounMapping2SUMO('09441107-n',[ ('Sea',instance)]).
nounMapping2SUMO('09441352-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09441587-n',[ ('SouthPacificOcean',equivalence)]).
nounMapping2SUMO('09441725-n',[ ('River',instance)]).
nounMapping2SUMO('09441875-n',[ ('Sea',subsumption)]).
nounMapping2SUMO('09442001-n',[ ('Island',subsumption)]).
nounMapping2SUMO('09442146-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09442341-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09442496-n',[ ('Star',instance)]).
nounMapping2SUMO('09442595-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09442723-n',[ ('Wood',subsumption)]).
nounMapping2SUMO('09442838-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09443136-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09443281-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('09443453-n',[ ('Creek',subsumption)]).
nounMapping2SUMO('09443641-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('09443753-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09443921-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09444100-n',[ ('Star',equivalence)]).
nounMapping2SUMO('09444783-n',[ ('Star',subsumption)]).
nounMapping2SUMO('09444942-n',[ ('Star',subsumption)]).
nounMapping2SUMO('09445008-n',[ ('SlopedArea',subsumption)]).
nounMapping2SUMO('09445088-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09445289-n',[ ('Steppe',equivalence)]).
nounMapping2SUMO('09445435-n',[ ('Stone',subsumption)]).
nounMapping2SUMO('09445566-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('09445780-n',[ ('Star',instance)]).
nounMapping2SUMO('09445910-n',[ ('WaterCloud',subsumption)]).
nounMapping2SUMO('09446012-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('09446115-n',[ ('Strait',equivalence)]).
nounMapping2SUMO('09446617-n',[ ('Strait',instance)]).
nounMapping2SUMO('09446747-n',[ ('Strait',instance)]).
nounMapping2SUMO('09446868-n',[ ('Strait',instance)]).
nounMapping2SUMO('09447047-n',[ ('Strait',instance)]).
nounMapping2SUMO('09447335-n',[ ('Strait',instance)]).
nounMapping2SUMO('09447450-n',[ ('Strait',instance)]).
nounMapping2SUMO('09447666-n',[ ('ShoreArea',subsumption)]).
nounMapping2SUMO('09447806-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09447917-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09448090-n',[ ('AtmosphericRegion',subsumption)]).
nounMapping2SUMO('09448251-n',[ ('WaterCloud',subsumption)]).
nounMapping2SUMO('09448361-n',[ ('StreamWaterArea',equivalence)]).
nounMapping2SUMO('09448690-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09448829-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('09448945-n',[ ('Region',subsumption)]).
nounMapping2SUMO('09449127-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09449282-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09449510-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09449657-n',[ ('PlantSubstance',subsumption)]).
nounMapping2SUMO('09449773-n',[ ('River',instance)]).
nounMapping2SUMO('09449949-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09450163-n',[ ('Sol',equivalence)]).
nounMapping2SUMO('09450454-n',[ ('Sol',equivalence)]).
nounMapping2SUMO('09450553-n',[ ('River',instance)]).
nounMapping2SUMO('09450708-n',[ ('Star',subsumption)]).
nounMapping2SUMO('09450866-n',[ ('Planet',subsumption)]).
nounMapping2SUMO('09451103-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('09451237-n',[ ('Star',subsumption)]).
nounMapping2SUMO('09451378-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09451517-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09451864-n',[ ('River',instance)]).
nounMapping2SUMO('09452017-n',[ ('River',instance)]).
nounMapping2SUMO('09452291-n',[ ('LowlandArea',subsumption)]).
nounMapping2SUMO('09452395-n',[ ('Swamp',equivalence)]).
nounMapping2SUMO('09452653-n',[ ('Region',subsumption)]).
nounMapping2SUMO('09452760-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09452866-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('09453008-n',[ ('Plateau',equivalence)]).
nounMapping2SUMO('09453288-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09453566-n',[ ('River',instance)]).
nounMapping2SUMO('09453718-n',[ ('Waterfall',instance)]).
nounMapping2SUMO('09453887-n',[ ('River',instance)]).
nounMapping2SUMO('09454153-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09454265-n',[ ('Bay',instance)]).
nounMapping2SUMO('09454412-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09454642-n',[ ('Lake',subsumption)]).
nounMapping2SUMO('09454744-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09454925-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('09455046-n',[ ('Sea',instance)]).
nounMapping2SUMO('09455206-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09455306-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09455524-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09455640-n',[ ('River',instance)]).
nounMapping2SUMO('09455910-n',[ ('Tent',equivalence)]).
nounMapping2SUMO('09455998-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('09456207-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09456369-n',[ ('Planet',subsumption)]).
nounMapping2SUMO('09456614-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('09456860-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09457020-n',[ ('River',instance)]).
nounMapping2SUMO('09457199-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09457367-n',[ ('AtmosphericRegion',subsumption)]).
nounMapping2SUMO('09457507-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09457693-n',[ ('WaterCloud',subsumption)]).
nounMapping2SUMO('09457851-n',[ ('River',instance)]).
nounMapping2SUMO('09457979-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09458079-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09458269-n',[ ('ShoreArea',subsumption)]).
nounMapping2SUMO('09458372-n',[ ('LowlandArea',subsumption)]).
nounMapping2SUMO('09458494-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09458587-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09458791-n',[ ('River',instance)]).
nounMapping2SUMO('09458967-n',[ ('Sea',instance)]).
nounMapping2SUMO('09459114-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09459269-n',[ ('Moon',instance)]).
nounMapping2SUMO('09459393-n',[ ('River',instance)]).
nounMapping2SUMO('09459557-n',[ ('River',instance)]).
nounMapping2SUMO('09459812-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09459979-n',[ ('Hill',subsumption)]).
nounMapping2SUMO('09460046-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09460139-n',[ ('Strait',instance)]).
nounMapping2SUMO('09460312-n',[ ('LandTransitway',subsumption)]).
nounMapping2SUMO('09460516-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09460680-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('09460888-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09461069-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('09461170-n',[ ('CultivatedLandArea',subsumption)]).
nounMapping2SUMO('09461315-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09461515-n',[ ('River',instance)]).
nounMapping2SUMO('09461724-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09461864-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09462049-n',[ ('River',instance)]).
nounMapping2SUMO('09462231-n',[ ('Moon',instance)]).
nounMapping2SUMO('09462312-n',[ ('Inlet',instance)]).
nounMapping2SUMO('09462452-n',[ ('AtmosphericRegion',subsumption)]).
nounMapping2SUMO('09462600-n',[ ('AtmosphericRegion',subsumption)]).
nounMapping2SUMO('09462773-n',[ ('Region',subsumption)]).
nounMapping2SUMO('09462924-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09463078-n',[ ('Waterfall',instance)]).
nounMapping2SUMO('09463226-n',[ ('Tundra',equivalence)]).
nounMapping2SUMO('09463362-n',[ ('River',instance)]).
nounMapping2SUMO('09463547-n',[ ('River',instance)]).
nounMapping2SUMO('09463721-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09463919-n',[ ('Lawn',equivalence)]).
nounMapping2SUMO('09464098-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09464221-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('09464335-n',[ ('Waterfall',instance)]).
nounMapping2SUMO('09464486-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('09464652-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09464805-n',[ ('River',instance)]).
nounMapping2SUMO('09464962-n',[ ('Sea',instance)]).
nounMapping2SUMO('09465135-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09465290-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09465459-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09465795-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('09465984-n',[ ('WaterArea',instance)]).
nounMapping2SUMO('09466280-n',[ ('Object',equivalence)]).
nounMapping2SUMO('09466678-n',[ ('SlopedArea',subsumption)]).
nounMapping2SUMO('09466757-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09466863-n',[ ('Peninsula',instance)]).
nounMapping2SUMO('09467043-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09467185-n',[ ('MountainRange',instance)]).
nounMapping2SUMO('09467417-n',[ ('PlanetUranus',instance)]).
nounMapping2SUMO('09467696-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09467765-n',[ ('Waterfall',instance)]).
nounMapping2SUMO('09467921-n',[ ('River',instance)]).
nounMapping2SUMO('09468237-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09468447-n',[ ('Electron',subsumption)]).
nounMapping2SUMO('09468604-n',[ ('Valley',equivalence)]).
nounMapping2SUMO('09468959-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('09469152-n',[ ('Star',subsumption)]).
nounMapping2SUMO('09469285-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09469744-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('09469912-n',[ ('Star',instance)]).
nounMapping2SUMO('09470027-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('09470222-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09470343-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09470550-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09470762-n',[ ('PlanetVenus',instance)]).
nounMapping2SUMO('09471224-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09471349-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09471481-n',[ ('River',instance)]).
nounMapping2SUMO('09471638-n',[ ('Waterfall',instance)]).
nounMapping2SUMO('09471865-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09471976-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09472135-n',[ ('River',instance)]).
nounMapping2SUMO('09472268-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09472413-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09472597-n',[ ('VolcanicMountain',equivalence)]).
nounMapping2SUMO('09473239-n',[ ('River',instance)]).
nounMapping2SUMO('09473397-n',[ ('River',instance)]).
nounMapping2SUMO('09473558-n',[ ('River',instance)]).
nounMapping2SUMO('09473685-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09473808-n',[ ('River',instance)]).
nounMapping2SUMO('09474010-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09474162-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09474412-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('09474557-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('09474663-n',[ ('Rock',subsumption)]).
nounMapping2SUMO('09474765-n',[ ('Burrow',subsumption)]).
nounMapping2SUMO('09474895-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09475044-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('09475179-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09475292-n',[ ('Waterfall',equivalence)]).
nounMapping2SUMO('09475716-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09475827-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('09475925-n',[ ('ShoreArea',equivalence)]).
nounMapping2SUMO('09476011-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09476123-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('09476331-n',[ ('WaterArea',subsumption)]).
nounMapping2SUMO('09476521-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('09476717-n',[ ('SubatomicParticle',subsumption)]).
nounMapping2SUMO('09477037-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09477319-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('09477427-n',[ ('Sea',instance)]).
nounMapping2SUMO('09477567-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09477718-n',[ ('River',subsumption)]).
nounMapping2SUMO('09477890-n',[ ('Swamp',subsumption)]).
nounMapping2SUMO('09478047-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09478210-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09478355-n',[ ('River',instance)]).
nounMapping2SUMO('09478569-n',[ ('Star',subsumption)]).
nounMapping2SUMO('09478678-n',[ ('River',instance)]).
nounMapping2SUMO('09478810-n',[ ('Sea',instance)]).
nounMapping2SUMO('09478962-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('09479072-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09479238-n',[ ('Island',instance)]).
nounMapping2SUMO('09479424-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09479635-n',[ ('River',instance)]).
nounMapping2SUMO('09479811-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09479962-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('09480077-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('09480241-n',[ ('Channel',instance)]).
nounMapping2SUMO('09480428-n',[ ('Lake',instance)]).
nounMapping2SUMO('09480556-n',[ ('River',instance)]).
nounMapping2SUMO('09480699-n',[ ('Region',subsumption)]).
nounMapping2SUMO('09480809-n',[ ('GeographicArea',equivalence)]).
nounMapping2SUMO('09480959-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09481036-n',[ ('Burrow',subsumption)]).
nounMapping2SUMO('09481120-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('09481285-n',[ ('River',instance)]).
nounMapping2SUMO('09481523-n',[ ('River',instance)]).
nounMapping2SUMO('09481754-n',[ ('River',instance)]).
nounMapping2SUMO('09481958-n',[ ('Sea',instance)]).
nounMapping2SUMO('09482131-n',[ ('River',instance)]).
nounMapping2SUMO('09482330-n',[ ('River',instance)]).
nounMapping2SUMO('09482566-n',[ ('Mountain',instance)]).
nounMapping2SUMO('09482715-n',[ ('Waterfall',instance)]).
nounMapping2SUMO('09482916-n',[ ('River',instance)]).
nounMapping2SUMO('09483129-n',[ ('River',instance)]).
nounMapping2SUMO('09483340-n',[ ('River',instance)]).
nounMapping2SUMO('09483519-n',[ ('StaticWaterArea',instance)]).
nounMapping2SUMO('09483738-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09484313-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09484465-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09484664-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09486424-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09486639-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09486781-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09487022-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09487252-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09487385-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09487546-n',[ ('Agent',instance)]).
nounMapping2SUMO('09487692-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09487821-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09488006-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09488117-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09488259-n',[ ('Death',equivalence)]).
nounMapping2SUMO('09488448-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09488584-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09488711-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09488995-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09489146-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09489601-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09489697-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09489790-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09489889-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09490054-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09490210-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09490352-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09490572-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09490756-n',[ ('Female',subsumption)]).
nounMapping2SUMO('09490825-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09490961-n',[ ('Female',subsumption)]).
nounMapping2SUMO('09491038-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09491222-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09491324-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09491504-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09491784-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09491966-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09492123-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09492733-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09492877-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09493043-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09493204-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09493374-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09493562-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09493807-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09493983-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09494149-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09494280-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09494388-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09494609-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09494764-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09494951-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09495103-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09495382-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09495619-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09495732-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09495849-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09495962-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09496099-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09496261-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09496460-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09496673-n',[ ('Agent',instance)]).
nounMapping2SUMO('09496802-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09496918-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09497163-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09497364-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09497641-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09497775-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('09497913-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09498072-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09498186-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09498301-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09498497-n',[ ('Man',instance)]).
nounMapping2SUMO('09498697-n',[ ('Man',instance)]).
nounMapping2SUMO('09499056-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09499230-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09499338-n',[ ('Man',instance)]).
nounMapping2SUMO('09499494-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09499657-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09499854-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09500003-n',[ ('Man',instance)]).
nounMapping2SUMO('09500217-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09500398-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09500625-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09500936-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09501198-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09501322-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09501427-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09501527-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09501737-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09502080-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09502298-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09502481-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09502700-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09502906-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09503121-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09503282-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09503486-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09503682-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09503877-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09504135-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09504464-n',[ ('FieldOfStudy',instance)]).
nounMapping2SUMO('09504603-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09504790-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09504915-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09505153-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09505418-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09506216-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09506337-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09506598-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09506674-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09506751-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09506830-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09506973-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09507097-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09507639-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09507756-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09507909-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09508076-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09508228-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09508368-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09508474-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09508666-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09508809-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09508975-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09509119-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09509232-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09509375-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09509546-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09509678-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09509770-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09509911-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09510073-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09510164-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09510305-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09510419-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09510527-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09510643-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09510746-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09510904-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09511368-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09511519-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09511712-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09511875-n',[ ('Agent',instance)]).
nounMapping2SUMO('09512028-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09512157-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09512266-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09512391-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09512516-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09512611-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09512692-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09512835-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09512913-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09513065-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09513216-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09513430-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09513569-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09513744-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09513902-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09515027-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09515131-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09515269-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09515473-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09515570-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09515712-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09515877-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09515988-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09516146-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09516323-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09516498-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09516700-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09516881-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09517057-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09517209-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09517342-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09517492-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09517628-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09517890-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09518020-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09518145-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09518306-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09518451-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09518578-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09518683-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09518782-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09518908-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09519075-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09519192-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09519288-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09519454-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09519596-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09519748-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09519901-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09520103-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09520223-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09520367-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09520498-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09520617-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09520752-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09520880-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09521051-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09521157-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09521395-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09521521-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09521648-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09521763-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09521994-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09522121-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09522222-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09522344-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09522498-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09522615-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09522735-n',[ ('Man',instance)]).
nounMapping2SUMO('09522837-n',[ ('Man',instance)]).
nounMapping2SUMO('09522978-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09524027-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09524151-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09524263-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09524440-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09524555-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09524671-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09524840-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09524921-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09525065-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09525170-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09525279-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09525486-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09525579-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09525746-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09525874-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09525961-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09526107-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09526221-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09526367-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09526497-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09526606-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09526703-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09526808-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09526913-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09527001-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09527091-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09527185-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09527291-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09527454-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09527560-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09527707-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09527825-n',[ ('Sculpture',instance)]).
nounMapping2SUMO('09527924-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09528032-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09528135-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09528237-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09528380-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09528475-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09528587-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09528727-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09528919-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09529013-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09529083-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09529201-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09529364-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09529454-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09529573-n',[ ('Agent',instance)]).
nounMapping2SUMO('09529644-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09529933-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09529999-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09530141-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09530238-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09530515-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09530629-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09530721-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09530867-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09531186-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09531296-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09531409-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09531515-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09531630-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09531826-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09531955-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09532101-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09532214-n',[ ('Man',instance)]).
nounMapping2SUMO('09532384-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09532553-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09532691-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09532837-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09532942-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09533048-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09533301-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09533406-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09533498-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09533668-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09533790-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09533910-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09534058-n',[ ('Man',instance)]).
nounMapping2SUMO('09534187-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09534428-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09534675-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09534843-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09534918-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09535001-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09535130-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09535255-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09535409-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09535504-n',[ ('Man',instance)]).
nounMapping2SUMO('09535622-n',[ ('Female',subsumption)]).
nounMapping2SUMO('09535708-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09535809-n',[ ('Female',subsumption)]).
nounMapping2SUMO('09535940-n',[ ('Female',subsumption)]).
nounMapping2SUMO('09536058-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09536363-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09536584-n',[ ('Agent',instance)]).
nounMapping2SUMO('09536789-n',[ ('Agent',instance)]).
nounMapping2SUMO('09536973-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09537144-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('09537325-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09537502-n',[ ('Man',instance)]).
nounMapping2SUMO('09537660-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09537781-n',[ ('Agent',instance)]).
nounMapping2SUMO('09538021-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09538318-n',[ ('Agent',instance)]).
nounMapping2SUMO('09538544-n',[ ('Agent',instance)]).
nounMapping2SUMO('09538633-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09538757-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09538915-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09539183-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09539394-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09539517-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09539640-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09539730-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09539872-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09540055-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09540241-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09540329-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09540430-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09540739-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09540939-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09541125-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09541346-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09541434-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09541526-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09541661-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09541809-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09541919-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09542170-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09542258-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09542339-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09542541-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09542697-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09542868-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09543021-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09543154-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09543353-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09543673-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09543748-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09543924-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09544109-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09544262-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09544433-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09544746-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09544876-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09545000-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09545171-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09545324-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09545755-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09545976-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09546145-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('09546280-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09546453-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09546604-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09546772-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09546905-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09547111-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09547353-n',[ ('WaterVehicle',instance)]).
nounMapping2SUMO('09547528-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09547629-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09547903-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09548111-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09548316-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09548489-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09548632-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09549047-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09549216-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09549416-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09549643-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09549758-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09549983-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09550125-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09550278-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09550443-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09550585-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09550758-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09550899-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09551040-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09551152-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09551260-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09551356-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09552681-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09553347-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09553490-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09553599-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09553767-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09554019-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09554132-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09554297-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09554505-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09554701-n',[ ('Man',instance)]).
nounMapping2SUMO('09554910-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09555127-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09555236-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09555391-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09555514-n',[ ('Agent',instance)]).
nounMapping2SUMO('09555653-n',[ ('Agent',instance)]).
nounMapping2SUMO('09555785-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09555962-n',[ ('Agent',instance)]).
nounMapping2SUMO('09556121-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09556305-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09556580-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09556697-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09556915-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09557130-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09557289-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09557387-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09557632-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09557770-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09557965-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09558177-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09558388-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09558569-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09558756-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09558898-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09559071-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09559201-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09559404-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09559573-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09559769-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09559896-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09560061-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09560196-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09560426-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09560762-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09560940-n',[ ('Agent',instance)]).
nounMapping2SUMO('09561137-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09561320-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09561593-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09561755-n',[ ('Agent',instance)]).
nounMapping2SUMO('09561970-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09562166-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09562319-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09562526-n',[ ('Agent',instance)]).
nounMapping2SUMO('09562704-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09562883-n',[ ('Agent',instance)]).
nounMapping2SUMO('09563042-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('09563183-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09563425-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09563619-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09563805-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09563998-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09564177-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09564371-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09564480-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09564680-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09564889-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09565099-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09565334-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09565503-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09565639-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09565787-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09565914-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09565999-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09566320-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09566436-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09566544-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09566667-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09566791-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09566904-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09567044-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09567180-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09567309-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09567421-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09567560-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09567767-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09567913-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09568051-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09568241-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09568488-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09568643-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09568776-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09568927-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09569142-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09569330-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09569467-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09569709-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09569985-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09570114-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09570298-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09570522-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09570630-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09570794-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09570957-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09571090-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09571249-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09571390-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09571581-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09571693-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09571914-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09572113-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09572249-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09572425-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09572825-n',[ ('Female',subsumption)]).
nounMapping2SUMO('09573145-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09573262-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09573405-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09573561-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09573682-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09573966-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09574226-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09574350-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09574446-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09574544-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09574657-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09574767-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09574926-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09575033-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09575140-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09575316-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09575548-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09575701-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09575902-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09576164-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09576338-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09576548-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09576746-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09576914-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09577004-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09577155-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09577308-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09577467-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09577601-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09577833-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09578005-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09578248-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09578465-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09579070-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09579198-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09579345-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09579491-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09579714-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09579848-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09579994-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09580125-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09580354-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09580521-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09580673-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09580829-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09580971-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09581129-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09581338-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09581526-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09581680-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09581859-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09582019-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09582122-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09582343-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09582616-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09582726-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09582845-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09582949-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09583196-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09583321-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09583506-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09583723-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09583888-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09584079-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09584218-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09584405-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09584559-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09584725-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09584933-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09585218-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09585434-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09585650-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09585757-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09585889-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09586011-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09586231-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09586326-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09586442-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09586553-n',[ ('Man',instance)]).
nounMapping2SUMO('09586743-n',[ ('Woman',instance)]).
nounMapping2SUMO('09586994-n',[ ('Man',instance)]).
nounMapping2SUMO('09587217-n',[ ('Man',instance)]).
nounMapping2SUMO('09587409-n',[ ('Man',instance)]).
nounMapping2SUMO('09587565-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09589323-n',[ ('Man',instance)]).
nounMapping2SUMO('09589444-n',[ ('Boy',instance)]).
nounMapping2SUMO('09589585-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09589748-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09589876-n',[ ('Woman',instance)]).
nounMapping2SUMO('09589996-n',[ ('Man',instance)]).
nounMapping2SUMO('09590205-n',[ ('Man',instance)]).
nounMapping2SUMO('09590377-n',[ ('Man',instance)]).
nounMapping2SUMO('09590495-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09590772-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09590980-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09591155-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09591450-n',[ ('Man',instance)]).
nounMapping2SUMO('09591676-n',[ ('DomesticCat',instance)]).
nounMapping2SUMO('09591814-n',[ ('Chicken',instance)]).
nounMapping2SUMO('09591973-n',[ ('Girl',instance)]).
nounMapping2SUMO('09592147-n',[ ('Man',instance)]).
nounMapping2SUMO('09592272-n',[ ('Man',instance)]).
nounMapping2SUMO('09592384-n',[ ('Man',instance)]).
nounMapping2SUMO('09592563-n',[ ('Woman',instance)]).
nounMapping2SUMO('09592734-n',[ ('Man',instance)]).
nounMapping2SUMO('09592848-n',[ ('Man',instance)]).
nounMapping2SUMO('09593044-n',[ ('Man',instance)]).
nounMapping2SUMO('09593144-n',[ ('Woman',instance)]).
nounMapping2SUMO('09593416-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09593651-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09593937-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09594093-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09594298-n',[ ('Man',instance)]).
nounMapping2SUMO('09594604-n',[ ('Man',instance)]).
nounMapping2SUMO('09594756-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09594906-n',[ ('Man',instance)]).
nounMapping2SUMO('09595059-n',[ ('Man',instance)]).
nounMapping2SUMO('09595240-n',[ ('SentientAgent',instance)]).
nounMapping2SUMO('09595545-n',[ ('Woman',instance)]).
nounMapping2SUMO('09595717-n',[ ('Man',instance)]).
nounMapping2SUMO('09595957-n',[ ('Man',instance)]).
nounMapping2SUMO('09596186-n',[ ('Woman',instance)]).
nounMapping2SUMO('09596374-n',[ ('Woman',instance)]).
nounMapping2SUMO('09596547-n',[ ('Man',instance)]).
nounMapping2SUMO('09596733-n',[ ('Woman',instance)]).
nounMapping2SUMO('09596884-n',[ ('Woman',instance)]).
nounMapping2SUMO('09597141-n',[ ('Man',instance)]).
nounMapping2SUMO('09597478-n',[ ('Man',instance)]).
nounMapping2SUMO('09597628-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09597798-n',[ ('Man',instance)]).
nounMapping2SUMO('09598066-n',[ ('Man',instance)]).
nounMapping2SUMO('09598270-n',[ ('Man',instance)]).
nounMapping2SUMO('09598370-n',[ ('Man',instance)]).
nounMapping2SUMO('09598491-n',[ ('Man',instance)]).
nounMapping2SUMO('09598598-n',[ ('Man',instance)]).
nounMapping2SUMO('09598750-n',[ ('Man',instance)]).
nounMapping2SUMO('09598888-n',[ ('Man',instance)]).
nounMapping2SUMO('09599023-n',[ ('Man',instance)]).
nounMapping2SUMO('09599195-n',[ ('Man',instance)]).
nounMapping2SUMO('09599401-n',[ ('Man',instance)]).
nounMapping2SUMO('09599633-n',[ ('Canine',instance)]).
nounMapping2SUMO('09599728-n',[ ('Man',instance)]).
nounMapping2SUMO('09599891-n',[ ('Man',instance)]).
nounMapping2SUMO('09600031-n',[ ('Man',instance)]).
nounMapping2SUMO('09600188-n',[ ('Woman',instance)]).
nounMapping2SUMO('09600439-n',[ ('Man',instance)]).
nounMapping2SUMO('09600624-n',[ ('Man',instance)]).
nounMapping2SUMO('09600764-n',[ ('Man',instance)]).
nounMapping2SUMO('09600901-n',[ ('Human',instance)]).
nounMapping2SUMO('09601049-n',[ ('Man',instance)]).
nounMapping2SUMO('09601219-n',[ ('Woman',instance)]).
nounMapping2SUMO('09601429-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09601571-n',[ ('Man',instance)]).
nounMapping2SUMO('09601769-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09601906-n',[ ('Man',instance)]).
nounMapping2SUMO('09602048-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09602162-n',[ ('Man',instance)]).
nounMapping2SUMO('09602258-n',[ ('Man',instance)]).
nounMapping2SUMO('09602383-n',[ ('Man',instance)]).
nounMapping2SUMO('09602484-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09602610-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09602716-n',[ ('Man',instance)]).
nounMapping2SUMO('09602828-n',[ ('Boy',instance)]).
nounMapping2SUMO('09602964-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09603120-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09603258-n',[ ('Man',instance)]).
nounMapping2SUMO('09603353-n',[ ('Boy',instance)]).
nounMapping2SUMO('09603471-n',[ ('Man',subsumption)]).
nounMapping2SUMO('09603667-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09603761-n',[ ('Man',instance)]).
nounMapping2SUMO('09603919-n',[ ('Boy',instance)]).
nounMapping2SUMO('09604014-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09604227-n',[ ('Man',instance)]).
nounMapping2SUMO('09604345-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('09604451-n',[ ('Man',instance)]).
nounMapping2SUMO('09604574-n',[ ('Man',instance)]).
nounMapping2SUMO('09604706-n',[ ('Man',instance)]).
nounMapping2SUMO('09604868-n',[ ('Canine',instance)]).
nounMapping2SUMO('09604981-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09605110-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09605289-n',[ ('FullyFormed',subsumption)]).
nounMapping2SUMO('09606009-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09606380-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09606527-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09606873-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09607055-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09607208-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09607280-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09607630-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09607782-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09607903-n',[ ('Judaism',subsumption)]).
nounMapping2SUMO('09608002-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09608377-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09608520-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09608709-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09609155-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09609232-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09609561-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09609746-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09609871-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09610093-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09610173-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09610255-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09610405-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09610660-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09611548-n',[ ('Judaism',subsumption)]).
nounMapping2SUMO('09611722-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09611884-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09612131-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09612291-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09612447-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('09612580-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('09612700-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09612848-n',[ ('Buyer',subsumption)]).
nounMapping2SUMO('09613118-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09613191-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09613559-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09613690-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09613853-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09614047-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09614315-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09614684-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09615211-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09615336-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09615465-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09615807-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('09616573-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09616722-n',[ ('USMilitaryRankO1',subsumption)]).
nounMapping2SUMO('09616922-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09617161-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09617292-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09617435-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09617508-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09617577-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09617696-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09617867-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('09618760-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09618880-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09618957-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09619168-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09619452-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09619605-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09619734-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09619824-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09620078-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09620794-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09621232-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09621359-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09621545-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09622049-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('09622302-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09622745-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09622928-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09623038-n',[ ('Guiding',equivalence)]).
nounMapping2SUMO('09624168-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09624559-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09624899-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09624980-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09625213-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09625309-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09625401-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09625676-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09625789-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09626031-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09626238-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09626589-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09627017-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09627117-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09627263-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('09627462-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09627807-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09627906-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09628382-n',[ ('Deist',subsumption)]).
nounMapping2SUMO('09629065-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09629246-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09629477-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09629643-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09629752-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09630641-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09631129-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09631463-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09632274-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09632518-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09633969-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09634494-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09635534-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09635635-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09635823-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09635973-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09636106-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09636339-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09636796-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09636890-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09637013-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09637211-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09637339-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09637435-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09637512-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09637684-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09637837-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09638009-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09638245-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09638454-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09638569-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09638722-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09638875-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09639237-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09639382-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09639543-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09639719-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09639919-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09640220-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09640327-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09640490-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09640577-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09640715-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09640859-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09641002-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09641130-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09641226-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09641422-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09641578-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09641757-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09642821-n',[ ('UnitedStates',subsumption)]).
nounMapping2SUMO('09642917-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09643078-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09643421-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09643545-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09643670-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09643799-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09644008-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09644152-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09644332-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09644518-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09644657-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09644820-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09645091-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09645788-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09645871-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09645996-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09646112-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09646220-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09646432-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09646608-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09647473-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09647680-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09647834-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09648176-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09648309-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09648743-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09648911-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09649067-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09649249-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09649372-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09649554-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09649926-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09650250-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09650456-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09650609-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09650729-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09650839-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09650989-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09651123-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09651418-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09651537-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09651653-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09651790-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09651968-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09652149-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09652278-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09652398-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09652535-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09652746-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09652900-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09653014-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09653144-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09653295-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09653438-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09653616-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09653805-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09653971-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09654079-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09654259-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09654374-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09654518-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09654687-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09654898-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09655018-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09655213-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09655354-n',[ ('Judaism',subsumption)]).
nounMapping2SUMO('09655466-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09655569-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09655709-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09655891-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09656077-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09656205-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09656378-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09656547-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09656673-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09657206-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09657489-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09657615-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09657748-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09657887-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09658254-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09658398-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09658543-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09658670-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09658815-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09658921-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09659039-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09659188-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09659327-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09659447-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09659605-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09659711-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09659866-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09660010-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09660138-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09660240-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09660373-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09660524-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09660645-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09660820-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09660958-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09661107-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09661258-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09661397-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09661543-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09661731-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09661873-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09662038-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09662325-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09662530-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09662661-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09662804-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09662951-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09663121-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09663248-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09663472-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09663628-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09663786-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09663999-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09664121-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09664295-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09664450-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09664556-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09664766-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09664908-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09665075-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09665218-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09665367-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09665545-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09665897-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09666039-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09666206-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09666349-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09666476-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09666622-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09666883-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('09666974-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09667097-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09667205-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09667358-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09667572-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09667715-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09667927-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09668058-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09668199-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09668437-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09668562-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09668729-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09668988-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09669125-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09669631-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09669942-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09670051-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09670170-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09670280-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09670415-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09670521-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09670637-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09670772-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09670909-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09671089-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09671202-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09671334-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09671453-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09671641-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09671808-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09671974-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09672105-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09672314-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09672455-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09672590-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09672725-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09672840-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09672963-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09673091-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09673232-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09673341-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09673495-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09673779-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09673916-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09674307-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09674412-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09674521-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09674631-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09674786-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09674908-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09675045-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09675156-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09675283-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09675393-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09675529-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09675673-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09675799-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09675922-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09676021-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09676127-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09676247-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09676374-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09676490-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09676746-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09676884-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09677168-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09677280-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09677427-n',[ ('Protestant',subsumption)]).
nounMapping2SUMO('09677561-n',[ ('Christian',subsumption)]).
nounMapping2SUMO('09677713-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09677830-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09678009-n',[ ('Christian',equivalence)]).
nounMapping2SUMO('09678581-n',[ ('Protestant',subsumption)]).
nounMapping2SUMO('09678747-n',[ ('Protestant',subsumption)]).
nounMapping2SUMO('09678917-n',[ ('Christian',subsumption)]).
nounMapping2SUMO('09679028-n',[ ('Christian',subsumption)]).
nounMapping2SUMO('09679170-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09679316-n',[ ('Protestant',equivalence)]).
nounMapping2SUMO('09679708-n',[ ('Protestant',subsumption)]).
nounMapping2SUMO('09679925-n',[ ('Catholic',equivalence)]).
nounMapping2SUMO('09680136-n',[ ('ReligiousAttribute',subsumption)]).
nounMapping2SUMO('09680235-n',[ ('Christian',subsumption)]).
nounMapping2SUMO('09680387-n',[ ('EasternOrthodoxChristian',equivalence)]).
nounMapping2SUMO('09680504-n',[ ('Catholic',equivalence)]).
nounMapping2SUMO('09680657-n',[ ('Catholic',subsumption)]).
nounMapping2SUMO('09680908-n',[ ('Catholic',subsumption)]).
nounMapping2SUMO('09681107-n',[ ('Christian',subsumption)]).
nounMapping2SUMO('09681234-n',[ ('Christian',subsumption)]).
nounMapping2SUMO('09681351-n',[ ('ReligiousJew',subsumption)]).
nounMapping2SUMO('09681973-n',[ ('Female',subsumption), ('Human',subsumption), ('ReligiousJew',subsumption)]).
nounMapping2SUMO('09682122-n',[ ('Human',subsumption), ('ReligiousJew',subsumption)]).
nounMapping2SUMO('09682291-n',[ ('Muslim',equivalence)]).
nounMapping2SUMO('09682803-n',[ ('Muslim',subsumption)]).
nounMapping2SUMO('09682967-n',[ ('Muslim',subsumption)]).
nounMapping2SUMO('09683180-n',[ ('Muslim',subsumption)]).
nounMapping2SUMO('09683306-n',[ ('Muslim',subsumption)]).
nounMapping2SUMO('09683559-n',[ ('Muslim',subsumption)]).
nounMapping2SUMO('09683757-n',[ ('Buddhist',equivalence)]).
nounMapping2SUMO('09683924-n',[ ('Buddhist',subsumption)]).
nounMapping2SUMO('09684082-n',[ ('Buddhist',subsumption)]).
nounMapping2SUMO('09684226-n',[ ('Buddhist',subsumption)]).
nounMapping2SUMO('09684352-n',[ ('Buddhist',subsumption)]).
nounMapping2SUMO('09684476-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09684609-n',[ ('Hindu',equivalence)]).
nounMapping2SUMO('09684901-n',[ ('Hindu',subsumption)]).
nounMapping2SUMO('09685006-n',[ ('Hindu',subsumption)]).
nounMapping2SUMO('09685085-n',[ ('Jain',equivalence)]).
nounMapping2SUMO('09685233-n',[ ('ReligiousAttribute',instance)]).
nounMapping2SUMO('09685398-n',[ ('ReligiousAttribute',instance)]).
nounMapping2SUMO('09685564-n',[ ('ReligiousAttribute',instance)]).
nounMapping2SUMO('09685711-n',[ ('ReligiousAttribute',instance)]).
nounMapping2SUMO('09685806-n',[ ('Shintoist',equivalence)]).
nounMapping2SUMO('09685922-n',[ ('ReligiousAttribute',instance)]).
nounMapping2SUMO('09686051-n',[ ('ReligiousAttribute',instance)]).
nounMapping2SUMO('09686146-n',[ ('Zoroastrian',equivalence)]).
nounMapping2SUMO('09686262-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09686401-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09686536-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09687775-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09687940-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09688008-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09688233-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09688366-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09688487-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09688596-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09688804-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09689000-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09689152-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09689435-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09689631-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09689739-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09689958-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09690083-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09690208-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09690371-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09690496-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09690621-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09690762-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09690864-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09691024-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09691149-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09691279-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09691435-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09691604-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09691729-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09691858-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09691994-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09692125-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09692250-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09692430-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09692624-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09692915-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09693100-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09693244-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09693372-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('09693618-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09693809-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09693982-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09694109-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09694269-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09694392-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09694529-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09694664-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09694771-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09694894-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09695019-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09695132-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09695257-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09695379-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09695514-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09695620-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09695747-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09695871-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09695979-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09696124-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09696280-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09696456-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09696585-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09696763-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09696944-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09697070-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09697246-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09697401-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09697650-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09697771-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09697986-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09698108-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09698337-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09698517-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09698644-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09698788-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09698901-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09699020-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09699200-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09699403-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09699536-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09699642-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09699763-n',[ ('Group',subsumption)]).
nounMapping2SUMO('09699918-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09700017-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09700125-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09700253-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09700371-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09700492-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09700706-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09700823-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09700964-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09701148-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09701603-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09701833-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09701977-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09702134-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09702541-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09702673-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09702836-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09703101-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09703181-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09703344-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09703485-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09703573-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09703708-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09703809-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09703932-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09704057-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09704157-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09704283-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09704368-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09704509-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09704630-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09704770-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09704876-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09705003-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09705124-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09705287-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09705471-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09705671-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09705784-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09705909-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09706029-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09706132-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09706255-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09706396-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09706548-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09706746-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09706911-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09707061-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09707166-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09707289-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09707400-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09707587-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09707735-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09707887-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09707992-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09708118-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09708247-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09708405-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09708648-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09708750-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09708889-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09709001-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09709155-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09709229-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09709332-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09709441-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09709531-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09709673-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09709795-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09709916-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09710041-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09710164-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09710619-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09710753-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09710886-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09711009-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09711132-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09711320-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09711435-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09711530-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09711661-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09711754-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09711870-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09711978-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09712090-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('09712195-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09712324-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09712448-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09712570-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09712696-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09712967-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09713108-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09713260-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09713357-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09713501-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09713764-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09713985-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09714120-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09714264-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09714429-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09714694-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09714952-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09715165-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09715303-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09715427-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09715521-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09715685-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09715833-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09715974-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09716047-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09716439-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09716643-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09716837-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09716933-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09717047-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09717233-n',[ ('FreshWaterArea',instance)]).
nounMapping2SUMO('09717454-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09717566-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09717696-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09717789-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09717917-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09718092-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09718217-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09718518-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09718652-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09718811-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09718936-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09719105-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09719207-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09719309-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09719430-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09719653-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09719794-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09720033-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09720256-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09720406-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09720595-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09720702-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09720842-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09720967-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09721088-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09721244-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09721444-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09721647-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09721759-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09721883-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09722064-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09722159-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09722279-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09722399-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09722530-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09722658-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09722817-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09722898-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09723067-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09723228-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09723361-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09723564-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09723689-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09723819-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09723944-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09724066-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09724234-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09724365-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('09724533-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09724656-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09724785-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09725000-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09725124-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09725229-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09725402-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09725546-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09725653-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09725772-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09725935-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09726037-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('09726120-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09726246-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09726374-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09726499-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09726621-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09726811-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09726970-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09727191-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09727323-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09727440-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09727627-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09727747-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09727826-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09728009-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09728137-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09728285-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09728403-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09728850-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09729062-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09729156-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09729271-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09729387-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09729530-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09729945-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09730077-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09730204-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09730383-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09730533-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09730732-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09730824-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09730951-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09731082-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09731225-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09731343-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09731436-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09731571-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09731906-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09732047-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09732170-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09732293-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09732441-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09732544-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09732668-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09732778-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09732903-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09733028-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09733243-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09733333-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09733459-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09733580-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09733707-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09733793-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09733899-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09734006-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09734185-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09734294-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09734450-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09734535-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09734639-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09734760-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09734885-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09735023-n',[ ('Hat',subsumption)]).
nounMapping2SUMO('09735113-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09735258-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09735542-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09735654-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09735790-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09735913-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09736035-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09736181-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09736312-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09736485-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09736633-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09736798-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09736945-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09737050-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09737161-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09737297-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09737453-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09737653-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09737835-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09737981-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09738121-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09738275-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09738400-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09738708-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09740085-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09740724-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09740856-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09740954-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09741074-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09741233-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09741331-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09741432-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09741526-n',[ ('UnitedStates',subsumption)]).
nounMapping2SUMO('09741612-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09741722-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09741816-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09741904-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09741999-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09742101-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09742188-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09742315-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09742443-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09742569-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09742690-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09742844-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09742927-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09743016-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09743112-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09743192-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09743275-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09743383-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09743487-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09743601-n',[ ('UnitedStates',subsumption)]).
nounMapping2SUMO('09743690-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09743792-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09743891-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09743986-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09744075-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09744161-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09744262-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09744346-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09744462-n',[ ('UnitedStates',subsumption)]).
nounMapping2SUMO('09744587-n',[ ('UnitedStates',subsumption)]).
nounMapping2SUMO('09744679-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09744834-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09744945-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09745041-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09745132-n',[ ('UnitedStates',subsumption)]).
nounMapping2SUMO('09745229-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09745324-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09745438-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09745535-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09745636-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09745732-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09745834-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09745933-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09746014-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09746101-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09746189-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09746314-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09746438-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09746536-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09746637-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09746725-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09746819-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09746936-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09747062-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09747191-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09747329-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09747495-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09747618-n',[ ('Canine',subsumption)]).
nounMapping2SUMO('09747722-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09747969-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09748101-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09748239-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09748408-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09748541-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09748648-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09748770-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09748889-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09749011-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09749142-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09749260-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09749386-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09749509-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09749614-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09749753-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09749880-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09750046-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09750157-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09750282-n',[ ('NaturalLanguage',subsumption)]).
nounMapping2SUMO('09750410-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09750524-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09750641-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09750770-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09750891-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09751076-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09751256-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09751403-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09751496-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('09751622-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09751772-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09751895-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09752023-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09752246-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09752381-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09752519-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09752657-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09752795-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09752927-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09753065-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09753204-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09753348-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09753498-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09753642-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09753792-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09753930-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09754051-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09754152-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09754217-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09754404-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09754541-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09754633-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09754780-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09754907-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09755086-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09755241-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09755398-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09755555-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09755657-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09755788-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09755893-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09756049-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09756195-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09756400-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09756500-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09756637-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09756961-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09757076-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09757175-n',[ ('MedicalDoctor',subsumption)]).
nounMapping2SUMO('09757311-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09757449-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09757653-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09757836-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('09757944-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09758173-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09758424-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('09758643-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09758781-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09758885-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09759069-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09759311-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('09759501-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09759684-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09759875-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09760080-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09760290-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09760476-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09760609-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09760735-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09760913-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('09761068-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09761310-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('09761403-n',[ ('Accountant',subsumption)]).
nounMapping2SUMO('09761753-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09762011-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09762101-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09762385-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09762509-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09762821-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09763272-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09763349-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09763668-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('09763784-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09764201-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09764381-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('09764598-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('09764732-n',[ ('GovernmentPerson',subsumption)]).
nounMapping2SUMO('09764900-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09765118-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09765278-n',[ ('Actor',equivalence)]).
nounMapping2SUMO('09767197-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09767592-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09767700-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09768753-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09768830-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09769076-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09769345-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09769525-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09769636-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09769803-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09769929-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09770179-n',[ ('MilitaryOfficer',subsumption)]).
nounMapping2SUMO('09770359-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09770472-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09770743-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09770949-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09771204-n',[ ('USMilitaryRankO10',subsumption)]).
nounMapping2SUMO('09771435-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09771664-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09771855-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09772029-n',[ ('Teenager',equivalence)]).
nounMapping2SUMO('09772330-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09772448-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09772606-n',[ ('Object',subsumption)]).
nounMapping2SUMO('09772746-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09772930-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09773076-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09773169-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09773245-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09773682-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09773962-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09774167-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09774266-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09774783-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09775663-n',[ ('Attorney',subsumption)]).
nounMapping2SUMO('09775907-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09776079-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09776186-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09776261-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09776346-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09776522-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09776642-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09776807-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09776933-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09777012-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09777353-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09777870-n',[ ('PoliceSergeant',subsumption)]).
nounMapping2SUMO('09777975-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09778144-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09778266-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09778392-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09778537-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09778676-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09778783-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09778927-n',[ ('Agnostic',equivalence)]).
nounMapping2SUMO('09779124-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09779280-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09779461-n',[ ('Journalist',subsumption)]).
nounMapping2SUMO('09779623-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09779790-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('09780120-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('09780249-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09780395-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09780547-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09780676-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09780828-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09780984-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09781171-n',[ ('Marshal',subsumption)]).
nounMapping2SUMO('09781398-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09781504-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09781650-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09781804-n',[ ('Mayor',subsumption)]).
nounMapping2SUMO('09781921-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09782167-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09782397-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09782589-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09782730-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09782855-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09782946-n',[ ('Man',instance)]).
nounMapping2SUMO('09783130-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09783369-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09783537-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09783653-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09783776-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09783884-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09784043-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09784160-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09784306-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09784443-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09784564-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('09784707-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09784870-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09785042-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09785236-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09785409-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09785580-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09785659-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09785786-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09785891-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09785992-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09786115-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09786226-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('09786338-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09786585-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('09786760-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09786922-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09787076-n',[ ('Female',subsumption)]).
nounMapping2SUMO('09787293-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09787390-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09787534-n',[ ('Ambassador',equivalence)]).
nounMapping2SUMO('09787765-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09787878-n',[ ('Female',subsumption), ('Ambassador',subsumption)]).
nounMapping2SUMO('09787955-n',[ ('Attorney',subsumption)]).
nounMapping2SUMO('09788073-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09788237-n',[ ('Attorney',subsumption)]).
nounMapping2SUMO('09788521-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09788611-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09788761-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('09789150-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09789304-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09789449-n',[ ('Surgeon',subsumption)]).
nounMapping2SUMO('09789566-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09789668-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('09789898-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09790047-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09790188-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09790278-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09790482-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09790666-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09790865-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09791014-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09791151-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09791248-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09791419-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09791530-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('09791816-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09792125-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09792237-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09792555-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('09792896-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('09792969-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09793141-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09793248-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09793352-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('09793495-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09793717-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09793830-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09793946-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09794081-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09794211-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09794320-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09794426-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09794550-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09794668-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09794797-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09794917-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09795010-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09795124-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09795334-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09795556-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09795639-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09795751-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09795894-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09796062-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09796185-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09796323-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09796809-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09796974-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09797113-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09797257-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09797375-n',[ ('Pope',subsumption)]).
nounMapping2SUMO('09797606-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09797742-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09797873-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('09797998-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09798096-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09798244-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09798404-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09798534-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09798811-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09799213-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('09799461-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09799607-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09799808-n',[ ('UnitedStates',subsumption)]).
nounMapping2SUMO('09799920-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09800056-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09800249-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09800469-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09800631-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09800964-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09801102-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09801275-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09801371-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09801533-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09801864-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09802050-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09802239-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09802445-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09802641-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09802844-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09802951-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09803060-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09803247-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09803429-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09803800-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09804053-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09804230-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09804343-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09804518-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09804658-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09804806-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09805151-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('09805324-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09805475-n',[ ('Architect',equivalence)]).
nounMapping2SUMO('09806944-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09807075-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09807379-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09807495-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09807609-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09807754-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09808080-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09808351-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('09808466-n',[ ('FullyFormed',subsumption)]).
nounMapping2SUMO('09808591-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09808686-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09808794-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09808949-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09809134-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09809279-n',[ ('MilitaryPerson',subsumption)]).
nounMapping2SUMO('09809427-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09809538-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('09809749-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('09809925-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('09810166-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09810364-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09810633-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09810707-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09810867-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('09810983-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('09811112-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('09811281-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('09811414-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09811568-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09811712-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09811852-n',[ ('MilitaryPerson',subsumption)]).
nounMapping2SUMO('09812068-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('09812338-n',[ ('Artist',equivalence)]).
nounMapping2SUMO('09813126-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('09813219-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09813351-n',[ ('Student',subsumption)]).
nounMapping2SUMO('09813441-n',[ ('Teacher',subsumption)]).
nounMapping2SUMO('09813522-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09813632-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09813696-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09814084-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09814252-n',[ ('SkilledProfession',subsumption)]).
nounMapping2SUMO('09814381-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09814488-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09814567-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09814660-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09815076-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09815188-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09815455-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09815677-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09815790-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09816654-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09816771-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09817174-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09817386-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09817536-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09817694-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09817816-n',[ ('SkilledProfession',subsumption)]).
nounMapping2SUMO('09818022-n',[ ('SkilledProfession',subsumption)]).
nounMapping2SUMO('09818343-n',[ ('SkilledProfession',subsumption)]).
nounMapping2SUMO('09819291-n',[ ('SkilledProfession',subsumption)]).
nounMapping2SUMO('09819477-n',[ ('SkilledProfession',subsumption)]).
nounMapping2SUMO('09819667-n',[ ('SkilledProfession',subsumption)]).
nounMapping2SUMO('09819860-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('09820044-n',[ ('Atheist',equivalence)]).
nounMapping2SUMO('09820263-n',[ ('ProfessionalAthlete',equivalence)]).
nounMapping2SUMO('09821086-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09821253-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09821831-n',[ ('ServicePosition',subsumption)]).
nounMapping2SUMO('09822640-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09822830-n',[ ('AttorneyGeneral',subsumption)]).
nounMapping2SUMO('09822955-n',[ ('SkilledProfession',subsumption)]).
nounMapping2SUMO('09823153-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09823287-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09823502-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('09823683-n',[ ('OccupationalRole',subsumption)]).
nounMapping2SUMO('09823832-n',[ ('Female',subsumption), ('OccupationalRole',subsumption)]).
nounMapping2SUMO('09823927-n',[ ('SkilledProfession',subsumption)]).
nounMapping2SUMO('09824065-n',[ ('Female',subsumption), ('Writer',subsumption)]).
nounMapping2SUMO('09824135-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09824361-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09824609-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09824978-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09825096-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09825296-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09825413-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09825519-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09825750-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09825939-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('09826074-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09826204-n',[ ('Pilot',equivalence)]).
nounMapping2SUMO('09826605-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('09826698-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09826821-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('09826945-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('09827166-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09827246-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09827363-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09827519-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09827683-n',[ ('HumanBaby',equivalence)]).
nounMapping2SUMO('09828216-n',[ ('HumanBaby',equivalence)]).
nounMapping2SUMO('09828403-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09828600-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09828760-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('09828988-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09829122-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09829305-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09829506-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09829650-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09829798-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09829923-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09830080-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09830194-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09830400-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09830553-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09830629-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09830759-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09830926-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09831057-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09831166-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09831303-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09831411-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('09831731-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09831856-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09831962-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09832321-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09832456-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09832538-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09832633-n',[ ('Woman',subsumption)]).
nounMapping2SUMO('09832762-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09832873-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09832978-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09833111-n',[ ('PoliceOfficer',subsumption)]).
nounMapping2SUMO('09833275-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09833441-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('09833536-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09833651-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09833751-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09833896-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09833997-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09834159-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('09834258-n',[ ('Woman',subsumption)]).
nounMapping2SUMO('09834378-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09834592-n',[ ('Female',subsumption), ('EntertainmentProfession',subsumption)]).
nounMapping2SUMO('09834699-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09834885-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09835017-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09835153-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09835230-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('09835348-n',[ ('Position',instance)]).
nounMapping2SUMO('09835506-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('09836057-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09836160-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('09836343-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09836519-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09836658-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09836786-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09836976-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09837088-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09837201-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09837360-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09837459-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('09837580-n',[ ('Banker',subsumption)]).
nounMapping2SUMO('09837720-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09837824-n',[ ('Banker',subsumption)]).
nounMapping2SUMO('09837981-n',[ ('BankEngineer',subsumption)]).
nounMapping2SUMO('09838117-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09838200-n',[ ('Banker',subsumption)]).
nounMapping2SUMO('09838295-n',[ ('Stealing',subsumption)]).
nounMapping2SUMO('09838370-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09838511-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('09838621-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('09838701-n',[ ('Protestant',subsumption)]).
nounMapping2SUMO('09838895-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09839022-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09839085-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09839167-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09839343-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09839436-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09839515-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09839702-n',[ ('Female',subsumption), ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09839774-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09839860-n',[ ('Pilot',subsumption)]).
nounMapping2SUMO('09840050-n',[ ('Actor',subsumption)]).
nounMapping2SUMO('09840217-n',[ ('BusinessPerson',subsumption)]).
nounMapping2SUMO('09840435-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09840520-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09840639-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09840871-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09840963-n',[ ('Lawyer',subsumption)]).
nounMapping2SUMO('09841188-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09841400-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09841515-n',[ ('Coach',subsumption)]).
nounMapping2SUMO('09841696-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09841865-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09841955-n',[ ('Coach',subsumption)]).
nounMapping2SUMO('09842047-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('09842288-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09842395-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09842528-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('09842629-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('09842716-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('09842823-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09843048-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09843200-n',[ ('Chef',subsumption)]).
nounMapping2SUMO('09843309-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09843443-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09843602-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09843716-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09843824-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09843956-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09844221-n',[ ('Coach',subsumption)]).
nounMapping2SUMO('09844356-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09844457-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09844566-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09844685-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09844770-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09844898-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09845016-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09845191-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09845401-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09845589-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09845737-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09845849-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09845999-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09846142-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09846265-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09846355-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09846469-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09846586-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09846755-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09846894-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09847010-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09847267-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('09847344-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('09847425-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09847543-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09847629-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09847727-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09848110-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09848285-n',[ ('Taoist',equivalence)]).
nounMapping2SUMO('09848489-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09848775-n',[ ('Porter',subsumption)]).
nounMapping2SUMO('09848916-n',[ ('Porter',subsumption)]).
nounMapping2SUMO('09849012-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09849167-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09849256-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('09849349-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09849462-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09849598-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09849801-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('09849874-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09849990-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09850121-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09850317-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09850457-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09850642-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09850760-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09850974-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('09851087-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09851165-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09851371-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09851465-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09851575-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09851719-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09851876-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09852081-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09852179-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09852289-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09852430-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('09852558-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('09852679-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09852826-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('09852979-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('09853087-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09853184-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09853305-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09853467-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('09853541-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09853645-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09853881-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09854218-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('09854290-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09854421-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09854510-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09854708-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09854813-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09854915-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09855433-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09855630-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09856267-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09856401-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09856500-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09856671-n',[ ('Birth',equivalence)]).
nounMapping2SUMO('09856827-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09857007-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09857200-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('09857852-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09857957-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09858165-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('09858299-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09858560-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09858733-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09858913-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09859038-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('09859152-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09859285-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09859412-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09859557-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('09859684-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09859818-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09859975-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09860130-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09860248-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09860415-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09860506-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09860653-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09860813-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09860940-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09861059-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09861166-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('09861287-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09861395-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09861599-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09861718-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09861863-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09861946-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09862183-n',[ ('ShipOfficer',subsumption)]).
nounMapping2SUMO('09862345-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09862479-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09862621-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09862713-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09862845-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09863031-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09863238-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09863339-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09863500-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('09863620-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09863749-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09863936-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09864252-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09864429-n',[ ('NonCommissionedOfficerRank',subsumption)]).
nounMapping2SUMO('09864536-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09864632-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09864761-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09864891-n',[ ('Male',subsumption), ('HumanSlave',subsumption)]).
nounMapping2SUMO('09864968-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09865068-n',[ ('Female',subsumption), ('HumanSlave',subsumption)]).
nounMapping2SUMO('09865162-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09865279-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09865398-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09865547-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09865672-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09865744-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09865838-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09865954-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09866115-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09866222-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09866354-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09866473-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09866559-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09866661-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09866817-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09866922-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09867069-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09867154-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09867311-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09867437-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09867633-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09867818-n',[ ('Protestant',subsumption)]).
nounMapping2SUMO('09867956-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09868157-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09868270-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09868703-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09868782-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09868899-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09869009-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09869171-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09869317-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09869447-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09869578-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09869706-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09869830-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09869961-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09870096-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('09870208-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09870746-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09870926-n',[ ('Man',equivalence)]).
nounMapping2SUMO('09871095-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09871229-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('09871364-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09871580-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09871681-n',[ ('Organization',instance)]).
nounMapping2SUMO('09871867-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09871952-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09872066-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09872285-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('09872464-n',[ ('FullyFormed',subsumption)]).
nounMapping2SUMO('09872557-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09872782-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09872996-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09873135-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09873242-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09873348-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09873473-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09873604-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09873769-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09873899-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09874014-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09874118-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09874260-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09874428-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09874518-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09874618-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09874725-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09874862-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09875025-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09875188-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09875353-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09875540-n',[ ('USMilitaryRankO7',subsumption)]).
nounMapping2SUMO('09875663-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09875786-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09875979-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09876152-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09876308-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09876454-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('09876701-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09876892-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('09877124-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09877288-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09877370-n',[ ('Food',subsumption)]).
nounMapping2SUMO('09877443-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('09877587-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09877750-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09877856-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09877951-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09878179-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09878275-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09878559-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09878702-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09878921-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09879144-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09879297-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09879552-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09879616-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09879744-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09880075-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09880189-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('09880338-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09880427-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09880646-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09880741-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09880881-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09881009-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09881133-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09881265-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09881358-n',[ ('ServicePosition',subsumption)]).
nounMapping2SUMO('09881519-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09881613-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09881748-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09881895-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09882007-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09882615-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('09882716-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09883047-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09883174-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09883362-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09883452-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09883630-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('09883740-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('09883807-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09883947-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09884133-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09884305-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09884391-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09884509-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09884666-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09884815-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09884934-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09885059-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09885145-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09885334-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09885416-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09885534-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09885676-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09885769-n',[ ('Male',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('09885866-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09886010-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09886220-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09886403-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09886540-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09886700-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09886807-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09886911-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09887034-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09887378-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09887496-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09887850-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09888017-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09888269-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('09888429-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09888635-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09888832-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09888978-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09889065-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('09889170-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09889346-n',[ ('Protestant',subsumption)]).
nounMapping2SUMO('09889539-n',[ ('Cinematographer',subsumption)]).
nounMapping2SUMO('09889691-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09889941-n',[ ('Camp',equivalence)]).
nounMapping2SUMO('09890072-n',[ ('Organization',instance)]).
nounMapping2SUMO('09890192-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09890296-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('09890411-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09890507-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09890662-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09890749-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09890894-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09890987-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09891079-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09891300-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09891470-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09891613-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09891730-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09891864-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09892066-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09892156-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09892262-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09892410-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09892513-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09892693-n',[ ('Pilot',subsumption)]).
nounMapping2SUMO('09892831-n',[ ('USMilitaryRankO6',subsumption)]).
nounMapping2SUMO('09893015-n',[ ('PoliceCaptain',subsumption)]).
nounMapping2SUMO('09893191-n',[ ('USMilitaryRankO3',equivalence)]).
nounMapping2SUMO('09893344-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09893502-n',[ ('Animal',subsumption)]).
nounMapping2SUMO('09893600-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09893746-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09893916-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09894040-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09894143-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09894445-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09894654-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09894909-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09895138-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09895222-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09895480-n',[ ('Male',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('09895561-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09895701-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09895902-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09896084-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09896170-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09896311-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('09896401-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09896520-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09896685-n',[ ('Carpenter',subsumption)]).
nounMapping2SUMO('09896826-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09896973-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09897170-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('09897350-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09897603-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09897696-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09897914-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09898020-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09898107-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('09898215-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09898346-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09898692-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09898797-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09898892-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09899134-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09899289-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09899438-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09899534-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09899671-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09899782-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09899929-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09900153-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09900284-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09900391-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09900499-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09900711-n',[ ('Process',subsumption)]).
nounMapping2SUMO('09900873-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('09900981-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09901143-n',[ ('Catching',equivalence)]).
nounMapping2SUMO('09901337-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('09901502-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09901642-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09901786-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09901921-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09902017-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09902128-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09902256-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09902353-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('09902611-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('09902731-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09902851-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09902954-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09903153-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09903367-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09903501-n',[ ('Cellist',equivalence)]).
nounMapping2SUMO('09903639-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09903936-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09904057-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09904208-n',[ ('AgeGroup',instance)]).
nounMapping2SUMO('09904321-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('09904556-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09904708-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09904837-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09905050-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09905185-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09905530-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09905697-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09905842-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09905965-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09906079-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09906195-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09906293-n',[ ('Maid',subsumption)]).
nounMapping2SUMO('09906449-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09906538-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09906704-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09906848-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09906986-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09907196-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09907408-n',[ ('Position',instance)]).
nounMapping2SUMO('09907566-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09907717-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09907804-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09907919-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('09908025-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09908273-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09908508-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09908678-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09908769-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09908853-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09908986-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09909060-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09909363-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09909477-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09909660-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09909760-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09909929-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09910084-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09910222-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09910374-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09910556-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09910719-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('09910840-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09911051-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09911226-n',[ ('Maid',subsumption)]).
nounMapping2SUMO('09911465-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09911570-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09911849-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09912075-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09912243-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09912431-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09912598-n',[ ('SalesPosition',subsumption)]).
nounMapping2SUMO('09912681-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09912765-n',[ ('Teenager',subsumption)]).
nounMapping2SUMO('09912907-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09912995-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09913110-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09913240-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('09913329-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09913455-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09913593-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09913741-n',[ ('SalesPosition',subsumption)]).
nounMapping2SUMO('09913824-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09915434-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09915577-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('09915651-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09915834-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09915964-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09916109-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09916209-n',[ ('PoliceCaptain',subsumption)]).
nounMapping2SUMO('09916348-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09916601-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09916788-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09917214-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09917345-n',[ ('USMilitaryRankE7',subsumption)]).
nounMapping2SUMO('09917481-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09917593-n',[ ('HumanChild',equivalence)]).
nounMapping2SUMO('09918248-n',[ ('HumanChild',equivalence)]).
nounMapping2SUMO('09918554-n',[ ('HumanChild',equivalence)]).
nounMapping2SUMO('09918762-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09918867-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09919061-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09919200-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09919297-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09919451-n',[ ('Text',subsumption)]).
nounMapping2SUMO('09919690-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09919771-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09919899-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09920106-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09920283-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09920771-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09920901-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09921034-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09921168-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09921291-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09921409-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09921673-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09921792-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09922485-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09922659-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09922799-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09923003-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09923101-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09923186-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09923263-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09923418-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09923561-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09923673-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('09923996-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09924106-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09924195-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09924313-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09924437-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09924540-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09924742-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09924854-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09924996-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09925459-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09925592-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09925824-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09925953-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09926088-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09926246-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('09926426-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('09926519-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('09926656-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09926862-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09926991-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09927089-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09927305-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09927451-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('09928136-n',[ ('Cleric',equivalence)]).
nounMapping2SUMO('09928364-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09928451-n',[ ('ClericalSecretary',subsumption)]).
nounMapping2SUMO('09928845-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09929005-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09929202-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09929298-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09929577-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09929770-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09929861-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09929988-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09930102-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09930257-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09930464-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('09930628-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('09930772-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09930876-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09931165-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09931267-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09931418-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09931640-n',[ ('Coach',equivalence)]).
nounMapping2SUMO('09931989-n',[ ('Coach',subsumption)]).
nounMapping2SUMO('09932098-n',[ ('Coach',subsumption)]).
nounMapping2SUMO('09932227-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09932336-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09932429-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09932508-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09932616-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09932706-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09932788-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09932892-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('09933020-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09933098-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09933235-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09933324-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09933411-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09933613-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09933842-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09933972-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09934085-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09934213-n',[ ('Female',subsumption), ('Student',subsumption)]).
nounMapping2SUMO('09934337-n',[ ('EngineeringComponent',subsumption)]).
nounMapping2SUMO('09934488-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09934647-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09934774-n',[ ('Male',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('09934846-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('09934921-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09935107-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09935233-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09935351-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09935434-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09935793-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09935990-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09936215-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09936362-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09936620-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09936825-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09936892-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09937056-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09937250-n',[ ('USMilitaryRankO6',equivalence)]).
nounMapping2SUMO('09937489-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09937688-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09937802-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09937903-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09938080-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09938272-n',[ ('StandardBearer',subsumption)]).
nounMapping2SUMO('09938449-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09938554-n',[ ('MilitaryRank',subsumption)]).
nounMapping2SUMO('09938672-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09938851-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09938991-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09939154-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09939313-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09939827-n',[ ('Pilot',subsumption)]).
nounMapping2SUMO('09940026-n',[ ('OccupationalRole',instance)]).
nounMapping2SUMO('09940146-n',[ ('Comedian',equivalence)]).
nounMapping2SUMO('09940725-n',[ ('Comedian',equivalence)]).
nounMapping2SUMO('09940818-n',[ ('Female',subsumption), ('Comedian',subsumption)]).
nounMapping2SUMO('09940987-n',[ ('Human',subsumption), ('Comedian',subsumption)]).
nounMapping2SUMO('09941089-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09941172-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09941383-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09941571-n',[ ('USMilitaryRankO5',subsumption)]).
nounMapping2SUMO('09941787-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09941964-n',[ ('MilitaryCommander',equivalence)]).
nounMapping2SUMO('09942275-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09942431-n',[ ('Writing',subsumption)]).
nounMapping2SUMO('09942587-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('09942697-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09942871-n',[ ('Doorman',subsumption)]).
nounMapping2SUMO('09942970-n',[ ('CommissionedOfficerRank',equivalence)]).
nounMapping2SUMO('09943239-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09943541-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09943811-n',[ ('GovernmentOfficer',subsumption)]).
nounMapping2SUMO('09944022-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09944160-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09944337-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09944430-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09944529-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09944677-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09944763-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09944931-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09945021-n',[ ('CommissionedOfficerRank',subsumption)]).
nounMapping2SUMO('09945223-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09945319-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09945603-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('09945745-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09945905-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('09946278-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09946437-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09946574-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09946672-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09946814-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09946957-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09947127-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09947232-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09949946-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09950150-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09950318-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09950457-n',[ ('Neurosis',subsumption)]).
nounMapping2SUMO('09950728-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09950917-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09951070-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09951274-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09951524-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09951616-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09951717-n',[ ('SalesPosition',subsumption)]).
nounMapping2SUMO('09951835-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09951953-n',[ ('Concierge',equivalence)]).
nounMapping2SUMO('09952163-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09952393-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09952539-n',[ ('MusicalConductor',equivalence)]).
nounMapping2SUMO('09953052-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09953178-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09953275-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('09953350-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09953483-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09953615-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09953775-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('09953965-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09954081-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09954246-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09954355-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09954479-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09954639-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09954804-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09954879-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09955015-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09955406-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09955517-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09955643-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('09955781-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09955944-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09956035-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09956147-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09956387-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09956578-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09956780-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09957013-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09957156-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09957523-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09957614-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09957834-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09958133-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09958292-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09958447-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09958569-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09958724-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09958892-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09959142-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09959258-n',[ ('PoliceOfficer',subsumption)]).
nounMapping2SUMO('09959387-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09959527-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09959658-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('09959797-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09960001-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09960117-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09960315-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09960417-n',[ ('AgeGroup',equivalence)]).
nounMapping2SUMO('09960545-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09960688-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09960891-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('09961012-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09961198-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09961331-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('09961469-n',[ ('Neurosis',subsumption)]).
nounMapping2SUMO('09961605-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09961739-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09961889-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09961999-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09962214-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09962414-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09962612-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09962789-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09962966-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09963159-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09963320-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09963574-n',[ ('Chef',equivalence)]).
nounMapping2SUMO('09963680-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09963773-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09963914-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09964064-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09964202-n',[ ('Pilot',subsumption)]).
nounMapping2SUMO('09964315-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09964411-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09964659-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09964805-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09965021-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09965134-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09965424-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09965515-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09965625-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09965787-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09965905-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09965985-n',[ ('Coroner',subsumption)]).
nounMapping2SUMO('09966139-n',[ ('USMilitaryRankE4',subsumption)]).
nounMapping2SUMO('09966255-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09966470-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09966554-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09966710-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09966941-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09967063-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09967159-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09967270-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09967406-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09967555-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09967816-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09967967-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09968128-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09968259-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09968433-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('09968549-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09968652-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09968741-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09968845-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09969062-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09969218-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09969375-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09969491-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09969589-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09969718-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09969869-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09970088-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09970192-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09970295-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09970402-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09970493-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09970699-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09970822-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09970963-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('09971047-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09971135-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09971273-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09971385-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09971595-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09971682-n',[ ('Bird',subsumption)]).
nounMapping2SUMO('09971839-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09972010-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('09972157-n',[ ('FashionDesigner',subsumption)]).
nounMapping2SUMO('09972458-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09972587-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09972661-n',[ ('FarmHand',subsumption)]).
nounMapping2SUMO('09972946-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09973072-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09973209-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09973422-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('09973490-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09973624-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09973749-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09973903-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09974054-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09974177-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09974278-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09974496-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09974648-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09975425-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09975630-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09975806-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09975933-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09976024-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09976119-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09976283-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09976429-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09976551-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09976728-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09976917-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09977082-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09977178-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09977326-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09977520-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09977660-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09978442-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('09978566-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09978697-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('09978889-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('09979072-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09979321-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09979589-n',[ ('ArtCritic',subsumption)]).
nounMapping2SUMO('09979913-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09979985-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09980090-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09980275-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09980458-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09980658-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09980805-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09980985-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09981092-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('09981183-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09981278-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09981365-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('09981540-n',[ ('SkilledOccupation',instance)]).
nounMapping2SUMO('09981740-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('09981834-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09981939-n',[ ('Organization',instance)]).
nounMapping2SUMO('09982013-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('09982152-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09982277-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09982370-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09982525-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('09982760-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09982873-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09983053-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09983214-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09983314-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09983444-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09983572-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('09983889-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09984047-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09984187-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09984298-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09984659-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09984960-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09985075-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09985207-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09985279-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09985470-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09985577-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09985683-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09985809-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('09985978-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09986189-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09986450-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('09986532-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09986700-n',[ ('Philosophy',subsumption)]).
nounMapping2SUMO('09986904-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09987045-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09987161-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09987239-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09987573-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09987696-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09987927-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09988063-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09988216-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('09988311-n',[ ('Male',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('09988392-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09988493-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09988597-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09988703-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09988918-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('09989045-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09989168-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09989290-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09989502-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09990415-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09990690-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09990777-n',[ ('Teacher',subsumption)]).
nounMapping2SUMO('09990904-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09991026-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09991285-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09991406-n',[ ('Male',subsumption), ('EntertainmentPosition',instance)]).
nounMapping2SUMO('09991530-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09991740-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09991867-n',[ ('Favorite',subsumption)]).
nounMapping2SUMO('09992138-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09992238-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09992331-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09992429-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09992538-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09992746-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09992837-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('09993040-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09993122-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09993252-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09993651-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09993822-n',[ ('Male',subsumption), ('Human',subsumption), ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('09993901-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09994119-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09994319-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('09994400-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09994520-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09994673-n',[ ('Deacon',subsumption)]).
nounMapping2SUMO('09994808-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09994878-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('09994943-n',[ ('Dead',subsumption)]).
nounMapping2SUMO('09995253-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09995398-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09995573-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09995757-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09995829-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09995925-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09996039-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09996149-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('09996304-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09996481-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09996636-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09996784-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09996920-n',[ ('Position',instance)]).
nounMapping2SUMO('09997068-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09997212-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09997404-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09997622-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09997834-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09997939-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09998101-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09998788-n',[ ('Position',subsumption)]).
nounMapping2SUMO('09998907-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09999036-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09999135-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09999443-n',[ ('Human',subsumption)]).
nounMapping2SUMO('09999532-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09999683-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('09999795-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10000007-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10000158-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10000294-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10000459-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10000616-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10000787-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10000945-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10001058-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10001217-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10001481-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10001647-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10001764-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10001882-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10002031-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10002151-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10002257-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10002477-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10002644-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10002760-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10002982-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10003120-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10003283-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10003476-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10003575-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10003782-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10003870-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10004019-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10004171-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10004282-n',[ ('Dentist',subsumption)]).
nounMapping2SUMO('10004539-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10004718-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10004804-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10005006-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10005163-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10005280-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10005548-n',[ ('Deputy',subsumption)]).
nounMapping2SUMO('10005721-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10005934-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10006081-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10006177-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10006337-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('10006511-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10006748-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10006842-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10007109-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10007511-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10007684-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10007809-n',[ ('Designer',subsumption)]).
nounMapping2SUMO('10007995-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10008123-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10008254-n',[ ('PoliceOfficer',subsumption)]).
nounMapping2SUMO('10008388-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10008535-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10008716-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10009162-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10009276-n',[ ('PoliceDetective',subsumption)]).
nounMapping2SUMO('10009484-n',[ ('PrivateDetective',equivalence)]).
nounMapping2SUMO('10009671-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10009926-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('10010062-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10010243-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10010400-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10010525-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10010632-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10010767-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10010864-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10010977-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10011074-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10011360-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10011486-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10011659-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10011785-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10011902-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10012244-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10012377-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10012484-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10012713-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10012815-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10012989-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10013114-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10013242-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10013399-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10013614-n',[ ('Waiter',equivalence)]).
nounMapping2SUMO('10013811-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10013927-n',[ ('DiplomaticAgent',subsumption)]).
nounMapping2SUMO('10014658-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10014771-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10014939-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10015215-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10015485-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10015607-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10015792-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10015897-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10016103-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10016954-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10017190-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10017272-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10017422-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10017664-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10017794-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10017890-n',[ ('DisplacedPerson',subsumption), ('StatelessPerson',subsumption)]).
nounMapping2SUMO('10018021-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10018373-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10018532-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10018653-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10018747-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10018861-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10019072-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10019187-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10019308-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10019406-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10019552-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10019733-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10019888-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10020031-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10020366-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10020533-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10020670-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10020807-n',[ ('Teacher',subsumption)]).
nounMapping2SUMO('10020890-n',[ ('MedicalDoctor',subsumption)]).
nounMapping2SUMO('10021892-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10022111-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10022645-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10022759-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10022908-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10023039-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10023129-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10023264-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10023381-n',[ ('Pilot',subsumption)]).
nounMapping2SUMO('10023506-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10023656-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10023885-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10024025-n',[ ('FullyFormed',subsumption)]).
nounMapping2SUMO('10024119-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10024362-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10024621-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('10024784-n',[ ('Woman',subsumption)]).
nounMapping2SUMO('10024937-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('10025060-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10025195-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10025295-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10025391-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10025487-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10025635-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10025730-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10026058-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10026261-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10026367-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10026553-n',[ ('Doorman',equivalence)]).
nounMapping2SUMO('10026763-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('10026976-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10027105-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10027246-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10027476-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10027590-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10027798-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10027953-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10028123-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10028289-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10028402-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10028541-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10028638-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10028765-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10028977-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10029068-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10029269-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10029429-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10029729-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10029831-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('10029985-n',[ ('RedcoatSoldier',equivalence)]).
nounMapping2SUMO('10030147-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10030277-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10032190-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10032342-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10032524-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10032676-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10032884-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10032987-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10033082-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10033225-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10033412-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10033572-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10033663-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10033888-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10034020-n',[ ('NonCommissionedOfficerRank',subsumption)]).
nounMapping2SUMO('10034201-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10034614-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10034785-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10034906-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10035314-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10035430-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10035655-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10035809-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10035952-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10036135-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10036266-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10036444-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10036574-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10036692-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10036802-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10036929-n',[ ('Drummer',equivalence)]).
nounMapping2SUMO('10037080-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10037194-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10037385-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10037588-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10037922-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10038119-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10038226-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10038320-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10038409-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10038547-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10038620-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10038778-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10038929-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10039164-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10039271-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10039391-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10039569-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10039663-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10039946-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10040049-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10040240-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10040344-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10040515-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10040617-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10040698-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10040789-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10040945-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10041093-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10041195-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10041373-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10041539-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10041684-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10041787-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10041887-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10042074-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10042186-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10042300-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10042690-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10042845-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10043024-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10043163-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10043331-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10043491-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10043643-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10044470-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10044682-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10044763-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10044879-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10045361-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10045454-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10045713-n',[ ('Teacher',subsumption)]).
nounMapping2SUMO('10046387-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10046527-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10046717-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10046870-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10047030-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10047199-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10047371-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10047459-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10047822-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10048001-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10048117-n',[ ('Man',subsumption)]).
nounMapping2SUMO('10048218-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10048367-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10048485-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10048612-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10048729-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10048836-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10049017-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10049363-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10049522-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10049648-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10049788-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10049896-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10050043-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10050163-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10050261-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10050432-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10050558-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10050712-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10050880-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10051026-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10051215-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10051337-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10051552-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10051683-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10051761-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10051861-n',[ ('Unemployed',subsumption)]).
nounMapping2SUMO('10051975-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10052128-n',[ ('Male',subsumption), ('Human',instance)]).
nounMapping2SUMO('10052244-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10052497-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10052694-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10052843-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10053004-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10053439-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10053591-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10053708-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10053808-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10054657-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10054875-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10054975-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10055085-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10055181-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10055297-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10055410-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10055566-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10055730-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10055847-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10056103-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10056398-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10056611-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10056719-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10056914-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10057114-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10057271-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10057491-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10057595-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10057714-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10057918-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10058027-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10058155-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10058411-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10058585-n',[ ('EnlistedSoldierRank',subsumption)]).
nounMapping2SUMO('10058777-n',[ ('EnlistedSoldierRank',equivalence)]).
nounMapping2SUMO('10058962-n',[ ('EnlistedSoldierRank',subsumption), ('Female',subsumption)]).
nounMapping2SUMO('10059067-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10059162-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10059323-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10059582-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10059904-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10060075-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10060175-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10060352-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10060621-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10060904-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10061043-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10061195-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10061323-n',[ ('Governor',subsumption)]).
nounMapping2SUMO('10061431-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('10061554-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10061656-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10061882-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10062042-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10062176-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10062275-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('10062385-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10062492-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10062594-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10062716-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10062785-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10062905-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10062996-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10063177-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10063340-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10063461-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10063635-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10063919-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10064046-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10064229-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10064405-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10064537-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10064669-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10064831-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10064977-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10065066-n',[ ('Philosophy',subsumption)]).
nounMapping2SUMO('10065261-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10065547-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10065643-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10065758-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10065911-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10066059-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10066206-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10066314-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10066452-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10066624-n',[ ('Evacuee',equivalence)]).
nounMapping2SUMO('10066732-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10067011-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10067305-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10067600-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10067793-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10067867-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10067968-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10068234-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10068425-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10068537-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('10068682-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('10068804-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10068928-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10069120-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10069296-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10069427-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10069645-n',[ ('BusinessExecutive',equivalence)]).
nounMapping2SUMO('10069869-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10069981-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10070108-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10070219-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10070377-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10070449-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10070563-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10070711-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10070942-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10071139-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10071332-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10071557-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10071912-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10072054-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10072187-n',[ ('ReligiousPosition',instance)]).
nounMapping2SUMO('10072346-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10072546-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10072708-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10073634-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10073762-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10073851-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10073992-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10074249-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10074339-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10074578-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10074735-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10074841-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('10075063-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10075185-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10075299-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10075416-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10075529-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10075693-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10075802-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10075899-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10076033-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10076224-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10076307-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10076483-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('10076604-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10076778-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10076957-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10077106-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10077278-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10077394-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10077504-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10077593-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10077879-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10078131-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10078333-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10078415-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10078529-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10078643-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10078719-n',[ ('Boy',subsumption)]).
nounMapping2SUMO('10078806-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10079210-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10079310-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10079399-n',[ ('FarmHand',equivalence)]).
nounMapping2SUMO('10079677-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10079769-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10079893-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10080117-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('10080206-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10080337-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10080508-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10080784-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10080869-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10081204-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10081456-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10081670-n',[ ('Man',subsumption)]).
nounMapping2SUMO('10081842-n',[ ('Man',subsumption)]).
nounMapping2SUMO('10082043-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10082146-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10082299-n',[ ('Boy',subsumption)]).
nounMapping2SUMO('10082423-n',[ ('Painting',subsumption)]).
nounMapping2SUMO('10082562-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10082687-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10082805-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10082886-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10082997-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10083097-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10083264-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10083358-n',[ ('Man',subsumption)]).
nounMapping2SUMO('10083526-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10083677-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10083823-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10084043-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10084181-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10084295-n',[ ('Female',subsumption), ('Human',subsumption), ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10084635-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10085101-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10085217-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10085344-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10085449-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10085548-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10085736-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10085869-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10085970-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10086074-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10086383-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10086568-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10086744-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10086821-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10087080-n',[ ('FieldGradeOfficerRank',subsumption)]).
nounMapping2SUMO('10087255-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10087434-n',[ ('Pilot',subsumption)]).
nounMapping2SUMO('10087574-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10087736-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10087868-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10088101-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10088200-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10088390-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10089484-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10089615-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10089779-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10089892-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10090020-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10090498-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10090745-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10090864-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('10091012-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10091256-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10091349-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10091450-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10091564-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10091651-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10091861-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10091997-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10092098-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10092299-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10092488-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10092643-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10092794-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10092880-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10092978-n',[ ('USMilitaryRankO2',subsumption)]).
nounMapping2SUMO('10093167-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10093264-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10093396-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10093475-n',[ ('USMilitaryRankE7',subsumption)]).
nounMapping2SUMO('10093658-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('10093818-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10093908-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10094046-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10094236-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10094320-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10094444-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10094584-n',[ ('FlagOfficerRank',subsumption)]).
nounMapping2SUMO('10094782-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10094954-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10095061-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('10095265-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10095420-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10095550-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10095664-n',[ ('PoliceOfficer',subsumption)]).
nounMapping2SUMO('10095769-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10095869-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10096016-n',[ ('USMilitaryRankSpecial',subsumption)]).
nounMapping2SUMO('10096126-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10096217-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10096375-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10096508-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10096620-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10096725-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10096855-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10096964-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10097154-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10097262-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10097477-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10097590-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10097705-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10097842-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10097995-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10098092-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10098245-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10098388-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10098517-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10098624-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10098710-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10098862-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10099002-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10099093-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10099278-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10099375-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10100124-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10100314-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10100514-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10100620-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10100761-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10101078-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10101202-n',[ ('Coach',subsumption)]).
nounMapping2SUMO('10101308-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10101427-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10101634-n',[ ('ProfessionalAthlete',subsumption)]).
nounMapping2SUMO('10101981-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10102130-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10102222-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10102369-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10102506-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10102800-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10102969-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10103155-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10103228-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10103315-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10103485-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10103794-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10103921-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10104064-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10104209-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10104487-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10104592-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10104756-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('10104888-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10104983-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10105085-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10105260-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10105359-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10105462-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10105618-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10105733-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10105906-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10106080-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10106242-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10106387-n',[ ('Male',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10106509-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10106642-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10106752-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10106995-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10107173-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10107303-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10107604-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10107778-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10107883-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10108018-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10108089-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10108240-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10108348-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10108464-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10108606-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10108719-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10108832-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10108937-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10109050-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10109197-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10109342-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('10109443-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10109662-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10109826-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10109985-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10110093-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10110287-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10110421-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10110731-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10110893-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10111023-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10111144-n',[ ('Organization',instance)]).
nounMapping2SUMO('10111358-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10111463-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10111601-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10111688-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10111779-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10111903-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('10112129-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('10112434-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('10112591-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('10113072-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10113249-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10113362-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10113583-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10113753-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10113869-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10113997-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10114114-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10114209-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10114384-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10114476-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10114550-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10114662-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10114897-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10115082-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10115271-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('10115430-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10115603-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10115748-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10115840-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10115946-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10116093-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10116246-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10116370-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10116478-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10116579-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10116702-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10116905-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10117017-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10117154-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10117267-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10117415-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10117511-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10117739-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10117851-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10117957-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10118113-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10118208-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10118301-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10118382-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('10118587-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10118743-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10118844-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10119200-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10119351-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10119491-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10119609-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10119685-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10119775-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10119874-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10119953-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10120085-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10120330-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10120533-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10120671-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10120816-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10121026-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10121144-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10121246-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10121467-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10121595-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10121714-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10121800-n',[ ('MedicalDoctor',subsumption)]).
nounMapping2SUMO('10121952-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10122128-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10122300-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10122441-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10122531-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10122645-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10122765-n',[ ('Book',subsumption)]).
nounMapping2SUMO('10122858-n',[ ('Female',subsumption), ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('10123026-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10123122-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10123214-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('10123312-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10123415-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10123517-n',[ ('Painting',subsumption)]).
nounMapping2SUMO('10123615-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10123711-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10123844-n',[ ('CommissionedOfficerRank',subsumption)]).
nounMapping2SUMO('10125561-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10125697-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10125786-n',[ ('FlagOfficerRank',subsumption)]).
nounMapping2SUMO('10126009-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10126177-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10126424-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10126708-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10126806-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10126926-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10127186-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10127273-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10127420-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10127555-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10127689-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10127916-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10128016-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10128163-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10128254-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('10128381-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10128519-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10128748-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10128909-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10129133-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10129338-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10129464-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10129585-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10129719-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10129825-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10130447-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10130584-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10130686-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10130877-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10131016-n',[ ('Organization',instance)]).
nounMapping2SUMO('10131151-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10131268-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10131515-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10131590-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10131663-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10131815-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10132035-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10132145-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10132305-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10132422-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10132502-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10132641-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10132775-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10132887-n',[ ('SkilledOccupation',instance)]).
nounMapping2SUMO('10132988-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10133210-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10133307-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10133458-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10133644-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10133850-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10134001-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10134178-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10134282-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10134396-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10134552-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10134627-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10134760-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10134870-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10134982-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10135129-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10135197-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10135297-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10135411-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('10135709-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10135842-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10135953-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10136146-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10136283-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10136463-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10136615-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10136775-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('10136959-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10137367-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10137498-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10137632-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10137825-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10137936-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10138114-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10138242-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10138369-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10138472-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10138767-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10139077-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10139206-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10139347-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10139651-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10139774-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10139944-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10140051-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10140169-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10140314-n',[ ('Governor',subsumption)]).
nounMapping2SUMO('10140597-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10140683-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10140783-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10140929-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10141109-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10141268-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10141364-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10141590-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10141732-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10141811-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10141930-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10142060-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10142166-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10142290-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10142391-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10142537-n',[ ('ReligiousPosition',instance)]).
nounMapping2SUMO('10142747-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10142946-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10143085-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10143172-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10143299-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10143371-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10143530-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10143595-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('10143725-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10143889-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('10144055-n',[ ('Designer',subsumption)]).
nounMapping2SUMO('10144188-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10144338-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10144468-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10144571-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10144730-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10144838-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10144962-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10145081-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10145239-n',[ ('BiologicalAgent',subsumption)]).
nounMapping2SUMO('10145340-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10145480-n',[ ('BiologicalAgent',subsumption)]).
nounMapping2SUMO('10145590-n',[ ('BiologicalAgent',subsumption)]).
nounMapping2SUMO('10145682-n',[ ('BiologicalAgent',subsumption)]).
nounMapping2SUMO('10145774-n',[ ('BiologicalAgent',subsumption)]).
nounMapping2SUMO('10145902-n',[ ('BiologicalAgent',subsumption)]).
nounMapping2SUMO('10146002-n',[ ('BiologicalAgent',subsumption)]).
nounMapping2SUMO('10146104-n',[ ('BiologicalAgent',subsumption)]).
nounMapping2SUMO('10146209-n',[ ('BiologicalAgent',subsumption)]).
nounMapping2SUMO('10146313-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10146416-n',[ ('Government',instance)]).
nounMapping2SUMO('10146559-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10146682-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10146816-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10146927-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10147121-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10147262-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10147352-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10147488-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10147619-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10147710-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10147849-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10147935-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10148035-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10148165-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10148305-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10148542-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10148663-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10148825-n',[ ('FieldGradeOfficerRank',subsumption)]).
nounMapping2SUMO('10148991-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10149128-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10149241-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10149436-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10149527-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('10149720-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10149867-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10150071-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10150281-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10150415-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10150556-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10150794-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10150940-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10151133-n',[ ('Buyer',subsumption)]).
nounMapping2SUMO('10151261-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10151367-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('10151570-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10151760-n',[ ('Guitarist',equivalence)]).
nounMapping2SUMO('10151957-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10152083-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10152306-n',[ ('USMilitaryRankE7',subsumption)]).
nounMapping2SUMO('10152440-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10152528-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10152616-n',[ ('ReligiousPosition',instance)]).
nounMapping2SUMO('10152763-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('10152889-n',[ ('ReligiousPosition',subsumption)]).
nounMapping2SUMO('10153009-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10153155-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10153266-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10153414-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10153594-n',[ ('Gymnast',equivalence)]).
nounMapping2SUMO('10153724-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('10153865-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10154013-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10154186-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10154601-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10154740-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10154871-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10155140-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10155222-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10155485-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10155600-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10155692-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10155849-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10156173-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10156284-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10156425-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10156629-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10156726-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10156831-n',[ ('NaturalLanguage',instance)]).
nounMapping2SUMO('10157016-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('10157128-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10157271-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10157378-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10157549-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10157744-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10158010-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10158139-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10158222-n',[ ('Man',instance)]).
nounMapping2SUMO('10158319-n',[ ('Man',instance)]).
nounMapping2SUMO('10158506-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10158608-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10158756-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10159045-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10159186-n',[ ('Maid',subsumption)]).
nounMapping2SUMO('10159289-n',[ ('OccupationalRole',subsumption)]).
nounMapping2SUMO('10159434-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10159533-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10159615-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10159714-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10159852-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10160012-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10160188-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10160280-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10160412-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10160624-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10160770-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10160913-n',[ ('OccupationalRole',subsumption)]).
nounMapping2SUMO('10161047-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10161178-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('10161273-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10161363-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10161521-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10161622-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10161695-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10161867-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10162016-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10162104-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10162194-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10162354-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10162507-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10162644-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10162780-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10162991-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10163354-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10163452-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10163593-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10163723-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10163900-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10164025-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10164233-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10164397-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10164492-n',[ ('Female',subsumption), ('Profession',subsumption)]).
nounMapping2SUMO('10164605-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10164747-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10164997-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10165109-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10165448-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10165673-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10165808-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10165957-n',[ ('Investigating',equivalence)]).
nounMapping2SUMO('10166189-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10166313-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10166394-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10166626-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10166762-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('10166902-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10167042-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10167152-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10167252-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10167361-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10167448-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10167565-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10167740-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10167838-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10168012-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10168183-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10168368-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10168457-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10168584-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10168837-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10169008-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10169147-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10169241-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10169419-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10169607-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10169678-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10169796-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10169937-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10170060-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10170172-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10170359-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10170598-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10170681-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10170866-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10170989-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10171219-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10171456-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10171567-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10171755-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10171953-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10172080-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10172448-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10172668-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10172793-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10172942-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10173086-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10173305-n',[ ('Female',subsumption)]).
nounMapping2SUMO('10173410-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10173579-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10173665-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10173771-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10173895-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10174148-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10174253-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10174330-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10174445-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10174589-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10174695-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10174845-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('10174971-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10175090-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10175248-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10175418-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10175507-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10175725-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10175963-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10176111-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10176357-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10176475-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10176679-n',[ ('FarmHand',equivalence)]).
nounMapping2SUMO('10176913-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10177014-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10177150-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10178077-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10178216-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10178464-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10178611-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10178821-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10178917-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('10179069-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10179207-n',[ ('Coach',subsumption)]).
nounMapping2SUMO('10179291-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10179527-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10179649-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10179817-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('10179911-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10180178-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10180580-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10180791-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10180923-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10181026-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10181137-n',[ ('Position',instance)]).
nounMapping2SUMO('10181445-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10181547-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10181656-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10181799-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('10181878-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10181990-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10182190-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10182402-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10182499-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10182628-n',[ ('Position',instance)]).
nounMapping2SUMO('10182812-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10182913-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10183157-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10183347-n',[ ('Woman',subsumption)]).
nounMapping2SUMO('10183556-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10183757-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10183931-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10184081-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10184290-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10184403-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10184505-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10184683-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10184822-n',[ ('Man',subsumption)]).
nounMapping2SUMO('10184946-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('10185148-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10185327-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10185483-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10185591-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10185682-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10185793-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10186068-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10186143-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10186216-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10186350-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10186578-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10186686-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10186774-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10186950-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10187059-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10187130-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10187356-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10187491-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10187557-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10187710-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10187842-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10187990-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10188146-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10188226-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10188369-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10188472-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10188576-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10188715-n',[ ('Maid',subsumption)]).
nounMapping2SUMO('10188856-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10188957-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10189059-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10189179-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10189278-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10189597-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10189776-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10189975-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10190122-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10190231-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('10190373-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10190516-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10190644-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10190745-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10190871-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10191001-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10191089-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10191192-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10191388-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10191613-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10191802-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10191943-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10192412-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10192588-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10192704-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10192839-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10192926-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10193026-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10193419-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10193543-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10193650-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10193719-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10193864-n',[ ('ProfessionalAthlete',subsumption)]).
nounMapping2SUMO('10193967-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10194231-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10194341-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('10194463-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10194566-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10194775-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10194865-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10194969-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10195056-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10195155-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10195261-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('10195487-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10195593-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10195942-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10196046-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10196133-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10196283-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10196404-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10196490-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10196617-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10196725-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10196845-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10196965-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10197182-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10197392-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10197525-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10197780-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10197967-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10198437-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10198602-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10198759-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10198832-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10198958-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10199103-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10199251-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10199489-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10199644-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10199783-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10199902-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10200047-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10200246-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10200365-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10200531-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10200781-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10201366-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10201535-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10201956-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10202085-n',[ ('Woman',subsumption)]).
nounMapping2SUMO('10202225-n',[ ('Man',subsumption)]).
nounMapping2SUMO('10202363-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10202531-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10202624-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10202763-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10202854-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10203016-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10203135-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10203298-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10203682-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10203839-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('10203949-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10204177-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10204833-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10204921-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10205138-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10205231-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10205344-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('10205457-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10205714-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10205833-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10205985-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10206173-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10206506-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10206629-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10206763-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10206887-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10207077-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10207169-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10207370-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10207514-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10207681-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10207831-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10208189-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10208287-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10208432-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10208583-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10208748-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10208847-n',[ ('PoliceOfficer',subsumption)]).
nounMapping2SUMO('10208950-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10209082-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10209246-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10209539-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10209616-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10209731-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10209888-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10210137-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10210512-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10210648-n',[ ('Designer',subsumption)]).
nounMapping2SUMO('10210911-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10211036-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10211203-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10211463-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10211666-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10211830-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('10211962-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10212074-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10212231-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10212338-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10212501-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('10212780-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('10213034-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10213180-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10213319-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10213429-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('10213652-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10214062-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10214230-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10214390-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10214637-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10215623-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10215815-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10215953-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10216106-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10216403-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10216560-n',[ ('Man',subsumption)]).
nounMapping2SUMO('10216690-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10216839-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10216928-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10217038-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10217208-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10217335-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10217436-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10217552-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10217684-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10217831-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10218043-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10218164-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10218292-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10218390-n',[ ('Man',instance)]).
nounMapping2SUMO('10218692-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10218802-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10218989-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10219121-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10219240-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10219380-n',[ ('Government',instance)]).
nounMapping2SUMO('10219453-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10219577-n',[ ('Janitor',subsumption)]).
nounMapping2SUMO('10219680-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10219778-n',[ ('Man',instance)]).
nounMapping2SUMO('10219879-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10220080-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10220228-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10220360-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10220486-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10220807-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10220924-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('10221040-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10221162-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10221312-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10221520-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('10221656-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10221777-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10221956-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10222170-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10222259-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10222353-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10222497-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10222716-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10222822-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10222949-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10223069-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10223177-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10223294-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('10223459-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10223606-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('10223744-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10223869-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10223994-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10224098-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10224295-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10224446-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10224578-n',[ ('Journalist',equivalence)]).
nounMapping2SUMO('10225118-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10225219-n',[ ('Judge',subsumption)]).
nounMapping2SUMO('10225787-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10225931-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10226060-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10226219-n',[ ('Woman',instance)]).
nounMapping2SUMO('10226413-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10226556-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('10226803-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10226993-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10227166-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10227266-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10227393-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10227490-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10227601-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10227698-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10227793-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10227889-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10227985-n',[ ('Lawyer',subsumption)]).
nounMapping2SUMO('10228278-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10228468-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10228592-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10228712-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10228864-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10229034-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10229193-n',[ ('Pilot',subsumption)]).
nounMapping2SUMO('10229338-n',[ ('Position',instance)]).
nounMapping2SUMO('10229498-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10229721-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10229883-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10229983-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10230097-n',[ ('Leader',subsumption)]).
nounMapping2SUMO('10230216-n',[ ('Leader',subsumption)]).
nounMapping2SUMO('10230335-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10230432-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10230580-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10230736-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10230801-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10231087-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10231361-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10231515-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10233248-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10233445-n',[ ('Position',instance)]).
nounMapping2SUMO('10234340-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10234867-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10235024-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10235142-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10235269-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10235385-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10235549-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10236114-n',[ ('BiologicalAttribute',equivalence)]).
nounMapping2SUMO('10236304-n',[ ('BiologicalAttribute',equivalence)]).
nounMapping2SUMO('10236521-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10236663-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10236842-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('10236946-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10237069-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10237196-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10237315-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10237464-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10237556-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10237676-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10237799-n',[ ('DiseaseOrSyndrome',instance)]).
nounMapping2SUMO('10237935-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10238029-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10238127-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10238272-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10238375-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('10238749-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('10238898-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('10239089-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('10239217-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('10239329-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('10239501-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('10239619-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10239761-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10239928-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10240082-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10240235-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10240417-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('10240514-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10240715-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10240821-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10240921-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10241024-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10241300-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('10242032-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10242328-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10242439-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('10242573-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10242682-n',[ ('LacrossePlayer',equivalence)]).
nounMapping2SUMO('10242791-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10243137-n',[ ('Woman',equivalence)]).
nounMapping2SUMO('10243273-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10243384-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10243483-n',[ ('Maid',subsumption)]).
nounMapping2SUMO('10243582-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10243664-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10243791-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10243872-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10243988-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10244108-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10244226-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10244359-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10244503-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10244665-n',[ ('USMilitaryRankE3',subsumption)]).
nounMapping2SUMO('10244818-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10244913-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10245029-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10245156-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10245236-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10245341-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10245507-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10245639-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10245863-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10246176-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10246317-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10246395-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10246511-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10246703-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10246913-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10247044-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10247176-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10247250-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10247358-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10247519-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10247720-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10247800-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10247880-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10248008-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10248091-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10248198-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10248377-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10248542-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('10248711-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10248876-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10249011-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10249191-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10249270-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10249459-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10249869-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10249950-n',[ ('Lawyer',equivalence)]).
nounMapping2SUMO('10250527-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10250712-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10250873-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10251002-n',[ ('Man',instance)]).
nounMapping2SUMO('10251125-n',[ ('Man',instance)]).
nounMapping2SUMO('10251329-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10251417-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10251517-n',[ ('Male',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10251612-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10251779-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10252075-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10252222-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10252354-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('10252547-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10252674-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10252921-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10253122-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10253296-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10253479-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10253611-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('10253703-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10253887-n',[ ('Veteran',subsumption)]).
nounMapping2SUMO('10253995-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10254392-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10254585-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10254670-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10254761-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10254965-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10255096-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('10255207-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10255348-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10255459-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10255567-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10255728-n',[ ('Object',subsumption)]).
nounMapping2SUMO('10255915-n',[ ('Judaism',subsumption)]).
nounMapping2SUMO('10256080-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10256537-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10256756-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10257084-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10257221-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10257402-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10257524-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10257647-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10257948-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10258152-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10258304-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10258493-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('10258602-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10258786-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10258896-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10259016-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10259094-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10259225-n',[ ('PoliceOfficer',subsumption)]).
nounMapping2SUMO('10259348-n',[ ('USMilitaryRankO2',subsumption)]).
nounMapping2SUMO('10259527-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10259780-n',[ ('USMilitaryRankO5',subsumption)]).
nounMapping2SUMO('10259997-n',[ ('USMilitaryRankO4',subsumption)]).
nounMapping2SUMO('10260166-n',[ ('USMilitaryRankO9',subsumption)]).
nounMapping2SUMO('10260322-n',[ ('LieutenantGovernor',subsumption)]).
nounMapping2SUMO('10260473-n',[ ('USMilitaryRankO2',subsumption)]).
nounMapping2SUMO('10260706-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10260800-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10260943-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10261041-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10261211-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('10261388-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10261511-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10261624-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10261762-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10261862-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10261977-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10262093-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10262183-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10262343-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10262445-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10262561-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10262655-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10262764-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10262880-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10263002-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10263146-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('10263259-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10263411-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10263580-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10263684-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10263790-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10263931-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10264120-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10264219-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10264437-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10264928-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10265070-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10265200-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10265281-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10265390-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10265532-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10265801-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10265891-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10266016-n',[ ('ArtCritic',subsumption)]).
nounMapping2SUMO('10266328-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('10266486-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10266744-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10266848-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10267166-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10267311-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10267437-n',[ ('Man',instance)]).
nounMapping2SUMO('10267561-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10267719-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('10267865-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10267941-n',[ ('ReligiousProfession',subsumption)]).
nounMapping2SUMO('10268058-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10268180-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10268299-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10268422-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10268505-n',[ ('ServicePosition',subsumption)]).
nounMapping2SUMO('10268629-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10268827-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10268930-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10269078-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10269199-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10269289-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10269458-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10269611-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10269785-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10270109-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10270232-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10270383-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10270468-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10270628-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10270777-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10270878-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10271124-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10271216-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10271451-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10271525-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10271677-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10272171-n',[ ('Position',instance)]).
nounMapping2SUMO('10272375-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10272499-n',[ ('Position',instance)]).
nounMapping2SUMO('10272657-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('10272782-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10272913-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10273064-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10273352-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10273438-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10273572-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10273669-n',[ ('Man',instance)]).
nounMapping2SUMO('10273906-n',[ ('Woman',instance)]).
nounMapping2SUMO('10274173-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10274318-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10274474-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10274639-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10274815-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10274985-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10275249-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10275395-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10275534-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10275676-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10275848-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10275940-n',[ ('ProfessionalAthelete',subsumption)]).
nounMapping2SUMO('10276045-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10276238-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10276477-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10276659-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10276764-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('10276942-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10277027-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10277132-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10277231-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10277352-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10277509-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10277638-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10277815-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('10277912-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10278128-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10278263-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10278456-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10278568-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10278666-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('10278805-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10279018-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10279219-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10279317-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10279392-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10279540-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10279669-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10279778-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10279867-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10279964-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10280034-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10280130-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10280364-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10280495-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10280598-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10280674-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10280945-n',[ ('Judge',subsumption)]).
nounMapping2SUMO('10281176-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10281276-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10281432-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('10281546-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10281637-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10281770-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10281896-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10282014-n',[ ('ReligiousPosition',instance)]).
nounMapping2SUMO('10282262-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10282374-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10282482-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10282672-n',[ ('Maid',subsumption)]).
nounMapping2SUMO('10282845-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10282920-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10283037-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10283170-n',[ ('USMilitaryRankO4',subsumption)]).
nounMapping2SUMO('10283366-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10283546-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10283663-n',[ ('USMilitaryRankO8',subsumption)]).
nounMapping2SUMO('10283824-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10283931-n',[ ('BaseballPlayer',subsumption)]).
nounMapping2SUMO('10284064-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10284763-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10284871-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10284965-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10285135-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10285313-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10285762-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('10285938-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10286084-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10286200-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('10286282-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('10286539-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('10286749-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10286855-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10286989-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10287082-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10287213-n',[ ('Man',equivalence)]).
nounMapping2SUMO('10288516-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10288763-n',[ ('FullyFormed',subsumption)]).
nounMapping2SUMO('10288964-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10289039-n',[ ('Human',equivalence)]).
nounMapping2SUMO('10289176-n',[ ('Man',equivalence)]).
nounMapping2SUMO('10289338-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10289462-n',[ ('Female',subsumption), ('Manager',subsumption)]).
nounMapping2SUMO('10289534-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10289671-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10289766-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10289863-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10289969-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10290099-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10290223-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10290422-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10290541-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('10290684-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10290813-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10290919-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10291110-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10291240-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10291469-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10291580-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10291730-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10291822-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10291942-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10292052-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10292192-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10292316-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10292622-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10292714-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10292824-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10292969-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10293172-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10293332-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10293502-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10293590-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10293773-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10293861-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10294020-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10294139-n',[ ('Government',instance)]).
nounMapping2SUMO('10294318-n',[ ('Government',instance)]).
nounMapping2SUMO('10294421-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10294602-n',[ ('EnlistedSoldierRank',subsumption)]).
nounMapping2SUMO('10294953-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10295190-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10295371-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10295479-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10295597-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10295819-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10295951-n',[ ('Marshal',subsumption)]).
nounMapping2SUMO('10296176-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10296444-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10296618-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10296832-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10297140-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10297234-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('10297367-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10297531-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10297655-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10297841-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10297983-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10298202-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10298271-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10298343-n',[ ('Murder',subsumption)]).
nounMapping2SUMO('10298482-n',[ ('Teacher',subsumption)]).
nounMapping2SUMO('10298647-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10298798-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10298912-n',[ ('ShipCaptain',subsumption)]).
nounMapping2SUMO('10299125-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10299250-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10299583-n',[ ('USMilitaryRankE8',subsumption)]).
nounMapping2SUMO('10299700-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10299875-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10300041-n',[ ('ShipMate',subsumption)]).
nounMapping2SUMO('10300154-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10300303-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10300500-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10300654-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10300829-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10300963-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10301089-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10301261-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('10302446-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10302576-n',[ ('Woman',subsumption)]).
nounMapping2SUMO('10302700-n',[ ('Woman',subsumption)]).
nounMapping2SUMO('10302816-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10302905-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10303037-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10303186-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10303310-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10303385-n',[ ('ServicePosition',subsumption)]).
nounMapping2SUMO('10303513-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10303654-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10303814-n',[ ('Mayor',subsumption)]).
nounMapping2SUMO('10304018-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10304086-n',[ ('Woman',subsumption)]).
nounMapping2SUMO('10304160-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10304278-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10304383-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10304505-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10304650-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('10304783-n',[ ('Philosophy',subsumption)]).
nounMapping2SUMO('10304914-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10305062-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10305192-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10305391-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10305523-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10305635-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10305802-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10306004-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10306181-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10306279-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10306496-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10306595-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10306716-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('10306890-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('10307114-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10307234-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('10308066-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('10308168-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('10308275-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('10308394-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('10308504-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10308653-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10308732-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10308938-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10309009-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10309147-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10309347-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10309496-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10309614-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10309785-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10309896-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10310404-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10310516-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10310647-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10310783-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10310903-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10311021-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10311243-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10311375-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10311506-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10311661-n',[ ('Woman',subsumption)]).
nounMapping2SUMO('10311823-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10311995-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10312077-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10312287-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10312491-n',[ ('Government',subsumption)]).
nounMapping2SUMO('10312600-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('10312773-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10312890-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10313000-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10313146-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10313239-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('10313441-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10313580-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10313724-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10313872-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10314054-n',[ ('Man',subsumption)]).
nounMapping2SUMO('10314182-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10314305-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10314422-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10314517-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10314627-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10314703-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10314836-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10314952-n',[ ('Migrant',equivalence)]).
nounMapping2SUMO('10315217-n',[ ('Position',instance)]).
nounMapping2SUMO('10315382-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10315456-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10315561-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10315730-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10315837-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10316013-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10316164-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10316360-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10316527-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10316683-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10316862-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10317007-n',[ ('MilitaryOfficer',equivalence)]).
nounMapping2SUMO('10317500-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10317717-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10317884-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10317963-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10318087-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10318193-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10318293-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10318414-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10318607-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10318686-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10318802-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10318892-n',[ ('Actor',subsumption)]).
nounMapping2SUMO('10319163-n',[ ('Actor',subsumption)]).
nounMapping2SUMO('10319313-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10319580-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10319796-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10319996-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10320106-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10320230-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10320354-n',[ ('FullyFormed',subsumption)]).
nounMapping2SUMO('10320484-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10320612-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10320695-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10320863-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10321126-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10321233-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10321340-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10321474-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10321632-n',[ ('Government',instance)]).
nounMapping2SUMO('10321754-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10321882-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10322084-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10322238-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10322391-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('10322546-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10322648-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10322801-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('10322957-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10323182-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10323529-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10323634-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10323752-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10323999-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10324201-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10324357-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10324560-n',[ ('ModellingPosition',subsumption)]).
nounMapping2SUMO('10324851-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10325013-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('10325243-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10325549-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10325656-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10325774-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10325957-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10326087-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10326257-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10326392-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10326551-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10326643-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10326776-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10326883-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10327002-n',[ ('Muslim',subsumption)]).
nounMapping2SUMO('10327143-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10327333-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10327475-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10327583-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10327696-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10327824-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10327987-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10328123-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10328328-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10328437-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10328560-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10328696-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10328782-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10328941-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10329035-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10329143-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10329251-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10329337-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10329579-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10329675-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10329789-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10329945-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10330189-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10330439-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10330593-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10330722-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10330835-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10330931-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10331098-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10331167-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10331258-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10331347-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('10331569-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('10331841-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10332016-n',[ ('FullyFormed',subsumption)]).
nounMapping2SUMO('10332110-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10332257-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10332385-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10332861-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10332953-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10333044-n',[ ('Woman',subsumption)]).
nounMapping2SUMO('10333165-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10333317-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10333439-n',[ ('Boy',subsumption)]).
nounMapping2SUMO('10333601-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10333719-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10333838-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10334009-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10334101-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10334255-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10334335-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10334461-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10334567-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10334782-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10334957-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10335123-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10335246-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10335563-n',[ ('Mouse',equivalence)]).
nounMapping2SUMO('10335679-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10335801-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10335931-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('10336234-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10336411-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10336537-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10336730-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10336904-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10337020-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10337134-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10337300-n',[ ('Stealing',subsumption)]).
nounMapping2SUMO('10337488-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10337645-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10337789-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10337913-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10338094-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10338231-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10338391-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10338498-n',[ ('Painting',subsumption)]).
nounMapping2SUMO('10338628-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10338707-n',[ ('Murder',equivalence)]).
nounMapping2SUMO('10339179-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10339251-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10339350-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10339504-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10339717-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10339856-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10339966-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10340312-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10341243-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10341343-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10341446-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10341573-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10341660-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('10341955-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10342180-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10342367-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10342543-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10342770-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10342893-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10342992-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10343088-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10343211-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10343355-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10343449-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10343554-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10343869-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10344004-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10344121-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10344203-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10344319-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10344443-n',[ ('Celebrity',equivalence)]).
nounMapping2SUMO('10344656-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10344774-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10344922-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10345015-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10345100-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10345302-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10345422-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10345556-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10345659-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10345804-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10346015-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10346198-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('10346392-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10346514-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10346955-n',[ ('Philosophy',subsumption)]).
nounMapping2SUMO('10347110-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10347204-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10347298-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10347446-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10347593-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10347883-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10348365-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10348526-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10348752-n',[ ('Governor',subsumption)]).
nounMapping2SUMO('10348874-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10348989-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10349090-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10349243-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10349551-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('10349670-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10349750-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('10349836-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10350220-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10350484-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10350666-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10350774-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10350896-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10351064-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10351152-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10351281-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10351491-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10351625-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10351874-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10352208-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10352299-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10352557-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10352663-n',[ ('FullyFormed',subsumption)]).
nounMapping2SUMO('10352782-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10352898-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10353016-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10353269-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10353355-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10353475-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10353598-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10353734-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10353813-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10353928-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10354053-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10354265-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10354580-n',[ ('Researcher',instance)]).
nounMapping2SUMO('10354754-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10354898-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10355142-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('10355306-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10355449-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10355688-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10355806-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10355942-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10356066-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10356213-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10356344-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10356450-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10356592-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10356749-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10356877-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10357012-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10357112-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10357207-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10357349-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10357484-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10357613-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10357737-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10357907-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10358032-n',[ ('Porter',subsumption)]).
nounMapping2SUMO('10358124-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10358322-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10358420-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10358575-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10358794-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10358889-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10359117-n',[ ('Female',subsumption), ('Muslim',subsumption)]).
nounMapping2SUMO('10359300-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10359422-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10359546-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10359659-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10359759-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10359988-n',[ ('Philosophy',subsumption)]).
nounMapping2SUMO('10360101-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10360253-n',[ ('AgeGroup',subsumption)]).
nounMapping2SUMO('10360366-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10360578-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10360747-n',[ ('NonCommissionedOfficerRank',equivalence)]).
nounMapping2SUMO('10361060-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10361194-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10361296-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10361390-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10361525-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10361901-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10362003-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10362195-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10362319-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10362428-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10362557-n',[ ('Protestantism',subsumption)]).
nounMapping2SUMO('10362682-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10362765-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10362917-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('10363017-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10363149-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('10363360-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10363445-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10363573-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10363913-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10364198-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10364333-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10364502-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10364643-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10365399-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10365514-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10365701-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10365846-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10365984-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10366145-n',[ ('Woman',subsumption)]).
nounMapping2SUMO('10366276-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10366383-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10366484-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('10366692-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10366779-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10366966-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10367409-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10367548-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10367694-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10367819-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10368009-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('10368113-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10368291-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10368414-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10368528-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10368624-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10368711-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10368798-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10368920-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10369095-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10369166-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10369317-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10369417-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10369528-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10369699-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10369845-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10369955-n',[ ('Government',subsumption)]).
nounMapping2SUMO('10370122-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10370286-n',[ ('AgeGroup',instance)]).
nounMapping2SUMO('10370381-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10370603-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10370683-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10370881-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10370955-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10371052-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10371221-n',[ ('Position',equivalence)]).
nounMapping2SUMO('10371330-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10371450-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10371741-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10372076-n',[ ('GameReferee',subsumption)]).
nounMapping2SUMO('10372373-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10373390-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('10373525-n',[ ('Government',instance)]).
nounMapping2SUMO('10373639-n',[ ('Government',instance)]).
nounMapping2SUMO('10373801-n',[ ('Government',instance)]).
nounMapping2SUMO('10373998-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10374282-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10374415-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10374541-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10374652-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10374762-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10374849-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10374943-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10375052-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10375129-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10375214-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('10375314-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10375402-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10375506-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('10375690-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10375794-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10376523-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10376890-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10377021-n',[ ('Woman',equivalence)]).
nounMapping2SUMO('10377185-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10377291-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10377394-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10377542-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10377633-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('10377732-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10377865-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10378026-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10378113-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10378213-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10378290-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10378412-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10378780-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10378952-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10379073-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10379278-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10379376-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10379620-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10379758-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10380000-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10380126-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10380305-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10380499-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10380672-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10381100-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10381214-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10381369-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10381698-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10381804-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10381981-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10382157-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10382302-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10382380-n',[ ('Judge',subsumption)]).
nounMapping2SUMO('10382480-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10382597-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10382710-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10382825-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10383094-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10383237-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10383505-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10383689-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10383816-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10384054-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10384214-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10384392-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10384496-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10384610-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10384772-n',[ ('Judaism',subsumption)]).
nounMapping2SUMO('10384935-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10385159-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10385354-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10385455-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10385566-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10385707-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10385923-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10386071-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10386196-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10386312-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10386515-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10386618-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10386754-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10386874-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10386984-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10387196-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10387324-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10387476-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10387586-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10387712-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10387836-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10387936-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10388082-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10388192-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10388321-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10388440-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10388647-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10388732-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10388924-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10389398-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10389760-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10389865-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10389976-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10390050-n',[ ('Group',subsumption)]).
nounMapping2SUMO('10390199-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10390427-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('10390600-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10390698-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10390807-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10390902-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10391086-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10391248-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10391416-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10391513-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10391653-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10393909-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10394141-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10394329-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10394434-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10394673-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10394786-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10395073-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10395209-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10395390-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10395605-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10395828-n',[ ('Position',instance)]).
nounMapping2SUMO('10395926-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10396106-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10396337-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10396462-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10396594-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10396727-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10396908-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10397001-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10397142-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10397275-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10397392-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10397482-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10397694-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10397886-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10398033-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10398176-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10398370-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10398487-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('10398624-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10398806-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10399019-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10399130-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10399299-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10399491-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10399895-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10400003-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('10400108-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('10400205-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10400309-n',[ ('PoliticalFigure',subsumption)]).
nounMapping2SUMO('10400437-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10400618-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10400826-n',[ ('Maid',subsumption)]).
nounMapping2SUMO('10400998-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10401204-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10401331-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10401468-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('10401639-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10401829-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10402086-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10402285-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10402417-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10402603-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10402709-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10402824-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('10403162-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10403366-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10403490-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10403633-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('10403768-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10403876-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10404242-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10404426-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10404550-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10404672-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10404810-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10404998-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('10405107-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10405229-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10405320-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10405410-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('10405540-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10405694-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10406072-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('10406266-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10406391-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10406765-n',[ ('Man',subsumption)]).
nounMapping2SUMO('10406905-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10407105-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10407221-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10407310-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10407552-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10407726-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10407954-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10408324-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10408438-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10408552-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10408809-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10408939-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10409011-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10409161-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10409322-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10409459-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10409634-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10409752-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10410035-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10410125-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10410246-n',[ ('PeacekeepingUnit',equivalence)]).
nounMapping2SUMO('10410440-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10410531-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10410668-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10410815-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10410996-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10411163-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10411356-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10411551-n',[ ('SalesPosition',subsumption)]).
nounMapping2SUMO('10411867-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10412055-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('10412554-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10412669-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10412784-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10412910-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10413276-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10413429-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10413588-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10413688-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10413834-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10414084-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10414239-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10414379-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10414507-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10414612-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10414768-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10414865-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('10415037-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10415230-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('10415439-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10415638-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10416270-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10416364-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10416444-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10416567-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10416732-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('10416828-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10416909-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10417045-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10417168-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10417288-n',[ ('Soldier',instance)]).
nounMapping2SUMO('10417424-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10417551-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10417682-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10417843-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10417969-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10418101-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10418302-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10418577-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10418735-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10418841-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10419047-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10419472-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10419630-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10419785-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10419916-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10420031-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('10420277-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10420392-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10420507-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10420649-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10420809-n',[ ('NonCommissionedOfficerRank',subsumption)]).
nounMapping2SUMO('10421016-n',[ ('Position',instance)]).
nounMapping2SUMO('10421183-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('10421339-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10421470-n',[ ('Pharmacist',subsumption)]).
nounMapping2SUMO('10421753-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10421956-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10422405-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10422540-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10422759-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10422871-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10423031-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10423225-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10423514-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10423589-n',[ ('Philosophy',equivalence)]).
nounMapping2SUMO('10425946-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10426184-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10426363-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10426454-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10426630-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10426749-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10427103-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10427223-n',[ ('Journalist',subsumption)]).
nounMapping2SUMO('10427359-n',[ ('SkilledOccupation',instance)]).
nounMapping2SUMO('10427467-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('10427658-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10427764-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10428004-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10429965-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10430554-n',[ ('SkilledOccupation',instance)]).
nounMapping2SUMO('10430665-n',[ ('Pianist',equivalence)]).
nounMapping2SUMO('10431122-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10431224-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10431330-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10431514-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10431625-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10431770-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10431907-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10432053-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10432189-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10432320-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('10432441-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10432532-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10432674-n',[ ('MovingResidence',subsumption)]).
nounMapping2SUMO('10432875-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10432957-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10433077-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10433164-n',[ ('Pilot',equivalence)]).
nounMapping2SUMO('10433452-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('10433610-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('10433737-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10434054-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10434160-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10434321-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10434424-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10434725-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10434947-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10435041-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10435169-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10435251-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10435367-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10435716-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10435855-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10435988-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10436334-n',[ ('Sales',subsumption)]).
nounMapping2SUMO('10436458-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10436707-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10436851-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10437014-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10437137-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10437262-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10437590-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10437698-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10437852-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('10438042-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10438172-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10438470-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10438619-n',[ ('BusinessPerson',subsumption)]).
nounMapping2SUMO('10438728-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10438842-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10438952-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10439087-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10439203-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10439373-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10439523-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10439629-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10439727-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10439851-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10440387-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10440580-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10440717-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10440886-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10441037-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10441124-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10441251-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10441410-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10441534-n',[ ('FullyFormed',subsumption)]).
nounMapping2SUMO('10441694-n',[ ('FullyFormed',subsumption)]).
nounMapping2SUMO('10441819-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10441962-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10442093-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10442232-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10442417-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10442573-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10442705-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10442815-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10442923-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10443032-n',[ ('Plumber',subsumption)]).
nounMapping2SUMO('10443170-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10443482-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10443659-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10443830-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10443955-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10444058-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10444194-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10447255-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10447359-n',[ ('Position',instance)]).
nounMapping2SUMO('10447585-n',[ ('Position',instance)]).
nounMapping2SUMO('10447828-n',[ ('Food',subsumption)]).
nounMapping2SUMO('10447924-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10448065-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10448157-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10448322-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10448455-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10448568-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10448670-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10448834-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10448983-n',[ ('PoliceOfficer',equivalence)]).
nounMapping2SUMO('10449412-n',[ ('Government',subsumption)]).
nounMapping2SUMO('10449521-n',[ ('PoliceSergeant',subsumption)]).
nounMapping2SUMO('10449664-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('10449845-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10450038-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10450161-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10450303-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10451263-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10451450-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10451590-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10451858-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10452024-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10452151-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10452260-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10452432-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10452535-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10452631-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10452752-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10452892-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('10453061-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10453184-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10453265-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10453357-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10453533-n',[ ('Pope',instance)]).
nounMapping2SUMO('10454645-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10454752-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10454972-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10455094-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10455305-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10455447-n',[ ('Porter',equivalence)]).
nounMapping2SUMO('10455619-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10455821-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10455915-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('10456070-n',[ ('Pretending',subsumption)]).
nounMapping2SUMO('10456138-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10456391-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10456514-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10456603-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('10456696-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10456874-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10456950-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10457214-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10457293-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10457444-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10457597-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('10457777-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10457903-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10458024-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10458111-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10458356-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10458519-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10458596-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('10458696-n',[ ('Dentist',subsumption)]).
nounMapping2SUMO('10458834-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10459116-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10459212-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10459414-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10459575-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10459687-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10459764-n',[ ('Position',instance)]).
nounMapping2SUMO('10459882-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10460033-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10460193-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10460286-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10460501-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10460599-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10460720-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10460806-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10461060-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10461169-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10461280-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10461424-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('10461747-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10462005-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('10462217-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10462429-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10462588-n',[ ('SkilledOccupation',instance)]).
nounMapping2SUMO('10462751-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10462860-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10463028-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10463259-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('10463386-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10463582-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('10463714-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10463943-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10464052-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('10464178-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('10464432-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10464542-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10464711-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10464870-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10465002-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10465128-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10465248-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10465451-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10465635-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10465831-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10465922-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('10466060-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10466198-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10466387-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10466564-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10466759-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10466918-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10467052-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10467179-n',[ ('President',subsumption)]).
nounMapping2SUMO('10467395-n',[ ('President',subsumption)]).
nounMapping2SUMO('10468559-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10468750-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10468962-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10469346-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10469511-n',[ ('Philosophy',subsumption)]).
nounMapping2SUMO('10469611-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10469786-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10469874-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10469979-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10470132-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10470314-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10470460-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10470779-n',[ ('Cleric',equivalence)]).
nounMapping2SUMO('10471250-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('10471570-n',[ ('Female',subsumption), ('Cleric',subsumption)]).
nounMapping2SUMO('10471640-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10471732-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10471859-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10471948-n',[ ('MedicalDoctor',subsumption)]).
nounMapping2SUMO('10472129-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10472274-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10472447-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10472690-n',[ ('Position',instance)]).
nounMapping2SUMO('10472799-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10473273-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10473453-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10473562-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10473718-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10473789-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10473917-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10474064-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10474343-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10474446-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10474645-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10474950-n',[ ('LegalAgent',subsumption)]).
nounMapping2SUMO('10475163-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10475297-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10475584-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10475687-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10475835-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10475940-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10476086-n',[ ('Prisoner',equivalence)]).
nounMapping2SUMO('10476331-n',[ ('PrisonerOfWar',equivalence)]).
nounMapping2SUMO('10476467-n',[ ('PrivateRank',subsumption)]).
nounMapping2SUMO('10476671-n',[ ('PrivateDetective',subsumption)]).
nounMapping2SUMO('10476928-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10477077-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10477465-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10477585-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10477713-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10477839-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10477955-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10478118-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10478293-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10478462-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10478626-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10478827-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10478960-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10479135-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10479328-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10479493-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10479561-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10479783-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10480018-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10480253-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('10480583-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10480730-n',[ ('Professor',equivalence)]).
nounMapping2SUMO('10481003-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10481167-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10481268-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('10481561-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10481711-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10481929-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10482054-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10482220-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10482414-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10482587-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10482768-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10482921-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10483138-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10483274-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10483395-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10483530-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10483799-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10483890-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10484526-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10484739-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10484858-n',[ ('PublicProsecutor',subsumption)]).
nounMapping2SUMO('10485168-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10485298-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10485440-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10485883-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10485989-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10486166-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10486236-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10486349-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10486468-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10486561-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10486679-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10486909-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10487026-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10487182-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10487363-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10487592-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10487710-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10488016-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10488309-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10488513-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10488656-n',[ ('Psychology',subsumption)]).
nounMapping2SUMO('10488865-n',[ ('Psychology',equivalence)]).
nounMapping2SUMO('10489426-n',[ ('Psychology',subsumption)]).
nounMapping2SUMO('10489564-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10489818-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10489944-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10490141-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10490330-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10490421-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10490557-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10490699-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10490965-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10491136-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10491309-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10491575-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10491869-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10491998-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10492086-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10492202-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10492447-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10492627-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10492727-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10492894-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10493093-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10493199-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10493419-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10493528-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10493685-n',[ ('Actor',subsumption)]).
nounMapping2SUMO('10493835-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10493922-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10494037-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10494195-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10494373-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10494643-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10494778-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10494935-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10495167-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10495299-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10495421-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10495555-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10495756-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10495880-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10495975-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10496081-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10496193-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10496393-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10496489-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10496626-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10496715-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10496825-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10496927-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('10497046-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10497135-n',[ ('Judge',subsumption)]).
nounMapping2SUMO('10497202-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('10497373-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10497534-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10497645-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10497775-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10497946-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10498046-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10498196-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10498422-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10498551-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10498699-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10498816-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10498986-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10499110-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10499232-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10499355-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10499631-n',[ ('Queen',subsumption)]).
nounMapping2SUMO('10499857-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10500217-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10500419-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10500506-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10500603-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10500717-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10500824-n',[ ('Position',instance)]).
nounMapping2SUMO('10500942-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10501097-n',[ ('Agent',instance)]).
nounMapping2SUMO('10501203-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10501453-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10501635-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10501747-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10501908-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10502046-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10502204-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10502329-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('10502576-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10502762-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10502950-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10503138-n',[ ('ServicePosition',subsumption)]).
nounMapping2SUMO('10503247-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10503452-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10503710-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10503818-n',[ ('SkilledOccupation',instance)]).
nounMapping2SUMO('10503965-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10504090-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10504206-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10504426-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10504545-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10504664-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10504805-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10504956-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10505085-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10505206-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10505347-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('10505459-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10505613-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10505732-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10505816-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10505942-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10506094-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10506220-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10506336-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10506417-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10506544-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10506642-n',[ ('Female',subsumption), ('Hindu',subsumption)]).
nounMapping2SUMO('10506762-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10506915-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10507070-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10507230-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10507380-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10507482-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10507565-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10507692-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10507783-n',[ ('Man',instance)]).
nounMapping2SUMO('10508008-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10508141-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('10508272-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10508379-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10508475-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10508710-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('10508862-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10509063-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10509161-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10509389-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('10509605-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10509810-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10510078-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10510245-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10510339-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10510546-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10510818-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10510974-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10511069-n',[ ('ClericalSecretary',subsumption)]).
nounMapping2SUMO('10511239-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10511425-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10511649-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10511771-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10511856-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10511960-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10512109-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10512201-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10512372-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10512562-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10512708-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10512859-n',[ ('EnlistedSoldierRank',subsumption)]).
nounMapping2SUMO('10512982-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10513120-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10513386-n',[ ('Porter',subsumption)]).
nounMapping2SUMO('10513509-n',[ ('PoliceOfficer',subsumption)]).
nounMapping2SUMO('10513623-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10513823-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10513938-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10514051-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10514121-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10514255-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('10514429-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10514643-n',[ ('FieldOfLaw',subsumption)]).
nounMapping2SUMO('10514784-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10514962-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10515194-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10515863-n',[ ('Judaism',subsumption)]).
nounMapping2SUMO('10516016-n',[ ('Refugee',equivalence)]).
nounMapping2SUMO('10516117-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10516294-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('10516422-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10516527-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10516692-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10516874-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10517032-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10517137-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10517283-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10517405-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10517583-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10517743-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10517826-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10518003-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10518194-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10518349-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10518602-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('10518945-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10519126-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10519291-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('10519494-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10519884-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10519984-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10520109-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10520286-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10520544-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10520675-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10520804-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10520964-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10521100-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10521288-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10521470-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10521662-n',[ ('NewsReporter',equivalence)]).
nounMapping2SUMO('10521853-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10521928-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10522035-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10522324-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10522495-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10522633-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10522759-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10522956-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10523076-n',[ ('Researcher',subsumption)]).
nounMapping2SUMO('10523341-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10523519-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10524076-n',[ ('Position',instance)]).
nounMapping2SUMO('10524223-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10524413-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10524711-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10524869-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10524973-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10525134-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10525436-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10525617-n',[ ('Unemployed',subsumption)]).
nounMapping2SUMO('10525785-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10525878-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10526096-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10526300-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10526441-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('10526534-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10526633-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10526795-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10526927-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10527147-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10527334-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10527915-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10528023-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10528148-n',[ ('Hominid',subsumption)]).
nounMapping2SUMO('10528295-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10528493-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10528816-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10528969-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10529103-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10529231-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10529555-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10529684-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10529823-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10529965-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10530150-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10530288-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10530383-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10530475-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10530571-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10530677-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10530769-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10530862-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10530959-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10531109-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10531227-n',[ ('PoliticalOrganization',subsumption)]).
nounMapping2SUMO('10531445-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10531557-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10531694-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10531838-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10531948-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10532058-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10532252-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10532393-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10532479-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10532576-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10532751-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10532886-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10533013-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10533541-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10533681-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10533780-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10533874-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10533983-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10534277-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10534389-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10534586-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10534748-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10534849-n',[ ('NormativeAttribute',instance)]).
nounMapping2SUMO('10535047-n',[ ('Man',instance)]).
nounMapping2SUMO('10535196-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('10535366-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10535604-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10535706-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10535881-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10536021-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10536134-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10536274-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10536416-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10536728-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10536897-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10537018-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10537107-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10537240-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10537708-n',[ ('FamilyGroup',instance)]).
nounMapping2SUMO('10537822-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10537906-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10538082-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10538154-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10538272-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10538398-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10538518-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10538629-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10538733-n',[ ('FarmHand',subsumption)]).
nounMapping2SUMO('10538853-n',[ ('Position',instance)]).
nounMapping2SUMO('10539015-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10539160-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10539278-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10539462-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10539616-n',[ ('GroupOfPeople',subsumption)]).
nounMapping2SUMO('10539715-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10540114-n',[ ('Government',instance)]).
nounMapping2SUMO('10540252-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10540413-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('10540526-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10540656-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10540735-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10540872-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10540984-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('10541106-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10541229-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10541833-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10541983-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10542054-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10542138-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('10542401-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('10542499-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10542608-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10542761-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10542888-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10543057-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10543161-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10543420-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10543544-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10543713-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10543795-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10543937-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10544067-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10544232-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10544480-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10544615-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10544748-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10544940-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10545087-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10545187-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10545296-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10545415-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10545524-n',[ ('Judaism',subsumption)]).
nounMapping2SUMO('10545682-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10545792-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10545940-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10546062-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10546202-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10546428-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10546561-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10546633-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10546850-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10547145-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10548227-n',[ ('SalesPosition',subsumption)]).
nounMapping2SUMO('10548419-n',[ ('Female',subsumption), ('SalesPosition',subsumption)]).
nounMapping2SUMO('10548537-n',[ ('SalesPosition',subsumption)]).
nounMapping2SUMO('10548681-n',[ ('SalesPosition',equivalence)]).
nounMapping2SUMO('10548976-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10549062-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10549165-n',[ ('Position',instance)]).
nounMapping2SUMO('10549315-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10549510-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10549648-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10549763-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10549925-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10550090-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10550252-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10550369-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10550468-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10550551-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10550673-n',[ ('Man',instance)]).
nounMapping2SUMO('10550951-n',[ ('Man',instance)]).
nounMapping2SUMO('10551265-n',[ ('Woman',instance)]).
nounMapping2SUMO('10551576-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10551751-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10551898-n',[ ('Muslim',subsumption)]).
nounMapping2SUMO('10552019-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10552203-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10552285-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10552393-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10552486-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10552639-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10552742-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10552980-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10553140-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10553235-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10553402-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10553627-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10553805-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10554024-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10554141-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10554243-n',[ ('Saxophonist',equivalence)]).
nounMapping2SUMO('10554455-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10554666-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10554846-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10555059-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10555156-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10555311-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10555430-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10555538-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('10555679-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10555825-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10555936-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10556033-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('10556124-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10556235-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10556401-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10556518-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10556704-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10556825-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10556953-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10557094-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10557246-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10557404-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10557517-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10557699-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10557854-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('10558773-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10558896-n',[ ('Philosophy',subsumption)]).
nounMapping2SUMO('10559009-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10559192-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10559288-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10559508-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10559603-n',[ ('Female',subsumption), ('Student',subsumption)]).
nounMapping2SUMO('10559683-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10559840-n',[ ('Female',subsumption), ('Teacher',subsumption)]).
nounMapping2SUMO('10559996-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10560106-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10560247-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10560352-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10560548-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10560637-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10561222-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10561320-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10561613-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10561736-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10561861-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10562135-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10562283-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10562391-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10562509-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10562645-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10562749-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10562968-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10563183-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10563314-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10563403-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10563610-n',[ ('Food',subsumption)]).
nounMapping2SUMO('10563711-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10563826-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('10563940-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10564098-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10564224-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10564400-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10564541-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10564660-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10564800-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10564905-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10565048-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10565197-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10565302-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10565502-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10565667-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10565764-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10565951-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10566072-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10566893-n',[ ('ArtWork',subsumption)]).
nounMapping2SUMO('10566966-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10567096-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10567172-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10567268-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10567401-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10567613-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10567722-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10567848-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10567979-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10568083-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10568200-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10568358-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10568443-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10568608-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10568754-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10568915-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10569011-n',[ ('USMilitaryRankO1',subsumption)]).
nounMapping2SUMO('10569179-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10569411-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10569744-n',[ ('ClericalSecretary',equivalence)]).
nounMapping2SUMO('10570019-n',[ ('GovernmentSecretary',equivalence)]).
nounMapping2SUMO('10570429-n',[ ('Position',instance)]).
nounMapping2SUMO('10570704-n',[ ('Position',instance)]).
nounMapping2SUMO('10570961-n',[ ('Position',instance)]).
nounMapping2SUMO('10571202-n',[ ('SecretaryOfDefense',equivalence)]).
nounMapping2SUMO('10571435-n',[ ('Position',instance)]).
nounMapping2SUMO('10571670-n',[ ('Position',instance)]).
nounMapping2SUMO('10571907-n',[ ('Position',instance)]).
nounMapping2SUMO('10572185-n',[ ('Position',instance)]).
nounMapping2SUMO('10572469-n',[ ('Position',instance)]).
nounMapping2SUMO('10572706-n',[ ('Position',instance)]).
nounMapping2SUMO('10572889-n',[ ('Position',instance)]).
nounMapping2SUMO('10573129-n',[ ('Position',instance)]).
nounMapping2SUMO('10573349-n',[ ('Position',instance)]).
nounMapping2SUMO('10573596-n',[ ('Position',instance)]).
nounMapping2SUMO('10573829-n',[ ('Position',instance)]).
nounMapping2SUMO('10573957-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10574154-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10574311-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10574425-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10574538-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10574723-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10574840-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10574958-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10575089-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10575241-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10575387-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10575463-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10575594-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10575705-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10575787-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10576071-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10576223-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10576316-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10576513-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10576676-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10576818-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10576962-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10577182-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10577284-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10577710-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10577820-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10578021-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10578162-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10578349-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10578471-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10578656-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10578762-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10578952-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10579062-n',[ ('CollegeSenior',subsumption)]).
nounMapping2SUMO('10579176-n',[ ('NonCommissionedOfficerRank',subsumption)]).
nounMapping2SUMO('10579369-n',[ ('NonCommissionedOfficerRank',subsumption)]).
nounMapping2SUMO('10579549-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10579676-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10579835-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10580030-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10580304-n',[ ('Judaism',subsumption)]).
nounMapping2SUMO('10580437-n',[ ('AgeGroup',instance)]).
nounMapping2SUMO('10580535-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10580772-n',[ ('USMilitaryRankE5',subsumption)]).
nounMapping2SUMO('10581094-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10581278-n',[ ('USMilitaryRankE9',subsumption)]).
nounMapping2SUMO('10581464-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10581648-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10581772-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10581890-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10582032-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10582154-n',[ ('ServicePosition',subsumption)]).
nounMapping2SUMO('10582507-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10582604-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10582746-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('10583250-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10583387-n',[ ('MovingResidence',equivalence)]).
nounMapping2SUMO('10583790-n',[ ('ClericalSecretary',subsumption)]).
nounMapping2SUMO('10583916-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10584021-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10584318-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10584501-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10584617-n',[ ('AgeGroup',instance)]).
nounMapping2SUMO('10584729-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10584853-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10584973-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10585077-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10585217-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10585359-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10585496-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10585628-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10585773-n',[ ('Christianity',subsumption)]).
nounMapping2SUMO('10585976-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10586166-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10586265-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10586444-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10586557-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10586674-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10586793-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10586903-n',[ ('Man',subsumption)]).
nounMapping2SUMO('10586998-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10587089-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10587227-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('10587378-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10587536-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10587605-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10587806-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10587894-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10588074-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10588182-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10588357-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10588519-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10588601-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10588724-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10588860-n',[ ('Man',instance)]).
nounMapping2SUMO('10588965-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10589066-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10589140-n',[ ('Sheriff',subsumption)]).
nounMapping2SUMO('10589243-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10589402-n',[ ('Position',instance)]).
nounMapping2SUMO('10589566-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10589666-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10589785-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10589930-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10590042-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10590146-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10590239-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10590339-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10590452-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10590537-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10590638-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10590764-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10590903-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10590977-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10591072-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10591239-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10591347-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10591481-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10591678-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10591811-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10591949-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10592049-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10592152-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10592397-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10592595-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10592811-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10592986-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10593115-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10593392-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10593521-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10593618-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10593745-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10594043-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10594147-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10594284-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10594408-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10594523-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10594634-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10594715-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('10594857-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10595012-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10595164-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10595361-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10595551-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10595647-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10596272-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10596348-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10596517-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10596689-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10596899-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10597091-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10597234-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10597505-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10597642-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10597745-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10597889-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10598013-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10598181-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10598349-n',[ ('Sikh',equivalence)]).
nounMapping2SUMO('10598459-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10598641-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10598749-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10598904-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10599068-n',[ ('Man',instance)]).
nounMapping2SUMO('10599215-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10599354-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10599806-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10601078-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10601234-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10601362-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10601451-n',[ ('Man',equivalence)]).
nounMapping2SUMO('10601526-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10601644-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10601725-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10601840-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('10602119-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10602258-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10602470-n',[ ('Female',subsumption), ('ReligiousPosition',subsumption)]).
nounMapping2SUMO('10602695-n',[ ('Female',subsumption), ('Deacon',subsumption)]).
nounMapping2SUMO('10602985-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10603242-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10603378-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10603528-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10603766-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10603851-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10603959-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('10604089-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10604180-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10604275-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10604380-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10604491-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10604634-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10604880-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10604979-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10605088-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10605253-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10605375-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10605510-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10605608-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10605737-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10605848-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10605985-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('10607291-n',[ ('Human',undefined)]).
nounMapping2SUMO('10607478-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10607706-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10607824-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10607933-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10608073-n',[ ('Porter',subsumption)]).
nounMapping2SUMO('10608188-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10608385-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10608658-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10608803-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10609092-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10609198-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10609325-n',[ ('HumanSlave',equivalence)]).
nounMapping2SUMO('10609556-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10609686-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10609871-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10609960-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10610096-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10610201-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10610333-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10610465-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10610699-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10610850-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10611117-n',[ ('Woman',instance)]).
nounMapping2SUMO('10611267-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10611361-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10611541-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10611613-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10611729-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10611869-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10611988-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10612104-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10612210-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10612373-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10612518-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10612645-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10612803-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10612931-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10613052-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10613198-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10613387-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10613505-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10613738-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10613839-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10613996-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10614225-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10614363-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10614507-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10614629-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10614812-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10614976-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10615179-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10615334-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10615584-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10615702-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10615808-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10615929-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10616048-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10616204-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10616379-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10616578-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10616670-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10616779-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10616899-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10617024-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10617193-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10617397-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10617501-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10617665-n',[ ('SportsPosition',instance)]).
nounMapping2SUMO('10617814-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10617904-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10618007-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10618146-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10618234-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10618342-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10618465-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10618685-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10618848-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10619176-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10619409-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10619492-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10619642-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10619888-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10620027-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10620212-n',[ ('Protestant',subsumption)]).
nounMapping2SUMO('10620437-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10620586-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10620758-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10621140-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10621294-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10621400-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10621514-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10621738-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10621847-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10621941-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10622053-n',[ ('Soldier',equivalence)]).
nounMapping2SUMO('10623175-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10623354-n',[ ('Requesting',subsumption)]).
nounMapping2SUMO('10623533-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10623650-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10623806-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10623949-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10624074-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10624310-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10624437-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10624540-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10624915-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10625000-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10625099-n',[ ('Philosophy',subsumption)]).
nounMapping2SUMO('10625285-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10625438-n',[ ('CollegeSophomore',subsumption)]).
nounMapping2SUMO('10625546-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10625860-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('10626194-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('10626439-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('10626540-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('10626630-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10626722-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10626867-n',[ ('ClericalSecretary',subsumption)]).
nounMapping2SUMO('10626994-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10627082-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('10627252-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10627349-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10627557-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10627714-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10627899-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10628097-n',[ ('Protestantism',subsumption)]).
nounMapping2SUMO('10628222-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('10628368-n',[ ('ConfederateSoldier',equivalence)]).
nounMapping2SUMO('10628644-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10629020-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10629142-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10629329-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10629449-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10629545-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10629647-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10629820-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10629939-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10630093-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10630188-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10631131-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10631309-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10631512-n',[ ('Guiding',subsumption)]).
nounMapping2SUMO('10631654-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10631765-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10631941-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('10632576-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10633298-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10633450-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10634075-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10634316-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10634464-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10634596-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10634723-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10634849-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10634990-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('10635149-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10635275-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10635460-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10635625-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10635788-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10635907-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10636014-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10636340-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10636488-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10636598-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('10636746-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('10636874-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10637038-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10637229-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10637360-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10637483-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10637635-n',[ ('SkilledOccupation',instance)]).
nounMapping2SUMO('10637839-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10637961-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10638136-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10638310-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10638385-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10638734-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10638813-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('10638922-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10639047-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10639238-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10639359-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10639469-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10639637-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10639817-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10639925-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10640084-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10640195-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10640327-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10640446-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10640620-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10640968-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10641112-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10641223-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10641301-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10641413-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10641551-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10641755-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10642151-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10642388-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10642499-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10642596-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10642705-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10642845-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10642988-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10643095-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10643218-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10643400-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10643476-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10643584-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10643727-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10643837-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10643937-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10644062-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10644179-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10644301-n',[ ('FarmHand',subsumption)]).
nounMapping2SUMO('10644469-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('10644598-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10644839-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10645017-n',[ ('USMilitaryRankE6',subsumption)]).
nounMapping2SUMO('10645223-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10645392-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10645611-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10645854-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10646032-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10646140-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10646325-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10646433-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10646528-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('10646641-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10646780-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10646942-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('10647168-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('10647359-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10647475-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10647582-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10647745-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10648033-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('10648237-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10648696-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10648909-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10649047-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10649197-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10649308-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10649438-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10649574-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10649724-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10649823-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10649962-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10650076-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10650162-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10652511-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10652605-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10652703-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10652837-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10652954-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10653238-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10653388-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10653529-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10653679-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10653793-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10653903-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10654015-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10654211-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10654321-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10654461-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10654596-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10654701-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10654827-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10654932-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10655075-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10655169-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10655442-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10655594-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10655730-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10655875-n',[ ('Female',subsumption), ('ServicePosition',subsumption)]).
nounMapping2SUMO('10655986-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10656120-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10656223-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10656488-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10656706-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10656832-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10656969-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10657165-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10657306-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10657444-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10657556-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10657681-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10657835-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10657969-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10658122-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10658304-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10658501-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10658676-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10658867-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('10659042-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10659188-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10659294-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10659393-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10659571-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10659762-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10659961-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10660128-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10660250-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('10660333-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10660471-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10660621-n',[ ('Pilot',subsumption)]).
nounMapping2SUMO('10660729-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10660883-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10661002-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10661216-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10661334-n',[ ('Socialrole',subsumption)]).
nounMapping2SUMO('10661464-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10661563-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10661732-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10661865-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('10662046-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10662162-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10662306-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10662474-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10662649-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10662819-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10662952-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10663137-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10663315-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10663549-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10663659-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10663745-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10663858-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10663996-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10664076-n',[ ('Government',subsumption)]).
nounMapping2SUMO('10664235-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10664340-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10664656-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10664850-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10665006-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10665190-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10665302-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10665455-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('10665587-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10665698-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10666259-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10666464-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10666615-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10666752-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10666846-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10667041-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('10667187-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10667477-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10667596-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10667709-n',[ ('CompanyGradeRank',subsumption)]).
nounMapping2SUMO('10667863-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10668024-n',[ ('Cleric',subsumption)]).
nounMapping2SUMO('10668280-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10668450-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10668666-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('10669009-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10669125-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10669236-n',[ ('CommissionedOfficerRank',subsumption)]).
nounMapping2SUMO('10669357-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10669486-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10669727-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10669876-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10669991-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10670310-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10670483-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10670668-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10670885-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10671042-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10671300-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10671387-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10671467-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10671613-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10671736-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10671898-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10672066-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10672192-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10672371-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10672540-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10672662-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10672908-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10673296-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10673451-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10673669-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10673776-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10673946-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10674130-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10674315-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10674471-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10674592-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10674713-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10674896-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10675010-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10675142-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10675258-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10675346-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10675481-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10675609-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10675721-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10675876-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10676018-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10676214-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10676319-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10676434-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10676569-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10676682-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10676877-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10677271-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10677604-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10677713-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10678472-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10678662-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10678841-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10678937-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10679054-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10679174-n',[ ('Surgeon',subsumption)]).
nounMapping2SUMO('10679503-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10679610-n',[ ('Position',instance)]).
nounMapping2SUMO('10679723-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10679845-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10679998-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10680153-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10680370-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10680609-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10680796-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10680910-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10681060-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10681194-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10681383-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10681557-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10681748-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('10681891-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10682038-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10682169-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10682380-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10682501-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10682599-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10682713-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10682850-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10682953-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10683126-n',[ ('Swimmer',subsumption)]).
nounMapping2SUMO('10683349-n',[ ('Swimmer',subsumption)]).
nounMapping2SUMO('10683593-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10683675-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10683801-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10683927-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10684146-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10684311-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10684446-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10684538-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10684630-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10684827-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10685123-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10685300-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('10685398-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10685480-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('10685587-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10685685-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10685853-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10686073-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10686313-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10686517-n',[ ('Composing',subsumption)]).
nounMapping2SUMO('10686598-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10686694-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10686885-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10687025-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10687135-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10687231-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10687427-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10687516-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10687728-n',[ ('SkilledOccupation',instance)]).
nounMapping2SUMO('10687826-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10687922-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10688070-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10688238-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10688356-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10688491-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10688671-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10688811-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10688975-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10689104-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10689306-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10689429-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10689564-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10689784-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10689878-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10690002-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10690095-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10690268-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10690421-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10690538-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10690648-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10690742-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10690849-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10691052-n',[ ('Position',instance)]).
nounMapping2SUMO('10691148-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10691318-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10691485-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10691600-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10691764-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10691937-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10692090-n',[ ('Man',subsumption)]).
nounMapping2SUMO('10692269-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10692405-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10692482-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10692696-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10692883-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10693052-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10693235-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10693334-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10693459-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10693646-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10693824-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10694163-n',[ ('Tax',equivalence)]).
nounMapping2SUMO('10694258-n',[ ('Teacher',equivalence)]).
nounMapping2SUMO('10694849-n',[ ('Favorite',subsumption)]).
nounMapping2SUMO('10694939-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10695050-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10695192-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10695333-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10695450-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10695555-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10695822-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10695917-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10696101-n',[ ('USMilitaryRankE6',subsumption)]).
nounMapping2SUMO('10696251-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10696508-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10696672-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10696755-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10696888-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10697013-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('10697135-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10697282-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10697420-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10697519-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('10697782-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10697879-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10698064-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10698241-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10698368-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10698550-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10698649-n',[ ('Man',instance)]).
nounMapping2SUMO('10698970-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10699099-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10699262-n',[ ('Human',equivalence)]).
nounMapping2SUMO('10699415-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10699558-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10699752-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10699981-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10700105-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10700201-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10700517-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10700640-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10700840-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10700963-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10701096-n',[ ('Coach',subsumption)]).
nounMapping2SUMO('10701180-n',[ ('Athlete',subsumption)]).
nounMapping2SUMO('10701644-n',[ ('TennisProfessional',equivalence)]).
nounMapping2SUMO('10701783-n',[ ('Male',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10701962-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10702077-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10702167-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10702307-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10702483-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10702615-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10702781-n',[ ('Terrorist',equivalence)]).
nounMapping2SUMO('10703221-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10703336-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10703480-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10703553-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('10703692-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10703905-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10704098-n',[ ('Pilot',subsumption)]).
nounMapping2SUMO('10704238-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10704516-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('10704712-n',[ ('Government',instance)]).
nounMapping2SUMO('10704886-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10705100-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10705211-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10705345-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10705448-n',[ ('SkilledOccupation',instance)]).
nounMapping2SUMO('10705615-n',[ ('Profession',subsumption)]).
nounMapping2SUMO('10706812-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10707134-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10707233-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10707616-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10707707-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10707804-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10708292-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('10708454-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10708797-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10708976-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10709131-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10709256-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10709358-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10709435-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10709529-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10709745-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10709876-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10709979-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('10710171-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10710259-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10710403-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10710509-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10710632-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10710778-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10710913-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10711005-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10711144-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10711253-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10711370-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10711483-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10711641-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10711766-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10711852-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10712055-n',[ ('SkilledOccupation',instance)]).
nounMapping2SUMO('10712229-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10712374-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10712474-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10712573-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10712690-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10712835-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10713012-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10713124-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10713254-n',[ ('Government',instance)]).
nounMapping2SUMO('10713367-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10713502-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10713686-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10713843-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10713923-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10714054-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10714195-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10714317-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('10714465-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10714577-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10714684-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10714851-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10715030-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10715136-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10715211-n',[ ('Man',instance)]).
nounMapping2SUMO('10715347-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10715447-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10715544-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10715671-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10715789-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10715881-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10716005-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10716286-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10716389-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10716576-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10716698-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10716864-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10717055-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10717196-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10717337-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10717461-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10717589-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10717772-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10717921-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10718040-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10718131-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10718349-n',[ ('Position',instance)]).
nounMapping2SUMO('10718509-n',[ ('Position',instance)]).
nounMapping2SUMO('10718665-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10718794-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10718952-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10719036-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10719132-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10719267-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10719395-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10719573-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10719692-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10719807-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10719972-n',[ ('PoliceDetective',subsumption)]).
nounMapping2SUMO('10720097-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10720197-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10720267-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10720453-n',[ ('SalesPosition',subsumption)]).
nounMapping2SUMO('10720964-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10721124-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10721321-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10721470-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10721612-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10721708-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10721819-n',[ ('Female',subsumption), ('TheaterPosition',subsumption)]).
nounMapping2SUMO('10721919-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10722029-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10722137-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10722239-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10722385-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10722575-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10722758-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10722965-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10723230-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10723300-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10723474-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10723597-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10723731-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10723873-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10723984-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10724132-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10724272-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10724372-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10724570-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10724699-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10724999-n',[ ('SkilledOccupation',instance)]).
nounMapping2SUMO('10725149-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10725280-n',[ ('SkilledOccupation',instance)]).
nounMapping2SUMO('10725438-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10725613-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10725734-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('10725893-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10726031-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10726233-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10726388-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('10726524-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10726669-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10726786-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10727016-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10727171-n',[ ('OccupationalTrade',subsumption)]).
nounMapping2SUMO('10727256-n',[ ('Treasurer',subsumption)]).
nounMapping2SUMO('10727458-n',[ ('Position',instance)]).
nounMapping2SUMO('10727623-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10727818-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10727944-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10728117-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10728233-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10728361-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10728523-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10728624-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10728727-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10728828-n',[ ('Region',subsumption)]).
nounMapping2SUMO('10728998-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10729175-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10729330-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10729442-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10729567-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('10729711-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10729801-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10729923-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10730077-n',[ ('Christian',subsumption)]).
nounMapping2SUMO('10730262-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10730416-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10730542-n',[ ('Government',instance)]).
nounMapping2SUMO('10730615-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10730728-n',[ ('Government',instance)]).
nounMapping2SUMO('10730820-n',[ ('Woman',subsumption)]).
nounMapping2SUMO('10731013-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10731244-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10731560-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10731732-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10731848-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('10732010-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10732212-n',[ ('Government',subsumption)]).
nounMapping2SUMO('10732314-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10732521-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10732644-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10732748-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10732854-n',[ ('FamilyGroup',subsumption)]).
nounMapping2SUMO('10732967-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10733117-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10733225-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10733350-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10733487-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10733574-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10733705-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10733820-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10733891-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10733999-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10734129-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10734235-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10734394-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10734568-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10734741-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10734891-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('10734963-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10735173-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10735298-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10735564-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10735707-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10735852-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10735984-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10736091-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('10736259-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10736394-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10736602-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10736788-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10736926-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10737103-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10737264-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10737431-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10737717-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10737860-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10737964-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('10738111-n',[ ('Transportation',subsumption)]).
nounMapping2SUMO('10738215-n',[ ('Christian',subsumption)]).
nounMapping2SUMO('10738321-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10738515-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10738670-n',[ ('Protestant',subsumption)]).
nounMapping2SUMO('10738787-n',[ ('Christian',subsumption)]).
nounMapping2SUMO('10738871-n',[ ('Christian',subsumption)]).
nounMapping2SUMO('10738968-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10739135-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10739297-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10739391-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10739512-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10739636-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10739881-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10740017-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10740219-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10740482-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10740594-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10740732-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10740868-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10741152-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10741258-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10741367-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10741493-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10741590-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10741821-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10742005-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10742111-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10742269-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10742384-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10742546-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10742736-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10742881-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10742997-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10743124-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10743356-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10743543-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10743675-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('10743941-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10744078-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10744164-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10744456-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10744544-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10744844-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10745006-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10745181-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10745332-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10745613-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10745770-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10745894-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10746056-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10746195-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10746346-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10746460-n',[ ('Position',instance)]).
nounMapping2SUMO('10746581-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10746799-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10746931-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10747119-n',[ ('Vegetarian',equivalence)]).
nounMapping2SUMO('10747294-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10747424-n',[ ('Vegetarian',subsumption)]).
nounMapping2SUMO('10747548-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10747672-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10747815-n',[ ('Position',instance)]).
nounMapping2SUMO('10747965-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10748142-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10748309-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10748506-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10748620-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10748804-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10748889-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10749004-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10749123-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10749353-n',[ ('Veteran',subsumption)]).
nounMapping2SUMO('10749528-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('10749715-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10749928-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10750031-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10750188-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10750365-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10750524-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10750640-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10750788-n',[ ('USMilitaryRankO9',subsumption)]).
nounMapping2SUMO('10750911-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10751026-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10751152-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10751265-n',[ ('VicePresident',equivalence)]).
nounMapping2SUMO('10751527-n',[ ('VicePresident',subsumption)]).
nounMapping2SUMO('10751710-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10751785-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10752020-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10752093-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10752480-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10752719-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10752930-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10753061-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10753182-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10753339-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10753442-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10753546-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10753779-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10753917-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10753989-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10754088-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10754189-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10754281-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10754449-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10754578-n',[ ('Violinist',equivalence)]).
nounMapping2SUMO('10754920-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10755080-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10755164-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10755257-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10755394-n',[ ('OccupationalRole',subsumption)]).
nounMapping2SUMO('10755512-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10755648-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10755815-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10755926-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10756061-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10756148-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10756261-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10756433-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10756641-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10756837-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10756937-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10757050-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10757193-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10757492-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10757625-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10757817-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10757918-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('10758121-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10758207-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10758337-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10758445-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10758589-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10758713-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10758847-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10758949-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10759047-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10759151-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10759331-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10759543-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10759702-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10759820-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10759982-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10760199-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10760340-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10760622-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10760763-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10760951-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10761190-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10761326-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10761519-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10761693-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10761858-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10761962-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('10762064-n',[ ('Walking',subsumption)]).
nounMapping2SUMO('10762212-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10762342-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10762480-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10762607-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10762693-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10762792-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10763075-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10763245-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10763383-n',[ ('Waiter',equivalence)]).
nounMapping2SUMO('10763620-n',[ ('Female',subsumption), ('Waiter',equivalence)]).
nounMapping2SUMO('10763725-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10763878-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10763985-n',[ ('ServicePosition',subsumption)]).
nounMapping2SUMO('10764128-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10764296-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10764465-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10764622-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10764719-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10764907-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10765000-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10765098-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10765189-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10765305-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10765435-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('10765587-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10765679-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10765885-n',[ ('Man',instance)]).
nounMapping2SUMO('10766025-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10766260-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10766409-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10766492-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10766626-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10766718-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10766899-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10767020-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10767154-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10767265-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10767432-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10767519-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10767654-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('10767762-n',[ ('SentientAgent',subsumption)]).
nounMapping2SUMO('10767837-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10768022-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10768148-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10768272-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10768391-n',[ ('NonCommissionedOfficerRank',subsumption)]).
nounMapping2SUMO('10768505-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10768585-n',[ ('Soldier',subsumption)]).
nounMapping2SUMO('10768810-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10768903-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10769084-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10769188-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10769321-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10769459-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10769607-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10769782-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10769905-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10770059-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10770309-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10770433-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10770545-n',[ ('Artist',subsumption)]).
nounMapping2SUMO('10770767-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10770891-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10771066-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10771270-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10771392-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10771539-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10771636-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10771809-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10771990-n',[ ('Carnivore',subsumption)]).
nounMapping2SUMO('10772092-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10772190-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10772289-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10772392-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10772472-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10772580-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10772721-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10772937-n',[ ('FarmHand',subsumption)]).
nounMapping2SUMO('10773040-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10773126-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10773277-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10773394-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10773527-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10773665-n',[ ('SkilledOccupation',subsumption)]).
nounMapping2SUMO('10773800-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10773901-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10774018-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10774113-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('10774223-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10774329-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10774440-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10774756-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10774870-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10775003-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('10775128-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10775245-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10775379-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10775536-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10775660-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10775771-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10775911-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10776052-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10776141-n',[ ('PoliticalOrganization',instance)]).
nounMapping2SUMO('10776339-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10776766-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10776887-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10776987-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10777147-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10777299-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10777400-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10777768-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10777894-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10778044-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10778148-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('10778345-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('10778553-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('10778711-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('10778888-n',[ ('ReligiousOrganization',subsumption)]).
nounMapping2SUMO('10778999-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10779238-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10779416-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10779504-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10779610-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10779775-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10779897-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10779995-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10780105-n',[ ('Female',subsumption), ('ReligiousAttribute',subsumption)]).
nounMapping2SUMO('10780185-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10780284-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10780506-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10780632-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10781236-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10781460-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10781547-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10781684-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10781817-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10781984-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10782135-n',[ ('SportsPosition',subsumption)]).
nounMapping2SUMO('10782248-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10782362-n',[ ('CommissionedOfficerRank',subsumption)]).
nounMapping2SUMO('10782471-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10782632-n',[ ('Pilot',subsumption)]).
nounMapping2SUMO('10782791-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10782940-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10783145-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10783240-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10783352-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10783438-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10783539-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10783646-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10783734-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10783881-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10784015-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10784113-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10784281-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10784436-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10784544-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10784675-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10784795-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10784922-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10785085-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10785203-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('10785333-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10785480-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10785574-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10785695-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10785869-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10786033-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10786270-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10786517-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10786755-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10786892-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10786992-n',[ ('EthnicGroup',subsumption)]).
nounMapping2SUMO('10787197-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10787364-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10787470-n',[ ('Woman',equivalence)]).
nounMapping2SUMO('10788852-n',[ ('Female',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10789118-n',[ ('Male',subsumption), ('SocialRole',subsumption)]).
nounMapping2SUMO('10789415-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10789534-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10789709-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10789820-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10789963-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10790077-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10790192-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10790384-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10790479-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10790596-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10790671-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10790813-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10790918-n',[ ('Writer',subsumption)]).
nounMapping2SUMO('10791002-n',[ ('Neurosis',subsumption)]).
nounMapping2SUMO('10791115-n',[ ('Female',subsumption), ('Position',subsumption)]).
nounMapping2SUMO('10791221-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('10791820-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10791890-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10792028-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10792178-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10792335-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10792506-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('10792746-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10792856-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10793019-n',[ ('SocialRole',instance)]).
nounMapping2SUMO('10793168-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10793492-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10793570-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10793799-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10794014-n',[ ('Writer',equivalence)]).
nounMapping2SUMO('10801291-n',[ ('Writer',equivalence)]).
nounMapping2SUMO('10801561-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10801697-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10801802-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10801893-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10802043-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10802147-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10802283-n',[ ('EthnicGroup',instance)]).
nounMapping2SUMO('10802507-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10802621-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10802842-n',[ ('ManualLabor',subsumption)]).
nounMapping2SUMO('10802953-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10803031-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10803193-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10803282-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10803463-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('10803586-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10803691-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10803838-n',[ ('Musician',subsumption)]).
nounMapping2SUMO('10803978-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10804102-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10804287-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10804406-n',[ ('HumanYouth',equivalence)]).
nounMapping2SUMO('10804636-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10804732-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10804923-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10805113-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('10805274-n',[ ('Judaism',subsumption)]).
nounMapping2SUMO('10805501-n',[ ('BeliefGroup',subsumption)]).
nounMapping2SUMO('10805638-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10805783-n',[ ('CognitiveAgent',subsumption)]).
nounMapping2SUMO('10805932-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10806113-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10806222-n',[ ('Position',subsumption)]).
nounMapping2SUMO('10806612-n',[ ('Agent',instance)]).
nounMapping2SUMO('10806693-n',[ ('Man',instance)]).
nounMapping2SUMO('10806841-n',[ ('Man',instance)]).
nounMapping2SUMO('10807016-n',[ ('Man',instance)]).
nounMapping2SUMO('10807197-n',[ ('Man',instance)]).
nounMapping2SUMO('10807317-n',[ ('Man',instance)]).
nounMapping2SUMO('10807487-n',[ ('Man',instance)]).
nounMapping2SUMO('10807858-n',[ ('Man',instance)]).
nounMapping2SUMO('10808045-n',[ ('Man',instance)]).
nounMapping2SUMO('10808200-n',[ ('Man',instance)]).
nounMapping2SUMO('10808353-n',[ ('Man',instance)]).
nounMapping2SUMO('10808539-n',[ ('Man',instance)]).
nounMapping2SUMO('10808756-n',[ ('Man',instance)]).
nounMapping2SUMO('10808886-n',[ ('Man',instance)]).
nounMapping2SUMO('10809086-n',[ ('Man',instance)]).
nounMapping2SUMO('10809223-n',[ ('Writer',instance)]).
nounMapping2SUMO('10809317-n',[ ('Man',instance)]).
nounMapping2SUMO('10809576-n',[ ('Man',instance)]).
nounMapping2SUMO('10809675-n',[ ('Man',instance)]).
nounMapping2SUMO('10809857-n',[ ('Man',instance)]).
nounMapping2SUMO('10810046-n',[ ('Woman',instance)]).
nounMapping2SUMO('10810215-n',[ ('Woman',instance)]).
nounMapping2SUMO('10810397-n',[ ('Man',instance)]).
nounMapping2SUMO('10810549-n',[ ('Writer',instance)]).
nounMapping2SUMO('10810671-n',[ ('Man',instance)]).
nounMapping2SUMO('10810818-n',[ ('Man',instance)]).
nounMapping2SUMO('10810923-n',[ ('Man',instance)]).
nounMapping2SUMO('10811118-n',[ ('Man',instance)]).
nounMapping2SUMO('10811228-n',[ ('Man',instance)]).
nounMapping2SUMO('10811352-n',[ ('Man',instance)]).
nounMapping2SUMO('10811540-n',[ ('Man',instance)]).
nounMapping2SUMO('10811708-n',[ ('Man',instance)]).
nounMapping2SUMO('10811900-n',[ ('Man',instance)]).
nounMapping2SUMO('10812047-n',[ ('Man',instance)]).
nounMapping2SUMO('10812225-n',[ ('Woman',instance)]).
nounMapping2SUMO('10812360-n',[ ('Man',instance)]).
nounMapping2SUMO('10812550-n',[ ('Man',instance)]).
nounMapping2SUMO('10812800-n',[ ('Man',instance)]).
nounMapping2SUMO('10813049-n',[ ('Man',instance)]).
nounMapping2SUMO('10813204-n',[ ('Man',instance)]).
nounMapping2SUMO('10813374-n',[ ('Man',instance)]).
nounMapping2SUMO('10813527-n',[ ('Writer',instance)]).
nounMapping2SUMO('10813711-n',[ ('Writer',instance)]).
nounMapping2SUMO('10813813-n',[ ('Man',instance)]).
nounMapping2SUMO('10813986-n',[ ('Man',instance)]).
nounMapping2SUMO('10814328-n',[ ('Man',instance)]).
nounMapping2SUMO('10814574-n',[ ('Man',instance)]).
nounMapping2SUMO('10814776-n',[ ('Man',instance)]).
nounMapping2SUMO('10814953-n',[ ('Man',instance)]).
nounMapping2SUMO('10815113-n',[ ('Woman',instance)]).
nounMapping2SUMO('10815343-n',[ ('Woman',instance)]).
nounMapping2SUMO('10815477-n',[ ('Man',instance)]).
nounMapping2SUMO('10815648-n',[ ('Man',instance)]).
nounMapping2SUMO('10816136-n',[ ('Man',instance)]).
nounMapping2SUMO('10816223-n',[ ('Man',instance)]).
nounMapping2SUMO('10816424-n',[ ('Man',instance)]).
nounMapping2SUMO('10816644-n',[ ('Man',instance)]).
nounMapping2SUMO('10816890-n',[ ('Man',instance)]).
nounMapping2SUMO('10817102-n',[ ('Writer',instance)]).
nounMapping2SUMO('10817244-n',[ ('Man',instance)]).
nounMapping2SUMO('10817458-n',[ ('Man',instance)]).
nounMapping2SUMO('10817607-n',[ ('Man',instance)]).
nounMapping2SUMO('10817717-n',[ ('Man',instance)]).
nounMapping2SUMO('10817935-n',[ ('Writer',instance)]).
nounMapping2SUMO('10818088-n',[ ('Man',instance)]).
nounMapping2SUMO('10818312-n',[ ('Man',instance)]).
nounMapping2SUMO('10818469-n',[ ('Queen',instance)]).
nounMapping2SUMO('10818715-n',[ ('Man',instance)]).
nounMapping2SUMO('10818860-n',[ ('Man',instance)]).
nounMapping2SUMO('10819134-n',[ ('Woman',instance)]).
nounMapping2SUMO('10819285-n',[ ('CognitiveAgent',instance)]).
nounMapping2SUMO('10819533-n',[ ('Man',instance)]).
nounMapping2SUMO('10819755-n',[ ('Man',instance)]).
nounMapping2SUMO('10820053-n',[ ('Man',instance)]).
nounMapping2SUMO('10820163-n',[ ('Man',instance)]).
nounMapping2SUMO('10820444-n',[ ('Man',instance)]).
nounMapping2SUMO('10820613-n',[ ('Man',instance)]).
nounMapping2SUMO('10820790-n',[ ('Man',instance)]).
nounMapping2SUMO('10821218-n',[ ('Man',instance)]).
nounMapping2SUMO('10821379-n',[ ('Writer',instance)]).
nounMapping2SUMO('10821514-n',[ ('Man',instance)]).
nounMapping2SUMO('10821699-n',[ ('Woman',instance)]).
nounMapping2SUMO('10821867-n',[ ('Man',instance)]).
nounMapping2SUMO('10822027-n',[ ('Man',instance)]).
nounMapping2SUMO('10822211-n',[ ('Man',instance)]).
nounMapping2SUMO('10822338-n',[ ('Man',instance)]).
nounMapping2SUMO('10822567-n',[ ('Man',instance)]).
nounMapping2SUMO('10822786-n',[ ('Man',instance)]).
nounMapping2SUMO('10822962-n',[ ('Man',instance)]).
nounMapping2SUMO('10823199-n',[ ('Man',instance)]).
nounMapping2SUMO('10823369-n',[ ('Man',instance)]).
nounMapping2SUMO('10823529-n',[ ('Man',instance)]).
nounMapping2SUMO('10823760-n',[ ('Man',instance)]).
nounMapping2SUMO('10823894-n',[ ('Human',subsumption)]).
nounMapping2SUMO('10824146-n',[ ('Man',instance)]).
nounMapping2SUMO('10824352-n',[ ('Man',instance)]).
nounMapping2SUMO('10824541-n',[ ('Man',instance)]).
nounMapping2SUMO('10824710-n',[ ('Man',instance)]).
nounMapping2SUMO('10824888-n',[ ('Man',instance)]).
nounMapping2SUMO('10825180-n',[ ('Man',instance)]).
nounMapping2SUMO('10825407-n',[ ('Man',instance)]).
nounMapping2SUMO('10825554-n',[ ('Writer',instance)]).
nounMapping2SUMO('10825718-n',[ ('Man',instance)]).
nounMapping2SUMO('10825923-n',[ ('Man',instance)]).
nounMapping2SUMO('10826033-n',[ ('Man',instance)]).
nounMapping2SUMO('10826204-n',[ ('Writer',instance)]).
nounMapping2SUMO('10826352-n',[ ('Man',instance)]).
nounMapping2SUMO('10826557-n',[ ('Man',instance)]).
nounMapping2SUMO('10826717-n',[ ('Woman',instance)]).
nounMapping2SUMO('10826952-n',[ ('Man',instance)]).
nounMapping2SUMO('10827155-n',[ ('Man',instance)]).
nounMapping2SUMO('10827513-n',[ ('Man',instance)]).
nounMapping2SUMO('10827678-n',[ ('Man',instance)]).
nounMapping2SUMO('10827873-n',[ ('Man',instance)]).
nounMapping2SUMO('10828091-n',[ ('Writer',instance)]).
nounMapping2SUMO('10828233-n',[ ('Man',instance)]).
nounMapping2SUMO('10828368-n',[ ('Man',instance)]).
nounMapping2SUMO('10828573-n',[ ('Man',instance)]).
nounMapping2SUMO('10828990-n',[ ('Man',instance)]).
nounMapping2SUMO('10829293-n',[ ('Woman',instance)]).
nounMapping2SUMO('10829450-n',[ ('Man',instance)]).
nounMapping2SUMO('10829733-n',[ ('Man',instance)]).
nounMapping2SUMO('10830046-n',[ ('Man',instance)]).
nounMapping2SUMO('10830229-n',[ ('Man',instance)]).
nounMapping2SUMO('10830456-n',[ ('Man',instance)]).
nounMapping2SUMO('10830731-n',[ ('Man',instance)]).
nounMapping2SUMO('10831003-n',[ ('Man',instance)]).
nounMapping2SUMO('10831136-n',[ ('Man',instance)]).
nounMapping2SUMO('10831363-n',[ ('Woman',instance)]).
nounMapping2SUMO('10831483-n',[ ('Man',instance)]).
nounMapping2SUMO('10831656-n',[ ('Man',instance)]).
nounMapping2SUMO('10831860-n',[ ('Man',instance)]).
nounMapping2SUMO('10832085-n',[ ('Man',instance)]).
nounMapping2SUMO('10832251-n',[ ('Writer',instance)]).
nounMapping2SUMO('10832415-n',[ ('Man',instance)]).
nounMapping2SUMO('10832568-n',[ ('Man',instance)]).
nounMapping2SUMO('10832731-n',[ ('Woman',instance)]).
nounMapping2SUMO('10832908-n',[ ('Man',instance)]).
nounMapping2SUMO('10833111-n',[ ('Man',instance)]).
nounMapping2SUMO('10833304-n',[ ('Man',instance)]).
nounMapping2SUMO('10833425-n',[ ('Man',instance)]).
nounMapping2SUMO('10833595-n',[ ('Man',instance)]).
nounMapping2SUMO('10833805-n',[ ('Man',instance)]).
nounMapping2SUMO('10834011-n',[ ('Writer',instance)]).
nounMapping2SUMO('10834176-n',[ ('Man',instance)]).
nounMapping2SUMO('10834337-n',[ ('Man',instance)]).
nounMapping2SUMO('10834439-n',[ ('Man',instance)]).
nounMapping2SUMO('10834543-n',[ ('Man',instance)]).
nounMapping2SUMO('10834690-n',[ ('Man',instance)]).
nounMapping2SUMO('10834869-n',[ ('Man',instance)]).
nounMapping2SUMO('10835022-n',[ ('Man',instance)]).
nounMapping2SUMO('10835218-n',[ ('Man',instance)]).
nounMapping2SUMO('10835450-n',[ ('Woman',instance)]).
nounMapping2SUMO('10835709-n',[ ('Man',instance)]).
nounMapping2SUMO('10835866-n',[ ('Woman',instance)]).
nounMapping2SUMO('10836029-n',[ ('Man',instance)]).
nounMapping2SUMO('10836184-n',[ ('Man',instance)]).
nounMapping2SUMO('10836308-n',[ ('Man',instance)]).
nounMapping2SUMO('10836413-n',[ ('Writer',instance)]).
nounMapping2SUMO('10836555-n',[ ('Man',instance)]).
nounMapping2SUMO('10836725-n',[ ('Man',instance)]).
nounMapping2SUMO('10836862-n',[ ('Man',instance)]).
nounMapping2SUMO('10837023-n',[ ('Man',instance)]).
nounMapping2SUMO('10837258-n',[ ('Man',instance)]).
nounMapping2SUMO('10837461-n',[ ('Man',instance)]).
nounMapping2SUMO('10837567-n',[ ('Man',instance)]).
nounMapping2SUMO('10837737-n',[ ('Man',instance)]).
nounMapping2SUMO('10837918-n',[ ('Man',instance)]).
nounMapping2SUMO('10838288-n',[ ('Woman',subsumption)]).
nounMapping2SUMO('10838484-n',[ ('Man',instance)]).
nounMapping2SUMO('10838665-n',[ ('Writer',instance)]).
nounMapping2SUMO('10838802-n',[ ('Man',instance)]).
nounMapping2SUMO('10838997-n',[ ('Man',instance)]).
nounMapping2SUMO('10839131-n',[ ('Man',instance)]).
nounMapping2SUMO('10839329-n',[ ('Man',instance)]).
nounMapping2SUMO('10839469-n',[ ('Man',instance)]).
nounMapping2SUMO('10839617-n',[ ('Man',instance)]).
nounMapping2SUMO('10839791-n',[ ('Man',instance)]).
nounMapping2SUMO('10840021-n',[ ('Man',instance)]).
nounMapping2SUMO('10840354-n',[ ('Man',instance)]).
nounMapping2SUMO('10840563-n',[ ('Man',instance)]).
nounMapping2SUMO('10840769-n',[ ('Man',instance)]).
nounMapping2SUMO('10841065-n',[ ('Man',instance)]).
nounMapping2SUMO('10841241-n',[ ('Writer',instance)]).
nounMapping2SUMO('10841405-n',[ ('Man',instance)]).
nounMapping2SUMO('10841657-n',[ ('Man',instance)]).
nounMapping2SUMO('10841880-n',[ ('Man',instance)]).
nounMapping2SUMO('10842030-n',[ ('Man',instance)]).
nounMapping2SUMO('10842213-n',[ ('Man',instance)]).
nounMapping2SUMO('10842376-n',[ ('Woman',instance)]).
nounMapping2SUMO('10842575-n',[ ('Man',instance)]).
nounMapping2SUMO('10842730-n',[ ('Man',instance)]).
nounMapping2SUMO('10842923-n',[ ('Man',instance)]).
nounMapping2SUMO('10843035-n',[ ('Writer',instance)]).
nounMapping2SUMO('10843228-n',[ ('Writer',instance)]).
nounMapping2SUMO('10843425-n',[ ('Man',instance)]).
nounMapping2SUMO('10843705-n',[ ('Man',instance)]).
nounMapping2SUMO('10843858-n',[ ('Man',instance)]).
nounMapping2SUMO('10844031-n',[ ('Pope',instance)]).
nounMapping2SUMO('10844231-n',[ ('Pope',instance)]).
nounMapping2SUMO('10844401-n',[ ('Woman',instance)]).
nounMapping2SUMO('10844527-n',[ ('Writer',instance)]).
nounMapping2SUMO('10844667-n',[ ('Man',instance)]).
nounMapping2SUMO('10844805-n',[ ('Man',instance)]).
nounMapping2SUMO('10845050-n',[ ('Man',instance)]).
nounMapping2SUMO('10845248-n',[ ('Man',instance)]).
nounMapping2SUMO('10845424-n',[ ('Man',instance)]).
nounMapping2SUMO('10845603-n',[ ('Man',instance)]).
nounMapping2SUMO('10845763-n',[ ('Man',instance)]).
nounMapping2SUMO('10845926-n',[ ('Man',instance)]).
nounMapping2SUMO('10846089-n',[ ('Man',instance)]).
nounMapping2SUMO('10846224-n',[ ('Man',instance)]).
nounMapping2SUMO('10846400-n',[ ('Woman',instance)]).
nounMapping2SUMO('10846504-n',[ ('Man',instance)]).
nounMapping2SUMO('10846693-n',[ ('Man',instance)]).
nounMapping2SUMO('10846913-n',[ ('Man',instance)]).
nounMapping2SUMO('10847125-n',[ ('Man',instance)]).
nounMapping2SUMO('10847330-n',[ ('Man',instance)]).
nounMapping2SUMO('10847454-n',[ ('Man',instance)]).
nounMapping2SUMO('10847653-n',[ ('Man',instance)]).
nounMapping2SUMO('10847793-n',[ ('Man',instance)]).
nounMapping2SUMO('10847994-n',[ ('Woman',instance)]).
nounMapping2SUMO('10848122-n',[ ('Man',instance)]).
nounMapping2SUMO('10848356-n',[ ('Man',instance)]).
nounMapping2SUMO('10848500-n',[ ('Man',instance)]).
nounMapping2SUMO('10848641-n',[ ('Man',instance)]).
nounMapping2SUMO('10848802-n',[ ('Man',instance)]).
nounMapping2SUMO('10848946-n',[ ('Man',instance)]).
nounMapping2SUMO('10849083-n',[ ('Man',instance)]).
nounMapping2SUMO('10849213-n',[ ('Man',instance)]).
nounMapping2SUMO('10849323-n',[ ('Man',instance)]).
nounMapping2SUMO('10849435-n',[ ('Man',instance)]).
nounMapping2SUMO('10849625-n',[ ('Man',instance)]).
nounMapping2SUMO('10849873-n',[ ('Man',instance)]).
nounMapping2SUMO('10850049-n',[ ('Man',instance)]).
nounMapping2SUMO('10850273-n',[ ('Man',instance)]).
nounMapping2SUMO('10850469-n',[ ('Woman',instance)]).
nounMapping2SUMO('10850667-n',[ ('Man',instance)]).
nounMapping2SUMO('10850964-n',[ ('Man',instance)]).
nounMapping2SUMO('10851139-n',[ ('Writer',instance)]).
nounMapping2SUMO('10851282-n',[ ('Man',instance)]).
nounMapping2SUMO('10851452-n',[ ('Man',instance)]).
nounMapping2SUMO('10851599-n',[ ('Man',instance)]).
nounMapping2SUMO('10851865-n',[ ('Man',instance)]).
nounMapping2SUMO('10851987-n',[ ('Woman',instance)]).
nounMapping2SUMO('10852130-n',[ ('Man',instance)]).
nounMapping2SUMO('10852320-n',[ ('Man',instance)]).
nounMapping2SUMO('10852506-n',[ ('Man',instance)]).
nounMapping2SUMO('10852669-n',[ ('Man',instance)]).
nounMapping2SUMO('10852803-n',[ ('Man',instance)]).
nounMapping2SUMO('10852961-n',[ ('Man',instance)]).
nounMapping2SUMO('10853244-n',[ ('Man',instance)]).
nounMapping2SUMO('10853413-n',[ ('Man',instance)]).
nounMapping2SUMO('10853628-n',[ ('Man',instance)]).
nounMapping2SUMO('10853767-n',[ ('Man',instance)]).
nounMapping2SUMO('10853932-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('10854146-n',[ ('Man',instance)]).
nounMapping2SUMO('10854265-n',[ ('Man',instance)]).
nounMapping2SUMO('10854397-n',[ ('Man',instance)]).
nounMapping2SUMO('10854627-n',[ ('Writer',instance)]).
nounMapping2SUMO('10854777-n',[ ('Man',instance)]).
nounMapping2SUMO('10855047-n',[ ('Man',instance)]).
nounMapping2SUMO('10855200-n',[ ('Man',instance)]).
nounMapping2SUMO('10855431-n',[ ('Woman',instance)]).
nounMapping2SUMO('10855604-n',[ ('Man',instance)]).
nounMapping2SUMO('10855834-n',[ ('Man',instance)]).
nounMapping2SUMO('10855987-n',[ ('Man',instance)]).
nounMapping2SUMO('10856215-n',[ ('Man',instance)]).
nounMapping2SUMO('10856486-n',[ ('Man',instance)]).
nounMapping2SUMO('10856799-n',[ ('Pope',instance)]).
nounMapping2SUMO('10857001-n',[ ('Man',instance)]).
nounMapping2SUMO('10857159-n',[ ('Writer',instance)]).
nounMapping2SUMO('10857271-n',[ ('Man',instance)]).
nounMapping2SUMO('10857418-n',[ ('Man',instance)]).
nounMapping2SUMO('10857540-n',[ ('Man',instance)]).
nounMapping2SUMO('10857697-n',[ ('Writer',instance)]).
nounMapping2SUMO('10857849-n',[ ('Man',instance)]).
nounMapping2SUMO('10858018-n',[ ('Woman',instance)]).
nounMapping2SUMO('10858164-n',[ ('Man',instance)]).
nounMapping2SUMO('10858333-n',[ ('Man',instance)]).
nounMapping2SUMO('10858468-n',[ ('Man',instance)]).
nounMapping2SUMO('10858577-n',[ ('Man',instance)]).
nounMapping2SUMO('10858872-n',[ ('Writer',instance)]).
nounMapping2SUMO('10859012-n',[ ('Man',instance)]).
nounMapping2SUMO('10859194-n',[ ('Man',instance)]).
nounMapping2SUMO('10859369-n',[ ('Man',instance)]).
nounMapping2SUMO('10859485-n',[ ('Man',instance)]).
nounMapping2SUMO('10859669-n',[ ('Man',instance)]).
nounMapping2SUMO('10859857-n',[ ('Man',instance)]).
nounMapping2SUMO('10860108-n',[ ('Man',instance)]).
nounMapping2SUMO('10860347-n',[ ('Writer',instance)]).
nounMapping2SUMO('10860444-n',[ ('Writer',instance)]).
nounMapping2SUMO('10860589-n',[ ('Man',instance)]).
nounMapping2SUMO('10860807-n',[ ('Man',instance)]).
nounMapping2SUMO('10860999-n',[ ('Man',instance)]).
nounMapping2SUMO('10861174-n',[ ('Woman',instance)]).
nounMapping2SUMO('10861329-n',[ ('Man',instance)]).
nounMapping2SUMO('10861535-n',[ ('Man',instance)]).
nounMapping2SUMO('10861741-n',[ ('Man',instance)]).
nounMapping2SUMO('10861926-n',[ ('Position',instance)]).
nounMapping2SUMO('10862113-n',[ ('Man',instance)]).
nounMapping2SUMO('10862281-n',[ ('Man',instance)]).
nounMapping2SUMO('10862507-n',[ ('Man',instance)]).
nounMapping2SUMO('10862676-n',[ ('Man',instance)]).
nounMapping2SUMO('10862822-n',[ ('Man',instance)]).
nounMapping2SUMO('10862999-n',[ ('Man',instance)]).
nounMapping2SUMO('10863124-n',[ ('Man',instance)]).
nounMapping2SUMO('10863440-n',[ ('Woman',instance)]).
nounMapping2SUMO('10863552-n',[ ('Man',instance)]).
nounMapping2SUMO('10863717-n',[ ('Man',instance)]).
nounMapping2SUMO('10863896-n',[ ('Man',instance)]).
nounMapping2SUMO('10864064-n',[ ('Man',instance)]).
nounMapping2SUMO('10864204-n',[ ('Woman',instance)]).
nounMapping2SUMO('10864428-n',[ ('Man',instance)]).
nounMapping2SUMO('10864635-n',[ ('Man',instance)]).
nounMapping2SUMO('10864858-n',[ ('Man',instance)]).
nounMapping2SUMO('10865140-n',[ ('Position',instance)]).
nounMapping2SUMO('10865329-n',[ ('Man',instance)]).
nounMapping2SUMO('10865567-n',[ ('Woman',instance)]).
nounMapping2SUMO('10865700-n',[ ('Woman',instance)]).
nounMapping2SUMO('10865860-n',[ ('Woman',instance)]).
nounMapping2SUMO('10865990-n',[ ('Man',instance)]).
nounMapping2SUMO('10866090-n',[ ('Man',instance)]).
nounMapping2SUMO('10866217-n',[ ('Man',instance)]).
nounMapping2SUMO('10866385-n',[ ('Man',instance)]).
nounMapping2SUMO('10866571-n',[ ('Writer',instance)]).
nounMapping2SUMO('10866738-n',[ ('Man',instance)]).
nounMapping2SUMO('10866883-n',[ ('Woman',instance)]).
nounMapping2SUMO('10867064-n',[ ('Man',instance)]).
nounMapping2SUMO('10867238-n',[ ('Man',instance)]).
nounMapping2SUMO('10867473-n',[ ('Man',instance)]).
nounMapping2SUMO('10867708-n',[ ('Man',instance)]).
nounMapping2SUMO('10867933-n',[ ('Man',instance)]).
nounMapping2SUMO('10868025-n',[ ('Man',instance)]).
nounMapping2SUMO('10868177-n',[ ('Man',instance)]).
nounMapping2SUMO('10868397-n',[ ('Man',instance)]).
nounMapping2SUMO('10868562-n',[ ('Man',instance)]).
nounMapping2SUMO('10868738-n',[ ('Man',instance)]).
nounMapping2SUMO('10868980-n',[ ('Man',instance)]).
nounMapping2SUMO('10869207-n',[ ('Man',instance)]).
nounMapping2SUMO('10869385-n',[ ('Man',instance)]).
nounMapping2SUMO('10869683-n',[ ('Man',instance)]).
nounMapping2SUMO('10869931-n',[ ('Man',instance)]).
nounMapping2SUMO('10870072-n',[ ('Man',instance)]).
nounMapping2SUMO('10870235-n',[ ('Writer',instance)]).
nounMapping2SUMO('10870440-n',[ ('Man',instance)]).
nounMapping2SUMO('10870691-n',[ ('Man',instance)]).
nounMapping2SUMO('10870897-n',[ ('Man',instance)]).
nounMapping2SUMO('10871129-n',[ ('Man',instance)]).
nounMapping2SUMO('10871270-n',[ ('Man',instance)]).
nounMapping2SUMO('10871424-n',[ ('Man',instance)]).
nounMapping2SUMO('10871655-n',[ ('Man',instance)]).
nounMapping2SUMO('10871756-n',[ ('Writer',instance)]).
nounMapping2SUMO('10871926-n',[ ('Man',instance)]).
nounMapping2SUMO('10872105-n',[ ('Man',instance)]).
nounMapping2SUMO('10872287-n',[ ('Man',instance)]).
nounMapping2SUMO('10872505-n',[ ('Writer',instance)]).
nounMapping2SUMO('10872624-n',[ ('Man',instance)]).
nounMapping2SUMO('10872839-n',[ ('Woman',instance)]).
nounMapping2SUMO('10873059-n',[ ('Man',instance)]).
nounMapping2SUMO('10873303-n',[ ('Writer',instance)]).
nounMapping2SUMO('10873505-n',[ ('Man',instance)]).
nounMapping2SUMO('10873679-n',[ ('Man',instance)]).
nounMapping2SUMO('10873783-n',[ ('Man',instance)]).
nounMapping2SUMO('10873937-n',[ ('Man',instance)]).
nounMapping2SUMO('10874162-n',[ ('Man',instance)]).
nounMapping2SUMO('10874393-n',[ ('Writer',instance)]).
nounMapping2SUMO('10874540-n',[ ('Man',instance)]).
nounMapping2SUMO('10874706-n',[ ('Writer',instance)]).
nounMapping2SUMO('10874921-n',[ ('Man',instance)]).
nounMapping2SUMO('10875107-n',[ ('Man',instance)]).
nounMapping2SUMO('10875249-n',[ ('Man',instance)]).
nounMapping2SUMO('10875468-n',[ ('Man',instance)]).
nounMapping2SUMO('10875681-n',[ ('Man',instance)]).
nounMapping2SUMO('10875910-n',[ ('Man',instance)]).
nounMapping2SUMO('10876160-n',[ ('Man',instance)]).
nounMapping2SUMO('10876419-n',[ ('Man',instance)]).
nounMapping2SUMO('10876513-n',[ ('Man',instance)]).
nounMapping2SUMO('10876661-n',[ ('Man',instance)]).
nounMapping2SUMO('10876798-n',[ ('Man',instance)]).
nounMapping2SUMO('10877015-n',[ ('Man',instance)]).
nounMapping2SUMO('10877253-n',[ ('Man',instance)]).
nounMapping2SUMO('10877456-n',[ ('Writer',instance)]).
nounMapping2SUMO('10877584-n',[ ('Man',instance)]).
nounMapping2SUMO('10877841-n',[ ('Man',instance)]).
nounMapping2SUMO('10878161-n',[ ('Man',instance)]).
nounMapping2SUMO('10878375-n',[ ('Man',instance)]).
nounMapping2SUMO('10878530-n',[ ('Man',instance)]).
nounMapping2SUMO('10878672-n',[ ('Man',instance)]).
nounMapping2SUMO('10878844-n',[ ('Man',instance)]).
nounMapping2SUMO('10879009-n',[ ('Man',instance)]).
nounMapping2SUMO('10879155-n',[ ('Writer',instance)]).
nounMapping2SUMO('10879364-n',[ ('Writer',instance)]).
nounMapping2SUMO('10879551-n',[ ('Man',instance)]).
nounMapping2SUMO('10879789-n',[ ('Pope',instance)]).
nounMapping2SUMO('10880024-n',[ ('Man',instance)]).
nounMapping2SUMO('10880189-n',[ ('Woman',instance)]).
nounMapping2SUMO('10880398-n',[ ('Man',instance)]).
nounMapping2SUMO('10880669-n',[ ('Man',instance)]).
nounMapping2SUMO('10880841-n',[ ('Writer',instance)]).
nounMapping2SUMO('10880981-n',[ ('Man',instance)]).
nounMapping2SUMO('10881092-n',[ ('Writer',instance)]).
nounMapping2SUMO('10881269-n',[ ('Writer',instance)]).
nounMapping2SUMO('10881382-n',[ ('Man',instance)]).
nounMapping2SUMO('10881616-n',[ ('Writer',instance)]).
nounMapping2SUMO('10881784-n',[ ('Man',instance)]).
nounMapping2SUMO('10881986-n',[ ('Man',instance)]).
nounMapping2SUMO('10882089-n',[ ('Man',instance)]).
nounMapping2SUMO('10882293-n',[ ('Man',instance)]).
nounMapping2SUMO('10882436-n',[ ('Man',instance)]).
nounMapping2SUMO('10882588-n',[ ('Man',instance)]).
nounMapping2SUMO('10882706-n',[ ('Man',instance)]).
nounMapping2SUMO('10882846-n',[ ('Man',instance)]).
nounMapping2SUMO('10882988-n',[ ('Man',instance)]).
nounMapping2SUMO('10883202-n',[ ('Man',instance)]).
nounMapping2SUMO('10883380-n',[ ('Man',instance)]).
nounMapping2SUMO('10883533-n',[ ('Man',instance)]).
nounMapping2SUMO('10883688-n',[ ('Man',instance)]).
nounMapping2SUMO('10883871-n',[ ('Man',instance)]).
nounMapping2SUMO('10884061-n',[ ('Man',instance)]).
nounMapping2SUMO('10884369-n',[ ('Man',instance)]).
nounMapping2SUMO('10884597-n',[ ('Woman',instance)]).
nounMapping2SUMO('10884831-n',[ ('Man',instance)]).
nounMapping2SUMO('10885006-n',[ ('Man',instance)]).
nounMapping2SUMO('10885176-n',[ ('Man',instance)]).
nounMapping2SUMO('10885352-n',[ ('Man',instance)]).
nounMapping2SUMO('10885487-n',[ ('Man',instance)]).
nounMapping2SUMO('10885603-n',[ ('Man',instance)]).
nounMapping2SUMO('10885831-n',[ ('Man',instance)]).
nounMapping2SUMO('10885994-n',[ ('Man',instance)]).
nounMapping2SUMO('10886222-n',[ ('Man',instance)]).
nounMapping2SUMO('10886361-n',[ ('Man',instance)]).
nounMapping2SUMO('10886558-n',[ ('Man',instance)]).
nounMapping2SUMO('10886763-n',[ ('Man',instance)]).
nounMapping2SUMO('10886929-n',[ ('Man',instance)]).
nounMapping2SUMO('10887137-n',[ ('Writer',instance)]).
nounMapping2SUMO('10887290-n',[ ('Woman',instance)]).
nounMapping2SUMO('10887420-n',[ ('Woman',instance)]).
nounMapping2SUMO('10887593-n',[ ('Woman',instance)]).
nounMapping2SUMO('10887790-n',[ ('Woman',instance)]).
nounMapping2SUMO('10887981-n',[ ('Man',instance)]).
nounMapping2SUMO('10888151-n',[ ('Woman',instance)]).
nounMapping2SUMO('10888401-n',[ ('Man',instance)]).
nounMapping2SUMO('10888644-n',[ ('Man',instance)]).
nounMapping2SUMO('10888788-n',[ ('Man',instance)]).
nounMapping2SUMO('10888891-n',[ ('Man',instance)]).
nounMapping2SUMO('10889032-n',[ ('Writer',instance)]).
nounMapping2SUMO('10889316-n',[ ('Man',instance)]).
nounMapping2SUMO('10889533-n',[ ('Man',instance)]).
nounMapping2SUMO('10889689-n',[ ('Man',instance)]).
nounMapping2SUMO('10889905-n',[ ('Man',instance)]).
nounMapping2SUMO('10890032-n',[ ('Man',instance)]).
nounMapping2SUMO('10890211-n',[ ('Man',instance)]).
nounMapping2SUMO('10890437-n',[ ('Writer',instance)]).
nounMapping2SUMO('10890637-n',[ ('Man',instance)]).
nounMapping2SUMO('10890868-n',[ ('Man',instance)]).
nounMapping2SUMO('10891029-n',[ ('Man',instance)]).
nounMapping2SUMO('10891271-n',[ ('Man',instance)]).
nounMapping2SUMO('10891428-n',[ ('Man',instance)]).
nounMapping2SUMO('10891569-n',[ ('Man',instance)]).
nounMapping2SUMO('10891830-n',[ ('Man',instance)]).
nounMapping2SUMO('10891981-n',[ ('Man',instance)]).
nounMapping2SUMO('10892218-n',[ ('Writer',instance)]).
nounMapping2SUMO('10892416-n',[ ('Man',instance)]).
nounMapping2SUMO('10892564-n',[ ('Man',instance)]).
nounMapping2SUMO('10892786-n',[ ('Man',instance)]).
nounMapping2SUMO('10892947-n',[ ('Man',instance)]).
nounMapping2SUMO('10893153-n',[ ('Man',instance)]).
nounMapping2SUMO('10893433-n',[ ('Man',instance)]).
nounMapping2SUMO('10893606-n',[ ('Man',instance)]).
nounMapping2SUMO('10893830-n',[ ('Writer',instance)]).
nounMapping2SUMO('10894065-n',[ ('Writer',instance)]).
nounMapping2SUMO('10894208-n',[ ('Man',instance)]).
nounMapping2SUMO('10894365-n',[ ('Man',instance)]).
nounMapping2SUMO('10894522-n',[ ('Writer',instance)]).
nounMapping2SUMO('10894652-n',[ ('Man',instance)]).
nounMapping2SUMO('10894905-n',[ ('Man',instance)]).
nounMapping2SUMO('10895073-n',[ ('Man',instance)]).
nounMapping2SUMO('10895274-n',[ ('Writer',instance)]).
nounMapping2SUMO('10895549-n',[ ('Man',instance)]).
nounMapping2SUMO('10895688-n',[ ('Man',instance)]).
nounMapping2SUMO('10896046-n',[ ('Man',instance)]).
nounMapping2SUMO('10896255-n',[ ('Man',instance)]).
nounMapping2SUMO('10896452-n',[ ('Man',instance)]).
nounMapping2SUMO('10896644-n',[ ('Man',instance)]).
nounMapping2SUMO('10896823-n',[ ('Writer',instance)]).
nounMapping2SUMO('10896987-n',[ ('Writer',instance)]).
nounMapping2SUMO('10897154-n',[ ('Man',instance)]).
nounMapping2SUMO('10897312-n',[ ('Man',instance)]).
nounMapping2SUMO('10897594-n',[ ('Man',instance)]).
nounMapping2SUMO('10897796-n',[ ('Man',instance)]).
nounMapping2SUMO('10897946-n',[ ('Man',instance)]).
nounMapping2SUMO('10898133-n',[ ('Man',instance)]).
nounMapping2SUMO('10898308-n',[ ('Man',instance)]).
nounMapping2SUMO('10898549-n',[ ('Man',instance)]).
nounMapping2SUMO('10898693-n',[ ('Man',instance)]).
nounMapping2SUMO('10898929-n',[ ('Man',instance)]).
nounMapping2SUMO('10899164-n',[ ('Man',instance)]).
nounMapping2SUMO('10899414-n',[ ('Man',instance)]).
nounMapping2SUMO('10899747-n',[ ('Man',instance)]).
nounMapping2SUMO('10899951-n',[ ('Man',instance)]).
nounMapping2SUMO('10900146-n',[ ('Man',instance)]).
nounMapping2SUMO('10900366-n',[ ('Man',instance)]).
nounMapping2SUMO('10900524-n',[ ('Man',instance)]).
nounMapping2SUMO('10900730-n',[ ('Writer',instance)]).
nounMapping2SUMO('10900953-n',[ ('Pope',instance)]).
nounMapping2SUMO('10901192-n',[ ('Pope',instance)]).
nounMapping2SUMO('10901420-n',[ ('Pope',instance)]).
nounMapping2SUMO('10901589-n',[ ('Pope',instance)]).
nounMapping2SUMO('10901827-n',[ ('Woman',instance)]).
nounMapping2SUMO('10902051-n',[ ('Man',instance)]).
nounMapping2SUMO('10902232-n',[ ('Man',instance)]).
nounMapping2SUMO('10902409-n',[ ('Man',instance)]).
nounMapping2SUMO('10902591-n',[ ('Man',instance)]).
nounMapping2SUMO('10902752-n',[ ('Woman',instance)]).
nounMapping2SUMO('10902934-n',[ ('Man',instance)]).
nounMapping2SUMO('10903172-n',[ ('Man',instance)]).
nounMapping2SUMO('10903413-n',[ ('Woman',instance)]).
nounMapping2SUMO('10903570-n',[ ('Man',instance)]).
nounMapping2SUMO('10903722-n',[ ('Woman',instance)]).
nounMapping2SUMO('10903918-n',[ ('Man',instance)]).
nounMapping2SUMO('10904107-n',[ ('Writer',instance)]).
nounMapping2SUMO('10904270-n',[ ('Man',instance)]).
nounMapping2SUMO('10904463-n',[ ('Man',instance)]).
nounMapping2SUMO('10904639-n',[ ('Man',instance)]).
nounMapping2SUMO('10904821-n',[ ('Man',instance)]).
nounMapping2SUMO('10904992-n',[ ('Writer',instance)]).
nounMapping2SUMO('10905159-n',[ ('Writer',instance)]).
nounMapping2SUMO('10905315-n',[ ('Man',instance)]).
nounMapping2SUMO('10905568-n',[ ('Man',instance)]).
nounMapping2SUMO('10905703-n',[ ('Man',instance)]).
nounMapping2SUMO('10906048-n',[ ('Man',instance)]).
nounMapping2SUMO('10906234-n',[ ('Man',instance)]).
nounMapping2SUMO('10906462-n',[ ('Writer',instance)]).
nounMapping2SUMO('10906638-n',[ ('Man',instance)]).
nounMapping2SUMO('10906822-n',[ ('Man',instance)]).
nounMapping2SUMO('10907103-n',[ ('Position',instance)]).
nounMapping2SUMO('10907236-n',[ ('Woman',instance)]).
nounMapping2SUMO('10907501-n',[ ('Man',instance)]).
nounMapping2SUMO('10907647-n',[ ('Man',instance)]).
nounMapping2SUMO('10907851-n',[ ('Man',instance)]).
nounMapping2SUMO('10907962-n',[ ('Man',instance)]).
nounMapping2SUMO('10908313-n',[ ('Man',instance)]).
nounMapping2SUMO('10908534-n',[ ('Man',instance)]).
nounMapping2SUMO('10908756-n',[ ('Man',instance)]).
nounMapping2SUMO('10908919-n',[ ('Man',instance)]).
nounMapping2SUMO('10909127-n',[ ('Man',instance)]).
nounMapping2SUMO('10909303-n',[ ('Man',instance)]).
nounMapping2SUMO('10909471-n',[ ('Man',instance)]).
nounMapping2SUMO('10909724-n',[ ('Man',instance)]).
nounMapping2SUMO('10909929-n',[ ('Man',instance)]).
nounMapping2SUMO('10910076-n',[ ('Man',instance)]).
nounMapping2SUMO('10910305-n',[ ('Man',instance)]).
nounMapping2SUMO('10910421-n',[ ('Man',instance)]).
nounMapping2SUMO('10910580-n',[ ('Woman',instance)]).
nounMapping2SUMO('10910769-n',[ ('Man',instance)]).
nounMapping2SUMO('10910948-n',[ ('Musician',instance)]).
nounMapping2SUMO('10911104-n',[ ('Man',instance)]).
nounMapping2SUMO('10911288-n',[ ('Man',instance)]).
nounMapping2SUMO('10911534-n',[ ('Woman',instance)]).
nounMapping2SUMO('10911687-n',[ ('Man',instance)]).
nounMapping2SUMO('10911948-n',[ ('Man',instance)]).
nounMapping2SUMO('10912079-n',[ ('Man',instance)]).
nounMapping2SUMO('10912243-n',[ ('Man',instance)]).
nounMapping2SUMO('10912451-n',[ ('Man',instance)]).
nounMapping2SUMO('10912626-n',[ ('Woman',instance)]).
nounMapping2SUMO('10912802-n',[ ('Man',instance)]).
nounMapping2SUMO('10913010-n',[ ('Man',instance)]).
nounMapping2SUMO('10913203-n',[ ('Man',instance)]).
nounMapping2SUMO('10913355-n',[ ('Woman',instance)]).
nounMapping2SUMO('10913503-n',[ ('Man',instance)]).
nounMapping2SUMO('10913641-n',[ ('Man',instance)]).
nounMapping2SUMO('10913871-n',[ ('Man',instance)]).
nounMapping2SUMO('10914006-n',[ ('Man',instance)]).
nounMapping2SUMO('10914134-n',[ ('Man',instance)]).
nounMapping2SUMO('10914331-n',[ ('Man',instance)]).
nounMapping2SUMO('10914447-n',[ ('Writer',instance)]).
nounMapping2SUMO('10914548-n',[ ('Woman',instance)]).
nounMapping2SUMO('10914658-n',[ ('Man',instance)]).
nounMapping2SUMO('10914779-n',[ ('Man',instance)]).
nounMapping2SUMO('10915025-n',[ ('Man',instance)]).
nounMapping2SUMO('10915173-n',[ ('Man',instance)]).
nounMapping2SUMO('10915373-n',[ ('Man',instance)]).
nounMapping2SUMO('10915566-n',[ ('Man',instance)]).
nounMapping2SUMO('10915772-n',[ ('Man',instance)]).
nounMapping2SUMO('10915862-n',[ ('Man',instance)]).
nounMapping2SUMO('10916105-n',[ ('Man',instance)]).
nounMapping2SUMO('10916325-n',[ ('Position',instance)]).
nounMapping2SUMO('10916505-n',[ ('Man',instance)]).
nounMapping2SUMO('10916731-n',[ ('Man',instance)]).
nounMapping2SUMO('10916887-n',[ ('Man',instance)]).
nounMapping2SUMO('10916993-n',[ ('Man',instance)]).
nounMapping2SUMO('10917164-n',[ ('Man',instance)]).
nounMapping2SUMO('10917377-n',[ ('Writer',instance)]).
nounMapping2SUMO('10917554-n',[ ('Man',instance)]).
nounMapping2SUMO('10917703-n',[ ('Woman',instance)]).
nounMapping2SUMO('10917999-n',[ ('Man',instance)]).
nounMapping2SUMO('10918119-n',[ ('Man',instance)]).
nounMapping2SUMO('10918358-n',[ ('Man',instance)]).
nounMapping2SUMO('10918558-n',[ ('Writer',instance)]).
nounMapping2SUMO('10918679-n',[ ('Man',instance)]).
nounMapping2SUMO('10918834-n',[ ('Man',instance)]).
nounMapping2SUMO('10919061-n',[ ('Man',instance)]).
nounMapping2SUMO('10919278-n',[ ('Man',instance)]).
nounMapping2SUMO('10919496-n',[ ('Man',instance)]).
nounMapping2SUMO('10919598-n',[ ('Man',instance)]).
nounMapping2SUMO('10919886-n',[ ('Man',instance)]).
nounMapping2SUMO('10920051-n',[ ('Man',instance)]).
nounMapping2SUMO('10920207-n',[ ('Man',instance)]).
nounMapping2SUMO('10920366-n',[ ('Man',instance)]).
nounMapping2SUMO('10920582-n',[ ('Man',instance)]).
nounMapping2SUMO('10920832-n',[ ('Man',instance)]).
nounMapping2SUMO('10921009-n',[ ('Man',instance)]).
nounMapping2SUMO('10921218-n',[ ('Man',instance)]).
nounMapping2SUMO('10921324-n',[ ('Man',instance)]).
nounMapping2SUMO('10921571-n',[ ('Man',instance)]).
nounMapping2SUMO('10921879-n',[ ('Man',instance)]).
nounMapping2SUMO('10922019-n',[ ('Man',instance)]).
nounMapping2SUMO('10922239-n',[ ('Man',instance)]).
nounMapping2SUMO('10922501-n',[ ('Man',instance)]).
nounMapping2SUMO('10922772-n',[ ('Man',instance)]).
nounMapping2SUMO('10922968-n',[ ('Man',instance)]).
nounMapping2SUMO('10923146-n',[ ('Man',instance)]).
nounMapping2SUMO('10923313-n',[ ('Man',instance)]).
nounMapping2SUMO('10923521-n',[ ('Man',instance)]).
nounMapping2SUMO('10923700-n',[ ('Man',instance)]).
nounMapping2SUMO('10924072-n',[ ('Man',instance)]).
nounMapping2SUMO('10924231-n',[ ('Man',instance)]).
nounMapping2SUMO('10924347-n',[ ('Woman',instance)]).
nounMapping2SUMO('10924452-n',[ ('Man',instance)]).
nounMapping2SUMO('10924649-n',[ ('Man',instance)]).
nounMapping2SUMO('10924828-n',[ ('Man',instance)]).
nounMapping2SUMO('10924987-n',[ ('Man',instance)]).
nounMapping2SUMO('10925132-n',[ ('Man',instance)]).
nounMapping2SUMO('10925402-n',[ ('Man',instance)]).
nounMapping2SUMO('10925584-n',[ ('Man',instance)]).
nounMapping2SUMO('10925772-n',[ ('Writer',instance)]).
nounMapping2SUMO('10925939-n',[ ('Man',instance)]).
nounMapping2SUMO('10926066-n',[ ('Man',instance)]).
nounMapping2SUMO('10926238-n',[ ('Man',instance)]).
nounMapping2SUMO('10926429-n',[ ('Man',instance)]).
nounMapping2SUMO('10926597-n',[ ('Man',instance)]).
nounMapping2SUMO('10926773-n',[ ('Man',instance)]).
nounMapping2SUMO('10926917-n',[ ('Man',instance)]).
nounMapping2SUMO('10927104-n',[ ('Man',instance)]).
nounMapping2SUMO('10927270-n',[ ('Writer',instance)]).
nounMapping2SUMO('10927424-n',[ ('Man',instance)]).
nounMapping2SUMO('10927687-n',[ ('Man',instance)]).
nounMapping2SUMO('10927824-n',[ ('Man',instance)]).
nounMapping2SUMO('10928140-n',[ ('Man',instance)]).
nounMapping2SUMO('10928299-n',[ ('Man',instance)]).
nounMapping2SUMO('10928498-n',[ ('Man',instance)]).
nounMapping2SUMO('10928645-n',[ ('Man',instance)]).
nounMapping2SUMO('10928810-n',[ ('Man',instance)]).
nounMapping2SUMO('10928978-n',[ ('Man',instance)]).
nounMapping2SUMO('10929116-n',[ ('Man',instance)]).
nounMapping2SUMO('10929316-n',[ ('Man',instance)]).
nounMapping2SUMO('10929437-n',[ ('Man',instance)]).
nounMapping2SUMO('10929657-n',[ ('Man',instance)]).
nounMapping2SUMO('10929886-n',[ ('Woman',instance)]).
nounMapping2SUMO('10930099-n',[ ('Man',instance)]).
nounMapping2SUMO('10930296-n',[ ('Man',instance)]).
nounMapping2SUMO('10930428-n',[ ('Man',instance)]).
nounMapping2SUMO('10930591-n',[ ('Man',instance)]).
nounMapping2SUMO('10930778-n',[ ('Man',instance)]).
nounMapping2SUMO('10930913-n',[ ('Man',instance)]).
nounMapping2SUMO('10931059-n',[ ('Man',instance)]).
nounMapping2SUMO('10931167-n',[ ('Writer',instance)]).
nounMapping2SUMO('10931333-n',[ ('Man',instance)]).
nounMapping2SUMO('10931452-n',[ ('Man',instance)]).
nounMapping2SUMO('10931634-n',[ ('Man',instance)]).
nounMapping2SUMO('10931854-n',[ ('Man',instance)]).
nounMapping2SUMO('10932140-n',[ ('Man',instance)]).
nounMapping2SUMO('10932244-n',[ ('Man',instance)]).
nounMapping2SUMO('10932495-n',[ ('Man',instance)]).
nounMapping2SUMO('10932696-n',[ ('Man',instance)]).
nounMapping2SUMO('10932898-n',[ ('Man',instance)]).
nounMapping2SUMO('10933084-n',[ ('Man',instance)]).
nounMapping2SUMO('10933266-n',[ ('Man',instance)]).
nounMapping2SUMO('10933449-n',[ ('Man',instance)]).
nounMapping2SUMO('10933658-n',[ ('Woman',instance)]).
nounMapping2SUMO('10933929-n',[ ('Woman',instance)]).
nounMapping2SUMO('10934154-n',[ ('Man',instance)]).
nounMapping2SUMO('10934410-n',[ ('Writer',instance)]).
nounMapping2SUMO('10934611-n',[ ('Woman',instance)]).
nounMapping2SUMO('10934758-n',[ ('Man',instance)]).
nounMapping2SUMO('10935025-n',[ ('Writer',instance)]).
nounMapping2SUMO('10935128-n',[ ('Man',instance)]).
nounMapping2SUMO('10935304-n',[ ('Woman',instance)]).
nounMapping2SUMO('10935567-n',[ ('Man',instance)]).
nounMapping2SUMO('10935745-n',[ ('Writer',instance)]).
nounMapping2SUMO('10935968-n',[ ('Leader',instance)]).
nounMapping2SUMO('10936279-n',[ ('Man',instance)]).
nounMapping2SUMO('10936424-n',[ ('Man',instance)]).
nounMapping2SUMO('10936567-n',[ ('Man',instance)]).
nounMapping2SUMO('10936716-n',[ ('Man',instance)]).
nounMapping2SUMO('10936894-n',[ ('Man',instance)]).
nounMapping2SUMO('10937126-n',[ ('Man',instance)]).
nounMapping2SUMO('10937364-n',[ ('Man',instance)]).
nounMapping2SUMO('10937611-n',[ ('Woman',instance)]).
nounMapping2SUMO('10937882-n',[ ('Man',instance)]).
nounMapping2SUMO('10938019-n',[ ('Man',instance)]).
nounMapping2SUMO('10938199-n',[ ('Man',instance)]).
nounMapping2SUMO('10938363-n',[ ('Man',instance)]).
nounMapping2SUMO('10938640-n',[ ('Man',instance)]).
nounMapping2SUMO('10938821-n',[ ('Man',instance)]).
nounMapping2SUMO('10939040-n',[ ('Man',instance)]).
nounMapping2SUMO('10939187-n',[ ('Man',instance)]).
nounMapping2SUMO('10939360-n',[ ('Man',instance)]).
nounMapping2SUMO('10939475-n',[ ('Man',instance)]).
nounMapping2SUMO('10939630-n',[ ('Man',instance)]).
nounMapping2SUMO('10939856-n',[ ('Man',instance)]).
nounMapping2SUMO('10940053-n',[ ('Man',instance)]).
nounMapping2SUMO('10940315-n',[ ('Man',instance)]).
nounMapping2SUMO('10940474-n',[ ('Man',instance)]).
nounMapping2SUMO('10940669-n',[ ('Man',instance)]).
nounMapping2SUMO('10941206-n',[ ('Man',instance)]).
nounMapping2SUMO('10941515-n',[ ('Writer',instance)]).
nounMapping2SUMO('10941714-n',[ ('Man',instance)]).
nounMapping2SUMO('10941992-n',[ ('Man',instance)]).
nounMapping2SUMO('10942144-n',[ ('Man',instance)]).
nounMapping2SUMO('10942279-n',[ ('Man',instance)]).
nounMapping2SUMO('10942473-n',[ ('Man',instance)]).
nounMapping2SUMO('10942675-n',[ ('Man',instance)]).
nounMapping2SUMO('10942866-n',[ ('Man',instance)]).
nounMapping2SUMO('10943115-n',[ ('Man',instance)]).
nounMapping2SUMO('10943256-n',[ ('Man',instance)]).
nounMapping2SUMO('10943405-n',[ ('Man',instance)]).
nounMapping2SUMO('10943659-n',[ ('Man',instance)]).
nounMapping2SUMO('10943811-n',[ ('Man',instance)]).
nounMapping2SUMO('10944013-n',[ ('Man',instance)]).
nounMapping2SUMO('10944238-n',[ ('Man',instance)]).
nounMapping2SUMO('10944468-n',[ ('Man',instance)]).
nounMapping2SUMO('10944593-n',[ ('Man',instance)]).
nounMapping2SUMO('10944686-n',[ ('Man',instance)]).
nounMapping2SUMO('10944902-n',[ ('Writer',instance)]).
nounMapping2SUMO('10945048-n',[ ('Writer',instance)]).
nounMapping2SUMO('10945263-n',[ ('Writer',instance)]).
nounMapping2SUMO('10945415-n',[ ('Woman',instance)]).
nounMapping2SUMO('10945546-n',[ ('Man',instance)]).
nounMapping2SUMO('10945699-n',[ ('Man',instance)]).
nounMapping2SUMO('10945825-n',[ ('Man',instance)]).
nounMapping2SUMO('10945977-n',[ ('Man',instance)]).
nounMapping2SUMO('10946134-n',[ ('Man',instance)]).
nounMapping2SUMO('10946286-n',[ ('Writer',instance)]).
nounMapping2SUMO('10946481-n',[ ('Woman',instance)]).
nounMapping2SUMO('10946624-n',[ ('Man',instance)]).
nounMapping2SUMO('10946750-n',[ ('Man',instance)]).
nounMapping2SUMO('10946961-n',[ ('Man',instance)]).
nounMapping2SUMO('10947108-n',[ ('Man',instance)]).
nounMapping2SUMO('10947259-n',[ ('Man',instance)]).
nounMapping2SUMO('10947403-n',[ ('Woman',instance)]).
nounMapping2SUMO('10947628-n',[ ('Man',instance)]).
nounMapping2SUMO('10947922-n',[ ('Man',instance)]).
nounMapping2SUMO('10948117-n',[ ('Man',instance)]).
nounMapping2SUMO('10948312-n',[ ('Man',instance)]).
nounMapping2SUMO('10948478-n',[ ('Man',instance)]).
nounMapping2SUMO('10948656-n',[ ('Woman',instance)]).
nounMapping2SUMO('10948798-n',[ ('Man',instance)]).
nounMapping2SUMO('10948993-n',[ ('Man',instance)]).
nounMapping2SUMO('10949192-n',[ ('Man',instance)]).
nounMapping2SUMO('10949424-n',[ ('Man',instance)]).
nounMapping2SUMO('10949586-n',[ ('Man',instance)]).
nounMapping2SUMO('10949782-n',[ ('Man',instance)]).
nounMapping2SUMO('10949952-n',[ ('Man',instance)]).
nounMapping2SUMO('10950092-n',[ ('Man',instance)]).
nounMapping2SUMO('10950219-n',[ ('Man',instance)]).
nounMapping2SUMO('10950448-n',[ ('Man',instance)]).
nounMapping2SUMO('10950786-n',[ ('Man',instance)]).
nounMapping2SUMO('10951017-n',[ ('Man',instance)]).
nounMapping2SUMO('10951278-n',[ ('Man',instance)]).
nounMapping2SUMO('10951459-n',[ ('Man',instance)]).
nounMapping2SUMO('10951697-n',[ ('Man',instance)]).
nounMapping2SUMO('10951948-n',[ ('Man',instance)]).
nounMapping2SUMO('10952143-n',[ ('Man',instance)]).
nounMapping2SUMO('10952421-n',[ ('Man',instance)]).
nounMapping2SUMO('10952629-n',[ ('Man',instance)]).
nounMapping2SUMO('10952919-n',[ ('Man',instance)]).
nounMapping2SUMO('10953035-n',[ ('Man',instance)]).
nounMapping2SUMO('10953188-n',[ ('Man',instance)]).
nounMapping2SUMO('10953344-n',[ ('Position',instance)]).
nounMapping2SUMO('10953473-n',[ ('Man',instance)]).
nounMapping2SUMO('10953605-n',[ ('Man',instance)]).
nounMapping2SUMO('10953797-n',[ ('Man',instance)]).
nounMapping2SUMO('10954039-n',[ ('Man',instance)]).
nounMapping2SUMO('10954180-n',[ ('Man',instance)]).
nounMapping2SUMO('10954328-n',[ ('Man',instance)]).
nounMapping2SUMO('10954498-n',[ ('Man',instance)]).
nounMapping2SUMO('10954819-n',[ ('Man',instance)]).
nounMapping2SUMO('10954966-n',[ ('Man',instance)]).
nounMapping2SUMO('10955282-n',[ ('Man',instance)]).
nounMapping2SUMO('10955483-n',[ ('Man',instance)]).
nounMapping2SUMO('10955748-n',[ ('Man',instance)]).
nounMapping2SUMO('10955920-n',[ ('Woman',instance)]).
nounMapping2SUMO('10956134-n',[ ('Man',instance)]).
nounMapping2SUMO('10956377-n',[ ('Man',instance)]).
nounMapping2SUMO('10956612-n',[ ('Man',instance)]).
nounMapping2SUMO('10956883-n',[ ('Writer',instance)]).
nounMapping2SUMO('10957072-n',[ ('Man',instance)]).
nounMapping2SUMO('10957330-n',[ ('Woman',instance)]).
nounMapping2SUMO('10957748-n',[ ('Woman',instance)]).
nounMapping2SUMO('10958010-n',[ ('Man',instance)]).
nounMapping2SUMO('10958182-n',[ ('Man',instance)]).
nounMapping2SUMO('10958381-n',[ ('Position',instance)]).
nounMapping2SUMO('10958552-n',[ ('Writer',instance)]).
nounMapping2SUMO('10958703-n',[ ('Man',instance)]).
nounMapping2SUMO('10958885-n',[ ('Man',instance)]).
nounMapping2SUMO('10959074-n',[ ('Man',instance)]).
nounMapping2SUMO('10959223-n',[ ('Man',instance)]).
nounMapping2SUMO('10959374-n',[ ('Man',instance)]).
nounMapping2SUMO('10959479-n',[ ('Man',instance)]).
nounMapping2SUMO('10959664-n',[ ('Man',instance)]).
nounMapping2SUMO('10959857-n',[ ('Man',instance)]).
nounMapping2SUMO('10960230-n',[ ('Man',instance)]).
nounMapping2SUMO('10960439-n',[ ('Man',instance)]).
nounMapping2SUMO('10960561-n',[ ('Man',instance)]).
nounMapping2SUMO('10960772-n',[ ('Man',instance)]).
nounMapping2SUMO('10960922-n',[ ('Man',instance)]).
nounMapping2SUMO('10961087-n',[ ('Man',instance)]).
nounMapping2SUMO('10961372-n',[ ('Woman',instance)]).
nounMapping2SUMO('10961650-n',[ ('Man',instance)]).
nounMapping2SUMO('10961816-n',[ ('Man',instance)]).
nounMapping2SUMO('10962041-n',[ ('Man',instance)]).
nounMapping2SUMO('10962302-n',[ ('Man',instance)]).
nounMapping2SUMO('10962423-n',[ ('Man',instance)]).
nounMapping2SUMO('10962611-n',[ ('Man',instance)]).
nounMapping2SUMO('10962712-n',[ ('Man',instance)]).
nounMapping2SUMO('10962837-n',[ ('Man',instance)]).
nounMapping2SUMO('10963050-n',[ ('Man',instance)]).
nounMapping2SUMO('10963254-n',[ ('Man',instance)]).
nounMapping2SUMO('10963467-n',[ ('Man',instance)]).
nounMapping2SUMO('10963642-n',[ ('Man',instance)]).
nounMapping2SUMO('10963815-n',[ ('Man',instance)]).
nounMapping2SUMO('10964052-n',[ ('Man',instance)]).
nounMapping2SUMO('10964261-n',[ ('Man',instance)]).
nounMapping2SUMO('10964520-n',[ ('Man',instance)]).
nounMapping2SUMO('10964660-n',[ ('Woman',instance)]).
nounMapping2SUMO('10964829-n',[ ('Man',instance)]).
nounMapping2SUMO('10965019-n',[ ('Man',instance)]).
nounMapping2SUMO('10965151-n',[ ('Man',instance)]).
nounMapping2SUMO('10965361-n',[ ('Man',instance)]).
nounMapping2SUMO('10965550-n',[ ('Man',instance)]).
nounMapping2SUMO('10965700-n',[ ('Man',instance)]).
nounMapping2SUMO('10965836-n',[ ('Man',instance)]).
nounMapping2SUMO('10965966-n',[ ('Woman',instance)]).
nounMapping2SUMO('10966145-n',[ ('Man',instance)]).
nounMapping2SUMO('10966318-n',[ ('Man',instance)]).
nounMapping2SUMO('10966496-n',[ ('Woman',instance)]).
nounMapping2SUMO('10966665-n',[ ('Man',instance)]).
nounMapping2SUMO('10966842-n',[ ('Man',instance)]).
nounMapping2SUMO('10966982-n',[ ('Man',instance)]).
nounMapping2SUMO('10967152-n',[ ('Woman',instance)]).
nounMapping2SUMO('10967311-n',[ ('Writer',instance)]).
nounMapping2SUMO('10967447-n',[ ('Woman',instance)]).
nounMapping2SUMO('10967633-n',[ ('Man',instance)]).
nounMapping2SUMO('10967872-n',[ ('Man',instance)]).
nounMapping2SUMO('10968058-n',[ ('Man',instance)]).
nounMapping2SUMO('10968257-n',[ ('Man',instance)]).
nounMapping2SUMO('10968401-n',[ ('Position',instance)]).
nounMapping2SUMO('10968504-n',[ ('Writer',instance)]).
nounMapping2SUMO('10968640-n',[ ('Man',instance)]).
nounMapping2SUMO('10968835-n',[ ('Man',instance)]).
nounMapping2SUMO('10968956-n',[ ('Man',instance)]).
nounMapping2SUMO('10969118-n',[ ('Man',instance)]).
nounMapping2SUMO('10969305-n',[ ('Man',instance)]).
nounMapping2SUMO('10969799-n',[ ('Man',instance)]).
nounMapping2SUMO('10969986-n',[ ('Man',instance)]).
nounMapping2SUMO('10970279-n',[ ('Man',instance)]).
nounMapping2SUMO('10970488-n',[ ('Man',instance)]).
nounMapping2SUMO('10970603-n',[ ('Man',instance)]).
nounMapping2SUMO('10970718-n',[ ('Man',instance)]).
nounMapping2SUMO('10970864-n',[ ('Man',instance)]).
nounMapping2SUMO('10971080-n',[ ('Man',instance)]).
nounMapping2SUMO('10971264-n',[ ('Man',instance)]).
nounMapping2SUMO('10971528-n',[ ('Man',instance)]).
nounMapping2SUMO('10971697-n',[ ('Man',instance)]).
nounMapping2SUMO('10971852-n',[ ('Man',instance)]).
nounMapping2SUMO('10971981-n',[ ('Woman',instance)]).
nounMapping2SUMO('10972094-n',[ ('Writer',instance)]).
nounMapping2SUMO('10972298-n',[ ('Man',instance)]).
nounMapping2SUMO('10972495-n',[ ('Man',instance)]).
nounMapping2SUMO('10972697-n',[ ('Writer',instance)]).
nounMapping2SUMO('10972825-n',[ ('Man',instance)]).
nounMapping2SUMO('10972985-n',[ ('Writer',instance)]).
nounMapping2SUMO('10973164-n',[ ('Man',instance)]).
nounMapping2SUMO('10973339-n',[ ('Man',instance)]).
nounMapping2SUMO('10973497-n',[ ('Man',instance)]).
nounMapping2SUMO('10973722-n',[ ('Man',instance)]).
nounMapping2SUMO('10973873-n',[ ('Man',instance)]).
nounMapping2SUMO('10974033-n',[ ('Man',instance)]).
nounMapping2SUMO('10974136-n',[ ('Woman',instance)]).
nounMapping2SUMO('10974271-n',[ ('Woman',instance)]).
nounMapping2SUMO('10974455-n',[ ('Woman',instance)]).
nounMapping2SUMO('10974592-n',[ ('Man',instance)]).
nounMapping2SUMO('10974740-n',[ ('Man',instance)]).
nounMapping2SUMO('10974971-n',[ ('Writer',instance)]).
nounMapping2SUMO('10975101-n',[ ('Man',instance)]).
nounMapping2SUMO('10975202-n',[ ('Man',instance)]).
nounMapping2SUMO('10975304-n',[ ('Man',instance)]).
nounMapping2SUMO('10975404-n',[ ('Writer',instance)]).
nounMapping2SUMO('10975583-n',[ ('Man',instance)]).
nounMapping2SUMO('10975796-n',[ ('Man',instance)]).
nounMapping2SUMO('10976004-n',[ ('Man',instance)]).
nounMapping2SUMO('10976256-n',[ ('Man',instance)]).
nounMapping2SUMO('10976468-n',[ ('Man',instance)]).
nounMapping2SUMO('10976708-n',[ ('Man',instance)]).
nounMapping2SUMO('10976862-n',[ ('Man',instance)]).
nounMapping2SUMO('10976997-n',[ ('Man',instance)]).
nounMapping2SUMO('10977159-n',[ ('Man',instance)]).
nounMapping2SUMO('10977368-n',[ ('Writer',instance)]).
nounMapping2SUMO('10977542-n',[ ('Man',instance)]).
nounMapping2SUMO('10977660-n',[ ('Man',instance)]).
nounMapping2SUMO('10977881-n',[ ('Man',instance)]).
nounMapping2SUMO('10978098-n',[ ('Man',instance)]).
nounMapping2SUMO('10978422-n',[ ('Man',instance)]).
nounMapping2SUMO('10978693-n',[ ('Man',instance)]).
nounMapping2SUMO('10978842-n',[ ('Man',instance)]).
nounMapping2SUMO('10979079-n',[ ('Man',instance)]).
nounMapping2SUMO('10979535-n',[ ('Man',instance)]).
nounMapping2SUMO('10979694-n',[ ('Man',instance)]).
nounMapping2SUMO('10979887-n',[ ('Man',instance)]).
nounMapping2SUMO('10980097-n',[ ('Man',instance)]).
nounMapping2SUMO('10980256-n',[ ('Man',instance)]).
nounMapping2SUMO('10980448-n',[ ('Man',instance)]).
nounMapping2SUMO('10980681-n',[ ('Man',instance)]).
nounMapping2SUMO('10980893-n',[ ('Man',instance)]).
nounMapping2SUMO('10981089-n',[ ('Man',instance)]).
nounMapping2SUMO('10981251-n',[ ('Man',instance)]).
nounMapping2SUMO('10981409-n',[ ('Man',instance)]).
nounMapping2SUMO('10981569-n',[ ('Man',instance)]).
nounMapping2SUMO('10981750-n',[ ('Man',instance)]).
nounMapping2SUMO('10981961-n',[ ('Man',instance)]).
nounMapping2SUMO('10982127-n',[ ('Man',instance)]).
nounMapping2SUMO('10982295-n',[ ('Man',instance)]).
nounMapping2SUMO('10982450-n',[ ('Woman',instance)]).
nounMapping2SUMO('10982658-n',[ ('Man',instance)]).
nounMapping2SUMO('10982870-n',[ ('Man',instance)]).
nounMapping2SUMO('10983007-n',[ ('Man',instance)]).
nounMapping2SUMO('10983172-n',[ ('Man',instance)]).
nounMapping2SUMO('10983503-n',[ ('Man',instance)]).
nounMapping2SUMO('10983758-n',[ ('Man',instance)]).
nounMapping2SUMO('10983931-n',[ ('Man',instance)]).
nounMapping2SUMO('10984126-n',[ ('Man',instance)]).
nounMapping2SUMO('10984257-n',[ ('Man',instance)]).
nounMapping2SUMO('10984418-n',[ ('Man',instance)]).
nounMapping2SUMO('10984589-n',[ ('Man',instance)]).
nounMapping2SUMO('10984876-n',[ ('Man',instance)]).
nounMapping2SUMO('10984979-n',[ ('Man',instance)]).
nounMapping2SUMO('10985160-n',[ ('Man',instance)]).
nounMapping2SUMO('10985440-n',[ ('Man',instance)]).
nounMapping2SUMO('10985653-n',[ ('Man',instance)]).
nounMapping2SUMO('10985838-n',[ ('Man',instance)]).
nounMapping2SUMO('10986022-n',[ ('Man',instance)]).
nounMapping2SUMO('10986272-n',[ ('Man',instance)]).
nounMapping2SUMO('10986437-n',[ ('Man',instance)]).
nounMapping2SUMO('10986562-n',[ ('Man',instance)]).
nounMapping2SUMO('10986710-n',[ ('Writer',instance)]).
nounMapping2SUMO('10986866-n',[ ('Man',instance)]).
nounMapping2SUMO('10987044-n',[ ('Man',instance)]).
nounMapping2SUMO('10987176-n',[ ('Man',instance)]).
nounMapping2SUMO('10987358-n',[ ('Man',instance)]).
nounMapping2SUMO('10987565-n',[ ('Man',instance)]).
nounMapping2SUMO('10987724-n',[ ('Man',instance)]).
nounMapping2SUMO('10988059-n',[ ('Man',instance)]).
nounMapping2SUMO('10988261-n',[ ('Man',instance)]).
nounMapping2SUMO('10988466-n',[ ('Man',instance)]).
nounMapping2SUMO('10988570-n',[ ('Man',instance)]).
nounMapping2SUMO('10988887-n',[ ('Man',instance)]).
nounMapping2SUMO('10989099-n',[ ('Man',instance)]).
nounMapping2SUMO('10989339-n',[ ('Man',instance)]).
nounMapping2SUMO('10989610-n',[ ('Woman',instance)]).
nounMapping2SUMO('10989801-n',[ ('Woman',instance)]).
nounMapping2SUMO('10989977-n',[ ('Man',instance)]).
nounMapping2SUMO('10990212-n',[ ('Man',instance)]).
nounMapping2SUMO('10990371-n',[ ('Writer',instance)]).
nounMapping2SUMO('10990509-n',[ ('Woman',instance)]).
nounMapping2SUMO('10990733-n',[ ('Man',instance)]).
nounMapping2SUMO('10990963-n',[ ('Man',instance)]).
nounMapping2SUMO('10991165-n',[ ('Woman',instance)]).
nounMapping2SUMO('10991303-n',[ ('Man',instance)]).
nounMapping2SUMO('10991415-n',[ ('Man',instance)]).
nounMapping2SUMO('10991583-n',[ ('Man',instance)]).
nounMapping2SUMO('10991740-n',[ ('Writer',instance)]).
nounMapping2SUMO('10991936-n',[ ('Man',instance)]).
nounMapping2SUMO('10992192-n',[ ('Man',instance)]).
nounMapping2SUMO('10992336-n',[ ('Man',instance)]).
nounMapping2SUMO('10992528-n',[ ('Man',instance)]).
nounMapping2SUMO('10992675-n',[ ('Man',instance)]).
nounMapping2SUMO('10992933-n',[ ('Man',instance)]).
nounMapping2SUMO('10993098-n',[ ('Man',instance)]).
nounMapping2SUMO('10993350-n',[ ('Man',instance)]).
nounMapping2SUMO('10993507-n',[ ('Man',instance)]).
nounMapping2SUMO('10993636-n',[ ('Writer',instance)]).
nounMapping2SUMO('10993777-n',[ ('Man',instance)]).
nounMapping2SUMO('10993936-n',[ ('Writer',instance)]).
nounMapping2SUMO('10994097-n',[ ('Man',instance)]).
nounMapping2SUMO('10994308-n',[ ('Man',instance)]).
nounMapping2SUMO('10994500-n',[ ('Man',instance)]).
nounMapping2SUMO('10994660-n',[ ('Man',instance)]).
nounMapping2SUMO('10994906-n',[ ('Man',instance)]).
nounMapping2SUMO('10995115-n',[ ('Man',instance)]).
nounMapping2SUMO('10995292-n',[ ('Man',instance)]).
nounMapping2SUMO('10995592-n',[ ('Man',instance)]).
nounMapping2SUMO('10995850-n',[ ('Man',instance)]).
nounMapping2SUMO('10996090-n',[ ('Man',instance)]).
nounMapping2SUMO('10996285-n',[ ('Man',instance)]).
nounMapping2SUMO('10996533-n',[ ('Man',instance)]).
nounMapping2SUMO('10996677-n',[ ('Man',instance)]).
nounMapping2SUMO('10996876-n',[ ('Man',instance)]).
nounMapping2SUMO('10997068-n',[ ('Man',instance)]).
nounMapping2SUMO('10997234-n',[ ('Man',instance)]).
nounMapping2SUMO('10997405-n',[ ('Man',instance)]).
nounMapping2SUMO('10997553-n',[ ('Man',instance)]).
nounMapping2SUMO('10997742-n',[ ('Man',instance)]).
nounMapping2SUMO('10997888-n',[ ('Man',instance)]).
nounMapping2SUMO('10997997-n',[ ('Writer',instance)]).
nounMapping2SUMO('10998117-n',[ ('Woman',instance)]).
nounMapping2SUMO('10998305-n',[ ('Man',instance)]).
nounMapping2SUMO('10998474-n',[ ('Man',instance)]).
nounMapping2SUMO('10998651-n',[ ('Writer',instance)]).
nounMapping2SUMO('10998860-n',[ ('Man',instance)]).
nounMapping2SUMO('10999048-n',[ ('Man',instance)]).
nounMapping2SUMO('10999202-n',[ ('Man',instance)]).
nounMapping2SUMO('10999410-n',[ ('Man',instance)]).
nounMapping2SUMO('10999584-n',[ ('Man',instance)]).
nounMapping2SUMO('10999873-n',[ ('Man',instance)]).
nounMapping2SUMO('11000012-n',[ ('Man',instance)]).
nounMapping2SUMO('11000172-n',[ ('Man',instance)]).
nounMapping2SUMO('11000349-n',[ ('Woman',instance)]).
nounMapping2SUMO('11000469-n',[ ('Woman',instance)]).
nounMapping2SUMO('11000660-n',[ ('Man',instance)]).
nounMapping2SUMO('11000786-n',[ ('Man',instance)]).
nounMapping2SUMO('11001053-n',[ ('Man',instance)]).
nounMapping2SUMO('11001211-n',[ ('Man',instance)]).
nounMapping2SUMO('11001422-n',[ ('Woman',instance)]).
nounMapping2SUMO('11001567-n',[ ('Man',instance)]).
nounMapping2SUMO('11001668-n',[ ('Man',instance)]).
nounMapping2SUMO('11001848-n',[ ('Man',instance)]).
nounMapping2SUMO('11002040-n',[ ('Man',instance)]).
nounMapping2SUMO('11002191-n',[ ('Man',instance)]).
nounMapping2SUMO('11002422-n',[ ('Man',instance)]).
nounMapping2SUMO('11002548-n',[ ('Man',instance)]).
nounMapping2SUMO('11002684-n',[ ('Man',instance)]).
nounMapping2SUMO('11002895-n',[ ('Man',instance)]).
nounMapping2SUMO('11003068-n',[ ('Man',instance)]).
nounMapping2SUMO('11003276-n',[ ('Woman',instance)]).
nounMapping2SUMO('11003599-n',[ ('Man',instance)]).
nounMapping2SUMO('11003724-n',[ ('Man',instance)]).
nounMapping2SUMO('11003918-n',[ ('Man',instance)]).
nounMapping2SUMO('11004106-n',[ ('Man',instance)]).
nounMapping2SUMO('11004333-n',[ ('Writer',instance)]).
nounMapping2SUMO('11004485-n',[ ('Man',instance)]).
nounMapping2SUMO('11004731-n',[ ('Man',instance)]).
nounMapping2SUMO('11004861-n',[ ('Woman',instance)]).
nounMapping2SUMO('11005050-n',[ ('Man',instance)]).
nounMapping2SUMO('11005320-n',[ ('Man',instance)]).
nounMapping2SUMO('11005429-n',[ ('Writer',instance)]).
nounMapping2SUMO('11005571-n',[ ('Man',instance)]).
nounMapping2SUMO('11005780-n',[ ('Man',instance)]).
nounMapping2SUMO('11005972-n',[ ('Man',instance)]).
nounMapping2SUMO('11006128-n',[ ('Writer',instance)]).
nounMapping2SUMO('11006231-n',[ ('Man',instance)]).
nounMapping2SUMO('11006431-n',[ ('Writer',instance)]).
nounMapping2SUMO('11006689-n',[ ('Writer',instance)]).
nounMapping2SUMO('11006889-n',[ ('Man',instance)]).
nounMapping2SUMO('11007059-n',[ ('Man',instance)]).
nounMapping2SUMO('11007181-n',[ ('Woman',instance)]).
nounMapping2SUMO('11007332-n',[ ('Man',instance)]).
nounMapping2SUMO('11007620-n',[ ('Man',instance)]).
nounMapping2SUMO('11007750-n',[ ('Man',instance)]).
nounMapping2SUMO('11007993-n',[ ('Writer',instance)]).
nounMapping2SUMO('11008173-n',[ ('Man',instance)]).
nounMapping2SUMO('11008313-n',[ ('Man',instance)]).
nounMapping2SUMO('11008462-n',[ ('Man',instance)]).
nounMapping2SUMO('11008647-n',[ ('Man',instance)]).
nounMapping2SUMO('11008870-n',[ ('Writer',instance)]).
nounMapping2SUMO('11009115-n',[ ('Position',instance)]).
nounMapping2SUMO('11009273-n',[ ('Man',instance)]).
nounMapping2SUMO('11009495-n',[ ('Man',instance)]).
nounMapping2SUMO('11009635-n',[ ('Man',instance)]).
nounMapping2SUMO('11009773-n',[ ('Man',instance)]).
nounMapping2SUMO('11010019-n',[ ('Man',instance)]).
nounMapping2SUMO('11010187-n',[ ('Woman',instance)]).
nounMapping2SUMO('11010385-n',[ ('Man',instance)]).
nounMapping2SUMO('11010557-n',[ ('Writer',instance)]).
nounMapping2SUMO('11010697-n',[ ('Man',instance)]).
nounMapping2SUMO('11010936-n',[ ('Man',instance)]).
nounMapping2SUMO('11011123-n',[ ('Man',instance)]).
nounMapping2SUMO('11011398-n',[ ('Man',instance)]).
nounMapping2SUMO('11011559-n',[ ('Writer',instance)]).
nounMapping2SUMO('11011764-n',[ ('Man',instance)]).
nounMapping2SUMO('11012042-n',[ ('Man',instance)]).
nounMapping2SUMO('11012153-n',[ ('Writer',instance)]).
nounMapping2SUMO('11012300-n',[ ('Writer',instance)]).
nounMapping2SUMO('11012474-n',[ ('Man',instance)]).
nounMapping2SUMO('11012676-n',[ ('Man',instance)]).
nounMapping2SUMO('11012846-n',[ ('Man',instance)]).
nounMapping2SUMO('11012993-n',[ ('Man',instance)]).
nounMapping2SUMO('11013191-n',[ ('Man',instance)]).
nounMapping2SUMO('11013324-n',[ ('Man',instance)]).
nounMapping2SUMO('11013574-n',[ ('Man',instance)]).
nounMapping2SUMO('11013743-n',[ ('Man',instance)]).
nounMapping2SUMO('11013876-n',[ ('Man',instance)]).
nounMapping2SUMO('11014212-n',[ ('Man',instance)]).
nounMapping2SUMO('11014450-n',[ ('Man',instance)]).
nounMapping2SUMO('11014652-n',[ ('Man',instance)]).
nounMapping2SUMO('11014833-n',[ ('Man',instance)]).
nounMapping2SUMO('11015080-n',[ ('Man',instance)]).
nounMapping2SUMO('11015420-n',[ ('Man',instance)]).
nounMapping2SUMO('11015525-n',[ ('Man',instance)]).
nounMapping2SUMO('11015650-n',[ ('Man',instance)]).
nounMapping2SUMO('11015872-n',[ ('Woman',instance)]).
nounMapping2SUMO('11016075-n',[ ('Writer',instance)]).
nounMapping2SUMO('11016199-n',[ ('Man',instance)]).
nounMapping2SUMO('11016374-n',[ ('Man',instance)]).
nounMapping2SUMO('11016563-n',[ ('Writer',instance)]).
nounMapping2SUMO('11016841-n',[ ('Man',instance)]).
nounMapping2SUMO('11017020-n',[ ('Man',instance)]).
nounMapping2SUMO('11017118-n',[ ('Man',instance)]).
nounMapping2SUMO('11017295-n',[ ('Man',instance)]).
nounMapping2SUMO('11017454-n',[ ('Man',instance)]).
nounMapping2SUMO('11017661-n',[ ('Man',instance)]).
nounMapping2SUMO('11017831-n',[ ('Man',instance)]).
nounMapping2SUMO('11017987-n',[ ('Man',instance)]).
nounMapping2SUMO('11018153-n',[ ('Man',instance)]).
nounMapping2SUMO('11018439-n',[ ('Woman',instance)]).
nounMapping2SUMO('11018683-n',[ ('Man',instance)]).
nounMapping2SUMO('11018862-n',[ ('Man',instance)]).
nounMapping2SUMO('11019073-n',[ ('Man',instance)]).
nounMapping2SUMO('11019269-n',[ ('Man',instance)]).
nounMapping2SUMO('11019425-n',[ ('Man',instance)]).
nounMapping2SUMO('11019570-n',[ ('Man',instance)]).
nounMapping2SUMO('11019900-n',[ ('Man',instance)]).
nounMapping2SUMO('11020069-n',[ ('Man',instance)]).
nounMapping2SUMO('11020225-n',[ ('Man',instance)]).
nounMapping2SUMO('11020375-n',[ ('Man',instance)]).
nounMapping2SUMO('11020513-n',[ ('Man',instance)]).
nounMapping2SUMO('11020721-n',[ ('Man',instance)]).
nounMapping2SUMO('11020888-n',[ ('Woman',instance)]).
nounMapping2SUMO('11021100-n',[ ('Man',instance)]).
nounMapping2SUMO('11021178-n',[ ('Man',instance)]).
nounMapping2SUMO('11021342-n',[ ('Man',instance)]).
nounMapping2SUMO('11021667-n',[ ('Man',instance)]).
nounMapping2SUMO('11021916-n',[ ('Man',instance)]).
nounMapping2SUMO('11022001-n',[ ('Writer',instance)]).
nounMapping2SUMO('11022160-n',[ ('Man',instance)]).
nounMapping2SUMO('11022309-n',[ ('Man',instance)]).
nounMapping2SUMO('11022465-n',[ ('Man',instance)]).
nounMapping2SUMO('11022669-n',[ ('Writer',instance)]).
nounMapping2SUMO('11022848-n',[ ('Man',instance)]).
nounMapping2SUMO('11023070-n',[ ('Man',instance)]).
nounMapping2SUMO('11023327-n',[ ('Writer',instance)]).
nounMapping2SUMO('11023442-n',[ ('Man',instance)]).
nounMapping2SUMO('11023623-n',[ ('Man',instance)]).
nounMapping2SUMO('11023883-n',[ ('Man',instance)]).
nounMapping2SUMO('11024033-n',[ ('Writer',instance)]).
nounMapping2SUMO('11024226-n',[ ('Man',instance)]).
nounMapping2SUMO('11024419-n',[ ('Man',instance)]).
nounMapping2SUMO('11024582-n',[ ('Man',instance)]).
nounMapping2SUMO('11024731-n',[ ('Man',instance)]).
nounMapping2SUMO('11024908-n',[ ('Man',instance)]).
nounMapping2SUMO('11025125-n',[ ('Writer',instance)]).
nounMapping2SUMO('11025326-n',[ ('Man',instance)]).
nounMapping2SUMO('11025508-n',[ ('Man',instance)]).
nounMapping2SUMO('11025668-n',[ ('Man',instance)]).
nounMapping2SUMO('11025926-n',[ ('Woman',instance)]).
nounMapping2SUMO('11026078-n',[ ('Woman',instance)]).
nounMapping2SUMO('11026231-n',[ ('Man',instance)]).
nounMapping2SUMO('11026372-n',[ ('Man',instance)]).
nounMapping2SUMO('11026597-n',[ ('Man',instance)]).
nounMapping2SUMO('11026816-n',[ ('Writer',instance)]).
nounMapping2SUMO('11026981-n',[ ('Man',instance)]).
nounMapping2SUMO('11027127-n',[ ('Man',instance)]).
nounMapping2SUMO('11027294-n',[ ('Writer',instance)]).
nounMapping2SUMO('11027416-n',[ ('Man',instance)]).
nounMapping2SUMO('11027631-n',[ ('Man',instance)]).
nounMapping2SUMO('11027885-n',[ ('Man',instance)]).
nounMapping2SUMO('11028074-n',[ ('Man',instance)]).
nounMapping2SUMO('11028196-n',[ ('Man',instance)]).
nounMapping2SUMO('11028446-n',[ ('Man',instance)]).
nounMapping2SUMO('11028675-n',[ ('Man',instance)]).
nounMapping2SUMO('11028780-n',[ ('Man',instance)]).
nounMapping2SUMO('11029005-n',[ ('Man',instance)]).
nounMapping2SUMO('11029132-n',[ ('Man',instance)]).
nounMapping2SUMO('11029298-n',[ ('Man',instance)]).
nounMapping2SUMO('11029454-n',[ ('Man',instance)]).
nounMapping2SUMO('11029637-n',[ ('Man',instance)]).
nounMapping2SUMO('11029888-n',[ ('Man',instance)]).
nounMapping2SUMO('11030025-n',[ ('Man',instance)]).
nounMapping2SUMO('11030260-n',[ ('Man',instance)]).
nounMapping2SUMO('11030395-n',[ ('Man',instance)]).
nounMapping2SUMO('11030679-n',[ ('Writer',instance)]).
nounMapping2SUMO('11030855-n',[ ('Man',instance)]).
nounMapping2SUMO('11031016-n',[ ('Man',instance)]).
nounMapping2SUMO('11031257-n',[ ('Writer',instance)]).
nounMapping2SUMO('11031420-n',[ ('Man',instance)]).
nounMapping2SUMO('11031668-n',[ ('Man',instance)]).
nounMapping2SUMO('11031842-n',[ ('Man',instance)]).
nounMapping2SUMO('11031995-n',[ ('Man',instance)]).
nounMapping2SUMO('11032158-n',[ ('Man',instance)]).
nounMapping2SUMO('11032359-n',[ ('Man',instance)]).
nounMapping2SUMO('11032541-n',[ ('Man',instance)]).
nounMapping2SUMO('11032700-n',[ ('Man',instance)]).
nounMapping2SUMO('11032840-n',[ ('Writer',instance)]).
nounMapping2SUMO('11033003-n',[ ('Man',instance)]).
nounMapping2SUMO('11033159-n',[ ('Man',instance)]).
nounMapping2SUMO('11033358-n',[ ('Man',instance)]).
nounMapping2SUMO('11033631-n',[ ('Man',instance)]).
nounMapping2SUMO('11033870-n',[ ('Writer',instance)]).
nounMapping2SUMO('11033992-n',[ ('Man',instance)]).
nounMapping2SUMO('11034167-n',[ ('Man',instance)]).
nounMapping2SUMO('11034307-n',[ ('Man',instance)]).
nounMapping2SUMO('11034485-n',[ ('Woman',instance)]).
nounMapping2SUMO('11034596-n',[ ('Man',instance)]).
nounMapping2SUMO('11034874-n',[ ('Man',instance)]).
nounMapping2SUMO('11035017-n',[ ('Man',instance)]).
nounMapping2SUMO('11035132-n',[ ('Man',instance)]).
nounMapping2SUMO('11035363-n',[ ('Man',instance)]).
nounMapping2SUMO('11035618-n',[ ('Writer',instance)]).
nounMapping2SUMO('11035780-n',[ ('Man',instance)]).
nounMapping2SUMO('11035957-n',[ ('Man',instance)]).
nounMapping2SUMO('11036140-n',[ ('Man',instance)]).
nounMapping2SUMO('11036405-n',[ ('Woman',instance)]).
nounMapping2SUMO('11036521-n',[ ('Man',instance)]).
nounMapping2SUMO('11036668-n',[ ('Man',instance)]).
nounMapping2SUMO('11036911-n',[ ('Man',instance)]).
nounMapping2SUMO('11037157-n',[ ('Man',instance)]).
nounMapping2SUMO('11037278-n',[ ('Man',instance)]).
nounMapping2SUMO('11037495-n',[ ('Man',instance)]).
nounMapping2SUMO('11037836-n',[ ('Man',instance)]).
nounMapping2SUMO('11037966-n',[ ('Writer',instance)]).
nounMapping2SUMO('11038084-n',[ ('Man',instance)]).
nounMapping2SUMO('11038293-n',[ ('Man',instance)]).
nounMapping2SUMO('11038505-n',[ ('Writer',instance)]).
nounMapping2SUMO('11038657-n',[ ('Man',instance)]).
nounMapping2SUMO('11038810-n',[ ('Man',instance)]).
nounMapping2SUMO('11038978-n',[ ('Man',instance)]).
nounMapping2SUMO('11039188-n',[ ('Woman',instance)]).
nounMapping2SUMO('11039344-n',[ ('Man',instance)]).
nounMapping2SUMO('11039577-n',[ ('Woman',instance)]).
nounMapping2SUMO('11039690-n',[ ('Man',instance)]).
nounMapping2SUMO('11039860-n',[ ('Writer',instance)]).
nounMapping2SUMO('11040024-n',[ ('Man',instance)]).
nounMapping2SUMO('11040240-n',[ ('Man',instance)]).
nounMapping2SUMO('11040381-n',[ ('Man',instance)]).
nounMapping2SUMO('11040596-n',[ ('Man',instance)]).
nounMapping2SUMO('11040800-n',[ ('Man',instance)]).
nounMapping2SUMO('11040985-n',[ ('Man',instance)]).
nounMapping2SUMO('11041236-n',[ ('Man',instance)]).
nounMapping2SUMO('11041447-n',[ ('Man',instance)]).
nounMapping2SUMO('11041660-n',[ ('Man',instance)]).
nounMapping2SUMO('11041814-n',[ ('Man',instance)]).
nounMapping2SUMO('11042036-n',[ ('Man',instance)]).
nounMapping2SUMO('11042165-n',[ ('Man',instance)]).
nounMapping2SUMO('11042482-n',[ ('Man',instance)]).
nounMapping2SUMO('11042691-n',[ ('Man',instance)]).
nounMapping2SUMO('11043040-n',[ ('Man',instance)]).
nounMapping2SUMO('11043389-n',[ ('Man',instance)]).
nounMapping2SUMO('11043519-n',[ ('Man',instance)]).
nounMapping2SUMO('11043836-n',[ ('Man',instance)]).
nounMapping2SUMO('11043980-n',[ ('Woman',instance)]).
nounMapping2SUMO('11044168-n',[ ('Woman',instance)]).
nounMapping2SUMO('11044295-n',[ ('Man',instance)]).
nounMapping2SUMO('11044517-n',[ ('Man',instance)]).
nounMapping2SUMO('11044629-n',[ ('Man',instance)]).
nounMapping2SUMO('11044789-n',[ ('Man',instance)]).
nounMapping2SUMO('11044939-n',[ ('Man',instance)]).
nounMapping2SUMO('11045106-n',[ ('Man',instance)]).
nounMapping2SUMO('11045353-n',[ ('Man',instance)]).
nounMapping2SUMO('11045569-n',[ ('Man',instance)]).
nounMapping2SUMO('11045796-n',[ ('Man',instance)]).
nounMapping2SUMO('11045898-n',[ ('Man',instance)]).
nounMapping2SUMO('11046169-n',[ ('Man',instance)]).
nounMapping2SUMO('11046457-n',[ ('Man',instance)]).
nounMapping2SUMO('11046722-n',[ ('Man',instance)]).
nounMapping2SUMO('11046934-n',[ ('Man',instance)]).
nounMapping2SUMO('11047139-n',[ ('Man',instance)]).
nounMapping2SUMO('11047333-n',[ ('Man',instance)]).
nounMapping2SUMO('11047521-n',[ ('Man',instance)]).
nounMapping2SUMO('11047701-n',[ ('Man',instance)]).
nounMapping2SUMO('11047961-n',[ ('Man',instance)]).
nounMapping2SUMO('11048109-n',[ ('Woman',instance)]).
nounMapping2SUMO('11048205-n',[ ('Writer',instance)]).
nounMapping2SUMO('11048389-n',[ ('Man',instance)]).
nounMapping2SUMO('11048586-n',[ ('Man',instance)]).
nounMapping2SUMO('11048739-n',[ ('Man',instance)]).
nounMapping2SUMO('11048879-n',[ ('Writer',instance)]).
nounMapping2SUMO('11049001-n',[ ('Writer',instance)]).
nounMapping2SUMO('11049128-n',[ ('Man',instance)]).
nounMapping2SUMO('11049278-n',[ ('Man',instance)]).
nounMapping2SUMO('11049443-n',[ ('Man',instance)]).
nounMapping2SUMO('11049608-n',[ ('Writer',instance)]).
nounMapping2SUMO('11049835-n',[ ('Man',instance)]).
nounMapping2SUMO('11049938-n',[ ('Man',instance)]).
nounMapping2SUMO('11050057-n',[ ('Man',instance)]).
nounMapping2SUMO('11050183-n',[ ('Man',instance)]).
nounMapping2SUMO('11050436-n',[ ('Cleric',instance)]).
nounMapping2SUMO('11050537-n',[ ('Man',instance)]).
nounMapping2SUMO('11050723-n',[ ('Man',instance)]).
nounMapping2SUMO('11050870-n',[ ('Man',instance)]).
nounMapping2SUMO('11051070-n',[ ('Man',instance)]).
nounMapping2SUMO('11051376-n',[ ('Man',instance)]).
nounMapping2SUMO('11051632-n',[ ('MedicalDoctor',instance)]).
nounMapping2SUMO('11051822-n',[ ('Man',instance)]).
nounMapping2SUMO('11052043-n',[ ('Man',instance)]).
nounMapping2SUMO('11052186-n',[ ('Man',instance)]).
nounMapping2SUMO('11052299-n',[ ('Man',instance)]).
nounMapping2SUMO('11052498-n',[ ('Man',instance)]).
nounMapping2SUMO('11052672-n',[ ('Man',instance)]).
nounMapping2SUMO('11052843-n',[ ('Man',instance)]).
nounMapping2SUMO('11052955-n',[ ('Man',instance)]).
nounMapping2SUMO('11053218-n',[ ('Man',instance)]).
nounMapping2SUMO('11053344-n',[ ('Man',instance)]).
nounMapping2SUMO('11053559-n',[ ('Man',instance)]).
nounMapping2SUMO('11053817-n',[ ('Woman',instance)]).
nounMapping2SUMO('11054034-n',[ ('Man',instance)]).
nounMapping2SUMO('11054173-n',[ ('Man',instance)]).
nounMapping2SUMO('11054442-n',[ ('Man',instance)]).
nounMapping2SUMO('11054563-n',[ ('Woman',instance)]).
nounMapping2SUMO('11054670-n',[ ('Writer',instance)]).
nounMapping2SUMO('11054856-n',[ ('Man',instance)]).
nounMapping2SUMO('11055042-n',[ ('Man',instance)]).
nounMapping2SUMO('11055154-n',[ ('Man',instance)]).
nounMapping2SUMO('11055296-n',[ ('Man',instance)]).
nounMapping2SUMO('11055454-n',[ ('Man',instance)]).
nounMapping2SUMO('11055612-n',[ ('Man',instance)]).
nounMapping2SUMO('11055807-n',[ ('Writer',instance)]).
nounMapping2SUMO('11055915-n',[ ('Man',instance)]).
nounMapping2SUMO('11056060-n',[ ('Man',instance)]).
nounMapping2SUMO('11056195-n',[ ('Man',instance)]).
nounMapping2SUMO('11056466-n',[ ('Man',instance)]).
nounMapping2SUMO('11056654-n',[ ('Man',instance)]).
nounMapping2SUMO('11056799-n',[ ('Man',instance)]).
nounMapping2SUMO('11056947-n',[ ('Writer',instance)]).
nounMapping2SUMO('11057076-n',[ ('Man',instance)]).
nounMapping2SUMO('11057221-n',[ ('Man',instance)]).
nounMapping2SUMO('11057381-n',[ ('Man',instance)]).
nounMapping2SUMO('11057548-n',[ ('Man',instance)]).
nounMapping2SUMO('11057679-n',[ ('Man',instance)]).
nounMapping2SUMO('11057925-n',[ ('Man',instance)]).
nounMapping2SUMO('11058335-n',[ ('Man',instance)]).
nounMapping2SUMO('11058436-n',[ ('Man',instance)]).
nounMapping2SUMO('11058633-n',[ ('Man',instance)]).
nounMapping2SUMO('11058914-n',[ ('Man',instance)]).
nounMapping2SUMO('11059079-n',[ ('Man',instance)]).
nounMapping2SUMO('11059263-n',[ ('Man',instance)]).
nounMapping2SUMO('11059438-n',[ ('Man',instance)]).
nounMapping2SUMO('11059593-n',[ ('Man',instance)]).
nounMapping2SUMO('11059772-n',[ ('Man',instance)]).
nounMapping2SUMO('11059875-n',[ ('Man',instance)]).
nounMapping2SUMO('11060103-n',[ ('Woman',instance)]).
nounMapping2SUMO('11060241-n',[ ('Man',instance)]).
nounMapping2SUMO('11060416-n',[ ('Man',instance)]).
nounMapping2SUMO('11060535-n',[ ('Musician',instance)]).
nounMapping2SUMO('11060688-n',[ ('Woman',instance)]).
nounMapping2SUMO('11060805-n',[ ('Woman',instance)]).
nounMapping2SUMO('11060937-n',[ ('Man',instance)]).
nounMapping2SUMO('11061089-n',[ ('Man',instance)]).
nounMapping2SUMO('11061225-n',[ ('Man',instance)]).
nounMapping2SUMO('11061317-n',[ ('Man',instance)]).
nounMapping2SUMO('11061552-n',[ ('Man',instance)]).
nounMapping2SUMO('11061734-n',[ ('Man',instance)]).
nounMapping2SUMO('11061853-n',[ ('Man',instance)]).
nounMapping2SUMO('11062111-n',[ ('Woman',instance)]).
nounMapping2SUMO('11062285-n',[ ('Man',instance)]).
nounMapping2SUMO('11062424-n',[ ('Man',instance)]).
nounMapping2SUMO('11062649-n',[ ('Woman',instance)]).
nounMapping2SUMO('11062801-n',[ ('Man',instance)]).
nounMapping2SUMO('11062963-n',[ ('Man',instance)]).
nounMapping2SUMO('11063061-n',[ ('Writer',instance)]).
nounMapping2SUMO('11063182-n',[ ('Writer',instance)]).
nounMapping2SUMO('11063309-n',[ ('Man',instance)]).
nounMapping2SUMO('11063535-n',[ ('Writer',instance)]).
nounMapping2SUMO('11063687-n',[ ('Man',instance)]).
nounMapping2SUMO('11063944-n',[ ('Man',instance)]).
nounMapping2SUMO('11064106-n',[ ('Man',instance)]).
nounMapping2SUMO('11064330-n',[ ('Man',instance)]).
nounMapping2SUMO('11064472-n',[ ('Man',instance)]).
nounMapping2SUMO('11064662-n',[ ('Man',instance)]).
nounMapping2SUMO('11064834-n',[ ('Man',instance)]).
nounMapping2SUMO('11065101-n',[ ('Writer',instance)]).
nounMapping2SUMO('11065229-n',[ ('Man',instance)]).
nounMapping2SUMO('11065345-n',[ ('Man',instance)]).
nounMapping2SUMO('11065562-n',[ ('Man',instance)]).
nounMapping2SUMO('11065718-n',[ ('Man',instance)]).
nounMapping2SUMO('11065938-n',[ ('Man',instance)]).
nounMapping2SUMO('11066209-n',[ ('Man',instance)]).
nounMapping2SUMO('11066425-n',[ ('Man',instance)]).
nounMapping2SUMO('11066621-n',[ ('Man',instance)]).
nounMapping2SUMO('11066772-n',[ ('Writer',instance)]).
nounMapping2SUMO('11066938-n',[ ('Man',instance)]).
nounMapping2SUMO('11067047-n',[ ('Man',instance)]).
nounMapping2SUMO('11067184-n',[ ('Man',instance)]).
nounMapping2SUMO('11067396-n',[ ('Man',instance)]).
nounMapping2SUMO('11067604-n',[ ('Man',instance)]).
nounMapping2SUMO('11067745-n',[ ('Man',instance)]).
nounMapping2SUMO('11067885-n',[ ('Man',instance)]).
nounMapping2SUMO('11068196-n',[ ('Man',instance)]).
nounMapping2SUMO('11068401-n',[ ('Man',instance)]).
nounMapping2SUMO('11068630-n',[ ('Man',instance)]).
nounMapping2SUMO('11068760-n',[ ('Man',instance)]).
nounMapping2SUMO('11068922-n',[ ('Man',instance)]).
nounMapping2SUMO('11069085-n',[ ('Woman',instance)]).
nounMapping2SUMO('11069261-n',[ ('Man',instance)]).
nounMapping2SUMO('11069430-n',[ ('Man',instance)]).
nounMapping2SUMO('11069534-n',[ ('Man',instance)]).
nounMapping2SUMO('11069746-n',[ ('Writer',instance)]).
nounMapping2SUMO('11069974-n',[ ('Man',instance)]).
nounMapping2SUMO('11070218-n',[ ('Man',instance)]).
nounMapping2SUMO('11070387-n',[ ('Woman',instance)]).
nounMapping2SUMO('11070531-n',[ ('Man',instance)]).
nounMapping2SUMO('11070644-n',[ ('Writer',instance)]).
nounMapping2SUMO('11070855-n',[ ('Man',instance)]).
nounMapping2SUMO('11070994-n',[ ('Man',instance)]).
nounMapping2SUMO('11071177-n',[ ('Man',instance)]).
nounMapping2SUMO('11071467-n',[ ('Man',instance)]).
nounMapping2SUMO('11071574-n',[ ('Man',instance)]).
nounMapping2SUMO('11071677-n',[ ('Man',instance)]).
nounMapping2SUMO('11071838-n',[ ('Man',instance)]).
nounMapping2SUMO('11071960-n',[ ('Man',instance)]).
nounMapping2SUMO('11072189-n',[ ('Pope',instance)]).
nounMapping2SUMO('11072396-n',[ ('Pope',instance)]).
nounMapping2SUMO('11072673-n',[ ('Pope',instance)]).
nounMapping2SUMO('11072887-n',[ ('Man',instance)]).
nounMapping2SUMO('11073061-n',[ ('Writer',instance)]).
nounMapping2SUMO('11073324-n',[ ('Writer',instance)]).
nounMapping2SUMO('11073453-n',[ ('Writer',instance)]).
nounMapping2SUMO('11073586-n',[ ('Man',instance)]).
nounMapping2SUMO('11073795-n',[ ('Woman',instance)]).
nounMapping2SUMO('11074140-n',[ ('Man',instance)]).
nounMapping2SUMO('11074284-n',[ ('Writer',instance)]).
nounMapping2SUMO('11074573-n',[ ('Man',instance)]).
nounMapping2SUMO('11074769-n',[ ('Man',instance)]).
nounMapping2SUMO('11074870-n',[ ('Man',instance)]).
nounMapping2SUMO('11075021-n',[ ('Man',instance)]).
nounMapping2SUMO('11075219-n',[ ('Man',instance)]).
nounMapping2SUMO('11075352-n',[ ('Man',instance)]).
nounMapping2SUMO('11075452-n',[ ('Man',instance)]).
nounMapping2SUMO('11075670-n',[ ('Man',instance)]).
nounMapping2SUMO('11075823-n',[ ('Man',instance)]).
nounMapping2SUMO('11076079-n',[ ('Man',instance)]).
nounMapping2SUMO('11076359-n',[ ('Writer',instance)]).
nounMapping2SUMO('11076566-n',[ ('Man',instance)]).
nounMapping2SUMO('11076820-n',[ ('Man',instance)]).
nounMapping2SUMO('11076965-n',[ ('Man',instance)]).
nounMapping2SUMO('11077195-n',[ ('Woman',instance)]).
nounMapping2SUMO('11077369-n',[ ('Man',instance)]).
nounMapping2SUMO('11077484-n',[ ('Man',instance)]).
nounMapping2SUMO('11077649-n',[ ('Man',instance)]).
nounMapping2SUMO('11077762-n',[ ('Man',instance)]).
nounMapping2SUMO('11077927-n',[ ('Writer',instance)]).
nounMapping2SUMO('11078059-n',[ ('Writer',instance)]).
nounMapping2SUMO('11078203-n',[ ('Man',instance)]).
nounMapping2SUMO('11078404-n',[ ('Man',instance)]).
nounMapping2SUMO('11078650-n',[ ('Man',instance)]).
nounMapping2SUMO('11078774-n',[ ('Man',instance)]).
nounMapping2SUMO('11078982-n',[ ('Writer',instance)]).
nounMapping2SUMO('11079252-n',[ ('Writer',instance)]).
nounMapping2SUMO('11079392-n',[ ('Man',instance)]).
nounMapping2SUMO('11079544-n',[ ('Man',instance)]).
nounMapping2SUMO('11079802-n',[ ('Man',instance)]).
nounMapping2SUMO('11080174-n',[ ('Man',instance)]).
nounMapping2SUMO('11080351-n',[ ('Man',instance)]).
nounMapping2SUMO('11080601-n',[ ('Man',instance)]).
nounMapping2SUMO('11080745-n',[ ('Man',instance)]).
nounMapping2SUMO('11080884-n',[ ('Man',instance)]).
nounMapping2SUMO('11080987-n',[ ('Man',instance)]).
nounMapping2SUMO('11081111-n',[ ('Man',instance)]).
nounMapping2SUMO('11081353-n',[ ('Woman',instance)]).
nounMapping2SUMO('11081673-n',[ ('Man',instance)]).
nounMapping2SUMO('11081828-n',[ ('Man',instance)]).
nounMapping2SUMO('11082135-n',[ ('Man',instance)]).
nounMapping2SUMO('11082353-n',[ ('Man',instance)]).
nounMapping2SUMO('11082535-n',[ ('Writer',instance)]).
nounMapping2SUMO('11082652-n',[ ('Man',instance)]).
nounMapping2SUMO('11082842-n',[ ('Man',instance)]).
nounMapping2SUMO('11083064-n',[ ('Man',instance)]).
nounMapping2SUMO('11083527-n',[ ('Man',instance)]).
nounMapping2SUMO('11083656-n',[ ('Man',instance)]).
nounMapping2SUMO('11084110-n',[ ('Man',instance)]).
nounMapping2SUMO('11084200-n',[ ('Man',instance)]).
nounMapping2SUMO('11084409-n',[ ('Man',instance)]).
nounMapping2SUMO('11084514-n',[ ('Woman',instance)]).
nounMapping2SUMO('11084789-n',[ ('Man',instance)]).
nounMapping2SUMO('11084895-n',[ ('Man',instance)]).
nounMapping2SUMO('11085113-n',[ ('Man',instance)]).
nounMapping2SUMO('11085267-n',[ ('Man',instance)]).
nounMapping2SUMO('11085402-n',[ ('Man',instance)]).
nounMapping2SUMO('11085559-n',[ ('Man',instance)]).
nounMapping2SUMO('11085633-n',[ ('Man',instance)]).
nounMapping2SUMO('11085813-n',[ ('Man',instance)]).
nounMapping2SUMO('11085924-n',[ ('Writer',instance)]).
nounMapping2SUMO('11086279-n',[ ('Man',instance)]).
nounMapping2SUMO('11086607-n',[ ('Pope',instance)]).
nounMapping2SUMO('11086774-n',[ ('Man',instance)]).
nounMapping2SUMO('11087091-n',[ ('Man',instance)]).
nounMapping2SUMO('11087359-n',[ ('Man',instance)]).
nounMapping2SUMO('11087612-n',[ ('Man',instance)]).
nounMapping2SUMO('11087767-n',[ ('Man',instance)]).
nounMapping2SUMO('11087931-n',[ ('Man',instance)]).
nounMapping2SUMO('11088059-n',[ ('Man',instance)]).
nounMapping2SUMO('11088346-n',[ ('Man',instance)]).
nounMapping2SUMO('11088622-n',[ ('Writer',instance)]).
nounMapping2SUMO('11088771-n',[ ('Man',instance)]).
nounMapping2SUMO('11088969-n',[ ('Man',instance)]).
nounMapping2SUMO('11089318-n',[ ('Man',instance)]).
nounMapping2SUMO('11089484-n',[ ('Man',instance)]).
nounMapping2SUMO('11089669-n',[ ('Man',instance)]).
nounMapping2SUMO('11089868-n',[ ('Man',instance)]).
nounMapping2SUMO('11090136-n',[ ('Man',instance)]).
nounMapping2SUMO('11090235-n',[ ('Man',instance)]).
nounMapping2SUMO('11090378-n',[ ('Man',instance)]).
nounMapping2SUMO('11090512-n',[ ('Man',instance)]).
nounMapping2SUMO('11090631-n',[ ('Man',instance)]).
nounMapping2SUMO('11090884-n',[ ('Woman',instance)]).
nounMapping2SUMO('11091084-n',[ ('Writer',instance)]).
nounMapping2SUMO('11091184-n',[ ('Man',instance)]).
nounMapping2SUMO('11091374-n',[ ('Man',instance)]).
nounMapping2SUMO('11091545-n',[ ('Woman',instance)]).
nounMapping2SUMO('11091706-n',[ ('Man',instance)]).
nounMapping2SUMO('11091863-n',[ ('Man',instance)]).
nounMapping2SUMO('11092126-n',[ ('Man',instance)]).
nounMapping2SUMO('11092292-n',[ ('Man',instance)]).
nounMapping2SUMO('11092541-n',[ ('Man',instance)]).
nounMapping2SUMO('11092740-n',[ ('Man',instance)]).
nounMapping2SUMO('11092938-n',[ ('Man',instance)]).
nounMapping2SUMO('11093116-n',[ ('Writer',instance)]).
nounMapping2SUMO('11093325-n',[ ('Man',instance)]).
nounMapping2SUMO('11093469-n',[ ('Man',instance)]).
nounMapping2SUMO('11093674-n',[ ('Man',instance)]).
nounMapping2SUMO('11093848-n',[ ('Man',instance)]).
nounMapping2SUMO('11094055-n',[ ('Man',instance)]).
nounMapping2SUMO('11094312-n',[ ('Leader',instance)]).
nounMapping2SUMO('11094611-n',[ ('Man',instance)]).
nounMapping2SUMO('11094780-n',[ ('Man',instance)]).
nounMapping2SUMO('11094928-n',[ ('Man',instance)]).
nounMapping2SUMO('11095123-n',[ ('Man',instance)]).
nounMapping2SUMO('11095391-n',[ ('Man',instance)]).
nounMapping2SUMO('11095587-n',[ ('Man',instance)]).
nounMapping2SUMO('11095731-n',[ ('Man',instance)]).
nounMapping2SUMO('11095907-n',[ ('Man',instance)]).
nounMapping2SUMO('11096033-n',[ ('Man',instance)]).
nounMapping2SUMO('11096192-n',[ ('Man',instance)]).
nounMapping2SUMO('11096338-n',[ ('Man',instance)]).
nounMapping2SUMO('11096508-n',[ ('Man',instance)]).
nounMapping2SUMO('11096645-n',[ ('Man',instance)]).
nounMapping2SUMO('11096801-n',[ ('Man',instance)]).
nounMapping2SUMO('11096991-n',[ ('Man',instance)]).
nounMapping2SUMO('11097208-n',[ ('Man',instance)]).
nounMapping2SUMO('11097335-n',[ ('Man',instance)]).
nounMapping2SUMO('11097525-n',[ ('Man',instance)]).
nounMapping2SUMO('11097625-n',[ ('Writer',instance)]).
nounMapping2SUMO('11097820-n',[ ('Man',instance)]).
nounMapping2SUMO('11098039-n',[ ('Man',instance)]).
nounMapping2SUMO('11098223-n',[ ('Man',instance)]).
nounMapping2SUMO('11098380-n',[ ('Man',instance)]).
nounMapping2SUMO('11098601-n',[ ('Man',instance)]).
nounMapping2SUMO('11098707-n',[ ('Man',instance)]).
nounMapping2SUMO('11098876-n',[ ('Man',instance)]).
nounMapping2SUMO('11099085-n',[ ('Writer',instance)]).
nounMapping2SUMO('11099438-n',[ ('Man',instance)]).
nounMapping2SUMO('11099729-n',[ ('Man',instance)]).
nounMapping2SUMO('11099923-n',[ ('Man',instance)]).
nounMapping2SUMO('11100139-n',[ ('Man',instance)]).
nounMapping2SUMO('11100260-n',[ ('Man',instance)]).
nounMapping2SUMO('11100462-n',[ ('Man',instance)]).
nounMapping2SUMO('11100619-n',[ ('Man',instance)]).
nounMapping2SUMO('11100798-n',[ ('Man',instance)]).
nounMapping2SUMO('11101000-n',[ ('Man',instance)]).
nounMapping2SUMO('11101250-n',[ ('Man',instance)]).
nounMapping2SUMO('11101576-n',[ ('Man',instance)]).
nounMapping2SUMO('11101700-n',[ ('Man',instance)]).
nounMapping2SUMO('11101843-n',[ ('Man',instance)]).
nounMapping2SUMO('11101986-n',[ ('Man',instance)]).
nounMapping2SUMO('11102144-n',[ ('Man',instance)]).
nounMapping2SUMO('11102353-n',[ ('Man',instance)]).
nounMapping2SUMO('11102493-n',[ ('Writer',instance)]).
nounMapping2SUMO('11102674-n',[ ('Writer',instance)]).
nounMapping2SUMO('11102878-n',[ ('Man',instance)]).
nounMapping2SUMO('11103104-n',[ ('Man',instance)]).
nounMapping2SUMO('11103397-n',[ ('Man',instance)]).
nounMapping2SUMO('11103648-n',[ ('Man',instance)]).
nounMapping2SUMO('11103864-n',[ ('Man',instance)]).
nounMapping2SUMO('11104008-n',[ ('Man',instance)]).
nounMapping2SUMO('11104287-n',[ ('Man',instance)]).
nounMapping2SUMO('11104458-n',[ ('Man',instance)]).
nounMapping2SUMO('11104676-n',[ ('Man',instance)]).
nounMapping2SUMO('11104896-n',[ ('Man',instance)]).
nounMapping2SUMO('11105054-n',[ ('Man',instance)]).
nounMapping2SUMO('11105298-n',[ ('Man',instance)]).
nounMapping2SUMO('11105463-n',[ ('Man',instance)]).
nounMapping2SUMO('11105609-n',[ ('Man',instance)]).
nounMapping2SUMO('11105778-n',[ ('Writer',instance)]).
nounMapping2SUMO('11105945-n',[ ('Man',instance)]).
nounMapping2SUMO('11106170-n',[ ('Man',instance)]).
nounMapping2SUMO('11106290-n',[ ('Man',instance)]).
nounMapping2SUMO('11106479-n',[ ('Man',instance)]).
nounMapping2SUMO('11106652-n',[ ('Man',instance)]).
nounMapping2SUMO('11106830-n',[ ('Man',instance)]).
nounMapping2SUMO('11106943-n',[ ('Man',instance)]).
nounMapping2SUMO('11107110-n',[ ('Woman',instance)]).
nounMapping2SUMO('11107308-n',[ ('Man',instance)]).
nounMapping2SUMO('11107436-n',[ ('Man',instance)]).
nounMapping2SUMO('11107635-n',[ ('Man',instance)]).
nounMapping2SUMO('11107757-n',[ ('Man',instance)]).
nounMapping2SUMO('11107901-n',[ ('Man',instance)]).
nounMapping2SUMO('11108084-n',[ ('Man',instance)]).
nounMapping2SUMO('11108195-n',[ ('Man',instance)]).
nounMapping2SUMO('11108400-n',[ ('Man',instance)]).
nounMapping2SUMO('11108584-n',[ ('Writer',instance)]).
nounMapping2SUMO('11108767-n',[ ('Man',instance)]).
nounMapping2SUMO('11109027-n',[ ('Man',instance)]).
nounMapping2SUMO('11109192-n',[ ('Woman',instance)]).
nounMapping2SUMO('11109289-n',[ ('Man',instance)]).
nounMapping2SUMO('11109424-n',[ ('Man',instance)]).
nounMapping2SUMO('11109563-n',[ ('Man',instance)]).
nounMapping2SUMO('11109728-n',[ ('Man',instance)]).
nounMapping2SUMO('11109970-n',[ ('Man',instance)]).
nounMapping2SUMO('11110205-n',[ ('Man',instance)]).
nounMapping2SUMO('11110396-n',[ ('Man',instance)]).
nounMapping2SUMO('11110617-n',[ ('Man',instance)]).
nounMapping2SUMO('11110791-n',[ ('Man',instance)]).
nounMapping2SUMO('11110917-n',[ ('Man',instance)]).
nounMapping2SUMO('11111085-n',[ ('Man',instance)]).
nounMapping2SUMO('11111194-n',[ ('Man',instance)]).
nounMapping2SUMO('11111335-n',[ ('Man',instance)]).
nounMapping2SUMO('11111577-n',[ ('Man',instance)]).
nounMapping2SUMO('11111710-n',[ ('Man',instance)]).
nounMapping2SUMO('11111845-n',[ ('Man',instance)]).
nounMapping2SUMO('11112058-n',[ ('Man',instance)]).
nounMapping2SUMO('11112377-n',[ ('Man',instance)]).
nounMapping2SUMO('11112488-n',[ ('Man',instance)]).
nounMapping2SUMO('11112628-n',[ ('Position',instance)]).
nounMapping2SUMO('11112907-n',[ ('Man',instance)]).
nounMapping2SUMO('11113077-n',[ ('Man',instance)]).
nounMapping2SUMO('11113266-n',[ ('Man',instance)]).
nounMapping2SUMO('11113489-n',[ ('Man',instance)]).
nounMapping2SUMO('11113601-n',[ ('Man',instance)]).
nounMapping2SUMO('11113732-n',[ ('Man',instance)]).
nounMapping2SUMO('11113898-n',[ ('Man',instance)]).
nounMapping2SUMO('11114056-n',[ ('Man',instance)]).
nounMapping2SUMO('11114285-n',[ ('Man',instance)]).
nounMapping2SUMO('11114423-n',[ ('Man',instance)]).
nounMapping2SUMO('11114637-n',[ ('Writer',instance)]).
nounMapping2SUMO('11114791-n',[ ('Man',instance)]).
nounMapping2SUMO('11115029-n',[ ('Man',instance)]).
nounMapping2SUMO('11115131-n',[ ('Man',instance)]).
nounMapping2SUMO('11115293-n',[ ('Man',instance)]).
nounMapping2SUMO('11115558-n',[ ('Man',instance)]).
nounMapping2SUMO('11115785-n',[ ('Man',instance)]).
nounMapping2SUMO('11115929-n',[ ('Man',instance)]).
nounMapping2SUMO('11116117-n',[ ('Man',instance)]).
nounMapping2SUMO('11116284-n',[ ('Woman',instance)]).
nounMapping2SUMO('11116466-n',[ ('Woman',instance)]).
nounMapping2SUMO('11116642-n',[ ('Man',instance)]).
nounMapping2SUMO('11116875-n',[ ('Man',instance)]).
nounMapping2SUMO('11117108-n',[ ('Woman',instance)]).
nounMapping2SUMO('11117307-n',[ ('Man',instance)]).
nounMapping2SUMO('11117451-n',[ ('Man',instance)]).
nounMapping2SUMO('11117744-n',[ ('Writer',instance)]).
nounMapping2SUMO('11117931-n',[ ('Writer',instance)]).
nounMapping2SUMO('11118072-n',[ ('Man',instance)]).
nounMapping2SUMO('11118205-n',[ ('Man',instance)]).
nounMapping2SUMO('11118362-n',[ ('Man',instance)]).
nounMapping2SUMO('11118481-n',[ ('Man',instance)]).
nounMapping2SUMO('11118602-n',[ ('Man',instance)]).
nounMapping2SUMO('11118886-n',[ ('Man',instance)]).
nounMapping2SUMO('11119061-n',[ ('Man',instance)]).
nounMapping2SUMO('11119190-n',[ ('Man',instance)]).
nounMapping2SUMO('11119476-n',[ ('Man',instance)]).
nounMapping2SUMO('11119634-n',[ ('Man',instance)]).
nounMapping2SUMO('11119917-n',[ ('Man',instance)]).
nounMapping2SUMO('11120146-n',[ ('Man',instance)]).
nounMapping2SUMO('11120368-n',[ ('Man',instance)]).
nounMapping2SUMO('11120530-n',[ ('Man',instance)]).
nounMapping2SUMO('11120633-n',[ ('Man',instance)]).
nounMapping2SUMO('11120834-n',[ ('Man',instance)]).
nounMapping2SUMO('11121108-n',[ ('Man',instance)]).
nounMapping2SUMO('11121451-n',[ ('Man',instance)]).
nounMapping2SUMO('11121640-n',[ ('Man',instance)]).
nounMapping2SUMO('11121876-n',[ ('Woman',instance)]).
nounMapping2SUMO('11122114-n',[ ('Man',instance)]).
nounMapping2SUMO('11122439-n',[ ('Writer',instance)]).
nounMapping2SUMO('11122579-n',[ ('Man',instance)]).
nounMapping2SUMO('11122825-n',[ ('Writer',instance)]).
nounMapping2SUMO('11122977-n',[ ('Man',instance)]).
nounMapping2SUMO('11123124-n',[ ('Man',instance)]).
nounMapping2SUMO('11123262-n',[ ('Man',instance)]).
nounMapping2SUMO('11123439-n',[ ('Man',instance)]).
nounMapping2SUMO('11123590-n',[ ('Man',instance)]).
nounMapping2SUMO('11123762-n',[ ('Man',instance)]).
nounMapping2SUMO('11123894-n',[ ('Man',instance)]).
nounMapping2SUMO('11124088-n',[ ('Man',instance)]).
nounMapping2SUMO('11124300-n',[ ('Man',instance)]).
nounMapping2SUMO('11124472-n',[ ('Woman',instance)]).
nounMapping2SUMO('11124647-n',[ ('Man',instance)]).
nounMapping2SUMO('11124831-n',[ ('Woman',instance)]).
nounMapping2SUMO('11124961-n',[ ('Man',instance)]).
nounMapping2SUMO('11125080-n',[ ('Man',instance)]).
nounMapping2SUMO('11125193-n',[ ('Man',instance)]).
nounMapping2SUMO('11125546-n',[ ('Man',instance)]).
nounMapping2SUMO('11125646-n',[ ('Man',instance)]).
nounMapping2SUMO('11125840-n',[ ('Man',instance)]).
nounMapping2SUMO('11125957-n',[ ('Man',instance)]).
nounMapping2SUMO('11126081-n',[ ('Man',instance)]).
nounMapping2SUMO('11126295-n',[ ('Man',instance)]).
nounMapping2SUMO('11126490-n',[ ('Man',instance)]).
nounMapping2SUMO('11126783-n',[ ('Man',instance)]).
nounMapping2SUMO('11127011-n',[ ('Man',instance)]).
nounMapping2SUMO('11127188-n',[ ('Man',instance)]).
nounMapping2SUMO('11127419-n',[ ('Man',instance)]).
nounMapping2SUMO('11127565-n',[ ('Man',instance)]).
nounMapping2SUMO('11127752-n',[ ('Man',instance)]).
nounMapping2SUMO('11127996-n',[ ('Pope',instance)]).
nounMapping2SUMO('11128236-n',[ ('Writer',instance)]).
nounMapping2SUMO('11128394-n',[ ('Man',instance)]).
nounMapping2SUMO('11128673-n',[ ('Man',instance)]).
nounMapping2SUMO('11128834-n',[ ('Man',instance)]).
nounMapping2SUMO('11129017-n',[ ('Writer',instance)]).
nounMapping2SUMO('11129130-n',[ ('Man',instance)]).
nounMapping2SUMO('11129286-n',[ ('Man',instance)]).
nounMapping2SUMO('11129478-n',[ ('Writer',instance)]).
nounMapping2SUMO('11129665-n',[ ('Man',instance)]).
nounMapping2SUMO('11129808-n',[ ('Man',instance)]).
nounMapping2SUMO('11130113-n',[ ('Man',instance)]).
nounMapping2SUMO('11130291-n',[ ('Writer',instance)]).
nounMapping2SUMO('11130474-n',[ ('Man',instance)]).
nounMapping2SUMO('11130661-n',[ ('Man',instance)]).
nounMapping2SUMO('11130940-n',[ ('Man',instance)]).
nounMapping2SUMO('11131135-n',[ ('Man',instance)]).
nounMapping2SUMO('11131358-n',[ ('Man',instance)]).
nounMapping2SUMO('11131505-n',[ ('Man',instance)]).
nounMapping2SUMO('11131658-n',[ ('Man',instance)]).
nounMapping2SUMO('11131808-n',[ ('Man',instance)]).
nounMapping2SUMO('11131981-n',[ ('Woman',instance)]).
nounMapping2SUMO('11132117-n',[ ('Woman',instance)]).
nounMapping2SUMO('11132245-n',[ ('Woman',instance)]).
nounMapping2SUMO('11132462-n',[ ('Man',instance)]).
nounMapping2SUMO('11132768-n',[ ('Woman',instance)]).
nounMapping2SUMO('11132948-n',[ ('Man',instance)]).
nounMapping2SUMO('11133197-n',[ ('Man',instance)]).
nounMapping2SUMO('11133387-n',[ ('Man',instance)]).
nounMapping2SUMO('11133551-n',[ ('Man',instance)]).
nounMapping2SUMO('11133778-n',[ ('Man',instance)]).
nounMapping2SUMO('11133938-n',[ ('Man',instance)]).
nounMapping2SUMO('11134115-n',[ ('Man',instance)]).
nounMapping2SUMO('11134196-n',[ ('Man',instance)]).
nounMapping2SUMO('11134339-n',[ ('Man',instance)]).
nounMapping2SUMO('11134466-n',[ ('Man',instance)]).
nounMapping2SUMO('11134620-n',[ ('Man',instance)]).
nounMapping2SUMO('11134730-n',[ ('Man',instance)]).
nounMapping2SUMO('11134895-n',[ ('Man',instance)]).
nounMapping2SUMO('11135044-n',[ ('Man',instance)]).
nounMapping2SUMO('11135236-n',[ ('Man',instance)]).
nounMapping2SUMO('11135371-n',[ ('Man',instance)]).
nounMapping2SUMO('11135488-n',[ ('Woman',instance)]).
nounMapping2SUMO('11135610-n',[ ('Man',instance)]).
nounMapping2SUMO('11135797-n',[ ('Man',instance)]).
nounMapping2SUMO('11135991-n',[ ('Man',instance)]).
nounMapping2SUMO('11136214-n',[ ('Man',instance)]).
nounMapping2SUMO('11136405-n',[ ('Man',instance)]).
nounMapping2SUMO('11136622-n',[ ('Man',instance)]).
nounMapping2SUMO('11136798-n',[ ('Man',instance)]).
nounMapping2SUMO('11136973-n',[ ('Man',instance)]).
nounMapping2SUMO('11137175-n',[ ('Man',instance)]).
nounMapping2SUMO('11137334-n',[ ('Man',instance)]).
nounMapping2SUMO('11137506-n',[ ('Man',instance)]).
nounMapping2SUMO('11137748-n',[ ('Writer',instance)]).
nounMapping2SUMO('11137928-n',[ ('Man',instance)]).
nounMapping2SUMO('11138085-n',[ ('Man',instance)]).
nounMapping2SUMO('11138180-n',[ ('Woman',instance)]).
nounMapping2SUMO('11138301-n',[ ('Man',instance)]).
nounMapping2SUMO('11138449-n',[ ('Man',instance)]).
nounMapping2SUMO('11138681-n',[ ('Man',instance)]).
nounMapping2SUMO('11138924-n',[ ('Man',instance)]).
nounMapping2SUMO('11139092-n',[ ('Man',instance)]).
nounMapping2SUMO('11139253-n',[ ('Man',instance)]).
nounMapping2SUMO('11139403-n',[ ('Man',instance)]).
nounMapping2SUMO('11139520-n',[ ('Man',instance)]).
nounMapping2SUMO('11139619-n',[ ('Man',instance)]).
nounMapping2SUMO('11139739-n',[ ('Man',instance)]).
nounMapping2SUMO('11139927-n',[ ('Man',instance)]).
nounMapping2SUMO('11140100-n',[ ('Man',instance)]).
nounMapping2SUMO('11140243-n',[ ('Man',instance)]).
nounMapping2SUMO('11140461-n',[ ('Man',instance)]).
nounMapping2SUMO('11140582-n',[ ('Man',instance)]).
nounMapping2SUMO('11140745-n',[ ('Man',instance)]).
nounMapping2SUMO('11140862-n',[ ('Man',instance)]).
nounMapping2SUMO('11141019-n',[ ('Man',instance)]).
nounMapping2SUMO('11141289-n',[ ('Man',instance)]).
nounMapping2SUMO('11141495-n',[ ('Man',instance)]).
nounMapping2SUMO('11141709-n',[ ('Man',instance)]).
nounMapping2SUMO('11141882-n',[ ('Man',instance)]).
nounMapping2SUMO('11141981-n',[ ('Man',instance)]).
nounMapping2SUMO('11142155-n',[ ('Man',instance)]).
nounMapping2SUMO('11142368-n',[ ('Man',instance)]).
nounMapping2SUMO('11142517-n',[ ('Woman',instance)]).
nounMapping2SUMO('11142614-n',[ ('Man',instance)]).
nounMapping2SUMO('11142788-n',[ ('Man',instance)]).
nounMapping2SUMO('11142922-n',[ ('Man',instance)]).
nounMapping2SUMO('11143044-n',[ ('Man',instance)]).
nounMapping2SUMO('11143163-n',[ ('Man',instance)]).
nounMapping2SUMO('11143331-n',[ ('Man',instance)]).
nounMapping2SUMO('11143458-n',[ ('Man',instance)]).
nounMapping2SUMO('11143600-n',[ ('Man',instance)]).
nounMapping2SUMO('11143806-n',[ ('Man',instance)]).
nounMapping2SUMO('11143933-n',[ ('Man',instance)]).
nounMapping2SUMO('11144068-n',[ ('Man',instance)]).
nounMapping2SUMO('11144291-n',[ ('Man',instance)]).
nounMapping2SUMO('11144431-n',[ ('Man',instance)]).
nounMapping2SUMO('11144604-n',[ ('Writer',instance)]).
nounMapping2SUMO('11144860-n',[ ('Man',instance)]).
nounMapping2SUMO('11145085-n',[ ('Man',instance)]).
nounMapping2SUMO('11145199-n',[ ('Man',instance)]).
nounMapping2SUMO('11145364-n',[ ('Man',instance)]).
nounMapping2SUMO('11145563-n',[ ('Man',instance)]).
nounMapping2SUMO('11145730-n',[ ('Writer',instance)]).
nounMapping2SUMO('11145850-n',[ ('Man',instance)]).
nounMapping2SUMO('11146010-n',[ ('Man',instance)]).
nounMapping2SUMO('11146193-n',[ ('Man',instance)]).
nounMapping2SUMO('11146407-n',[ ('Man',instance)]).
nounMapping2SUMO('11146494-n',[ ('Writer',instance)]).
nounMapping2SUMO('11146670-n',[ ('Man',instance)]).
nounMapping2SUMO('11146914-n',[ ('Man',instance)]).
nounMapping2SUMO('11147099-n',[ ('Man',instance)]).
nounMapping2SUMO('11147185-n',[ ('Man',instance)]).
nounMapping2SUMO('11147348-n',[ ('Man',instance)]).
nounMapping2SUMO('11147533-n',[ ('Man',instance)]).
nounMapping2SUMO('11147729-n',[ ('Man',instance)]).
nounMapping2SUMO('11147924-n',[ ('Man',instance)]).
nounMapping2SUMO('11148152-n',[ ('Man',instance)]).
nounMapping2SUMO('11148259-n',[ ('Man',instance)]).
nounMapping2SUMO('11148486-n',[ ('Man',instance)]).
nounMapping2SUMO('11148748-n',[ ('Woman',instance)]).
nounMapping2SUMO('11148899-n',[ ('Man',instance)]).
nounMapping2SUMO('11149016-n',[ ('Man',instance)]).
nounMapping2SUMO('11149243-n',[ ('Man',instance)]).
nounMapping2SUMO('11149373-n',[ ('Man',instance)]).
nounMapping2SUMO('11149483-n',[ ('Man',instance)]).
nounMapping2SUMO('11149630-n',[ ('Man',instance)]).
nounMapping2SUMO('11149762-n',[ ('Writer',instance)]).
nounMapping2SUMO('11149867-n',[ ('Man',instance)]).
nounMapping2SUMO('11149995-n',[ ('Man',instance)]).
nounMapping2SUMO('11150224-n',[ ('Man',instance)]).
nounMapping2SUMO('11150471-n',[ ('Man',instance)]).
nounMapping2SUMO('11150634-n',[ ('Man',instance)]).
nounMapping2SUMO('11150809-n',[ ('Man',instance)]).
nounMapping2SUMO('11150973-n',[ ('Man',instance)]).
nounMapping2SUMO('11151084-n',[ ('Writer',instance)]).
nounMapping2SUMO('11151189-n',[ ('Man',instance)]).
nounMapping2SUMO('11151322-n',[ ('Man',instance)]).
nounMapping2SUMO('11151436-n',[ ('Man',instance)]).
nounMapping2SUMO('11151579-n',[ ('Man',instance)]).
nounMapping2SUMO('11151798-n',[ ('Man',instance)]).
nounMapping2SUMO('11151932-n',[ ('Woman',instance)]).
nounMapping2SUMO('11152122-n',[ ('Man',instance)]).
nounMapping2SUMO('11152331-n',[ ('Writer',instance)]).
nounMapping2SUMO('11152544-n',[ ('Man',instance)]).
nounMapping2SUMO('11152758-n',[ ('Man',instance)]).
nounMapping2SUMO('11152856-n',[ ('Man',instance)]).
nounMapping2SUMO('11153094-n',[ ('Man',instance)]).
nounMapping2SUMO('11153200-n',[ ('Man',instance)]).
nounMapping2SUMO('11153456-n',[ ('Man',instance)]).
nounMapping2SUMO('11153615-n',[ ('Man',instance)]).
nounMapping2SUMO('11153783-n',[ ('Man',instance)]).
nounMapping2SUMO('11153887-n',[ ('Man',instance)]).
nounMapping2SUMO('11154023-n',[ ('Writer',instance)]).
nounMapping2SUMO('11154174-n',[ ('Man',instance)]).
nounMapping2SUMO('11154355-n',[ ('Man',instance)]).
nounMapping2SUMO('11154489-n',[ ('Writer',instance)]).
nounMapping2SUMO('11154646-n',[ ('Man',instance)]).
nounMapping2SUMO('11154857-n',[ ('Man',instance)]).
nounMapping2SUMO('11155013-n',[ ('Man',instance)]).
nounMapping2SUMO('11155196-n',[ ('Man',instance)]).
nounMapping2SUMO('11155331-n',[ ('Man',instance)]).
nounMapping2SUMO('11155444-n',[ ('Man',instance)]).
nounMapping2SUMO('11155577-n',[ ('Man',instance)]).
nounMapping2SUMO('11155814-n',[ ('Man',instance)]).
nounMapping2SUMO('11155943-n',[ ('Man',instance)]).
nounMapping2SUMO('11156122-n',[ ('Man',instance)]).
nounMapping2SUMO('11156333-n',[ ('Man',instance)]).
nounMapping2SUMO('11156548-n',[ ('Woman',instance)]).
nounMapping2SUMO('11156812-n',[ ('Man',instance)]).
nounMapping2SUMO('11156943-n',[ ('Writer',instance)]).
nounMapping2SUMO('11157140-n',[ ('Woman',instance)]).
nounMapping2SUMO('11157275-n',[ ('Man',instance)]).
nounMapping2SUMO('11157422-n',[ ('Man',instance)]).
nounMapping2SUMO('11157580-n',[ ('Man',instance)]).
nounMapping2SUMO('11157719-n',[ ('Man',instance)]).
nounMapping2SUMO('11157954-n',[ ('Writer',instance)]).
nounMapping2SUMO('11158156-n',[ ('Man',instance)]).
nounMapping2SUMO('11158364-n',[ ('Man',instance)]).
nounMapping2SUMO('11158533-n',[ ('Writer',instance)]).
nounMapping2SUMO('11158651-n',[ ('Man',instance)]).
nounMapping2SUMO('11158754-n',[ ('Man',instance)]).
nounMapping2SUMO('11158982-n',[ ('Man',instance)]).
nounMapping2SUMO('11159214-n',[ ('Man',instance)]).
nounMapping2SUMO('11159318-n',[ ('Man',instance)]).
nounMapping2SUMO('11159418-n',[ ('Man',instance)]).
nounMapping2SUMO('11159595-n',[ ('Man',instance)]).
nounMapping2SUMO('11159698-n',[ ('Man',instance)]).
nounMapping2SUMO('11159819-n',[ ('Man',instance)]).
nounMapping2SUMO('11159920-n',[ ('Man',instance)]).
nounMapping2SUMO('11160055-n',[ ('Man',instance)]).
nounMapping2SUMO('11160200-n',[ ('Pope',instance)]).
nounMapping2SUMO('11160361-n',[ ('Man',instance)]).
nounMapping2SUMO('11160457-n',[ ('Man',instance)]).
nounMapping2SUMO('11160676-n',[ ('Man',instance)]).
nounMapping2SUMO('11160861-n',[ ('Man',instance)]).
nounMapping2SUMO('11161045-n',[ ('Man',instance)]).
nounMapping2SUMO('11161228-n',[ ('Man',instance)]).
nounMapping2SUMO('11161412-n',[ ('Woman',instance)]).
nounMapping2SUMO('11161664-n',[ ('Woman',instance)]).
nounMapping2SUMO('11162010-n',[ ('Woman',instance)]).
nounMapping2SUMO('11162206-n',[ ('Woman',instance)]).
nounMapping2SUMO('11162582-n',[ ('Woman',instance)]).
nounMapping2SUMO('11162793-n',[ ('Man',instance)]).
nounMapping2SUMO('11162915-n',[ ('Writer',instance)]).
nounMapping2SUMO('11163041-n',[ ('Man',instance)]).
nounMapping2SUMO('11163160-n',[ ('Man',instance)]).
nounMapping2SUMO('11163342-n',[ ('Man',instance)]).
nounMapping2SUMO('11163582-n',[ ('Man',instance)]).
nounMapping2SUMO('11163709-n',[ ('Man',instance)]).
nounMapping2SUMO('11163859-n',[ ('Man',instance)]).
nounMapping2SUMO('11164058-n',[ ('Man',instance)]).
nounMapping2SUMO('11164163-n',[ ('Man',instance)]).
nounMapping2SUMO('11164332-n',[ ('Man',instance)]).
nounMapping2SUMO('11164505-n',[ ('Man',instance)]).
nounMapping2SUMO('11164671-n',[ ('Writer',instance)]).
nounMapping2SUMO('11164970-n',[ ('Writer',instance)]).
nounMapping2SUMO('11165164-n',[ ('Man',instance)]).
nounMapping2SUMO('11165339-n',[ ('Writer',instance)]).
nounMapping2SUMO('11165519-n',[ ('Man',instance)]).
nounMapping2SUMO('11165712-n',[ ('Writer',instance)]).
nounMapping2SUMO('11165854-n',[ ('Man',instance)]).
nounMapping2SUMO('11166060-n',[ ('Man',instance)]).
nounMapping2SUMO('11166251-n',[ ('Leader',instance)]).
nounMapping2SUMO('11166504-n',[ ('Man',instance)]).
nounMapping2SUMO('11166732-n',[ ('Man',instance)]).
nounMapping2SUMO('11166877-n',[ ('Man',instance)]).
nounMapping2SUMO('11167088-n',[ ('Woman',instance)]).
nounMapping2SUMO('11167269-n',[ ('Man',instance)]).
nounMapping2SUMO('11167418-n',[ ('Man',instance)]).
nounMapping2SUMO('11167595-n',[ ('Man',instance)]).
nounMapping2SUMO('11167792-n',[ ('Man',instance)]).
nounMapping2SUMO('11167952-n',[ ('Man',instance)]).
nounMapping2SUMO('11168218-n',[ ('Man',instance)]).
nounMapping2SUMO('11168513-n',[ ('Man',instance)]).
nounMapping2SUMO('11168645-n',[ ('Man',instance)]).
nounMapping2SUMO('11168839-n',[ ('Man',instance)]).
nounMapping2SUMO('11168974-n',[ ('Man',instance)]).
nounMapping2SUMO('11169135-n',[ ('Man',instance)]).
nounMapping2SUMO('11169294-n',[ ('Man',instance)]).
nounMapping2SUMO('11169418-n',[ ('Man',instance)]).
nounMapping2SUMO('11169595-n',[ ('Writer',instance)]).
nounMapping2SUMO('11169764-n',[ ('Man',instance)]).
nounMapping2SUMO('11169943-n',[ ('Man',instance)]).
nounMapping2SUMO('11170123-n',[ ('Man',instance)]).
nounMapping2SUMO('11170248-n',[ ('Man',instance)]).
nounMapping2SUMO('11170438-n',[ ('Man',instance)]).
nounMapping2SUMO('11170604-n',[ ('Man',instance)]).
nounMapping2SUMO('11170764-n',[ ('Man',instance)]).
nounMapping2SUMO('11170913-n',[ ('Man',instance)]).
nounMapping2SUMO('11171157-n',[ ('Man',instance)]).
nounMapping2SUMO('11171298-n',[ ('Woman',instance)]).
nounMapping2SUMO('11171409-n',[ ('Man',instance)]).
nounMapping2SUMO('11171513-n',[ ('Man',instance)]).
nounMapping2SUMO('11171614-n',[ ('Woman',instance)]).
nounMapping2SUMO('11171851-n',[ ('Man',instance)]).
nounMapping2SUMO('11172045-n',[ ('Man',instance)]).
nounMapping2SUMO('11172181-n',[ ('Man',instance)]).
nounMapping2SUMO('11172411-n',[ ('Man',instance)]).
nounMapping2SUMO('11172609-n',[ ('Man',instance)]).
nounMapping2SUMO('11172795-n',[ ('Writer',instance)]).
nounMapping2SUMO('11172929-n',[ ('Man',instance)]).
nounMapping2SUMO('11173031-n',[ ('Man',instance)]).
nounMapping2SUMO('11173199-n',[ ('Man',instance)]).
nounMapping2SUMO('11173475-n',[ ('Man',instance)]).
nounMapping2SUMO('11173778-n',[ ('Man',instance)]).
nounMapping2SUMO('11173917-n',[ ('Man',instance)]).
nounMapping2SUMO('11174119-n',[ ('Man',instance)]).
nounMapping2SUMO('11174354-n',[ ('Man',instance)]).
nounMapping2SUMO('11174563-n',[ ('Man',instance)]).
nounMapping2SUMO('11174730-n',[ ('Man',instance)]).
nounMapping2SUMO('11174901-n',[ ('Man',instance)]).
nounMapping2SUMO('11175040-n',[ ('Man',instance)]).
nounMapping2SUMO('11175243-n',[ ('Man',instance)]).
nounMapping2SUMO('11175445-n',[ ('Man',instance)]).
nounMapping2SUMO('11175605-n',[ ('Man',instance)]).
nounMapping2SUMO('11175748-n',[ ('Man',instance)]).
nounMapping2SUMO('11175875-n',[ ('Man',instance)]).
nounMapping2SUMO('11176005-n',[ ('Man',instance)]).
nounMapping2SUMO('11176230-n',[ ('Man',instance)]).
nounMapping2SUMO('11176388-n',[ ('Man',instance)]).
nounMapping2SUMO('11176527-n',[ ('Woman',instance)]).
nounMapping2SUMO('11176669-n',[ ('Man',instance)]).
nounMapping2SUMO('11176797-n',[ ('Writer',instance)]).
nounMapping2SUMO('11176932-n',[ ('Man',instance)]).
nounMapping2SUMO('11177151-n',[ ('Woman',instance)]).
nounMapping2SUMO('11177370-n',[ ('Man',instance)]).
nounMapping2SUMO('11177532-n',[ ('Man',instance)]).
nounMapping2SUMO('11177695-n',[ ('Man',instance)]).
nounMapping2SUMO('11177873-n',[ ('Man',instance)]).
nounMapping2SUMO('11178059-n',[ ('Man',instance)]).
nounMapping2SUMO('11178161-n',[ ('Man',instance)]).
nounMapping2SUMO('11178393-n',[ ('Man',instance)]).
nounMapping2SUMO('11178631-n',[ ('Writer',instance)]).
nounMapping2SUMO('11178781-n',[ ('Man',instance)]).
nounMapping2SUMO('11178922-n',[ ('Man',instance)]).
nounMapping2SUMO('11179124-n',[ ('Man',instance)]).
nounMapping2SUMO('11179287-n',[ ('Man',instance)]).
nounMapping2SUMO('11179502-n',[ ('Man',instance)]).
nounMapping2SUMO('11179666-n',[ ('Man',instance)]).
nounMapping2SUMO('11179797-n',[ ('Man',instance)]).
nounMapping2SUMO('11179923-n',[ ('Man',instance)]).
nounMapping2SUMO('11180029-n',[ ('Man',instance)]).
nounMapping2SUMO('11180209-n',[ ('Man',instance)]).
nounMapping2SUMO('11180357-n',[ ('Man',instance)]).
nounMapping2SUMO('11180476-n',[ ('Man',instance)]).
nounMapping2SUMO('11180643-n',[ ('Man',instance)]).
nounMapping2SUMO('11180812-n',[ ('Writer',instance)]).
nounMapping2SUMO('11180952-n',[ ('Man',instance)]).
nounMapping2SUMO('11181073-n',[ ('Writer',instance)]).
nounMapping2SUMO('11181255-n',[ ('Man',instance)]).
nounMapping2SUMO('11181438-n',[ ('Man',instance)]).
nounMapping2SUMO('11181634-n',[ ('Man',instance)]).
nounMapping2SUMO('11181835-n',[ ('Man',instance)]).
nounMapping2SUMO('11181937-n',[ ('Man',instance)]).
nounMapping2SUMO('11182098-n',[ ('Man',instance)]).
nounMapping2SUMO('11182275-n',[ ('Writer',instance)]).
nounMapping2SUMO('11182479-n',[ ('Woman',instance)]).
nounMapping2SUMO('11182621-n',[ ('Man',instance)]).
nounMapping2SUMO('11182825-n',[ ('Man',instance)]).
nounMapping2SUMO('11182966-n',[ ('Man',instance)]).
nounMapping2SUMO('11183074-n',[ ('Writer',instance)]).
nounMapping2SUMO('11183211-n',[ ('Writer',instance)]).
nounMapping2SUMO('11183387-n',[ ('Man',instance)]).
nounMapping2SUMO('11183605-n',[ ('Man',instance)]).
nounMapping2SUMO('11183791-n',[ ('Man',instance)]).
nounMapping2SUMO('11183955-n',[ ('Man',instance)]).
nounMapping2SUMO('11184092-n',[ ('Man',instance)]).
nounMapping2SUMO('11184273-n',[ ('Man',instance)]).
nounMapping2SUMO('11184531-n',[ ('Researcher',instance)]).
nounMapping2SUMO('11184694-n',[ ('Writer',instance)]).
nounMapping2SUMO('11184825-n',[ ('Man',instance)]).
nounMapping2SUMO('11184927-n',[ ('Man',instance)]).
nounMapping2SUMO('11185044-n',[ ('Man',instance)]).
nounMapping2SUMO('11185175-n',[ ('Man',instance)]).
nounMapping2SUMO('11185392-n',[ ('Man',instance)]).
nounMapping2SUMO('11185500-n',[ ('Man',instance)]).
nounMapping2SUMO('11185680-n',[ ('Man',instance)]).
nounMapping2SUMO('11185816-n',[ ('Man',instance)]).
nounMapping2SUMO('11186042-n',[ ('Writer',instance)]).
nounMapping2SUMO('11186207-n',[ ('Woman',instance)]).
nounMapping2SUMO('11186356-n',[ ('Man',instance)]).
nounMapping2SUMO('11186511-n',[ ('Writer',instance)]).
nounMapping2SUMO('11186685-n',[ ('Man',instance)]).
nounMapping2SUMO('11186911-n',[ ('Man',instance)]).
nounMapping2SUMO('11187154-n',[ ('Woman',instance)]).
nounMapping2SUMO('11187364-n',[ ('Man',instance)]).
nounMapping2SUMO('11187471-n',[ ('Woman',instance)]).
nounMapping2SUMO('11187601-n',[ ('Man',instance)]).
nounMapping2SUMO('11187754-n',[ ('Man',instance)]).
nounMapping2SUMO('11187930-n',[ ('Man',instance)]).
nounMapping2SUMO('11188123-n',[ ('Man',instance)]).
nounMapping2SUMO('11188316-n',[ ('Man',instance)]).
nounMapping2SUMO('11188613-n',[ ('Man',instance)]).
nounMapping2SUMO('11188742-n',[ ('Man',instance)]).
nounMapping2SUMO('11188852-n',[ ('Woman',instance)]).
nounMapping2SUMO('11189054-n',[ ('Man',instance)]).
nounMapping2SUMO('11189274-n',[ ('Man',instance)]).
nounMapping2SUMO('11189432-n',[ ('Man',instance)]).
nounMapping2SUMO('11189579-n',[ ('Man',instance)]).
nounMapping2SUMO('11189709-n',[ ('Man',instance)]).
nounMapping2SUMO('11189829-n',[ ('Man',instance)]).
nounMapping2SUMO('11190024-n',[ ('Man',instance)]).
nounMapping2SUMO('11190183-n',[ ('Man',instance)]).
nounMapping2SUMO('11190446-n',[ ('Man',instance)]).
nounMapping2SUMO('11190592-n',[ ('Man',instance)]).
nounMapping2SUMO('11190774-n',[ ('Man',instance)]).
nounMapping2SUMO('11190954-n',[ ('Man',instance)]).
nounMapping2SUMO('11191113-n',[ ('Man',instance)]).
nounMapping2SUMO('11191251-n',[ ('Man',instance)]).
nounMapping2SUMO('11191475-n',[ ('Man',instance)]).
nounMapping2SUMO('11191653-n',[ ('Man',instance)]).
nounMapping2SUMO('11191848-n',[ ('Man',instance)]).
nounMapping2SUMO('11192067-n',[ ('Man',instance)]).
nounMapping2SUMO('11192195-n',[ ('Woman',instance)]).
nounMapping2SUMO('11192349-n',[ ('Writer',instance)]).
nounMapping2SUMO('11192533-n',[ ('Man',instance)]).
nounMapping2SUMO('11192666-n',[ ('Man',instance)]).
nounMapping2SUMO('11192901-n',[ ('Man',instance)]).
nounMapping2SUMO('11193058-n',[ ('Man',instance)]).
nounMapping2SUMO('11193250-n',[ ('Man',instance)]).
nounMapping2SUMO('11193392-n',[ ('Man',instance)]).
nounMapping2SUMO('11193645-n',[ ('Woman',instance)]).
nounMapping2SUMO('11193814-n',[ ('Man',instance)]).
nounMapping2SUMO('11193928-n',[ ('Man',instance)]).
nounMapping2SUMO('11194062-n',[ ('Woman',instance)]).
nounMapping2SUMO('11194205-n',[ ('Man',instance)]).
nounMapping2SUMO('11194355-n',[ ('Man',instance)]).
nounMapping2SUMO('11194587-n',[ ('Man',instance)]).
nounMapping2SUMO('11194749-n',[ ('Man',instance)]).
nounMapping2SUMO('11194910-n',[ ('Man',instance)]).
nounMapping2SUMO('11195073-n',[ ('Man',instance)]).
nounMapping2SUMO('11195295-n',[ ('Man',instance)]).
nounMapping2SUMO('11195452-n',[ ('Man',instance)]).
nounMapping2SUMO('11195619-n',[ ('Man',instance)]).
nounMapping2SUMO('11195771-n',[ ('Man',instance)]).
nounMapping2SUMO('11195913-n',[ ('Man',instance)]).
nounMapping2SUMO('11196046-n',[ ('Man',instance)]).
nounMapping2SUMO('11196208-n',[ ('Man',instance)]).
nounMapping2SUMO('11196305-n',[ ('Man',instance)]).
nounMapping2SUMO('11196627-n',[ ('Writer',instance)]).
nounMapping2SUMO('11196764-n',[ ('Writer',instance)]).
nounMapping2SUMO('11196934-n',[ ('Man',instance)]).
nounMapping2SUMO('11197099-n',[ ('Man',instance)]).
nounMapping2SUMO('11197417-n',[ ('Man',instance)]).
nounMapping2SUMO('11197633-n',[ ('Man',instance)]).
nounMapping2SUMO('11197743-n',[ ('Man',instance)]).
nounMapping2SUMO('11197944-n',[ ('Man',instance)]).
nounMapping2SUMO('11198094-n',[ ('Writer',instance)]).
nounMapping2SUMO('11198253-n',[ ('Man',instance)]).
nounMapping2SUMO('11198375-n',[ ('Man',instance)]).
nounMapping2SUMO('11198608-n',[ ('Man',instance)]).
nounMapping2SUMO('11198861-n',[ ('Man',instance)]).
nounMapping2SUMO('11198981-n',[ ('Writer',instance)]).
nounMapping2SUMO('11199137-n',[ ('Man',instance)]).
nounMapping2SUMO('11199234-n',[ ('Man',instance)]).
nounMapping2SUMO('11199394-n',[ ('Man',instance)]).
nounMapping2SUMO('11199727-n',[ ('Man',instance)]).
nounMapping2SUMO('11199943-n',[ ('Woman',instance)]).
nounMapping2SUMO('11200090-n',[ ('Man',instance)]).
nounMapping2SUMO('11200276-n',[ ('Man',instance)]).
nounMapping2SUMO('11200492-n',[ ('Man',instance)]).
nounMapping2SUMO('11200686-n',[ ('Writer',instance)]).
nounMapping2SUMO('11200812-n',[ ('Man',instance)]).
nounMapping2SUMO('11200949-n',[ ('Man',instance)]).
nounMapping2SUMO('11201061-n',[ ('Woman',instance)]).
nounMapping2SUMO('11201264-n',[ ('Man',instance)]).
nounMapping2SUMO('11201386-n',[ ('Man',instance)]).
nounMapping2SUMO('11201740-n',[ ('Woman',instance)]).
nounMapping2SUMO('11201941-n',[ ('Woman',instance)]).
nounMapping2SUMO('11202063-n',[ ('Man',instance)]).
nounMapping2SUMO('11202322-n',[ ('Pope',instance)]).
nounMapping2SUMO('11202477-n',[ ('Man',instance)]).
nounMapping2SUMO('11202581-n',[ ('Man',instance)]).
nounMapping2SUMO('11202722-n',[ ('Woman',instance)]).
nounMapping2SUMO('11202833-n',[ ('Man',instance)]).
nounMapping2SUMO('11203059-n',[ ('Man',instance)]).
nounMapping2SUMO('11203287-n',[ ('Man',instance)]).
nounMapping2SUMO('11203472-n',[ ('Man',instance)]).
nounMapping2SUMO('11203795-n',[ ('Man',instance)]).
nounMapping2SUMO('11203920-n',[ ('Man',instance)]).
nounMapping2SUMO('11204069-n',[ ('Man',instance)]).
nounMapping2SUMO('11204276-n',[ ('Man',instance)]).
nounMapping2SUMO('11204409-n',[ ('Man',instance)]).
nounMapping2SUMO('11204689-n',[ ('Man',instance)]).
nounMapping2SUMO('11204855-n',[ ('Man',instance)]).
nounMapping2SUMO('11204962-n',[ ('Man',instance)]).
nounMapping2SUMO('11205246-n',[ ('Man',instance)]).
nounMapping2SUMO('11205375-n',[ ('Man',instance)]).
nounMapping2SUMO('11205647-n',[ ('Man',instance)]).
nounMapping2SUMO('11205797-n',[ ('Man',instance)]).
nounMapping2SUMO('11205975-n',[ ('Man',instance)]).
nounMapping2SUMO('11206150-n',[ ('Man',instance)]).
nounMapping2SUMO('11206356-n',[ ('Man',instance)]).
nounMapping2SUMO('11206544-n',[ ('Writer',instance)]).
nounMapping2SUMO('11206705-n',[ ('Man',instance)]).
nounMapping2SUMO('11206885-n',[ ('Man',instance)]).
nounMapping2SUMO('11207006-n',[ ('Man',instance)]).
nounMapping2SUMO('11207125-n',[ ('Man',instance)]).
nounMapping2SUMO('11207410-n',[ ('Woman',instance)]).
nounMapping2SUMO('11207585-n',[ ('Man',instance)]).
nounMapping2SUMO('11207768-n',[ ('Man',instance)]).
nounMapping2SUMO('11207929-n',[ ('Man',instance)]).
nounMapping2SUMO('11208172-n',[ ('Man',instance)]).
nounMapping2SUMO('11208431-n',[ ('Man',instance)]).
nounMapping2SUMO('11208688-n',[ ('Man',instance)]).
nounMapping2SUMO('11208917-n',[ ('Man',instance)]).
nounMapping2SUMO('11209019-n',[ ('Man',instance)]).
nounMapping2SUMO('11209201-n',[ ('Man',instance)]).
nounMapping2SUMO('11209306-n',[ ('Man',instance)]).
nounMapping2SUMO('11209428-n',[ ('Woman',instance)]).
nounMapping2SUMO('11209543-n',[ ('Writer',instance)]).
nounMapping2SUMO('11209675-n',[ ('Man',instance)]).
nounMapping2SUMO('11209790-n',[ ('Man',instance)]).
nounMapping2SUMO('11209990-n',[ ('Man',instance)]).
nounMapping2SUMO('11210105-n',[ ('Man',instance)]).
nounMapping2SUMO('11210291-n',[ ('Man',instance)]).
nounMapping2SUMO('11210383-n',[ ('Man',instance)]).
nounMapping2SUMO('11210610-n',[ ('Man',instance)]).
nounMapping2SUMO('11210806-n',[ ('Woman',instance)]).
nounMapping2SUMO('11210963-n',[ ('Writer',instance)]).
nounMapping2SUMO('11211071-n',[ ('Man',instance)]).
nounMapping2SUMO('11211236-n',[ ('Man',instance)]).
nounMapping2SUMO('11211322-n',[ ('Writer',instance)]).
nounMapping2SUMO('11211419-n',[ ('Man',instance)]).
nounMapping2SUMO('11211517-n',[ ('Writer',instance)]).
nounMapping2SUMO('11211696-n',[ ('Man',instance)]).
nounMapping2SUMO('11211870-n',[ ('Man',instance)]).
nounMapping2SUMO('11211987-n',[ ('Writer',instance)]).
nounMapping2SUMO('11212120-n',[ ('Man',instance)]).
nounMapping2SUMO('11212226-n',[ ('Man',instance)]).
nounMapping2SUMO('11212426-n',[ ('Man',instance)]).
nounMapping2SUMO('11212534-n',[ ('Man',instance)]).
nounMapping2SUMO('11212669-n',[ ('Writer',instance)]).
nounMapping2SUMO('11212786-n',[ ('Man',instance)]).
nounMapping2SUMO('11212988-n',[ ('Writer',instance)]).
nounMapping2SUMO('11213094-n',[ ('Man',instance)]).
nounMapping2SUMO('11213216-n',[ ('Woman',instance)]).
nounMapping2SUMO('11213323-n',[ ('Man',instance)]).
nounMapping2SUMO('11213552-n',[ ('Man',instance)]).
nounMapping2SUMO('11213726-n',[ ('Man',instance)]).
nounMapping2SUMO('11213966-n',[ ('Man',instance)]).
nounMapping2SUMO('11214153-n',[ ('Man',instance)]).
nounMapping2SUMO('11214320-n',[ ('Man',instance)]).
nounMapping2SUMO('11214513-n',[ ('Man',instance)]).
nounMapping2SUMO('11214707-n',[ ('Man',instance)]).
nounMapping2SUMO('11214926-n',[ ('Writer',instance)]).
nounMapping2SUMO('11215070-n',[ ('Man',instance)]).
nounMapping2SUMO('11215205-n',[ ('Woman',instance)]).
nounMapping2SUMO('11215384-n',[ ('Man',instance)]).
nounMapping2SUMO('11215541-n',[ ('Man',instance)]).
nounMapping2SUMO('11215724-n',[ ('Man',instance)]).
nounMapping2SUMO('11215909-n',[ ('Man',instance)]).
nounMapping2SUMO('11216100-n',[ ('Man',instance)]).
nounMapping2SUMO('11216264-n',[ ('Writer',instance)]).
nounMapping2SUMO('11216386-n',[ ('Man',instance)]).
nounMapping2SUMO('11216562-n',[ ('Man',instance)]).
nounMapping2SUMO('11216797-n',[ ('Man',instance)]).
nounMapping2SUMO('11216922-n',[ ('Man',instance)]).
nounMapping2SUMO('11217072-n',[ ('Man',instance)]).
nounMapping2SUMO('11217182-n',[ ('Man',instance)]).
nounMapping2SUMO('11217312-n',[ ('Man',instance)]).
nounMapping2SUMO('11217479-n',[ ('Writer',instance)]).
nounMapping2SUMO('11217668-n',[ ('Man',instance)]).
nounMapping2SUMO('11217789-n',[ ('Man',instance)]).
nounMapping2SUMO('11218054-n',[ ('Man',instance)]).
nounMapping2SUMO('11218153-n',[ ('Man',instance)]).
nounMapping2SUMO('11218290-n',[ ('Man',instance)]).
nounMapping2SUMO('11218473-n',[ ('Man',instance)]).
nounMapping2SUMO('11218625-n',[ ('Man',instance)]).
nounMapping2SUMO('11218776-n',[ ('Man',instance)]).
nounMapping2SUMO('11218938-n',[ ('Man',instance)]).
nounMapping2SUMO('11219121-n',[ ('Man',instance)]).
nounMapping2SUMO('11219293-n',[ ('Man',instance)]).
nounMapping2SUMO('11219502-n',[ ('Man',instance)]).
nounMapping2SUMO('11219635-n',[ ('Man',instance)]).
nounMapping2SUMO('11219851-n',[ ('Man',instance)]).
nounMapping2SUMO('11219992-n',[ ('Writer',instance)]).
nounMapping2SUMO('11220149-n',[ ('Man',instance)]).
nounMapping2SUMO('11220319-n',[ ('Man',instance)]).
nounMapping2SUMO('11220461-n',[ ('Man',instance)]).
nounMapping2SUMO('11220664-n',[ ('Man',instance)]).
nounMapping2SUMO('11220836-n',[ ('Man',instance)]).
nounMapping2SUMO('11221107-n',[ ('Man',instance)]).
nounMapping2SUMO('11221268-n',[ ('Man',instance)]).
nounMapping2SUMO('11221389-n',[ ('Man',instance)]).
nounMapping2SUMO('11221495-n',[ ('Man',instance)]).
nounMapping2SUMO('11221650-n',[ ('Man',instance)]).
nounMapping2SUMO('11221778-n',[ ('Man',instance)]).
nounMapping2SUMO('11221956-n',[ ('Man',instance)]).
nounMapping2SUMO('11222054-n',[ ('Man',instance)]).
nounMapping2SUMO('11222457-n',[ ('Man',instance)]).
nounMapping2SUMO('11222655-n',[ ('Man',instance)]).
nounMapping2SUMO('11222759-n',[ ('Writer',instance)]).
nounMapping2SUMO('11222914-n',[ ('Man',instance)]).
nounMapping2SUMO('11223119-n',[ ('Man',instance)]).
nounMapping2SUMO('11223294-n',[ ('Man',instance)]).
nounMapping2SUMO('11223396-n',[ ('Woman',instance)]).
nounMapping2SUMO('11223642-n',[ ('Man',instance)]).
nounMapping2SUMO('11223929-n',[ ('Man',instance)]).
nounMapping2SUMO('11224046-n',[ ('Woman',instance)]).
nounMapping2SUMO('11224173-n',[ ('Man',instance)]).
nounMapping2SUMO('11224309-n',[ ('Man',instance)]).
nounMapping2SUMO('11224419-n',[ ('Man',instance)]).
nounMapping2SUMO('11224654-n',[ ('Writer',instance)]).
nounMapping2SUMO('11224877-n',[ ('Man',instance)]).
nounMapping2SUMO('11225165-n',[ ('Man',instance)]).
nounMapping2SUMO('11225350-n',[ ('Writer',instance)]).
nounMapping2SUMO('11225469-n',[ ('Man',instance)]).
nounMapping2SUMO('11225661-n',[ ('Writer',instance)]).
nounMapping2SUMO('11226126-n',[ ('Pope',instance)]).
nounMapping2SUMO('11226427-n',[ ('Pope',instance)]).
nounMapping2SUMO('11226614-n',[ ('Man',instance)]).
nounMapping2SUMO('11226713-n',[ ('Man',instance)]).
nounMapping2SUMO('11226933-n',[ ('Man',instance)]).
nounMapping2SUMO('11227101-n',[ ('Man',instance)]).
nounMapping2SUMO('11227206-n',[ ('Man',instance)]).
nounMapping2SUMO('11227400-n',[ ('Woman',instance)]).
nounMapping2SUMO('11227499-n',[ ('Man',instance)]).
nounMapping2SUMO('11227618-n',[ ('Woman',instance)]).
nounMapping2SUMO('11227796-n',[ ('Man',instance)]).
nounMapping2SUMO('11228039-n',[ ('Man',instance)]).
nounMapping2SUMO('11228153-n',[ ('Man',instance)]).
nounMapping2SUMO('11228298-n',[ ('Man',instance)]).
nounMapping2SUMO('11228486-n',[ ('Man',instance)]).
nounMapping2SUMO('11228691-n',[ ('ReligiousOrganization',instance)]).
nounMapping2SUMO('11228956-n',[ ('Man',instance)]).
nounMapping2SUMO('11229095-n',[ ('Position',instance)]).
nounMapping2SUMO('11229323-n',[ ('Man',instance)]).
nounMapping2SUMO('11229499-n',[ ('Man',instance)]).
nounMapping2SUMO('11229662-n',[ ('Writer',instance)]).
nounMapping2SUMO('11229801-n',[ ('Man',instance)]).
nounMapping2SUMO('11230021-n',[ ('Man',instance)]).
nounMapping2SUMO('11230158-n',[ ('Man',instance)]).
nounMapping2SUMO('11230402-n',[ ('Man',instance)]).
nounMapping2SUMO('11230669-n',[ ('Man',instance)]).
nounMapping2SUMO('11230780-n',[ ('Man',instance)]).
nounMapping2SUMO('11230977-n',[ ('Man',instance)]).
nounMapping2SUMO('11231157-n',[ ('Man',instance)]).
nounMapping2SUMO('11231433-n',[ ('Man',instance)]).
nounMapping2SUMO('11231683-n',[ ('Man',instance)]).
nounMapping2SUMO('11231821-n',[ ('Man',instance)]).
nounMapping2SUMO('11231943-n',[ ('Man',instance)]).
nounMapping2SUMO('11232050-n',[ ('Man',instance)]).
nounMapping2SUMO('11232229-n',[ ('Man',instance)]).
nounMapping2SUMO('11232475-n',[ ('Man',instance)]).
nounMapping2SUMO('11232615-n',[ ('Man',instance)]).
nounMapping2SUMO('11232837-n',[ ('Man',instance)]).
nounMapping2SUMO('11232989-n',[ ('Man',instance)]).
nounMapping2SUMO('11233211-n',[ ('Man',instance)]).
nounMapping2SUMO('11233383-n',[ ('Man',instance)]).
nounMapping2SUMO('11233595-n',[ ('Man',instance)]).
nounMapping2SUMO('11233934-n',[ ('ReligiousPosition',instance)]).
nounMapping2SUMO('11234152-n',[ ('Woman',instance)]).
nounMapping2SUMO('11234292-n',[ ('Man',instance)]).
nounMapping2SUMO('11234472-n',[ ('Man',instance)]).
nounMapping2SUMO('11234643-n',[ ('Woman',instance)]).
nounMapping2SUMO('11234813-n',[ ('Man',instance)]).
nounMapping2SUMO('11234951-n',[ ('Man',instance)]).
nounMapping2SUMO('11235112-n',[ ('Man',instance)]).
nounMapping2SUMO('11235263-n',[ ('Man',instance)]).
nounMapping2SUMO('11235510-n',[ ('Man',instance)]).
nounMapping2SUMO('11235619-n',[ ('Man',instance)]).
nounMapping2SUMO('11235787-n',[ ('Man',instance)]).
nounMapping2SUMO('11235926-n',[ ('Man',instance)]).
nounMapping2SUMO('11236043-n',[ ('Man',instance)]).
nounMapping2SUMO('11236188-n',[ ('Position',instance)]).
nounMapping2SUMO('11236317-n',[ ('Man',instance)]).
nounMapping2SUMO('11236497-n',[ ('Man',instance)]).
nounMapping2SUMO('11236663-n',[ ('Man',instance)]).
nounMapping2SUMO('11236852-n',[ ('Man',instance)]).
nounMapping2SUMO('11237075-n',[ ('Man',instance)]).
nounMapping2SUMO('11237275-n',[ ('Pope',instance)]).
nounMapping2SUMO('11237550-n',[ ('Man',instance)]).
nounMapping2SUMO('11237868-n',[ ('Pope',instance)]).
nounMapping2SUMO('11238092-n',[ ('Man',instance)]).
nounMapping2SUMO('11238303-n',[ ('Man',instance)]).
nounMapping2SUMO('11238511-n',[ ('Man',instance)]).
nounMapping2SUMO('11238726-n',[ ('Man',instance)]).
nounMapping2SUMO('11238906-n',[ ('Man',instance)]).
nounMapping2SUMO('11239143-n',[ ('Writer',instance)]).
nounMapping2SUMO('11239271-n',[ ('Man',instance)]).
nounMapping2SUMO('11239443-n',[ ('Man',instance)]).
nounMapping2SUMO('11239567-n',[ ('Writer',instance)]).
nounMapping2SUMO('11239765-n',[ ('Writer',instance)]).
nounMapping2SUMO('11239989-n',[ ('Man',instance)]).
nounMapping2SUMO('11240139-n',[ ('Man',instance)]).
nounMapping2SUMO('11240249-n',[ ('Woman',instance)]).
nounMapping2SUMO('11240480-n',[ ('Writer',instance)]).
nounMapping2SUMO('11240609-n',[ ('Man',instance)]).
nounMapping2SUMO('11240733-n',[ ('Man',instance)]).
nounMapping2SUMO('11240996-n',[ ('Man',instance)]).
nounMapping2SUMO('11241106-n',[ ('Man',instance)]).
nounMapping2SUMO('11241300-n',[ ('Man',instance)]).
nounMapping2SUMO('11241455-n',[ ('Man',instance)]).
nounMapping2SUMO('11241655-n',[ ('Woman',instance)]).
nounMapping2SUMO('11241854-n',[ ('Man',instance)]).
nounMapping2SUMO('11242077-n',[ ('Man',instance)]).
nounMapping2SUMO('11242321-n',[ ('Woman',instance)]).
nounMapping2SUMO('11242469-n',[ ('Woman',instance)]).
nounMapping2SUMO('11242596-n',[ ('Man',instance)]).
nounMapping2SUMO('11242743-n',[ ('Man',instance)]).
nounMapping2SUMO('11242849-n',[ ('Man',instance)]).
nounMapping2SUMO('11243102-n',[ ('Writer',instance)]).
nounMapping2SUMO('11243268-n',[ ('Man',instance)]).
nounMapping2SUMO('11243424-n',[ ('Writer',instance)]).
nounMapping2SUMO('11243562-n',[ ('Man',instance)]).
nounMapping2SUMO('11243720-n',[ ('Writer',instance)]).
nounMapping2SUMO('11243907-n',[ ('Man',instance)]).
nounMapping2SUMO('11244061-n',[ ('Man',instance)]).
nounMapping2SUMO('11244419-n',[ ('Man',instance)]).
nounMapping2SUMO('11244550-n',[ ('Writer',instance)]).
nounMapping2SUMO('11244765-n',[ ('Man',instance)]).
nounMapping2SUMO('11244887-n',[ ('Man',instance)]).
nounMapping2SUMO('11245110-n',[ ('Man',instance)]).
nounMapping2SUMO('11245382-n',[ ('Man',instance)]).
nounMapping2SUMO('11245590-n',[ ('Writer',instance)]).
nounMapping2SUMO('11245744-n',[ ('Writer',instance)]).
nounMapping2SUMO('11245902-n',[ ('Writer',instance)]).
nounMapping2SUMO('11246040-n',[ ('Man',instance)]).
nounMapping2SUMO('11246255-n',[ ('Man',instance)]).
nounMapping2SUMO('11246408-n',[ ('Man',instance)]).
nounMapping2SUMO('11246542-n',[ ('Man',instance)]).
nounMapping2SUMO('11246718-n',[ ('Man',instance)]).
nounMapping2SUMO('11247002-n',[ ('Man',instance)]).
nounMapping2SUMO('11247155-n',[ ('Man',instance)]).
nounMapping2SUMO('11247298-n',[ ('Man',instance)]).
nounMapping2SUMO('11247413-n',[ ('Man',instance)]).
nounMapping2SUMO('11247644-n',[ ('Man',instance)]).
nounMapping2SUMO('11247897-n',[ ('Man',instance)]).
nounMapping2SUMO('11248077-n',[ ('Man',instance)]).
nounMapping2SUMO('11248232-n',[ ('Man',instance)]).
nounMapping2SUMO('11248426-n',[ ('Man',instance)]).
nounMapping2SUMO('11248599-n',[ ('Man',instance)]).
nounMapping2SUMO('11248777-n',[ ('Man',instance)]).
nounMapping2SUMO('11248997-n',[ ('Man',instance)]).
nounMapping2SUMO('11249191-n',[ ('Man',instance)]).
nounMapping2SUMO('11249322-n',[ ('Man',instance)]).
nounMapping2SUMO('11249559-n',[ ('Writer',instance)]).
nounMapping2SUMO('11249712-n',[ ('Writer',instance)]).
nounMapping2SUMO('11249890-n',[ ('Man',instance)]).
nounMapping2SUMO('11250056-n',[ ('Man',instance)]).
nounMapping2SUMO('11250287-n',[ ('Man',instance)]).
nounMapping2SUMO('11250581-n',[ ('Man',instance)]).
nounMapping2SUMO('11250833-n',[ ('Man',instance)]).
nounMapping2SUMO('11250991-n',[ ('Man',instance)]).
nounMapping2SUMO('11251225-n',[ ('Writer',instance)]).
nounMapping2SUMO('11251384-n',[ ('Man',instance)]).
nounMapping2SUMO('11251531-n',[ ('Man',instance)]).
nounMapping2SUMO('11251788-n',[ ('Man',instance)]).
nounMapping2SUMO('11251995-n',[ ('Man',instance)]).
nounMapping2SUMO('11252222-n',[ ('Man',instance)]).
nounMapping2SUMO('11252392-n',[ ('Man',instance)]).
nounMapping2SUMO('11252627-n',[ ('Man',instance)]).
nounMapping2SUMO('11252915-n',[ ('Man',instance)]).
nounMapping2SUMO('11253097-n',[ ('Man',instance)]).
nounMapping2SUMO('11253248-n',[ ('Man',instance)]).
nounMapping2SUMO('11253455-n',[ ('Man',instance)]).
nounMapping2SUMO('11253630-n',[ ('Writer',instance)]).
nounMapping2SUMO('11253802-n',[ ('Woman',instance)]).
nounMapping2SUMO('11254028-n',[ ('Man',instance)]).
nounMapping2SUMO('11254213-n',[ ('Man',instance)]).
nounMapping2SUMO('11254393-n',[ ('Man',instance)]).
nounMapping2SUMO('11254683-n',[ ('Man',instance)]).
nounMapping2SUMO('11254950-n',[ ('Man',instance)]).
nounMapping2SUMO('11255085-n',[ ('Man',instance)]).
nounMapping2SUMO('11255211-n',[ ('Man',instance)]).
nounMapping2SUMO('11255460-n',[ ('Man',instance)]).
nounMapping2SUMO('11255619-n',[ ('Man',instance)]).
nounMapping2SUMO('11255775-n',[ ('Woman',instance)]).
nounMapping2SUMO('11255917-n',[ ('Man',instance)]).
nounMapping2SUMO('11256125-n',[ ('Man',instance)]).
nounMapping2SUMO('11256335-n',[ ('Man',instance)]).
nounMapping2SUMO('11256494-n',[ ('Man',instance)]).
nounMapping2SUMO('11256765-n',[ ('Man',instance)]).
nounMapping2SUMO('11257031-n',[ ('Man',instance)]).
nounMapping2SUMO('11257159-n',[ ('Man',instance)]).
nounMapping2SUMO('11257395-n',[ ('Man',instance)]).
nounMapping2SUMO('11257547-n',[ ('Man',instance)]).
nounMapping2SUMO('11257697-n',[ ('Man',instance)]).
nounMapping2SUMO('11257932-n',[ ('Man',instance)]).
nounMapping2SUMO('11258096-n',[ ('Man',instance)]).
nounMapping2SUMO('11258214-n',[ ('Man',instance)]).
nounMapping2SUMO('11258353-n',[ ('Man',instance)]).
nounMapping2SUMO('11258501-n',[ ('Man',instance)]).
nounMapping2SUMO('11258769-n',[ ('Man',instance)]).
nounMapping2SUMO('11258924-n',[ ('Man',instance)]).
nounMapping2SUMO('11259054-n',[ ('Man',instance)]).
nounMapping2SUMO('11259457-n',[ ('Man',instance)]).
nounMapping2SUMO('11259635-n',[ ('Man',instance)]).
nounMapping2SUMO('11259777-n',[ ('Man',instance)]).
nounMapping2SUMO('11259950-n',[ ('Man',instance)]).
nounMapping2SUMO('11260325-n',[ ('Writer',instance)]).
nounMapping2SUMO('11260622-n',[ ('Man',instance)]).
nounMapping2SUMO('11260945-n',[ ('Man',instance)]).
nounMapping2SUMO('11261184-n',[ ('Man',instance)]).
nounMapping2SUMO('11261364-n',[ ('Man',instance)]).
nounMapping2SUMO('11261483-n',[ ('Man',instance)]).
nounMapping2SUMO('11261698-n',[ ('Man',instance)]).
nounMapping2SUMO('11261804-n',[ ('Man',instance)]).
nounMapping2SUMO('11261986-n',[ ('Man',instance)]).
nounMapping2SUMO('11262168-n',[ ('Man',instance)]).
nounMapping2SUMO('11262340-n',[ ('Man',instance)]).
nounMapping2SUMO('11262468-n',[ ('Man',instance)]).
nounMapping2SUMO('11262574-n',[ ('Man',instance)]).
nounMapping2SUMO('11262765-n',[ ('Man',instance)]).
nounMapping2SUMO('11262929-n',[ ('Man',instance)]).
nounMapping2SUMO('11263180-n',[ ('Man',instance)]).
nounMapping2SUMO('11263337-n',[ ('Man',instance)]).
nounMapping2SUMO('11263558-n',[ ('Man',instance)]).
nounMapping2SUMO('11263687-n',[ ('Man',instance)]).
nounMapping2SUMO('11263803-n',[ ('Man',instance)]).
nounMapping2SUMO('11264002-n',[ ('Man',instance)]).
nounMapping2SUMO('11264193-n',[ ('Man',instance)]).
nounMapping2SUMO('11264343-n',[ ('Writer',instance)]).
nounMapping2SUMO('11264508-n',[ ('Man',instance)]).
nounMapping2SUMO('11264614-n',[ ('Man',instance)]).
nounMapping2SUMO('11264828-n',[ ('Man',instance)]).
nounMapping2SUMO('11264973-n',[ ('Man',instance)]).
nounMapping2SUMO('11265183-n',[ ('Man',instance)]).
nounMapping2SUMO('11265416-n',[ ('Man',instance)]).
nounMapping2SUMO('11265591-n',[ ('Writer',instance)]).
nounMapping2SUMO('11265731-n',[ ('Man',instance)]).
nounMapping2SUMO('11265914-n',[ ('Man',instance)]).
nounMapping2SUMO('11266117-n',[ ('Man',instance)]).
nounMapping2SUMO('11266279-n',[ ('Man',instance)]).
nounMapping2SUMO('11266524-n',[ ('Man',instance)]).
nounMapping2SUMO('11266703-n',[ ('Man',instance)]).
nounMapping2SUMO('11266920-n',[ ('Man',instance)]).
nounMapping2SUMO('11267113-n',[ ('Man',instance)]).
nounMapping2SUMO('11267343-n',[ ('Man',instance)]).
nounMapping2SUMO('11267568-n',[ ('Man',instance)]).
nounMapping2SUMO('11267745-n',[ ('Man',instance)]).
nounMapping2SUMO('11267949-n',[ ('Man',instance)]).
nounMapping2SUMO('11268118-n',[ ('Man',instance)]).
nounMapping2SUMO('11268326-n',[ ('Man',instance)]).
nounMapping2SUMO('11268523-n',[ ('Man',instance)]).
nounMapping2SUMO('11268667-n',[ ('Woman',instance)]).
nounMapping2SUMO('11268883-n',[ ('Man',instance)]).
nounMapping2SUMO('11269085-n',[ ('Man',instance)]).
nounMapping2SUMO('11269236-n',[ ('Man',instance)]).
nounMapping2SUMO('11269367-n',[ ('Man',instance)]).
nounMapping2SUMO('11269515-n',[ ('Man',instance)]).
nounMapping2SUMO('11269697-n',[ ('Man',instance)]).
nounMapping2SUMO('11270023-n',[ ('Man',instance)]).
nounMapping2SUMO('11270380-n',[ ('Woman',instance)]).
nounMapping2SUMO('11270577-n',[ ('Woman',instance)]).
nounMapping2SUMO('11270772-n',[ ('Woman',instance)]).
nounMapping2SUMO('11270948-n',[ ('Man',instance)]).
nounMapping2SUMO('11271094-n',[ ('Man',instance)]).
nounMapping2SUMO('11271349-n',[ ('Man',instance)]).
nounMapping2SUMO('11271563-n',[ ('Man',instance)]).
nounMapping2SUMO('11271720-n',[ ('Man',instance)]).
nounMapping2SUMO('11271859-n',[ ('Man',instance)]).
nounMapping2SUMO('11272030-n',[ ('Writer',instance)]).
nounMapping2SUMO('11272198-n',[ ('Man',instance)]).
nounMapping2SUMO('11272415-n',[ ('Man',instance)]).
nounMapping2SUMO('11272523-n',[ ('Man',instance)]).
nounMapping2SUMO('11272689-n',[ ('Writer',instance)]).
nounMapping2SUMO('11272972-n',[ ('Man',instance)]).
nounMapping2SUMO('11273104-n',[ ('Man',instance)]).
nounMapping2SUMO('11273286-n',[ ('Man',instance)]).
nounMapping2SUMO('11273479-n',[ ('Man',instance)]).
nounMapping2SUMO('11273679-n',[ ('Man',instance)]).
nounMapping2SUMO('11273907-n',[ ('Writer',instance)]).
nounMapping2SUMO('11274103-n',[ ('Man',instance)]).
nounMapping2SUMO('11274269-n',[ ('Man',instance)]).
nounMapping2SUMO('11274454-n',[ ('Writer',instance)]).
nounMapping2SUMO('11274714-n',[ ('Man',instance)]).
nounMapping2SUMO('11274812-n',[ ('Man',instance)]).
nounMapping2SUMO('11275035-n',[ ('Writer',instance)]).
nounMapping2SUMO('11275170-n',[ ('Man',instance)]).
nounMapping2SUMO('11275344-n',[ ('Woman',instance)]).
nounMapping2SUMO('11275495-n',[ ('Man',instance)]).
nounMapping2SUMO('11275636-n',[ ('Man',instance)]).
nounMapping2SUMO('11275772-n',[ ('Man',instance)]).
nounMapping2SUMO('11275952-n',[ ('Woman',instance)]).
nounMapping2SUMO('11276100-n',[ ('Man',instance)]).
nounMapping2SUMO('11276285-n',[ ('Man',instance)]).
nounMapping2SUMO('11276549-n',[ ('Man',instance)]).
nounMapping2SUMO('11276676-n',[ ('Position',instance)]).
nounMapping2SUMO('11276971-n',[ ('Man',instance)]).
nounMapping2SUMO('11277096-n',[ ('Man',instance)]).
nounMapping2SUMO('11277279-n',[ ('Man',instance)]).
nounMapping2SUMO('11277500-n',[ ('Woman',instance)]).
nounMapping2SUMO('11277680-n',[ ('Man',instance)]).
nounMapping2SUMO('11277900-n',[ ('Man',instance)]).
nounMapping2SUMO('11278120-n',[ ('Writer',instance)]).
nounMapping2SUMO('11278351-n',[ ('Man',instance)]).
nounMapping2SUMO('11278498-n',[ ('Man',instance)]).
nounMapping2SUMO('11278756-n',[ ('Man',instance)]).
nounMapping2SUMO('11278980-n',[ ('Writer',instance)]).
nounMapping2SUMO('11279109-n',[ ('Man',instance)]).
nounMapping2SUMO('11279300-n',[ ('Woman',instance)]).
nounMapping2SUMO('11279433-n',[ ('Man',instance)]).
nounMapping2SUMO('11279648-n',[ ('Man',instance)]).
nounMapping2SUMO('11279874-n',[ ('Man',instance)]).
nounMapping2SUMO('11280013-n',[ ('Writer',instance)]).
nounMapping2SUMO('11280213-n',[ ('Writer',instance)]).
nounMapping2SUMO('11280405-n',[ ('Woman',instance)]).
nounMapping2SUMO('11280653-n',[ ('Man',instance)]).
nounMapping2SUMO('11280905-n',[ ('Man',instance)]).
nounMapping2SUMO('11281174-n',[ ('Man',instance)]).
nounMapping2SUMO('11281345-n',[ ('Man',instance)]).
nounMapping2SUMO('11281555-n',[ ('Woman',instance)]).
nounMapping2SUMO('11281682-n',[ ('Man',instance)]).
nounMapping2SUMO('11281837-n',[ ('Man',instance)]).
nounMapping2SUMO('11281995-n',[ ('Man',instance)]).
nounMapping2SUMO('11282154-n',[ ('Writer',instance)]).
nounMapping2SUMO('11282286-n',[ ('Writer',instance)]).
nounMapping2SUMO('11282434-n',[ ('Man',instance)]).
nounMapping2SUMO('11282613-n',[ ('Man',instance)]).
nounMapping2SUMO('11282802-n',[ ('Man',instance)]).
nounMapping2SUMO('11283158-n',[ ('Man',instance)]).
nounMapping2SUMO('11283300-n',[ ('Man',instance)]).
nounMapping2SUMO('11283517-n',[ ('Man',instance)]).
nounMapping2SUMO('11283682-n',[ ('Writer',instance)]).
nounMapping2SUMO('11283843-n',[ ('Man',instance)]).
nounMapping2SUMO('11284024-n',[ ('Man',instance)]).
nounMapping2SUMO('11284216-n',[ ('Man',instance)]).
nounMapping2SUMO('11284409-n',[ ('Writer',instance)]).
nounMapping2SUMO('11284541-n',[ ('Man',instance)]).
nounMapping2SUMO('11284742-n',[ ('Man',instance)]).
nounMapping2SUMO('11284884-n',[ ('Man',instance)]).
nounMapping2SUMO('11285091-n',[ ('Man',instance)]).
nounMapping2SUMO('11285282-n',[ ('Man',instance)]).
nounMapping2SUMO('11285456-n',[ ('Man',instance)]).
nounMapping2SUMO('11285692-n',[ ('Man',instance)]).
nounMapping2SUMO('11285902-n',[ ('Man',instance)]).
nounMapping2SUMO('11286117-n',[ ('Man',instance)]).
nounMapping2SUMO('11286354-n',[ ('Man',instance)]).
nounMapping2SUMO('11286476-n',[ ('Man',instance)]).
nounMapping2SUMO('11286618-n',[ ('Man',instance)]).
nounMapping2SUMO('11286820-n',[ ('Man',instance)]).
nounMapping2SUMO('11287016-n',[ ('Man',instance)]).
nounMapping2SUMO('11287186-n',[ ('Man',instance)]).
nounMapping2SUMO('11287437-n',[ ('Man',instance)]).
nounMapping2SUMO('11287570-n',[ ('Man',instance)]).
nounMapping2SUMO('11287734-n',[ ('Man',instance)]).
nounMapping2SUMO('11287964-n',[ ('Man',instance)]).
nounMapping2SUMO('11288216-n',[ ('Man',instance)]).
nounMapping2SUMO('11288528-n',[ ('Man',instance)]).
nounMapping2SUMO('11288818-n',[ ('Man',instance)]).
nounMapping2SUMO('11288930-n',[ ('Man',instance)]).
nounMapping2SUMO('11289161-n',[ ('Writer',instance)]).
nounMapping2SUMO('11289307-n',[ ('Man',instance)]).
nounMapping2SUMO('11289491-n',[ ('Man',instance)]).
nounMapping2SUMO('11289709-n',[ ('Man',instance)]).
nounMapping2SUMO('11289830-n',[ ('Man',instance)]).
nounMapping2SUMO('11289999-n',[ ('Man',instance)]).
nounMapping2SUMO('11290107-n',[ ('Man',instance)]).
nounMapping2SUMO('11290272-n',[ ('Man',instance)]).
nounMapping2SUMO('11290477-n',[ ('Man',instance)]).
nounMapping2SUMO('11290653-n',[ ('Man',instance)]).
nounMapping2SUMO('11290864-n',[ ('Man',instance)]).
nounMapping2SUMO('11290984-n',[ ('Man',instance)]).
nounMapping2SUMO('11291179-n',[ ('Man',instance)]).
nounMapping2SUMO('11291284-n',[ ('Man',instance)]).
nounMapping2SUMO('11291451-n',[ ('Man',instance)]).
nounMapping2SUMO('11291575-n',[ ('Man',instance)]).
nounMapping2SUMO('11291824-n',[ ('Man',instance)]).
nounMapping2SUMO('11292105-n',[ ('Man',instance)]).
nounMapping2SUMO('11292207-n',[ ('Man',instance)]).
nounMapping2SUMO('11292391-n',[ ('Man',instance)]).
nounMapping2SUMO('11292662-n',[ ('Man',instance)]).
nounMapping2SUMO('11292809-n',[ ('Man',instance)]).
nounMapping2SUMO('11293008-n',[ ('Man',instance)]).
nounMapping2SUMO('11293157-n',[ ('Man',instance)]).
nounMapping2SUMO('11293334-n',[ ('Man',instance)]).
nounMapping2SUMO('11293470-n',[ ('Man',instance)]).
nounMapping2SUMO('11293636-n',[ ('Writer',instance)]).
nounMapping2SUMO('11293805-n',[ ('Man',instance)]).
nounMapping2SUMO('11293972-n',[ ('Woman',instance)]).
nounMapping2SUMO('11294202-n',[ ('Man',instance)]).
nounMapping2SUMO('11294349-n',[ ('Man',instance)]).
nounMapping2SUMO('11294582-n',[ ('Woman',instance)]).
nounMapping2SUMO('11294680-n',[ ('Woman',instance)]).
nounMapping2SUMO('11294834-n',[ ('Man',instance)]).
nounMapping2SUMO('11295033-n',[ ('Man',instance)]).
nounMapping2SUMO('11295196-n',[ ('Writer',instance)]).
nounMapping2SUMO('11295464-n',[ ('Man',instance)]).
nounMapping2SUMO('11295619-n',[ ('Man',instance)]).
nounMapping2SUMO('11295828-n',[ ('Man',instance)]).
nounMapping2SUMO('11295936-n',[ ('Man',instance)]).
nounMapping2SUMO('11296139-n',[ ('Woman',instance)]).
nounMapping2SUMO('11296279-n',[ ('Man',instance)]).
nounMapping2SUMO('11296429-n',[ ('Man',instance)]).
nounMapping2SUMO('11296602-n',[ ('Man',instance)]).
nounMapping2SUMO('11296775-n',[ ('Woman',instance)]).
nounMapping2SUMO('11296914-n',[ ('Man',instance)]).
nounMapping2SUMO('11297032-n',[ ('Writer',instance)]).
nounMapping2SUMO('11297263-n',[ ('Man',instance)]).
nounMapping2SUMO('11297457-n',[ ('Writer',instance)]).
nounMapping2SUMO('11297595-n',[ ('Man',instance)]).
nounMapping2SUMO('11297756-n',[ ('Man',instance)]).
nounMapping2SUMO('11297983-n',[ ('Man',instance)]).
nounMapping2SUMO('11298240-n',[ ('Man',instance)]).
nounMapping2SUMO('11298403-n',[ ('Man',instance)]).
nounMapping2SUMO('11298519-n',[ ('Man',instance)]).
nounMapping2SUMO('11298634-n',[ ('Man',instance)]).
nounMapping2SUMO('11298810-n',[ ('Man',instance)]).
nounMapping2SUMO('11299030-n',[ ('Man',instance)]).
nounMapping2SUMO('11299212-n',[ ('Writer',instance)]).
nounMapping2SUMO('11299367-n',[ ('Man',instance)]).
nounMapping2SUMO('11299501-n',[ ('Woman',instance)]).
nounMapping2SUMO('11299672-n',[ ('Man',instance)]).
nounMapping2SUMO('11299770-n',[ ('Man',instance)]).
nounMapping2SUMO('11299890-n',[ ('Man',instance)]).
nounMapping2SUMO('11300089-n',[ ('Man',instance)]).
nounMapping2SUMO('11300326-n',[ ('Man',instance)]).
nounMapping2SUMO('11300465-n',[ ('Man',instance)]).
nounMapping2SUMO('11300678-n',[ ('Writer',instance)]).
nounMapping2SUMO('11300893-n',[ ('Man',instance)]).
nounMapping2SUMO('11301129-n',[ ('Man',instance)]).
nounMapping2SUMO('11301279-n',[ ('Man',instance)]).
nounMapping2SUMO('11301414-n',[ ('Man',instance)]).
nounMapping2SUMO('11301597-n',[ ('Man',instance)]).
nounMapping2SUMO('11301809-n',[ ('Woman',instance)]).
nounMapping2SUMO('11302062-n',[ ('Man',instance)]).
nounMapping2SUMO('11302224-n',[ ('Man',instance)]).
nounMapping2SUMO('11302449-n',[ ('Writer',instance)]).
nounMapping2SUMO('11302615-n',[ ('Writer',instance)]).
nounMapping2SUMO('11302772-n',[ ('Man',instance)]).
nounMapping2SUMO('11302962-n',[ ('Man',instance)]).
nounMapping2SUMO('11303132-n',[ ('Man',instance)]).
nounMapping2SUMO('11303522-n',[ ('Man',instance)]).
nounMapping2SUMO('11303698-n',[ ('Man',instance)]).
nounMapping2SUMO('11304011-n',[ ('Woman',instance)]).
nounMapping2SUMO('11304139-n',[ ('Pope',instance)]).
nounMapping2SUMO('11304354-n',[ ('Man',instance)]).
nounMapping2SUMO('11304461-n',[ ('Man',instance)]).
nounMapping2SUMO('11304669-n',[ ('Man',instance)]).
nounMapping2SUMO('11304811-n',[ ('Man',instance)]).
nounMapping2SUMO('11304912-n',[ ('Man',instance)]).
nounMapping2SUMO('11305159-n',[ ('Man',instance)]).
nounMapping2SUMO('11305258-n',[ ('Man',instance)]).
nounMapping2SUMO('11305402-n',[ ('Man',instance)]).
nounMapping2SUMO('11305611-n',[ ('Man',instance)]).
nounMapping2SUMO('11305745-n',[ ('Woman',instance)]).
nounMapping2SUMO('11305851-n',[ ('Woman',instance)]).
nounMapping2SUMO('11306008-n',[ ('Woman',instance)]).
nounMapping2SUMO('11306175-n',[ ('Man',instance)]).
nounMapping2SUMO('11306297-n',[ ('Man',instance)]).
nounMapping2SUMO('11306473-n',[ ('Writer',instance)]).
nounMapping2SUMO('11306619-n',[ ('Man',instance)]).
nounMapping2SUMO('11306760-n',[ ('Man',instance)]).
nounMapping2SUMO('11306920-n',[ ('Man',instance)]).
nounMapping2SUMO('11307082-n',[ ('Writer',instance)]).
nounMapping2SUMO('11307262-n',[ ('Man',instance)]).
nounMapping2SUMO('11307422-n',[ ('Man',instance)]).
nounMapping2SUMO('11307587-n',[ ('Man',instance)]).
nounMapping2SUMO('11307759-n',[ ('Man',instance)]).
nounMapping2SUMO('11307937-n',[ ('Man',instance)]).
nounMapping2SUMO('11308120-n',[ ('Writer',instance)]).
nounMapping2SUMO('11308396-n',[ ('Man',instance)]).
nounMapping2SUMO('11308520-n',[ ('Writer',instance)]).
nounMapping2SUMO('11308624-n',[ ('Man',instance)]).
nounMapping2SUMO('11308739-n',[ ('Man',instance)]).
nounMapping2SUMO('11308877-n',[ ('Man',instance)]).
nounMapping2SUMO('11308988-n',[ ('Man',instance)]).
nounMapping2SUMO('11309164-n',[ ('Man',instance)]).
nounMapping2SUMO('11309318-n',[ ('Man',instance)]).
nounMapping2SUMO('11309449-n',[ ('Man',instance)]).
nounMapping2SUMO('11309613-n',[ ('Writer',instance)]).
nounMapping2SUMO('11309772-n',[ ('Man',instance)]).
nounMapping2SUMO('11309958-n',[ ('Man',instance)]).
nounMapping2SUMO('11310081-n',[ ('Man',instance)]).
nounMapping2SUMO('11310321-n',[ ('Man',instance)]).
nounMapping2SUMO('11310523-n',[ ('Man',instance)]).
nounMapping2SUMO('11310679-n',[ ('Man',instance)]).
nounMapping2SUMO('11310833-n',[ ('Man',instance)]).
nounMapping2SUMO('11311011-n',[ ('Man',instance)]).
nounMapping2SUMO('11311173-n',[ ('Man',instance)]).
nounMapping2SUMO('11311287-n',[ ('Writer',instance)]).
nounMapping2SUMO('11311450-n',[ ('Man',instance)]).
nounMapping2SUMO('11311623-n',[ ('Man',instance)]).
nounMapping2SUMO('11311817-n',[ ('Man',instance)]).
nounMapping2SUMO('11311959-n',[ ('Writer',instance)]).
nounMapping2SUMO('11312120-n',[ ('Man',instance)]).
nounMapping2SUMO('11312362-n',[ ('Man',instance)]).
nounMapping2SUMO('11312556-n',[ ('Man',instance)]).
nounMapping2SUMO('11312709-n',[ ('Man',instance)]).
nounMapping2SUMO('11313011-n',[ ('Man',instance)]).
nounMapping2SUMO('11313357-n',[ ('Man',instance)]).
nounMapping2SUMO('11313507-n',[ ('Woman',instance)]).
nounMapping2SUMO('11313726-n',[ ('Man',instance)]).
nounMapping2SUMO('11313911-n',[ ('Man',instance)]).
nounMapping2SUMO('11314119-n',[ ('Writer',instance)]).
nounMapping2SUMO('11314219-n',[ ('Man',instance)]).
nounMapping2SUMO('11314315-n',[ ('Man',instance)]).
nounMapping2SUMO('11314514-n',[ ('Man',instance)]).
nounMapping2SUMO('11314666-n',[ ('Writer',instance)]).
nounMapping2SUMO('11314792-n',[ ('Writer',instance)]).
nounMapping2SUMO('11314969-n',[ ('Man',instance)]).
nounMapping2SUMO('11315140-n',[ ('Woman',instance)]).
nounMapping2SUMO('11315249-n',[ ('Man',instance)]).
nounMapping2SUMO('11315379-n',[ ('Man',instance)]).
nounMapping2SUMO('11315580-n',[ ('Man',instance)]).
nounMapping2SUMO('11315760-n',[ ('Man',instance)]).
nounMapping2SUMO('11316003-n',[ ('Man',instance)]).
nounMapping2SUMO('11316141-n',[ ('Man',instance)]).
nounMapping2SUMO('11316249-n',[ ('Writer',instance)]).
nounMapping2SUMO('11316429-n',[ ('Man',instance)]).
nounMapping2SUMO('11316567-n',[ ('Writer',instance)]).
nounMapping2SUMO('11316669-n',[ ('Man',instance)]).
nounMapping2SUMO('11316828-n',[ ('Man',instance)]).
nounMapping2SUMO('11316970-n',[ ('Writer',instance)]).
nounMapping2SUMO('11317086-n',[ ('Man',instance)]).
nounMapping2SUMO('11317309-n',[ ('Man',instance)]).
nounMapping2SUMO('11317416-n',[ ('Man',instance)]).
nounMapping2SUMO('11317519-n',[ ('Man',instance)]).
nounMapping2SUMO('11317749-n',[ ('Man',instance)]).
nounMapping2SUMO('11317897-n',[ ('Writer',instance)]).
nounMapping2SUMO('11318039-n',[ ('Man',instance)]).
nounMapping2SUMO('11318171-n',[ ('Man',instance)]).
nounMapping2SUMO('11318348-n',[ ('Man',instance)]).
nounMapping2SUMO('11318462-n',[ ('Man',instance)]).
nounMapping2SUMO('11318692-n',[ ('Writer',instance)]).
nounMapping2SUMO('11318824-n',[ ('Writer',instance)]).
nounMapping2SUMO('11318967-n',[ ('Man',instance)]).
nounMapping2SUMO('11319134-n',[ ('Man',instance)]).
nounMapping2SUMO('11319244-n',[ ('Man',instance)]).
nounMapping2SUMO('11319413-n',[ ('Man',instance)]).
nounMapping2SUMO('11319570-n',[ ('Woman',instance)]).
nounMapping2SUMO('11319704-n',[ ('Man',instance)]).
nounMapping2SUMO('11319810-n',[ ('Man',instance)]).
nounMapping2SUMO('11320044-n',[ ('Man',instance)]).
nounMapping2SUMO('11320245-n',[ ('Man',instance)]).
nounMapping2SUMO('11320405-n',[ ('Writer',instance)]).
nounMapping2SUMO('11320631-n',[ ('Man',instance)]).
nounMapping2SUMO('11320821-n',[ ('Man',instance)]).
nounMapping2SUMO('11321051-n',[ ('Position',instance)]).
nounMapping2SUMO('11321296-n',[ ('Man',instance)]).
nounMapping2SUMO('11321428-n',[ ('Man',instance)]).
nounMapping2SUMO('11321647-n',[ ('Man',instance)]).
nounMapping2SUMO('11321841-n',[ ('Man',instance)]).
nounMapping2SUMO('11322068-n',[ ('Woman',instance)]).
nounMapping2SUMO('11322178-n',[ ('Woman',instance)]).
nounMapping2SUMO('11322344-n',[ ('Man',instance)]).
nounMapping2SUMO('11322481-n',[ ('Man',instance)]).
nounMapping2SUMO('11322627-n',[ ('Man',instance)]).
nounMapping2SUMO('11322758-n',[ ('Man',instance)]).
nounMapping2SUMO('11322937-n',[ ('Man',instance)]).
nounMapping2SUMO('11323094-n',[ ('Man',instance)]).
nounMapping2SUMO('11323316-n',[ ('Writer',instance)]).
nounMapping2SUMO('11323448-n',[ ('Man',instance)]).
nounMapping2SUMO('11323580-n',[ ('Writer',instance)]).
nounMapping2SUMO('11323721-n',[ ('Man',instance)]).
nounMapping2SUMO('11323849-n',[ ('Man',instance)]).
nounMapping2SUMO('11324090-n',[ ('Man',instance)]).
nounMapping2SUMO('11324212-n',[ ('Man',instance)]).
nounMapping2SUMO('11324428-n',[ ('Woman',instance)]).
nounMapping2SUMO('11324619-n',[ ('Man',instance)]).
nounMapping2SUMO('11324785-n',[ ('Man',instance)]).
nounMapping2SUMO('11324902-n',[ ('Man',instance)]).
nounMapping2SUMO('11325146-n',[ ('Man',instance)]).
nounMapping2SUMO('11325265-n',[ ('Man',instance)]).
nounMapping2SUMO('11325419-n',[ ('Man',instance)]).
nounMapping2SUMO('11325534-n',[ ('Man',instance)]).
nounMapping2SUMO('11325663-n',[ ('Man',instance)]).
nounMapping2SUMO('11325867-n',[ ('Man',instance)]).
nounMapping2SUMO('11326008-n',[ ('Man',instance)]).
nounMapping2SUMO('11326154-n',[ ('Man',instance)]).
nounMapping2SUMO('11326433-n',[ ('Woman',instance)]).
nounMapping2SUMO('11326591-n',[ ('Man',instance)]).
nounMapping2SUMO('11326730-n',[ ('Man',instance)]).
nounMapping2SUMO('11326869-n',[ ('Man',instance)]).
nounMapping2SUMO('11326999-n',[ ('Man',instance)]).
nounMapping2SUMO('11327163-n',[ ('Man',instance)]).
nounMapping2SUMO('11327273-n',[ ('Man',instance)]).
nounMapping2SUMO('11327398-n',[ ('Pope',instance)]).
nounMapping2SUMO('11327544-n',[ ('Writer',instance)]).
nounMapping2SUMO('11327650-n',[ ('Man',instance)]).
nounMapping2SUMO('11327744-n',[ ('Man',instance)]).
nounMapping2SUMO('11327964-n',[ ('Man',instance)]).
nounMapping2SUMO('11328085-n',[ ('Man',instance)]).
nounMapping2SUMO('11328289-n',[ ('Man',instance)]).
nounMapping2SUMO('11328524-n',[ ('Man',instance)]).
nounMapping2SUMO('11328714-n',[ ('Man',instance)]).
nounMapping2SUMO('11328930-n',[ ('Man',instance)]).
nounMapping2SUMO('11329030-n',[ ('Writer',instance)]).
nounMapping2SUMO('11329281-n',[ ('Man',instance)]).
nounMapping2SUMO('11329507-n',[ ('Woman',instance)]).
nounMapping2SUMO('11329690-n',[ ('Man',instance)]).
nounMapping2SUMO('11329808-n',[ ('Man',instance)]).
nounMapping2SUMO('11330026-n',[ ('Man',instance)]).
nounMapping2SUMO('11330228-n',[ ('Man',instance)]).
nounMapping2SUMO('11330346-n',[ ('Man',instance)]).
nounMapping2SUMO('11330504-n',[ ('Woman',instance)]).
nounMapping2SUMO('11330692-n',[ ('Man',instance)]).
nounMapping2SUMO('11330963-n',[ ('Man',instance)]).
nounMapping2SUMO('11331063-n',[ ('Man',instance)]).
nounMapping2SUMO('11331192-n',[ ('Man',instance)]).
nounMapping2SUMO('11331300-n',[ ('Man',instance)]).
nounMapping2SUMO('11331442-n',[ ('Writer',instance)]).
nounMapping2SUMO('11331669-n',[ ('Man',instance)]).
nounMapping2SUMO('11331804-n',[ ('Man',instance)]).
nounMapping2SUMO('11332068-n',[ ('Man',instance)]).
nounMapping2SUMO('11332250-n',[ ('Man',instance)]).
nounMapping2SUMO('11332423-n',[ ('Man',instance)]).
nounMapping2SUMO('11332572-n',[ ('Man',instance)]).
nounMapping2SUMO('11332688-n',[ ('Man',instance)]).
nounMapping2SUMO('11332892-n',[ ('Man',instance)]).
nounMapping2SUMO('11333071-n',[ ('Man',instance)]).
nounMapping2SUMO('11333237-n',[ ('Man',instance)]).
nounMapping2SUMO('11333390-n',[ ('Woman',instance)]).
nounMapping2SUMO('11333601-n',[ ('Man',instance)]).
nounMapping2SUMO('11333762-n',[ ('Man',instance)]).
nounMapping2SUMO('11334003-n',[ ('Man',instance)]).
nounMapping2SUMO('11334215-n',[ ('Woman',instance)]).
nounMapping2SUMO('11334317-n',[ ('Woman',instance)]).
nounMapping2SUMO('11334428-n',[ ('Man',instance)]).
nounMapping2SUMO('11334609-n',[ ('Man',instance)]).
nounMapping2SUMO('11334773-n',[ ('Woman',instance)]).
nounMapping2SUMO('11334925-n',[ ('Man',instance)]).
nounMapping2SUMO('11335041-n',[ ('Man',instance)]).
nounMapping2SUMO('11335226-n',[ ('Man',instance)]).
nounMapping2SUMO('11335330-n',[ ('Man',instance)]).
nounMapping2SUMO('11335491-n',[ ('Man',instance)]).
nounMapping2SUMO('11335695-n',[ ('Man',instance)]).
nounMapping2SUMO('11335878-n',[ ('Woman',instance)]).
nounMapping2SUMO('11336176-n',[ ('Writer',instance)]).
nounMapping2SUMO('11336364-n',[ ('Woman',instance)]).
nounMapping2SUMO('11336544-n',[ ('Woman',instance)]).
nounMapping2SUMO('11336668-n',[ ('Man',instance)]).
nounMapping2SUMO('11336850-n',[ ('Man',instance)]).
nounMapping2SUMO('11337202-n',[ ('Writer',instance)]).
nounMapping2SUMO('11337331-n',[ ('Man',instance)]).
nounMapping2SUMO('11337629-n',[ ('Man',instance)]).
nounMapping2SUMO('11337779-n',[ ('Woman',instance)]).
nounMapping2SUMO('11337999-n',[ ('Man',instance)]).
nounMapping2SUMO('11338172-n',[ ('Man',instance)]).
nounMapping2SUMO('11338484-n',[ ('Man',instance)]).
nounMapping2SUMO('11338667-n',[ ('Man',instance)]).
nounMapping2SUMO('11338796-n',[ ('Man',instance)]).
nounMapping2SUMO('11339041-n',[ ('Man',instance)]).
nounMapping2SUMO('11339155-n',[ ('Man',instance)]).
nounMapping2SUMO('11339361-n',[ ('Man',instance)]).
nounMapping2SUMO('11339534-n',[ ('Man',instance)]).
nounMapping2SUMO('11339669-n',[ ('Man',instance)]).
nounMapping2SUMO('11339905-n',[ ('Man',instance)]).
nounMapping2SUMO('11340146-n',[ ('Man',instance)]).
nounMapping2SUMO('11340411-n',[ ('Man',instance)]).
nounMapping2SUMO('11340642-n',[ ('Man',instance)]).
nounMapping2SUMO('11340824-n',[ ('Man',instance)]).
nounMapping2SUMO('11340992-n',[ ('Writer',instance)]).
nounMapping2SUMO('11341137-n',[ ('Man',instance)]).
nounMapping2SUMO('11341267-n',[ ('Man',instance)]).
nounMapping2SUMO('11341374-n',[ ('Man',instance)]).
nounMapping2SUMO('11341479-n',[ ('Man',instance)]).
nounMapping2SUMO('11341614-n',[ ('Man',instance)]).
nounMapping2SUMO('11341760-n',[ ('Man',instance)]).
nounMapping2SUMO('11341970-n',[ ('Man',instance)]).
nounMapping2SUMO('11342191-n',[ ('Man',instance)]).
nounMapping2SUMO('11342301-n',[ ('Man',instance)]).
nounMapping2SUMO('11342440-n',[ ('Man',instance)]).
nounMapping2SUMO('11342618-n',[ ('Man',instance)]).
nounMapping2SUMO('11342766-n',[ ('Man',instance)]).
nounMapping2SUMO('11342905-n',[ ('Man',instance)]).
nounMapping2SUMO('11343040-n',[ ('Man',instance)]).
nounMapping2SUMO('11343208-n',[ ('Man',instance)]).
nounMapping2SUMO('11343333-n',[ ('Man',instance)]).
nounMapping2SUMO('11343507-n',[ ('Man',instance)]).
nounMapping2SUMO('11343625-n',[ ('Man',instance)]).
nounMapping2SUMO('11343847-n',[ ('Man',instance)]).
nounMapping2SUMO('11343998-n',[ ('Man',instance)]).
nounMapping2SUMO('11344092-n',[ ('Man',instance)]).
nounMapping2SUMO('11344235-n',[ ('Man',instance)]).
nounMapping2SUMO('11344337-n',[ ('Writer',instance)]).
nounMapping2SUMO('11344549-n',[ ('Man',instance)]).
nounMapping2SUMO('11344733-n',[ ('Man',instance)]).
nounMapping2SUMO('11345017-n',[ ('Writer',instance)]).
nounMapping2SUMO('11345181-n',[ ('Writer',instance)]).
nounMapping2SUMO('11345378-n',[ ('Writer',instance)]).
nounMapping2SUMO('11345539-n',[ ('Man',instance)]).
nounMapping2SUMO('11345705-n',[ ('Man',instance)]).
nounMapping2SUMO('11345878-n',[ ('Man',instance)]).
nounMapping2SUMO('11346110-n',[ ('Man',instance)]).
nounMapping2SUMO('11346257-n',[ ('Man',instance)]).
nounMapping2SUMO('11346391-n',[ ('Man',instance)]).
nounMapping2SUMO('11346568-n',[ ('Man',instance)]).
nounMapping2SUMO('11346710-n',[ ('Man',instance)]).
nounMapping2SUMO('11346873-n',[ ('Man',instance)]).
nounMapping2SUMO('11347080-n',[ ('Man',instance)]).
nounMapping2SUMO('11347317-n',[ ('Man',instance)]).
nounMapping2SUMO('11347519-n',[ ('Man',instance)]).
nounMapping2SUMO('11347674-n',[ ('Man',instance)]).
nounMapping2SUMO('11347834-n',[ ('Man',instance)]).
nounMapping2SUMO('11348047-n',[ ('Woman',instance)]).
nounMapping2SUMO('11348160-n',[ ('Man',instance)]).
nounMapping2SUMO('11348356-n',[ ('Man',instance)]).
nounMapping2SUMO('11348584-n',[ ('Man',instance)]).
nounMapping2SUMO('11348812-n',[ ('Man',instance)]).
nounMapping2SUMO('11348946-n',[ ('Man',instance)]).
nounMapping2SUMO('11349092-n',[ ('Man',instance)]).
nounMapping2SUMO('11349207-n',[ ('Writer',instance)]).
nounMapping2SUMO('11349318-n',[ ('Man',instance)]).
nounMapping2SUMO('11349635-n',[ ('Man',instance)]).
nounMapping2SUMO('11349739-n',[ ('Man',instance)]).
nounMapping2SUMO('11350059-n',[ ('Man',instance)]).
nounMapping2SUMO('11350286-n',[ ('Man',instance)]).
nounMapping2SUMO('11350393-n',[ ('Man',instance)]).
nounMapping2SUMO('11350514-n',[ ('Man',instance)]).
nounMapping2SUMO('11350705-n',[ ('Man',instance)]).
nounMapping2SUMO('11350959-n',[ ('Man',instance)]).
nounMapping2SUMO('11351212-n',[ ('Man',instance)]).
nounMapping2SUMO('11351347-n',[ ('Woman',instance)]).
nounMapping2SUMO('11351529-n',[ ('Man',instance)]).
nounMapping2SUMO('11351677-n',[ ('Man',instance)]).
nounMapping2SUMO('11351832-n',[ ('Man',instance)]).
nounMapping2SUMO('11352035-n',[ ('Writer',instance)]).
nounMapping2SUMO('11352192-n',[ ('Man',instance)]).
nounMapping2SUMO('11352498-n',[ ('Man',instance)]).
nounMapping2SUMO('11352701-n',[ ('Man',instance)]).
nounMapping2SUMO('11352883-n',[ ('Man',instance)]).
nounMapping2SUMO('11353078-n',[ ('Man',instance)]).
nounMapping2SUMO('11353195-n',[ ('Man',instance)]).
nounMapping2SUMO('11353412-n',[ ('Man',instance)]).
nounMapping2SUMO('11353510-n',[ ('Man',instance)]).
nounMapping2SUMO('11353847-n',[ ('Man',instance)]).
nounMapping2SUMO('11354001-n',[ ('Man',instance)]).
nounMapping2SUMO('11354145-n',[ ('Man',instance)]).
nounMapping2SUMO('11354333-n',[ ('Man',instance)]).
nounMapping2SUMO('11354743-n',[ ('Man',instance)]).
nounMapping2SUMO('11355082-n',[ ('Man',instance)]).
nounMapping2SUMO('11355247-n',[ ('Man',instance)]).
nounMapping2SUMO('11355428-n',[ ('Man',instance)]).
nounMapping2SUMO('11355537-n',[ ('Man',instance)]).
nounMapping2SUMO('11355669-n',[ ('Man',instance)]).
nounMapping2SUMO('11356018-n',[ ('Man',instance)]).
nounMapping2SUMO('11356183-n',[ ('Woman',instance)]).
nounMapping2SUMO('11356283-n',[ ('Writer',instance)]).
nounMapping2SUMO('11356392-n',[ ('Writer',instance)]).
nounMapping2SUMO('11356512-n',[ ('Man',instance)]).
nounMapping2SUMO('11356636-n',[ ('Man',instance)]).
nounMapping2SUMO('11356822-n',[ ('Pope',instance)]).
nounMapping2SUMO('11357086-n',[ ('Man',instance)]).
nounMapping2SUMO('11357332-n',[ ('Pope',instance)]).
nounMapping2SUMO('11357514-n',[ ('Man',instance)]).
nounMapping2SUMO('11357660-n',[ ('Man',instance)]).
nounMapping2SUMO('11357879-n',[ ('Man',instance)]).
nounMapping2SUMO('11358065-n',[ ('Man',instance)]).
nounMapping2SUMO('11358225-n',[ ('Man',instance)]).
nounMapping2SUMO('11358374-n',[ ('Man',instance)]).
nounMapping2SUMO('11358598-n',[ ('Man',instance)]).
nounMapping2SUMO('11358719-n',[ ('Man',instance)]).
nounMapping2SUMO('11358863-n',[ ('Man',instance)]).
nounMapping2SUMO('11359037-n',[ ('Man',instance)]).
nounMapping2SUMO('11359187-n',[ ('Man',instance)]).
nounMapping2SUMO('11359412-n',[ ('Man',instance)]).
nounMapping2SUMO('11359558-n',[ ('Man',instance)]).
nounMapping2SUMO('11359697-n',[ ('Writer',instance)]).
nounMapping2SUMO('11359867-n',[ ('Man',instance)]).
nounMapping2SUMO('11360022-n',[ ('Man',instance)]).
nounMapping2SUMO('11360175-n',[ ('Man',instance)]).
nounMapping2SUMO('11360311-n',[ ('Man',instance)]).
nounMapping2SUMO('11360534-n',[ ('Man',instance)]).
nounMapping2SUMO('11360744-n',[ ('Man',instance)]).
nounMapping2SUMO('11360895-n',[ ('Writer',instance)]).
nounMapping2SUMO('11361039-n',[ ('Man',instance)]).
nounMapping2SUMO('11361142-n',[ ('Man',instance)]).
nounMapping2SUMO('11361288-n',[ ('Man',instance)]).
nounMapping2SUMO('11361423-n',[ ('Woman',instance)]).
nounMapping2SUMO('11361585-n',[ ('Man',instance)]).
nounMapping2SUMO('11361757-n',[ ('Man',instance)]).
nounMapping2SUMO('11361913-n',[ ('Man',instance)]).
nounMapping2SUMO('11362022-n',[ ('Man',instance)]).
nounMapping2SUMO('11362195-n',[ ('Man',instance)]).
nounMapping2SUMO('11362329-n',[ ('Man',instance)]).
nounMapping2SUMO('11362452-n',[ ('Man',instance)]).
nounMapping2SUMO('11362573-n',[ ('Man',instance)]).
nounMapping2SUMO('11362885-n',[ ('Man',instance)]).
nounMapping2SUMO('11363020-n',[ ('Man',instance)]).
nounMapping2SUMO('11363164-n',[ ('Man',instance)]).
nounMapping2SUMO('11363269-n',[ ('Man',instance)]).
nounMapping2SUMO('11363412-n',[ ('Writer',instance)]).
nounMapping2SUMO('11363552-n',[ ('Man',instance)]).
nounMapping2SUMO('11363657-n',[ ('Man',instance)]).
nounMapping2SUMO('11363791-n',[ ('Man',instance)]).
nounMapping2SUMO('11363930-n',[ ('Man',instance)]).
nounMapping2SUMO('11364135-n',[ ('Man',instance)]).
nounMapping2SUMO('11364243-n',[ ('Man',instance)]).
nounMapping2SUMO('11364419-n',[ ('Man',instance)]).
nounMapping2SUMO('11364570-n',[ ('Man',instance)]).
nounMapping2SUMO('11364799-n',[ ('Man',instance)]).
nounMapping2SUMO('11365100-n',[ ('Man',instance)]).
nounMapping2SUMO('11365300-n',[ ('Man',instance)]).
nounMapping2SUMO('11365516-n',[ ('Man',instance)]).
nounMapping2SUMO('11365674-n',[ ('Man',instance)]).
nounMapping2SUMO('11365857-n',[ ('Woman',instance)]).
nounMapping2SUMO('11366109-n',[ ('Writer',instance)]).
nounMapping2SUMO('11366232-n',[ ('Man',instance)]).
nounMapping2SUMO('11366405-n',[ ('Man',instance)]).
nounMapping2SUMO('11366548-n',[ ('Man',instance)]).
nounMapping2SUMO('11366658-n',[ ('Man',instance)]).
nounMapping2SUMO('11366787-n',[ ('Man',instance)]).
nounMapping2SUMO('11366895-n',[ ('Man',instance)]).
nounMapping2SUMO('11367035-n',[ ('Man',instance)]).
nounMapping2SUMO('11367195-n',[ ('Man',instance)]).
nounMapping2SUMO('11367436-n',[ ('Writer',instance)]).
nounMapping2SUMO('11367581-n',[ ('Man',instance)]).
nounMapping2SUMO('11367725-n',[ ('Man',instance)]).
nounMapping2SUMO('11367910-n',[ ('Man',instance)]).
nounMapping2SUMO('11368076-n',[ ('Man',instance)]).
nounMapping2SUMO('11368240-n',[ ('Man',instance)]).
nounMapping2SUMO('11368368-n',[ ('Man',instance)]).
nounMapping2SUMO('11368638-n',[ ('Writer',instance)]).
nounMapping2SUMO('11368841-n',[ ('Writer',instance)]).
nounMapping2SUMO('11369035-n',[ ('Man',instance)]).
nounMapping2SUMO('11369251-n',[ ('Man',instance)]).
nounMapping2SUMO('11369444-n',[ ('Man',instance)]).
nounMapping2SUMO('11369551-n',[ ('Man',instance)]).
nounMapping2SUMO('11369676-n',[ ('Man',instance)]).
nounMapping2SUMO('11369834-n',[ ('Man',instance)]).
nounMapping2SUMO('11370068-n',[ ('Man',instance)]).
nounMapping2SUMO('11370201-n',[ ('Writer',instance)]).
nounMapping2SUMO('11370314-n',[ ('Position',instance)]).
nounMapping2SUMO('11370554-n',[ ('Man',instance)]).
nounMapping2SUMO('11370654-n',[ ('Man',instance)]).
nounMapping2SUMO('11370990-n',[ ('Man',instance)]).
nounMapping2SUMO('11371125-n',[ ('Writer',instance)]).
nounMapping2SUMO('11371254-n',[ ('Man',instance)]).
nounMapping2SUMO('11371443-n',[ ('Man',instance)]).
nounMapping2SUMO('11371622-n',[ ('Writer',instance)]).
nounMapping2SUMO('11371778-n',[ ('Man',instance)]).
nounMapping2SUMO('11372054-n',[ ('Man',instance)]).
nounMapping2SUMO('11372242-n',[ ('Man',instance)]).
nounMapping2SUMO('11372372-n',[ ('Man',instance)]).
nounMapping2SUMO('11372599-n',[ ('Writer',instance)]).
nounMapping2SUMO('11372799-n',[ ('Man',instance)]).
nounMapping2SUMO('11372896-n',[ ('Man',instance)]).
nounMapping2SUMO('11373099-n',[ ('Writer',instance)]).
nounMapping2SUMO('11373231-n',[ ('Man',instance)]).
nounMapping2SUMO('11373379-n',[ ('Man',instance)]).
nounMapping2SUMO('11373550-n',[ ('Man',instance)]).
nounMapping2SUMO('11373672-n',[ ('Man',instance)]).
nounMapping2SUMO('11373897-n',[ ('Man',instance)]).
nounMapping2SUMO('11374085-n',[ ('Writer',instance)]).
nounMapping2SUMO('11374281-n',[ ('Woman',instance)]).
nounMapping2SUMO('11374448-n',[ ('Man',instance)]).
nounMapping2SUMO('11374589-n',[ ('Man',instance)]).
nounMapping2SUMO('11374789-n',[ ('Man',instance)]).
nounMapping2SUMO('11374952-n',[ ('Writer',instance)]).
nounMapping2SUMO('11375087-n',[ ('Man',instance)]).
nounMapping2SUMO('11375418-n',[ ('Man',instance)]).
nounMapping2SUMO('11375677-n',[ ('Man',instance)]).
nounMapping2SUMO('11375909-n',[ ('Man',instance)]).
nounMapping2SUMO('11376069-n',[ ('Woman',instance)]).
nounMapping2SUMO('11376201-n',[ ('Man',instance)]).
nounMapping2SUMO('11376400-n',[ ('Man',instance)]).
nounMapping2SUMO('11376565-n',[ ('Man',instance)]).
nounMapping2SUMO('11376742-n',[ ('Man',instance)]).
nounMapping2SUMO('11376939-n',[ ('Man',instance)]).
nounMapping2SUMO('11377043-n',[ ('Man',instance)]).
nounMapping2SUMO('11377168-n',[ ('Writer',instance)]).
nounMapping2SUMO('11377315-n',[ ('Man',instance)]).
nounMapping2SUMO('11377564-n',[ ('Man',instance)]).
nounMapping2SUMO('11377712-n',[ ('Man',instance)]).
nounMapping2SUMO('11377851-n',[ ('Man',instance)]).
nounMapping2SUMO('11378087-n',[ ('Writer',instance)]).
nounMapping2SUMO('11378254-n',[ ('Man',instance)]).
nounMapping2SUMO('11378462-n',[ ('Man',instance)]).
nounMapping2SUMO('11378662-n',[ ('Man',instance)]).
nounMapping2SUMO('11378805-n',[ ('Man',instance)]).
nounMapping2SUMO('11378929-n',[ ('Man',instance)]).
nounMapping2SUMO('11379108-n',[ ('Man',instance)]).
nounMapping2SUMO('11379217-n',[ ('Man',instance)]).
nounMapping2SUMO('11379336-n',[ ('Man',instance)]).
nounMapping2SUMO('11379436-n',[ ('Man',instance)]).
nounMapping2SUMO('11379536-n',[ ('Man',instance)]).
nounMapping2SUMO('11379691-n',[ ('Man',instance)]).
nounMapping2SUMO('11379812-n',[ ('Man',instance)]).
nounMapping2SUMO('11379908-n',[ ('Man',instance)]).
nounMapping2SUMO('11380035-n',[ ('Man',instance)]).
nounMapping2SUMO('11380159-n',[ ('Man',instance)]).
nounMapping2SUMO('11380429-n',[ ('Man',instance)]).
nounMapping2SUMO('11380655-n',[ ('Man',instance)]).
nounMapping2SUMO('11380768-n',[ ('Man',instance)]).
nounMapping2SUMO('11380923-n',[ ('Man',instance)]).
nounMapping2SUMO('11381193-n',[ ('Writer',instance)]).
nounMapping2SUMO('11381457-n',[ ('Writer',instance)]).
nounMapping2SUMO('11381583-n',[ ('Writer',instance)]).
nounMapping2SUMO('11381684-n',[ ('Man',instance)]).
nounMapping2SUMO('11381824-n',[ ('Man',instance)]).
nounMapping2SUMO('11381964-n',[ ('Man',instance)]).
nounMapping2SUMO('11382112-n',[ ('Man',instance)]).
nounMapping2SUMO('11382278-n',[ ('Woman',instance)]).
nounMapping2SUMO('11382398-n',[ ('Writer',instance)]).
nounMapping2SUMO('11382555-n',[ ('Man',instance)]).
nounMapping2SUMO('11382688-n',[ ('Man',instance)]).
nounMapping2SUMO('11382795-n',[ ('Woman',instance)]).
nounMapping2SUMO('11382930-n',[ ('Writer',instance)]).
nounMapping2SUMO('11383100-n',[ ('Man',instance)]).
nounMapping2SUMO('11383278-n',[ ('Man',instance)]).
nounMapping2SUMO('11383425-n',[ ('Man',instance)]).
nounMapping2SUMO('11383546-n',[ ('Man',instance)]).
nounMapping2SUMO('11383767-n',[ ('Writer',instance)]).
nounMapping2SUMO('11383917-n',[ ('Man',instance)]).
nounMapping2SUMO('11384022-n',[ ('Man',instance)]).
nounMapping2SUMO('11384159-n',[ ('Writer',instance)]).
nounMapping2SUMO('11384291-n',[ ('Man',instance)]).
nounMapping2SUMO('11384566-n',[ ('Man',instance)]).
nounMapping2SUMO('11384755-n',[ ('Man',instance)]).
nounMapping2SUMO('11384986-n',[ ('Man',instance)]).
nounMapping2SUMO('11385126-n',[ ('Man',instance)]).
nounMapping2SUMO('11385277-n',[ ('Man',instance)]).
nounMapping2SUMO('11385442-n',[ ('Position',instance)]).
nounMapping2SUMO('11385611-n',[ ('Man',instance)]).
nounMapping2SUMO('11385748-n',[ ('Writer',instance)]).
nounMapping2SUMO('11386005-n',[ ('Man',instance)]).
nounMapping2SUMO('11386138-n',[ ('Man',instance)]).
nounMapping2SUMO('11386346-n',[ ('Writer',instance)]).
nounMapping2SUMO('11386503-n',[ ('Man',instance)]).
nounMapping2SUMO('11386692-n',[ ('Writer',instance)]).
nounMapping2SUMO('11386853-n',[ ('Man',instance)]).
nounMapping2SUMO('11387060-n',[ ('Man',instance)]).
nounMapping2SUMO('11387179-n',[ ('Man',instance)]).
nounMapping2SUMO('11387362-n',[ ('Man',instance)]).
nounMapping2SUMO('11387539-n',[ ('Man',instance)]).
nounMapping2SUMO('11387692-n',[ ('Man',instance)]).
nounMapping2SUMO('11387806-n',[ ('Man',instance)]).
nounMapping2SUMO('11387973-n',[ ('Man',instance)]).
nounMapping2SUMO('11388141-n',[ ('Man',instance)]).
nounMapping2SUMO('11388321-n',[ ('Man',instance)]).
nounMapping2SUMO('11388538-n',[ ('Man',instance)]).
nounMapping2SUMO('11388841-n',[ ('Man',instance)]).
nounMapping2SUMO('11389003-n',[ ('Man',instance)]).
nounMapping2SUMO('11389301-n',[ ('Man',instance)]).
nounMapping2SUMO('11389481-n',[ ('Man',instance)]).
nounMapping2SUMO('11389619-n',[ ('Man',instance)]).
nounMapping2SUMO('11389901-n',[ ('Man',instance)]).
nounMapping2SUMO('11390058-n',[ ('Man',instance)]).
nounMapping2SUMO('11390170-n',[ ('Man',instance)]).
nounMapping2SUMO('11390364-n',[ ('Man',instance)]).
nounMapping2SUMO('11390549-n',[ ('Position',instance)]).
nounMapping2SUMO('11390692-n',[ ('Man',instance)]).
nounMapping2SUMO('11390855-n',[ ('Man',instance)]).
nounMapping2SUMO('11391123-n',[ ('Man',instance)]).
nounMapping2SUMO('11391234-n',[ ('Man',instance)]).
nounMapping2SUMO('11391379-n',[ ('Man',instance)]).
nounMapping2SUMO('11391587-n',[ ('Man',instance)]).
nounMapping2SUMO('11391759-n',[ ('Man',instance)]).
nounMapping2SUMO('11391915-n',[ ('Man',instance)]).
nounMapping2SUMO('11392082-n',[ ('Man',instance)]).
nounMapping2SUMO('11392210-n',[ ('Writer',instance)]).
nounMapping2SUMO('11392368-n',[ ('Writer',instance)]).
nounMapping2SUMO('11392539-n',[ ('Man',instance)]).
nounMapping2SUMO('11392754-n',[ ('Man',instance)]).
nounMapping2SUMO('11392913-n',[ ('Man',instance)]).
nounMapping2SUMO('11393124-n',[ ('Man',instance)]).
nounMapping2SUMO('11393315-n',[ ('Man',instance)]).
nounMapping2SUMO('11393446-n',[ ('Writer',instance)]).
nounMapping2SUMO('11393546-n',[ ('Man',instance)]).
nounMapping2SUMO('11393828-n',[ ('Man',instance)]).
nounMapping2SUMO('11394042-n',[ ('Writer',instance)]).
nounMapping2SUMO('11394214-n',[ ('Man',instance)]).
nounMapping2SUMO('11394398-n',[ ('Man',instance)]).
nounMapping2SUMO('11394491-n',[ ('Writer',instance)]).
nounMapping2SUMO('11394657-n',[ ('Writer',instance)]).
nounMapping2SUMO('11394848-n',[ ('Man',instance)]).
nounMapping2SUMO('11394954-n',[ ('Man',instance)]).
nounMapping2SUMO('11395199-n',[ ('Writer',instance)]).
nounMapping2SUMO('11395466-n',[ ('Man',instance)]).
nounMapping2SUMO('11395609-n',[ ('Writer',instance)]).
nounMapping2SUMO('11395773-n',[ ('Man',instance)]).
nounMapping2SUMO('11395895-n',[ ('Woman',instance)]).
nounMapping2SUMO('11396000-n',[ ('Woman',instance)]).
nounMapping2SUMO('11396128-n',[ ('Woman',instance)]).
nounMapping2SUMO('11396338-n',[ ('Man',instance)]).
nounMapping2SUMO('11396535-n',[ ('Man',instance)]).
nounMapping2SUMO('11396667-n',[ ('Writer',instance)]).
nounMapping2SUMO('11396943-n',[ ('Man',instance)]).
nounMapping2SUMO('11397094-n',[ ('Man',instance)]).
nounMapping2SUMO('11397271-n',[ ('Man',instance)]).
nounMapping2SUMO('11397488-n',[ ('Man',instance)]).
nounMapping2SUMO('11397657-n',[ ('Man',instance)]).
nounMapping2SUMO('11397885-n',[ ('Man',instance)]).
nounMapping2SUMO('11398094-n',[ ('Writer',instance)]).
nounMapping2SUMO('11398195-n',[ ('Man',instance)]).
nounMapping2SUMO('11398344-n',[ ('Man',instance)]).
nounMapping2SUMO('11398489-n',[ ('Man',instance)]).
nounMapping2SUMO('11398611-n',[ ('Man',instance)]).
nounMapping2SUMO('11398783-n',[ ('Man',instance)]).
nounMapping2SUMO('11398955-n',[ ('Writer',instance)]).
nounMapping2SUMO('11399123-n',[ ('Writer',instance)]).
nounMapping2SUMO('11399274-n',[ ('Man',instance)]).
nounMapping2SUMO('11399446-n',[ ('Man',instance)]).
nounMapping2SUMO('11399620-n',[ ('Man',instance)]).
nounMapping2SUMO('11399716-n',[ ('Man',instance)]).
nounMapping2SUMO('11399866-n',[ ('Man',instance)]).
nounMapping2SUMO('11400126-n',[ ('Man',instance)]).
nounMapping2SUMO('11400230-n',[ ('Man',instance)]).
nounMapping2SUMO('11400490-n',[ ('Man',instance)]).
nounMapping2SUMO('11400594-n',[ ('Woman',instance)]).
nounMapping2SUMO('11400704-n',[ ('Woman',instance)]).
nounMapping2SUMO('11400837-n',[ ('Man',instance)]).
nounMapping2SUMO('11401009-n',[ ('Man',instance)]).
nounMapping2SUMO('11401194-n',[ ('Man',instance)]).
nounMapping2SUMO('11401282-n',[ ('Man',instance)]).
nounMapping2SUMO('11401418-n',[ ('Man',instance)]).
nounMapping2SUMO('11401617-n',[ ('Man',instance)]).
nounMapping2SUMO('11401797-n',[ ('Man',instance)]).
nounMapping2SUMO('11401947-n',[ ('Man',instance)]).
nounMapping2SUMO('11402120-n',[ ('Man',instance)]).
nounMapping2SUMO('11402341-n',[ ('Man',instance)]).
nounMapping2SUMO('11402463-n',[ ('Man',instance)]).
nounMapping2SUMO('11402626-n',[ ('Man',instance)]).
nounMapping2SUMO('11402801-n',[ ('Man',instance)]).
nounMapping2SUMO('11403015-n',[ ('Man',instance)]).
nounMapping2SUMO('11403220-n',[ ('Man',instance)]).
nounMapping2SUMO('11403456-n',[ ('Man',instance)]).
nounMapping2SUMO('11403600-n',[ ('Man',instance)]).
nounMapping2SUMO('11403692-n',[ ('Man',instance)]).
nounMapping2SUMO('11403828-n',[ ('Man',instance)]).
nounMapping2SUMO('11404140-n',[ ('Man',instance)]).
nounMapping2SUMO('11404280-n',[ ('Woman',instance)]).
nounMapping2SUMO('11404402-n',[ ('Man',instance)]).
nounMapping2SUMO('11404666-n',[ ('Man',instance)]).
nounMapping2SUMO('11404871-n',[ ('Writer',instance)]).
nounMapping2SUMO('11404971-n',[ ('Man',instance)]).
nounMapping2SUMO('11405176-n',[ ('Man',instance)]).
nounMapping2SUMO('11405319-n',[ ('Man',instance)]).
nounMapping2SUMO('11405437-n',[ ('Man',instance)]).
nounMapping2SUMO('11405684-n',[ ('Man',instance)]).
nounMapping2SUMO('11405826-n',[ ('Man',instance)]).
nounMapping2SUMO('11406023-n',[ ('Man',instance)]).
nounMapping2SUMO('11406141-n',[ ('Man',instance)]).
nounMapping2SUMO('11406314-n',[ ('Man',instance)]).
nounMapping2SUMO('11406460-n',[ ('Man',instance)]).
nounMapping2SUMO('11406700-n',[ ('Man',instance)]).
nounMapping2SUMO('11406906-n',[ ('Man',instance)]).
nounMapping2SUMO('11407048-n',[ ('Man',instance)]).
nounMapping2SUMO('11407175-n',[ ('Man',instance)]).
nounMapping2SUMO('11407302-n',[ ('Man',instance)]).
nounMapping2SUMO('11407465-n',[ ('Man',instance)]).
nounMapping2SUMO('11407591-n',[ ('Man',instance)]).
nounMapping2SUMO('11407715-n',[ ('Man',instance)]).
nounMapping2SUMO('11407865-n',[ ('Man',instance)]).
nounMapping2SUMO('11408041-n',[ ('Man',instance)]).
nounMapping2SUMO('11408148-n',[ ('Writer',instance)]).
nounMapping2SUMO('11408243-n',[ ('Man',instance)]).
nounMapping2SUMO('11408414-n',[ ('Man',instance)]).
nounMapping2SUMO('11408559-n',[ ('IntentionalProcess',not(subsumption))]).
nounMapping2SUMO('11408733-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11408914-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('11409059-n',[ ('ChemicalProcess',equivalence)]).
nounMapping2SUMO('11409329-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('11409538-n',[ ('ChemicalSynthesis',equivalence)]).
nounMapping2SUMO('11409689-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('11409892-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('11410023-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('11410172-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('11410298-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('11410527-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('11410625-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11411501-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11411610-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11411839-n',[ ('Physical',subsumption)]).
nounMapping2SUMO('11412179-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('11412334-n',[ ('Physical',subsumption)]).
nounMapping2SUMO('11412592-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11412727-n',[ ('Process',equivalence)]).
nounMapping2SUMO('11412993-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('11413263-n',[ ('Physical',subsumption)]).
nounMapping2SUMO('11413661-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11413800-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('11414041-n',[ ('Physical',subsumption)]).
nounMapping2SUMO('11414257-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('11414411-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11414608-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11414874-n',[ ('Physical',subsumption)]).
nounMapping2SUMO('11415084-n',[ ('Translocation',subsumption)]).
nounMapping2SUMO('11415342-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('11415492-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('11415608-n',[ ('Physical',subsumption)]).
nounMapping2SUMO('11415721-n',[ ('NaturalProcess',subsumption)]).
nounMapping2SUMO('11415842-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11416087-n',[ ('Physical',subsumption)]).
nounMapping2SUMO('11416534-n',[ ('Physical',subsumption)]).
nounMapping2SUMO('11416722-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11416988-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11417129-n',[ ('Expressing',equivalence)]).
nounMapping2SUMO('11417387-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11417561-n',[ ('Device',subsumption)]).
nounMapping2SUMO('11417672-n',[ ('IntentionalProcess',not(subsumption))]).
nounMapping2SUMO('11418011-n',[ ('IntentionalProcess',not(subsumption))]).
nounMapping2SUMO('11418138-n',[ ('IntentionalProcess',not(subsumption))]).
nounMapping2SUMO('11418460-n',[ ('IntentionalProcess',not(subsumption))]).
nounMapping2SUMO('11418750-n',[ ('BiologicalProcess',equivalence)]).
nounMapping2SUMO('11419404-n',[ ('IntentionalProcess',not(subsumption))]).
nounMapping2SUMO('11420139-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11420376-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11420631-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('11420831-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11421214-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11421401-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11421618-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11421822-n',[ ('RadiatingNuclear',subsumption)]).
nounMapping2SUMO('11422114-n',[ ('Newton',subsumption)]).
nounMapping2SUMO('11422277-n',[ ('Force',subsumption)]).
nounMapping2SUMO('11422446-n',[ ('Force',subsumption)]).
nounMapping2SUMO('11422597-n',[ ('GasMixture',equivalence)]).
nounMapping2SUMO('11422822-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11423028-n',[ ('Region',subsumption)]).
nounMapping2SUMO('11423197-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11423356-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11423471-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('11423607-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11423756-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11423952-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11424194-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('11424400-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11424589-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('11424704-n',[ ('Ampere',subsumption)]).
nounMapping2SUMO('11424816-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11424938-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11425088-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11425401-n',[ ('IntentionalProcess',not(subsumption))]).
nounMapping2SUMO('11425580-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11425989-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11426125-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11426288-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11426530-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11426778-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('11426914-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11427067-n',[ ('Region',subsumption)]).
nounMapping2SUMO('11427241-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11427501-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11427619-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11427736-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11427842-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('11428023-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11428379-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11428567-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11428699-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11428862-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11429057-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11429238-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11429356-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11429458-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11429661-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11429968-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11430483-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11430659-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11430863-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11431058-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11431191-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11431302-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11431617-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11431754-n',[ ('Wind',subsumption)]).
nounMapping2SUMO('11432155-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11432262-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11432387-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11432508-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11432632-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11432758-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11432887-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11433013-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11433140-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11433297-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11433435-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11433546-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11433698-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11433806-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11434016-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11434150-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11434448-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11434594-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11434747-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11434899-n',[ ('PhysicalState',subsumption)]).
nounMapping2SUMO('11435028-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11435358-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11435541-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11435661-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11435871-n',[ ('PhysicalState',subsumption)]).
nounMapping2SUMO('11436019-n',[ ('PhysicalState',subsumption)]).
nounMapping2SUMO('11436163-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('11436283-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11436491-n',[ ('ChemicalSynthesis',equivalence)]).
nounMapping2SUMO('11436585-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11436748-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11436929-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11437111-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11437344-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11437577-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11437823-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11437957-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11438105-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11438260-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11438468-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11438612-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11438756-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11438904-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('11439031-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('11439312-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('11439446-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('11439566-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('11439690-n',[ ('Cloud',equivalence)]).
nounMapping2SUMO('11439924-n',[ ('WeatherProcess',subsumption)]).
nounMapping2SUMO('11440012-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('11440123-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11440521-n',[ ('Freezing',subsumption)]).
nounMapping2SUMO('11440691-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11440802-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11441077-n',[ ('RadiatingElectromagnetic',subsumption)]).
nounMapping2SUMO('11441416-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('11441561-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11441707-n',[ ('RadiatingElectromagnetic',subsumption)]).
nounMapping2SUMO('11441980-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('11442073-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('11442298-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11442524-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11442630-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11442752-n',[ ('Wind',subsumption)]).
nounMapping2SUMO('11442894-n',[ ('Wind',subsumption)]).
nounMapping2SUMO('11443057-n',[ ('Wind',subsumption)]).
nounMapping2SUMO('11443173-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11443283-n',[ ('Wind',subsumption)]).
nounMapping2SUMO('11443409-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11443532-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11443721-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11443929-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11444038-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11444117-n',[ ('Death',equivalence)]).
nounMapping2SUMO('11444371-n',[ ('IntentionalProcess',not(subsumption))]).
nounMapping2SUMO('11444643-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('11444816-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('11445187-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11445395-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('11445564-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('11445753-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('11445960-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('11446067-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('11446242-n',[ ('Condensing',subsumption)]).
nounMapping2SUMO('11446459-n',[ ('Condensing',subsumption)]).
nounMapping2SUMO('11446598-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('11446771-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11446934-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11447153-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11447319-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11447532-n',[ ('ComputerProcess',subsumption)]).
nounMapping2SUMO('11447691-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11447851-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11448013-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11448153-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11448343-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11448475-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11448593-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11448714-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11448835-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11449002-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11449419-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11449561-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11449658-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11449784-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('11449907-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11450453-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11450566-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11450869-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11451310-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11451442-n',[ ('Radiating',equivalence)]).
nounMapping2SUMO('11451944-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11452079-n',[ ('Joule',equivalence)]).
nounMapping2SUMO('11452218-n',[ ('Joule',equivalence)]).
nounMapping2SUMO('11452750-n',[ ('Joule',subsumption)]).
nounMapping2SUMO('11453016-n',[ ('Watt',equivalence)]).
nounMapping2SUMO('11453210-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11453420-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11453735-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11453860-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11454042-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('11454310-n',[ ('Reflecting',subsumption)]).
nounMapping2SUMO('11454470-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11454591-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('11454953-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('11455092-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('11455236-n',[ ('Water',subsumption)]).
nounMapping2SUMO('11455386-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('11455695-n',[ ('Region',subsumption)]).
nounMapping2SUMO('11455901-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11456083-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11456273-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11456462-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11456615-n',[ ('Icon',instance)]).
nounMapping2SUMO('11456760-n',[ ('AtmosphericRegion',subsumption)]).
nounMapping2SUMO('11457057-n',[ ('Region',subsumption)]).
nounMapping2SUMO('11457283-n',[ ('Region',subsumption)]).
nounMapping2SUMO('11457392-n',[ ('Region',subsumption)]).
nounMapping2SUMO('11457496-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('11457586-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('11457841-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11457944-n',[ ('Combustion',subsumption)]).
nounMapping2SUMO('11458102-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11458314-n',[ ('Fog',equivalence)]).
nounMapping2SUMO('11458514-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('11458624-n',[ ('Newton',equivalence)]).
nounMapping2SUMO('11459200-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11459369-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11459538-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('11459748-n',[ ('GeographicArea',subsumption)]).
nounMapping2SUMO('11459907-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('11460063-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('11460281-n',[ ('Touching',subsumption)]).
nounMapping2SUMO('11460488-n',[ ('StormFront',equivalence)]).
nounMapping2SUMO('11460728-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11460829-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11460962-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11461080-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11461268-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('11461563-n',[ ('Region',subsumption)]).
nounMapping2SUMO('11461684-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11461825-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11462013-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11462152-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11462276-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11462401-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11462526-n',[ ('WeatherFront',subsumption)]).
nounMapping2SUMO('11462951-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11463073-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11463265-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11463371-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11463544-n',[ ('RadiatingVisibleLight',subsumption)]).
nounMapping2SUMO('11463647-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11463746-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('11463895-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11464027-n',[ ('Region',subsumption)]).
nounMapping2SUMO('11464143-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11464784-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11464926-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('11465017-n',[ ('Wind',subsumption)]).
nounMapping2SUMO('11465297-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11465425-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11465530-n',[ ('Water',subsumption)]).
nounMapping2SUMO('11465688-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11465775-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11465888-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('11466043-n',[ ('Heating',equivalence)]).
nounMapping2SUMO('11466337-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('11466458-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('11466701-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('11466834-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('11466909-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('11467018-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11467202-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11467318-n',[ ('IntentionalProcess',not(subsumption))]).
nounMapping2SUMO('11467543-n',[ ('Fog',subsumption)]).
nounMapping2SUMO('11467650-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11467786-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11467996-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('11468172-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11468442-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11468578-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11468763-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('11468973-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('11469108-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11469265-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11469481-n',[ ('RadiatingInfrared',subsumption)]).
nounMapping2SUMO('11469691-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11469827-n',[ ('Reflecting',subsumption)]).
nounMapping2SUMO('11470008-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11470139-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11470348-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11470492-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11470621-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('11470765-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('11470933-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('11471097-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('11471359-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('11471578-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('11471828-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('11471977-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('11472131-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('11472352-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('11472503-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11472612-n',[ ('WeatherProcess',subsumption)]).
nounMapping2SUMO('11472699-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11472820-n',[ ('RadiatingInfrared',equivalence)]).
nounMapping2SUMO('11472960-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11473033-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11473138-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('11473291-n',[ ('Living',equivalence)]).
nounMapping2SUMO('11473488-n',[ ('BiologicalProcess',equivalence)]).
nounMapping2SUMO('11473685-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('11473807-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('11473954-n',[ ('RadiatingVisibleLight',subsumption)]).
nounMapping2SUMO('11474637-n',[ ('RadiatingElectromagnetic',equivalence)]).
nounMapping2SUMO('11474774-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11475067-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11475279-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11475476-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11475682-n',[ ('Newton',subsumption)]).
nounMapping2SUMO('11475992-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11476231-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11476430-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11476619-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11476767-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11476939-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11477041-n',[ ('Region',subsumption)]).
nounMapping2SUMO('11477269-n',[ ('Region',subsumption)]).
nounMapping2SUMO('11477384-n',[ ('Region',subsumption)]).
nounMapping2SUMO('11477582-n',[ ('AtmosphericRegion',subsumption)]).
nounMapping2SUMO('11477710-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11477921-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('11478171-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11478299-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11478514-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11478682-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11478898-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11479058-n',[ ('Magnetism',subsumption)]).
nounMapping2SUMO('11479368-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11479640-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11479816-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11480091-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11480284-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11480521-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11480698-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11480930-n',[ ('RadiatingSound',equivalence)]).
nounMapping2SUMO('11481209-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('11481334-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('11481487-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('11481627-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11481824-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('11482013-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11482140-n',[ ('Melting',equivalence)]).
nounMapping2SUMO('11482312-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11482579-n',[ ('AstronomicalBody',instance)]).
nounMapping2SUMO('11482706-n',[ ('Fog',equivalence)]).
nounMapping2SUMO('11482873-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11482985-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11483179-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11483354-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11483472-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11483580-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11483829-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11483990-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('11484260-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('11484375-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('11484570-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11484741-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11484861-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11484975-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11485186-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11485264-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('11485367-n',[ ('Sunlight',subsumption)]).
nounMapping2SUMO('11485582-n',[ ('Sunlight',subsumption)]).
nounMapping2SUMO('11485681-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11485774-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11485907-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11486049-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11486178-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('11486381-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('11486708-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('11486983-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('11487078-n',[ ('Death',subsumption)]).
nounMapping2SUMO('11487298-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11487424-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11487533-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11487732-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11487950-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11488160-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11488387-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11488601-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11488828-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11489070-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11489230-n',[ ('WaterCurrent',subsumption)]).
nounMapping2SUMO('11489383-n',[ ('WaterCurrent',subsumption)]).
nounMapping2SUMO('11489536-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11489686-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11489878-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11490058-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('11490257-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('11490335-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('11490463-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('11490638-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11490934-n',[ ('WaterCloud',subsumption)]).
nounMapping2SUMO('11491026-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11491194-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11491308-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11491619-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('11491816-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11492014-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11492240-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11492388-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('11492643-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('11492833-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('11493083-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('11493266-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('11493452-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('11493827-n',[ ('Volt',subsumption)]).
nounMapping2SUMO('11494076-n',[ ('Volt',subsumption)]).
nounMapping2SUMO('11494287-n',[ ('Volt',subsumption)]).
nounMapping2SUMO('11494472-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11494638-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11494935-n',[ ('Pascal',subsumption)]).
nounMapping2SUMO('11495041-n',[ ('Pascal',equivalence)]).
nounMapping2SUMO('11495607-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11495708-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11495822-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11495964-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11496157-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11496296-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11496503-n',[ ('Pascal',subsumption)]).
nounMapping2SUMO('11496746-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11496881-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11497173-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11497378-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11497586-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11497777-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11497888-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11498040-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11498203-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11498461-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11498679-n',[ ('Explosion',subsumption)]).
nounMapping2SUMO('11498850-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11499091-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11499284-n',[ ('Radiating',equivalence)]).
nounMapping2SUMO('11499510-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11499817-n',[ ('RadioEmission',subsumption)]).
nounMapping2SUMO('11500122-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11500349-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11500458-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11500570-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11500679-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11500816-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11500968-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11501230-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11501381-n',[ ('Raining',subsumption)]).
nounMapping2SUMO('11501649-n',[ ('Water',subsumption)]).
nounMapping2SUMO('11501737-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11501864-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11501988-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11502102-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11502322-n',[ ('Raining',subsumption)]).
nounMapping2SUMO('11502497-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11502695-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('11503060-n',[ ('Reflecting',subsumption)]).
nounMapping2SUMO('11503287-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11503482-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11503644-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11503813-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('11503968-n',[ ('Ohm',equivalence)]).
nounMapping2SUMO('11504225-n',[ ('Ohm',subsumption)]).
nounMapping2SUMO('11504313-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11504478-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11504750-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11504898-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11505057-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('11505210-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11505318-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('11505546-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('11505769-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('11505952-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11506167-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11506349-n',[ ('RadiatingVisibleLight',subsumption)]).
nounMapping2SUMO('11506549-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('11506738-n',[ ('Cutting',equivalence)]).
nounMapping2SUMO('11507000-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11507174-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11507321-n',[ ('RadioEmission',subsumption)]).
nounMapping2SUMO('11507511-n',[ ('RadioEmission',subsumption)]).
nounMapping2SUMO('11507655-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11507797-n',[ ('ProbabilityRelation',subsumption)]).
nounMapping2SUMO('11507951-n',[ ('Water',subsumption)]).
nounMapping2SUMO('11508092-n',[ ('Smoke',equivalence)]).
nounMapping2SUMO('11508303-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('11508382-n',[ ('Snowing',subsumption)]).
nounMapping2SUMO('11508578-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11508808-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11509066-n',[ ('Water',subsumption)]).
nounMapping2SUMO('11509204-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11509377-n',[ ('Water',subsumption)]).
nounMapping2SUMO('11509570-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11509697-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11509968-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11510067-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11510223-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11510411-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11510571-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11510714-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11510896-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('11511004-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11511176-n',[ ('Region',subsumption)]).
nounMapping2SUMO('11511327-n',[ ('Region',subsumption)]).
nounMapping2SUMO('11511405-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11511523-n',[ ('Spark',equivalence)]).
nounMapping2SUMO('11511765-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11512144-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11512331-n',[ ('RadiatingSound',subsumption)]).
nounMapping2SUMO('11512650-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11512818-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11512992-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11513179-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11513357-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11513631-n',[ ('Region',subsumption)]).
nounMapping2SUMO('11513761-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('11513880-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11514008-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11514171-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11514288-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11514462-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11514559-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11514672-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11514805-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11515051-n',[ ('Stretching',equivalence)]).
nounMapping2SUMO('11515325-n',[ ('ShapeChange',subsumption)]).
nounMapping2SUMO('11515526-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11515644-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('11515734-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11515849-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11515935-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11516113-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11516439-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11516659-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11516819-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11517041-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11517210-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11517494-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11517656-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11517776-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11517898-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11517999-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11518168-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11518330-n',[ ('AstronomicalBody',subsumption)]).
nounMapping2SUMO('11518494-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11518645-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11518743-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11518915-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11519121-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11519253-n',[ ('WeatherProcess',subsumption)]).
nounMapping2SUMO('11519450-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11519702-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11519799-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('11519949-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11520120-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11520271-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11520435-n',[ ('IntentionalProcess',not(subsumption))]).
nounMapping2SUMO('11520619-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('11520821-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('11520989-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11521145-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11521267-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11521404-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11521534-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11521665-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11521824-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11521940-n',[ ('RadiatingUltraviolet',subsumption)]).
nounMapping2SUMO('11522206-n',[ ('RadiatingUltraviolet',subsumption)]).
nounMapping2SUMO('11522325-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11522448-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11522649-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11522730-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11522815-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11523031-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11523256-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('11523369-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('11523538-n',[ ('Volt',equivalence)]).
nounMapping2SUMO('11523736-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11523839-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11524110-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11524213-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11524324-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11524451-n',[ ('WeatherProcess',subsumption)]).
nounMapping2SUMO('11524662-n',[ ('WeatherProcess',subsumption)]).
nounMapping2SUMO('11525303-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11525480-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11525614-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11525779-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('11525955-n',[ ('Wind',equivalence)]).
nounMapping2SUMO('11526894-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('11527014-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11527177-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11527386-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('11527556-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11527767-n',[ ('Meat',subsumption)]).
nounMapping2SUMO('11527967-n',[ ('Process',subsumption)]).
nounMapping2SUMO('11528225-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('11528427-n',[ ('RadiatingLight',subsumption)]).
nounMapping2SUMO('11528636-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('11528841-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('11528939-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('11529158-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('11529295-n',[ ('Physical',subsumption)]).
nounMapping2SUMO('11529441-n',[ ('VisualAttribute',subsumption)]).
nounMapping2SUMO('11529603-n',[ ('Plant',equivalence)]).
nounMapping2SUMO('11530008-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('11530149-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('11530283-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('11530512-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('11530715-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('11530860-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('11530990-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('11531090-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('11531193-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('11531334-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11531457-n',[ ('NonFloweringPlant',equivalence)]).
nounMapping2SUMO('11531701-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('11531916-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11532017-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11532194-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11532351-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11532547-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('11532682-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11532816-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11533026-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11533212-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11533365-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11533472-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11533622-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11533772-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11533999-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11534161-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11534360-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11534434-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('11534677-n',[ ('Plant',equivalence)]).
nounMapping2SUMO('11536087-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('11536230-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('11536369-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('11536567-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('11536673-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('11536778-n',[ ('Moss',equivalence)]).
nounMapping2SUMO('11537327-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11537506-n',[ ('Moss',equivalence)]).
nounMapping2SUMO('11537665-n',[ ('Moss',equivalence)]).
nounMapping2SUMO('11537886-n',[ ('Moss',equivalence)]).
nounMapping2SUMO('11538123-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11538341-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11538582-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11538716-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11538820-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11538935-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11539289-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11539467-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11539675-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11539825-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11540000-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11540230-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11540439-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11540631-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11540747-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11540970-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11541111-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11541322-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11541579-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11541713-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11541919-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11542137-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11542341-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11542640-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11542920-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11543105-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11543264-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11543429-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11543602-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11543792-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11544015-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11544131-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11544314-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11544540-n',[ ('Moss',subsumption)]).
nounMapping2SUMO('11544769-n',[ ('Fern',equivalence)]).
nounMapping2SUMO('11545214-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('11545350-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('11545524-n',[ ('Fern',equivalence)]).
nounMapping2SUMO('11545714-n',[ ('Fern',equivalence)]).
nounMapping2SUMO('11547562-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('11547737-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11547855-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11548465-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11548594-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11548728-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11548870-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11549009-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11549138-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11549245-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11549391-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11549487-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11549638-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11549779-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11549895-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11550022-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11550205-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11550340-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11550474-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11550620-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11550725-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11550890-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11551044-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11551211-n',[ ('FloweringPlant',equivalence)]).
nounMapping2SUMO('11551659-n',[ ('FloweringPlant',equivalence)]).
nounMapping2SUMO('11551898-n',[ ('NonFloweringPlant',equivalence)]).
nounMapping2SUMO('11552133-n',[ ('NonFloweringPlant',equivalence)]).
nounMapping2SUMO('11552386-n',[ ('FloweringPlant',equivalence)]).
nounMapping2SUMO('11552594-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11552686-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11552806-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11552976-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11553240-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11553419-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('11553522-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('11553634-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('11553763-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11554175-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11555413-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11556187-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11556857-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11561228-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11562747-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11564258-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11564734-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11565040-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11565385-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11566230-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11566682-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11567411-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11571907-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11573173-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11573660-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11575425-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11579418-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11585340-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11590783-n',[ ('Fungus',equivalence)]).
nounMapping2SUMO('11592146-n',[ ('Fungus',equivalence)]).
nounMapping2SUMO('11594676-n',[ ('Fungus',equivalence)]).
nounMapping2SUMO('11595312-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11596108-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11596344-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11596486-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11596845-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11597126-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11597396-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11597657-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11597924-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11598100-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11598287-n',[ ('Shrub',subsumption)]).
nounMapping2SUMO('11598452-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11598686-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11598886-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11598991-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11599165-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11599324-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11599694-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11600139-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11600372-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11600671-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11600900-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11601177-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11601333-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11601487-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11601757-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11601918-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11602091-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11602304-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11602478-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11602671-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11602873-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11603045-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11603246-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11603462-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11603630-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11603835-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11604046-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11604225-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11604393-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11604576-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11604698-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11604904-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11605147-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11605396-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11605542-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11605708-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11606379-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11606661-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11606846-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11607071-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11607392-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11607739-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11608055-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11608250-n',[ ('PineTree',equivalence)]).
nounMapping2SUMO('11608885-n',[ ('Wood',subsumption)]).
nounMapping2SUMO('11609122-n',[ ('Wood',subsumption)]).
nounMapping2SUMO('11609251-n',[ ('Wood',subsumption)]).
nounMapping2SUMO('11609362-n',[ ('Wood',subsumption)]).
nounMapping2SUMO('11609475-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11609684-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11609862-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11610047-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11610215-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11610437-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11610602-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11610823-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11611087-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11611233-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11611356-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11611561-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11611758-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11612018-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11612235-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11612349-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11612575-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11612923-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11613219-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11613459-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11613692-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11613867-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11614039-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11614250-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11614420-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11614713-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11615026-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11615259-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11615387-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11615607-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11615812-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11615967-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11616260-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11616486-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11616662-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11616852-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11617090-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11617272-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11617631-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11617878-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11618079-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11618290-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11618525-n',[ ('PineTree',subsumption)]).
nounMapping2SUMO('11618750-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11618861-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11619136-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11619227-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11619455-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11619687-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11619845-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11620016-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11620248-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11620389-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11620560-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11620673-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11620912-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11621029-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11621281-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11621547-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11621727-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11621950-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11622184-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11622368-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11622591-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11622771-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11622988-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11623105-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11623304-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11623556-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11623685-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11623815-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11623967-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11624192-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11624367-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11624531-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11624840-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11625003-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11625223-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11625391-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11625632-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11625804-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11626010-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11626152-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11626409-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11626585-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11626826-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11627028-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11627168-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11627364-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11627512-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11627714-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11627908-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11628087-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11628284-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11628456-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11628678-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11628793-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11629047-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11629211-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11629354-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11629501-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11630017-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11630351-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11630489-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11630890-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11631159-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11631405-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11631619-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11631854-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11631985-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11632167-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11632376-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11632619-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11632794-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11632929-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11633116-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11633284-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11633459-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11633633-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11633863-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11633999-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11634243-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11634393-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11634526-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11634736-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11634970-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11635152-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11635433-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11635709-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11635830-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11636068-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11636204-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11636389-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11636566-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11636835-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('11637015-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11637247-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11637482-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11637659-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11637810-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11637991-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11638109-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11638378-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11638525-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11638698-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11638902-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11639084-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11639306-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11639445-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11639609-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11639863-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11640132-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11640471-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11640645-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11640898-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11641034-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11641275-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11641494-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11641788-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11641963-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11642243-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11642430-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11642622-n',[ ('FloweringPlant',instance)]).
nounMapping2SUMO('11642912-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11643022-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11643354-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11643506-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11643684-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11643835-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11644046-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11644226-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11644462-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11644712-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11644872-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11645041-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11645163-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11645271-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11645590-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11645783-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11645914-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11646167-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11646344-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11646517-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11646694-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11646955-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11647131-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11647306-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11647548-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11647703-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11647868-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11648039-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11648268-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11648428-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11648617-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11648776-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11649012-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11649150-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11649359-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11649597-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11649749-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11649878-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11650160-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11650307-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11650430-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11650558-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11650759-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11650919-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11651133-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11651259-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11651731-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11652039-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11652217-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11652376-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11652578-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11652753-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11652966-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11653126-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11653323-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11653570-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11653728-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11653904-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11654124-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11654293-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11654438-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11654667-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11654984-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11655152-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11655407-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11655592-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11655764-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11655974-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11656123-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11656380-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11656549-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11656771-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11656974-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11657153-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11657314-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11657585-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11657763-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11657904-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11658104-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11658331-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11658544-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11658709-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11658872-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11659068-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11659248-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11659500-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11659627-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11659909-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11660121-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11660300-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11660537-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11660848-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11660979-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11661207-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11661372-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11661707-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11661909-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11662128-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11662371-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11662585-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11662764-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11662937-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11663136-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11663263-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11663449-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11663813-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11664090-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11664301-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11664418-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11664677-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('11664929-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11665372-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11665648-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11665781-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11666854-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11667112-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11667562-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11668117-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11668340-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11668573-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11668952-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11669335-n',[ ('Flower',subsumption)]).
nounMapping2SUMO('11669786-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11669921-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11672269-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11672400-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11674019-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11674105-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11674332-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11674603-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11674798-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11674914-n',[ ('Flower',subsumption)]).
nounMapping2SUMO('11675025-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11675096-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11675245-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11675404-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11675537-n',[ ('Pollen',equivalence)]).
nounMapping2SUMO('11675738-n',[ ('Pollen',subsumption)]).
nounMapping2SUMO('11675842-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11676500-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11676743-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11676850-n',[ ('PlantBranch',subsumption)]).
nounMapping2SUMO('11676963-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11677045-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11677144-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11677259-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11677485-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11677603-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11677743-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11677902-n',[ ('PlantBranch',subsumption)]).
nounMapping2SUMO('11678010-n',[ ('PlantBranch',subsumption)]).
nounMapping2SUMO('11678123-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11678199-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11678299-n',[ ('PlantBranch',subsumption)]).
nounMapping2SUMO('11678377-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11678493-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('11678635-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11678768-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11679085-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11679250-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11679378-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('11679528-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11679652-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11679779-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11679909-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11680032-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('11680277-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('11680457-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11680596-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11680838-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11680995-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('11681255-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('11681393-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('11681554-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('11681692-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('11681865-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('11682003-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('11682166-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('11682349-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('11682512-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('11682659-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11682842-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11683105-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11683216-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11683331-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11683443-n',[ ('BodyJunction',subsumption)]).
nounMapping2SUMO('11683556-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('11683747-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('11683838-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11683989-n',[ ('Seed',subsumption)]).
nounMapping2SUMO('11684264-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('11684499-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('11684654-n',[ ('BodyCovering',subsumption)]).
nounMapping2SUMO('11684739-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11685091-n',[ ('Seed',subsumption)]).
nounMapping2SUMO('11685179-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11685400-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11685512-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11685621-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11685766-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11685876-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11686049-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11686195-n',[ ('PlantLeaf',subsumption)]).
nounMapping2SUMO('11686398-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11686503-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('11686652-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('11686780-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11686912-n',[ ('DevelopmentalAttribute',subsumption)]).
nounMapping2SUMO('11687071-n',[ ('DevelopmentalAttribute',subsumption)]).
nounMapping2SUMO('11687266-n',[ ('DevelopmentalAttribute',subsumption)]).
nounMapping2SUMO('11687432-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('11687553-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11687681-n',[ ('DevelopmentalAttribute',subsumption)]).
nounMapping2SUMO('11687789-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11687964-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('11688069-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11688199-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11688378-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11688552-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('11688750-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11688958-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11689054-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11689197-n',[ ('Seed',subsumption)]).
nounMapping2SUMO('11689367-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11689483-n',[ ('Oilseed',equivalence)]).
nounMapping2SUMO('11689678-n',[ ('Seed',subsumption)]).
nounMapping2SUMO('11689815-n',[ ('Seed',subsumption)]).
nounMapping2SUMO('11689957-n',[ ('Seed',subsumption)]).
nounMapping2SUMO('11690088-n',[ ('Seed',subsumption)]).
nounMapping2SUMO('11690169-n',[ ('Seed',subsumption)]).
nounMapping2SUMO('11690254-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('11690455-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11690612-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11690737-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11690893-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11691046-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11691332-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11691523-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11691857-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('11691990-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11692108-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11692265-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11692604-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11692792-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11692952-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11693566-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11693812-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11693981-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11694300-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11694469-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11694664-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11694866-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11695085-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11695285-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11695485-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11695599-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11695813-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11695974-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11696211-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11696338-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11696450-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11696606-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11696776-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11696935-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11697158-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11697388-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11697560-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11697802-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11698042-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11698245-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11698433-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11698562-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11698895-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11699071-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11699283-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11699442-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11699751-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11699915-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11700058-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11700279-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11700401-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11700676-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11700864-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11701066-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11701302-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11701492-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11701698-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11701903-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11702081-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11702252-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11702428-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11702566-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11702713-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11702999-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11703205-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11703386-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11703669-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11703935-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11704093-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11704401-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11704620-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11704791-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11705052-n',[ ('Cinnamon',equivalence)]).
nounMapping2SUMO('11705171-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11705387-n',[ ('Cinnamon',subsumption)]).
nounMapping2SUMO('11705573-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11705776-n',[ ('Cinnamon',subsumption)]).
nounMapping2SUMO('11705921-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11706120-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11706325-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11706629-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11706761-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11706942-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11707109-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11707229-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11707511-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('11707668-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11707827-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11708181-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11708442-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11708658-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11708857-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11709045-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11709205-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11709450-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11709674-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11710008-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11710136-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11710393-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11710658-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11710827-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11710987-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11711289-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11711537-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11711764-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11711971-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11712153-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11712282-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11712621-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11712827-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11713034-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11713164-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11713370-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11713628-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11713763-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11713960-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11714150-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11714382-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11714618-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11714853-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11715207-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11715430-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11715678-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11715810-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11716041-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11716167-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11716285-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11716422-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11716698-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11716877-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11717007-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11717239-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11717399-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11717577-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11717820-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11718096-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11718296-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11718521-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11718681-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11718911-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11719120-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11719286-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11719468-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11720088-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11720353-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11720643-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11720891-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11721124-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11721337-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11721642-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11721844-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11722036-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11722199-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11722342-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11722466-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11722621-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11722769-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11722982-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11723227-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11723452-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11723655-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11723770-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11723986-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11724109-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11724363-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11724529-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11724660-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11724822-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11725015-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11725311-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11725480-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11725623-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11725821-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11725973-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11726145-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11726269-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11726433-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11726569-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11726707-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11726925-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11727091-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11727358-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11727540-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11727738-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11727976-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11728099-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11728350-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11728530-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11728769-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11728945-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11729142-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11729315-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11729478-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11729860-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11730015-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11730205-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11730312-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11730458-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11730602-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11730750-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11730933-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11731157-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11731411-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11731659-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11731861-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11732052-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11732309-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11732567-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11732857-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11733054-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11733312-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11733424-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11733548-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11733769-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11733904-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11734093-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11734300-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11734493-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11734698-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11734872-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11735053-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11735325-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11735570-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11735822-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11735977-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11736216-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11736362-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11736569-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11736694-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11736851-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11737009-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11737125-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11737316-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11737534-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11737752-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11738063-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11738203-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11738378-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11738547-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11738832-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11738997-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11739199-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11739365-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11739530-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11739809-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11739978-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11740208-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11740414-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11740655-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11740824-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11741010-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11741175-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11741350-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11741575-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11741797-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11742003-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('11742175-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11742310-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11742531-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11742745-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11742878-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11743109-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11743294-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11743570-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11743772-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11744011-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11744108-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11744251-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11744355-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11744471-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11744583-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('11744859-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('11745817-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11746060-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11746224-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11746419-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11746600-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11746776-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11747468-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11748002-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('11748330-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11748501-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11748811-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('11748936-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11749112-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11749273-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11749462-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11749603-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11749742-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11749920-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11750173-n',[ ('Bean',subsumption)]).
nounMapping2SUMO('11750359-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11750508-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11750745-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('11750855-n',[ ('Clover',subsumption)]).
nounMapping2SUMO('11750989-n',[ ('Clover',subsumption)]).
nounMapping2SUMO('11751213-n',[ ('Clover',subsumption)]).
nounMapping2SUMO('11751347-n',[ ('Clover',subsumption)]).
nounMapping2SUMO('11751598-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11751765-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11751974-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11752168-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11752404-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11752578-n',[ ('Clover',equivalence)]).
nounMapping2SUMO('11752798-n',[ ('Clover',subsumption)]).
nounMapping2SUMO('11752937-n',[ ('Clover',subsumption)]).
nounMapping2SUMO('11753143-n',[ ('Clover',subsumption)]).
nounMapping2SUMO('11753355-n',[ ('Clover',subsumption)]).
nounMapping2SUMO('11753562-n',[ ('Clover',subsumption)]).
nounMapping2SUMO('11753700-n',[ ('Clover',subsumption)]).
nounMapping2SUMO('11753936-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11754188-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11754633-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11754893-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11755110-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11755319-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11755694-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11756092-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11756329-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11756522-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11756669-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('11756870-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11757017-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11757190-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11757433-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11757653-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11757851-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11758122-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11758276-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11758483-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11758628-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11758799-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11759049-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11759224-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11759404-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11759609-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11759853-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11760128-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11760294-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11760560-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11760785-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11761007-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11761202-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11761484-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11761650-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11761836-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11762018-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11762237-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11762433-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11762706-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11762927-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11763142-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11763340-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('11763473-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11763625-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11763874-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11764072-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11764231-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11764478-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11764814-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11765099-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11765277-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11765568-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11765859-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11766046-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11766189-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11766432-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11766609-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11767196-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11767354-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11767630-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11767877-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11768108-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11768242-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11768505-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11768816-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11769002-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11769176-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11769483-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11769621-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11769803-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11770013-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11770256-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11770526-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11770753-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11770969-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11771147-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11771383-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11771539-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11771746-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11771924-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11772154-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11772408-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11772702-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11772879-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11773138-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11773408-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11773628-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11773860-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11773987-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11774279-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11774513-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11774795-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11774972-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11775160-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11775340-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11775626-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11775780-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11775959-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11776234-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11776337-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11776511-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11776861-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11777080-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11777365-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11777552-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11777779-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11777929-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11778092-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11778257-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11778391-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11778534-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11779300-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11779801-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11780018-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11780148-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11780424-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11780589-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11780747-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11780930-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11781176-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11781301-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('11781430-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11781658-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11781850-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11782036-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11782266-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11782522-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11782761-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11782878-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11783162-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11783488-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11783723-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11783920-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11784126-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11784323-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11784497-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11784825-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11785100-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11785276-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11785475-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11785668-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11785875-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11786017-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11786131-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11786365-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11786539-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11786843-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11786983-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11787190-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11787391-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11787625-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11787892-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11788039-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11788223-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11788382-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11788536-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11788727-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11788926-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11789066-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11789280-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11789438-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11789589-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11789796-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11789962-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11790089-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11790239-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11790390-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11790624-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11790788-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11790936-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11791155-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11791341-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11791446-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11791569-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11791819-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11792029-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11792155-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11792341-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11792598-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11792742-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11793032-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11793252-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11793403-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11793651-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11793779-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11794024-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11794139-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11794267-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11794519-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11794791-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11795049-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11795216-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11795366-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11795580-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11795774-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11796005-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11796188-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11796318-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11796573-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11796744-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11797016-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11797321-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11797508-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11797722-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11797981-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11798270-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11798496-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11798688-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11798851-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11798978-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11799158-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11799331-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11799520-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11799732-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11800020-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11800236-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11800359-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11800565-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11800799-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11801038-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11801247-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11801392-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11801665-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11801891-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11802076-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11802212-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11802410-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11802586-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11802800-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11802995-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11803118-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11803277-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11803475-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11804082-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11804433-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11804604-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11805255-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11805380-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11805544-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11805837-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11805956-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11806219-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11806369-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11806521-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11806679-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11806814-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11806975-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11807108-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11807367-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11807525-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11807696-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11807849-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11807979-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11808299-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11808468-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11808721-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11808932-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11809094-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11809271-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11809437-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11809594-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11809754-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11809922-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11810030-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11810190-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11810358-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11810559-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11810728-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11810918-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11811059-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11811308-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11811473-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11811706-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11811921-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11812094-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11812358-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11812573-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11812910-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11813077-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11813309-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11813490-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11813830-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11814059-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11814238-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11814440-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11814584-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11814824-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11814996-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11815194-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11815491-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11815721-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11815918-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11816121-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11816336-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11816649-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11816829-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11817000-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11817160-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11817329-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11817501-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11817774-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11817914-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11818069-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11818271-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11818515-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11818636-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11818945-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11819354-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11819509-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11819751-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11819912-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11820191-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11820323-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11820463-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11820751-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11820965-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11821184-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11821415-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11821534-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11821777-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11821929-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11822167-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11822300-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11822557-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11822849-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11823043-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11823305-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11823436-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11823572-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11823756-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11824146-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11824344-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11824548-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11824747-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11825013-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11825211-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11825351-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11825535-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11825749-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11825988-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11826198-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11826416-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11826569-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11826715-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11826999-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11827169-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11827348-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11827541-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11827775-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11828113-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11828247-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11828577-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11828804-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11828973-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11829205-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11829435-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11829672-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11829922-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11830045-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11830252-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11830400-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11830570-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11830714-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11830906-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11831100-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11831297-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11831521-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11831730-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11831874-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11832108-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11832214-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11832480-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11832671-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11832899-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11833073-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11833208-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11833373-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11833577-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11833749-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11833999-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11834148-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11834272-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11834521-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11834654-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11834890-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11835114-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11835251-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11835451-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11835568-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11835806-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11836137-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11836327-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11836556-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11836722-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11837020-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11837204-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11837351-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11837562-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11837743-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11837970-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11838266-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11838413-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11838741-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11838916-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11839167-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11839297-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11839460-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11839568-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11839823-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11840067-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11840246-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11840476-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11840764-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11841061-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11841247-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('11841368-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11841529-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11842204-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11842861-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11843053-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11843285-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11843441-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11843709-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11843896-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11844203-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11844371-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11844651-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11844892-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11845019-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11845277-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11845387-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11845557-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11845793-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11845913-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11846087-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11846312-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11846425-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11846582-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11846765-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11846970-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11847169-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11847414-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11847615-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11847841-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11848009-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11848253-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11848479-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11848610-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11848867-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11849017-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11849271-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11849467-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11849666-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11849871-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11849983-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11850136-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11850337-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11850521-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11850748-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11850918-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11851101-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11851258-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11851395-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11851578-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11851839-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11852028-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11852148-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11852255-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11852531-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11852814-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11853079-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11853191-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11853356-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11853644-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11853813-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11853979-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11854232-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11854479-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11854760-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11855122-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11855274-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11855435-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11855553-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11855842-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11856055-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11856271-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11856389-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11856573-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11856815-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11856981-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11857320-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11857528-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11857696-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11857875-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11858077-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11858406-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11858703-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11858814-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11859024-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11859275-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11859472-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11859737-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11859981-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11860208-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11860555-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11860801-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11861021-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11861238-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11861487-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11861641-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11861853-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11862089-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11862300-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11862598-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11862835-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11863242-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11863467-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11863717-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11863877-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11864114-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11864364-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11864602-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11864906-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11865071-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11865276-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11865429-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11865574-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11865738-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11865874-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11866078-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11866248-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11866469-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11866706-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11866942-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11867070-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11867311-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11867525-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11868814-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11869351-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11869689-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11869890-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11870044-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11870212-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11870418-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11870607-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11870747-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11870916-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11871059-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11871294-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11871496-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11871748-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11871916-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11872146-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11872324-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11872473-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11872658-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11872850-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11872973-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11873182-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('11873396-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11873612-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11873845-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11874081-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11874300-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11874423-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11874707-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11874878-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11875100-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11875523-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11875691-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11875938-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11876204-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11876316-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11876432-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11876634-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11876803-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11876976-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11877193-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11877283-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11877473-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11877646-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11877860-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11878101-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11878283-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11878520-n',[ ('Oil',subsumption)]).
nounMapping2SUMO('11878633-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11878808-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11879054-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11879291-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11879505-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11879722-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11879895-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11880032-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('11880218-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11880411-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11880610-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11880791-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11881063-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11881189-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11881426-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11881563-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11881742-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11882074-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11882237-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11882426-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11882636-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11882821-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11882972-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11883137-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11883328-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11883628-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11883799-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11883945-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11884198-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11884384-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11884667-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11884967-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11885148-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11885292-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11885524-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11885697-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11885856-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11886157-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11886380-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11886537-n',[ ('Arugula',equivalence)]).
nounMapping2SUMO('11886788-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11887119-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11887310-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11887476-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11887750-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11888061-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11888271-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11888424-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11888621-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11888800-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11889078-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11889205-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11889473-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11889619-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11889847-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11890022-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11890150-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11890329-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11890507-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11890723-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11890884-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11891050-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11891175-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11891395-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11891541-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11891838-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11892029-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11892181-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11892460-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11892637-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11892817-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11893004-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11893131-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11893451-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11893640-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11893808-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11893916-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11894173-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11894327-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11894558-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11894770-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11894958-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('11895092-n',[ ('Daikon',equivalence)]).
nounMapping2SUMO('11895270-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11895472-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11895714-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11895980-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11896141-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11896365-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11896519-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11896722-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11896904-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11897116-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11897342-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11897466-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11897760-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11897900-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11898079-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11898271-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11898474-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11898639-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11898775-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11899027-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11899223-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11899432-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11899595-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11899762-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11899921-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11900058-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11900569-n',[ ('Poppy',equivalence)]).
nounMapping2SUMO('11900986-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11901294-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11901452-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11901597-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11901759-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11901977-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11902200-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11902389-n',[ ('OpiumPoppy',equivalence)]).
nounMapping2SUMO('11902595-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11902709-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11902982-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11903167-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11903333-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11903525-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11903671-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11903881-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11904109-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11904274-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11904477-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11904743-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11904896-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11905035-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11905236-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11905392-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11905584-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11905749-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11905989-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11906127-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11906359-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11906514-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11906713-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11906917-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11907100-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11907267-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11907405-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11907554-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11907689-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11907939-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11908077-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11908431-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11908549-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11908718-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11908846-n',[ ('Poppy',subsumption)]).
nounMapping2SUMO('11909048-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11909353-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11909527-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11909745-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11909864-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11910070-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11910271-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11910460-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11910666-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11910835-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11911274-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11911591-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11915214-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11915658-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11915899-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11916268-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11916467-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11916696-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11916965-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11917186-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11917407-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11917633-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11917835-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11918131-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11918286-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11918473-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11918631-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11918808-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11919026-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11919232-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11919447-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11919761-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11919975-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11920133-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11920344-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11920498-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11920663-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11920867-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11920998-n',[ ('Pyrethrum',equivalence)]).
nounMapping2SUMO('11921200-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11921395-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11921622-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11921792-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11921949-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11922192-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11922374-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11922661-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11922755-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11922839-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11922926-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11923016-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11923174-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11923397-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11923637-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11923827-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11924014-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11924330-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11924445-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11924661-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11924849-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11925140-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11925303-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11925450-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11925720-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11925898-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11926185-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11926365-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11926640-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11926833-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11926976-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11927215-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11927509-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11927616-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11927740-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11927901-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11928352-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11928549-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11928858-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11929027-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11929291-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11929477-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11929743-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11929880-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11930038-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11930203-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11930353-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11930571-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11930788-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11930994-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11931135-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11931312-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11931540-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11931756-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11931918-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11932745-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11932927-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11933099-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11933257-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11933387-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11933546-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11933728-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11933903-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11934041-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11934239-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11934463-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11934616-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11934807-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11935027-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11935187-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11935330-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11935469-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11935627-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11935715-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11935794-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11935877-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11935953-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11936027-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11936113-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11936199-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11936287-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11936369-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11936448-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11936539-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11936624-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11936707-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11936782-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11936864-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11936946-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11937023-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11937102-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11937195-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11937278-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11937360-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11937446-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11937523-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11937692-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11937965-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11938261-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11938556-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11938732-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11938977-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11939180-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11939380-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11939491-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11939699-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11939887-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11940006-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11940349-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11940478-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11940599-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11940750-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11940915-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11941094-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11941178-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11941261-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11941478-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11941719-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11941924-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11942144-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11942366-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11942487-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11942659-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11942875-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11943133-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11943299-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11943407-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11943660-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11943824-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11943992-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11944196-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11944569-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11944751-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11944954-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11945228-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11945367-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11945514-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11945783-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11945930-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11946051-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11946313-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('11946433-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('11946584-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11946727-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11946918-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11947079-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11947251-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11947429-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11947629-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11947802-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11948044-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11948264-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11948469-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11948656-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11948864-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11949015-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11949217-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11949402-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11949707-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11949857-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11950028-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11950345-n',[ ('Chrysanthemum',equivalence)]).
nounMapping2SUMO('11950686-n',[ ('Chrysanthemum',subsumption)]).
nounMapping2SUMO('11950877-n',[ ('Chrysanthemum',subsumption)]).
nounMapping2SUMO('11951052-n',[ ('Chrysanthemum',subsumption)]).
nounMapping2SUMO('11951271-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('11951385-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11951511-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11951820-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11951961-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11952058-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11952153-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11952346-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11952541-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11952900-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11953038-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11953339-n',[ ('Endive',equivalence)]).
nounMapping2SUMO('11953610-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('11953762-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11953884-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11954161-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11954345-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11954484-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11954642-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11954798-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11955040-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11955153-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11955398-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11955532-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11955770-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11955896-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11956208-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11956348-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11956671-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11956850-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11957162-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11957317-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11957514-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11957678-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11957912-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11958080-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11958316-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11958499-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11958742-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11958888-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11959104-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11959259-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11959489-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11959632-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11959862-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11960084-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11960245-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11960540-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11960673-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11960943-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11961100-n',[ ('Chrysanthemum',subsumption)]).
nounMapping2SUMO('11961266-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11961446-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11961686-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11961871-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11962108-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11962272-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11962500-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11962667-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11962853-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11962994-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11963158-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11963305-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11963572-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11963755-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11963932-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11964269-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11964446-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11964688-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11964848-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11965054-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11965218-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11965378-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11965627-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11965962-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11966083-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11966215-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11966385-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11966617-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11966896-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11967142-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11967315-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11967572-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11967744-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11967878-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11968104-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11968335-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11968519-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11968704-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11968931-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11969166-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11969410-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11969607-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11969806-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11969977-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11970101-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11970298-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11970429-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11970586-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11970846-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11971094-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11971248-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11971406-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11971600-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11971783-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11971927-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11972141-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11972291-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11972569-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11972759-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11972959-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11973159-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11973341-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11973634-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11973749-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11973888-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11974126-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11974373-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11974557-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11974888-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11975100-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11975254-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11975482-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11975658-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11975853-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11976170-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11976314-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11976511-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11976715-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11976933-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11977125-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11977303-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11977512-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11977660-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11977887-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11978035-n',[ ('Sunflower',equivalence)]).
nounMapping2SUMO('11978233-n',[ ('Sunflower',equivalence)]).
nounMapping2SUMO('11978551-n',[ ('Sunflower',subsumption)]).
nounMapping2SUMO('11978713-n',[ ('Sunflower',subsumption)]).
nounMapping2SUMO('11978961-n',[ ('Sunflower',subsumption)]).
nounMapping2SUMO('11979187-n',[ ('Sunflower',subsumption)]).
nounMapping2SUMO('11979354-n',[ ('Sunflower',subsumption)]).
nounMapping2SUMO('11979527-n',[ ('Sunflower',subsumption)]).
nounMapping2SUMO('11979715-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11979964-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('11980088-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11980318-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11980577-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11980682-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11980867-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11981192-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11981314-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11981475-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11981817-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11982115-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11982342-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11982545-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11982724-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11982939-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11983160-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11983375-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11983606-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11983739-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11983910-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11984144-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11984397-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11984542-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11984659-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11984854-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11985053-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11985321-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11985586-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11985739-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11985903-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11986091-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11986306-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11986511-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11986729-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11986900-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11987126-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11987349-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11987511-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11987722-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11987956-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11988132-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11988419-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11988596-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11988774-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11988893-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11989087-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11989266-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11989393-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11989636-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11989869-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11990167-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11990313-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11990627-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11990804-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11990920-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11991080-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11991263-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11991549-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11991777-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11991993-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11992166-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11992340-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11992479-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11992674-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11992806-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11993007-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11993203-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11993444-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11993675-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11993932-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11994150-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11994336-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11994527-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11994718-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('11994827-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11995092-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11995396-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11995683-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11995840-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11996092-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11996251-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11996490-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11996677-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11996792-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11997032-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11997160-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11997409-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11997775-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11997969-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11998317-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11998492-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11998648-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11998888-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11999140-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11999278-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11999455-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11999656-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('11999958-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12000191-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12000356-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12000609-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12000851-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12001077-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12001294-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12001565-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12001707-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12001924-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12002197-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12002428-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12002651-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12002826-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12002957-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12003167-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12003407-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12003696-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12003814-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12004120-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12004310-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12004547-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12004686-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12004987-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12005148-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12005329-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12005500-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12005656-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12005869-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12006081-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12006306-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12006503-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12006766-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12006930-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12007196-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12007406-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12007560-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12007766-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12008017-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12008252-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12008487-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12008749-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12009047-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12009250-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12009420-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12009616-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12009792-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12010021-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12010188-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12010458-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12010628-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12010815-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12011067-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12011370-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12011620-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12011838-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12012111-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12012253-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12012510-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12012755-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12012897-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12013035-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12013323-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12013511-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12013701-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12013811-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12014085-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12014355-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12014524-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12014739-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12014923-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12015076-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12015221-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12015384-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12015525-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12015840-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12015959-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12016434-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12016567-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12016777-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12016914-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12017127-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12017326-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12017511-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12017664-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12017853-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12018014-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12018100-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12018188-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12018271-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12018363-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12018447-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12018530-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12018640-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12018760-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12019035-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12019190-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12019375-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12019675-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12019827-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12020048-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12020184-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12020388-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12020507-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12020736-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12020941-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12021120-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12021499-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12021882-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12022054-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12022382-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12022719-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('12022821-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12023108-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12023407-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12023726-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12023996-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12024176-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12024445-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12024690-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12024805-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12025019-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12025220-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12025507-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12025849-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12026018-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12026306-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12026476-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12026764-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12026981-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12027222-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12027538-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12027658-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12027864-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12028012-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12028196-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12028424-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12028818-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12029039-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12029326-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12029635-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12029929-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12030092-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12030265-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12030479-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12030654-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12030908-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12031139-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12031388-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12031547-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12031739-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12031927-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12032215-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12032429-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12032686-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12032939-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12033139-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12033310-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12033504-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12033709-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12033939-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12034141-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12034384-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12034594-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12034828-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12035064-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12035213-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12035423-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12035631-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12035907-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12036067-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12036226-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12036368-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12036533-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12036781-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12036939-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12037328-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12037499-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12037691-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12037864-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12038038-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12038208-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12038406-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12038585-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12038760-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12038898-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12039122-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12039317-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12039524-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12039743-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12041446-n',[ ('Orchid',equivalence)]).
nounMapping2SUMO('12043248-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12043444-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12043673-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12043836-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12044041-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12044269-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12044467-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12044571-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12044784-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12045004-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12045157-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12045352-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12045514-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12045695-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12045860-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12046028-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12046251-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12046428-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12046620-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12046815-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12047060-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12047173-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12047345-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12047586-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12047884-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12048056-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12048231-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12048399-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12048537-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12048772-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12048928-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12049134-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12049282-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12049412-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12049562-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12049796-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12050014-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12050295-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12050533-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12050766-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12050959-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12051103-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12051285-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12051514-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12051792-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12052053-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12052267-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12052447-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12052630-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12052787-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12053138-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12053405-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12053690-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12053962-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12054195-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12054499-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12054678-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12054902-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12055073-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12055317-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12055516-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12055839-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12056099-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12056217-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12056601-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12056758-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12056990-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12057211-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12057447-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12057660-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12057895-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12058192-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12058429-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12058630-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12058822-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12059090-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12059314-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12059479-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12059625-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12059851-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12060118-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12060380-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12060546-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12060816-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12061104-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12061380-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12061614-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12061849-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12062105-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12062227-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12062468-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12062626-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12062781-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12063066-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12063211-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12063414-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12063639-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12063887-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12064183-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12064389-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12064591-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12064814-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12064996-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12065316-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12065649-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12065777-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12066018-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12066261-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12066451-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12066630-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12066821-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12067029-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12067193-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12067433-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12067672-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12067817-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12068138-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12068432-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12068615-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12068824-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12069009-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12069217-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12069488-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12069679-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12069821-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12070016-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12070177-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12070381-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12070583-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12070712-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12070950-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12071259-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12071477-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12071744-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12071965-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12072210-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12072419-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12072722-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12073007-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12073217-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12073410-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12073554-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12073744-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12073991-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12074205-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12074408-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12074678-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12074867-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12075010-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12075151-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12075299-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12075495-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12075830-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12076075-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12076223-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12076381-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12076577-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12076852-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12077062-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12077244-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12077505-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12077732-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12077944-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12078172-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12078451-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12078596-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12078747-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12078954-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12079120-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12079352-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12079523-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12079737-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12079963-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12080199-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12080395-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12080588-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12080820-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12081022-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12081215-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12081488-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12081649-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12081851-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12082131-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12082357-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12082593-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12082764-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12082980-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12083113-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12083339-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12083591-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12083847-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12084158-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12084400-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12084555-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12084746-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12084890-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12085117-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12085267-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12085469-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12085664-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12085840-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12086012-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12086192-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12086362-n',[ ('Orchid',subsumption)]).
nounMapping2SUMO('12086539-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12086778-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12087032-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12087207-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12087408-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12087650-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12087807-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12087961-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12088223-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12088327-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12088495-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12088768-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12088909-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12089178-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12089320-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12089496-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12089625-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12089846-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12090041-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12090318-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12090702-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12090890-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12091213-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12091377-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12091550-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12091697-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12091806-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12091953-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12092127-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12092262-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12092417-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12092629-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12092766-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12092930-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12093088-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12093329-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12093600-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12093769-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12093885-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12094121-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12094244-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12094401-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12094612-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12094786-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12095020-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12095281-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12095412-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12095543-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12095647-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12095781-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12095934-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12096089-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12096223-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12096395-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12096563-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12096674-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12096798-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12097013-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12097180-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12097396-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12097556-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12097746-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12097927-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12098227-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12098403-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12098524-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12098665-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12098827-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12099031-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12099220-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12099342-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12099556-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12099803-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12099972-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12100187-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12100382-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12100538-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12101870-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12102133-n',[ ('Grass',equivalence)]).
nounMapping2SUMO('12103349-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12103476-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12103680-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12103894-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12104104-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12104238-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12104384-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12104501-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12104614-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12104734-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12104943-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12105125-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12105353-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12105578-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12105828-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12105981-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12106134-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12106323-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12106540-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12106786-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12107002-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12107191-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12107336-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12107489-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12107710-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12107970-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12108249-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12108432-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12108613-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12108742-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12108871-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12109189-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12109365-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12109498-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12109719-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12109827-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12110085-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12110236-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12110352-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12110475-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12110630-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12110778-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12111043-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12111238-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12111399-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12111627-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12111744-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12111882-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12112008-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12112219-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12112337-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12112488-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12112609-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12112789-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12112918-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12113195-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12113323-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12113471-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12113657-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12113790-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12114010-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12114226-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12114397-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12114590-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12114770-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12114981-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12115180-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12115383-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12115563-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12115748-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12116058-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12116267-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12116429-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12116583-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12116734-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12116881-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12117017-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12117235-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12117326-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12117507-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12117695-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12117912-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12118223-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12118414-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12118661-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12118912-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12119099-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12119238-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12119390-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12119539-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12119717-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12119822-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12119947-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12120114-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12120347-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12120578-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12120812-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12121033-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12121187-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12121405-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12121610-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12121835-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12122018-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12122124-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12122245-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12122442-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12122581-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12122725-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12122918-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12123050-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12123244-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12123450-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12123648-n',[ ('Seed',subsumption)]).
nounMapping2SUMO('12123741-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12123932-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12124172-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12124358-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12124505-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12124627-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12124818-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12125001-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12125183-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12125398-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12125584-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12125782-n',[ ('PaddyRice',equivalence)]).
nounMapping2SUMO('12125890-n',[ ('PaddyRice',equivalence)]).
nounMapping2SUMO('12126084-n',[ ('PaddyRice',equivalence)]).
nounMapping2SUMO('12126238-n',[ ('PaddyRice',subsumption)]).
nounMapping2SUMO('12126360-n',[ ('PaddyRice',subsumption)]).
nounMapping2SUMO('12126516-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12126736-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12126911-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12127030-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12127237-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12127460-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12127575-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12127768-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12127890-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12128071-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12128306-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12128490-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12128645-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12128825-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12129134-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12129349-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12129525-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12129738-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12129986-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12130160-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12130408-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12130549-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12130759-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12130937-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12131216-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12131405-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12131550-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12131767-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12132092-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12132299-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12132502-n',[ ('SugarCane',subsumption)]).
nounMapping2SUMO('12132754-n',[ ('SugarCane',subsumption)]).
nounMapping2SUMO('12132956-n',[ ('SugarCane',subsumption)]).
nounMapping2SUMO('12133151-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12133332-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12133462-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12133682-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12133870-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12134025-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12134300-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12134486-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12134695-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12134836-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12135049-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12135270-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12135576-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12135729-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12135898-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12136206-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12136392-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12136581-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12136720-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12136944-n',[ ('Sorghum',equivalence)]).
nounMapping2SUMO('12137120-n',[ ('Sorghum',equivalence)]).
nounMapping2SUMO('12137337-n',[ ('Sorghum',subsumption)]).
nounMapping2SUMO('12137569-n',[ ('Sorghum',subsumption)]).
nounMapping2SUMO('12137791-n',[ ('Sorghum',subsumption)]).
nounMapping2SUMO('12137954-n',[ ('Sorghum',subsumption)]).
nounMapping2SUMO('12138110-n',[ ('Sorghum',subsumption)]).
nounMapping2SUMO('12138248-n',[ ('Sorghum',subsumption)]).
nounMapping2SUMO('12138444-n',[ ('Sorghum',subsumption)]).
nounMapping2SUMO('12138578-n',[ ('Sorghum',subsumption)]).
nounMapping2SUMO('12138757-n',[ ('Sorghum',subsumption)]).
nounMapping2SUMO('12138905-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12139196-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12139367-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12139575-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12139793-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12139921-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12140137-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12140358-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12140511-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12140759-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12140903-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12141037-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12141167-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12141385-n',[ ('CerealGrass',equivalence)]).
nounMapping2SUMO('12141495-n',[ ('CerealGrass',equivalence)]).
nounMapping2SUMO('12141890-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12142085-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12142357-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12142450-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12142750-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12142874-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12143065-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12143215-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12143405-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12143572-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12143676-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12144117-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12144313-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12144399-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12144580-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12144742-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12144987-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12145148-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12145325-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12145477-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12145638-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12145802-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12145919-n',[ ('CerealGrass',subsumption)]).
nounMapping2SUMO('12146100-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12146311-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12146488-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12146654-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12146823-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12147031-n',[ ('Grass',subsumption)]).
nounMapping2SUMO('12147226-n',[ ('Bamboo',equivalence)]).
nounMapping2SUMO('12147539-n',[ ('Bamboo',subsumption)]).
nounMapping2SUMO('12147699-n',[ ('Bamboo',subsumption)]).
nounMapping2SUMO('12147835-n',[ ('Bamboo',subsumption)]).
nounMapping2SUMO('12148079-n',[ ('Bamboo',subsumption)]).
nounMapping2SUMO('12148253-n',[ ('Bamboo',subsumption)]).
nounMapping2SUMO('12148439-n',[ ('Bamboo',subsumption)]).
nounMapping2SUMO('12148610-n',[ ('Bamboo',subsumption)]).
nounMapping2SUMO('12148757-n',[ ('Bamboo',subsumption)]).
nounMapping2SUMO('12148962-n',[ ('Bamboo',subsumption)]).
nounMapping2SUMO('12149144-n',[ ('Bamboo',subsumption)]).
nounMapping2SUMO('12149350-n',[ ('Bamboo',subsumption)]).
nounMapping2SUMO('12149521-n',[ ('Bamboo',subsumption)]).
nounMapping2SUMO('12149751-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12150028-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12150447-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12150722-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12150969-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12151170-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12151365-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12151615-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12151814-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12152031-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12152251-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12152406-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12152532-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12152722-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12152869-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12153033-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12153224-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12153393-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12153580-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12153741-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12153914-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12154114-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12154228-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12154426-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12154628-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12154773-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12155009-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12155126-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12155259-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12155459-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12155583-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12155773-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12156117-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12156308-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12156484-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12156679-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12156819-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12157056-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12157179-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12157276-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12157677-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12157769-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12158031-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12158148-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12158443-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('12158798-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('12159055-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('12159388-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('12159555-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('12159804-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('12159942-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('12160125-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('12160303-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('12160490-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('12160857-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('12161056-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('12161285-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('12161577-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('12161744-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('12161969-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('12162181-n',[ ('Squash',subsumption)]).
nounMapping2SUMO('12162425-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12162758-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12162905-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12163035-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12163279-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12163456-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12163649-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12163824-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12164065-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12164215-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12164363-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12164656-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12164881-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12165170-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12165384-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12165608-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12165758-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12166003-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12166128-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12166312-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12166424-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12166793-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12166929-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12167075-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12167282-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12167436-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12167602-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12167749-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12167955-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12168126-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12168385-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12168565-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12168750-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12168898-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12169099-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12169320-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12169526-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12169776-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12170415-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12170585-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12171098-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12171316-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12171503-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12171750-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12171966-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12172364-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12172481-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12172715-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12172906-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('12173069-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12173407-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12173664-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12173912-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12174124-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12174311-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12174521-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12174742-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12174926-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12175181-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12175370-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12175598-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12175797-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12175949-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12176278-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12176453-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12176709-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12176953-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12177129-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12177249-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12177455-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12177592-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12177844-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12178129-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12178358-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12178494-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12178780-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12178896-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12179122-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12179391-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12179632-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12179907-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12180168-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12180456-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12180714-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12180885-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12181147-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12181352-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12181612-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12181851-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12182049-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12182276-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12182414-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12182615-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12182858-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12183026-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12183318-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12183452-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12183636-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12183816-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12183916-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12184095-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12184337-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12184468-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12184724-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12184912-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12185078-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12185254-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12185526-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12185687-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12185859-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12186116-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12186352-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12186554-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12186839-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12187030-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12187247-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12187450-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12187663-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12187891-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12188120-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12188289-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12188484-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12188635-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12188985-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12189293-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12189429-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12189620-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12189779-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12189987-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12190241-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12190410-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12190712-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12190869-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12191075-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12191240-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12191461-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12191587-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12191813-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12191965-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12192132-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12192373-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12192722-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12192877-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12193205-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12193334-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12193458-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12193665-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12193964-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12194147-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12194466-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12194613-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12194776-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12195186-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12195391-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12195533-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12195734-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12195965-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12196129-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12196336-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12196527-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12196694-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12196954-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12197211-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12197359-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12197601-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12197765-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12197901-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12198140-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12198286-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12198628-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12198793-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12199030-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12199266-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12199399-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12199564-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12199790-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12199982-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12200143-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12200315-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12200504-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12200747-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12200905-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12201166-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12201331-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12201456-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12201580-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12201761-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12201938-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12202234-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12202352-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12202712-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12202936-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12203331-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12203529-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12203699-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12203896-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12204032-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12204175-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12204405-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12204546-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12204730-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12204925-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12205104-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12205308-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12205460-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12205694-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12212361-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12212690-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12212810-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12213197-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12213485-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12213635-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12214245-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12214605-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12214789-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12215022-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12215210-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12215373-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12215579-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12215824-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12216028-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12216215-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12216382-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12216628-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12216836-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12216968-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12217211-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12217453-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12217586-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12217851-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12218054-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12218274-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12218490-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12218621-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12218868-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12219065-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12219289-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12219495-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12219668-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12219875-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12220019-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12220247-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12220496-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12220654-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12220829-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12220994-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12221191-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12221368-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12221522-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12221801-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12221943-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12222090-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12222334-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12222493-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12222715-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12222900-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12223160-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12223405-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12223569-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12223764-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12223950-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12224140-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12224309-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12224522-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12224669-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12224978-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12225222-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12225349-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12225563-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12225769-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12226009-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12226322-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12226932-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12227220-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12227420-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12227658-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12227909-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12228045-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12228229-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12228387-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12228546-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12228689-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12228886-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12229111-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12229282-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12229443-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12229651-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12229887-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12230146-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12230347-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12230540-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12230794-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12231031-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12231192-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12231358-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12231709-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12231918-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12232114-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12232280-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12232503-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12232683-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12232851-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12233094-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12233249-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12233410-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12233529-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12233759-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12233998-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12234176-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12234318-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12234513-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12234669-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12234913-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12235051-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12235263-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12235479-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12235765-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12236160-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12236363-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12236546-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12236768-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12236977-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12237152-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12237350-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12237486-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12237641-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12237855-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12238073-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12238306-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12238491-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12238756-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12238913-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12239100-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12239240-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12239458-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12239647-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12239880-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12240150-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12240335-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12240477-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12240715-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12240965-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12241192-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12241426-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12241699-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12241880-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12242123-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12242287-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12242409-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12242668-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12242850-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12243109-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12243292-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12243459-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12243693-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12243927-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12244153-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12244458-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12244650-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12244819-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12245067-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12245319-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12245472-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12245695-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12245885-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12246037-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12246232-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12246641-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12246773-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12246941-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12247202-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12247407-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12247664-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12247963-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12248141-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12248359-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12248574-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12248780-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12248941-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12249122-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12249294-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12249542-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12249821-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12249993-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12250180-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12250413-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12250708-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12250874-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12251001-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12251137-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12251278-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12251577-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12251740-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12251997-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12252168-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12252383-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12252620-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12252866-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12253083-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12253229-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12253487-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12253664-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12253835-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12254014-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12254168-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12254478-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12254667-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12254891-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12255086-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12255225-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12255452-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12255659-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12255934-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12256112-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12256325-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12256522-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12256708-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12256920-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12257140-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12257343-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12257570-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12257725-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12257920-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12258101-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12258380-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12258663-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12258885-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12259122-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12259316-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12259615-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12259788-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12260021-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12260208-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12260593-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12260799-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12261179-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12261359-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12261571-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12261808-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12262018-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12262185-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12262327-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12262553-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12262905-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12263038-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12263204-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12263410-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12263588-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12263738-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12263987-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12264254-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12264512-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12264621-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12264786-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12265083-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12265266-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12265394-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12265600-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12265740-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12265900-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12266217-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12266528-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12266644-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12266796-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12266984-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12267133-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12267265-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12267411-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12267534-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12267677-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12267841-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12267931-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('12268096-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12268246-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12268918-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12269099-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('12269241-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12269406-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12269652-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12270027-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12270278-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12270460-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12270741-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12270946-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12271187-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12271451-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12271643-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12271933-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12272239-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12272432-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12272650-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12272735-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12272883-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12273114-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12273344-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12273515-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12273768-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12273939-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12274151-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12274358-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12274630-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12274863-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12275131-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12275317-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12275489-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12275675-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12275888-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12276110-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12276314-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12276477-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12276628-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12276872-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12277150-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12277334-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12277578-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12277800-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12278107-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12278371-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12278650-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12278865-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12279060-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12279293-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12279458-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12279772-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12280060-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12280364-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12280487-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12280886-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12281241-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12281600-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12281788-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12281974-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12282235-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12282527-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12282737-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12282933-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12283147-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12283395-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12283542-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12283790-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12283981-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12284262-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12284665-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12284821-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12285049-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12285195-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12285369-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12285512-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12285705-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12285900-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12286068-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12286197-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12286372-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12286581-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12286826-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12286988-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12287195-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12287388-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12287642-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12287836-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12288005-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12288188-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12288422-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12288598-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12288823-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12289115-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12289310-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12289433-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12289585-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12289744-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12290116-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12290522-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12290748-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12290975-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12291143-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12291292-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12291459-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12291564-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12291671-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12291763-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12291959-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12292285-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12292463-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12292655-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12292877-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12293180-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12293419-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12293723-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12294124-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12294331-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12294542-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12294723-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12294871-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12295033-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12295237-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12295429-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12295560-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12295796-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12296045-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12296218-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12296432-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12296735-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12296929-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12297110-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12297280-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12297507-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12297678-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12297846-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12298003-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12298165-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12298395-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12298637-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12298783-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12298958-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12299165-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12299425-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12299640-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12299988-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12300441-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12300625-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12300840-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12301038-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12301180-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12301445-n',[ ('Olive',equivalence)]).
nounMapping2SUMO('12301613-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12301766-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12301917-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12302071-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12302248-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12302418-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12302565-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12302692-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12302974-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12303083-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12303349-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12303462-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12303921-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12304115-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12304286-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12304420-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12304572-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12304703-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12304899-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12305089-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12305293-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12305475-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12305654-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12305819-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12305986-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12306089-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12306270-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12306419-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12306519-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12306717-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12306938-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12307076-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12307240-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12307455-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12307611-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12307756-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12308112-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12308259-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12308447-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12308664-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12308907-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12309052-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12309277-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12309403-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12309630-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12309850-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12310021-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12310153-n',[ ('Lilac',equivalence)]).
nounMapping2SUMO('12310349-n',[ ('Lilac',equivalence)]).
nounMapping2SUMO('12310638-n',[ ('Lilac',subsumption)]).
nounMapping2SUMO('12310840-n',[ ('Lilac',subsumption)]).
nounMapping2SUMO('12311045-n',[ ('Lilac',subsumption)]).
nounMapping2SUMO('12311224-n',[ ('Lilac',subsumption)]).
nounMapping2SUMO('12311413-n',[ ('Lilac',subsumption)]).
nounMapping2SUMO('12311579-n',[ ('Lilac',subsumption)]).
nounMapping2SUMO('12311800-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12311894-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12312110-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12312276-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12312405-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12312728-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12313005-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12313574-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12313735-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12313954-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12314146-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12314315-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12314652-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12314808-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12315060-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12315245-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12315424-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12315598-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12315818-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12315999-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12316300-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12316444-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12316572-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12316853-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12316982-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12317164-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12317296-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12317487-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12317611-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12317763-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12317919-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12318164-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12318378-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12318615-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12318782-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12318965-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12319204-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12319414-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12319687-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12320010-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12320285-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12320414-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12320627-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12320806-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12321077-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12321304-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12321395-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12321669-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12321873-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12322099-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12322359-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12322501-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12322699-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12322887-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12323411-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12323665-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12323820-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12324056-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12324222-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12324388-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12324558-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12324756-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12324906-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12325093-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12325234-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12325497-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12325667-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12325787-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12326033-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12326178-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12326369-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12326604-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12326842-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12327022-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12327209-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12327407-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12327528-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12327718-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12327846-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12328026-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12328241-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12328398-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12328567-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12328801-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12329020-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12329260-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12329473-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12329744-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12329899-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12330239-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12330336-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12330469-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12330587-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12330751-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12330891-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12331066-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12331263-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12331415-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12331655-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12331788-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12332030-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12332218-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12332422-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12332555-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12332718-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12332866-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12333053-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12333397-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12333530-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12333771-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12333961-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12334153-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12334293-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12334520-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12334686-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12334891-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12335351-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12335483-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12335664-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12335800-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12335937-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12336092-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12336224-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12336333-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12336586-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12336727-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12336973-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12337131-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12337246-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12337391-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12337617-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12337800-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12337922-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12338034-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12338146-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12338258-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12338454-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12338655-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12338796-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12338979-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12339090-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12339319-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12339526-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12339831-n',[ ('Clove',equivalence)]).
nounMapping2SUMO('12339972-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12340202-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12340383-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12340581-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12340755-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12340998-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12341126-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12341412-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12341542-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12341795-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12341931-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12342043-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12342299-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12342498-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12342852-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12343092-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12343306-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12343480-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12343753-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12343951-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12344131-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12344283-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12344483-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12344700-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12344837-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12344996-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12345136-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12345280-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12345495-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12345709-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12345899-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12346179-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12346448-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12346578-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12346813-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12346986-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12347158-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12347380-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12347490-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12347639-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12347892-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12348127-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12348294-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12348518-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12348635-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12348774-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12349091-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12349315-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12349491-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12349711-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12349916-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12350032-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12350234-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12350433-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12350578-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12350758-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12350959-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12351091-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12351287-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12351477-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12351600-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12351790-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12351975-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12352150-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12352287-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12352639-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12352844-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12352990-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12353203-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12353431-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12353604-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12353754-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12354068-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12354374-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12354619-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12354849-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12355023-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12355320-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12355594-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12355760-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12356023-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12356255-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12356395-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12356668-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12356960-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12357100-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12357343-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12357485-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12357802-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12357968-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12358173-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12358293-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12358485-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12359026-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12359578-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12359734-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12359952-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12360108-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12360534-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12360684-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12360817-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12360958-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12361135-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12361350-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12361560-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12361754-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12361946-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12362274-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12362514-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12362668-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12362844-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12363110-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12363301-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12363580-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12363768-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12363988-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12364379-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12364604-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12364823-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12364940-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12365158-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12365285-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12365462-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12365670-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12365900-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12366053-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12366186-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12366313-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12366507-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12366675-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12366870-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12367122-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12367306-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12367611-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12368028-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12368257-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12368451-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12368637-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12368847-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12369066-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12369309-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12369476-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12369665-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12369845-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12370011-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12370174-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12370384-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12370549-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12370842-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12371002-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12371202-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12371439-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12371704-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12371911-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12372124-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12372233-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12372520-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12372708-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12372932-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12373100-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12373361-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12373526-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12373739-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12374002-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12374238-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12374418-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12374705-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12374862-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12375107-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12375294-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12375518-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12375769-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12376073-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12376240-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12376382-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12376553-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12376740-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12376950-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12377198-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12377328-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12377494-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12377658-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12377809-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12378080-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12378249-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12378546-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12378753-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12378963-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12379278-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12379531-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12379781-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12380029-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12380197-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12380305-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12380597-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12380761-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12380926-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12381095-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12381321-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12381511-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12381666-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12381931-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12382233-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12382484-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12382699-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12382875-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12383073-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12383256-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12383402-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12383737-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12383894-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12384037-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12384227-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12384375-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12384569-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12384680-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12384839-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12385046-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12385219-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12385429-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12385566-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12385830-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12386039-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12386263-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12386462-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12386724-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12386945-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12387103-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12387201-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12387478-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12387633-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12387839-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12388143-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12388293-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12388444-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12388652-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12388858-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12388989-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12389130-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12389317-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12389501-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12389727-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12389932-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12390099-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12390314-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12390485-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12390681-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12390914-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12391111-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12391280-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12391477-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12391745-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12392070-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12392385-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12392549-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12392765-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12392943-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12393086-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12393269-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12393527-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12393723-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12393942-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12394118-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12394328-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12394494-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12394638-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12394861-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12395068-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12395289-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12395463-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12395717-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12395906-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12396091-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12396255-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12396666-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12396924-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12397210-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12397431-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12397594-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12397864-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12398174-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12398384-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12398526-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12398682-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12398990-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12399132-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12399384-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12399534-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12399656-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12399784-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12399899-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12400261-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12400489-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12400720-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12400924-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12401122-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12401335-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12401684-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12401893-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12402051-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12402348-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12402596-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12402840-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12403075-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12403276-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12403513-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12403862-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12403994-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12404314-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12404484-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12404729-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12404943-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12405209-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12405714-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12406155-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12406304-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12406488-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12406715-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12406902-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12407079-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12407222-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12407396-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12407545-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12407715-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12407890-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12408077-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12408280-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12408466-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12408717-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12408873-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12409016-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12409231-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12409470-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12409651-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12409840-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12410032-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12410205-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12410381-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12410715-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12411084-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12411461-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12411710-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12411922-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12412355-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12412606-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12412850-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12412987-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12413165-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12413301-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12413419-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12413642-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12413880-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12414035-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12414159-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12414329-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12414449-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12414602-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12414818-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12414932-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12415089-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12415272-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12415401-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12415595-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12415765-n',[ ('Waterfall',subsumption)]).
nounMapping2SUMO('12415911-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12416073-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12416278-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12416423-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12416703-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12416917-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12417062-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12417273-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12417382-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12417686-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12417836-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12418065-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12418221-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12418356-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12418507-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12418680-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12419037-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12419217-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12419394-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12419592-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12419878-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12420124-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12420335-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12420535-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12420722-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12420991-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12421137-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12421334-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12421467-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12421683-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12421917-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12422129-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12422230-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12422399-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12422559-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12422751-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12422931-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12423211-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12423444-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12423565-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12425281-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12426100-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12426248-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12426623-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12426749-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12426978-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12427184-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12427391-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12427566-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12427757-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12427946-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12428076-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12428242-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12428412-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12428587-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12428747-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12428915-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12429148-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12429352-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12429589-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12429770-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12429942-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12430198-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12430471-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12430675-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12430878-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12431128-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12431434-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12431861-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12432069-n',[ ('Onion',subsumption)]).
nounMapping2SUMO('12432356-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12432574-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12432707-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12432808-n',[ ('Onion',subsumption)]).
nounMapping2SUMO('12433081-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12433178-n',[ ('Onion',subsumption)]).
nounMapping2SUMO('12433429-n',[ ('Shallot',equivalence)]).
nounMapping2SUMO('12433540-n',[ ('Onion',subsumption)]).
nounMapping2SUMO('12433769-n',[ ('Onion',subsumption)]).
nounMapping2SUMO('12433952-n',[ ('Onion',subsumption)]).
nounMapping2SUMO('12434106-n',[ ('Onion',subsumption)]).
nounMapping2SUMO('12434239-n',[ ('Onion',subsumption)]).
nounMapping2SUMO('12434483-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12434634-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12434775-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12434985-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12435152-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12435338-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12435486-n',[ ('Onion',subsumption)]).
nounMapping2SUMO('12435649-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12435777-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12435965-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12436090-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12436260-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12436490-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12436677-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12436907-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12437047-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12437311-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12437513-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12437769-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12437930-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12438046-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12438324-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12438571-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12438783-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12438977-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12439154-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12439400-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12439626-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12439830-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12440128-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12440385-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12440623-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12440869-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12441183-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12441390-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12441552-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12441770-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12441958-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12442220-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12442548-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12442697-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12442865-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12443144-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12443323-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12443547-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12443736-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12443929-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12444095-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12444261-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12444490-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12444666-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12444898-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12445138-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12445387-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12445628-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12445848-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12446200-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12446519-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12446737-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12446908-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12447121-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12447346-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12447581-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12447891-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12448136-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12448361-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12448700-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12449024-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12449296-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12449526-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12449784-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12449934-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12450099-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12450344-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12450607-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12450840-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12451070-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12451240-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12451399-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12451566-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12451789-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12451915-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12452256-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12452480-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12452673-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12452836-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12453018-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12453186-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12453539-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12453714-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12453857-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12454021-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12454159-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12454436-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12454556-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12454705-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12454793-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12454949-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12455101-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12455342-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12455540-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12455787-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12455950-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12456278-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12456527-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12456845-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12457091-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12457250-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12457519-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12457771-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12458002-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12458224-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12458383-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12458550-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12458713-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12458874-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12459048-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12459275-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12459471-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12459629-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12459882-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12460146-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12460308-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12460549-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12460697-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12460957-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12461109-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12461326-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12461466-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12461673-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12461809-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12462032-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12462221-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12462401-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12462582-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12462805-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12462951-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12463134-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12463322-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12463574-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12463743-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12463975-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12464128-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12464278-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12464476-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12464649-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12464903-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12465107-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12465321-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12465557-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12465796-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12466034-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12466206-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12466450-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12466727-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12467018-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12467197-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12467433-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12467592-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12467811-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12468081-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12468243-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12468545-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12468719-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12468900-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12469157-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12469372-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12469517-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12469725-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12469936-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12470092-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12470329-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12470512-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12470907-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12471150-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12471366-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12471544-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12471825-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12472024-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12472326-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12472559-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12472778-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12473011-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12473171-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12473405-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12473608-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12473840-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12474006-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12474167-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12474418-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12474620-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12474828-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12475035-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12475242-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12475450-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12475593-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12475774-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12476036-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12476510-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12476902-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12477163-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12477401-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12477583-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12477747-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12477983-n',[ ('BlueAgave',equivalence)]).
nounMapping2SUMO('12478131-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12478283-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12478506-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12478768-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12479066-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12479303-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12479537-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12479689-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12479821-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12480004-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12480233-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12480456-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12480677-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12480895-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12481150-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12481289-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12481458-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12481641-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12481806-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12482031-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12482437-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12482668-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12482893-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12483091-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12483282-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12483427-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12483625-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12483841-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12484029-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12484244-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12484413-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12484612-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12484784-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12485122-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12485331-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12485523-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12485653-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12485811-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12485981-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12486254-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12486397-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('12486574-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12486732-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12486882-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12487058-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12487262-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('12487394-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12487647-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12488121-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12488454-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12488709-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12488914-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12489046-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12489268-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12489524-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12489676-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12489815-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12490054-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12490330-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12490490-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12490671-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12490827-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12491017-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12491200-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12491435-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12491626-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12491826-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12492106-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12492460-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12492682-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12492900-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12493090-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12493208-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12493426-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12493699-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12493868-n',[ ('Shrub',subsumption)]).
nounMapping2SUMO('12494115-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12494358-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12494629-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12494794-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12495146-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12495396-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12495509-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12495670-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12495895-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12496207-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12496427-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12496735-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12496949-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12497322-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12497492-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12497669-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12498055-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12498316-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12498457-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12498739-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12498928-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12499163-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12499439-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12499757-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12499979-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12500309-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12500518-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12500751-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12501035-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12501202-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12501537-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12501745-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12503908-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12504094-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12504306-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12504570-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12504783-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12505032-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12505253-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12505563-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12505752-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12505987-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12506181-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12506341-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12506614-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12506784-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12506991-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12507236-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12507379-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12507670-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12507823-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12508077-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12508309-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12508497-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12508618-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12508762-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12508936-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12509109-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12509297-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12509476-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12509665-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12509821-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12509993-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12510197-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12510343-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12510569-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12510774-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12511046-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12511239-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12511488-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12511703-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12511856-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12512095-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12512294-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12512460-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12512674-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12512947-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12513172-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12513426-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12513613-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12513933-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12514138-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12514324-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12514592-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12514802-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12514992-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12515219-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12515393-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12515597-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12515711-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12515925-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12516040-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12516165-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12516432-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12516584-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12516828-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12517077-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12517253-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12517445-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12517642-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12517820-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12518013-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12518305-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12518481-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12518725-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12518879-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12519089-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12519328-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12519563-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12519824-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12520015-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12520223-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12520406-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12520661-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12520864-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12521186-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12521394-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12521624-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12521847-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12522188-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12522493-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12522678-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12522894-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12523141-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12523319-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12523475-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12523698-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12523850-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12524010-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12524188-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12524395-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12524518-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12524633-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12524944-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12525168-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12525347-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12525513-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12525753-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12525975-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12526178-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12526380-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12526516-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12526754-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12526946-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12527081-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12527391-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12527569-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12527738-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12528109-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12528382-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12528549-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12528768-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12528974-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12529220-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12529353-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12529500-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12529730-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12529905-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12530208-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12530439-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12530629-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12530818-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12531144-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12531328-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12531552-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12531727-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12532008-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12532168-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12532564-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12532720-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12532886-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12533190-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12533437-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12533588-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12533730-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12533992-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12534208-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12534453-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12534625-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12534862-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12535101-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12535254-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12535461-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12535593-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12535820-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12536040-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12536291-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12536455-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12536665-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12536871-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12537068-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12537253-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12537437-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12537569-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12537988-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12538209-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12538380-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12538603-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12539074-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12539306-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12539564-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12539832-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12540001-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12540250-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12540488-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12540647-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12540800-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12540966-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12541157-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12541403-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12541606-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12541805-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12542043-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12542240-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12542466-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12542649-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12542910-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12543186-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12543455-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12543639-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12543826-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12544027-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12544240-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12544539-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12544646-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12544862-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12545090-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12545232-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12545429-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12545635-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12545865-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12546015-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12546183-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12546420-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12546617-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12546832-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12546962-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12547215-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12547503-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12547658-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12547872-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12548134-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12548280-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12548564-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12548804-n',[ ('Alfalfa',subsumption)]).
nounMapping2SUMO('12549005-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12549192-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12549420-n',[ ('Alfalfa',subsumption)]).
nounMapping2SUMO('12549649-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12549799-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12549976-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12550210-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12550408-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12550788-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12550968-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12551173-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12551457-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12551669-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12551877-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('12552081-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12552309-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12552658-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12552893-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12553114-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12553314-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12553573-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12553742-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12554029-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12554242-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12554526-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12554729-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12554911-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12555069-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12555255-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12555553-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12555720-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12555859-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12556030-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12556307-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12556533-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12556656-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12556793-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12557064-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12557280-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12557438-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12557556-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12557681-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12557995-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12558230-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12558425-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12558680-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12558902-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12559044-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12559302-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12559518-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12559842-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12560016-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12560282-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12560420-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12560621-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12560775-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12561038-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12561169-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12561309-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12561594-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12561696-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12561897-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12562141-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12562420-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12562577-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12562785-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12563045-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12563281-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12563404-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12563567-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12563702-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12563913-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12564083-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12564381-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12564613-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12564840-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12565102-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12565368-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12565590-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12565730-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12565912-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12566112-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('12566331-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12566627-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12566809-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12566954-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12567316-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12567490-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12567768-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12567950-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12568186-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12568506-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12568649-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12568865-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12569037-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12569233-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12569426-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12569616-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12569851-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12570126-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12570394-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12570703-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12570972-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12571194-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12571330-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12571606-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12571781-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12572021-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12572188-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12572373-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12572546-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12572759-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12572858-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12573078-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12573256-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12573474-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12573647-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12573760-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12573911-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12574143-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12574320-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12574470-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12574727-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12574866-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12575089-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12575322-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12575679-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12575812-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12576029-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12576323-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12576451-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12576555-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12576695-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12576838-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12577000-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12577362-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12577686-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12577895-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12578255-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12578626-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12578916-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12579038-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12579242-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12579404-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12579593-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12579822-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12580012-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12580204-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12580457-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12580654-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12580786-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12580896-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12581110-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12581230-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12581381-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12582231-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12582665-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12582846-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12583126-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12583401-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12583529-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12583681-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12583855-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12584057-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12584191-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12584365-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12584559-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12584715-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12584970-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12585137-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12585373-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12585512-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12585629-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12585967-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12586110-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12586298-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12586499-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12586725-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12586867-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12586989-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12587132-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12587366-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12587487-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12587686-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12587803-n',[ ('Coconut',equivalence)]).
nounMapping2SUMO('12588054-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12588156-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12588320-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12588584-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12588780-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12588989-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12589142-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12589286-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12589458-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12589687-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12589841-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12590117-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12590232-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12590499-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12590600-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12590715-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12590842-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12591017-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12591195-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12591351-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12591523-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12591702-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12591897-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12592058-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12592351-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12592544-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12592839-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('12592971-n',[ ('Food',subsumption)]).
nounMapping2SUMO('12593122-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12593341-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('12593508-n',[ ('Food',subsumption)]).
nounMapping2SUMO('12593689-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12593826-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12593994-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12594165-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12594324-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12594533-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12594746-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12594989-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12595305-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12595452-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12595699-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12595801-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12595964-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12596148-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12596345-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12596525-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12596709-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12596849-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12597006-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12597134-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12597333-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12597466-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12597640-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12597798-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12598027-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12598247-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12598409-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12598629-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12598826-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12599185-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12599435-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12599661-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12599874-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12600095-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12600267-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12600417-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12600574-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12600888-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12601106-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12601335-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12601494-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12601805-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12602118-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12602262-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12602434-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12602612-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12602850-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12602980-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12603273-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12603449-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12603672-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12603784-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12603959-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12604228-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12604460-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12604639-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12604845-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12605019-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12605315-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12605519-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12605683-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12605872-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12605965-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12606227-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12606438-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12606545-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12606688-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12606797-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12606907-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12607198-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12607456-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12607717-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12607896-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12608127-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12608447-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12608620-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12608778-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12608941-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12609128-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12609379-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12609638-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12609842-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12609968-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12610186-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12610328-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12610609-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12610740-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12610933-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12611243-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12611479-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12611640-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12611815-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12612020-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12612170-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12612410-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12612640-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12612709-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12612811-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12612913-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12613285-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12613408-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12613596-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12613706-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12613968-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12614096-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12614317-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12614477-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12614625-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12614763-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12614962-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12615097-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12615232-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12615427-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12615710-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12615986-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12616248-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12616442-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12616630-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12616825-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12616996-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12617140-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12617384-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12617559-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12617739-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12617950-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12618146-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12618336-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12618524-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12618727-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12618942-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12619306-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12620031-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12620196-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12620546-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12620661-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12620779-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12620969-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12621110-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12621260-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12621410-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12621619-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12621836-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('12621945-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12622072-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12622297-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12622483-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12622653-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12622875-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12623077-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12623211-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12623368-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12623524-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12623818-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12624055-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12624249-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12624381-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12624568-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12624721-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12624873-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12625003-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12625215-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12625383-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12625670-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12625823-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12626030-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12626353-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12626674-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12626878-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12627119-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12627347-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12627526-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12627750-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12628060-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12628356-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12628579-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12628705-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12628872-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12628986-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12629187-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12629305-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12629523-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12629666-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12629946-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12630144-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12630478-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12630641-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12630763-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12630999-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12631224-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12631331-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12631637-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12631813-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12631932-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12632072-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12632335-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12632526-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12632733-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12632875-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12633061-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12633386-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12633638-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12633866-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12633994-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12634211-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12634429-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12634734-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12634986-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12635151-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12635359-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12635532-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12635744-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12635955-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12636107-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12636224-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12636430-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12636705-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12636885-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12637123-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12637319-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12637485-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12637729-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12638218-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12638556-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12638753-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12638964-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12639168-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12639376-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12639584-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12639736-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12639910-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12640081-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12640284-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12640435-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12640607-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12640839-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12641007-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12641180-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12641413-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12641796-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12641931-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12642090-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12642200-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12642435-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12642600-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12642734-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12642964-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12643113-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12643313-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12643473-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12643688-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12643877-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12644057-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12644283-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12644464-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12644713-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12644902-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12645174-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12645530-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12645754-n',[ ('Food',subsumption)]).
nounMapping2SUMO('12645913-n',[ ('Food',subsumption)]).
nounMapping2SUMO('12646072-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12646197-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12646397-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12646605-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12646740-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12646950-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12647231-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12647376-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12647560-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12647787-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12647893-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12648045-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12648196-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12648424-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12648693-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12648888-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12649065-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12649317-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12649539-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12649723-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12649866-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12650038-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12650229-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12650379-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12650556-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12650805-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12650915-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12651062-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12651229-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12651465-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12651611-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12651821-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12652876-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12653056-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12653218-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12653436-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12653633-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12653762-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12654012-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12654227-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12654387-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12654659-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12654857-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12655062-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12655245-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12655351-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12655498-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12655605-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12655726-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12655869-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12656229-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12656369-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12656528-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12656685-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12656909-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12657082-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12657294-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12657509-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12657755-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12657940-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12658118-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12658308-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12658481-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12658603-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12658715-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12658846-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12659064-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12659203-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12659356-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12659539-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12659730-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12660009-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12660601-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12660796-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12661045-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12661227-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12661420-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12661538-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12661661-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12661873-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12662074-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12662223-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12662379-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12662654-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12662772-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12663023-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12663254-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12663359-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12663554-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12663804-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12664005-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12664187-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12664469-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12664710-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12664897-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12665048-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12665271-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12665659-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12665857-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12666050-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12666159-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12666369-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12666602-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12666768-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12666965-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12667179-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12667406-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12667582-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12667817-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12667964-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12668131-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12668364-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12668517-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12668732-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12668917-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12669157-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12669362-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12669641-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12669803-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12670013-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12670172-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12670334-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12670558-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12670758-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12670962-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12671157-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12671529-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12671651-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12671898-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12672083-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12672289-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12672497-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12672631-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12672843-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12673012-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12673178-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12673328-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12673588-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12673755-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12674120-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12674484-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12674685-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12674895-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12675100-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12675299-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12675515-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12675716-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12675876-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12676134-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12676370-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12676534-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12676703-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12676940-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12677120-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12677331-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12677427-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12677612-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12677841-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12678059-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12678224-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12678548-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12678794-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12679023-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12679201-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12679432-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12679593-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12679712-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12679876-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12680125-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12680402-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12680652-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12680864-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12681141-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12681376-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12681579-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12681768-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12681893-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12682054-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12682264-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12682411-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12682668-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12682882-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12683096-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12683248-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12683407-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12683571-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12683791-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12683950-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12684153-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12684379-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12684640-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12685214-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12685431-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12685679-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12685831-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12686077-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12686274-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12686496-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12686676-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12686877-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12687044-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12687211-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12687462-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12687698-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12687957-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12688187-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12688372-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12688526-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12688716-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12688903-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12689305-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12689491-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12689641-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12689808-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12690046-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12690240-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12690388-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12690653-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12691028-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12691189-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12691428-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12691661-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12691834-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12692024-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12692160-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12692323-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12692521-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12692714-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12692875-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12693033-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12693244-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12693352-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12693457-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12693590-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12693734-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12693865-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12694048-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12694193-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12694336-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12694486-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12694707-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12695144-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12695572-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12695760-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12695975-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12696322-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12696492-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12696830-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12697021-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12697152-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12697360-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12697514-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12697709-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12697883-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12698027-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12698283-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12698435-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12698598-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12698774-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12698905-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12699031-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12699157-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12699301-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12699485-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12699618-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12699778-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12699922-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12700088-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12700219-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12700357-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12700560-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12700711-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12700831-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12700996-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12701178-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12701491-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12701666-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12701901-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12702124-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12702443-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12702706-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12702948-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12703190-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12703383-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12703557-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12703716-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12703856-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12704041-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12704191-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12704343-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12704513-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12704636-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12704844-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12705013-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12705220-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12705458-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12705698-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12705978-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12706240-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12706410-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12706644-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12707040-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12707199-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12707432-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12707781-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12708293-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12708520-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12708654-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12708941-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12709103-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12709349-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12709591-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12709688-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12709901-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12710295-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12710415-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12710577-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12710693-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12710917-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12711182-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12711398-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12711596-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12711817-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12711984-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12712149-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12712320-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12712488-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12712626-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12712820-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12713063-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12713358-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12713521-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12713664-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12713866-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12714114-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12714254-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12714550-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12714755-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12714949-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12715195-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12715408-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12715569-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12715914-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12716166-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12716400-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12716594-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12716861-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12717072-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12717224-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12717524-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12717644-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12717914-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12718074-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12718314-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12718483-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12718685-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('12718807-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12718995-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12719277-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12719455-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12719684-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12719944-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12720200-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12720354-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12720532-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12720893-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12721122-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12721357-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12721477-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12721705-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12721864-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12722071-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12722382-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12722567-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12722768-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('12722884-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12723062-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12723330-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12723446-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12723610-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12723835-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12723985-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12724201-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12724942-n',[ ('WillowTree',equivalence)]).
nounMapping2SUMO('12725521-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12725738-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12725940-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12726159-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12726357-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12726528-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12726670-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12726902-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12727101-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12727301-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12727518-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12727729-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12727960-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12728164-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12728322-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12728508-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12728656-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12728864-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12729023-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12729164-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12729315-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12729521-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12729729-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12729950-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12730143-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12730370-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12730544-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12730776-n',[ ('WillowTree',subsumption)]).
nounMapping2SUMO('12731029-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12731202-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12731401-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12731714-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12731835-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12732009-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12732252-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12732491-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12732605-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12732756-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12732966-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12733218-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12733428-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12733647-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12733870-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12734070-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12734215-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12734446-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12734722-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12735009-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12735160-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12735452-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12735666-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12735817-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12736064-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12736228-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12736455-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12736603-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12736840-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12736999-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12737251-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12737383-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12737745-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12737898-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12738087-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12738259-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12738480-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12738599-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12738859-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12739072-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12739332-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12739595-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12739801-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12739966-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12740196-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12740514-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12740967-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12741079-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12741222-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12741409-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12741586-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12741792-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12742041-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12742290-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12742546-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12742741-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12742878-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12743009-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12743232-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12743352-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12743680-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12743823-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12743976-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12744142-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12744277-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12744387-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12744656-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12744850-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12745160-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12745386-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12745564-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12745788-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12745976-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12746106-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12746253-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12746474-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12746733-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12746884-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12747120-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12747371-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12747563-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12747831-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12747961-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12748248-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12748534-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12748815-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12749049-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12749289-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12749456-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12749679-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12749852-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12750076-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12750306-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12750577-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12750767-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12751043-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12751172-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12751402-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12751554-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12751675-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12751823-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12752039-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12752205-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12752666-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12752892-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12753007-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12753245-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12753573-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12753762-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12754003-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12754174-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12754311-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12754468-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12754648-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12754781-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12754981-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12755225-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12755387-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12755559-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12755727-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12755876-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12756059-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12756286-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12756457-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12756862-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12757115-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12757303-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12757458-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12757668-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12757816-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12757930-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12758014-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12758099-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12758176-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12758250-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12758325-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12758399-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12758471-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12758555-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12758639-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12759120-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12759273-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12759496-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12759668-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12760013-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12760132-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12760316-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12760539-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12760722-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12760875-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12761123-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12761284-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12761471-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12761702-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12761905-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12762049-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('12762245-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12762405-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12762583-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12762896-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12763205-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12763291-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12763529-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12763762-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12764008-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12764202-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12764507-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12764703-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12764978-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12765115-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12765402-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12765679-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12765846-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12766043-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12766241-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12766595-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12766869-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12767208-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12767423-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12767648-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12767951-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12768177-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12768369-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12768682-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12768809-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12768933-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12769065-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12769219-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12769318-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12769430-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12769663-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12769815-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12770068-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12770277-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12770529-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12770736-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12770892-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12771085-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12771192-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12771390-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12771597-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12771890-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12772081-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12772419-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12772557-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12772753-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12772908-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12773142-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12773334-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12773488-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12773651-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12773917-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12774127-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12774299-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12774496-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12774641-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12774891-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12775070-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12775225-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12775393-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12775530-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12775717-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12775919-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12776212-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12776391-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12776558-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12776774-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12776946-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12777179-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12777294-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12777436-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12777680-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12777778-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12777892-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12778045-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12778219-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12778398-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12778605-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12778926-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12779233-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12779437-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12779603-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12779851-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12780168-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('12780325-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12780563-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12780852-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12781007-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12781241-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12781421-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12781659-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12781814-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12781940-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12782108-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12782338-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12782530-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12782774-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12782915-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12783173-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12783316-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12783601-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12783730-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12783996-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12784173-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12784371-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12784543-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12784738-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12784889-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12785110-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12785312-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12785499-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12785724-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12785889-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12786097-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12786273-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12786464-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12786684-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12786836-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12787007-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12787196-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12787364-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12787565-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12787846-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12788201-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12788487-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12788678-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12788854-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12789054-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12789226-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12789399-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12789554-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12789767-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12789977-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12790185-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12790430-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12790656-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12790835-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12791064-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12791329-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12791539-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12791790-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12792041-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12792638-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12793015-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12793284-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12793494-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12793695-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12793886-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12794135-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12794367-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12794568-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12794853-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12794985-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12795209-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12795352-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12795555-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12795829-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12796022-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12796192-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12796385-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12796617-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12796849-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12797025-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12797213-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12797368-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12797693-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12797860-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12798041-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12798284-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12798466-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12798632-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12798910-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12799119-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12799269-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12799580-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12799776-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12800049-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12800327-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12800586-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12800832-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12801072-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12801323-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12801520-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12801781-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12801966-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12802248-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12802442-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12802707-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12802987-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12803226-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12803517-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12803754-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12803958-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12804216-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12804352-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12804621-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12804866-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12805146-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12805373-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12805561-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12805762-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12805899-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12806015-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12806270-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12806455-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12806732-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12807082-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12807251-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12807409-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12807624-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12807773-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12808007-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12808227-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12808751-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12808933-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12809233-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12809365-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12809626-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12809868-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12810007-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12810151-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12810318-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12810595-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12810847-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12811027-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12811294-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12811501-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12811713-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12811856-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12812121-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12812235-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12812478-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12812665-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12812801-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12813024-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12813189-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12813393-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12813753-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12813870-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12814003-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12814235-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12814417-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12814643-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12814857-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12814960-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12815060-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12815198-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12815434-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12815668-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12815838-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12815925-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12816359-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12816508-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12816753-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12816942-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12817129-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12817335-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12817464-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12817694-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12817855-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12818004-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12818147-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12818346-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12818601-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12818742-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12818966-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12819141-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12819354-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12819560-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12819728-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12819953-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12820113-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12820292-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12820434-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12820669-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12820853-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12821048-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12821257-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12821505-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12821736-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12821895-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12822115-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12822284-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12822466-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12822650-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12822769-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12822955-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12823164-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12823531-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12823717-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12823859-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12824053-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12824289-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12824482-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12824581-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12824735-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12824909-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12825061-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12825301-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12825497-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12825721-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12825949-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12826143-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12826395-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12826516-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12826895-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12827068-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12827270-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12827537-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12827684-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12827907-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12828220-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12828379-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12828520-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12828628-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12828791-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12828977-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12829099-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12829582-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12829809-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12829975-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12830080-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12830222-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12830404-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12830568-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12830789-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12830974-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12831141-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12831389-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12831535-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12831776-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12831932-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12832140-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12832315-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12832538-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12832690-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12832822-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12832976-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12833149-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12833341-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12833526-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12833793-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12833985-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12834190-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12834408-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12834671-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12834798-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12834938-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12835196-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12835331-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12835578-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12835766-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12836033-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12836212-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12836337-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12836508-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12836663-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12836862-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12837052-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12837259-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12837466-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12837643-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12837803-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12838027-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12839319-n',[ ('Mint',equivalence)]).
nounMapping2SUMO('12839409-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12839574-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12839839-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12839979-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12840168-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12840362-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12840502-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12840640-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12840749-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12841007-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12841193-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12841354-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12841472-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12841686-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12841872-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12842105-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12842302-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12842519-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12842642-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12842765-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12842887-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12843144-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12843316-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12843557-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12843844-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12843970-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12844220-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12844409-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12844697-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12844939-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12845187-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12845413-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12845732-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12845908-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12846143-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12846335-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12846546-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12846690-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12846869-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12847008-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12847254-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12847374-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12847749-n',[ ('Mint',subsumption)]).
nounMapping2SUMO('12847927-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12848212-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12848343-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12848499-n',[ ('Mint',subsumption)]).
nounMapping2SUMO('12848770-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12848870-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12849061-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12849279-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12849416-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12849597-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12849717-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12849952-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12850168-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12850336-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12850531-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12850718-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12850906-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12851094-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12851304-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12851469-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12851673-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12851860-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12852049-n',[ ('Mint',subsumption)]).
nounMapping2SUMO('12852234-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12852428-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12852570-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12852726-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12852930-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12853080-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12853287-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12853482-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12853706-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12853901-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12854048-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12854193-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12854443-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12854600-n',[ ('Mint',subsumption)]).
nounMapping2SUMO('12854925-n',[ ('Mint',subsumption)]).
nounMapping2SUMO('12855042-n',[ ('Mint',subsumption)]).
nounMapping2SUMO('12855365-n',[ ('Mint',subsumption)]).
nounMapping2SUMO('12855494-n',[ ('Mint',subsumption)]).
nounMapping2SUMO('12855710-n',[ ('Mint',subsumption)]).
nounMapping2SUMO('12855886-n',[ ('Mint',subsumption)]).
nounMapping2SUMO('12856091-n',[ ('Mint',subsumption)]).
nounMapping2SUMO('12856287-n',[ ('Mint',subsumption)]).
nounMapping2SUMO('12856479-n',[ ('Mint',subsumption)]).
nounMapping2SUMO('12856680-n',[ ('Mint',subsumption)]).
nounMapping2SUMO('12856868-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12857024-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12857204-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12857456-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12857594-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12857779-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12858019-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12858150-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12858397-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12858618-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12858871-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12858987-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12859153-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12859272-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12859488-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12859679-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12859873-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12859986-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12860254-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12860365-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12860542-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12860842-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12860978-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12861139-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12861345-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12861541-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12861751-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12861892-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12862116-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12862312-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12862512-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12862648-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12862828-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12863026-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12863234-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12863458-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12863624-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12863819-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12864038-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12864160-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12864363-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12864545-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12864902-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12865037-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12865239-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12865367-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12865562-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12865708-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12865824-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12866002-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12866162-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12866333-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12866459-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12866635-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12866824-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12866968-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12867184-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12867449-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12867679-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12867826-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12868019-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12868248-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12868418-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12868634-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12868880-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12869061-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12869248-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12869478-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12869668-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12869874-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12870048-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12870225-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12870392-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12870535-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12870682-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12870891-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12871074-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12871272-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12871484-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12871696-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12871859-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12871992-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12872257-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12872458-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12872698-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12872914-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12873182-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12873341-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12873646-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12873834-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12873984-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12874231-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12874429-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12874642-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12874783-n',[ ('Sesame',equivalence)]).
nounMapping2SUMO('12874996-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12875269-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12875594-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12875697-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12875861-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12876032-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12876684-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12876899-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12877041-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12877244-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12877493-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12877637-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12877838-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12878019-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12878169-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12878325-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12878525-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12878784-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12879068-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12879350-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12879527-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12879719-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12879963-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12880244-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12880462-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12880638-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12880799-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12880963-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12881105-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12881429-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12881631-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12881913-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12882158-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12882321-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12882591-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12882779-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12882945-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12883265-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12883395-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12883628-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12883733-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12883923-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12884100-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12884260-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12884523-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12885045-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12885265-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12885510-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12885754-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12885956-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12886185-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12886402-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12886600-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12886831-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12887065-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12887293-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12887532-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12887713-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12888016-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12888234-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12888457-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12888733-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12888906-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12889219-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12889412-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12889579-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12889713-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12890009-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12890265-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12890490-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12890685-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12890928-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12891093-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12891305-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12891469-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12891643-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12891824-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12892013-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12892226-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12893094-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12893463-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12893794-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12893993-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12894247-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12894438-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12894607-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12894930-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12895298-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12895578-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12895811-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12896000-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12896307-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12896615-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12896862-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12897118-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12897341-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12897493-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12897788-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12897999-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12898226-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12898342-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12898628-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12898774-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12898959-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12899166-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12899333-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12899537-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12899752-n',[ ('Shrub',subsumption)]).
nounMapping2SUMO('12899971-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12900148-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12900462-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12900783-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12900987-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12901264-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12901565-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12901724-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12902021-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12902297-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12902466-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12902662-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12902887-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12903014-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12903250-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12903367-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12903503-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12903794-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12903964-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12904148-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12904314-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12904562-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12904720-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12904938-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12905135-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12905412-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12905655-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12905817-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12906021-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12906214-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12906334-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12906498-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12906771-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12906926-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12907057-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12907287-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12907465-n',[ ('Tobacco',equivalence)]).
nounMapping2SUMO('12907671-n',[ ('Tobacco',subsumption)]).
nounMapping2SUMO('12907857-n',[ ('Tobacco',subsumption)]).
nounMapping2SUMO('12908093-n',[ ('Tobacco',subsumption)]).
nounMapping2SUMO('12908230-n',[ ('Tobacco',subsumption)]).
nounMapping2SUMO('12908432-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12908645-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12908854-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12909068-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12909252-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12909421-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12909614-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12909759-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12909917-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12910141-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12910285-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12910676-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12910875-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12911079-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12911264-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12911440-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12911673-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12911914-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12912105-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12912274-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12912498-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12912670-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12912801-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12913004-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12913144-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12913352-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12913524-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12913645-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12913791-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12914048-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12914193-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12914433-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12914731-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12914923-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12915140-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12915230-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12915400-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12915568-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12915811-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12916025-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12916179-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12916356-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12916511-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('12916723-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12916935-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12917338-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12917901-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12918404-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12918609-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12918810-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12918991-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12919195-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12919403-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12919646-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12919847-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12920043-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12920204-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12920521-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12920719-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12920955-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12921126-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12921315-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12921499-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12921660-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12921868-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12922119-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12922283-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12922458-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12922600-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12922763-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12922933-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12923108-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12923257-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12923439-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12923652-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12923839-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12924036-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12924284-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12924452-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12924623-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12924984-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12925179-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12925394-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12925583-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12925836-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12926039-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12926316-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12926480-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12926689-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12927013-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12927194-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12927354-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12927494-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12927758-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12927921-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12928071-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12928307-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12928491-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12928690-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12928819-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('12929061-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12929237-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12929403-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12929600-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12929783-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12930044-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12930778-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12930951-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12931109-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12931231-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12931449-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12931542-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12931738-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12931906-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12932173-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12932365-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12932532-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12932706-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12932966-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12933164-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12933274-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12933403-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12933616-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12933827-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12934036-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12934174-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12934368-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12934479-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12934685-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12934776-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12934985-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12935166-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12935457-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12935609-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12935982-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12936155-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12936333-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12936469-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12936713-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12936826-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12936999-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12937130-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12937388-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12937678-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12937822-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12938081-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12938193-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12938445-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12938667-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12938897-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12939104-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12939282-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12939479-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12939664-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12939874-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12940060-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12940226-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12940427-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12940609-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12940778-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12940939-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12941220-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12941360-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12941536-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12941717-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12941914-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('12942025-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12942270-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12942395-n',[ ('Parsley',equivalence)]).
nounMapping2SUMO('12942572-n',[ ('Parsley',subsumption)]).
nounMapping2SUMO('12942729-n',[ ('Parsley',subsumption)]).
nounMapping2SUMO('12942930-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12943049-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12943302-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12943443-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12943743-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12943912-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12944095-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12944238-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12944390-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12944590-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12944723-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12944960-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12945177-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12945366-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12945549-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12945708-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12945828-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12946088-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12946432-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12946578-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12946849-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12947171-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('12947313-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12947544-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12947756-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12947895-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12948053-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12948251-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12948495-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12948633-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12948849-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12948978-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12949160-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12949361-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12949549-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12949722-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12949955-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12950126-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12950314-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12950501-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12950669-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12950796-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12950984-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12951146-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('12951331-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('12951465-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12951668-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12951835-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12952022-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12952165-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12952469-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12952590-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12952717-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12952852-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12953079-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12953206-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12953484-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12953712-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12953919-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12954185-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12954353-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12954634-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12954799-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12954978-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12955191-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12955414-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12955639-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12955840-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12956029-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12956170-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12956367-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12956588-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12956791-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12956922-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12957076-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12957298-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12957467-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12957608-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12957803-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12957924-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12958140-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12958261-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12958470-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12958615-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12958772-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12958921-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12959074-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12959226-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12959371-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12959538-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12959802-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12959967-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12960211-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12960378-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12960552-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12960729-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12960863-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12961112-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12961242-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12961393-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12961536-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12961689-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12961879-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12962059-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('12962149-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12962310-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12962389-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12962488-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12962622-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12962847-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12962992-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12963140-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12963307-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12963494-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12963628-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12963796-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12964130-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12964321-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12964572-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12964750-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12964920-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12965056-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12965209-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12965463-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12965626-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12965951-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12966048-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12966193-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12966290-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12966386-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12966581-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12966804-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12966945-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12967124-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12967281-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12967504-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12967656-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12967776-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12967955-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12968136-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12968309-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12968408-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12968658-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12968882-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12969131-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12969425-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12969670-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12969927-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12970193-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12970293-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12970379-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12970560-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12970733-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('12970872-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12971157-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12971400-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12971624-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12971804-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12971956-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12972136-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12972414-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12972629-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12972818-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12972966-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12973202-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12973443-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12973541-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12973791-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12973937-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12974062-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12974286-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12974457-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12974662-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12974826-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12974987-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12975207-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12975608-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12975804-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12975982-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12976198-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12976389-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12976554-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12976672-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12976985-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12977296-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12977565-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12977795-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12978076-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12978232-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12978381-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12978654-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12978826-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12978969-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12979129-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12979316-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12979478-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12979630-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12979829-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12980080-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12980231-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12980478-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12980652-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12980840-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12981086-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12981301-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12981443-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12981595-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12981791-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12981954-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12982103-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12982338-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12982468-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12982590-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12982723-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12982915-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12983048-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12983217-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12983404-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12983654-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12983873-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12983961-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12984160-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12984267-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12984377-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12984489-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12984595-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12984699-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12984802-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12985010-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12985236-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12985420-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12985629-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12985773-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12985857-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12986084-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12986227-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12986337-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12986447-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12986858-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12987056-n',[ ('Lichen',equivalence)]).
nounMapping2SUMO('12987423-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12987535-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12987652-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12987834-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12987993-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12988158-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12988341-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12988572-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12988703-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12988858-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12989007-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12989142-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12989301-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12989462-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12989739-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12989938-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12990092-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12990250-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12990407-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12990597-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12990800-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12990938-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12991184-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12991488-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12991645-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12991837-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12992022-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12992177-n',[ ('Lichen',subsumption)]).
nounMapping2SUMO('12992464-n',[ ('Fungus',equivalence)]).
nounMapping2SUMO('12992868-n',[ ('Fungus',equivalence)]).
nounMapping2SUMO('12994475-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12994711-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('12994892-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('12994979-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12995435-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12995601-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12995724-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12996068-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12996225-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12996841-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12997128-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12997432-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12997654-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12997919-n',[ ('Mushroom',equivalence)]).
nounMapping2SUMO('12998130-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('12998349-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('12998815-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13000372-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13000668-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13000891-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13001041-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13001206-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13001366-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13001529-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13001743-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13001930-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13002209-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13002433-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13002750-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13002925-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13003061-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13003254-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13003522-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13003712-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13003846-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13003974-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13004065-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13004160-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13004423-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13004640-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13004826-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13004992-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13005166-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13005329-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13005568-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13005835-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13005984-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13006171-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13006377-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13006631-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13006741-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13006894-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13007034-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13007195-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13007417-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13007629-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13007770-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13008157-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13008315-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13008485-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13008689-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13008839-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13009085-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13009244-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13009429-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13009656-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13009780-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13010064-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13010219-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13010401-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13010694-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13010951-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13011221-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13011461-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('13011595-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13011679-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13011856-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13012030-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13012253-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13012469-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13012613-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13012835-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13012973-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13013187-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13013534-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13013764-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13013965-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13014097-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13014265-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13014409-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13014581-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13014741-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13014879-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13015040-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13015229-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13015509-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13015688-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13015826-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13016076-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13016289-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13016457-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13016749-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13017102-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13017240-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13017439-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13017610-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13017789-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13017979-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13018088-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13018232-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13018407-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13018579-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13018749-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13018906-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13019017-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13019202-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13019496-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13019643-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13019835-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13020011-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13020191-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13020481-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13020623-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13020964-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13021166-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13021332-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13021543-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13021689-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13021867-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13022078-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13022210-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13022538-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13022709-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13022903-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('13023134-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13023292-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13023783-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13024012-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13024348-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13024500-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13024653-n',[ ('Mushroom',subsumption)]).
nounMapping2SUMO('13024763-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13024967-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13025197-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13025421-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13025647-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13025854-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13026015-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13026146-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13026339-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13026529-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13026763-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13027049-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13027190-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13027375-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13027557-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13027670-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13027879-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13028070-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13028337-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13028611-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13028937-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13029122-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13029326-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13029610-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13029760-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13029946-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13030157-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13030337-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13030438-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13030616-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13030852-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13031007-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13031193-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13031323-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13031474-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13031690-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13031956-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13032115-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13032381-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13032618-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13032923-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13033134-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13033396-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13033577-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13033879-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13034062-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13034277-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13034431-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13034555-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13034788-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13034953-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13035241-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13035389-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13035521-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13035707-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13035925-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13036116-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13036312-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13036592-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13036804-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13036907-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13037124-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13037406-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13037585-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13037805-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13038068-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13038376-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13038577-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13038744-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13038944-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13039349-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13039553-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13039870-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13040108-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13040303-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13040629-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13040796-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13040971-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13041172-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13041312-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13041548-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13041725-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13041943-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13042134-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13042316-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13042514-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13042694-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13042814-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13042982-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13043264-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13043516-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13043746-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13043926-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13044149-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13044375-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13044541-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13044778-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13045027-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13045210-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13045429-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13045594-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13045834-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13045975-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13046130-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13046285-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13046512-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13046669-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13046887-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13047011-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13047216-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13047385-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13047706-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13047862-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13048212-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13048447-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13048666-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13048932-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13049105-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13049285-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13049561-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13049953-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13050397-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13050555-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13050705-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13050940-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13051196-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13051346-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13051546-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13051694-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13051866-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13052014-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13052248-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13052431-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13052670-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13052931-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13053187-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13053450-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13053608-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13053816-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13054073-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13054211-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13054560-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13055009-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13055423-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13055577-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13055792-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13055949-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13056135-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13056349-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13056607-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13056799-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13057054-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13057242-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13057422-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13057639-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13057845-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13058037-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13058272-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13058447-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13058608-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13058796-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13058963-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13059139-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13059298-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13059485-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13059657-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13059852-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13060017-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13060190-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13060451-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13060689-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13060912-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13061172-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13061348-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13061471-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13061704-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13061921-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13062112-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13062272-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13062421-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13062630-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13062868-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13063046-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13063269-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13063514-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13063666-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13063784-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13063936-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13064111-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13064247-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13064457-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13064678-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13064852-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13065089-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13065215-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13065514-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13065702-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13065902-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13066129-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13066448-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13066631-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13066803-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13066979-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13067191-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13067330-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13067532-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13067672-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13067845-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13068073-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13068255-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13068434-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13068565-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13068735-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13068917-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13069224-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13069348-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13069535-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13069773-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13070003-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13070308-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13070708-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13070875-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13071029-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13071371-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13071553-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13071815-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13072031-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13072209-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13072350-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13072528-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13072706-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13072863-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13073055-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13073211-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13073380-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13073526-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13073703-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13073979-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13074084-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13074277-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13074619-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13074814-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13075020-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13075272-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13075441-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13075684-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13075847-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13076041-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13076181-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13076405-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13076643-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13076831-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13077033-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13077295-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13077479-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13077811-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13078021-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13078133-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13078483-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13078652-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13078809-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13079073-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13079203-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13079419-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13079567-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13079775-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13079953-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13080174-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13080306-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13080471-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13080674-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13080866-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13081050-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13081229-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13081369-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13081565-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13081778-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13081999-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13082077-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13082293-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13082568-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13082711-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13082829-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13083023-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13083306-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13083461-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13083586-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13084184-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13084479-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13084633-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('13084834-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13084993-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13085113-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13085747-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13085864-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('13086063-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('13086220-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13086438-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13086556-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('13086753-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('13086908-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13087625-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('13088096-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13088460-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('13088688-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('13088858-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('13088989-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13089135-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13089246-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('13089419-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13089526-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13089631-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13089902-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13090018-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13090091-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13090248-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13090395-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13090594-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13090743-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13090871-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13091057-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13091227-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13091312-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('13091492-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13091620-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13091774-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('13091982-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13092078-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13092240-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13092385-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13092548-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('13092722-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13092836-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13092987-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('13093102-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('13093275-n',[ ('Organ',subsumption)]).
nounMapping2SUMO('13093380-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13093629-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13093725-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13093852-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13093928-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13094003-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13094145-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13094273-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13094381-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('13094556-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('13094732-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('13095013-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('13095348-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13095543-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13095685-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('13096035-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('13096159-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('13096317-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('13096677-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('13096779-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('13096863-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('13097187-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13097338-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13097536-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('13097752-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('13097949-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13098186-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13098420-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13098515-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('13098648-n',[ ('Wood',subsumption)]).
nounMapping2SUMO('13098853-n',[ ('Cell',subsumption)]).
nounMapping2SUMO('13098962-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('13099194-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13099373-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13099444-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('13099586-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('13099734-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('13099833-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13099999-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13100156-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13100677-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13102409-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13102648-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13102775-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13102946-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13103023-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13103136-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13103660-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13103750-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13103877-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('13104059-n',[ ('BotanicalTree',equivalence)]).
nounMapping2SUMO('13107694-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('13107807-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('13107891-n',[ ('BotanicalTree',subsumption)]).
nounMapping2SUMO('13108131-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13108323-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13108481-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13108545-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13108662-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13108841-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13109733-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13110915-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13111174-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13111340-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13111504-n',[ ('PlantBranch',subsumption)]).
nounMapping2SUMO('13111700-n',[ ('PlantBranch',subsumption)]).
nounMapping2SUMO('13111881-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13112035-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13112201-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13112296-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13112427-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13112664-n',[ ('Shrub',subsumption)]).
nounMapping2SUMO('13118330-n',[ ('Shrub',subsumption)]).
nounMapping2SUMO('13118398-n',[ ('FloweringPlant',instance)]).
nounMapping2SUMO('13118569-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13118707-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13119870-n',[ ('Shrub',subsumption)]).
nounMapping2SUMO('13120003-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13120211-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13120446-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13120775-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13120958-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13121104-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13121349-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13121544-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13122364-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13122985-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13123309-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13123431-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13123681-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13123841-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13124019-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13124164-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('13124358-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('13124529-n',[ ('Organism',subsumption)]).
nounMapping2SUMO('13124654-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13124855-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13125003-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('13125117-n',[ ('PlantRoot',equivalence)]).
nounMapping2SUMO('13125882-n',[ ('PlantRoot',subsumption)]).
nounMapping2SUMO('13126050-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13126192-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13126308-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('13126428-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13126580-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13126684-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13126856-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13127001-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13127091-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13127303-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13127473-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13127666-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13127843-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13128003-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13128156-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13128278-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13128365-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13128582-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13128771-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13128976-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13129078-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13129165-n',[ ('PlantBranch',equivalence)]).
nounMapping2SUMO('13129826-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13129938-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13130014-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13130161-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13130305-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13130423-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13130569-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13130726-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13130885-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('13131028-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13131282-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13131516-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13131618-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13131752-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13131883-n',[ ('PlantLeaf',subsumption)]).
nounMapping2SUMO('13132034-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13132156-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13132338-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13132486-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13132656-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13132756-n',[ ('Flower',subsumption)]).
nounMapping2SUMO('13132940-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13133140-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13133233-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13133316-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13133438-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13133613-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13133786-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13133932-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13134059-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13134302-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13134531-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13134680-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13134844-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13134947-n',[ ('FruitOrVegetable',equivalence)]).
nounMapping2SUMO('13135692-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13135832-n',[ ('Seed',equivalence)]).
nounMapping2SUMO('13136316-n',[ ('Bean',equivalence)]).
nounMapping2SUMO('13136556-n',[ ('Nut',equivalence)]).
nounMapping2SUMO('13136781-n',[ ('Nut',subsumption)]).
nounMapping2SUMO('13136863-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13137010-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13137225-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('13137409-n',[ ('Berry',equivalence)]).
nounMapping2SUMO('13137672-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13137951-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13138155-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13138308-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13138658-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13138842-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13139055-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13139321-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13139482-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('13139647-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13139837-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13139918-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13140049-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13140242-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13140367-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13140535-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13140699-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13140993-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13141141-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13141415-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13141564-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13141797-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13141972-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13142182-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13142380-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13142504-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13142695-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13142907-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13143097-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13143285-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13143483-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13143626-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13143758-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13143930-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13144084-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13144303-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13144511-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13144794-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13145040-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13145250-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13145444-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13145924-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13146035-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13146225-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13146403-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13146583-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13146740-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13146928-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13147045-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13147153-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13147270-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13147386-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13147532-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13147689-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13147788-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13147918-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13148019-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13148208-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13148384-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13148602-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13148791-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13149039-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13149296-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13149506-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13149829-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13149970-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13150178-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13150378-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13150592-n',[ ('FruitOrVegetable',subsumption)]).
nounMapping2SUMO('13150741-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13150894-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13151082-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13151265-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13151439-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13151568-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13151820-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13151975-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13152203-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13152339-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13152592-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13152742-n',[ ('Leaf',equivalence)]).
nounMapping2SUMO('13153532-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13153633-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13153729-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('13153888-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('13154077-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13154190-n',[ ('Gland',subsumption)]).
nounMapping2SUMO('13154388-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13154494-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13154586-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13154736-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13154841-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13155095-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13155175-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13155305-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13155451-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13155611-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13155759-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13155899-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13156006-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13156083-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13156592-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13156799-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13156884-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13156986-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13157137-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13157346-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13157481-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13157595-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13157684-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13157780-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13157858-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13157971-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13158071-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13158167-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13158258-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13158386-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13158512-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13158605-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13158714-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13158815-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13158925-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13159044-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13159155-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13159263-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13159357-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13159457-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13159558-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13159691-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13159778-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13159890-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13160015-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13160116-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13160254-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13160365-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13160485-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13160604-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13160695-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13160831-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13160938-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13161056-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13161151-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13161254-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13161412-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13161506-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13161639-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13161754-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13161904-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13161998-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13162164-n',[ ('Leaf',subsumption)]).
nounMapping2SUMO('13162297-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13162815-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13162945-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13163093-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13163250-n',[ ('PlantBranch',equivalence)]).
nounMapping2SUMO('13163471-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13163553-n',[ ('PlantBranch',subsumption)]).
nounMapping2SUMO('13163649-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13163803-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13163991-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13164285-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('13164403-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13164501-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13164583-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13164763-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13164881-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13164970-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13165086-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13165286-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13165409-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13165552-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13165646-n',[ ('PlantBranch',subsumption)]).
nounMapping2SUMO('13165727-n',[ ('TreeBranch',subsumption)]).
nounMapping2SUMO('13165815-n',[ ('PlantBranch',subsumption)]).
nounMapping2SUMO('13166044-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13166191-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13166338-n',[ ('Fern',equivalence)]).
nounMapping2SUMO('13167078-n',[ ('Fern',equivalence)]).
nounMapping2SUMO('13169219-n',[ ('Fern',equivalence)]).
nounMapping2SUMO('13169674-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13170060-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13170286-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13170498-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13170661-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13170840-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13171041-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13171210-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13171447-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13171649-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13171797-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13171975-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13172107-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13172725-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13172923-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13173132-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13173259-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13173488-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13173697-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13173882-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13174206-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13174354-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13174515-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13174670-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13174823-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13175074-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13175324-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13175484-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13175682-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13175847-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13176000-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13176201-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13176363-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13176523-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13176714-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13176873-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13177048-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13177354-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13177529-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13177768-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13177884-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13178107-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13178284-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13178500-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13178707-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13178883-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13179056-n',[ ('Plant',subsumption)]).
nounMapping2SUMO('13179216-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13179410-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13179648-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13179804-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13179972-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13180304-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13180534-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13180875-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13181055-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13181244-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13181406-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13181616-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13181811-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13181988-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13182164-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13182338-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13182462-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13182662-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13182799-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13182937-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13183056-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13183251-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13183489-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13183669-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13183874-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13184001-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13184164-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13184394-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13184492-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13184873-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13185134-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13185269-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13185436-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13185658-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13185820-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13185998-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13186200-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13186388-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13186546-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13186654-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13187031-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13187167-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13187367-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13187604-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13187826-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13188096-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13188268-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13188462-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13188619-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13188767-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13188973-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13189222-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13189428-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13189656-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13189844-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13190060-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13190218-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13190469-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13190747-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13190917-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13191148-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13191318-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13191620-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13191770-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13191884-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13192025-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13192625-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13192898-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13193143-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13193269-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13193466-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13193642-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13193856-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13194036-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13194212-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13194328-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13194572-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13194758-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13194918-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13195151-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13195341-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13195547-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13195761-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13196003-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13196234-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13196369-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13196545-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13196738-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13196942-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13197085-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13197274-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13197507-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13197670-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13197800-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13198054-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13198354-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13198482-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13198728-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13198914-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13199244-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13199445-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13199717-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13199970-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13200193-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13200411-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13200542-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13200651-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13200806-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13200986-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13201239-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13201423-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13201566-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13201725-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13201969-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13202125-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13202355-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13202602-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13202749-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13202933-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13203115-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13203251-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13203405-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13203551-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13203708-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13203842-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13204102-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13204276-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13204482-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13204646-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13204826-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13205058-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13205249-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13205482-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13206001-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13206178-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13206438-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13206584-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13206817-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13207094-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13207335-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13207572-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13207736-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13207923-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13208138-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13208302-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13208468-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13208705-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13208965-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13209129-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13209270-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13209460-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13209647-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13209808-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13210006-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13210205-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13210350-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13210597-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13210827-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13211020-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13211179-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13211305-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13211516-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13211790-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13212025-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13212175-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13212379-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13212559-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13212751-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13213066-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13213235-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13213397-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13213577-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13213768-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13214031-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13214217-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13214340-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13214485-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13214645-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13214813-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13215063-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13215258-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13215462-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13215586-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13215799-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13215936-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13216238-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13216475-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13216673-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13216812-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13217005-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13217213-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13217494-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13217624-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13217763-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13217993-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13218114-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13218281-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13218504-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13218722-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13218900-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13219067-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13219258-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13219422-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13219833-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13219976-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13220122-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13220355-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13220525-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13220663-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13220842-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13221243-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13221383-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13221529-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13221807-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13222035-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13222227-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13222477-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13222669-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13222877-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13222985-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13223090-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13223265-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13223485-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13223588-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13223710-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13223843-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13224086-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13224256-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13224454-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13224673-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13224922-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13225075-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13225244-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13225365-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13225617-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13225729-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13225955-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13226135-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13226320-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13226526-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13226698-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13226871-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13227009-n',[ ('NonFloweringPlant',subsumption)]).
nounMapping2SUMO('13227235-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13227557-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13227778-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13228017-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13228194-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13228357-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13228536-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13228692-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13228867-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13229018-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13229227-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13229358-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13229543-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13229747-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13229951-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13230190-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13230421-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13230662-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13230843-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13231078-n',[ ('Fern',subsumption)]).
nounMapping2SUMO('13231298-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13231436-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13231678-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13231919-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13232106-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13232363-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13232515-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13232779-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('13233012-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13233435-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13233548-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13233727-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13234114-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13234293-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13234519-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13234678-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13234857-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13235011-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13235159-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13235319-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13235503-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13235766-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13235947-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13236100-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13236354-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13236495-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13236726-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13236887-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13237075-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13237188-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13237343-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13237508-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13237788-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13237988-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13238178-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13238375-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13238654-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13238828-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13238988-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13239177-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13239471-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13239736-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13239921-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13240025-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13240203-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13240362-n',[ ('FloweringPlant',subsumption)]).
nounMapping2SUMO('13240514-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13240839-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13240971-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('13241057-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13241182-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13241407-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13241600-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13241940-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13242239-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13242410-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13242484-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13242558-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13242719-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13242923-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13243134-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13243261-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13243374-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13243466-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('13243668-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13243780-n',[ ('Proprietorship',equivalence)]).
nounMapping2SUMO('13243991-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13244109-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13244753-n',[ ('Object',subsumption)]).
nounMapping2SUMO('13244881-n',[ ('PropertyFn',equivalence)]).
nounMapping2SUMO('13245076-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13245217-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13245338-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13245504-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13245626-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13245846-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13246079-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13246332-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13246475-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13246662-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13247149-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13247228-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13247358-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13247445-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13247554-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13247712-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13247818-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13247981-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13248087-n',[ ('Position',subsumption)]).
nounMapping2SUMO('13248274-n',[ ('Position',subsumption)]).
nounMapping2SUMO('13248393-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13248598-n',[ ('Automobile',subsumption)]).
nounMapping2SUMO('13248792-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13248928-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13249062-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13249154-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13249245-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13249400-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13249599-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13249699-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13249805-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13249927-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13250048-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13250244-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13250398-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13250542-n',[ ('WealthFn',equivalence)]).
nounMapping2SUMO('13250680-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13250930-n',[ ('WealthFn',equivalence)]).
nounMapping2SUMO('13251154-n',[ ('PropertyFn',equivalence)]).
nounMapping2SUMO('13251289-n',[ ('WealthFn',equivalence)]).
nounMapping2SUMO('13251424-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13251715-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13251906-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13251980-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13252062-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13252168-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13252293-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13252395-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13252513-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13252672-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13252853-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13252973-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13253255-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('13253423-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('13253612-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('13253751-n',[ ('Buying',subsumption)]).
nounMapping2SUMO('13254011-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13254105-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13254237-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13254443-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13254697-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13254805-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13254985-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13255145-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13255562-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13255713-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13255883-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13255994-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13256303-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13256434-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13256599-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13256691-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13256894-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13257098-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13257354-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13257511-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13257792-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13257982-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13258167-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13258269-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13258362-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13258825-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13259013-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13259199-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13259359-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13259481-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13259630-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13259797-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13259917-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('13260092-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13260190-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13260510-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13260645-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13260762-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13260936-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13261107-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13261242-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13261380-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13261597-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13261779-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13261916-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13262077-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13262200-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13262335-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13262462-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('13262663-n',[ ('UnilateralGetting',subsumption)]).
nounMapping2SUMO('13262913-n',[ ('Getting',subsumption)]).
nounMapping2SUMO('13263257-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13263375-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13263540-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13263779-n',[ ('Bequeathing',subsumption)]).
nounMapping2SUMO('13263920-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13264076-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13264203-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13264342-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13264522-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13264688-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13264794-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13265011-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13265425-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13265603-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13265749-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13265904-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13266170-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13266348-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13266515-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13266690-n',[ ('Giving',instance)]).
nounMapping2SUMO('13266892-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13267014-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13267263-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13267411-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13267534-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13267687-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13267816-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13268020-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13268146-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13268484-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13268683-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13268758-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13268842-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13269054-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13269186-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13269318-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13269459-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13269596-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13269683-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13269890-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13270038-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13270260-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13270373-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13270545-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13270648-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13270760-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13270906-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13271094-n',[ ('FinancialInstrument',subsumption)]).
nounMapping2SUMO('13271320-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13271498-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13271631-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13271705-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13271797-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13271937-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13272059-n',[ ('Transaction',subsumption)]).
nounMapping2SUMO('13272283-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13272545-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13272712-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13272860-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13273050-n',[ ('Expressing',subsumption)]).
nounMapping2SUMO('13273154-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13273381-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('13273550-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13273738-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13273836-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13273949-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13274092-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13274364-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13274487-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13274597-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13274732-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13274892-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13275137-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('13275288-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13275495-n',[ ('Payment',equivalence)]).
nounMapping2SUMO('13275847-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13276330-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13276519-n',[ ('Payment',subsumption)]).
nounMapping2SUMO('13276604-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13276778-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13276913-n',[ ('Payment',subsumption)]).
nounMapping2SUMO('13277056-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13277179-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13277492-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13277644-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13277789-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13277886-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13278100-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13278275-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13278375-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13279046-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13279162-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13279262-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13279809-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13279913-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13280008-n',[ ('Transaction',subsumption)]).
nounMapping2SUMO('13280139-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13280251-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13280373-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13280515-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13280658-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13280795-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13280896-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13280992-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13281130-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13281275-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13281476-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13281641-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13281770-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13281925-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13282007-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13282161-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13282275-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13282419-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13282550-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13282948-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13283033-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13283187-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13283314-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13283485-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13283620-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13283764-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13283952-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13284048-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13284184-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13284283-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13284356-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13284442-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13284562-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13284784-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13284973-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13285101-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13285176-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13285619-n',[ ('FinancialInstrument',subsumption)]).
nounMapping2SUMO('13285714-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13285855-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13285973-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13286099-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13286254-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13286524-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13286640-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13286801-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13287239-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13287414-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13287540-n',[ ('FinancialInstrument',subsumption)]).
nounMapping2SUMO('13287787-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13287984-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13288206-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13288337-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13288529-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13288661-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13288798-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13288942-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13289020-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('13289159-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13289306-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13289467-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13289630-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13289744-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13289845-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13290002-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13290285-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13290566-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13290676-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13290991-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13291189-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13291356-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13291614-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13291831-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13292104-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13292244-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13292390-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13292613-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13292787-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13292989-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13293246-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13293377-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13293512-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13293625-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13293752-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13293901-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13294029-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13294135-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13294302-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13294403-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13294503-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13294763-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13295025-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13295183-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13295360-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('13295657-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13295972-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13296089-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13296194-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13296270-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13296460-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13296593-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('13296752-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('13296899-n',[ ('Funding',equivalence)]).
nounMapping2SUMO('13297097-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13297254-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13297397-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13297595-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13297740-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13297850-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13298011-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13298287-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13298537-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13298701-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13298935-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13299071-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13299248-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13299357-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13299453-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13299651-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13299804-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13300025-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13300141-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13300324-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13300411-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13300555-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13300711-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13300828-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13300922-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13301174-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13301328-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13301500-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13301620-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13301715-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13301835-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13302001-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13302201-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13302293-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13302467-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13302621-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13302775-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13302905-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13303045-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13303214-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13303315-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13303759-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13303880-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13304009-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13304186-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13304340-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13304508-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13304665-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13304819-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13304927-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13305070-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13305262-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13305373-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13305510-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13305673-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13305794-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13305932-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13306190-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13306346-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13306436-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13306669-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13306870-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13307370-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13307514-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13307685-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13307784-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13307901-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13307995-n',[ ('Corkage',equivalence)]).
nounMapping2SUMO('13308147-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13308336-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13308432-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13308543-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13308650-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13308750-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13308864-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13308999-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13309776-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13309865-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13309956-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13310091-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13310230-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13310415-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13310539-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13310727-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13310858-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13310985-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13311217-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13311368-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13311573-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13311679-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13311830-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13312010-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13312190-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13312329-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13312434-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13312569-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13312754-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13312962-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13313188-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13313322-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13313464-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13313591-n',[ ('Law',subsumption)]).
nounMapping2SUMO('13313733-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('13313899-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13314085-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13314226-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13314355-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13314495-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13314652-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13314796-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13314936-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13315077-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13315191-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13315364-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13315518-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13315616-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13315743-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('13315827-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13315999-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13316332-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13316568-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13316722-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13316905-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13317002-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13317137-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13317269-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13317422-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13317517-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13317611-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13317759-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13317858-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13317941-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13318024-n',[ ('Tax',subsumption)]).
nounMapping2SUMO('13318147-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13318411-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13318584-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13318804-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13318934-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13319032-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13319253-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13319415-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13319512-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13319726-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13319872-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13320045-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13320168-n',[ ('ChargingAFee',equivalence)]).
nounMapping2SUMO('13320691-n',[ ('ChargingAFee',subsumption)]).
nounMapping2SUMO('13320766-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13320860-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13321081-n',[ ('ChargingAFee',subsumption)]).
nounMapping2SUMO('13321230-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13321338-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13321495-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13321722-n',[ ('ChargingAFee',subsumption)]).
nounMapping2SUMO('13321992-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13322113-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13322343-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13322520-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13322641-n',[ ('ChargingAFee',subsumption)]).
nounMapping2SUMO('13322758-n',[ ('ChargingAFee',subsumption)]).
nounMapping2SUMO('13322867-n',[ ('ChargingAFee',subsumption)]).
nounMapping2SUMO('13322938-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13323102-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13323207-n',[ ('ChargingAFee',subsumption)]).
nounMapping2SUMO('13323313-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13323460-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13323648-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13323749-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13323885-n',[ ('ChargingAFee',subsumption)]).
nounMapping2SUMO('13323988-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13324188-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13324297-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13324427-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13324609-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13324710-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13324826-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13324912-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13325010-n',[ ('PerFn',equivalence)]).
nounMapping2SUMO('13325382-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13325505-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13325722-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13325847-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13326021-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13326103-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13326198-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13326450-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13326620-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13326772-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13326871-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13326975-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13327136-n',[ ('PerFn',subsumption)]).
nounMapping2SUMO('13327231-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13327503-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13327676-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13327896-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13328073-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13328273-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13328357-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13328578-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13328853-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13329047-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13329322-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13329489-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13329641-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13330168-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13330283-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13330425-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13330591-n',[ ('FinancialInstrument',subsumption)]).
nounMapping2SUMO('13330764-n',[ ('FinancialInstrument',subsumption)]).
nounMapping2SUMO('13330941-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13331198-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13331634-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13331778-n',[ ('WealthFn',equivalence)]).
nounMapping2SUMO('13332009-n',[ ('Object',subsumption)]).
nounMapping2SUMO('13332197-n',[ ('Human',subsumption)]).
nounMapping2SUMO('13332290-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13332395-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('13332500-n',[ ('Object',subsumption)]).
nounMapping2SUMO('13332670-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('13332820-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('13333047-n',[ ('FinancialInstrument',subsumption)]).
nounMapping2SUMO('13333237-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13333420-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13333546-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13333696-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13333833-n',[ ('Stock',equivalence)]).
nounMapping2SUMO('13334307-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13334492-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13334650-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13334767-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13335008-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13335172-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13335521-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13335635-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13335808-n',[ ('Stock',subsumption)]).
nounMapping2SUMO('13335974-n',[ ('Stock',subsumption)]).
nounMapping2SUMO('13336204-n',[ ('Stock',subsumption)]).
nounMapping2SUMO('13336368-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13336492-n',[ ('Stock',subsumption)]).
nounMapping2SUMO('13336650-n',[ ('Stock',subsumption)]).
nounMapping2SUMO('13336770-n',[ ('Stock',subsumption)]).
nounMapping2SUMO('13336933-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13337050-n',[ ('Stock',subsumption)]).
nounMapping2SUMO('13337146-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13337322-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13337471-n',[ ('Bond',subsumption)]).
nounMapping2SUMO('13337634-n',[ ('Bond',subsumption)]).
nounMapping2SUMO('13337770-n',[ ('Bond',subsumption)]).
nounMapping2SUMO('13338066-n',[ ('Bond',subsumption)]).
nounMapping2SUMO('13338234-n',[ ('GovernmentBond',subsumption)]).
nounMapping2SUMO('13338439-n',[ ('Bond',subsumption)]).
nounMapping2SUMO('13338657-n',[ ('MunicipalBond',subsumption)]).
nounMapping2SUMO('13338780-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13338960-n',[ ('Bond',subsumption)]).
nounMapping2SUMO('13339189-n',[ ('Bond',subsumption)]).
nounMapping2SUMO('13339325-n',[ ('RegisteredBond',subsumption)]).
nounMapping2SUMO('13339542-n',[ ('Bond',subsumption)]).
nounMapping2SUMO('13339734-n',[ ('SecuredBond',subsumption)]).
nounMapping2SUMO('13339844-n',[ ('Bond',subsumption)]).
nounMapping2SUMO('13340080-n',[ ('Security',subsumption)]).
nounMapping2SUMO('13340244-n',[ ('Security',subsumption)]).
nounMapping2SUMO('13340579-n',[ ('Security',subsumption)]).
nounMapping2SUMO('13340751-n',[ ('Bonds',subsumption)]).
nounMapping2SUMO('13340902-n',[ ('Bond',subsumption)]).
nounMapping2SUMO('13341052-n',[ ('Bond',subsumption)]).
nounMapping2SUMO('13341350-n',[ ('Law',subsumption)]).
nounMapping2SUMO('13341593-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13341756-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13341962-n',[ ('BinaryRelation',subsumption)]).
nounMapping2SUMO('13342135-n',[ ('Share',equivalence)]).
nounMapping2SUMO('13342398-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13342597-n',[ ('Stock',subsumption)]).
nounMapping2SUMO('13342692-n',[ ('Investment',subsumption)]).
nounMapping2SUMO('13342987-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13343123-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13343284-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13343526-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13343774-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13343917-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13344071-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('13344386-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13344462-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('13344664-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13344804-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13345286-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13345403-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13345560-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13345962-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13346209-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13346337-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13346432-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13346630-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13346773-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13346912-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13347065-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13347237-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13347489-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13347750-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13347947-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13348227-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13348456-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13348792-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('13348964-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13349208-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('13349395-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13349662-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13349834-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13349997-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13350182-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13350322-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13350443-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13350702-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13350875-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13350976-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13351278-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13351457-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13351680-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13351860-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13351986-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13352138-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13352341-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13352464-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13352610-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13352722-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13352865-n',[ ('Giving',subsumption)]).
nounMapping2SUMO('13353004-n',[ ('Promise',subsumption)]).
nounMapping2SUMO('13353156-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13353280-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13353446-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13353607-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13353858-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13354021-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13354154-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13354260-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13354420-n',[ ('MeanOfProduction',subsumption)]).
nounMapping2SUMO('13354769-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13354985-n',[ ('FinancialText',subsumption)]).
nounMapping2SUMO('13355301-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13355504-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13355656-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13355868-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13356002-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13356112-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13356402-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13356569-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13356774-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13356887-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13356985-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13357178-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13357410-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13357572-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13357720-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13357891-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('13358000-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13358151-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('13358260-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('13358360-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('13358549-n',[ ('DepositAccount',subsumption)]).
nounMapping2SUMO('13358895-n',[ ('MutualFundAccount',equivalence)]).
nounMapping2SUMO('13359032-n',[ ('MutualFundAccount',subsumption)]).
nounMapping2SUMO('13359153-n',[ ('MutualFundAccount',subsumption)]).
nounMapping2SUMO('13359263-n',[ ('InvestmentAccount',subsumption)]).
nounMapping2SUMO('13359428-n',[ ('InvestmentAccount',subsumption)]).
nounMapping2SUMO('13359572-n',[ ('SavingsAccount',subsumption)]).
nounMapping2SUMO('13359690-n',[ ('DepositAccount',subsumption)]).
nounMapping2SUMO('13359941-n',[ ('DepositAccount',subsumption)]).
nounMapping2SUMO('13360103-n',[ ('DepositAccount',subsumption)]).
nounMapping2SUMO('13360254-n',[ ('DepositAccount',subsumption)]).
nounMapping2SUMO('13360390-n',[ ('DepositAccount',subsumption)]).
nounMapping2SUMO('13360498-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13360950-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13361083-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13361333-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13361465-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13361624-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13361830-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13361962-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13362182-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13362347-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13362540-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13362734-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13362918-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13363056-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13363217-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13363365-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13363704-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('13363893-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13363970-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13364212-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13364368-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13364602-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13364821-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13364984-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13365137-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13365286-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13365698-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13365978-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13366137-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13366311-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13366428-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13366537-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13366693-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13366912-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('13367070-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('13367448-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('13367593-n',[ ('Object',subsumption)]).
nounMapping2SUMO('13367787-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13367913-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('13368052-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('13368318-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('13368517-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('13368675-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('13368900-n',[ ('StationaryArtifact',subsumption)]).
nounMapping2SUMO('13369074-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('13369159-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13369282-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('13369474-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13369567-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13369723-n',[ ('FinancialInstrument',subsumption)]).
nounMapping2SUMO('13369857-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13370014-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13370215-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13370448-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13370669-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13370938-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13371030-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13371190-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13371274-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13371355-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('13371489-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('13371682-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('13371760-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('13371866-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('13371958-n',[ ('Diamond',subsumption)]).
nounMapping2SUMO('13372123-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('13372262-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('13372403-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('13372585-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('13372665-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('13372812-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('13372961-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13373214-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13373426-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13373584-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13373746-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13374008-n',[ ('CurrencyMeasure',equivalence)]).
nounMapping2SUMO('13374161-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13374281-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('13374426-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('13374597-n',[ ('Lending',subsumption)]).
nounMapping2SUMO('13374764-n',[ ('Loan',subsumption)]).
nounMapping2SUMO('13374887-n',[ ('Loan',subsumption)]).
nounMapping2SUMO('13374979-n',[ ('Loan',subsumption)]).
nounMapping2SUMO('13375167-n',[ ('Loan',subsumption)]).
nounMapping2SUMO('13375323-n',[ ('CreditAccount',subsumption)]).
nounMapping2SUMO('13375604-n',[ ('CreditAccount',equivalence)]).
nounMapping2SUMO('13375758-n',[ ('CreditAccount',subsumption)]).
nounMapping2SUMO('13375891-n',[ ('CreditAccount',subsumption)]).
nounMapping2SUMO('13376012-n',[ ('CreditCard',equivalence)]).
nounMapping2SUMO('13376426-n',[ ('BankCard',equivalence)]).
nounMapping2SUMO('13376512-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13376643-n',[ ('BankCard',subsumption)]).
nounMapping2SUMO('13376764-n',[ ('DebitCard',equivalence)]).
nounMapping2SUMO('13377003-n',[ ('BankCard',subsumption)]).
nounMapping2SUMO('13377268-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13377654-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13377749-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13377899-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13378031-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13378174-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13378348-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('13378518-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13378717-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13378816-n',[ ('FinancialInstrument',subsumption)]).
nounMapping2SUMO('13378968-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13379106-n',[ ('CreditAccount',subsumption)]).
nounMapping2SUMO('13379264-n',[ ('CreditAccount',subsumption)]).
nounMapping2SUMO('13379413-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13379619-n',[ ('CreditAccount',subsumption)]).
nounMapping2SUMO('13379753-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13380004-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13380148-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13380309-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13380530-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13380667-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13380820-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13380996-n',[ ('CreditAccount',subsumption)]).
nounMapping2SUMO('13381145-n',[ ('Deposit',equivalence)]).
nounMapping2SUMO('13381303-n',[ ('Deposit',subsumption)]).
nounMapping2SUMO('13381428-n',[ ('Deposit',subsumption)]).
nounMapping2SUMO('13381602-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13381734-n',[ ('Check',subsumption)]).
nounMapping2SUMO('13382121-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13382306-n',[ ('Check',subsumption)]).
nounMapping2SUMO('13382471-n',[ ('Check',subsumption)]).
nounMapping2SUMO('13382614-n',[ ('Check',subsumption)]).
nounMapping2SUMO('13382766-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13382975-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13383090-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13383289-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13383439-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13383696-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13383855-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13384018-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13384164-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13384341-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13384557-n',[ ('Currency',equivalence)]).
nounMapping2SUMO('13384877-n',[ ('Currency',subsumption)]).
nounMapping2SUMO('13385080-n',[ ('BritishPound',subsumption)]).
nounMapping2SUMO('13385216-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13385466-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('13385583-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13385778-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13385913-n',[ ('Currency',equivalence)]).
nounMapping2SUMO('13386136-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13386334-n',[ ('CurrencyBill',subsumption)]).
nounMapping2SUMO('13386465-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13386614-n',[ ('Currency',equivalence)]).
nounMapping2SUMO('13386882-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13387209-n',[ ('CurrencyBill',subsumption)]).
nounMapping2SUMO('13387479-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13387689-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13387877-n',[ ('CurrencyCoin',equivalence)]).
nounMapping2SUMO('13388000-n',[ ('CurrentMeasure',subsumption)]).
nounMapping2SUMO('13388111-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13388245-n',[ ('CurrencyCoin',equivalence)]).
nounMapping2SUMO('13389105-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13389194-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13389359-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13389475-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13389577-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13389660-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13389763-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13389864-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13389949-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13390040-n',[ ('UnitedStatesTenCentCoin',equivalence)]).
nounMapping2SUMO('13390139-n',[ ('UnitedStatesFiveCentCoin',equivalence)]).
nounMapping2SUMO('13390244-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13390405-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13390525-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13390626-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13390788-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13390857-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13390963-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13391118-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13391262-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13391373-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13391452-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13391610-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13391693-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13391774-n',[ ('UnitedStatesCentCoin',equivalence)]).
nounMapping2SUMO('13391841-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13391967-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13392156-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13392262-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13392357-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13392472-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13392580-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13392688-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13392786-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13392896-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13392977-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13393059-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13393155-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13393265-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13393427-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13393599-n',[ ('CurrencyCoin',subsumption)]).
nounMapping2SUMO('13393762-n',[ ('CurrencyBill',subsumption)]).
nounMapping2SUMO('13394179-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13394326-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('13394592-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('13394792-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('13394907-n',[ ('Contract',subsumption)]).
nounMapping2SUMO('13395074-n',[ ('CurrencyBill',subsumption)]).
nounMapping2SUMO('13395187-n',[ ('CurrencyBill',subsumption)]).
nounMapping2SUMO('13395296-n',[ ('CurrencyBill',subsumption)]).
nounMapping2SUMO('13395407-n',[ ('CurrencyBill',subsumption)]).
nounMapping2SUMO('13395515-n',[ ('CurrencyBill',subsumption)]).
nounMapping2SUMO('13395652-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13395799-n',[ ('CurrencyBill',subsumption)]).
nounMapping2SUMO('13395897-n',[ ('UnitedStatesDollarBill',equivalence)]).
nounMapping2SUMO('13396054-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13396276-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13396485-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13396603-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13396768-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13396861-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13397018-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13397174-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13397443-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13397519-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13397705-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13397932-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13398074-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13398241-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13398469-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13398768-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13398859-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13398953-n',[ ('Lending',subsumption)]).
nounMapping2SUMO('13399275-n',[ ('Lending',subsumption)]).
nounMapping2SUMO('13399379-n',[ ('Lending',subsumption)]).
nounMapping2SUMO('13399570-n',[ ('Lending',subsumption)]).
nounMapping2SUMO('13399782-n',[ ('Lending',subsumption)]).
nounMapping2SUMO('13400024-n',[ ('Lending',subsumption)]).
nounMapping2SUMO('13400150-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13400334-n',[ ('Lending',subsumption)]).
nounMapping2SUMO('13400472-n',[ ('Lending',subsumption)]).
nounMapping2SUMO('13400580-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13400662-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13400798-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13401013-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13401261-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13401412-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13401610-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13401746-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13401970-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13402209-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13402389-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13402529-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13402690-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13402879-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13403025-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13403146-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13403331-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13403520-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13403643-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13403964-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13404156-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13404248-n',[ ('FinancialText',subsumption)]).
nounMapping2SUMO('13404534-n',[ ('FinancialText',subsumption)]).
nounMapping2SUMO('13404655-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13404879-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13405015-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13405166-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13405296-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13405480-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13405646-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13405807-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13405962-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13406374-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13406509-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13406638-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('13406852-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('13407012-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('13407208-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13407389-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13407561-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13407718-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13407844-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13408023-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13408256-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13408361-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13408473-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13408641-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13408776-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13408980-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13409160-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13409363-n',[ ('SubtractionFn',subsumption)]).
nounMapping2SUMO('13409647-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13409850-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13410269-n',[ ('SubtractionFn',subsumption)]).
nounMapping2SUMO('13410458-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('13410803-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13411005-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('13411157-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('13411385-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('13411533-n',[ ('Investigating',subsumption)]).
nounMapping2SUMO('13411785-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('13411943-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13412131-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13412321-n',[ ('Book',subsumption)]).
nounMapping2SUMO('13412533-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13412721-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13412877-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13413016-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13413159-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13413294-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13413493-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13413840-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13413986-n',[ ('Transaction',subsumption)]).
nounMapping2SUMO('13414159-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13414310-n',[ ('Book',subsumption)]).
nounMapping2SUMO('13414443-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13414554-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13414770-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13414849-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13415043-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13415168-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13415271-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13415381-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13415547-n',[ ('MealPlan',equivalence)]).
nounMapping2SUMO('13415744-n',[ ('FullBoard',equivalence)]).
nounMapping2SUMO('13415866-n',[ ('HalfBoard',equivalence)]).
nounMapping2SUMO('13415998-n',[ ('BreakfastBoard',equivalence)]).
nounMapping2SUMO('13416106-n',[ ('BreakfastBoard',subsumption)]).
nounMapping2SUMO('13416241-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13416345-n',[ ('FinancialInstrument',equivalence)]).
nounMapping2SUMO('13416897-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13417071-n',[ ('Stock',subsumption)]).
nounMapping2SUMO('13417289-n',[ ('FinancialInstrument',subsumption)]).
nounMapping2SUMO('13417410-n',[ ('Bond',subsumption)]).
nounMapping2SUMO('13418047-n',[ ('Bond',subsumption)]).
nounMapping2SUMO('13418219-n',[ ('PropertyFn',subsumption)]).
nounMapping2SUMO('13418616-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13418713-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('13418823-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13419032-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13419178-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13419325-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13419535-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13419755-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13419951-n',[ ('Stock',subsumption)]).
nounMapping2SUMO('13420221-n',[ ('Stock',subsumption)]).
nounMapping2SUMO('13420359-n',[ ('Stock',subsumption)]).
nounMapping2SUMO('13420544-n',[ ('Stock',subsumption)]).
nounMapping2SUMO('13420722-n',[ ('Bond',subsumption)]).
nounMapping2SUMO('13420900-n',[ ('Security',subsumption)]).
nounMapping2SUMO('13421095-n',[ ('Security',subsumption)]).
nounMapping2SUMO('13421286-n',[ ('Stock',subsumption)]).
nounMapping2SUMO('13421462-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13421702-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('13421832-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13422061-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13422234-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13422411-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13422545-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13422684-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13422905-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13423007-n',[ ('Certificate',subsumption)]).
nounMapping2SUMO('13423118-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13423267-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13423405-n',[ ('EndFn',subsumption)]).
nounMapping2SUMO('13423489-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13423615-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13423779-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13423922-n',[ ('Wetting',subsumption)]).
nounMapping2SUMO('13424183-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('13424477-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13424643-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('13424865-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13425067-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13425245-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13425425-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13425637-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13425839-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13425980-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13426238-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13426376-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13426591-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('13426726-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('13426948-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13427078-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('13427356-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13427481-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13427633-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13427789-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('13427989-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('13428159-n',[ ('Aerating',subsumption)]).
nounMapping2SUMO('13428308-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13428421-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('13428608-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('13428804-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13429006-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13429194-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13429300-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13429432-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('13429585-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('13429780-n',[ ('PhysiologicProcess',subsumption)]).
nounMapping2SUMO('13429888-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13430074-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('13430262-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13430391-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13430495-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13430786-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13431043-n',[ ('ChemicalSynthesis',subsumption)]).
nounMapping2SUMO('13431221-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13431380-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13431569-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13431722-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('13431992-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13432085-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13432249-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('13432443-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13432647-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13432802-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13432903-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13433061-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13433283-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13433462-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('13433727-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('13433948-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13434120-n',[ ('AsexualReproduction',equivalence)]).
nounMapping2SUMO('13434406-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13434537-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('13434688-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13434878-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13435152-n',[ ('ChemicalSynthesis',subsumption)]).
nounMapping2SUMO('13435377-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13435548-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13435770-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13435918-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13436063-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13436206-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13436361-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13436503-n',[ ('PhysiologicProcess',subsumption)]).
nounMapping2SUMO('13436682-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13436809-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13436992-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13437181-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13437379-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13437495-n',[ ('PhysiologicProcess',subsumption)]).
nounMapping2SUMO('13437610-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13437753-n',[ ('Calorie',subsumption)]).
nounMapping2SUMO('13437902-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13438006-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13438088-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13438223-n',[ ('Making',subsumption)]).
nounMapping2SUMO('13438521-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('13438671-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13438817-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13438979-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('13439088-n',[ ('Combustion',subsumption)]).
nounMapping2SUMO('13439230-n',[ ('StateChange',subsumption)]).
nounMapping2SUMO('13439390-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('13439570-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('13439807-n',[ ('GasMotion',subsumption)]).
nounMapping2SUMO('13439935-n',[ ('Coloring',subsumption)]).
nounMapping2SUMO('13440063-n',[ ('BiologicalProcess',equivalence)]).
nounMapping2SUMO('13440779-n',[ ('Boiling',equivalence)]).
nounMapping2SUMO('13440935-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13441154-n',[ ('Fermentation',subsumption)]).
nounMapping2SUMO('13441387-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13441536-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('13441812-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('13441959-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('13442168-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13442312-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13442476-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13442639-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('13442715-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13442867-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13442998-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13443120-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13443228-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('13443370-n',[ ('Condensing',subsumption)]).
nounMapping2SUMO('13443537-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13443709-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13443787-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13444131-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13444513-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13444703-n',[ ('Replication',subsumption)]).
nounMapping2SUMO('13444940-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13445296-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13445479-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13445624-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13445831-n',[ ('ChemicalSynthesis',subsumption)]).
nounMapping2SUMO('13445972-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13446197-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13446390-n',[ ('ChemicalProcess',equivalence)]).
nounMapping2SUMO('13447361-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13447923-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('13448179-n',[ ('ChemicalSynthesis',subsumption)]).
nounMapping2SUMO('13448334-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('13448622-n',[ ('ChemicalSynthesis',subsumption)]).
nounMapping2SUMO('13448778-n',[ ('Chromatography',subsumption)]).
nounMapping2SUMO('13448970-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13449156-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('13449319-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('13449450-n',[ ('QuantityChange',subsumption)]).
nounMapping2SUMO('13449566-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('13449714-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13449892-n',[ ('ChemicalSynthesis',subsumption)]).
nounMapping2SUMO('13450070-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('13450206-n',[ ('Combustion',equivalence)]).
nounMapping2SUMO('13450417-n',[ ('Combustion',subsumption)]).
nounMapping2SUMO('13450636-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('13450862-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13451073-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13451204-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13451348-n',[ ('Condensing',equivalence)]).
nounMapping2SUMO('13451508-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13451665-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13451804-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13452117-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13452347-n',[ ('PhysiologicProcess',subsumption)]).
nounMapping2SUMO('13452614-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('13452750-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('13452947-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('13453160-n',[ ('Cooling',equivalence)]).
nounMapping2SUMO('13453428-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13453640-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('13453737-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13453861-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('13454130-n',[ ('Substituting',subsumption)]).
nounMapping2SUMO('13454318-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13454479-n',[ ('StateChange',subsumption)]).
nounMapping2SUMO('13454789-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13454950-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13455086-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13455234-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13455487-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13455906-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('13456071-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13456252-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13456367-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13456567-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13456715-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13456899-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('13457181-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13457378-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13457665-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13457831-n',[ ('Boiling',subsumption)]).
nounMapping2SUMO('13458019-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('13458268-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13458571-n',[ ('Decreasing',equivalence)]).
nounMapping2SUMO('13458840-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13458968-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13459088-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13459322-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('13459821-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13460034-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('13460129-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('13460299-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13460568-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13460863-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('13460991-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('13461162-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13461390-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13461525-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13461722-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('13461951-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('13462084-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13462191-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13462387-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('13462680-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('13462795-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13462989-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13463255-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13463490-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('13463656-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('13464031-n',[ ('Condensing',subsumption)]).
nounMapping2SUMO('13464204-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13464440-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13464557-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('13464820-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13465264-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13465382-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('13465530-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('13465809-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13465998-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('13466170-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13466312-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13466449-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13466586-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13466849-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13467009-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('13467224-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13467443-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('13467700-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13467916-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('13468094-n',[ ('StateChange',subsumption)]).
nounMapping2SUMO('13468306-n',[ ('Condensing',subsumption)]).
nounMapping2SUMO('13468542-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13468786-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13468954-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('13469066-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('13469317-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('13469526-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13469674-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('13469893-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('13470015-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13470193-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('13470392-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13470491-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13470687-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13470868-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13471052-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13471206-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13471517-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13471681-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13471815-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13471958-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13472125-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13472341-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13472518-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('13472862-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('13473097-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13473392-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13473536-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('13473716-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13473836-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13474130-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13474290-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('13474495-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13474615-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13474734-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13474858-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13475072-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13475205-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13475320-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('13475538-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13475944-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13476111-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13476267-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13476440-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13476590-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13477023-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13477462-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13477691-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13477812-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13477934-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13478055-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13478205-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13478342-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13478525-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13478813-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13479034-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('13479169-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13479380-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('13479605-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('13479889-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13480176-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13480394-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('13480541-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13480667-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13480848-n',[ ('Combustion',equivalence)]).
nounMapping2SUMO('13481224-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('13481408-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('13481580-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('13481727-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13481883-n',[ ('Combustion',subsumption)]).
nounMapping2SUMO('13481994-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13482187-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('13482330-n',[ ('LiquidMotion',subsumption)]).
nounMapping2SUMO('13482580-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('13482781-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13482940-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13483061-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('13483190-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('13483331-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13483488-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13483726-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13483971-n',[ ('Condensing',subsumption)]).
nounMapping2SUMO('13484082-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('13484303-n',[ ('ComputerProcess',subsumption)]).
nounMapping2SUMO('13484644-n',[ ('Freezing',equivalence)]).
nounMapping2SUMO('13484937-n',[ ('Freezing',subsumption)]).
nounMapping2SUMO('13485270-n',[ ('Freezing',subsumption)]).
nounMapping2SUMO('13485408-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('13485525-n',[ ('ChemicalSynthesis',subsumption)]).
nounMapping2SUMO('13485767-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('13485890-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13485968-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13486115-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13486270-n',[ ('Boiling',equivalence)]).
nounMapping2SUMO('13486431-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13486520-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13486671-n',[ ('Replication',subsumption)]).
nounMapping2SUMO('13486838-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13487207-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13487409-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13487638-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13487791-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13487952-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13488110-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13488310-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('13488498-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13488606-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('13488844-n',[ ('Creation',subsumption)]).
nounMapping2SUMO('13489037-n',[ ('Growth',equivalence)]).
nounMapping2SUMO('13490343-n',[ ('Increasing',equivalence)]).
nounMapping2SUMO('13490487-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('13490683-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13490909-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('13491060-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13491464-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('13491616-n',[ ('PhysiologicProcess',subsumption)]).
nounMapping2SUMO('13491794-n',[ ('Cooling',subsumption)]).
nounMapping2SUMO('13491876-n',[ ('Heating',equivalence)]).
nounMapping2SUMO('13492136-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('13492287-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13492453-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13492789-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('13493003-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('13493213-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13493399-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13493566-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('13493692-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('13493874-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('13493998-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13494192-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13494325-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('13494472-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('13494707-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13494919-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13495209-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13495333-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13495413-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13495507-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13495636-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('13495873-n',[ ('Combustion',subsumption)]).
nounMapping2SUMO('13496017-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13496167-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('13496286-n',[ ('Attaching',subsumption)]).
nounMapping2SUMO('13496517-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13496771-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13496972-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13497135-n',[ ('Increasing',equivalence)]).
nounMapping2SUMO('13497650-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('13497784-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('13497928-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13498213-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13498404-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('13498666-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13498828-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13499165-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13499393-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13499590-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13499782-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13499923-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13500023-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13500214-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13500437-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13500557-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13500674-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13500860-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13501059-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('13501261-n',[ ('Combustion',subsumption)]).
nounMapping2SUMO('13501405-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13501548-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('13501738-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13501941-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('13502205-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13502397-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13502556-n',[ ('ChemicalSynthesis',subsumption)]).
nounMapping2SUMO('13502714-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13502909-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13503226-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13503345-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('13503513-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('13503673-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('13503908-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13504173-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13504403-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13504497-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13504739-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13504947-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13505069-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('13505249-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13505467-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13505843-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13505987-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13506119-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('13506477-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('13506587-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13506727-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13506906-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('13507210-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('13507336-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13507472-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13507617-n',[ ('StateChange',subsumption)]).
nounMapping2SUMO('13507827-n',[ ('PhysiologicProcess',subsumption)]).
nounMapping2SUMO('13508005-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13508183-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13508333-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13508651-n',[ ('StateChange',subsumption)]).
nounMapping2SUMO('13508830-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13508950-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13509042-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13509196-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13509383-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13509528-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13509843-n',[ ('PhysiologicProcess',subsumption)]).
nounMapping2SUMO('13509967-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13510152-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13510263-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13510433-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('13510638-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13510829-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13510946-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13511243-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('13511368-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('13511507-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('13511755-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13512036-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13512238-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13512506-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13512725-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('13513222-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13513362-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('13513540-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13513747-n',[ ('Menstruation',subsumption)]).
nounMapping2SUMO('13514314-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13514648-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('13514880-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('13515149-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13515251-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13515353-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13515520-n',[ ('Substituting',subsumption)]).
nounMapping2SUMO('13515678-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13515828-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('13515958-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13516176-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('13516312-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13516597-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('13516842-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13517080-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13517199-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('13517385-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13517553-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13517717-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13517843-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13518140-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13518279-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13518432-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13518563-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13518656-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('13518963-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13520426-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('13520629-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13520731-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('13520849-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13520981-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13521072-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13521444-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13521616-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13521873-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13522084-n',[ ('Transfer',subsumption)]).
nounMapping2SUMO('13522305-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13522485-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13522611-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13522744-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13522879-n',[ ('SexualReproduction',subsumption)]).
nounMapping2SUMO('13523088-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13523208-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13523503-n',[ ('ChemicalSynthesis',subsumption)]).
nounMapping2SUMO('13523661-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13523983-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13524191-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13524295-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13524399-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13524612-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13524686-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13524804-n',[ ('Making',subsumption)]).
nounMapping2SUMO('13524925-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13525549-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13525912-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13526110-n',[ ('BiologicalProcess',equivalence)]).
nounMapping2SUMO('13527726-n',[ ('Organification',subsumption)]).
nounMapping2SUMO('13527817-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13527965-n',[ ('StateChange',subsumption)]).
nounMapping2SUMO('13528100-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('13528441-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13528750-n',[ ('Ossification',subsumption)]).
nounMapping2SUMO('13528852-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13529015-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13529167-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13529295-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13529450-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13529616-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('13529831-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13530108-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('13530237-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13530408-n',[ ('Oxidation',subsumption)]).
nounMapping2SUMO('13530799-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13530989-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13531149-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13531318-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13531435-n',[ ('ChemicalDecomposition',subsumption)]).
nounMapping2SUMO('13531652-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13531927-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('13532059-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('13532196-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13532356-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('13532501-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('13532747-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('13532886-n',[ ('Birth',equivalence)]).
nounMapping2SUMO('13533186-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('13533349-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13533470-n',[ ('PathologicProcess',equivalence)]).
nounMapping2SUMO('13533704-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('13533886-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13534098-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13534274-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13534608-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13534773-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13534954-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13535261-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13535583-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13535837-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13536016-n',[ ('StateChange',equivalence)]).
nounMapping2SUMO('13536299-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13536523-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13536661-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('13536794-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13537176-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13537429-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13537622-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13537761-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13537894-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('13538080-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13538182-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13538314-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13538757-n',[ ('ChemicalSynthesis',subsumption)]).
nounMapping2SUMO('13538996-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13539143-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13539262-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('13539422-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13539585-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('13539894-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('13540091-n',[ ('ChemicalSynthesis',subsumption)]).
nounMapping2SUMO('13540199-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('13540322-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13540429-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13540610-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13540791-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13540975-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13541167-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13541491-n',[ ('OrganizationalProcess',subsumption)]).
nounMapping2SUMO('13541798-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('13541975-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13542114-n',[ ('Proliferation',equivalence)]).
nounMapping2SUMO('13542374-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13542474-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13542688-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13542855-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13542947-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('13543093-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13543231-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13543418-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13543564-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13543871-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13543968-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13544073-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('13544279-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13544433-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13544537-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13544783-n',[ ('PhysiologicProcess',subsumption)]).
nounMapping2SUMO('13544930-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13545036-n',[ ('Heating',subsumption)]).
nounMapping2SUMO('13545184-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('13545382-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13545627-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13545733-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13545845-n',[ ('PhysiologicProcess',subsumption)]).
nounMapping2SUMO('13545973-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13546169-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('13546416-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('13546768-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('13547048-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13547199-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13547380-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13547513-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13547677-n',[ ('ChemicalReduction',subsumption)]).
nounMapping2SUMO('13547925-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13548105-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13548350-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13548531-n',[ ('Cooling',subsumption)]).
nounMapping2SUMO('13548734-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13548931-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('13549105-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13549311-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13549488-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13549672-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13549916-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13550089-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('13550318-n',[ ('Replication',equivalence)]).
nounMapping2SUMO('13550504-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13550755-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('13550940-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13551117-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13551396-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13551617-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13551823-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13551965-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13552124-n',[ ('OrganismProcess',subsumption)]).
nounMapping2SUMO('13552270-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13552528-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13552644-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13552858-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13553083-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13553251-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('13553418-n',[ ('AsexualReproduction',subsumption)]).
nounMapping2SUMO('13553560-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13553758-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('13553916-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13554121-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13554343-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13554586-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13554800-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13554984-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13555101-n',[ ('Maintaining',subsumption)]).
nounMapping2SUMO('13555240-n',[ ('SexualReproduction',equivalence)]).
nounMapping2SUMO('13555446-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('13555599-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13555775-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13555915-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13556151-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13556249-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13556377-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13556509-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13556893-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('13557158-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13557451-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13557766-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13558003-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13558125-n',[ ('ChemicalSynthesis',subsumption)]).
nounMapping2SUMO('13558325-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13558490-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13558696-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13558953-n',[ ('PowerGeneration',subsumption)]).
nounMapping2SUMO('13559177-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13559409-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13559509-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13559782-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13560079-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13560191-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13560329-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13560417-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13560586-n',[ ('Combustion',subsumption)]).
nounMapping2SUMO('13560738-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13560911-n',[ ('PoliticalProcess',subsumption)]).
nounMapping2SUMO('13561198-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13561396-n',[ ('Making',subsumption)]).
nounMapping2SUMO('13561521-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13561719-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13561896-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('13562133-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13562328-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13562474-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13562680-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13562862-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13563139-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13563382-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('13563522-n',[ ('Selling',subsumption)]).
nounMapping2SUMO('13563647-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13563746-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13563948-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('13564045-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13564215-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('13564501-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13564639-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13564795-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('13564910-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13565201-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('13565379-n',[ ('ChemicalSynthesis',equivalence)]).
nounMapping2SUMO('13565622-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13565781-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13565940-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13566041-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13566212-n',[ ('QuantityChange',subsumption)]).
nounMapping2SUMO('13566436-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13566535-n',[ ('Melting',equivalence)]).
nounMapping2SUMO('13566928-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('13567063-n',[ ('StateChange',subsumption)]).
nounMapping2SUMO('13567177-n',[ ('ChemicalSynthesis',subsumption)]).
nounMapping2SUMO('13567344-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13567515-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13567627-n',[ ('Fermentation',subsumption)]).
nounMapping2SUMO('13567960-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13568109-n',[ ('ChemicalProcess',subsumption)]).
nounMapping2SUMO('13568238-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13568524-n',[ ('Radiating',subsumption)]).
nounMapping2SUMO('13568796-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13568983-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13569226-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13569464-n',[ ('Substituting',subsumption)]).
nounMapping2SUMO('13569664-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13569774-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('13569905-n',[ ('GasMotion',subsumption)]).
nounMapping2SUMO('13570072-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13570236-n',[ ('Substituting',subsumption)]).
nounMapping2SUMO('13570472-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13570574-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13570783-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13570923-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13571041-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('13571217-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13571365-n',[ ('PhysiologicProcess',subsumption)]).
nounMapping2SUMO('13571580-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13571763-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13571943-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13572226-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13572324-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13572436-n',[ ('StateChange',subsumption)]).
nounMapping2SUMO('13572860-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13573057-n',[ ('Growth',subsumption)]).
nounMapping2SUMO('13573181-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13573368-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13573499-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13573666-n',[ ('Fermentation',subsumption)]).
nounMapping2SUMO('13573805-n',[ ('StateChange',subsumption)]).
nounMapping2SUMO('13573915-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('13574193-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('13574452-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13574582-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13574804-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13574928-n',[ ('ContentDevelopment',subsumption)]).
nounMapping2SUMO('13575109-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('13575226-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13575433-n',[ ('Fermentation',equivalence)]).
nounMapping2SUMO('13575869-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13576101-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('13576355-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('13576982-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('13577171-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13577544-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13577731-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13577934-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13578140-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13578267-n',[ ('SystemeInternationalUnit',equivalence)]).
nounMapping2SUMO('13578830-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13579166-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13579287-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13579510-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13579679-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13579829-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13579933-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13580058-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13580228-n',[ ('Calculating',subsumption)]).
nounMapping2SUMO('13580415-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13580723-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13580909-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('13581067-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('13581218-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('13581465-n',[ ('AbsoluteValueFn',equivalence)]).
nounMapping2SUMO('13581598-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('13581871-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('13582013-n',[ ('Number',equivalence)]).
nounMapping2SUMO('13583030-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13583137-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13583272-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13583478-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('13583611-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13583724-n',[ ('UnitOfMeasure',equivalence)]).
nounMapping2SUMO('13584646-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13584746-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13584918-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13585127-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13585309-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13585429-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13585819-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13585997-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13586122-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13586455-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13586831-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13587030-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13587236-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13587525-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13587763-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13587963-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13588233-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13588381-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13588497-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13588625-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13588819-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13589003-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13589140-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13589321-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13589546-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13589681-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13589957-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13590079-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13590327-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13590598-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13590974-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13591123-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13591314-n',[ ('Number',subsumption)]).
nounMapping2SUMO('13591586-n',[ ('Number',subsumption)]).
nounMapping2SUMO('13591761-n',[ ('Counting',subsumption)]).
nounMapping2SUMO('13591998-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13592105-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13592219-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13592384-n',[ ('Counting',subsumption)]).
nounMapping2SUMO('13592598-n',[ ('Counting',subsumption)]).
nounMapping2SUMO('13592764-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13592871-n',[ ('Counting',subsumption)]).
nounMapping2SUMO('13593065-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13593219-n',[ ('MultiplicationFn',subsumption)]).
nounMapping2SUMO('13593438-n',[ ('MultiplicationFn',subsumption)]).
nounMapping2SUMO('13593634-n',[ ('MultiplicationFn',subsumption)]).
nounMapping2SUMO('13593908-n',[ ('Number',subsumption)]).
nounMapping2SUMO('13594005-n',[ ('PrimeNumber',equivalence)]).
nounMapping2SUMO('13594136-n',[ ('PrimeNumber',subsumption)]).
nounMapping2SUMO('13594302-n',[ ('PrimeNumber',equivalence)]).
nounMapping2SUMO('13594417-n',[ ('Number',subsumption)]).
nounMapping2SUMO('13594585-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13595094-n',[ ('GameShot',subsumption)]).
nounMapping2SUMO('13595276-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13595414-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13595550-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('13595699-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13595844-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13595968-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13596106-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13596235-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13596422-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13596569-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13596673-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13596756-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13596986-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13597147-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13597280-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13597444-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13597585-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13597794-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13598013-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13598128-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13598237-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13598408-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13598556-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13598715-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13598960-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13599114-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13599348-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13599469-n',[ ('LengthMeasure',equivalence)]).
nounMapping2SUMO('13599547-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13599730-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13599871-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13599982-n',[ ('SpeedFn',equivalence)]).
nounMapping2SUMO('13600097-n',[ ('AngleMeasure',subsumption)]).
nounMapping2SUMO('13600404-n',[ ('AreaMeasure',subsumption)]).
nounMapping2SUMO('13600822-n',[ ('VolumeMeasure',subsumption)]).
nounMapping2SUMO('13601370-n',[ ('VolumeMeasure',subsumption)]).
nounMapping2SUMO('13601483-n',[ ('VolumeMeasure',subsumption)]).
nounMapping2SUMO('13601596-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13602401-n',[ ('VolumeMeasure',subsumption)]).
nounMapping2SUMO('13602526-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13602922-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13603065-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13603305-n',[ ('LengthMeasure',equivalence)]).
nounMapping2SUMO('13604275-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13604572-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13604718-n',[ ('CurrencyMeasure',equivalence)]).
nounMapping2SUMO('13607187-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('13607405-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13607616-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('13607873-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13607985-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13608207-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13608319-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13608480-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13608598-n',[ ('TemperatureMeasure',subsumption)]).
nounMapping2SUMO('13608788-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('13609214-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('13609390-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13609507-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13609871-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13609948-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13610046-n',[ ('Procedure',instance)]).
nounMapping2SUMO('13610162-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13610426-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13610540-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13610669-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13610815-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13610987-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13611082-n',[ ('AngleMeasure',instance)]).
nounMapping2SUMO('13611207-n',[ ('AngularDegree',equivalence)]).
nounMapping2SUMO('13611395-n',[ ('AngleMeasure',instance)]).
nounMapping2SUMO('13611567-n',[ ('AngleMeasure',instance)]).
nounMapping2SUMO('13611740-n',[ ('AngleMeasure',instance)]).
nounMapping2SUMO('13611884-n',[ ('AngleMeasure',instance)]).
nounMapping2SUMO('13612042-n',[ ('Radian',equivalence)]).
nounMapping2SUMO('13612319-n',[ ('AngleMeasure',instance)]).
nounMapping2SUMO('13612427-n',[ ('AngleMeasure',instance)]).
nounMapping2SUMO('13612550-n',[ ('AngleMeasure',instance)]).
nounMapping2SUMO('13612688-n',[ ('AngleMeasure',instance)]).
nounMapping2SUMO('13612791-n',[ ('Steradian',equivalence)]).
nounMapping2SUMO('13612943-n',[ ('AreaMeasure',instance)]).
nounMapping2SUMO('13613060-n',[ ('AreaMeasure',instance)]).
nounMapping2SUMO('13613177-n',[ ('AreaMeasure',instance)]).
nounMapping2SUMO('13613294-n',[ ('AreaMeasure',instance)]).
nounMapping2SUMO('13613408-n',[ ('SquareMile',instance)]).
nounMapping2SUMO('13613504-n',[ ('SquareMile',instance)]).
nounMapping2SUMO('13613592-n',[ ('AreaMeasure',instance)]).
nounMapping2SUMO('13613742-n',[ ('Acre',equivalence)]).
nounMapping2SUMO('13613862-n',[ ('AreaMeasure',instance)]).
nounMapping2SUMO('13613985-n',[ ('AreaMeasure',instance)]).
nounMapping2SUMO('13614143-n',[ ('AreaMeasure',instance)]).
nounMapping2SUMO('13614256-n',[ ('AreaMeasure',instance)]).
nounMapping2SUMO('13614467-n',[ ('AreaMeasure',instance)]).
nounMapping2SUMO('13614572-n',[ ('AreaMeasure',instance)]).
nounMapping2SUMO('13614679-n',[ ('AreaMeasure',instance)]).
nounMapping2SUMO('13614764-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13615036-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13615235-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13615557-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13616054-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13616340-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13616427-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13616560-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13616688-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13616787-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13616926-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13617046-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13617207-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13617308-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13617468-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13617630-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13617713-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13617835-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13617952-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13618076-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13618180-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13618298-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13618418-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13618508-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13618629-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13618849-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13619028-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13619168-n',[ ('Cup',equivalence)]).
nounMapping2SUMO('13619307-n',[ ('Pint',equivalence)]).
nounMapping2SUMO('13619475-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13619592-n',[ ('Quart',equivalence)]).
nounMapping2SUMO('13619764-n',[ ('UnitedStatesGallon',equivalence)]).
nounMapping2SUMO('13619920-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13620154-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13620404-n',[ ('Pint',equivalence)]).
nounMapping2SUMO('13620549-n',[ ('Quart',equivalence)]).
nounMapping2SUMO('13620713-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13620871-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13621011-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13621190-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13621418-n',[ ('Ounce',equivalence)]).
nounMapping2SUMO('13621660-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13621850-n',[ ('Pint',equivalence)]).
nounMapping2SUMO('13622035-n',[ ('Quart',equivalence)]).
nounMapping2SUMO('13622209-n',[ ('UnitedKingdomGallon',equivalence)]).
nounMapping2SUMO('13622451-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13622591-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13622769-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13622914-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13623054-n',[ ('MassMeasure',instance)]).
nounMapping2SUMO('13623205-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13623329-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13623455-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13623636-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13623856-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13624026-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13624190-n',[ ('Liter',equivalence)]).
nounMapping2SUMO('13624509-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13624705-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13624873-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13625063-n',[ ('VolumeMeasure',instance)]).
nounMapping2SUMO('13625237-n',[ ('Bit',equivalence)]).
nounMapping2SUMO('13625482-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('13625884-n',[ ('Byte',subsumption)]).
nounMapping2SUMO('13626013-n',[ ('Byte',equivalence)]).
nounMapping2SUMO('13626240-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13626464-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13626789-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13626942-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13627114-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13627327-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13627516-n',[ ('KiloByte',equivalence)]).
nounMapping2SUMO('13627681-n',[ ('KiloByte',equivalence)]).
nounMapping2SUMO('13627810-n',[ ('KiloByte',equivalence)]).
nounMapping2SUMO('13627935-n',[ ('InformationMeasure',subsumption)]).
nounMapping2SUMO('13628056-n',[ ('MegaByte',equivalence)]).
nounMapping2SUMO('13628246-n',[ ('MegaByte',equivalence)]).
nounMapping2SUMO('13628419-n',[ ('MegaByte',equivalence)]).
nounMapping2SUMO('13628592-n',[ ('InformationMeasure',subsumption)]).
nounMapping2SUMO('13628761-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13628955-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13629132-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13629309-n',[ ('InformationMeasure',subsumption)]).
nounMapping2SUMO('13629482-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13629676-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13629854-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13630036-n',[ ('InformationMeasure',subsumption)]).
nounMapping2SUMO('13630213-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13630387-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13630545-n',[ ('Lead',equivalence)]).
nounMapping2SUMO('13630707-n',[ ('InformationMeasure',instance)]).
nounMapping2SUMO('13630864-n',[ ('InformationMeasure',instance)]).
nounMapping2SUMO('13631037-n',[ ('InformationMeasure',instance)]).
nounMapping2SUMO('13631194-n',[ ('InformationMeasure',instance)]).
nounMapping2SUMO('13631355-n',[ ('InformationMeasure',instance)]).
nounMapping2SUMO('13631512-n',[ ('InformationMeasure',instance)]).
nounMapping2SUMO('13631687-n',[ ('InformationMeasure',instance)]).
nounMapping2SUMO('13631845-n',[ ('InformationMeasure',instance)]).
nounMapping2SUMO('13632007-n',[ ('InformationMeasure',instance)]).
nounMapping2SUMO('13632164-n',[ ('Ytterbium',equivalence)]).
nounMapping2SUMO('13632320-n',[ ('Ytterbium',equivalence)]).
nounMapping2SUMO('13632461-n',[ ('Ytterbium',equivalence)]).
nounMapping2SUMO('13632606-n',[ ('InformationMeasure',instance)]).
nounMapping2SUMO('13632744-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13632961-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13633229-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13633375-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13633596-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13633704-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13633851-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13634033-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13634205-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13634418-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13634615-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13634784-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13635108-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13635336-n',[ ('RadiationMeasure',equivalence)]).
nounMapping2SUMO('13635553-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13635698-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13635854-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13635985-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13636135-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13636286-n',[ ('Farad',equivalence)]).
nounMapping2SUMO('13636529-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13636648-n',[ ('Coulomb',equivalence)]).
nounMapping2SUMO('13636866-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13636989-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13637124-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13637240-n',[ ('Siemens',equivalence)]).
nounMapping2SUMO('13637376-n',[ ('Ampere',equivalence)]).
nounMapping2SUMO('13637613-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13637722-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13637841-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13637988-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13638094-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13638244-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13638375-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13638577-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13638706-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13638847-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13639009-n',[ ('Tesla',equivalence)]).
nounMapping2SUMO('13639147-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13639274-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13639405-n',[ ('Henry',equivalence)]).
nounMapping2SUMO('13639647-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13639808-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13639927-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13640050-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13640206-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13640371-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13640520-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13640716-n',[ ('Lux',equivalence)]).
nounMapping2SUMO('13640866-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13641023-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13641175-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13641299-n',[ ('Lumen',equivalence)]).
nounMapping2SUMO('13641534-n',[ ('Candela',equivalence)]).
nounMapping2SUMO('13641855-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13642000-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13642122-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13642337-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13642464-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13642596-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13642729-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13642856-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13642982-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13643109-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13643276-n',[ ('Volt',equivalence)]).
nounMapping2SUMO('13643770-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13643894-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13644047-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13644165-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13644379-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13644522-n',[ ('Watt',equivalence)]).
nounMapping2SUMO('13644761-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13644894-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13645010-n',[ ('Horsepower',instance)]).
nounMapping2SUMO('13645132-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13645331-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13645465-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13645599-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13645812-n',[ ('Organization',subsumption)]).
nounMapping2SUMO('13646031-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13646223-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13646367-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13646557-n',[ ('Rad',equivalence)]).
nounMapping2SUMO('13646694-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13646816-n',[ ('Ohm',equivalence)]).
nounMapping2SUMO('13647097-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13647215-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13647353-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13647498-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13647667-n',[ ('Newton',equivalence)]).
nounMapping2SUMO('13647888-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13647997-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13648184-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13648378-n',[ ('Object',subsumption)]).
nounMapping2SUMO('13648596-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13648793-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13648947-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13649054-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('13649268-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('13649626-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('13649791-n',[ ('Inch',equivalence)]).
nounMapping2SUMO('13650045-n',[ ('FootLength',equivalence)]).
nounMapping2SUMO('13650225-n',[ ('Foot',equivalence)]).
nounMapping2SUMO('13650447-n',[ ('YardLength',equivalence)]).
nounMapping2SUMO('13650735-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('13650921-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13651072-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13651218-n',[ ('Mile',equivalence)]).
nounMapping2SUMO('13651520-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('13651804-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13651931-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13652066-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13652203-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13652335-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13652443-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13652529-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('13652661-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('13652799-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13652886-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13652994-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13653154-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13653261-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13653349-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13653461-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13653615-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('13653821-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('13653902-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13654093-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13654232-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('13654380-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('13654571-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13654674-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13654777-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13654889-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13655089-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13655262-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13655414-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13655570-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13655790-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13655908-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13656075-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13656204-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13656345-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13656520-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13656749-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13656913-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13657080-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13657244-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13657489-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13657691-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13657849-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13658027-n',[ ('Angstrom',equivalence)]).
nounMapping2SUMO('13658278-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13658496-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13658657-n',[ ('Millimeter',equivalence)]).
nounMapping2SUMO('13658828-n',[ ('Centimeter',equivalence)]).
nounMapping2SUMO('13658998-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13659162-n',[ ('Meter',equivalence)]).
nounMapping2SUMO('13659419-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13659604-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13659760-n',[ ('Kilometer',equivalence)]).
nounMapping2SUMO('13659943-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13660084-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13660178-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13660337-n',[ ('Mile',instance)]).
nounMapping2SUMO('13660619-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13660868-n',[ ('LengthMeasure',instance)]).
nounMapping2SUMO('13661045-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13661163-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13661273-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13661820-n',[ ('EuroDollar',equivalence)]).
nounMapping2SUMO('13662190-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13662703-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13663077-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13663229-n',[ ('AfghanAfghani',equivalence)]).
nounMapping2SUMO('13663340-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13663448-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13663562-n',[ ('ArgentineAustral',equivalence)]).
nounMapping2SUMO('13663694-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13663820-n',[ ('ThaiBaht',equivalence)]).
nounMapping2SUMO('13663933-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13664041-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13664153-n',[ ('PanamanianBalboa',equivalence)]).
nounMapping2SUMO('13664283-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13664396-n',[ ('EthiopianBirr',equivalence)]).
nounMapping2SUMO('13664521-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13664808-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13665027-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13665256-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13665965-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13666675-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13666790-n',[ ('VenezuelanBolivar',equivalence)]).
nounMapping2SUMO('13666922-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13667048-n',[ ('GhanianCedi',equivalence)]).
nounMapping2SUMO('13667150-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13667255-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13667372-n',[ ('CostaRicanColon',equivalence)]).
nounMapping2SUMO('13667523-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13667643-n',[ ('ElSalvadoranColon',equivalence)]).
nounMapping2SUMO('13667797-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13667908-n',[ ('BrazilianReal',equivalence)]).
nounMapping2SUMO('13668034-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13668161-n',[ ('GambianDalasi',equivalence)]).
nounMapping2SUMO('13668266-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13668380-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13668491-n',[ ('AlgerianDinar',equivalence)]).
nounMapping2SUMO('13668632-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13668751-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13668864-n',[ ('BahrainianDinar',equivalence)]).
nounMapping2SUMO('13669006-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13669237-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13669342-n',[ ('IraqiDinar',equivalence)]).
nounMapping2SUMO('13669479-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13669590-n',[ ('JordanianDinar',equivalence)]).
nounMapping2SUMO('13669733-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13669860-n',[ ('KuwaitiDinar',equivalence)]).
nounMapping2SUMO('13669998-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13670156-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13670281-n',[ ('LibyanDinar',equivalence)]).
nounMapping2SUMO('13670399-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13670521-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13670668-n',[ ('TunisianDinar',equivalence)]).
nounMapping2SUMO('13670790-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13670935-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13671047-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13671182-n',[ ('YugoslavianDinar',equivalence)]).
nounMapping2SUMO('13671310-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13671416-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13671527-n',[ ('MoroccanDirham',equivalence)]).
nounMapping2SUMO('13671674-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13671813-n',[ ('UnitedArabEmirateDirham',equivalence)]).
nounMapping2SUMO('13671967-n',[ ('AustralianDollar',equivalence)]).
nounMapping2SUMO('13672077-n',[ ('BahamianDollar',equivalence)]).
nounMapping2SUMO('13672177-n',[ ('BarbadosDollar',equivalence)]).
nounMapping2SUMO('13672274-n',[ ('BelizeDollar',equivalence)]).
nounMapping2SUMO('13672367-n',[ ('BermudaDollar',equivalence)]).
nounMapping2SUMO('13672462-n',[ ('BruneiDollar',equivalence)]).
nounMapping2SUMO('13672555-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13672794-n',[ ('CanadianDollar',equivalence)]).
nounMapping2SUMO('13672967-n',[ ('CaymanIslandsDollar',equivalence)]).
nounMapping2SUMO('13673080-n',[ ('DominicanDollar',equivalence)]).
nounMapping2SUMO('13673178-n',[ ('FijiDollar',equivalence)]).
nounMapping2SUMO('13673267-n',[ ('GrenadaDollar',equivalence)]).
nounMapping2SUMO('13673362-n',[ ('GuyanaDollar',equivalence)]).
nounMapping2SUMO('13673455-n',[ ('HongKongDollar',equivalence)]).
nounMapping2SUMO('13673554-n',[ ('JamaicanDollar',equivalence)]).
nounMapping2SUMO('13673650-n',[ ('KiribatiDollar',equivalence)]).
nounMapping2SUMO('13673747-n',[ ('LiberianDollar',equivalence)]).
nounMapping2SUMO('13673843-n',[ ('NewZealandDollar',equivalence)]).
nounMapping2SUMO('13673946-n',[ ('SingaporeDollar',equivalence)]).
nounMapping2SUMO('13674045-n',[ ('TaiwanDollar',equivalence)]).
nounMapping2SUMO('13674138-n',[ ('TrinidadAndTobagoDollar',equivalence)]).
nounMapping2SUMO('13674257-n',[ ('TuvaluDollar',equivalence)]).
nounMapping2SUMO('13674350-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13674479-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13674660-n',[ ('ZimbabweanDollar',equivalence)]).
nounMapping2SUMO('13674759-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13674890-n',[ ('VietnameseDong',equivalence)]).
nounMapping2SUMO('13674994-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13675093-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13675218-n',[ ('GreekDrachma',equivalence)]).
nounMapping2SUMO('13675349-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13675456-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13675591-n',[ ('SaoThomeEPrincipeDobra',equivalence)]).
nounMapping2SUMO('13675708-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13675824-n',[ ('CapeVerdeEscudo',equivalence)]).
nounMapping2SUMO('13675976-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13676108-n',[ ('PortugueseEscudo',equivalence)]).
nounMapping2SUMO('13676285-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13676396-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13676544-n',[ ('HungarianForint',equivalence)]).
nounMapping2SUMO('13676650-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13676758-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13676897-n',[ ('BelgianFranc',equivalence)]).
nounMapping2SUMO('13677019-n',[ ('BeninFranc',equivalence)]).
nounMapping2SUMO('13677109-n',[ ('BurundiFranc',equivalence)]).
nounMapping2SUMO('13677222-n',[ ('CameroonFranc',equivalence)]).
nounMapping2SUMO('13677337-n',[ ('CentralAfricanRepublicFranc',equivalence)]).
nounMapping2SUMO('13677469-n',[ ('ChadianFranc',equivalence)]).
nounMapping2SUMO('13677579-n',[ ('CongoFranc',equivalence)]).
nounMapping2SUMO('13677692-n',[ ('DjiboutiFranc',equivalence)]).
nounMapping2SUMO('13677788-n',[ ('FrenchFranc',equivalence)]).
nounMapping2SUMO('13677889-n',[ ('GabonFranc',equivalence)]).
nounMapping2SUMO('13677998-n',[ ('IvoryCoastFranc',equivalence)]).
nounMapping2SUMO('13678145-n',[ ('LuxembourgFranc',equivalence)]).
nounMapping2SUMO('13678273-n',[ ('MadagascarFranc',equivalence)]).
nounMapping2SUMO('13678373-n',[ ('MaliFranc',equivalence)]).
nounMapping2SUMO('13678480-n',[ ('NigerFranc',equivalence)]).
nounMapping2SUMO('13678589-n',[ ('RwandaFranc',equivalence)]).
nounMapping2SUMO('13678700-n',[ ('SenegaleseFranc',equivalence)]).
nounMapping2SUMO('13678816-n',[ ('SwissFranc',equivalence)]).
nounMapping2SUMO('13678931-n',[ ('TogoFranc',equivalence)]).
nounMapping2SUMO('13679038-n',[ ('BurkinaFasoFranc',equivalence)]).
nounMapping2SUMO('13679161-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13679273-n',[ ('HaitianGourde',equivalence)]).
nounMapping2SUMO('13679377-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13679494-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13679608-n',[ ('ParaguaYanguarani',equivalence)]).
nounMapping2SUMO('13679739-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13679855-n',[ ('DutchGuilder',equivalence)]).
nounMapping2SUMO('13680032-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13680146-n',[ ('SurinameseGuilder',equivalence)]).
nounMapping2SUMO('13680273-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13680381-n',[ ('PeruvianInti',equivalence)]).
nounMapping2SUMO('13680463-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13680599-n',[ ('PapuanKina',equivalence)]).
nounMapping2SUMO('13680712-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13680823-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13680948-n',[ ('LaotianKip',equivalence)]).
nounMapping2SUMO('13681048-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13681142-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13681275-n',[ ('CzechKoruna',equivalence)]).
nounMapping2SUMO('13681407-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13681530-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13681661-n',[ ('SlovakianKoruna',equivalence)]).
nounMapping2SUMO('13681749-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13681863-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13681993-n',[ ('IcelandicKrona',equivalence)]).
nounMapping2SUMO('13682116-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13682221-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13682330-n',[ ('SwedishKrona',equivalence)]).
nounMapping2SUMO('13682450-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13682631-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13682740-n',[ ('DanishKrone',equivalence)]).
nounMapping2SUMO('13682860-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13682971-n',[ ('NorwegianKrone',equivalence)]).
nounMapping2SUMO('13683093-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13683221-n',[ ('MalawianKwacha',equivalence)]).
nounMapping2SUMO('13683342-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13683451-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13683578-n',[ ('ZambianKwacha',equivalence)]).
nounMapping2SUMO('13683700-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13683805-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13683932-n',[ ('AngolanKwanza',equivalence)]).
nounMapping2SUMO('13684037-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13684140-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13684298-n',[ ('MyanmarKyat',equivalence)]).
nounMapping2SUMO('13684402-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13684503-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13684632-n',[ ('AlbanianLek',equivalence)]).
nounMapping2SUMO('13684735-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13684853-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13684965-n',[ ('HonduranLempira',equivalence)]).
nounMapping2SUMO('13685096-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13685216-n',[ ('SierraLeoneLeone',equivalence)]).
nounMapping2SUMO('13685346-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13685475-n',[ ('RomanianLeu',equivalence)]).
nounMapping2SUMO('13685578-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13685678-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13685809-n',[ ('BulgarianLev',equivalence)]).
nounMapping2SUMO('13685913-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13686023-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13686137-n',[ ('SwazilandLilangeni',equivalence)]).
nounMapping2SUMO('13686268-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13686376-n',[ ('ItalianLira',equivalence)]).
nounMapping2SUMO('13686526-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13686660-n',[ ('BritishPound',equivalence)]).
nounMapping2SUMO('13686877-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13687015-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13687160-n',[ ('TurkishLira',equivalence)]).
nounMapping2SUMO('13687278-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13687420-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13687524-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13687652-n',[ ('LesothoLoti',equivalence)]).
nounMapping2SUMO('13687756-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13687906-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13688033-n',[ ('GermanMark',equivalence)]).
nounMapping2SUMO('13688190-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13688319-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13688447-n',[ ('FinnishMarkka',equivalence)]).
nounMapping2SUMO('13688577-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13688695-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13688811-n',[ ('MozambiqueMetical',equivalence)]).
nounMapping2SUMO('13688944-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13689073-n',[ ('NigerianNaira',equivalence)]).
nounMapping2SUMO('13689178-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13689282-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13689411-n',[ ('BhutaneseNgultrum',equivalence)]).
nounMapping2SUMO('13689518-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13689630-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13689765-n',[ ('MauritanIanouguiya',equivalence)]).
nounMapping2SUMO('13689875-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13689984-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13690109-n',[ ('TonganPaanga',equivalence)]).
nounMapping2SUMO('13690214-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13690321-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13690445-n',[ ('MacaoPataca',equivalence)]).
nounMapping2SUMO('13690549-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13690650-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13690758-n',[ ('SpanishPeseta',equivalence)]).
nounMapping2SUMO('13690911-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13691022-n',[ ('BolivianBoliviano',equivalence)]).
nounMapping2SUMO('13691154-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13691269-n',[ ('NicaraguanCordoba',equivalence)]).
nounMapping2SUMO('13691401-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13691509-n',[ ('ChileanPeso',equivalence)]).
nounMapping2SUMO('13691651-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13691764-n',[ ('ColombianPeso',equivalence)]).
nounMapping2SUMO('13691909-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13692014-n',[ ('CubanPeso',equivalence)]).
nounMapping2SUMO('13692151-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13692278-n',[ ('DominicanPeso',equivalence)]).
nounMapping2SUMO('13692437-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13692559-n',[ ('GuineaBissauPeso',equivalence)]).
nounMapping2SUMO('13692713-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13692822-n',[ ('MexicanPeso',equivalence)]).
nounMapping2SUMO('13692963-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13693084-n',[ ('PhilippinePeso',equivalence)]).
nounMapping2SUMO('13693237-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13693349-n',[ ('UruguayanPeso',equivalence)]).
nounMapping2SUMO('13693514-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13693641-n',[ ('CypriotPound',equivalence)]).
nounMapping2SUMO('13693781-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13693908-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13694017-n',[ ('EgyptianPound',equivalence)]).
nounMapping2SUMO('13694160-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13694367-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13694552-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13694657-n',[ ('IrishPound',equivalence)]).
nounMapping2SUMO('13694825-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13694936-n',[ ('LebanesePound',equivalence)]).
nounMapping2SUMO('13695081-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13695189-n',[ ('MalteseLira',equivalence)]).
nounMapping2SUMO('13695307-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13695420-n',[ ('SudanesePound',equivalence)]).
nounMapping2SUMO('13695567-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13695674-n',[ ('SyrianPound',equivalence)]).
nounMapping2SUMO('13695815-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13695945-n',[ ('BotswanaPula',equivalence)]).
nounMapping2SUMO('13696050-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13696155-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13696270-n',[ ('GuatemalanQuetzal',equivalence)]).
nounMapping2SUMO('13696402-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13696523-n',[ ('SouthAfricanRand',equivalence)]).
nounMapping2SUMO('13696652-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13696777-n',[ ('IranianRial',equivalence)]).
nounMapping2SUMO('13696893-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13697011-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13697134-n',[ ('OmaniRiyal',equivalence)]).
nounMapping2SUMO('13697262-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13697380-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13697505-n',[ ('YemeniRial',equivalence)]).
nounMapping2SUMO('13697621-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13697727-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13697840-n',[ ('CambodianRiel',equivalence)]).
nounMapping2SUMO('13697963-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13698076-n',[ ('MalaysianRinggit',instance)]).
nounMapping2SUMO('13698202-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13698327-n',[ ('QatariRiyal',equivalence)]).
nounMapping2SUMO('13698445-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13698567-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13698706-n',[ ('SaudiArabianRiyal',equivalence)]).
nounMapping2SUMO('13698838-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13698949-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13699076-n',[ ('RussianRuble',equivalence)]).
nounMapping2SUMO('13699189-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13699313-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13699442-n',[ ('ArmenianDram',equivalence)]).
nounMapping2SUMO('13699527-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13699612-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13699747-n',[ ('AzerbaijanImanat',equivalence)]).
nounMapping2SUMO('13699836-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13699925-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13700056-n',[ ('BelarusianRubel',equivalence)]).
nounMapping2SUMO('13700142-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13700233-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13700362-n',[ ('EstonianKroon',equivalence)]).
nounMapping2SUMO('13700448-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13700533-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13700662-n',[ ('GeorgianLari',equivalence)]).
nounMapping2SUMO('13700766-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13700870-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13701005-n',[ ('KazakhstanItenge',equivalence)]).
nounMapping2SUMO('13701094-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13701183-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13701310-n',[ ('LatvianLats',equivalence)]).
nounMapping2SUMO('13701394-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13701482-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13701615-n',[ ('LithuanianLitas',equivalence)]).
nounMapping2SUMO('13701703-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13701793-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13701928-n',[ ('KyrgyzstanIsom',equivalence)]).
nounMapping2SUMO('13702015-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13702102-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13702231-n',[ ('MoldovanLeu',equivalence)]).
nounMapping2SUMO('13702315-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13702396-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13702531-n',[ ('TajikistaniRuble',equivalence)]).
nounMapping2SUMO('13702620-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13702707-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13702840-n',[ ('TurkmenManat',equivalence)]).
nounMapping2SUMO('13702931-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13703022-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13703151-n',[ ('UkranianHryvnia',equivalence)]).
nounMapping2SUMO('13703258-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13703370-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13703505-n',[ ('UzbekistanIsom',equivalence)]).
nounMapping2SUMO('13703592-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13703679-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13703804-n',[ ('IndianRupee',equivalence)]).
nounMapping2SUMO('13703942-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13704143-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13704274-n',[ ('PakistaniRupee',equivalence)]).
nounMapping2SUMO('13704418-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13704529-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13704643-n',[ ('MauritianRupee',equivalence)]).
nounMapping2SUMO('13704788-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13704897-n',[ ('NepaleseRupee',equivalence)]).
nounMapping2SUMO('13705037-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13705153-n',[ ('SeychellesRupee',equivalence)]).
nounMapping2SUMO('13705300-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13705415-n',[ ('SriLankanRupee',equivalence)]).
nounMapping2SUMO('13705559-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13705674-n',[ ('IndonesianRupiah',equivalence)]).
nounMapping2SUMO('13705800-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13705929-n',[ ('AustrianSchilling',equivalence)]).
nounMapping2SUMO('13706068-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13706183-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13706310-n',[ ('IsraeliShekel',equivalence)]).
nounMapping2SUMO('13706415-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13706521-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13706628-n',[ ('KenyanShilling',equivalence)]).
nounMapping2SUMO('13706753-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13706864-n',[ ('SomalianShilling',equivalence)]).
nounMapping2SUMO('13706993-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13707106-n',[ ('TanzanianShilling',equivalence)]).
nounMapping2SUMO('13707237-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13707346-n',[ ('UgandanShilling',equivalence)]).
nounMapping2SUMO('13707473-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13707585-n',[ ('EcuadoranSucre',equivalence)]).
nounMapping2SUMO('13707713-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13707804-n',[ ('GuineanFranc',equivalence)]).
nounMapping2SUMO('13707897-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13708014-n',[ ('BangladeshItaka',equivalence)]).
nounMapping2SUMO('13708141-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13708282-n',[ ('WesternSamoaNtala',equivalence)]).
nounMapping2SUMO('13708392-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13708500-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13708631-n',[ ('MongolianTugrik',equivalence)]).
nounMapping2SUMO('13708748-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13708855-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13708992-n',[ ('NorthKoreanWon',equivalence)]).
nounMapping2SUMO('13709118-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13709223-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13709360-n',[ ('SouthKoreanWon',equivalence)]).
nounMapping2SUMO('13709486-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13709591-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13709700-n',[ ('JapaneseYen',equivalence)]).
nounMapping2SUMO('13709819-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13709992-n',[ ('ChineseYuan',equivalence)]).
nounMapping2SUMO('13710101-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13710219-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13710317-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13710443-n',[ ('ZaireSezaire',equivalence)]).
nounMapping2SUMO('13710546-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13710651-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13710777-n',[ ('PolishZloty',equivalence)]).
nounMapping2SUMO('13710881-n',[ ('CurrencyMeasure',instance)]).
nounMapping2SUMO('13710986-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13711060-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13711303-n',[ ('Pascal',equivalence)]).
nounMapping2SUMO('13711416-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13711570-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13711663-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13711855-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13712120-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13712286-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13712428-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13712592-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13712689-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13712890-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13713003-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13713159-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13713300-n',[ ('Inch',subsumption)]).
nounMapping2SUMO('13713408-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13713521-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13713633-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13713817-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13713983-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13714082-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13714184-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13714376-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13714491-n',[ ('CelsiusDegree',equivalence)]).
nounMapping2SUMO('13714641-n',[ ('FahrenheitDegree',equivalence)]).
nounMapping2SUMO('13714756-n',[ ('KelvinDegree',equivalence)]).
nounMapping2SUMO('13714905-n',[ ('RankineDegree',equivalence)]).
nounMapping2SUMO('13715001-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13715124-n',[ ('CelsiusDegree',subsumption)]).
nounMapping2SUMO('13715240-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13715495-n',[ ('Amu',equivalence)]).
nounMapping2SUMO('13715614-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('13715755-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13715921-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13716084-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13716490-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13716686-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13716878-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13717155-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13717619-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13717728-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13717914-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13718046-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13718178-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13718267-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13718451-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13718574-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13718675-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13718838-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13718946-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13719102-n',[ ('Mollusk',subsumption)]).
nounMapping2SUMO('13719291-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13719410-n',[ ('MassMeasure',subsumption)]).
nounMapping2SUMO('13719529-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13719683-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13719808-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13719922-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13720096-n',[ ('PoundMass',equivalence)]).
nounMapping2SUMO('13720302-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13720405-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13720501-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13720600-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13720852-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13721003-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13721177-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13721387-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13721529-n',[ ('TonMass',equivalence)]).
nounMapping2SUMO('13721695-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13721804-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13721893-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13722060-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13722198-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13722340-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13722522-n',[ ('Ounce',instance)]).
nounMapping2SUMO('13722757-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13722929-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13723061-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13723189-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13723304-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13723470-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13723577-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13723712-n',[ ('Gram',equivalence)]).
nounMapping2SUMO('13723899-n',[ ('AtomGram',equivalence)]).
nounMapping2SUMO('13724081-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13724350-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13724474-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13724582-n',[ ('Kilogram',equivalence)]).
nounMapping2SUMO('13724838-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13724977-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13725108-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13725271-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13725457-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13725588-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13725726-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13725902-n',[ ('ElectronVolt',equivalence)]).
nounMapping2SUMO('13726074-n',[ ('Joule',equivalence)]).
nounMapping2SUMO('13726296-n',[ ('Calorie',equivalence)]).
nounMapping2SUMO('13726562-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13726947-n',[ ('BritishThermalUnit',equivalence)]).
nounMapping2SUMO('13727209-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13727333-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13727478-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13727683-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13727841-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13727931-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13728074-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13728203-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('13728367-n',[ ('PositiveInteger',equivalence)]).
nounMapping2SUMO('13728499-n',[ ('Integer',equivalence)]).
nounMapping2SUMO('13728818-n',[ ('AdditionFn',subsumption)]).
nounMapping2SUMO('13728924-n',[ ('AdditionFn',subsumption)]).
nounMapping2SUMO('13729031-n',[ ('Number',subsumption)]).
nounMapping2SUMO('13729135-n',[ ('Number',subsumption)]).
nounMapping2SUMO('13729236-n',[ ('Number',subsumption)]).
nounMapping2SUMO('13729428-n',[ ('ComplexNumber',equivalence)]).
nounMapping2SUMO('13729732-n',[ ('ComplexNumber',subsumption)]).
nounMapping2SUMO('13729902-n',[ ('RealNumber',equivalence)]).
nounMapping2SUMO('13730054-n',[ ('ImaginaryNumber',equivalence)]).
nounMapping2SUMO('13730189-n',[ ('ImaginaryPartFn',equivalence)]).
nounMapping2SUMO('13730377-n',[ ('AbsoluteValueFn',subsumption)]).
nounMapping2SUMO('13730469-n',[ ('RationalNumber',equivalence)]).
nounMapping2SUMO('13730584-n',[ ('IrrationalNumber',equivalence)]).
nounMapping2SUMO('13730756-n',[ ('IrrationalNumber',subsumption)]).
nounMapping2SUMO('13730902-n',[ ('SquareRootFn',subsumption)]).
nounMapping2SUMO('13731021-n',[ ('MultiplicationFn',subsumption)]).
nounMapping2SUMO('13731241-n',[ ('MultiplicationFn',subsumption)]).
nounMapping2SUMO('13731356-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('13731530-n',[ ('Character',subsumption)]).
nounMapping2SUMO('13731669-n',[ ('MultiplicationFn',subsumption)]).
nounMapping2SUMO('13731840-n',[ ('SquareRootFn',equivalence)]).
nounMapping2SUMO('13731959-n',[ ('MultiplicationFn',subsumption)]).
nounMapping2SUMO('13732078-n',[ ('DivisionFn',subsumption)]).
nounMapping2SUMO('13732295-n',[ ('DivisionFn',subsumption)]).
nounMapping2SUMO('13732871-n',[ ('NumeratorFn',subsumption)]).
nounMapping2SUMO('13732953-n',[ ('DivisionFn',subsumption)]).
nounMapping2SUMO('13733066-n',[ ('DenominatorFn',equivalence)]).
nounMapping2SUMO('13733167-n',[ ('DivisionFn',subsumption)]).
nounMapping2SUMO('13733316-n',[ ('DivisionFn',subsumption)]).
nounMapping2SUMO('13733402-n',[ ('DivisionFn',subsumption)]).
nounMapping2SUMO('13733663-n',[ ('Number',subsumption)]).
nounMapping2SUMO('13733818-n',[ ('MultiplicationFn',subsumption)]).
nounMapping2SUMO('13733979-n',[ ('MultiplicationFn',subsumption)]).
nounMapping2SUMO('13734085-n',[ ('MultiplicationFn',subsumption)]).
nounMapping2SUMO('13734202-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13734349-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13734629-n',[ ('Integer',subsumption)]).
nounMapping2SUMO('13734816-n',[ ('Integer',subsumption)]).
nounMapping2SUMO('13734992-n',[ ('DivisionFn',subsumption)]).
nounMapping2SUMO('13735163-n',[ ('DivisionFn',subsumption)]).
nounMapping2SUMO('13735355-n',[ ('MultiplicationFn',subsumption)]).
nounMapping2SUMO('13735476-n',[ ('MultiplicationFn',subsumption)]).
nounMapping2SUMO('13735622-n',[ ('DivisionFn',subsumption)]).
nounMapping2SUMO('13735800-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13735921-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13736057-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13736197-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13736376-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13736550-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13736799-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13736997-n',[ ('PositiveRealNumber',subsumption)]).
nounMapping2SUMO('13737089-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13737190-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13737378-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13737480-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13737700-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13737830-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13737952-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13738043-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13738140-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13738235-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13738327-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13738459-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13738585-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13738705-n',[ ('DivisionFn',subsumption)]).
nounMapping2SUMO('13738840-n',[ ('DivisionFn',subsumption)]).
nounMapping2SUMO('13738939-n',[ ('DivisionFn',subsumption)]).
nounMapping2SUMO('13739051-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13739170-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13739278-n',[ ('DivisionFn',subsumption)]).
nounMapping2SUMO('13739396-n',[ ('DivisionFn',subsumption)]).
nounMapping2SUMO('13739507-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13739612-n',[ ('DivisionFn',subsumption)]).
nounMapping2SUMO('13739721-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13739826-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13739934-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13740051-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13740168-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13740591-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13740765-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13741022-n',[ ('NonnegativeInteger',subsumption)]).
nounMapping2SUMO('13741512-n',[ ('NonnegativeInteger',subsumption)]).
nounMapping2SUMO('13741603-n',[ ('NonnegativeInteger',subsumption)]).
nounMapping2SUMO('13741698-n',[ ('DigitCharacter',equivalence)]).
nounMapping2SUMO('13741797-n',[ ('NonnegativeInteger',subsumption)]).
nounMapping2SUMO('13741903-n',[ ('NonnegativeInteger',subsumption)]).
nounMapping2SUMO('13742011-n',[ ('NonnegativeInteger',subsumption)]).
nounMapping2SUMO('13742358-n',[ ('NonnegativeInteger',instance)]).
nounMapping2SUMO('13742573-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13742840-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13742980-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13743100-n',[ ('Beverage',subsumption)]).
nounMapping2SUMO('13743269-n',[ ('Number',equivalence)]).
nounMapping2SUMO('13743460-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('13743605-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13743869-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13744044-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13744304-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13744521-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13744722-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13744916-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13745086-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13745270-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13745420-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13746419-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13746512-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13746672-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13746785-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13746946-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('13747114-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13747199-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13747348-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13747469-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13747606-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13747725-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13747865-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13747989-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13748128-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13748246-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13748367-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13748493-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13748622-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13748763-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13748890-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13749017-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13749146-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13749278-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13749407-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13749527-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13749644-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13749778-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13749894-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13750033-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13750164-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13750297-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13750415-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13750504-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13750574-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13750712-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13750844-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13751036-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13751158-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13751265-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13751404-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13751533-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13751686-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13751829-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13752033-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13752172-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13752443-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13752679-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13752911-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13753067-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13753274-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13753430-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13753585-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13753740-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13753894-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13754008-n',[ ('Pi',equivalence)]).
nounMapping2SUMO('13754165-n',[ ('NumberE',equivalence)]).
nounMapping2SUMO('13754293-n',[ ('Increasing',equivalence)]).
nounMapping2SUMO('13754565-n',[ ('Increasing',subsumption)]).
nounMapping2SUMO('13754778-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13754948-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('13755053-n',[ ('InformationMeasure',subsumption)]).
nounMapping2SUMO('13755342-n',[ ('InformationMeasure',subsumption)]).
nounMapping2SUMO('13755627-n',[ ('InformationMeasure',subsumption)]).
nounMapping2SUMO('13755822-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('13755957-n',[ ('RealNumber',subsumption)]).
nounMapping2SUMO('13756125-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13757249-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('13757582-n',[ ('VolumeMeasure',subsumption)]).
nounMapping2SUMO('13757724-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13758197-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('13758296-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13758556-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('13758745-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('13759014-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('13759146-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13759428-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13759558-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('13759773-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('13759941-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('13760129-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('13760316-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13760980-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13761171-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13761407-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13761603-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13761801-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13761966-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13762178-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13762305-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('13762458-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13762579-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13762717-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13762836-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13763058-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13763185-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13763384-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13763626-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13763806-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('13763888-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('13763970-n',[ ('VolumeMeasure',subsumption)]).
nounMapping2SUMO('13764086-n',[ ('VolumeMeasure',subsumption)]).
nounMapping2SUMO('13764213-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('13764342-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('13764540-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13764639-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13764764-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13764897-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13764998-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13765086-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13765207-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13765306-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13765396-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13765531-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13765624-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13765749-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13765866-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13765990-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13766080-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13766166-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13766252-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13766337-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13766436-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13766547-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13766637-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13766733-n',[ ('Cup',subsumption)]).
nounMapping2SUMO('13766896-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13767042-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13767146-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13767239-n',[ ('Cup',subsumption)]).
nounMapping2SUMO('13767350-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13767455-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13767545-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13767691-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13767822-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13767956-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13768064-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13768154-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13768250-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13768343-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13768440-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13768537-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13768630-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13768748-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13768850-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13768946-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13769033-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13769123-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13769206-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13769317-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13769428-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13769549-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13769672-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('13769870-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13769994-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13770076-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13770169-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13770310-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13770416-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13770529-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13770635-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13770729-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13770829-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13770926-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13771034-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13771154-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13771290-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13771404-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13771828-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13771929-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13772020-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13772106-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13772313-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13772468-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13772653-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('13772876-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13772971-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13773047-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13773250-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13773361-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13773539-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13773725-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13773906-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13774010-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13774115-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13774311-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13774404-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13775093-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13775319-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13775523-n',[ ('ConstantQuantity',subsumption)]).
nounMapping2SUMO('13775706-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13775939-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13776060-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('13776137-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('13776342-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13776432-n',[ ('PositiveInteger',instance)]).
nounMapping2SUMO('13776621-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13776726-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13776854-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13776971-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13777098-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13777211-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13777344-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('13777509-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13777764-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13778089-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13778261-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('13778400-n',[ ('Region',subsumption)]).
nounMapping2SUMO('13778530-n',[ ('Region',subsumption)]).
nounMapping2SUMO('13778671-n',[ ('Region',subsumption)]).
nounMapping2SUMO('13778827-n',[ ('Region',subsumption)]).
nounMapping2SUMO('13778907-n',[ ('Region',subsumption)]).
nounMapping2SUMO('13779032-n',[ ('VolumeMeasure',subsumption)]).
nounMapping2SUMO('13779244-n',[ ('RealPositiveNumber',subsumption)]).
nounMapping2SUMO('13779374-n',[ ('VolumeMeasure',subsumption)]).
nounMapping2SUMO('13779570-n',[ ('VolumeMeasure',subsumption)]).
nounMapping2SUMO('13779804-n',[ ('PositiveInteger',subsumption)]).
nounMapping2SUMO('13780180-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13780339-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13780449-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13780606-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13780719-n',[ ('Relation',equivalence)]).
nounMapping2SUMO('13781164-n',[ ('Function',equivalence)]).
nounMapping2SUMO('13781348-n',[ ('Partnership',equivalence)]).
nounMapping2SUMO('13781670-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13781820-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13782033-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13782208-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13782329-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13782533-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13782769-n',[ ('BinaryRelation',subsumption)]).
nounMapping2SUMO('13783038-n',[ ('Abstract',equivalence)]).
nounMapping2SUMO('13783259-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('13783421-n',[ ('Sentence',subsumption)]).
nounMapping2SUMO('13783581-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13783816-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13784366-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('13784537-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13784763-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13784906-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13785136-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13785404-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13785557-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13785736-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13785965-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13786187-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13786413-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13786595-n',[ ('Character',subsumption)]).
nounMapping2SUMO('13786748-n',[ ('Character',subsumption)]).
nounMapping2SUMO('13786960-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13787379-n',[ ('SineFn',equivalence)]).
nounMapping2SUMO('13787551-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13787723-n',[ ('CosineFn',equivalence)]).
nounMapping2SUMO('13787853-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13788035-n',[ ('TangentFn',equivalence)]).
nounMapping2SUMO('13788182-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13788369-n',[ ('TangentFn',subsumption)]).
nounMapping2SUMO('13788502-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13788690-n',[ ('CosineFn',subsumption)]).
nounMapping2SUMO('13788820-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13789002-n',[ ('SineFn',subsumption)]).
nounMapping2SUMO('13789136-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13789281-n',[ ('Function',subsumption)]).
nounMapping2SUMO('13789462-n',[ ('ExponentiationFn',equivalence)]).
nounMapping2SUMO('13789627-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('13789751-n',[ ('Graph',subsumption)]).
nounMapping2SUMO('13789849-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('13790004-n',[ ('List',subsumption)]).
nounMapping2SUMO('13790133-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13790492-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13790592-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13790712-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13790912-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13791122-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13791250-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13791389-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13791910-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13792183-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13792468-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13792579-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13792692-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13792842-n',[ ('Object',subsumption)]).
nounMapping2SUMO('13793127-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13793330-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13793504-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13793776-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13794034-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13794226-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13794417-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13794658-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13794793-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13794885-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13795042-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13795180-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13795489-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13795695-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13795834-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13796053-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13796216-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13796403-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13796585-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13796779-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13797142-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13797313-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13797561-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13797747-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13797856-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13797985-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13798118-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13798301-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13798491-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('13798814-n',[ ('Abstract',subsumption)]).
nounMapping2SUMO('13799063-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('13799245-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('13799392-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('13799655-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('13799796-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('13799967-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('13800115-n',[ ('Word',subsumption)]).
nounMapping2SUMO('13800267-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13800418-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13800539-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13800675-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13800801-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('13801040-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('13801217-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13801424-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13801700-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13801937-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13802098-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13802306-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13802485-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13802634-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13802805-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('13802920-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13803158-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13803431-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13803782-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('13804085-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('13804203-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('13804375-n',[ ('Text',subsumption)]).
nounMapping2SUMO('13804507-n',[ ('InternalChange',subsumption)]).
nounMapping2SUMO('13804669-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13804889-n',[ ('PastFn',subsumption)]).
nounMapping2SUMO('13805020-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13805179-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13805336-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13805456-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13805594-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13805734-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13805974-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13806140-n',[ ('PastFn',subsumption)]).
nounMapping2SUMO('13806404-n',[ ('PastFn',subsumption)]).
nounMapping2SUMO('13806614-n',[ ('PastFn',subsumption)]).
nounMapping2SUMO('13806735-n',[ ('PastFn',subsumption)]).
nounMapping2SUMO('13806964-n',[ ('PastFn',subsumption)]).
nounMapping2SUMO('13807178-n',[ ('FutureFn',subsumption)]).
nounMapping2SUMO('13807403-n',[ ('FutureFn',subsumption)]).
nounMapping2SUMO('13807636-n',[ ('Communication',subsumption)]).
nounMapping2SUMO('13807853-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('13808004-n',[ ('LinguisticExpression',subsumption)]).
nounMapping2SUMO('13808161-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('13808405-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('13808566-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('13808708-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('13808868-n',[ ('RelationalAttribute',subsumption)]).
nounMapping2SUMO('13808981-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13809207-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13809769-n',[ ('BinaryRelation',subsumption)]).
nounMapping2SUMO('13809920-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13810141-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13810323-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13810615-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13810818-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('13811184-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('13811340-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13811410-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13811740-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13811900-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13812173-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13812296-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13812607-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13813042-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13813283-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13813483-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13813591-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13813765-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13813898-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13814041-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13814184-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13814336-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13814456-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13814601-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13814755-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13814898-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13815030-n',[ ('BinaryRelation',subsumption)]).
nounMapping2SUMO('13815152-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13815342-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13815449-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13815742-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13816071-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13816313-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13816521-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13816649-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('13816862-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13817066-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13817279-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13817526-n',[ ('PositiveRealNumber',equivalence)]).
nounMapping2SUMO('13817761-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13817872-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13818143-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13818354-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13818551-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13818736-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13818829-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13818916-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13819074-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13819207-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13820000-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13820239-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13820432-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13820544-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13820655-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('13820826-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13820993-n',[ ('DivisionFn',equivalence)]).
nounMapping2SUMO('13821118-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13821272-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13821408-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13821570-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13821766-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13821977-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13822249-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13822364-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13822569-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13822735-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13822876-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13822995-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13823150-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13823287-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13823483-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13823651-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13823968-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13824114-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13824340-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13824500-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13824675-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13824815-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13824929-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13825080-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13825292-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13825490-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13825664-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13825840-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13826084-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13826221-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13826426-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13826614-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13826732-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13826845-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13826959-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13827103-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13827205-n',[ ('RegulatoryProcess',equivalence)]).
nounMapping2SUMO('13827426-n',[ ('DirectionalAttribute',equivalence)]).
nounMapping2SUMO('13827943-n',[ ('DirectionalAttribute',subsumption)]).
nounMapping2SUMO('13828075-n',[ ('DirectionalAttribute',equivalence)]).
nounMapping2SUMO('13828343-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('13828520-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('13828681-n',[ ('Horizontal',equivalence)]).
nounMapping2SUMO('13828795-n',[ ('Vertical',equivalence)]).
nounMapping2SUMO('13828905-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('13829047-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('13829243-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('13829408-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13829586-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('13829720-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('13829848-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('13829980-n',[ ('PositionalAttribute',subsumption)]).
nounMapping2SUMO('13830084-n',[ ('DirectionalAttribute',subsumption)]).
nounMapping2SUMO('13830166-n',[ ('DirectionalAttribute',subsumption)]).
nounMapping2SUMO('13830305-n',[ ('DirectionalAttribute',equivalence)]).
nounMapping2SUMO('13831000-n',[ ('DirectionalAttribute',subsumption)]).
nounMapping2SUMO('13831176-n',[ ('North',equivalence)]).
nounMapping2SUMO('13831310-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13831441-n',[ ('North',equivalence)]).
nounMapping2SUMO('13831572-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13831717-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13831843-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13831994-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13832118-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13832236-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13832355-n',[ ('East',equivalence)]).
nounMapping2SUMO('13832480-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13832599-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13832717-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13832841-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13832993-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13833119-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13833256-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13833375-n',[ ('South',equivalence)]).
nounMapping2SUMO('13833504-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13833623-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13833760-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13833886-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13834038-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13834162-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13834280-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13834399-n',[ ('West',equivalence)]).
nounMapping2SUMO('13834524-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13834643-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13834761-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13834885-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13835037-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13835163-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13835308-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13835427-n',[ ('North',equivalence)]).
nounMapping2SUMO('13835546-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13835664-n',[ ('East',equivalence)]).
nounMapping2SUMO('13835781-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13835899-n',[ ('South',equivalence)]).
nounMapping2SUMO('13836018-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13836136-n',[ ('West',equivalence)]).
nounMapping2SUMO('13836253-n',[ ('DirectionalAttribute',instance)]).
nounMapping2SUMO('13836371-n',[ ('AngleMeasure',subsumption)]).
nounMapping2SUMO('13836550-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13836715-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13836841-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13837009-n',[ ('BusinessCompetition',equivalence)]).
nounMapping2SUMO('13837200-n',[ ('BusinessCompetition',subsumption)]).
nounMapping2SUMO('13837351-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13837439-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13837667-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13837840-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13838025-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13838205-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13838386-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13838766-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13838930-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13839120-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13839287-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13839468-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13839662-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13839888-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13840039-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13840231-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13840404-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13840553-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13840719-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13840958-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13841213-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13841467-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13841651-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13841863-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13842241-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13842415-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13842622-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13842841-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13843001-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13843173-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13843401-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13843601-n',[ ('ReciprocalFn',equivalence)]).
nounMapping2SUMO('13843786-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13843920-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13844057-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13844212-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13844518-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('13844690-n',[ ('TemporalRelation',equivalence)]).
nounMapping2SUMO('13844923-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13845114-n',[ ('TemporalRelation',subsumption)]).
nounMapping2SUMO('13845239-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13845838-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13846199-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13846356-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13846546-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13846708-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13846900-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13847124-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13847240-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13847402-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13847498-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13847616-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13847715-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13847858-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13847954-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13848052-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13848149-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13848249-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13848349-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13848466-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13848565-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13848684-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13848784-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13848884-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13848983-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13849082-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13849180-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13849296-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13849394-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13849512-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13849611-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13849710-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13849810-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13849913-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13850019-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13850148-n',[ ('ListOrderFn',subsumption)]).
nounMapping2SUMO('13850304-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13850674-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13851067-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13851245-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13851426-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13851677-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13851865-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13852083-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13852395-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13852600-n',[ ('CelsiusDegree',equivalence)]).
nounMapping2SUMO('13852820-n',[ ('FahrenheitDegree',equivalence)]).
nounMapping2SUMO('13853002-n',[ ('KelvinDegree',equivalence)]).
nounMapping2SUMO('13853198-n',[ ('RankineDegree',subsumption)]).
nounMapping2SUMO('13853407-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13853546-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13853680-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13853808-n',[ ('Comparing',equivalence)]).
nounMapping2SUMO('13853947-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('13854101-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13854318-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('13854488-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13854649-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13855100-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13855230-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13855377-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13855627-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13855828-n',[ ('Relation',subsumption)]).
nounMapping2SUMO('13856110-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13856320-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13856449-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13856574-n',[ ('SignumFn',equivalence)]).
nounMapping2SUMO('13856857-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('13857008-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('13857159-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13857314-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13857486-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13857676-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13857804-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13858045-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13858270-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13858392-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13858481-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13858604-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13858833-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13859043-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13859307-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13859512-n',[ ('QuantityChange',subsumption)]).
nounMapping2SUMO('13859692-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('13859925-n',[ ('QuantityChange',subsumption)]).
nounMapping2SUMO('13860145-n',[ ('QuantityChange',subsumption)]).
nounMapping2SUMO('13860281-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('13860548-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13860793-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13861050-n',[ ('TwoDimensionalFigure',subsumption)]).
nounMapping2SUMO('13861449-n',[ ('TwoDimensionalFigure',subsumption)]).
nounMapping2SUMO('13861580-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13861686-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13861806-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13861934-n',[ ('TwoDimensionalFigure',subsumption)]).
nounMapping2SUMO('13862144-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13862282-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13862407-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13862552-n',[ ('GeometricFigure',subsumption)]).
nounMapping2SUMO('13862644-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13862780-n',[ ('GeometricFigure',subsumption)]).
nounMapping2SUMO('13863020-n',[ ('GeometricFigure',subsumption)]).
nounMapping2SUMO('13863186-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13863473-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13863602-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('13863771-n',[ ('OneDimensionalFigure',equivalence)]).
nounMapping2SUMO('13864035-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('13864153-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13864423-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13864542-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13864763-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13864965-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13865298-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13865483-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13865786-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13865904-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13866144-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13866515-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13866626-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13866827-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13867005-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13867133-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13867276-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13867492-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13867641-n',[ ('TwoDimensionalFigure',subsumption)]).
nounMapping2SUMO('13868248-n',[ ('TwoDimensionalFigure',subsumption)]).
nounMapping2SUMO('13868371-n',[ ('TwoDimensionalFigure',subsumption)]).
nounMapping2SUMO('13868515-n',[ ('TwoDimensionalFigure',subsumption)]).
nounMapping2SUMO('13868607-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13868813-n',[ ('TwoDimensionalFigure',subsumption)]).
nounMapping2SUMO('13868944-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13869045-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13869129-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13869243-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13869327-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13869547-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13869676-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13869788-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13869896-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13869991-n',[ ('GraphArc',subsumption)]).
nounMapping2SUMO('13870414-n',[ ('GraphArc',subsumption)]).
nounMapping2SUMO('13870680-n',[ ('GraphArc',subsumption)]).
nounMapping2SUMO('13870805-n',[ ('GraphArc',subsumption)]).
nounMapping2SUMO('13870935-n',[ ('GraphArc',subsumption)]).
nounMapping2SUMO('13871134-n',[ ('LineFormation',subsumption)]).
nounMapping2SUMO('13871338-n',[ ('GraphArc',subsumption)]).
nounMapping2SUMO('13871452-n',[ ('GraphArc',subsumption)]).
nounMapping2SUMO('13871538-n',[ ('GraphArc',subsumption)]).
nounMapping2SUMO('13871717-n',[ ('GraphArc',subsumption)]).
nounMapping2SUMO('13871967-n',[ ('GraphArc',subsumption)]).
nounMapping2SUMO('13872072-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13872211-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13872421-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13872592-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13872822-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13872975-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13873213-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13873361-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13873502-n',[ ('Circle',equivalence)]).
nounMapping2SUMO('13873849-n',[ ('Circle',subsumption)]).
nounMapping2SUMO('13873917-n',[ ('Circle',subsumption)]).
nounMapping2SUMO('13874073-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13874251-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13874384-n',[ ('Circle',subsumption)]).
nounMapping2SUMO('13874558-n',[ ('TwoDimensionalFigure',subsumption)]).
nounMapping2SUMO('13874927-n',[ ('GraphArc',subsumption)]).
nounMapping2SUMO('13875027-n',[ ('CircleSector',subsumption)]).
nounMapping2SUMO('13875185-n',[ ('Circle',subsumption)]).
nounMapping2SUMO('13875392-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13875571-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13875884-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13875970-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13876371-n',[ ('Circle',subsumption)]).
nounMapping2SUMO('13876561-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13876753-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13876921-n',[ ('TwoDimensionalFigure',subsumption)]).
nounMapping2SUMO('13877129-n',[ ('RationalNumber',subsumption)]).
nounMapping2SUMO('13877408-n',[ ('GraphArc',subsumption)]).
nounMapping2SUMO('13877547-n',[ ('GraphArc',subsumption)]).
nounMapping2SUMO('13877667-n',[ ('GraphArc',subsumption)]).
nounMapping2SUMO('13877785-n',[ ('AngleMeasure',subsumption)]).
nounMapping2SUMO('13877918-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13878112-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13878306-n',[ ('Oval',subsumption)]).
nounMapping2SUMO('13878634-n',[ ('Square',equivalence)]).
nounMapping2SUMO('13878951-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13879049-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13879126-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13879320-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13879634-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13879816-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13879947-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13880102-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('13880199-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13880295-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13880415-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13880551-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13880704-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13880811-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13880994-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13881175-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13881381-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13881512-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13881644-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13881810-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13882008-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13882201-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13882276-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13882385-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13882487-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13882563-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13882639-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13882713-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13882804-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13882883-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13882961-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13883133-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13883346-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13883494-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13883603-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13883763-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13883885-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13884261-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13884384-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13884511-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13884740-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13884930-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13885011-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13885111-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13885207-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13885370-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13885700-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13885836-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13886133-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13886260-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13886371-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13886575-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13886724-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13886910-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13887056-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13887211-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13887319-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13887509-n',[ ('TwoDimensionalAngle',equivalence)]).
nounMapping2SUMO('13888387-n',[ ('TwoDimensionalAngle',subsumption)]).
nounMapping2SUMO('13888491-n',[ ('AngleMeasure',equivalence)]).
nounMapping2SUMO('13888783-n',[ ('AngleMeasure',subsumption)]).
nounMapping2SUMO('13889066-n',[ ('AngleMeasure',subsumption)]).
nounMapping2SUMO('13889216-n',[ ('PlaneAngleMeasure',equivalence)]).
nounMapping2SUMO('13889331-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13889461-n',[ ('SolidAngleMeasure',equivalence)]).
nounMapping2SUMO('13889602-n',[ ('AngleMeasure',subsumption)]).
nounMapping2SUMO('13889843-n',[ ('AngleMeasure',subsumption)]).
nounMapping2SUMO('13890064-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13890226-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13890391-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13890535-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13890679-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13890869-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13891082-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13891242-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13891371-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13891547-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13891735-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13891937-n',[ ('AcuteAngle',equivalence)]).
nounMapping2SUMO('13892048-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13892142-n',[ ('TwoDimensionalAngle',subsumption)]).
nounMapping2SUMO('13892237-n',[ ('RightAngle',equivalence)]).
nounMapping2SUMO('13892383-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13892562-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13892674-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13892765-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13892897-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13893129-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13893310-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13893502-n',[ ('AngleMeasure',subsumption)]).
nounMapping2SUMO('13893694-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13893786-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('13894154-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('13894306-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13894434-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13895262-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13895362-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13895549-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13895622-n',[ ('Object',subsumption)]).
nounMapping2SUMO('13895745-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13895852-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('13895986-n',[ ('Object',subsumption)]).
nounMapping2SUMO('13896100-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13896217-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13896369-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13896695-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13896854-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13897002-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13897198-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13897377-n',[ ('Icon',subsumption)]).
nounMapping2SUMO('13897528-n',[ ('LineFormation',subsumption)]).
nounMapping2SUMO('13897657-n',[ ('LengthMeasure',subsumption)]).
nounMapping2SUMO('13897837-n',[ ('LineFormation',subsumption)]).
nounMapping2SUMO('13897996-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13898207-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13898315-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13898509-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13898645-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13898899-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13899109-n',[ ('HemisphereFigure',equivalence)]).
nounMapping2SUMO('13899200-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13899404-n',[ ('Sphere',subsumption)]).
nounMapping2SUMO('13899735-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13899804-n',[ ('Cylinder',equivalence)]).
nounMapping2SUMO('13900088-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13900287-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13900422-n',[ ('LineFormation',subsumption)]).
nounMapping2SUMO('13900760-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('13900914-n',[ ('LineFormation',subsumption)]).
nounMapping2SUMO('13901055-n',[ ('LineFormation',subsumption)]).
nounMapping2SUMO('13901211-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13901321-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13901423-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13901490-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('13901585-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13901858-n',[ ('Water',subsumption)]).
nounMapping2SUMO('13901925-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13902048-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13902229-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13902336-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13902482-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13902793-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13902905-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13903079-n',[ ('LineFormation',subsumption)]).
nounMapping2SUMO('13903387-n',[ ('LineFormation',subsumption)]).
nounMapping2SUMO('13903576-n',[ ('Region',subsumption)]).
nounMapping2SUMO('13903738-n',[ ('Region',subsumption)]).
nounMapping2SUMO('13903855-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('13904011-n',[ ('Number',undefined)]).
nounMapping2SUMO('13904164-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13904325-n',[ ('GraphArc',subsumption)]).
nounMapping2SUMO('13904506-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13904665-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13904843-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('13905121-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('13905275-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13905405-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('13905572-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13905792-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13906345-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13906484-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13906669-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13906767-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13906936-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13907104-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13907272-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13907415-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13907847-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13908021-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13908201-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13908348-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('13908580-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13908777-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13908954-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13909071-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13909190-n',[ ('SineFn',equivalence)]).
nounMapping2SUMO('13909296-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13909488-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13909632-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13909752-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13909889-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13910019-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13910116-n',[ ('Region',subsumption)]).
nounMapping2SUMO('13910384-n',[ ('SpaceRegion',equivalence)]).
nounMapping2SUMO('13910895-n',[ ('Region',subsumption)]).
nounMapping2SUMO('13911045-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13911151-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13911429-n',[ ('Hole',equivalence)]).
nounMapping2SUMO('13911517-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('13911660-n',[ ('SpaceRegion',subsumption)]).
nounMapping2SUMO('13911872-n',[ ('GeometricPoint',subsumption)]).
nounMapping2SUMO('13912115-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('13912260-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('13912424-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('13912540-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('13912686-n',[ ('StreamWaterArea',subsumption)]).
nounMapping2SUMO('13912839-n',[ ('Object',subsumption)]).
nounMapping2SUMO('13912992-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('13913164-n',[ ('Region',subsumption)]).
nounMapping2SUMO('13913263-n',[ ('GraphArc',subsumption)]).
nounMapping2SUMO('13913427-n',[ ('GraphArc',subsumption)]).
nounMapping2SUMO('13913566-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13913849-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13914141-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13914265-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13914473-n',[ ('Region',subsumption)]).
nounMapping2SUMO('13914608-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13914837-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13915023-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13915113-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13915209-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13915305-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13915417-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13915594-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13915690-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13915784-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13915883-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13915999-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13916363-n',[ ('SolidAngleMeasure',subsumption)]).
nounMapping2SUMO('13916495-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13916603-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13916721-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13916927-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13917022-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13917094-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13917214-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13917334-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13917457-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13917690-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13917785-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13917874-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13918095-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13918274-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13918387-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13918584-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13918717-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13918816-n',[ ('PlaneAngleMeasure',subsumption)]).
nounMapping2SUMO('13918965-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('13919059-n',[ ('AngleMeasure',subsumption)]).
nounMapping2SUMO('13919173-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('13919394-n',[ ('AngleMeasure',subsumption)]).
nounMapping2SUMO('13919547-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('13919685-n',[ ('Object',subsumption)]).
nounMapping2SUMO('13919919-n',[ ('Device',subsumption)]).
nounMapping2SUMO('13920012-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13920169-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13920322-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13920429-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13920835-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13923030-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('13923219-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('13923440-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13923582-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13923779-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13923929-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13924069-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('13924196-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13924336-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13924536-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('13924659-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13924863-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13925015-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13925188-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13925340-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13925550-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('13925752-n',[ ('Proposition',equivalence)]).
nounMapping2SUMO('13926068-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13926168-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13926329-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13926451-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13926535-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13926786-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13926932-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('13927112-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13927231-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13927383-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13928191-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13928388-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13928668-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13928943-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13929037-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13929336-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13929477-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13929588-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('13929852-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13930073-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13930245-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13930385-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13930725-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13930928-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13931145-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13931356-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13931436-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13931627-n',[ ('Human',subsumption)]).
nounMapping2SUMO('13931765-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13931889-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13932045-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13932213-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13932421-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13932739-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13932948-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13933103-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13933221-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13933391-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13933560-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13933841-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13934070-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13934274-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13934465-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13934596-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13934900-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13935227-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13935400-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13935572-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13935753-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13935910-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13936030-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13936153-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13936304-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13936441-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13936557-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13936676-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13936783-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13936939-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13937075-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13937284-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13937406-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13937554-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13937727-n',[ ('True',subsumption)]).
nounMapping2SUMO('13937918-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13938210-n',[ ('True',subsumption)]).
nounMapping2SUMO('13938296-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13938440-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13938663-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13938899-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13939158-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13939353-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13939604-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13939734-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13939892-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13940311-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13940456-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13941125-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13941337-n',[ ('EndFn',subsumption)]).
nounMapping2SUMO('13941469-n',[ ('WealthFn',subsumption)]).
nounMapping2SUMO('13941806-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13941924-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13942104-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13942405-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13942554-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13942743-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13942875-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13943053-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13943236-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13943400-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13943598-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13943740-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13943968-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13944096-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13944337-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13944516-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13944747-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13944914-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13945102-n',[ ('Position',subsumption)]).
nounMapping2SUMO('13945495-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13945682-n',[ ('Position',subsumption)]).
nounMapping2SUMO('13945919-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('13946760-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13947010-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13947174-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13947272-n',[ ('GameAttribute',subsumption)]).
nounMapping2SUMO('13947415-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13947645-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13947867-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13948026-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13948136-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13948441-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13948654-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13948766-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13948912-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13949080-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13949275-n',[ ('UnilateralGiving',subsumption)]).
nounMapping2SUMO('13949463-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13949576-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13949802-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13950143-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13950282-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13950440-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13950703-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13950812-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13951215-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13951444-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13951629-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13951794-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13951984-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13952171-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13952386-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13952466-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13952601-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13952792-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13953057-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13953215-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13953356-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('13953467-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13953608-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13953787-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13953936-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13954118-n',[ ('Unemployed',subsumption)]).
nounMapping2SUMO('13954253-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13954818-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13955152-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13955341-n',[ ('True',subsumption)]).
nounMapping2SUMO('13955461-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13955874-n',[ ('True',equivalence)]).
nounMapping2SUMO('13956097-n',[ ('True',equivalence)]).
nounMapping2SUMO('13956362-n',[ ('True',subsumption)]).
nounMapping2SUMO('13956488-n',[ ('True',equivalence)]).
nounMapping2SUMO('13956905-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13957117-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13957268-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('13957390-n',[ ('Living',subsumption)]).
nounMapping2SUMO('13957493-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13957601-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13957974-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13958138-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13958353-n',[ ('Attribute',equivalence)]).
nounMapping2SUMO('13958456-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13958672-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13958800-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13958921-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13959069-n',[ ('Process',equivalence)]).
nounMapping2SUMO('13959289-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13959463-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13959642-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13959818-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13959931-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13960117-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('13960357-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13960464-n',[ ('False',equivalence)]).
nounMapping2SUMO('13960833-n',[ ('False',subsumption)]).
nounMapping2SUMO('13960974-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13961179-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13961273-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13961399-n',[ ('WhenFn',equivalence)]).
nounMapping2SUMO('13961642-n',[ ('Living',equivalence)]).
nounMapping2SUMO('13962048-n',[ ('Human',equivalence)]).
nounMapping2SUMO('13962166-n',[ ('Living',subsumption)]).
nounMapping2SUMO('13962360-n',[ ('Process',subsumption)]).
nounMapping2SUMO('13962498-n',[ ('Dead',equivalence)]).
nounMapping2SUMO('13962765-n',[ ('Dead',equivalence)]).
nounMapping2SUMO('13963032-n',[ ('Dead',subsumption)]).
nounMapping2SUMO('13963192-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13963342-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13963565-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13963757-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13963970-n',[ ('MarriageContract',equivalence)]).
nounMapping2SUMO('13964466-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13964591-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13964879-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13965049-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13965274-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13965515-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13965627-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13965780-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13965888-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13966007-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13966201-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13966340-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13966496-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13966683-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13966795-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13966925-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13967089-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13967215-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13967507-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13967581-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13967715-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13967827-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13967970-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13968092-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13968308-n',[ ('Unemployed',equivalence)]).
nounMapping2SUMO('13968547-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13968859-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13968973-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13969101-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13969243-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13969700-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13969854-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13969988-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13970124-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13970236-n',[ ('PeaceState',equivalence)]).
nounMapping2SUMO('13970460-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13970584-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13970764-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13970912-n',[ ('ContestAttribute',subsumption)]).
nounMapping2SUMO('13971065-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('13971382-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('13971561-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13971802-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('13971901-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('13972180-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('13972387-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('13972505-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('13972601-n',[ ('Cooperation',subsumption)]).
nounMapping2SUMO('13972797-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13973059-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13973320-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('13973490-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13973632-n',[ ('PhysicalQuantity',subsumption)]).
nounMapping2SUMO('13973769-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13973990-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13974144-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13974317-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13974620-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('13974937-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13975037-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13975292-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13975444-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('13975659-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13975752-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13975988-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13976182-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13976322-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13976527-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13976731-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13976907-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13977043-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13977184-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13977366-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13977732-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13977870-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13978033-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13978166-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13978344-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13978601-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13978709-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13978914-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13979064-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13979173-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13979503-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13979786-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13979977-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13980128-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13980288-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13980596-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13980845-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('13981137-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('13981271-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('13981403-n',[ ('WarState',equivalence)]).
nounMapping2SUMO('13981763-n',[ ('War',subsumption)]).
nounMapping2SUMO('13981885-n',[ ('War',subsumption)]).
nounMapping2SUMO('13982000-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('13982156-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('13982357-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13982588-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13982692-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13982839-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13982999-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13983147-n',[ ('Illuminated',equivalence)]).
nounMapping2SUMO('13983304-n',[ ('Illuminated',subsumption)]).
nounMapping2SUMO('13983515-n',[ ('Unilluminated',equivalence)]).
nounMapping2SUMO('13983717-n',[ ('Unilluminated',subsumption)]).
nounMapping2SUMO('13983807-n',[ ('Unilluminated',subsumption)]).
nounMapping2SUMO('13984082-n',[ ('Unilluminated',subsumption)]).
nounMapping2SUMO('13984285-n',[ ('Illuminated',subsumption)]).
nounMapping2SUMO('13984468-n',[ ('Illuminated',subsumption)]).
nounMapping2SUMO('13984613-n',[ ('Illuminated',subsumption)]).
nounMapping2SUMO('13984944-n',[ ('Unilluminated',equivalence)]).
nounMapping2SUMO('13985098-n',[ ('Illuminated',subsumption)]).
nounMapping2SUMO('13985219-n',[ ('Illuminated',subsumption)]).
nounMapping2SUMO('13985323-n',[ ('Illuminated',subsumption)]).
nounMapping2SUMO('13985462-n',[ ('Unilluminated',subsumption)]).
nounMapping2SUMO('13985671-n',[ ('Illuminated',subsumption)]).
nounMapping2SUMO('13985818-n',[ ('EmotionalState',equivalence)]).
nounMapping2SUMO('13986189-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('13986372-n',[ ('Happiness',subsumption)]).
nounMapping2SUMO('13986679-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('13986943-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('13987219-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('13987423-n',[ ('Happiness',subsumption)]).
nounMapping2SUMO('13987719-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('13987905-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('13988101-n',[ ('Happiness',subsumption)]).
nounMapping2SUMO('13988224-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('13988498-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('13988663-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('13988871-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('13989051-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('13989280-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('13989443-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('13989627-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13989863-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13990064-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13990389-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13990502-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13990675-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13990960-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13991121-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13991245-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13991346-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13991516-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13991688-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13991823-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('13992194-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13992387-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13992514-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13992738-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13992935-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13993030-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13993210-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13993356-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13993517-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('13993685-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13993842-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13994014-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13994148-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13994456-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13994806-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13995016-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13995148-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13995378-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13995662-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13995824-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13995935-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13996061-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13996211-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13996300-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13996571-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13996719-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13996909-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13997050-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13997253-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13997529-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13997778-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13998014-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13998186-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13998263-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13998395-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('13998576-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13998781-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('13998966-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13999114-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('13999206-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13999663-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('13999941-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14000105-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14000200-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14000302-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14000403-n',[ ('Process',subsumption)]).
nounMapping2SUMO('14000642-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14000820-n',[ ('Process',subsumption)]).
nounMapping2SUMO('14001031-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14001213-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14001348-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14001629-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14001728-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14001852-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14001973-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14002109-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14002279-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('14002481-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14002813-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('14002915-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('14003167-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14003432-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14003599-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14003880-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('14004017-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14004149-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('14004317-n',[ ('Motion',equivalence)]).
nounMapping2SUMO('14004572-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14004958-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('14005137-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14005302-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14005549-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14005728-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14005892-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14006179-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14006490-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14006684-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14006821-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14006945-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14007546-n',[ ('IntentionalProcess',subsumption)]).
nounMapping2SUMO('14007750-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14007864-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14008050-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14008342-n',[ ('Process',subsumption)]).
nounMapping2SUMO('14008567-n',[ ('Impelling',subsumption)]).
nounMapping2SUMO('14008806-n',[ ('Obligation',equivalence)]).
nounMapping2SUMO('14009020-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14009274-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14009481-n',[ ('Process',subsumption)]).
nounMapping2SUMO('14009618-n',[ ('Obligation',subsumption)]).
nounMapping2SUMO('14009763-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14009946-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14010148-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14010636-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14010845-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14010927-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14011408-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14011557-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14011724-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14011811-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14012173-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14012311-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14012501-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14012667-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14013005-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14013249-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('14013368-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('14013549-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14013646-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14013751-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14013841-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14013981-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14014162-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14014425-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14014521-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14014621-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14014849-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14014990-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14015148-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14015266-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14015361-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14015596-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14015731-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14015996-n',[ ('StateOfMind',subsumption)]).
nounMapping2SUMO('14016114-n',[ ('StateOfMind',equivalence)]).
nounMapping2SUMO('14016275-n',[ ('Reasoning',subsumption)]).
nounMapping2SUMO('14016361-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14016863-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14017033-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14017206-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14017332-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('14017451-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14017665-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('14017871-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14018055-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14018203-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14018318-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14018432-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14018567-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14018918-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14019039-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14019138-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14019296-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14019441-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14019600-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14019840-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14020023-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14020271-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14020558-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14020753-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14020936-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14021118-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14021266-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14021471-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14021622-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14021853-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14021936-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14022068-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14022199-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14022369-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14022520-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14022661-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14022849-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14022959-n',[ ('Awake',equivalence)]).
nounMapping2SUMO('14023236-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14023374-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14023491-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14023804-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14023901-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14023997-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14024185-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14024296-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14024391-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14024581-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14024882-n',[ ('Asleep',equivalence)]).
nounMapping2SUMO('14025258-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14025478-n',[ ('Asleep',subsumption)]).
nounMapping2SUMO('14025755-n',[ ('Asleep',subsumption)]).
nounMapping2SUMO('14025993-n',[ ('Asleep',subsumption)]).
nounMapping2SUMO('14026089-n',[ ('Asleep',equivalence)]).
nounMapping2SUMO('14026166-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14026285-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14026376-n',[ ('StateOfMind',subsumption)]).
nounMapping2SUMO('14026592-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14026781-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14026869-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14026981-n',[ ('Unconscious',subsumption)]).
nounMapping2SUMO('14027204-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14027396-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14027674-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14028087-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14028291-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14028406-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14028652-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14028967-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14029163-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14029405-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14029686-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14029943-n',[ ('Unconscious',subsumption)]).
nounMapping2SUMO('14030084-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14030291-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14030435-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14030671-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14030820-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14031108-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14031523-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14031660-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14031922-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14032100-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14032293-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14032480-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14032599-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14032737-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14032868-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14033054-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14033185-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14033481-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14033587-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14033802-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14033917-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14034177-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14035298-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14035502-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14035695-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14035909-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14036043-n',[ ('Awake',subsumption)]).
nounMapping2SUMO('14036203-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14036356-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14036539-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14036735-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14036892-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14037011-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14037480-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14037619-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14037816-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14037925-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14038027-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14038185-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14038264-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14038482-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14038743-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14038993-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14039179-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14039310-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14039534-n',[ ('Hungry',subsumption)]).
nounMapping2SUMO('14039828-n',[ ('Hungry',subsumption)]).
nounMapping2SUMO('14039974-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14040071-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14040310-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14040490-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14040660-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14040846-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14040966-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14041106-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14041256-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14041508-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14041631-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14041763-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14041940-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14042165-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14042423-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14042735-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14042914-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14043092-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14043243-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14043458-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14043579-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14043708-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14043882-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14044174-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14044372-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14044454-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14044592-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14044719-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14044852-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14044930-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14045141-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14045347-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14045507-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14045835-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14045954-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14046038-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14046202-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14046751-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14046861-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14047009-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14047171-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14047440-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14047547-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14047641-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14047740-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14048015-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14048134-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14048309-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14048441-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14048847-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14049098-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14049262-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14049420-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14049552-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14049711-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14050011-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14050143-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14050434-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14050559-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14050871-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14051056-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14051201-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14051381-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14051494-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14051728-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14051917-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14052046-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14052403-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14053384-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14053558-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14053717-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14053850-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14053965-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14054102-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14054262-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14054465-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14054642-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14054762-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14055052-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14055408-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14055623-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14055796-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14055977-n',[ ('UnitOfMeasure',instance)]).
nounMapping2SUMO('14056143-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14056280-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14056588-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14056685-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14057001-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14057221-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14057371-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14057569-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14057828-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14058066-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14058252-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14058456-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14058563-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14058770-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14058934-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14059021-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14059143-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14059252-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14059336-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14059481-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14059663-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14059825-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14059928-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14060256-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14060417-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14060575-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14060688-n',[ ('Disability',subsumption)]).
nounMapping2SUMO('14060929-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14061097-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14061263-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14061462-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14061599-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14061703-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14061805-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14062332-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('14062490-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14062565-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14062725-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14063089-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14063290-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14063475-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14063633-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14063877-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14064044-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('14064186-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('14064296-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14064408-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14064644-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14064984-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14065071-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14065156-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14065243-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14065332-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14065412-n',[ ('InternalAttribute',subsumption)]).
nounMapping2SUMO('14065693-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14065903-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14066005-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14066203-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14066492-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14066661-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14066806-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14066959-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14067076-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14067481-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14067575-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14067681-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14067786-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14067902-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14068177-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14068344-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14068528-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14068685-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14068894-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14069057-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14069212-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14069383-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14069541-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14069747-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14069895-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14070055-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14070206-n',[ ('ConsciousnessAttribute',subsumption)]).
nounMapping2SUMO('14070360-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14071235-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14071419-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14071559-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14071758-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14071896-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14072126-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14072239-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14072423-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14072625-n',[ ('Anthrax',subsumption)]).
nounMapping2SUMO('14072934-n',[ ('Anthrax',subsumption)]).
nounMapping2SUMO('14073331-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14073505-n',[ ('ArgentinianHemorrhagicFever',equivalence)]).
nounMapping2SUMO('14073647-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14073795-n',[ ('Malaria',subsumption)]).
nounMapping2SUMO('14073906-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14074041-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14074267-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14074394-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14074606-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14074715-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14074877-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14075199-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14075358-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14075660-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14075838-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14076011-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14076126-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14076270-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14076479-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14076667-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14076809-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14076992-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14077269-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14077454-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14077693-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14077830-n',[ ('Malaria',equivalence)]).
nounMapping2SUMO('14078120-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14078421-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14078613-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14078733-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14078871-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14079156-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14079493-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14079740-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14079861-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14079971-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14080210-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14080352-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14080622-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14080836-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14081025-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14081124-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14081216-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14081297-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14081375-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14081665-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14081789-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14081941-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14082186-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14082303-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14082595-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14082788-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14082984-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14083061-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14083200-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14083368-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14083559-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14083790-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14084291-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14084502-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14084709-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14084880-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14085220-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14085474-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14085592-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14085708-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14086036-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14086143-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14086528-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14086626-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14086924-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14087096-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14087208-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14087321-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14087513-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14087758-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14087938-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14088127-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14088412-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14088758-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14088918-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14089080-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14089240-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14089339-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14089450-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14089592-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14089719-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14089974-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14090245-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14090416-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14090530-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14090727-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14090842-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14091018-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14091126-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14091254-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14091525-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14091757-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14091965-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14092114-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14092247-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14092456-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14092577-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14092704-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14092925-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14093096-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14093325-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14093464-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14093591-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14093723-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14093874-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14094068-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14094350-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14094653-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14094881-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14095128-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14095273-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14095439-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14095568-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14095742-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14095948-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14096123-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14096328-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14096412-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14096598-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14096724-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14096957-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14097162-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14097321-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14097432-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14097574-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14097893-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14098078-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14098347-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14098458-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14098663-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14098864-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14099050-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14099172-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14099439-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14099552-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14099643-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14099785-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14099933-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14100092-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14100243-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14100370-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14100494-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14100769-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14100957-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14101083-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14101317-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14101568-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14101801-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14101935-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14102075-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14102347-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14102454-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14102631-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14102831-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14103018-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14103180-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14103288-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14103510-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14103785-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14103998-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14104118-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14104218-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14104367-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14104522-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14104645-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14104830-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14105091-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14105386-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14105504-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14105629-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14105737-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14106025-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14106352-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14106456-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14106609-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14106727-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14106823-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14106917-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14107085-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14107249-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14107374-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14107653-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14107750-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14107849-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14108039-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14108232-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14108324-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14108576-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14108713-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14108938-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14109101-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14109485-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14109691-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14109889-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14110025-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14110146-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14110219-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14110411-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14110674-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14110966-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14111133-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14111355-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14111540-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14111715-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14111915-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14112101-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14112255-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14112466-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14112719-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14112855-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14113021-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14113228-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14113471-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14113636-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14113798-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14113938-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14114186-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14114365-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14114555-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14114773-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14114886-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14115086-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14115245-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14115351-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14115454-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14115648-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14115799-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14115914-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14116078-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14116321-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14116482-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14116672-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14116908-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14117173-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14117317-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14117449-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14117668-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14117805-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14118138-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14118423-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14118936-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14119598-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14119770-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14120096-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14120310-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14120614-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14120767-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14121058-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14121276-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14121500-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14121667-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14121804-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14122053-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14122235-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14122497-n',[ ('Influenza',equivalence)]).
nounMapping2SUMO('14122670-n',[ ('Influenza',subsumption)]).
nounMapping2SUMO('14122813-n',[ ('Influenza',subsumption)]).
nounMapping2SUMO('14123044-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14123259-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14123510-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14123759-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14124070-n',[ ('ScarletFever',equivalence)]).
nounMapping2SUMO('14124232-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14124423-n',[ ('Smallpox',equivalence)]).
nounMapping2SUMO('14124688-n',[ ('Smallpox',subsumption)]).
nounMapping2SUMO('14124931-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14125159-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14125333-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14125466-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14125774-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14125881-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14126078-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14126181-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14126293-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14126412-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14126519-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14126660-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14126908-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14127100-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14127211-n',[ ('InfectiousDisease',subsumption)]).
nounMapping2SUMO('14127782-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14128029-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14128331-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14128536-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14128650-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14128812-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14129223-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14129351-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14129579-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14129784-n',[ ('DengueFever',equivalence)]).
nounMapping2SUMO('14129999-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14130166-n',[ ('InfectiousDisease',subsumption)]).
nounMapping2SUMO('14130354-n',[ ('Hepatitis',equivalence)]).
nounMapping2SUMO('14130518-n',[ ('Hepatitis',equivalence)]).
nounMapping2SUMO('14130661-n',[ ('HepatitisA',equivalence)]).
nounMapping2SUMO('14130942-n',[ ('HepatitisB',equivalence)]).
nounMapping2SUMO('14131247-n',[ ('Hepatitis',subsumption)]).
nounMapping2SUMO('14131353-n',[ ('HepatitisC',equivalence)]).
nounMapping2SUMO('14131651-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14131950-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14132102-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14132375-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14132524-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14132829-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14132975-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14133159-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14133543-n',[ ('Gonorrhea',equivalence)]).
nounMapping2SUMO('14133750-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14133985-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14134351-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14134482-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14134623-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14134819-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14135065-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14135181-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14135277-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14135623-n',[ ('EbolaHemorrhagicFever',equivalence)]).
nounMapping2SUMO('14135956-n',[ ('LassaFever',equivalence)]).
nounMapping2SUMO('14136187-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14136544-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14136674-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14136868-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14137066-n',[ ('InfectiousDisease',subsumption)]).
nounMapping2SUMO('14137408-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14137561-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14137829-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14138178-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14138364-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14138538-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14138691-n',[ ('Plague',equivalence)]).
nounMapping2SUMO('14139015-n',[ ('BubonicPlague',equivalence)]).
nounMapping2SUMO('14139333-n',[ ('BubonicPlague',subsumption)]).
nounMapping2SUMO('14139462-n',[ ('BubonicPlague',subsumption)]).
nounMapping2SUMO('14139661-n',[ ('PneumonicPlague',equivalence)]).
nounMapping2SUMO('14139959-n',[ ('Plague',subsumption)]).
nounMapping2SUMO('14140176-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14140391-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14140533-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14140781-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14141062-n',[ ('LouseBorneTyphus',equivalence)]).
nounMapping2SUMO('14141238-n',[ ('LouseBorneTyphus',equivalence)]).
nounMapping2SUMO('14141490-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14141656-n',[ ('RockyMountainSpottedFever',equivalence)]).
nounMapping2SUMO('14141821-n',[ ('QFever',equivalence)]).
nounMapping2SUMO('14141912-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14142207-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14142326-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14142459-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14142768-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14142983-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14143239-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14143415-n',[ ('Tuberculosis',equivalence)]).
nounMapping2SUMO('14143818-n',[ ('Tuberculosis',subsumption)]).
nounMapping2SUMO('14144064-n',[ ('Tuberculosis',subsumption)]).
nounMapping2SUMO('14144247-n',[ ('Tuberculosis',subsumption)]).
nounMapping2SUMO('14144416-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14144626-n',[ ('Pertussis',equivalence)]).
nounMapping2SUMO('14144761-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14144960-n',[ ('YellowSkin',equivalence)]).
nounMapping2SUMO('14145095-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14145501-n',[ ('ViralDisease',subsumption)]).
nounMapping2SUMO('14145759-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14145911-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14146128-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14146273-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14146459-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14146571-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14146774-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14147014-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14147212-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14147380-n',[ ('Emphysema',subsumption)]).
nounMapping2SUMO('14147627-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14147964-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14148231-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14148411-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14148510-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14148646-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14148834-n',[ ('Legionellosis',equivalence)]).
nounMapping2SUMO('14149167-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14149290-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14149536-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14149773-n',[ ('Psittacosis',equivalence)]).
nounMapping2SUMO('14149963-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14150210-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14150363-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14150470-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14150612-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14150740-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14151139-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14151884-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14152169-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14152279-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14152492-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14152617-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14152803-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14152924-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14153010-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14153285-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14153468-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14153616-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14153982-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14154168-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14154421-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14154669-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14154832-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14155031-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14155274-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14155506-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14155834-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14156134-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14156345-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14156488-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14156740-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14156976-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14157163-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14157527-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14157782-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14157967-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14158179-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14158424-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14158594-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14158812-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14158997-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14159153-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14159318-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14159459-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14159623-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14159887-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14160179-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14160365-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14160665-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14160786-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14160903-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14161075-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14161515-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14161795-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14162025-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14162275-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14162563-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14162943-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14163182-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14163676-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14164007-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14164190-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14164341-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14164548-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14164866-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14165081-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14165240-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14165373-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14165544-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14165730-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14165909-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14166118-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14166358-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14166589-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14166775-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14166968-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14167123-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14167298-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14167426-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14167773-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14168010-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14168176-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14168447-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14168653-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14168792-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14169128-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14169364-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14169717-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14169897-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14170070-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14170337-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14170623-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14170772-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14170987-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14171176-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14171492-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14171682-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14172005-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14172217-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14172383-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14172558-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14172873-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14173013-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14173175-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14173295-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14173397-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14173484-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14173625-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14173823-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14174011-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14174208-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14174316-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14174455-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14174549-n',[ ('InfectiousDisease',subsumption)]).
nounMapping2SUMO('14175165-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14175313-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14175579-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14175727-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14175903-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14176051-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14176372-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14176570-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14176715-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14176895-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14177210-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14177423-n',[ ('HemorrhagicFever',equivalence)]).
nounMapping2SUMO('14177848-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14178077-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14178326-n',[ ('InfectiousDisease',subsumption)]).
nounMapping2SUMO('14178482-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14178794-n',[ ('InfectiousDisease',subsumption)]).
nounMapping2SUMO('14178913-n',[ ('InfectiousDisease',subsumption)]).
nounMapping2SUMO('14179104-n',[ ('InfectiousDisease',subsumption)]).
nounMapping2SUMO('14179276-n',[ ('InfectiousDisease',subsumption)]).
nounMapping2SUMO('14179390-n',[ ('CrimeanCongoHemorrhagicFever',equivalence)]).
nounMapping2SUMO('14179569-n',[ ('RiftValleyFever',equivalence)]).
nounMapping2SUMO('14179744-n',[ ('HIVVirus',equivalence)]).
nounMapping2SUMO('14179839-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14179946-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14180213-n',[ ('InfectiousDisease',subsumption)]).
nounMapping2SUMO('14180327-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14180565-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14180848-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14181049-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14181187-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14181409-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14181713-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14181948-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14182103-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14182242-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14182332-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14182453-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14182568-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14182697-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14182871-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14183065-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14183210-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14183337-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14183420-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14183522-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14183692-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14183774-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14183926-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14184067-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14184254-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14184390-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14184506-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14184608-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14184801-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14184986-n',[ ('StrepThroat',equivalence)]).
nounMapping2SUMO('14185219-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14185353-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14185503-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14185620-n',[ ('InfectiousDisease',subsumption)]).
nounMapping2SUMO('14185803-n',[ ('Tetanus',equivalence)]).
nounMapping2SUMO('14186046-n',[ ('InfectiousDisease',subsumption)]).
nounMapping2SUMO('14186256-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14186340-n',[ ('InfectiousDisease',subsumption)]).
nounMapping2SUMO('14186541-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14186738-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14187229-n',[ ('Antibody',subsumption)]).
nounMapping2SUMO('14187378-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14187869-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14188030-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14188238-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14188467-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14188568-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14188702-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14188804-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14189065-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14189204-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14189837-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14190132-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14190284-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14190493-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14190736-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14190907-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14191037-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14191284-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14191442-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14191646-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14191756-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14191903-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14192034-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14192199-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14192376-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14192672-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14192790-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14192942-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14193202-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14193325-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14193421-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14193571-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14193711-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14193925-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14194183-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14194345-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('14194690-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14194942-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14195112-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14195315-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14195715-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14195939-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14196221-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14196405-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14196543-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14196722-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14196823-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14196965-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14197099-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14197315-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14197468-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14197628-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14197780-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14198019-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14198200-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14198380-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14198576-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14198829-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14198997-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14199146-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14199264-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14199389-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14199477-n',[ ('Goiter',subsumption)]).
nounMapping2SUMO('14199700-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14199934-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14200098-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14200301-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14200418-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14200548-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14200704-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14200873-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14201311-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14201520-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14201682-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14201845-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14201989-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14202119-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14202272-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14202417-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14202520-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14202673-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14202763-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14202996-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14203269-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14203346-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14203605-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14203813-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14203942-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14204095-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14204253-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14204441-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14204586-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14204763-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14204950-n',[ ('PathologicProcess',equivalence)]).
nounMapping2SUMO('14206224-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14206375-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14206477-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14206722-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14206826-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14206929-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14207256-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14207388-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14207561-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14207711-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14207809-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14207978-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14208065-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14208176-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14208342-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14208438-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14208587-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14208988-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14209087-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14209201-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14209348-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14209635-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14209836-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14210119-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14210354-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14210564-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14210716-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14210888-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14210971-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14211212-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14211294-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14211440-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14211609-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14211985-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14212126-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14212303-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14212402-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14212579-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14212670-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14212759-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14212941-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14213044-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14213199-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14213328-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('14213512-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14213867-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14214001-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14214209-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14214355-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14214486-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14214584-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14214819-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14214938-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14215046-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14215199-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14215331-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14215908-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14216054-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14216152-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14216234-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14216318-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14216404-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14216546-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14216653-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14216793-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14216888-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14217002-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14217147-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14217253-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14217360-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14217473-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14217581-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14217676-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14217897-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14218057-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14218158-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14218293-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14218401-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14218493-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14218637-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14218717-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14218805-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14218887-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14218991-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14219068-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14219187-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14219290-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14219394-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14219487-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14219661-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14220308-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14220474-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14220735-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14220998-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14221138-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14221311-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14221601-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14221741-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14221924-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14222112-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14222352-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14222541-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14222685-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14222788-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14222918-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14223074-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14223296-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14223492-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14223638-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14223752-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14223870-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14223978-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14224170-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14224341-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14224547-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14224757-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14225045-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14225215-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14225346-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14225463-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14225632-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14225877-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14226056-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14226303-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14226567-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14226709-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14226862-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14227015-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14227218-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14227357-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14227488-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14227613-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14227806-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14227906-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14228038-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14228148-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14228376-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14228512-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14228712-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14228885-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14229067-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14229248-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14229403-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14229604-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14229788-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14229912-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14230083-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14230232-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14230358-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14230588-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14230800-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14231022-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14231207-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14231330-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14231504-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14231640-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14231794-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14232034-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14232157-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14232299-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14232460-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14232596-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14232740-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14232945-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14233155-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14233267-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14233545-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14233717-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14233974-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14234074-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14234317-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14234436-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14234611-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14234867-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14234950-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14235066-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14235200-n',[ ('Tumor',subsumption)]).
nounMapping2SUMO('14235667-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14235793-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14235928-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14236130-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14236226-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14236595-n',[ ('Tumor',subsumption)]).
nounMapping2SUMO('14236743-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14236872-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14237032-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14237148-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14237351-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14237489-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14237561-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14237818-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14238041-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14238211-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14238393-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14238528-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14238639-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14238820-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14238953-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14239097-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14239322-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14239425-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14239743-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14239918-n',[ ('Cancer',equivalence)]).
nounMapping2SUMO('14240262-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14240487-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14240587-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14240775-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14241088-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14241241-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14241319-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14241400-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14241556-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14241733-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14241825-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14241968-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14242132-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14242337-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14242788-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14242922-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14243268-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14243393-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14243649-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14243877-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14244003-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14244160-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14244353-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14244542-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14244726-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14244991-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14245163-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14245405-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14245594-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14245758-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14245928-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14246097-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14246359-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14246710-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14246899-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14247035-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14247239-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14247360-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14247458-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14247575-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14247743-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14247954-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14248069-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14248256-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14248422-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14248541-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14248669-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14248787-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14248899-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14249037-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14249138-n',[ ('Tumor',subsumption)]).
nounMapping2SUMO('14249262-n',[ ('Tumor',subsumption)]).
nounMapping2SUMO('14249384-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14249512-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14249601-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14249785-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14249937-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14250081-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14250232-n',[ ('Tumor',subsumption)]).
nounMapping2SUMO('14250433-n',[ ('Tumor',subsumption)]).
nounMapping2SUMO('14250514-n',[ ('Tumor',subsumption)]).
nounMapping2SUMO('14250622-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14250850-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14251045-n',[ ('Tumor',subsumption)]).
nounMapping2SUMO('14251174-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14251317-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14251435-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14251616-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14251845-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14251981-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14252067-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14252184-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14252320-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14252464-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14252564-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14252722-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14252864-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14253124-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14254102-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14254397-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14254570-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14254768-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14254926-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14255064-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14255234-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14255536-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14255848-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14256014-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14256117-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14256227-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14256346-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14256585-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14256668-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14256889-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14257014-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14257147-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14257377-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14257563-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14257687-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14257779-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14257993-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14258176-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14258293-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14258391-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14258512-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14258609-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14258762-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14258865-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14258957-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14259133-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14259320-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14259431-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14259616-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14259739-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14259865-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14260044-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14260182-n',[ ('Anthrax',subsumption)]).
nounMapping2SUMO('14260349-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14260550-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14260774-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14260898-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14260991-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14261112-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14261244-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14261384-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14261508-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14261717-n',[ ('ViralDisease',subsumption)]).
nounMapping2SUMO('14261846-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14262045-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14262153-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14262336-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14262419-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14262585-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14262740-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14262882-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14263089-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14263280-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14263440-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14263562-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14263753-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14263944-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14264042-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14264203-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14264352-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14264517-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14264664-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14264858-n',[ ('InfectiousDisease',subsumption)]).
nounMapping2SUMO('14265006-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14265205-n',[ ('Glanders',equivalence)]).
nounMapping2SUMO('14265350-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14265508-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14265722-n',[ ('MarburgDisease',equivalence)]).
nounMapping2SUMO('14265958-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14266168-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14266313-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14266400-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14266521-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14266677-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14266835-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14267017-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14267205-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14267358-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14267588-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14267722-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14267841-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14267994-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14268084-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14268221-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14268439-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14268623-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14268871-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14269090-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14269319-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14269556-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14269772-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14270016-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14270127-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14270241-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14270380-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14270614-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14270846-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14271015-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14271173-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14271322-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14271480-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14271667-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14271920-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14272023-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14272141-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14272347-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14272421-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14272620-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14272915-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14273084-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14273183-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14273277-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14273365-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14273601-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14273753-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14273860-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14274068-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14274217-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14274451-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14274592-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14274701-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14274801-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14274905-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14274975-n',[ ('Psittacosis',equivalence)]).
nounMapping2SUMO('14275077-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14275240-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14275405-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14275560-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14275661-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14275764-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14275978-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14276081-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14276201-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14276360-n',[ ('Tularemia',equivalence)]).
nounMapping2SUMO('14276649-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14276936-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14277655-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14277833-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14278102-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14278219-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14278360-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14278500-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14278642-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14278773-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14278953-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14279099-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14279235-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14279417-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14279543-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14279632-n',[ ('BacterialDisease',subsumption)]).
nounMapping2SUMO('14279845-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14280011-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14280151-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14280298-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14280504-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14280639-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14280775-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14280986-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14281086-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14281216-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14281397-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14281549-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14281678-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14281851-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14281992-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14282107-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14282258-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14282384-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14282524-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14282698-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14282796-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14282890-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14283002-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14283097-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14283178-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14283423-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14283525-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14283632-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14283909-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14284026-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14284193-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14284309-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14284450-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14284581-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14284688-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14284876-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14285008-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14285113-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14285276-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14285461-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14285662-n',[ ('Injuring',equivalence)]).
nounMapping2SUMO('14286339-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14286435-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14286549-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14286885-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14286995-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14287113-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14287314-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14287408-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14287567-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14287647-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14287741-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14287823-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14287904-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14287995-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14288107-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14288235-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14288561-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14288725-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14288871-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14289079-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14289193-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14289387-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14289504-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14289590-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14289829-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14289942-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14290107-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14290212-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14290365-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14290534-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14290751-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14290881-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14291010-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14291173-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14291295-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14291435-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14291561-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14291823-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14292090-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14292571-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14292688-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14292796-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14292944-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14293093-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14293207-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14293352-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14293505-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14293678-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14293840-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14293985-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14294117-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14294271-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14294354-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14294517-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14294678-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14294861-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14294964-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14295140-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14295248-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14295389-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14295691-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14295829-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14295986-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14296142-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14296254-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14296399-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14296579-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14296802-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14296966-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14297150-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14297329-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14297406-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14297489-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14297696-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14297870-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14298102-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14298247-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14298420-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14298620-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14298815-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14299070-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14299336-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14299480-n',[ ('Injuring',subsumption)]).
nounMapping2SUMO('14299637-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14301785-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14302005-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14302261-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14302460-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14302652-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14302847-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14303009-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14303249-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14303448-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14303647-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14303743-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14303877-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14304060-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14304722-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14304964-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14305149-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14305458-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14305699-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14305990-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14306245-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14306475-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14306802-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14307035-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14307275-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14307468-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14307724-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14308012-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14308168-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14308311-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14308472-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14308945-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14309183-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14309394-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14309653-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14309938-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14310172-n',[ ('Dead',subsumption)]).
nounMapping2SUMO('14310292-n',[ ('Death',subsumption)]).
nounMapping2SUMO('14310504-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14310830-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14310987-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14311117-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14311348-n',[ ('DiseaseOrSyndrome',equivalence)]).
nounMapping2SUMO('14311574-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('14311709-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14311801-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14311977-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('14312172-n',[ ('Tumor',subsumption)]).
nounMapping2SUMO('14312363-n',[ ('Tumor',subsumption)]).
nounMapping2SUMO('14312481-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14312600-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14312776-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14312889-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14313017-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14313154-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14313342-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14313440-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14313661-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14313943-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14314320-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14314483-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14314597-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14314756-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14314850-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14315071-n',[ ('Stating',subsumption)]).
nounMapping2SUMO('14315192-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14315549-n',[ ('Bloating',subsumption)]).
nounMapping2SUMO('14315722-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14315897-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14316048-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14316164-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14316352-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14316470-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14316583-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14316714-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14317064-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14317221-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14317433-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14317562-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14317720-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14317943-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14318030-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14318116-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14318210-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14318360-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14318552-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14318714-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14318819-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14318927-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14319093-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14319299-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14319454-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14319684-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14320016-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14320218-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14320394-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14320602-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14320813-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14320984-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14321135-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14321243-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14321333-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14321469-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14321653-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14321814-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14321953-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14322106-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14322248-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14322528-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14322699-n',[ ('Unhappiness',equivalence)]).
nounMapping2SUMO('14323683-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14323974-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14324099-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14324274-n',[ ('Pain',equivalence)]).
nounMapping2SUMO('14324572-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14324672-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14324795-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14325006-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14325220-n',[ ('PsychologicalProcess',instance)]).
nounMapping2SUMO('14325335-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14325437-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14325575-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14325732-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14325902-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14325976-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14326072-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14326190-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14326305-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14326458-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14326607-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14326880-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14326969-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14327125-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14327266-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14327435-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14327543-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14327707-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14327878-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14327970-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14328105-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14328290-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14328513-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14328588-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14328720-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14328794-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14328894-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14328966-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14329040-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14329159-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14329262-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14329460-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14329578-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14329654-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14329762-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14329888-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14330046-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14330201-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14330265-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14330340-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14330588-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14330727-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14330833-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14330992-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14331137-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14331271-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14331373-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14331690-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14331873-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14332085-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14332339-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14332448-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14332617-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14333058-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14333136-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14333334-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14333433-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14333575-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14333645-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14333721-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14333863-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14334011-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14334122-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14334306-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14334511-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14334631-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14334814-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14335006-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14335097-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14335223-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14335485-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14335641-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14335761-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14335884-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14336004-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14336169-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14336317-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14336539-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14338848-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14338942-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14339094-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14339219-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14339387-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14339536-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14339682-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14339772-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14339914-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14340091-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14340182-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14340287-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14340462-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14340635-n',[ ('Malaria',subsumption)]).
nounMapping2SUMO('14340734-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14340822-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14340914-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14341001-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14341091-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14341253-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14341334-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14341432-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14341563-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14341652-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14341769-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14341923-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14342132-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14342533-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14342638-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14342742-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14342882-n',[ ('EasternEquineEncephalitis',equivalence)]).
nounMapping2SUMO('14343062-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14343302-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14343411-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14343597-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14343735-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14344033-n',[ ('WestNileFever',subsumption)]).
nounMapping2SUMO('14344189-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14344720-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14344881-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14344997-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14345168-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14345304-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14345455-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14345552-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14345719-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14345815-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14345958-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14346080-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14346190-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14346280-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14346416-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14346606-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14346731-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14346909-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14347045-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14347190-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14347334-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14347540-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14347695-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14347774-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14347886-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14347993-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14348070-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14348176-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14348300-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14348429-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14348538-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14348647-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14348757-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14348895-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14349043-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14349208-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14349311-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14349446-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14349541-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14349628-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14349717-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14349807-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14349892-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14350023-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14350106-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14350206-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14350292-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14350448-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14350536-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14350837-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14351002-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14351094-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14351219-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14351321-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14351490-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14351629-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14351759-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14351886-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14351995-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14352077-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14352163-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14352334-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14352455-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14352570-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14352687-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14352801-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14352890-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14353008-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14353314-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14353479-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14353622-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14353862-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14353995-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14354121-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14354257-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14354462-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14354642-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14354751-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14354847-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14354960-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14355060-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14355238-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14355356-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14355459-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14355643-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14355725-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14355819-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14355901-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14356044-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14356167-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14356328-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14356497-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14356578-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14356720-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14356993-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14357160-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14357251-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14357370-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14357454-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14357607-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14357693-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14357770-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14357853-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14357942-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14358022-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14358335-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14358474-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14358622-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14358709-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14358860-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14358993-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14359073-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14359174-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14359459-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14359816-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14359952-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14360156-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14360320-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14360459-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14360742-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14360915-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14361064-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14361182-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14361415-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14361513-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14361664-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14361972-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14362075-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14362179-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14362373-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14362510-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14362593-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14362841-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14363027-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14363139-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14363367-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14363483-n',[ ('Scar',subsumption)]).
nounMapping2SUMO('14363785-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14363913-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14364065-n',[ ('Scar',subsumption)]).
nounMapping2SUMO('14364217-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14364306-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14364432-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14364566-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14364802-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14364980-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14365119-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14365356-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14365619-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14365741-n',[ ('Atrophy',subsumption)]).
nounMapping2SUMO('14365950-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14366225-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14366486-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14366633-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14366759-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14367005-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14367080-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14367249-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14367341-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14367556-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14367649-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14367797-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14368032-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14368192-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14368288-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14368483-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14368805-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14368917-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14369064-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14369194-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14369408-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14369530-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14369744-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14369913-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14370122-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14370267-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14370391-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14370526-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14370726-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14370825-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14370992-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14371082-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14371161-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14371449-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14371620-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14371770-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14371913-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14372286-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14372399-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14372513-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14372738-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14372855-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14373057-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14373246-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14373407-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14373582-n',[ ('StateOfMind',equivalence)]).
nounMapping2SUMO('14374273-n',[ ('StateOfMind',subsumption)]).
nounMapping2SUMO('14374432-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14374764-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14375005-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14375166-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14375241-n',[ ('StateOfMind',subsumption)]).
nounMapping2SUMO('14375363-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14375576-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14375761-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14375890-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14376188-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('14376497-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14376695-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14376855-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14377177-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14377375-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14377617-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14377830-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14377965-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14378064-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14378177-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14378311-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14378439-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14378586-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14378712-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14378897-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14379017-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14379130-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14379360-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14379501-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14379703-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14379829-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14380140-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14380473-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14380717-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14381017-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14381249-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14381416-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14381732-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14381840-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14381997-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14382075-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14382159-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14382238-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14382766-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14382871-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14382967-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14383067-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14383163-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14383252-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14383362-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14383444-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14383544-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14383624-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14383759-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14383848-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14383961-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14384041-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14384133-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14384227-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14384351-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14384431-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14384509-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14384602-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14384684-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14384796-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14385002-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14385082-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14385160-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14385243-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14385325-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14385403-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14385734-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14385818-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14385919-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14386022-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14386130-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14386475-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14386590-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14386697-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14386968-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14387202-n',[ ('StateOfMind',subsumption)]).
nounMapping2SUMO('14387349-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14387477-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14387604-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14387807-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14387975-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14388139-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14388596-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14388758-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('14388910-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14389240-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14389584-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14389739-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14389909-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14390109-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14390249-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14390466-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14390839-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14390967-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14391112-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14391319-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14391480-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14391660-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14391876-n',[ ('StateOfMind',subsumption)]).
nounMapping2SUMO('14392143-n',[ ('StateOfMind',subsumption)]).
nounMapping2SUMO('14392318-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14392491-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14392639-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14392862-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14393033-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14393161-n',[ ('Neurosis',subsumption)]).
nounMapping2SUMO('14393438-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14393716-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14393862-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14393958-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14394094-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14394479-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14394783-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14395018-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14395240-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14395403-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14395597-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14395955-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14396096-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14396431-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14396707-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14396890-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14397040-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14397372-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14397563-n',[ ('StateOfMind',subsumption)]).
nounMapping2SUMO('14397714-n',[ ('StateOfMind',subsumption)]).
nounMapping2SUMO('14397889-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14398067-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14398279-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14398390-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14398523-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14398929-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14399116-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14399438-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14399852-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14400325-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14400507-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14400677-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14400979-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14401240-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14401512-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14401644-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14401878-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14402015-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14402184-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14402377-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14402488-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14402625-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14402763-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14402922-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14403107-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14403282-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14403560-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14403772-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14404042-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14404160-n',[ ('Unhappiness',subsumption)]).
nounMapping2SUMO('14404460-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14404610-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14404722-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14404831-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14404941-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14405061-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14405225-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14405452-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14405621-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14405774-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14405931-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14406209-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('14406303-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14406465-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14406573-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14406900-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14407070-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14407211-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14407283-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14407435-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14407536-n',[ ('Unconscious',subsumption)]).
nounMapping2SUMO('14407795-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14407899-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14408086-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14408519-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14408646-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14408951-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14409137-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14409285-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14409371-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14409489-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14409718-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14409880-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14410089-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14410365-n',[ ('StaticWaterArea',subsumption)]).
nounMapping2SUMO('14410605-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14410918-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14411079-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14411243-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14411772-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14411884-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14411981-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14412374-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14412564-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14412725-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14412882-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14413162-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14413265-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14413411-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('14413644-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14413831-n',[ ('LandArea',subsumption)]).
nounMapping2SUMO('14413993-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('14414146-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14414294-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('14414503-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('14414715-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14414980-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14415072-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14415163-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14415335-n',[ ('Keeping',subsumption)]).
nounMapping2SUMO('14415518-n',[ ('SurfaceChange',subsumption)]).
nounMapping2SUMO('14415773-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14415898-n',[ ('PsychologicalAttribute',subsumption)]).
nounMapping2SUMO('14416089-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14416349-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14416473-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14416668-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14416845-n',[ ('StateOfMind',subsumption)]).
nounMapping2SUMO('14417146-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14417300-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14417551-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14417697-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14417993-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14418103-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14418290-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14418395-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('14418662-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('14418822-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('14418970-n',[ ('Declaring',subsumption)]).
nounMapping2SUMO('14419164-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14419510-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14419737-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14419889-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('14420074-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14420240-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14420464-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14420780-n',[ ('True',subsumption)]).
nounMapping2SUMO('14420954-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14421139-n',[ ('Comparing',subsumption)]).
nounMapping2SUMO('14421373-n',[ ('Separating',subsumption)]).
nounMapping2SUMO('14421585-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14421724-n',[ ('Combining',subsumption)]).
nounMapping2SUMO('14422035-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14422179-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14422488-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14422751-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14422871-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14423268-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14423428-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14423614-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14423740-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14423870-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14424087-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14424384-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('14424517-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14424780-n',[ ('FullyFormed',equivalence)]).
nounMapping2SUMO('14425103-n',[ ('FullyFormed',subsumption)]).
nounMapping2SUMO('14425319-n',[ ('FullyFormed',subsumption)]).
nounMapping2SUMO('14425414-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14425601-n',[ ('FullyFormed',subsumption)]).
nounMapping2SUMO('14425715-n',[ ('Female',subsumption), ('Human',subsumption)]).
nounMapping2SUMO('14425853-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('14425974-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('14426325-n',[ ('FullyFormed',subsumption)]).
nounMapping2SUMO('14426449-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('14426568-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14426736-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('14426910-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('14427065-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('14427239-n',[ ('NonFullyFormed',subsumption)]).
nounMapping2SUMO('14427408-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14427537-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14427633-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('14427991-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14428160-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14428404-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14428655-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14428796-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14428970-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14429150-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14429382-n',[ ('RatingAttribute',equivalence)]).
nounMapping2SUMO('14429484-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14429608-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14429885-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14429985-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14430916-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14431015-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14431169-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14431338-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14431471-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14431637-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14431738-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14431902-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14432032-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14432167-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14432271-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14432389-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14432527-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14432623-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14432744-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14432875-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14433001-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14433115-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14433232-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14433361-n',[ ('SocialRole',subsumption)]).
nounMapping2SUMO('14433505-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14433587-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14433769-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14434022-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14434219-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14434329-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14434522-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14434681-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14434866-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14435187-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14435353-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14435445-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14435670-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14435809-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14436029-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14436285-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14436438-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14436667-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14436769-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14436875-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14437134-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14437386-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14437552-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14437845-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14437976-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14438125-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14438419-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14438541-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14438693-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14438788-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14438898-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14439012-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14439149-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14439294-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14439447-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14439745-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14440035-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14440137-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14440488-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14440623-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14440875-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14441083-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14441230-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14441498-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14441610-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14441714-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14441825-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14442361-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14442530-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14442749-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14442933-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14443228-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14443345-n',[ ('NormativeAttribute',instance)]).
nounMapping2SUMO('14443434-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14443532-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14443676-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14443786-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14443912-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14444114-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14444326-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('14444644-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('14444825-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('14445072-n',[ ('FinancialTransaction',subsumption)]).
nounMapping2SUMO('14445226-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14445379-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14445749-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14446034-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14446161-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14446298-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14446493-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14446652-n',[ ('StateOfMind',subsumption)]).
nounMapping2SUMO('14446878-n',[ ('StateOfMind',subsumption)]).
nounMapping2SUMO('14447019-n',[ ('StateOfMind',subsumption)]).
nounMapping2SUMO('14447165-n',[ ('StateOfMind',subsumption)]).
nounMapping2SUMO('14447303-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14447525-n',[ ('StateOfMind',subsumption)]).
nounMapping2SUMO('14447816-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14447908-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14448200-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14448333-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14448692-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14448825-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14448910-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14449022-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14449126-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14449405-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14449865-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14449960-n',[ ('Quantity',subsumption)]).
nounMapping2SUMO('14450172-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14450339-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14450540-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14450691-n',[ ('Necessity',equivalence)]).
nounMapping2SUMO('14450904-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14451020-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14451189-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14451349-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14451672-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14451911-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('14452151-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14452294-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14452442-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('14452616-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14453066-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14453175-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14453290-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14453414-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14453554-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14453676-n',[ ('InfectiousDisease',subsumption)]).
nounMapping2SUMO('14453840-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14454030-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14454311-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14454450-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14454661-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14454773-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14454874-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14454988-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14455074-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14455206-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('14455419-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('14455552-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('14455700-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('14455847-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14455966-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14456054-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('14456138-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('14456435-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('14456586-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('14456752-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('14456893-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('14457041-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14457218-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14457361-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14457630-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14457707-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14457838-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('14457976-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('14458181-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14458593-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14458763-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14458943-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('14459093-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('14459185-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14459332-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14459422-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14459715-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14459824-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14460257-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14460407-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14460565-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14460974-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14461231-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14461519-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14461679-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14462064-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14462193-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14462565-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14462666-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14462946-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14463170-n',[ ('Malfunctioning',subsumption)]).
nounMapping2SUMO('14463331-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14463471-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14463676-n',[ ('Decreasing',subsumption)]).
nounMapping2SUMO('14463826-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14464005-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14464203-n',[ ('Malfunctioning',subsumption)]).
nounMapping2SUMO('14464512-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14464675-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14464793-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14464883-n',[ ('AnatomicalStructure',subsumption)]).
nounMapping2SUMO('14465048-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14465768-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14466122-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14466258-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14466344-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14466432-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14466567-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14466846-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14466974-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14467172-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14467395-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14467685-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14467846-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14467975-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14468167-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14468348-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14468508-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14468693-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14468870-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14469014-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14469154-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14469334-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14469466-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14469766-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14470144-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14470496-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14470754-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14471054-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14471224-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14471507-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14471724-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14471926-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14472111-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14472299-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14472526-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14472624-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14472900-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14473054-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14473222-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14473655-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14473917-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14474052-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14474264-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14474435-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14474556-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14474718-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14474894-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14475154-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14475273-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14475405-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14475661-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14475992-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14476205-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14476290-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14476521-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14476697-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14476852-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14477076-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14477207-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14477342-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14477509-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14477667-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14477877-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14478143-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14478291-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14478433-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14478684-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14478862-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14478975-n',[ ('Process',subsumption)]).
nounMapping2SUMO('14479086-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14479320-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14479488-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14479615-n',[ ('PhysicalState',equivalence)]).
nounMapping2SUMO('14480065-n',[ ('PhysicalState',subsumption)]).
nounMapping2SUMO('14480420-n',[ ('Liquid',equivalence)]).
nounMapping2SUMO('14480772-n',[ ('Solid',equivalence)]).
nounMapping2SUMO('14481080-n',[ ('Gas',equivalence)]).
nounMapping2SUMO('14481511-n',[ ('PhysicalState',subsumption)]).
nounMapping2SUMO('14481929-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('14482299-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14482444-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14482620-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14482852-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14482968-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('14483126-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14483348-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14483508-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14483620-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14483744-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14483917-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14484378-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14484516-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14484646-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14484778-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14484969-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14485064-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14485249-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14485436-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14485526-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14485673-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14485811-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14485990-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14486122-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('14486274-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14486533-n',[ ('EmotionalState',subsumption)]).
nounMapping2SUMO('14486639-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14486767-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14487026-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14487184-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14487443-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14487598-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14487731-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14487902-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14488004-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14488118-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14488200-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14488317-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('14488594-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('14488813-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14488912-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14489113-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14489361-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('14489523-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14489699-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14489859-n',[ ('Pliable',equivalence)]).
nounMapping2SUMO('14490110-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14490319-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14490564-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14490685-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14490801-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14491034-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14491171-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14491271-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14491625-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14491889-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14492116-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14492249-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14492373-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14492634-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14492723-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14492953-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14493145-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14493426-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14493613-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14493716-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14494032-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14494186-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14494358-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('14494594-n',[ ('Process',subsumption)]).
nounMapping2SUMO('14494716-n',[ ('InternalAttribute',subsumption)]).
nounMapping2SUMO('14494893-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14495080-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14495230-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14495466-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14495589-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14495761-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14495980-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14496063-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14496193-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14496451-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14496563-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14496710-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14496977-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14497120-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14497233-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14497365-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14497511-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14497679-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14497763-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14498096-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14498404-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14498567-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14498733-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14498843-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14498972-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14499111-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14499262-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14499594-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14499734-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14499953-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14500047-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14500341-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14500567-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14500819-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14500908-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14501172-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14501375-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14501545-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14501726-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14502896-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14503060-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14503234-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14503354-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14503528-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('14503665-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14503990-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14504103-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14504405-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14504558-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14504726-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14504889-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14505069-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14505215-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14505364-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14505469-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14505667-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14505821-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14506020-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14506233-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14506403-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14506533-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14506656-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14506920-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14507050-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14507148-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14507375-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14507651-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14507787-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14507951-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14508149-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14508368-n',[ ('Closing',subsumption)]).
nounMapping2SUMO('14508578-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14508799-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14508974-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14509219-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14509299-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14509491-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14509583-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14509712-n',[ ('Poisoning',equivalence)]).
nounMapping2SUMO('14510104-n',[ ('Poisoning',subsumption)]).
nounMapping2SUMO('14510247-n',[ ('Poisoning',subsumption)]).
nounMapping2SUMO('14510401-n',[ ('Poisoning',subsumption)]).
nounMapping2SUMO('14510648-n',[ ('Poisoning',subsumption)]).
nounMapping2SUMO('14510814-n',[ ('Poisoning',subsumption)]).
nounMapping2SUMO('14510955-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14511234-n',[ ('Poisoning',subsumption)]).
nounMapping2SUMO('14511491-n',[ ('Poisoning',subsumption)]).
nounMapping2SUMO('14511730-n',[ ('Poisoning',subsumption)]).
nounMapping2SUMO('14511862-n',[ ('Poisoning',subsumption)]).
nounMapping2SUMO('14512009-n',[ ('Poisoning',subsumption)]).
nounMapping2SUMO('14512088-n',[ ('Poisoning',subsumption)]).
nounMapping2SUMO('14512270-n',[ ('Poisoning',subsumption)]).
nounMapping2SUMO('14512508-n',[ ('Poisoning',subsumption)]).
nounMapping2SUMO('14512674-n',[ ('Poisoning',subsumption)]).
nounMapping2SUMO('14512817-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('14513062-n',[ ('Region',subsumption)]).
nounMapping2SUMO('14513259-n',[ ('Region',subsumption)]).
nounMapping2SUMO('14513489-n',[ ('Region',subsumption)]).
nounMapping2SUMO('14513694-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('14513944-n',[ ('Region',subsumption)]).
nounMapping2SUMO('14514039-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14514392-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14514491-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14514685-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14514805-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14515041-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14515177-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14515344-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14515463-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14515633-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14515816-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14516082-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14516256-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14516501-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14516743-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14517067-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14517243-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14517412-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14517629-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14517852-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14518010-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14518219-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14518377-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14518539-n',[ ('SoundAttribute',subsumption)]).
nounMapping2SUMO('14518671-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14518820-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14518924-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('14519097-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('14519208-n',[ ('Removing',subsumption)]).
nounMapping2SUMO('14519366-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14519673-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14519942-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('14520123-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14520278-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14520518-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14520670-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14520829-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14521021-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14521302-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14521648-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14521954-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14522113-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14522265-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14522408-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14522570-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('14522809-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14522956-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14523090-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14523344-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14523436-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14523669-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14523787-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14523923-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14524029-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14524198-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14524383-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14524487-n',[ ('Motion',subsumption)]).
nounMapping2SUMO('14524661-n',[ ('StateOfMind',subsumption)]).
nounMapping2SUMO('14524849-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('14525108-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14525274-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14525365-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14525548-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14525777-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14526032-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14526182-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14526635-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14526764-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14526954-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('14527171-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('14527430-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('14527553-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('14527721-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('14527977-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14528193-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('14528571-n',[ ('OrganOrTissueProcess',subsumption)]).
nounMapping2SUMO('14528752-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14528873-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14529082-n',[ ('Process',subsumption)]).
nounMapping2SUMO('14529212-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14529408-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14529524-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14529612-n',[ ('Law',subsumption)]).
nounMapping2SUMO('14529835-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14530061-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14530403-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14530563-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14530659-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14530836-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14531056-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14531203-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14531392-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14531598-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14531772-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('14531983-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('14532142-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14532250-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14532458-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14532659-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14532816-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14533106-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14533203-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14533547-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14533796-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14533937-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14534076-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14534199-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14534333-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14534457-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('14534571-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14534696-n',[ ('Damp',equivalence)]).
nounMapping2SUMO('14535056-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14535431-n',[ ('Damp',subsumption)]).
nounMapping2SUMO('14535643-n',[ ('Damp',subsumption)]).
nounMapping2SUMO('14535807-n',[ ('Damp',subsumption)]).
nounMapping2SUMO('14535905-n',[ ('Damp',subsumption)]).
nounMapping2SUMO('14536085-n',[ ('Damp',subsumption)]).
nounMapping2SUMO('14536207-n',[ ('Damp',subsumption)]).
nounMapping2SUMO('14536331-n',[ ('Damp',subsumption)]).
nounMapping2SUMO('14536438-n',[ ('Dry',equivalence)]).
nounMapping2SUMO('14536831-n',[ ('Dry',subsumption)]).
nounMapping2SUMO('14537054-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14537250-n',[ ('Dry',subsumption)]).
nounMapping2SUMO('14537472-n',[ ('Dry',subsumption)]).
nounMapping2SUMO('14537563-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14537735-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14538113-n',[ ('Dry',subsumption)]).
nounMapping2SUMO('14538329-n',[ ('Dry',subsumption)]).
nounMapping2SUMO('14538472-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14538811-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14538908-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14539029-n',[ ('PhysicalAttribute',subsumption)]).
nounMapping2SUMO('14539165-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14539268-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14539524-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14539693-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14539826-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14539960-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14540220-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('14540318-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('14540455-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14540564-n',[ ('Agent',subsumption)]).
nounMapping2SUMO('14540765-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('14541044-n',[ ('Process',subsumption)]).
nounMapping2SUMO('14541247-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14541538-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14541677-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14541852-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14542320-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14542441-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14542579-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('14542858-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14542983-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14543145-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14543231-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14543411-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14543552-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14543756-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14543931-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14544159-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14544335-n',[ ('InternalAttribute',subsumption)]).
nounMapping2SUMO('14544672-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14545045-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14545215-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14545353-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14545548-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14545685-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14545845-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14546042-n',[ ('TraitAttribute',subsumption)]).
nounMapping2SUMO('14546227-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14546432-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14546596-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14546701-n',[ ('InternalAttribute',subsumption)]).
nounMapping2SUMO('14546844-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14547036-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14547188-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14547369-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14547643-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14547976-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14548105-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14548343-n',[ ('Disability',equivalence)]).
nounMapping2SUMO('14548913-n',[ ('PhysicalDisability',subsumption)]).
nounMapping2SUMO('14549070-n',[ ('PhysicalDisability',subsumption)]).
nounMapping2SUMO('14549284-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14549382-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14549491-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14549600-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14549709-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14549823-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14549937-n',[ ('PhysicalDisability',subsumption)]).
nounMapping2SUMO('14550195-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14550366-n',[ ('PhysicalDisability',subsumption)]).
nounMapping2SUMO('14550469-n',[ ('Disability',subsumption)]).
nounMapping2SUMO('14550614-n',[ ('Disability',subsumption)]).
nounMapping2SUMO('14550797-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14550987-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14551146-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14551321-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14551565-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14551704-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14551822-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14551986-n',[ ('Disability',subsumption)]).
nounMapping2SUMO('14552205-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14552355-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14552477-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14552718-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14552802-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14553290-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14553590-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14553873-n',[ ('Blind',subsumption)]).
nounMapping2SUMO('14554011-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14554345-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14554459-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14554591-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14554695-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14554853-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14555059-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14555214-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14555414-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14555560-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14555688-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14555790-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14555962-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14556203-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14556426-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14556552-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14556656-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14556765-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14556879-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14557091-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14557206-n',[ ('Blind',subsumption)]).
nounMapping2SUMO('14557315-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14557415-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14557573-n',[ ('SensoryDisability',subsumption)]).
nounMapping2SUMO('14557719-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14557898-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14558226-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14558599-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14558700-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14558801-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14558899-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14558995-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14559134-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14559208-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14559495-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14559644-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14559757-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14559852-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14559983-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14560115-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14560253-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14560360-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('14560538-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('14560612-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('14560926-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('14561102-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('14561327-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('14561461-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('14561618-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('14561839-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('14561995-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('14562142-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('14562324-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('14562541-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('14562683-n',[ ('Damaging',subsumption)]).
nounMapping2SUMO('14562854-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14562960-n',[ ('Process',subsumption)]).
nounMapping2SUMO('14563222-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14563475-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14563564-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14563784-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14563928-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14564056-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14564165-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14564306-n',[ ('Offering',equivalence)]).
nounMapping2SUMO('14564519-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14564779-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14564934-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14565121-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14565196-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14565417-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14565696-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14565927-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14566129-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14566308-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14566476-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14566606-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14566766-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14566996-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14567134-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14567281-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14567421-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14567571-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14567690-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14567812-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14567956-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14568194-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14568359-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14568516-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14568621-n',[ ('ShapeAttribute',subsumption)]).
nounMapping2SUMO('14568762-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14568986-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14569121-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14569337-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14569508-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14569683-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14569844-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14570091-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14570330-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14570581-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14570676-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14570761-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14570846-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14570939-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14571028-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14571181-n',[ ('Death',subsumption)]).
nounMapping2SUMO('14571377-n',[ ('Atrophy',subsumption)]).
nounMapping2SUMO('14571504-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14571618-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14571714-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14571930-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14572074-n',[ ('PsychologicalProcess',subsumption)]).
nounMapping2SUMO('14572265-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14572353-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14572503-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14572637-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14572770-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14572854-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14572951-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14573099-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14573196-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14573303-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14573432-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14573553-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14573713-n',[ ('NormativeAttribute',subsumption)]).
nounMapping2SUMO('14573846-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14574014-n',[ ('PathologicProcess',subsumption)]).
nounMapping2SUMO('14574192-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14574349-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14574504-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14574675-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14574846-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14575063-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14575180-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14575399-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14575531-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14575700-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14575849-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14575952-n',[ ('Disseminating',not(subsumption))]).
nounMapping2SUMO('14576053-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14576242-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14576468-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('14576690-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('14576860-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('14577046-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14577331-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14577469-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14577753-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14577872-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14578104-n',[ ('Lubricating',equivalence)]).
nounMapping2SUMO('14578302-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14578471-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14578634-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14578792-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14578940-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14579063-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14579215-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14579365-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14579489-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14579623-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14579827-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14580090-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14580334-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14580476-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('14580597-n',[ ('Object',equivalence)]).
nounMapping2SUMO('14580752-n',[ ('SocialInteraction',subsumption)]).
nounMapping2SUMO('14580897-n',[ ('Substance',equivalence)]).
nounMapping2SUMO('14582025-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14582220-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14582535-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14582716-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14582870-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14583066-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14583228-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14583400-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14583573-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14583670-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14583843-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14584016-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14584110-n',[ ('Group',subsumption)]).
nounMapping2SUMO('14584260-n',[ ('BiologicalProcess',subsumption)]).
nounMapping2SUMO('14584390-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14584502-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14584658-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14584765-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14585048-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14585223-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14585392-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14585519-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14585808-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14585960-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('14586119-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14586258-n',[ ('Mixture',equivalence)]).
nounMapping2SUMO('14586769-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14587688-n',[ ('BotulinumToxin',equivalence)]).
nounMapping2SUMO('14587886-n',[ ('BotulinumToxin',subsumption)]).
nounMapping2SUMO('14588219-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14588492-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14588646-n',[ ('PhysicalState',subsumption)]).
nounMapping2SUMO('14588797-n',[ ('PhysicalState',subsumption)]).
nounMapping2SUMO('14588986-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14589114-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14589223-n',[ ('Solution',equivalence)]).
nounMapping2SUMO('14589912-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14589994-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14590293-n',[ ('SalineSolution',subsumption)]).
nounMapping2SUMO('14590441-n',[ ('Electrolyte',subsumption)]).
nounMapping2SUMO('14590542-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14590685-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14590795-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14590975-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14591091-n',[ ('Suspension',subsumption)]).
nounMapping2SUMO('14591333-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14591481-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14591635-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14591804-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14591901-n',[ ('Toxin',subsumption)]).
nounMapping2SUMO('14592028-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14592217-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14592309-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14592405-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14592610-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14593162-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14593344-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14593545-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14593671-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14593874-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14594032-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14594174-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14594313-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14594456-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14594708-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14594925-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('14595076-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14595176-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14595279-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14595403-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14595543-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14595711-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14595933-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14596063-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14596216-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14596398-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14596599-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14596700-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14596839-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14596956-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14597158-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14597413-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14597628-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14597758-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14598079-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14598251-n',[ ('CottonFiber',subsumption)]).
nounMapping2SUMO('14598383-n',[ ('MeasuringDevice',subsumption)]).
nounMapping2SUMO('14598525-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14598704-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14598834-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14598937-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14599168-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14599494-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14599641-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14599806-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14599938-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14600135-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14600238-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14600357-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14600504-n',[ ('OrganicCompound',subsumption)]).
nounMapping2SUMO('14600742-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14600927-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14601039-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14601178-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14601294-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14601505-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14601646-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14601829-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14602490-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14602597-n',[ ('Clay',subsumption)]).
nounMapping2SUMO('14602721-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14602851-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14602987-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14603143-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14603236-n',[ ('Hydrocarbon',subsumption)]).
nounMapping2SUMO('14603497-n',[ ('Chlorofluorocarbon',equivalence)]).
nounMapping2SUMO('14603798-n',[ ('CSGas',equivalence)]).
nounMapping2SUMO('14604038-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14604184-n',[ ('ChemicalSalt',subsumption)]).
nounMapping2SUMO('14604286-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14604454-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14604616-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14604763-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14604857-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14604959-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14605132-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('14605415-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14605590-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14605787-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14606137-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14606290-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14606482-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14606704-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14606839-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14606993-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14607131-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14607250-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14607378-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14607521-n',[ ('ChemicalAcid',equivalence)]).
nounMapping2SUMO('14609198-n',[ ('MeasuringDevice',subsumption)]).
nounMapping2SUMO('14609443-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14609689-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14609784-n',[ ('MeasuringDevice',subsumption)]).
nounMapping2SUMO('14610088-n',[ ('Hydrocarbon',subsumption)]).
nounMapping2SUMO('14610261-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14610347-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14610443-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14610548-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14610703-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14610782-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14610914-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14611031-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14611158-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14611279-n',[ ('ChemicalSalt',subsumption)]).
nounMapping2SUMO('14611397-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14611521-n',[ ('Hydrogen',subsumption)]).
nounMapping2SUMO('14611679-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14611804-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14611980-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14612077-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14612317-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14612444-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14612618-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14612764-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14612972-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14613130-n',[ ('Chlorofluorocarbon',subsumption)]).
nounMapping2SUMO('14613368-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14613643-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14613841-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14613922-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14614139-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14614245-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14614378-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14614490-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14614594-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14614744-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14614864-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14615006-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14615135-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14615264-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14615400-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14615602-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14615724-n',[ ('ChemicalSalt',subsumption)]).
nounMapping2SUMO('14615822-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14615971-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14616073-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14616181-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14616292-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14616410-n',[ ('ChemicalSalt',subsumption)]).
nounMapping2SUMO('14616508-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14616620-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14616740-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14616939-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14617189-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14617427-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14617597-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14617715-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14617834-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14617944-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14618050-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14618253-n',[ ('ChemicalBase',subsumption)]).
nounMapping2SUMO('14618674-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14618834-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14619033-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14619225-n',[ ('Atom',equivalence)]).
nounMapping2SUMO('14619658-n',[ ('Atom',subsumption)]).
nounMapping2SUMO('14619857-n',[ ('Atom',subsumption)]).
nounMapping2SUMO('14620066-n',[ ('Atom',subsumption)]).
nounMapping2SUMO('14620257-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14620549-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14620654-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14620781-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14620895-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14621080-n',[ ('Atom',subsumption)]).
nounMapping2SUMO('14621194-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14621319-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14621446-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14622141-n',[ ('Carbon',subsumption)]).
nounMapping2SUMO('14622350-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14622491-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14622623-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14622768-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14622893-n',[ ('ElementalSubstance',equivalence)]).
nounMapping2SUMO('14624025-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14624191-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14624369-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14624659-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14624743-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14624944-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14625110-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14625297-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14625458-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14627081-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14627246-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14627373-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14627529-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14627655-n',[ ('Actinium',equivalence)]).
nounMapping2SUMO('14627820-n',[ ('Aluminum',equivalence)]).
nounMapping2SUMO('14628119-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14628307-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14628494-n',[ ('Americium',equivalence)]).
nounMapping2SUMO('14628668-n',[ ('Antimony',equivalence)]).
nounMapping2SUMO('14628920-n',[ ('Argon',equivalence)]).
nounMapping2SUMO('14629149-n',[ ('Arsenic',equivalence)]).
nounMapping2SUMO('14629561-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14629772-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14629998-n',[ ('Barium',equivalence)]).
nounMapping2SUMO('14630204-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14630363-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14630492-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14630630-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14630769-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14631134-n',[ ('Berkelium',equivalence)]).
nounMapping2SUMO('14631295-n',[ ('Beryllium',equivalence)]).
nounMapping2SUMO('14631502-n',[ ('Bismuth',equivalence)]).
nounMapping2SUMO('14631757-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14631871-n',[ ('Boron',equivalence)]).
nounMapping2SUMO('14632129-n',[ ('Bromine',equivalence)]).
nounMapping2SUMO('14632444-n',[ ('Cadmium',equivalence)]).
nounMapping2SUMO('14632648-n',[ ('Calcium',equivalence)]).
nounMapping2SUMO('14633037-n',[ ('Californium',equivalence)]).
nounMapping2SUMO('14633206-n',[ ('Carbon',equivalence)]).
nounMapping2SUMO('14633781-n',[ ('Atom',subsumption), ('Carbon',subsumption)]).
nounMapping2SUMO('14633856-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14633957-n',[ ('Cerium',equivalence)]).
nounMapping2SUMO('14634232-n',[ ('Caesium',equivalence)]).
nounMapping2SUMO('14634477-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14634591-n',[ ('Chlorine',equivalence)]).
nounMapping2SUMO('14634999-n',[ ('Chlorine',subsumption)]).
nounMapping2SUMO('14635092-n',[ ('Chromium',equivalence)]).
nounMapping2SUMO('14635290-n',[ ('Cobalt',equivalence)]).
nounMapping2SUMO('14635542-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14635722-n',[ ('Copper',equivalence)]).
nounMapping2SUMO('14636220-n',[ ('Curium',equivalence)]).
nounMapping2SUMO('14636392-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14636523-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14636647-n',[ ('Dysprosium',equivalence)]).
nounMapping2SUMO('14636822-n',[ ('Einsteinium',equivalence)]).
nounMapping2SUMO('14636988-n',[ ('Erbium',equivalence)]).
nounMapping2SUMO('14637176-n',[ ('Europium',equivalence)]).
nounMapping2SUMO('14637339-n',[ ('Fermium',equivalence)]).
nounMapping2SUMO('14637507-n',[ ('Fluorine',equivalence)]).
nounMapping2SUMO('14637864-n',[ ('Francium',equivalence)]).
nounMapping2SUMO('14638041-n',[ ('Gadolinium',equivalence)]).
nounMapping2SUMO('14638256-n',[ ('Gallium',equivalence)]).
nounMapping2SUMO('14638517-n',[ ('Germanium',equivalence)]).
nounMapping2SUMO('14638799-n',[ ('Gold',equivalence)]).
nounMapping2SUMO('14639269-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14639368-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14639467-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14639556-n',[ ('Hafnium',equivalence)]).
nounMapping2SUMO('14639795-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14639921-n',[ ('Helium',equivalence)]).
nounMapping2SUMO('14640222-n',[ ('Holmium',equivalence)]).
nounMapping2SUMO('14640434-n',[ ('Hydrogen',equivalence)]).
nounMapping2SUMO('14640756-n',[ ('Hydrogen',equivalence)]).
nounMapping2SUMO('14640890-n',[ ('Hydrogen',subsumption)]).
nounMapping2SUMO('14641046-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14641223-n',[ ('Indium',equivalence)]).
nounMapping2SUMO('14641397-n',[ ('Iodine',equivalence)]).
nounMapping2SUMO('14641797-n',[ ('Iodine',subsumption)]).
nounMapping2SUMO('14642005-n',[ ('Iodine',subsumption)]).
nounMapping2SUMO('14642219-n',[ ('Iridium',equivalence)]).
nounMapping2SUMO('14642417-n',[ ('Iron',equivalence)]).
nounMapping2SUMO('14642916-n',[ ('Krypton',equivalence)]).
nounMapping2SUMO('14643118-n',[ ('Lanthanum',equivalence)]).
nounMapping2SUMO('14643323-n',[ ('Lawrencium',equivalence)]).
nounMapping2SUMO('14643467-n',[ ('Lead',equivalence)]).
nounMapping2SUMO('14643793-n',[ ('Lithium',equivalence)]).
nounMapping2SUMO('14644063-n',[ ('Lutetium',equivalence)]).
nounMapping2SUMO('14644249-n',[ ('Magnesium',equivalence)]).
nounMapping2SUMO('14644654-n',[ ('Manganese',equivalence)]).
nounMapping2SUMO('14644963-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14645092-n',[ ('Mendelevium',equivalence)]).
nounMapping2SUMO('14645346-n',[ ('Mercury',equivalence)]).
nounMapping2SUMO('14645661-n',[ ('Molybdenum',equivalence)]).
nounMapping2SUMO('14645882-n',[ ('Neodymium',equivalence)]).
nounMapping2SUMO('14646152-n',[ ('Neon',equivalence)]).
nounMapping2SUMO('14646403-n',[ ('Neptunium',equivalence)]).
nounMapping2SUMO('14646610-n',[ ('Nickel',equivalence)]).
nounMapping2SUMO('14646942-n',[ ('Niobium',equivalence)]).
nounMapping2SUMO('14647154-n',[ ('Niobium',equivalence)]).
nounMapping2SUMO('14647235-n',[ ('Nitrogen',equivalence)]).
nounMapping2SUMO('14647623-n',[ ('Nitrogen',equivalence)]).
nounMapping2SUMO('14647722-n',[ ('Nobelium',equivalence)]).
nounMapping2SUMO('14647907-n',[ ('Osmium',equivalence)]).
nounMapping2SUMO('14648100-n',[ ('Oxygen',equivalence)]).
nounMapping2SUMO('14648526-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14648754-n',[ ('Palladium',equivalence)]).
nounMapping2SUMO('14649036-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14649197-n',[ ('Phosphorus',equivalence)]).
nounMapping2SUMO('14649543-n',[ ('Platinum',equivalence)]).
nounMapping2SUMO('14649775-n',[ ('Plutonium',equivalence)]).
nounMapping2SUMO('14650137-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14650366-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14650556-n',[ ('Polonium',equivalence)]).
nounMapping2SUMO('14650807-n',[ ('Potassium',equivalence)]).
nounMapping2SUMO('14651212-n',[ ('Praseodymium',equivalence)]).
nounMapping2SUMO('14651479-n',[ ('Promethium',equivalence)]).
nounMapping2SUMO('14651708-n',[ ('Protactinium',equivalence)]).
nounMapping2SUMO('14651921-n',[ ('Radium',equivalence)]).
nounMapping2SUMO('14652104-n',[ ('Radon',equivalence)]).
nounMapping2SUMO('14652390-n',[ ('Rhenium',equivalence)]).
nounMapping2SUMO('14652623-n',[ ('Rhodium',equivalence)]).
nounMapping2SUMO('14652824-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14652954-n',[ ('Rubidium',equivalence)]).
nounMapping2SUMO('14653242-n',[ ('Ruthenium',equivalence)]).
nounMapping2SUMO('14653416-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14653596-n',[ ('Samarium',equivalence)]).
nounMapping2SUMO('14653831-n',[ ('Scandium',equivalence)]).
nounMapping2SUMO('14654058-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14654175-n',[ ('Selenium',equivalence)]).
nounMapping2SUMO('14654541-n',[ ('Silicon',equivalence)]).
nounMapping2SUMO('14654954-n',[ ('Silver',equivalence)]).
nounMapping2SUMO('14655371-n',[ ('Sodium',equivalence)]).
nounMapping2SUMO('14655731-n',[ ('Strontium',equivalence)]).
nounMapping2SUMO('14656001-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14656219-n',[ ('Sulphur',equivalence)]).
nounMapping2SUMO('14656666-n',[ ('Tantalum',equivalence)]).
nounMapping2SUMO('14656926-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14657047-n',[ ('Technetium',equivalence)]).
nounMapping2SUMO('14657228-n',[ ('Tellurium',equivalence)]).
nounMapping2SUMO('14657566-n',[ ('Terbium',equivalence)]).
nounMapping2SUMO('14657818-n',[ ('Thallium',equivalence)]).
nounMapping2SUMO('14658109-n',[ ('Thorium',equivalence)]).
nounMapping2SUMO('14658422-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14658546-n',[ ('Thulium',equivalence)]).
nounMapping2SUMO('14658855-n',[ ('Tin',equivalence)]).
nounMapping2SUMO('14659211-n',[ ('Titanium',equivalence)]).
nounMapping2SUMO('14659512-n',[ ('Tungsten',equivalence)]).
nounMapping2SUMO('14659794-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14659922-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14660052-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14660183-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14660314-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14660443-n',[ ('Uranium',equivalence)]).
nounMapping2SUMO('14660700-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14660835-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14661020-n',[ ('Vanadium',equivalence)]).
nounMapping2SUMO('14661274-n',[ ('Xenon',equivalence)]).
nounMapping2SUMO('14661482-n',[ ('Ytterbium',equivalence)]).
nounMapping2SUMO('14661740-n',[ ('Yttrium',equivalence)]).
nounMapping2SUMO('14661977-n',[ ('Zinc',equivalence)]).
nounMapping2SUMO('14662281-n',[ ('Zirconium',equivalence)]).
nounMapping2SUMO('14662574-n',[ ('Mineral',equivalence)]).
nounMapping2SUMO('14665102-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14665351-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14665469-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14665605-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14665767-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14666012-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14666369-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14666510-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14666758-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14666885-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14667017-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14667181-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14667328-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14667455-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14667668-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14667855-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14667949-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14668065-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14668277-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14668539-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14668743-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14668895-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14669084-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14669242-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14669413-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14669677-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14669823-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14669927-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14670061-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14670178-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14670344-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14670481-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14670639-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14670954-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14671125-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14671253-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14671372-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14671587-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14671744-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14671895-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14672023-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14672224-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14672373-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14672544-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14672717-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14672893-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14673032-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14673150-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14673325-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14673462-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14673669-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14673747-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14673978-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14674143-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14674408-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14674584-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14674776-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14675012-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14675216-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14675356-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14675569-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14675910-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14676042-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14676326-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14676486-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14676608-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14676756-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14676943-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14677144-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14677314-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14677485-n',[ ('Clothing',subsumption)]).
nounMapping2SUMO('14677610-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14677778-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14678068-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14678230-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14678406-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14678551-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14678762-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14678952-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14679147-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14679267-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14679447-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14679584-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14679780-n',[ ('ChemicalSalt',subsumption)]).
nounMapping2SUMO('14679882-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14680040-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14680261-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14680415-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14680514-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14680661-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14680836-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14680963-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14681100-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14681249-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14681445-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14681555-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14681987-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14682133-n',[ ('Molecule',equivalence)]).
nounMapping2SUMO('14682469-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14682642-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14682963-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14683085-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14683204-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14683447-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14683595-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14683859-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14684017-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14684111-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14684272-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14684427-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14684607-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14684690-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14684798-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14684918-n',[ ('BodySubstance',subsumption), ('Combustible',subsumption)]).
nounMapping2SUMO('14685017-n',[ ('Substance',subsumption), ('Combustible',subsumption)]).
nounMapping2SUMO('14685172-n',[ ('Carbon',subsumption)]).
nounMapping2SUMO('14685296-n',[ ('Combustible',subsumption)]).
nounMapping2SUMO('14685475-n',[ ('Substance',subsumption), ('Combustible',subsumption)]).
nounMapping2SUMO('14685641-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14685768-n',[ ('Substance',subsumption), ('Combustible',subsumption)]).
nounMapping2SUMO('14685881-n',[ ('PetroleumProduct',subsumption), ('Combustible',subsumption)]).
nounMapping2SUMO('14686020-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14686186-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14686352-n',[ ('PetroleumProduct',subsumption), ('Combustible',subsumption)]).
nounMapping2SUMO('14686585-n',[ ('PetroleumProduct',subsumption), ('Combustible',subsumption)]).
nounMapping2SUMO('14686723-n',[ ('Mixture',subsumption), ('Combustible',subsumption)]).
nounMapping2SUMO('14686913-n',[ ('Gasoline',subsumption)]).
nounMapping2SUMO('14687261-n',[ ('Gasoline',subsumption)]).
nounMapping2SUMO('14687513-n',[ ('Combustible',subsumption)]).
nounMapping2SUMO('14687633-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14687818-n',[ ('Alcohol',subsumption)]).
nounMapping2SUMO('14688089-n',[ ('Fuel',subsumption)]).
nounMapping2SUMO('14688234-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14688500-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14688705-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14688831-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14688978-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14689226-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14689325-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14689493-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14689672-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14689817-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14689940-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14690063-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14690186-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14690335-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14690447-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14690607-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14690790-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14690938-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14691085-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14691231-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14691445-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14691686-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14691822-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14692026-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14692202-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14692342-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14692510-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14692682-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14692844-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14692973-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14693124-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14693275-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14693396-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14693575-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14693733-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14694161-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14694293-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14694453-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14694571-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14694672-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14694765-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14694910-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14695069-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14695184-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14695351-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14695497-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14695588-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14695737-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14695838-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14695953-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14696035-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14696180-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14696331-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14696463-n',[ ('RicinToxin',equivalence)]).
nounMapping2SUMO('14696690-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14696793-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14697485-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14697600-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14697708-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14697839-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14698000-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14698233-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14698405-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14698568-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14698698-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14698884-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14699068-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14699209-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14699321-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14699441-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14699574-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14699752-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14700046-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14700162-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14700280-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14700438-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14700594-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14700745-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14700985-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14701143-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14701412-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14701521-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14701628-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14701826-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14701949-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14702117-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14702256-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14702416-n',[ ('Glue',subsumption)]).
nounMapping2SUMO('14702703-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14702875-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14703190-n',[ ('Glue',subsumption)]).
nounMapping2SUMO('14703345-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14703458-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14703566-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14703709-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14703797-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14703999-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14704152-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14704328-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14704465-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14704640-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14704851-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14704966-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14705183-n',[ ('Device',subsumption)]).
nounMapping2SUMO('14705287-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14705386-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14705533-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14705718-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14706026-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14706214-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14706372-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14706574-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14706749-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14706889-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14707101-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14707361-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14707710-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14707903-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14708042-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14708232-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14708413-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14708531-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14708720-n',[ ('Alcohol',equivalence)]).
nounMapping2SUMO('14709102-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14709265-n',[ ('Alcohol',subsumption)]).
nounMapping2SUMO('14709706-n',[ ('Alcohol',subsumption)]).
nounMapping2SUMO('14709791-n',[ ('Alcohol',subsumption)]).
nounMapping2SUMO('14709907-n',[ ('Alcohol',subsumption)]).
nounMapping2SUMO('14710024-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14710164-n',[ ('Alcohol',subsumption)]).
nounMapping2SUMO('14710325-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14710501-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14710662-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14710805-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14710935-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14711008-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14711197-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14711364-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14711647-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14711799-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14712036-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14712224-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14712489-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14712692-n',[ ('Alkaloid',equivalence)]).
nounMapping2SUMO('14713120-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14713247-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14713341-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14713487-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14713748-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14714028-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14714213-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14714353-n',[ ('EpsilonToxin',equivalence)]).
nounMapping2SUMO('14714645-n',[ ('Aflatoxin',equivalence)]).
nounMapping2SUMO('14714817-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14715008-n',[ ('Alkaloid',subsumption), ('Toxin',subsumption)]).
nounMapping2SUMO('14715189-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14715356-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14715453-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14715601-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14715679-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14715786-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14716042-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14716358-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14716550-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14716845-n',[ ('MetallicAlloy',subsumption)]).
nounMapping2SUMO('14716997-n',[ ('Brass',equivalence)]).
nounMapping2SUMO('14717275-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14717634-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14717785-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14717925-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14718017-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14718099-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14718233-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14718362-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14718483-n',[ ('MetallicAlloy',subsumption)]).
nounMapping2SUMO('14718626-n',[ ('MetallicAlloy',subsumption)]).
nounMapping2SUMO('14718715-n',[ ('MetallicAlloy',subsumption)]).
nounMapping2SUMO('14718822-n',[ ('MetallicAlloy',subsumption)]).
nounMapping2SUMO('14719025-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14719169-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14719291-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14719458-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14719597-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14719725-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14719893-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14720101-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14720238-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14720474-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14720588-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14720692-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14720833-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('14720962-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14721236-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14721342-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14721470-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('14721635-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14721781-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14721951-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14722056-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14722240-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14722426-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14722589-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14722738-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14722912-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14723079-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14723425-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14723628-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14723909-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14724025-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14724264-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14724436-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14724645-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14724916-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14725024-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14725217-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14725364-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14725444-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14725591-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14725809-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14725941-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14726124-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14726315-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14726484-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14726642-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14726823-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14726998-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14727153-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14727355-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14727508-n',[ ('Water',subsumption)]).
nounMapping2SUMO('14727670-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14728724-n',[ ('Protein',equivalence)]).
nounMapping2SUMO('14729633-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14729737-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14729953-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14730105-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14730301-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14730421-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14730553-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14730802-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14730955-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14731135-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14731334-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14731509-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14731716-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14731799-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14731964-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14732116-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14732299-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14732472-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14732722-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14732946-n',[ ('Enzyme',equivalence)]).
nounMapping2SUMO('14733941-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14734164-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14734348-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14734487-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14734625-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14734761-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14734905-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14735077-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14735225-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14735347-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14735457-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14735642-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14735822-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14735953-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14736079-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14736201-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14736359-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14736510-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14736854-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14736972-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14737249-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14737365-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14737639-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14737847-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14738052-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14738295-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14738521-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14738623-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14738752-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14738892-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14739004-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14739271-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14739360-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14739734-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14739861-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14739978-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14740094-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14740227-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14740587-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14740915-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14741124-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14741474-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14741730-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14742028-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14742271-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14742476-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14742601-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14742737-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14742917-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14743046-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14743289-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14743381-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14743582-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14743727-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14743840-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14743976-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14744120-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14744291-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14744417-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14744589-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14744698-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14744841-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14745057-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14745222-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14745368-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14745477-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14745635-n',[ ('Steroid',equivalence)]).
nounMapping2SUMO('14745891-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14746048-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14746270-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14746417-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14746793-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14747007-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14747168-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14747338-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14747587-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14747838-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14747981-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14748117-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14748335-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14748577-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14748765-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14749030-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14749272-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14749543-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14749794-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14750122-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14750316-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14750622-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14750782-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14751055-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14751216-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14751417-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14751863-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14752057-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14752323-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14752511-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14752702-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14752952-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14753188-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14753414-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14753808-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14754192-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14754378-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14754505-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14754705-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14754860-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14754985-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14755077-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14755641-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14755804-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14756039-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14756200-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14756369-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14756606-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14756754-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14757011-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14757172-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14757382-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14757547-n',[ ('Ivory',subsumption)]).
nounMapping2SUMO('14757754-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14757848-n',[ ('Bone',equivalence)]).
nounMapping2SUMO('14758027-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('14758252-n',[ ('Bone',subsumption)]).
nounMapping2SUMO('14758420-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14758536-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14758706-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14758842-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('14759003-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14759147-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14759275-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14759444-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14759515-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14759588-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14759722-n',[ ('Leather',equivalence)]).
nounMapping2SUMO('14760339-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14760447-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14760555-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14760696-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14760813-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14760965-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14761122-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14761334-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14761450-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14761578-n',[ ('Food',subsumption)]).
nounMapping2SUMO('14761806-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14762038-n',[ ('CleaningDevice',subsumption)]).
nounMapping2SUMO('14762145-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14762248-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14762366-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14762486-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14762572-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14762664-n',[ ('Leather',subsumption)]).
nounMapping2SUMO('14762758-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14762846-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14762969-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14763059-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14763218-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14763329-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14763424-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14763508-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14763674-n',[ ('Fabric',instance)]).
nounMapping2SUMO('14763879-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14763964-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14764061-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14764440-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14764518-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14764617-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14764715-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14764820-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14764910-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14765016-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14765148-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14765240-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14765324-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14765422-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14765497-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14765575-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14765687-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14765785-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14765856-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14765946-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14766040-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14766189-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14766265-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14766364-n',[ ('Antifreeze',equivalence)]).
nounMapping2SUMO('14766532-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14766725-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14766890-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14767087-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14767202-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14767291-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14767477-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14767663-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14767796-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14767996-n',[ ('Hydrocarbon',subsumption)]).
nounMapping2SUMO('14768201-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14768480-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14768640-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14768765-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14768854-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14768989-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14769160-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14769331-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14769465-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14769644-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14769760-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14769962-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14770146-n',[ ('Grease',subsumption)]).
nounMapping2SUMO('14770248-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14770400-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14770500-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14770631-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14770838-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14771088-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14771270-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14771482-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14771643-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14771831-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14772007-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14772185-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14772317-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14772461-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14772594-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14772716-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14772877-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14773022-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14773275-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14773447-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14773618-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14773787-n',[ ('Water',subsumption)]).
nounMapping2SUMO('14773865-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14773989-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14774090-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14774228-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14774397-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14774491-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14774575-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14774699-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14774894-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14775067-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14775173-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14775321-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14775430-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14775626-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14775729-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14775995-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14776237-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14776391-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14776523-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14776686-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14776804-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14776924-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14777104-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14777188-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14777277-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14777441-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14777523-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14777606-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14777768-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14777856-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14777939-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14778019-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14778436-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14778982-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14779082-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14779205-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14779550-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14779796-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14780040-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14780267-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14780605-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14780737-n',[ ('Soil',subsumption)]).
nounMapping2SUMO('14780850-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14781062-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14781225-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14781513-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14781631-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14781752-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14781872-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14781989-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14782150-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14782252-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14782403-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14782529-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14782689-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14782833-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14782919-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14783038-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14783251-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14783436-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14783588-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14783670-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14783808-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14784111-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14784198-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14784290-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14784506-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14784601-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('14784705-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('14784831-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('14784952-n',[ ('Fungus',subsumption)]).
nounMapping2SUMO('14785065-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14785197-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14785325-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14785436-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14785524-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14785625-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14785840-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14785941-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14786110-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14786257-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14786361-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14786479-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14786943-n',[ ('Device',subsumption)]).
nounMapping2SUMO('14787093-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14787270-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14787386-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14787520-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14787707-n',[ ('Food',subsumption)]).
nounMapping2SUMO('14787816-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('14787954-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14788200-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14788332-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14788485-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14788596-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14788714-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14788875-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14789087-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14789220-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14789365-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14789504-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14789724-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14789885-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14790137-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14790259-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14790526-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14790693-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14790796-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14790979-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14791202-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14791292-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14791453-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14791560-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14791722-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14791830-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14791988-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14792146-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14792281-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14792389-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14792550-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14792703-n',[ ('Carbohydrate',equivalence)]).
nounMapping2SUMO('14793223-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14793393-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14793533-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14793812-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14793921-n',[ ('Cellulose',subsumption)]).
nounMapping2SUMO('14794203-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14794304-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14794418-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14794534-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14794693-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14794823-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14794993-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14795263-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14795432-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14795598-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14795749-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14795959-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14796073-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14796359-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14796575-n',[ ('Carbon',subsumption)]).
nounMapping2SUMO('14796748-n',[ ('Carbon',subsumption)]).
nounMapping2SUMO('14796969-n',[ ('CarbonDioxide',equivalence)]).
nounMapping2SUMO('14797264-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14797436-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14797641-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14797813-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14798039-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14798331-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14798450-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14798709-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14798815-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14799084-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14799244-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14799476-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14799601-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14799833-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14799927-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14800034-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14800138-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14800277-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14800539-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14800706-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14800842-n',[ ('BiologicalAttribute',equivalence)]).
nounMapping2SUMO('14800979-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14801146-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14801271-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14801402-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14801493-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14801594-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14801711-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14801845-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14801921-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14802167-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14802262-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14802450-n',[ ('Steel',equivalence)]).
nounMapping2SUMO('14802921-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14803074-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14803283-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14803438-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14803578-n',[ ('Device',subsumption)]).
nounMapping2SUMO('14803695-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14803886-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14804039-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14804175-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14804487-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14804641-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14804797-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14804958-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14805145-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14805322-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14805412-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14805550-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14805676-n',[ ('Paper',subsumption)]).
nounMapping2SUMO('14805899-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14806176-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14806333-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14806598-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14806728-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14806838-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14807410-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14807558-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14807737-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14807929-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14808147-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14808273-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14808418-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14808617-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14808752-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14808911-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14809057-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14809247-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14809373-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14809521-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14809666-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14809756-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14809843-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14810032-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14810168-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14810356-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14810466-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14810561-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('14810704-n',[ ('Chromium',subsumption)]).
nounMapping2SUMO('14810854-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14811083-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14811196-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14811347-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14811435-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14811556-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14811706-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14811826-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14811932-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14812047-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14812233-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14812359-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14812566-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14812763-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14812872-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14813067-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14813182-n',[ ('Clay',equivalence)]).
nounMapping2SUMO('14813560-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14813709-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14813843-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14813957-n',[ ('Clay',subsumption)]).
nounMapping2SUMO('14814125-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14814295-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14814419-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14814531-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14814616-n',[ ('Coal',subsumption)]).
nounMapping2SUMO('14814921-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14815086-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14815263-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14815423-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14815530-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14815628-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14815728-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14815867-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14816064-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14816181-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14816401-n',[ ('List',subsumption)]).
nounMapping2SUMO('14816613-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14816745-n',[ ('Fuel',subsumption)]).
nounMapping2SUMO('14816899-n',[ ('DNAMolecule',subsumption)]).
nounMapping2SUMO('14817141-n',[ ('DNAMolecule',subsumption)]).
nounMapping2SUMO('14817346-n',[ ('DNAMolecule',subsumption)]).
nounMapping2SUMO('14817419-n',[ ('DNAMolecule',subsumption)]).
nounMapping2SUMO('14817592-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14817783-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14817964-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14818101-n',[ ('Humus',subsumption)]).
nounMapping2SUMO('14818238-n',[ ('CompoundSubstance',equivalence)]).
nounMapping2SUMO('14819856-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14820052-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14820180-n',[ ('Concrete',equivalence)]).
nounMapping2SUMO('14820425-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14820641-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14820747-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14820933-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14821043-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14821248-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14821590-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14821852-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14821984-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14822141-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14822563-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14822762-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14822839-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14823036-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14823227-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14823376-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14823547-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14823690-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14823788-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14823944-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14824140-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14824238-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14824469-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14824556-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14824702-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14824906-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14825062-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14825243-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14825487-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14825631-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14825812-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14825982-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14826173-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14826328-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14826482-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14826613-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14826767-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14826904-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14827017-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14827191-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14827346-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14827505-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14827680-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14827763-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14827871-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14827979-n',[ ('Hydrocarbon',subsumption)]).
nounMapping2SUMO('14828193-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14828396-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14828511-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14828683-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14828815-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14828927-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14829073-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14829172-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14829264-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14829470-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14829565-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14829765-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14829964-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14830164-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14830364-n',[ ('DNAMolecule',equivalence)]).
nounMapping2SUMO('14830992-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14831178-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14831338-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14831479-n',[ ('DNAMolecule',subsumption)]).
nounMapping2SUMO('14831665-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14831812-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14832046-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14832193-n',[ ('RNAMolecule',equivalence)]).
nounMapping2SUMO('14832770-n',[ ('RNAMolecule',subsumption)]).
nounMapping2SUMO('14833027-n',[ ('RNAMolecule',subsumption)]).
nounMapping2SUMO('14833143-n',[ ('RNAMolecule',subsumption)]).
nounMapping2SUMO('14833514-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14833618-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14833729-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14833885-n',[ ('Word',subsumption)]).
nounMapping2SUMO('14834013-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14834132-n',[ ('Water',subsumption)]).
nounMapping2SUMO('14834325-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14834563-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14834714-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14834807-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14834906-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14835004-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14835125-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14835230-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14835333-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14835478-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14835569-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14835686-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14835817-n',[ ('Paper',subsumption)]).
nounMapping2SUMO('14835980-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14836127-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14836308-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14836468-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14836642-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14836851-n',[ ('Water',subsumption)]).
nounMapping2SUMO('14836960-n',[ ('Liquid',subsumption)]).
nounMapping2SUMO('14837258-n',[ ('Water',subsumption)]).
nounMapping2SUMO('14837364-n',[ ('Exhaust',equivalence)]).
nounMapping2SUMO('14837506-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14837678-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('14837786-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14837900-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14838055-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14838217-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14838539-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14838677-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14838821-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14838951-n',[ ('Lubricant',subsumption)]).
nounMapping2SUMO('14839206-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14839322-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14839439-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14839698-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14839846-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('14840092-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14840342-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14840583-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14840755-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14841056-n',[ ('Liquid',subsumption)]).
nounMapping2SUMO('14841267-n',[ ('Air',equivalence)]).
nounMapping2SUMO('14841770-n',[ ('Breathing',equivalence)]).
nounMapping2SUMO('14841923-n',[ ('Air',subsumption)]).
nounMapping2SUMO('14842019-n',[ ('DiseaseOrSyndrome',subsumption)]).
nounMapping2SUMO('14842091-n',[ ('Breathing',subsumption)]).
nounMapping2SUMO('14842226-n',[ ('Gas',subsumption)]).
nounMapping2SUMO('14842378-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14842560-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14842703-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14842847-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14842992-n',[ ('Soil',subsumption)]).
nounMapping2SUMO('14843295-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14843493-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14843640-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14843767-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14843877-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14843986-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14844169-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14844281-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14844414-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14844560-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14844693-n',[ ('Soil',equivalence)]).
nounMapping2SUMO('14845383-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14845578-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('14845743-n',[ ('Water',equivalence)]).
nounMapping2SUMO('14846517-n',[ ('Water',subsumption)]).
nounMapping2SUMO('14846646-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14846779-n',[ ('Nectar',subsumption)]).
nounMapping2SUMO('14846890-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14847103-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14847357-n',[ ('Water',subsumption)]).
nounMapping2SUMO('14847503-n',[ ('Water',subsumption)]).
nounMapping2SUMO('14847654-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14847810-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14847929-n',[ ('Electrolyte',equivalence)]).
nounMapping2SUMO('14848149-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14848245-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14848479-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14848642-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14848785-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14848995-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14849215-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14849367-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14849540-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14849655-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14849789-n',[ ('Device',subsumption)]).
nounMapping2SUMO('14849880-n',[ ('Device',subsumption)]).
nounMapping2SUMO('14850051-n',[ ('Device',subsumption)]).
nounMapping2SUMO('14850190-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14850334-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14850483-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14850826-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14850948-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14851157-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14851414-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14851668-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14851850-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14852003-n',[ ('Antifreeze',subsumption)]).
nounMapping2SUMO('14852312-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14852450-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14852646-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14852747-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14852913-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14853112-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14853210-n',[ ('ExplosiveSubstance',subsumption)]).
nounMapping2SUMO('14853392-n',[ ('ExplosiveSubstance',subsumption)]).
nounMapping2SUMO('14853530-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14853647-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14853796-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14853947-n',[ ('Excrement',equivalence)]).
nounMapping2SUMO('14854262-n',[ ('Feces',equivalence)]).
nounMapping2SUMO('14854581-n',[ ('Feces',equivalence)]).
nounMapping2SUMO('14854764-n',[ ('Feces',subsumption)]).
nounMapping2SUMO('14854847-n',[ ('Feces',equivalence)]).
nounMapping2SUMO('14855066-n',[ ('Feces',subsumption)]).
nounMapping2SUMO('14855150-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14855280-n',[ ('Feces',subsumption)]).
nounMapping2SUMO('14855428-n',[ ('Feces',subsumption)]).
nounMapping2SUMO('14855512-n',[ ('Feces',subsumption)]).
nounMapping2SUMO('14855635-n',[ ('Excrement',subsumption)]).
nounMapping2SUMO('14855724-n',[ ('Urine',equivalence)]).
nounMapping2SUMO('14855992-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14856134-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14856263-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14856752-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14856893-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14857021-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14857151-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14857278-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14857497-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14857737-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('14857897-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14858099-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14858292-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14858451-n',[ ('Food',subsumption)]).
nounMapping2SUMO('14858637-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14858794-n',[ ('Liquid',subsumption)]).
nounMapping2SUMO('14858950-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14859100-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14859201-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14859344-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14859622-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14859838-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14860102-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14860280-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14860455-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14860603-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14860749-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14860842-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14861042-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14861355-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14861566-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14861716-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14861887-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14862064-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14862192-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14862316-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14862481-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14862640-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14862753-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14863031-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('14863177-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14863326-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14863521-n',[ ('Fertilizer',subsumption)]).
nounMapping2SUMO('14863788-n',[ ('Fertilizer',subsumption)]).
nounMapping2SUMO('14863883-n',[ ('Fertilizer',subsumption)]).
nounMapping2SUMO('14863970-n',[ ('Collection',subsumption)]).
nounMapping2SUMO('14864079-n',[ ('Fertilizer',subsumption)]).
nounMapping2SUMO('14864170-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14864259-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('14864360-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14864731-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14864825-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14864961-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14865221-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14865316-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14865533-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14865667-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14865800-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14865934-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14866043-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14866166-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14866369-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14866490-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14866605-n',[ ('ChemicalSalt',subsumption)]).
nounMapping2SUMO('14866769-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14866889-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('14867365-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14867545-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14867690-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14867858-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('14868116-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14868243-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14868464-n',[ ('Device',subsumption)]).
nounMapping2SUMO('14868564-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14868771-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14868916-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14869035-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14869177-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14869327-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14869513-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14869658-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14869829-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14869975-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14870078-n',[ ('CottonFiber',subsumption)]).
nounMapping2SUMO('14870325-n',[ ('CottonFiber',subsumption)]).
nounMapping2SUMO('14870424-n',[ ('CottonFiber',subsumption)]).
nounMapping2SUMO('14870525-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14870665-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14870821-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14870924-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14871078-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14871268-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14871370-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14871464-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14871601-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14871791-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14871883-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14871968-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14872226-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14872325-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14872408-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14872572-n',[ ('Device',subsumption)]).
nounMapping2SUMO('14872697-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('14872875-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('14873056-n',[ ('TherapeuticProcess',subsumption)]).
nounMapping2SUMO('14873196-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14873344-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14873641-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14873951-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14874196-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14874564-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14874731-n',[ ('Chlorofluorocarbon',subsumption)]).
nounMapping2SUMO('14874932-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14875077-n',[ ('Fuel',subsumption)]).
nounMapping2SUMO('14875707-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14875878-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14876066-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14876206-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14876318-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14876473-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14876679-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14876771-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14876872-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14876993-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14877100-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14877234-n',[ ('Gas',subsumption)]).
nounMapping2SUMO('14877486-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14877585-n',[ ('Gas',subsumption)]).
nounMapping2SUMO('14878483-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14878650-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14878844-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14878980-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14879115-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14879247-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14879356-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14879492-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14879605-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14879750-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14879996-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14880107-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14880273-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14880425-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14880557-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14880690-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14880777-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14880960-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14881143-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14881224-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14881303-n',[ ('Glass',equivalence)]).
nounMapping2SUMO('14881759-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14881861-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14882000-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14882117-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14882248-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14882370-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14882578-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14882793-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14882935-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14883098-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14883206-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14883517-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14883661-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14883766-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14883954-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14884120-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14884336-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14884481-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14884581-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14884669-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14884820-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14884963-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14885088-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14885369-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14885684-n',[ ('OrganicCompound',subsumption)]).
nounMapping2SUMO('14885857-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14886037-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14886180-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14886297-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14886443-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14886579-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14887026-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14887305-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14887464-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14887633-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('14887801-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14887925-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14888124-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14888310-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14888529-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14888720-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14888884-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14889074-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14889271-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14889371-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14889479-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14889728-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14889857-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14889973-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14890099-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14890183-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14890286-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14890485-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14890659-n',[ ('Lubricant',equivalence)]).
nounMapping2SUMO('14890945-n',[ ('Grease',equivalence)]).
nounMapping2SUMO('14891132-n',[ ('Paper',subsumption)]).
nounMapping2SUMO('14891255-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14891425-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14891581-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14891678-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('14891868-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14891988-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14892138-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14892289-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14892405-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14892510-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14892655-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14892989-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14893128-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14893271-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14893406-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14893537-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14893652-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14893881-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14894029-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14894140-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14894481-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14894880-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14895003-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14895189-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14895373-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14895498-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14895599-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14895807-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14896018-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14896128-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14896321-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14896441-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14896714-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14896923-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14897083-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14897164-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14897369-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14897521-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14897620-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14897751-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14897941-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14898101-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14898273-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14898364-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14898470-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14899152-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14899328-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14899530-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14899687-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14899888-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14900008-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14900184-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14900342-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14900454-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14900571-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14900695-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14900817-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14900963-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14901158-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14901265-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14901411-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14901565-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14901679-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14901793-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14901959-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14902141-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14902500-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14902627-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14902733-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14902949-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14903095-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14903339-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14903466-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14903596-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14903763-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14903942-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14904052-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14904226-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14904359-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14904528-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14904661-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14904956-n',[ ('Paper',subsumption)]).
nounMapping2SUMO('14905076-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14905197-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14905333-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14905422-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14905607-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14905720-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14905911-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14906085-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14906261-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14906500-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14906656-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14906850-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14907122-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14907273-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14907349-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14907703-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14907867-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14908027-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14908146-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14908297-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14908422-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14908584-n',[ ('Hair',subsumption)]).
nounMapping2SUMO('14908683-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14908822-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14908977-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14909120-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14909319-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14909480-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14909584-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14909703-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14909895-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14910165-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14910440-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14910581-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14910748-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14910926-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14911057-n',[ ('Hydrocarbon',subsumption)]).
nounMapping2SUMO('14911530-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14911704-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14911899-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14912092-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14912245-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14912387-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14912556-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14912710-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14912840-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14912935-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14913136-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14913278-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14913403-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14913518-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14913633-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14913744-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14913860-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14914014-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14914191-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14914301-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14914544-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14914670-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14914775-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14914945-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14915072-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14915184-n',[ ('Solid',subsumption)]).
nounMapping2SUMO('14915462-n',[ ('Solid',subsumption)]).
nounMapping2SUMO('14915622-n',[ ('Solid',subsumption)]).
nounMapping2SUMO('14915804-n',[ ('Solid',subsumption)]).
nounMapping2SUMO('14915928-n',[ ('Solid',subsumption)]).
nounMapping2SUMO('14916053-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14916185-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('14916369-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14916512-n',[ ('Gas',subsumption)]).
nounMapping2SUMO('14916670-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14916796-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14916962-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14917080-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14917208-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14917561-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14917635-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14917859-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14918023-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14918162-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14918264-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14918380-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14918529-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('14918654-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14918784-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14918883-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14918994-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14919156-n',[ ('Gas',subsumption)]).
nounMapping2SUMO('14919272-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14919511-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14919635-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14919819-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('14919948-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14920252-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14920388-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14920586-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14920728-n',[ ('Liquid',subsumption)]).
nounMapping2SUMO('14920844-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14921090-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14921272-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14921414-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14921622-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14921777-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14921974-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14922107-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14922252-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14922371-n',[ ('ChemicalSalt',subsumption)]).
nounMapping2SUMO('14922529-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14922637-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14922779-n',[ ('Protein',equivalence)]).
nounMapping2SUMO('14922960-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14923060-n',[ ('ColorAttribute',subsumption)]).
nounMapping2SUMO('14923207-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14923337-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14923458-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14923733-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14923872-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14923962-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14924067-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14924188-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14924359-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14924473-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14924602-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14924786-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14924915-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14925033-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14925198-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14925378-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14925526-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14925645-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14925776-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14925945-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14926086-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14926180-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14926294-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14926595-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14926937-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14927051-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14927250-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14927451-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14927587-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14927739-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14927881-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14928008-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14928180-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14928332-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14928518-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14928729-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14928885-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14929062-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14929209-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14929350-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14929462-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14929662-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('14929797-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14929897-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14930073-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14930165-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14930312-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14930476-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14930670-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14930824-n',[ ('Brass',subsumption)]).
nounMapping2SUMO('14930989-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14931212-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14931323-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14931472-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14931559-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14931633-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14931795-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14931879-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14932222-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14932303-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14932554-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14932645-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14932741-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14932943-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14933086-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14933236-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14933314-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14933569-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14933663-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14933755-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14933911-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14934031-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14934229-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14934353-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14934527-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14934655-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14934758-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14934864-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14934998-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14935128-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14935319-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14935555-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14935751-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14936010-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14936226-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14936474-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14936630-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14936790-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14936905-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14937093-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14937225-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14937366-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14937521-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14937658-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14937801-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14937943-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14938199-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14938389-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14938467-n',[ ('Cotton',subsumption)]).
nounMapping2SUMO('14938578-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14938687-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14938907-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14939230-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14939445-n',[ ('PhysicalState',subsumption)]).
nounMapping2SUMO('14939663-n',[ ('Blood',subsumption)]).
nounMapping2SUMO('14939755-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14939900-n',[ ('Fluid',equivalence)]).
nounMapping2SUMO('14940100-n',[ ('Liquid',equivalence)]).
nounMapping2SUMO('14940386-n',[ ('Liquid',equivalence)]).
nounMapping2SUMO('14940750-n',[ ('Liquid',subsumption)]).
nounMapping2SUMO('14940856-n',[ ('Air',subsumption)]).
nounMapping2SUMO('14940952-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14941087-n',[ ('Liquid',subsumption)]).
nounMapping2SUMO('14941230-n',[ ('Liquid',subsumption)]).
nounMapping2SUMO('14941407-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14941642-n',[ ('Device',subsumption)]).
nounMapping2SUMO('14941787-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14941884-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14942223-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14942411-n',[ ('NaturalMagnet',subsumption)]).
nounMapping2SUMO('14942631-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14942762-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14942924-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14943009-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14943359-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14943580-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('14943814-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14943950-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14944182-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14944317-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14944455-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14944617-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14944888-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14945137-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14945254-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14945399-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14945517-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14945624-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14945725-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14945914-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14946082-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14946251-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14946424-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14946618-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14946750-n',[ ('Paper',subsumption)]).
nounMapping2SUMO('14946939-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14947125-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14947255-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14947445-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14947558-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14947702-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14947807-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14948055-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14948156-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14948265-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14948377-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14948645-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14948812-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14948983-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('14949075-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('14949227-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14949384-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14949522-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14949608-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14949746-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14949886-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14950055-n',[ ('Water',subsumption)]).
nounMapping2SUMO('14950129-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14950300-n',[ ('Liquid',subsumption)]).
nounMapping2SUMO('14950394-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14950694-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14950937-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14951110-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14951229-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14951377-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14951682-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14951814-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14951983-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14952122-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14952290-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14952441-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14952654-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14952878-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14953005-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14953091-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14953240-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14953357-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14953441-n',[ ('Oil',subsumption)]).
nounMapping2SUMO('14953564-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14953674-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14953813-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14953968-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14954152-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14954284-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14954601-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14954733-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14954822-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14955030-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14955246-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14955391-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14955559-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14955682-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14955776-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14955889-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14956027-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('14956143-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14956325-n',[ ('Soil',equivalence)]).
nounMapping2SUMO('14956523-n',[ ('Food',subsumption)]).
nounMapping2SUMO('14956661-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14956921-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14957057-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14957152-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14957270-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14957546-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14957649-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14957795-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14957893-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14958102-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14958254-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14958405-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14958564-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14958800-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14958937-n',[ ('Hydrocarbon',subsumption)]).
nounMapping2SUMO('14959058-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14959234-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14959472-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14959644-n',[ ('PlantAgriculturalProduct',subsumption)]).
nounMapping2SUMO('14959939-n',[ ('Hay',equivalence)]).
nounMapping2SUMO('14960090-n',[ ('Gas',subsumption)]).
nounMapping2SUMO('14960261-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14960457-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14960606-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14960721-n',[ ('Gas',subsumption)]).
nounMapping2SUMO('14960963-n',[ ('Gas',subsumption)]).
nounMapping2SUMO('14961375-n',[ ('Sarin',equivalence)]).
nounMapping2SUMO('14961512-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14961722-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14961896-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14962117-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14962291-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14962387-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14962521-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14962612-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14962837-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('14963051-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14963187-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14963317-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14963486-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14963634-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14963762-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14963916-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14964129-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14964367-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14964590-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14964925-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14965135-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14965321-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14965501-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14965780-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14965958-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14966058-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14966192-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14966334-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14966530-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14966667-n',[ ('Oil',equivalence)]).
nounMapping2SUMO('14967478-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14967577-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14967730-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14967893-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14968038-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14968185-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14968308-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14968402-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14968526-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14968795-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14968926-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14969044-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14969254-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14969421-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14969523-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14969666-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14969892-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14969994-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14970136-n',[ ('Gas',subsumption)]).
nounMapping2SUMO('14970538-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14970645-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14970752-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14970920-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14971022-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14971234-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14971359-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14971519-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14971969-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14972092-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14972184-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14972359-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14972582-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14972681-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14972807-n',[ ('Gas',subsumption)]).
nounMapping2SUMO('14973133-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14973303-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14973492-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14973585-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('14973833-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14973965-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14974153-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14974264-n',[ ('Paper',equivalence)]).
nounMapping2SUMO('14975266-n',[ ('Paper',subsumption)]).
nounMapping2SUMO('14975351-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14975444-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14975598-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14975779-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14975872-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14976001-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14976170-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14976323-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14976448-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14976634-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('14976759-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14976871-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14977075-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('14977188-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('14977358-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14977504-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14977741-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14977845-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14978114-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14978232-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14978453-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14978544-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14978729-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14978887-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14979052-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14979132-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14979285-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14979410-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14979588-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14979730-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14979961-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14980087-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14980215-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14980468-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14980579-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14980784-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14980910-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('14981183-n',[ ('ChemicalEquilibrium',equivalence)]).
nounMapping2SUMO('14981461-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14981579-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14981847-n',[ ('Gas',subsumption)]).
nounMapping2SUMO('14981983-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14982129-n',[ ('Gas',subsumption)]).
nounMapping2SUMO('14982265-n',[ ('ChemicalSalt',subsumption)]).
nounMapping2SUMO('14982421-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14982681-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14982907-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14983036-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14983143-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14983326-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('14983491-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14983694-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14983774-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14983911-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14984066-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14984244-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('14984378-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14984584-n',[ ('DNAPolymerase',equivalence)]).
nounMapping2SUMO('14984687-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14984799-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14984973-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14985383-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14986004-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14986144-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14986277-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14986438-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14986593-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14986719-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14986890-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14987025-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14987150-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14987341-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14987484-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14987695-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14988150-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14988337-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14988502-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14988635-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14988741-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14988854-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14988961-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14989106-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14989243-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('14989430-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14989545-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14989820-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14990723-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14990864-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14991004-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14991106-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14991210-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14991319-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14991476-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14991611-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14991712-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('14991927-n',[ ('Object',subsumption)]).
nounMapping2SUMO('14992165-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14992287-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14992613-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14992945-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('14993137-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14993378-n',[ ('Gas',subsumption)]).
nounMapping2SUMO('14993559-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14993713-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14993868-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('14994004-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('14994328-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14994726-n',[ ('ChemicalSalt',subsumption)]).
nounMapping2SUMO('14994824-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14995061-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14995278-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14995541-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14995812-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14995918-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14996020-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14996158-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14996295-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14996395-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14996579-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14996709-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('14996843-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14997012-n',[ ('Powder',equivalence)]).
nounMapping2SUMO('14997274-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14997393-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('14997529-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14997699-n',[ ('CompoundSubstance',equivalence)]).
nounMapping2SUMO('14997888-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14998042-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14998142-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14998290-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14998421-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14998522-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14998677-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14998826-n',[ ('Gas',subsumption)]).
nounMapping2SUMO('14998965-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14999106-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('14999411-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14999614-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('14999801-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('14999913-n',[ ('ChemicalBase',subsumption)]).
nounMapping2SUMO('15000060-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15000149-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15000334-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('15000475-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15000689-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15000858-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15000973-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15001212-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15001394-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15001500-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15001640-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15001753-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15001887-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15002138-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15002233-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15002346-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15002546-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15002679-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('15002814-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('15002959-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('15003139-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15003329-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15003496-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('15003645-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('15003797-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15003969-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15004149-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('15004317-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('15004501-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15004715-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15004874-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15005071-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('15005386-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15005577-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15005716-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15005895-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15006012-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15006118-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15006258-n',[ ('Rubber',subsumption)]).
nounMapping2SUMO('15006682-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15006789-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15007016-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15007190-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15007377-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15007534-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15007677-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15007803-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15007917-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15008025-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15008142-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15008287-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15008399-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15008607-n',[ ('Water',subsumption)]).
nounMapping2SUMO('15008765-n',[ ('Condensing',subsumption)]).
nounMapping2SUMO('15008847-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('15009192-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15009326-n',[ ('Water',subsumption)]).
nounMapping2SUMO('15009474-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15009637-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15009843-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15010038-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15010277-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('15010430-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15010703-n',[ ('ChemicalSalt',subsumption)]).
nounMapping2SUMO('15011987-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15012214-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('15012327-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15012478-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('15012668-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15012810-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15012999-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15013139-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15013269-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15013450-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('15013577-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('15013764-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15013875-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15014012-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15014170-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15014406-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15014529-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('15014696-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15014845-n',[ ('Fabric',subsumption)]).
nounMapping2SUMO('15014990-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15015192-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15015355-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15015501-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15015872-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('15015963-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15016123-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15016314-n',[ ('GunPowder',subsumption)]).
nounMapping2SUMO('15016503-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15016726-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15016852-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15016984-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15017121-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15017343-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15017466-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15017604-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15017878-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15018013-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15018169-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15018318-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15018448-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15018572-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15018688-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('15018889-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('15019030-n',[ ('Sand',equivalence)]).
nounMapping2SUMO('15019267-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15019357-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15019483-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15019645-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15019734-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15019844-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('15019972-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15020107-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('15020203-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15020297-n',[ ('Saxitoxin',equivalence)]).
nounMapping2SUMO('15020528-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15020628-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15020794-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15020905-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15020974-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('15021085-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15021189-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15021381-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('15021560-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('15021824-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15021927-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15022035-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15022171-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15022389-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15022617-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15022776-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15023156-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15023294-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('15023537-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15023720-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('15023959-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15024124-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15024240-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15024606-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15024773-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15024997-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15025228-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15025397-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15025571-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15025815-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15025942-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15026155-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15026256-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15026420-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15026508-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15026716-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15026963-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15027189-n',[ ('Antibody',equivalence)]).
nounMapping2SUMO('15027618-n',[ ('Antibody',subsumption)]).
nounMapping2SUMO('15027762-n',[ ('Antibody',subsumption)]).
nounMapping2SUMO('15027888-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15027970-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15028050-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15028208-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15028378-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15028555-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15028684-n',[ ('Antibody',subsumption)]).
nounMapping2SUMO('15028818-n',[ ('Antibody',subsumption)]).
nounMapping2SUMO('15029002-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15029147-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15029292-n',[ ('Antibody',subsumption)]).
nounMapping2SUMO('15029482-n',[ ('Antibody',subsumption)]).
nounMapping2SUMO('15029646-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15029781-n',[ ('Antibody',subsumption)]).
nounMapping2SUMO('15030022-n',[ ('Medicine',subsumption)]).
nounMapping2SUMO('15030264-n',[ ('Antibody',subsumption)]).
nounMapping2SUMO('15030481-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15030853-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15031073-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15031231-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15031418-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15031705-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15031866-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15032071-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15032376-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('15032661-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('15032829-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15033063-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15033189-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15033367-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15033662-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15033846-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15034074-n',[ ('Toxin',equivalence)]).
nounMapping2SUMO('15034454-n',[ ('Antigen',subsumption)]).
nounMapping2SUMO('15034741-n',[ ('Toxin',subsumption)]).
nounMapping2SUMO('15034939-n',[ ('Toxin',subsumption)]).
nounMapping2SUMO('15035123-n',[ ('BotulinumToxin',equivalence)]).
nounMapping2SUMO('15035367-n',[ ('Toxin',subsumption)]).
nounMapping2SUMO('15035505-n',[ ('Toxin',subsumption)]).
nounMapping2SUMO('15035697-n',[ ('Toxin',subsumption)]).
nounMapping2SUMO('15035832-n',[ ('Toxin',subsumption)]).
nounMapping2SUMO('15035975-n',[ ('Gas',subsumption)]).
nounMapping2SUMO('15036103-n',[ ('Toxin',subsumption)]).
nounMapping2SUMO('15036211-n',[ ('Toxin',subsumption)]).
nounMapping2SUMO('15036321-n',[ ('Toxin',subsumption)]).
nounMapping2SUMO('15036536-n',[ ('Toxin',subsumption)]).
nounMapping2SUMO('15036638-n',[ ('Toxin',subsumption)]).
nounMapping2SUMO('15036916-n',[ ('Toxin',subsumption)]).
nounMapping2SUMO('15037127-n',[ ('Toxin',subsumption)]).
nounMapping2SUMO('15037249-n',[ ('Toxin',subsumption)]).
nounMapping2SUMO('15037339-n',[ ('Antigen',equivalence)]).
nounMapping2SUMO('15037664-n',[ ('ContentBearingObject',subsumption)]).
nounMapping2SUMO('15037877-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15038127-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15038316-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('15038426-n',[ ('Gas',subsumption)]).
nounMapping2SUMO('15038520-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15038680-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15038789-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15038892-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15038987-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('15039179-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('15039335-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15039445-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15039568-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15039703-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15039827-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15039935-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('15040033-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15040129-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15040266-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15040493-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15040809-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15040899-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15041050-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15041190-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15041277-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15041688-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15041793-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15041911-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15042052-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('15042194-n',[ ('CorpuscularObject',subsumption)]).
nounMapping2SUMO('15042295-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('15042429-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('15042542-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15042654-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15042772-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15042856-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15043002-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15043118-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15043308-n',[ ('Water',subsumption)]).
nounMapping2SUMO('15043399-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15043579-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15043763-n',[ ('Snowing',equivalence)]).
nounMapping2SUMO('15044016-n',[ ('Object',subsumption)]).
nounMapping2SUMO('15044122-n',[ ('Water',subsumption)]).
nounMapping2SUMO('15044232-n',[ ('Snowing',subsumption)]).
nounMapping2SUMO('15044327-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15044523-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15044648-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15044844-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15045030-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15045216-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15045379-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15045490-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15045677-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15045782-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15046077-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15046250-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15046421-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15046568-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15046716-n',[ ('Water',subsumption)]).
nounMapping2SUMO('15046900-n',[ ('Solid',subsumption)]).
nounMapping2SUMO('15047167-n',[ ('Solid',subsumption)]).
nounMapping2SUMO('15047313-n',[ ('Liquid',subsumption)]).
nounMapping2SUMO('15047849-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15047988-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15048184-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15048293-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('15048463-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15048623-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15048748-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('15048888-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15049096-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15049309-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15049401-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15049594-n',[ ('Liquid',subsumption)]).
nounMapping2SUMO('15049745-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('15049902-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('15050011-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15050161-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15050320-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('15050516-n',[ ('Toxin',subsumption)]).
nounMapping2SUMO('15050695-n',[ ('StaphylococcalEnterotoxinB',equivalence)]).
nounMapping2SUMO('15050898-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15051129-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15051301-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15051392-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15051503-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15051608-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15051705-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15052063-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('15052223-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15052413-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15052555-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('15052667-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15052852-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('15052970-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15053212-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15053373-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('15053568-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15053703-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15053867-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('15054347-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('15054467-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('15054607-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('15054770-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('15054862-n',[ ('Nutrient',subsumption)]).
nounMapping2SUMO('15055046-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('15055181-n',[ ('Steam',equivalence)]).
nounMapping2SUMO('15055342-n',[ ('Steam',equivalence)]).
nounMapping2SUMO('15055442-n',[ ('Cloud',subsumption)]).
nounMapping2SUMO('15055633-n',[ ('GasMixture',subsumption)]).
nounMapping2SUMO('15055936-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15056112-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15056372-n',[ ('NerveAgent',subsumption)]).
nounMapping2SUMO('15056541-n',[ ('Water',subsumption)]).
nounMapping2SUMO('15056749-n',[ ('Water',subsumption)]).
nounMapping2SUMO('15056827-n',[ ('Water',subsumption)]).
nounMapping2SUMO('15056938-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15057103-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15057212-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15057433-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15057558-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('15057744-n',[ ('Steroid',subsumption)]).
nounMapping2SUMO('15058023-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15058163-n',[ ('Steroid',subsumption)]).
nounMapping2SUMO('15058310-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15058544-n',[ ('Cholesterol',equivalence)]).
nounMapping2SUMO('15058755-n',[ ('Cholesterol',subsumption)]).
nounMapping2SUMO('15058987-n',[ ('Cholesterol',subsumption)]).
nounMapping2SUMO('15059237-n',[ ('Cholesterol',subsumption)]).
nounMapping2SUMO('15059404-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15059552-n',[ ('Steroid',subsumption)]).
nounMapping2SUMO('15059694-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15059797-n',[ ('Water',subsumption)]).
nounMapping2SUMO('15059939-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15060131-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15060326-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15060449-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15060569-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('15060688-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('15060825-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15060937-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('15061171-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('15061428-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15061550-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15061674-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15061936-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15062057-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15062284-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15062468-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('15062641-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15062778-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('15062955-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15063108-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15063224-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15063358-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('15063493-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15063699-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15063946-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15064053-n',[ ('Gas',subsumption)]).
nounMapping2SUMO('15064327-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15064560-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15064729-n',[ ('Atom',subsumption)]).
nounMapping2SUMO('15064917-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15065025-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('15065280-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15065483-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15065584-n',[ ('Paper',subsumption)]).
nounMapping2SUMO('15065713-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15065928-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15066125-n',[ ('NerveAgent',subsumption)]).
nounMapping2SUMO('15066367-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15066666-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15066796-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15066906-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('15067025-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15067237-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15067375-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15067576-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15067739-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15067877-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('15068134-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15068282-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('15068436-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15068635-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15068754-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15068891-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15069046-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15069161-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('15069338-n',[ ('Tetrodotoxin',equivalence)]).
nounMapping2SUMO('15069472-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15069584-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15069712-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15069820-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15069998-n',[ ('Depressant',subsumption)]).
nounMapping2SUMO('15070098-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15070234-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('15070366-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15070550-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15070699-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15070897-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15071035-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('15071229-n',[ ('Metal',subsumption)]).
nounMapping2SUMO('15071366-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15071503-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15071684-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15071960-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15072099-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15072331-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15072491-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15072657-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15072857-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15073018-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15073147-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15073285-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15073424-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15073563-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15073784-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('15073973-n',[ ('HormoneTSH',equivalence)]).
nounMapping2SUMO('15074203-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('15074456-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15074568-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15074772-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15074962-n',[ ('Paper',subsumption)]).
nounMapping2SUMO('15075141-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15075298-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15075378-n',[ ('Liquid',subsumption)]).
nounMapping2SUMO('15075596-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('15075691-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15075867-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15076011-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('15076180-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15076349-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15076523-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15076619-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15076931-n',[ ('ElementalSubstance',subsumption)]).
nounMapping2SUMO('15077109-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15077226-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15077338-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('15077571-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('15077752-n',[ ('Device',subsumption)]).
nounMapping2SUMO('15077917-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15078050-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15078550-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15078768-n',[ ('Steroid',subsumption)]).
nounMapping2SUMO('15079030-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15079184-n',[ ('Paper',subsumption)]).
nounMapping2SUMO('15079310-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15079445-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15079557-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15079656-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15079795-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15079925-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15080055-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15080168-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15080277-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('15080382-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('15080571-n',[ ('Carbohydrate',subsumption)]).
nounMapping2SUMO('15080747-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15080942-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15081052-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('15081221-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15081417-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15081595-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('15081675-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15081828-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15081957-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15082036-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15082198-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15082382-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15082524-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15082766-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15082890-n',[ ('Molecule',subsumption)]).
nounMapping2SUMO('15083146-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15083283-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15083429-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15083533-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15083611-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15083713-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('15083819-n',[ ('Gasoline',subsumption)]).
nounMapping2SUMO('15083974-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15084110-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('15084277-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15084357-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15084545-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15084824-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15084999-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15085175-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15085327-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15085472-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15085682-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('15085836-n',[ ('ChemicalSalt',subsumption)]).
nounMapping2SUMO('15085925-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15086088-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15086247-n',[ ('ReproductiveBody',subsumption)]).
nounMapping2SUMO('15086352-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('15086545-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('15086672-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('15086811-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15086939-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15087090-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15087244-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15087384-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15087486-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15087632-n',[ ('Protein',subsumption)]).
nounMapping2SUMO('15087904-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15088111-n',[ ('Vinegar',subsumption)]).
nounMapping2SUMO('15088183-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15088308-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15088440-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15088669-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15088869-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15089104-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15089258-n',[ ('Vitamin',equivalence)]).
nounMapping2SUMO('15089472-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15089645-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15089803-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15090065-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15090238-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15090379-n',[ ('Hydrocarbon',subsumption)]).
nounMapping2SUMO('15090535-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15090742-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15091129-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15091304-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15091473-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15091669-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15091846-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15092059-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15092227-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15092409-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15092650-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15092751-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15092942-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15093049-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15093137-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15093298-n',[ ('Vitamin',subsumption)]).
nounMapping2SUMO('15093482-n',[ ('SulfuricAcid',subsumption)]).
nounMapping2SUMO('15093735-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15093938-n',[ ('Wallpaper',subsumption)]).
nounMapping2SUMO('15094053-n',[ ('Paper',subsumption)]).
nounMapping2SUMO('15094136-n',[ ('Water',subsumption)]).
nounMapping2SUMO('15094294-n',[ ('Oil',subsumption)]).
nounMapping2SUMO('15094824-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15095014-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15095103-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15095237-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15095389-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('15095496-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15095639-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15095771-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15095926-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15096048-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15096233-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15096331-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15096426-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15096524-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15096661-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15096783-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15097017-n',[ ('Detergent',equivalence)]).
nounMapping2SUMO('15097209-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15097430-n',[ ('FatTissue',subsumption)]).
nounMapping2SUMO('15097578-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15097722-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15097849-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15097994-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15098161-n',[ ('Wood',equivalence)]).
nounMapping2SUMO('15100023-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('15100112-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('15100257-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('15100397-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('15100479-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('15100570-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('15100644-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('15100834-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15100945-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15101059-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15101157-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15101271-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15101361-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15101586-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15101723-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15101854-n',[ ('BoardOrBlock',subsumption)]).
nounMapping2SUMO('15102167-n',[ ('Oil',subsumption)]).
nounMapping2SUMO('15102359-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('15102455-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15102622-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15102712-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15102894-n',[ ('Hole',subsumption)]).
nounMapping2SUMO('15103007-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15103226-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15103485-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15103634-n',[ ('Tissue',subsumption)]).
nounMapping2SUMO('15103780-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15103911-n',[ ('Mixture',subsumption)]).
nounMapping2SUMO('15104088-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15104217-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15104488-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15104598-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15104669-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15104752-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15104860-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15104933-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15105008-n',[ ('BodyPart',subsumption)]).
nounMapping2SUMO('15105122-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15105268-n',[ ('Artifact',subsumption)]).
nounMapping2SUMO('15105638-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15105733-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15105849-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15105955-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15106143-n',[ ('Liquid',subsumption)]).
nounMapping2SUMO('15106271-n',[ ('Microorganism',subsumption)]).
nounMapping2SUMO('15106529-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15106674-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15106867-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15107196-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15107362-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15107524-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15107677-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15107876-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15108087-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15108324-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15108538-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15108745-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15108897-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15109016-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15109127-n',[ ('Mineral',subsumption)]).
nounMapping2SUMO('15109391-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15109586-n',[ ('Enzyme',subsumption)]).
nounMapping2SUMO('15109745-n',[ ('Physical',subsumption)]).
nounMapping2SUMO('15109931-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15110096-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15110307-n',[ ('PureSubstance',subsumption)]).
nounMapping2SUMO('15110454-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15110666-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15110796-n',[ ('BodySubstance',subsumption)]).
nounMapping2SUMO('15110956-n',[ ('Object',subsumption)]).
nounMapping2SUMO('15111116-n',[ ('Hormone',subsumption)]).
nounMapping2SUMO('15111437-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15111609-n',[ ('BiologicallyActiveSubstance',subsumption)]).
nounMapping2SUMO('15111903-n',[ ('Solution',subsumption)]).
nounMapping2SUMO('15112086-n',[ ('Object',subsumption)]).
nounMapping2SUMO('15112239-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15112425-n',[ ('Substance',subsumption)]).
nounMapping2SUMO('15112565-n',[ ('Solid',subsumption)]).
nounMapping2SUMO('15112702-n',[ ('Food',subsumption)]).
nounMapping2SUMO('15112828-n',[ ('ChemicalSalt',subsumption)]).
nounMapping2SUMO('15112932-n',[ ('ChemicalAcid',subsumption)]).
nounMapping2SUMO('15113050-n',[ ('CompoundSubstance',subsumption)]).
nounMapping2SUMO('15113229-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15115926-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15116095-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15116283-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15116532-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15116724-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15116910-n',[ ('TimeZone',equivalence)]).
nounMapping2SUMO('15117246-n',[ ('TimeZone',subsumption)]).
nounMapping2SUMO('15117516-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15117621-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15117809-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15118011-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15118100-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15118228-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15118453-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15118724-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15118935-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15119072-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15119185-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15119374-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15119536-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15119919-n',[ ('TimePoint',subsumption)]).
nounMapping2SUMO('15120050-n',[ ('TimePoint',subsumption)]).
nounMapping2SUMO('15120223-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('15120346-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('15120528-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('15120715-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15120823-n',[ ('PastFn',equivalence)]).
nounMapping2SUMO('15121088-n',[ ('PastFn',equivalence)]).
nounMapping2SUMO('15121153-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15121302-n',[ ('PastFn',equivalence)]).
nounMapping2SUMO('15121406-n',[ ('PastFn',equivalence)]).
nounMapping2SUMO('15121625-n',[ ('FutureFn',equivalence)]).
nounMapping2SUMO('15121880-n',[ ('FutureFn',subsumption)]).
nounMapping2SUMO('15122011-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15122231-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15122648-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15122853-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15123115-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15123362-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15123512-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15123589-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15123754-n',[ ('SelfConnectedObject',subsumption)]).
nounMapping2SUMO('15123996-n',[ ('PastFn',equivalence)]).
nounMapping2SUMO('15124183-n',[ ('TimeDuration',instance)]).
nounMapping2SUMO('15124361-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15124545-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15124713-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15124864-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15125097-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15125323-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15125519-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15125679-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15125845-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15126000-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15126175-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15126361-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15126595-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15126750-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15126931-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15127165-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15127307-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15127507-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15127729-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15127982-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15128200-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15128363-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15128549-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15128711-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15128997-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15129220-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15129572-n',[ ('TimeDuration',instance)]).
nounMapping2SUMO('15129927-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15130205-n',[ ('CoordinatedUniversalTimeZone',equivalence)]).
nounMapping2SUMO('15130434-n',[ ('CoordinatedUniversalTimeZone',equivalence)]).
nounMapping2SUMO('15130612-n',[ ('CoordinatedUniversalTimeZone',subsumption)]).
nounMapping2SUMO('15130749-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15130926-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15131123-n',[ ('WhenFn',subsumption)]).
nounMapping2SUMO('15131269-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15131448-n',[ ('CoordinatedUniversalTimeZone',subsumption)]).
nounMapping2SUMO('15131598-n',[ ('TimeZone',subsumption)]).
nounMapping2SUMO('15131734-n',[ ('TimeZone',instance)]).
nounMapping2SUMO('15131994-n',[ ('EasternTimeZone',equivalence)]).
nounMapping2SUMO('15132201-n',[ ('CentralTimeZone',equivalence)]).
nounMapping2SUMO('15132408-n',[ ('MountainTimeZone',equivalence)]).
nounMapping2SUMO('15132638-n',[ ('PacificTimeZone',equivalence)]).
nounMapping2SUMO('15132865-n',[ ('TimeZone',instance)]).
nounMapping2SUMO('15133069-n',[ ('TimeZone',subsumption)]).
nounMapping2SUMO('15133289-n',[ ('TimeZone',instance)]).
nounMapping2SUMO('15133488-n',[ ('Attribute',subsumption)]).
nounMapping2SUMO('15133621-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15133903-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15134054-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15134233-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15134340-n',[ ('TimeMeasure',subsumption)]).
nounMapping2SUMO('15134490-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15134691-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15134913-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15135057-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15135258-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15135434-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15135536-n',[ ('BiologicalAttribute',subsumption)]).
nounMapping2SUMO('15135700-n',[ ('Process',subsumption)]).
nounMapping2SUMO('15135822-n',[ ('Entity',subsumption)]).
nounMapping2SUMO('15135996-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15136147-n',[ ('Week',equivalence)]).
nounMapping2SUMO('15136342-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15136453-n',[ ('Day',equivalence)]).
nounMapping2SUMO('15136723-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15136923-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15137047-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15137194-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15137295-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15137425-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15137556-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15137676-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15137890-n',[ ('Vacationing',equivalence)]).
nounMapping2SUMO('15138241-n',[ ('Vacationing',subsumption)]).
nounMapping2SUMO('15138401-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15138496-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15138600-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15138691-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15138809-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15138903-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15139018-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15139130-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15139432-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15139552-n',[ ('PassCertificate',subsumption)]).
nounMapping2SUMO('15139691-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15139849-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15139983-n',[ ('Year',subsumption)]).
nounMapping2SUMO('15140080-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15140190-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15140294-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15140405-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15140744-n',[ ('WhenFn',equivalence)]).
nounMapping2SUMO('15140892-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15141059-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15141213-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15141375-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15141486-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15141693-n',[ ('PastFn',subsumption)]).
nounMapping2SUMO('15141894-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15142025-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15142167-n',[ ('BeginFn',equivalence)]).
nounMapping2SUMO('15142452-n',[ ('Birth',subsumption)]).
nounMapping2SUMO('15142568-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15142836-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15143012-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('15143276-n',[ ('Death',equivalence)]).
nounMapping2SUMO('15143477-n',[ ('EndFn',equivalence)]).
nounMapping2SUMO('15143726-n',[ ('Death',subsumption)]).
nounMapping2SUMO('15143864-n',[ ('Living',subsumption)]).
nounMapping2SUMO('15143984-n',[ ('Living',subsumption)]).
nounMapping2SUMO('15144094-n',[ ('Living',subsumption)]).
nounMapping2SUMO('15144178-n',[ ('EndFn',subsumption)]).
nounMapping2SUMO('15144371-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15145012-n',[ ('SummerSeason',subsumption)]).
nounMapping2SUMO('15145171-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15145499-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15145586-n',[ ('DevelopmentalAttribute',subsumption)]).
nounMapping2SUMO('15145782-n',[ ('DevelopmentalAttribute',subsumption)]).
nounMapping2SUMO('15146004-n',[ ('DevelopmentalAttribute',subsumption)]).
nounMapping2SUMO('15146260-n',[ ('DevelopmentalAttribute',subsumption)]).
nounMapping2SUMO('15146545-n',[ ('DevelopmentalAttribute',subsumption)]).
nounMapping2SUMO('15146828-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15147097-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15147330-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15147504-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15147598-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15147713-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15147850-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15148081-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15148295-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15148467-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15148584-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15148707-n',[ ('Decade',subsumption)]).
nounMapping2SUMO('15148787-n',[ ('Decade',subsumption)]).
nounMapping2SUMO('15148867-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15148958-n',[ ('Decade',subsumption)]).
nounMapping2SUMO('15149038-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15149180-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15149271-n',[ ('Decade',subsumption)]).
nounMapping2SUMO('15149351-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15149472-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15149562-n',[ ('Decade',subsumption)]).
nounMapping2SUMO('15149642-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15149763-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15149853-n',[ ('Decade',subsumption)]).
nounMapping2SUMO('15149933-n',[ ('Decade',subsumption)]).
nounMapping2SUMO('15150013-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15150134-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15150224-n',[ ('Decade',subsumption)]).
nounMapping2SUMO('15150304-n',[ ('Decade',subsumption)]).
nounMapping2SUMO('15150384-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15150493-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15150618-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15150710-n',[ ('Decade',subsumption)]).
nounMapping2SUMO('15150790-n',[ ('Decade',subsumption)]).
nounMapping2SUMO('15150870-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15150993-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15151084-n',[ ('Decade',subsumption)]).
nounMapping2SUMO('15151175-n',[ ('Decade',subsumption)]).
nounMapping2SUMO('15151255-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15151379-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15151470-n',[ ('Decade',subsumption)]).
nounMapping2SUMO('15151561-n',[ ('Decade',subsumption)]).
nounMapping2SUMO('15151641-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15151764-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15152062-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15152261-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15152409-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15152531-n',[ ('TimePoint',subsumption)]).
nounMapping2SUMO('15152674-n',[ ('TimePoint',subsumption)]).
nounMapping2SUMO('15152817-n',[ ('FullyFormed',equivalence)]).
nounMapping2SUMO('15153225-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15153353-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15153472-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15153667-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15153787-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15154190-n',[ ('PsychologicalDysfunction',subsumption)]).
nounMapping2SUMO('15154376-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15154462-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15154646-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15154774-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('15155220-n',[ ('Day',equivalence)]).
nounMapping2SUMO('15155747-n',[ ('TimeDuration',instance)]).
nounMapping2SUMO('15155891-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15156001-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15156187-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15156311-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15156424-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15156537-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('15156746-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('15157041-n',[ ('Day',equivalence)]).
nounMapping2SUMO('15157225-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15158189-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15158359-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15158450-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15158691-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15158816-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15158997-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15159139-n',[ ('NightTime',subsumption)]).
nounMapping2SUMO('15159265-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15159426-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15159583-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15159819-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15160076-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15160216-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15160418-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15160579-n',[ ('Year',subsumption)]).
nounMapping2SUMO('15160866-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15161165-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15161284-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15161430-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15161631-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15161872-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('15162210-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15162388-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15162523-n',[ ('Day',instance)]).
nounMapping2SUMO('15162640-n',[ ('Day',instance)]).
nounMapping2SUMO('15162764-n',[ ('Day',instance)]).
nounMapping2SUMO('15162882-n',[ ('Day',instance)]).
nounMapping2SUMO('15163005-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15163157-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15163408-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15163797-n',[ ('Sunday',equivalence)]).
nounMapping2SUMO('15163979-n',[ ('Monday',equivalence)]).
nounMapping2SUMO('15164105-n',[ ('Tuesday',equivalence)]).
nounMapping2SUMO('15164233-n',[ ('Wednesday',equivalence)]).
nounMapping2SUMO('15164354-n',[ ('Thursday',equivalence)]).
nounMapping2SUMO('15164463-n',[ ('Friday',equivalence)]).
nounMapping2SUMO('15164570-n',[ ('Saturday',equivalence)]).
nounMapping2SUMO('15164750-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15164957-n',[ ('DayTime',subsumption)]).
nounMapping2SUMO('15165289-n',[ ('Morning',subsumption)]).
nounMapping2SUMO('15165490-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15165637-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15165805-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15165917-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15166070-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15166191-n',[ ('Afternoon',equivalence)]).
nounMapping2SUMO('15166352-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15166462-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15166742-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15166897-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15167027-n',[ ('NightTime',subsumption)]).
nounMapping2SUMO('15167349-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15167474-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15167577-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15167675-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15167778-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15167906-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15168080-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15168185-n',[ ('TimePoint',subsumption)]).
nounMapping2SUMO('15168369-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15168475-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15168569-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15168665-n',[ ('Hour',subsumption)]).
nounMapping2SUMO('15168790-n',[ ('Sunrise',subsumption)]).
nounMapping2SUMO('15169136-n',[ ('Hour',subsumption)]).
nounMapping2SUMO('15169248-n',[ ('Sunset',subsumption)]).
nounMapping2SUMO('15169421-n',[ ('Sunset',subsumption)]).
nounMapping2SUMO('15169759-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15169873-n',[ ('Week',equivalence)]).
nounMapping2SUMO('15170178-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15170331-n',[ ('TimeDuration',equivalence)]).
nounMapping2SUMO('15170504-n',[ ('Weekend',equivalence)]).
nounMapping2SUMO('15170786-n',[ ('Week',subsumption)]).
nounMapping2SUMO('15171008-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15171145-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15171307-n',[ ('Day',instance)]).
nounMapping2SUMO('15171738-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15171857-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15172212-n',[ ('TimeIntervalFn',equivalence)]).
nounMapping2SUMO('15172423-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15172664-n',[ ('Putting',subsumption)]).
nounMapping2SUMO('15172782-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15172881-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15173064-n',[ ('Year',subsumption)]).
nounMapping2SUMO('15173259-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15173353-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15173479-n',[ ('UnitOfMeasure',subsumption)]).
nounMapping2SUMO('15173712-n',[ ('Measuring',subsumption)]).
nounMapping2SUMO('15173830-n',[ ('Procedure',instance)]).
nounMapping2SUMO('15173974-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15174122-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15174218-n',[ ('Procedure',instance)]).
nounMapping2SUMO('15174885-n',[ ('Procedure',instance)]).
nounMapping2SUMO('15175202-n',[ ('Procedure',instance)]).
nounMapping2SUMO('15175640-n',[ ('Month',subsumption)]).
nounMapping2SUMO('15175987-n',[ ('Month',subsumption)]).
nounMapping2SUMO('15176161-n',[ ('Month',subsumption)]).
nounMapping2SUMO('15176319-n',[ ('Month',subsumption)]).
nounMapping2SUMO('15176476-n',[ ('Month',subsumption)]).
nounMapping2SUMO('15176630-n',[ ('Month',subsumption)]).
nounMapping2SUMO('15176785-n',[ ('Month',subsumption)]).
nounMapping2SUMO('15176937-n',[ ('Month',subsumption)]).
nounMapping2SUMO('15177091-n',[ ('Month',subsumption)]).
nounMapping2SUMO('15177244-n',[ ('Month',subsumption)]).
nounMapping2SUMO('15177396-n',[ ('Month',subsumption)]).
nounMapping2SUMO('15177549-n',[ ('Month',subsumption)]).
nounMapping2SUMO('15177705-n',[ ('Month',subsumption)]).
nounMapping2SUMO('15177866-n',[ ('Procedure',instance)]).
nounMapping2SUMO('15178417-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('15178546-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('15178694-n',[ ('Procedure',subsumption)]).
nounMapping2SUMO('15178841-n',[ ('Procedure',instance)]).
nounMapping2SUMO('15179415-n',[ ('Procedure',instance)]).
nounMapping2SUMO('15179888-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15180082-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15180209-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15180304-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('15180528-n',[ ('TimePoint',equivalence)]).
nounMapping2SUMO('15180934-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15181094-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15181282-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15181444-n',[ ('Week',subsumption)]).
nounMapping2SUMO('15181556-n',[ ('Year',subsumption)]).
nounMapping2SUMO('15181718-n',[ ('Proposition',subsumption)]).
nounMapping2SUMO('15181977-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15182053-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15182189-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15182319-n',[ ('YearDuration',subsumption)]).
nounMapping2SUMO('15182402-n',[ ('Monday',subsumption)]).
nounMapping2SUMO('15182569-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15182724-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15182805-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15183085-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15183266-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15183428-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15183802-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15184008-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15184170-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15184755-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15185007-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15185290-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15185471-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15185721-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15185837-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15185996-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15186147-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15186412-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15186596-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15186681-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15186871-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15187077-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15187250-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15187451-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15187619-n',[ ('Monday',subsumption)]).
nounMapping2SUMO('15187800-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15187988-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15188154-n',[ ('Sunday',subsumption)]).
nounMapping2SUMO('15188359-n',[ ('Sunday',subsumption)]).
nounMapping2SUMO('15188505-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15188688-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15188852-n',[ ('Monday',subsumption)]).
nounMapping2SUMO('15189033-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15189249-n',[ ('Sunday',subsumption)]).
nounMapping2SUMO('15189347-n',[ ('Saturday',subsumption)]).
nounMapping2SUMO('15189452-n',[ ('Monday',subsumption)]).
nounMapping2SUMO('15189684-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15189838-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15189982-n',[ ('Sunday',subsumption)]).
nounMapping2SUMO('15190084-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15190228-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15190424-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15190520-n',[ ('Monday',subsumption)]).
nounMapping2SUMO('15190652-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15190779-n',[ ('Friday',subsumption)]).
nounMapping2SUMO('15190895-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15191080-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15191233-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15191401-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15191494-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('15191587-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15191661-n',[ ('Sunday',subsumption)]).
nounMapping2SUMO('15191739-n',[ ('Sunday',subsumption)]).
nounMapping2SUMO('15191827-n',[ ('Friday',subsumption)]).
nounMapping2SUMO('15191924-n',[ ('Sunday',subsumption)]).
nounMapping2SUMO('15192008-n',[ ('Saturday',subsumption)]).
nounMapping2SUMO('15192116-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15192272-n',[ ('Sunday',subsumption)]).
nounMapping2SUMO('15192406-n',[ ('Sunday',subsumption)]).
nounMapping2SUMO('15192544-n',[ ('Sunday',subsumption)]).
nounMapping2SUMO('15192649-n',[ ('Sunday',subsumption)]).
nounMapping2SUMO('15192736-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15192890-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15193052-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15193271-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15193526-n',[ ('Thursday',subsumption)]).
nounMapping2SUMO('15193660-n',[ ('Thursday',subsumption)]).
nounMapping2SUMO('15193776-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15193908-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15194194-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15194506-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15194739-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15194860-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15194940-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15195059-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15195259-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15195388-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15195477-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15195622-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15195834-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15195928-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('15196186-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15196444-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15196537-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15196746-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15196870-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15197042-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15197302-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15197658-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15197954-n',[ ('Holiday',subsumption)]).
nounMapping2SUMO('15198136-n',[ ('Holiday',subsumption)]).
nounMapping2SUMO('15198401-n',[ ('Holiday',subsumption)]).
nounMapping2SUMO('15198662-n',[ ('Holiday',subsumption)]).
nounMapping2SUMO('15198872-n',[ ('Holiday',subsumption)]).
nounMapping2SUMO('15199033-n',[ ('ReligiousProcess',subsumption)]).
nounMapping2SUMO('15199406-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15199592-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15200032-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15200164-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15200314-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15200493-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15200661-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15200896-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15201116-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15201384-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15201505-n',[ ('YearDuration',equivalence)]).
nounMapping2SUMO('15201822-n',[ ('YearDuration',equivalence)]).
nounMapping2SUMO('15201994-n',[ ('EndFn',subsumption)]).
nounMapping2SUMO('15202131-n',[ ('Year',subsumption)]).
nounMapping2SUMO('15202230-n',[ ('Year',subsumption)]).
nounMapping2SUMO('15202424-n',[ ('Year',subsumption)]).
nounMapping2SUMO('15202532-n',[ ('Year',subsumption)]).
nounMapping2SUMO('15202634-n',[ ('Year',equivalence)]).
nounMapping2SUMO('15202806-n',[ ('Year',equivalence)]).
nounMapping2SUMO('15203017-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15203120-n',[ ('YearDuration',equivalence)]).
nounMapping2SUMO('15203229-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15203565-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15203791-n',[ ('YearDuration',equivalence)]).
nounMapping2SUMO('15204201-n',[ ('YearDuration',subsumption)]).
nounMapping2SUMO('15204297-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15204485-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15204609-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15204720-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15204907-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15204983-n',[ ('Decade',subsumption)]).
nounMapping2SUMO('15205532-n',[ ('Century',equivalence)]).
nounMapping2SUMO('15205719-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15205799-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15205880-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15206004-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15206097-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15206195-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15206296-n',[ ('Month',equivalence)]).
nounMapping2SUMO('15206590-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15206744-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15206943-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15207103-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15207302-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15207430-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15207556-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15207770-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15207872-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15208036-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15208162-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15208333-n',[ ('DayDuration',equivalence)]).
nounMapping2SUMO('15208540-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15208740-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15208898-n',[ ('YearDuration',equivalence)]).
nounMapping2SUMO('15209074-n',[ ('HourDuration',equivalence)]).
nounMapping2SUMO('15209174-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15209316-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15209413-n',[ ('Month',equivalence)]).
nounMapping2SUMO('15209706-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15210045-n',[ ('January',equivalence)]).
nounMapping2SUMO('15210383-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15210486-n',[ ('February',equivalence)]).
nounMapping2SUMO('15210765-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15210870-n',[ ('March',equivalence)]).
nounMapping2SUMO('15211090-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15211189-n',[ ('April',equivalence)]).
nounMapping2SUMO('15211385-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15211484-n',[ ('May',equivalence)]).
nounMapping2SUMO('15211711-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15211806-n',[ ('June',equivalence)]).
nounMapping2SUMO('15212070-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15212167-n',[ ('July',equivalence)]).
nounMapping2SUMO('15212358-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15212455-n',[ ('August',equivalence)]).
nounMapping2SUMO('15212638-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15212739-n',[ ('September',equivalence)]).
nounMapping2SUMO('15213008-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15213115-n',[ ('October',equivalence)]).
nounMapping2SUMO('15213303-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15213406-n',[ ('November',equivalence)]).
nounMapping2SUMO('15213669-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15213774-n',[ ('December',subsumption)]).
nounMapping2SUMO('15213963-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15214068-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15214419-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15214639-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15214840-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15215068-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15215270-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15215480-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15215693-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15215816-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15215994-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15216189-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15216386-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15216563-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15216760-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15216966-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15217308-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15217443-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15217563-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15217674-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15217787-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15217911-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15218037-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15218149-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15218272-n',[ ('Ramadan',equivalence)]).
nounMapping2SUMO('15218448-n',[ ('EidAlFitr',equivalence)]).
nounMapping2SUMO('15218551-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15218663-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15218798-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15219022-n',[ ('EidAladha',equivalence)]).
nounMapping2SUMO('15219351-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15219694-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15219874-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15220027-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15220149-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15220267-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15220385-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15220503-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15220625-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15220743-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15220864-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15220985-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15221099-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15221286-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15221474-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15221596-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15221718-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15221818-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15222012-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15222202-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15222369-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15222540-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15222686-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15222840-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15222951-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15223048-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15223190-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15223343-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15223574-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15223750-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15223916-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15224156-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15224293-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15224486-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15224692-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15224978-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15225076-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15225249-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15225526-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15225668-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15225797-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15225929-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15226046-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15226214-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15226451-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15226625-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15226732-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15226972-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15227133-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15227261-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15227391-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15227593-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15227846-n',[ ('HourDuration',equivalence)]).
nounMapping2SUMO('15228162-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15228267-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15228378-n',[ ('Hour',equivalence)]).
nounMapping2SUMO('15228787-n',[ ('Hour',subsumption)]).
nounMapping2SUMO('15228910-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15229019-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15229144-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15229300-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15229408-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15229677-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15229784-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15229875-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15229974-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15230076-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15230180-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15230363-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15230482-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15230617-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15230790-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15231031-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15231263-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15231415-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15231634-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15231765-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15231964-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15232236-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15232406-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15232712-n',[ ('TimeDuration',instance)]).
nounMapping2SUMO('15232899-n',[ ('TimeDuration',instance)]).
nounMapping2SUMO('15233047-n',[ ('TimeDuration',instance)]).
nounMapping2SUMO('15233239-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15233411-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15233614-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15233778-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15233989-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15234212-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15234348-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15234469-n',[ ('Contest',subsumption)]).
nounMapping2SUMO('15234587-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15234764-n',[ ('MinuteDuration',equivalence)]).
nounMapping2SUMO('15234942-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15235126-n',[ ('SecondDuration',equivalence)]).
nounMapping2SUMO('15235334-n',[ ('SecondDuration',subsumption)]).
nounMapping2SUMO('15235540-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15235687-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15235853-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15236015-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15236176-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15236338-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15236475-n',[ ('SeasonOfYear',subsumption)]).
nounMapping2SUMO('15236859-n',[ ('FallSeason',equivalence)]).
nounMapping2SUMO('15237044-n',[ ('SpringSeason',subsumption)]).
nounMapping2SUMO('15237250-n',[ ('SummerSeason',subsumption)]).
nounMapping2SUMO('15237567-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15237782-n',[ ('WinterSeason',subsumption)]).
nounMapping2SUMO('15238074-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15238169-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15238271-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15238371-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15238472-n',[ ('SeasonOfYear',subsumption)]).
nounMapping2SUMO('15238570-n',[ ('SeasonOfYear',subsumption)]).
nounMapping2SUMO('15238761-n',[ ('SeasonOfYear',subsumption)]).
nounMapping2SUMO('15238895-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15239033-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15239174-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15239292-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15239579-n',[ ('SeasonOfYear',equivalence)]).
nounMapping2SUMO('15240119-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15240291-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15240389-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15240503-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15240633-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15240733-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15240888-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15240998-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15241094-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15241186-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15241311-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15241405-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15241507-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15241655-n',[ ('Sunday',subsumption)]).
nounMapping2SUMO('15241777-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15241898-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15242029-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15242209-n',[ ('Sunday',subsumption)]).
nounMapping2SUMO('15242432-n',[ ('Monday',subsumption)]).
nounMapping2SUMO('15242599-n',[ ('Tuesday',subsumption)]).
nounMapping2SUMO('15242719-n',[ ('Week',subsumption)]).
nounMapping2SUMO('15242955-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15243202-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15243351-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15243590-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15243730-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15243976-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15244094-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15244200-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15244351-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15244505-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15244650-n',[ ('TimePoint',subsumption)]).
nounMapping2SUMO('15244942-n',[ ('TimePoint',subsumption)]).
nounMapping2SUMO('15245144-n',[ ('TimePoint',subsumption)]).
nounMapping2SUMO('15245244-n',[ ('TimePoint',subsumption)]).
nounMapping2SUMO('15245382-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15245515-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15245711-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15245829-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15245990-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15246135-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15246258-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15246353-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15246683-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15246775-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15246853-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15247110-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15247410-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15247518-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15248020-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15248269-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15248564-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15248812-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15249096-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15249236-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15249458-n',[ ('Year',subsumption)]).
nounMapping2SUMO('15249547-n',[ ('YearDuration',subsumption)]).
nounMapping2SUMO('15249636-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15249799-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15250178-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15250312-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15250468-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15250580-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15250691-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15250890-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15250991-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15251092-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15251212-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15251336-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15251489-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15251600-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15251757-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15251892-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15252021-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15252146-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15252300-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15252422-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15252524-n',[ ('PastFn',subsumption)]).
nounMapping2SUMO('15252635-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15252770-n',[ ('FutureFn',subsumption)]).
nounMapping2SUMO('15252907-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15253139-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15253895-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15254028-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15254550-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15254831-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15254933-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15255195-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15255439-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15255641-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15255804-n',[ ('BaseballInning',equivalence)]).
nounMapping2SUMO('15256022-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15256245-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15256417-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15256567-n',[ ('Plan',subsumption)]).
nounMapping2SUMO('15256714-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15256915-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15257416-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15257553-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15257692-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15257829-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15258091-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15258179-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15258281-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15258450-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15258694-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15258945-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15259076-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15259284-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15259812-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15260130-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15260277-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15260436-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15260651-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15260814-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15260964-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15261169-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15261306-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15261471-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15261658-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15261868-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15261972-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15262120-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15262360-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15262510-n',[ ('TimePoint',subsumption)]).
nounMapping2SUMO('15262624-n',[ ('Publication',subsumption)]).
nounMapping2SUMO('15262794-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15262921-n',[ ('SubjectiveAssessmentAttribute',equivalence)]).
nounMapping2SUMO('15263045-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15263138-n',[ ('PastFn',subsumption)]).
nounMapping2SUMO('15263283-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15263675-n',[ ('ImmediateFutureFn',equivalence)]).
nounMapping2SUMO('15263795-n',[ ('FutureFn',subsumption)]).
nounMapping2SUMO('15263925-n',[ ('FutureFn',subsumption)]).
nounMapping2SUMO('15264010-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15264168-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15264264-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15264363-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15264607-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15264726-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15264891-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15265021-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15265135-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15265219-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15265331-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15265423-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15265518-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15266034-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15266164-n',[ ('BeginFn',equivalence)]).
nounMapping2SUMO('15266265-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15266568-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15266685-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15266911-n',[ ('EndFn',equivalence)]).
nounMapping2SUMO('15267373-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15267536-n',[ ('EndFn',equivalence)]).
nounMapping2SUMO('15267945-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15268094-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15268239-n',[ ('EndFn',subsumption)]).
nounMapping2SUMO('15268367-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15268547-n',[ ('EndFn',subsumption)]).
nounMapping2SUMO('15268682-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15268857-n',[ ('EndFn',equivalence)]).
nounMapping2SUMO('15268993-n',[ ('BeginFn',subsumption)]).
nounMapping2SUMO('15269128-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15269331-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15269513-n',[ ('TimeInterval',equivalence)]).
nounMapping2SUMO('15269996-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15270245-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15270431-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15270697-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15270862-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15271008-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15271417-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15271619-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15271732-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15271901-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15272029-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15272382-n',[ ('Increasing',equivalence)]).
nounMapping2SUMO('15272571-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15272685-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15272791-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15272887-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15273101-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15273241-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15273406-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15273522-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15273626-n',[ ('Asleep',subsumption)]).
nounMapping2SUMO('15273875-n',[ ('Asleep',subsumption)]).
nounMapping2SUMO('15273955-n',[ ('Asleep',subsumption)]).
nounMapping2SUMO('15274074-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15274305-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15274441-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15274695-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15274863-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15275094-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15275315-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15275466-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15275598-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15275727-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15275851-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15276023-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15276171-n',[ ('FunctionQuantity',subsumption)]).
nounMapping2SUMO('15276307-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15276427-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15276642-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15276801-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15276959-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15277118-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15277358-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15277462-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15277730-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15277926-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15278132-n',[ ('Lumen',equivalence)]).
nounMapping2SUMO('15278281-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15278691-n',[ ('Hertz',subsumption)]).
nounMapping2SUMO('15278825-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15278960-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15279104-n',[ ('Hertz',equivalence)]).
nounMapping2SUMO('15279299-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15279480-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15279596-n',[ ('Hertz',subsumption)]).
nounMapping2SUMO('15279767-n',[ ('SpeedFn',subsumption)]).
nounMapping2SUMO('15279957-n',[ ('Hertz',subsumption)]).
nounMapping2SUMO('15280108-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15280201-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15280346-n',[ ('SpeedFn',subsumption)]).
nounMapping2SUMO('15280497-n',[ ('SpeedFn',subsumption)]).
nounMapping2SUMO('15280695-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15280964-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15281071-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15281176-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15281329-n',[ ('CurrencyMeasure',subsumption)]).
nounMapping2SUMO('15281653-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15281870-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15282032-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15282188-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15282378-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15282534-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15282696-n',[ ('SpeedFn',equivalence)]).
nounMapping2SUMO('15283097-n',[ ('SpeedFn',subsumption)]).
nounMapping2SUMO('15283224-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15283327-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15283433-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15283554-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15283675-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15283780-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15283920-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15284043-n',[ ('SpeedFn',subsumption)]).
nounMapping2SUMO('15284158-n',[ ('SpeedFn',subsumption)]).
nounMapping2SUMO('15284285-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15284553-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15284704-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15284878-n',[ ('SpeedFn',subsumption)]).
nounMapping2SUMO('15284999-n',[ ('Meeting',subsumption)]).
nounMapping2SUMO('15285180-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15285279-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15285456-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15285622-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15285772-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15285910-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15286042-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15286249-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15287073-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15287199-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15287351-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15287486-n',[ ('TimeDependentQuantity',subsumption)]).
nounMapping2SUMO('15287578-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15287830-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15288111-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15288489-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15288707-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15288943-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15289208-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15289524-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15289779-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15289944-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15290132-n',[ ('AngleMeasure',subsumption)]).
nounMapping2SUMO('15290337-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15290930-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15291110-n',[ ('Process',subsumption)]).
nounMapping2SUMO('15291199-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15291416-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15291498-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15291714-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15291801-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15292069-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15292260-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15292336-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15292502-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15292617-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15292722-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15292829-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15292960-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15293091-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15293227-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15293328-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15293435-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15293590-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15293788-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15293931-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15294085-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15294211-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15294382-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15294607-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15294745-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15294884-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15295045-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15295267-n',[ ('SubjectiveAssessmentAttribute',subsumption)]).
nounMapping2SUMO('15295416-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15295603-n',[ ('TimeInterval',instance)]).
nounMapping2SUMO('15295778-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15295884-n',[ ('TimePoint',subsumption)]).
nounMapping2SUMO('15296039-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15296258-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15296354-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15296489-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15296687-n',[ ('TimePosition',subsumption)]).
nounMapping2SUMO('15296920-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15297069-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15297303-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15297472-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15297672-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15297859-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15298011-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15298283-n',[ ('TimeDuration',instance)]).
nounMapping2SUMO('15298507-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15298695-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15298852-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15298995-n',[ ('TimeInterval',subsumption)]).
nounMapping2SUMO('15299097-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15299225-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15299367-n',[ ('Day',subsumption)]).
nounMapping2SUMO('15299585-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15299783-n',[ ('TimeDuration',subsumption)]).
nounMapping2SUMO('15300051-n',[ ('Day',instance)]).
